<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

//PERMS VALIDATION-------------------------------------------------------
if ( hasPermission(['P0018']) != 1 ) {
	$response["errors"] = true;
	$response["type"] = "permission";
	$response["line"] = "PERM001";
	$response["message"] = "Access is not allowed!";
	die(json_encode($response));
}

if ($_SESSION['mod_Vendas'] == 0) {
	$response["errors"] = true;
	$response["type"] = "permission";
	$response["line"] = "PERM002";
	$response["message"] = "Access is not allowed!";
	$response["session"] = $_SESSION;
	die(json_encode($response));
}
//------------------------------------------------------------------------

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET SNC TABLE IN USE --------------------------------------------------
$snc_table = getSncBaseTable();
$code = '';
if($snc_table == 'faturacao_snc_base'){$code = '2111';}
elseif($snc_table == 'faturacao_snc_micro'){$code = '211';}
else{
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS000";
	$response["message"] = 'SNC - tabela invalida';
	die(json_encode($response));
}

//GET POST VARS ---------------------------------------------------------
$idDados = $_POST['idCliente'];

//CHECK IF USED (REMOVE ALL PREDEFINIDAS) -------------------------------
$query = "SELECT ID_Account, Usado, Codigo, Nome FROM faturacao_clientes WHERE ID_Cliente=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $idAccount, $usado, $codigocliente, $nome_cliente );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add info to main array
if($usado > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CHECK IF GENERAL ACCOUNT ----------------------------------------------
$idSncBase = 0;
$query = "SELECT ID_Snc_Base FROM ".$snc_table." WHERE Snc_Code = ".$code."";
if ($stmt = $sqli_connection -> prepare($query)) {
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA002";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idSncBase);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA003";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

$query = "SELECT ID_Account FROM faturacao_accounts WHERE ID_SNC=".$idSncBase." AND ContaSistema =1";
if ($stmt = $sqli_connection -> prepare($query)) {
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idAccountGeneral);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_accounts WHERE ID_Account=? AND ID_Account <> ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dd", $idAccount, $idAccountGeneral );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "SELECT ID_Responsavel FROM faturacao_responsavel_entidades WHERE ID_Cliente = ?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//result
	$stmt -> bind_param("s", $idDados);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "HELP005A";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($idResponsavel);
	while ($stmt -> fetch()) {
		deleteResponsables($idResponsavel);
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "HELP006A";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//remove
function deleteResponsables($idResponsavel){
	global $sqli_connection;

	$query = "DELETE FROM faturacao_responsaveis WHERE ID_Responsavel=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idResponsavel );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "DEL001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "DEL002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_responsavel_entidades WHERE ID_Cliente=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idDados );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS008";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_cliente_vendedor WHERE ID_Cliente_Rel=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idDados );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007a";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS008a";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_clientes WHERE ID_Cliente=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idDados );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Élimination du client (code: ".$codigocliente.", nom: ".$nome_cliente.")";
insert_log(0,"Apagar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>