<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

//PERMS VALIDATION-------------------------------------------------------
if ( hasPermission(['P0019']) != 1 ) {
	$response["errors"] = true;
	$response["type"] = "permission";
	$response["line"] = "PERM001";
	$response["message"] = "Access is not allowed!";
	die(json_encode($response));
}

if ($_SESSION['mod_Vendas'] == 0) {
	$response["errors"] = true;
	$response["type"] = "permission";
	$response["line"] = "PERM002";
	$response["message"] = "Access is not allowed!";
	$response["session"] = $_SESSION;
	die(json_encode($response));
}
//------------------------------------------------------------------------

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
$idCliente = $_POST['idCliente'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT ID_Cliente,
	Nome,
	Codigo,
	Endereco,
	CodigoPostal,
	Cidade,
	Pais,
	Email,
	Telemovel,
	Website,
	(SELECT Descricao AS Metodo FROM faturacao_metodos_pagamento WHERE faturacao_metodos_pagamento.ID_Metodo = faturacao_clientes.MetPagamento),
	MetPagamento,
	Vencimento,
	Desconto,
	(SELECT SUM(TotalLiquidado) - SUM(TotalPagar) FROM faturacao_faturas WHERE faturacao_faturas.ID_Cliente=faturacao_clientes.ID_Cliente AND Estado IN ('Aberto', 'Pago')),
	(SELECT SUM(TotalPagar) FROM faturacao_notas_credito WHERE faturacao_notas_credito.ID_Cliente=faturacao_clientes.ID_Cliente AND Estado IN ('Aberto', 'Pago')),
	(SELECT SUM(TotalPagar) FROM faturacao_faturas WHERE faturacao_faturas.ID_Cliente=faturacao_clientes.ID_Cliente AND Estado IN ('Aberto', 'Pago')),
	CASE Titulo WHEN 'M' THEN 'Monsieur' WHEN 'Mme' THEN 'Madame' WHEN 'Mlle' THEN 'Mademoiselle' ELSE NULL END,
	Titulo,
	Apelido,
	(SELECT Codigo_Interno AS Vendedor FROM faturacao_responsavel_contratos WHERE faturacao_responsavel_contratos.ID_RespContrato = faturacao_clientes.ID_Vendedor),
	(SELECT COUNT(*) FROM faturacao_faturas WHERE faturacao_faturas.ID_Cliente=faturacao_clientes.ID_Cliente AND Estado IN ('Aberto') AND datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) > 10),
	ID_Vendedor,
	(SELECT Nome AS Responsavel FROM faturacao_responsavel_contratos WHERE faturacao_responsavel_contratos.ID_RespContrato = faturacao_clientes.ID_Responsavel),
	ID_Responsavel,
	PlanoContas,
	(SELECT Descricao FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo = faturacao_clientes.PlanoContas ) AS PlanoContasDesc
	FROM faturacao_clientes WHERE ID_Cliente=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCliente);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
        $objectData['ID_Client'],
		$objectData['Name'],
		$objectData['Code'],
		$objectData['Address'],
		$objectData['PostalCode'],
		$objectData['Localite'],
		$objectData['Country'],
		$objectData['Email'],
		$objectData['Phone'],
		$objectData['Website'],
		$objectData['PaymentMethodDescription'],
		$objectData['PaymentMethod'],
		$objectData['PaymentConditions'],
		$objectData['Discount'],
		$objectData['Solde'],
		$objectData['ChiffreCredit'],
		$objectData['ChiffreFactures'],
		$objectData['Title'],
		$objectData['TitleSmall'],
		$objectData['Surname'],
		$objectData['Vendeur'],
		$objectData['Rappel'],
		$objectData['ID_Vendeur'],
		$objectData['ResponsibleContract'],
		$objectData['ID_Responsible'],
		$objectData['PlanComptable'],
		$objectData['PlanComptableDescription']
	);
	$stmt -> fetch();
	$stmt -> close();
		
	$objectData['CountryName'] = getCountryByISO2($objectData['Country']);
	$objectData['FullName'] = $objectData['Name'] ." ". $objectData['Surname'];
	
	$objectData['Chiffre'] = $objectData['ChiffreFactures'] - $objectData['ChiffreCredit'];
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//GET RESPONSABLES
$objectData['Responsibles'] = array();
$query = "SELECT ID_Responsavel,
	(SELECT Codigo FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	(SELECT Nome FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	(SELECT Prenom FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	(SELECT Contacto FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	(SELECT Email FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	Posicao
	FROM faturacao_responsavel_entidades WHERE ID_Cliente=? ORDER BY ID_Responsavel";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $objectData['ID_Client']);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idResponsavel, $codigo, $nome, $prenom, $contacto, $email,$posicao );
	while ($stmt -> fetch()) {
		$datalin[] = array(
		        	// "id" => $idResponsavel,
		        	// "code" => $codigo,
		        	"name" => $nome,
		        	"surname" => $prenom,
		        	"contact" => $contacto,
		        	"email" => $email,
		        	"position" => $posicao,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
if($datalin != null) $objectData['Responsibles'] = $datalin;
else $objectData['Responsibles'] = array();
//-----------------------------------------------------------------------

//GET RESPONSABLES
$objectData['vendeurs'] = array();
if(isVendedor() == 1){
	$internalCode = getUserInternalCode();
	$query = "SELECT ID_Vendedor_Rel,
		faturacao_vendedores.Codigo_Interno,
		faturacao_vendedores.Nome,
		faturacao_vendedores.Codigo,
		faturacao_vendedores.Contacto
		FROM faturacao_cliente_vendedor, faturacao_vendedores  WHERE ID_Cliente_Rel=? AND ID_Vendedor_Rel = ID_Vendedor AND faturacao_vendedores.Codigo_Interno = '".$internalCode."' ORDER BY faturacao_vendedores.Codigo_Interno ";
}else{
	$query = "SELECT ID_Vendedor_Rel,
		faturacao_vendedores.Codigo_Interno,
		faturacao_vendedores.Nome,
		faturacao_vendedores.Codigo,
		faturacao_vendedores.Contacto
		FROM faturacao_cliente_vendedor, faturacao_vendedores  WHERE ID_Cliente_Rel=? AND ID_Vendedor_Rel = ID_Vendedor ORDER BY faturacao_vendedores.Codigo_Interno";
}
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $objectData['ID_Client']);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ID_Vendedor_Rel, $Codigo_Interno, $Nome, $Codigo, $Contacto );
	while ($stmt -> fetch()) {
		$data2[] = array(
		        	"id" => $ID_Vendedor_Rel,
		        	"internal_code" => $Codigo_Interno,
		        	"name" => $Nome,
		        	"code" => $Codigo,
		        	"contact" => $Contacto,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
if($data2 != null) $objectData['vendeurs'] = $data2;
else $objectData['vendeurs'] = array();
//-----------------------------------------------------------------------

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));

?>