<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$opcao = $_POST['opcao'];

$data = "";
switch ($opcao) {
	//Clientes
	case 1:
		$query = "SELECT ID_Cliente, Nome, Apelido, Codigo, Nif FROM faturacao_clientes ORDER BY CAST(Codigo AS UNSIGNED)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA001";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($ID_Cliente, $Nome, $Apelido, $Codigo, $Nif );
			while ($stmt -> fetch()) {
				$data[] = array("ID_Cliente" => $ID_Cliente, "Nome" => $Nome, "Apelido" => $Apelido, "Codigo" => $Codigo, "Nif" => $Nif);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA002";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Detalhes Cliente
	case 2:
		if( isset($_POST['idCliente']) ){
			$idCliente = $_POST['idCliente'];
		}else{
			$response["errors"] = true;
			$response["type"] = "FTGA003";
			$response["message"] = "Sem id de Client.";
			die(json_encode($response));
		}
		$query = "SELECT Nif, Endereco, CodigoPostal, (SELECT Nome FROM concelho WHERE concelho.ID_Concelho = faturacao_clientes.Cidade) AS Cidade, (SELECT Nome FROM distrito WHERE distrito.ID_Distrito = faturacao_clientes.Regiao) AS Regiao, Pais, Vencimento, Desconto FROM faturacao_clientes WHERE ID_Cliente = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $idCliente);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA004";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($Nif, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Pais, $Vencimento, $Desconto );
			$stmt -> fetch();
			$stmt -> close();

			$paisFull = getCountryByISO2($Pais);
			$data = array("Nif" => $Nif, "Endereco" => $Endereco,"CodigoPostal" => $CodigoPostal, "Cidade" => $Cidade,"Regiao" => $Regiao, "Pais" => $paisFull, "Vencimento" => $Vencimento, "Desconto" => $Desconto);
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA005";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Series
	case 3:
		$query = "SELECT ID_Serie, Nome, Predefinida FROM faturacao_series ORDER BY Nome";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA006";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($ID_Serie, $Nome, $Predefinida );
			while ($stmt -> fetch()) {
				$data[] = array("ID_Serie" => $ID_Serie, "Nome" => $Nome, "Predefinida" => $Predefinida);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA007";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Series: NextID
	case 4:
		if( isset($_POST['idSerie']) ){
			$idSerie = $_POST['idSerie'];
		}else{
			$response["errors"] = true;
			$response["type"] = "FTGA008";
			$response["message"] = "Pas d'identifiant série.";
			die(json_encode($response));
		}
		$query = "SELECT MAX(Numero) FROM faturacao_orcamentos WHERE ID_Serie=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $idSerie);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA009";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($maxID );
			$stmt -> fetch();
			$stmt -> close();
			$nextID = $maxID + 1;
			$data = array("NextID" => $nextID);
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA010";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Moedas
	case 5:
		$query = "SELECT ID_Moeda, Nome, Simbolo, ISO_Code FROM faturacao_moedas ORDER BY Nome";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA011";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($ID_Moeda, $Nome, $Simbolo, $ISO );
			while ($stmt -> fetch()) {
				if($ISO == 'CHF') $Predefinido = 1;
				else $Predefinido = 0;
				$data[] = array("ID_Moeda" => $ID_Moeda, "Nome" => $Nome.' ('.$Simbolo.")", "Predefinido" => $Predefinido, "Simbolo" => $Simbolo, "ISO" => $ISO );
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA012";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Articles
	case 6:
		$articleIncluded = '';
		if( isset($_POST['articleID']) ){
			$articleID = $_POST['articleID'];
			if($articleID > 0){
				$articleIncluded = ' OR ID_Artigo = '.$articleID;
			}
		}
		$query = "SELECT ID_Artigo, Nome, Codigo, CodigoBarras, SerialNumber,
			(SELECT Nome AS Categoria FROM faturacao_artigos_categorias WHERE faturacao_artigos_categorias.ID_Categoria = faturacao_artigos.ID_Categoria),
			Tipo
			FROM faturacao_artigos WHERE Ativo = 1 ".$articleIncluded." ORDER BY Nome";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA013";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result(
			            $ID_Artigo,
						$Nome,
						$Codigo,
						$CodigoBarras,
						$SerialNumber,
						$Categoria,
						$Tipo
					);
			while ($stmt -> fetch()) {
				$data[] = array(
				    "ID_Artigo" => $ID_Artigo,
					"Nome" => $Nome,
					"Codigo" => $Codigo,
					"CodigoBarras" => $CodigoBarras,
					"SerialNumber" => $SerialNumber,
					"Categoria" => $Categoria,
					"Tipo" => $Tipo,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA014";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Taxes
	case 7:
		$query = "SELECT ID_Imposto, Nome, Valor, Predefinido, Subclasse FROM faturacao_impostos WHERE Ativo = 1 ORDER BY Nome";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA015";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result(
			            $ID_Imposto,
						$Nome,
						$Valor,
						$Predefinido,
						$Subclasse
					);
			while ($stmt -> fetch()) {
				$data[] = array(
				    "ID_Imposto" => $ID_Imposto,
					"Nome" => $Nome,
					"Valor" => $Valor,
					"Predefinido" => $Predefinido,
					"Subclasse" => $Subclasse,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA016";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Motives
	case 8:
		$query = "SELECT ID_Motivo, Codigo, Descricao FROM faturacao_motivos_isencao ORDER BY Codigo";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA017";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result(
			            $ID_Motivo,
						$Codigo,
						$Descricao
					);
			while ($stmt -> fetch()) {
				$data[] = array(
				    "ID_Motivo" => $ID_Motivo,
					"Codigo" => $Codigo,
					"Descricao" => $Descricao,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA018";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Articles Details
	case 9:
		if( isset($_POST['articleID']) ){
			$articleID = $_POST['articleID'];
		}else{
			$response["errors"] = true;
			$response["type"] = "FTGA019";
			$response["message"] = "Pas d'identifiant série.";
			die(json_encode($response));
		}
		$query = "SELECT ID_Artigo, Nome, Preco, ID_Imposto, RetencaoPercentagem, RetencaoValor, 
			(SELECT Sigla AS Sigla FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade = faturacao_artigos.ID_Unidade),
			Tipo
			FROM faturacao_artigos WHERE ID_Artigo = ? ORDER BY Nome";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $articleID);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA020";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result(
			            $ID_Artigo,
						$Nome,
						$Preco,
						$ID_Imposto,
						$RetencaoPercentagem,
						$RetencaoValor,
						$Sigla,
						$Tipo
					);
			while ($stmt -> fetch()) {
				//calculate 
				$retencaoFinal = 0;
				if($RetencaoValor > 0) {
					$retencaoFinal = ($RetencaoValor * 100) / $Preco;
				}
				else{
					// $taxa = $RetencaoPercentagem * 0.01;
					// $retencaoFinal = $Preco * $taxa;
					$retencaoFinal = $RetencaoPercentagem;
				}

				$data = array(
				    "ID_Artigo" => $ID_Artigo,
					"Nome" => $Nome,
					"Preco" => $Preco,
					"ID_Imposto" => $ID_Imposto,
					"RetencaoPercentagem" => $RetencaoPercentagem,
					"RetencaoValor" => $RetencaoValor,
					"Retencao" => $retencaoFinal,
					"Sigla" => $Sigla,
					"Tipo" => $Tipo,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA021";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Currency Cambio Rate
	case 10:
		if( isset($_POST['ISO']) ){
			$ISO = $_POST['ISO'];
		}else{
			$response["errors"] = true;
			$response["type"] = "FTGA022";
			$response["message"] = "Sem iso definido.";
			die(json_encode($response));
		}
		$rates = json_decode(file_get_contents('http://api.fixer.io/latest?base=CHF&symbols='.$ISO), true);
		$taxa = $rates['rates'][$ISO];
		// var_dump($rates['rates'][$ISO]);die();
		
		if($taxa > 0){
			//update rate in db -----------------
			$query = "UPDATE faturacao_moedas SET Ultima_Taxa=? WHERE ISO_Code=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("ds", $taxa, $ISO );
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA023";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA024";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}
			//-----------------------------------
		}else{
			$query = "SELECT Ultima_Taxa FROM faturacao_moedas WHERE ISO_Code = ?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("s", $ISO);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "FTGA025";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> bind_result($ultimaTaxa );
				$stmt -> fetch();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "FTGA026";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			$taxa = $ultimaTaxa;
		}
		
		$response["errors"] = false;
		$response["data"] = array( 'rate' => $taxa );
		die(json_encode($response));

		break;
}
?>