<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idCompra = $_POST['idDocument'];
	

//DEFINE VARS ------------------------------------------------------------
$fieldIdName = 'ID_Compra';
$tableName = 'faturacao_compras';
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idCompra == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000A";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ".$fieldIdName.", 
		Numero,  
		(SELECT CONCAT(Nome,' (',Simbolo,')') FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS Moeda, 
		(SELECT ISO_Code FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS ISOCode, 
		(SELECT Simbolo FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS Simbolo,
		TaxaMoeda,
		Data,
		GrossTotal,
		(SELECT Nome FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = ".$tableName.".ID_Fornecedor) AS Fornecedor,
		(SELECT Apelido FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = ".$tableName.".ID_Fornecedor) AS Fornecedor2,
		(SELECT Nif FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = ".$tableName.".ID_Fornecedor) AS Nif,
		Estado,
		DataPagamento
		FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Compra'],
	        	$objectData['Numero'],
	        	$objectData['Moeda'],
	        	$objectData['ISOCode'],
	        	$objectData['Simbolo'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['Data'],
	        	$objectData['TotalPagar'],
	        	$objectData['Fornecedor'],
	        	$objectData['Apelido'],
	        	$objectData['Nif'],
	        	$objectData['Estado'],
	        	$objectData['DataPagamento']
			);
	$stmt -> fetch();
	$stmt -> close();

	$objectData['ValorPagavel'] = $objectData['TotalPagar'];
	$objectData['ValorPagavel_Estrangeiro'] = $objectData['ValorPagavel'] * $objectData['TaxaMoeda'];
	
	$tempDate = DateTime::createFromFormat('d/m/Y', $objectData['Data']);
	$objectData['DataNormalizada'] = $tempDate->format('Y/m/d');
	$objectData['TotalCreditado'] = 0;
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM LINHAS MAIN DOCUMENT --------------------------------------------
$objectData['lines_nc'] = array();
$query = "SELECT ID_NotaCreditoCompra, Numero, Data, GrossTotal, Estado FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=? AND Estado NOT IN ('Rascunho') ORDER BY ID_NotaCreditoCompra";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idCompra);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS005";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ID_NotaCreditoCompra, $numero, $data_nota, $total_nota, $estado );
	while ($stmt -> fetch()) {

		$dtReceipt = DateTime::createFromFormat('d/m/Y', $data_nota);
		$dataNCProcessed = $dtReceipt->format('Y-m-d');
		
		//Adicionar NC
		$objectData['lines_nc'][] = array(
		                       		'ID_NotaCreditoCompra' => $ID_NotaCreditoCompra, 
		                       		'Numero' => $numero, 
		                       		'Data' => $data_nota, 
		                       		'DataNormalizada' => $dataNCProcessed,
		                       		'TotalCreditado' => $total_nota,
		                       		'Estado' => $estado,
		                       	);
		$objectData['TotalCreditado'] += $total_nota;
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS006";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

$objectData['ValorCreditado_Estrangeiro'] = $objectData['TotalCreditado'] * $objectData['TaxaMoeda'];
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>