<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(16,1064);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idCompra = $_POST['idCompra'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idCompra == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Data, Numero FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $data, $numeroCompra);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Aberto' || $Estado == 'Anulado') {
	$response["errors"] = true;
	$response["bloqueada"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003";
	$response["message"] = "Compra aberta ou anulada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($data) && $data != '' ? $data : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
$dataAtualizacao = date("d/m/Y H:i:s");

// DEFINE NEW NUMBER
$query = "UPDATE faturacao_compras SET ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_Compra = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dsd", $id_utilizador, $dataAtualizacao, $idCompra);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//------------------------------------------------------------------------
//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
//------------------------------------------------------------------------
$query = "SELECT PlanoContas, PlanoContasBanco, Numero , 
			(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Codigo, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Fornecedor,
			IFNULL(
				(SELECT SUM(GrossTotal) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totPVPNC,
			IFNULL(
				(SELECT SUM(NetTotal) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totUnitNC,
			IFNULL(
				(SELECT SUM(TaxPayable) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totTVANC,
			GrossTotal,	NetTotal, TaxPayable
		FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoFornecedor, $planoBanco, $numeroDoc, $numFornecedor, $nomeFornecedor, $totalPVP_NC, $totalUnit_NC, $totalTVA_NC, $totalPVP, $totalUnit, $totalTVA );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA029";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//PROCESS MOVEMENT FOR DOCUMENT
$texto = $data2[16]['trad'].' ('.$data2[1064]['trad'].') - '.$numeroDoc.' - '.$numFornecedor.' - '.$nomeFornecedor;

//calculate values
$totalPVP = $totalPVP - $totalPVP_NC;
$totalUnit = $totalUnit - $totalUnit_NC;
$totalTVA = $totalTVA - $totalTVA_NC;

if($planoFornecedor > 0){
	$tipoMovimento = 'C';
	// insertMovimentoContabilistico($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento);
	insertMovimentoContabilistico($planoFornecedor, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento);
}

//PROCESS MOVEMENT FOR DOCUMENT
/*if($planoBanco > 0){
	$query = "SELECT 
			(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_compras.ID_Banco) AS Banco
		FROM faturacao_compras WHERE ID_Compra=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCompra);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS030";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($nomeBanco);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS031";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//MOVEMENT
	$textoBanco = $texto.' - Banque: '.$nomeBanco;
	$tipoMovimentoBanco = 'D';
	// insertMovimentoContabilistico($planoBanco, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
	insertMovimentoContabilistico($planoBanco, $planoFornecedor, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
}*/

//------------------------------------------------------------------------
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Achat - Marquer comme ouvert (numéro: ".$numeroCompra.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>