<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDados = $_POST['idImposto'];

//CHECK IF USED (REMOVE ALL PREDEFINIDAS) -------------------------------
$query = "SELECT ID_ImpostoUsado FROM faturacao_impostos_usados WHERE faturacao_impostos_usados.ID_Imposto=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $ID_ImpostoUsado );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add info to main array
if($ID_ImpostoUsado > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//GET THE TYPE BEFORE DELETE --------------------------------------------
$query = "SELECT FinalidadeTipo, Nome FROM faturacao_impostos WHERE ID_Imposto=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
	}
	$stmt -> bind_result( $TipoFinalidade, $nomeImposto );
	$stmt -> fetch();
	$stmt -> close();
} else {}
//-----------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_impostos WHERE ID_Imposto=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idDados );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//CHECK IF HAS STANDARD ----------------------------------------
$query = "SELECT ID_Imposto FROM faturacao_impostos WHERE Predefinido=1 AND Ativo=1 AND FinalidadeTipo=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("s", $TipoFinalidade);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {}
	$stmt -> bind_result($idImpostoPredefinido);
	$stmt -> fetch();
	$stmt -> close();
} else {}

//if smaller than 1 -- auto standard the first item
if($idImpostoPredefinido < 1){
	//clear all standards
	$query = "UPDATE faturacao_impostos SET Predefinido=0 WHERE FinalidadeTipo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
	//bind params
	$stmt -> bind_param("s", $TipoFinalidade);
	//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//add new standard
	$query = "SELECT ID_Imposto FROM faturacao_impostos WHERE Ativo=1 AND FinalidadeTipo=? LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $TipoFinalidade);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {}
		$stmt -> bind_result($idImpostoAtivo);
		$stmt -> fetch();
		$stmt -> close();
	} else {}
	var_dump($TipoFinalidade,$idImpostoAtivo);
	if($idImpostoAtivo > 0){
		//DEFINE NEW STANDARD --------------------------------------
		$query = "UPDATE faturacao_impostos SET Predefinido=1 WHERE ID_Imposto=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			//bind params
			$stmt -> bind_param("d", $idImpostoAtivo);
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> close();
		} else {}
	}
}

//log sistema - processo
$descricao_log ="Élimination du TVA (".$nomeImposto.")";
insert_log(0,"Apagar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>