<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(896,902);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$id_imposto = $_POST['id_imposto'];
$nome_imposto = $_POST['nome_imposto'];
$valor_imposto = $_POST['valor_imposto'];
$regiao_imposto = $_POST['regiao_imposto'];
$subclasse_imposto = $_POST['subclasse_imposto'];
$descricao_imposto = $_POST['descricao_imposto'];
$compte_imposto = $_POST['compte_imposto'];
$typecompte_imposto = $_POST['typecompte_imposto'];
$flagPredefinirEdit = $_POST['flagPredefinirEdit'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $id_imposto == '' || $nome_imposto == '' || $valor_imposto == '' || $regiao_imposto == '' || $subclasse_imposto == '' || $compte_imposto == '' || $typecompte_imposto == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

if($typecompte_imposto == 'F'){
	$typecompte_text_imposto = $data[896]['trad'];
}else{
	$typecompte_text_imposto = $data[902]['trad'];
}

//UPDATE DB (REMOVE ALL PREDEFINIDAS) -----------------------------------
if($flagPredefinirEdit == 1){
	$query = "UPDATE faturacao_impostos SET Predefinido=0 WHERE FinalidadeTipo=?";

	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $typecompte_imposto );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//--------------------------------------------------------------

//INSERT DB -------------------------------------------------------------
$query = "UPDATE faturacao_impostos SET Nome=?, Valor=?, Regiao=?, Subclasse=?, Descricao=?, Predefinido=?, PlanoContas=?, FinalidadeTipo=?, FinalidadeTexto=? WHERE ID_Imposto=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssdsssd", $nome_imposto, $valor_imposto, $regiao_imposto, $subclasse_imposto, $descricao_imposto, $flagPredefinirEdit, $compte_imposto, $typecompte_imposto, $typecompte_text_imposto, $id_imposto );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------

if($flagPredefinirEdit == 0){
	//CHECK IF HAS STANDARD ----------------------------------------
	$query = "SELECT ID_Imposto FROM faturacao_impostos WHERE Predefinido=1 AND Ativo=1 AND FinalidadeTipo=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $typecompte_imposto);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {}
		$stmt -> bind_result($idImpostoPredefinido);
		$stmt -> fetch();
		$stmt -> close();
	} else {}

	//if smaller than 1 -- auto standard the first item
	if($idImpostoPredefinido < 1){
		$query = "SELECT ID_Imposto FROM faturacao_impostos WHERE Ativo=1 AND FinalidadeTipo=? LIMIT 1";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("s", $typecompte_imposto);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result($idImpostoAtivo);
			$stmt -> fetch();
			$stmt -> close();
		} else {}
		if($idImpostoAtivo > 0){
			//DEFINE NEW STANDARD --------------------------------------
			$query = "UPDATE faturacao_impostos SET Predefinido=1 WHERE ID_Imposto=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				//bind params
				$stmt -> bind_param("d", $idImpostoAtivo);
				$result = $stmt -> execute();
				if (false === $result) {}
				$stmt -> close();
			} else {}
		}
	}
}

//log sistema - processo
$descricao_log ="Édition du TVA (".$nome_imposto.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>