<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idAchat = $_POST['idAchat'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idAchat == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//-----------------------------------------------------------------------
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//VERIFICA SE PODE SER ANULADO ------------------------------------------
	$query = "SELECT Estado, Numero FROM faturacao_contrats_achats WHERE ID_Achat=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idAchat, $NumeroAchat);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($Estado);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($Estado == 'Rascunho') {
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS003A";
		$response["message"] = "Achat em rascunho!";
		$response["estado"] = $Estado;
		die(json_encode($response));
	}
	if($Estado == 'Anulado') {
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS003B";
		$response["message"] = "Achat já anulada!";
		$response["estado"] = $Estado;
		die(json_encode($response));
	}
	if($Estado == 'Confirmado') {
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS003C";
		$response["message"] = "Achat já confirmada!";
		$response["estado"] = $Estado;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//UPDATE DB -------------------------------------------------------------
	$dataAtualizacao = date("d/m/Y H:i:s");

	$query = "UPDATE faturacao_contrats_achats SET Estado = 'Confirmado', 
			ID_Utilizador_Atualizacao=?, DataAtualizacao=? 
			WHERE ID_Achat=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dsd", $id_utilizador, $dataAtualizacao, $idAchat );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}


//log sistema - processo
$descricao_log ="Confirmation du contrat de achat (id: ".$idAchat." - ".$NumeroAchat.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>