<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];
$data = "";
//GET POST VARS ---------------------------------------------------------
$idAchat = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idAchat == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ID_Achat,
		Numero,
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_contrats_achats.ID_Cliente) AS Cliente,
		EnderecoCliente, 
		CodigoPostalCliente, 
		RegiaoCliente, 
		CidadeCliente, 
		EmailCliente, 
		PaisCliente,
		EnderecoClienteDescarga, 
		EnderecoCliente2Descarga, 
		CodigoPostalClienteDescarga, 
		RegiaoClienteDescarga, 
		CidadeClienteDescarga, 
		EmailClienteDescarga, 
		PaisClienteDescarga,
		(SELECT Nome FROM faturacao_vendedores WHERE faturacao_vendedores.ID_Vendedor = faturacao_contrats_achats.ID_Vendedor_Primeiro) AS VendedorPrimeiro,
		(SELECT Nome FROM faturacao_responsavel_contratos WHERE faturacao_responsavel_contratos.ID_RespContrato = faturacao_contrats_achats.ID_Vendedor_Segundo) AS VendedorSegundo,
		Data,
		Debut,
		Facturation,
		(SELECT Vencimento FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_contrats_achats.ID_Cliente) as Vencimento,
		Referencia,
		Remarque,
		PrixAchat,
		PrixInstallation,
		PrixPreparation,
		PrixTaxeAntecipe,
		Estado,
		DataCriacao,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_contrats_achats.ID_Utilizador_Criacao) AS ID_Utilizador_Criacao,
		DataAtualizacao,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_contrats_achats.ID_Utilizador_Atualizacao) AS ID_Utilizador_Atualizacao,
		(SELECT CONCAT(Prenom,' ',Nome) FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_contrats_achats.ID_ResponsavelPrimeiro) AS ResponsavelPrimeiro,
		(SELECT CONCAT(Prenom,' ',Nome) FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_contrats_achats.ID_ResponsavelSegundo) AS ResponsavelSegundo,
		DataTermo,
		CONCAT(NomeCliente,' ',ApelidoCliente) AS ClienteNome,
		(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_contrats_achats.ID_Cliente) AS NCliente,
		(SELECT Apelido FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_contrats_achats.ID_Cliente) AS ACliente,
		NomeCliente,
		ApelidoCliente,
		NomeCliente2,
		ApelidoCliente2,
		(SELECT Suspendu FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_contrats_achats.ID_Cliente)
		FROM faturacao_contrats_achats WHERE ID_Achat=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idAchat);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Achat'],
	        	$objectData['Numero'],
	        	$objectData['Cliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['EnderecoClienteDescarga'],
	        	$objectData['EnderecoCliente2Descarga'],
	        	$objectData['CodigoPostalClienteDescarga'],
	        	$objectData['RegiaoClienteDescarga'],
	        	$objectData['CidadeClienteDescarga'],
	        	$objectData['EmailClienteDescarga'],
	        	$objectData['PaisClienteDescarga'],
	        	$objectData['VendedorPrimeiro'],
	        	$objectData['VendedorSegundo'],
	        	$objectData['Data'],
	        	$objectData['Debut'],
	        	$objectData['Facturation'],
	        	$objectData['Paiment'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['PrixAchat'],
	        	$objectData['PrixInstallation'],
	        	$objectData['PrixPreparation'],
	        	$objectData['PrixTaxeAntecipe'],
	        	$objectData['Estado'],
	        	$objectData['DataCriacao'],
	        	$objectData['ID_Utilizador_Criacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['ID_Utilizador_Atualizacao'],
	        	$objectData['ResponsavelPrimeiro'],
	        	$objectData['ResponsavelSegundo'],
	        	$objectData['DataTermo'],
	        	$objectData['ClienteNome'],
	        	$objectData['NCliente'],
	        	$objectData['ACliente'],
	        	$objectData['NomeCliente'],
	        	$objectData['ApelidoCliente'],
	        	$objectData['NomeCliente2'],
	        	$objectData['ApelidoCliente2'],
	        	$objectData['Suspendu']
			);
	$stmt -> fetch();
	$stmt -> close();

	//processar país
	$objectData['PaisFull'] = getCountryByISO2($objectData['PaisCliente']);
	$objectData['PaisFullDescarga'] = getCountryByISO2($objectData['PaisClienteDescarga']);
	$objectData['ClienteNome2'] = $objectData['NomeCliente2'] .' '.$objectData['ApelidoCliente2'];

	//process name
	if($objectData['ClienteNome']) $objectData['Cliente'] = $objectData['ClienteNome'];

	if(!$objectData['NomeCliente2'] && !$objectData['ApelidoCliente2']) {
		if($objectData['NomeCliente']) $objectData['NomeCliente2'] = $objectData['NomeCliente'];
		elseif($objectData['NCliente']) $objectData['NomeCliente2'] = $objectData['NCliente'];
		else $objectData['NomeCliente2'] = '-';

		if($objectData['ApelidoCliente']) $objectData['ApelidoCliente2'] = $objectData['ApelidoCliente'];
		elseif($objectData['ACliente']) $objectData['ApelidoCliente2'] = $objectData['ACliente'];
		else $objectData['ApelidoCliente2'] = '-';
	}
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DA FATURA ------------------------------------------
$query = "SELECT ID_Linha,
		ID_Artigo,
		NumeroLinha,
		ProductCode,
		ProductDescription,
		SerialNumber,
		Quantidade
		FROM faturacao_contrats_achats_linhas WHERE ID_Achat=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idAchat);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($id_linha, $id_artigo, $num_linha, $codigo_artigo, $descricao, $serial_number, $quantidade );
	while ($stmt -> fetch()) {
		$datalin[] = array(
		        	"id_linha" => $id_linha,
		        	"id_artigo" => $id_artigo,
		        	"num_linha" => $num_linha,
		        	"codigo_artigo" => $codigo_artigo,
		        	"descricao" => nl2br($descricao),
		        	"serial_number" => $serial_number,
		        	"quantidade" => $quantidade,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $datalin;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>