<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDevis = $_POST['idDocument'];
$data = "";
//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idDevis == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Devis -------------------------------------------
$query = "SELECT ID_Devis, 
		ID_Cliente, 
		(SELECT CONCAT(Nome, ' ', Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_devis.ID_Cliente) AS NomeCliente, 
		(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_devis.ID_Cliente) AS CodigoCliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente, 
		ID_Moeda, 
		TaxaMoeda,
		(SELECT Vencimento FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_devis.ID_Cliente) as Vencimento,
		ID_Serie, 
		Numero, 
		Data, 
		Validade, 
		Referencia, 
		Observacoes, 
		PercentagemDesconto, 
		Estado, 
		ID_Utilizador, 
		ID_UtilizadorAtualizacao, 
		MetodoPagamento,
		ID_Banco,
		DataAtualizacao,
		GrossTotal,
		TaxPayable,
		NetTotal,
		Desconto,
		TotaRetencao,
		(SELECT Suspendu FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_devis.ID_Cliente)
		FROM faturacao_devis WHERE ID_Devis=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDevis);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Devis'],
	        	$objectData['ID_Cliente'],
	        	$objectData['NomeCliente'],
	        	$objectData['CodigoCliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['ID_Moeda'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['Vencimento'],
	        	$objectData['ID_Serie'],
	        	$objectData['Numero'],
	        	$objectData['Data'],
	        	$objectData['Validade'],
	        	$objectData['Referencia'],
	        	$objectData['Observacoes'],
	        	$objectData['PercentagemDesconto'],
	        	$objectData['Estado'],
	        	$objectData['ID_Utilizador'],
	        	$objectData['ID_UtilizadorAtualizacao'],
	        	$objectData['MetodoPagamento'],
	        	$objectData['ID_Banco'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['GrossTotal'],
	        	$objectData['TaxPayable'],
	        	$objectData['NetTotal'],
	        	$objectData['Desconto'],
	        	$objectData['TotaRetencao'],
	        	$objectData['Suspendu']
			);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DA FATURA ------------------------------------------
$query = "SELECT ID_Artigo,
		Descricao,
		Quantidade,
		UnidadeMedida,
		PrecoUnitario,
		ID_Imposto,
		(SELECT ID_Motivo FROM faturacao_motivos_isencao WHERE faturacao_motivos_isencao.Codigo = faturacao_devis_linhas.TaxExemptionCode ) AS ID_Motivo,
		DescontoLinha,
		PercentagemRetencao,
		(SELECT Tipo FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_devis_linhas.ID_Artigo ) AS Tipo,
		PlanoContas,
		PlanoContasTVA,
		TotalLinha,
		ProductCode,
		(SELECT CodigoBarras FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_devis_linhas.ID_Artigo)
		FROM faturacao_devis_linhas WHERE ID_Devis=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDevis);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($artigo, $descricao, $qtd, $unidade, $preco, $imposto, $motivo, $desconto, $retencao, $tipo, $PlanoContas, $PlanoContasTVA, $totalLinha, $codigo_artigo, $codigobarras_artigo );
	while ($stmt -> fetch()) {
		$datalin[] = array(
		        	"artigo" => $artigo,
					"descricao" => $descricao,
					"qtd" => $qtd,
					"unidade" => $unidade,
					"preco" => $preco,
					"imposto" => $imposto,
					"motivo" => $motivo,
					"desconto" => $desconto,
					"retencao" => $retencao,
					"Tipo" => $tipo,
					"PlanoContas" => $PlanoContas,
					"PlanoContasTVA" => $PlanoContasTVA,
					"totalLinha" => $totalLinha,
					"codigo" => $codigo_artigo,
					"codigobarras" => $codigobarras_artigo,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $datalin;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>