<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";

if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,1273,65,123);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];
$username = $_SESSION['username'];

//GET POST VARS ----------------------------------------------------------
$idRecibo = $_POST['idRecibo'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idRecibo == '' ) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

try {
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//VERIFICA SE PODE SER ALTERADO -----------------------------------------
	$query = "SELECT Estado, TransactionDate, CustomerID, GrossTotal FROM faturacao_recibos WHERE ID_Recibo=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idRecibo);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> bind_result($Estado, $data, $customerID, $grossTotal);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}

	if($Estado != 'Pago') {
		$response["errors"] = true;
		$response["type"] = "usado";
		$response["line"] = "FATS003";
		$response["message"] = "Recibo já anulado!";
		$response["estado"] = $Estado;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	/*if( $impressoes > 0 ) {
		$response["errors"] = true;
		$response["type"] = "usado";
		$response["line"] = "FATS005";
		$response["message"] = "Recibo já impresso!";
		$response["impressoes"] = $impressoes;
		$sqli_connection->rollback();
		die(json_encode($response));
	}*/
	//-----------------------------------------------------------------------

	//CHECK IF CLOSED MONTH -------------------------------------------------
	$dateCheckPost = isset($data) && $data != '' ? $data : date("Y-m-d");
	$dateCheckAux = explode("-", $dateCheckPost);
	$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[0]);
	if($isClosedMonth){
		$response["errors"] = true;
		$response["exists"] = true;
		$response["type"] = "FATS000x";
		$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	$invoiceStatusDate = date("Y-m-d H:i:s");
	$invoiceStatusDate = str_replace (' ','T',$invoiceStatusDate);

	//UPDATE DB -------------------------------------------------------------
	$query = "UPDATE faturacao_recibos SET Estado='Anulado', PaymentStatus='A', PaymentStatusDate=?, SourceID_Estado=? WHERE ID_Recibo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssd", $invoiceStatusDate, $username, $idRecibo );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS013";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS014";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}

	// GET VALUES TO RESTORE -----------------------------------------------
	$query = "SELECT ID_Documento, TipoDocumento, (CreditAmount + ValorIVA) - TotalExtraRecebido, TotalExtraRecebido FROM faturacao_recibos_linhas WHERE ID_Recibo=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idRecibo);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS015";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> bind_result($idDocumento, $tipoDoc, $valorDescontar, $valorExtraRecebido);
		$totalDescontarRecibo = 0;
		while( $stmt -> fetch() ){
			$linhas_descontar[] = array('ID_Documento' => $idDocumento, 'TipoDocumento' => $tipoDoc, 'TotalDescontar' => $valorDescontar, 'TotalExtraRecebido' => $valorExtraRecebido);
			$totalDescontarRecibo += $valorDescontar;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS016";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}

	// RESTORE VALUES ---------------------------------------------------
	foreach ($linhas_descontar as $linha) {
		switch ($linha['TipoDocumento']) {
			case 'FT':
				$tableName = 'faturacao_faturas';
				$fieldName = 'ID_Fatura';
				$tipoRecibo = 'Recibo de Fatura';
				break;
			/*case 'ND':
				$tableName = 'faturacao_notas_debito';
				$fieldName = 'ID_NotaDebito';
				$tipoRecibo = 'Recibo de Nota de Débito';
				break;*/
			case 'NC':
				$tableName = 'faturacao_notas_credito';
				$fieldName = 'ID_NotaCredito';
				$tipoRecibo = 'Recibo de Nota de Crédito';
				break;
			default:
				$response["errors"] = true;
				$response["type"] = "var";
				$response["line"] = "FATS017";
				$response["message"] = $sqli_connection -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
				break;
		}

		//init vars
		$id_cliente = 0;
		$valorExtraFat = 0;
		$valorExtraFatLiq = 0;
		$TotalLiquidadoFatura = 0;
		$TotalLiquidadoDocumentoFatura = 0;
		$TotalPagarFatura = 0;
		$GrossTotalFatura = 0;

		if($linha['TipoDocumento'] == 'FT'){
			$query2 = "SELECT ID_Cliente, TotalExtra, TotalExtraLiquidado, TotalLiquidado, TotalLiquidadoDocumento, TotalPagar, GrossTotal FROM faturacao_faturas WHERE ID_Fatura=?";
			if ( $stmt2 = $sqli_connection -> prepare($query2) ) {
				//bind params
				$stmt2 -> bind_param("d", $linha['ID_Documento']);
				//result single
				$result2 = $stmt2 -> execute();
				if (false === $result2) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS008";
					$response["message"] = $stmt2 -> error;
					$sqli_connection->rollback();
					die(json_encode($response));
				}
				$stmt2 -> bind_result($id_cliente, $valorExtraFat, $valorExtraFatLiq, $TotalLiquidadoFatura, $TotalLiquidadoDocumentoFatura, $TotalPagarFatura, $GrossTotalFatura);
				$stmt2 -> fetch();
				$stmt2 -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS009";
				$response["message"] = $sqli_connection -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
		}
		
		$query = "UPDATE ".$tableName." SET TotalLiquidado=TotalLiquidado-?, TotalLiquidadoDocumento=TotalLiquidadoDocumento-?, Estado='Aberto' WHERE ".$fieldName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			if($linha['TipoDocumento'] == 'FT')
				$stmt -> bind_param("ddd", $totalDescontarRecibo, $linha['TotalDescontar'], $linha['ID_Documento']);
			else
				$stmt -> bind_param("ddd", $linha['TotalDescontar'], $linha['TotalDescontar'], $linha['ID_Documento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS018";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS019";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}

		//calculate extra valor
		//TotalExtraRecebido
		//$valorExtraFat
		//$valorExtraFatLiq
		$remainingExtra = $valorExtraFat - $linha['TotalExtraRecebido'];

		if($remainingExtra < $valorExtraFatLiq) $remainingExtra = $valorExtraFatLiq;

		//update total extra and confirm total liquidado values
		if($linha['TipoDocumento'] == 'FT'){		
			$query = "UPDATE faturacao_faturas SET TotalExtra=? WHERE ID_Fatura=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("sd", $remainingExtra, $linha['ID_Documento']);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS018";
					$response["message"] = $stmt -> error;
					$sqli_connection->rollback();
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS019";
				$response["message"] = $sqli_connection -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}

			//confirm totals
			$DocumentStatus = 'Aberto';
			$totalNCs_Total = getTotalNCs($linha['ID_Documento']);
			$totalNCs_Document = $totalNCs_Total;

			if($totalNCs_Document > $GrossTotalFatura) $totalNCs_Document = $GrossTotalFatura;
			if($totalNCs_Total > $TotalPagarFatura) $totalNCs_Total = $TotalPagarFatura;

			$remainingDocument = $TotalLiquidadoFatura - $linha['TotalDescontar'];
			$remainingTotal = $TotalLiquidadoDocumentoFatura - $linha['TotalDescontar'];

			if($remainingDocument < 0) $remainingDocument = 0;
			if($remainingTotal < 0) $remainingTotal = 0;

			$newDocument = $remainingDocument;
			$newTotal = $remainingTotal;

			if($totalNCs_Document >= $remainingDocument) $newDocument = $totalNCs_Document;
			if($totalNCs_Total >= $remainingTotal) $newTotal = $totalNCs_Total;

			if($newTotal >= $TotalPagarFatura || $newDocument >= $GrossTotalFatura ) $DocumentStatus = 'Pago';

			$query = "UPDATE faturacao_faturas SET TotalLiquidado=?, TotalLiquidadoDocumento=?, Estado=? WHERE ID_Fatura=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("sssd", $newDocument, $newTotal, $DocumentStatus, $linha['ID_Documento']);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS019A";
					$response["message"] = $stmt -> error;
					$sqli_connection->rollback();
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS019B";
				$response["message"] = $sqli_connection -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
		}
	}

	//------------------------------------------------------------------------
	//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
	//------------------------------------------------------------------------
	$query = "SELECT (SELECT PlanoContas FROM ".$tableName." WHERE ".$fieldName."=ID_DocumentoMain) AS PlanoContas, 
			(SELECT PlanoContasBanco FROM ".$tableName." WHERE ".$fieldName."=ID_DocumentoMain) AS PlanoContasBanco,
			(SELECT Nome FROM faturacao_bancos, ".$tableName." WHERE faturacao_bancos.ID_Banco = ".$tableName.".ID_Banco AND ".$fieldName."=ID_DocumentoMain) AS Banco,
			(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_recibos.ID_Serie) AS Serie,
			Numero , CustomerID, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.Codigo = faturacao_recibos.CustomerID) AS Cliente,
			GrossTotal, NetTotal, TaxPayable,
			(SELECT CONCAT('FA ',(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',faturacao_faturas.Numero) FROM faturacao_faturas WHERE faturacao_faturas.ID_Fatura = faturacao_recibos.ID_DocumentoMain) AS DocumentoOrigem, TransactionDate
		FROM faturacao_recibos WHERE ID_Recibo=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idRecibo);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA028";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoCliente, $planoBanco, $nomeBanco, $serie, $numeroDoc, $numCliente, $nomeCliente, $totalPVP, $totalUnit, $totalTVA, $RefDocOrigem, $dataNewDB );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA029";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//PROCESS DATE
	$dateNewTmp = DateTime::createFromFormat('Y-m-d', $dataNewDB);
	$dataNew = $dateNewTmp->format('d/m/Y');

	//PROCESS MOVEMENT FOR DOCUMENT
	$texto = $data2[1273]['trad'].' ('.$data2[65]['trad'].') - '.$serie.'/'.$numeroDoc.' - '.$RefDocOrigem.' - '.$numCliente.' - '.$nomeCliente.' - '.$data2[123]['trad'].': '.$nomeBanco;

	$tipoMovimento = 'C';
	if($planoBanco > 0){
		insertMovimentoContabilisticoManual($planoCliente, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento, $dataNew, 'A');
	} else {
		insertMovimentoContabilisticoManual($planoCliente, '', $texto, $totalPVP, 0, 0, $tipoMovimento, $dataNew, 'A');
	}

	// -------------------------------------------------------------------------------------------------------------------------------
	//log sistema
	$descricao_log ="Annulation du Paiement (id: ".$idRecibo.")";
	insert_log(0,"Editar",$descricao_log,$sqli_connection);

	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
die(json_encode($response));


//get NC for invoices to recalculate total already payed
function getTotalNCs($idFatura){
	global $sqli_connection;

	//init vars
	$totalNCs = 0;

	//process
	$query = "SELECT SUM(TotalLiquidado) FROM faturacao_notas_credito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem = 'FT' AND Estado IN ('Aberto','Pago') ";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS015";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> bind_result($totalNCs);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS016";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	if($totalNCs) return $totalNCs;
	else return 0;
}
?>