<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,729);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}

//GET POST VARS ---------------------------------------------------------
$idDocumento = $_POST['idDocumento'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idDocumento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
//------------------------------------------------------------------------


//-----------------------------------------------------------------------
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//VERIFICA SE PODE SER GERADO --------------------------------------------
	$query = "SELECT Estado, Numero FROM faturacao_contrats_achats WHERE ID_Achat=?";
	if ( $stmt = $sqli_connection->prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt->execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($Estado, $NumeroAchat);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($Estado == 'Rascunho' ) {
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS003";
		$response["message"] = "Documento inválido para clonar!";
		$response["estado"] = $Estado;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//DEFINE VARS -----------------------------------------------------------
	$objectData = array();

	//OBTEM OS Données de Livraison ------------------------------------------------
	$query = "SELECT ID_Achat, 
			Numero,
			ID_Cliente,
			EnderecoCliente,
			CodigoPostalCliente,
			CidadeCliente,
			RegiaoCliente,
			EmailCliente,
			PaisCliente,
			EnderecoClienteDescarga,
			EnderecoCliente2Descarga, 
			CodigoPostalClienteDescarga,
			CidadeClienteDescarga,
			RegiaoClienteDescarga,
			EmailClienteDescarga,
			PaisClienteDescarga,
			ID_Vendedor_Primeiro,
			ID_Vendedor_Segundo,
			Data,
			Debut,
			Facturation,
			Paiment,
			Referencia,
			Remarque,
			PrixAchat,
			PrixInstallation,
			PrixPreparation,
			PrixTaxeAntecipe,
			Estado,
			DataCriacao,
			ID_Utilizador_Criacao,
			DataAtualizacao,
			ID_Utilizador_Atualizacao
			FROM faturacao_contrats_achats WHERE ID_Achat=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		        	$objectData['ID_Achat'],
		        	$objectData['Numero'],
		        	$objectData['ID_Cliente'],
		        	$objectData['EnderecoCliente'],
		        	$objectData['CodigoPostalCliente'],
		        	$objectData['CidadeCliente'],
		        	$objectData['RegiaoCliente'],
		        	$objectData['EmailCliente'],
		        	$objectData['PaisCliente'],
		        	$objectData['EnderecoClienteDescarga'],
					$objectData['EnderecoCliente2Descarga'],
		        	$objectData['CodigoPostalClienteDescarga'],
		        	$objectData['CidadeClienteDescarga'],
		        	$objectData['RegiaoClienteDescarga'],
		        	$objectData['EmailClienteDescarga'],
		        	$objectData['PaisClienteDescarga'],
		        	$objectData['ID_Vendedor_Primeiro'],
		        	$objectData['ID_Vendedor_Segundo'],
		        	$objectData['Data'],
		        	$objectData['Debut'],
		        	$objectData['Facturation'],
		        	$objectData['Paiment'],
		        	$objectData['Referencia'],
		        	$objectData['Remarque'],
		        	$objectData['PrixAchat'],
		        	$objectData['PrixInstallation'],
		        	$objectData['PrixPreparation'],
		        	$objectData['PrixTaxeAntecipe'],
		        	$objectData['Estado'],
		        	$objectData['DataCriacao'],
		        	$objectData['ID_Utilizador_Criacao'],
		        	$objectData['DataAtualizacao'],
		        	$objectData['ID_Utilizador_Atualizacao']
				);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//PREPARE VARS ----------------------------------------------------------
	$timestamp = microtime(true);
	$data = date("d/m/Y");
	$debut = date("d/m/Y");
	$dataCriacao = date("d/m/Y H:i:s");
	$utilizadorCriacao = $id_utilizador;
	$dataAtualizacao = date("d/m/Y H:i:s");
	$utilizadorAtualizacao = $id_utilizador;
	$estado = 'Rascunho';
	//-----------------------------------------------------------------------

	//INSERT OPEN DOCUMENT --------------------------------------------------
	$query = "INSERT INTO faturacao_contrats_achats (
				ID_Cliente, 
				EnderecoCliente, 
				CodigoPostalCliente, 
				CidadeCliente, 
				RegiaoCliente, 
				EmailCliente, 
				PaisCliente,
				EnderecoClienteDescarga, 
				EnderecoCliente2Descarga, 
				CodigoPostalClienteDescarga, 
				CidadeClienteDescarga, 
				RegiaoClienteDescarga, 
				EmailClienteDescarga, 
				PaisClienteDescarga,
				ID_Vendedor_Primeiro, 
				ID_Vendedor_Segundo, 
				Data, 
				Debut, 
				Facturation, 
				Paiment, 
				Referencia, 
				Remarque, 
				PrixAchat, 
				PrixInstallation, 
				PrixPreparation, 
				PrixTaxeAntecipe, 
				Estado, 
				DataCriacao, 
				ID_Utilizador_Criacao, 
				DataAtualizacao, 
				ID_Utilizador_Atualizacao, 
				TimeStamp_Achat
		) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dsssssssssssssddssssssssssssdsds",
					$objectData['ID_Cliente'],
					$objectData['EnderecoCliente'],
					$objectData['CodigoPostalCliente'],
					$objectData['CidadeCliente'],
					$objectData['RegiaoCliente'],
					$objectData['EmailCliente'],
					$objectData['PaisCliente'],
					$objectData['EnderecoClienteDescarga'],
					$objectData['EnderecoCliente2Descarga'],
					$objectData['CodigoPostalClienteDescarga'],
					$objectData['CidadeClienteDescarga'],
					$objectData['RegiaoClienteDescarga'],
					$objectData['EmailClienteDescarga'],
					$objectData['PaisClienteDescarga'],
					$objectData['ID_Vendedor_Primeiro'],
					$objectData['ID_Vendedor_Segundo'],
					$data,
					$debut,
		        	$objectData['Facturation'],
		        	$objectData['Paiment'],
		        	$objectData['Referencia'],
		        	$objectData['Remarque'],
		        	$objectData['PrixAchat'],
		        	$objectData['PrixInstallation'],
		        	$objectData['PrixPreparation'],
		        	$objectData['PrixTaxeAntecipe'],
					$estado,
					$dataCriacao,
					$utilizadorCriacao,
					$dataAtualizacao,
					$utilizadorAtualizacao,
					$timestamp  
		    	);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//GET DOCUMENT ID
	$query = "SELECT ID_Achat FROM faturacao_contrats_achats WHERE TimeStamp_Achat = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $timestamp);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS008";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($idAchatNew);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS009";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $idAchatNew < 1){
		$response["errors"] = true;
		$response["type"] = "FATS010";
		$response["message"] = "Location inválida";
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//GET THE LINES ----------------------------------------------------------
	$data = array();
	$query = "SELECT ID_Achat,
				ID_Artigo,
				NumeroLinha,
				ProductCode,
				ProductDescription,
				SerialNumber,
				Quantidade
			FROM faturacao_contrats_achats_linhas WHERE ID_Achat=? ORDER BY ID_Linha";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS011";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> bind_result(
				$ID_Achat, 
				$ID_Artigo, 
				$NumeroLinha, 
				$ProductCode, 
				$ProductDescription, 
				$SerialNumber, 
				$Quantidade
			);
		while ($stmt -> fetch()) {
			$datalin[] = array(
			        	"ID_Achat" => $ID_Achat,
			        	"ID_Artigo" => $ID_Artigo,
			        	"NumeroLinha" => $NumeroLinha,
			        	"ProductCode" => $ProductCode,
			        	"ProductDescription" => $ProductDescription,
			        	"SerialNumber" => $SerialNumber,
			        	"Quantidade" => $Quantidade,
			        );
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS012";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	//add lines to object
	$objectData['linhas'] = $datalin;
	//------------------------------------------------------------------------

	//INSERT THE LINES
	foreach ($objectData['linhas'] as $linha) {
		//INSERT INTO DB -----------------------------------------------------
		$query = "INSERT INTO faturacao_contrats_achats_linhas (
			ID_Achat, ID_Artigo, 
			NumeroLinha, ProductCode, ProductDescription, SerialNumber, Quantidade
			) 
			VALUES (?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddsssd", 
			            $idAchatNew, 
						$linha['ID_Artigo'],
						$linha['NumeroLinha'],
						$linha['ProductCode'],
						$linha['ProductDescription'],
						$linha['SerialNumber'],
						$linha['Quantidade']
					);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS013";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS014";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
	}

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}


//log sistema - processo
$descricao_log = $data2[729]['trad'].": Contract Achat (id: ".$idDocumento." - ".$NumeroAchat.") -- Contract Achat (id: ".$idAchatNew.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response["idDestino"] = $idAchatNew;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_contrats_achats WHERE ID_Achat=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_contrats_achats_linhas WHERE ID_Achat=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}

?>