<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idNota = $_POST['idNota'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idNota == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}
//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Data, Validade, ID_Serie, TotaRetencao, TotalPagar, ID_Documento_Origem, Tipo_Documento_Origem, Data_Documento_Origem FROM faturacao_notas_debito WHERE ID_NotaDebito=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idNota);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $data, $validade, $serie, $retencaoTotal, $totalPagar, $docOrigem, $docType, $dataOrigin );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado != 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "usado";
	$response["line"] = "FATS003";
	$response["message"] = "Nota já finalizada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}

//PROCESS ORIGIN
$fieldIdName = '';
$tableName = '';
switch ($docType) {
	case 'FT':
		$fieldIdName = 'ID_Fatura';
		$tableName = 'faturacao_faturas';
		break;
	case 'FS':
		$fieldIdName = 'ID_FaturaSimplificada';
		$tableName = 'faturacao_faturas_simplificadas';
		break;
	case 'FR':
		$fieldIdName = 'ID_FaturaRecibo';
		$tableName = 'faturacao_faturas_recibo';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000AA";
		$response["message"] = 'Tipo inválido!';
		die(json_encode($response));
		break;
}
//-----------------------------------------------------------------------

//CHECK ORIGIN DOCUMENT -------------------------------------------------
$query = "SELECT Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $docOrigem);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000C";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($estadoOrigem );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS0000D";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CLOSE THE DOCUMENT ----------------------------------------------------
$systemEntryDateUpdate = date("Y-m-d H:i:s");
$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
$invoiceStatusDate = date("Y-m-d H:i:s");
$invoiceStatusDate = str_replace (' ','T',$invoiceStatusDate);
$sourceID = $_SESSION['username'];
$hash = 'TESTE';
$hashControl = 1;
$hashPrint = 'ABCD';
$movementEndTime = '';
// $retencaoCalc = round($retencaoTotal,2);
$retencaoCalc = $retencaoTotal;
// $totalLiquidado = $retencaoCalc;
$totalLiquidado = 0;

$dataNew = $data;
$validadeNew = $validade;
$dataAtualizacao = date("d/m/Y H:i:s");

//process InvoiceDate and period to the choosen one
$tempDate = DateTime::createFromFormat('d/m/Y', $data);
$invoiceDate = $tempDate->format('Y-m-d');
$period = $tempDate->format('m');
//define start time
$movementStartTime = $tempDate->format("Y-m-d H:i:s");
$movementStartTime = str_replace (' ','T',$movementStartTime);


//GET LAST DATE
$query = "SELECT MAX(Numero), Data FROM faturacao_notas_debito WHERE ID_Serie = ? AND Numero > 0";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $serie);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA023";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($numMax, $dataLast);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA024";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $numMax > 0){
	//this entry date timestamp
	$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
	$dtOriginDateTime = $dtOriginDate->getTimestamp();

	//last date timestamp
	$dtLast = DateTime::createFromFormat("d/m/Y H:i:s", $dataLast." 00:00:00");
	$dtLastTime = $dtLast->getTimestamp();

	//this entry validade timestamp
	$dtThisValidade = DateTime::createFromFormat("d/m/Y H:i:s", $validade." 00:00:00");
	$dtThisValidadeTime = $dtThisValidade->getTimestamp();

	//this entry date timestamp
	$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
	$dtThisDateTime = $dtThisDate->getTimestamp();

	//process new dates
	if( $dtThisDateTime < $dtLastTime ){
		// $dataNew = $dataLast;
		// //update invoiceDate and period
		// $invoiceDate = date("Y-m-d");
		// $period = date("m");
		// //define start time
		// $movementStartTime = date("Y-m-d H:i:s");
		// $movementStartTime = str_replace (' ','T',$movementStartTime);
		
		//alert user that the date is before the last one
		$response["errors"] = true;
		$response["type"] = "FTGA024A";
		$response["data_superior"] = true;
		$response["dataUltima"] = $dataLast;
		$response["message"] = "Data superior à última nota.";
		die(json_encode($response));
	}
	//process date origin
	if( $dtThisDateTime < $dtOriginDateTime ){
		//alert user that the date is before the last one
		$response["errors"] = true;
		$response["type"] = "FTGA024B";
		$response["data_superior2"] = true;
		$response["dataUltima"] = $dataOrigin;
		$response["message"] = "Data superior à última fatura.";
		die(json_encode($response));
	}

	if( $dtThisValidadeTime < $dtThisDateTime ){
		$validadeNew = $data;
	}
}else{
	//this entry date timestamp
	$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
	$dtOriginDateTime = $dtOriginDate->getTimestamp();

	//this entry date timestamp
	$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
	$dtThisDateTime = $dtThisDate->getTimestamp();


	//process date origin
	if( $dtThisDateTime < $dtOriginDateTime ){
		//alert user that the date is before the last one
		$response["errors"] = true;
		$response["type"] = "FTGA024C";
		$response["data_superior2"] = true;
		$response["dataUltima"] = $dataOrigin;
		$response["message"] = "Data superior à última fatura.";
		die(json_encode($response));
	}
}

// DEFINE NEW NUMBER
$query = "UPDATE faturacao_notas_debito SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_notas_debito WHERE ID_Serie=?) AS SubNumeroMax) + 1), Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_NotaDebito = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssdsd", $serie, $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idNota);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA025";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

// UPDATE REMAIN FIELDS
$query = "UPDATE faturacao_notas_debito SET InvoiceStatusDate=?, SourceID=?, Hash=?, HashControl=?, Hash_Print=?, Period=?, InvoiceDate=?, MovementEndTime=?, MovementStartTime=?, TotalLiquidado=?, SystemEntryDate=? WHERE ID_NotaDebito = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssdsssssssd", $invoiceStatusDate, $sourceID, $hash, $hashControl, $hashPrint, $period, $invoiceDate, $movementEndTime, $movementStartTime, $totalLiquidado, $systemEntryDateUpdate, $idNota );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA025";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
// UPDATE REMAIN FIELDS LINES
$query = "UPDATE faturacao_notas_debito_linhas SET TaxPointDate=? WHERE ID_NotaDebito = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sd", $invoiceDate, $idNota );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026A";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026B";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
$query = "SELECT TotalPagar, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $docOrigem);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026C";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($totalPagarOrigem, $estadoOrigemLast );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026D";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//last check on estado
if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FTGA026E";
	die(json_encode($response));
}else{
	###---- UPDATE DOC ORIGEM ----###
	$totalPagarOrigemNovo = $totalPagarOrigem + $totalPagar;
	$estadoNovo = 'Aberto';
	$query = "UPDATE ".$tableName." SET TotalPagar=?, Estado=? WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssd", $totalPagarOrigemNovo, $estadoNovo, $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026F";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026G";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//--------------------------------------------------------------------

//UPDATE STOCKS
/* Le stock ne doit etre update qu'avec les factures
$stockUpdateResult = decreaseArticlesStock($idNota, 'faturacao_notas_debito', 'ID_NotaDebito');
if($stockUpdateResult != true){
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA027";
	$response["message"] = 'Falha ao atualizar stocks.';
	die(json_encode($response));
}*/

//response
$response["errors"] = false;
die(json_encode($response));

?>