<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];
$data = "";

//GET POST VARS ---------------------------------------------------------
$idDocument = $_POST['idDocument'];
$DocumentType = $_POST['DocumentType'];

//DEFINE VARS -----------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idDocument == '' || $DocumentType == '') 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//PROCESS TABLE NAME AND FIELD NAME -------------------------------------
$fieldIdName = '';
$tableName = '';
switch ($DocumentType) {
	case 'CC':
		$fieldIdName = 'ID_Consommable';
		$tableName = 'faturacao_consommables';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000AA";
		$response["message"] = 'Tipo inválido!';
		die(json_encode($response));
		break;
}

//OBTEM OS Données de Facture ----------------------------------------------
$query = "SELECT ".$fieldIdName.", 
		ID_Cliente, 
		(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = ".$tableName.".ID_Cliente) AS NomeCliente, 
		(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = ".$tableName.".ID_Cliente) AS CodigoCliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente, 

		EnderecoClienteDescarga, 
		EnderecoCliente2Descarga, 
		CodigoPostalClienteDescarga, 
		RegiaoClienteDescarga, 
		CidadeClienteDescarga, 
		PaisClienteDescarga, 
		
		(SELECT Telemovel FROM faturacao_clientes WHERE faturacao_consommables.ID_Cliente=faturacao_clientes.ID_Cliente),
		Numero, 
		Data, 
		Debut, 
		Referencia, 
		Remarque, 
		Estado, 
		ID_Utilizador_Criacao, 
		ID_Utilizador_Atualizacao, 
		DataAtualizacao,
		(SELECT CONCAT(Fabricante, ' ', Modelo) FROM faturacao_consommables_compteurs WHERE faturacao_consommables.ID_Consommable=faturacao_consommables_compteurs.ID_Consommable ORDER BY ID_Compteur DESC LIMIT 1),
		(SELECT NumSerie FROM faturacao_consommables_compteurs WHERE faturacao_consommables.ID_Consommable=faturacao_consommables_compteurs.ID_Consommable ORDER BY ID_Compteur DESC LIMIT 1),
		Etat_noir,
		Etat_couleur,
		NomeCliente2,
		ApelidoCliente2,
		TituloCliente,
		(SELECT Suspendu FROM faturacao_clientes WHERE faturacao_consommables.ID_Cliente=faturacao_clientes.ID_Cliente)
		FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocument);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Fatura'],
	        	$objectData['ID_Cliente'],
	        	$objectData['NomeCliente'],
	        	$objectData['CodigoCliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['EnderecoClienteDescarga'],
	        	$objectData['EnderecoCliente2Descarga'],
	        	$objectData['CodigoPostalClienteDescarga'],
	        	$objectData['RegiaoClienteDescarga'],
	        	$objectData['CidadeClienteDescarga'],
	        	$objectData['PaisClienteDescarga'],
	        	$objectData['TelefoneCliente'],
	        	$objectData['Numero'],
	        	$objectData['Data'],
	        	$objectData['Debut'],
	        	$objectData['Referencia'],
	        	$objectData['Observacoes'],
	        	$objectData['Estado'],
	        	$objectData['ID_UtilizadorCriacao'],
	        	$objectData['ID_UtilizadorAtualizacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['Impressora'],
	        	$objectData['NumImpressora'],
	        	$objectData['Etat_noir'],
	        	$objectData['Etat_couleur'],
	        	$objectData['Nome'],
	        	$objectData['Apelido'],
	        	$objectData['Titulo'],
	        	$objectData['Suspendu']
			);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DA FATURA ------------------------------------------
$query = "SELECT ID_Artigo,
		Nome,
		(SELECT Sigla FROM faturacao_unidades WHERE faturacao_artigos.ID_Unidade=faturacao_unidades.ID_Unidade) AS UnidadeMedida,
		Preco,
		ID_Imposto,
		-- (SELECT ID_Motivo FROM faturacao_motivos_isencao WHERE faturacao_motivos_isencao.Codigo = faturacao_rapports_travail_linhas.TaxExemptionCode ) AS ID_Motivo,
		-- DescontoLinha,
		-- PercentagemRetencao,
		Tipo,
		Codigo,
		CodigoBarras
		FROM faturacao_artigos WHERE faturacao_artigos.ID_Categoria=(SELECT faturacao_artigos_categorias.ID_Categoria FROM faturacao_artigos_categorias WHERE Nome LIKE 'Rapports de Travail' LIMIT 1) AND Ativo = 1 ORDER BY Codigo ASC";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($artigo, $descricao, $unidade, $preco, $imposto, /*$motivo, $desconto, $retencao,*/ $tipo, $codigo_artigo, $codigobarras_artigo  );
	while ($stmt -> fetch()) {
		$datalin[] = array(
		        	"artigo" => $artigo,
					"descricao" => $descricao,
					"unidade" => $unidade,
					"preco" => $preco,
					"imposto" => $imposto,
					"qtd" => 0,
					// "motivo" => $motivo,
					"desconto" => 0,
					// "retencao" => $retencao,
					"Tipo" => $tipo,
					"totalLinha" => 0,
					"codigo" => $codigo_artigo,
					"codigobarras" => $codigobarras_artigo,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $datalin;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>