<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$nome_responsavel = $_POST['nome_responsavel'];
$prenom_responsavel = $_POST['prenom_responsavel'];
$email_responsavel = $_POST['email_responsavel'];
$contacto_responsavel = $_POST['contacto_responsavel'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $nome_responsavel == '' || $prenom_responsavel == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//GET NEXT CODIGO RESPONSAVEL ----------------------------------------------------
$query = "SELECT MAX(CAST(Codigo AS UNSIGNED)) FROM faturacao_responsaveis";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "HELP001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($nextID);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "HELP002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//return next id
$codigoResponsavel = $nextID+1;

$timestampResponsavel = microtime(true);

//INSERT DB ------------------------------------------------------------------
$query = "INSERT INTO faturacao_responsaveis (
	Codigo, 
	Nome, 
	Prenom,
	Email,
	Contacto,
	TimeStampResponsavel
	) VALUES (?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssssss", 
		$codigoResponsavel,
	    $nome_responsavel, 
	    $prenom_responsavel, 
		$email_responsavel,
		$contacto_responsavel,
		$timestampResponsavel
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------------------

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT ID_Responsavel FROM faturacao_responsaveis WHERE TimeStampResponsavel=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("s", $timestampResponsavel);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idResponsavel);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Création du responsable (Modal)(code: ".$codigoResponsavel.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response['idFornecedor'] = $idResponsavel;
$response['NextID'] = $codigoResponsavel+1;
die(json_encode($response));
?>