<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];


//GET POST VARS ---------------------------------------------------------
$idResponsavel = $_POST['idResponsavel'];
$nome_responsavel = $_POST['nome_responsavel'];
$codigo_interno_responsavel = $_POST['codigo_interno_responsavel'];
$contacto_responsavel = $_POST['contacto_responsavel'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idResponsavel == '' || $nome_responsavel == '' || $codigo_interno_responsavel == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//CHECK IF INT. CODE USED -------------------------------------------------
$query = "SELECT COUNT(*) FROM faturacao_responsavel_contratos WHERE Codigo_Interno=? AND ID_RespContrato<>?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("sd", $codigo_interno_responsavel, $idResponsavel);

	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $usado );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add info to main array
if($usado > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["usada"] = true;
	$response["line"] = "FATS002A";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//INSERT DB ------------------------------------------------------------------
$query = "UPDATE faturacao_responsavel_contratos SET
	Nome=?,
	Contacto=?,
	Codigo_Interno=?
	WHERE ID_RespContrato = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssd", 
	    $nome_responsavel,	    
		$contacto_responsavel,
		$codigo_interno_responsavel,
		$idResponsavel 
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Édition du responsable (id: ".$idResponsavel.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);
	
//response
$response["errors"] = false;
die(json_encode($response));
?>