<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$nome_responsavel = $_POST['nome_responsavel'];
$codigo_interno_responsavel = $_POST['codigo_interno_responsavel'];
$contacto_responsavel = $_POST['contacto_responsavel'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $nome_responsavel == '' || $codigo_interno_responsavel == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//CHECK IF INT. CODE USED -------------------------------------------------
$query = "SELECT COUNT(*) FROM faturacao_responsavel_contratos WHERE Codigo_Interno=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("s", $codigo_interno_responsavel);

	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $usado );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add info to main array
if($usado > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["usada"] = true;
	$response["line"] = "FATS002A";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//GET NEXT CODIGO VENDEDOR ----------------------------------------------------
$query = "SELECT MAX(CAST(Codigo AS UNSIGNED)) FROM faturacao_responsavel_contratos";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "HELP001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($nextID);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "HELP002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//return next id
$codigoVendedor = $nextID+1;

$timestampVendedor = microtime(true);

//INSERT DB ------------------------------------------------------------------
$query = "INSERT INTO faturacao_responsavel_contratos (
	Codigo, 
	Codigo_Interno, 
	Nome, 
	Contacto,
	TimeStampVendedor
	) VALUES (?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssss", 
	    $codigoVendedor, 
	    $codigo_interno_responsavel, 
	    $nome_responsavel, 
		$contacto_responsavel,
		$timestampVendedor
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------------------

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT ID_RespContrato FROM faturacao_responsavel_contratos WHERE TimeStampVendedor=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("s", $timestampVendedor);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idResponsavel);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Création du responsable (id: ".$idResponsavel.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>