<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$descricao_codepostal = $_POST['descricao_codepostal'];
$code_codepostal = $_POST['code_codepostal'];

if ($descricao_codepostal == '' || $code_codepostal == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//-----------------------------------------------------------------------
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//INSERT DB -------------------------------------------------------------
	$query = "INSERT INTO faturacao_npa_localites (npa, localite) VALUES(?,?) ";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ss", $code_codepostal, $descricao_codepostal );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//--------------------------------------------------------------


	//log sistema -------------------------------------------------------
	$descricao_log ="Code Postal (NPA): Création (".$code_codepostal." - ".$descricao_codepostal.")";
	insert_log(14,"Inserir",$descricao_log,$sqli_connection);

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
die(json_encode($response));
?>