<?php
/**
 * |-----------------------------------------------------------------------
 * |
 * |						Login Actions - API
 * |
 * |	(Must get the user password from utilizador table and update here*)
 * |		(on licence generation must insert the licence user here* to!)
 * |			(* means: faturacao_utilizadores_webservices table)
 * |
 * |-----------------------------------------------------------------------
 */

//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
// include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/auth/controltoken.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/server_key.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/jwt_helper.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/helpers.php";

// var_dump($_POST);die();

//PROCESS LOGIN ---------------------------------------------------------
if (isset($_POST['username']) && isset($_POST['password'])) {

	try {
		// Turn off AUTOCOMMIT and begin Transaction
		mysqli_autocommit($sqli_connection, FALSE);
		$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

		//prepare vars
		$userRec = $_POST['username'];
		$pwdRec = $_POST['password'];
		$userWebApi = null;
		$Nome = null;
		$Username = null;
		$Email = null;
		$Password = null;
		$Salt = null;
		$UserWebserviceTable = null;
		$PasswordErrada = null;
		$PasswordBloqueada = null;

		//process the token
		$query = "SELECT Nome, Username, Email, Password, Salt, (SELECT ID_UtilizadorWebservice FROM faturacao_utilizadores_webservices WHERE faturacao_utilizadores_webservices.Username = utilizador.Username LIMIT 1) AS UserWebserviceTable, (SELECT PasswordErrada FROM faturacao_utilizadores_webservices WHERE faturacao_utilizadores_webservices.Username = utilizador.Username LIMIT 1) AS PasswordErrada, (SELECT PasswordBloqueada FROM faturacao_utilizadores_webservices WHERE faturacao_utilizadores_webservices.Username = utilizador.Username LIMIT 1) AS PasswordBloqueada FROM utilizador WHERE Username =?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("s", $userRec);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 500 Internal Server Error.');
				$response["errors"] = true;
				$response["type"] = "sql_query";
				$response["line"] = "WAPI_SQLQ001";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($Nome, $Username, $Email, $Password, $Salt, $UserWebserviceTable, $PasswordErrada, $PasswordBloqueada);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "sql_conn";
			$response["line"] = "WAPI_SQLC001";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}		

		//check if can login ----------------------
		if(!$Nome && !$Username){
			//cancel the request
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 403 Forbidden.');
			$response["errors"] = true;
			$response["type"] = "validation";
			$response["line"] = "WAPI_VAL003";
			$response["message"] = 'Invalid username/password. Please provide a valid username/password.';
			die(json_encode($response));
		}
		//-----------------------------------------

		//check if can login ----------------------
		if($PasswordErrada && $PasswordErrada > 3){

			$nDtPWD = time();
			$expiresPwdBlock = DateTime::createFromFormat("Y-m-d H:i:s", $PasswordBloqueada);
			$expiresPwdBlockTimestamp = $expiresPwdBlock->getTimestamp();

			//check password block until date
			if($nDtPWD < $expiresPwdBlockTimestamp){
				//block the request
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 403 Forbidden.');
				$response["errors"] = true;
				$response["type"] = "validation";
				$response["line"] = "WAPI_VAL001";
				$response["message"] = 'Login blocked! Please try again later.';
				$response["attempts"] = $PasswordErrada;
				$response["blocked_until"] = $PasswordBloqueada;
				die(json_encode($response));
			}
		}
		//-----------------------------------------


		//update/insert data on webservices users table
		$query = '';
		if($UserWebserviceTable > 0){
			//get user id for further use
			$userWebApi = $UserWebserviceTable;

			$query = "UPDATE faturacao_utilizadores_webservices SET Nome=?, Email=?, Password=?, Salt=? WHERE Username =?";
		}else{
			$query = "INSERT INTO faturacao_utilizadores_webservices ( Nome, Username, Email, Password, Salt ) VALUES (?,?,?,?,?)";
		}
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			if($UserWebserviceTable > 0) $stmt -> bind_param("sssss", $Nome, $Email, $Password, $Salt, $userRec);
			else $stmt -> bind_param("sssss", $Nome, $Username, $Email, $Password, $Salt);

			//result
			$result = $stmt -> execute();
			if (false === $result) {
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 500 Internal Server Error.');
				$response["errors"] = true;
				$response["type"] = "sql_query";
				$response["line"] = "WAPI_SQLQ002";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			//get last id and close connection
			if($UserWebserviceTable < 1) {
				$tmpID = $stmt->insert_id;
				$userWebApi = $tmpID;
			}
			$stmt -> close();

		} else {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "sql_conn";
			$response["line"] = "WAPI_SQLC002";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//get hashed password
		$HashRec = hash('sha256', $pwdRec);
		$pwdRecHash = hash('sha256', $Salt . $HashRec);

		//process password
		if ($pwdRecHash != $Password){
			//vars
			$minutesToTry = 0;
			$PasswordErradaNew = $PasswordErrada + 1;

			//check password attempts to calculate de minutes remaining until next try
			if($PasswordErrada && $PasswordErrada > 5){
				$minutesToTry = $PasswordErrada * 15;
			}elseif($PasswordErrada > 2){
				$minutesToTry = 1;
			}else{
				$minutesToTry = 0;
			}
			// password block date
			$cTime = date('Y-m-d H:i:s');
			$newBlockDate = date("Y-m-d H:i:s", strtotime("+".$minutesToTry." minutes", strtotime($cTime)));

			//Update wrong passwords
			$query = "UPDATE faturacao_utilizadores_webservices SET PasswordErrada=?, PasswordBloqueada=? WHERE ID_UtilizadorWebservice =?";
			if ( $stmt = $sqli_connection -> prepare($query) ) {
				//bind params
				$stmt -> bind_param("sss", $PasswordErradaNew, $newBlockDate, $userWebApi);
				//result
				$result = $stmt -> execute();
				if (false === $result) {
					header('Content-Type: application/json; charset=UTF-8');
					header('HTTP/1.1 500 Internal Server Error.');
					$response["errors"] = true;
					$response["type"] = "sql_query";
					$response["line"] = "WAPI_SQLQ002A";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 500 Internal Server Error.');
				$response["errors"] = true;
				$response["type"] = "sql_conn";
				$response["line"] = "WAPI_SQLC002A";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			//---------------------------------

			// Save all querys on DB
			$sqli_connection->commit();

			//---------------------------------

			//cancel the request
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 403 Forbidden.');
			$response["errors"] = true;
			$response["type"] = "validation";
			$response["line"] = "WAPI_VAL002";
			$response["message"] = 'Invalid username/password. Please provide a valid username/password.';
			$response["attempts"] = $PasswordErradaNew;
			$response["block_until"] = $newBlockDate;
			die(json_encode($response));
		}else{
			//if success then generate new token
			$pToken = array();
			$pToken['user'] = $userWebApi;
			$pToken['username'] = $Username;
			$pToken['created'] = date('Y-m-d H:i:s');
			//get key
			$serverKey = getServerKey();

			$newToken = JWT::encode($pToken, $serverKey);
			// $newTokenDec = JWT::decode($newToken, $serverKey);

			// token expire date valid for 15 minutes
			$current_date_time = date('Y-m-d H:i:s');
			$newExpireDate = date("Y-m-d H:i:s", strtotime("+15 minutes", strtotime($current_date_time)));

			//Update
			$query = "UPDATE faturacao_utilizadores_webservices SET Token=?, Token_Created=?, Token_Expires=?, PasswordErrada=NULL, PasswordBloqueada=NULL WHERE ID_UtilizadorWebservice =?";
			if ( $stmt = $sqli_connection -> prepare($query) ) {
				//bind params
				$stmt -> bind_param("ssss", $newToken, $current_date_time, $newExpireDate, $userWebApi);
				//result
				$result = $stmt -> execute();
				if (false === $result) {
					header('Content-Type: application/json; charset=UTF-8');
					header('HTTP/1.1 500 Internal Server Error.');
					$response["errors"] = true;
					$response["type"] = "sql_query";
					$response["line"] = "WAPI_SQLQ003";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 500 Internal Server Error.');
				$response["errors"] = true;
				$response["type"] = "sql_conn";
				$response["line"] = "WAPI_SQLC003";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}
			//---------------------------------

			// Save all querys on DB
			$sqli_connection->commit();

			//log the action ------------------
			$logUserID = $userWebApi;
			$logUserName = $Username;
			$logAction = 'Login';
			$logDesc = 'Sucesso';
			insert_log($logUserID,$logUserName , $logAction, $logDesc, $sqli_connection);

			//---------------------------------
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 200 Ok.');
			$response["errors"] = false;
			$response["type"] = "-";
			$response["line"] = "-";
			$response["message"] = "Login successfully!";
			$response["user"] = array(
				'user_id' => $userWebApi,
				'name' => $Nome,
				'username' => $Username,
				'email' => $Email,
			);
			$response["_token"] = $newToken;
			die(json_encode($response));
		}

		// test things
		// header('Content-Type: application/json; charset=UTF-8');
		// header('HTTP/1.1 200 Ok.');
		// $response["errors"] = false;
		// $response["type"] = "-";
		// $response["line"] = "-";
		// $response["userId_db"] = $UserWebserviceTable;
		// $response["username_rec"] = $userRec;
		// $response["username_db"] = $userWebApi;
		// $response["serverKey"] = $serverKey;
		// $response["newToken"] = $newToken;
		// $response["current_date_time"] = $current_date_time;
		// $response["newExpireDate"] = $newExpireDate;
		// $response["newTokenDec"] = $newTokenDec;
		// $sqli_connection->rollback();
		// die(json_encode($response));
	} catch (Exception $e) {
		$sqli_connection->rollback();

		//cancel request
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "sql_trans";
		$response["line"] = "WAPI_SQLT001";
		$response["message"] = $e->getMessage();
		die(json_encode($response));
	}
}else{
	//cancel the request
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 400 Bad Request.');
	$response["errors"] = true;
	$response["type"] = "connection";
	$response["line"] = "WAPI_CONN001";
	$response["message"] = 'Missing username/password. Please provide a valid username/password.';
	die(json_encode($response));
}
