<?php
/**
 * |-----------------------------------------------------------------------
 * |
 * |							Log Register
 * |
 * |-----------------------------------------------------------------------
 */

/**
 * INSERT LOGS FOR WEBSERVICES CALLS
 * @param  $idUser          [id of user]
 * @param  $nameUser        [username of user]
 * @param  $accao           [Login, Logout, Inserir, Editar, Apagar]
 * @param  $descricao       [description of the action]
 * @param  $sqli_connection [sql connection]
 * @return json response
 */
function insert_log($idUser,$nameUser , $action, $description, $sqli_connection) {
	//nullable values
	$modulo = 0;

	//prepare user
	$id_utilizador = $idUser;
	$nome_utilizador = $nameUser;

	//prepare time
	$data = date('d/m/Y');
	$hora = date('H:i:s');

	//prepare action and description
	$accao = $action;
	$descricao = '[WEBS_API] '.$description;

	//get IP address
	if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
		$ip = $_SERVER['HTTP_CLIENT_IP'];
	} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
		$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	} else {
		$ip = $_SERVER['REMOTE_ADDR'];
	}

	$query = "Insert into log (ID_Utilizador, Nome, Data, Hora, ID_Modulo, Accao, Descricao, IP) values(?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dsssdsss", $id_utilizador, $nome_utilizador, $data, $hora, $modulo, $accao, $descricao, $ip);
		$stmt -> execute();
		$stmt -> close();
	}
}
?>