<?php
/**
 * |-----------------------------------------------------------------------
 * |
 * |						Processor Functions
 * |
 * |-----------------------------------------------------------------------
 */

//GLOBAL VAR --------------------------------------------------------------
$gOpcaoProcessor = null;
$recToken = null;

//PROCESS REQUEST METHOD AND GET OPTION FOR PROCESSING --------------------
switch ($_SERVER['REQUEST_METHOD']) {
	case 'GET':
		$recToken = $_GET['_token'];
		$gOpcaoProcessor = $_GET['option'];
		break;

	case 'POST':
		$recToken = $_POST['_token'];
		$gOpcaoProcessor = $_POST['option'];
		break;

	case 'PUT':
		parse_str(file_get_contents("php://input"),$_PUT);
		$recToken = $_PUT['_token'];
		$gOpcaoProcessor = $_PUT['option'];
		break;

	case 'PATCH':
		parse_str(file_get_contents("php://input"),$_PATCH);
		$recToken = $_PATCH['_token'];
		$gOpcaoProcessor = $_PATCH['option'];
		break;

	case 'DELETE':
		parse_str(file_get_contents("php://input"),$_DELETE);
		$recToken = $_DELETE['_token'];
		$gOpcaoProcessor = $_DELETE['option'];
		break;
	
	default:
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 405 Method Not Allowed.');
		$response["errors"] = true;
		$response["type"] = "connection";
		$response["line"] = "WAPI_CONN001";
		$response["message"] = 'The Received method is not supported by the target resource.';
		die(json_encode($response));
		break;
		
}
//-------------------------------------------------------------------------

/**
 * Get base link for application
 * @return string
 */
function getBaseLink(){
	//var
	$finalBaseUrl = null;

	//process base link and return string with url
	$protocol = isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off' ? 'https' : 'http';
	$baseurl = $_SERVER['SERVER_NAME'];

	//process final string
	$finalBaseUrl = $protocol.'://'.$baseurl;

	//return final url
	return $finalBaseUrl;
}

/**
 * Get api path for application
 * @return string
 */
function getApiPath(){
	//process final string
	$finalApiPath = '/frifacturation/server';

	//return final url
	return $finalApiPath;
}

/**
 * Get webservices path for application
 * @return string
 */
function getWebservicesPath(){
	//process final string
	$finalApiPath = '/frifacturation/server/webservices';

	//return final url
	return $finalApiPath;
}
