<?php
/**
 * |-----------------------------------------------------------------------
 * |
 * |							SERVER KEY JWT
 * |
 * |-----------------------------------------------------------------------
 */


/**
 * Get the server key
 * @return server key
 */
function getServerKey(){
	global $sqli_connection;
	
	//b64
	$combine_key = "RlJJQ09ERV9DSF9DSEUzMzA2MDUzMzM=";
	$server_key = null;

	//process key to be used
	try {
		// Turn off AUTOCOMMIT and begin Transaction
		// mysqli_autocommit($sqli_connection, FALSE);
		// $sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

		//get DB
		$query = "SELECT Nif FROM faturacao_empresa_dados LIMIT 1";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			// $stmt -> bind_param("s", $nifEmpresa);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 500 Internal Server Error.');
				$response["errors"] = true;
				$response["type"] = "sql_query";
				$response["line"] = "WAPI_SQLQ001";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($NifEmpresa);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "sql_conn";
			$response["line"] = "WAPI_SQLC001";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//clean Nif from punctuation or special chars
		$cleanedNif = simpleCleanerString($NifEmpresa);

		//process the server key
		$hashKey = hash('sha256', $cleanedNif);
		$server_key = hash('sha256', $combine_key . $hashKey);
		
	} catch (Exception $e) {
		return false;
	}

	//return key
	return $server_key;
}

//clean strings (simple version)
function simpleCleanerString($string) {
	// Replaces all spaces with hyphens.
	$string = str_replace(' ', '-', $string);

	// Removes special chars.
	$string = preg_replace('/[^A-Za-z0-9\-]/', '', $string);
	
	// Replaces multiple hyphens with single one and return string
	return preg_replace('/-+/', '-', $string);
}
?>