<?php 
/**
 * Get all Perms organized by features
 * @param  $fieldName
 * @param  $tableName
 * @return next id
 */
function getAllPermsList($roleID){
	global $sqli_connection;

	//DEFINE VARS ---------------
	$objectData = array();

	//GET FEATURES --------------
	$query = "SELECT ID_Funcionalidade, Nome
	FROM faturacao_funcionalidades ORDER BY Posicao";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("d", $var);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($id_funcionade, $nome );
		while ($stmt -> fetch()) {
			$objectData[] = array(
			        	"id_funcionalidade" => $id_funcionade,
			        	"nome_funcionalidade" => $nome,
			        	"permissoes" => [],
			        );
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//---------------------------
	
	//GET FEATURES --------------
	foreach ($objectData as $key => $obj) {
		$query = "SELECT ID_Permission, Machine_Name, Name,
		(SELECT COUNT(*) FROM faturacao_role_permission WHERE ID_Role_Rel=".$roleID." AND ID_Permission_Rel = ID_Permission)
		FROM faturacao_permissions WHERE Funcionalidade=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $obj['id_funcionalidade']);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS001";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($id_permission, $machinename, $nome_permission, $counter_p );
			while ($stmt -> fetch()) {
				$selected=$counter_p;
				if($counter_p > 0) $selected = 'checked';

				$objectData[$key]['permissoes'][] = array(
				        	"id_permission" => $id_permission,
				        	"machinename" => $machinename,
				        	"nome_permission" => $nome_permission,
				        	"is_checked" => $selected,
				        );
			}
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS002";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}
	//---------------------------

	return $objectData;
}
?>