<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idFecho = $_POST['idFermeture'];


//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idFecho == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}

//GET INFO BD -------------------------------------------------------------
$estadoAtual=0; $anoBD=0; $mesBD=0; $mesStr = '';
$query = "SELECT Estado, Ano, Mes FROM faturacao_fecho_mes WHERE ID_MesFecho = ?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	$stmt -> bind_param("d", $idFecho);
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS0001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($estadoAtual, $anoBD, $mesBD);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS0002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
$mesStr = month_in_french($mesBD);
//------------------------------------------------------------------------

//INSERT NEW DOCUMENT ----------------------------------------------------
$novoEstado = 1;
if($estadoAtual == 1) $novoEstado = 0;
$query = "UPDATE faturacao_fecho_mes SET Estado=? WHERE ID_MesFecho = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param(
		"dd", 
		$novoEstado,
		$idFecho
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS0003B";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Édition de fermeture du mois ( ".$mesStr." ".$anoBD." - Changement d\'état)";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));

?>