<?php
//INCLUDE CONNECTION
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
//GET POST VARS

$id_utilizador = $_SESSION['id_utilizadorEDIT'];

if ($id_utilizador == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

$password_utilizador = $_POST['password_utilizador'];
$nome_utilizador = '';


//CHECK IF VARS ARE NULL OR EMPTY
if ($password_utilizador == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

//GET USER DATA
$query = "SELECT Nome FROM utilizador WHERE ID_Utilizador=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($nome_utilizador);
	$stmt -> fetch();
	$stmt -> close();

} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//Salt Func
function createSalt() {
	$text = md5(uniqid(rand(), true));
	return substr($text, 0, 3);
}


$hash = hash('sha256', $password_utilizador);
$salt = createSalt();
$password_utilizador = hash('sha256', $salt . $hash);
$tipo_utilizador = 2;

$query = "UPDATE  utilizador SET  Password=?, Salt=? WHERE ID_Utilizador=? AND ID_TipoUtilizador=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssdd", $password_utilizador, $salt, $id_utilizador, $tipo_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA007";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA008";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}

//log sistema - processo
$descricao_log ="Modification du mot de passe de l'utilisateur (id: ".$id_utilizador." | nom: ".$nome_utilizador.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

unset($_SESSION['id_utilizadorEDIT']);
$response["errors"] = false;
die(json_encode($response));
?>