<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idRole = $_POST['idRole'];
$permissions = $_POST['permissions'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idRole == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}

//GET SOME DATA ----------------------------------------------------------
$query = "SELECT faturacao_roles.Name FROM faturacao_roles WHERE ID_Role=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idRole);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($namerole);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DELETE PREVIOUS PERMISSIONS -------------------------------------------
$query = "DELETE FROM faturacao_role_permission WHERE ID_Role_Rel=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idRole );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------


//INSERT NEW PERMISSIONS -------------------------------------------------
if( sizeof($permissions) > 0 ){
	foreach ($permissions as $key => $perm) {
		$query = "INSERT INTO faturacao_role_permission (
				ID_Role_Rel, 
				ID_Permission_Rel
				) 
			VALUES (?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param(
				"dd", 
				$idRole,
				$perm['id_permission']
			);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS0003";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS0003B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}
}
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Édition de Permissions du profil (nom: ".$namerole.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["role"] = $idRole;
$response["errors"] = false;
die(json_encode($response));

?>