<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idPermission = $_POST['idPermission'];
$nome = $_POST['nome'];
$funcionalidade = $_POST['funcionalidade'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idPermission == '' || $nome == '' || $funcionalidade == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}

//GET NEW ID -------------------------------------------------------------
$query = "SELECT Machine_Name FROM faturacao_permissions WHERE ID_Permission = ?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	$stmt -> bind_param("d", $idPermission);
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS0001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($machine_name);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS0002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//INSERT NEW DOCUMENT ----------------------------------------------------
$query = "UPDATE faturacao_permissions SET
			Name=?, 
			Funcionalidade=?
			WHERE ID_Permission = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param(
		"sdd", 
		$nome,
		$funcionalidade,
		$idPermission
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS0003B";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Édition de permission (machine name: P".$machine_name.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));

?>