<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($_POST['data']) && $_POST['data'] != '' ? $_POST['data'] : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//GET POST VARS ---------------------------------------------------------
$docOrigem = $_POST['docOrigem'];
$docType = $_POST['docType'];
$cliente = $_POST['cliente'];
$serie = $_POST['serie'];
$numero = $_POST['numero'];
$data = $_POST['data'];
$validade = $_POST['validade'];
$referencia = $_POST['referencia'];
$pagamento = $_POST['pagamento'];
$banco = $_POST['banco'];
$vencimento = $_POST['vencimento'];
$moeda = $_POST['moeda'];
$desconto = $_POST['desconto'];
$observacoes = $_POST['observacoes'];
$motivo = $_POST['motivo'];
$linhas = $_POST['linhas'];
$finalizarDocumento = $_POST['finalizarDocumento'];
$precisaBanco = $_POST['precisaBanco'];

//REMAIN FIELDS ----------------------------------------------------------
$vendedor = $_SESSION['username'];
$estado = 'Rascunho';
$taxPayable = 0;
$netTotal = 0;
$grossTotal = 0;
$systemEntryDate = '';
$timestamp = 0;
$totalDesconto = 0;
$percentagemDesconto = $desconto;
$retencaoTotal = 0;
$totalSDesconto = 0;

$extraOri = 0; $extraLiqOri = 0; $extraPorPagarOri = 0;


//NEW FIELDS FATURAS -----------------------------------------------------
$invoiceType = 'NC';
$EACCode = '';
$customerID = '';
$totalPagar = 0;
// MetodoPagamento
// BancoID
$invoiceStatusDate = '';
$sourceID = $_SESSION['username'];
$hash = '';
$hashControl = 1;
$hashPrint = '';
$period = '';
$invoiceDate = '';
$movementEndTime = '';
$movementStartTime = '';
$totalLiquidado = 0;

//NEW FIELDS PLANO CONTAS
$PlanoContasCliente = getPlanoCode("PlanoContas", "faturacao_clientes", "ID_Cliente", $cliente);
$PlanoContasBanco = '';

//PROCESS ORIGIN
$fieldIdName = '';
$tableName = '';
switch ($docType) {
	case 'FT':
		$fieldIdName = 'ID_Fatura';
		$tableName = 'faturacao_faturas';
		break;
	case 'FS':
		$fieldIdName = 'ID_FaturaSimplificada';
		$tableName = 'faturacao_faturas_simplificadas';
		break;
	case 'FR':
		$fieldIdName = 'ID_FaturaRecibo';
		$tableName = 'faturacao_faturas_recibo';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000AA";
		$response["message"] = 'Tipo inválido!';
		die(json_encode($response));
		break;
}

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $docOrigem == '' || $docType == '' || $cliente == '' || $serie == '' || $numero == '' || $data == '' || $validade == '' || $pagamento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
if( $precisaBanco > 0 && ($banco < 1 || $banco == '') )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000B";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//CHECK LINES
if(!is_array($linhas) || empty($linhas)){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000x";
	$response["lines_empty"] = true;
	$response["message"] = "";
	die(json_encode($response));
}
//-----------------------------------------------------------------------
// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);die();


try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//GET REMAINING FIELDS FROM ORIGIN DOC -----------------------------------
	$query = "SELECT InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = ".$tableName.".ID_Serie), Numero, Data, ID_Cliente, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS0000C";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($invoiceTypeOrigin, $serieOrigin, $numeroOrigin, $dataOrigin, $idClienteOrigin, $estadoOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000D";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//contruct final reference
	$referenceOrigin = "FA ".$serieOrigin.'/'.$numeroOrigin;
	//------------------------------------------------------------------------

	//CHECK IF IS THE SAME CLIENT AND STATUS ALLOWED -------------------------
	if( $idClienteOrigin != $cliente )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS0000E";
		die(json_encode($response));
	}
	if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS0000F";
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//GET CLIENT DATA --------------------------------------------------------
	$query = "SELECT Nif, Endereco, CodigoPostal, Cidade, Regiao, Pais, Email, Codigo FROM faturacao_clientes WHERE ID_Cliente = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $cliente);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($Nif, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Pais, $Email, $CodigoCliente );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//process fields
	if( trim($Endereco) == '' ) $Endereco = 'Desconhecido';
	if( trim($CodigoPostal) == '' ) $CodigoPostal = 'Desconhecido';
	if( trim($Cidade) == '' ) $Cidade = 'Desconhecido';
	if( trim($Regiao) == '' ) $Regiao = 'Desconhecido';
	if( trim($Pais) == '' ) $Pais = 'Desconhecido';
	//------------------------------------------------------------------------

	//GET CURRENCY DATA ------------------------------------------------------
	$query = "SELECT  Ultima_Taxa FROM faturacao_moedas WHERE ID_Moeda = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $moeda);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ultimaTaxa);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $ultimaTaxa <= 0){
		$response["errors"] = true;
		$response["type"] = "FTGA005";
		$response["message"] = "Moeda inválida";
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//GET COMPANY DATA -------------------------------------------------------
	$query = "SELECT  CONCAT(Endereco1,' ',Endereco2) AS Endereco, CodigoPostal, Cidade, Cidade, CAE_Principal FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		// $stmt -> bind_param("d", $moeda);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($enderecoCarga, $codigopostalCarga, $cidadeCarga, $idCidadeCarga, $CAE_Principal);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//GET REGION
	// $query = "SELECT (SELECT Nome FROM distrito WHERE distrito.ID_Distrito = concelho.ID_Distrito) AS Regiao FROM concelho WHERE ID_Concelho = ?";
	// if ($stmt = $sqli_connection -> prepare($query)) {
	// 	$stmt -> bind_param("d", $idCidadeCarga);
	// 	$result = $stmt -> execute();
	// 	if (false === $result) {
	// 		$response["errors"] = true;
	// 		$response["type"] = "FTGA008";
	// 		$response["message"] = $stmt -> error;
	// 		die(json_encode($response));
	// 	}
	// 	$stmt -> bind_result($regiaoCarga);
	// 	$stmt -> fetch();
	// 	$stmt -> close();
	// } else {
	// 	$response["errors"] = true;
	// 	$response["type"] = "FTGA009";
	// 	$response["message"] = $sqli_connection -> error;
	// 	die(json_encode($response));
	// }
	$regiaoCarga = '';
	//process fields
	if( trim($enderecoCarga) == '' ) $enderecoCarga = 'Desconhecido';
	if( trim($codigopostalCarga) == '' ) $codigopostalCarga = 'Desconhecido';
	if( trim($cidadeCarga) == '' ) $cidadeCarga = 'Desconhecido';
	if( trim($regiaoCarga) == '' ) $regiaoCarga = 'Desconhecido';
	//------------------------------------------------------------------------

	$timestamp = microtime(true);
	$systemEntryDate = date("Y-m-d H:i:s");
	$systemEntryDate = str_replace (' ','T',$systemEntryDate);
	$EACCode = $CAE_Principal;
	$customerID = $CodigoCliente;
	if( $precisaBanco > 0 ){
		$bancoFinalID = $banco;
		$PlanoContasBanco = getPlanoCode("PlanoContas", "faturacao_bancos", "ID_Banco", $banco);
	}else{
		$bancoFinalID = 0;
	}

	//INSERT OPEN DOCUMENT ---------------------------------------------------
	$query = "INSERT INTO faturacao_notas_credito(ID_Cliente, EnderecoCliente, CodigoPostalCliente, CidadeCliente, RegiaoCliente, EmailCliente, PaisCliente, ID_Moeda, TaxaMoeda, Vendedor, Vencimento, EnderecoCarga, CodigoPostalCarga, CidadeCarga, RegiaoCarga, ID_Serie, Data, Validade, Referencia, Observacoes, SystemEntryDate, TimeStampDate, Estado, ID_Utilizador, InvoiceType, EACCode, CustomerID, MetodoPagamento, ID_Banco, ID_Documento_Origem, Tipo_Documento_Origem, Reason_Origem, Data_Documento_Origem, Reference, PlanoContas, PlanoContasBanco ) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssssssdsssssssdsssssssdsssdddssssss", $cliente, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Email, $Pais, $moeda, $ultimaTaxa, $vendedor, $vencimento, $enderecoCarga, $codigopostalCarga, $cidadeCarga, $regiaoCarga, $serie, $data, $validade, $referencia, $observacoes, $systemEntryDate, $timestamp, $estado, $id_utilizador, $invoiceType, $EACCode, $customerID, $pagamento, $bancoFinalID, $docOrigem, $docType, $motivo, $dataOrigin, $referenceOrigin, $PlanoContasCliente, $PlanoContasBanco );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA010";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA011";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//GET DOCUMENT ID
	$query = "SELECT ID_NotaCredito FROM faturacao_notas_credito WHERE TimeStampDate = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $timestamp);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA012";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($idNota);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA013";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $idNota < 1){
		$response["errors"] = true;
		$response["type"] = "FTGA014";
		$response["message"] = "Nota inválida";
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//PROCESS LINES ----------------------------------------------------------
	$numLinha = 1;
	foreach ($linhas as $linha) {
		//init vars
		$ProductDescription = '';
		$ProductCode = '';
		$SerialNumber = '';
		$TaxType = '';
		$TaxCountryRegion = '';
		$TaxCode = '';
		$TaxPercentage = '';
		$impostoUsed = '';
		$TaxExemptionCode = '';
		$TaxExemptionReason = '';
		$TaxPointDate = date("Y-m-d");

		//NEW FIELDS PLANO CONTAS
		$PlanoContasArtigo = 0;
		$PlanoContasImposto = 0;

		//GET ORIGINAL PLAN ARTICLE AND PLAN TAXES ---------------
		$planoArtigo = 0;
		$planoImposto = 0;
		$query = "SELECT PlanoContas, PlanoContasTVA FROM ".$tableName."_linhas WHERE ID_Linha = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['idLinhaOrigem']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA015AAA";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($planoArtigo, $planoImposto);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA015B";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		
		$PlanoContasArtigo = $planoArtigo;
		$PlanoContasImposto = $planoImposto;
		//--------------------------------------------------------------------

		//CHECK IF THE PRODUCTS ARE THE SAME AS THE ORIGIN DOC ---------------
		$query = "SELECT COUNT(*) FROM ".$tableName."_linhas WHERE ".$fieldIdName."=? AND ID_Artigo = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dd", $docOrigem, $linha['artigo']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA015A";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($countValidArticles);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA015B";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		if( $countValidArticles < 1 ){
			$response["errors"] = true;
			$response["type"] = "FTGA015C";
			$response["message"] = 'O artigo não existe no documento de origem!';
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------

		//GET ARTICLE DATA ---------------------------------------------------
		$query = "SELECT  Nome, Codigo, SerialNumber, (SELECT Sigla FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade = faturacao_artigos.ID_Unidade) AS Unidade FROM faturacao_artigos WHERE ID_Artigo = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['artigo']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA015D";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($ProductDescription, $ProductCode, $SerialNumber, $Unidade);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA016";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
		
		//GET TAXES DATA -----------------------------------------------------
		$query = "SELECT  Tipo, Regiao, Subclasse, Valor FROM faturacao_impostos WHERE ID_Imposto = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['imposto']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA017";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA018";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
			//VERIFICAR SE IMPOSTO JÁ BLOQUEADO -------------------------------------
			$query = "SELECT COUNT(*) FROM faturacao_impostos_usados WHERE ID_Imposto=?";
			if ( $stmt = $sqli_connection -> prepare($query) ) {
				//bind params
				$stmt -> bind_param("d", $linha['imposto']);
				//result single
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA018A";
					$response["message"] = $stmt -> error;
					// deleteRecord($idNota);
					die(json_encode($response));
				}
				$stmt -> bind_result($impostoUsed);
				$stmt -> fetch();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018B";
				$response["message"] = $sqli_connection -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			if($impostoUsed < 1){
				//INSERT DB --------------------------------------------------
				$query = "INSERT INTO faturacao_impostos_usados(ID_Imposto) VALUES (?)";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("d", $linha['imposto'] );
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "query";
						$response["line"] = "FTGA018C";
						$response["message"] = $stmt -> error;
						// deleteRecord($idNota);
						die(json_encode($response));
					}
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA018D";
					$response["message"] = $sqli_connection -> error;
					// deleteRecord($idNota);
					die(json_encode($response));
				}
				//------------------------------------------------------------
			}

			//CASO SEJA TIPO ISE
			// if( $TaxCode == 'ISE' ){
			if( $TaxCode == 'ISENTO' ){
				if( $linha['motivo'] < 1){
					$response["errors"] = true;
					$response["type"] = "var";
					$response["line"] = "FTGA018E";
					$response["message"] = "Motivo de isenção inválido";
					// deleteRecord($idNota);
					die(json_encode($response));
				}else{
					$query = "SELECT  Codigo, Descricao FROM faturacao_motivos_isencao WHERE ID_Motivo = ?";
					if ($stmt = $sqli_connection -> prepare($query)) {
						$stmt -> bind_param("d", $linha['motivo']);
						$result = $stmt -> execute();
						if (false === $result) {
							$response["errors"] = true;
							$response["type"] = "FTGA018F";
							$response["message"] = $stmt -> error;
							// deleteRecord($idNota);
							die(json_encode($response));
						}
						$stmt -> bind_result($TaxExemptionCode, $TaxExemptionReason);
						$stmt -> fetch();
						$stmt -> close();
					} else {
						$response["errors"] = true;
						$response["type"] = "FTGA018G";
						$response["message"] = $sqli_connection -> error;
						// deleteRecord($idNota);
						die(json_encode($response));
					}
				}

			}
		//--------------------------------------------------------------------
		
		//check if vals are smaller than 0
		if( $linha['qtd'] <= 0 ){
			$response["errors"] = true;
			$response["type"] = "FTGA018H";
			$response["message"] = 'Valores das linhas menores que 0';
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		if( $linha['preco'] < 0 ){
			$response["errors"] = true;
			$response["type"] = "FTGA018I";
			$response["message"] = 'Valores das linhas menores que 0';
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		
		//TOTALS
		$debitAmount = 0;
		$creditAmount = 0;
		$settelementAmount = 0;
		$totalSIVA = 0;
		$totalLinha = 0;

		$linhaDesconto = $linha['desconto'] * 0.01;
		$descontoProcessed = $desconto * 0.01;
		$taxaIVA = $TaxPercentage * 0.01;
		$ivaProcessed = $taxaIVA + 1 ;

		$totalSIVA = $linha['qtd'] * $linha['preco'];
		$desconto1 = $totalSIVA * $linhaDesconto; //calcula desconto 1
		$totalSIVA = $totalSIVA - ($totalSIVA * $linhaDesconto); //calcula descunto linha
		$desconto2 = $totalSIVA * $descontoProcessed; //calcula desconto 2
		$totalSIVA = $totalSIVA - ($totalSIVA * $descontoProcessed); //calcula desconto global

		$settelementAmount = $desconto1 + $desconto2;
		$debitAmount = $totalSIVA;
		$totalLinha = $totalSIVA * $ivaProcessed;

		$retencao = $linha['retencao'] * 0.01;
		$retencao = $totalSIVA * $retencao;

		//TOTALS DOCUMENT
		$taxPayable = $taxPayable + ($totalSIVA * $taxaIVA);
		$netTotal = $netTotal + $totalSIVA;
		$grossTotal = $taxPayable + $netTotal;
		// $grossTotal = round($grossTotal,2);
		$totalDesconto = $totalDesconto + $settelementAmount;
		if( $Nif != '999999990' ) $retencaoTotal = $retencaoTotal + $retencao;
		$totalSDesconto = $totalSDesconto + ( $linha['qtd'] * $linha['preco'] );

		//INSERT INTO DB -----------------------------------------------------
		$query = "INSERT INTO faturacao_notas_credito_linhas (ID_NotaCredito, NumeroLinha, 
			ID_Artigo, ProductCode, ProductDescription, Quantidade, UnidadeMedida, PrecoUnitario, TaxPointDate, Descricao, SerialNumber, 
			ID_Imposto, TaxType, TaxCountryRegion, TaxCode, TaxPercentage, TaxExemptionReason, TaxExemptionCode, 
			DescontoLinha, CreditAmount, DebitAmount, SettlementAmount, ValorRetencao, PercentagemRetencao, TotalLinha, TotalLinhaSIVA, PlanoContas, PlanoContasTVA, ID_LinhaOrigem) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddssssssssdsssssssssssssssss", $idNota, $numLinha, $linha['artigo'], $ProductCode, $ProductDescription, $linha['qtd'], $Unidade, $linha['preco'], $TaxPointDate, $linha['descricao'], $SerialNumber, $linha['imposto'], $TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage, $TaxExemptionReason, $TaxExemptionCode, $linha['desconto'], $creditAmount, $debitAmount, $settelementAmount, $retencao, $linha['retencao'], $totalLinha, $totalSIVA, $PlanoContasArtigo, $PlanoContasImposto, $linha['idLinhaOrigem'] );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA019";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
		
		$numLinha++;

		//BLOCK ARTICLE ------------------------------------------------------
		$query = "UPDATE faturacao_artigos SET Usado=1 WHERE ID_Artigo=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['artigo']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA020A";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020B";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
	}
	//------------------------------------------------------------------------

	//UPDATES TOTALS ---------------------------------------------------------
	$totalDesconto = round($totalDesconto,$numDecimais);
	$retencaoTotal = round($retencaoTotal,$numDecimais);
	$taxPayable = round($taxPayable,$numDecimais);
	$netTotal = round($netTotal,$numDecimais);
	$grossTotal = round($grossTotal,$numDecimais);
	$grossTotal = roundPriceUp($grossTotal);
	$totalPagar = $grossTotal;
	$totalLiquidado = $grossTotal;
	$totalLiquidadoDoc = $grossTotal;

	$query = "UPDATE faturacao_notas_credito SET TaxPayable=?, NetTotal=?, GrossTotal=?, Desconto=?, PercentagemDesconto=?, TotaRetencao=?, TotalSDesconto=?, TotalLiquidadoDocumento=?,TotalLiquidado=?, TotalPagar=?, Data_Documento_Origem=?, Reference=? WHERE ID_NotaCredito=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssssssssssssd", $taxPayable, $netTotal, $grossTotal, $totalDesconto, $percentagemDesconto, $retencaoTotal, $totalSDesconto, $totalLiquidadoDoc, $totalLiquidado, $totalPagar, $dataOrigin, $referenceOrigin, $idNota);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA021C";
			$response["message"] = $stmt -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA022";
		$response["message"] = $sqli_connection -> error;
		// deleteRecord($idNota);
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//CLOSE THE DOCUMENT -----------------------------------------------------
	if( $finalizarDocumento > 0 ){
		$systemEntryDateUpdate = date("Y-m-d H:i:s");
		$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
		$invoiceStatusDate = date("Y-m-d H:i:s");
		$invoiceStatusDate = str_replace (' ','T',$invoiceStatusDate);
		$sourceID = $_SESSION['username'];
		$hash = 'TESTE';
		$hashControl = 1;
		$hashPrint = 'ABCD';
		$movementEndTime = '';
		// $retencaoCalc = round($retencaoTotal,2);
		$retencaoCalc = $retencaoTotal;
		// $totalLiquidado = $retencaoCalc;
		// $totalLiquidado = 0;

		$dataNew = $data;
		$validadeNew = $validade;
		$dataAtualizacao = date("d/m/Y H:i:s");
		
		//process InvoiceDate and period to the choosen one
		$tempDate = DateTime::createFromFormat('d/m/Y', $data);
		$invoiceDate = $tempDate->format('Y-m-d');
		$period = $tempDate->format('m');
		//define start time
		$movementStartTime = $tempDate->format("Y-m-d H:i:s");
		$movementStartTime = str_replace (' ','T',$movementStartTime);


		//GET LAST DATE
		$query = "SELECT Numero, Data FROM faturacao_notas_credito WHERE ID_Serie = ? AND Numero > 0 ORDER BY STR_TO_DATE( Data,  '%d/%m/%Y' ) DESC LIMIT 1";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $serie);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA023";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($numMax, $dataLast);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA024";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		if( $numMax > 0){
			//this entry date timestamp
			$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
			$dtOriginDateTime = $dtOriginDate->getTimestamp();

			//last date timestamp
			$dtLast = DateTime::createFromFormat("d/m/Y H:i:s", $dataLast." 00:00:00");
			$dtLastTime = $dtLast->getTimestamp();

			//this entry validade timestamp
			$dtThisValidade = DateTime::createFromFormat("d/m/Y H:i:s", $validade." 00:00:00");
			$dtThisValidadeTime = $dtThisValidade->getTimestamp();

			//this entry date timestamp
			$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
			$dtThisDateTime = $dtThisDate->getTimestamp();

			//process new dates
			if( $dtThisDateTime < $dtLastTime ){
				// $dataNew = $dataLast;
				// //update invoiceDate and period
				// $invoiceDate = date("Y-m-d");
				// $period = date("m");
				// //define start time
				// $movementStartTime = date("Y-m-d H:i:s");
				// $movementStartTime = str_replace (' ','T',$movementStartTime);
				
				//alert user that the date is before the last one
				$response["errors"] = true;
				$response["type"] = "FTGA024A";
				$response["data_superior"] = true;
				$response["dataUltima"] = $dataLast;
				$response["message"] = "Data superior à última nota.";
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			//process date origin
			if( $dtThisDateTime < $dtOriginDateTime ){
				//alert user that the date is before the last one
				$response["errors"] = true;
				$response["type"] = "FTGA024B";
				$response["data_superior2"] = true;
				$response["dataUltima"] = $dataOrigin;
				$response["message"] = "Data superior à última fatura.";
				// deleteRecord($idNota);
				die(json_encode($response));
			}

			if( $dtThisValidadeTime < $dtThisDateTime ){
				$validadeNew = $data;
			}
		}else{
			//this entry date timestamp
			$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
			$dtOriginDateTime = $dtOriginDate->getTimestamp();

			//this entry date timestamp
			$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
			$dtThisDateTime = $dtThisDate->getTimestamp();

			//process date origin
			if( $dtThisDateTime < $dtOriginDateTime ){
				//alert user that the date is before the last one
				$response["errors"] = true;
				$response["type"] = "FTGA024C";
				$response["data_superior2"] = true;
				$response["dataUltima"] = $dataOrigin;
				$response["message"] = "Data superior à última fatura.";
				// deleteRecord($idNota);
				die(json_encode($response));
			}
		}



		// DEFINE NEW NUMBER
		$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_notas_credito WHERE ID_Serie=".intval($serie).";";
		$maxID = getMaxNumberDocument($queryStmt);
		$initNumber = getInitNumber("NumeroInicial_NC","faturacao_series", "WHERE ID_Serie=?", $serie);
		if($nextID < $initNumber && $maxID < 1){
			$query = "UPDATE faturacao_notas_credito SET Numero = ".$initNumber.", ID_Serie=?, Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Pago' WHERE ID_NotaCredito = ?";
		}else{
			$query = "UPDATE faturacao_notas_credito SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_notas_credito WHERE ID_Serie=?) AS SubNumeroMax) + 1), Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Pago' WHERE ID_NotaCredito = ?";
		}
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dssdsd", $serie, $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idNota);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA025";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}

		// UPDATE REMAIN FIELDS
		$query = "UPDATE faturacao_notas_credito SET InvoiceStatusDate=?, SourceID=?, Hash=?, HashControl=?, Hash_Print=?, Period=?, InvoiceDate=?, MovementEndTime=?, MovementStartTime=?, SystemEntryDate=? WHERE ID_NotaCredito = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sssdssssssd", $invoiceStatusDate, $sourceID, $hash, $hashControl, $hashPrint, $period, $invoiceDate, $movementEndTime, $movementStartTime, $systemEntryDateUpdate, $idNota );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA025";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		// UPDATE REMAIN FIELDS LINES
		$query = "UPDATE faturacao_notas_credito_linhas SET TaxPointDate=? WHERE ID_NotaCredito = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sd", $invoiceDate, $idNota );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA026A";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026B";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}

		//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
		$query = "SELECT TotalLiquidadoDocumento, TotalLiquidado, GrossTotal, TotalPagar, Estado, TotalExtra, TotalExtraLiquidado, (TotalExtra - TotalExtraLiquidado) FROM ".$tableName." WHERE ".$fieldIdName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $docOrigem);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA026C";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($totalLiqDocOrig, $totalLiqOrig, $GrossTotalOrig, $totalPagarOrig, $estadoOrigemLast, $extraOri, $extraLiqOri, $extraPorPagarOri );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026D";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		//last check on estado
		if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
		{
			$response["errors"] = true;
			$response["type"] = "var";
			$response["line"] = "FTGA026E";
			// deleteRecord($idNota);
			die(json_encode($response));
		}else{
			$totalMaxPagavel = ($GrossTotalOrig - $totalLiqDocOrig) + $extraPorPagarOri;
			$totalMaxPagavel = round($totalMaxPagavel,$numDecimais);
			$totalPagar = round($totalPagar,$numDecimais);
			$precision = $totalMaxPagavel - $totalPagar;
			if($precision < 0){
				$response["errors"] = true;
				$response["type"] = "var";
				$response["pagavel"] = true;
				$response["totalPagar"] = $totalPagar;
				$response["totalMaxPagavel"] = $totalMaxPagavel;
				$response["precision"] = $precision;
				$response["line"] = "FTGA026EA";
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			###---- UPDATE DOC ORIGEM ----###
			
			if($extraPorPagarOri > 0){
				$extraPorPagarOri = round($extraPorPagarOri,$numDecimais);

				$totChecker = floatval($totalPagar) - floatval($extraPorPagarOri);
				$totChecker = round($totChecker,3);

				//check payment vals
				// if($totalPagar > $extraPorPagarOri){
				// 	$response["errors"] = true;
				// 	$response["type"] = "var";
				// 	$response["pagavel"] = true;
				// 	$response["totalPagar"] = $totalPagar;
				// 	$response["extraPorPagarOri"] = $extraPorPagarOri;
				// 	$response["line"] = "FTGA026EB";
				// 	// deleteRecord($idNota);
				// 	die(json_encode($response));
				// }
				if($totChecker > 0.01){
					$response["errors"] = true;
					$response["type"] = "var";
					$response["pagavel"] = true;
					$response["totalPagar"] = $totalPagar;
					$response["extraPorPagarOri"] = $extraPorPagarOri;
					$response["line"] = "FTGA026EB";
					// deleteRecord($idNota);
					die(json_encode($response));
				}

				//update
				$query = "UPDATE ".$tableName." SET TotalExtraLiquidado=(? + TotalExtraLiquidado) WHERE ".$fieldIdName."=?";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("sd", $totalPagar, $docOrigem);
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "query";
						$response["line"] = "FTGA026F";
						$response["message"] = $stmt -> error;
						// deleteRecord($idNota);
						die(json_encode($response));
					}
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA026G";
					$response["message"] = $sqli_connection -> error;
					// deleteRecord($idNota);
					die(json_encode($response));
				}
			}else{
				$totalLiqDocOrigNovo = $totalLiqDocOrig + $totalPagar;
				$totalLiqOrigNovo = $totalLiqOrig + $totalPagar;

				$totChecker = floatval($totalLiqOrigNovo) - floatval($totalPagarOrig);
				$totChecker = round($totChecker,3);

				// var_dump(floatval($totalLiqOrigNovo), floatval($totalPagarOrig), $totChecker );
				$estadoNovo = 'Aberto';
				// if( $totalLiqOrigNovo > $totalPagarOrig ){
				// 	$response["errors"] = true;
				// 	$response["type"] = "FTGA026EB";
				// 	$response["message"] = "Valor inserido superior ao valor pagável!";
				// 	// deleteRecord($idNota);
				// 	die(json_encode($response));
				// }else if($totalLiqOrigNovo == $totalPagarOrig){
				// 	$estadoNovo = 'Pago';
				// }
				if( $totChecker > 0.01 ){
					$response["errors"] = true;
					$response["type"] = "FTGA026EBA";
					$response["message"] = "Valor inserido superior ao valor pagável!";
					// deleteRecord($idNota);
					die(json_encode($response));
				}else if($totChecker >= 0 && $totChecker <= 0.01){
					$estadoNovo = 'Pago';
				}

				$query = "UPDATE ".$tableName." SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("sssd", $totalLiqDocOrigNovo, $totalLiqOrigNovo, $estadoNovo, $docOrigem);
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "query";
						$response["line"] = "FTGA026F";
						$response["message"] = $stmt -> error;
						// deleteRecord($idNota);
						die(json_encode($response));
					}
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA026G";
					$response["message"] = $sqli_connection -> error;
					// deleteRecord($idNota);
					die(json_encode($response));
				}
			}
		}
		//--------------------------------------------------------------------
		
		//UPDATE STOCKS
		$stockUpdateResult = increaseArticlesStock($idNota, 'faturacao_notas_credito', 'ID_NotaCredito');
		if($stockUpdateResult != true){
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA027";
			$response["message"] = 'Falha ao atualizar stocks.';
			die(json_encode($response));
		}

		//------------------------------------------------------------------------
		//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
		//------------------------------------------------------------------------
		$query = "SELECT PlanoContas, PlanoContasBanco,
					(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_credito.ID_Serie) AS Serie,
					Numero , CustomerID, 
					(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_notas_credito.ID_Cliente) AS Cliente,
					GrossTotal, NetTotal, TaxPayable,
				(SELECT CONCAT('FA ',(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',faturacao_faturas.Numero) FROM faturacao_faturas WHERE faturacao_faturas.ID_Fatura = faturacao_notas_credito.ID_Documento_Origem) AS DocumentoOrigem
				FROM faturacao_notas_credito WHERE ID_NotaCredito=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idNota);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA028";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($planoCliente, $planoBanco, $serie, $numeroDoc, $numCliente, $nomeCliente, $totalPVP, $totalUnit, $totalTVA, $RefDocOrigem );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA029";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		//PROCESS MOVEMENT FOR DOCUMENT
		$texto = 'Note de Crédit - '.$serie.'/'.$numeroDoc.' - '.$RefDocOrigem.' - '.$numCliente.' - '.$nomeCliente;
		/*if($planoCliente > 0){
			$tipoMovimento = 'C';
			insertMovimentoContabilistico($planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento);
		}*/

		//LINES -- ARTICLES
		$query = "SELECT PlanoContas, ProductCode, TotalLinha, TotalLinhaSIVA, (TotalLinha - TotalLinhaSIVA), ID_Imposto FROM faturacao_notas_credito_linhas WHERE ID_NotaCredito=? ORDER BY ID_Linha";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idNota);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA030";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($planoArtigo, $codigoArtigo,$totalPVP_Artigo, $totalUnit_Artigo, $totalTVA_Artigo, $id_imposto_artigo );
			while ($stmt -> fetch()) {
				//PROCESS MOVEMENT ARTICLE
				if($planoArtigo > 0){
					$textoArtigo = $texto.' - Article - '.$codigoArtigo;
					// $tipoMovimentoArtigo = 'D';
					$tipoMovimentoArtigo = 1;
					$dataArtigos[] = array('plano'=>$planoArtigo, 'texto'=>$textoArtigo, 'totalPVP'=>$totalPVP_Artigo, 'totalUnit'=>$totalUnit_Artigo, 'totalTVA'=>$totalTVA_Artigo, 'tipo'=>$tipoMovimentoArtigo, 'id_imposto_artigo'=>$id_imposto_artigo);
				}
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA031";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		if(isset($dataArtigos)){
			foreach ($dataArtigos as $line) {
				$Edited_TotalPVP = round($line['totalUnit'],$numDecimais);
				if($Edited_TotalPVP > 0){
					insertMovimentoContabilisticoManual($line['plano'], $planoCliente, $line['texto'], $Edited_TotalPVP, 0, $Edited_TotalPVP, $line['tipo'], $data, 'A', $line['id_imposto_artigo'], 0);
				}
			}
		}

		//LINES -- TVA
		$query = "SELECT (SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_notas_credito_linhas.ID_Imposto), (SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_notas_credito_linhas.ID_Imposto) AS Imposto, 
					TaxPercentage, SUM(TotalLinha), SUM(TotalLinhaSIVA), ID_Imposto 
				FROM faturacao_notas_credito_linhas WHERE ID_NotaCredito=? GROUP BY ID_Imposto";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idNota);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA030";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
			$stmt -> bind_result($planoTVA, $nomeTVA, $percentagemTVA, $totalPVP_TVA, $totalUnit_TVA, $id_imposto_TVA );
			while ($stmt -> fetch()) {
				//PROCESS MOVEMENT ARTICLE
				if($planoTVA > 0){
					$totalTVA_TVA = $totalPVP_TVA - $totalUnit_TVA;
					$textoTVA = $texto.' - TVA - '.$nomeTVA.': '.$percentagemTVA.'%';
					// $tipoMovimentoTVA = 'D';
					$tipoMovimentoTVA = 1;
					$dataTVA[] = array('plano'=>$planoTVA, 'texto'=>$textoTVA, 'totalPVP'=>$totalPVP_TVA, 'totalUnit'=>$totalUnit_TVA, 'totalTVA'=>$totalTVA_TVA, 'tipo'=>$tipoMovimentoTVA, 'id_imposto_TVA'=>$id_imposto_TVA);
				}
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA031";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			die(json_encode($response));
		}
		if(isset($dataTVA)){
			foreach ($dataTVA as $line) {
				insertMovimentoContabilisticoManual($line['plano'], $planoCliente, $line['texto'], $line['totalTVA'], 0, $line['totalTVA'], $line['tipo'], $data, 'A', $line['id_imposto_TVA'], 1);
			}
		}
		//------------------------------------------------------------------------
		//------------------------------------------------------------------------

		//log sistema - processo
		$descricao_log ="Création et finalisation du note de crédit (id: ".$idNota.")";
		insert_log(0,"Inserir",$descricao_log,$sqli_connection);
	}else{
		$response["nota"] = $idNota;

		//log sistema - processo
		$descricao_log ="Création du note de crédit (id: ".$idNota.")";
		insert_log(0,"Inserir",$descricao_log,$sqli_connection);
	}
	//------------------------------------------------------------------------

	//BLOCK CLIENT ----------------------------------------------------------
	$query = "UPDATE faturacao_clientes SET Usado=1 WHERE ID_Cliente=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $cliente);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA027";
			$response["message"] = $stmt -> error;
			// deleteRecord($idNota);
			// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $sqli_connection -> error;
		// deleteRecord($idNota);
		// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//BLOCK BANK ----------------------------------------------------------
	$query = "UPDATE faturacao_bancos SET Usado=1 WHERE ID_Banco=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $bancoFinalID);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA029";
			$response["message"] = $stmt -> error;
			// deleteRecord($idNota);
			// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $sqli_connection -> error;
		// deleteRecord($idNota);
		// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//INSERT NEW MOTIVE IF NOT INSERTED YET ----------------------------------
	$query = "SELECT COUNT(*) FROM faturacao_motivos_notas WHERE Descricao LIKE '%".$motivo."%'";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA031";
				$response["message"] = $stmt -> error;
				// deleteRecord($idNota);
				// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
				die(json_encode($response));
			}
			$stmt -> bind_result( $counterMotives );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA032";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idNota);
			// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
			die(json_encode($response));
		}
		if( $counterMotives < 1 ){
			$query = "INSERT INTO faturacao_motivos_notas (Descricao) VALUES (?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("s", $motivo );
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA033";
					$response["message"] = $stmt -> error;
					// deleteRecord($idNota);
					// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA034";
				$response["message"] = $sqli_connection -> error;
				// deleteRecord($idNota);
				// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);
				die(json_encode($response));
			}
		}
	//------------------------------------------------------------------------

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}


//response
$response["errors"] = false;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_notas_credito WHERE ID_NotaCredito=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_notas_credito_linhas WHERE ID_NotaCredito=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}

//Recalculate Totals for origin Document
function recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName){
	global $sqli_connection;
	$totalLiqGeralNew = 0;
	$totalLiqDocNew = 0;
	//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
	$query = "SELECT TotalPagar, GrossTotal, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($totalPagarOrigem, $totalGrossOrigem, $estadoOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//last check on estado
	if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "REM007";
		die(json_encode($response));
	}else{
		//GET NC TOTALS -----------------------------
		$query = "SELECT SUM(GrossTotal) FROM faturacao_notas_credito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($sumGrossNC );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009A";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//GET RECEIPTS LINES TOTALS -----------------
		$query = "SELECT SUM(faturacao_recibos_linhas.CreditAmount), SUM(faturacao_recibos_linhas.valorIVA) 
			FROM faturacao_recibos_linhas, faturacao_recibos 
			WHERE faturacao_recibos.ID_Recibo = faturacao_recibos_linhas.ID_Recibo AND ID_Documento=? AND TipoDocumento=? AND faturacao_recibos.Estado IN ('Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($linesCreditSUM, $linesIvaSUM );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//GET RECEIPTS TOTALS -----------------
		$query = "SELECT SUM(GrossTotal), SUM(ValorRetencao) 
			FROM faturacao_recibos 
			WHERE ID_DocumentoMain=? AND Tipo_DocumentoMain=? AND faturacao_recibos.Estado IN ('Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($recTotalSUM, $recRetencaoSUM );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009C";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//totals
		$totalLiqDocNew = $sumGrossNC + ($linesCreditSUM + $linesIvaSUM); //document total payed
		$totalLiqGeralNew = $recTotalSUM + $recRetencaoSUM; //general total payed

		//round numbers
		$totalLiqDocNew = round($totalLiqDocNew,$numDecimais);
		$totalLiqGeralNew = round($totalLiqGeralNew,$numDecimais);

		if($totalLiqDocNew > $totalGrossOrigem){
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010A";
			$response["message"] = "Valores Inválidos";
			die(json_encode($response));
		}

		$estadoNovo = 'Aberto';
		if( $totalLiqGeralNew < $totalPagarOrigem){
			$estadoNovo = 'Aberto';
		}elseif( $totalLiqGeralNew = $totalPagarOrigem){
			$estadoNovo = 'Pago';
		}else{
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010B";
			$response["message"] = "Valores Inválidos";
			die(json_encode($response));
		}

		$query = "UPDATE ".$tableName." SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sssd", $totalLiqDocNew, $totalLiqGeralNew, $estadoNovo, $docOrigem);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM011";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM012";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}
	//--------------------------------------------------------------------
}
?>