<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$linhaspagamento = $_POST['linhaspagamento'];

// "id_documento" : idDoc,
// "data" : dataLinha,
// "texto" : textoLinha,
// "valor_pagar" : valorLinha,

// var_dump($linhaspagamento);
// die();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( empty($linhaspagamento) ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//process lines
	foreach ($linhaspagamento as $key => $linha) {
		//VERIFICA NULOS --------------------------------------------------------
		if($linha['id_documento'] == '' || $linha['data'] == '' || $linha['valor_pagar'] == ''){
			$response["errors"] = true;
			$response["type"] = "var";
			$response["line"] = "FATS000A";
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//-----------------------------------------------------------------------

		//CHECK IF CLOSED MONTH -------------------------------------------------
		$dateCheckPost = isset($linha['data']) && $linha['data'] != '' ? $linha['data'] : date("d/m/Y");
		$dateCheckAux = explode("/", $dateCheckPost);
		$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
		if($isClosedMonth){
			$response["errors"] = true;
			$response["exists"] = true;
			$response["type"] = "FATS000x";
			$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
			die(json_encode($response));
		}
		//-----------------------------------------------------------------------
		
		//VERIFICA SE PODE SER ALTERADO -----------------------------------------
		$EstadoCompra=null;
		$numeroCompra=0;
		$TotalLiquidadoCompra=0;
		$TotalCreditadoCompra=0;
		$GrossTotalCompra=0;
		$ID_BancoCompra=0;
		$MetodoPagamentoCompra=0;
		$porPagar=0;

		$query = "SELECT Estado, Numero, TotalLiquidado, TotalCreditado, GrossTotal, ID_Banco, MetodoPagamento, (GrossTotal - TotalLiquidado) FROM faturacao_compras WHERE ID_Compra=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $linha['id_documento']);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS001";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> bind_result($EstadoCompra, $numeroCompra, $TotalLiquidadoCompra, $TotalCreditadoCompra, $GrossTotalCompra, $ID_BancoCompra, $MetodoPagamentoCompra, $porPagar);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS002";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		// $porPagar = $GrossTotalCompra - $TotalLiquidadoCompra;
		if($EstadoCompra != 'Aberto' || $porPagar < $linha['valor_pagar'] ) {
			$response["errors"] = true;
			$response["Compra"] = $numeroCompra;
			$response["EstadoCompra"] = $EstadoCompra;
			$response["porPagar"] = $porPagar;
			$response["type"] = "var";
			$response["line"] = "FATS00301";
			$response["message"] = "Achat invalid!";
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//-----------------------------------------------------------------------
		// var_dump($linha['id_documento'], $linha['data'], $linha['valor_pagar'], $ID_BancoCompra, $MetodoPagamentoCompra, $linha['texto']);
		// echo '<br>';
		
		//INSERT PAYMENT --------------------------------------------------------
		$query = "INSERT INTO faturacao_compras_pagamentos (ID_Compra, Data, TotalPago, Banco, Metodo, Observacoes) 
			VALUES (?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dsssss", $linha['id_documento'], $linha['data'], $linha['valor_pagar'], $ID_BancoCompra, $MetodoPagamentoCompra, $linha['texto'] );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS003B";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS003C";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//-----------------------------------------------------------------------

		//CLOSE THE DOCUMENT -----------------------------------------------------
		$dataAtualizacao = date("d/m/Y H:i:s");

		$estadoNew = 'Aberto';
		$totalLiquidadoNew = 0;
		$totalLiquidadoNew = $linha['valor_pagar'] + $TotalLiquidadoCompra;

		if($totalLiquidadoNew > $GrossTotalCompra) {
			$response["errors"] = true;
			$response["Compra"] = $numeroCompra;
			$response["EstadoCompra"] = $EstadoCompra;
			$response["porPagar"] = $porPagar;
			$response["type"] = "var";
			$response["line"] = "FATS00302";
			$response["message"] = "Achat invalid!";
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		elseif($totalLiquidadoNew == $GrossTotalCompra){
			$estadoNew = 'Pago';
			// $totalLiquidadoNew = $GrossTotalCompra;
		}
		// echo '<br>';
		// var_dump($porPagar, $linha['valor_pagar'],$totalLiquidadoNew, $estadoNew);
		// echo '<br>';

		// DEFINE NEW NUMBER
		$query = "UPDATE faturacao_compras SET ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado=?, DataPagamento=?, TotalLiquidado=? WHERE ID_Compra = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dssssd", $id_utilizador, $dataAtualizacao, $estadoNew, $linha['data'], $totalLiquidadoNew, $linha['id_documento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS004";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS005";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}

		//generate movements
		insercaoMovimento($sqli_connection, $linha['id_documento'], $linha['data'], $linha['texto'], $linha['valor_pagar'], 0, 0);
	}
	//--------------------------------------------------------------------
	
	// Save all querys on DB
	// $sqli_connection->rollback();
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}
//------------------------------------------------------------------------


//log sistema - processo
$descricao_log ="Achat - Marquer comme payé (numéro: ".$numeroCompra.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));


// ==================================
// Anulação de movimentos anteriores
// ==================================
function insercaoMovimento($sqli_connection, $idCompra, $dataNew, $descricaoPagamento, $valorPagamento, $valorTVA, $valorUnit){
	//------------------------------------------------------------------------
	//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
	//------------------------------------------------------------------------
	$query = "SELECT PlanoContas, PlanoContasBanco, Numero , 
			(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Codigo, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Fornecedor,
			GrossTotal,	NetTotal, TaxPayable
			FROM faturacao_compras WHERE ID_Compra=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCompra);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoFornecedor, $planoBanco, $numeroDoc, $numFornecedor, $nomeFornecedor, $totalPVP, $totalUnit, $totalTVA );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//PROCESS MOVEMENT FOR DOCUMENT
	$texto = 'Paiement (Achat) - '.$numeroDoc.' - '.$numFornecedor.' - '.$nomeFornecedor.' - '.$descricaoPagamento;

	//calculate values
	// $totalPVP = $totalPVP - $totalPVP_NC;
	// $totalUnit = $totalUnit - $totalUnit_NC;
	// $totalTVA = $totalTVA - $totalTVA_NC;
	
	$totalPVP = $valorPagamento;
	$totalUnit = $valorTVA;
	$totalTVA = $valorUnit;

	/*if($planoFornecedor > 0){
		$tipoMovimento = 'D';
		// insertMovimentoContabilistico($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento);
		insertMovimentoContabilistico($planoFornecedor, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento);
	}*/

	//PROCESS MOVEMENT FOR DOCUMENT
	if($planoBanco > 0){
		$query = "SELECT 
				(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_compras.ID_Banco) AS Banco
			FROM faturacao_compras WHERE ID_Compra=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idCompra);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "HELP003";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($nomeBanco);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP004";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//MOVEMENT
		$textoBanco = $texto.' - Banque: '.$nomeBanco;
		// $tipoMovimentoBanco = 'C';
		// insertMovimentoContabilistico($planoBanco, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
		$tipoMovimentoBanco = 'D';
		// insertMovimentoContabilistico($planoFornecedor, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimentoBanco);
		insertMovimentoContabilisticoManual($planoFornecedor, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimentoBanco, $dataNew, 'A');
	} else {
		$tipoMovimentoBanco = 'D';
		// insertMovimentoContabilistico($planoFornecedor, '', $texto, $totalPVP, 0, 0, $tipoMovimentoBanco);
		insertMovimentoContabilisticoManual($planoFornecedor, '', $texto, $totalPVP, 0, 0, $tipoMovimentoBanco, $dataNew, 'A');
	}

	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
}
?>