<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/Bvr.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idFatura = $_POST['idFatura'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idFatura == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//VERIFICA SE PODE SER ALTERADO -----------------------------------------
	$query = "SELECT Estado, Data, Validade, ID_Serie, TotaRetencao, ID_Banco, CustomerID, Referencia  FROM faturacao_faturas WHERE ID_Fatura=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($Estado, $data, $validade, $serie, $retencaoTotal, $bancoFinalID, $CodigoCliente,$referencia );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($Estado != 'Rascunho') {
		$response["errors"] = true;
		$response["type"] = "usado";
		$response["line"] = "FATS003";
		$response["message"] = "Fatura já finalizada!";
		$response["estado"] = $Estado;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//CHECK IF CLOSED MONTH -------------------------------------------------
	$dateCheckPost = isset($data) && $data != '' ? $data : date("d/m/Y");
	$dateCheckAux = explode("/", $dateCheckPost);
	$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
	if($isClosedMonth){
		$response["errors"] = true;
		$response["exists"] = true;
		$response["type"] = "FATS000x";
		$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//VALIDAR REFERENCIA -----------------------------------------------------
	// if( $referencia  != ''){
	// 	$query = "SELECT COUNT(*) FROM faturacao_faturas WHERE Referencia = ? AND ID_Fatura <> ?";
	// 	if ($stmt = $sqli_connection -> prepare($query)) {
	// 		$stmt -> bind_param("sd", $referencia, $idFatura);
	// 		$result = $stmt -> execute();
	// 		if (false === $result) {
	// 			$response["errors"] = true;
	// 			$response["type"] = "FTGA001A";
	// 			$response["message"] = $stmt -> error;
	// 			die(json_encode($response));
	// 		}
	// 		$stmt -> bind_result($counterRef );
	// 		$stmt -> fetch();
	// 		$stmt -> close();
	// 	} else {
	// 		$response["errors"] = true;
	// 		$response["type"] = "FTGA001B";
	// 		$response["message"] = $sqli_connection -> error;
	// 		die(json_encode($response));
	// 	}
	// }
	// if($counterRef > 0){
	// 	$response["errors"] = true;
	// 	$response["type"] = "FTGA001C";
	// 	$response["referencia"] = true;
	// 	$response["message"] = "Referencia já existente.";
	// 	die(json_encode($response));
	// }
	//------------------------------------------------------------------------
	//
	//CLOSE THE DOCUMENT -----------------------------------------------------
	$dataNew = $data;
	$validadeNew = $validade;
	$dataAtualizacao = date("d/m/Y H:i:s");

	$systemEntryDateUpdate = date("Y-m-d H:i:s");
	$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
	$invoiceStatusDate = date("Y-m-d H:i:s");
	$invoiceStatusDate = str_replace (' ','T',$invoiceStatusDate);
	$sourceID = $_SESSION['username'];
	$hash = 'TESTE';
	$hashControl = 1;
	$hashPrint = 'ABCD';
	$movementEndTime = '';
	// $retencaoCalc = round($retencaoTotal,2);
	$retencaoCalc = $retencaoTotal;
	$totalLiquidado = 0;

	//process InvoiceDate and period to the choosen one
	$tempDate = DateTime::createFromFormat('d/m/Y', $data);
	$invoiceDate = $tempDate->format('Y-m-d');
	$period = $tempDate->format('m');
	//define start time
	$movementStartTime = $tempDate->format("Y-m-d H:i:s");
	$movementStartTime = str_replace (' ','T',$movementStartTime);


	//GET LAST DATE
	$query = "SELECT Numero, Data FROM faturacao_faturas WHERE ID_Serie = ? AND Numero > 0 ORDER BY STR_TO_DATE( Data,  '%d/%m/%Y' ) DESC LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $serie);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($numMax, $dataLast);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA024";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $numMax > 0){
		//last date timestamp
		$dtLast = DateTime::createFromFormat("d/m/Y H:i:s", $dataLast." 00:00:00");
		$dtLastTime = $dtLast->getTimestamp();

		//this entry validade timestamp
		$dtThisValidade = DateTime::createFromFormat("d/m/Y H:i:s", $validade." 00:00:00");
		$dtThisValidadeTime = $dtThisValidade->getTimestamp();

		//this entry date timestamp
		$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
		$dtThisDateTime = $dtThisDate->getTimestamp();

		//process new dates
		// if( $dtThisDateTime < $dtLastTime ){
		// 		// $dataNew = $dataLast;
		// 		// //update invoiceDate and period
		// 		// $invoiceDate = date("Y-m-d");
		// 		// $period = date("m");
		// 		// //define start time
		// 		// $movementStartTime = date("Y-m-d H:i:s");
		// 		// $movementStartTime = str_replace (' ','T',$movementStartTime);
				
		// 		//alert user that the date is before the last one
		// 		$response["errors"] = true;
		// 		$response["type"] = "FTGA024A";
		// 		$response["data_superior"] = true;
		// 		$response["dataUltima"] = $dataLast;
		// 		$response["message"] = "Data superior à última fatura.";
		// 		die(json_encode($response));
		// }

		if( $dtThisValidadeTime < $dtThisDateTime ){
			$validadeNew = $data;
		}
	}

	// DEFINE NEW NUMBER
	$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_faturas WHERE ID_Serie=".intval($serie).";";
	$maxID = getMaxNumberDocument($queryStmt);
	$initNumber = getInitNumber("NumeroInicial_FT","faturacao_series", "WHERE ID_Serie=?", $serie);
	if($nextID < $initNumber && $maxID < 1){
		$query = "UPDATE faturacao_faturas SET Numero = ".$initNumber.", ID_Serie=?, Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_Fatura = ?";
	}else{
		$query = "UPDATE faturacao_faturas SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_faturas WHERE ID_Serie=?) AS SubNumeroMax) + 1), Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_Fatura = ?";
	}
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssdsd", $serie, $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idFatura);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//------------------------------------------------------------------------
	// UPDATE REMAIN FIELDS
	$query = "UPDATE faturacao_faturas SET InvoiceStatusDate=?, SourceID=?, Hash=?, HashControl=?, Hash_Print=?, Period=?, InvoiceDate=?, MovementEndTime=?, MovementStartTime=?, TotalLiquidado=?, SystemEntryDate=? WHERE ID_Fatura = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssdsssssssd", $invoiceStatusDate, $sourceID, $hash, $hashControl, $hashPrint, $period, $invoiceDate, $movementEndTime, $movementStartTime, $totalLiquidado, $systemEntryDateUpdate, $idFatura );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA009";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA010";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	// UPDATE REMAIN FIELDS LINES
	$query = "UPDATE faturacao_faturas_linhas SET TaxPointDate=? WHERE ID_Fatura = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sd", $invoiceDate, $idFatura );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA011";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA012";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//UPDATE STOCKS
	$stockUpdateResult = decreaseArticlesStock($idFatura, 'faturacao_faturas', 'ID_Fatura');
	if($stockUpdateResult != true){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = 'Falha ao atualizar stocks.';
		die(json_encode($response));
	}

	//PROCESS BVR IF BANK SELECTED
	if($bancoFinalID > 0){
		$query = "SELECT  CodigoBVR FROM faturacao_bancos WHERE ID_Banco = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $bancoFinalID);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA027A";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($codigoBVR_banco);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA027B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		if( $codigoBVR_banco < 0){
			$response["errors"] = true;
			$response["type"] = "FTGA027C";
			$response["message"] = "Banco";
			die(json_encode($response));
		}
		//-------------------------------------------------
		
		$n_ZerosLeft = 11 - strlen($codigoBVR_banco);
		$zerosGenerated = str_pad('',  $n_ZerosLeft, "0");
		$typeDoc = '0';
		$docNumberFormated = str_pad($idFatura, 7, "0", STR_PAD_LEFT);
		$clientNumberFormated = str_pad($CodigoCliente, 7, "0", STR_PAD_LEFT);

		$new_code_bvr = $codigoBVR_banco.$docNumberFormated.$zerosGenerated.$clientNumberFormated.$typeDoc;

		//CALCULATE BVR
		$new_control_bvr_digit = Bvr::calculate($new_code_bvr);
		$new_code_bvr = $new_code_bvr.$new_control_bvr_digit;

		// UPDATE REMAIN FIELDS
		$query = "UPDATE faturacao_faturas SET BVR=? WHERE ID_Fatura = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sd", $new_code_bvr, $idFatura );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA027D";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA027E";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}

	//------------------------------------------------------------------------
	//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
	//------------------------------------------------------------------------
	$query = "SELECT PlanoContas, PlanoContasBanco,
				(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) AS Serie,
				Numero , CustomerID, 
				(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS Cliente,
				GrossTotal, NetTotal, TaxPayable
			FROM faturacao_faturas WHERE ID_Fatura=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA028";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoCliente, $planoBanco, $serie, $numeroDoc, $numCliente, $nomeCliente, $totalPVP, $totalUnit, $totalTVA );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA029";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//PROCESS MOVEMENT FOR DOCUMENT
	$texto = 'Facture - '.$serie.'/'.$numeroDoc.' - '.$numCliente.' - '.$nomeCliente;
	/*if($planoCliente > 0){
		$tipoMovimento = 'D';
		insertMovimentoContabilistico($planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento);
	}*/

	//LINES -- ARTICLES
	$query = "SELECT PlanoContas, ProductCode, TotalLinha, TotalLinhaSIVA, (TotalLinha - TotalLinhaSIVA), ID_Imposto FROM faturacao_faturas_linhas WHERE ID_Fatura=? ORDER BY ID_Linha";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA030";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoArtigo, $codigoArtigo,$totalPVP_Artigo, $totalUnit_Artigo, $totalTVA_Artigo, $id_imposto_artigo );
		while ($stmt -> fetch()) {
			//PROCESS MOVEMENT ARTICLE
			if($planoArtigo > 0){
				$textoArtigo = $texto.' - Article - '.$codigoArtigo;
				// $tipoMovimentoArtigo = 'C';
				$tipoMovimentoArtigo = 0;
				$dataArtigos[] = array('plano'=>$planoArtigo, 'texto'=>$textoArtigo, 'totalPVP'=>$totalPVP_Artigo, 'totalUnit'=>$totalUnit_Artigo, 'totalTVA'=>$totalTVA_Artigo, 'tipo'=>$tipoMovimentoArtigo, 'id_imposto_artigo'=>$id_imposto_artigo);
			}
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA031";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if(isset($dataArtigos)){
		foreach ($dataArtigos as $line) {
				$Edited_TotalPVP = round($line['totalUnit'],$numDecimais);
				if($Edited_TotalPVP > 0){
					// insertMovimentoContabilistico($line['plano'], $line['texto'], $Edited_TotalPVP, 0, 0, $line['tipo']);
					insertMovimentoContabilisticoManual($planoCliente, $line['plano'], $line['texto'], $Edited_TotalPVP, 0, $Edited_TotalPVP, $line['tipo'], $data, 'A', $line['id_imposto_artigo'], 0);
				}
		}
	}

	//LINES -- TVA
	$query = "SELECT (SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_faturas_linhas.ID_Imposto), (SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_faturas_linhas.ID_Imposto) AS Imposto, 
				TaxPercentage, SUM(TotalLinha), SUM(TotalLinhaSIVA), ID_Imposto 
			FROM faturacao_faturas_linhas WHERE ID_Fatura=? GROUP BY ID_Imposto";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA030";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoTVA, $nomeTVA, $percentagemTVA, $totalPVP_TVA, $totalUnit_TVA, $id_imposto_TVA );
		while ($stmt -> fetch()) {
			//PROCESS MOVEMENT ARTICLE
			if($planoTVA > 0){
				$totalTVA_TVA = $totalPVP_TVA - $totalUnit_TVA;
				$textoTVA = $texto.' - TVA - '.$nomeTVA.': '.$percentagemTVA.'%';
				// $tipoMovimentoTVA = 'C';
				$tipoMovimentoTVA = 0;
				$dataTVA[] = array('plano'=>$planoTVA, 'texto'=>$textoTVA, 'totalPVP'=>$totalPVP_TVA, 'totalUnit'=>$totalUnit_TVA, 'totalTVA'=>$totalTVA_TVA, 'tipo'=>$tipoMovimentoTVA, 'id_imposto_TVA'=>$id_imposto_TVA);
			}
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA031";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if(isset($dataTVA)){
		foreach ($dataTVA as $line) {
			// insertMovimentoContabilistico($line['plano'], $line['texto'], $line['totalTVA'], 0, 0, $line['tipo']);
			insertMovimentoContabilisticoManual($planoCliente, $line['plano'], $line['texto'], $line['totalTVA'], 0, $line['totalTVA'], $line['tipo'], $data, 'A', $line['id_imposto_TVA'], 1);
		}
	}
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------

	//log sistema - processo
	$descricao_log ="Finalisation de facture (id: ".$idFatura.")";
	insert_log(0,"Editar",$descricao_log,$sqli_connection);
	//------------------------------------------------------------------------
	
	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}


//response
$response["errors"] = false;
die(json_encode($response));
?>