<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idFecho = $_POST['idFermeture'];
$mes_post = $_POST['mes_post'];
$ano_post = $_POST['ano_post'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idFecho == '' || $mes_post == '' || $ano_post == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}

//CHECK IF EXISTS -------------------------------------------------------------
$countExists = 0;
$query = "SELECT COUNT(*) FROM faturacao_fecho_mes WHERE Mes=? AND Ano=? AND ID_MesFecho!=?;";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	$stmt -> bind_param("ddd", $mes_post, $ano_post, $idFecho);
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS0001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($countExists);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS0002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($countExists > 0){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Cette fin de mois est déjà inscrite.';
	die(json_encode($response));
}
//------------------------------------------------------------------------

//INSERT NEW DOCUMENT ----------------------------------------------------
$query = "UPDATE faturacao_fecho_mes SET Ano=?, Mes=? WHERE ID_MesFecho = ?;";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param(
		"ddd", 
		$ano_post,
		$mes_post,
		$idFecho
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS0003B";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET INFO BD -------------------------------------------------------------
$estadoAtual=0; $anoBD=0; $mesBD=0; $mesStr = '';
$query = "SELECT Estado, Ano, Mes FROM faturacao_fecho_mes WHERE ID_MesFecho = ?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	$stmt -> bind_param("d", $idFecho);
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS0001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($estadoAtual, $anoBD, $mesBD);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS0002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
$mesStr = month_in_french($mesBD);
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Édition de fermeture du mois ( ".$mesStr." ".$anoBD." )";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));

?>