<?php 
$helpersFile = true;

//init common vars
$uniMedida = getValorPadrao('UnidadesMedida', 'faturacao_personalizar_documentos');
$numDecimaisPrice = getValorPadrao('NumCasasDecimais', 'faturacao_personalizar_documentos');
if(!$uniMedida) $uniMedida = 0;
if(!$numDecimaisPrice) $numDecimaisPrice = 2;
$numDecimais = 2;

/**
 * |-----------------------------------------------------------------------
 * |
 * |						Helper Functions
 * |
 * | Functions to be used anytime, anywhere. Just like a service provider.
 * |
 * |-----------------------------------------------------------------------
 */

//CHECK IF ADMIN FATURAÇÃO
function adminCheckerFat($userID){
	global $sqli_connection;
	//process
	$query = "SELECT AdministradorFaturacao FROM utilizador WHERE ID_Utilizador = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $userID);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($administrador);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//return next id
	return $administrador;
}

/**
 * Get the Next ID for table
 * @param  $fieldName
 * @param  $tableName
 * @return next id
 */
function getNextID($fieldName,$tableName){
	global $sqli_connection;

	$nextID = 0;

	//process
	$query = "SELECT MAX(CAST(".$fieldName." AS UNSIGNED)) FROM ".$tableName."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($nextID);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//return next id
	return $nextID+1;
}

/**
 * Get the Next ID for table
 * @param  $fieldName
 * @param  $tableName
 * @return next id
 */
function getNextID_Perm($fieldName,$tableName){
	global $sqli_connection;

	$nextID = 0;

	//process
	$query = "SELECT MAX(CAST(".$fieldName." AS UNSIGNED)) FROM ".$tableName."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($nextID);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//new id
	$newID = $nextID+1;
	$finalID = $newID;

	if($newID < 10) $finalID = '000'.$newID;
	elseif($newID < 100) $finalID = '00'.$newID;
	elseif($newID < 1000) $finalID = '0'.$newID;

	//return next id
	return $finalID;
}

/**
 * Get the Next ID for table
 * @param  $fieldName
 * @param  $tableName
 * @return next id
 */
function getUserFullName($userID){
	global $sqli_connection;
	//process
	$query = "SELECT Nome FROM utilizador WHERE ID_Utilizador = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $userID);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($nomeUtilizador);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//return next id
	return $nomeUtilizador;
}

/**
 * Get The base table
 * @return return base table string
 */
function getSncBaseTable(){
	global $sqli_connection;
	//GET SNC TABLE IN USE --------------------------------------------------
	$snc_table = '';

	//GET TYPE OF SNC (S OR M)
	$query = "SELECT NormaContabilistica FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
	    $result = $stmt -> execute();
	    if (false === $result) {}
	    $stmt -> bind_result($typeSNC);
	    $stmt -> fetch();
	    $stmt -> close();
	} else {
	    $response["errors"] = true;
		$response["type"] = "HELP003";
	    $response["message"] = $sqli_connection -> error;
	    die(json_encode($response));
	}
	if($typeSNC == 'S') $snc_table = 'faturacao_snc_base';
	else if($typeSNC == 'M') $snc_table = 'faturacao_snc_micro';
	else{
	    $response["errors"] = true;
		$response["type"] = "HELP004";
	    $response["message"] = 'SNC base não definido!';
	    die(json_encode($response));
	}
	//-----------------------------------------------------------------------
	
	return $snc_table;
}

/**
 * Get Valores Padrão
 * @return padrão
 */
function getValorPadrao($fieldName, $tableName){
	global $sqli_connection;
	$padrao = '';
	//process
	$query = "SELECT ".$fieldName." FROM ".$tableName." LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($padrao);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	return $padrao;
}

/**
 * Check if document can be edited
 * @param  $idObject
 * @param  $statusFieldName
 * @param  $statusString
 * @param  $tableName
 * @return bool
 */
function checkIfCanBeEdit($idObject, $idFieldName, $statusFieldName, $statusString, $tableName){
	global $sqli_connection;
	$canEdit = false;

	//process
	$query = "SELECT ".$statusFieldName." FROM ".$tableName." WHERE ".$idFieldName." = ".$idObject." LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($statusDB);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	if( $statusDB != $statusString ) $canEdit = false;
	else $canEdit = true;

	return $canEdit;
}

/**
 * Check if document can be edited
 * @param  $idObject
 * @param  $statusFieldName
 * @param  $statusString
 * @param  $tableName
 * @return bool
 */
function checkIfCanBeEditCompra($idObject){
	global $sqli_connection;
	$canEdit = false;

	$extraCondition = "(SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE faturacao_compras_notas_credito.ID_Documento_Origem = faturacao_compras.ID_Compra)";

	//process
	$query = "SELECT (SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE faturacao_compras_notas_credito.ID_Documento_Origem = faturacao_compras.ID_Compra) AS CountNotasCredito, (SELECT COUNT(*) FROM faturacao_compras_pagamentos WHERE faturacao_compras_pagamentos.ID_Compra = faturacao_compras.ID_Compra) AS CountPagamentos, Estado FROM faturacao_compras WHERE ID_Compra = ".$idObject." LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($countNC, $countPayments, $estadoAchat);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//process checker
	if($estado == 'Anulado' || $estado == 'Pago' ) $canEdit = false;
	else {
		if($countNC == 0 && $countPayments == 0) $canEdit = true;
		else $canEdit = false;
	}

	// if( $statusDB != $statusString ) $canEdit = false;
	// else $canEdit = true;

	return $canEdit;
}

/**
 * Check payment values
 * @param  $idObject
 * @param  $statusFieldName
 * @param  $statusString
 * @param  $tableName
 * @return bool
 */
function resetDocumentPaymentTotals($idDocument, $type){
	global $sqli_connection;
	$resultChecker = true;

	$totalPagoGeral = 0;
	$totalPagoDocument = 0;
	$fieldIdName = '';
	$tableName = '';

	//MAIN DOCUMENT TABLE NAME
	switch ($type) {
		case 'FT':
			$fieldIdName = 'ID_Fatura';
			$tableName = 'faturacao_faturas';
			break;
		case 'FS':
			$fieldIdName = 'ID_FaturaSimplificada';
			$tableName = 'faturacao_faturas_simplificadas';
			break;
		case 'FR':
			$fieldIdName = 'ID_FaturaRecibo';
			$tableName = 'faturacao_faturas_recibo';
			break;
		
		default:
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0001";
			$response["message"] = 'Tipo inválido!';
			die(json_encode($response));
			break;
	}

	//#GET ASSOCIATED DOCS (ND) --------------------------
	$query = "SELECT SUM(TotalLiquidado) FROM faturacao_notas_debito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ds", $idDocument, $type);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0002";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($sumTotalLiquidadoND );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0003";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//#---------------------------------------------------
	
	//#GET ASSOCIATED DOCS (NC) --------------------------	
	$query = "SELECT SUM(GrossTotal) FROM faturacao_notas_credito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ds", $idDocument, $type);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($sumTotalLiquidadoNC );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//#---------------------------------------------------

	//GET RECEIPT LINES FOR MAIN DOCUMENT ----------------
	$query = "SELECT CreditAmount, valorIVA FROM faturacao_recibos_linhas, faturacao_recibos 
	WHERE faturacao_recibos_linhas.TipoDocumento=? AND faturacao_recibos_linhas.ID_Documento=? AND faturacao_recibos_linhas.ID_Recibo=faturacao_recibos.ID_Recibo AND faturacao_recibos.Estado = 'Pago' ORDER BY ID_Linha";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("sd", $type, $idDocument);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($creditAmount, $valorIva );
		while ($stmt -> fetch()) {
			$totalCalc = $creditAmount + $valorIva;
			// $totalCalc = round($totalCalc,2);
			$totalPagoGeral += $totalCalc;
			$totalPagoDocument += $totalCalc;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//GET MAIN DOCUMENT TOTAL TO PAY
	$query = "SELECT TotalPagar, GrossTotal FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocument);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0008";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($totalPagarDocumento, $totalGrossDocumento);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0009";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//UPDATE MAIN DOCUMENT -----------------------------
	$totalPagarDocumento = round($totalPagarDocumento,2);
	$totalPagoGeral = $totalPagoGeral + $sumTotalLiquidadoND + $sumTotalLiquidadoNC;
	$totalPagoDocument = $totalPagoDocument + $sumTotalLiquidadoNC;
	$totalPagoGeral_tmp = round($totalPagoGeral,2);

	$totalPagoDocument_tmp = round($totalPagoDocument,2);
	
	if( $totalPagoDocument_tmp > $totalGrossDocumento){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0010A";
		$response["message"] = "Total Inválido!";
		die(json_encode($response));
	}
	
	//process estado
	$estadoProcessed = 'Aberto';
	if( $totalPagoGeral_tmp > $totalPagarDocumento){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0010B";
		$response["message"] = "Total Inválido!";
		die(json_encode($response));
	}else if($totalPagoGeral_tmp == $totalPagarDocumento){
		$estadoProcessed = 'Pago';
	}else{
		$estadoProcessed = 'Aberto';
	}

	$query = "UPDATE ".$tableName." SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssd", $totalPagoDocument, $totalPagoGeral, $estadoProcessed, $idDocument);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0011";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0012";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	return $resultChecker;
}

/**
 * Increase the stock levels for the articles present on the document
 * @param  $idDocument
 * @param  $tableName 
 * @param  $fieldName 
 * @return bool
 */
function increaseArticlesStock($idDocument, $tableName, $fieldName){
	global $sqli_connection;
	$result = true;

	//Get the arcticles and the stock value to update
	$query = "SELECT ID_Artigo, Quantidade FROM ".$tableName."_linhas WHERE ".$fieldName." =?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocument);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP013";
			$response["message"] = $stmt -> error;
			return $result = false;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($idArticle, $stockNovo);
		while ($stmt -> fetch()) {
			$articles[] = array(
		        	"idArticle" => $idArticle,
		        	"stockNovo" => $stockNovo,
		        );
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP014";
		$response["message"] = $sqli_connection -> error;
		return $result = false;
		die(json_encode($response));
	}

	//Process the articles and change stock
	foreach ($articles as $item) {
		$stockAtual = 0;
		$calculatedStock = 0;
		//Get current stock to be changed later
		$query = "SELECT Stock FROM faturacao_artigos WHERE ID_Artigo=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $item['idArticle']);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP015";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($stockAtual);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP016";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}

		//clean vars for calculation
		$stockAtual = round($stockAtual, 3);
		$stockNovoClean = round($item['stockNovo'], 3);
		//new stock level
		$calculatedStock = $stockAtual + $stockNovoClean;

		//Update stock levels
		$query = "UPDATE faturacao_artigos SET Stock=? WHERE ID_Artigo = ?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("sd", $calculatedStock, $item['idArticle']);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP017";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP018";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}
	}

	return $result;
}

/**
 * Decrease the stock levels for the articles present on the document
 * @param  $idDocument
 * @param  $tableName 
 * @param  $fieldName 
 * @return bool
 */
function decreaseArticlesStock($idDocument, $tableName, $fieldName){
	global $sqli_connection;
	$result = true;

	//get init vars
	$stockminimo = getValorPadrao('StockMinimo', 'faturacao_personalizar_documentos');
	$emailrececaostock = getValorPadrao('EmailRececaoStock', 'faturacao_personalizar_documentos');

	//Get the arcticles and the stock value to update
	$query = "SELECT ID_Artigo, Quantidade FROM ".$tableName."_linhas WHERE ".$fieldName." =?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocument);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP013";
			$response["message"] = $stmt -> error;
			return $result = false;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($idArticle, $stockNovo);
		while ($stmt -> fetch()) {
			$articles[] = array(
		        	"idArticle" => $idArticle,
		        	"stockNovo" => $stockNovo,
		        );
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP014";
		$response["message"] = $sqli_connection -> error;
		return $result = false;
		die(json_encode($response));
	}

	//Process the articles and change stock
	foreach ($articles as $item) {
		$stockAtual = 0;
		$calculatedStock = 0;
		//Get current stock to be changed later
		$query = "SELECT Stock, Codigo, Nome, Tipo FROM faturacao_artigos WHERE ID_Artigo=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $item['idArticle']);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP015";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($stockAtual, $articleCode, $articleDescprition, $articleType);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP016";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}

		//clean vars for calculation
		$stockAtual = round($stockAtual, 3);
		$stockNovoClean = round($item['stockNovo'], 3);
		//new stock level
		$calculatedStock = $stockAtual - $stockNovoClean;

		//Update stock levels
		$query = "UPDATE faturacao_artigos SET Stock=? WHERE ID_Artigo = ?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("sd", $calculatedStock, $item['idArticle']);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP017";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP018";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}

		//check if stock is lower
		if($calculatedStock < $stockminimo){
			if($emailrececaostock && $articleType == 'P'){
				$subject = 'Frifacturation: Niveau de stock bas';

				$htmlContent = '<p>Cher administrateur,</p>';
				$htmlContent .= '<p>L\'article "'.$articleDescprition.'" a un niveau de stock inférieur à votre limite de stock minimum.</p>';
				$htmlContent .= '<p><br></p>';
				$htmlContent .= '<p><b>Référence:</b> '.$articleCode.'</p>';
				$htmlContent .= '<p><b>Article:</b> '.$articleDescprition.'</p>';
				$htmlContent .= '<p><b>Quantité actuelle:</b> '.$calculatedStock.'</p>';
				$htmlContent .= '<p><br></p><p>Cordialement,</p><p>Frifacturation.</p>';

				sendEmailPHPMailer($htmlContent, $subject, $emailrececaostock);
			}
		}
	}

	return $result;
}

/**
 * Check the usage of specific plan comptable
 * @param  $idPlano
 * @return bool
 */
function checkPlanoContasUsage($codePlano){
	global $sqli_connection;

	//returner flag
	$checker = false;

	//PROCESS TAXES TABLE ---------------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_impostos WHERE PlanoContas = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP019";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP020";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS BANQUE TABLE --------------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_bancos WHERE PlanoContas = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP021";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP022";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS ARTICLE TABLE -------------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_artigos WHERE PlanoContas = ? OR PlanoContasCompras=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP023";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP024";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS CLIENT TABLE --------------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_clientes WHERE PlanoContas = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP025";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP026";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS FOURNISSEUR TABLE ---------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_fornecedores WHERE PlanoContas = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP027";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP028";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS FACTURES TABLE ------------------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_faturas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_faturas WHERE PlanoContasBanco = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP029";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP030";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS FACTURES LINES TABLE ------------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_faturas_linhas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_faturas_linhas WHERE PlanoContasTVA = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP031";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP032";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS NOTES CREDIT FACTURES TABLE -----------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_notas_credito WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_notas_credito WHERE PlanoContasBanco = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP033";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP034";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS NOTES CREDIT LINES FACTURES TABLE -----
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_notas_credito_linhas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_notas_credito_linhas WHERE PlanoContasTVA = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP035";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP036";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS ACHATS TABLE --------------------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_compras WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_compras WHERE PlanoContasBanco = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP037";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP038";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS ACHATS LINES TABLE --------------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_compras_linhas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_compras_linhas WHERE PlanoContasTVA = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP039";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP040";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS NOTES CREDIT ACHATS TABLE -------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE PlanoContasBanco = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP041";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP042";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS NOTES CREDIT LINES ACHATS TABLE -------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_compras_notas_credito_linhas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_compras_notas_credito_linhas WHERE PlanoContasTVA = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP043";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP044";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS MOVEMENTS LINES TABLE -----------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT COUNT(*) FROM faturacao_movimentos_contabilisticos WHERE PlanoContas_Credito = ? OR PlanoContas_Debito = ?	";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP045A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP045B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//RETURN BOOL (TRUE -> IS USED // FALSE -> IS NOT USED)
	return $checker;
}

/**
 * Get Plano Code
 * @return code
 */
function getPlanoCode($fieldName, $tableName, $fieldObject, $idObject){
	global $sqli_connection;
	$code = '';

	//process
	$query = "SELECT ".$fieldName." FROM ".$tableName." WHERE ".$fieldObject." IN (".$idObject.") LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP045C";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($code);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP046";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//return
	return $code;
}

/**
 * Inserir Novo Movimento Contabilistico
 * @param  $PlanoContas  
 * @param  $Descricao    
 * @param  $TotalPVP     
 * @param  $TotalUnit    
 * @param  $TotalTVA     
 * @param  $TipoMovimento
 * @return result (bool)
 */
function insertMovimentoContabilistico($PlanoContasDebito, $PlanoContasCredito, $Descricao, $TotalPVP, $TotalUnit, $TotalTVA, $TipoMovimento, $codeTVA = 0, $inclTVA = 0){
	global $sqli_connection;
	$result = true;

	//prepare remaining vars
	$data = date("d/m/Y H:i:s");
	$timestamp = microtime(true);
	/*$PlanoContasDebito = 0;
	$PlanoContasCredito = 0;*/

	//Round Values
	// $TotalPVP = round($TotalPVP,2);
	// $TotalUnit = round($TotalUnit,2);
	// $TotalTVA = round($TotalTVA,2);

	//Process Movimentos Débito
	/*if($TipoMovimento == 'D'){
		$PlanoContasDebito = $PlanoContas;
		// var_dump($TotalPVP, $TotalUnit, $TotalTVA);
	}else{
		$TotalPVP = $TotalPVP * (-1);
		$TotalUnit = $TotalUnit * (-1);
		$TotalTVA = $TotalTVA * (-1);
		$PlanoContasCredito = $PlanoContas;
	}*/
	if($TipoMovimento == 'D') $TipoMovimento = 0;
	elseif($TipoMovimento == 'C') $TipoMovimento = 1;
	elseif($TipoMovimento == 0) $TipoMovimento = 0;
	else $TipoMovimento = 1;

	//PROCESS CODE_TVA
	$percentageTVA = 0;
	$percentageTVA_tmp = 0;
	if( $codeTVA < 1 || !$codeTVA ) $codeTVA = 0;
	else{
		$query = "SELECT Valor FROM faturacao_impostos WHERE ID_Imposto = ? ";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			$stmt -> bind_param("d", $codeTVA);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP047AA";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($percentageTVA_tmp);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP047AB";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		if($percentageTVA_tmp != null) $percentageTVA = $percentageTVA_tmp;
	}

	if( $inclTVA < 1 || !$inclTVA ) {
		$inclTVA = 0;
		$TotalTVA = 0;
	}

	//INSERT RECORD
	$query = "INSERT INTO faturacao_movimentos_contabilisticos 
				(Data, PlanoContas_Debito, PlanoContas_Credito, Descricao, Total_PVP, Total_Unit, Total_TVA, TipoMovimento, TimeStampMovimento, ID_ImpostoTVA, PercentageTVA, IncludeTVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssssssdssss", 
		                    $data, 
		                    $PlanoContasDebito, 
		                    $PlanoContasCredito, 
		                    $Descricao, 
		                    $TotalPVP, 
		                    $TotalUnit, 
		                    $TotalTVA,
		                    $TipoMovimento,
		                    $timestamp,
		                    $codeTVA,
		                    $percentageTVA,
		                    $inclTVA
		        );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP047";
			$response["message"] = $stmt -> error;
			
			$result = false;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP048";
		$response["message"] = $sqli_connection -> error;
		
		$result = false;
		die(json_encode($response));
	}

	//return result
	return $result;
}

/**
 * Inserir Novo Movimento Contabilistico (Manual)
 * @param  $PlanoContas  
 * @param  $Descricao    
 * @param  $TotalPVP     
 * @param  $TotalUnit    
 * @param  $TotalTVA     
 * @param  $TipoMovimento
 * @param  $DataMovimento
 * @return result (bool)
 */
function insertMovimentoContabilisticoManual($PlanoContasDebito, $PlanoContasCredito, $Descricao, $TotalPVP, $TotalUnit, $TotalTVA, $TipoMovimento, $DataMovimento, $NaturezaMovimento = null, $codeTVA = null, $inclTVA = 0){
	global $sqli_connection;
	$result = true;
	$naturezaProcessed = null;

	//prepare remaining vars
	// $data = date("d/m/Y H:i:s");
	$tmpDT = DateTime::createFromFormat('d/m/Y', $DataMovimento);
	$data = $tmpDT->format('d/m/Y H:i:s');
	$timestamp = microtime(true);
	/*$PlanoContasDebito = 0;
	$PlanoContasCredito = 0;*/

	//Round Values
	// $TotalPVP = round($TotalPVP,2);
	// $TotalUnit = round($TotalUnit,2);
	// $TotalTVA = round($TotalTVA,2);

	//Process Movimentos Débito
	/*if($TipoMovimento == 'D'){
		$PlanoContasDebito = $PlanoContas;
		// var_dump($TotalPVP, $TotalUnit, $TotalTVA);
	}else{
		$TotalPVP = $TotalPVP * (-1);
		$TotalUnit = $TotalUnit * (-1);
		$TotalTVA = $TotalTVA * (-1);
		$PlanoContasCredito = $PlanoContas;
	}*/
	if($TipoMovimento == 'D') $TipoMovimento = 0;
	elseif($TipoMovimento == 'C') $TipoMovimento = 1;
	elseif($TipoMovimento == 0) $TipoMovimento = 0;
	else $TipoMovimento = 0;

	//PROCESS CODE_TVA
	$percentageTVA = 0;
	$percentageTVA_tmp = 0;
	if( $codeTVA < 1 || !$codeTVA ) $codeTVA = 0;
	else{
		$query = "SELECT Valor FROM faturacao_impostos WHERE ID_Imposto = ? ";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			$stmt -> bind_param("d", $codeTVA);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP047BA";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($percentageTVA_tmp);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP047BB";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		if($percentageTVA_tmp != null) $percentageTVA = $percentageTVA_tmp;
	}

	if( $inclTVA < 1 || !$inclTVA ) {
		$inclTVA = 0;
		$TotalTVA = 0;
	}

	//Process Movement Nature
	if($NaturezaMovimento) $naturezaProcessed = $NaturezaMovimento;
	else $naturezaProcessed = 'A';

	//INSERT RECORD
	$query = "INSERT INTO faturacao_movimentos_contabilisticos 
				(Data, PlanoContas_Debito, PlanoContas_Credito, Descricao, Total_PVP, Total_Unit, Total_TVA, TipoMovimento, TimeStampMovimento, NaturezaMovimento, ID_ImpostoTVA, PercentageTVA, IncludeTVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssssssdsssss", 
		                    $data, 
		                    $PlanoContasDebito, 
		                    $PlanoContasCredito, 
		                    $Descricao, 
		                    $TotalPVP, 
		                    $TotalUnit, 
		                    $TotalTVA,
		                    $TipoMovimento,
		                    $timestamp,
		                    $naturezaProcessed,
		                    $codeTVA,
		                    $percentageTVA,
		                    $inclTVA
		        );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP047B";
			$response["message"] = $stmt -> error;
			
			$result = false;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP048B";
		$response["message"] = $sqli_connection -> error;
		
		$result = false;
		die(json_encode($response));
	}

	//return result
	return $result;
}

/**
 * Get the Initial Number
 * @param  $fieldName
 * @param  $tableName
 * @param  $whereClause
 * @param  $idParam
 * @return initNumber
 */
function getInitNumber($fieldName, $tableName, $whereClause = '', $idParam = 0){
	global $sqli_connection;

	$initNumber = 1;

	//process
	$query = "SELECT ".$fieldName." FROM ".$tableName." ".$whereClause." LIMIT 1;";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		if(intval($idParam) > 0) $stmt -> bind_param("d", $idParam );
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP050";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($initNumber);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP051";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//return next id
	return $initNumber;
}

/**
 * Get the Max Number for table
 * @param  $query
 * @return max number
 */
function getMaxNumberDocument($queryStmt){
	global $sqli_connection;

	$maxNumber = 0;

	//process
	$query = $queryStmt;
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP052";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($maxNumber);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP052";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//return next id
	return $maxNumber;
}

/**
 * Get list of <options/> with available years for history select box
 * @return $listYears [array of years]
 */
function getYearsHistoryOtps(){
	global $sqli_connection;

	//init vars
	$currentYear = intval($_SESSION['ano']);
	$listYearsStrs = array();
	$listYears = array(
		array(
			"ano_val" => $currentYear,
			"ano_label" => $currentYear,
		)
	);

	//get oldest log date
	$query = "SELECT YEAR(STR_TO_DATE(Data, '%d/%m/%Y')) FROM log WHERE ID_Log > 0 GROUP BY YEAR(STR_TO_DATE(Data, '%d/%m/%Y')) ORDER BY YEAR(STR_TO_DATE(Data, '%d/%m/%Y')) DESC;";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codeTVA);
		//result
		$result = $stmt -> execute();
		if (false === $result) {}
		$stmt -> store_result();
		$stmt -> bind_result($oldestYear);
		while($stmt -> fetch()){
			if(intval($oldestYear) != $currentYear){
				$listYears[] = array(
					"ano_val" => $oldestYear,
					"ano_label" => $oldestYear,
				);
			}
		}
		$stmt -> close();
	} else {}

	//generate <options/>
	foreach ($listYears as $yearItem) {
		$selectedAttr = intval($yearItem['ano_val']) == $currentYear ? 'selected="selected"' : '';

		array_push($listYearsStrs, '<option value="'.$yearItem['ano_val'].'" '.$selectedAttr.'>'.$yearItem['ano_label'].'</option>');
	}

	//response
	return $listYearsStrs;
}

/**
 * Check if Date is Bloqued / Closed
 * @param $month
 * @param $year
 * @return $listYears [array of years]
 */
function checkIfClosedMonth($month, $year){
	global $sqli_connection;

	//init vars
	$isClosed = false;
	$countExists = 0;
	$processedMonth = $month;
	if($month < 10) $processedMonth = str_replace("0", "", $month);

	//get oldest log date
	$query = "SELECT COUNT(*) FROM faturacao_fecho_mes WHERE Mes=? AND Ano=? AND Estado = 1;";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $processedMonth, $year);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP053";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($countExists);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP054";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($countExists > 0){
		$isClosed = true;
	}
	//response
	return $isClosed;
}


/**
 * Get Custom Rounded UP Value for Invoices (0.05 UP)
 * @param  [float] $valueToRise
 * @return formatted value
 *  
 * Exemple - Facture CHF 2,60 c'est CHF 2,60
 * Exemple - Facture CHF 2,61 c'est CHF 2,60
 * Exemple - Facture CHF 2,62 c'est CHF 2,60
 * Exemple - Facture CHF 2,63 c’est CHF 2,65
 * Exemple - Facture CHF 2,64 c’est CHF 2,65
 * Exemple - Facture CHF 2,65 c’est CHF 2,65
 * Exemple - Facture CHF 2,66 c’est CHF 2,65
 * Exemple - Facture CHF 2,67 c’est CHF 2,65
 * Exemple - Facture CHF 2,68 c'est CHF 2,70
 * Exemple - Facture CHF 2,69 c’est CHF 2,70
 * Exemple - Facture CHF 2,70 c’est CHF 2,70

 */
function roundPriceUp($valueToRise) {
	$finalValue = 0;
	//confirm that the value is rounded
	$roundedValue = round($valueToRise, 2);
	$roundedValue = number_format($roundedValue, 2, '.', '');
	// var_dump($roundedValue);
	//grab last decimal number
	$lastNumber = substr($roundedValue, -1);

	/* === process the last decimal number === */
	
	//when is bigger than 0 and smaller than 3, 
	//it means that the last decimal needs to be replaced by 0 (from 0.00)
	if($lastNumber > 0 && $lastNumber <= 2) {
		$replacement = 0;
		$finalValue = substr($roundedValue, 0, -1).$replacement;
	}
	//when is bigger than 2 and smaller than 8, 
	//it means that the last decimal needs to be replaced by 5 (from 0.05)
	elseif($lastNumber > 2 && $lastNumber <= 7) {
		$replacement = 5;
		$finalValue = substr($roundedValue, 0, -1).$replacement;
	}
	//when is bigger than 7 and smaller than 10, 
	//it meand we need to round up to 1 decimal case
	//and it will return the 1.00 (number rounded 0.05 up) from the number
	elseif($lastNumber > 7 && $lastNumber <=9 ) {
		$finalValue = round($valueToRise, 1);
	}
	else{
		$finalValue = $roundedValue;
	}
	/* =========== /end processing =========== */

	//return final formatted value
	return round($finalValue,2);
}

/**
 * Calculate and print extensive date in french
 * @param  $date [ enter date format 2011-01-31 (Y-m-d) ]
 * @return extensive date
 */
function date_in_french($date){
	$week_name = array("Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi");
	$month_name=array("","Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août",
	"Septembre","Octobre","Novembre","Décembre");

	$split = preg_split('/-/', $date);
	$year = $split[0];
	$month = round($split[1]);
	$day = round($split[2]);

	$week_day = date("w", mktime(12, 0, 0, $month, $day, $year));
	// return $date_fr = $week_name[$week_day] .' '. $day .' '. $month_name[$month] .' '. $year;
	return $date_fr = $day .' '. $month_name[$month] .' '. $year;
}

/**
 * Get Month Desc in french
 * @param  $month (1 - 12)
 * @return extensive month
 */
function month_in_french($month){
	$finalStr = '';

	switch ($month) {
		case 1: $finalStr = 'Janvier'; break;
		case 2: $finalStr = 'Février'; break;
		case 3: $finalStr = 'Mars'; break;
		case 4: $finalStr = 'Avril'; break;
		case 5: $finalStr = 'Mai'; break;
		case 6: $finalStr = 'Juin'; break;
		case 7: $finalStr = 'Juillet'; break;
		case 8: $finalStr = 'Août'; break;
		case 9: $finalStr = 'Septembre'; break;
		case 10: $finalStr = 'Octobre'; break;
		case 11: $finalStr = 'Novembre'; break;
		case 12: $finalStr = 'Décembre'; break;
		
		default: break;
	}

	return $finalStr;
}

/**
 * Get Month Formated
 * @param  $month (1 - 12)
 * @return formated month (01 - 12)
 */
function format_numeric_month($month){
	$finalStr = '';

	switch ($month) {
		case 1: $finalStr = '0'.$month; break;
		case 2: $finalStr = '0'.$month; break;
		case 3: $finalStr = '0'.$month; break;
		case 4: $finalStr = '0'.$month; break;
		case 5: $finalStr = '0'.$month; break;
		case 6: $finalStr = '0'.$month; break;
		case 7: $finalStr = '0'.$month; break;
		case 8: $finalStr = '0'.$month; break;
		case 9: $finalStr = '0'.$month; break;
		case 10: $finalStr = ''.$month; break;
		case 11: $finalStr = ''.$month; break;
		case 12: $finalStr = ''.$month; break;
		
		default: break;
	}

	return $finalStr;
}

/**
 * Calculate and print extensive date in french
 * @param  $date [ enter date format 2011-01-31 (Y-m-d) ]
 * @return extensive date
 */
function date_french_ByElement($date, $format, $element){
	//init vars
	$week_name = array("Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi");
	$month_name=array("","Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août",
	"Septembre","Octobre","Novembre","Décembre");

	$finalResult = '';

	//process date using received format
	$tmpDT = DateTime::createFromFormat($format, $date);

	//process element to retreied
	switch ($element) {
		case 'd':
			$finalResult = $tmpDT->format('d');
			break;
		case 'm':
			$finalResult = $tmpDT->format('m');
			break;
		case 'M':
			$month = round( $tmpDT->format('m') );
			$finalResult = strtolower( $month_name[$month] );
			break;
		case 'y':
			$finalResult = $tmpDT->format('y');
			break;
		case 'Y':
			$finalResult = $tmpDT->format('Y');
			break;
		case 'time':
			$finalResult = $tmpDT->format('H:i:s');
			break;
		
		default:
			$finalResult = $tmpDT->format($format);
			break;
	}

	//return result
	return $finalResult;
}
/**
 * Send emails using PHP Mailer
 * @param  [type] $htmlContent [description]
 * @param  [type] $subject     [description]
 * @param  [type] $toEmail     [description]
 * @return [type]              [description]
 */
function sendEmailPHPMailer($htmlContent, $subject, $toEmail){
	require_once $_SERVER["DOCUMENT_ROOT"] . '/server/PHPMailer/PHPMailerAutoload.php';

	//send email
    try{
        $body = $htmlContent;
        //echo $body;

        $Mailer = new PHPMailer();

        // define que será usado SMTP
        $Mailer -> IsSMTP();

        // envia email HTML
        $Mailer -> isHTML(true);

        // codificação UTF-8, a codificação mais usada recentemente
        $Mailer -> CharSet = 'UTF-8';

        // Configurações do SMTP
        $Mailer -> SMTPAuth = true;
		$Mailer -> SMTPSecure = '';
		$Mailer -> Host = 'mail.infomaniak.com';
		$Mailer -> Port = 587;
		$Mailer -> Username = 'no-reply@frifacturation.ch';
		$Mailer -> Password = 'k5xc0dBFaESq';
		$Mailer -> From = 'no-reply@frifacturation.ch';
		$Mailer -> FromName = 'Frifacturation';
		$Mailer -> Subject = $subject;
		// $Mailer -> AddAttachment($invoiceLink, $invoiceName);
		$Mailer -> AddAddress($toEmail);
		// $Mailer -> AddCC('tiago.pais@ftkode.com');
		$Mailer -> Body = $body;

		//RECEIPT
		// $Mailer->AddCustomHeader( "X-Confirm-Reading-To: ".$fromEmail."" );
		// $Mailer->AddCustomHeader( "Return-receipt-to: ".$fromEmail."" );

        //send email and check response
        $send = $Mailer -> Send();

        if($send) return true;
        else return false;
    }catch(Exception $e){
        return false;
    }

    //return
    return true;
}

/**
 * CLEAN STRING: " AND ' AND TRIM
 * @param  $stringToClean
 * @return cleaned string
 */
function stringCleanerDB($stringToClean) {
	// Replaces "
	$stringToClean = str_replace('"', ' ', $stringToClean);
	// Replaces '
	$stringToClean = str_replace("'", " ", $stringToClean);
	// TRIM
	$stringToClean = trim($stringToClean);

	//reponse
	return $stringToClean;
}

/**
 * CLEAN STRING FROM SPECIAL CHARS AND BLANK SPACES
 * @param  $string
 * @return cleaned string
 */
function stringCleanerSC($stringToClean) {
	// Replaces all spaces.
	$stringToClean = str_replace(' ', '', $stringToClean);
	// Removes special chars.
	$stringToClean = preg_replace('/[^A-Za-z0-9\-]/', '', $stringToClean);
	
	// Replaces multiple hyphens.
	return preg_replace('/-+/', '', $stringToClean);
}

/**
 * CLEAN STRING FOR FILE NAMES
 * @param  $string
 * @return cleaned string
 */
function stringCleanerFileName($stringToClean) {
	// Replaces all spaces.
	$stringToClean = stringCleanerDB($stringToClean);
	// Removes special chars.
	$stringToClean = stringCleanerSC($stringToClean);
	
	// Replaces multiple hyphens.
	return $stringToClean;
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// 								LOW PRIORITY RESOURCES
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
/**
 * Get The country full name
 * @param  [string] $iso2Code
 * @return response
 */
function getCountryByISO2($iso2Code){
	$fullname = '';
	switch ($iso2Code) {		
		case "CH" : $fullname = "Suisse" ; 													break;
		case "FR" : $fullname = "France" ; 													break;
		case "IT" : $fullname = "Italie" ; 													break;
		case "DE" : $fullname = "Allemagne" ; 												break;
		case "PT" : $fullname = "Portugal" ; 												break;
		case "ES" : $fullname = "Espagne" ; 												break;
		case "AT" : $fullname = "Autriche" ; 												break;
		case "LU" : $fullname = "Luxembourg" ; 												break;
		case "LI" : $fullname = "Liechtenstein" ; 											break;
		case "AF" : $fullname = "Afghanistan" ; 											break;
		case "ZA" : $fullname = "Afrique du Sud" ; 											break;
		case "AL" : $fullname = "Albanie" ; 												break;
		case "DZ" : $fullname = "Algérie" ; 												break;
		case "AD" : $fullname = "Andorre" ; 												break;
		case "AO" : $fullname = "Angola" ; 													break;
		case "AI" : $fullname = "Anguilla" ; 												break;
		case "AG" : $fullname = "Antigua-et-Barbuda" ; 										break;
		case "AN" : $fullname = "Antilles néerlandaises" ; 									break;
		case "SA" : $fullname = "Arabie saoudite" ; 										break;
		case "AR" : $fullname = "Argentine" ; 												break;
		case "AM" : $fullname = "Arménie" ; 												break;
		case "AW" : $fullname = "Aruba" ; 													break;
		case "AU" : $fullname = "Australie" ; 												break;
		case "AZ" : $fullname = "Azerbaïdjan" ; 											break;
		case "BH" : $fullname = "Bahreïn" ; 												break;
		case "BD" : $fullname = "Bangladesh" ; 												break;
		case "BB" : $fullname = "Barbade" ; 												break;
		case "BE" : $fullname = "Belgique" ; 												break;
		case "BZ" : $fullname = "Belize" ; 													break;
		case "BJ" : $fullname = "Bénin" ; 													break;
		case "BY" : $fullname = "Biélorussie" ; 											break;
		case "MM" : $fullname = "Birmanie" ; 												break;
		case "BO" : $fullname = "Bolivie" ; 												break;
		case "BA" : $fullname = "Bosnie-Herzégovine" ; 										break;
		case "BW" : $fullname = "Botswana" ; 												break;
		case "BR" : $fullname = "Brésil" ; 													break;
		case "BN" : $fullname = "Brunei" ; 													break;
		case "BG" : $fullname = "Bulgarie" ; 												break;
		case "BF" : $fullname = "Burkina&nbsp;Faso" ; 										break;
		case "BI" : $fullname = "Burundi" ; 												break;
		case "KH" : $fullname = "Cambodge" ; 												break;
		case "CM" : $fullname = "Cameroun" ; 												break;
		case "CA" : $fullname = "Canada" ; 													break;
		case "CV" : $fullname = "Cap-Vert" ; 												break;
		case "CL" : $fullname = "Chili" ; 													break;
		case "CN" : $fullname = "Chine" ; 													break;
		case "CY" : $fullname = "Chypre" ; 													break;
		case "CO" : $fullname = "Colombie" ; 												break;
		case "KM" : $fullname = "Comores" ; 												break;
		case "CG" : $fullname = "Congo-Brazzaville / (Congo)" ; 							break;
		case "CD" : $fullname = "Congo-Kinshasa / (République démocratique du Congo)" ; 	break;
		case "KP" : $fullname = "Corée du Nord" ; 											break;
		case "KR" : $fullname = "Corée du Sud" ; 											break;
		case "CR" : $fullname = "Costa Rica" ; 												break;
		case "CI" : $fullname = "Côte d'Ivoire" ; 											break;
		case "HR" : $fullname = "Croatie" ; 												break;
		case "CU" : $fullname = "Cuba" ; 													break;
		case "DK" : $fullname = "Danemark" ; 												break;
		case "DJ" : $fullname = "Djibouti" ; 												break;
		case "DM" : $fullname = "Dominique" ; 												break;
		case "EG" : $fullname = "Égypte" ; 													break;
		case "AE" : $fullname = "Émirats arabes unis" ; 									break;
		case "EC" : $fullname = "Équateur" ; 												break;
		case "ER" : $fullname = "Érythrée" ; 												break;
		case "EE" : $fullname = "Estonie" ; 												break;
		case "US" : $fullname = "États-Unis" ; 												break;
		case "ET" : $fullname = "Éthiopie" ; 												break;
		case "FJ" : $fullname = "Fidji" ; 													break;
		case "FI" : $fullname = "Finlande" ; 												break;
		case "GA" : $fullname = "Gabon" ; 													break;
		case "GM" : $fullname = "Gambie" ; 													break;
		case "GE" : $fullname = "Géorgie" ; 												break;
		case "GH" : $fullname = "Ghana" ; 													break;
		case "GR" : $fullname = "Grèce" ; 													break;
		case "GD" : $fullname = "Grenade" ; 												break;
		case "GU" : $fullname = "Guam" ; 													break;
		case "GT" : $fullname = "Guatemala" ; 												break;
		case "GN" : $fullname = "Guinée" ; 													break;
		case "GQ" : $fullname = "Guinée équatoriale" ; 										break;
		case "GW" : $fullname = "Guinée-Bissau" ; 											break;
		case "GY" : $fullname = "Guyana" ; 													break;
		case "HT" : $fullname = "Haïti" ; 													break;
		case "HN" : $fullname = "Honduras" ; 												break;
		case "HU" : $fullname = "Hongrie" ; 												break;
		case "KY" : $fullname = "Îles Caïmans" ; 											break;
		case "CK" : $fullname = "Îles Cook" ; 												break;
		case "PN" : $fullname = "Îles Pitcairn" ; 											break;
		case "TC" : $fullname = "Îles Turques-et-Caïques" ; 								break;
		case "VG" : $fullname = "Îles Vierges britanniques" ; 								break;
		case "VI" : $fullname = "Îles Vierges des États-Unis" ; 							break;
		case "IN" : $fullname = "Inde" ; 													break;
		case "ID" : $fullname = "Indonésie" ; 												break;
		case "IQ" : $fullname = "Irak" ; 													break;
		case "IR" : $fullname = "Iran" ; 													break;
		case "IE" : $fullname = "Irlande" ; 												break;
		case "IS" : $fullname = "Islande" ; 												break;
		case "IL" : $fullname = "Israel" ; 													break;
		case "JM" : $fullname = "Jamaïque" ; 												break;
		case "JP" : $fullname = "Japon" ; 													break;
		case "JO" : $fullname = "Jordanie" ; 												break;
		case "KZ" : $fullname = "Kazakhstan" ; 												break;
		case "KE" : $fullname = "Kenya" ; 													break;
		case "KG" : $fullname = "Kirghizistan" ; 											break;
		case "KI" : $fullname = "Kiribati" ; 												break;
		case "KW" : $fullname = "Koweït" ; 													break;
		case "LA" : $fullname = "Laos" ; 													break;
		case "LS" : $fullname = "Lesotho" ; 												break;
		case "LV" : $fullname = "Lettonie" ; 												break;
		case "LB" : $fullname = "Liban" ; 													break;
		case "LR" : $fullname = "Liberia" ; 												break;
		case "LY" : $fullname = "Libye" ; 													break;
		case "LT" : $fullname = "Lituanie" ; 												break;
		case "MO" : $fullname = "Macao" ; 													break;
		case "MK" : $fullname = "Macédoine" ; 												break;
		case "MG" : $fullname = "Madagascar" ; 												break;
		case "MY" : $fullname = "Malaisie" ; 												break;
		case "MW" : $fullname = "Malawi" ; 													break;
		case "MV" : $fullname = "Maloptiones" ; 											break;
		case "ML" : $fullname = "Mali" ; 													break;
		case "MT" : $fullname = "Malte" ; 													break;
		case "MA" : $fullname = "Maroc" ; 													break;
		case "MH" : $fullname = "Marshall" ; 												break;
		case "MU" : $fullname = "Maurice" ; 												break;
		case "MR" : $fullname = "Mauritanie" ; 												break;
		case "MX" : $fullname = "Mexique" ; 												break;
		case "FM" : $fullname = "Micronésie" ; 												break;
		case "MD" : $fullname = "Moldavie" ; 												break;
		case "MC" : $fullname = "Monaco" ; 													break;
		case "MN" : $fullname = "Mongolie" ; 												break;
		case "ME" : $fullname = "Monténégro" ; 												break;
		case "MS" : $fullname = "Montserrat" ; 												break;
		case "MZ" : $fullname = "Mozambique" ; 												break;
		case "NA" : $fullname = "Namibie" ; 												break;
		case "NR" : $fullname = "Nauru" ; 													break;
		case "NP" : $fullname = "Népal" ; 													break;
		case "NI" : $fullname = "Nicaragua" ; 												break;
		case "NE" : $fullname = "Niger" ; 													break;
		case "NG" : $fullname = "Nigeria" ; 												break;
		case "NU" : $fullname = "Niue" ; 													break;
		case "NF" : $fullname = "Norfolk" ; 												break;
		case "NO" : $fullname = "Norvège" ; 												break;
		case "NZ" : $fullname = "Nouvelle-Zélande" ; 										break;
		case "OM" : $fullname = "Oman" ; 													break;
		case "UG" : $fullname = "Ouganda" ; 												break;
		case "UZ" : $fullname = "Ouzbékistan" ; 											break;
		case "PK" : $fullname = "Pakistan" ; 												break;
		case "PW" : $fullname = "Palaos" ; 													break;
		case "PA" : $fullname = "Panamá" ; 													break;
		case "PG" : $fullname = "Papouasie-Nouvelle-Guinée" ; 								break;
		case "PY" : $fullname = "Paraguay" ; 												break;
		case "NL" : $fullname = "Pays-Bas" ; 												break;
		case "PE" : $fullname = "Pérou" ; 													break;
		case "PH" : $fullname = "Philippines" ; 											break;
		case "PL" : $fullname = "Pologne" ; 												break;
		case "PR" : $fullname = "Porto Rico" ; 												break;
		case "QA" : $fullname = "Qatar" ; 													break;
		case "DO" : $fullname = "République dominicaine" ; 									break;
		case "CZ" : $fullname = "République tchèque" ; 										break;
		case "CF" : $fullname = "République centrafricaine" ; 								break;
		case "RO" : $fullname = "Roumanie" ; 												break;
		case "GB" : $fullname = "Royaume-Uni" ; 											break;
		case "RU" : $fullname = "Russie" ; 													break;
		case "RW" : $fullname = "Rwanda" ; 													break;
		case "KN" : $fullname = "Saint-Christophe-et-Niévès" ; 								break;
		case "LC" : $fullname = "Sainte-Lucie" ; 											break;
		case "SM" : $fullname = "Saint-Marin" ; 											break;
		case "VC" : $fullname = "Saint-Vincent-et-les Grenadines" ; 						break;
		case "SB" : $fullname = "Salomon" ; 												break;
		case "SV" : $fullname = "Salvador" ; 												break;
		case "WS" : $fullname = "Samoa" ; 													break;
		case "ST" : $fullname = "Sao Tomé-et-Principe" ; 									break;
		case "SN" : $fullname = "Sénégal" ; 												break;
		case "RS" : $fullname = "Serbie" ; 													break;
		case "SC" : $fullname = "Seychelles" ; 												break;
		case "SL" : $fullname = "Sierra Leone" ; 											break;
		case "SG" : $fullname = "Singapour" ; 												break;
		case "SK" : $fullname = "Slovaquie" ; 												break;
		case "SI" : $fullname = "Slovénie" ; 												break;
		case "SO" : $fullname = "Somalie" ; 												break;
		case "SD" : $fullname = "Soudan" ; 													break;
		case "LK" : $fullname = "Sri Lanka" ; 												break;
		case "SE" : $fullname = "Suède" ; 													break;
		case "SR" : $fullname = "Suriname" ; 												break;
		case "SZ" : $fullname = "Swaziland" ; 												break;
		case "SY" : $fullname = "Syrie" ; 													break;
		case "TJ" : $fullname = "Tadjikistan" ; 											break;
		case "TW" : $fullname = "Taïwan / (République de Chine)" ; 							break;
		case "TZ" : $fullname = "Tanzanie" ; 												break;
		case "TD" : $fullname = "Tchad" ; 													break;
		case "TH" : $fullname = "Thaïlande" ; 												break;
		case "TL" : $fullname = "Timor oriental" ; 											break;
		case "TG" : $fullname = "Togo" ; 													break;
		case "TK" : $fullname = "Tokelau" ; 												break;
		case "TO" : $fullname = "Tonga" ; 													break;
		case "TT" : $fullname = "Trinité-et-Tobago" ; 										break;
		case "TN" : $fullname = "Tunisie" ; 												break;
		case "TM" : $fullname = "Turkménistan" ; 											break;
		case "TR" : $fullname = "Turquie" ; 												break;
		case "TV" : $fullname = "Tuvalu" ; 													break;
		case "UA" : $fullname = "Ukraine" ; 												break;
		case "UY" : $fullname = "Uruguay" ; 												break;
		case "VU" : $fullname = "Vanuatu" ; 												break;
		case "VA" : $fullname = "Vatican (Saint-Siège)" ; 									break;
		case "VE" : $fullname = "Venezuela" ; 												break;
		case "VN" : $fullname = "Viêt Nam" ; 												break;
		case "YE" : $fullname = "Yémen" ; 													break;
		case "ZM" : $fullname = "Zambie" ; 													break;
		case "ZW" : $fullname = "Zimbabwe" ; 												break;
		
		default:	break;
	}
	return $fullname;
}

?>