<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idFatura = $_POST['idFatura'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idFatura == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Exportada, TotalPagar, 
	(SELECT COUNT(*) FROM faturacao_notas_credito WHERE Estado IN ('Aberto','Pago') AND faturacao_notas_credito.ID_Documento_Origem = faturacao_faturas.ID_Fatura AND faturacao_notas_credito.Tipo_Documento_Origem = 'FT'),
	(SELECT COUNT(*) FROM faturacao_recibos WHERE Estado IN ('Aberto','Pago') AND faturacao_recibos.ID_DocumentoMain = faturacao_faturas.ID_Fatura AND faturacao_recibos.Tipo_DocumentoMain = 'FT' ), Data
	FROM faturacao_faturas WHERE ID_Fatura=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $Bloqueada, $totalPagamento, $totalCreditos, $totalRecibos, $data);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003A";
	$response["message"] = "Fatura em rascunho!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
if($Estado == 'Anulado') {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003B";
	$response["message"] = "Fatura já anulada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//Check if Blocked
if($Bloqueada == 1) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003C";
	$response["message"] = "Fatura bloqueada!";
	$response["bloqueada"] = true;
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//Check if Associated
if($totalCreditos > 0 || $totalRecibos > 0) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003D";
	$response["message"] = "Fatura bloqueada!";
	$response["dependentes"] = true;
	$response["recibos"] = $totalRecibos;
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($data) && $data != '' ? $data : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//UPDATE DB -------------------------------------------------------------
$dataAtualizacao = date("d/m/Y H:i:s");

$query = "UPDATE faturacao_faturas SET Estado = 'Anulado', TotalLiquidado=?, TotalLiquidadoDocumento=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=? WHERE ID_Fatura=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssssd", $totalPagamento, $totalPagamento, $id_utilizador, $dataAtualizacao, $idFatura );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//------------------------------------------------------------------------
//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
//------------------------------------------------------------------------
$query = "SELECT PlanoContas, PlanoContasBanco,
			(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) AS Serie,
			Numero , CustomerID, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS Cliente,
			GrossTotal, NetTotal, TaxPayable, Data
		FROM faturacao_faturas WHERE ID_Fatura=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoCliente, $planoBanco, $serie, $numeroDoc, $numCliente, $nomeCliente, $totalPVP, $totalUnit, $totalTVA, $dataNew );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA029";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//PROCESS MOVEMENT FOR DOCUMENT
$texto = 'Facture (Annulation) - '.$serie.'/'.$numeroDoc.' - '.$numCliente.' - '.$nomeCliente;

if($Estado == 'Aberto'){
	/*if($planoCliente > 0){
		$tipoMovimento = 'C';
		// insertMovimentoContabilistico($planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento);
		insertMovimentoContabilistico($planoCliente, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento);
	}*/
}else{
	if($planoBanco > 0){
		$tipoMovimento = 'C';
		// insertMovimentoContabilistico($planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento);
		insertMovimentoContabilisticoManual($planoCliente, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento, $dataNew, 'A');		
	}
}

//LINES -- ARTICLES
$query = "SELECT PlanoContas, ProductCode, TotalLinha, TotalLinhaSIVA, (TotalLinha - TotalLinhaSIVA), ID_Imposto FROM faturacao_faturas_linhas WHERE ID_Fatura=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoArtigo, $codigoArtigo,$totalPVP_Artigo, $totalUnit_Artigo, $totalTVA_Artigo, $id_imposto_artigo );
	while ($stmt -> fetch()) {
		//PROCESS MOVEMENT ARTICLE
		if($planoArtigo > 0){
			$textoArtigo = $texto.' - Article - '.$codigoArtigo;
			$tipoMovimentoArtigo = 'C';
			// $tipoMovimentoArtigo = 1;
			$dataArtigos[] = array('plano'=>$planoArtigo, 'texto'=>$textoArtigo, 'totalPVP'=>$totalPVP_Artigo, 'totalUnit'=>$totalUnit_Artigo, 'totalTVA'=>$totalTVA_Artigo, 'tipo'=>$tipoMovimentoArtigo, 'id_imposto_artigo'=>$id_imposto_artigo);
		}
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA031";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if(isset($dataArtigos)){
	foreach ($dataArtigos as $line) {
			$Edited_TotalPVP = round($line['totalUnit'],$numDecimais);
			if($Edited_TotalPVP > 0){
				insertMovimentoContabilisticoManual($line['plano'], $planoCliente, $line['texto'], $Edited_TotalPVP, 0, $Edited_TotalPVP, $line['tipo'], $dataNew, 'A', $line['id_imposto_artigo'], 0);
			}
	}
}

//LINES -- TVA
$query = "SELECT (SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_faturas_linhas.ID_Imposto), (SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_faturas_linhas.ID_Imposto) AS Imposto, 
			TaxPercentage, SUM(TotalLinha), SUM(TotalLinhaSIVA), ID_Imposto 
		FROM faturacao_faturas_linhas WHERE ID_Fatura=? GROUP BY ID_Imposto";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoTVA, $nomeTVA, $percentagemTVA, $totalPVP_TVA, $totalUnit_TVA, $id_imposto_TVA );
	while ($stmt -> fetch()) {
		//PROCESS MOVEMENT ARTICLE
		if($planoTVA > 0){
			$totalTVA_TVA = $totalPVP_TVA - $totalUnit_TVA;
			$textoTVA = $texto.' - TVA - '.$nomeTVA.': '.$percentagemTVA.'%';
			$tipoMovimentoTVA = 'C';
			// $tipoMovimentoTVA = 1;
			$dataTVA[] = array('plano'=>$planoTVA, 'texto'=>$textoTVA, 'totalPVP'=>$totalPVP_TVA, 'totalUnit'=>$totalUnit_TVA, 'totalTVA'=>$totalTVA_TVA, 'tipo'=>$tipoMovimentoTVA, 'id_imposto_TVA'=>$id_imposto_TVA);
		}
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA031";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if(isset($dataTVA)){
	foreach ($dataTVA as $line) {
		insertMovimentoContabilisticoManual($line['plano'], $planoCliente, $line['texto'], $line['totalTVA'], 0, $line['totalTVA'], $line['tipo'], $dataNew, 'A', $line['id_imposto_TVA'], 1);
	}
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Annulation du facture (id: ".$idFatura.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>