<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idNota = $_POST['idNota'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idNota == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Data, Validade, TotaRetencao, TotalPagar, ID_Documento_Origem, Tipo_Documento_Origem, Data_Documento_Origem, Numero FROM faturacao_compras_notas_credito WHERE ID_NotaCreditoCompra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idNota);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $data, $validade, $retencaoTotal, $totalPagar, $docOrigem, $docType, $dataOrigin, $numeroNota );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado != 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "usado";
	$response["line"] = "FATS003";
	$response["message"] = "Nota já processada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($data) && $data != '' ? $data : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//PROCESS ORIGIN
$fieldIdName = 'ID_Compra';
$tableName = 'faturacao_compras';
// switch ($docType) {
// 	case 'FT':
// 		$fieldIdName = 'ID_Fatura';
// 		$tableName = 'faturacao_faturas';
// 		break;
// 	case 'FS':
// 		$fieldIdName = 'ID_FaturaSimplificada';
// 		$tableName = 'faturacao_faturas_simplificadas';
// 		break;
// 	case 'FR':
// 		$fieldIdName = 'ID_FaturaRecibo';
// 		$tableName = 'faturacao_faturas_recibo';
// 		break;
	
// 	default:
// 		$response["errors"] = true;
// 		$response["type"] = "query";
// 		$response["line"] = "FATS0000AA";
// 		$response["message"] = 'Tipo inválido!';
// 		die(json_encode($response));
// 		break;
// }
//-----------------------------------------------------------------------

//CHECK ORIGIN DOCUMENT -------------------------------------------------
$query = "SELECT TotalCreditado, TotalLiquidado, GrossTotal, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $docOrigem);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000C";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($totalCreditadoDocOrig,$totalLiquidadoDocOrig, $GrossTotalOrig, $estadoOrigem );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS0000D";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//VERIFY TOTAL PAYABLE
if($totalCreditadoDocOrig > $totalLiquidadoDocOrig) $totalMaxPagavel = $GrossTotalOrig - $totalCreditadoDocOrig;
else $totalMaxPagavel = $GrossTotalOrig - $totalLiquidadoDocOrig;

if( $totalPagar > $totalMaxPagavel){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["pagavel"] = true;
	$response["line"] = "FATS0000E";
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CLOSE THE DOCUMENT ----------------------------------------------------
$systemEntryDateUpdate = date("Y-m-d H:i:s");
$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
// $retencaoCalc = round($retencaoTotal,2);
$retencaoCalc = $retencaoTotal;
// $totalLiquidado = $retencaoCalc;
// $totalLiquidado = 0;

$dataNew = $data;
$validadeNew = $validade;
$dataAtualizacao = date("d/m/Y H:i:s");

//this entry date timestamp
$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
$dtOriginDateTime = $dtOriginDate->getTimestamp();

//this entry date timestamp
$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
$dtThisDateTime = $dtThisDate->getTimestamp();

//process date origin
if( $dtThisDateTime < $dtOriginDateTime ){
	//alert user that the date is before the last one
	$response["errors"] = true;
	$response["type"] = "FTGA024C";
	$response["data_superior2"] = true;
	$response["dataUltima"] = $dataOrigin;
	$response["message"] = "Data superior à compra.";
	restoreRecord($idNota);
	die(json_encode($response));
}

// DEFINE NEW NUMBER
$query = "UPDATE faturacao_compras_notas_credito SET Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Pago' WHERE ID_NotaCreditoCompra = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssdsd", $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idNota);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA025";
		$response["message"] = $stmt -> error;
		restoreRecord($idNota);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026";
	$response["message"] = $sqli_connection -> error;
	restoreRecord($idNota);
	die(json_encode($response));
}

// UPDATE REMAIN FIELDS
$query = "UPDATE faturacao_compras_notas_credito SET SystemEntryDate=? WHERE ID_NotaCreditoCompra = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sd", $systemEntryDateUpdate, $idNota );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA025";
		$response["message"] = $stmt -> error;
		restoreRecord($idNota);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026";
	$response["message"] = $sqli_connection -> error;
	restoreRecord($idNota);
	die(json_encode($response));
}

//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
$query = "SELECT TotalCreditado, TotalLiquidado, GrossTotal, GrossTotal, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $docOrigem);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026C";
		$response["message"] = $stmt -> error;
		restoreRecord($idNota);
		die(json_encode($response));
	}
	$stmt -> bind_result($totalCreditadoOrig, $totalLiquidadoOrig, $GrossTotalOrig, $totalPagarOrig, $estadoOrigemLast );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA026D";
	$response["message"] = $sqli_connection -> error;
	restoreRecord($idNota);
	die(json_encode($response));
}
//last check on estado
if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FTGA026E";
	restoreRecord($idNota);
	die(json_encode($response));
}else{
	if($totalCreditadoOrig > $totalLiquidadoOrig) $totalMaxCreditavel = $GrossTotalOrig - $totalCreditadoOrig;
	else $totalMaxCreditavel = $GrossTotalOrig - $totalLiquidadoOrig;

	$totalMaxCreditavel = round($totalMaxCreditavel,$numDecimais);
	$totalPagar = round($totalPagar,$numDecimais);
	$precision = $totalMaxCreditavel - $totalPagar;
	if($precision < 0){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["pagavel"] = true;
		$response["totalPagar"] = $totalPagar;
		$response["totalMaxPagavel"] = $totalMaxCreditavel;
		$response["precision"] = $precision;
		$response["line"] = "FTGA026EA";
		restoreRecord($idNota);
		die(json_encode($response));
	}
	###---- UPDATE DOC ORIGEM ----###
	$totalCreditadoNovo = $totalCreditadoOrig + $totalPagar;
	$totalLiquidadoNovo = $totalLiquidadoOrig + $totalPagar;

	$estadoNovo = 'Aberto';
	if( $totalLiquidadoNovo > $totalPagarOrig ){
		$response["errors"] = true;
		$response["type"] = "FTGA026EB";
		$response["message"] = "Valor inserido superior ao valor pagável!";
		restoreRecord($idNota);
		die(json_encode($response));
	}else if($totalLiquidadoNovo == $totalPagarOrig){
		$estadoNovo = 'Pago';
	}

	$query = "UPDATE ".$tableName." SET TotalCreditado=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssd", $totalCreditadoNovo, $totalLiquidadoNovo, $estadoNovo, $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026F";
			$response["message"] = $stmt -> error;
			restoreRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026G";
		$response["message"] = $sqli_connection -> error;
		restoreRecord($idNota);
		die(json_encode($response));
	}
}
//--------------------------------------------------------------------

//UPDATE STOCKS
$stockUpdateResult = decreaseArticlesStock($idNota, 'faturacao_compras_notas_credito', 'ID_NotaCreditoCompra');
if($stockUpdateResult != true){
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA027";
	$response["message"] = 'Falha ao atualizar stocks.';
	die(json_encode($response));
}

//------------------------------------------------------------------------
//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
//------------------------------------------------------------------------
$query = "SELECT PlanoContas, PlanoContasBanco, Numero , 
			(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras_notas_credito.ID_Fornecedor) AS Codigo, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras_notas_credito.ID_Fornecedor) AS Fornecedor,
			GrossTotal, NetTotal, TaxPayable,
			(SELECT Numero FROM faturacao_compras WHERE faturacao_compras.ID_Compra = faturacao_compras_notas_credito.ID_Documento_Origem) AS DocumentoOrigem
		FROM faturacao_compras_notas_credito WHERE ID_NotaCreditoCompra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idNota);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $stmt -> error;
		restoreRecord($idNota);
		die(json_encode($response));
	}
	$stmt -> bind_result($planoFornecedor, $planoBanco, $numeroDoc, $numFornecedor, $nomeFornecedor, $totalPVP, $totalUnit, $totalTVA, $RefDocOrigem );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA029";
	$response["message"] = $sqli_connection -> error;
		restoreRecord($idNota);
	die(json_encode($response));
}
//PROCESS MOVEMENT FOR DOCUMENT
$texto = 'Achat: Note de Crédit - '.$numeroDoc.' - '.$RefDocOrigem.' - '.$numFornecedor.' - '.$nomeFornecedor;
/*if($planoFornecedor > 0){
	$tipoMovimento = 'D';
	// insertMovimentoContabilistico($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento);
	insertMovimentoContabilisticoManual($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento, $dataNew, 'A');
}*/

//LINES -- ARTICLES
$query = "SELECT PlanoContas, ProductCode, TotalLinha, TotalLinhaSIVA, (TotalLinha - TotalLinhaSIVA), ID_Imposto FROM faturacao_compras_notas_credito_linhas WHERE ID_NotaCreditoCompra=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idNota);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $stmt -> error;
		restoreRecord($idNota);
		die(json_encode($response));
	}
	$stmt -> bind_result($planoArtigo, $codigoArtigo,$totalPVP_Artigo, $totalUnit_Artigo, $totalTVA_Artigo, $id_imposto_artigo );
	while ($stmt -> fetch()) {
		//PROCESS MOVEMENT ARTICLE
		if($planoArtigo > 0){
			$textoArtigo = $texto.' - Article - '.$codigoArtigo;
			$tipoMovimentoArtigo = 'C';
			$dataArtigos[] = array('plano'=>$planoArtigo, 'texto'=>$textoArtigo, 'totalPVP'=>$totalPVP_Artigo, 'totalUnit'=>$totalUnit_Artigo, 'totalTVA'=>$totalTVA_Artigo, 'tipo'=>$tipoMovimentoArtigo, 'id_imposto_artigo'=>$id_imposto_artigo);
		}
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA031";
	$response["message"] = $sqli_connection -> error;
		restoreRecord($idNota);
	die(json_encode($response));
}
if(isset($dataArtigos)){
	foreach ($dataArtigos as $line) {
			$Edited_TotalPVP = round($line['totalUnit'],$numDecimais);
			if($Edited_TotalPVP > 0){
				// insertMovimentoContabilistico($line['plano'], $line['texto'], $Edited_TotalPVP, 0, 0, $line['tipo']);
				// insertMovimentoContabilisticoManual($line['plano'], $line['texto'], $Edited_TotalPVP, 0, 0, $line['tipo'], $dataNew, 'A');
				insertMovimentoContabilisticoManual($planoFornecedor, $line['plano'], $line['texto'], $Edited_TotalPVP, 0, $Edited_TotalPVP, $line['tipo'], $dataNew, 'A', $line['id_imposto_artigo'], 0);
			}
	}
}

//LINES -- TVA
$query = "SELECT (SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_compras_notas_credito_linhas.ID_Imposto), (SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_compras_notas_credito_linhas.ID_Imposto) AS Imposto, 
			TaxPercentage, SUM(TotalLinha), SUM(TotalLinhaSIVA), ID_Imposto 
		FROM faturacao_compras_notas_credito_linhas WHERE ID_NotaCreditoCompra=? GROUP BY ID_Imposto";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idNota);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $stmt -> error;
		restoreRecord($idNota);
		die(json_encode($response));
	}
	$stmt -> bind_result($planoTVA, $nomeTVA, $percentagemTVA, $totalPVP_TVA, $totalUnit_TVA, $id_imposto_TVA );
	while ($stmt -> fetch()) {
		//PROCESS MOVEMENT ARTICLE
		if($planoTVA > 0){
			$totalTVA_TVA = $totalPVP_TVA - $totalUnit_TVA;
			$textoTVA = $texto.' - TVA - '.$nomeTVA.': '.$percentagemTVA.'%';
			$tipoMovimentoTVA = 'C';
			$dataTVA[] = array('plano'=>$planoTVA, 'texto'=>$textoTVA, 'totalPVP'=>$totalPVP_TVA, 'totalUnit'=>$totalUnit_TVA, 'totalTVA'=>$totalTVA_TVA, 'tipo'=>$tipoMovimentoTVA, 'id_imposto_TVA'=>$id_imposto_TVA);
		}
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA031";
	$response["message"] = $sqli_connection -> error;
		restoreRecord($idNota);
	die(json_encode($response));
}
if(isset($dataTVA)){
	foreach ($dataTVA as $line) {
		// insertMovimentoContabilistico($line['plano'], $line['texto'], $line['totalTVA'], 0, 0, $line['tipo']);
		// insertMovimentoContabilisticoManual($line['plano'], $line['texto'], $line['totalTVA'], 0, 0, $line['tipo'], $dataNew, 'A');
		insertMovimentoContabilisticoManual($planoFornecedor, $line['plano'], $line['texto'], $line['totalTVA'], 0, $line['totalTVA'], $line['tipo'], $dataNew, 'A', $line['id_imposto_TVA'], 1);
	}
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Finalisation du note de crédit (Achat) (numéro: ".$numeroNota.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function restoreRecord($idNota){
	global $sqli_connection;

	// DEFINE NEW NUMBER
	$query = "UPDATE faturacao_compras_notas_credito SET ID_UtilizadorAtualizacao=0, DataAtualizacao='', Estado='Rascunho' WHERE ID_NotaCreditoCompra = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idNota);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM000";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM001";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	// UPDATE REMAIN FIELDS LINES
	$query = "UPDATE faturacao_compras_notas_credito_linhas SET TaxPointDate='' WHERE ID_NotaCreditoCompra = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idNota );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004A";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}

//Recalculate Totals for origin Document
function recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName){
	global $sqli_connection;
	$totalLiqGeralNew = 0;
	$totalLiqDocNew = 0;
	//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
	$query = "SELECT TotalPagar, GrossTotal, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($totalPagarOrigem, $totalGrossOrigem, $estadoOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//last check on estado
	if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "REM007";
		die(json_encode($response));
	}else{
		//GET NC TOTALS -----------------------------
		$query = "SELECT SUM(GrossTotal) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($sumGrossNC );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009A";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//GET RECEIPTS LINES TOTALS -----------------
		$query = "SELECT SUM(faturacao_recibos_linhas.CreditAmount), SUM(faturacao_recibos_linhas.valorIVA) 
			FROM faturacao_recibos_linhas, faturacao_recibos 
			WHERE faturacao_recibos.ID_Recibo = faturacao_recibos_linhas.ID_Recibo AND ID_Documento=? AND TipoDocumento=? AND faturacao_recibos.Estado IN ('Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($linesCreditSUM, $linesIvaSUM );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//GET RECEIPTS TOTALS -----------------
		$query = "SELECT SUM(GrossTotal), SUM(ValorRetencao) 
			FROM faturacao_recibos 
			WHERE ID_DocumentoMain=? AND Tipo_DocumentoMain=? AND faturacao_recibos.Estado IN ('Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($recTotalSUM, $recRetencaoSUM );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009C";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//totals
		$totalLiqDocNew = $sumGrossNC + ($linesCreditSUM + $linesIvaSUM); //document total payed
		$totalLiqGeralNew = $recTotalSUM + $recRetencaoSUM; //general total payed

		//round numbers
		$totalLiqDocNew = round($totalLiqDocNew,$numDecimais);
		$totalLiqGeralNew = round($totalLiqGeralNew,$numDecimais);

		if($totalLiqDocNew > $totalGrossOrigem){
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010A";
			$response["message"] = "Valores Inválidos";
			die(json_encode($response));
		}

		$estadoNovo = 'Aberto';
		if( $totalLiqGeralNew < $totalPagarOrigem){
			$estadoNovo = 'Aberto';
		}elseif( $totalLiqGeralNew = $totalPagarOrigem){
			$estadoNovo = 'Pago';
		}else{
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010B";
			$response["message"] = "Valores Inválidos";
			die(json_encode($response));
		}

		$query = "UPDATE ".$tableName." SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sssd", $totalLiqDocNew, $totalLiqGeralNew, $estadoNovo, $docOrigem);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM011";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM012";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}
	//--------------------------------------------------------------------
}

?>