<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "Tous"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[1, "desc"],[0, "asc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/server/datatable/fermeture_mois.php",
		"oLanguage" : {
			"sLengthMenu" : "Show _MENU_ enregistrements par page",
			"sZeroRecords" : "Sans enregistrements",
			"sInfo" : "_START_ a _END_ de _TOTAL_ enregistrements",
			"sInfoEmpty" : " 0 a 0 de 0 enregistrements",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "Suivant",
				"sFirst" : "Premier",
				"sPrevious" : "Précédent",
				"sLast" : "Dernier"
			}
		},
		"aoColumns" : [null, null, 
		{
			"sClass" : "text-center",
		}, 
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		}
		],
		"aoColumnDefs" : [
		{
			"aTargets" : [0],
			"mRender" : function(data, type, full) {
				var element = '';
				
				switch(full[0]){
					case '1': element = 'Janvier'; break;
					case '2': element = 'Février'; break;
					case '3': element = 'Mars'; break;
					case '4': element = 'Avril'; break;
					case '5': element = 'Mai'; break;
					case '6': element = 'Juin'; break;
					case '7': element = 'Juillet'; break;
					case '8': element = 'Août'; break;
					case '9': element = 'Septembre'; break;
					case '10': element = 'Octobre'; break;
					case '11': element = 'Novembre'; break;
					case '12': element = 'Décembre'; break;
					
					default: element = full[0]; break;
				}

				//return html
				return element;
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				var element = '';
				
				if(full[2] == 1) element = '<span class="label label-red">Fermé</span>'
				else element = '<span class="label label-green">Ouvert</span>'

				//return html
				return element;
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				var processedName = full[1].replace(/'/gi, " ");
				var nome = "'"+ processedName +"'";
				
				var html = '';

				if(full[2] == 1) html += '<a class="options-link text-green" onclick="alterState('+ full[3] +', '+nome+')" title="Ouvert le Mois"><i class="fa fa-unlock"></i></a>';
				else html += '<a class="options-link text-red" onclick="alterState('+ full[3] +', '+nome+')" title="Fermer le mois"><i class="fa fa-lock"></i></a>';

				html += '<a class="options-link text-red" onclick="eliminarFermeture('+ full[3] +', '+nome+')" title="Supprimer"><i class="fa fa-trash"></i></a>';

				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[3]);


			return nRow;
		},
		"fnDrawCallback" : function(oSettings) {
            $(".ellipsis").ellipsis(); 
		}

	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-blue dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> Rechercher</button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
	
	//remover
	function eliminarFermeture(idFermeture, nome){
		if (confirm("Êtes-vous sûr de vouloir supprimer le fermeture du mois \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/server/autorisations/fermeture_mois/apagar.php',
				dataType : 'json',
				data : {
					idFermeture : idFermeture
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] Impossible d'enlever cette fermeture du mois. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] Impossible d'enlever cette fermeture du mois. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("Fermeture du Mois supprimé avec succès.", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					// //reload
					// setTimeout(function() {
					// 	location.reload();
					// }, 1500);
					pesquisar();
				}
			});
		} else { return false; }
	}
	
	//alter state
	function alterState(idFermeture, nome){
		if (confirm("Êtes-vous sûr de vouloir modifier le statut du fermeture du mois \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/server/autorisations/fermeture_mois/alterstate.php',
				dataType : 'json',
				data : {
					idFermeture : idFermeture
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] Il n'est pas possible de changer le statut de cette fin de mois. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] Il n'est pas possible de changer le statut de cette fin de mois. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("Changement effectué avec succès.", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					// setTimeout(function() {
					// 	location.reload();
					// }, 1500);
					pesquisar();
				}
			});
		} else { return false; }
	}
</script>