<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idCompra = $_POST['idCompra'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idCompra == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//CHECK IF USED ---------------------------------------------------------
$query = "SELECT Estado, (SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=?) AS Creditos, Numero FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("dd", $idCompra, $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $estadoCompra, $creditosAtivos, $numeroConta );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add info to main array
if($estadoCompra != 'Rascunho' || $creditosAtivos > 0 ) {
	$response["errors"] = true;
	$response["bloqueada"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_compras WHERE ID_Compra=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idCompra );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//LINHAS
$query = "DELETE FROM faturacao_compras_linhas WHERE ID_Compra=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idCompra );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Élimination de l'achat (numéro: ".$numeroConta.")";
insert_log(0,"Apagar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>