<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$nome = $_POST['nome'];
$funcionalidade = $_POST['funcionalidade'];
$newIdProcesed = '';

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $nome == '' || $funcionalidade == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}

//GET NEW ID -------------------------------------------------------------
$query = "SELECT MAX(CAST(Machine_Name AS UNSIGNED)) FROM faturacao_permissions";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS0001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($nextID);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS0002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//new id
$newID = $nextID+1;
$finalID = $newID;

if($newID < 10) $finalID = '000'.$newID;
elseif($newID < 100) $finalID = '00'.$newID;
elseif($newID < 1000) $finalID = '0'.$newID;

//return next id
$newIdProcesed = $newIdProcesed . $finalID;
//------------------------------------------------------------------------

//INSERT NEW DOCUMENT ----------------------------------------------------
$query = "INSERT INTO faturacao_permissions (
			Machine_Name, 
			Name, 
			Funcionalidade 
			) 
	VALUES (?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param(
		"ssd", 
		$newIdProcesed,
		$nome,
		$funcionalidade
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS0003B";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//GET DOCUMENT ID
$query = "SELECT ID_Permission FROM faturacao_permissions  WHERE Machine_Name = ? LIMIT 1";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("s", $newIdProcesed);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS0004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idPermission);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS0005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $idPermission < 1){
	$response["errors"] = true;
	$response["type"] = "FATS0006";
	$response["message"] = "Permission invalid";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Création de permission (machine name: P".$newIdProcesed.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));

?>