<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($_POST['data_recibo']) && $_POST['data_recibo'] != '' ? $_POST['data_recibo'] : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//GET POST VARS ---------------------------------------------------------
$idFatura = $_POST['idFatura'];
$typeDoc = $_POST['typeDoc'];
$valor_recibo = $_POST['valor_recibo'];
$data_recibo = $_POST['data_recibo'];
$serie_recibo = $_POST['serie_recibo'];
$pagamento_recibo = $_POST['pagamento_recibo'];
$banco_recibo = $_POST['banco_recibo'];
$observacoes_recibo = $_POST['observacoes_recibo'];
$linhas = $_POST['linhas'];
$precisaBanco = $_POST['precisaBanco'];
$total_extra = $_POST['total_extra'];
//remain vars
$atcud = 0;
$period = 0;
$transactiondate = '';
$PaymentType = 'RG';
$PaymentStatus = 'N';
$PaymentStatusDate = '';
$sourcePayment = 'P';
$sourceID_Estado = $_SESSION['username'];
$sourceID_Origem = $_SESSION['username'];
$systemEntryDate = '';
$CustomerID = '';
$TaxPayable = 0;
$NetTotal = 0;
$GrossTotal = 0;
$GrossTotalRecebido = 0;
$ID_Moeda = 0;
$TaxaMoeda = 0;
$ValorRetencao = 0;
$estado = 'Pago';
$tipoDocOrigem = $typeDoc;

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idFatura == '' || $typeDoc == '' || $valor_recibo == '' || $data_recibo == '' || $serie_recibo == '' || $pagamento_recibo == '' || $linhas == '' || $linhas == null ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
if( $precisaBanco > 0 && ($banco_recibo < 1 || $banco_recibo == '') )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000B";
	die(json_encode($response));
}

//CHECK LINES
if(!is_array($linhas) || empty($linhas)){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000x";
	$response["lines_empty"] = true;
	$response["message"] = "";
	die(json_encode($response));
}
//-----------------------------------------------------------------------

try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//MAIN DOCUMENT TABLE NAME
	switch ($typeDoc) {
		case 'FT':
			$fieldIdName = 'ID_Fatura';
			$tableName = 'faturacao_faturas';
			break;
		// case 'FS':
		// 	$fieldIdName = 'ID_FaturaSimplificada';
		// 	$tableName = 'faturacao_faturas_simplificadas';
		// 	break;
		// case 'FR':
		// 	$fieldIdName = 'ID_FaturaRecibo';
		// 	$tableName = 'faturacao_faturas_recibo';
		// 	break;
		
		default:
			$response["errors"] = true;
			$response["type"] = "var";
			$response["line"] = "FATS000B";
			die(json_encode($response));
			break;
	}
	//------------------------------------------------------------------------

	//Données de Facture --------------------------------------------------------
	$query = "SELECT ".$fieldIdName.", Data,(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = ".$tableName.".ID_Cliente), ID_Moeda, TaxaMoeda, TotalLiquidado, TotalPagar FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Fatura, $dataFatura, $cod_cliente, $moedaFat, $taxaFat, $liquidadoTotalFatura, $totalPagarFatura);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($ID_Fatura < 1 || $cod_cliente < 1){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = "Fatura inválida.";
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//GET LAST RECEIPT DATE -------------------------------------------------
	$query = "SELECT ID_Recibo, TransactionDate FROM faturacao_recibos WHERE ID_Serie=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $serie_recibo);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS003A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($idRecLast, $lastDateReceipt);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($idRecLast > 0){
		$dtReciboTmp = DateTime::createFromFormat('d/m/Y', $data_recibo);
		$dtreciboTimeStamp = $dtReciboTmp->getTimestamp();

		$dtLastRec = DateTime::createFromFormat('Y-m-d', $lastDateReceipt);
		$dtLastReciboProc = $dtLastRec->format('d/m/Y');
		$dtLastTimeStamp = $dtLastRec->getTimestamp();

		//check if receipt date bigger than last receipt date
		// if( $dtreciboTimeStamp < $dtLastTimeStamp){
		// 	$response["errors"] = true;
		// 	$response["type"] = "query";
		// 	$response["data_superior"] = true;
		// 	$response["dataUltima"] = $dtLastReciboProc;
		// 	$response["message"] = "Data superior à data do ultimo recibo.";
		// 	die(json_encode($response));
		// }
	}
	//-----------------------------------------------------------------------

	//PROCESS SOME FIELDS ---------------------------------------------------
	$dtReceipt = DateTime::createFromFormat('d/m/Y', $data_recibo);
	$dataReciboProcessed = $dtReceipt->format('Y-m-d');
	$dataReciboTimestamp = $dtReceipt->getTimestamp();

	$dtInvoice = DateTime::createFromFormat('d/m/Y', $dataFatura);
	$dataFaturaTimestamp = $dtInvoice->getTimestamp();

	//process bank
	if( $precisaBanco > 0 ){
		$bancoFinalID = $banco_recibo;
	}else{
		$bancoFinalID = 0;
	}

	//check if receipt date bigger than invoice date
	// if( $dataReciboTimestamp < $dataFaturaTimestamp){
		// $response["errors"] = true;
		// $response["type"] = "query";
		// $response["data_superior"] = true;
		// $response["dataUltima"] = $dataFatura;
		// $response["message"] = "Data superior à data da fatura.";
		// die(json_encode($response));
	// }

	//fill fields
	$CustomerID = $cod_cliente;
	$ID_Moeda = $moedaFat;
	$TaxaMoeda = $taxaFat;
	$period = $dtReceipt->format('m');

	$timestamp = microtime(true);
	$transactiondate = $dataReciboProcessed;
	$systemEntryDate = date("Y-m-d H:i:s");
	$systemEntryDate = str_replace (' ','T',$systemEntryDate);
	$PaymentStatusDate = $systemEntryDate;
	//------------------------------------------------------------------------

	//INSERT INTO DB ---------------------------------------------------------
	$query = "INSERT INTO faturacao_recibos (ID_Serie, ATCUD, Period, TransactionDate, PaymentType, PaymentStatus, PaymentStatusDate, SourcePayment, Description, SourceID_Estado, SourceID_Origem, SystemEntryDate, TimestampDate, CustomerID, Estado, ID_Moeda, TaxaMoeda, ID_DocumentoMain, Tipo_DocumentoMain) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssssssssssssssdsds", $serie_recibo, $atcud, $period, $transactiondate, $PaymentType, $PaymentStatus, $PaymentStatusDate, $sourcePayment, $observacoes_recibo, $sourceID_Estado, $sourceID_Origem, $systemEntryDate, $timestamp, $CustomerID, $estado, $moedaFat, $taxaFat, $idFatura, $tipoDocOrigem );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//GET DOCUMENT ID
	$query = "SELECT ID_Recibo FROM faturacao_recibos WHERE TimestampDate = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $timestamp);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($idRecibo);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $idRecibo < 1){
		$response["errors"] = true;
		$response["type"] = "FATS009";
		$response["message"] = "Recibo inválido";
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//PROCESS LINES ----------------------------------------------------------
	$numLinha = 1;
	foreach ($linhas as $linha) {
		//init vars
		$originatingOn = '';
		$invoiceDate = '';
		$debitAmount = 0;
		$creditAmount = 0;
		$retencao = 0;

		//GET DOCUMENT DATA ---------------------------------------------------
		switch ( $linha['tipo'] ) {
			case 'FT':
				$query = "SELECT InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) AS Serie, Numero, InvoiceDate, TotalLiquidadoDocumento, GrossTotal, TaxPayable, TotaRetencao, Estado FROM faturacao_faturas WHERE ID_Fatura = ?";
				$queryUpdate = "UPDATE faturacao_faturas SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=?, TotalExtra=( ? + TotalExtra ) WHERE ID_Fatura=?";
				break;
			// case 'FS':
			// 	$query = "SELECT InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas_simplificadas.ID_Serie) AS Serie, Numero, InvoiceDate, TotalLiquidadoDocumento, GrossTotal, TaxPayable, TotaRetencao, Estado FROM faturacao_faturas_simplificadas WHERE ID_FaturaSimplificada = ?";
			// 	$queryUpdate = "UPDATE faturacao_faturas_simplificadas SET TotalLiquidadoDocumento=?, Estado=? WHERE ID_FaturaSimplificada=?";
			// 	break;
			// case 'FR':
			// 	# code...
			// 	break;
			// case 'ND':
			// 	$query = "SELECT InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_debito.ID_Serie) AS Serie, Numero, InvoiceDate, TotalLiquidadoDocumento, GrossTotal, TaxPayable, TotaRetencao, Estado FROM faturacao_notas_debito WHERE ID_NotaDebito = ?";
			// 	$queryUpdate = "UPDATE faturacao_notas_debito SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ID_NotaDebito=?";
			// 	break;
			
			default:
				$response["errors"] = true;
				$response["type"] = "FATS010";
				$response["message"] = 'Tipo de Documento Inválido';
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
				break;
		}
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['id_documento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FATS011";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> bind_result($tipoDocumento, $serieDocumento, $numberDocumento, $dataDocumento, $totalLiquidadoDocumento, $totalDocumento, $ivaDocumento, $retencaoDocumento, $estadoDocumento);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FATS012";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
		//validations
		if( $estadoDocumento != 'Aberto' && $estadoDocumento != 'Pago' ){
			$response["errors"] = true;
			$response["type"] = "FATS013A";
			$response["message"] = "Documento num estado inválido para pagamento!";
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}

		$dtRecTmp = DateTime::createFromFormat('d/m/Y', $data_recibo);
		$dtRecTimeStamp = $dtRecTmp->getTimestamp();

		$dtLine = DateTime::createFromFormat('Y-m-d', $dataDocumento);
		$dataLineTimestamp = $dtLine->getTimestamp();
		// $dataLineTimestamp = $dataLineTimestamp + 86400 + 86400 + 86400;

		//check if receipt date bigger than invoice date
		// if( $dtRecTimeStamp < $dataLineTimestamp){
			// $response["errors"] = true;
			// $response["type"] = "query";
			// $response["data_superior"] = "FATS013B";
			// $response["dataUltima"] = $dtLine->format('d/m/Y');
			// $response["message"] = "Data superior à data do documento.";
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			// die(json_encode($response));
		// }
		//--------------------------------------------------------------------
		
		//get Remaining values to use in calculations
		$totalFatura = $totalDocumento;
		$totalPagavelOrig = $totalDocumento - $totalLiquidadoDocumento;
		if($totalPagavelOrig > 0){
			$ivaRestante = ($totalPagavelOrig * $ivaDocumento) / $totalFatura;
			$retencaoRestante = ($totalPagavelOrig * $retencaoDocumento) / $totalFatura; 
		}else{
			$ivaRestante = 0;
			$retencaoRestante = 0;
		}

		$ivaRestante = round($ivaRestante,$numDecimais);
		$retencaoRestante = round($retencaoRestante,$numDecimais);
		
		$totalPagavel = $totalPagavelOrig - $retencaoRestante;

		if($totalPagavel > 0){
			//calculate values for this field
			$ivaPagamento = ($linha['valor_pagar'] * $ivaRestante) / $totalPagavel;
			$retencao = ($linha['valor_pagar'] * $retencaoRestante) / $totalPagavel;
		}else{
			$ivaPagamento = 0;
			$retencao = 0;
		}
		
		$ivaPagamento = round($ivaPagamento,$numDecimais);
		$retencao = round($retencao,$numDecimais);

		$creditAmount = ($linha['valor_pagar'] + $retencao) - $ivaPagamento;
		$totalPagamento = $linha['valor_pagar'];

		//validate payment totals
		$totalPagamento_tmp = round($totalPagamento,$numDecimais);
		$totalPagavel_tmp = round($totalPagavel,$numDecimais);
		// var_dump('totalPagamento - '.$totalPagamento);
		// var_dump('totalPagavel - '.$totalPagavel);
		// var_dump('totalPagamento_tmp - '.$totalPagamento_tmp);
		// var_dump('totalPagavel_tmp - '.$totalPagavel_tmp);
		if( $totalPagamento_tmp > $totalPagavel_tmp){ 
			// $response["errors"] = true;
			// $response["type"] = "FATS014";
			// $response["message"] = "Valor inserido superior ao valor pagável!";
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			// die(json_encode($response));
		}elseif( $totalPagamento_tmp == $totalPagavel_tmp ){
			$totalPagamento = $totalPagavel;
		}
		// var_dump('totalPagamento2 - '.$totalPagamento);

		//TOTALS RECIBO
		$TaxPayable = $TaxPayable + $ivaPagamento;
		$NetTotal = $NetTotal + $creditAmount;
		$GrossTotal = $GrossTotal + $linha['valor_pagar'];
		$GrossTotalRecebido = $GrossTotalRecebido + $linha['valor_pagar'];
		$ValorRetencao = $ValorRetencao + $retencao;

		//process last fields
		$documentNumber = $tipoDocumento.' '.$serieDocumento.'/'.$numberDocumento;
		$documentDate = $dataDocumento;

		//INSERT INTO DB -----------------------------------------------------
		$query = "INSERT INTO faturacao_recibos_linhas (ID_Recibo, NumeroLinha, ID_Documento, TipoDocumento, OriginatingOn, InvoiceDate, DebitAmount, CreditAmount, ValorRetencao, valorIVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddsssssss", $idRecibo, $numLinha, $linha['id_documento'], $linha['tipo'], $documentNumber, $documentDate, $debitAmount, $creditAmount, $retencao, $ivaPagamento );
			$result = $stmt -> execute();
			$idLinhaRecibo = $stmt->insert_id;
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS015";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS016";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
		
		//UPDATE DOCUMENT ----------------------------------------------------
		$valorPagavelDocumento = $totalDocumento - $totalLiquidadoDocumento;
		$totLiquidadoDoc = $totalPagamento + $retencao;

		//calculate total extra money
		$totalExtra = $totalPagamento - $valorPagavelDocumento;
		$totalExtra = round($totalExtra,$numDecimais);

		//round totals
		$valorPagavelDocumento = round($valorPagavelDocumento,$numDecimais);
		$totLiquidadoDoc = round($totLiquidadoDoc,$numDecimais);

		$estadoProcDoc = 'Aberto';
		if( $totLiquidadoDoc > $valorPagavelDocumento ){
			// $response["errors"] = true;
			// $response["type"] = "FATS016A";
			// $response["message"] = "Valor inserido superior ao valor pagável!";
			// deleteRecord($idRecibo);
			// 	resetDocumentPaymentTotals($idFatura, $typeDoc);
			// die(json_encode($response));
			
			$estadoProcDoc = 'Pago';
		}else if($totLiquidadoDoc == $valorPagavelDocumento){
			$estadoProcDoc = 'Pago';
		}

		//update document totals
		if( $estadoProcDoc == 'Pago' ) $totLiquidadoSUM = $totalDocumento;
		else $totLiquidadoSUM = $totalPagamento + $retencao + $totalLiquidadoDocumento;
		// $totLiquidadoSUM = round($totLiquidadoSUM,2);

		//udate origin document
		if ($stmt = $sqli_connection -> prepare($queryUpdate)) {
			// if( $linha['tipo'] == 'ND' ) $stmt -> bind_param("sssd", $totLiquidadoSUM, $totLiquidadoSUM, $estadoProcDoc, $linha['id_documento']);
			// else $stmt -> bind_param("ssd", $totLiquidadoSUM, $estadoProcDoc, $linha['id_documento']);
			$stmt -> bind_param("ssssd", $totLiquidadoSUM, $totLiquidadoSUM, $estadoProcDoc, $totalExtra, $linha['id_documento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS017";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS018";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
		
		//UPDATE DB ROW ------------------------------------------------------
		$query = "UPDATE faturacao_recibos_linhas SET TotalExtraRecebido = ? WHERE ID_Linha=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sd", $totalExtra, $idLinhaRecibo );
			$result = $stmt -> execute();
			$idLinhaRecibo = $stmt->insert_id;
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS015";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS016";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------

		$numLinha++;
	}
	//------------------------------------------------------------------------

	//UPDATE TOTALS RECEIPT AND STORE PAYMENTS LINES -------------------------
	//TOTALS RECIBO
	// $TaxPayable = $TaxPayable + $ivaPagamento;
	// $NetTotal = $NetTotal + $creditAmount;
	// $GrossTotal_Rec = round($GrossTotal,2);
	$GrossTotal_Rec = $GrossTotal;
	$GrossTotalRecebido_Rec = round($GrossTotalRecebido,$numDecimais);
	// $ValorRetencao_Rec = round($ValorRetencao,2);
	$ValorRetencao_Rec = $ValorRetencao;

	//get payment mechanism 
	$query = "SELECT Codigo FROM faturacao_metodos_pagamento WHERE ID_Metodo = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $pagamento_recibo);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS007";
			$response["message"] = $stmt -> error;
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$stmt -> bind_result($mechanism);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS008";
		$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
		die(json_encode($response));
	}

	//insert into receipt payments lines
	$query = "INSERT INTO faturacao_recibos_pagamentos (ID_Recibo, PaymentMechanism, PaymentAmount, PaymentDate, ID_Metodo, ID_Banco) 
		VALUES (?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dsssdd", $idRecibo, $mechanism, $GrossTotalRecebido_Rec, $transactiondate, $pagamento_recibo, $bancoFinalID );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS019";
			$response["message"] = $stmt -> error;
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS020";
		$response["message"] = $sqli_connection -> error;
		// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
		die(json_encode($response));
	}

	//update receipt totals
	$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_recibos WHERE ID_Serie=".intval($serie_recibo).";";
	$maxID = getMaxNumberDocument($queryStmt);
	$initNumber = getInitNumber("NumeroInicial_RG","faturacao_series", "WHERE ID_Serie=?", $serie_recibo);
	if($nextID < $initNumber && $maxID < 1){
		$query = "UPDATE faturacao_recibos SET Numero=".$initNumber.", ID_Serie=?, TaxPayable=?, NetTotal=?, GrossTotal=?, TotalRecebido=?, ValorRetencao=? WHERE ID_Recibo=?";
	}else{
		$query = "UPDATE faturacao_recibos SET Numero=((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_recibos WHERE ID_Serie=?) AS SubNumeroMax) + 1), TaxPayable=?, NetTotal=?, GrossTotal=?, TotalRecebido=?, ValorRetencao=? WHERE ID_Recibo=?";
	}
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dsssssd", $serie_recibo, $TaxPayable, $NetTotal, $GrossTotal_Rec, $GrossTotalRecebido_Rec, $ValorRetencao_Rec, $idRecibo);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS021";
			$response["message"] = $stmt -> error;
			// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS022";
		$response["message"] = $sqli_connection -> error;
		// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
		die(json_encode($response));
	}

	//------------------------------------------------------------------------

	//UPDATES TOTALS ---------------------------------------------------------
	// $totalLiquidado = $liquidadoTotalFatura + $GrossTotal + $ValorRetencao;
	// $totalLiquidado_tmp = round($totalLiquidado,2);
	// $totalPagarFatura_tmp = round($totalPagarFatura,2);

	//GET SUM FROM tables
	// $query = "SELECT SUM(TotalLiquidado) FROM faturacao_notas_debito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
	// if ($stmt = $sqli_connection -> prepare($query)) {
	// 	$stmt -> bind_param("ds", $idFatura, $typeDoc );
	// 	$result = $stmt -> execute();
	// 	if (false === $result) {
	// 		$response["errors"] = true;
	// 		$response["type"] = "FATS022A";
	// 		$response["message"] = $stmt -> error;
	// 		// deleteRecord($idRecibo);
	// 		// resetDocumentPaymentTotals($idFatura, $typeDoc);
	// 		die(json_encode($response));
	// 	}
	// 	$stmt -> bind_result($totLiqND_DocOrigin);
	// 	$stmt -> fetch();
	// 	$stmt -> close();
	// } else {
	// 	$response["errors"] = true;
	// 	$response["type"] = "FATS022B";
	// 	$response["message"] = $sqli_connection -> error;
	// 		// deleteRecord($idRecibo);
	// 		// resetDocumentPaymentTotals($idFatura, $typeDoc);
	// 	die(json_encode($response));
	// }
	// //GET SUM FROM tables
	// $query = "SELECT SUM(TotalLiquidadoDocumento) FROM ".$tableName." WHERE ".$fieldIdName."=?";
	// if ($stmt = $sqli_connection -> prepare($query)) {
	// 	$stmt -> bind_param("d", $idFatura );
	// 	$result = $stmt -> execute();
	// 	if (false === $result) {
	// 		$response["errors"] = true;
	// 		$response["type"] = "FATS022C";
	// 		$response["message"] = $stmt -> error;
	// 		// deleteRecord($idRecibo);
	// 		// resetDocumentPaymentTotals($idFatura, $typeDoc);
	// 		die(json_encode($response));
	// 	}
	// 	$stmt -> bind_result($totDocLiq_DocOrigin);
	// 	$stmt -> fetch();
	// 	$stmt -> close();
	// } else {
	// 	$response["errors"] = true;
	// 	$response["type"] = "FATS022D";
	// 	$response["message"] = $sqli_connection -> error;
	// 		// deleteRecord($idRecibo);
	// 		// resetDocumentPaymentTotals($idFatura, $typeDoc);
	// 	die(json_encode($response));
	// }

	// $totalLiquidado = $totLiqND_DocOrigin + $totDocLiq_DocOrigin;
	// $totalLiquidado_tmp = round($totalLiquidado,2);
	// $totalPagarFatura_tmp = round($totalPagarFatura,2);

	// $estadoProcessed = 'Aberto';
	// if( $totalLiquidado_tmp > $totalPagarFatura_tmp){
	// 	$response["errors"] = true;
	// 	$response["type"] = "query";
	// 	$response["valor"] = $totalLiquidado_tmp;
	// 	$response["valor2"] = $totalPagarFatura_tmp;
	// 	$response["line"] = "FATS023";
	// 	$response["message"] = "Valores superiores ao Total Payable!";
	// 	// deleteRecord($idRecibo);
	// 			// resetDocumentPaymentTotals($idFatura, $typeDoc);
	// 	die(json_encode($response));
	// }else if($totalLiquidado_tmp == $totalPagarFatura_tmp){
	// 	$estadoProcessed = 'Pago';
	// }else{
	// 	$estadoProcessed = 'Aberto';
	// }

	// $query = "UPDATE ".$tableName." SET TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
	// if ($stmt = $sqli_connection -> prepare($query)) {
	// 	$stmt -> bind_param("ssd", $totalLiquidado, $estadoProcessed, $idFatura);
	// 	$result = $stmt -> execute();
	// 	if (false === $result) {
	// 		$response["errors"] = true;
	// 		$response["type"] = "query";
	// 		$response["line"] = "FATS024";
	// 		$response["message"] = $stmt -> error;
	// 		// deleteRecord($idRecibo);
	// 			// resetDocumentPaymentTotals($idFatura, $typeDoc);
	// 		die(json_encode($response));
	// 	}
	// 	$stmt -> close();
	// } else {
	// 	$response["errors"] = true;
	// 	$response["type"] = "query";
	// 	$response["line"] = "FATS025";
	// 	$response["message"] = $sqli_connection -> error;
	// 	// deleteRecord($idRecibo);
	// 			// resetDocumentPaymentTotals($idFatura, $typeDoc);
	// 	die(json_encode($response));
	// }
	//------------------------------------------------------------------------

	//BLOCK BANK ----------------------------------------------------------
	$query = "UPDATE faturacao_bancos SET Usado=1 WHERE ID_Banco=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $bancoFinalID);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA001";
			$response["message"] = $stmt -> error;
			// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA002";
		$response["message"] = $sqli_connection -> error;
		// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//------------------------------------------------------------------------
	//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
	//------------------------------------------------------------------------
	$totalPVP = $GrossTotal_Rec;
	$totalUnit = $NetTotal;
	$totalTVA = $TaxPayable;
	//GET DETAILS
	$query = "SELECT PlanoContas, PlanoContasBanco, CustomerID, 
				(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS Cliente, CONCAT('FA ',(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',faturacao_faturas.Numero) AS DocumentoOrigem
			FROM faturacao_faturas WHERE ID_Fatura=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS026";
			$response["message"] = $stmt -> error;
			// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$stmt -> bind_result($planoCliente, $planoBanco, $numCliente, $nomeCliente, $RefDocOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS027";
		$response["message"] = $sqli_connection -> error;
		// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
		die(json_encode($response));
	}
	//GET DETAILS RECEIPT
	$query = "SELECT (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_recibos.ID_Serie) AS Serie, Numero
			FROM faturacao_recibos WHERE ID_Recibo=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idRecibo);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS028";
			$response["message"] = $stmt -> error;
			// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$stmt -> bind_result($serieRecib, $numRecib );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS029";
		$response["message"] = $sqli_connection -> error;
		// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
		die(json_encode($response));
	}

	//PROCESS MOVEMENT FOR DOCUMENT
	$texto = 'Paiement - '.$serieRecib.'/'.$numRecib.' - '.$RefDocOrigem.' - '.$numCliente.' - '.$nomeCliente;
	/*if($planoCliente > 0){
		$tipoMovimento = 'C';
		insertMovimentoContabilistico($planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento);
	}*/

	//PROCESS MOVEMENT FOR DOCUMENT
	if($planoBanco > 0){
		$query = "SELECT 
				(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_faturas.ID_Banco) AS Banco
			FROM faturacao_faturas WHERE ID_Fatura=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idFatura);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS030";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> bind_result($nomeBanco);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS031";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		//MOVEMENT
		$textoBanco = $texto.' - Banque: '.$nomeBanco;
		$tipoMovimentoBanco = 'D';
		// insertMovimentoContabilistico($planoBanco, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
		// insertMovimentoContabilistico($planoBanco, $planoCliente, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
		insertMovimentoContabilisticoManual($planoBanco, $planoCliente, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco, $data_recibo);
	} else {
		$tipoMovimento = 'D';
		// insertMovimentoContabilistico('', $planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento);
		insertMovimentoContabilisticoManual('', $planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento, $data_recibo);
	}
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------


	//log sistema - processo
	$descricao_log ="Paiement de facture (id: ".$idFatura.", valeur: ".number_format($GrossTotal, 2, '.', '\'' )." CHF)";
	insert_log(0,"Inserir",$descricao_log,$sqli_connection);

	// Save all querys on DB
	$sqli_connection->commit();

} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["fatura"] = $idFatura;
$response["errors"] = false;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_recibos WHERE ID_Recibo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_recibos_linhas WHERE ID_Recibo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//PAGAMENTOS
	$query = "DELETE FROM faturacao_recibos_pagamentos WHERE ID_Recibo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
	

	
}
?>