<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "Tous"]],
		"aaSorting" : [[0, "asc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/artigos_categorias.php",
		"oLanguage" : {
			"sLengthMenu" : "Show _MENU_ enregistrements par page",
			"sZeroRecords" : "Sans enregistrements",
			"sInfo" : "_START_ a _END_ de _TOTAL_ enregistrements",
			"sInfoEmpty" : " 0 a 0 de 0 enregistrements",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "Suivant",
				"sFirst" : "Premier",
				"sPrevious" : "Précédent",
				"sLast" : "Dernier"
			}
		},
		"aoColumns" : [null, null,null, 
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		}],
		"aoColumnDefs" : [
		{
			"aTargets" : [0],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[0].length > 80) element = full[0].substr(0,80)+"...";
				else element = full[0];
				//return html
				return element;
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[2] == 1){
					element = '&nbsp;<i class="fa fa-check text-green" title="Ativada"></i>&nbsp; Ativada';
				}else{
					element = '&nbsp;<i class="fa fa-ban text-yellow" title="Desativada"></i>&nbsp; Desativada';
				}
				return element;
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				var processedName = full[0].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'" + processedName + "'";
				var html = '';

				//state options
				if(full[2] == 1){
					html += '<a onClick="alterState('+full[3]+')" class="options-link text-violet" title="Désactiver"><i class="fa fa-ban"></i></a>';
				}else{
					html += '<a onClick="alterState('+full[3]+')" class="options-link text-green" title="Activer"><i class="fa fa-check-square-o"></i></a>';
				}
				//edition options
				if( full[1] > 0 ){
					html += '<span class="text-gray" style="margin: 4px;"><i class="fa fa-edit"></i></span>';
					html += '<span class="text-gray" style="margin: 4px;"><i class="fa fa-trash"></i></span>';
				}else{
					html += '<a onclick="editarCategoria('+ full[3] +')" class="options-link text-orange"><i class="fa fa-edit" title="Modifier"></i></a>';
					html += '<a class="options-link text-red" onclick="eliminarCategoria('+ full[3] +', '+nome+')" title="Supprimer"><i class="fa fa-trash"></i></a>';
				}

				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[3]);

			return nRow;
		}
	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> Rechercher</button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------

	/**
	 * Edit Category
	 * @param  idCategoria
	 * @return modal
	 */
	function editarCategoria(idCategoria){
		//get Details
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/artigos/categorias_detalhes.php',
			data : {
				idCategoria : idCategoria
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[TC001] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					$("input").attr("disabled", true);
					$("select").attr("disabled", true);
					$(".submit_button").attr("disabled", true);
					$("input:radio").iCheck("disable");

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[TC002] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						$("input").attr("disabled", true);
						$("select").attr("disabled", true);
						$(".submit_button").attr("disabled", true);
						$("input:radio").iCheck("disable");
					} else {
						if (resposta.data != null) {
							var categoria = resposta.data;
							//fill the modal info
							$('#ModalEdit_ID_categoria').val(idCategoria);
							$('#ModalEdit_nome_categoria').val(categoria.Nome);
						} else {
							//fill the modal info
							$('#ModalEdit_ID_categoria').val('-');
							$('#ModalEdit_nome_categoria').val('-');
						}
					}
				}
			},
			complete : function() {}
		});
		//open modal				
		$('#modal-categoria-edit').modal('show');
	}

	//change Prédéfini
	function alterState(idCategoria){
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/artigos/categorias_estado.php',
			dataType : 'json',
			data : {
				idCategoria : idCategoria
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] Une erreur s'est produite. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] Une erreur s'est produite. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("Categoria atualizada com sucesso.", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				location.reload();
			}
		});
	}

	//change Prédéfini
	function eliminarCategoria(idCategoria, nome){
		if (confirm("Êtes-vous sûr de vouloir supprimer la catégorie \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/artigos/categorias_apagar.php',
				dataType : 'json',
				data : {
					idCategoria : idCategoria
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] Não é possivel remover esta categoria. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] Não é possivel remover esta categoria. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("Categoria removida com sucesso.", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					setTimeout(function() {
						location.reload();
					}, 1000);
				}
			});
		} else { return false; }
	}
</script>