<script type="text/javascript">
	/**
	 * Fill clientes
	 * @param  {Number} lastID [description]
	 * @return {[type]}        [description]
	 */
	function fill_clientes(lastID = 0, blockResume = false, dadosObj = null) {
		var options = $("select#cliente_guia");
		// $(options).empty();

		$(".fullscreen").show();

		//prepare select
		$(options).attr("disabled", false);

		if(lastID != 0) $(options).append($("<option />").val(lastID).html(dadosObj).attr('selected', 'selected'));
		
		//init select2
		$('#cliente_guia').select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- Client --",
			allowClear: true,
			// minimumInputLength: 2,
			templateResult: clientesTemplate,
			templateSelection: clientesTemplateLabel,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 2, //search term
						search_term: params.term, //search term
						search_idcliente: lastID, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results:$.map(data.results,function(val,i){
							var textLabel = val.Codigo+' - '+val.Nome;
							return{id:val.ID_Cliente,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		});

		if(lastID != 0) $(options).val(lastID);
		if(lastID != 0) getClientDetails(lastID, 0, blockResume);

        $(".fullscreen").fadeOut();
	}

	/**
	 * Fill clientes
	 * @param  {Number} lastID [description]
	 * @return {[type]}        [description]
	 */
	function getClientDetails(idCliente, dismissFields = 0, blockResume = false) {
		$("#nif_cliente_guia").val('');
		$("#endereco_cliente_guia").val('');
		$("#codigopostal_cliente_guia").val('');
		$("#regiao_cliente_guia").val('');
		$("#cidade_cliente_guia").val('');
		$("#pais_cliente_guia").val('');
		if( dismissFields == 0 ){
			//descarga address
			$("#endereco_descarga_guia").val('');
			$("#codigopostal_descarga_guia").val('');
			$("#regiao_descarga_guia").val('');
			$("#cidade_descarga_guia").val('');
			$("#pais_descarga_guia").val('');
		}
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/guias-transporte.php',
			dataType : 'json',
			data : { 
				opcao: 2,
				idCliente: idCliente
			},
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
						} else {
							var dados = resposta.data;
							$("#nif_cliente_guia").val(dados.Nif);
							$("#endereco_cliente_guia").val(dados.Endereco);
							$("#codigopostal_cliente_guia").val(dados.CodigoPostal);
							$("#regiao_cliente_guia").val(dados.Regiao);
							$("#cidade_cliente_guia").val(dados.Cidade);
							$("#pais_cliente_guia").val(dados.Pais);
							if( dismissFields == 0 ){
								$("#vencimento_guia").val(dados.Vencimento);
								$("#vencimento_guia").trigger('change');
								$("#desconto_guia").autoNumeric('set', dados.Desconto);
								//descarga address
								$("#endereco_descarga_guia").val(dados.Endereco);
								$("#codigopostal_descarga_guia").val(dados.CodigoPostal);
								$("#regiao_descarga_guia").val(dados.Regiao);
								
								var npaInput = dados.CodigoPostal;
								
								if( dados.Pais_Small != 'CH'){ 
									$("#selectCidadeWrapper2").hide(); 
									$("#cidade_descarga_guia_estrang").show(); 
									
									$("#cidade_descarga_guia_estrang").val(dados.Cidade); 
									$("select#cidade_descarga_guia").empty();
									$("select#cidade_descarga_guia").trigger('change');
								}
								else { 
									$("#cidade_descarga_guia_estrang").hide(); 
									$("#selectCidadeWrapper2").show(); 
									getLocaliteFromNpa(npaInput, 'cidade_descarga_guia');
								}

								$("#pais_descarga_guia").val(dados.Pais_Small);
								$("#pais_descarga_guia").trigger('change');


								calculateDataValidade();
								$('#pagamento_guia').val(dados.MetPagamento);
								$("#pagamento_guia").trigger('change');
								var needBank = Number( $('option:selected', $('#pagamento_guia') ).attr('data-bank') );
								if(needBank == 1){
									precisaBanco = 1;
									$('#banco_select_guia').show();
								}else{
									precisaBanco = 0;
									$('#banco_select_guia').hide();
								}
							}
							calculateDataValidade();

							// block retencao if nif == 999999990
							if( $("#nif_cliente_guia").val() == '999999990' ){
								$(".lineInputRetencao").prop('disabled', true);
								$(".lineInputRetencao").autoNumeric('set',0);

								if( dismissFields == 0 ){
									//recalculate all
									$(".lineInputRetencao").each(function() {
										var lineID = $(this).attr('data-id-line');
										calculaLinha(lineID,blockResume);
									});
								}
							}
							else {
								if( dismissFields == 0 ){
									$(".lineInputRetencao").each(function() {
										var lineID = $(this).attr('data-id-line');
										// var articleID = $("select#codigo_linha_"+lineID).val();
										// if( articleID < 1) $(".lineInputRetencao").prop('disabled', true);
										// else $(".lineInputRetencao").prop('disabled', false);
										//recalculate all
										calculaLinha(lineID,blockResume);
									});
								}
							}
							if(!blockResume) calculateDataValidade();
						}
					}
				}
			},
			complete : function() {	}
		});
	}

	/**
	 * Fill series
	 * @param  {Number} lastID [description]
	 * @return {[type]}        [description]
	 */
	function fill_series(lastID = 0, blockResume = false) {
		var options = $("select#serie_guia");

		if(sessionStorage.getItem("series") === null){
			$(options).empty();
			var id_predefinida = 0;

			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/guias-transporte.php',
				dataType : 'json',
				data : { 
					opcao: 3
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null) {
								$(options).attr("disabled", true);

							} else {
								$(options).attr("disabled", false);

								$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

								$.each(resposta.data, function() {
									$(options).append($("<option />").val(this.ID_Serie).html(this.Nome));
									if(this.Predefinida > 0) id_predefinida = this.ID_Serie;
								});
							}
						}
					}
				},
				complete : function() {
					if(lastID != 0) $(options).val(lastID);
					else if(id_predefinida > 0) $(options).val(id_predefinida);
					else $(options).val($("select#serie_guia option:eq(1)").val());
					
					//init select2
					$(options).select2({
						escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "Sélectionnez",
					});

					//get the client details
					getNextNumber();
				}
			});
		}else{
			$(".fullscreen").show();

			if(lastID != 0) $(options).val(lastID);

			$(options).trigger('change');

			//get the client details
			getNextNumber();

	        $(".fullscreen").fadeOut();
		}
	}

	/**
	 * Get the next number for this serie
	 * @return next number to input
	 */
	function getNextNumber(){
		var idSerie = $("select#serie_guia").val();
		$('#numero_guia').val('...');

		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/guias-transporte.php',
			dataType : 'json',
			data : { 
				opcao: 4,
				idSerie: idSerie
			},
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							var dados = resposta.data;
							$('#numero_guia').val(dados.NextID);
						}
					}
				}
			},
			complete : function() {}
		});
	}

	/**
	 * Fill Pagamentos
	 * @return list
	 */
	function fill_pagamentos(lastID = 0, bankID = 0) {
		var options = $("select#pagamento_guia");
		// $(options).empty();
		var defaultID = 0;

		if(sessionStorage.getItem("payment_types") === null){
			$(options).empty();
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/guia-transporte.php',
				dataType : 'json',
				data : { 
					opcao: 11
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null) {
								$(options).attr("disabled", true);

							} else {
								$(options).attr("disabled", false);

								$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));
								
								//storing in session
								sessionStorage.setItem('payment_types', true );

								$.each(resposta.data, function() {
									if( this.Predefinido > 0 ) defaultID = this.ID_Metodo;
									$(options).append($("<option />").val(this.ID_Metodo).html(this.Nome).attr('data-bank', this.Banco));
								});
							}
						}
					}
				},
				complete : function() {
					if(lastID != 0) $(options).val(lastID);
					else if(defaultID > 0) $(options).val(defaultID);
					else $(options).val($("select#pagamento_guia option:eq(1)").val());
					
					//init select2
					$(options).select2({
						escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "Sélectionnez",
					});

					//call the banks
					fill_bancos(bankID);
				}
			});
		}else{
			$(".fullscreen").show();

			if(lastID != 0) $(options).val(lastID);

			$(options).trigger('change');

			//call the banks
			fill_bancos(bankID);

	        $(".fullscreen").fadeOut();
		}
	}

	/**
	 * Fill Morada Carga
	 * @return list
	 */
	function fill_morada_carga() {
		//carga address
		$("#endereco_carga_guia").val('');
		$("#codigopostal_carga_guia").val('');
		$("#regiao_carga_guia").val('');
		$("#cidade_carga_guia").val('');
		// $("#pais_carga_guia").val('');
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/guias-transporte.php',
			dataType : 'json',
			data : { 
				opcao: 13
			},
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
						} else {
							var dados = resposta.data;

							//carga address
							$("#endereco_carga_guia").val(dados.Endereco);
							$("#codigopostal_carga_guia").val(dados.CodigoPostal);
							// $("#regiao_carga_guia").val(dados.Regiao);
							$("#cidade_carga_guia").val(dados.Cidade);
							// $("#pais_carga_guia").val(dados.Pais_Small);
							// $("#pais_carga_guia").trigger('change');

							getLocaliteFromNpa(dados.CodigoPostal, 'cidade_carga_guia');
						}
					}
				}
			},
			complete : function() {
			}
		});
	}
	
	/**
	 * Fill Bancos
	 * @return list
	 */
	function fill_bancos(lastID = 0) {
		var options = $("select#banco_guia");
		// $(options).empty();
		var defaultID = 0;

		if(sessionStorage.getItem("banks") === null){
			$(options).empty();
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/guia-transporte.php',
				dataType : 'json',
				data : { 
					opcao: 12
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null) {
								$(options).attr("disabled", true);

							} else {
								$(options).attr("disabled", false);

								$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

								//storing in session
								sessionStorage.setItem('banks', true );

								$.each(resposta.data, function() {
									if( this.Predefinido > 0 ) defaultID = this.ID_Banco;
									$(options).append($("<option />").val(this.ID_Banco).html(this.Nome));
								});
							}
						}
					}
				},
				complete : function() {
					if(lastID != 0) $(options).val(lastID);
					else if(defaultID > 0) $(options).val(defaultID);
					else $(options).val($("select#banco_guia option:eq(1)").val());
					
					//init select2
					$(options).select2({
						escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "Sélectionnez",
					});

					//active the select or not
					var needBank = Number( $('option:selected', $("select#pagamento_guia") ).attr('data-bank') );
					if(needBank == 1){
						precisaBanco = 1;
						$('#banco_select_guia').show();
					}else{
						precisaBanco = 0;
						$('#banco_select_guia').hide();
					}
				}
			});
		}else{
			$(".fullscreen").show();
			
			if(lastID != 0) $(options).val(lastID);

			$(options).trigger('change');

			//active the select or not
			var needBank = Number( $('option:selected', $("select#pagamento_guia") ).attr('data-bank') );
			if(needBank == 1){
				precisaBanco = 1;
				$('#banco_select_guia').show();
			}else{
				precisaBanco = 0;
				$('#banco_select_guia').hide();
			}

	        $(".fullscreen").fadeOut();
		}
	}

	/**
	 * Fill Moedas
	 * @return list
	 */
	function fill_moedas(lastID = 0) {
		var options = $("select#moeda_guia");
		// $(options).empty();
		var defaultID = 0;

		if(sessionStorage.getItem("coins") === null){
			$(options).empty();
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/guias-transporte.php',
				dataType : 'json',
				data : { 
					opcao: 5
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null) {
								$(options).attr("disabled", true);

							} else {
								$(options).attr("disabled", false);

								$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

								//storing in session
								sessionStorage.setItem('coins', true);

								$.each(resposta.data, function() {
									if( this.Predefinido > 0 ) defaultID = this.ID_Moeda;
									$(options).append($("<option />").val(this.ID_Moeda).html(this.Nome).attr('data-simbolo', this.Simbolo).attr('data-iso', this.ISO));
								});
							}
						}
					}
				},
				complete : function() {
					if(lastID != 0) $(options).val(lastID);
					else if(defaultID > 0) $(options).val(defaultID);
					else $(options).val($("select#moeda_guia option:eq(1)").val());
					
					//init select2
					$(options).select2({
						escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "Sélectionnez",
					});
				}
			});
		}else{
			$(".fullscreen").show();

			if(lastID != 0) $(options).val(lastID);

			$(options).trigger('change');

	        $(".fullscreen").fadeOut();
		}
	}

	/**
	 * Change article
	 * @param  lineID
	 */
	function changeArticle(lineID){
		//get article data
		var articleID = $("select#codigo_linha_"+lineID).val();
		if( articleID < 1){
			$("#descricao_linha_"+lineID).val('');
			$("#qtd_linha_"+lineID).autoNumeric('set', 0);
			$("#unidade_linha_"+lineID).html('UN');
			$("#preco_linha_"+lineID).autoNumeric('set', 0);
			$("#desc_linha_"+lineID).autoNumeric('set', 0);
			$("#retencao_linha_"+lineID).autoNumeric('set', 0);
			$("#total_linha_"+lineID).autoNumeric('set', 0);
			//disable Fields
			$("#descricao_linha_"+lineID).prop('disabled', true);
			$("#qtd_linha_"+lineID).prop('disabled', true);
			$("#preco_linha_"+lineID).prop('disabled', true);
			$("#desc_linha_"+lineID).prop('disabled', true);
			$("#retencao_linha_"+lineID).prop('disabled', true);
			// $("#iva_linha_"+lineID).prop('disabled', true);
			// $("#iva_linha_"+lineID).trigger('change');
			// $("#motivo_linha_"+lineID).prop('disabled', true);
			
			//taxes calculation
			calculateTaxesLines();
			//update document totals
			updateDocumentTotals();
		}else{
			//disable Fields
			$("#descricao_linha_"+lineID).prop('disabled', false);
			$("#qtd_linha_"+lineID).prop('disabled', false);
			$("#preco_linha_"+lineID).prop('disabled', false);
			$("#desc_linha_"+lineID).prop('disabled', false);
			$("#retencao_linha_"+lineID).prop('disabled', false);
			// $("#iva_linha_"+lineID).prop('disabled', false);
			// $("#iva_linha_"+lineID).trigger('change');
			// $("#motivo_linha_"+lineID).prop('disabled', false);
			
			// block retencao if nif == 999999990
			if( $("#nif_cliente_guia").val() == '999999990') $("#retencao_linha_"+lineID).prop('disabled', true);
			else $("#retencao_linha_"+lineID).prop('disabled', false);

			//get data
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/guias-transporte.php',
				dataType : 'json',
				data : { 
					opcao: 9,
					articleID : articleID
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] Une erreur s'est produite dans la ligne de l'article. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] Une erreur s'est produite dans la ligne de l'article. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null){} 
							else {
								var dados = resposta.data;
								// console.log(dados);
								//processing fields
								$("#descricao_linha_"+lineID).val(dados.Nome);
								$("#qtd_linha_"+lineID).autoNumeric('set', 1);
								$("#unidade_linha_"+lineID).html(dados.Sigla);
								$("#preco_linha_"+lineID).autoNumeric('set', dados.Preco);
								if(dados.ID_Imposto > 0){
									$("#iva_linha_"+lineID).val(dados.ID_Imposto);
									$("#iva_linha_"+lineID).trigger('change');
								}
								$("#desc_linha_"+lineID).autoNumeric('set', 0);

								// block retencao if nif == 999999990
								if( $("#nif_cliente_guia").val() == '999999990') $("#retencao_linha_"+lineID).autoNumeric('set', 0);
								else $("#retencao_linha_"+lineID).autoNumeric('set', dados.Retencao);

								//block Rétention or not
								if(dados.Tipo == 'S'){
									$("#retencao_linha_"+lineID).prop('disabled', false);
								}else{
									$("#retencao_linha_"+lineID).autoNumeric('set',0);
									$("#retencao_linha_"+lineID).prop('disabled', true);
								}

								var subclasse = $('option:selected', $("#iva_linha_"+lineID) ).attr('data-subclasse');
								changeTaxes(lineID, subclasse, true);

								//calculations
								calculaLinha(lineID);
							}
						}
					}
				},
				complete : function() {}
			});
		}		
	}

	/**
	 * Calculates values for the article line
	 * @param  lineID
	 * @return values calculated
	 */
	function calculaLinha(lineID, blockResume = false){
		$(".fullscreen").show();

		//process the retenções field
		var tipo = $('option:selected', $("select#codigo_linha_"+lineID) ).attr('data-tipo');
		// console.log('tipo: '+tipo);
		if(tipo != 'S' || $("#nif_cliente_guia").val() == '999999990' ){
			$("#retencao_linha_"+lineID).autoNumeric('set',0);
			$("#retencao_linha_"+lineID).prop('disabled', true);
			// console.log('bloqueado');
		}else{
			$("#retencao_linha_"+lineID).prop('disabled', false);
		}

		var qtd = Number( $("#qtd_linha_"+lineID).autoNumeric('get') );
		var preco = Number( $("#preco_linha_"+lineID).autoNumeric('get') );
		var iva = Number( $('option:selected', $("#iva_linha_"+lineID)).attr('data-valor') );
		iva = Number ( (iva * 0.01)+1 );
		var desconto = Number( $("#desc_linha_"+lineID).autoNumeric('get') );
		desconto = Number ( (desconto * 0.01) );
		var tmpRet = Number( $("#retencao_linha_"+lineID).autoNumeric('get') );
		var retencao = Number( (tmpRet * 0.01) );
		var total = 0;

		//desconto generico
		var desconto2 = $('#desconto_guia').autoNumeric('get');
		desconto2 = Number ( (desconto2 * 0.01) );

		//process line totals
		total = qtd * preco;
		total = total * iva;
		total = total - (total * desconto);
		total = total - (total * desconto2);
		// total = total - retencao;
		
		//calc retencao
		total2 = qtd * preco;
		total2 = total2 - (total2 * desconto);
		total2 = total2 - (total2 * desconto2);
		retencao = Number( total2 * retencao );

		$("#total_linha_"+lineID).autoNumeric('set', total);
		var totalProcessed = $("#total_linha_"+lineID).autoNumeric('get');

		//process field background color if negative numbers appear
		if( retencao > totalProcessed ) $("#total_linha_"+lineID).parent().addClass('bg-red').attr('data-status', 'invalid');
		else $("#total_linha_"+lineID).parent().removeClass('bg-red').attr('data-status', 'valid');

		//calculate taxes lines
		calculateTaxesLines();

		//update document totals
		if(!blockResume) updateDocumentTotals();

	    $(".fullscreen").fadeOut();
	}


	/**
	 * Function to add new line
	 * @return 
	 */
	function addArticleLine(articleID = 0, impostoID = 0, motivoID = 0, changeLineVals = 0, planoID = 0, blockResume = false, dadosObj = null){
		lastIdLine++;

		var htmlLine = '<tr class="articles_lines" id="line_'+lastIdLine+'">'+
							'<td style="width:100px; max-width:150px;">'+
								'<select data-id-line="'+lastIdLine+'" class="lineInputArtigo form-control select2 show-tick" data-live-search="true"  data-header="Sélectionnez" id="codigo_linha_'+lastIdLine+'" name="codigo_linha_'+lastIdLine+'" >'+
									'<option value="" data-hidden="true">Article</option>'+
								'</select>'+
							'</td>'+
							'<td>'+
								'<textarea data-id-line="'+lastIdLine+'" class="lineInputDescricao form-control" id="descricao_linha_'+lastIdLine+'" name="descricao_linha_'+lastIdLine+'" placeholder="..." rows="1"></textarea>'+
							'</td>'+
							'<td style="width:105px;">'+
								'<input type="text" data-id-line="'+lastIdLine+'" class="lineInputChange lineInputQTD form-control qtd" id="qtd_linha_'+lastIdLine+'" name="qtd_linha_'+lastIdLine+'" placeholder="0.00" style="width: <?php echo $qtdSizePerc; ?>; display: inline-block;" />'+
								' <span id="unidade_linha_'+lastIdLine+'" style="font-size: 10px; <?php echo $spanStyleOnly; ?>">UN</span>'+
							'</td>'+
							'<td style="width:100px;">'+
								'<input type="text" data-id-line="'+lastIdLine+'" class="lineInputChange lineInputPreco form-control moneyBig" id="preco_linha_'+lastIdLine+'" name="preco_linha_'+lastIdLine+'" placeholder="0.00 CHF" />'+
							'</td>'+
							'<td style="width:120px;">'+
								'<select data-id-line="'+lastIdLine+'" class="lineInputChange lineInputImposto form-control select2 show-tick" data-live-search="true"  data-header="Sélectionnez la taxe" id="iva_linha_'+lastIdLine+'" name="iva_linha_'+lastIdLine+'" >'+
									'<option value="" data-hidden="true">Taxe</option>'+
								'</select>'+
							'</td>'+
							// '<td style="width:120px;">'+
							// 	'<select data-id-line="'+lastIdLine+'" class="lineInputMotivo form-control select2 show-tick" data-live-search="true"  data-header="Sélectionnez Raison" id="motivo_linha_'+lastIdLine+'" name="motivo_linha_'+lastIdLine+'" disabled >'+
							// 		'<option value="" data-hidden="true">Motif</option>'+
							// 	'</select>'+
							// '</td>'+
							'<td style="width:80px;">'+
								'<input type="text" data-id-line="'+lastIdLine+'" class="lineInputChange lineInputDesconto form-control percentage" id="desc_linha_'+lastIdLine+'" name="desc_linha_'+lastIdLine+'" placeholder="0 %" />'+
							'</td>'+
							'<td style="width:80px;" class=" hide">'+
								'<input type="text" data-id-line="'+lastIdLine+'" class="lineInputChange lineInputRetencao form-control percentage" id="retencao_linha_'+lastIdLine+'" name="retencao_linha_'+lastIdLine+'" placeholder="0.00%" />'+
							'</td>'+
							'<td class="text-right" style="width:100px;">'+
								'<span id="total_linha_'+lastIdLine+'" style="display: block" class="money">0</span>'+
							'</td>'+
							'<td style="width:30px; text-align: center;">'+
								'<a class="options-link text-red" onclick="eliminarLinha('+lastIdLine+')" title="Remover Linha"><i class="fa fa-trash"></i></a>'+
							'</td>'+
						'</tr>';
		$('#tbody_artigos').append(htmlLine);

		//init line
		fill_articles(lastIdLine, articleID, changeLineVals, dadosObj);
		fill_ivas(lastIdLine, impostoID, motivoID);
		if(motivoID == 0) fill_motivos(lastIdLine, motivoID);

		//disable the fields of the lines
		$("#descricao_linha_"+lastIdLine).prop('disabled', true);
		$("#qtd_linha_"+lastIdLine).prop('disabled', true);
		$("#preco_linha_"+lastIdLine).prop('disabled', true);
		$("#desc_linha_"+lastIdLine).prop('disabled', true);
		$("#retencao_linha_"+lastIdLine).prop('disabled', true);

		linesListenersInit(lastIdLine);

		//to force line to init when add new article using modal
		if(changeLineVals != 0){
			changeArticle(lastIdLine);
		}

		valorLinhas++;
		update_resumeTable();
	}

	/**
	 * Fill the articles select
	 * @param  select id
	 * @return articles
	 */
	function fill_articles(lineID, articleID = 0, changeLineVals = 0, dadosObj = null){
		$(".fullscreen").show();
		var options = $("select#codigo_linha_"+lineID);
		// $(options).empty();
		var id_predefinido = 0;
				
		// console.log('entrou no else');

		if(dadosObj != null) {
			$(options).append($("<option />").val(articleID).text(dadosObj.codigo).attr('data-barcode', dadosObj.codigobarras).attr('data-tipo', dadosObj.Tipo).attr('selected', 'selected'));
		}

		$(options).select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- Article --",
			allowClear: true,
			// minimumInputLength: 2,
			templateResult: articlesTemplate,
			templateSelection: articlesTemplateLabel,
			// closeOnSelect: false,
			// selectOnClose: false,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 1, //search term
						search_term: params.term, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					//init vars
					var resultsReturn = data.results;
					var foundSearchResults = false;
					var selected = 0;

					//return results
					params.page = params.page || 1;
					// console.log('returned ', resultsReturn);
					return {
						results:$.map(resultsReturn,function(val,i){
							var textLabel = val.Codigo;
							return{id:i,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		}).on('select2:select', function (e) {
			// console.log('change event: ',e.params.data, $(this));
			var data = e.params.data;        
			// console.log( $(this).children('[value="'+data['id']+'"]') );
			$(this).children('[value="'+data['id']+'"]').attr('data-tipo', data["data"]["Tipo"]).attr('data-barcode', data["data"]["CodigoBarras"]);
		}).trigger('change');

		// if(changeLineVals != 0){
		// 	changeArticle(lineID);
		// }
		
		//auto init select
		// $('button[data-select2-id="codigo_linha_'+lineID+'"]').trigger('click');
		$('.lineInputArtigo').select2('close');
		// if(changeLineVals == 0) $('#codigo_linha_'+lineID).select2('open');

        $(".fullscreen").fadeOut();
	}

	/**
	 * Fill the ivas select
	 * @param  select id
	 * @return ivas
	 */
	function fill_ivas(lineID, impostoID = 0, motivoID = 0){
		var options = $("select#iva_linha_"+lineID);
		$(options).empty();
		var id_predefinido = 0;
		var defaultID = 0;
		var isento = 0;

		if(sessionStorage.getItem("taxes") === null){
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/guias-transporte.php',
				dataType : 'json',
				data : { 
					opcao: 7
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null) {
								$(options).attr("disabled", true);

							} else {
								$(options).attr("disabled", false);

								$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

								// $(options).append($("<option />").val(0).text('-- Imposto --'));
								$.each(resposta.data, function() {
									if( this.Predefinido > 0 ) defaultID = this.ID_Imposto;
									if( this.Predefinido > 0 && this.Subclasse == 'ISE' ) isento = 1;
									$(options).append( $("<option />").val(this.ID_Imposto).html(this.Nome+': '+this.Valor+'%').attr('data-subclasse', this.Subclasse).attr('data-valor', this.Valor) );
								});

								//storing in session
								sessionStorage.setItem('taxes', $(options).html() );
							}
						}
					}
				},
				complete : function() {
					if(impostoID != 0) $(options).val(impostoID);
					else if(defaultID > 0) $(options).val(defaultID);
					else $(options).val($("select#iva_linha_"+lineID+" option:eq(0)").val());
					
					//init select2
					$(options).select2({
						escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "Sélectionnez",
					});

					if(isento == 1) $("select#motivo_linha_"+lineID).prop('disabled', false);
					$("select#motivo_linha_"+lineID).trigger('change');

					if(motivoID != 0) {
						fill_motivos(lineID, motivoID);
					}
				}
			});
		}else{
			$(".fullscreen").show();

			// console.log('entrou no else');
			var dadosTaxes = sessionStorage.getItem('taxes');

			//prepare select
			$(options).attr("disabled", false);

			$(options).append(dadosTaxes);

			//prepare the select
			if(impostoID != 0) $(options).val(impostoID);
			else if(defaultID > 0) $(options).val(defaultID);
			else $(options).val($("select#iva_linha_"+lineID+" option:eq(0)").val());
					
			//init select2
			$(options).select2({
				escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "-- Taxe --",
			});

			isento = $("select#motivo_linha_"+lineID).attr('data-subclasse');
			if(isento == 1) $("select#motivo_linha_"+lineID).prop('disabled', false);
			$("select#motivo_linha_"+lineID).trigger('change');

			if(motivoID != 0) {
				fill_motivos(lineID, motivoID);
			}

	        $(".fullscreen").fadeOut();
		}
	}

	/**
	 * Fill the motivos isenção select
	 * @param  select id
	 * @return motivos isenção
	 */
	function fill_motivos(lineID, motivoID = 0){
		var options = $("select#motivo_linha_"+lineID);
		$(options).empty();
		var id_predefinido = 0;
		var defaultID = 0;
		var isento = 0;

		if(sessionStorage.getItem("motives") === null){
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/guias-transporte.php',
				dataType : 'json',
				data : { 
					opcao: 8
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null) {
								$(options).attr("disabled", true);

							} else {
								$(options).attr("disabled", false);

								$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez Raison"));

								$(options).append($("<option />").val(0).text('-- Raison --'));

								$.each(resposta.data, function() {
									$descriptionSummary = '';
									/*if(this.Descricao.length > 20) descriptionSummary = this.Descricao.substr(0,20)+"...";
									else*/ descriptionSummary = this.Descricao;
									$(options).append( $("<option />").val(this.ID_Motivo).html('<small>'+this.Codigo+': '+descriptionSummary+'</small>') );
								});

								//storing in session
								sessionStorage.setItem('motives', $(options).html() );
							}
						}
					}
				},
				complete : function() {
					if(motivoID != 0) $(options).val(motivoID);
					else $(options).val($("select#motivo_linha_"+lineID+" option:eq(1)").val());

					//init select2
					$(options).select2({
						escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "Sélectionnez",
					});

					if(motivoID < 1) {
						if( $("select#iva_linha_"+lineID).attr('data-subclasse') == 'ISE' ) {
							$("select#motivo_linha_"+lineID).prop('disabled', false);
							$("select#motivo_linha_"+lineID).trigger('change');
						}
						else {
							$("select#motivo_linha_"+lineID).prop('disabled', true);
							$("select#motivo_linha_"+lineID).val(0);
							$("select#motivo_linha_"+lineID).trigger('change');
						}
					}else {
						$("select#motivo_linha_"+lineID).prop('disabled', false);
					}
				}
			});
		}else{
			$(".fullscreen").show();
			
			// console.log('entrou no else');
			var dadosMotives = sessionStorage.getItem('motives');

			//prepare select
			$(options).attr("disabled", false);

			$(options).append(dadosMotives);

			if(motivoID != 0) $(options).val(motivoID);
			else $(options).val($("select#motivo_linha_"+lineID+" option:eq(1)").val());

			//init select2
			$(options).select2({
				escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "-- Raison --",
			});

			if(motivoID < 1) {
				if( $("select#iva_linha_"+lineID).attr('data-subclasse') == 'ISE' ) {
					$("select#motivo_linha_"+lineID).prop('disabled', false);
					// $("select#motivo_linha_"+lineID).trigger('change');
				}
				else {
					$("select#motivo_linha_"+lineID).prop('disabled', true);
					$("select#motivo_linha_"+lineID).val(0);
					// $("select#motivo_linha_"+lineID).trigger('change');
				}
				$("select#motivo_linha_"+lineID).trigger('change');
			}else {
				$("select#motivo_linha_"+lineID).prop('disabled', false);
			}

	        $(".fullscreen").fadeOut();
		}
	}

	/**
	 * Delete Line
	 * @param  lineID
	 */
	function eliminarLinha(lineID){
		if(valorLinhas < 2){
			alert('Il doit y avoir au moins 1 élément de article!');
		}else{
			valorLinhas--;
			$('#line_'+lineID).remove();

			//calculate taxes lines
			calculateTaxesLines();

			//update document totals
			updateDocumentTotals();
		}
	}

	/**
	 * active or disable taxes selects
	 * @param  lineID   
	 * @param  subclasse
	 * @return none
	 */
	function changeTaxes(lineID, subclasse, blockUpdate = false){
		if(subclasse == 'ISE') {
			$("select#motivo_linha_"+lineID).prop('disabled', false);
		}
		else {
			$("select#motivo_linha_"+lineID).prop('disabled', true);
			$("select#motivo_linha_"+lineID).val(0);
		}
		if(!blockUpdate) $("select#motivo_linha_"+lineID).trigger('change');
	}

	/**
	 * Calculate the taxes
	 * @return taxes totals
	 */
	function calculateTaxesLines(){
		//expired function
	}

	/**
	 * Update the document totals table
	 * @return totals
	 */
	function updateDocumentTotals(blockResume = false){
		
		//stop previous call
		if (typeof xhrTotals !== 'undefined' && xhrTotals !== null) xhrTotals.abort();

		//global value
		var desconto2 = $('#desconto_guia').autoNumeric('get');

		//init the arrays
		var linesTaxes = [];
		var linesTotals = [];

		//get data to send to server
		$("select.lineInputArtigo").each(function() {
			var lineID = $(this).attr('data-id-line');
			var ivaID = $("#iva_linha_"+lineID).val();
			var descricaoIVA = $('option:selected', $("#iva_linha_"+lineID)).html();
			
			var qtd = Number( $("#qtd_linha_"+lineID).autoNumeric('get') );
			var preco = Number( $("#preco_linha_"+lineID).autoNumeric('get') );
			var iva = Number( $('option:selected', $("#iva_linha_"+lineID)).attr('data-valor') );
			if(isNaN(iva)) iva = 0;
			var desconto = Number( $("#desc_linha_"+lineID).autoNumeric('get') );
			
			//add to array taxes
			linesTaxes.push({
				"ivaID" : ivaID,
				"lineID" : lineID,
				"descricaoIVA" : descricaoIVA,
				"qtd" : qtd,
				"preco" : preco,
				"iva" : iva,
				"desconto" : desconto,
				"desconto2" : desconto2,
			});

			//==================================
			var retencao = Number( $("#retencao_linha_"+lineID).autoNumeric('get') );
			
			//add to array totals
			linesTotals.push({
				"lineID" : lineID,
				"qtd" : qtd,
				"preco" : preco,
				"desconto" : desconto,
				"retencao" : retencao,
				"desconto2" : desconto2,
			});
		});
		// console.log(linesTaxes, linesTotals, 'update totals!');

		//calculate the totals and retrieve them
		xhrTotals = $.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/calculate_totals.php',
			dataType : 'json',
			data : { 
				linesTaxes : linesTaxes,
				linesTotals : linesTotals
			},
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT9999] Ocorreu um erro. Contacte o administrador", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT9999] Ocorreu um erro. Contacte o administrador", $.scojs_message.TYPE_ERROR);
					} else {
						$('.taxes_lines').remove();

						// console.log(resposta);
						var htmlLines = resposta.dataIva;
						if(htmlLines != '') $('.taxes-table').append(htmlLines);

						// console.log(resposta);
						var totalsValues = resposta.dataTotals;
						if(totalsValues != '' && blockResume == false) {
							valorSomatorio = totalsValues['valorSomatorio'];
							valorDescontos = totalsValues['valorDescontos'];
							valorRetencao = totalsValues['valorRetencao'];
							valorTotal = totalsValues['valorTotal'];
							valorSiva = totalsValues['valorSiva'];
							valorIva = totalsValues['valorIva'];
						}

						//init money class
						$(".money").autoNumeric("init", {
							aSep : '\'',
							aDec : '.',
							aSign : ' CHF',
							pSign : 's',
							vMin:'0',
							mDec : <?php echo $numDecimais; ?>
						});
					}
				}
			},
			complete : function() {
				//update resume table
				update_resumeTable();

				//if currency != 'EUR'
				calculateCurrencyCambio();
			}
		});

		return false;
	}

	/**
	 * Update the resume table
	 * @return none
	 */
	function update_resumeTable(){
		valorTotal = roundPriceUp(valorTotal);
		$('#valor-linhas').html( valorLinhas );
		$('#valor-somatorio').autoNumeric( 'set', valorSomatorio );
		$('#valor-descontos').autoNumeric( 'set', valorDescontos );
		$('#valor-retencao').autoNumeric( 'set', valorRetencao );
		$('#valor-siva').autoNumeric( 'set', valorSiva );
		$('#valor-iva').autoNumeric( 'set', valorIva );
		$('#valor-total').autoNumeric( 'set', valorTotal );
		return true;
	}

	/**
	 * Get Custom Rounded UP Value for Invoices (0.05 UP)
	 * @return rounded value
	 */
	function roundPriceUp(valueToRise){
		var finalValue = 0;
		//confirm that the value is rounded
		var roundedValue = Number(valueToRise).toFixed(2);
		//grab last decimal number
		var lastNumber = roundedValue.substr(roundedValue.length - 1);

		/* === process the last decimal number === */
		if(lastNumber > 0 && lastNumber <= 2) {
			var replacement = 0;
			finalValue = roundedValue.slice(0, -1) + ''+replacement;
		}
		else if(lastNumber > 2 && lastNumber <= 7) {
			var replacement = 5;
			finalValue = roundedValue.slice(0, -1) + ''+replacement;
		}
		else if(lastNumber > 7 && lastNumber <=9 ) {
			finalValue = Number(valueToRise).toFixed(1);
		}
		else{
			finalValue = roundedValue;
		}
		/* =========== /end processing =========== */
		// console.log(roundedValue,lastNumber, finalValue)

		// console.log( roundedValue,lastNumber, finalValue );
		
		//return final formatted value
		return finalValue;
	}

	/**
	 * Init the lines listners
	 * @return none
	 */
	function linesListenersInit(lineID_new = 0){
		$(".fullscreen").show();
		
		//init elements
		$(".money").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : ' CHF',
			pSign : 's',
			vMin:'0',
			mDec : <?php echo $numDecimais; ?>
		});
		$(".moneyBig").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : ' CHF',
			pSign : 's',
			mDec : <?php echo $numDecimaisPrice; ?>,
			vMin:'0'
		});
		//init elements
		$(".qtd").autoNumeric("init", {
			aSep : '',
			aDec : '.',
			aSign : '',
			pSign : 's',
			mDec : 3,
			vMin:'0'
		});
		//init elements
		$(".percentage").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : '%',
			vMax : '100',
			pSign : 's',
			mDec : 2,
			vMin:'0'
		});

		//change article
		$("select#codigo_linha_"+lineID_new).on('change', function(event){
			var lineID = $(this).attr('data-id-line');
			changeArticle(lineID);
		});
		
		//change tax
		$("select#iva_linha_"+lineID_new).on('change', function(event){
			var lineID = $(this).attr('data-id-line');
			var subclasse = $('option:selected', this).attr('data-subclasse');
			changeTaxes(lineID, subclasse);
			calculaLinha(lineID);
		});

		//calculate line --------------------------------------------------
		$("tr#line_"+lineID_new+" input.lineInputChange").on('keyup', function(event){
			// console.log('keyup ', lineID_new);
			var lineID = $(this).attr('data-id-line');
			calculaLinha(lineID);
		});
		// $("tr#line_"+lineID_new+" select.lineInputChange").on('change', function(event){
		// console.log('listner4');
		// 	// console.log('change ', lineID_new);
		// 	var lineID = $(this).attr('data-id-line');
		// 	calculaLinha(lineID);
		// });
	    
	    $(".fullscreen").fadeOut();
	}

	/**
	 * Change Currency Cambio
	 * @return none
	 */
	function calculateCurrencyCambio(){
		var iso = $('option:selected', $("#moeda_guia") ).attr('data-iso');
		var simbolo = $('option:selected', $("#moeda_guia") ).attr('data-simbolo');
		var valorTaxa = 0;
		var totalMoeda = 0;

		if( iso != 'CHF' ){
			$("#moeda_estrangeira").html('Total en '+simbolo+':');
			// $("valor-moeda-estrangeira");

			$(".moneyCountry").autoNumeric("update", {
				aSign : ' '+simbolo
			});
			if( taxaCambio == 0 || lastSimbolo != simbolo){
				$.ajax({
					type : 'POST',
					url : '/frifacturation/server/combobox/guias-transporte.php',
					dataType : 'json',
					data : { 
						opcao: 10,
						ISO : iso
					},
					success : function(resposta) {
						if (resposta == null) {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.errors == true) {
								$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
							} else {
								valorTaxa = Number( resposta.data.rate );
								$("#taxa-cambio").html(valorTaxa);

								//store taxa and simbolo
								taxaCambio = valorTaxa;
								lastSimbolo = simbolo;

								//calculate currency
								totalMoeda = valorTotal * valorTaxa;
								$("#valor-moeda-estrangeira").autoNumeric('set', totalMoeda);
							}
						}
					},
					complete : function() {}
				});
			}else{
				$("#taxa-cambio").html(taxaCambio);

				//calculate currency
				totalMoeda = valorTotal * taxaCambio;
				$("#valor-moeda-estrangeira").autoNumeric('set', totalMoeda);
			}


			$("#linha_moeda_estrangeira").show();
			$("#linha_moeda_estrangeira2").show();
		}else{
			$("#moeda_estrangeira").html('');

			$("#linha_moeda_estrangeira").hide();
			$("#linha_moeda_estrangeira2").hide();
		}
	}
</script>