<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "Tous"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[0, "desc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/conta_corrente.php",
		"oLanguage" : {
			"sLengthMenu" : "Show _MENU_ enregistrements par page",
			"sZeroRecords" : "Sans enregistrements",
			"sInfo" : "_START_ a _END_ de _TOTAL_ enregistrements",
			"sInfoEmpty" : " 0 a 0 de 0 enregistrements",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "Suivant",
				"sFirst" : "Premier",
				"sPrevious" : "Précédent",
				"sLast" : "Dernier"
			}
		},
		"aoColumns" : [null, 
		{
			"bVisible" : true,
		}, 
		null, null, null, null,
		{
			"bVisible" : false,
		},
		{
			"sClass" : "text-right",
		},
		{
			"sClass" : "text-right",
		},
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		},
		{
			"bVisible" : false,
		}
		],
		"aoColumnDefs" : [
		{
			"aTargets" : [0],
			"mRender" : function(data, type, full) {
				var element = '';
				var tmp = full[0].split("-");
				var tmpNew = tmp[0]+'/'+tmp[1]+'/'+tmp[2];
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				element = '<span data-normalizeDate="'+tmpNew+'">'+tmpLBL+'</span>';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[9] == 'Pago') element = '<span style="color: green;">'+full[2]+'</span>';
				if(full[9] == 'Aberto') element = '<span style="color: blue;">'+full[2]+'</span>';
				if(full[9] == 'Anulado') element = '<span style="color: black;">'+full[2]+'</span>';
				//else element = full[0];
				//return html
				return element;
			}
		},
		{
			"aTargets" : [4],
			"mRender" : function(data, type, full) {
				//return html
				return '<span class="ellipsis" data-size="38">'+full[4]+'</span>';
			}
		},
		{
			"aTargets" : [5],
			"mRender" : function(data, type, full) {
				var cleanerString = full[5].replace(/Desconhecido/gi, " ");
				//return html
				return '<span class="ellipsis" data-size="28">'+cleanerString+'</span>';
			}
		},
		{
			"aTargets" : [7],
			"mRender" : function(data, type, full) {
				var element = '';

				if(full[1] == 'Facture' || full[1] == 'FA' || full[1] == 'N. Crédit' || full[1] == 'NC'){
					var colorText = 'text-red';
					if(full[7] >= 0) colorText = 'text-green';
					element ='<span class="money '+colorText+'">'+full[7]+'</span>';

					//init elements
					$(".money").autoNumeric("init", {
						aSep : '\'',
						aDec : '.',
						aSign : ' CHF',
						pSign : 's',
						mDec : <?php echo $numDecimais; ?>
					});
				}else{
					element = '-';
				}

				//return html
				return element;
			}
		},
		{
			"aTargets" : [8],
			"mRender" : function(data, type, full) {
				var element = '';

				if(full[1] == 'Facture' || full[1] == 'FA'){
					var color = 'text-red';
					if(full[8] == null) full[8] = 0;
					if(full[8] >= 0) color = 'text-green';
					element ='<span class="money '+color+'">'+full[8]+'</span>';

					//init elements
					$(".money").autoNumeric("init", {
						aSep : '\'',
						aDec : '.',
						aSign : ' CHF',
						pSign : 's',
						mDec : <?php echo $numDecimais; ?>
					});
				}else{
					element = '-';
				}

				//return html
				return element;
			}
		},
		{
			"aTargets" : [9],
			"mRender" : function(data, type, full) {
				var processedName = full[1].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'" + processedName + "'";
				var html = '';

				if(full[1] == 'Facture' || full[1] == 'FA'){
					html += '<a href="/frifacturation/factures/details?facture='+ full[10] +'" class="options-link text-info"><i class="fa fa-eye" title="Détails"></i></a>';
				}
				if(full[1] == 'N. Crédit' || full[1] == 'NC'){
					html += '<a href="/frifacturation/notes-credit/details?note='+ full[10] +'" class="options-link text-info"><i class="fa fa-eye" title="Détails"></i></a>';
				}

				if(full[1] == 'B. Livraison' || full[1] == 'BL'){
					html += '<a href="/frifacturation/bulletin-livraison/details?livraison='+ full[10] +'" class="options-link text-info"><i class="fa fa-eye" title="Détails"></i></a>';
				}

				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[10]);

			if(aData[9] == 'Anulado') $(nRow).css("text-decoration", "line-through");

			return nRow;
		},
		"fnDrawCallback" : function(oSettings) {
            $(".ellipsis").ellipsis(); 
		},

		"footerCallback" : function(row, data, start, end, display) {
            var api = this.api(), data;

            // Remove the formatting to get integer data for summation
            var intVal = function(i) {
                return typeof i === 'string' ? i.replace(/[\$,]/g, '') * 1 : typeof i === 'number' ? i : 0;
            };

            // Total current page
            var valorTotal = api.column(7, { page: 'current'}).data().reduce(function(a, b) {
                return intVal(a) + intVal(b);
            }, 0);
            // Total current page
            var valorSolde = api.column(8, { page: 'current'}).data().reduce(function(a, b) {
                return intVal(a) + intVal(b);
            }, 0);

            //Por liquidar -> Used extra field to calculate already rounded for a better real value
			$('body').append( $("<span />").val(0).addClass('money').attr('id','valorDocTemp') );
			$(".money").autoNumeric("init", {
				aSep : '\'',
				aDec : '.',
				aSign : ' CHF',
				pSign : 's',
				//vMin:'0',
				mDec : <?php echo $numDecimais; ?>
			});
			
			$( "#valorDocTemp" ).autoNumeric('set', valorTotal);
			valorTotal = $( "#valorDocTemp" ).autoNumeric('get');
			$( "#valorDocTemp" ).autoNumeric('set', valorSolde);
			valorSolde = $( "#valorDocTemp" ).autoNumeric('get');
			$( "#valorDocTemp" ).remove();

            //final calculation
            //-------------------------------------------------------------------------------------
            
            $('.money').not(".table-menu > tbody > tr > td > span").html("");
            $('.money').not(".table-menu > tbody > tr > td > span").autoNumeric("set", 0);


            // Update footer
            $(api.column(7).footer()).html('<span class="money">' + valorTotal + '</span>');
            $(api.column(8).footer()).html('<span class="money">' + valorSolde + '</span>');
        }
	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> Rechercher</button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
</script>