<script type="text/javascript">
	/**
	 * Get Document Data
	 * @param  idDocument
	 * @return none
	 */
	function fill_document(idDocument){
		$(".fullscreen").show();

		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contrats/location/detalhesEditar.php',
			dataType : 'json',
			data : { idDocument : idDocument },
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT001] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT002] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$.scojs_message("[FAT003] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							var dados = resposta.data;

							//fill Data
							$("#numero_location").val(dados.Numero);
							$("#endereco_cliente_location").val(dados.EnderecoCliente);
							$("#codigopostal_cliente_location").val(dados.CodigoPostalCliente);
							$("#regiao_cliente_location").val(dados.RegiaoCliente);
							$("#cidade_cliente_location").val(dados.CidadeCliente);
							$("#pais_cliente_location").val(dados.PaisCliente);
							$("#referencia_location").val(dados.Referencia);
							$("#remarque_location").val(dados.Remarque);
							$("#decompte_location").val(dados.Decompte_pages);

							$("#location_location").autoNumeric('set', dados.Location_Mensuelle);
							$("#emolument_location").autoNumeric('set', dados.Emolument_Admin);

							$("#data_location").datepicker().datepicker("setDate", dados.Data);
							$("#debut_location").datepicker().datepicker("setDate", dados.Debut);
							$( ".datepicker" ).datepicker("refresh");
							
							$("#pagamento_location").val(dados.Paiment);
							$("#pagamento_location").trigger('change');

							$("#tva_exclue_location").val(dados.TVA_Exclue_Primeiro);
							$("#tva_exclue_location").trigger('change');

							//process durée
							var splitDuree = dados.Duree.split(" ");
							$("#duree_location").val(splitDuree[0]);
							$("#duree_location").trigger('change');
							$("#duree_type_location").val(splitDuree[1]);
							$("#duree_type_location").trigger('change');

							//fill select boxes							
							var blockResume = true;
							var NomeCliente = dados.CodigoCliente+' - '+dados.NomeCliente;
							fill_clientes(dados.ID_Cliente, blockResume, NomeCliente, dados.ID_ResponsavelPrimeiro, dados.ID_ResponsavelSegundo);
							fill_vendedores_location(dados.ID_VendedorPrimeiro, blockResume, dados.VendedorPrimeiro);
							fill_responsaveis_location(dados.ID_VendedorSegundo, blockResume, dados.VendedorSegundo);

							//process lines
							processLinesLoaded(dados, blockResume );
						}
					}
				}
			},
			complete : function() {
			}
		});
	}

	//process the loaded document lines
	function processLinesLoaded(dados, blockResume){
		$(".fullscreen").show();
		
		//process lines
		var idx = 0;
		valorSomatorio = 0;
		$.each(dados.linhas, function() {
			// console.log(this);
			if(idx != 0){
				addArticleLine(this.id_artigo, this.imposto, this.motivo,0, 0, blockResume, this);
			}else{
				var lineID = lastIdLine;
				//fill selects for line 0
				fill_articles(lineID, this.id_artigo,0, this);
			}
			var lineID = lastIdLine;

			//enable fields
			$("#descricao_linha_"+lineID).prop('disabled', false);

			//fill values
			// $("select#codigo_linha_"+lineID).val(this.artigo);
			// $("select#codigo_linha_"+lineID).trigger('change');

			$("#descricao_linha_"+lineID).val(this.descricao);

			idx++;
		});

		// console.log(dados.linhas.length);
		linesListenersInit();

        $(".fullscreen").fadeOut();
	}

	/**
	 * Fill clientes
	 * @param  {Number} lastID [description]
	 * @return {[type]}        [description]
	 */
	function fill_clientes(lastID = 0, blockResume = false, dadosObj = null, Resp1 = 0, Resp2 = 0) {
		var options = $("select#cliente_location");
		// $(options).empty();

		$(".fullscreen").show();

		//prepare select
		$(options).attr("disabled", false);

		if(lastID != 0) $(options).append($("<option />").val(lastID).html(dadosObj).attr('selected', 'selected'));
		
		//init select2
		$('#cliente_location').select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- Client --",
			allowClear: true,
			// minimumInputLength: 2,
			templateResult: clientesTemplate,
			templateSelection: clientesTemplateLabel,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 2, //search term
						search_term: params.term, //search term
						search_idcliente: lastID, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results:$.map(data.results,function(val,i){
							var textLabel = val.Codigo+' - '+val.Nome;
							return{id:val.ID_Cliente,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		});

		if(lastID != 0) $(options).val(lastID);
		if(lastID != 0) getClientDetails(lastID, 1, Resp1, Resp2, blockResume);

        $(".fullscreen").fadeOut();
	}

	/**
	 * Fill clientes
	 * @param  {Number} lastID [description]
	 * @return {[type]}        [description]
	 */
	function getClientDetails(idCliente, dismissFields = 0, Resp1 = 0, Resp2 = 0, blockResume = false) {
		$("#nif_cliente_location").val('');
		$("#endereco_cliente_location").val('');
		$("#codigopostal_cliente_location").val('');
		$("#regiao_cliente_location").val('');
		$("#cidade_cliente_location").val('');
		$("#pais_cliente_location").val('');
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/contrats_location.php',
			dataType : 'json',
			data : { 
				opcao: 2,
				idCliente: idCliente
			},
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						if (resposta.type == 'FTGA003'){
							$.scojs_message("[WRN0001] Sans clients créés. S'il vous plaît commencer par la création d'un nouveau client.", 3);
						}else {
							$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						}
					} else {
						if (resposta.data == null) {
						} else {
							var dados = resposta.data;
							$("#nif_cliente_location").val(dados.Nif);
							$("#endereco_cliente_location").val(dados.Endereco);
							$("#codigopostal_cliente_location").val(dados.CodigoPostal);
							$("#regiao_cliente_location").val(dados.Regiao);
							$("#cidade_cliente_location").val(dados.Cidade);
							$("#pais_cliente_location").val(dados.Pais);
							if(dismissFields == 0){
								$("#pagamento_location").val(dados.Vencimento);
								$("#pagamento_location").trigger('change');
							}

							//fill responsables
							fill_responsaveis_cliente(dados.Responsaveis, Resp1, Resp2);
						}
					}
				}
			},
			complete : function() {	}
		});
	}

	/**
	 * Change article
	 * @param  lineID
	 */
	function changeArticle(lineID){
		//get article data
		var articleID = $("select#codigo_linha_"+lineID).val();
		if( articleID < 1){
			$("#descricao_linha_"+lineID).val('');
			// $("#qtd_linha_"+lineID).autoNumeric('set', 0);
			//disable Fields
			$("#descricao_linha_"+lineID).prop('disabled', true);
			// $("#qtd_linha_"+lineID).prop('disabled', true);
			
		}else{
			//disable Fields
			$("#descricao_linha_"+lineID).prop('disabled', false);
			// $("#qtd_linha_"+lineID).prop('disabled', false);

			//get data
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/contrats_location.php',
				dataType : 'json',
				data : { 
					opcao: 9,
					articleID : articleID
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] Une erreur s'est produite dans la ligne de l'article. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] Une erreur s'est produite dans la ligne de l'article. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null){} 
							else {
								var dados = resposta.data;
								// console.log(dados);
								//processing fields
								$("#descricao_linha_"+lineID).val(dados.Nome);
								// $("#qtd_linha_"+lineID).autoNumeric('set', 1);

								//calculations
								calculaLinha(lineID);
							}
						}
					}
				},
				complete : function() {}
			});
		}		
	}

	/**
	 * Calculates values for the article line
	 * @param  lineID
	 * @return values calculated
	 */
	function calculaLinha(lineID){
		//process the retenções field
		var tipo = $('option:selected', $("select#codigo_linha_"+lineID) ).attr('data-tipo');
		// console.log('tipo: '+tipo);

		// var qtd = Number( $("#qtd_linha_"+lineID).autoNumeric('get') );
	}


	/**
	 * Function to add new line
	 * @return 
	 */
	function addArticleLine(articleID = 0, impostoID = 0, motivoID = 0, changeLineVals = 0, planoID = 0, blockResume = false, dadosObj = null){
		lastIdLine++;

		var htmlLine = '<tr class="articles_lines" id="line_'+lastIdLine+'">'+
							'<td style="width:200px;">'+
								'<select data-id-line="'+lastIdLine+'" class="lineInputArtigo form-control select2 show-tick" data-live-search="true"  data-header="Sélectionnez" id="codigo_linha_'+lastIdLine+'" name="codigo_linha_'+lastIdLine+'" >'+
									'<option value="" data-hidden="true">Article</option>'+
								'</select>'+
							'</td>'+
							'<td>'+
								'<textarea data-id-line="'+lastIdLine+'" class="lineInputDescricao form-control" id="descricao_linha_'+lastIdLine+'" name="descricao_linha_'+lastIdLine+'" placeholder="..." rows="1"></textarea>'+
							'</td>'+
							'<td style="width:30px; text-align: center;">'+
								'<a class="options-link text-red" onclick="eliminarLinha('+lastIdLine+')" title="Remover Linha"><i class="fa fa-trash"></i></a>'+
							'</td>'+
						'</tr>';
		$('#tbody_artigos').append(htmlLine);

		//init line
		fill_articles(lastIdLine, articleID, changeLineVals, dadosObj);

		//disable the fields of the lines
		$("#descricao_linha_"+lastIdLine).prop('disabled', true);
		// $("#qtd_linha_"+lastIdLine).prop('disabled', true);

		linesListenersInit(lastIdLine);

		//to force line to init when add new article using modal
		if(changeLineVals != 0){
			changeArticle(lastIdLine);
		}

		valorLinhas++;
	}

	/**
	 * Fill the articles select
	 * @param  select id
	 * @return articles
	 */
	function fill_articles(lineID, articleID = 0, changeLineVals = 0, dadosObj = null){
		$(".fullscreen").show();
		var options = $("select#codigo_linha_"+lineID);
		// $(options).empty();
		var id_predefinido = 0;
				
		// console.log('entrou no else');

		if(dadosObj != null) {
			$(options).append($("<option />").val(articleID).text(dadosObj.codigo).attr('data-barcode', dadosObj.codigobarras).attr('data-tipo', dadosObj.Tipo).attr('selected', 'selected'));
		}

		$(options).select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- Article --",
			allowClear: true,
			// minimumInputLength: 2,
			templateResult: articlesTemplate,
			templateSelection: articlesTemplateLabel,
			// closeOnSelect: false,
			// selectOnClose: false,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 1, //search term
						search_term: params.term, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					//init vars
					var resultsReturn = data.results;
					var foundSearchResults = false;
					var selected = 0;

					//return results
					params.page = params.page || 1;
					// console.log('returned ', resultsReturn);
					return {
						results:$.map(resultsReturn,function(val,i){
							var textLabel = val.Codigo;
							return{id:i,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		}).on('select2:select', function (e) {
			// console.log('change event: ',e.params.data, $(this));
			var data = e.params.data;        
			// console.log( $(this).children('[value="'+data['id']+'"]') );
			$(this).children('[value="'+data['id']+'"]').attr('data-tipo', data["data"]["Tipo"]);
		}).trigger('change');

		// if(changeLineVals != 0){
		// 	changeArticle(lineID);
		// }
		
		//auto init select
		// $('button[data-select2-id="codigo_linha_'+lineID+'"]').trigger('click');
		$('.lineInputArtigo').select2('close');
		// if(changeLineVals == 0) $('#codigo_linha_'+lineID).select2('open');

        $(".fullscreen").fadeOut();
	}

	/**
	 * Delete Line
	 * @param  lineID
	 */
	function eliminarLinha(lineID){
		if(valorLinhas < 2){
			alert('Il doit y avoir au moins 1 élément de article!');
		}else{
			valorLinhas--;
			$('#line_'+lineID).remove();
		}
	}

	/**
	 * Init the lines listners
	 * @return none
	 */
	function linesListenersInit(lineID_new = 0){
		$(".fullscreen").show();

		//init elements
		$(".money").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : ' CHF',
			pSign : 's',
			vMin:'0',
			mDec : <?php echo $numDecimais; ?>
		});
		$(".moneyMedium").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : ' CHF',
			pSign : 's',
			mDec : <?php echo $numDecimaisPrice; ?>,
			vMin:'0'
		});
		$(".moneyBig").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : ' CHF',
			pSign : 's',
			mDec : <?php echo $numDecimaisPrice; ?>,
			vMin:'0'
		});
		//init elements
		$(".qtd").autoNumeric("init", {
			aSep : '',
			aDec : '.',
			aSign : '',
			pSign : 's',
			mDec : 3,
			vMin:'0'
		});
		//init elements
		$(".percentage").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : '%',
			vMax : '100',
			pSign : 's',
			mDec : 2,
			vMin:'0'
		});

		//change article
		$("select.lineInputArtigo").on('change', function(event){
			var lineID = $(this).attr('data-id-line');
			changeArticle(lineID);
		});
	    
	    $(".fullscreen").fadeOut();
	}

	/**
	 * Fill vendedores
	 * @return list
	 */
	function fill_vendedores_location(lastID = 0, blockResume = false, dadosObj = null) {
		var options = $("select#vendeur_1_location");

		$(".fullscreen").show();

		//prepare select
		$(options).attr("disabled", false);

		if(lastID != 0) $(options).append($("<option />").val(lastID).html(dadosObj).attr('selected', 'selected'));
		
		//init select2
		$('#vendeur_1_location').select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- Vendeur --",
			allowClear: true,
			// minimumInputLength: 2,
			// templateResult: clientesTemplate,
			// templateSelection: clientesTemplateLabel,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 4, //search term
						search_term: params.term, //search term
						search_idvendedor: lastID, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results:$.map(data.results,function(val,i){
							var textLabel = val.Nome;
							return{id:val.ID_Vendedor,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		});

		if(lastID != 0) $(options).val(lastID);
		$(options).trigger('change');

        $(".fullscreen").fadeOut();
	}

	/**
	 * Fill responsables
	 * @return list
	 */
	function fill_responsaveis_cliente(responsaveis, lastID = 0, lastID2 = 0) {
		var options = $("select#resp_client_1_location");
		$(options).empty();

		var options2 = $("select#resp_client_2_location");
		$(options2).empty();

		//process data
		$(options).attr("disabled", false);
		// $(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

		$(options2).attr("disabled", false);
		// $(options2).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

		// $(options).append($("<option />").val(0).text('Sélectionnez'));
		// $(options2).append($("<option />").val(0).text('Sélectionnez'));

		$.each(responsaveis, function() {
			$(options).append($("<option />").val(this.ID_Responsavel).html(this.Prenom+' '+this.Nome));

			$(options2).append($("<option />").val(this.ID_Responsavel).html(this.Prenom+' '+this.Nome));
		});

		//fill selects
		if(lastID != 0) $(options).val(lastID);
		else $(options).val(null);
		$(options).trigger('change');

		if(lastID2 != 0) $(options2).val(lastID2);
		else $(options2).val(null);
		$(options2).trigger('change');

		return true;
	}

	/**
	 * Fill responsaveis
	 * @return list
	 */
	function fill_responsaveis_location(lastID = 0, blockResume = false, dadosObj = null) {
		var options = $("select#vendeur_2_location");

		$(".fullscreen").show();

		//prepare select
		$(options).attr("disabled", false);

		if(lastID != 0) $(options).append($("<option />").val(lastID).html(dadosObj).attr('selected', 'selected'));
		
		//init select2
		$('#vendeur_2_location').select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- Vendeur --",
			allowClear: true,
			// minimumInputLength: 2,
			// templateResult: clientesTemplate,
			// templateSelection: clientesTemplateLabel,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 5, //search term
						search_term: params.term, //search term
						search_idresponsavel: lastID, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results:$.map(data.results,function(val,i){
							var textLabel = val.Nome;
							return{id:val.ID_RespContrato,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		});

		if(lastID != 0) $(options).val(lastID);
		$(options).trigger('change');

        $(".fullscreen").fadeOut();
	}
</script>