<script type="text/javascript">
	/**
	 * Fill up regions
	 * @return select
	 */
	function fill_regions(){
		var options = $("select#regiao_fornecedor");
		$(options).empty();
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/fornecedores.php',
			data : { 
				opcao: 1
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL007] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL008] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

							$(options).append($("<option />").val(0).text('Aucune Région'));
							$.each(resposta.data, function() {
								$(options).append($("<option />").val(this.id).text(this.nome));

							});
						}
					}
				}
			},
			complete : function() {
				$(options).val(0); //viana do castelo district
				$(options).trigger('change');
				//fill the types
				fill_cities(0);
			}
		});
	}

	/**
	 * Fill up cities based on the region
	 * @param city
	 * @return select
	 */
	function fill_cities(region){
		var options = $("select#cidade_fornecedor");
		$(options).empty();
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/fornecedores.php',
			data : { 
				opcao: 2,
				regiao: region
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL007] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL008] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

							$(options).append($("<option />").val(0).text('Sem Cidade'));
							$.each(resposta.data, function() {
								$(options).append($("<option />").val(this.id).text(this.nome));

							});
						}
					}
				}
			},
			complete : function() {
				$(options).val( $("select#cidade_fornecedor option:eq(1)").val() );
				$(options).trigger('change');
			}
		});
	}

	/**
	 * Fill up groups
	 * @return select
	 */
	function fill_groups(){
		var id_predefinido = 0;
		var options = $("select#grupo_fornecedor");
		$(options).empty();
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/fornecedores.php',
			data : { 
				opcao: 3
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL007] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL008] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

							$(options).append($("<option />").val(0).text('Sem Grupo'));
							$.each(resposta.data, function() {
								if(this.predefinido == 1) id_predefinido = this.id;
								$(options).append($("<option />").val(this.id).text(this.nome));

							});
						}
					}
				}
			},
			complete : function() {
				$(options).val(id_predefinido);
				$(options).trigger('change');
			}
		});
	}

	/**
	 * Fill metodos de pagamento
	 * @param  {Number} lastID [description]
	 * @return {[type]}        [description]
	 */
	function fill_metodos() {
		var options = $("select#pagamento_fornecedor");
		$(options).empty();
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/fornecedores.php',
			dataType : 'json',
			data : { 
				opcao: 4
			},
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

							$(options).append($("<option />").val('-').text('Méthode Standard'));
							$.each(resposta.data, function() {
								$(options).append($("<option />").val(this.ID).html(this.Descricao));

							});
						}
					}
				}
			},
			complete : function() {
				$(options).val($("select#pagamento_fornecedor option:eq(1)").val());
				$(options).trigger('change');
			}
		});
	}

	//load data
	function fill_comptes() {
		var options = $("select#plano_fornecedor");
		$(options).empty();

		var resp = null;
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/plano_contas.php',
			data : {
				opcao : 3,
				defeito: 'fornecedor'
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							resp = resposta;
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));
							$(options).append($('<option />').val("").text("Sélectionnez"));

							$.each(resposta.data, function() {
								$(options).append($("<option />").val(this.codigo).html(this.descricao+''));
							});
						}
					}
				}
			},
			complete : function() {
				if(resp != null) $(options).val(resp.planoDefeito);
				else $(options).val($("select#plano_fornecedor option:eq(1)").val());
				$(options).trigger('change');
			}
		});
	}

	
	/**
	 * Fill up groups
	 * @return select
	 */
	function fill_responsables(){
		var options1 = $("select#r1_responsavel_fornecedor");
		$(options1).empty();

		var options2 = $("select#r2_responsavel_fornecedor");
		$(options2).empty();

		var options3 = $("select#r3_responsavel_fornecedor");
		$(options3).empty();

		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/fornecedores.php',
			data : { 
				opcao: 6
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL009] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL010] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options1).attr("disabled", true);
							$(options2).attr("disabled", true);
							$(options3).attr("disabled", true);

						} else {
							$(options1).attr("disabled", false);
							$(options2).attr("disabled", false);
							$(options3).attr("disabled", false);

							$(options1).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));
							$(options2).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));
							$(options3).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));

							// $(options1).append($("<option />").val(0).text('Sélectionnez'));
							// $(options2).append($("<option />").val(0).text('Sélectionnez'));
							// $(options3).append($("<option />").val(0).text('Sélectionnez'));
							$.each(resposta.data, function() {
								$(options1).append($("<option />").val(this.id).text(this.nome));
								$(options2).append($("<option />").val(this.id).text(this.nome));
								$(options3).append($("<option />").val(this.id).text(this.nome));
							});
						}
					}
				}
			},
			complete : function() {
				// $(options1).val( $("select#r1_responsavel_fornecedor option:eq(1)").val() );
				// $(options2).val( $("select#r2_responsavel_fornecedor option:eq(1)").val() );
				// $(options3).val( $("select#r3_responsavel_fornecedor option:eq(1)").val() );
				$(options1).trigger('change');
				$(options2).trigger('change');
				$(options3).trigger('change');
			}
		});
	}

	//load data
	function fill_banks(lastID = 0) {
		var options = $("select#new_banco_fornecedor");
		$(options).empty();

		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/fornecedores.php',
			data : {
				opcao : 7
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));
							$(options).append($('<option />').val("").text("Sélectionnez"));

							$.each(resposta.data, function() {
								$(options).append($("<option />").val(this.id).html(this.nome+''));
							});
						}
					}
				}
			},
			complete : function() {
				if(lastID != 0) $(options).val(lastID);
				// else $(options).val($("select#new_banco_fornecedor option:eq(1)").val());
				$(options).trigger('change');
			}
		});
	}
</script>