<div id="modal-confirmar-envio" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" data-backdrop="static" data-keyboard="false" aria-hidden="true" class="modal fade">
	<div class="modal-dialog modal-wide-width">
		<div class="modal-content">
			<div class="modal-header modal-header-orange">
				<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
					&times;
				</button>
				<h4 id="modal-header-primary-label" class="modal-title">Confirmer l'envoi d'un email</h4>
			</div>
			<div class="modal-body" style="overflow-y: visible;">
				<form id="form_confirmar_envio">
					<div id="form_div">
						<div class="row">
							<input type="hidden" id="document_iden" name="document_iden" />
							<div class="col-sm-12">
								<div class="form-group">
									<label class="control-label">Détails de la note de crédit</label>
									<span id="confirmar_envio_detalhes" style="display: block"></span>
								</div>
							</div>
						</div>
						<div class="row mtl">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label">Email actuel</label>
									<span id="confirmar_envio_email" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label">Nouveau email</label>
									<input type="email" class="form-control" id="confirmar_envio_emailnovo" name="confirmar_envio_emailnovo" placeholder="..." />
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-blue" id="confirmBtn-modal">
					<i class="fa fa-paper-plane"></i> Finir et Envoyer
				</button>
				<button type="button" data-dismiss="modal" class="btn btn-default">
					Annuler
				</button>
			</div>
		</div>
	</div>
</div>
<script type="text/javascript">
	
	// FORM EMAIL VALIDATOR
	val_form_new = $("#form_confirmar_envio").validate({
		ignore : "",
		rules : {
			confirmar_envio_emailnovo : {
				required : true,
			},
		},
		messages : {
			confirmar_envio_emailnovo : {
				required : "Ce champ est obligatoire",
				email : "Veuillez entrer une adresse e-mail valide"
			},
		},
		highlight : function(element, errorClass, validClass) {
			$(element).addClass(errorClass).removeClass(validClass);
		},
		unhighlight : function(element, errorClass, validClass) {
			$(element).removeClass(errorClass).addClass(validClass);
		},
		errorPlacement : function(error, element) {
			if (element.hasClass('selectpicker')) {
				if (element.parent().hasClass("input-group"))
					error.insertAfter(element.parent());
				else
					error.insertAfter(element.next("div"));
			} else {
				error.insertAfter(element);
			}
		}
	});

	//prevent form submit
	$("#form_confirmar_envio").submit(function(e) {
		e.preventDefault();
	});

	//confirm sender
	$("#confirmBtn-modal").on('click', function(event){
		var valid = $("#form_confirmar_envio").valid();

		if(valid == false) {
			$.scojs_message("Remplissez tous les champs", $.scojs_message.TYPE_ERROR);
		} else {
			var docIden = $("#document_iden").val();
			var emailSender = $("#confirmar_envio_emailnovo").val();

			//call sender function
			confirmNotaSender(docIden, emailSender);
		}
	});

	/**
	 * Get email for sender
	 * @param  id
	 */
	function fill_senderEmail(idDocumento){
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/faturas-comum/sender_email_notecredit.php',
			data : { 
				idDocumento : idDocumento
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL007] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL008] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							// console.log('nulo?');
						} else {
							var dados = resposta.data;
							// console.log(dados);
							$('#confirmar_envio_email').html(dados.EmailSender);
							$('#confirmar_envio_emailnovo').val(dados.EmailSender);
						}
					}
				}
			},
			complete : function() {
				$('#modal-confirmar-envio').modal("show");
			}
		});
	}
</script>