<div id="modal-responsavel" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" data-backdrop="static" data-keyboard="false" aria-hidden="true" class="modal fade">
	<div class="modal-dialog modal-wide-width">
		<div class="modal-content">
			<div class="modal-header modal-header-orange">
				<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
					&times;
				</button>
				<h4 id="modal-header-primary-label" class="modal-title"><i class="fa fa-user"></i>&nbsp;Nouveau responsable</h4>
			</div>
			<form id="form_new_responsavel" class="form-validate">
				<div class="modal-body">
					<div id="form_div">
						<h5 class="form-header">
							<legend class="form-legend">
								Données du Responsable
							</legend>
						</h5>
						<div class="section-form">
							<div class="row">
								<div class="col-sm-2">
									<div class="form-group">
										<label class="control-label">Code<span class="require">*</span></label>
										<input type="text" class="form-control" id="codigo_responsavel" name="codigo_responsavel" placeholder="..." disabled value="<?php echo getNextID('Codigo', 'faturacao_responsaveis') ?>" />
									</div>
								</div>
								<div class="col-sm-4">
									<div class="form-group">
										<label class="control-label">Nom<span class="require">*</span></label>
										<input type="text" class="form-control" id="nome_responsavel" name="nome_responsavel" placeholder="..." autofocus="true" />
									</div>
								</div>
								<div class="col-sm-6">
									<div class="form-group">
										<label class="control-label">Prénom<span class="require">*</span></label>
										<input type="text" class="form-control" id="prenom_responsavel" name="prenom_responsavel" placeholder="..." />
									</div>
								</div>
							</div>
							<div class="row">
								<div class="col-sm-6">
									<div class="form-group">
										<label class="control-label">Email</label>
										<input type="email" class="form-control" id="email_responsavel" name="email_responsavel" placeholder="..." />
									</div>
								</div>
								<div class="col-sm-4">
									<div class="form-group">
										<label class="control-label">Téléphone</label>
										<input type="text" class="form-control" id="contacto_responsavel" name="contacto_responsavel" placeholder="..." />
									</div>
								</div>	
							</div>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button class="btn btn-yellow submit_button" type="submit">
						<i class="fa fa-floppy-o"></i> Enregistrer
					</button>
					<button type="button" data-dismiss="modal" class="btn btn-default">
						Annuler
					</button>
				</div>
			</form>
		</div>
	</div>
</div>

<script>
	$(document).ajaxStart(function() {
		$(".fullscreen").show();
	});
	$(document).ajaxComplete(function() {
		if ($.active == 1) {
            $(".fullscreen").fadeOut();
        }
	});
	$(document).ready(function() {

		$(".fullscreen").fadeOut();

	});			

	/**
	 * ----------------------------------------------------
	 * ----------------- FORM PROCESSING ------------------
	 * ----------------------------------------------------
	 */
	val_form_new = $("#form_new_responsavel").validate({
		ignore : "",
		rules : {
			nome_responsavel : {
				required : true,
			},
			prenom_responsavel : {
				required : true,
			},
		},
		messages : {
			nome_responsavel : {
				required : "Ce champ est obligatoire"
			},
			prenom_responsavel : {
				required : "Ce champ est obligatoire"
			},
			email_responsavel : {
				email : "Veuillez entrer une adresse e-mail valide"
			},

		},
		highlight : function(element, errorClass, validClass) {
			$(element).addClass(errorClass).removeClass(validClass);
		},
		unhighlight : function(element, errorClass, validClass) {
			$(element).removeClass(errorClass).addClass(validClass);
		},
		errorPlacement : function(error, element) {
			if (element.hasClass('selectpicker')) {
				if (element.parent().hasClass("input-group"))
					error.insertAfter(element.parent());
				else
					error.insertAfter(element.next("div"));
			} else {
				error.insertAfter(element);
			}
		}
	});

	//check validation and upload foto
	$("#form_new_responsavel").submit(function(e) {
		e.preventDefault();

		var valid = $("#form_new_responsavel").valid();
		if (valid == false) {
			$.scojs_message("Remplissez tous les champs", $.scojs_message.TYPE_ERROR);
		} else {

			$("#form_new_responsavel").find('.submit_button').attr("disabled", true);
			$("#form_new_responsavel").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> Chargement...');

			//submite the form
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/responsaveis/inserir_modal.php',
				dataType : 'json',
				data : {
					nome_responsavel : $("#nome_responsavel").val(),							
					prenom_responsavel : $("#prenom_responsavel").val(),							
					email_responsavel : $("#email_responsavel").val(),							
					contacto_responsavel : $("#contacto_responsavel").val(),							
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] Erreur. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] Erreur. Contactez l'administrateur.", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("Les données sont entrées avec succès.", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					var resp = resposta;
					if (resp.responseJSON.errors) {
					} else {
						fill_responsables();
						$("#form_new_responsavel")[0].reset();
						$("#codigo_responsavel").val(resp.responseJSON.NextID);
						$('#modal-responsavel').modal("hide");
					}
					$("#form_new_responsavel").find('.submit_button').attr("disabled", false);
					$("#form_new_responsavel").find('.submit_button').html('<i class="fa fa-floppy-o"></i> Enregistrer');
				}
			});
		}
	});
</script>