
<div id="modal-stock" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" data-backdrop="static" data-keyboard="false" aria-hidden="true" class="modal fade">
	<div class="modal-dialog modal-wide-width">
		<div class="modal-content">
			<div class="modal-header modal-header-orange">
				<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
					&times;
				</button>
				<h4 id="modal-header-primary-label" class="modal-title">Mise à jour Stock</h4>
			</div>
			<form id="form_stock_artigo" class="form-validate" novalidate="novalidate">
				<input type="hidden" id="idArtigo">
				<div class="modal-body" style="overflow-y: visible;">
					<div id="form_div">
						<div class="row">
							<div class="col-sm-2">
								<div class="form-group">
									<label class="control-label">Référence</label>
									<span id="codigo_stock_artigo" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-4">
								<div class="form-group">
									<label class="control-label">Nom</label>
									<span id="nome_stock_artigo" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-3">
								<div class="form-group">
									<label class="control-label">Type</label>
									<span id="tipo_stock_artigo" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-3 hide">
								<div class="form-group">
									<label class="control-label">Categoria</label>
									<span id="categoria_stock_artigo" style="display: block"></span>
								</div>
							</div>
						</div>
						<div class="row mtl">
							<div class="col-sm-2">
								<div class="form-group">
									<label class="control-label">Barcode</label>
									<span id="codBarras_stock_artigo" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-4">
								<div class="form-group">
									<label class="control-label">Nº Série</label>
									<span id="nSerie_stock_artigo" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-3">
								<div class="form-group">
									<label class="control-label">Stock Actuel</label>
									<span id="qtd_atual_stock_artigo" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-3">
								<div class="form-group">
									<label class="control-label">Prix TTC</label>
									<span id="pvp_stock_artigo" class="money" style="display: block"></span>
								</div>
							</div>
						</div>
						<div class="row mtl">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label">Plan Comptable (Impôt Chiffre)</label>
									<span id="plano_stock_artigo" class="" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label">Plan Comptable (Impôt préalable)</label>
									<span id="plano_2_stock_artigo" class="" style="display: block"></span>
								</div>
							</div>
							<div class="col-xs-12"><hr></div>
						</div>
						<div class="row mtm">
							<div class="col-sm-4">
								<div class="form-group">
									<label class="control-label">Quantité en Stock<span class="require">*</span></label>
									<div style="display: block;">
										<input type="text" class="form-control qtd" id="qtd_stock_artigo" name="qtd_stock_artigo" placeholder="0.000" style=""/>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button  class="btn btn-green submit_button" type="submit">
						<i class="fa fa-floppy-o"></i> Enregistrer et Finir
					</button>
					<button type="button" data-dismiss="modal" class="btn btn-default">
						Annuler
					</button>

				</div>
			</form>
		</div>
	</div>
</div>

<script type="text/javascript">
	$(document).ready(function() {
		//init elements
		$(".qtd").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : '',
			pSign : 's',
			mDec : 3
		});
	});

	/**
	 * Get article details
	 * @param  idArtigo
	 * @return fill details
	 */
	function fill_article_data(idArtigo){
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/artigos/artigos_detalhes.php',
			data : { 
				idArtigo : idArtigo
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL007] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL008] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							//disable the selects
							$(seriesSel).attr("disabled", true);
							$(metodosSel).attr("disabled", true);
							$(bancosSel).attr("disabled", true);
						} else {
							var dados = resposta.data;

							$('#codigo_stock_artigo').html(dados.Codigo);
							$('#nome_stock_artigo').html(dados.Nome);
							$('#tipo_stock_artigo').html(dados.Tipo);
							$('#plano_stock_artigo').html(dados.PlanoContas+'&nbsp;>>&nbsp;'+dados.PlanoContasDesc);
							$('#plano_2_stock_artigo').html(dados.PlanoContasCompras+'&nbsp;>>&nbsp;'+dados.PlanoContasComprasDesc);
							$('#categoria_stock_artigo').html(dados.Categoria);
							$('#codBarras_stock_artigo').html(dados.CodigoBarras);
							$('#nSerie_stock_artigo').html(dados.SerialNumber);
							$('#qtd_atual_stock_artigo').html(dados.Stock+' ('+dados.Unidade+')');
							$('#qtd_stock_artigo').autoNumeric('set', dados.Stock);
							$('#pvp_stock_artigo').autoNumeric('set', dados.PrecoPVP);
						}
					}
				}
			},
			complete : function() {
				$('#modal-stock').modal("show");
			}
		});
	}

	/**
	 * ----------------------------------------------------
	 * ----------------- FORM PROCESSING ------------------
	 * ----------------------------------------------------
	 */
	val_form_new = $("#form_stock_artigo").validate({
		ignore : "",
		rules : {
			qtd_stock_artigo : {
				required : true,
			},
		},
		messages : {
			qtd_stock_artigo : {
				required : "Ce champ est obligatoire"
			},
		},
		highlight : function(element, errorClass, validClass) {
			$(element).addClass(errorClass).removeClass(validClass);
		},
		unhighlight : function(element, errorClass, validClass) {
			$(element).removeClass(errorClass).addClass(validClass);
		},
		errorPlacement : function(error, element) {
			if (element.hasClass('selectpicker')) {
				if (element.parent().hasClass("input-group"))
					error.insertAfter(element.parent());
				else
					error.insertAfter(element.next("div"));
			} else {
				error.insertAfter(element);
			}
		}
	});

	//check validation and upload foto
	$("#form_stock_artigo").submit(function(e) {
		e.preventDefault();

		var valid = $("#form_stock_artigo").valid();
		if (valid == false) {
			$.scojs_message("Remplissez tous les champs", $.scojs_message.TYPE_ERROR);
		} else {
			var validateForm = true;

			$("#form_stock_artigo").find('.submit_button').attr("disabled", true);
			$("#form_stock_artigo").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> Chargement ...');

			//submite the form
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/artigos/atualizar_stock.php',
				dataType : 'json',
				data : {
					idArtigo : $("#idArtigo").val(),
					qtd_stock_artigo : $("#qtd_stock_artigo").autoNumeric('get'),
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] Une erreur s'est produite lors de l'enregistrement des données. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] Une erreur s'est produite lors de l'enregistrement des données. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("La quantité de stock mise à jour avec succès.", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					var resp = resposta;

					if (resp.responseJSON.errors) {
						$.scojs_message("[FAT003] Une erreur s'est produite lors de l'enregistrement des données. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("La quantité de stock mise à jour avec succès.", $.scojs_message.TYPE_OK);
						//reload
						setTimeout(function() {
							// window.location.href = "../factures/details?facture="+resp.responseJSON.fatura;
							location.reload();
						}, 1000);
					}
					$("#form_stock_artigo").find('.submit_button').attr("disabled", false);
					$("#form_stock_artigo").find('.submit_button').html('<i class="fa fa-floppy-o"></i> Enregistrer');
				}
			});
		}
	});

	//ver recibo
	function atualizarStock(idArtigo){
	<?php if (hasPermission(['P0061']) == 1) { ?>
		$('#idArtigo').val(idArtigo);
		fill_article_data(idArtigo);
	<?php } else {?>
		alert('Votre profil d\'autorisations ne vous permet pas d\'effectuer l\'opération prévue.');
	<?php } ?>
	}
</script>