<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

	if ( hasPermission(['P0093']) == 1 ) {}
	else{
		header('Location: ../../acces-refuse?redirectfrom=/frifacturation/bvr&redirectto=/frifacturation');
	}

	if ($_SESSION['mod_Contabilidade'] == 0) {
		header('Location: ../../acces-fonctionnalites?redirectfrom=frifacturation&redirectto=/frifacturation');
	}
?>
<html>
	<title>Opérations bancaires: Importer BVR | Frifacturation</title>
	<head>
		<?php include('../../base/css.php') ?>
		<!-- ADDED CSS -->
		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">
		<link rel="stylesheet" href="/js/vendors/bootstrap-datepicker/datepicker3.css">
		<!-- //ADDED CSS -->
	</head>
	<body>
		<?php include '../../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../../menu.php'; ?>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
							<button class="btn btn-yellow btn-outlined btn-square" type="button" onclick="uploadFile()">
								<i class="fa fa-upload"></i> Importer BVR
							</button>
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li>
								Opérations bancaires
							</li>
							<li class="active">
								Gestion BVR
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row ptm">
							<div class="col-xs-12">
								<div class="row">
									<div class="col-md-2"></div>
									<div class="col-md-8">
										<div class="form-group ">
											<label class="control-label">Fichiers Importés<span class="require">*</span></label>
											<div class="input-group">
												<select class="form-control selectpicker show-tick" data-live-search="true"  data-header="Sélectionnez" id="bvr_importado" name="bvr_importado">
													<option value="" data-hidden="true">Sélectionnez</option>
												</select>
												<span class="input-group-btn">
													<a id="downFileBTN" class="btn btn-violet" target="_blank" download disabled>
														<i class="fa fa-download"></i> Télécharger le fichier
													</a>
												</span>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
						<hr>
						<div class="row ptm">
							<div class="col-xs-12">
								<h4 class="text-center">Détails des Mouvements</h4>
							</div>
							<div class="col-md-12 ">
								<table class="table table-bordered table-striped" id="table_id" >
									<thead>
										<tr>
											<th style="width: 60px;">Line</th>
											<th style="width: 60px;">Code</th>
											<th style="width: 100px;">Type</th>
											<th style="width: 100px;">Compte</th>
											<th style="width: 100px;">Type Paiement</th>
											<th style="width: 100px;">Date Traitement</th>
											<th>BVR</th>
											<th style="width: 130px;">Document Associé</th>
											<th style="width: 90px;">Montant&nbsp;&nbsp;</th>
											<th style="width: 60px;">Options</th>
											<th style="width: 80px;">Hidden</th>
										</tr>
									</thead>
									<tbody></tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<?php include '../../footer.php';	?>
		<?php include('../../base/scripts.php') ?>

		<!-- ADDED SCRIPTS -->
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>

		<script src="/js/autoNumeric.js"></script>
		<script src="/js/jquery.showmore.js"></script>
		
		<?php include('index_scripts.php');  ?>
		<?php include('../../modals/importar_bvr.php');  ?>
		<?php include('../../modals/detalhes_movimento_bvr.php');  ?>
		<!-- //ADDED SCRIPTS -->

		<script>
			$(".navbar-nav li.operations").addClass("active");
			$(".navbar-nav li.operations li.bvr_operations").addClass("active");
		</script>
		<script type="text/javascript">

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }
	            //init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});
			});
			$(document).ready(function() {

				$(".fullscreen").fadeOut();

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});
				
				//init datatables
				reloadTableLines("0");
				fill_bvr_files();
			});

			//reloads table
			$("#bvr_importado").on('change', function(event){
				var pathDownload = '/frifacturation/server/BVR_Reader/files/'+$(this).val();
				$('#downFileBTN').attr('href',pathDownload);
				$('#downFileBTN').attr('disabled',false);

				reloadTableLines( $(this).val() );
			});

			$(document).ready(function() {
				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});
			});
		</script>
	</body>
</html>