<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idsFaturas = json_decode($_POST['idsFaturas']);
$idCliente = $_POST['idCliente'];

// var_dump($idsFaturas, sizeof($idsFaturas), sizeof($idsFaturas) < 1, $idCliente);die();

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( !$idsFaturas || !$idCliente || $idCliente == '' || sizeof($idsFaturas) < 1 ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//PROCESS IDS
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//DEFINE VARS -----------------------------------------------------------
	$objectData = array();

	//GET CLIENT AND SOME OTHER DATA
	$query = "SELECT ID_Cliente, Nif, Endereco, CodigoPostal, Cidade, Regiao, Pais, Email, Codigo,
	(SELECT ID_Serie FROM faturacao_series WHERE faturacao_series.Predefinida=1) AS ID_Serie, 
	(SELECT Nome FROM faturacao_series WHERE faturacao_series.Predefinida=1) AS Serie,  
	(SELECT ID_Moeda FROM faturacao_moedas WHERE faturacao_moedas.ISO_Code='CHF') AS ID_Moeda,  
	(SELECT Ultima_Taxa FROM faturacao_moedas WHERE faturacao_moedas.ISO_Code='CHF') AS TaxaMoeda 
	FROM faturacao_clientes WHERE ID_Cliente = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCliente);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		        	$objectData['ID_Cliente'],
		        	$objectData['NifCliente'],
		        	$objectData['EnderecoCliente'],
		        	$objectData['CodigoPostalCliente'],
		        	$objectData['CidadeCliente'],
		        	$objectData['RegiaoCliente'],
		        	$objectData['PaisCliente'],
		        	$objectData['EmailCliente'],
		        	$objectData['CustomerID'],
		        	$objectData['ID_Serie'],
		        	$objectData['Serie'],
		        	$objectData['ID_Moeda'],
		        	$objectData['TaxaMoeda']
				);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//process fields
	if( trim($objectData['EnderecoCliente']) == '' ) $objectData['EnderecoCliente'] = 'Desconhecido';
	if( trim($objectData['CodigoPostalCliente']) == '' ) $objectData['CodigoPostalCliente'] = 'Desconhecido';
	if( trim($objectData['CidadeCliente']) == '' ) $objectData['CidadeCliente'] = 'Desconhecido';
	// if( trim($regiaoCarga) == '' ) $regiaoCarga = 'Desconhecido';
	$objectData['RegiaoCliente'] = 'Desconhecido';
	//-----------------------------------------------------------------------
	
	//GET COMPANY DATA
	$query = "SELECT CONCAT(Endereco1,' ',Endereco2) AS Endereco, CodigoPostal, Cidade, Cidade, CAE_Principal FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
			        	$objectData['EnderecoCarga'],
			        	$objectData['CodigoPostalCarga'],
			        	$objectData['CidadeCarga'],
			        	$objectData['IdCidadeCarga'],
			        	$objectData['EACCode']
				);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//process fields
	if( trim($objectData['EnderecoCarga']) == '' ) $objectData['EnderecoCarga'] = 'Desconhecido';
	if( trim($objectData['CodigoPostalCarga']) == '' ) $objectData['CodigoPostalCarga'] = 'Desconhecido';
	if( trim($objectData['CidadeCarga']) == '' ) $objectData['CidadeCarga'] = 'Desconhecido';
	// if( trim($regiaoCarga) == '' ) $regiaoCarga = 'Desconhecido';
	$objectData['RegiaoCarga'] = 'Desconhecido';
	//-----------------------------------------------------------------------
	
	//PREPARE REMAING FIELDS
	$objectData['Vencimento'] = getValorPadrao('Vencimento','faturacao_personalizar_documentos');
	$objectData['Vendedor'] = $_SESSION['username'];
	
	$objectData['Data'] = '';

	$objectData['MetodoPagamento'] = getValorPadrao('MetodoPagamento','faturacao_personalizar_documentos');
	if($objectData['MetodoPagamento'] > 1) $objectData['ID_Banco'] = getFieldFromTable('ID_Banco','faturacao_bancos', 'WHERE Predefinido=1 AND Ativo=1');
	else $objectData['ID_Banco'] = 0;

	$objectData['Numero'] = 0;
	$objectData['Referencia'] = '';
	$objectData['Observacoes'] = '';
	$objectData['TaxPayable'] = 0;
	$objectData['NetTotal'] = 0;
	$objectData['GrossTotal'] = 0;
	$objectData['Desconto'] = 0;
	$objectData['PercentagemDesconto'] = 0;
	$objectData['TotaRetencao'] = 0;
	$objectData['TotalSDesconto'] = 0;
	$objectData['TotalLiquidadoDocumento'] = 0;
	$objectData['TotalLiquidado'] = 0;
	$objectData['TotalPagar'] = 0;
	
	//PROCESS DOCS
	foreach ($idsFaturas as $key => $idDocumento) {
		// var_dump($idDocumento);die();
		$tmpObjectData = array();

		//VERIFICA SE PODE SER GERADO --------------------------------------------
		$query = 'SELECT Estado FROM faturacao_faturas WHERE ID_Fatura=?';
		if ( $stmt = $sqli_connection->prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idDocumento);
			//result single
			$result = $stmt->execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS001";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($Estado);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS002";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		if($Estado != 'Rascunho' ) {
			$response["errors"] = true;
			$response["type"] = "var";
			$response["line"] = "FATS003";
			$response["message"] = "Document non valide pour agréger!";
			$response["estado"] = $Estado;
			die(json_encode($response));
		}
		//-----------------------------------------------------------------------

		//OBTEM OS Données de Livraison ------------------------------------------------
		$query = "SELECT ID_Fatura, 
				Numero,  
				Referencia, 
				Observacoes, 
				TaxPayable, 
				NetTotal, 
				GrossTotal, 
				Desconto, 
				PercentagemDesconto, 
				TotaRetencao, 
				TotalSDesconto, 
				InvoiceType,
				TotalLiquidadoDocumento, 
				TotalLiquidado, 
				TotalPagar
				FROM faturacao_faturas WHERE ID_Fatura=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idDocumento);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS004";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result(
			        	$tmpObjectData['ID_Fatura'],
			        	$tmpObjectData['Numero'],
			        	$tmpObjectData['Referencia'],
			        	$tmpObjectData['Observacoes'],
			        	$tmpObjectData['TaxPayable'],
			        	$tmpObjectData['NetTotal'],
			        	$tmpObjectData['GrossTotal'],
			        	$tmpObjectData['Desconto'],
			        	$tmpObjectData['PercentagemDesconto'],
			        	$tmpObjectData['TotaRetencao'],
			        	$tmpObjectData['TotalSDesconto'],
			        	$tmpObjectData['InvoiceType'],
			        	$tmpObjectData['TotalLiquidadoDocumento'],
			        	$tmpObjectData['TotalLiquidado'],
			        	$tmpObjectData['TotalPagar']
					);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS005";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//Process values for main object
		if($objectData['Referencia'] != '') $objectData['Referencia'] = $objectData['Referencia'].'; '.$tmpObjectData['Referencia'];
		else $objectData['Referencia'] = $tmpObjectData['Referencia'];

		if($objectData['Observacoes'] != '') $objectData['Observacoes'] = $objectData['Observacoes'].'; '.$tmpObjectData['Observacoes'];
		else $objectData['Observacoes'] = $tmpObjectData['Observacoes'];

		$objectData['TaxPayable'] = $objectData['TaxPayable'] + $tmpObjectData['TaxPayable'];
		$objectData['NetTotal'] = $objectData['NetTotal'] + $tmpObjectData['NetTotal'];
		$objectData['GrossTotal'] = $objectData['GrossTotal'] + $tmpObjectData['GrossTotal'];
		$objectData['Desconto'] = $objectData['Desconto'] + $tmpObjectData['Desconto'];
		// $objectData['PercentagemDesconto'] = $objectData['PercentagemDesconto'] + $tmpObjectData['PercentagemDesconto'];
		$objectData['TotaRetencao'] = $objectData['TotaRetencao'] + $tmpObjectData['TotaRetencao'];
		$objectData['TotalSDesconto'] = $objectData['TotalSDesconto'] + $tmpObjectData['TotalSDesconto'];
		$objectData['TotalLiquidadoDocumento'] = 0;
		$objectData['TotalLiquidado'] = 0;
		$objectData['TotalPagar'] = $objectData['TotalPagar'] + $tmpObjectData['TotalPagar'];
		//-----------------------------------------------------------------------

		//GET THE LINES ----------------------------------------------------------
		$query = "SELECT NumeroLinha,
				ID_Artigo,
				ProductCode,
				ProductDescription,
				Quantidade,
				UnidadeMedida,
				PrecoUnitario,
				TaxPointDate,
				Descricao,
				SerialNumber,
				ID_Imposto,
				TaxType,
				TaxCountryRegion,
				TaxCode,
				TaxPercentage,
				TaxExemptionReason,
				TaxExemptionCode,
				DescontoLinha,
				CreditAmount,
				DebitAmount,
				SettlementAmount,
				ValorRetencao,
				PercentagemRetencao,
				TotalLinha,
				TotalLinhaSIVA
				FROM faturacao_faturas_linhas WHERE ID_Fatura=? ORDER BY ID_Linha";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idDocumento);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS011";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				// deleteRecord($idFatura);
				die(json_encode($response));
			}
			$stmt -> bind_result(
					$NumeroLinha, 
					$ID_Artigo, 
					$ProductCode, 
					$ProductDescription, 
					$Quantidade, 
					$UnidadeMedida, 
					$PrecoUnitario, 
					$TaxPointDate, 
					$Descricao, 
					$SerialNumber, 
					$ID_Imposto, 
					$TaxType, 
					$TaxCountryRegion, 
					$TaxCode, 
					$TaxPercentage, 
					$TaxExemptionReason, 
					$TaxExemptionCode, 
					$DescontoLinha, 
					$CreditAmount, 
					$DebitAmount, 
					$SettlementAmount, 
					$ValorRetencao, 
					$PercentagemRetencao, 
					$TotalLinha, 
					$TotalLinhaSIVA
				);
			while ($stmt -> fetch()) {
				//process total desconto percentagem
				if($SettlementAmount > 0){
					$totalSemDescontos = $Quantidade * $PrecoUnitario;
					$x = ($SettlementAmount * 100); 
					// var_dump('1 > '.$DescontoLinha.' --> '. $SettlementAmount);
					$DescontoLinha = $x / $totalSemDescontos;
					$DescontoLinha = round($DescontoLinha,2);
					// var_dump('2 > '.$DescontoLinha.' --> '. $DescontoLinha);
				}

				// $linhaDesconto = $DescontoLinha * 0.01;

				// $totalSIVA = $Quantidade * $PrecoUnitario;

				// $desconto1 = $totalSIVA * $linhaDesconto; //calcula desconto 1
				// $descontoGlobal = $SettlementAmount - $desconto1;

				// $objectData['somaDescontoGlobal'] = $objectData['somaDescontoGlobal'] + $descontoGlobal;
				// $objectData['somaDescontoLinhas'] = $objectData['somaDescontoLinhas'] + $desconto1;
				// $objectData['somaTotSDesc'] = $objectData['somaTotSDesc'] + ( $Quantidade * $PrecoUnitario );
				// $objectData['somaTotCDescLinha'] = $objectData['somaTotSDesc'] - $objectData['somaDescontoLinhas'];

				// $x = ($objectData['somaDescontoGlobal'] * 100); 
				// $objectData['PercentagemDesconto'] = $x / $objectData['somaTotCDescLinha'];
				// $objectData['PercentagemDesconto'] = round($objectData['PercentagemDesconto'],2);
				
				//add values to array of lines
				$data[] = array(
				        	"NumeroLinha" => $NumeroLinha,
				        	"ID_Artigo" => $ID_Artigo,
				        	"ProductCode" => $ProductCode,
				        	"ProductDescription" => $ProductDescription,
				        	"Quantidade" => $Quantidade,
				        	"UnidadeMedida" => $UnidadeMedida,
				        	"PrecoUnitario" => $PrecoUnitario,
				        	"TaxPointDate" => $TaxPointDate,
				        	"Descricao" => $Descricao,
				        	"SerialNumber" => $SerialNumber,
				        	"ID_Imposto" => $ID_Imposto,
				        	"TaxType" => $TaxType,
				        	"TaxCountryRegion" => $TaxCountryRegion,
				        	"TaxCode" => $TaxCode,
				        	"TaxPercentage" => $TaxPercentage,
				        	"TaxExemptionReason" => $TaxExemptionReason,
				        	"TaxExemptionCode" => $TaxExemptionCode,
				        	"DescontoLinha" => $DescontoLinha,
				        	"CreditAmount" => $CreditAmount,
				        	"DebitAmount" => $DebitAmount,
				        	"SettlementAmount" => $SettlementAmount,
				        	"ValorRetencao" => $ValorRetencao,
				        	"PercentagemRetencao" => $PercentagemRetencao,
				        	"TotalLinha" => $TotalLinha,
				        	"TotalLinhaSIVA" => $TotalLinhaSIVA,
				        );
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS012";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			// deleteRecord($idFatura);
			die(json_encode($response));
		}
		
		//add lines to object
		$objectData['linhas'] = $data;
		//------------------------------------------------------------------------
	}

	//GENERATE NEW DOC WITH ALL DATA
	
	//PREPARE VARS ----------------------------------------------------------
	$timestamp = microtime(true);
	$systemEntryDate = date("Y-m-d H:i:s");
	$systemEntryDate = str_replace (' ','T',$systemEntryDate);
	$numeroNew = 0;
	$dataNew = date("d/m/Y");

	$dateProcessed = date('Y-m-d', strtotime(" + ".$objectData['Vencimento']." days"));
	$validadeNew = DateTime::createFromFormat('Y-m-d', $dateProcessed);
	$validadeNew = $validadeNew->format('d/m/Y');

	$invoiceTypeNew = 'FT';
	$invoiceTypeOrigem = '';
	$totalLiquidadoDocumento = 0;
	$totalLiquidado = 0;
	$estadoNovo = 'Rascunho';
	$idDocOrigem = 0;
	$referenceDocOrigem = '';
	$objectData['GrossTotal'] = roundPriceUp($objectData['GrossTotal']);
	//-----------------------------------------------------------------------

	//NEW FIELDS PLANO CONTAS
	$PlanoContasCliente = getPlanoCode("PlanoContas", "faturacao_clientes", "ID_Cliente", $objectData['ID_Cliente']);
	if($objectData['ID_Banco'] != 0)
	$PlanoContasBanco = getPlanoCode("PlanoContas", "faturacao_bancos", "ID_Banco", $objectData['ID_Banco']);

	// $response["errors"] = true;
	// $response["data"] = $objectData;
	// die(json_encode($response));

	//INSERT OPEN DOCUMENT --------------------------------------------------
	$query = "INSERT INTO faturacao_faturas(
		ID_Cliente,
		EnderecoCliente,
		CodigoPostalCliente,
		CidadeCliente,
		RegiaoCliente,
		EmailCliente,
		PaisCliente,
		ID_Moeda,
		TaxaMoeda,
		Vendedor,
		Vencimento,
		EnderecoCarga,
		CodigoPostalCarga,
		CidadeCarga,
		RegiaoCarga,
		ID_Serie,
		Numero,
		Data,
		Validade,
		Referencia,
		Observacoes,
		TaxPayable,
		NetTotal,
		GrossTotal,
		SystemEntryDate,
		TimeStampDate,
		Desconto,
		PercentagemDesconto,
		TotaRetencao,
		TotalSDesconto,
		InvoiceType,
		EACCode,
		CustomerID,
		TotalLiquidadoDocumento,
		TotalLiquidado,
		TotalPagar,
		MetodoPagamento,
		ID_Banco,
		Estado,
		ID_Utilizador,
		Tipo_Doc_Origem,
		ID_Doc_Origem,
		Reference,
		Data_Doc_Origem,
		PlanoContas,
		PlanoContasBanco
		) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssssssdsssssssddssssssssssssssssssssdsdsdssss",
		            $objectData['ID_Cliente'],
		            $objectData['EnderecoCliente'],
		            $objectData['CodigoPostalCliente'],
		            $objectData['CidadeCliente'],
		            $objectData['RegiaoCliente'],
		            $objectData['EmailCliente'],
		            $objectData['PaisCliente'],
		            $objectData['ID_Moeda'],
		            $objectData['TaxaMoeda'],
		            $objectData['Vendedor'],
		            $objectData['Vencimento'],
		            $objectData['EnderecoCarga'],
		            $objectData['CodigoPostalCarga'],
		            $objectData['CidadeCarga'],
		            $objectData['RegiaoCarga'],
		            $objectData['ID_Serie'],
		            $numeroNew,
		            $dataNew,
		            $validadeNew,
		            $objectData['Referencia'],
		            $objectData['Observacoes'],
		            $objectData['TaxPayable'],
		            $objectData['NetTotal'],
		            $objectData['GrossTotal'],
		            $systemEntryDate,
		            $timestamp,
		            $objectData['Desconto'],
		            $objectData['PercentagemDesconto'],
		            $objectData['TotaRetencao'],
		            $objectData['TotalSDesconto'],
		            $invoiceTypeNew,
		            $objectData['EACCode'],
		            $objectData['CustomerID'],
		            $totalLiquidadoDocumento,
		            $totalLiquidado,
		            $objectData['GrossTotal'],
		            $objectData['MetodoPagamento'],
		            $objectData['ID_Banco'],
		            $estadoNovo,
		            $id_utilizador,
		            $invoiceTypeOrigem,
		            $idDocOrigem,
		            $referenceDocOrigem,
		            $objectData['Data'],
		            $PlanoContasCliente,
		            $PlanoContasBanco
		    	);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//GET DOCUMENT ID
	$query = "SELECT ID_Fatura FROM faturacao_faturas WHERE TimeStampDate = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $timestamp);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS008";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($idFatura);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS009";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $idFatura < 1){
		$response["errors"] = true;
		$response["type"] = "FATS010";
		$response["message"] = "Fatura inválida";
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//INSERT THE LINES
	foreach ($objectData['linhas'] as $linha) {
		// NEW FIELDS PLANO CONTAS
		$PlanoContasArtigo = getPlanoCode("PlanoContas", "faturacao_artigos", "ID_Artigo", $linha['ID_Artigo']);
		$PlanoContasTVA = getPlanoCode("PlanoContas", "faturacao_impostos", "ID_Imposto", $linha['ID_Imposto']);
		// -------------------------------------------------------------------

		//INSERT INTO DB -----------------------------------------------------
		$query = "INSERT INTO faturacao_faturas_linhas (
			ID_Fatura, 
			NumeroLinha,
			ID_Artigo,
			ProductCode,
			ProductDescription,
			Quantidade,
			UnidadeMedida,
			PrecoUnitario,
			TaxPointDate,
			Descricao,
			SerialNumber,
			ID_Imposto,
			TaxType,
			TaxCountryRegion,
			TaxCode,
			TaxPercentage,
			TaxExemptionReason,
			TaxExemptionCode,
			DescontoLinha,
			CreditAmount,
			DebitAmount,
			SettlementAmount,
			ValorRetencao,
			PercentagemRetencao,
			TotalLinha,
			TotalLinhaSIVA,
			PlanoContas,
			PlanoContasTVA
			) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddssssssssdssssssssssssssss", 
			            $idFatura, 
						$linha['NumeroLinha'],
						$linha['ID_Artigo'],
						$linha['ProductCode'],
						$linha['ProductDescription'],
						$linha['Quantidade'],
						$linha['UnidadeMedida'],
						$linha['PrecoUnitario'],
						$linha['TaxPointDate'],
						$linha['Descricao'],
						$linha['SerialNumber'],
						$linha['ID_Imposto'],
						$linha['TaxType'],
						$linha['TaxCountryRegion'],
						$linha['TaxCode'],
						$linha['TaxPercentage'],
						$linha['TaxExemptionReason'],
						$linha['TaxExemptionCode'],
						$linha['DescontoLinha'],
						$linha['CreditAmount'],
						$linha['DebitAmount'],
						$linha['SettlementAmount'],
						$linha['ValorRetencao'],
						$linha['PercentagemRetencao'],
						$linha['TotalLinha'],
						$linha['TotalLinhaSIVA'],
						$PlanoContasArtigo,
						$PlanoContasTVA
					);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS013";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				// deleteRecord($idFatura);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS014";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			// deleteRecord($idFatura);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
	}

	//agregar novo documento às Guias
	eliminarFaturasOrigem($idsFaturas);

	//log sistema - processo
	$descricao_log ="Agrégation des documents: Brouillon de factures -- Facture (id: ".$idFatura.")";
	insert_log(0,"Inserir",$descricao_log,$sqli_connection);

	// Save all querys on DB
	$sqli_connection->commit();

} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
$response["idDocumento"] = $idFatura;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_faturas WHERE ID_Fatura=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_faturas_linhas WHERE ID_Fatura=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}

//get field from table
function getFieldFromTable($fieldName,$tableName, $whereCondition){
	global $sqli_connection;
	$valorField = '';
	//process
	$query = "SELECT ".$fieldName." FROM ".$tableName." ".$whereCondition." LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELPSPC001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($valorField);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELPSPC002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	if($valorField > 0) return $valorField;
	else return 0;
}

//agregar novo documento às guias
function eliminarFaturasOrigem($idsFaturas){
	global $sqli_connection;

	//Update Guias
	foreach ($idsFaturas as $key => $idOrigem) {
		$query = "DELETE FROM faturacao_faturas WHERE ID_Fatura = ?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idOrigem);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELPSPC003";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELPSPC004";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}
		//LINHAS
		$query = "DELETE FROM faturacao_faturas_linhas WHERE ID_Fatura=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $idOrigem );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "HELPSPC005";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELPSPC006";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}

	return true;
}
?>