<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
$idArtigo = $_POST['idArtigo'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT ID_Artigo,
	Codigo, 
	CodigoBarras, 
	SerialNumber, 
	Nome, 
	(SELECT Nome as categoria FROM faturacao_artigos_categorias WHERE faturacao_artigos_categorias.ID_Categoria=faturacao_artigos.ID_Categoria) AS Categoria, 
	CASE Tipo WHEN 'P' THEN 'Produits' WHEN 'S' THEN 'Services' WHEN 'O' THEN 'Autres' ELSE NULL END AS Tipo,
	PrecoPVP,
	Preco,
	(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS IVA,
	(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto_Fornecedor) AS IVA_Fornecedor,
	(SELECT Descricao as Unidade FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade=faturacao_artigos.ID_Unidade) AS Unidade,
	Ativo,
	Usado,
	RetencaoPercentagem,
	RetencaoValor,
	PlanoContas,
	(SELECT Descricao FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo=faturacao_artigos.PlanoContas) AS DP1,
	PlanoContasCompras,
	(SELECT Descricao FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo=faturacao_artigos.PlanoContasCompras)DP2,
	Stock
	FROM faturacao_artigos WHERE ID_Artigo=?";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idArtigo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	    $objectData['ID_Artigo'],
	    $objectData['Codigo'],
	    $objectData['CodigoBarras'],
	    $objectData['SerialNumber'],
	    $objectData['Nome'],
	    $objectData['Categoria'],
	    $objectData['Tipo'],
	    $objectData['PrecoPVP'],
	    $objectData['Preco'],
	    $objectData['IVA'],
	    $objectData['IVA_Fornecedor'],
	    $objectData['Unidade'],
	    $objectData['Ativo'],
	    $objectData['Usado'],
	    $objectData['RetencaoPercentagem'],
	    $objectData['RetencaoValor'],
	    $objectData['PlanoContas'],
	    $objectData['PlanoContasDesc'],
	    $objectData['PlanoContasCompras'],
	    $objectData['PlanoContasComprasDesc'],
	    $objectData['Stock']
	);
	$stmt -> fetch();
	$stmt -> close();
	
	//calculate Rétention
	$retencaoFinal = 0;
	if($objectData['RetencaoValor'] > 0) $retencaoFinal = $objectData['RetencaoValor'];
	else{
		$taxa = $objectData['RetencaoPercentagem'] * 0.01;
		$retencaoFinal = $objectData['Preco'] * $taxa;
	}
	$objectData['Retencao'] = $retencaoFinal;
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));

?>