<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

//PERMS VALIDATION-------------------------------------------------------
if ( hasPermission(['P0063']) != 1 ) {
	$response["errors"] = true;
	$response["type"] = "permission";
	$response["line"] = "PERM001";
	$response["message"] = "Access is not allowed!";
	die(json_encode($response));
}
//------------------------------------------------------------------------

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
$idArtigo = $_POST['idArtigo'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT ID_Artigo,
	Codigo, 
	CodigoBarras, 
	SerialNumber, 
	Nome, 
	Tipo,
	CASE Tipo WHEN 'P' THEN 'Produits' WHEN 'S' THEN 'Services' WHEN 'O' THEN 'Autres' ELSE NULL END AS TypeExt,
	PrecoPVP,
	Preco,
	(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS IVA,
	(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto_Fornecedor) AS IVA_Fornecedor,
	(SELECT Sigla as Unidade FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade=faturacao_artigos.ID_Unidade) AS Unite_Mesure_Acronyme,
	(SELECT Descricao as Unidade FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade=faturacao_artigos.ID_Unidade) AS Unite_Mesure_Ext,
	Ativo,
	PlanoContas,
	(SELECT Descricao FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo=faturacao_artigos.PlanoContas) AS DP1,
	PlanoContasCompras,
	(SELECT Descricao FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo=faturacao_artigos.PlanoContasCompras)DP2,
	Stock
	FROM faturacao_artigos WHERE ID_Artigo=?";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idArtigo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	    $objectData['ID_Article'],
	    $objectData['Reference'],
	    $objectData['Barcode'],
	    $objectData['SerialNumber'],
	    $objectData['Nom'],
	    $objectData['Type'],
	    $objectData['TypeExt'],
	    $objectData['PrixTTC'],
	    $objectData['PrixHT'],
	    $objectData['TVA_Chiffre_Affaires'],
	    $objectData['TVA_Prealable'],
	    $objectData['Unite_Mesure_Acronyme'],
	    $objectData['Unite_Mesure_Ext'],
	    $objectData['Actif'],
	    $objectData['Plan_Comptable_Chiffre'],
	    $objectData['Plan_Comptable_Chiffre_Description'],
	    $objectData['Plan_Comptable_Prealable'],
	    $objectData['Plan_Comptable_Prealable_Description'],
	    $objectData['Stock']
	);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));

?>