<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idNota = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idNota == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ID_NotaCreditoCompra, 
		ID_Fornecedor, 
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras_notas_credito.ID_Fornecedor) AS NomeFornecedor, 
		(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras_notas_credito.ID_Fornecedor) AS CodigoFornecedor, 
		EnderecoFornecedor, 
		CodigoPostalFornecedor, 
		CidadeFornecedor, 
		RegiaoFornecedor, 
		EmailFornecedor, 
		PaisFornecedor, 
		ID_Moeda, 
		TaxaMoeda,
		Vencimento,
		Numero, 
		Data, 
		Validade, 
		Referencia, 
		Observacoes, 
		PercentagemDesconto, 
		Estado, 
		ID_Utilizador, 
		ID_UtilizadorAtualizacao, 
		MetodoPagamento,
		ID_Banco,
		DataAtualizacao,
		ID_Documento_Origem,
		Tipo_Documento_Origem,
		Reason_Origem,
		GrossTotal,
		TaxPayable,
		NetTotal,
		Desconto,
		TotaRetencao,
		(SELECT (GrossTotal - TotalLiquidado) FROM faturacao_compras WHERE faturacao_compras.ID_Compra = faturacao_compras_notas_credito.ID_Documento_Origem) AS ValorRegler,
		(SELECT Data FROM faturacao_compras WHERE faturacao_compras.ID_Compra = faturacao_compras_notas_credito.ID_Documento_Origem) AS DataOrigem,
		(SELECT Numero FROM faturacao_compras WHERE faturacao_compras.ID_Compra = faturacao_compras_notas_credito.ID_Documento_Origem) AS NumeroOrigem,
		(SELECT Estado FROM faturacao_compras WHERE faturacao_compras.ID_Compra = faturacao_compras_notas_credito.ID_Documento_Origem) AS EstadoOrigem
		FROM faturacao_compras_notas_credito WHERE ID_NotaCreditoCompra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idNota);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_NotaCreditoCompra'],
	        	$objectData['ID_Fornecedor'],
	        	$objectData['NomeFornecedor'],
	        	$objectData['CodigoFornecedor'],
	        	$objectData['EnderecoFornecedor'],
	        	$objectData['CodigoPostalFornecedor'],
	        	$objectData['CidadeFornecedor'],
	        	$objectData['RegiaoFornecedor'],
	        	$objectData['EmailFornecedor'],
	        	$objectData['PaisFornecedor'],
	        	$objectData['ID_Moeda'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['Vencimento'],
	        	$objectData['Numero'],
	        	$objectData['Data'],
	        	$objectData['Validade'],
	        	$objectData['Referencia'],
	        	$objectData['Observacoes'],
	        	$objectData['PercentagemDesconto'],
	        	$objectData['Estado'],
	        	$objectData['ID_Utilizador'],
	        	$objectData['ID_UtilizadorAtualizacao'],
	        	$objectData['MetodoPagamento'],
	        	$objectData['ID_Banco'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['ID_Documento_Origem'],
	        	$objectData['Tipo_Documento_Origem'],
	        	$objectData['Reason_Origem'],
				$objectData['GrossTotal'],
				$objectData['TaxPayable'],
				$objectData['NetTotal'],
				$objectData['Desconto'],
				$objectData['TotaRetencao'],
				$objectData['ValorRegler'],
				$objectData['DataOrigem'],
				$objectData['NumeroOrigem'],
				$objectData['EstadoOrigem']
			);
	$stmt -> fetch();
	$stmt -> close();

	//process origin label
	$ValorRegler = number_format($objectData['ValorRegler'], 2, '.', '\'' ).' CHF';

	$objectData['LabelOrigin'] = $objectData['NumeroOrigem'].' | '.$objectData['DataOrigem'].' | '.$objectData['CodigoFornecedor'].' - '.$objectData['NomeFornecedor'].' | Régler: '.$ValorRegler;

	//validade origem
	$objectData['ValidadeOrigem'] = 0;
	if($objectData['EstadoOrigem'] == 'Aberto') $objectData['ValidadeOrigem'] = 1;
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DA FATURA ------------------------------------------
$query = "SELECT ID_Artigo,
		Descricao,
		Quantidade,
		UnidadeMedida,
		PrecoUnitario,
		ID_Imposto,
		(SELECT ID_Motivo FROM faturacao_motivos_isencao WHERE faturacao_motivos_isencao.Codigo = faturacao_compras_notas_credito_linhas.TaxExemptionCode ) AS ID_Motivo,
		DescontoLinha,
		PercentagemRetencao,
		(SELECT Tipo FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_compras_notas_credito_linhas.ID_Artigo ) AS Tipo,
		ID_LinhaOrigem,
		PlanoContas,
		TotalLinha,
		ProductCode,
		(SELECT CodigoBarras FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_compras_notas_credito_linhas.ID_Artigo)
		FROM faturacao_compras_notas_credito_linhas WHERE ID_NotaCreditoCompra=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idNota);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($artigo, $descricao, $qtd, $unidade, $preco, $imposto, $motivo, $desconto, $retencao, $tipo,$ID_Linha, $PlanoContas, $totalLinha, $codigo_artigo, $codigobarras_artigo );
	while ($stmt -> fetch()) {
		$data[] = array(
		        	"artigo" => $artigo,
					"descricao" => $descricao,
					"qtd" => $qtd,
					"unidade" => $unidade,
					"preco" => $preco,
					"imposto" => $imposto,
					"motivo" => $motivo,
					"desconto" => $desconto,
					"retencao" => $retencao,
					"Tipo" => $tipo,
					"ID_Linha" => $ID_Linha,
					"PlanoContas" => $PlanoContas,
					"totalLinha" => $totalLinha,
					"codigo" => $codigo_artigo,
					"codigobarras" => $codigobarras_artigo,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $data;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>