<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idCompra = $_POST['idCompra'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idCompra == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Data, Numero FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $data, $numeroCompra);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Anulado' || $Estado == 'Pago') {
	$response["errors"] = true;
	$response["bloqueada"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003";
	$response["message"] = "Compra anulada/Paga!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($data) && $data != '' ? $data : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
$dataAtualizacao = date("d/m/Y H:i:s");

// DEFINE NEW NUMBER
$query = "UPDATE faturacao_compras SET ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Anulado' WHERE ID_Compra = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dsd", $id_utilizador, $dataAtualizacao, $idCompra);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//------------------------------------------------------------------------
//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
//------------------------------------------------------------------------
$query = "SELECT PlanoContas, PlanoContasBanco, Numero , 
			(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Codigo, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Fornecedor,
			IFNULL(
				(SELECT SUM(GrossTotal) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totPVPNC,
			IFNULL(
				(SELECT SUM(NetTotal) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totUnitNC,
			IFNULL(
				(SELECT SUM(TaxPayable) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totTVANC,
			GrossTotal,	NetTotal, TaxPayable, Data
		FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoFornecedor, $planoBanco, $numeroDoc, $numFornecedor, $nomeFornecedor, $totalPVP_NC, $totalUnit_NC, $totalTVA_NC, $totalPVP, $totalUnit, $totalTVA, $dataNew );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA029";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//PROCESS MOVEMENT FOR DOCUMENT
$texto = 'Achat (Annulé) - '.$numeroDoc.' - '.$numFornecedor.' - '.$nomeFornecedor;

//calculate values
$totalPVP = $totalPVP - $totalPVP_NC;
$totalUnit = $totalUnit - $totalUnit_NC;
$totalTVA = $totalTVA - $totalTVA_NC;

/*if($planoFornecedor > 0){
	$tipoMovimento = 'D';
	insertMovimentoContabilistico($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento);
}*/

//LINES -- ARTICLES
$query = "SELECT PlanoContas, ProductCode, TotalLinha, TotalLinhaSIVA, (TotalLinha - TotalLinhaSIVA) ,
			IFNULL(
				(SELECT SUM(TotalLinha) FROM faturacao_compras_notas_credito_linhas WHERE faturacao_compras_notas_credito_linhas.ID_LinhaOrigem=faturacao_compras_linhas.ID_Linha ) 
			,0) AS totPVPNC,
			IFNULL(
				(SELECT SUM(TotalLinhaSIVA) FROM faturacao_compras_notas_credito_linhas WHERE faturacao_compras_notas_credito_linhas.ID_LinhaOrigem=faturacao_compras_linhas.ID_Linha ) 
			,0) AS totUnitNC, ID_Imposto
		FROM faturacao_compras_linhas WHERE ID_Compra=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoArtigo, $codigoArtigo, $totalPVP_Artigo, $totalUnit_Artigo, $totalTVA_Artigo,$totalPVP_NC_Artigo, $totalUnit_NC_Artigo, $id_imposto_artigo );
	while ($stmt -> fetch()) {
		//CHECK IF ALREADY CREDITED
		$checker = $totalPVP_Artigo - $totalPVP_NC_Artigo;
		if($checker > 0){
			//PROCESS MOVEMENT ARTICLE
			if($planoArtigo > 0){
				$totalTVA_NC_Artigo = $totalPVP_NC_Artigo - $totalUnit_NC_Artigo;

				$totalPVP_Artigo_Final = $totalPVP_Artigo - $totalPVP_NC_Artigo;
				$totalUnit_Artigo_Final = $totalUnit_Artigo - $totalUnit_NC_Artigo;
				$totalTVA_Artigo_Final = $totalTVA_Artigo - $totalTVA_NC_Artigo;

				$textoArtigo = $texto.' - Article - '.$codigoArtigo;
				$tipoMovimentoArtigo = 'C';
				$dataArtigos[] = array('plano'=>$planoArtigo, 'texto'=>$textoArtigo, 'totalPVP'=>$totalPVP_Artigo_Final, 'totalUnit'=>$totalUnit_Artigo_Final, 'totalTVA'=>$totalTVA_Artigo_Final, 'tipo'=>$tipoMovimentoArtigo, 'id_imposto_artigo'=>$id_imposto_artigo);
			}
		}
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA031";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if(isset($dataArtigos)){
	foreach ($dataArtigos as $line) {
			$Edited_TotalPVP = round($line['totalUnit'],$numDecimais);
			if($Edited_TotalPVP > 0){
				// insertMovimentoContabilistico($line['plano'], $line['texto'], $Edited_TotalPVP, 0, 0, $line['tipo']);
				insertMovimentoContabilisticoManual($planoFornecedor, $line['plano'], $line['texto'], $Edited_TotalPVP, 0, $Edited_TotalPVP, $line['tipo'], $dataNew, 'A', $line['id_imposto_artigo'], 0);
			}
	}
}

//LINES -- TVA
$query = "SELECT (SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_compras_linhas.ID_Imposto), (SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_compras_linhas.ID_Imposto) AS Imposto, 
			TaxPercentage, SUM(TotalLinha), SUM(TotalLinhaSIVA),
			IFNULL(
				(SELECT SUM(TotalLinha) FROM faturacao_compras_notas_credito_linhas WHERE faturacao_compras_notas_credito_linhas.ID_LinhaOrigem=faturacao_compras_linhas.ID_Linha ) 
			,0) AS totPVPNC,
			IFNULL(
				(SELECT SUM(TotalLinhaSIVA) FROM faturacao_compras_notas_credito_linhas WHERE faturacao_compras_notas_credito_linhas.ID_LinhaOrigem=faturacao_compras_linhas.ID_Linha ) 
			,0) AS totUnitNC, ID_Imposto 
		FROM faturacao_compras_linhas WHERE ID_Compra=? GROUP BY ID_Imposto";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA030";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoTVA, $nomeTVA, $percentagemTVA, $totalPVP_TVA, $totalUnit_TVA, $totalPVP_NC_TVA, $totalUnit_NC_TVA, $id_imposto_TVA );
	while ($stmt -> fetch()) {
		//CHECK IF ALREADY CREDITED
		$checker = $totalPVP_TVA - $totalPVP_NC_TVA;
		if($checker > 0){
			//PROCESS MOVEMENT ARTICLE
			if($planoTVA > 0){
				$totalTVA_TVA = $totalPVP_TVA - $totalUnit_TVA;

				$totalTVA_NC_TVA = $totalPVP_NC_TVA - $totalUnit_NC_TVA;

				$totalPVP_TVA_Final = $totalPVP_TVA - $totalPVP_NC_TVA;
				$totalUnit_TVA_Final = $totalUnit_TVA - $totalUnit_NC_TVA;
				$totalTVA_TVA_Final = $totalTVA_TVA - $totalTVA_NC_TVA;
				
				$textoTVA = $texto.' - TVA - '.$nomeTVA.': '.$percentagemTVA.'%';
				$tipoMovimentoTVA = 'C';
				$dataTVA[] = array('plano'=>$planoTVA, 'texto'=>$textoTVA, 'totalPVP'=>$totalPVP_TVA_Final, 'totalUnit'=>$totalUnit_TVA_Final, 'totalTVA'=>$totalTVA_TVA_Final, 'tipo'=>$tipoMovimentoTVA, 'id_imposto_TVA'=>$id_imposto_TVA);
			}
		}
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA031";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if(isset($dataTVA)){
	foreach ($dataTVA as $line) {
		// insertMovimentoContabilistico($line['plano'], $line['texto'], $line['totalTVA'], 0, 0, $line['tipo']);
		insertMovimentoContabilisticoManual($planoFornecedor, $line['plano'], $line['texto'], $line['totalTVA'], 0, $line['totalTVA'], $line['tipo'], $dataNew, 'A', $line['id_imposto_TVA'], 1);
	}
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------


//log sistema - processo
$descricao_log ="Achat - Marquer comme annulé (numéro: ".$numeroCompra.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>