<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idCompra = $_POST['idCompra'];
$data_pagamento = $_POST['data_pagamento'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idCompra == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}
if($data_pagamento == '' ){
	$data_pagamento = date('d/m/Y');
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Numero FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $numeroCompra);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Pago' || $Estado == 'Anulado' ) {
	$response["errors"] = true;
	$response["bloqueada"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003";
	$response["message"] = "Compra já finalizada ou anulada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
$dataAtualizacao = date("d/m/Y H:i:s");

// DEFINE NEW NUMBER
$query = "UPDATE faturacao_compras SET ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Pago', DataPagamento=? WHERE ID_Compra = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssd", $id_utilizador, $dataAtualizacao, $data_pagamento, $idCompra);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//------------------------------------------------------------------------
//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
//------------------------------------------------------------------------
$query = "SELECT PlanoContas, PlanoContasBanco, Numero , 
			(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Codigo, 
			(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Fornecedor,
			IFNULL(
				(SELECT SUM(GrossTotal) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totPVPNC,
			IFNULL(
				(SELECT SUM(NetTotal) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totUnitNC,
			IFNULL(
				(SELECT SUM(TaxPayable) FROM faturacao_compras_notas_credito WHERE ID_Documento_Origem=ID_Compra ) 
			,0) AS totTVANC,
			GrossTotal,	NetTotal, TaxPayable
		FROM faturacao_compras WHERE ID_Compra=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompra);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($planoFornecedor, $planoBanco, $numeroDoc, $numFornecedor, $nomeFornecedor, $totalPVP_NC, $totalUnit_NC, $totalTVA_NC, $totalPVP, $totalUnit, $totalTVA );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA029";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//PROCESS MOVEMENT FOR DOCUMENT
$texto = 'Paiement (Achat) - '.$numeroDoc.' - '.$numFornecedor.' - '.$nomeFornecedor;

//calculate values
$totalPVP = $totalPVP - $totalPVP_NC;
$totalUnit = $totalUnit - $totalUnit_NC;
$totalTVA = $totalTVA - $totalTVA_NC;

/*if($planoFornecedor > 0){
	$tipoMovimento = 'D';
	// insertMovimentoContabilistico($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento);
	insertMovimentoContabilistico($planoFornecedor, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento);
}*/

//PROCESS MOVEMENT FOR DOCUMENT
if($planoBanco > 0){
	$query = "SELECT 
			(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_compras.ID_Banco) AS Banco
		FROM faturacao_compras WHERE ID_Compra=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCompra);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS030";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($nomeBanco);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS031";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//MOVEMENT
	$textoBanco = $texto.' - Banque: '.$nomeBanco;
	// $tipoMovimentoBanco = 'C';
	// insertMovimentoContabilistico($planoBanco, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
	$tipoMovimentoBanco = 'D';
	insertMovimentoContabilistico($planoFornecedor, $planoBanco, $texto, $totalPVP, 0, 0, $tipoMovimento);
} else {
	$tipoMovimentoBanco = 'D';
	insertMovimentoContabilistico($planoFornecedor, '', $texto, $totalPVP, 0, 0, $tipoMovimento);
}

//------------------------------------------------------------------------
//------------------------------------------------------------------------


//log sistema - processo
$descricao_log ="Achat - Marquer comme payé (numéro: ".$numeroCompra.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>