<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET SNC TABLE IN USE --------------------------------------------------
$snc_table = getSncBaseTable();

//GET POST VARS ---------------------------------------------------------
$snc_base_banco = $_POST['snc_base_banco'];
$descricao_banco = $_POST['descricao_banco'];
$bvr_banco = $_POST['bvr_banco'];
$compte_lapost1_banco = $_POST['compte_lapost1_banco'];
$compte_lapost2_banco = $_POST['compte_lapost2_banco'];
$debito_banco = $_POST['debito_banco'];
$credito_banco = $_POST['credito_banco'];
$flagPredefinir = $_POST['flagPredefinir'];
$plano_banco = $_POST['plano_banco'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $snc_base_banco == '' || $descricao_banco == '' || $bvr_banco == '' || $compte_lapost1_banco == '' || $compte_lapost2_banco == '' || $debito_banco == '' || $credito_banco == '' || $plano_banco == ''  ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//RECALCULATE THE ACCOUNT ID ---------------------------------------------
$query = "SELECT MAX(AccountID) FROM faturacao_accounts WHERE ID_SNC = ".$snc_base_banco;
if ($stmt = $sqli_connection -> prepare($query)) { 
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($accountMaxNumber);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

$query = "SELECT Snc_Code, Taxonomy_Code FROM ".$snc_table." WHERE ID_Snc_Base = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $snc_base_banco);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA002";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($sncCode, $taxonomyCode);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//get parent base
$baseParent = substr($sncCode, 0, 2);
// var_dump($baseParent);
if ($accountMaxNumber < 1) {
	$tmpAccount = $sncCode."1";
	$finalAccountNumber = $tmpAccount;
}else{
	$tmpAccount = $accountMaxNumber + 1;
	$finalAccountNumber = $tmpAccount;
}
//------------------------------------------------------------------------

//INSERT DB --------------------------------------------------------------
$query = "INSERT INTO faturacao_accounts (ID_SNC, AccountID, AccountDescription, TaxonomyCode, OpeningDebit, OpeningCredit) VALUES (?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dsssss", $snc_base_banco, $finalAccountNumber, $descricao_banco, $taxonomyCode, $debito_banco, $credito_banco);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//GET THE ID_ACCOUNT -----------------------------------------------------
$query = "SELECT ID_Account FROM faturacao_accounts WHERE AccountID = ".$finalAccountNumber;
if ($stmt = $sqli_connection -> prepare($query)) { 
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA005";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idAccount);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//UPDATE DB (REMOVE ALL PREDEFINIDAS) -----------------------------------
if($flagPredefinir == 1){
	$query = "UPDATE faturacao_bancos_fornecedores SET Predefinido=0";

	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//--------------------------------------------------------------

//INSERT DB --------------------------------------------------------------
$query = "INSERT INTO faturacao_bancos_fornecedores (Nome, DebitoInicial, CreditoInicial, ID_Account, Predefinido, CodigoBVR, CodigoBVR_LP1, CodigoBVR_LP2, PlanoContas) VALUES (?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssddssss", $descricao_banco, $debito_banco, $credito_banco, $idAccount, $flagPredefinir, $bvr_banco, $compte_lapost1_banco, $compte_lapost2_banco, $plano_banco);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS008";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS009";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Création du banque fournisseur  (".$descricao_banco.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>