<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';


$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idAccount = $_POST['idAccount'];
$descricao_conta = $_POST['descricao_conta'];
$debito_conta = $_POST['debito_conta'];
$credito_conta = $_POST['credito_conta'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idAccount == '' || $descricao_conta == '' || $debito_conta == '' || $credito_conta == ''  ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

// CHECK IF CAN BE UPDATED -----------------------------------------------
$query = "SELECT Usado  FROM faturacao_accounts WHERE ID_Account=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idAccount);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $usado );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//Reject if can't be removed
if($usado > 0) {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003";
	$response["message"] = "Conta bloqueada";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//UPDATE DB --------------------------------------------------------------
$query = "UPDATE faturacao_accounts SET AccountDescription=?, OpeningDebit=?, OpeningCredit=? WHERE ID_Account=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssd", $descricao_conta, $debito_conta, $credito_conta, $idAccount);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));
?>