<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
// $idDados = 1;

//DEFINE VARS ------------------------------------------------------------
// $objectData = array();

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT ID_Imposto,
	Nome, 
	Valor, 
	Predefinido, 
	Regiao, 
	Subclasse, 
	Descricao,
	Ativo,
	FinalidadeTexto,
	FinalidadeTipo,
	PlanoContas
	FROM faturacao_impostos ORDER BY PlanoContas, Valor";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	// $stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	    $ID_Imposto,
		$Nome,
		$Valor,
		$Predefinido,
		$Regiao,
		$Subclasse,
		$Descricao,
		$Ativo,
		$FinalidadeTexto,
		$FinalidadeTipo,
		$PlanoContas
	);
	while ($stmt -> fetch()) {
		//Process Selects Fields
		switch ($Regiao) {
			case 'CH': $Regiao = 'Suisse'; break;
			default: $Regiao = 'Suisse'; break;
		}
		switch ($Subclasse) {
			case 'NOR': $Subclasse = 'Taux Normale'; break;
			case 'INT': $Subclasse = 'Taux Intermédiaire'; break;
			case 'RED': $Subclasse = 'Taux Réduit'; break;
			case 'ISE': $Subclasse = 'Exonéré'; break;
			default: break;
		}
		//put data into array
		$data[] = array(
		    'ID_Imposto' => $ID_Imposto,
		    'Nome' => $Nome, 
		    'Valor' => $Valor,
		    'Predefinido' => $Predefinido,
		    'Regiao' => $Regiao,
		    'Subclasse' => $Subclasse,
		    'Descricao' => $Descricao,
		    'Ativo' => $Ativo,
		    'FinalidadeTexto' => $FinalidadeTexto,
		    'FinalidadeTipo' => $FinalidadeTipo,
		    'PlanoContas' => $PlanoContas,
		);
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//CHECK IF THE TAX IS USED -----------------------------------------------
foreach ($data as $key => $value) {
	$ID_ImpostoUsado = 0;
	$query = "SELECT ID_ImpostoUsado FROM faturacao_impostos_usados WHERE ID_Imposto=?";

	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $value['ID_Imposto']);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $ID_ImpostoUsado );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//add info to main array
	if($ID_ImpostoUsado > 0) $data[$key]['Usado'] = 1;
	else $data[$key]['Usado'] = 0;
}

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $data;
die(json_encode($response));

?>