<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$nome_imposto = $_POST['nome_imposto'];
$valor_imposto = $_POST['valor_imposto'];
$regiao_imposto = $_POST['regiao_imposto'];
$subclasse_imposto = $_POST['subclasse_imposto'];
$descricao_imposto = $_POST['descricao_imposto'];
$compte_imposto = $_POST['compte_imposto'];
$typecompte_imposto = $_POST['typecompte_imposto'];
$flagPredefinir = $_POST['flagPredefinir'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $nome_imposto == '' || $valor_imposto == '' || $regiao_imposto == '' || $subclasse_imposto == '' || $compte_imposto == '' || $typecompte_imposto == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

if($typecompte_imposto == 'F'){
	$typecompte_text_imposto = "Impôt préalable";
}else{
	$typecompte_text_imposto = "Impôt sur le chiffre d'affaires";
}

//UPDATE DB (REMOVE ALL PREDEFINIDAS) -----------------------------------
if($flagPredefinir == 1){
	$query = "UPDATE faturacao_impostos SET Predefinido=0 WHERE FinalidadeTipo=?";

	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $typecompte_imposto );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//--------------------------------------------------------------

//INSERT DB -------------------------------------------------------------
$query = "INSERT INTO faturacao_impostos (Nome, Valor, Regiao, Subclasse, Descricao, Predefinido, PlanoContas, FinalidadeTipo, FinalidadeTexto) VALUES (?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssdsss", $nome_imposto, $valor_imposto, $regiao_imposto, $subclasse_imposto, $descricao_imposto, $flagPredefinir, $compte_imposto, $typecompte_imposto, $typecompte_text_imposto );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------

//log sistema - processo
$descricao_log ="Création du TVA (".$nome_imposto.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>