<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idPlano = $_POST['idPlano'];
$plano_contas_plano = $_POST['plano_contas_plano'];
$codigo_plano = $_POST['codigo_plano'];
$descricao_plano = $_POST['descricao_plano'];
$categoria_plano = $_POST['categoria_plano'];
$subcategoria_plano = $_POST['subcategoria_plano'];
$collect_plano = $_POST['collect_plano'];
$ecriture_plano = $_POST['ecriture_plano'];
$iva_plano = $_POST['iva_plano'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idPlano == '' || $plano_contas_plano == '' || $codigo_plano == '' || $descricao_plano == '' || $categoria_plano == '' || $subcategoria_plano == ''  ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//process $iva_plano
if($iva_plano == '' || $iva_plano == null) $iva_plano = null;

//GET THE DETAILS --------------------------------------------------------
$planoCodigo = '';
$planoPlanoCategoria = '';
$planoSubCategoriaPlanoConta = '';
$planoID_CobrancaIVA = '';
$planoEcriture = '';
$processedCode = '';

$query = "SELECT Codigo, PlanoCategoria, SubCategoriaPlanoConta, ID_CobrancaIVA, Ecriture
	FROM faturacao_plano_conta WHERE ID_Plano=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idPlano);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	    $planoCodigo,
	    $planoPlanoCategoria,
	    $planoSubCategoriaPlanoConta,
	    $planoID_CobrancaIVA,
	    $planoEcriture
	);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

$planoUsado = checkPlanoContasUsage($planoCodigo);
//------------------------------------------------------------------------

//UPDATE PARENTS ---------------------------------------------------------
if($planoEcriture == '' || $planoUsado == true ){
	$query = "UPDATE faturacao_plano_conta SET Descricao=?, ID_Imposto=? WHERE ID_Plano=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssd", $descricao_plano, $iva_plano, $idPlano);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001AA";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002BB";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//------------------------------------------------------------------------

//UPDATE CHILDS ----------------------------------------------------------
else{
	//PROCESS THE CODE ---------------------------------------------------
	$query = "SELECT Codigo FROM faturacao_plano_conta WHERE ID_Plano = ?";
	if ($stmt = $sqli_connection -> prepare($query)) { 
		$stmt -> bind_param("d", $plano_contas_plano);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS001A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($codigoBase);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS001A";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	$processedCode = $codigoBase.$codigo_plano;
	//--------------------------------------------------------------------

	if( $processedCode != $planoCodigo){
		//CHECK IF THE ID EXISTS THE ACCOUNT ID --------------------------
		$query = "SELECT COUNT(*) FROM faturacao_plano_conta WHERE Codigo=?";
		if ($stmt = $sqli_connection -> prepare($query)) { 
			$stmt -> bind_param("s", $processedCode);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA002A";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($counterItems);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		if($counterItems > 0){
			$response["errors"] = true;
			$response["type"] = "var";
			$response["existe"] = true;
			$response["line"] = "FATS003A";
			$response["message"] = "Codigo existente";
			die(json_encode($response));
		}
		//----------------------------------------------------------------
	}

	//INSERT DB ----------------------------------------------------------
	$query = "UPDATE faturacao_plano_conta SET Codigo=?, Descricao=?, PlanoCategoria=?, SubCategoriaPlanoConta=?, ID_CobrancaIVA=?, Ecriture=?, ID_Imposto=? WHERE ID_Plano = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssssssd", $processedCode, $descricao_plano, $categoria_plano, $subcategoria_plano, $collect_plano, $ecriture_plano, $iva_plano, $idPlano);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//------------------------------------------------------------------------

if($processedCode == '') $processedCode = $planoCodigo;

//log sistema - processo
$descricao_log ="Édition du compte (".$processedCode.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>