<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idCompteur = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idCompteur == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ID_Compteur,
		(SELECT Numero FROM faturacao_consommables WHERE faturacao_consommables.ID_Consommable = faturacao_consommables_compteurs.ID_Consommable) AS NumeroConsommable,
		(SELECT Debut FROM faturacao_consommables WHERE faturacao_consommables.ID_Consommable = faturacao_consommables_compteurs.ID_Consommable) AS DebutConsommable,
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_clientes,faturacao_consommables WHERE faturacao_clientes.ID_Cliente = faturacao_consommables.ID_Cliente AND faturacao_consommables.ID_Consommable = faturacao_consommables_compteurs.ID_Consommable) AS ClienteConsommable,
		(SELECT Facturation FROM faturacao_consommables WHERE faturacao_consommables.ID_Consommable = faturacao_consommables_compteurs.ID_Consommable) AS FacturationConsommable,
		NumContagem,
		Data, 
		Ficheiro, 
		CASE Faturado WHEN 1 THEN 'Oui' ELSE 'Non' END AS Faturado, 
		ContadorDispositivo, 
		ContagemPreto, 
		ContagemCores,
		UltimaVerificacao, 
		NomeDispositivo, 
		Fabricante, 
		Modelo, 
		NumSerie, 
		MacAddress, 
		EnderecoIP,
		Piso,
		Localizacao,
		NomeAgente,
		VersaoAgente,
		DeviceId,
		Inatividade
		FROM faturacao_consommables_compteurs WHERE ID_Compteur=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCompteur);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Compteur'],
	        	$objectData['NumeroConsommable'],
	        	$objectData['DebutConsommable'],
	        	$objectData['ClienteConsommable'],
	        	$objectData['FacturationConsommable'],
	        	$objectData['NumContagem'],
	        	$objectData['Data'],
	        	$objectData['Ficheiro'],
	        	$objectData['Faturado'],
	        	$objectData['ContadorDispositivo'],
	        	$objectData['ContagemPreto'],
	        	$objectData['ContagemCores'],
	        	$objectData['UltimaVerificacao'],
	        	$objectData['NomeDispositivo'],
	        	$objectData['Fabricante'],
	        	$objectData['Modelo'],
	        	$objectData['NumSerie'],
	        	$objectData['MacAddress'],
	        	$objectData['EnderecoIP'],
	        	$objectData['Piso'],
	        	$objectData['Localizacao'],
	        	$objectData['NomeAgente'],
	        	$objectData['VersaoAgente'],
	        	$objectData['DeviceId'],
	        	$objectData['Inatividade']
			);
	$stmt -> fetch();
	$stmt -> close();

	//processar data sistem
	// $dataNew = DateTime::createFromFormat('Y-m-d H:i:s', $objectData['UltimaVerificacao']);
	// $objectData['UltimaVerificacaoNormal'] = $dataNew->format('d/m/Y');

} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>