<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idConsommable = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idConsommable == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idConsommable == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ID_Consommable,
		Numero,
		ID_Cliente,
		(SELECT CONCAT(Nome, ' ', Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_consommables.ID_Cliente) AS NomeCliente, 
		(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_consommables.ID_Cliente) AS CodigoCliente, 
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_consommables.ID_Cliente) AS Cliente,
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente,
		EnderecoClienteDescarga, 
		EnderecoCliente2Descarga, 
		CodigoPostalClienteDescarga, 
		CidadeClienteDescarga, 
		RegiaoClienteDescarga, 
		EmailClienteDescarga, 
		PaisClienteDescarga,
		ID_Vendedor_Primeiro,
		ID_Vendedor_Segundo,
		(SELECT Nome FROM faturacao_vendedores WHERE faturacao_vendedores.ID_Vendedor = faturacao_consommables.ID_Vendedor_Primeiro) AS VendedorPrimeiro,
		(SELECT Nome FROM faturacao_responsavel_contratos WHERE faturacao_responsavel_contratos.ID_RespContrato = faturacao_consommables.ID_Vendedor_Segundo) AS VendedorSegundo,
		Data,
		Debut,
		Facturation,
		Decompte_pages,
		Paiment,
		Referencia,
		Remarque,
		Prix_noir,
		Prix_couleur,
		Etat_noir,
		Etat_couleur,
		Estado,
		DataCriacao,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_consommables.ID_Utilizador_Criacao) AS ID_Utilizador_Criacao,
		DataAtualizacao,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_consommables.ID_Utilizador_Atualizacao) AS ID_Utilizador_Atualizacao,
		ID_ResponsavelPrimeiro,
		ID_ResponsavelSegundo,
		ForfaitDisponivel,
		ForfaitMensuel,
		ForfaitNoir,
		ForfaitCouleur,
		NomeCliente2,
		ApelidoCliente2
		FROM faturacao_consommables WHERE ID_Consommable=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idConsommable);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Consommable'],
	        	$objectData['Numero'],
	        	$objectData['ID_Cliente'],
	        	$objectData['NomeCliente'],
	        	$objectData['CodigoCliente'],
	        	$objectData['Cliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['EnderecoClienteDescarga'],
	        	$objectData['EnderecoCliente2Descarga'],
	        	$objectData['CodigoPostalClienteDescarga'],
	        	$objectData['CidadeClienteDescarga'],
	        	$objectData['RegiaoClienteDescarga'],
	        	$objectData['EmailClienteDescarga'],
	        	$objectData['PaisClienteDescarga'],
	        	$objectData['ID_VendedorPrimeiro'],
	        	$objectData['ID_VendedorSegundo'],
	        	$objectData['VendedorPrimeiro'],
	        	$objectData['VendedorSegundo'],
	        	$objectData['Data'],
	        	$objectData['Debut'],
	        	$objectData['Facturation'],
	        	$objectData['Decompte_pages'],
	        	$objectData['Paiment'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['Prix_noir'],
	        	$objectData['Prix_couleur'],
	        	$objectData['Etat_noir'],
	        	$objectData['Etat_couleur'],
	        	$objectData['Estado'],
	        	$objectData['DataCriacao'],
	        	$objectData['ID_Utilizador_Criacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['ID_Utilizador_Atualizacao'],
	        	$objectData['ID_ResponsavelPrimeiro'],
	        	$objectData['ID_ResponsavelSegundo'],
	        	$objectData['ForfaitDisponivel'],
	        	$objectData['ForfaitMensuel'],
	        	$objectData['ForfaitNoir'],
	        	$objectData['ForfaitCouleur'],
	        	$objectData['NomeCliente2'],
	        	$objectData['ApelidoCliente2']
			);
	$stmt -> fetch();
	$stmt -> close();

	//processar país
	$objectData['PaisFull'] = getCountryByISO2($objectData['PaisCliente']);

} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DA FATURA ------------------------------------------
$query = "SELECT ID_Linha,
		ID_Artigo,
		NumeroLinha,
		ProductCode,
		ProductDescription,
		SerialNumber,
		Quantidade,
		ProductCode,
		(SELECT CodigoBarras FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_consommables_linhas.ID_Artigo)
		FROM faturacao_consommables_linhas WHERE ID_Consommable=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idConsommable);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($id_linha, $id_artigo, $num_linha, $codigo_artigo, $descricao, $serial_number, $quantidade, $codigo_artigo, $codigobarras_artigo  );
	while ($stmt -> fetch()) {
		$data[] = array(
		        	"id_linha" => $id_linha,
		        	"id_artigo" => $id_artigo,
		        	"num_linha" => $num_linha,
		        	"codigo_artigo" => $codigo_artigo,
		        	"descricao" => $descricao,
		        	"serial_number" => $serial_number,
		        	"quantidade" => $quantidade,
					"codigo" => $codigo_artigo,
					"codigobarras" => $codigobarras_artigo,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $data;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>