<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/Bvr.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idLicence = $_POST['idLicence'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idLicence == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER FINALIZADO ---------------------------------------
$query = "SELECT Estado FROM faturacao_licences WHERE ID_Licence=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idLicence);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado != 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003A";
	$response["message"] = "Licence já processada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//UPDATE DB -------------------------------------------------------------
//prepare vars
$dataAtualizacao = date("d/m/Y H:i:s");
$utilizadorAtualizacao = $id_utilizador;
$estadoUpdate = 'Confirmado';

// DEFINE NEW NUMBER
$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_licences;";
$maxID = getMaxNumberDocument($queryStmt);
$initNumber = 700000 + getInitNumber("NumeroInicial_CLIC","faturacao_personalizar_documentos", "", 0);
if($nextID < $initNumber && $maxID < 1){
	$query = "UPDATE faturacao_licences SET Numero = ".$initNumber.", Estado=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=? WHERE ID_Licence = ?";
}else{
	$query = "UPDATE faturacao_licences SET Numero = (CASE WHEN (SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_licences) AS SubNumeroMaxP) > 0 THEN (SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_licences) AS SubNumeroMaxS) + 1 ELSE 700001 END), Estado=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=? WHERE ID_Licence = ?";
}
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sdsd", $estadoUpdate, $utilizadorAtualizacao, $dataAtualizacao, $idLicence);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------


//log sistema - processo
$descricao_log ="Finalisation du contrat de licence (id: ".$idLicence.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>