<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idLocation = $_POST['idLocation'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idLocation == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ANULADO ------------------------------------------
$query = "SELECT Estado FROM faturacao_locations WHERE ID_Location=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idLocation);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003A";
	$response["message"] = "Location em rascunho!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
if($Estado == 'Anulado') {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003B";
	$response["message"] = "Location já anulada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//UPDATE DB -------------------------------------------------------------
$dataAtualizacao = date("d/m/Y H:i:s");

$query = "UPDATE faturacao_locations SET Estado = 'Anulado', 
		ID_Utilizador_Atualizacao=?, DataAtualizacao=? 
		WHERE ID_Location=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dsd", $id_utilizador, $dataAtualizacao, $idLocation );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------


//log sistema - processo
$descricao_log ="Annulation du contrat de location (id: ".$idLocation.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>