<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
/*Control user*/
/*
 * Script:    DataTables server-side script for PHP and MySQL
 * Copyright: 2010 - Allan Jardine
 * License:   GPL v2 or BSD (3-point)
 * Edited by Pedro Gomes
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Easy set variables
 */

/* Database connection information */
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection_mysql.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

/* Array of database columns which should be read and sent back to DataTables. Use a space where
 * you want to insert a non-database field (for example a counter or static image)
 */
$aColumns = array(
    'Numero',
    'Referencia',
    'IFNULL( CONCAT(NomeCliente," / ",ApelidoCliente), (SELECT CONCAT(Nome," / ",Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_consommables.ID_Cliente) )',
    'STR_TO_DATE( Debut,  "%d/%m/%Y" )',
    'Facturation',
    'EnderecoCliente2Descarga',
    'CASE Estado WHEN "Anulado" THEN "0" ELSE Prix_noir END',
    'CASE Estado WHEN "Anulado" THEN "0" ELSE Prix_couleur END',
    'Estado',
    'ID_Consommable',
    'DataTermo',
    "Arquivado",
);

/* Column to filter*/
$fFilter = array(
    'Numero',
    'Referencia',
    'IFNULL( CONCAT(NomeCliente," / ",ApelidoCliente), (SELECT CONCAT(Nome," / ",Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_consommables.ID_Cliente) )',
    'Debut',
    'Facturation',
    'EnderecoCliente2Descarga',
    'CASE Estado WHEN "Anulado" THEN "0" ELSE Prix_noir END',
    'CASE Estado WHEN "Anulado" THEN "0" ELSE Prix_couleur END',
    'Estado',
    'ID_Consommable',
    'DataTermo',
    "Arquivado",
);

// 'AS' NAMES
$namesColumns = array(
    "Numero",
    "Referencia",
    "NomeCliente",
    "Debut",
    "Facturation",
    "EnderecoCliente2Descarga",
    "Prix_noir",
    'Prix_couleur',
    "Estado",
    "ID_Consommable",
    "DataTermo",
    "Arquivado",
);

/* Indexed column (used for fast and accurate table cardinality) */
$sIndexColumn = "faturacao_consommables.ID_Consommable";

/* DB table to use */
$sTable = "faturacao_consommables";

/*DB Table to count*/
$cTable = "faturacao_consommables";

/*LEFT JOIN Table*/
$sLeft="";

/*Join Table*/
// $sJoin = "ID_Consommable > 0";
if ( isVendedor() == 1 ) {
    $clientsIDs = getVendedorClients();
    $sJoin = "ID_Cliente IN (".$clientsIDs.")";
}else{
    $sJoin = "ID_Consommable > 0";
}

if( isset($_GET['archive']) && $_GET['archive'] == 0) $sJoin .= " AND Arquivado = 0 ";
if( isset($_GET['archive']) && $_GET['archive'] == 1) $sJoin .= " AND Arquivado = 1 ";
if( isset($_GET['archive']) && $_GET['archive'] == 2) $sJoin .= "  ";

// $sOrder_NDoc_First = "CASE Numero WHEN 0 THEN 9999999 ELSE CAST(Numero AS UNSIGNED) END";
$sOrder_NDoc_First = "CASE Numero WHEN 0 THEN 000000 ELSE CAST(Numero AS UNSIGNED) END";

/* 
 * Paging
 */
$sLimit = "";
if ( isset( $_GET['iDisplayStart'] ) && $_GET['iDisplayLength'] != '-1' )
{
    $sLimit = "LIMIT ".mysql_real_escape_string( $_GET['iDisplayStart'] ).", ".
        mysql_real_escape_string( $_GET['iDisplayLength'] );
}


/*
 * Ordering
 */
if ( isset( $_GET['iSortCol_0'] ) )
{
    $sOrder = "ORDER BY  ";
    for ( $i=0 ; $i<intval( $_GET['iSortingCols'] ) ; $i++ )
    {
        if ( $_GET[ 'bSortable_'.intval($_GET['iSortCol_'.$i]) ] == "true" )
        {
            if ($_GET['iSortCol_0'] == 0) {
                $sOrder .= $sOrder_NDoc_First .' '. mysql_real_escape_string($_GET['sSortDir_' . $i]) .', ';
            } else {
                $sOrder .= $aColumns[ intval( $_GET['iSortCol_'.$i] ) ]."
                    ".mysql_real_escape_string( $_GET['sSortDir_'.$i] ) .", ";
            }
        }
    }
    
    $sOrder = substr_replace( $sOrder, "", -2 );
    if ( $sOrder == "ORDER BY" )
    {
        $sOrder = "";
    }
}


/* 
 * Filtering
 * NOTE this does not match the built-in DataTables filtering which does it
 * word by word on any field. It's possible to do here, but concerned about efficiency
 * on very large tables, and MySQL's regex functionality is very limited
 */
    $sWhere = "WHERE " . $sJoin;
if ( $_GET['sSearch'] != "" )
{
    $sWhere = "WHERE ". $sJoin. " AND(";
    
    for ( $i=0 ; $i<count($fFilter) ; $i++ )
    {
        $sWhere .= $fFilter[$i]." LIKE '%".mysql_real_escape_string( $_GET['sSearch'] )."%' OR ";
    }
    $sWhere = substr_replace( $sWhere, "", -3 );
    $sWhere .= ')';
    
}

/* Individual column filtering */
for ( $i=0 ; $i<count($fFilter) ; $i++ )
{
    if ( $_GET['bSearchable_'.$i] == "true" && $_GET['sSearch_'.$i] != '' )
    {
        if ( $sWhere == "" )
        {
            $sWhere = "WHERE ";
        }
        else
        {
            $sWhere .= " AND ";
        }
        $sWhere .= $fFilter[$i]." LIKE '%".mysql_real_escape_string($_GET['sSearch_'.$i])."%' ";
    }
    
}



/*
* Select list
*/
$sSelect = "";
for ( $i=0 ; $i<count($aColumns) ; $i++ )
    {
             $sSelect .= $aColumns[$i] .' as `'.$namesColumns[$i].'`, ';
    }
$sSelect = substr_replace( $sSelect, "", -2 );

/*
 * SQL queries
 * Get data to display
 */
$sQuery = "
    SELECT SQL_CALC_FOUND_ROWS ". $sSelect ."
    FROM   $sTable
    $sWhere 
    $sOrder
    $sLimit
";
// echo $sQuery;
$rResult = executaQuery($sQuery);



/* Data set length after filtering */
$sQuery = "
    SELECT FOUND_ROWS()
";
$rResultFilterTotal = executaQuery($sQuery);
$aResultFilterTotal = mysql_fetch_array($rResultFilterTotal);
$iFilteredTotal = $aResultFilterTotal[0];

/* Total data set length */

$sQuery = "
    SELECT COUNT(".$sIndexColumn.")
    FROM   $cTable
"; 
$rResultTotal = executaQuery($sQuery);
$aResultTotal = mysql_fetch_array($rResultTotal);
$iTotal = $aResultTotal[0];


/*
 * Output
 */
$output = array(
    "sEcho" => intval($_GET['sEcho']),
    "iTotalRecords" => $iTotal,
    "iTotalDisplayRecords" => $iFilteredTotal,
    "aaData" => array()
);

while ( $aRow = mysql_fetch_array( $rResult ) )
{
    
    $row = array();
    for ( $i=0 ; $i<count($namesColumns) ; $i++ )
    {
        if ( $namesColumns[$i] == "version" )
        {
            /* Special output formatting for 'version' column */
            $row[] = ($aRow[ $namesColumns[$i] ]=="0") ? '-' : $aRow[ $namesColumns[$i] ] ;
        }
        else if ( $namesColumns[$i] != ' ' )
        {
            /* General output */
            $row[] = $aRow[ $namesColumns[$i] ];
            
        }
    }
    $output['aaData'][] = $row;
}

echo json_encode( $output );
?>