<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDevis = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idDevis == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Devis -------------------------------------------
$query = "SELECT ID_Devis, 
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_devis.ID_Cliente) AS Cliente, 
		(SELECT Nif FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_devis.ID_Cliente) AS Cliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente, 
		(SELECT CONCAT(Nome,' (',Simbolo,')') FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_devis.ID_Moeda )AS Moeda, 
		(SELECT ISO_Code FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_devis.ID_Moeda )AS ISOCode, 
		(SELECT Simbolo FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_devis.ID_Moeda )AS Simbolo, 
		TaxaMoeda,
		Vencimento,
		(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_devis.ID_Serie) AS Serie,  
		Numero, 
		Data, 
		Validade, 
		Referencia, 
		Observacoes, 
		PercentagemDesconto, 
		Estado, 
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_devis.ID_Utilizador) AS Criador, 
		TimeStampDate, 
		(SELECT Descricao FROM faturacao_metodos_pagamento WHERE faturacao_metodos_pagamento.ID_Metodo = faturacao_devis.MetodoPagamento) AS MetodoPagamento,
		(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_devis.ID_Banco) AS Banco,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_devis.ID_UtilizadorAtualizacao) AS UtilizadorAtualizacao, 
		DataAtualizacao,
		TotalLiquidado,
		TotalPagar,
		Tipo_Doc_Origem,
		ID_Doc_Origem,
		Reference,
		Data_Doc_Origem,
		BVR
		FROM faturacao_devis WHERE ID_Devis=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDevis);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Devis'],
	        	$objectData['Cliente'],
	        	$objectData['Nif'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['Moeda'],
	        	$objectData['IsoCode'],
	        	$objectData['Simbolo'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['Vencimento'],
	        	$objectData['Serie'],
	        	$objectData['Numero'],
	        	$objectData['Data'],
	        	$objectData['Validade'],
	        	$objectData['Referencia'],
	        	$objectData['Observacoes'],
	        	$objectData['PercentagemDesconto'],
	        	$objectData['Estado'],
	        	$objectData['UtilizadorCriador'],
	        	$objectData['DataCriacao'],
	        	$objectData['MetodoPagamento'],
	        	$objectData['Banco'],
	        	$objectData['ID_UtilizadorAtualizacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['TotalLiquidado'],
	        	$objectData['TotalPagar'],
	        	$objectData['Tipo_Doc_Origem'],
	        	$objectData['ID_Doc_Origem'],
	        	$objectData['Reference'],
	        	$objectData['Data_Doc_Origem'],
	        	$objectData['BVR']
			);
	$stmt -> fetch();
	$stmt -> close();

	$objectData['Observacoes'] = nl2br($objectData['Observacoes']);

	$objectData['PaisFull'] = getCountryByISO2($objectData['PaisCliente']);
	$objectData['DataCriacao'] = date('d/m/Y H:i:s', $objectData['DataCriacao']);
	$tempDate = DateTime::createFromFormat('d/m/Y', $objectData['Data']);
	$objectData['DataNormalizada'] = $tempDate->format('Y/m/d');

	//processar totais
	$objectData['TotalLiquidado_Estrangeiro'] = $objectData['TotalLiquidado'] * $objectData['TaxaMoeda'];
	$objectData['TotalPagar_Estrangeiro'] = $objectData['TotalPagar'] * $objectData['TaxaMoeda'];

	//processar BVR
	// $bvr_1 = substr($objectData['BVR'], 0, 2);
	// $bvr_2 = substr($objectData['BVR'], 2);
	// $objectData['BVR'] = $bvr_1 . ' ' . wordwrap($bvr_2, 5, ' ', true);
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DA FATURA ------------------------------------------
$query = "SELECT (SELECT Codigo FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_devis_linhas.ID_Artigo) AS Artigo,
		Descricao,
		Quantidade,
		UnidadeMedida,
		PrecoUnitario,
		ID_Imposto,
		(SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_devis_linhas.ID_Imposto) AS Imposto,
		(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_devis_linhas.ID_Imposto) AS ValorIVA,
		(SELECT ID_Motivo FROM faturacao_motivos_isencao WHERE faturacao_motivos_isencao.Codigo = faturacao_devis_linhas.TaxExemptionCode ) AS ID_Motivo,
		CONCAT(TaxExemptionCode,': ',TaxExemptionReason) AS Motivo,
		DescontoLinha,
		ValorRetencao,
		TotalLinha,
		SerialNumber,
		PlanoContas,
		PlanoContasTVA
		FROM faturacao_devis_linhas WHERE ID_Devis=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDevis);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($artigo, $descricao, $qtd, $unidade, $preco, $idIva, $desc_imposto, $valorIva, $id_motivo, $motivo, $desconto, $retencao, $totalLinha, $serial_number, $PlanoContas, $PlanoContasTVA );
	while ($stmt -> fetch()) {
		$data[] = array(
		        	"artigo" => $artigo,
					"descricao" => nl2br($descricao),
					"qtd" => $qtd,
					"unidade" => $unidade,
					"preco" => $preco,
					"idIva" => $idIva,
					"imposto" => number_format($valorIva,2).'%',
					"desc_imposto" => $desc_imposto,
					"valorIva" => $valorIva,
					"id_motivo" => $id_motivo,
					"motivo" => $motivo,
					"desconto" => $desconto,
					"retencao" => $retencao,
					"totalLinha" => $totalLinha,
					"serial_number" => $serial_number,
					"PlanoContas" => $PlanoContas,
					"PlanoContasTVA" => $PlanoContasTVA,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $data;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>