<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/PHPExcel/PHPExcel.php";

// ini_set('memory_limit', '128M');
// ini_set('max_execution_time', 300);

// ENV VARS
$id_utilizador = $_SESSION['id_utilizador'];

// die('THIS IS BLOCKED');

//INIT VARS
//process filters and related
$dateAccuel = "01/01/".date("Y");
$dateFin = "31/12/".date("Y");
if(isset( $_GET['dateAccuel']) ) $dateAccuel = $_GET['dateAccuel'];
if(isset( $_GET['dateFin']) ) $dateFin = $_GET['dateFin'];
$GLOBALS['dateAccuel'] = $dateAccuel;
$GLOBALS['dateFin'] = $dateFin;

//VALIDATE DATA
if(!$dateAccuel || $dateAccuel == '' || !$dateFin || $dateFin == ''){
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 404 Aucune donnée reçue.');
	header('Location: ../../../404?redirectfrom=/frifacturation/comptabilite/fournisseurs/extrait_documents&redirectto=/frifacturation/comptabilite/fournisseurs/extrait_documents');
}

//START PROCESSING QUERIES
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//log sistema - processo
	$descricao_log ="Exportation de documents: Fournisseurs";
	insert_log(0,"Editar",$descricao_log,$sqli_connection);

	//COMPANY INFO - - - - - - - - - - - - - - - - - - - - - -
	$query = "SELECT  Designacao, Nif, RegistoComercial, Endereco1, Endereco2, CodigoPostal, Cidade, Email, Website, CapitalSocial, Conservatoria, Telefone, Fax, Logotipo, NormaContabilistica, CAE_Principal  from faturacao_empresa_dados LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();

		if (false === $result) {
			$response["errors"] = true;
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($designacao, $nif, $registo_comercial, $endereco1, $endereco2, $codigo_postal, $cidade, $email, $website, $capital_social, $conservatoria, $telefone, $fax, $logotipo, $norma_contabilistica, $cae_principal);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	$GLOBALS['Designacao'] = $designacao;
	$GLOBALS['Nif'] = $nif;
	$GLOBALS['RegistoComercial'] = $registo_comercial;
	$GLOBALS['Endereco1'] = $endereco1;
	$GLOBALS['Endereco2'] = $endereco2;
	$GLOBALS['CodigoPostal'] = $codigo_postal;
	$GLOBALS['Cidade'] = $cidade;
	$GLOBALS['Email'] = $email;
	$GLOBALS['Website'] = $website;
	$GLOBALS['CapitalSocial'] = $capital_social;
	$GLOBALS['Conservatoria'] = $conservatoria;
	$GLOBALS['Telefone'] = $telefone;
	$GLOBALS['Fax'] = $fax;
	$GLOBALS['Logotipo'] = $logotipo;
	$GLOBALS['NormaContabilistica'] = $norma_contabilistica;
	$GLOBALS['CAE_Principal'] = $cae_principal;

	//DOC INFO - - - - - - - - - - - - - - - - - - - - - -
	$fournisseursInfos = array();
	$docsFinaisInfo = array();
	$query = "SELECT ID_Fornecedor, Codigo, CONCAT(Nome,' ',Apelido) AS NomeFornecedor, Endereco, CodigoPostal, Cidade, 

	(SELECT COUNT(*) FROM faturacao_compras WHERE Estado IN ('Aberto','Pago') AND faturacao_compras.ID_Fornecedor = faturacao_fornecedores.ID_Fornecedor AND (
					STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
					) ) AS TotFaturas,

	(SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE Estado IN ('Aberto','Pago') AND faturacao_compras_notas_credito.ID_Fornecedor = faturacao_fornecedores.ID_Fornecedor AND (
					STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
					) ) AS TotNotasCredito, PlanoContas, (SELECT Descricao FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo = faturacao_fornecedores.PlanoContas) AS PlanoContasDescricao
	FROM faturacao_fornecedores ORDER BY CAST(Codigo AS UNSIGNED)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		// $stmt -> bind_param("ss", $dateAccuel, $dateFin);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($ID_Fornecedor, $Codigo, $NomeFornecedor, $Endereco, $CodigoPostal, $Cidade, $TotFaturas, $TotNotasCredito, $PlanoContas, $PlanoContasDescricao);
		while($stmt->fetch()){
			if( $TotFaturas > 0 || $TotNotasCredito > 0 ){
				$fournisseursInfos[] = array(
					"ID_Fornecedor" => $ID_Fornecedor,
					"Codigo" => $Codigo,
					"NomeFornecedor" => $NomeFornecedor,
					"Endereco" => $Endereco,
					"CodigoPostal" => $CodigoPostal,
					"Cidade" => $Cidade,
					"TotFaturas" => $TotFaturas,
					"TotNotasCredito" => $TotNotasCredito,
					"PlanoContas" => $PlanoContas,
					"PlanoContasDescricao" => $PlanoContasDescricao,
					"Documentos" => array(),
					"Solde" => 0,
				);
			}
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));

	}

	//PROCESS CLIENTS
	foreach($fournisseursInfos as $index => $cliente) {
		//INIT VARS
		$documentosCliente = array();
		$soldeTotal = 0;

		//FATURAS
		$ID_Compra = null;
		$DataFatura = null;
		$NumeroFatura = null;
		$ReferenciaFatura = null;
		$GrossTotalFatura = null;
		$NetTotalFatura = null;
		$TaxPayableFatura = null;
		$InvoiceDateFatura = null;

		//GET DOCS FOR THIS CLIENT
		$query1 = "SELECT ID_Compra, Data, CONCAT(Numero) AS NumeroFatura, Referencia, GrossTotal, NetTotal, TaxPayable
			FROM faturacao_compras WHERE Estado IN ('Aberto','Pago') AND ID_Fornecedor = ? 
				AND (
					STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
				) ";
		if ($stmt1 = $sqli_connection -> prepare($query1)) {
			$stmt1 -> bind_param("d", $cliente['ID_Fornecedor']);
			$result1 = $stmt1 -> execute();

			if (false === $result1) {
				$response["errors"] = true;
				$response["message"] = $stmt1 -> error;
				die(json_encode($response));
			}
			$stmt1 -> store_result();
			$stmt1 -> bind_result($ID_Compra, $DataFatura, $NumeroFatura, $ReferenciaFatura, $GrossTotalFatura, $NetTotalFatura, $TaxPayableFatura);
			while($stmt1->fetch()){
				//process date
				$tempDateT = DateTime::createFromFormat('d/m/Y', $DataFatura);
				$InvoiceDateFatura = $tempDateT->format('Y-m-d');

				$tmpArrayFA = array(
					"ID_Documento" => $ID_Compra,
					"DataDocumento" => $DataFatura,
					"NumeroDocumento" => $NumeroFatura,
					"ReferenciaDocumento" => $ReferenciaFatura,
					"GrossTotalDocumento" => $GrossTotalFatura,
					"NetTotalDocumento" => $NetTotalFatura,
					"TaxPayableDocumento" => $TaxPayableFatura,
					"InvoiceDate" => $InvoiceDateFatura,
					"Tipo" => 'FA',
					"DesignacaoCliente" => $cliente['NomeFornecedor'],
				);

				$documentosCliente[] = $tmpArrayFA;
				$docsFinaisInfo[] = $tmpArrayFA;

				//add to solde total
				$soldeTotal = $soldeTotal + $GrossTotalFatura;
			}
			$stmt1 -> close();
		} else {
			$response["errors"] = true;
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//FATURAS
		$ID_NotaCreditoCompra = null;
		$DataNotaCredito = null;
		$NumeroNotaCredito = null;
		$ReferenciaNotaCredito = null;
		$GrossTotalNotaCredito = null;
		$NetTotalNotaCredito = null;
		$TaxPayableNotaCredito = null;
		$InvoiceDateNotaCredito = null;

		//GET DOCS FOR THIS CLIENT
		$query2 = "SELECT ID_NotaCreditoCompra, Data, CONCAT(Numero) AS NumeroNotaCredito, Referencia, GrossTotal, NetTotal, TaxPayable
			FROM faturacao_compras_notas_credito WHERE Estado IN ('Aberto','Pago') AND ID_Fornecedor = ? 
				AND (
					STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
				) ";
		if ($stmt2 = $sqli_connection -> prepare($query2)) {
			$stmt2 -> bind_param("d", $cliente['ID_Fornecedor']);
			$result1 = $stmt2 -> execute();

			if (false === $result1) {
				$response["errors"] = true;
				$response["message"] = $stmt2 -> error;
				die(json_encode($response));
			}
			$stmt2 -> store_result();
			$stmt2 -> bind_result($ID_NotaCreditoCompra, $DataNotaCredito, $NumeroNotaCredito, $ReferenciaNotaCredito, $GrossTotalNotaCredito, $NetTotalNotaCredito, $TaxPayableNotaCredito);
			while($stmt2->fetch()){
				//process date
				$tempDateT = DateTime::createFromFormat('d/m/Y', $DataNotaCredito);
				$InvoiceDateNotaCredito = $tempDateT->format('Y-m-d');

				$tmpArrayNC = array(
					"ID_Documento" => $ID_NotaCreditoCompra,
					"DataDocumento" => $DataNotaCredito,
					"NumeroDocumento" => $NumeroNotaCredito,
					"ReferenciaDocumento" => $ReferenciaNotaCredito,
					"GrossTotalDocumento" => $GrossTotalNotaCredito * (-1),
					"NetTotalDocumento" => $NetTotalNotaCredito * (-1),
					"TaxPayableDocumento" => $TaxPayableNotaCredito * (-1),
					"InvoiceDate" => $InvoiceDateNotaCredito,
					"Tipo" => 'NC',
					"DesignacaoCliente" => $cliente['NomeFornecedor'],
				);

				$documentosCliente[] = $tmpArrayNC;
				$docsFinaisInfo[] = $tmpArrayNC;

				//add to solde total
				$soldeTotal = $soldeTotal + ( $GrossTotalNotaCredito * (-1) );
			}
			$stmt2 -> close();
		} else {
			$response["errors"] = true;
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//organize Dates
		// usort($documentosCliente,'sortMovimentosDateHelper2');

		//add this to client info
		$fournisseursInfos[$index]['Documentos'] = $documentosCliente;
		$fournisseursInfos[$index]['Solde'] = $soldeTotal;
	}

	//organize Dates
	usort($docsFinaisInfo,'sortMovimentosDateHelper2');

	// var_dump($docsFinaisInfo);die();

	$sqli_connection->commit();
} catch (Exception $e) {
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 403 Opération refusée.');
	header('Location: ../../../404?redirectfrom=/frifacturation/comptabilite/fournisseurs/extrait_documents&redirectto=/frifacturation/comptabilite/fournisseurs/extrait_documents');
}


//START PROCESSING EXCEL
$objPHPExcel = new PHPExcel();

//SET HEADER
$firstSheetLine = 'Émis en: ' . date('d/m/Y H:i:s') . ' | Autorisé à: ' . $GLOBALS['Designacao'] . '. - TVA: ' . $GLOBALS['Nif'];
$objPHPExcel->getActiveSheet()->mergeCells('A1:F1')->setCellValue('A1',$firstSheetLine);
$objPHPExcel->getActiveSheet()->mergeCells('A2:F2')->setCellValue('A2','');

$secondSheetLine = 'De: ' . $dateAccuel . ' | à: ' . $dateFin;
$objPHPExcel->getActiveSheet()->mergeCells('A3:F3')->setCellValue('A3',$secondSheetLine);
$objPHPExcel->getActiveSheet()->mergeCells('A4:F4')->setCellValue('A4','');

$styleHeader = array(
	'borders' => array(
		'allborders' => array(
			'style' => PHPExcel_Style_Border::BORDER_MEDIUM,
			'color' => array('rgb' => '000000')
		)
	),
    'alignment' => array(
        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
        'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
    )
);
$objPHPExcel->getActiveSheet()->getStyle("A1:F1")->applyFromArray($styleHeader);
$objPHPExcel->getActiveSheet()->getStyle('A1:F1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setARGB('FFE0E0E0');
$objPHPExcel->getActiveSheet()->getStyle("A3:F3")->applyFromArray($styleHeader);
$objPHPExcel->getActiveSheet()->getStyle('A3:F3')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setARGB('FFE0E0E0');

//SET DOCS HEADER LINE
$objPHPExcel->getActiveSheet()->setCellValue('A5','N° Document');
$objPHPExcel->getActiveSheet()->setCellValue('B5','Fournisseur');
$objPHPExcel->getActiveSheet()->setCellValue('C5','Date de la facture');
$objPHPExcel->getActiveSheet()->setCellValue('D5','Total Payable sans TVA');
$objPHPExcel->getActiveSheet()->setCellValue('E5','TVA');
$objPHPExcel->getActiveSheet()->setCellValue('F5','Total Payable avec TVA');
// $objPHPExcel->getActiveSheet()->mergeCells('C5:F5')->setCellValue('C5','...');

$styleDocHeader = array(
	'borders' => array(
		'allborders' => array(
			'style' => PHPExcel_Style_Border::BORDER_THIN,
			'color' => array('rgb' => '000000')
		)
	),
    'alignment' => array(
        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
        'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
    )
);

$objPHPExcel->getActiveSheet()->getStyle("A5:F5")->applyFromArray($styleDocHeader);
$objPHPExcel->getActiveSheet()->getStyle('A5:F5')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setARGB('FFE0E0E0');

//PROCESS ROWS ===================================================
$styleDocLine = array(
	'borders' => array(
		'allborders' => array(
			'style' => PHPExcel_Style_Border::BORDER_THIN,
			'color' => array('rgb' => '000000')
		)
	),
    'alignment' => array(
        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
        'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
    )
);

//INIT LINE
$posInit = 6;

//SIZE DOCS
$tamDocs = sizeof($docsFinaisInfo);
if($tamDocs < 1) {
	$noDocsLabel = "Il n'y a pas de factures pour cette plage de dates.";
	$objPHPExcel->getActiveSheet()->mergeCells('A7:F7')->setCellValue('A7',$noDocsLabel);
	
	$styleEmpty = array(
	    'alignment' => array(
	        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
	        'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
	    )
	);
	$objPHPExcel->getActiveSheet()->getStyle("A7:F7")->applyFromArray($styleEmpty);
}else{
	//process docs main
	for ($i = 0; $i < $tamDocs; $i++) {
		//process doc
		$totIncidencia = number_format($docsFinaisInfo[$i]['NetTotalDocumento'], $numDecimais, '.', '\'' )." ";
		$totIva = number_format($docsFinaisInfo[$i]['TaxPayableDocumento'], $numDecimais, '.', '\'' )." ";
		$totTotal = number_format($docsFinaisInfo[$i]['GrossTotalDocumento'], $numDecimais, '.', '\'' )." ";

		// //ranges
		// $rangeCli = 'C'.$posInit.':F'.$posInit;
		// $rangeInc = 'G'.$posInit.':H'.$posInit;
		// $rangeIva = 'I'.$posInit.':J'.$posInit;
		// $rangeTot = 'K'.$posInit.':F'.$posInit;
		// $objPHPExcel->getActiveSheet()->mergeCells($rangeCli)->setCellValue('C'.$posInit,$docsFinaisInfo[$i]['DataDocumento']);

		$objPHPExcel->getActiveSheet()->setCellValue('A'.$posInit,$docsFinaisInfo[$i]['NumeroDocumento']);
		$objPHPExcel->getActiveSheet()->setCellValue('B'.$posInit,$docsFinaisInfo[$i]['DesignacaoCliente']);
		$objPHPExcel->getActiveSheet()->setCellValue('C'.$posInit,$docsFinaisInfo[$i]['DataDocumento']);
		$objPHPExcel->getActiveSheet()->setCellValue('D'.$posInit,$totIncidencia);
		$objPHPExcel->getActiveSheet()->setCellValue('E'.$posInit,$totIva);
		$objPHPExcel->getActiveSheet()->setCellValue('F'.$posInit,$totTotal);

		$objPHPExcel->getActiveSheet()->getStyle('A'.$posInit.':F'.$posInit)->applyFromArray($styleDocLine);
		// $objPHPExcel->getActiveSheet()->getStyle('F'.$posInit.':F'.$posInit)->applyFromArray($styleDocLineVals);
				
		//position next line
		$objPHPExcel->getActiveSheet()->getRowDimension($posInit)->setRowHeight(20);
		$posInit++;
		// $objPHPExcel->getActiveSheet()->mergeCells('A'.$posInit.':F'.$posInit)->setCellValue('A'.$posInit,'');
		// $objPHPExcel->getActiveSheet()->getRowDimension($posInit)->setRowHeight(10);
		// $posInit++;
	}
}
//================================================================

//AUTO SET COLS
$objPHPExcel->getActiveSheet()->getColumnDimension('A')->setAutoSize(false)->setWidth(15);
$objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(false)->setWidth(80);
$objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(false)->setWidth(18);
$objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(false)->setWidth(20);
$objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(false)->setWidth(15);
$objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(false)->setWidth(20);
$objPHPExcel->getActiveSheet()->getRowDimension('1')->setRowHeight(20);
$objPHPExcel->getActiveSheet()->getRowDimension('2')->setRowHeight(10);
$objPHPExcel->getActiveSheet()->getRowDimension('3')->setRowHeight(20);
$objPHPExcel->getActiveSheet()->getRowDimension('4')->setRowHeight(10);
$objPHPExcel->getActiveSheet()->getRowDimension('5')->setRowHeight(30);

//SHEET LABEL TITLE
$objPHPExcel->getActiveSheet()->setTitle( 'FACTURES_FOURNISSEURS' );

//FINISH AND OUTPUT FILE
$filename = "Exportation_Docs_Fournisseurs_IU_".$id_utilizador.".xlsx";
$filename2 = "Exportation_Docs_Fournisseurs_".date("Y_m_d_H_i_s").".xlsx";
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter->save(str_replace(__FILE__,$_SERVER['DOCUMENT_ROOT'] .'/docs/frifacturation/excel/'.$filename,__FILE__));

//FORCE DOWNLOAD
header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment;filename="'.$filename2.'"');
header('Cache-Control: max-age=0'); 
$objWriter->save('php://output');


/**
 * ==================================
 * HELPER FUNCTIONS
 * ==================================
 */

/* Compare 2 arrays by value of Date 
 * ASCENDENT
 */
function sortMovimentosDateHelper2($item1,$item2) {
	if ($item1['InvoiceDate'] == $item2['InvoiceDate']) {
		//processa por tipo
		if($item1['Tipo'] != $item2['Tipo']){
			return ($item1['Tipo'] == 'FA') ? -1 : 1;
		}else{
			return ($item1['NumeroDocumento'] > $item2['NumeroDocumento']) ? 1 : -1;
		}
    }
    return ($item1['InvoiceDate'] > $item2['InvoiceDate']) ? 1 : -1;
}

/* Compare 2 arrays by value of Date 
 * DESCENDENT
 */
function sortMovimentosHelper($item1,$item2) {
	if ($item1['InvoiceDate'] == $item2['InvoiceDate']) {
		return ($item1['Tipo'] == 'FA') ? -1 : 1;
        // return 0;
    }
    return ($item1['InvoiceDate'] < $item2['InvoiceDate']) ? 1 : -1;
}
?>