<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idRecibo = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idRecibo == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ID_Recibo, 
		PaymentType, 
		ID_Serie,  
		(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_recibos.ID_Serie) AS Serie,  
		Numero,  
		(SELECT CONCAT(Nome,' (',Simbolo,')') FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_recibos.ID_Moeda )AS Moeda, 
		(SELECT ISO_Code FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_recibos.ID_Moeda )AS ISOCode, 
		(SELECT Simbolo FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_recibos.ID_Moeda )AS Simbolo,
		TaxaMoeda,
		TransactionDate,
		Estado,
		GrossTotal,
		TotalRecebido,
		ValorRetencao,
		ID_DocumentoMain,
		Tipo_DocumentoMain,
		Description
		FROM faturacao_recibos WHERE ID_Recibo=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idRecibo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Recibo'],
	        	$objectData['PaymentType'],
	        	$objectData['ID_Serie'],
	        	$objectData['Serie'],
	        	$objectData['Numero'],
	        	$objectData['Moeda'],
	        	$objectData['ISOCode'],
	        	$objectData['Simbolo'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['TransactionDate'],
	        	$objectData['Estado'],
	        	$objectData['GrossTotal'],
	        	$objectData['TotalRecebido'],
	        	$objectData['ValorRetencao'],
	        	$objectData['ID_DocumentoMain'],
	        	$objectData['Tipo_DocumentoMain'],
	        	$objectData['Description']
			);
	$stmt -> fetch();
	$stmt -> close();

	$objectData['DocumentNumber'] = $objectData['PaymentType'].' '.$objectData['Serie'].'/'.$objectData['Numero'];

	$objectData['Total_Estrangeiro'] = $objectData['GrossTotal'] * $objectData['TaxaMoeda'];

	$objectData['TotalLiquidado'] = $objectData['GrossTotal'] + $objectData['ValorRetencao'];
	$objectData['TotalLiquidadoEstrangeiro'] = $objectData['TotalLiquidado'] * $objectData['TaxaMoeda'];

	$tempDate = DateTime::createFromFormat('Y-m-d', $objectData['TransactionDate']);
	$objectData['DataNormalizada'] = $tempDate->format('Y/m/d');
	$objectData['DataRecibo'] = $tempDate->format('d/m/Y');
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//GET ORIGIN DOC --------------------------------------------------------
$fieldIdName = '';
$tableName = '';
switch ($objectData['Tipo_DocumentoMain']) {
	case 'FT':
		$fieldIdName = 'ID_Fatura';
		$tableName = 'faturacao_faturas';
		break;
	case 'FS':
		$fieldIdName = 'ID_FaturaSimplificada';
		$tableName = 'faturacao_faturas_simplificadas';
		break;
	case 'FR':
		$fieldIdName = 'ID_FaturaRecibo';
		$tableName = 'faturacao_faturas_recibo';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003A";
		$response["message"] = 'Tipo inválido!';
		die(json_encode($response));
		break;
}
$query = "SELECT (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = ".$tableName.".ID_Serie) AS Serie, Numero, Data FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $objectData['ID_DocumentoMain']);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003B";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $serieDocMain, $numeroDocMain, $dataDocMain );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003C";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
$objectData['OriginDoc'] = 'FA '.$serieDocMain.'/'.$numeroDocMain;
$objectData['DataOriginDoc'] = $dataDocMain;
//-----------------------------------------------------------------------

//GET PAYMENT MECHANISM AND BANK ----------------------------------------
$query = "SELECT (SELECT Descricao FROM faturacao_metodos_pagamento WHERE faturacao_metodos_pagamento.ID_Metodo = faturacao_recibos_pagamentos.ID_Metodo) AS Metodo, 
	(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_recibos_pagamentos.ID_Banco) AS Banco 
	FROM faturacao_recibos_pagamentos WHERE ID_Recibo=? LIMIT 1";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idRecibo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003D";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $metodoRecibo, $bancoRecibo );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003C";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
$objectData['Metodo'] = $metodoRecibo;
$objectData['Banco'] = $bancoRecibo;
//-----------------------------------------------------------------------

//OBTEM LINHAS DOCUMENT -------------------------------------------------
$objectData['lines'] = array();
$query = "SELECT TipoDocumento, OriginatingOn, InvoiceDate, CreditAmount, ValorRetencao, valorIVA FROM faturacao_recibos_linhas WHERE ID_Recibo=? ORDER BY ID_Linha";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idRecibo);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($TipoDocumento, $OriginatingOn, $InvoiceDate, $CreditAmount, $ValorRetencao, $valorIVA );
	while ($stmt -> fetch()) {

		$dtReceipt = DateTime::createFromFormat('Y-m-d', $InvoiceDate);
		$dataLinhaProcessed = $dtReceipt->format('d/m/Y');

		$total_linha = ($CreditAmount + $valorIVA) - $ValorRetencao;

		$typeProcessed = '';
		$originatingOnProcessed = '';
		//PROCESS TYPE
		switch ($TipoDocumento) {
			case 'FT':
				$typeProcessed = 'Facture';
				$originatingOnProcessed = str_replace("FT","FA",$OriginatingOn);;
				break;
			case 'FS':
				$typeProcessed = 'Facture Simplifié';
				$originatingOnProcessed = str_replace("FS","FS",$OriginatingOn);;
				break;
			case 'FR':
				$typeProcessed = 'Facture Reçu';
				$originatingOnProcessed = str_replace("FR","FR",$OriginatingOn);;
				break;
			case 'ND':
				$typeProcessed = 'Note de Débit';
				$originatingOnProcessed = str_replace("ND","ND",$OriginatingOn);;
				break;
			
			default:
				$response["errors"] = true;
				$response["type"] = "FATS004A";
				$response["message"] = "Tipo Inválido!";
				die(json_encode($response));
				break;
		}
		
		//Adicionar recibo
		$objectData['lines'][] = array(
		                       		'TipoDocumento' => $TipoDocumento, 
		                       		'TipoDocumentoExtenso' => $typeProcessed, 
		                       		'OriginatingOn' => $originatingOnProcessed, 
		                       		'Data' => $dataLinhaProcessed, 
		                       		'CreditAmount' => $CreditAmount, 
		                       		'ValorRetencao' => $ValorRetencao, 
		                       		'valorIVA' => $valorIVA, 
		                       		'TotalLinha' => $total_linha,
		                       	);
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS004B";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>