<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idFatura = $_POST['idDocument'];
$typeDoc = $_POST['typeDoc'];

//DEFINE VARS ------------------------------------------------------------
$fieldIdName = '';
$tableName = '';
$tipoExtenso = '';
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idFatura == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//MAIN DOCUMENT TABLE NAME
switch ($typeDoc) {
	case 'FT':
		$fieldIdName = 'ID_Fatura';
		$tableName = 'faturacao_faturas';
		$tipoExtenso = 'Fatura';
		break;
	case 'FS':
		$fieldIdName = 'ID_FaturaSimplificada';
		$tableName = 'faturacao_faturas_simplificadas';
		$tipoExtenso = 'Fatura Simplificada';
		break;
	case 'FR':
		$fieldIdName = 'ID_FaturaRecibo';
		$tableName = 'faturacao_faturas_recibo';
		$tipoExtenso = 'Fatura Recibo';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS000B";
		die(json_encode($response));
		break;
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ".$fieldIdName.", 
		ID_Serie,  
		(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = ".$tableName.".ID_Serie) AS Serie,  
		Numero,  
		(SELECT CONCAT(Nome,' (',Simbolo,')') FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS Moeda, 
		(SELECT ISO_Code FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS ISOCode, 
		(SELECT Simbolo FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = ".$tableName.".ID_Moeda )AS Simbolo,
		TaxaMoeda,
		Data, 
		MetodoPagamento,
		ID_Banco,
		TotalLiquidadoDocumento,
		TotalLiquidado,
		TotalPagar,
		TaxPayable AS IVA,
		GrossTotal AS TotalFatura,
		TotaRetencao,
		Estado,
		InvoiceType
		FROM ".$tableName." WHERE ".$fieldIdName."=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Document'],
	        	$objectData['ID_Serie'],
	        	$objectData['Serie'],
	        	$objectData['Numero'],
	        	$objectData['Moeda'],
	        	$objectData['ISOCode'],
	        	$objectData['Simbolo'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['Data'],
	        	$objectData['MetodoPagamento'],
	        	$objectData['ID_Banco'],
	        	$objectData['TotalLiquidadoDocumento'],
	        	$objectData['TotalLiquidado'],
	        	$objectData['TotalPagar'],
	        	$objectData['IVA'],
	        	$objectData['TotalFatura'],
	        	$objectData['TotaRetencao'],
	        	$objectData['Estado'],
	        	$objectData['InvoiceType']
			);
	$stmt -> fetch();
	$stmt -> close();
	
	$objectData['ValorPagavel'] = 0;
	// $objectData['ValorPagavel'] = $objectData['TotalPagar'] - $objectData['TotalLiquidado'];
	// $objectData['ValorPagavel_Estrangeiro'] = $objectData['ValorPagavel'] * $objectData['TaxaMoeda'];

	$tempDate = DateTime::createFromFormat('d/m/Y', $objectData['Data']);
	$objectData['DataNormalizada'] = $tempDate->format('Y/m/d');
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM SERIES ----------------------------------------------------------
$query = "SELECT ID_Serie, Nome, Predefinida FROM faturacao_series ORDER BY Nome";
if ($stmt = $sqli_connection -> prepare($query)) {
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ID_Serie, $Nome, $Predefinida );
	while ($stmt -> fetch()) {
		$objectData['series'][] = array("ID_Serie" => $ID_Serie, "Nome" => $Nome, "Predefinida" => $Predefinida);
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM METODOS PAGAMENTO -----------------------------------------------
$predefinidoID = getValorPadrao('MetodoPagamento','faturacao_personalizar_documentos');

$query = "SELECT ID_Metodo, Descricao, Banco FROM faturacao_metodos_pagamento ORDER BY ID_Metodo";
if ($stmt = $sqli_connection -> prepare($query)) {
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS005";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ID_Metodo, $Descricao, $Banco );
	while ($stmt -> fetch()) {
		$default = 0;
		if($predefinidoID == $ID_Metodo) $default = 1;
		else $default = 0;
		$objectData['metodos'][] = array("ID_Metodo" => $ID_Metodo, "Nome" => $Descricao, "Predefinido" => $default, "Banco" => $Banco );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS006";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM BANCOS ----------------------------------------------------------
$query = "SELECT ID_Banco, Nome, Predefinido FROM faturacao_bancos WHERE Ativo = 1 ORDER BY ID_Banco";
if ($stmt = $sqli_connection -> prepare($query)) {
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS007";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ID_Banco, $Nome, $Predefinido );
	while ($stmt -> fetch()) {
		$objectData['bancos'][] = array("ID_Banco" => $ID_Banco, "Nome" => $Nome, "Predefinido" => $Predefinido );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS008";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM LINHAS ----------------------------------------------------------
$tempLiquidado = round($objectData['TotalLiquidadoDocumento'],$numDecimais);
$tempTotFat = round($objectData['TotalFatura'],$numDecimais);

if( $tempLiquidado < $tempTotFat || $objectData['Estado'] == 'Aberto' || $objectData['Estado'] == 'Pago'){
	//normalizar a data
	$tempDate = DateTime::createFromFormat('d/m/Y', $objectData['Data']);
	$dtNormalizada = $tempDate->format('Y/m/d');

	//processar linha da fatura
	$totalFatura = $objectData['TotalFatura'];
	$porPagar = $objectData['TotalFatura'] - $objectData['TotalLiquidadoDocumento'];
	if($porPagar > 0){
		$ivaRestante = ($porPagar * $objectData['IVA']) / $totalFatura;
		$retencaoRestante = ($porPagar * $objectData['TotaRetencao']) / $totalFatura;
	}else{
		$ivaRestante = 0;
		$retencaoRestante = 0;
	}

	$porPagar = $porPagar;

	$objectData['ValorPagavel'] = $porPagar - $retencaoRestante;
	// $objectData['ValorPagavel_Estrangeiro'] = $objectData['ValorPagavel'] * $objectData['TaxaMoeda'];

	$typeProcessed = '';
		//PROCESS TYPE
		switch ($typeDoc) {
			case 'FT':
				$typeProcessed = 'Facture';
				break;
			case 'FS':
				$typeProcessed = 'Facture Simplifié';
				break;
			case 'FR':
				$typeProcessed = 'Facture Réçu';
				break;
			
			default:
				$response["errors"] = true;
				$response["type"] = "FATS009";
				$response["message"] = "Tipo Inválido!";
				die(json_encode($response));
				break;
		}

	$tmpTotalPagar4dec = $porPagar - $retencaoRestante;
	$tmpTotalPagar4dec = round($tmpTotalPagar4dec, $numDecimais);
	//Adicionar linha da fatura
	$objectData['lines'][] = array(
	                       		'DocID' => $objectData['ID_Document'], 
	                       		'ID_Documento' => $objectData['ID_Document'].$typeDoc, 
	                       		'Tipo' => $typeProcessed, 
	                       		'TipoSmall' => $typeDoc, 
	                       		'Numero' => $typeDoc.' '.$objectData['Serie'].'/'.$objectData['Numero'], 
	                       		'Data' => $objectData['Data'], 
	                       		'DataNormalizada' => $dtNormalizada, 
	                       		'IVA' => $ivaRestante, 
	                       		'Retencao' => $retencaoRestante, 
	                       		'Total_Pagar' => $tmpTotalPagar4dec,
	                       		'Total_com_ret' => $porPagar,
	                       	);
}

// NOTAS DEBITO -----------------------------------------------------
$query = "SELECT ID_NotaDebito, 
		(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_debito.ID_Serie) AS Serie,  
		Numero, 
		Data, 
		TotalLiquidadoDocumento,
		TotalLiquidado,
		TaxPayable AS IVA,
		GrossTotal AS TotalDoc,
		TotaRetencao,
		Estado,
		InvoiceType
		FROM faturacao_notas_debito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado = 'Aberto' ";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("ds", $idFatura, $typeDoc);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS010";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$nd_ID_NotaDebito,
	        	$nd_Serie,
	        	$nd_Numero,
	        	$nd_Data,
	        	$nd_TotalLiquidadoDocumento,
	        	$nd_TotalLiquidado,
	        	$nd_IVA,
	        	$nd_TotalDocumento,
	        	$nd_TotaRetencao,
	        	$nd_Estado,
	        	$nd_InvoiceType
			);
	while ($stmt -> fetch()) {
		$dadosND[] = array(
		         	"ID_NotaDebito" => $nd_ID_NotaDebito,
		        	"Serie" => $nd_Serie,
		        	"Numero" => $nd_Numero,
		        	"Data" => $nd_Data,
		        	"TotalLiquidadoDocumento" => $nd_TotalLiquidadoDocumento,
		        	"TotalLiquidado" => $nd_TotalLiquidado,
		        	"IVA" => $nd_IVA,
		        	"TotalDocumento" => $nd_TotalDocumento,
		        	"TotaRetencao" => $nd_TotaRetencao,
		        	"Estado" => $nd_Estado,
		        	"InvoiceType" => $nd_InvoiceType
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS011";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//PROCESSING VARS AND VALUES ----------------------------------------
if( isset($dadosND) ){
	foreach ($dadosND as $itemND) {
		if($itemND['Estado'] != 'Aberto') {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS012";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//normalizar a data
		$tempDate = DateTime::createFromFormat('d/m/Y', $itemND['Data']);
		$dtNormalizada = $tempDate->format('Y/m/d');

		//processar linha da fatura
		$totalDocumento = $itemND['TotalDocumento'];
		$porPagar = $itemND['TotalDocumento'] - $itemND['TotalLiquidadoDocumento'];
		$ivaRestante = ($porPagar * $itemND['IVA']) / $totalDocumento;
		$retencaoRestante = ($porPagar * $itemND['TotaRetencao']) / $totalDocumento;

		// $porPagar = $porPagar;
		$tmpValorPagavel = $porPagar - $retencaoRestante;
		// $tmpValorPagavel = round($tmpValorPagavel,2);
		$objectData['ValorPagavel'] = $objectData['ValorPagavel'] + $tmpValorPagavel;
		// $objectData['ValorPagavel_Estrangeiro'] = $objectData['ValorPagavel'] * $objectData['TaxaMoeda'];

		$typeProcessed = '';
			//PROCESS TYPE
			switch ($itemND['InvoiceType']) {
				case 'ND':
					$typeProcessed = 'Note de Débit';
					break;
				
				default:
					$response["errors"] = true;
					$response["type"] = "FATS013";
					$response["message"] = "Tipo Inválido!";
					die(json_encode($response));
					break;
			}

		$tmpTotalPagar4dec = $porPagar - $retencaoRestante;
		$tmpTotalPagar4dec = round($tmpTotalPagar4dec, $numDecimais);
		//Adicionar linha da fatura
		$objectData['lines'][] = array(
		                       		'DocID' => $itemND['ID_NotaDebito'], 
		                       		'ID_Documento' => $itemND['ID_NotaDebito'].$itemND['InvoiceType'], 
		                       		'Tipo' => $typeProcessed, 
		                       		'TipoSmall' => $itemND['InvoiceType'], 
		                       		'Numero' => $itemND['InvoiceType'].' '.$itemND['Serie'].'/'.$itemND['Numero'], 
		                       		'Data' => $itemND['Data'], 
		                       		'DataNormalizada' => $dtNormalizada, 
		                       		'IVA' => $ivaRestante, 
		                       		'Retencao' => $retencaoRestante, 
		                       		'Total_Pagar' => $tmpTotalPagar4dec,
		                       		'Total_com_ret' => $porPagar,
		                       	);
	}
}

//Valor pagavel e valor pagavel estrangeiro final adjustments
$objectData['ValorPagavel_Estrangeiro'] = $objectData['ValorPagavel'] * $objectData['TaxaMoeda'];
//final rounds
$objectData['ValorPagavel'] = round($objectData['ValorPagavel'],$numDecimais);
$objectData['ValorPagavel_Estrangeiro'] = round($objectData['ValorPagavel_Estrangeiro'],$numDecimais);
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>