<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idFatura = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idFatura == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS Données de Facture -------------------------------------------
$query = "SELECT ID_Fatura, 
		(SELECT CONCAT(Nome,' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS Cliente, 
		ID_Cliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		EmailCliente, 
		PaisCliente, 
		(SELECT CONCAT(Nome,' (',Simbolo,')') FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_faturas.ID_Moeda )AS Moeda, 
		(SELECT ISO_Code FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_faturas.ID_Moeda )AS ISOCode, 
		(SELECT Simbolo FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_faturas.ID_Moeda )AS Simbolo, 
		TaxaMoeda,
		Vencimento,
		CONCAT('FA ',(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',Numero) AS DocumentReference,  
		(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) AS Serie,  
		ID_Serie,  
		Numero, 
		Data, 
		Validade, 
		Referencia, 
		Observacoes, 
		PercentagemDesconto, 
		Estado, 
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_faturas.ID_Utilizador) AS Criador, 
		TimeStampDate, 
		(SELECT Descricao FROM faturacao_metodos_pagamento WHERE faturacao_metodos_pagamento.ID_Metodo = faturacao_faturas.MetodoPagamento) AS MetodoPagamentoDesc,
		MetodoPagamento,
		(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_faturas.ID_Banco) AS Banco,
		ID_Banco,
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_faturas.ID_UtilizadorAtualizacao) AS UtilizadorAtualizacao, 
		DataAtualizacao,
		TotalLiquidado,
		TotalPagar,
		Tipo_Doc_Origem,
		ID_Doc_Origem,
		Reference,
		Data_Doc_Origem,
		BVR
		FROM faturacao_faturas WHERE ID_Fatura=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Document'],
	        	$objectData['Name_Client'],
	        	$objectData['ID_Client'],
	        	$objectData['Address_Client'],
	        	$objectData['PostalCode_Client'],
	        	$objectData['Localite_Client'],
	        	$objectData['Email_Client'],
	        	$objectData['Country_Client'],
	        	$objectData['Currency'],
	        	$objectData['Currency_ISO'],
	        	$objectData['Currency_Symbol'],
	        	$objectData['Currency_Exchange_Rate'],
	        	$objectData['PaymentConditions'],
	        	$objectData['Number_Document'],
	        	$objectData['Serie'],
	        	$objectData['ID_Serie'],
	        	$objectData['Number'],
	        	$objectData['Date'],
	        	$objectData['Date_Expiry'],
	        	$objectData['Reference'],
	        	$objectData['Observation'],
	        	$objectData['Discount'],
	        	$objectData['Status'],
	        	$objectData['CreatedBy'],
	        	$objectData['CreatedAt_TimeStamp'],
	        	$objectData['PaymentMethodDescription'],
	        	$objectData['PaymentMethod'],
	        	$objectData['Bank'],
	        	$objectData['ID_Bank'],
	        	$objectData['Last_UpdateBy'],
	        	$objectData['Last_UpdateAt'],
	        	$objectData['TotalPayed'],
	        	$objectData['GrossTotal'],
	        	$objectData['Origin_Document_Type'],
	        	$objectData['Origin_Document_ID'],
	        	$objectData['Origin_Document_Reference'],
	        	$objectData['Origin_Document_Date'],
	        	$objectData['BVR']
			);
	$stmt -> fetch();
	$stmt -> close();

	$objectData['Country_Client_Fullname'] = getCountryByISO2($objectData['Country_Client']);
	$objectData['CreatedAt'] = date('d/m/Y H:i:s', $objectData['CreatedAt_TimeStamp']);
	$tempDate = DateTime::createFromFormat('d/m/Y', $objectData['Date']);
	$objectData['NormalizedDate'] = $tempDate->format('Y/m/d');
   	
   	$objectData['Origin_Document_Type_Description'] = "";
	switch ($objectData['Origin_Document_Type']) {
		case 'GT': $objectData['Origin_Document_Type_Description'] = "Bulletin de livraison"; break;
		case 'CL': $objectData['Origin_Document_Type_Description'] = "Contrat location"; break;
		case 'CC': $objectData['Origin_Document_Type_Description'] = "Contrat d'entretien"; break;
		case 'RT': $objectData['Origin_Document_Type_Description'] = "Rapport de travail"; break;
		case 'DV': $objectData['Origin_Document_Type_Description'] = "Devis"; break;
		case 'LC': $objectData['Origin_Document_Type_Description'] = "Contrat licence"; break;
		case 'CA': $objectData['Origin_Document_Type_Description'] = "Contrat d'achat"; break;
		
		default: break;
	}

	$estadoString = '';
	switch ($objectData['Status']) {
		case 'Rascunho': $estadoString = 'Brouillon'; break;
		case 'Aberto': $estadoString = 'Ouvert'; break;
		case 'Pago': $estadoString = 'Payé'; break;
		case 'Anulado': $estadoString = 'Annulé'; break;
		
		default: break;
	}
	$objectData['Status'] = $estadoString;

	//processar totais
	// $objectData['TotalLiquidado_Estrangeiro'] = $objectData['TotalLiquidado'] * $objectData['TaxaMoeda'];
	// $objectData['TotalPagar_Estrangeiro'] = $objectData['TotalPagar'] * $objectData['TaxaMoeda'];

	//processar BVR
	$bvr_1 = substr($objectData['BVR'], 0, 2);
	$bvr_2 = substr($objectData['BVR'], 2);
	$objectData['BVR'] = $bvr_1 . ' ' . wordwrap($bvr_2, 5, ' ', true);
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//PROCESS ORIGIN IF EXISTS ----------------------------------------------
if($objectData['Origin_Document_ID'] > 0){
	$fieldIdName = '';
	$tableName = '';
	switch ($objectData['Origin_Document_Type']) {
		case 'GT':
			$fieldIdName = 'ID_GuiaTransporte';
			$tableName = 'faturacao_guias_transporte';
			$selectQuery = 'DataCarga, HoraCarga, DataDescarga, HoraDescarga';
			break;
		case 'CL':
			$fieldIdName = 'ID_Location';
			$tableName = 'faturacao_locations';
			$selectQuery = 'Duree, Debut';
			break;
		case 'CC':
			$fieldIdName = 'ID_Consommable';
			$tableName = 'faturacao_consommables';
			$selectQuery = 'Paiment, Debut';
			break;
		case 'RT':
			$fieldIdName = 'ID_Rapport';
			$tableName = 'faturacao_rapports_travail';
			$selectQuery = 'TotalPagar, Tecnico, Numero';
			break;
		case 'DV':
			$fieldIdName = 'ID_Devis';
			$tableName = 'faturacao_devis';
			$selectQuery = 'TotalPagar, Validade, Estado';
			break;
		case 'LC':
			$fieldIdName = 'ID_Licence';
			$tableName = 'faturacao_licences';
			$selectQuery = 'Duree, Debut';
			break;
		case 'CA':
			$fieldIdName = 'ID_Achat';
			$tableName = 'faturacao_contrats_achats';
			$selectQuery = 'Debut, PrixAchat';
			break;
		
		default:
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS0000AA";
			$response["message"] = 'Tipo inválido!';
			die(json_encode($response));
			break;
	}

	$query = "SELECT ".$selectQuery." FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ( $stmt = $sqli_connection->prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $objectData['Origin_Document_ID']);
		//result single
		$result = $stmt->execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}

		//result
		switch ($objectData['Origin_Document_Type']) {
			case 'GT':
				$stmt -> bind_result($DataCarga, $HoraCarga, $DataDescarga, $HoraDescarga);
				break;
			case 'CL':
				$stmt -> bind_result($Duree, $Debut);
				break;
			case 'CC':
				$stmt -> bind_result($Paiment, $Debut);
				break;
			case 'RT':
				$stmt -> bind_result($RT_TotalPagar, $RT_Tecnico, $RT_Numero);
				break;
			case 'DV':
				$stmt -> bind_result($DV_TotalPagar, $DV_Validade, $DV_Estado);
				break;
			case 'LC':
				$stmt -> bind_result($Duree, $Debut);
				break;
			case 'CA':
				$stmt -> bind_result($Debut, $PrixAchat);
				break;
			
			default:
				$stmt -> bind_result();
				break;
		}

		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//GET 
	switch ($objectData['Origin_Document_Type']) {
		case 'GT':
			$objectData['GT_DatePickup'] = $DataCarga.' '.$HoraCarga;
			$objectData['GT_DateArrive'] = $DataDescarga.' '.$HoraDescarga;
			break;
		case 'CL':
			$objectData['CL_Duree'] = $Duree;
			$objectData['CL_Debut'] = $Debut;
			break;
		case 'CC':
			$objectData['CC_Paiment'] = $Paiment;
			$objectData['CC_Debut'] = $Debut;
			break;
		case 'RT':
			$objectData['RT_GrossTotal'] = number_format($RT_TotalPagar, 2, '.', '').' CHF';
			$objectData['RT_Technician'] = $RT_Tecnico;
			$objectData['RT_Number'] = $RT_Numero;
			break;
		case 'DV':
			$objectData['DV_GrossTotal'] = number_format($DV_TotalPagar, 2, '.', '').' CHF';
			$objectData['DV_Date_Expiry'] = $DV_Validade;
			$objectData['DV_Status'] = $DV_Estado;
			break;
		case 'LC':
			$objectData['LC_Duree'] = $Duree;
			$objectData['LC_Debut'] = $Debut;
			break;
		case 'CA':
			$objectData['CA_Debut'] = $Debut;
			$objectData['CA_PrixAchat'] = number_format($PrixAchat, 2, '.', '').' CHF';
			break;
		
		default:
			$stmt -> bind_result();
			break;
	}

}
//-----------------------------------------------------------------------

//PROCESS AGREGATION IF EXISTS ------------------------------------------
$query = "SELECT InvoiceType, ID_GuiaTransporte,
	CONCAT('BL ', (SELECT faturacao_series.Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_guias_transporte.ID_Serie),'/',faturacao_guias_transporte.Numero),
	Data, CONCAT(DataCarga,' ',HoraCarga), CONCAT(DataDescarga,' ',HoraDescarga)
		FROM faturacao_guias_transporte WHERE Tipo_DocAgregado='FT' AND ID_DocAgregado=? ORDER BY ID_GuiaTransporte";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Tipo_Doc_Agregado, $ID_Doc_Agregado, $Reference_Agregado, $Data_Doc_Agregado, $DataHoraCarga, $DataHoraDescarga );
	while ($stmt -> fetch()) {
		$dataAgregados[] = array(
		        	"Document_Type" => $Tipo_Doc_Agregado,
		        	"Document_ID" => $ID_Doc_Agregado,
		        	"Document_Number" => $Reference_Agregado,
		        	"Document_Date" => $Data_Doc_Agregado,
		        	"TimePickup" => $DataHoraCarga,
		        	"TimeArrive" => $DataHoraDescarga,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002A";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['Aggregated_Docs'] = $dataAgregados;

//OBTEM AS LINHAS DA FATURA ------------------------------------------
/*$query = "SELECT (SELECT Codigo FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_faturas_linhas.ID_Artigo) AS Artigo,*/
$query = "SELECT ProductCode,
		Descricao,
		Quantidade,
		UnidadeMedida,
		(SELECT ID_Unidade FROM faturacao_unidades WHERE faturacao_unidades.Sigla = faturacao_faturas_linhas.UnidadeMedida) AS ID_UnidadeMedida,
		PrecoUnitario,
		ID_Imposto,
		(SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_faturas_linhas.ID_Imposto) AS Imposto,
		(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_faturas_linhas.ID_Imposto) AS ValorIVA,
		(SELECT ID_Motivo FROM faturacao_motivos_isencao WHERE faturacao_motivos_isencao.Codigo = faturacao_faturas_linhas.TaxExemptionCode ) AS ID_Motivo,
		CONCAT(TaxExemptionCode,': ',TaxExemptionReason) AS Motivo,
		DescontoLinha,
		ValorRetencao,
		TotalLinhaSIVA,
		(TotalLinha - TotalLinhaSIVA) AS TotalIVA,
		TotalLinha,
		SerialNumber,
		PlanoContas,
		PlanoContasTVA
		FROM faturacao_faturas_linhas WHERE ID_Fatura=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($artigo, $descricao, $qtd, $unidade, $unidadeID, $preco, $idIva, $desc_imposto, $valorIva, $id_motivo, $motivo, $desconto, $retencao, $totalSIVA, $totalIVA, $totalLinha, $serial_number, $PlanoContas, $PlanoContasTVA );
	while ($stmt -> fetch()) {
		$data[] = array(
		        	"ID_Article" => $artigo,
					"Description" => nl2br($descricao),
					"Quantity" => $qtd,
					"Unity" => $unidade,
					"ID_Unity" => $unidadeID,
					"PrixHT" => $preco,
					"Tax_ID" => $idIva,
					"Tax_Rate_Formatted" => number_format($valorIva,2).'%',
					"Tax_Description" => $desc_imposto,
					"Tax_Rate" => $valorIva,
					// "id_motivo" => $id_motivo,
					// "motivo" => $motivo,
					"Discount" => $desconto,
					// "retencao" => $retencao,
					"LineNetTotal" => $totalSIVA,
					"LineTaxPayable" => $totalIVA,
					"LineGrossTotal" => $totalLinha,
					"LineNetTotal_Formatted" => number_format($totalSIVA, 2, '.', '').' CHF',
					"LineTaxPayable_Formatted" => number_format($totalIVA, 2, '.', '').' CHF',
					"LineGrossTotal_Formatted" => number_format($totalLinha, 2, '.', '').' CHF',
					"Article_Serial" => $serial_number,
					"Article_Plan_Comptable" => $PlanoContas,
					"Tax_Plan_Comptable" => $PlanoContasTVA,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['lines'] = $data;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>