<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
$idFornecedor = $_POST['idFornecedor'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT ID_Fornecedor,
	Nome,
	Nif,
	Codigo,
	Endereco,
	CodigoPostal,
	Cidade,
	Pais,
	Regiao,
	Email,
	Telefone,
	Telemovel,
	Fax,
	Website,
	(SELECT Nome AS Grupo FROM faturacao_fornecedores_grupos WHERE faturacao_fornecedores_grupos.ID_Grupo = faturacao_fornecedores.ID_Grupo),
	ID_Grupo,
	(SELECT Descricao AS Metodo FROM faturacao_metodos_pagamento WHERE faturacao_metodos_pagamento.ID_Metodo = faturacao_fornecedores.MetPagamento),
	MetPagamento,
	Vencimento,
	Desconto,
	PreferenciaNome,
	PreferenciaTelefone,
	PreferenciaEmail,
	PreferenciaTelemovel,
	(SELECT CONCAT(AccountID,' - ',AccountDescription) AS Account FROM faturacao_accounts WHERE faturacao_accounts.ID_Account = faturacao_fornecedores.ID_Account),
	(SELECT ContaSistema AS ContaGeral FROM faturacao_accounts WHERE faturacao_accounts.ID_Account = faturacao_fornecedores.ID_Account),
	Usado,
	(SELECT SUM(GrossTotal) - SUM(TotalCreditado) FROM faturacao_compras WHERE faturacao_compras.ID_Fornecedor=faturacao_fornecedores.ID_Fornecedor AND Estado IN ('Pago')),
	(SELECT SUM(GrossTotal) - SUM(TotalCreditado) FROM faturacao_compras WHERE faturacao_compras.ID_Fornecedor=faturacao_fornecedores.ID_Fornecedor AND Estado IN ('Aberto', 'Pago')),
	CASE Titulo WHEN 'M' THEN 'Monsieur' WHEN 'Mme' THEN 'Madame' WHEN 'Mlle' THEN 'Mademoiselle' ELSE NULL END,
	Titulo,
	Apelido,
	PlanoContas,
	(SELECT Descricao FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo = faturacao_fornecedores.PlanoContas ) AS PlanoContasDesc,

	TypePayment,
	IBAN,
	BIC_SWIFT,
	ID_BancoFornecedor,
	ComptePostal,
	ID_BVR,
	NumeroCompte,
	(SELECT CONCAT(faturacao_bancos_fornecedores.BCNbr,' - ', faturacao_bancos_fornecedores.Nome) FROM faturacao_bancos_fornecedores WHERE faturacao_bancos_fornecedores.ID_BancoFornecedor=faturacao_fornecedores.ID_BancoFornecedor ) AS BancoLBL
	FROM faturacao_fornecedores WHERE ID_Fornecedor=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFornecedor);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
        $objectData['ID_Fornecedor'],
		$objectData['Nome'],
		$objectData['Nif'],
		$objectData['Codigo'],
		$objectData['Endereco'],
		$objectData['CodigoPostal'],
		$objectData['Cidade'],
		$objectData['Pais'],
		$objectData['Regiao'],
		$objectData['Email'],
		$objectData['Telefone'],
		$objectData['Telemovel'],
		$objectData['Fax'],
		$objectData['Website'],
		$objectData['Grupo'],
		$objectData['GrupoID'],
		$objectData['Metodo'],
		$objectData['MetodoID'],
		$objectData['Vencimento'],
		$objectData['Desconto'],
		$objectData['PreferenciaNome'],
		$objectData['PreferenciaTelefone'],
		$objectData['PreferenciaEmail'],
		$objectData['PreferenciaTelemovel'],
		$objectData['Account'],
		$objectData['ContaGeral'],
		$objectData['Usado'],
		$objectData['Solde'],
		$objectData['Chiffre'],
		$objectData['Titulo'],
		$objectData['TituloSmall'],
		$objectData['Apelido'],
		$objectData['PlanoContas'],
		$objectData['PlanoContasDesc'],

		//NEW BANK FIELDS
		$objectData['TypePayment'],
		$objectData['IBAN'],
		$objectData['BIC_SWIFT'],
		$objectData['ID_BancoFornecedor'],
		$objectData['ComptePostal'],
		$objectData['ID_BVR'],
		$objectData['NumeroCompte'],
		$objectData['BancoLBL']
	);
	$stmt -> fetch();
	$stmt -> close();
		
	$objectData['PaisFull'] = getCountryByISO2($objectData['Pais']);
	$objectData['Solde'] = $objectData['Solde'] - $objectData['Chiffre'];

	//PROCESS NEW BANK FIELDS LBL
	$objectData['TypePaymentLBL'] = '';

	switch ($objectData['TypePayment']) {
		case '826':
			$objectData['TypePaymentLBL'] = 'BVR Orange Banque';
			break;
		case '827':
			$objectData['TypePaymentLBL'] = 'Virement Bank (BV Rouge)';
			break;
		case '836':
			$objectData['TypePaymentLBL'] = 'Virement Étranger';
			break;
		
		default: break;
	}
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//GET RESPONSABLES
$objectData['Responsaveis'] = array();
$query = "SELECT ID_Responsavel,
	(SELECT Codigo FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	(SELECT Nome FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	(SELECT Prenom FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	(SELECT Contacto FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	(SELECT Email FROM faturacao_responsaveis WHERE faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel),
	Posicao
	FROM faturacao_responsavel_entidades WHERE ID_Fornecedor=? ORDER BY Posicao";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $objectData['ID_Fornecedor']);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idResponsavel, $codigo, $nome, $prenom, $contacto, $email, $posicao );
	while ($stmt -> fetch()) {
		$data[] = array(
		        	"id" => $idResponsavel,
		        	"codigo" => $codigo,
		        	"nome" => $nome,
		        	"prenom" => $prenom,
		        	"contacto" => $contacto,
		        	"email" => $email,
		        	"posicao" => $posicao,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
if($data != null) $objectData['Responsaveis'] = $data;
else $objectData['Responsaveis'] = array();
//-----------------------------------------------------------------------

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));

?>