<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];
// $id_utilizador = 2;

//GET POST VARS ---------------------------------------------------------
$idDocumento = $_POST['idDocumento'];
$firstTime = $_POST['firstTime'];
// $idDocumento = $_GET['idDocumento'];
// $firstTime = $_GET['firstTime'];

$codPrixAchat = 'CA0001';
$codPrixInstal = 'CA0002';
$codPrixPrep = 'CA0003';
$codPrixTaxe = 'CA0004';

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idDocumento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["message"] = "ID de document incorrect.";
	$response["line"] = "FATS00A";
	die(json_encode($response));
}
//------------------------------------------------------------------------


//-----------------------------------------------------------------------
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//VERIFICA SE PODE SER GERADO --------------------------------------------
	$query = "SELECT Estado FROM faturacao_contrats_achats WHERE ID_Achat=?";
	if ( $stmt = $sqli_connection->prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt->execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($Estado);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if($Estado == 'Rascunho' ) {
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS003";
		$response["message"] = "Document non valide à générer automatiquement!";
		$response["estado"] = $Estado;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//DEFINE VARS -----------------------------------------------------------
	$objectData = array();

	//OBTEM OS DADOS Licence -----------------------------------------------
	$query = "SELECT ID_Achat, 
			Numero,
			ID_Cliente,
			EnderecoCliente,
			CodigoPostalCliente,
			CidadeCliente,
			RegiaoCliente,
			EmailCliente,
			PaisCliente,
			(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_contrats_achats.ID_Cliente) AS CodigoCliente,
			(SELECT PlanoContas FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_contrats_achats.ID_Cliente) AS PlanoContasCliente,
			ID_Vendedor_Primeiro,
			(SELECT Nome FROM faturacao_vendedores WHERE faturacao_vendedores.ID_Vendedor = faturacao_contrats_achats.ID_Vendedor_Primeiro) AS VendedorPrimeiro,
			ID_Vendedor_Segundo,
			Data,
			Debut,
			Paiment,
			Referencia,
			Remarque,
			PrixAchat,
			PrixInstallation,
			PrixPreparation,
			PrixTaxeAntecipe,
			Estado,
			DataCriacao,
			ID_Utilizador_Criacao,
			DataAtualizacao,
			ID_Utilizador_Atualizacao
			FROM faturacao_contrats_achats WHERE ID_Achat=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		        	$objectData['ID_Achat'],
		        	$objectData['Numero'],
		        	$objectData['ID_Cliente'],
		        	$objectData['EnderecoCliente'],
		        	$objectData['CodigoPostalCliente'],
		        	$objectData['CidadeCliente'],
		        	$objectData['RegiaoCliente'],
		        	$objectData['EmailCliente'],
		        	$objectData['PaisCliente'],
		        	$objectData['CodigoCliente'],
		        	$objectData['PlanoContasCliente'],
		        	$objectData['ID_Vendedor_Primeiro'],
		        	$objectData['VendedorPrimeiro'],
		        	$objectData['ID_Vendedor_Segundo'],
		        	$objectData['Data'],
		        	$objectData['Debut'],
		        	$objectData['Paiment'],
		        	$objectData['Referencia'],
		        	$objectData['Remarque'],
		        	$objectData['PrixAchat'],
		        	$objectData['PrixInstallation'],
		        	$objectData['PrixPreparation'],
		        	$objectData['PrixTaxeAntecipe'],
		        	$objectData['Estado'],
		        	$objectData['DataCriacao'],
		        	$objectData['ID_Utilizador_Criacao'],
		        	$objectData['DataAtualizacao'],
		        	$objectData['ID_Utilizador_Atualizacao']
				);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//GET ARTICLES DETAILS --------------------------------------------------
	$artigo_p_achat = array();
	$query = "SELECT ID_Artigo,
		Codigo, 
		Nome, 
		Tipo,
		PrecoPVP,
		Preco,
		ID_Imposto,
		(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS IVA,
		ID_Imposto_Fornecedor,
		(SELECT Sigla as Unidade FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade=faturacao_artigos.ID_Unidade) AS Unidade,
		PlanoContas,
		PlanoContasCompras,
		SerialNumber,
		(SELECT Tipo FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxType,
		(SELECT Regiao FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxCountryRegion,
		(SELECT Subclasse FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxCode,
		(SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS PlanoContasTVA
		FROM faturacao_artigos WHERE Codigo=?";

	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $codPrixAchat);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		    $artigo_p_achat['ID_Artigo'],
		    $artigo_p_achat['Codigo'],
		    $artigo_p_achat['Nome'],
		    $artigo_p_achat['Tipo'],
		    $artigo_p_achat['PrecoPVP'],
		    $artigo_p_achat['PrecoUn'],
		    $artigo_p_achat['ID_Imposto'],
		    $artigo_p_achat['ValorIVA'],
		    $artigo_p_achat['ID_Imposto_Fornecedor'],
		    $artigo_p_achat['Unidade'],
		    $artigo_p_achat['PlanoContas'],
		    $artigo_p_achat['PlanoContasCompras'],
		    $artigo_p_achat['SerialNumber'],
		    $artigo_p_achat['TaxType'],
		    $artigo_p_achat['TaxCountryRegion'],
		    $artigo_p_achat['TaxCode'],
		    $artigo_p_achat['PlanoContasTVA']
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//Prepare remaing fields
	$artigo_p_achat['numlinha'] = 1;
	$artigo_p_achat['qtd'] = 1;
	$artigo_p_achat['preco'] = 0;
	$artigo_p_achat['preco_unit'] = 0;
	$artigo_p_achat['TaxPointDate'] = date("Y-m-d");
	$artigo_p_achat['TaxExemptionCode'] = '';
	$artigo_p_achat['TaxExemptionReason'] = '';
	$artigo_p_achat['Desconto'] = 0;
	$artigo_p_achat['settelementAmount'] = 0;
	$artigo_p_achat['retencao'] = 0;
	$artigo_p_achat['DebitAmount'] = 0;
	$artigo_p_achat['TotalLinha'] = 0;
	//-----------------------------------------------------------------------

	//GET ARTICLES DETAILS --------------------------------------------------
	$artigo_p_instal = array();
	$query = "SELECT ID_Artigo,
		Codigo, 
		Nome, 
		Tipo,
		PrecoPVP,
		Preco,
		ID_Imposto,
		(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS IVA,
		ID_Imposto_Fornecedor,
		(SELECT Sigla as Unidade FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade=faturacao_artigos.ID_Unidade) AS Unidade,
		PlanoContas,
		PlanoContasCompras,
		SerialNumber,
		(SELECT Tipo FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxType,
		(SELECT Regiao FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxCountryRegion,
		(SELECT Subclasse FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxCode,
		(SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS PlanoContasTVA
		FROM faturacao_artigos WHERE Codigo=?";

	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $codPrixInstal);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS008";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		    $artigo_p_instal['ID_Artigo'],
		    $artigo_p_instal['Codigo'],
		    $artigo_p_instal['Nome'],
		    $artigo_p_instal['Tipo'],
		    $artigo_p_instal['PrecoPVP'],
		    $artigo_p_instal['PrecoUn'],
		    $artigo_p_instal['ID_Imposto'],
		    $artigo_p_instal['ValorIVA'],
		    $artigo_p_instal['ID_Imposto_Fornecedor'],
		    $artigo_p_instal['Unidade'],
		    $artigo_p_instal['PlanoContas'],
		    $artigo_p_instal['PlanoContasCompras'],
		    $artigo_p_instal['SerialNumber'],
		    $artigo_p_instal['TaxType'],
		    $artigo_p_instal['TaxCountryRegion'],
		    $artigo_p_instal['TaxCode'],
		    $artigo_p_instal['PlanoContasTVA']
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS009";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//Prepare remaing fields
	$artigo_p_instal['numlinha'] = 2;
	$artigo_p_instal['qtd'] = 1;
	$artigo_p_instal['preco'] = 0;
	$artigo_p_instal['preco_unit'] = 0;
	$artigo_p_instal['TaxPointDate'] = date("Y-m-d");
	$artigo_p_instal['TaxExemptionCode'] = '';
	$artigo_p_instal['TaxExemptionReason'] = '';
	$artigo_p_instal['Desconto'] = 0;
	$artigo_p_instal['settelementAmount'] = 0;
	$artigo_p_instal['retencao'] = 0;
	$artigo_p_instal['DebitAmount'] = 0;
	$artigo_p_instal['TotalLinha'] = 0;
	//-----------------------------------------------------------------------

	//GET ARTICLES DETAILS --------------------------------------------------
	$artigo_p_prep = array();
	$query = "SELECT ID_Artigo,
		Codigo, 
		Nome, 
		Tipo,
		PrecoPVP,
		Preco,
		ID_Imposto,
		(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS IVA,
		ID_Imposto_Fornecedor,
		(SELECT Sigla as Unidade FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade=faturacao_artigos.ID_Unidade) AS Unidade,
		PlanoContas,
		PlanoContasCompras,
		SerialNumber,
		(SELECT Tipo FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxType,
		(SELECT Regiao FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxCountryRegion,
		(SELECT Subclasse FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxCode,
		(SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS PlanoContasTVA
		FROM faturacao_artigos WHERE Codigo=?";

	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $codPrixPrep);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS008";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		    $artigo_p_prep['ID_Artigo'],
		    $artigo_p_prep['Codigo'],
		    $artigo_p_prep['Nome'],
		    $artigo_p_prep['Tipo'],
		    $artigo_p_prep['PrecoPVP'],
		    $artigo_p_prep['PrecoUn'],
		    $artigo_p_prep['ID_Imposto'],
		    $artigo_p_prep['ValorIVA'],
		    $artigo_p_prep['ID_Imposto_Fornecedor'],
		    $artigo_p_prep['Unidade'],
		    $artigo_p_prep['PlanoContas'],
		    $artigo_p_prep['PlanoContasCompras'],
		    $artigo_p_prep['SerialNumber'],
		    $artigo_p_prep['TaxType'],
		    $artigo_p_prep['TaxCountryRegion'],
		    $artigo_p_prep['TaxCode'],
		    $artigo_p_prep['PlanoContasTVA']
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS009";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//Prepare remaing fields
	$artigo_p_prep['numlinha'] = 3;
	$artigo_p_prep['qtd'] = 1;
	$artigo_p_prep['preco'] = 0;
	$artigo_p_prep['preco_unit'] = 0;
	$artigo_p_prep['TaxPointDate'] = date("Y-m-d");
	$artigo_p_prep['TaxExemptionCode'] = '';
	$artigo_p_prep['TaxExemptionReason'] = '';
	$artigo_p_prep['Desconto'] = 0;
	$artigo_p_prep['settelementAmount'] = 0;
	$artigo_p_prep['retencao'] = 0;
	$artigo_p_prep['DebitAmount'] = 0;
	$artigo_p_prep['TotalLinha'] = 0;
	//-----------------------------------------------------------------------

	//GET ARTICLES DETAILS --------------------------------------------------
	$artigo_p_taxe = array();
	$query = "SELECT ID_Artigo,
		Codigo, 
		Nome, 
		Tipo,
		PrecoPVP,
		Preco,
		ID_Imposto,
		(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS IVA,
		ID_Imposto_Fornecedor,
		(SELECT Sigla as Unidade FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade=faturacao_artigos.ID_Unidade) AS Unidade,
		PlanoContas,
		PlanoContasCompras,
		SerialNumber,
		(SELECT Tipo FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxType,
		(SELECT Regiao FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxCountryRegion,
		(SELECT Subclasse FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS TaxCode,
		(SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto=faturacao_artigos.ID_Imposto) AS PlanoContasTVA
		FROM faturacao_artigos WHERE Codigo=?";

	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $codPrixTaxe);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS008";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		    $artigo_p_taxe['ID_Artigo'],
		    $artigo_p_taxe['Codigo'],
		    $artigo_p_taxe['Nome'],
		    $artigo_p_taxe['Tipo'],
		    $artigo_p_taxe['PrecoPVP'],
		    $artigo_p_taxe['PrecoUn'],
		    $artigo_p_taxe['ID_Imposto'],
		    $artigo_p_taxe['ValorIVA'],
		    $artigo_p_taxe['ID_Imposto_Fornecedor'],
		    $artigo_p_taxe['Unidade'],
		    $artigo_p_taxe['PlanoContas'],
		    $artigo_p_taxe['PlanoContasCompras'],
		    $artigo_p_taxe['SerialNumber'],
		    $artigo_p_taxe['TaxType'],
		    $artigo_p_taxe['TaxCountryRegion'],
		    $artigo_p_taxe['TaxCode'],
		    $artigo_p_taxe['PlanoContasTVA']
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS009";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//Prepare remaing fields
	$artigo_p_taxe['numlinha'] = 3;
	$artigo_p_taxe['qtd'] = 1;
	$artigo_p_taxe['preco'] = 0;
	$artigo_p_taxe['preco_unit'] = 0;
	$artigo_p_taxe['TaxPointDate'] = date("Y-m-d");
	$artigo_p_taxe['TaxExemptionCode'] = '';
	$artigo_p_taxe['TaxExemptionReason'] = '';
	$artigo_p_taxe['Desconto'] = 0;
	$artigo_p_taxe['settelementAmount'] = 0;
	$artigo_p_taxe['retencao'] = 0;
	$artigo_p_taxe['DebitAmount'] = 0;
	$artigo_p_taxe['TotalLinha'] = 0;
	//-----------------------------------------------------------------------

	//CHECK IF ARTICLES EXISTS OR GIVE ERROR --------------------------------
	if( !isset($artigo_p_instal['ID_Artigo']) || $artigo_p_instal['ID_Artigo'] < 1){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["message"] = "Les articles de achat n'existent pas.";
		$response["line"] = "FATS010";
		die(json_encode($response));
	}
	if( !isset($artigo_p_achat['ID_Artigo']) || $artigo_p_achat['ID_Artigo'] < 1){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["message"] = "Les articles de achat n'existent pas.";
		$response["line"] = "FATS011";
		die(json_encode($response));
	}
	if( !isset($artigo_p_prep['ID_Artigo']) || $artigo_p_prep['ID_Artigo'] < 1){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["message"] = "Les articles de achat n'existent pas.";
		$response["line"] = "FATS011";
		die(json_encode($response));
	}
	if( !isset($artigo_p_taxe['ID_Artigo']) || $artigo_p_taxe['ID_Artigo'] < 1){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["message"] = "Les articles de achat n'existent pas.";
		$response["line"] = "FATS011";
		die(json_encode($response));
	}

	//PREPARE VARS ----------------------------------------------------------
	$timestamp = microtime(true);
	$systemEntryDate = date("Y-m-d H:i:s");
	$systemEntryDate = str_replace (' ','T',$systemEntryDate);
	$numeroNew = 0;
	// $dataNew = date("d/m/Y");
	$dataNew = DateTime::createFromFormat('d/m/Y', $objectData['Debut']);
	$dataNew = $dataNew->format('d/m/Y');

	// $dateProcessed = date('Y-m-d', strtotime(" + ".$objectData['Paiment']." days"));
	// $validadeNew = DateTime::createFromFormat('Y-m-d', $dateProcessed);
	$validadeNew = DateTime::createFromFormat('d/m/Y', $objectData['Debut']);
	$validadeNew = $validadeNew->modify('+'.$objectData['Paiment'].' days');
	$validadeNew = $validadeNew->format('d/m/Y');

	$invoiceTypeNew = 'FT';
	$invoiceTypeOrigem = 'CA';
	$totalLiquidadoDocumento = 0;
	$totalLiquidado = 0;
	$estadoNovo = 'Rascunho';
	$idDocOrigem = $idDocumento;
	$referenceDocOrigem = ''.$objectData['Numero'];

	//CLIENT FIELDS
	if( trim($objectData['EnderecoCliente']) == '-' ) $objectData['EnderecoCliente'] = 'Desconhecido';
	if( trim($objectData['CodigoPostalCliente']) == '-' ) $objectData['CodigoPostalCliente'] = 'Desconhecido';
	if( trim($objectData['CidadeCliente']) == '-' ) $objectData['CidadeCliente'] = 'Desconhecido';
	if( trim($objectData['RegiaoCliente']) == '-' ) $objectData['RegiaoCliente'] = 'Desconhecido';
	if( trim($objectData['EmailCliente']) == '-' ) $objectData['EmailCliente'] = 'Desconhecido';
	if( trim($objectData['PaisCliente']) == '-' ) $objectData['PaisCliente'] = 'Desconhecido';

	if( trim($objectData['VendedorPrimeiro']) == '' || $objectData['VendedorPrimeiro'] == null ) $objectData['VendedorPrimeiro'] = '';

	$idMoeda = 1;
	$taxaMoeda = 1;
	$defaultSerie = 0; //select under
	$defaultMetodo = 0;
	$defaultBanco = 0;
	$defaultBancoPlano = 1002;
	$referenciaFatura = 'Contrat de Achat n° '.$objectData['Numero'];
	$observacoesFatura = $objectData['Remarque'];
	$Desconto = 0;
	$PercentagemDesconto = 0;
	$TotaRetencao = 0;
	$TotalSDesconto = 0;
	$EACCode = '';
	$CustomerID = $objectData['CodigoCliente'];

	$TaxPayable = 0;
	$NetTotal = 0;
	$GrossTotal = 0;

	$taxaIVA_location = $artigo_p_achat['ValorIVA'] * 0.01;
	$qtd_location = 1;

	//calcular qtd Licence
	$debutDate = DateTime::createFromFormat('d/m/Y', $objectData['Debut']);
	$m = $debutDate->format('m');
	$y = $debutDate->format('Y');
	$todayYear = date('Y');
	$todayMonth = date('m');

	//TAXA TVA
	$taxaIVA_p_achat = $artigo_p_achat['ValorIVA'] * 0.01;
	$taxaIVA_p_instal = $artigo_p_instal['ValorIVA'] * 0.01;
	$taxaIVA_p_prep = $artigo_p_prep['ValorIVA'] * 0.01;
	$taxaIVA_p_taxe = $artigo_p_taxe['ValorIVA'] * 0.01;
	
	//PRIX UNI. & NET TOTAL
	$artigo_p_achat['preco_unit'] = $objectData['PrixAchat'];
	$NetTotal_p_achat = $artigo_p_achat['qtd'] * $objectData['PrixAchat'];
	$artigo_p_achat['preco'] = $NetTotal_p_achat;

	$artigo_p_instal['preco_unit'] = $objectData['PrixInstallation'];
	$NetTotal_p_instal = $artigo_p_instal['qtd'] * $objectData['PrixInstallation'];
	$artigo_p_instal['preco'] = $NetTotal_p_instal;

	$artigo_p_prep['preco_unit'] = $objectData['PrixPreparation'];
	$NetTotal_p_prep = $artigo_p_prep['qtd'] * $objectData['PrixPreparation'];
	$artigo_p_prep['preco'] = $NetTotal_p_prep;

	$artigo_p_taxe['preco_unit'] = $objectData['PrixTaxeAntecipe'];
	$NetTotal_p_taxe = $artigo_p_taxe['qtd'] * $objectData['PrixTaxeAntecipe'];
	$artigo_p_taxe['preco'] = $NetTotal_p_taxe;

	//NetTotal GLOBAL
	$NetTotal = $NetTotal_p_achat + $NetTotal_p_instal + $NetTotal_p_prep + $NetTotal_p_taxe;

	//TVA GLOBAL
	$TaxPayable = $NetTotal_p_achat * $taxaIVA_p_achat;
	$TaxPayable = $TaxPayable + ($NetTotal_p_instal * $taxaIVA_p_instal);
	$TaxPayable = $TaxPayable + ($NetTotal_p_prep * $taxaIVA_p_prep);
	$TaxPayable = $TaxPayable + ($NetTotal_p_taxe * $taxaIVA_p_taxe);

	//PRIX LINE
	$artigo_p_achat['TotalLinha'] = $NetTotal_p_achat + ($NetTotal_p_achat * $taxaIVA_p_achat);
	$artigo_p_instal['TotalLinha'] = $NetTotal_p_instal + ($NetTotal_p_instal * $taxaIVA_p_instal);
	$artigo_p_prep['TotalLinha'] = $NetTotal_p_prep + ($NetTotal_p_prep * $taxaIVA_p_prep);
	$artigo_p_taxe['TotalLinha'] = $NetTotal_p_taxe + ($NetTotal_p_taxe * $taxaIVA_p_taxe);

	//PRIX TOTAL
	$GrossTotal = $NetTotal + $TaxPayable;

	//rounds
	$NetTotal = round($NetTotal,$numDecimais);
	$TaxPayable = round($TaxPayable,$numDecimais);
	$GrossTotal = round($GrossTotal,$numDecimais);
	$GrossTotal = roundPriceUp($GrossTotal);
	$TotalSDesconto = $NetTotal;

	// var_dump('TotalLinha1 --> '.$artigo_p_achat['TotalLinha'],'<br>','TotalLinha2 --> '.$artigo_p_instal['TotalLinha'],'<br>','<br>');
	// var_dump('TotalLinha3 --> '.$artigo_p_prep['TotalLinha'],'<br>','TotalLinha4 --> '.$artigo_p_taxe['TotalLinha'],'<br>','<br>');
	// var_dump('NetTotal --> '.$NetTotal,'<br>','TaxPayable --> '.$TaxPayable,'<br>','GrossTotal --> '.$GrossTotal);
	// die();

	//GET SERIES DEFAULT ----------------------------------------------------
	$query = "SELECT ID_Serie FROM faturacao_series ORDER BY Predefinida DESC LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS011A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		    $defaultSerie
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS011B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//Confirm SERIE ID
	if( $defaultSerie < 1){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["message"] = "Il n'y a pas de série prédéfinie.";
		$response["line"] = "FATS011C";
		die(json_encode($response));
	}

	//GET METODO DEFAULT ----------------------------------------------------
	$query = "SELECT MetodoPagamento FROM faturacao_personalizar_documentos LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS011D";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		    $defaultMetodo
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS011E";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//Confirm METODO ID
	if( $defaultMetodo < 1){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["message"] = "Il n'y a pas de méthode de paiement par défaut";
		$response["line"] = "FATS011F";
		die(json_encode($response));
	}

	//GET BANCO DEFAULT ----------------------------------------------------
	$query = "SELECT ID_Banco, PlanoContas FROM faturacao_bancos WHERE Ativo = 1 ORDER BY Predefinido DESC LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS011G";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		    $defaultBanco, $defaultBancoPlano 
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS011H";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//Confirm BANCO ID
	if( $defaultBanco < 1){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["message"] = "Aucune banque par défaut n'existe";
		$response["line"] = "FATS011I";
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//INSERT OPEN DOCUMENT --------------------------------------------------
	$query = "INSERT INTO faturacao_faturas(
		ID_Cliente,
		EnderecoCliente,
		CodigoPostalCliente,
		CidadeCliente,
		RegiaoCliente,
		EmailCliente,
		PaisCliente,
		PlanoContas,
		ID_Moeda,
		TaxaMoeda,
		Vendedor,
		Vencimento,
		EnderecoCarga,
		CodigoPostalCarga,
		CidadeCarga,
		RegiaoCarga,
		ID_Serie,
		Numero,
		Data,
		Validade,
		Referencia,
		Observacoes,
		TaxPayable,
		NetTotal,
		GrossTotal,
		SystemEntryDate,
		TimeStampDate,
		Desconto,
		PercentagemDesconto,
		TotaRetencao,
		TotalSDesconto,
		InvoiceType,
		EACCode,
		CustomerID,
		TotalLiquidadoDocumento,
		TotalLiquidado,
		TotalPagar,
		MetodoPagamento,
		ID_Banco,
		PlanoContasBanco,
		Estado,
		ID_Utilizador,
		Tipo_Doc_Origem,
		ID_Doc_Origem,
		Reference,
		Data_Doc_Origem
		) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dsssssssdsssssssddssssssssssssssssssssddsdsdss",
		            $objectData['ID_Cliente'],
		            $objectData['EnderecoCliente'],
		            $objectData['CodigoPostalCliente'],
		            $objectData['CidadeCliente'],
		            $objectData['RegiaoCliente'],
		            $objectData['EmailCliente'],
		            $objectData['PaisCliente'],
		            $objectData['PlanoContasCliente'],
		            $idMoeda,
		            $taxaMoeda,
		            $objectData['VendedorPrimeiro'],
		            $objectData['Paiment'],
		            $objectData['EnderecoCliente'],
		            $objectData['CodigoPostalCliente'],
		            $objectData['CidadeCliente'],
		            $objectData['RegiaoCliente'],
		            $defaultSerie,
		            $numeroNew,
		            $dataNew,
		            $validadeNew,
		            $referenciaFatura,
		            $observacoesFatura,
		            $TaxPayable,
		            $NetTotal,
		            $GrossTotal,
		            $systemEntryDate,
		            $timestamp,
		            $Desconto,
		            $PercentagemDesconto,
		            $TotaRetencao,
		            $TotalSDesconto,
		            $invoiceTypeNew,
		            $EACCode,
		            $CustomerID,
		            $totalLiquidadoDocumento,
		            $totalLiquidado,
		            $GrossTotal,
		            $defaultMetodo,
		            $defaultBanco,
		            $defaultBancoPlano,
		            $estadoNovo,
		            $id_utilizador,
		            $invoiceTypeOrigem,
		            $idDocOrigem,
		            $referenceDocOrigem,
		            $objectData['Data']
		    	);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS012";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS013";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//GET DOCUMENT ID
	$query = "SELECT ID_Fatura FROM faturacao_faturas WHERE TimeStampDate = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $timestamp);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS014";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($idFaturaNew);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS015";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $idFaturaNew < 1){
		$response["errors"] = true;
		$response["type"] = "FATS016";
		$response["message"] = "Une erreur s'est produite lors de la création de la facture.";
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//PROCESS THE LINES (1) --------------------------------------------------
	$query = "INSERT INTO faturacao_faturas_linhas (
			ID_Fatura, 
			NumeroLinha, 
			ID_Artigo, 
			ProductCode, 
			ProductDescription, 
			Quantidade, 
			UnidadeMedida, 
			PrecoUnitario, 
			TaxPointDate, 
			Descricao, 
			SerialNumber, 
			ID_Imposto, 
			TaxType, 
			TaxCountryRegion, 
			TaxCode, 
			TaxPercentage, 
			TaxExemptionReason, 
			TaxExemptionCode, 
			DescontoLinha, 
			CreditAmount, 
			DebitAmount, 
			SettlementAmount, 
			ValorRetencao, 
			PercentagemRetencao, 
			TotalLinha, 
			TotalLinhaSIVA, 
			PlanoContas, 
			PlanoContasTVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssssss", 
		        $idFaturaNew, 
		        $artigo_p_achat['numlinha'], 
		        $artigo_p_achat['ID_Artigo'], 
		        $artigo_p_achat['Codigo'], 
		        $artigo_p_achat['Nome'], 
		        $artigo_p_achat['qtd'], 
		        $artigo_p_achat['Unidade'], 
		        $artigo_p_achat['preco_unit'], 
		        $artigo_p_achat['TaxPointDate'], 
		        $artigo_p_achat['Nome'], 
		        $artigo_p_achat['SerialNumber'], 
		        $artigo_p_achat['ID_Imposto'], 
		        $artigo_p_achat['TaxType'], 
		        $artigo_p_achat['TaxCountryRegion'], 
		        $artigo_p_achat['TaxCode'], 
		        $artigo_p_achat['ValorIVA'], 
		        $artigo_p_achat['TaxExemptionReason'], 
		        $artigo_p_achat['TaxExemptionCode'], 
		        $artigo_p_achat['Desconto'], 
		        $artigo_p_achat['preco'], 
		        $artigo_p_achat['DebitAmount'], 
		        $artigo_p_achat['settelementAmount'], 
		        $artigo_p_achat['retencao'], 
		        $artigo_p_achat['retencao'], 
		        $artigo_p_achat['TotalLinha'], 
		        $artigo_p_achat['preco'], 
		        $artigo_p_achat['PlanoContas'], 
		        $artigo_p_achat['PlanoContasTVA'] 
		    );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS017";
			$response["message"] = $stmt -> error;
			deleteRecord($idFaturaNew);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS018";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idFaturaNew);
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//PROCESS THE LINES (2) --------------------------------------------------
	$query = "INSERT INTO faturacao_faturas_linhas (
			ID_Fatura, 
			NumeroLinha, 
			ID_Artigo, 
			ProductCode, 
			ProductDescription, 
			Quantidade, 
			UnidadeMedida, 
			PrecoUnitario, 
			TaxPointDate, 
			Descricao, 
			SerialNumber, 
			ID_Imposto, 
			TaxType, 
			TaxCountryRegion, 
			TaxCode, 
			TaxPercentage, 
			TaxExemptionReason, 
			TaxExemptionCode, 
			DescontoLinha, 
			CreditAmount, 
			DebitAmount, 
			SettlementAmount, 
			ValorRetencao, 
			PercentagemRetencao, 
			TotalLinha, 
			TotalLinhaSIVA, 
			PlanoContas, 
			PlanoContasTVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssssss", 
		        $idFaturaNew, 
		        $artigo_p_instal['numlinha'], 
		        $artigo_p_instal['ID_Artigo'], 
		        $artigo_p_instal['Codigo'], 
		        $artigo_p_instal['Nome'], 
		        $artigo_p_instal['qtd'], 
		        $artigo_p_instal['Unidade'], 
		        $artigo_p_instal['preco_unit'], 
		        $artigo_p_instal['TaxPointDate'], 
		        $artigo_p_instal['Nome'], 
		        $artigo_p_instal['SerialNumber'], 
		        $artigo_p_instal['ID_Imposto'], 
		        $artigo_p_instal['TaxType'], 
		        $artigo_p_instal['TaxCountryRegion'], 
		        $artigo_p_instal['TaxCode'], 
		        $artigo_p_instal['ValorIVA'], 
		        $artigo_p_instal['TaxExemptionReason'], 
		        $artigo_p_instal['TaxExemptionCode'], 
		        $artigo_p_instal['Desconto'], 
		        $artigo_p_instal['preco'], 
		        $artigo_p_instal['DebitAmount'], 
		        $artigo_p_instal['settelementAmount'], 
		        $artigo_p_instal['retencao'], 
		        $artigo_p_instal['retencao'], 
		        $artigo_p_instal['TotalLinha'], 
		        $artigo_p_instal['preco'], 
		        $artigo_p_instal['PlanoContas'], 
		        $artigo_p_instal['PlanoContasTVA'] 
		    );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS019";
			$response["message"] = $stmt -> error;
			deleteRecord($idFaturaNew);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS020";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idFaturaNew);
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//PROCESS THE LINES (3) --------------------------------------------------
	$query = "INSERT INTO faturacao_faturas_linhas (
			ID_Fatura, 
			NumeroLinha, 
			ID_Artigo, 
			ProductCode, 
			ProductDescription, 
			Quantidade, 
			UnidadeMedida, 
			PrecoUnitario, 
			TaxPointDate, 
			Descricao, 
			SerialNumber, 
			ID_Imposto, 
			TaxType, 
			TaxCountryRegion, 
			TaxCode, 
			TaxPercentage, 
			TaxExemptionReason, 
			TaxExemptionCode, 
			DescontoLinha, 
			CreditAmount, 
			DebitAmount, 
			SettlementAmount, 
			ValorRetencao, 
			PercentagemRetencao, 
			TotalLinha, 
			TotalLinhaSIVA, 
			PlanoContas, 
			PlanoContasTVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssssss", 
		        $idFaturaNew, 
		        $artigo_p_prep['numlinha'], 
		        $artigo_p_prep['ID_Artigo'], 
		        $artigo_p_prep['Codigo'], 
		        $artigo_p_prep['Nome'], 
		        $artigo_p_prep['qtd'], 
		        $artigo_p_prep['Unidade'], 
		        $artigo_p_prep['preco_unit'], 
		        $artigo_p_prep['TaxPointDate'], 
		        $artigo_p_prep['Nome'], 
		        $artigo_p_prep['SerialNumber'], 
		        $artigo_p_prep['ID_Imposto'], 
		        $artigo_p_prep['TaxType'], 
		        $artigo_p_prep['TaxCountryRegion'], 
		        $artigo_p_prep['TaxCode'], 
		        $artigo_p_prep['ValorIVA'], 
		        $artigo_p_prep['TaxExemptionReason'], 
		        $artigo_p_prep['TaxExemptionCode'], 
		        $artigo_p_prep['Desconto'], 
		        $artigo_p_prep['preco'], 
		        $artigo_p_prep['DebitAmount'], 
		        $artigo_p_prep['settelementAmount'], 
		        $artigo_p_prep['retencao'], 
		        $artigo_p_prep['retencao'], 
		        $artigo_p_prep['TotalLinha'], 
		        $artigo_p_prep['preco'], 
		        $artigo_p_prep['PlanoContas'], 
		        $artigo_p_prep['PlanoContasTVA'] 
		    );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS019";
			$response["message"] = $stmt -> error;
			deleteRecord($idFaturaNew);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS020";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idFaturaNew);
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//PROCESS THE LINES (4) --------------------------------------------------
	$query = "INSERT INTO faturacao_faturas_linhas (
			ID_Fatura, 
			NumeroLinha, 
			ID_Artigo, 
			ProductCode, 
			ProductDescription, 
			Quantidade, 
			UnidadeMedida, 
			PrecoUnitario, 
			TaxPointDate, 
			Descricao, 
			SerialNumber, 
			ID_Imposto, 
			TaxType, 
			TaxCountryRegion, 
			TaxCode, 
			TaxPercentage, 
			TaxExemptionReason, 
			TaxExemptionCode, 
			DescontoLinha, 
			CreditAmount, 
			DebitAmount, 
			SettlementAmount, 
			ValorRetencao, 
			PercentagemRetencao, 
			TotalLinha, 
			TotalLinhaSIVA, 
			PlanoContas, 
			PlanoContasTVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssssss", 
		        $idFaturaNew, 
		        $artigo_p_taxe['numlinha'], 
		        $artigo_p_taxe['ID_Artigo'], 
		        $artigo_p_taxe['Codigo'], 
		        $artigo_p_taxe['Nome'], 
		        $artigo_p_taxe['qtd'], 
		        $artigo_p_taxe['Unidade'], 
		        $artigo_p_taxe['preco_unit'], 
		        $artigo_p_taxe['TaxPointDate'], 
		        $artigo_p_taxe['Nome'], 
		        $artigo_p_taxe['SerialNumber'], 
		        $artigo_p_taxe['ID_Imposto'], 
		        $artigo_p_taxe['TaxType'], 
		        $artigo_p_taxe['TaxCountryRegion'], 
		        $artigo_p_taxe['TaxCode'], 
		        $artigo_p_taxe['ValorIVA'], 
		        $artigo_p_taxe['TaxExemptionReason'], 
		        $artigo_p_taxe['TaxExemptionCode'], 
		        $artigo_p_taxe['Desconto'], 
		        $artigo_p_taxe['preco'], 
		        $artigo_p_taxe['DebitAmount'], 
		        $artigo_p_taxe['settelementAmount'], 
		        $artigo_p_taxe['retencao'], 
		        $artigo_p_taxe['retencao'], 
		        $artigo_p_taxe['TotalLinha'], 
		        $artigo_p_taxe['preco'], 
		        $artigo_p_taxe['PlanoContas'], 
		        $artigo_p_taxe['PlanoContasTVA'] 
		    );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS019";
			$response["message"] = $stmt -> error;
			deleteRecord($idFaturaNew);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS020";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idFaturaNew);
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}


//log sistema - processo
$descricao_log ="Documents Automatiques: C. Achat (N. ".$objectData['Numero'].") -- Facture (Brouillon ID. ".$idFaturaNew.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response["idDestino"] = $idFaturaNew;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_faturas WHERE ID_Fatura=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_faturas_linhas WHERE ID_Fatura=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}

?>