<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDocumento = $_POST['idDocumento'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idDocumento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//VERIFICA SE PODE SER GERADO --------------------------------------------
$query = "SELECT Estado FROM faturacao_consommables WHERE ID_Consommable=?";
if ( $stmt = $sqli_connection->prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt->execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Rascunho' ) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003";
	$response["message"] = "Documento inválido para clonar!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DEFINE VARS -----------------------------------------------------------
$objectData = array();

//OBTEM OS Données de Livraison ------------------------------------------------
$query = "SELECT ID_Consommable, 
		Numero,
		ID_Cliente,
		EnderecoCliente,
		CodigoPostalCliente,
		CidadeCliente,
		RegiaoCliente,
		EmailCliente,
		PaisCliente,
		EnderecoClienteDescarga,
		CodigoPostalClienteDescarga,
		CidadeClienteDescarga,
		RegiaoClienteDescarga,
		EmailClienteDescarga,
		PaisClienteDescarga,
		ID_Vendedor_Primeiro,
		ID_Vendedor_Segundo,
		Data,
		Debut,
		Facturation,
		Decompte_pages,
		Paiment,
		Referencia,
		Remarque,
		Prix_noir,
		Prix_couleur,
		Etat_noir,
		Etat_couleur,
		Estado,
		DataCriacao,
		ID_Utilizador_Criacao,
		DataAtualizacao,
		ID_Utilizador_Atualizacao
		FROM faturacao_consommables WHERE ID_Consommable=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Consommable'],
	        	$objectData['Numero'],
	        	$objectData['ID_Cliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['EnderecoClienteDescarga'],
	        	$objectData['CodigoPostalClienteDescarga'],
	        	$objectData['CidadeClienteDescarga'],
	        	$objectData['RegiaoClienteDescarga'],
	        	$objectData['EmailClienteDescarga'],
	        	$objectData['PaisClienteDescarga'],
	        	$objectData['ID_Vendedor_Primeiro'],
	        	$objectData['ID_Vendedor_Segundo'],
	        	$objectData['Data'],
	        	$objectData['Debut'],
	        	$objectData['Facturation'],
	        	$objectData['Decompte_pages'],
	        	$objectData['Paiment'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['Prix_noir'],
	        	$objectData['Prix_couleur'],
	        	$objectData['Etat_noir'],
	        	$objectData['Etat_couleur'],
	        	$objectData['Estado'],
	        	$objectData['DataCriacao'],
	        	$objectData['ID_Utilizador_Criacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['ID_Utilizador_Atualizacao']
			);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//PREPARE VARS ----------------------------------------------------------
$timestamp = microtime(true);
$data = date("d/m/Y");
$debut = date("d/m/Y");
$dataCriacao = date("d/m/Y H:i:s");
$utilizadorCriacao = $id_utilizador;
$dataAtualizacao = date("d/m/Y H:i:s");
$utilizadorAtualizacao = $id_utilizador;
$estado = 'Rascunho';
//-----------------------------------------------------------------------

//INSERT OPEN DOCUMENT --------------------------------------------------
$query = "INSERT INTO faturacao_consommables (
			ID_Cliente, 
			EnderecoCliente, 
			CodigoPostalCliente, 
			CidadeCliente, 
			RegiaoCliente, 
			EmailCliente, 
			PaisCliente,
			EnderecoClienteDescarga, 
			CodigoPostalClienteDescarga, 
			CidadeClienteDescarga, 
			RegiaoClienteDescarga, 
			EmailClienteDescarga, 
			PaisClienteDescarga,
			ID_Vendedor_Primeiro, 
			ID_Vendedor_Segundo, 
			Data, 
			Debut, 
			Facturation, 
			Decompte_pages, 
			Paiment, 
			Referencia, 
			Remarque, 
			Prix_noir, 
			Prix_couleur, 
			Etat_noir, 
			Etat_couleur, 
			Estado, 
			DataCriacao, 
			ID_Utilizador_Criacao, 
			DataAtualizacao, 
			ID_Utilizador_Atualizacao, 
			TimeStamp_Consommable
	) 
	VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssssssssssssddsssssssssssssdsds",
				$objectData['ID_Cliente'],
				$objectData['EnderecoCliente'],
				$objectData['CodigoPostalCliente'],
				$objectData['CidadeCliente'],
				$objectData['RegiaoCliente'],
				$objectData['EmailCliente'],
				$objectData['PaisCliente'],
				$objectData['EnderecoClienteDescarga'],
				$objectData['CodigoPostalClienteDescarga'],
				$objectData['CidadeClienteDescarga'],
				$objectData['RegiaoClienteDescarga'],
				$objectData['EmailClienteDescarga'],
				$objectData['PaisClienteDescarga'],
				$objectData['ID_Vendedor_Primeiro'],
				$objectData['ID_Vendedor_Segundo'],
				$data,
				$debut,
	        	$objectData['Facturation'],
	        	$objectData['Decompte_pages'],
	        	$objectData['Paiment'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['Prix_noir'],
	        	$objectData['Prix_couleur'],
	        	$objectData['Etat_noir'],
	        	$objectData['Etat_couleur'],
				$estado,
				$dataCriacao,
				$utilizadorCriacao,
				$dataAtualizacao,
				$utilizadorAtualizacao,
				$timestamp  
	    	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//GET DOCUMENT ID
$query = "SELECT ID_Consommable FROM faturacao_consommables WHERE TimeStamp_Consommable = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("s", $timestamp);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS008";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idLocationNew);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS009";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $idLocationNew < 1){
	$response["errors"] = true;
	$response["type"] = "FATS010";
	$response["message"] = "Location inválida";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET THE LINES ----------------------------------------------------------
$data = array();
$query = "SELECT ID_Consommable,
			ID_Artigo,
			NumeroLinha,
			ProductCode,
			ProductDescription,
			SerialNumber,
			Quantidade
		FROM faturacao_consommables_linhas WHERE ID_Consommable=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS011";
		$response["message"] = $stmt -> error;
		deleteRecord($idLocationNew);
		die(json_encode($response));
	}
	$stmt -> bind_result(
			$ID_Consommable, 
			$ID_Artigo, 
			$NumeroLinha, 
			$ProductCode, 
			$ProductDescription, 
			$SerialNumber, 
			$Quantidade
		);
	while ($stmt -> fetch()) {
		$data[] = array(
		        	"ID_Consommable" => $ID_Consommable,
		        	"ID_Artigo" => $ID_Artigo,
		        	"NumeroLinha" => $NumeroLinha,
		        	"ProductCode" => $ProductCode,
		        	"ProductDescription" => $ProductDescription,
		        	"SerialNumber" => $SerialNumber,
		        	"Quantidade" => $Quantidade,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS012";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idLocationNew);
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $data;
//------------------------------------------------------------------------

//INSERT THE LINES
foreach ($objectData['linhas'] as $linha) {
	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_consommables_linhas (
		ID_Consommable, ID_Artigo, 
		NumeroLinha, ProductCode, ProductDescription, SerialNumber, Quantidade
		) 
		VALUES (?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddsssd", 
		            $idLocationNew, 
					$linha['ID_Artigo'],
					$linha['NumeroLinha'],
					$linha['ProductCode'],
					$linha['ProductDescription'],
					$linha['SerialNumber'],
					$linha['Quantidade']
				);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS013";
			$response["message"] = $stmt -> error;
			deleteRecord($idLocationNew);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS014";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idLocationNew);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
}


//log sistema - processo
$descricao_log ="Générer le document: Contract Entretien (id: ".$idDocumento.") -- Contract Entretien (id: ".$idLocationNew.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response["idDestino"] = $idLocationNew;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_consommables WHERE ID_Consommable=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_consommables_linhas WHERE ID_Consommable=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}

?>