<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDocumento = $_POST['idDocumento'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idDocumento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//PROCESS IDS
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//VERIFICA SE PODE SER GERADO --------------------------------------------
	$query = 'SELECT Estado FROM faturacao_devis WHERE ID_Devis=?';
	if ( $stmt = $sqli_connection->prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt->execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($Estado);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $Estado != 'Confirmado' ) {
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS003A";
		$response["message"] = "Documento inválido para clonar!";
		$response["estado_confirmado_invalido"] = true;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//DEFINE VARS -----------------------------------------------------------
	$objectData = array();

	//OBTEM OS Données de Livraison ------------------------------------------------
	$query = "SELECT ID_Devis, 
			ID_Cliente, 
			EnderecoCliente, 
			CodigoPostalCliente, 
			CidadeCliente, 
			RegiaoCliente, 
			EmailCliente, 
			PaisCliente, 
			ID_Moeda, 
			TaxaMoeda, 
			Vendedor, 
			Vencimento, 
			EnderecoCarga, 
			CodigoPostalCarga, 
			CidadeCarga,
			RegiaoCarga,
			(SELECT ID_Serie FROM faturacao_series WHERE faturacao_series.Predefinida=1) AS ID_Serie, 
			(SELECT Nome FROM faturacao_series WHERE faturacao_series.Predefinida=1) AS Serie, 
			Numero,  
			Referencia, 
			Observacoes, 
			TaxPayable, 
			NetTotal, 
			GrossTotal, 
			Desconto, 
			PercentagemDesconto, 
			TotaRetencao, 
			TotalSDesconto, 
			InvoiceType, 
			EACCode, 
			CustomerID, 
			TotalLiquidadoDocumento, 
			TotalLiquidado, 
			TotalPagar, 
			MetodoPagamento, 
			ID_Banco, 
			Data
			FROM faturacao_devis WHERE ID_Devis=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result(
		        	$objectData['ID_Devis'],
		        	$objectData['ID_Cliente'],
		        	$objectData['EnderecoCliente'],
		        	$objectData['CodigoPostalCliente'],
		        	$objectData['CidadeCliente'],
		        	$objectData['RegiaoCliente'],
		        	$objectData['EmailCliente'],
		        	$objectData['PaisCliente'],
		        	$objectData['ID_Moeda'],
		        	$objectData['TaxaMoeda'],
		        	$objectData['Vendedor'],
		        	$objectData['Vencimento'],
		        	$objectData['EnderecoCarga'],
		        	$objectData['CodigoPostalCarga'],
		        	$objectData['CidadeCarga'],
		        	$objectData['RegiaoCarga'],
		        	$objectData['ID_Serie'],
		        	$objectData['Serie'],
		        	$objectData['Numero'],
		        	$objectData['Referencia'],
		        	$objectData['Observacoes'],
		        	$objectData['TaxPayable'],
		        	$objectData['NetTotal'],
		        	$objectData['GrossTotal'],
		        	$objectData['Desconto'],
		        	$objectData['PercentagemDesconto'],
		        	$objectData['TotaRetencao'],
		        	$objectData['TotalSDesconto'],
		        	$objectData['InvoiceType'],
		        	$objectData['EACCode'],
		        	$objectData['CustomerID'],
		        	$objectData['TotalLiquidadoDocumento'],
		        	$objectData['TotalLiquidado'],
		        	$objectData['TotalPagar'],
		        	$objectData['MetodoPagamento'],
		        	$objectData['ID_Banco'],
		        	$objectData['Data']
				);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//NEW FIELDS PLANO CONTAS
	$PlanoContasCliente = getPlanoCode("PlanoContas", "faturacao_clientes", "ID_Cliente", $objectData['ID_Cliente']);
	if($objectData['ID_Banco'] != 0)
	$PlanoContasBanco = getPlanoCode("PlanoContas", "faturacao_bancos", "ID_Banco", $objectData['ID_Banco']);

	//PREPARE VARS ----------------------------------------------------------
	$timestamp = microtime(true);
	$systemEntryDate = date("Y-m-d H:i:s");
	$systemEntryDate = str_replace (' ','T',$systemEntryDate);
	$numeroNew = 0;
	$dataNew = date("d/m/Y");

	$dateProcessed = date('Y-m-d', strtotime(" + ".$objectData['Vencimento']." days"));
	$validadeNew = DateTime::createFromFormat('Y-m-d', $dateProcessed);
	$validadeNew = $validadeNew->format('d/m/Y');

	$invoiceTypeNew = 'GT';
	$totalLiquidadoDocumento = 0;
	$totalLiquidado = 0;
	$estadoNovo = 'Rascunho';
	$invoiceTypeOrigem = 'DV';
	$idDocOrigem = $idDocumento;
	$referenceDocOrigem = 'DV '.$objectData['Serie'].'/'.$objectData['Numero'];
	$objectData['GrossTotal'] = roundPriceUp($objectData['GrossTotal']);
	$objectData['GrossTotal'] = $objectData['GrossTotal'];

	//new vars specific for bl
	$objectData['DataCarga'] = date("d/m/Y");
	$objectData['DataDescarga'] = date("d/m/Y");
	$objectData['HoraCarga'] = date("H:i");
	$objectData['HoraDescarga'] = date("H:i");
	$objectData['EnderecoDescarga'] = $objectData['EnderecoCliente'];
	$objectData['CodigoPostalDescarga'] = $objectData['CodigoPostalCliente'];
	$objectData['CidadeDescarga'] = $objectData['CidadeCliente'];
	$objectData['RegiaoDescarga'] = $objectData['RegiaoCliente'];
	$objectData['PaisCarga'] = $objectData['PaisCliente'];
	$objectData['PaisDescarga'] = $objectData['PaisCliente'];
	$objectData['DeliveryID'] = '';
	//-----------------------------------------------------------------------

	//INSERT OPEN DOCUMENT --------------------------------------------------
	$query = "INSERT INTO faturacao_guias_transporte(
		ID_Cliente,
		EnderecoCliente,
		CodigoPostalCliente,
		CidadeCliente,
		RegiaoCliente,
		EmailCliente,
		PaisCliente,
		ID_Moeda,
		TaxaMoeda,
		Vendedor,
		Vencimento,
		EnderecoCarga,
		CodigoPostalCarga,
		CidadeCarga,
		RegiaoCarga,
		ID_Serie,
		Numero,
		Data,
		Validade,
		Referencia,
		Observacoes,
		TaxPayable,
		NetTotal,
		GrossTotal,
		SystemEntryDate,
		TimeStampDate,
		Desconto,
		PercentagemDesconto,
		TotaRetencao,
		TotalSDesconto,
		InvoiceType,
		EACCode,
		CustomerID,
		TotalLiquidadoDocumento,
		TotalLiquidado,
		TotalPagar,
		MetodoPagamento,
		ID_Banco,
		Estado,
		ID_Utilizador,
		DataCarga,
		DataDescarga,
		HoraCarga,
		HoraDescarga,
		EnderecoDescarga,
		CodigoPostalDescarga,
		CidadeDescarga,
		RegiaoDescarga,
		PaisCarga,
		PaisDescarga,
		DeliveryID
		) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssssssdsssssssddssssssssssssssssssssdsdsssssssssss",
		            $objectData['ID_Cliente'],
		            $objectData['EnderecoCliente'],
		            $objectData['CodigoPostalCliente'],
		            $objectData['CidadeCliente'],
		            $objectData['RegiaoCliente'],
		            $objectData['EmailCliente'],
		            $objectData['PaisCliente'],
		            $objectData['ID_Moeda'],
		            $objectData['TaxaMoeda'],
		            $objectData['Vendedor'],
		            $objectData['Vencimento'],
		            $objectData['EnderecoCarga'],
		            $objectData['CodigoPostalCarga'],
		            $objectData['CidadeCarga'],
		            $objectData['RegiaoCarga'],
		            $objectData['ID_Serie'],
		            $numeroNew,
		            $dataNew,
		            $validadeNew,
		            $objectData['Referencia'],
		            $objectData['Observacoes'],
		            $objectData['TaxPayable'],
		            $objectData['NetTotal'],
		            $objectData['GrossTotal'],
		            $systemEntryDate,
		            $timestamp,
		            $objectData['Desconto'],
		            $objectData['PercentagemDesconto'],
		            $objectData['TotaRetencao'],
		            $objectData['TotalSDesconto'],
		            $invoiceTypeNew,
		            $objectData['EACCode'],
		            $objectData['CustomerID'],
		            $totalLiquidadoDocumento,
		            $totalLiquidado,
		            $objectData['GrossTotal'],
		            $objectData['MetodoPagamento'],
		            $objectData['ID_Banco'],
		            $estadoNovo,
		            $id_utilizador,
		        	$objectData['DataCarga'],
		        	$objectData['DataDescarga'],
		        	$objectData['HoraCarga'],
		        	$objectData['HoraDescarga'],
		        	$objectData['EnderecoDescarga'],
		        	$objectData['CodigoPostalDescarga'],
		        	$objectData['CidadeDescarga'],
		        	$objectData['RegiaoDescarga'],
		        	$objectData['PaisCarga'],
		        	$objectData['PaisDescarga'],
		        	$objectData['DeliveryID']
		    	);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//GET DOCUMENT ID
	$query = "SELECT ID_GuiaTransporte FROM faturacao_guias_transporte WHERE TimeStampDate = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $timestamp);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS008";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($idGuiaNova);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS009";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $idGuiaNova < 1){
		$response["errors"] = true;
		$response["type"] = "FATS010";
		$response["message"] = "Fatura inválida";
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//GET THE LINES ----------------------------------------------------------
	$query = "SELECT NumeroLinha,
			ID_Artigo,
			ProductCode,
			ProductDescription,
			Quantidade,
			UnidadeMedida,
			PrecoUnitario,
			TaxPointDate,
			Descricao,
			SerialNumber,
			ID_Imposto,
			TaxType,
			TaxCountryRegion,
			TaxCode,
			TaxPercentage,
			TaxExemptionReason,
			TaxExemptionCode,
			DescontoLinha,
			CreditAmount,
			DebitAmount,
			SettlementAmount,
			ValorRetencao,
			PercentagemRetencao,
			TotalLinha,
			TotalLinhaSIVA,
			PlanoContas,
			PlanoContasTVA
			FROM faturacao_devis_linhas WHERE ID_Devis=? ORDER BY ID_Linha";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocumento);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS011";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			// deleteRecord($idGuiaNova);
			die(json_encode($response));
		}
		$stmt -> bind_result(
				$NumeroLinha, 
				$ID_Artigo, 
				$ProductCode, 
				$ProductDescription, 
				$Quantidade, 
				$UnidadeMedida, 
				$PrecoUnitario, 
				$TaxPointDate, 
				$Descricao, 
				$SerialNumber, 
				$ID_Imposto, 
				$TaxType, 
				$TaxCountryRegion, 
				$TaxCode, 
				$TaxPercentage, 
				$TaxExemptionReason, 
				$TaxExemptionCode, 
				$DescontoLinha, 
				$CreditAmount, 
				$DebitAmount, 
				$SettlementAmount, 
				$ValorRetencao, 
				$PercentagemRetencao, 
				$TotalLinha, 
				$TotalLinhaSIVA,
				$PlanoContas,
				$PlanoContasTVA
			);
		while ($stmt -> fetch()) {
			$data[] = array(
			        	"NumeroLinha" => $NumeroLinha,
			        	"ID_Artigo" => $ID_Artigo,
			        	"ProductCode" => $ProductCode,
			        	"ProductDescription" => $ProductDescription,
			        	"Quantidade" => $Quantidade,
			        	"UnidadeMedida" => $UnidadeMedida,
			        	"PrecoUnitario" => $PrecoUnitario,
			        	"TaxPointDate" => $TaxPointDate,
			        	"Descricao" => $Descricao,
			        	"SerialNumber" => $SerialNumber,
			        	"ID_Imposto" => $ID_Imposto,
			        	"TaxType" => $TaxType,
			        	"TaxCountryRegion" => $TaxCountryRegion,
			        	"TaxCode" => $TaxCode,
			        	"TaxPercentage" => $TaxPercentage,
			        	"TaxExemptionReason" => $TaxExemptionReason,
			        	"TaxExemptionCode" => $TaxExemptionCode,
			        	"DescontoLinha" => $DescontoLinha,
			        	"CreditAmount" => $CreditAmount,
			        	"DebitAmount" => $DebitAmount,
			        	"SettlementAmount" => $SettlementAmount,
			        	"ValorRetencao" => $ValorRetencao,
			        	"PercentagemRetencao" => $PercentagemRetencao,
			        	"TotalLinha" => $TotalLinha,
			        	"TotalLinhaSIVA" => $TotalLinhaSIVA,
			        	"PlanoContas" => $PlanoContas,
			        	"PlanoContasTVA" => $PlanoContasTVA,
			        );
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS012";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		// deleteRecord($idGuiaNova);
		die(json_encode($response));
	}
	//add lines to object
	$objectData['linhas'] = $data;
	//------------------------------------------------------------------------

	//INSERT THE LINES
	foreach ($objectData['linhas'] as $linha) {
		//INSERT INTO DB -----------------------------------------------------
		$query = "INSERT INTO faturacao_guias_transporte_linhas (
			ID_GuiaTransporte, 
			NumeroLinha,
			ID_Artigo,
			ProductCode,
			ProductDescription,
			Quantidade,
			UnidadeMedida,
			PrecoUnitario,
			TaxPointDate,
			Descricao,
			SerialNumber,
			ID_Imposto,
			TaxType,
			TaxCountryRegion,
			TaxCode,
			TaxPercentage,
			TaxExemptionReason,
			TaxExemptionCode,
			DescontoLinha,
			CreditAmount,
			DebitAmount,
			SettlementAmount,
			ValorRetencao,
			PercentagemRetencao,
			TotalLinha,
			TotalLinhaSIVA
			) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddssssssssdssssssssssssss", 
			            $idGuiaNova, 
						$linha['NumeroLinha'],
						$linha['ID_Artigo'],
						$linha['ProductCode'],
						$linha['ProductDescription'],
						$linha['Quantidade'],
						$linha['UnidadeMedida'],
						$linha['PrecoUnitario'],
						$linha['TaxPointDate'],
						$linha['Descricao'],
						$linha['SerialNumber'],
						$linha['ID_Imposto'],
						$linha['TaxType'],
						$linha['TaxCountryRegion'],
						$linha['TaxCode'],
						$linha['TaxPercentage'],
						$linha['TaxExemptionReason'],
						$linha['TaxExemptionCode'],
						$linha['DescontoLinha'],
						$linha['CreditAmount'],
						$linha['DebitAmount'],
						$linha['SettlementAmount'],
						$linha['ValorRetencao'],
						$linha['PercentagemRetencao'],
						$linha['TotalLinha'],
						$linha['TotalLinhaSIVA']
					);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS013";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				// deleteRecord($idGuiaNova);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS014";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			// deleteRecord($idGuiaNova);
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
	}
	//------------------------------------------------------------------------


	//log sistema - processo
	$descricao_log ="Générer le document: Devis (id: ".$idDocumento.") -- B. Livraison (id: ".$idGuiaNova.")";
	insert_log(0,"Inserir",$descricao_log,$sqli_connection);

	// Save all querys on DB
	$sqli_connection->commit();

} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
$response["idDestino"] = $idGuiaNova;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_guias_transporte WHERE ID_GuiaTransporte=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_guias_transporte_linhas WHERE ID_GuiaTransporte=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}

?>