<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDocumento = $_POST['idDocumento'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idDocumento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//VERIFICA SE PODE SER GERADO --------------------------------------------
$query = "SELECT Estado FROM faturacao_rapports_travail WHERE ID_Rapport=?";
if ( $stmt = $sqli_connection->prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt->execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Rascunho' ) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003";
	$response["message"] = "Documento inválido para clonar!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DEFINE VARS -----------------------------------------------------------
$objectData = array();

//OBTEM OS DADOS --------------------------------------------------------
$query = "SELECT ID_Rapport, 
		ID_Cliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente, 
		TelefoneCliente, 
		EnderecoClienteDescarga, 
		EnderecoCliente2Descarga, 
		CodigoPostalClienteDescarga, 
		RegiaoClienteDescarga, 
		CidadeClienteDescarga, 
		PaisClienteDescarga,
		Tecnico,
		TecnicoSegundo,
		ID_Tecnico,
		ID_TecnicoSegundo,
		Impressora,
		NumImpressora, 
		CompteurNB,
		CompteurCoul,  
		Numero, 
		Data, 
		Duree, 
		Referencia, 
		Remarque, 
		Estado, 
		ID_Utilizador_Criacao, 
		ID_Utilizador_Atualizacao, 
		DataAtualizacao,
		Tipo_Documento_Origem,
		ID_Documento_Origem,
		Reference,
		DateDebut,
		DateFin,
		Data_Documento_Origem,
		TaxPayable,
		NetTotal,
		GrossTotal,
		TotalPagar
		FROM faturacao_rapports_travail WHERE ID_Rapport=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Rapport'],
	        	$objectData['ID_Cliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['TelefoneCliente'],
	        	$objectData['EnderecoClienteDescarga'],
	        	$objectData['EnderecoCliente2Descarga'],
	        	$objectData['CodigoPostalClienteDescarga'],
	        	$objectData['RegiaoClienteDescarga'],
	        	$objectData['CidadeClienteDescarga'],
	        	$objectData['PaisClienteDescarga'],
	        	$objectData['Tecnico'],
	        	$objectData['TecnicoSegundo'],
	        	$objectData['ID_Tecnico'],
	        	$objectData['ID_TecnicoSegundo'],
	        	$objectData['Impressora'],
	        	$objectData['NumImpressora'],
	        	$objectData['CompteurNB'],
	        	$objectData['CompteurCoul'],
	        	$objectData['Numero'],
	        	$objectData['Data'],
	        	$objectData['Duree'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['Estado'],
	        	$objectData['ID_Utilizador'],
	        	$objectData['ID_UtilizadorAtualizacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['Tipo_Documento_Origem'],
	        	$objectData['ID_Documento_Origem'],
	        	$objectData['Reference'],
	        	$objectData['DateDebut'],
	        	$objectData['DateFin'],
	        	$objectData['Data_Documento_Origem'],
	        	$objectData['TaxPayable'],
	        	$objectData['NetTotal'],
	        	$objectData['GrossTotal'],
	        	$objectData['TotalPagar']
			);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//PREPARE VARS ----------------------------------------------------------
$timestamp = microtime(true);
$dataCriacao = date("d/m/Y H:i:s");
$dataServico = date("d/m/Y");

$estado = 'Rascunho';
$objectData['GrossTotal'] = roundPriceUp($objectData['GrossTotal']);
$objectData['TotalPagar'] = roundPriceUp($objectData['TotalPagar']);
//-----------------------------------------------------------------------

//INSERT OPEN DOCUMENT --------------------------------------------------
$query = "INSERT INTO faturacao_rapports_travail( 
		ID_Cliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente, 
		TelefoneCliente, 
		Data, 
		Duree, 
		Referencia, 
		Remarque, 
		TimeStamp_Rapport, 
		Estado, 
		ID_Utilizador_Criacao, 
		Impressora, 
		NumImpressora, 
		CompteurNB, 
		CompteurCoul, 
		DataCriacao, 
		ID_Documento_Origem, 
		Tipo_Documento_Origem, 
		Data_Documento_Origem, 
		Reference, 
		Tecnico, 
		DateDebut, 
		DateFin, 
		EnderecoClienteDescarga, 
		EnderecoCliente2Descarga, 
		CodigoPostalClienteDescarga, 
		CidadeClienteDescarga, 
		RegiaoClienteDescarga, 
		PaisClienteDescarga, 
		TecnicoSegundo, 
		ID_Tecnico, 
		ID_TecnicoSegundo,
		TaxPayable,
		NetTotal,
		GrossTotal,
		TotalPagar
	)VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dsssssssssssssdsssssdsssssssssssssssssss",
	            $objectData['ID_Cliente'],
	            $objectData['EnderecoCliente'],
	            $objectData['CodigoPostalCliente'],
	            $objectData['CidadeCliente'],
	            $objectData['RegiaoCliente'],
	            $objectData['EmailCliente'],
	            $objectData['PaisCliente'],
	            $objectData['TelefoneCliente'],
	            $dataServico,
	            $objectData['Duree'],
	            $objectData['Referencia'],
	            $objectData['Remarque'],
	            $timestamp,
	            $estado,
	            $id_utilizador,
	            $objectData['Impressora'],
	            $objectData['NumImpressora'],
	            $objectData['CompteurNB'],
	            $objectData['CompteurCoul'],
	            $dataCriacao,
	            $objectData['ID_Documento_Origem'],
	            $objectData['Tipo_Documento_Origem'],
	            $objectData['Data_Documento_Origem'],
	            $objectData['Reference'],
	            $objectData['Tecnico'],
	            $objectData['DateDebut'],
	            $objectData['DateFin'],
	            $objectData['EnderecoClienteDescarga'],
	            $objectData['EnderecoCliente2Descarga'],
	            $objectData['CodigoPostalClienteDescarga'],
	            $objectData['CidadeClienteDescarga'],
	            $objectData['RegiaoClienteDescarga'],
	            $objectData['PaisClienteDescarga'],
	            $objectData['TecnicoSegundo'],
	            $objectData['ID_Tecnico'],
	            $objectData['ID_TecnicoSegundo'],
	            $objectData['TaxPayable'],
	            $objectData['NetTotal'],
	            $objectData['GrossTotal'],
	            $objectData['TotalPagar']
	    	);
	$result = $stmt -> execute();
	$idRapportNovo = $stmt->insert_id;
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $idRapportNovo < 1){
	$response["errors"] = true;
	$response["type"] = "FATS010";
	$response["message"] = "Rapport invalid";
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DO RAPPORT --------------------------------------------
$query = "SELECT ID_Rapport,
		ID_Artigo,
		NumeroLinha,
		ProductCode,
		ProductDescription,
		SerialNumber,
		Quantidade,
		UnidadeMedida,
		PrecoUnitario,
		Descricao,
		ID_Imposto,
		TaxType,
		TaxCountryRegion,
		TaxCode,
		TaxPercentage,
		TaxExemptionReason,
		TaxExemptionCode,
		TotalLinha,
		TotalLinhaSIVA,
		DescontoLinha,
		SettlementAmount
		FROM faturacao_rapports_travail_linhas WHERE ID_Rapport=? ORDER BY NumeroLinha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		deleteRecord($idRapportNovo);
		die(json_encode($response));
	}
	$stmt -> bind_result(
			$ID_Rapport, 
			$ID_Artigo, 
			$NumeroLinha, 
			$ProductCode, 
			$ProductDescription, 
			$SerialNumber, 
			$Quantidade, 
			$UnidadeMedida, 
			$PrecoUnitario, 
			$Descricao, 
			$ID_Imposto, 
			$TaxType, 
			$TaxCountryRegion, 
			$TaxCode, 
			$TaxPercentage, 
			$TaxExemptionReason, 
			$TaxExemptionCode, 
			$TotalLinha, 
			$TotalLinhaSIVA, 
			$DescontoLinha, 
			$SettlementAmount
		);
	while ($stmt -> fetch()) {
		$dataLinhas[] = array(
		        	"ID_Rapport" => $ID_Rapport,
		        	"ID_Artigo" => $ID_Artigo,
		        	"NumeroLinha" => $NumeroLinha,
		        	"ProductCode" => $ProductCode,
		        	"ProductDescription" => $ProductDescription,
		        	"SerialNumber" => $SerialNumber,
		        	"Quantidade" => $Quantidade,
		        	"UnidadeMedida" => $UnidadeMedida,
		        	"PrecoUnitario" => $PrecoUnitario,
		        	"Descricao" => $Descricao,
		        	"ID_Imposto" => $ID_Imposto,
		        	"TaxType" => $TaxType,
		        	"TaxCountryRegion" => $TaxCountryRegion,
		        	"TaxCode" => $TaxCode,
		        	"TaxPercentage" => $TaxPercentage,
		        	"TaxExemptionReason" => $TaxExemptionReason,
		        	"TaxExemptionCode" => $TaxExemptionCode,
		        	"TotalLinha" => $TotalLinha,
		        	"TotalLinhaSIVA" => $TotalLinhaSIVA,
		        	"DescontoLinha" => $DescontoLinha,
		        	"SettlementAmount" => $SettlementAmount,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idRapportNovo);
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $dataLinhas;
// var_dump($objectData['linhas']);

//INSERT THE LINES
foreach ($objectData['linhas'] as $linha) {
// var_dump($linha);
	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_rapports_travail_linhas (
			ID_Rapport, 
			NumeroLinha, 
			ID_Artigo, 
			ProductCode, 
			ProductDescription, 
			Quantidade, 
			UnidadeMedida, 
			PrecoUnitario, 
			Descricao, 
			SerialNumber, 
			ID_Imposto, 
			TaxType, 
			TaxCountryRegion, 
			TaxCode, 
			TaxPercentage, 
			TaxExemptionReason, 
			TaxExemptionCode, 
			TotalLinha, 
			TotalLinhaSIVA, 
			DescontoLinha, 
			SettlementAmount
		) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssssssssssssssssssss", 
		            $idRapportNovo, 
					$linha['NumeroLinha'],
					$linha['ID_Artigo'],
					$linha['ProductCode'],
					$linha['ProductDescription'],
					$linha['Quantidade'],
					$linha['UnidadeMedida'],
					$linha['PrecoUnitario'],
					$linha['Descricao'],
					$linha['SerialNumber'],
					$linha['ID_Imposto'],
					$linha['TaxType'],
					$linha['TaxCountryRegion'],
					$linha['TaxCode'],
					$linha['TaxPercentage'],
					$linha['TaxExemptionReason'],
					$linha['TaxExemptionCode'],
					$linha['TotalLinha'],
					$linha['TotalLinhaSIVA'],
					$linha['DescontoLinha'],
					$linha['SettlementAmount']
				);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS013";
			$response["message"] = $stmt -> error;
			deleteRecord($idRapportNovo);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS014";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idRapportNovo);
		die(json_encode($response));
	}
}
//-----------------------------------------------------------------------

// var_dump($objectData, $idRapportNovo);

//log sistema - processo
$descricao_log ="Générer le document: Rapport de Travail (id: ".$idDocumento.") -- Rapport de Travail (id: ".$idRapportNovo.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response["idDestino"] = $idRapportNovo;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_rapports_travail WHERE ID_Rapport=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_rapports_travail_linhas WHERE ID_Rapport=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}
?>