<?php 
// $helpersFile = true;

/**
 * |-----------------------------------------------------------------------
 * |
 * |						Helper Functions
 * |
 * | Functions to be used anytime, anywhere. Just like a service provider.
 * |
 * |-----------------------------------------------------------------------
 */

/**
 * Get Total Faturado
 * @return total
 */
function getQD_Faturado(){
	global $sqli_connection;
	
	$ano = date("Y");

	$total = 0;

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    if($clientsIDs) $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    else $condition = " AND ID_Cliente IN (0) ";
	}
	// var_dump($condition);

	//process
	$query = "SELECT SUM(TotalPagar) FROM faturacao_faturas WHERE Estado IN ('Aberto','Pago') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//GET IDS FOR USE INTO NC
	$query = "SELECT ID_Fatura FROM faturacao_faturas WHERE Estado IN ('Aberto','Pago') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP002A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Fatura);
		while ($stmt -> fetch()) {
			$ids[] = $ID_Fatura;
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP002B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( is_null($ids) ){ $ids = 0; }
	else{ $ids = implode(',', $ids); }

	//process
	$query = "SELECT SUM(TotalPagar) FROM faturacao_notas_credito 
				WHERE Estado IN ('Aberto','Pago') AND ID_Documento_Origem IN (".$ids.") AND Tipo_Documento_Origem = 'FT'";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP002C";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($totalNC);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP002D";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//Process total
	$total = $total - $totalNC;

	//RETURN TOTAL
	return $total;
}

/**
 * Get Total Régler
 * @return total
 */
function getQD_FatPorLiquidar(){
	global $sqli_connection;
	
	$ano = date("Y");

	$total = 0;

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    if($clientsIDs) $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    else $condition = " AND ID_Cliente IN (0) ";
	}
	// var_dump($condition);

	//process
	$query = "SELECT SUM(TotalPagar) - SUM(TotalLiquidado) FROM faturacao_faturas WHERE Estado IN ('Aberto','Pago') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//RETURN TOTAL
	return $total;
}

/**
 * Get Total Liquidado
 * @return total
 */
function getQD_FatLiquidado(){
	global $sqli_connection;
	
	$ano = date("Y");

	$total = 0;

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    if($clientsIDs) $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    else $condition = " AND ID_Cliente IN (0) ";
	}
	// var_dump($condition);

	//process
	$query = "SELECT SUM(TotalLiquidado) FROM faturacao_faturas WHERE Estado IN ('Aberto','Pago') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//GET IDS FOR USE INTO NC
	$query = "SELECT ID_Fatura FROM faturacao_faturas WHERE Estado IN ('Aberto','Pago') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP006A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Fatura);
		while ($stmt -> fetch()) {
			$ids[] = $ID_Fatura;
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP006B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( is_null($ids) ){ $ids = 0; }
	else{ $ids = implode(',', $ids); }

	//process
	$query = "SELECT SUM(TotalPagar) FROM faturacao_notas_credito 
				WHERE Estado IN ('Aberto','Pago') AND ID_Documento_Origem IN (".$ids.") AND Tipo_Documento_Origem = 'FT'";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP006C";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($totalNC);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP006D";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//Process total
	$total = $total - $totalNC;

	return $total;
}


/**
 * Get Total IVA
 * @return total
 */
function getQD_FatIVA(){
	global $sqli_connection;
	
	$ano = date("Y");

	$total = 0;

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    if($clientsIDs) $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    else $condition = " AND ID_Cliente IN (0) ";
	}
	// var_dump($condition);

	//process
	$query = "SELECT SUM(TaxPayable) FROM faturacao_faturas WHERE Estado IN ('Aberto','Pago') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//GET IDS FOR USE INTO NC
	$query = "SELECT ID_Fatura FROM faturacao_faturas WHERE Estado IN ('Aberto','Pago') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP008A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Fatura);
		while ($stmt -> fetch()) {
			$ids[] = $ID_Fatura;
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP008B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( is_null($ids) ){ $ids = 0; }
	else{ $ids = implode(',', $ids); }

	//process
	$query = "SELECT SUM(TaxPayable) FROM faturacao_notas_credito 
				WHERE Estado IN ('Aberto','Pago') AND ID_Documento_Origem IN (".$ids.") AND Tipo_Documento_Origem = 'FT'";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP008C";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($totalNC);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP008D";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//Process total
	$total = $total - $totalNC;

	//RETURN
	return $total;
}

// --------- COMPRAS ---------

/**
 * Get Total Faturado
 * @return total
 */
function getQD_Comprado(){
	global $sqli_connection;
	
	$ano = date("Y");

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " WHERE ID_Cliente IN (".$clientsIDs.") ";
	    return 0;
	}
	// var_dump($condition);

	//process
	$query = "SELECT SUM(GrossTotal) - SUM(TotalCreditado) FROM faturacao_compras WHERE Estado IN ('Aberto','Pago') AND Data LIKE '%/".$ano."'";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP009";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP010";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	return $total;
}

/**
 * Get Total Régler
 * @return total
 */
function getQD_CompPorLiquidar(){
	global $sqli_connection;
	
	$ano = date("Y");

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " WHERE ID_Cliente IN (".$clientsIDs.") ";
	    return 0;
	}
	// var_dump($condition);

	//process
	$query = "SELECT SUM(GrossTotal) - SUM(TotalCreditado) FROM faturacao_compras WHERE Estado IN ('Aberto') AND Data LIKE '%/".$ano."'";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP011";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP012";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	return $total;
}

/**
 * Get Total Liquidado
 * @return total
 */
function getQD_CompLiquidado(){
	global $sqli_connection;
	
	$ano = date("Y");

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " WHERE ID_Cliente IN (".$clientsIDs.") ";
	    return 0;
	}
	// var_dump($condition);

	//process
	$query = "SELECT SUM(GrossTotal) - SUM(TotalCreditado) FROM faturacao_compras WHERE Estado IN ('Pago') AND Data LIKE '%/".$ano."'";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP013";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP014";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	return $total;
}

/**
 * Get Total IVA
 * @return total
 */
function getQD_CompIVA(){
	global $sqli_connection;
	
	$ano = date("Y");

	$total = 0;

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " WHERE ID_Cliente IN (".$clientsIDs.") ";
	    return 0;
	}
	// var_dump($condition);
	
	//process
	$query = "SELECT SUM(TaxPayable) FROM faturacao_compras WHERE Estado IN ('Aberto','Pago') AND Data LIKE '%/".$ano."'";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP015";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP016";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//GET IDS FOR USE INTO NC
	$query = "SELECT ID_Compra FROM faturacao_compras WHERE Estado IN ('Aberto','Pago') AND Data LIKE '%/".$ano."' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP008A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Compra);
		while ($stmt -> fetch()) {
			$ids[] = $ID_Compra;
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP008B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( is_null($ids) ){ $ids = 0; }
	else{ $ids = implode(',', $ids); }

	//process
	$query = "SELECT SUM(TaxPayable) FROM faturacao_compras_notas_credito 
				WHERE Estado IN ('Aberto','Pago') AND ID_Documento_Origem IN (".$ids.")";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP008C";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($totalNC);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP008D";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//Process total
	$total = $total - $totalNC;

	return $total;
}

// ------- Outras -------

/**
 * Get Total Clients
 * @return total
 */
function getQD_TotClients(){
	global $sqli_connection;

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " WHERE ID_Cliente IN (".$clientsIDs.") ";
	    if($clientsIDs) $condition = " WHERE ID_Cliente IN (".$clientsIDs.") ";
	    else $condition = " WHERE ID_Cliente IN (0) ";
	}
	// var_dump($condition);
	
	//process
	$query = "SELECT COUNT(*) FROM faturacao_clientes ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP016";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP017";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	return $total;
}

/**
 * Get Total Fornecedores
 * @return total
 */
function getQD_TotFornecedores(){
	global $sqli_connection;

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " WHERE ID_Cliente IN (".$clientsIDs.") ";
	    return '-';
	}
	// var_dump($condition);
	
	//process
	$query = "SELECT COUNT(*) FROM faturacao_fornecedores";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP017";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP018";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	return $total;
}

/**
 * Get Total Guias
 * @return total
 */
function getQD_TotGuias(){
	global $sqli_connection;

	$ano = date("Y");

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    if($clientsIDs) $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    else $condition = " AND ID_Cliente IN (0) ";
	}
	// var_dump($condition);
	
	//process
	$query = "SELECT COUNT(*) FROM faturacao_guias_transporte WHERE Estado NOT IN ('Rascunho') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP019";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP020";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	return $total;
}

/**
 * Get Total Guias
 * @return total
 */
function getQD_TotFaturas(){
	global $sqli_connection;
	
	$ano = date("Y");

	//condition params
	$condition = '';
	if ( isVendedor() == 1 ) {
	    $clientsIDs = getVendedorClients();
	    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
	    // $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    if($clientsIDs) $condition = " AND ID_Cliente IN (".$clientsIDs.") ";
	    else $condition = " AND ID_Cliente IN (0) ";
	}
	// var_dump($condition);
	
	//process
	$query = "SELECT COUNT(*) FROM faturacao_faturas WHERE Estado NOT IN ('Rascunho') AND InvoiceDate LIKE '".$ano."-%' ".$condition."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "QHELP021";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($total);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "QHELP022";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	return $total;
}
?>