<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idHonorario = $_POST['idDocument'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idHonorario == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//OBTEM OS DADOS DA HONORÁRIOS -------------------------------------------
$query = "SELECT ID_Honorario, 
		(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_honorarios.ID_Cliente) AS Cliente, 
		(SELECT Nif FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_honorarios.ID_Cliente) AS Cliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente, 
		(SELECT CONCAT(Nome,' (',Simbolo,')') FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_honorarios.ID_Moeda )AS Moeda, 
		(SELECT ISO_Code FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_honorarios.ID_Moeda )AS ISOCode, 
		(SELECT Simbolo FROM faturacao_moedas WHERE faturacao_moedas.ID_Moeda = faturacao_honorarios.ID_Moeda )AS Simbolo, 
		TaxaMoeda,
		Vencimento,
		(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_honorarios.ID_Serie) AS Serie,  
		Numero, 
		Data, 
		DataValidade, 
		Referencia, 
		Observacoes, 
		PercentagemDesconto, 
		Estado, 
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_honorarios.ID_Utilizador) AS Criador, 
		TimeStampDate, 
		(SELECT Nome FROM utilizador WHERE utilizador.ID_Utilizador = faturacao_honorarios.ID_UtilizadorAtualizacao) AS UtilizadorAtualizacao, 
		DataAtualizacao 
		FROM faturacao_honorarios WHERE ID_Honorario=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idHonorario);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Honorario'],
	        	$objectData['Cliente'],
	        	$objectData['Nif'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['Moeda'],
	        	$objectData['IsoCode'],
	        	$objectData['Simbolo'],
	        	$objectData['TaxaMoeda'],
	        	$objectData['Vencimento'],
	        	$objectData['Serie'],
	        	$objectData['Numero'],
	        	$objectData['Data'],
	        	$objectData['DataValidade'],
	        	$objectData['Referencia'],
	        	$objectData['Observacoes'],
	        	$objectData['PercentagemDesconto'],
	        	$objectData['Estado'],
	        	$objectData['UtilizadorCriador'],
	        	$objectData['DataCriacao'],
	        	$objectData['ID_UtilizadorAtualizacao'],
	        	$objectData['DataAtualizacao']
			);
	$stmt -> fetch();
	$stmt -> close();

	$objectData['PaisFull'] = getCountryByISO2($objectData['PaisCliente']);
	$objectData['DataCriacao'] = date('d/m/Y H:i:s', $objectData['DataCriacao']);
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DA HONORÁRIOS ------------------------------------------
$query = "SELECT (SELECT Codigo FROM faturacao_artigos WHERE faturacao_artigos.ID_Artigo = faturacao_honorarios_linhas.ID_Artigo) AS Artigo,
		Descricao,
		Quantidade,
		UnidadeMedida,
		PrecoUnitario,
		ID_Imposto,
		(SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_honorarios_linhas.ID_Imposto) AS Imposto,
		(SELECT Valor FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_honorarios_linhas.ID_Imposto) AS ValorIVA,
		(SELECT ID_Motivo FROM faturacao_motivos_isencao WHERE faturacao_motivos_isencao.Codigo = faturacao_honorarios_linhas.TaxExemptionCode ) AS ID_Motivo,
		CONCAT(TaxExemptionCode,': ',TaxExemptionReason) AS Motivo,
		DescontoLinha,
		ValorRetencao,
		TotalLinha
		FROM faturacao_honorarios_linhas WHERE ID_Honorario=? ORDER BY ID_Linha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idHonorario);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($artigo, $descricao, $qtd, $unidade, $preco, $idIva, $desc_imposto, $valorIva, $id_motivo, $motivo, $desconto, $retencao, $totalLinha );
	while ($stmt -> fetch()) {
		$data[] = array(
		        	"artigo" => $artigo,
					"descricao" => $descricao,
					"qtd" => $qtd,
					"unidade" => $unidade,
					"preco" => $preco,
					"idIva" => $idIva,
					"imposto" => number_format($valorIva,2).'%',
					"desc_imposto" => $desc_imposto,
					"valorIva" => $valorIva,
					"id_motivo" => $id_motivo,
					"motivo" => $motivo,
					"desconto" => $desconto,
					"retencao" => $retencao,
					"totalLinha" => $totalLinha,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $data;
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>