<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$idNota = $_POST['idNota'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idNota == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado, Data, Validade, ID_Serie, TotaRetencao, TotalPagar, ID_Documento_Origem, Tipo_Documento_Origem, Data_Documento_Origem FROM faturacao_notas_credito WHERE ID_NotaCredito=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idNota);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $data, $validade, $serie, $retencaoTotal, $totalPagar, $docOrigem, $docType, $dataOrigin );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado != 'Rascunho') {
	$response["errors"] = true;
	$response["type"] = "usado";
	$response["line"] = "FATS003";
	$response["message"] = "Nota já finalizada!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}

//CHECK IF CLOSED MONTH -------------------------------------------------
$dateCheckPost = isset($data) && $data != '' ? $data : date("d/m/Y");
$dateCheckAux = explode("/", $dateCheckPost);
$isClosedMonth = checkIfClosedMonth($dateCheckAux[1],$dateCheckAux[2]);
if($isClosedMonth){
	$response["errors"] = true;
	$response["exists"] = true;
	$response["type"] = "FATS000x";
	$response["message"] = 'Le mois correspondant à la date indiquée est déjà clôturé par la comptabilité.';
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//PROCESS ORIGIN
$fieldIdName = '';
$tableName = '';
switch ($docType) {
	case 'FT':
		$fieldIdName = 'ID_Fatura';
		$tableName = 'faturacao_faturas';
		break;
	case 'FS':
		$fieldIdName = 'ID_FaturaSimplificada';
		$tableName = 'faturacao_faturas_simplificadas';
		break;
	case 'FR':
		$fieldIdName = 'ID_FaturaRecibo';
		$tableName = 'faturacao_faturas_recibo';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000AA";
		$response["message"] = 'Tipo inválido!';
		die(json_encode($response));
		break;
}

$extraOri = 0; $extraLiqOri = 0; $extraPorPagarOri = 0; $extraPorPagarOri2 = 0;
//-----------------------------------------------------------------------


try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//CHECK ORIGIN DOCUMENT -------------------------------------------------
	$query = "SELECT TotalLiquidadoDocumento, GrossTotal, Estado, (TotalExtra - TotalExtraLiquidado) FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS0000C";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($totalLiqDocOrig, $GrossTotalOrig, $estadoOrigem, $extraPorPagarOri2 );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000D";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//VERIFY TOTAL PAYABLE
	$totalMaxPagavel = ($GrossTotalOrig - $totalLiqDocOrig) + $extraPorPagarOri2;
	if( $totalPagar > $totalMaxPagavel){
		$response["errors"] = true;
		$response["type"] = "var";
		$response["pagavel"] = true;
		$response["line"] = "FATS0000E";
		die(json_encode($response));
	}
	//-----------------------------------------------------------------------

	//CLOSE THE DOCUMENT ----------------------------------------------------
	$systemEntryDateUpdate = date("Y-m-d H:i:s");
	$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
	$invoiceStatusDate = date("Y-m-d H:i:s");
	$invoiceStatusDate = str_replace (' ','T',$invoiceStatusDate);
	$sourceID = $_SESSION['username'];
	$hash = 'TESTE';
	$hashControl = 1;
	$hashPrint = 'ABCD';
	$movementEndTime = '';
	// $retencaoCalc = round($retencaoTotal,2);
	$retencaoCalc = $retencaoTotal;
	// $totalLiquidado = $retencaoCalc;
	// $totalLiquidado = 0;

	$dataNew = $data;
	$validadeNew = $validade;
	$dataAtualizacao = date("d/m/Y H:i:s");

	//process InvoiceDate and period to the choosen one
	$tempDate = DateTime::createFromFormat('d/m/Y', $data);
	$invoiceDate = $tempDate->format('Y-m-d');
	$period = $tempDate->format('m');
	//define start time
	$movementStartTime = $tempDate->format("Y-m-d H:i:s");
	$movementStartTime = str_replace (' ','T',$movementStartTime);


	//GET LAST DATE
	$query = "SELECT Numero, Data FROM faturacao_notas_credito WHERE ID_Serie = ? AND Numero > 0 ORDER BY STR_TO_DATE( Data,  '%d/%m/%Y' ) DESC LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $serie);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA023";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($numMax, $dataLast);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA024";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $numMax > 0){
		//this entry date timestamp
		$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
		$dtOriginDateTime = $dtOriginDate->getTimestamp();

		//last date timestamp
		$dtLast = DateTime::createFromFormat("d/m/Y H:i:s", $dataLast." 00:00:00");
		$dtLastTime = $dtLast->getTimestamp();

		//this entry validade timestamp
		$dtThisValidade = DateTime::createFromFormat("d/m/Y H:i:s", $validade." 00:00:00");
		$dtThisValidadeTime = $dtThisValidade->getTimestamp();

		//this entry date timestamp
		$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
		$dtThisDateTime = $dtThisDate->getTimestamp();

		//process new dates
		if( $dtThisDateTime < $dtLastTime ){
			// $dataNew = $dataLast;
			// //update invoiceDate and period
			// $invoiceDate = date("Y-m-d");
			// $period = date("m");
			// //define start time
			// $movementStartTime = date("Y-m-d H:i:s");
			// $movementStartTime = str_replace (' ','T',$movementStartTime);
			
			//alert user that the date is before the last one
			$response["errors"] = true;
			$response["type"] = "FTGA024A";
			$response["data_superior"] = true;
			$response["dataUltima"] = $dataLast;
			$response["message"] = "Data superior à última nota.";
			die(json_encode($response));
		}
		//process date origin
		if( $dtThisDateTime < $dtOriginDateTime ){
			//alert user that the date is before the last one
			$response["errors"] = true;
			$response["type"] = "FTGA024B";
			$response["data_superior2"] = true;
			$response["dataUltima"] = $dataOrigin;
			$response["message"] = "Data superior à última fatura.";
			die(json_encode($response));
		}

		if( $dtThisValidadeTime < $dtThisDateTime ){
			$validadeNew = $data;
		}
	}else{
		//this entry date timestamp
		$dtOriginDate = DateTime::createFromFormat("d/m/Y H:i:s", $dataOrigin." 00:00:00");
		$dtOriginDateTime = $dtOriginDate->getTimestamp();

		//this entry date timestamp
		$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
		$dtThisDateTime = $dtThisDate->getTimestamp();

		//process date origin
		if( $dtThisDateTime < $dtOriginDateTime ){
			//alert user that the date is before the last one
			$response["errors"] = true;
			$response["type"] = "FTGA024C";
			$response["data_superior2"] = true;
			$response["dataUltima"] = $dataOrigin;
			$response["message"] = "Data superior à última fatura.";
			die(json_encode($response));
		}
	}

	// DEFINE NEW NUMBER
	$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_notas_credito WHERE ID_Serie=".intval($serie).";";
	$maxID = getMaxNumberDocument($queryStmt);
	$initNumber = getInitNumber("NumeroInicial_NC","faturacao_series", "WHERE ID_Serie=?", $serie);
	if($nextID < $initNumber && $maxID < 1){
		$query = "UPDATE faturacao_notas_credito SET Numero = ".$initNumber.", ID_Serie=?, Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Pago' WHERE ID_NotaCredito = ?";
	}else{
		$query = "UPDATE faturacao_notas_credito SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_notas_credito WHERE ID_Serie=?) AS SubNumeroMax) + 1), Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Pago' WHERE ID_NotaCredito = ?";
	}
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssdsd", $serie, $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idNota);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			// restoreRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		// restoreRecord($idNota);
		die(json_encode($response));
	}

	// UPDATE REMAIN FIELDS
	$query = "UPDATE faturacao_notas_credito SET InvoiceStatusDate=?, SourceID=?, Hash=?, HashControl=?, Hash_Print=?, Period=?, InvoiceDate=?, MovementEndTime=?, MovementStartTime=?, SystemEntryDate=? WHERE ID_NotaCredito = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssdssssssd", $invoiceStatusDate, $sourceID, $hash, $hashControl, $hashPrint, $period, $invoiceDate, $movementEndTime, $movementStartTime, $systemEntryDateUpdate, $idNota );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			// restoreRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		// restoreRecord($idNota);
		die(json_encode($response));
	}
	// UPDATE REMAIN FIELDS LINES
	$query = "UPDATE faturacao_notas_credito_linhas SET TaxPointDate=? WHERE ID_NotaCredito = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sd", $invoiceDate, $idNota );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026A";
			$response["message"] = $stmt -> error;
			// restoreRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026B";
		$response["message"] = $sqli_connection -> error;
		// restoreRecord($idNota);
		die(json_encode($response));
	}

	//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
	$query = "SELECT TotalLiquidadoDocumento, TotalLiquidado, GrossTotal, TotalPagar, Estado, TotalExtra, TotalExtraLiquidado, (TotalExtra - TotalExtraLiquidado) FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026C";
			$response["message"] = $stmt -> error;
			// restoreRecord($idNota);
			die(json_encode($response));
		}
		$stmt -> bind_result($totalLiqDocOrig, $totalLiqOrig, $GrossTotalOrig, $totalPagarOrig, $estadoOrigemLast, $extraOri, $extraLiqOri, $extraPorPagarOri );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026D";
		$response["message"] = $sqli_connection -> error;
		// restoreRecord($idNota);
		die(json_encode($response));
	}
	//last check on estado
	if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FTGA026E";
		// restoreRecord($idNota);
		die(json_encode($response));
	}else{
		###---- UPDATE DOC ORIGEM ----###
		if($extraPorPagarOri > 0){
			$extraPorPagarOri = round($extraPorPagarOri,$numDecimais);

			$totChecker = floatval($totalPagar) - floatval($extraPorPagarOri);
			$totChecker = round($totChecker,3);
			
			//check payment vals
			// if($totalPagar > $extraPorPagarOri){
			if($totChecker > 0.01){
				$response["errors"] = true;
				$response["type"] = "var";
				$response["pagavel"] = true;
				$response["totalPagar"] = $totalPagar;
				$response["extraPorPagarOri"] = $extraPorPagarOri;
				$response["line"] = "FTGA026EB";
				// deleteRecord($idNota);
				die(json_encode($response));
			}

			//update
			$query = "UPDATE ".$tableName." SET TotalExtraLiquidado=(? + TotalExtraLiquidado) WHERE ".$fieldIdName."=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("sd", $totalPagar, $docOrigem);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA026F";
					$response["message"] = $stmt -> error;
					// deleteRecord($idNota);
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA026G";
				$response["message"] = $sqli_connection -> error;
				// deleteRecord($idNota);
				die(json_encode($response));
			}
		}else{
			// $totalPagarOrig = $totalPagarOrig + $extraPorPagarOri;
			$totalLiqDocOrigNovo = $totalLiqDocOrig + $totalPagar;
			$totalLiqOrigNovo = $totalLiqOrig + $totalPagar;

			$totChecker = floatval($totalLiqOrigNovo) - floatval($totalPagarOrig);
			$totChecker = round($totChecker,3);
			
			$estadoNovo = 'Aberto';
			// if( $totalLiqOrigNovo > $totalPagarOrig ){
			if( $totChecker > 0.01 ){
				$response["errors"] = true;
				$response["type"] = "FATS016A";
				$response["message"] = "Valor inserido superior ao valor pagável!";
				// restoreRecord($idNota);
				die(json_encode($response));
			// }else if($totalLiqOrigNovo == $totalPagarOrig){
			}else if($totChecker >= 0 && $totChecker <= 0.01){
				$estadoNovo = 'Pago';
			}

			$query = "UPDATE ".$tableName." SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("sssd", $totalLiqDocOrigNovo, $totalLiqOrigNovo, $estadoNovo, $docOrigem);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA026F";
					$response["message"] = $stmt -> error;
					// restoreRecord($idNota);
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA026G";
				$response["message"] = $sqli_connection -> error;
				// restoreRecord($idNota);
				die(json_encode($response));
			}
		}
	}
	//--------------------------------------------------------------------

	//UPDATE STOCKS
	$stockUpdateResult = increaseArticlesStock($idNota, 'faturacao_notas_credito', 'ID_NotaCredito');
	if($stockUpdateResult != true){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = 'Falha ao atualizar stocks.';
		die(json_encode($response));
	}

	//------------------------------------------------------------------------
	//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
	//------------------------------------------------------------------------
	$query = "SELECT PlanoContas, PlanoContasBanco,
				(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_credito.ID_Serie) AS Serie,
				Numero , CustomerID, 
				(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_notas_credito.ID_Cliente) AS Cliente,
				GrossTotal, NetTotal, TaxPayable,
				(SELECT CONCAT('FA ',(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',faturacao_faturas.Numero) FROM faturacao_faturas WHERE faturacao_faturas.ID_Fatura = faturacao_notas_credito.ID_Documento_Origem) AS DocumentoOrigem
			FROM faturacao_notas_credito WHERE ID_NotaCredito=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idNota);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA028";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoCliente, $planoBanco, $serie, $numeroDoc, $numCliente, $nomeCliente, $totalPVP, $totalUnit, $totalTVA, $RefDocOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA029";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//PROCESS MOVEMENT FOR DOCUMENT
	$texto = 'Note de Crédit - '.$serie.'/'.$numeroDoc.' - '.$RefDocOrigem.' - '.$numCliente.' - '.$nomeCliente;
	/*if($planoCliente > 0){
		$tipoMovimento = 'C';
		insertMovimentoContabilistico($planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento);
	}*/

	//LINES -- ARTICLES
	$query = "SELECT PlanoContas, ProductCode, TotalLinha, TotalLinhaSIVA, (TotalLinha - TotalLinhaSIVA), ID_Imposto FROM faturacao_notas_credito_linhas WHERE ID_NotaCredito=? ORDER BY ID_Linha";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idNota);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA030";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoArtigo, $codigoArtigo,$totalPVP_Artigo, $totalUnit_Artigo, $totalTVA_Artigo, $id_imposto_artigo );
		while ($stmt -> fetch()) {
			//PROCESS MOVEMENT ARTICLE
			if($planoArtigo > 0){
				$textoArtigo = $texto.' - Article - '.$codigoArtigo;
				// $tipoMovimentoArtigo = 'D';
				$tipoMovimentoArtigo = 1;
				$dataArtigos[] = array('plano'=>$planoArtigo, 'texto'=>$textoArtigo, 'totalPVP'=>$totalPVP_Artigo, 'totalUnit'=>$totalUnit_Artigo, 'totalTVA'=>$totalTVA_Artigo, 'tipo'=>$tipoMovimentoArtigo, 'id_imposto_artigo'=>$id_imposto_artigo);
			}
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA031";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if(isset($dataArtigos)){
		foreach ($dataArtigos as $line) {
				$Edited_TotalPVP = round($line['totalUnit'],$numDecimais);
				if($Edited_TotalPVP > 0){
					insertMovimentoContabilisticoManual($line['plano'], $planoCliente, $line['texto'], $Edited_TotalPVP, 0, $Edited_TotalPVP, $line['tipo'], $data, 'A', $line['id_imposto_artigo'], 0);
				}
		}
	}

	//LINES -- TVA
	$query = "SELECT (SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_notas_credito_linhas.ID_Imposto), (SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_notas_credito_linhas.ID_Imposto) AS Imposto, 
				TaxPercentage, SUM(TotalLinha), SUM(TotalLinhaSIVA), ID_Imposto 
			FROM faturacao_notas_credito_linhas WHERE ID_NotaCredito=? GROUP BY ID_Imposto";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idNota);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA030";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($planoTVA, $nomeTVA, $percentagemTVA, $totalPVP_TVA, $totalUnit_TVA, $id_imposto_TVA );
		while ($stmt -> fetch()) {
			//PROCESS MOVEMENT ARTICLE
			if($planoTVA > 0){
				$totalTVA_TVA = $totalPVP_TVA - $totalUnit_TVA;
				$textoTVA = $texto.' - TVA - '.$nomeTVA.': '.$percentagemTVA.'%';
				// $tipoMovimentoTVA = 'D';
				$tipoMovimentoTVA = 1;
				$dataTVA[] = array('plano'=>$planoTVA, 'texto'=>$textoTVA, 'totalPVP'=>$totalPVP_TVA, 'totalUnit'=>$totalUnit_TVA, 'totalTVA'=>$totalTVA_TVA, 'tipo'=>$tipoMovimentoTVA, 'id_imposto_TVA'=>$id_imposto_TVA);
			}
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA031";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if(isset($dataTVA)){
		foreach ($dataTVA as $line) {
			insertMovimentoContabilisticoManual($line['plano'], $planoCliente, $line['texto'], $line['totalTVA'], 0, $line['totalTVA'], $line['tipo'], $data, 'A', $line['id_imposto_TVA'], 1);
		}
	}
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------


	//log sistema - processo
	$descricao_log ="Finalisation du note de crédit (id: ".$idNota.")";
	insert_log(0,"Editar",$descricao_log,$sqli_connection);

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function restoreRecord($idNota){
	global $sqli_connection;

	// DEFINE NEW NUMBER
	$query = "UPDATE faturacao_notas_credito SET Numero = 0, ID_UtilizadorAtualizacao=0, DataAtualizacao='', Estado='Rascunho' WHERE ID_NotaCredito = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idNota);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM000";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM001";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	// UPDATE REMAIN FIELDS
	$query = "UPDATE faturacao_notas_credito SET InvoiceStatusDate='', SourceID='', Hash='', HashControl='', Hash_Print='', Period='', InvoiceDate='', MovementEndTime='', MovementStartTime='' WHERE ID_NotaCredito = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idNota );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM002";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM003";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	// UPDATE REMAIN FIELDS LINES
	$query = "UPDATE faturacao_notas_credito_linhas SET TaxPointDate='' WHERE ID_NotaCredito = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idNota );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004A";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}

//Recalculate Totals for origin Document
function recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName){
	global $sqli_connection;
	$totalLiqGeralNew = 0;
	$totalLiqDocNew = 0;
	//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
	$query = "SELECT TotalPagar, GrossTotal, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($totalPagarOrigem, $totalGrossOrigem, $estadoOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//last check on estado
	if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "REM007";
		die(json_encode($response));
	}else{
		//GET NC TOTALS -----------------------------
		$query = "SELECT SUM(GrossTotal) FROM faturacao_notas_credito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($sumGrossNC );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009A";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//GET RECEIPTS LINES TOTALS -----------------
		$query = "SELECT SUM(faturacao_recibos_linhas.CreditAmount), SUM(faturacao_recibos_linhas.valorIVA) 
			FROM faturacao_recibos_linhas, faturacao_recibos 
			WHERE faturacao_recibos.ID_Recibo = faturacao_recibos_linhas.ID_Recibo AND ID_Documento=? AND TipoDocumento=? AND faturacao_recibos.Estado IN ('Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($linesCreditSUM, $linesIvaSUM );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//GET RECEIPTS TOTALS -----------------
		$query = "SELECT SUM(GrossTotal), SUM(ValorRetencao) 
			FROM faturacao_recibos 
			WHERE ID_DocumentoMain=? AND Tipo_DocumentoMain=? AND faturacao_recibos.Estado IN ('Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($recTotalSUM, $recRetencaoSUM );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009C";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//totals
		$totalLiqDocNew = $sumGrossNC + ($linesCreditSUM + $linesIvaSUM); //document total payed
		$totalLiqGeralNew = $recTotalSUM + $recRetencaoSUM; //general total payed

		//round numbers
		$totalLiqDocNew = round($totalLiqDocNew,$numDecimais);
		$totalLiqGeralNew = round($totalLiqGeralNew,$numDecimais);

		if($totalLiqDocNew > $totalGrossOrigem){
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010A";
			$response["message"] = "Valores Inválidos";
			die(json_encode($response));
		}

		$estadoNovo = 'Aberto';
		if( $totalLiqGeralNew < $totalPagarOrigem){
			$estadoNovo = 'Aberto';
		}elseif( $totalLiqGeralNew = $totalPagarOrigem){
			$estadoNovo = 'Pago';
		}else{
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010B";
			$response["message"] = "Valores Inválidos";
			die(json_encode($response));
		}

		$query = "UPDATE ".$tableName." SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sssd", $totalLiqDocNew, $totalLiqGeralNew, $estadoNovo, $docOrigem);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM011";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM012";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}
	//--------------------------------------------------------------------
}

?>