<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/faturas-comum/inserir_pagamento_function.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/BVR_Reader/Reader/BvrReader.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ----------------------------------------------------------
$ficheiro_bvr = $_POST['ficheiro_bvr'][0];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $ficheiro_bvr == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//PROCESS THE REQUESTED FILE ---------------------------------------------
$dadosFicheiro = BvrReader($ficheiro_bvr);

//CHECK FOR ERRORS AND REPORT THEM
if($dadosFicheiro['errors'] == true){
	$response = $dadosFicheiro;
	die(json_encode($response));
}
// var_dump($dadosFicheiro);die();
//------------------------------------------------------------------------

//INSERT DB LINES --------------------------------------------------------
$indLine = 1;
$tipoMovimento = 'Record';
$estadoBase = 'En attente'; // Estado Completo = Traité
$countUnprocessedLines = 0;

foreach ($dadosFicheiro['lines'] as $line) {
	//Repalce All NULL values for empty string
	$line = array_map(function($v){
	    if($v == NULL || is_null($v)) return "";
	    else return $v;
	},$line);

	//Init dates
	$Date_Paid_Processed = '';
	$Date_Processed_Processed = '';
	$Date_Credit_Note_Processed = '';
	$DateValuta_Processed = '';
	//process dates
	if(isset($line['Date_Paid']['date'])) $Date_Paid_Processed = cleanDateValues( $line['Date_Paid']['date'] );
    if(isset($line['Date_Processed']['date'])) $Date_Processed_Processed = cleanDateValues( $line['Date_Processed']['date'] );
    if(isset($line['Date_Credit_Note']['date'])) $Date_Credit_Note_Processed = cleanDateValues( $line['Date_Credit_Note']['date'] );
    if(isset($line['DateValuta']['date'])) $DateValuta_Processed = cleanDateValues( $line['DateValuta']['date'] );
    
	//process query
	$query = "INSERT INTO faturacao_movimento_bvr_importados (
		Linha,
		TipoMovimento,
		Estado,
		Both_Transaction_Code,
		Both_Transaction_Type,
		Row_Participant_ID,
		Both_Banking_Account,
		Row_Internal_Bank_Reference,
		Row_Microfilm_Reference,
		Row_Payment_type,
		Both_Signed_Amount,
		Both_ABS_Amount,
		Row_Date_Paid,
		Row_Date_Processed,
		Row_Date_Credit_Note,
		Row_DateValuta,
		Row_Full_BVR,
		Row_Short_BVR,
		Row_Reject_Code,
		Row_Fee,
		FicheiroBVR
		) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssssssssssssssssssss", 
		    $indLine,
		    $tipoMovimento, 
		    $estadoBase, 

		    $line['Transaction_Code'], 
		    $line['Transaction_Type'], 
		    $line['Participant_ID'], 
		    $line['Banking_Account'], 
		    $line['Internal_Bank_Reference'], 
		    $line['Microfilm_Reference'], 
		    $line['Payment_type'], 
		    $line['Signed_Amount'], 
		    $line['ABS_Amount'],

		    $Date_Paid_Processed, 
		    $Date_Processed_Processed, 
		    $Date_Credit_Note_Processed, 
		    $DateValuta_Processed, 

		    $line['Full_BVR'], 
		    $line['Short_BVR'], 
		    $line['Reject_Code'], 
		    $line['Fee'],

		    $ficheiro_bvr
		);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//process entry into system
	$countUnprocessedLines += processBvrIntoSystem($indLine, $line, $ficheiro_bvr);

	//incremente next number
	$indLine++;
}
//------------------------------------------------------------------------

//INSERT DB LINES --------------------------------------------------------
$tipoMovimento = 'Resume';
$estadoBase = 'Traité'; // Estado Completo = Traité

//set line
$lastLine = $dadosFicheiro['resume'][0];

//Repalce All NULL values for empty string
$lastLine = array_map(function($v){
    if($v == NULL || is_null($v)) return "";
    else return $v;
},$lastLine);

//Init dates
$Date_File_Creation_Processed = '';
//process dates
if(isset($lastLine['Date_File_Creation']['date'])) $Date_File_Creation_Processed = cleanDateValues( $lastLine['Date_File_Creation']['date'] );

//Inser Last Line (Totals)
$query = "INSERT INTO faturacao_movimento_bvr_importados (
	Linha,
	TipoMovimento,
	Estado,
	Both_Transaction_Code,
	Both_Transaction_Type,
	Both_Banking_Account,
	Both_Signed_Amount,
	Both_ABS_Amount,
	Resume_Number_Transactions,
	Resume_Date_File_Creation,
	Resume_Sorting_Key,
	Resume_Total_Fees,
	FicheiroBVR
	) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssssssssss", 
	    $indLine,
	    $tipoMovimento, 
	    $estadoBase, 

	    $lastLine['Transaction_Code'], 
	    $lastLine['Transaction_Type'], 
	    $lastLine['Banking_Account'], 
	    $lastLine['Signed_Amount'], 
	    $lastLine['ABS_Amount'], 
	    $lastLine['Number_Transactions'], 

	    $Date_File_Creation_Processed,

	    $lastLine['Sorting_Key'], 
	    $lastLine['Total_Fees'],
	    
	    $ficheiro_bvr
	);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS005";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS006";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//------------------------------------------------------------------------


//log sistema - processo
$descricao_log ="Importation de fichier BVR (nom: ".$ficheiro_bvr.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response["invalid_lines"] = $countUnprocessedLines;
die(json_encode($response));

//Clean Dates for BVR File Fields
function cleanDateValues($dateString)
{
	$cleanDate = '';

	if(isset($dateString)){
		if( !is_null($dateString) ){
			$tempDate = DateTime::createFromFormat('Y-m-d H:i:s', $dateString);
			$cleanDate = $tempDate->format('d/m/Y');
			// var_dump($dateString, $cleanDate);die();
		}
	}

	return $cleanDate;
}

/**
 * Associate and generate necessary dependencies into the system
 * @param  $idLine   
 * @param  $dadosLine
 * @param  $fileBVR
 * @return 0 or 1
 */
function processBvrIntoSystem($idLine, $dadosLine, $ficheiroBVR)
{
	global $sqli_connection;

	//init vars
	$id_fatura=0; $serie_fatura=0; $idSerie_fatura=0; $numero_fatura=0; $totalPorPagar_fatura=0; $metodo_fatura=0; $banco_fatura=0;

	//GET Origin Document -----------------------------------------------
	$query = "SELECT ID_Fatura, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie), ID_Serie, Numero, (TotalPagar - TotalLiquidado), MetodoPagamento, ID_Banco 
		FROM faturacao_faturas WHERE faturacao_faturas.BVR=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $dadosLine['Full_BVR']);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "SPC001";
			$response["message"] = $stmt -> error;
			updateBvrLine($idLine, $dadosLine, $ficheiroBVR, "En attente", "Erreur inconnue!");
			return 1;
		}
		$stmt -> bind_result( $id_fatura, $serie_fatura, $idSerie_fatura, $numero_fatura, $totalPorPagar_fatura, $metodo_fatura, $banco_fatura );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "SPC002";
		$response["message"] = $sqli_connection -> error;
		updateBvrLine($idLine, $dadosLine, $ficheiroBVR, "En attente", "Erreur inconnue!");
		return 1;
	}
	//check if exists
	if($id_fatura < 1){
		updateBvrLine($idLine, $dadosLine, $ficheiroBVR, "En attente", "Erreur: La référence BVR n'existe pas sur le système!");
		return 1;
	}

	//process DocumentoAssociado
	$documentoAssociado = 'FA '.$serie_fatura.'/'.$numero_fatura;

	//check totals
	$lineAmount = floatval($dadosLine['ABS_Amount']);    
    $totPorPagarFat = floatval($totalPorPagar_fatura);

	if(bccomp($lineAmount, $totPorPagarFat, 5) != 0){
		updateBvrLine($idLine, $dadosLine, $ficheiroBVR, "En attente", "Erreur: montant payé différent du montant impayé de la facture!", $documentoAssociado, 'FT');
		return 1;
	}
	//-------------------------------------------------------------------
	
	//process payment
	$ObservacoesRecibo = 'Reçu généré automatiquement après la confirmation du paiement bancaire (fichier BVR).';
	$resultRecu = gerarRecibo($id_fatura, 'FT', $lineAmount, $idSerie_fatura, $metodo_fatura, $banco_fatura, 1, $ObservacoesRecibo);
	if($resultRecu['result'] < 1){
		updateBvrLine($idLine, $dadosLine, $ficheiroBVR, "Traité", "Document payé avec succès!", $documentoAssociado, 'FT');
	}else{
		updateBvrLine($idLine, $dadosLine, $ficheiroBVR, "En attente", "Erreur de paiement de document!", $documentoAssociado, 'FT');
		return 1;
	}

	//return
	return 0;
}

/**
 * [updateBvrLine description]
 * @param  $idLine   
 * @param  $dadosLine
 * @param  $fileBVR
 * @return 0 or 1
 * 
 */
function updateBvrLine($idLine, $dadosLine, $ficheiroBVR, $estado, $observacoes, $idDocOrigem='', $tipoDocOrigem='')
{
	global $sqli_connection;
	// var_dump($idLine,$ficheiroBVR, $estado, $observacoes, $idDocOrigem, $tipoDocOrigem);

	//query 
	$query = "UPDATE faturacao_movimento_bvr_importados SET 
		Estado=?,
		DocumentoAssociado=?,
		DocumentoAssociadoTipo=?,
		Observacoes=?
		WHERE Linha = ? AND FicheiroBVR = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssssss", 
		    $estado,
			$idDocOrigem,
			$tipoDocOrigem,
			$observacoes,
		    $idLine,
		    $ficheiroBVR
		);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "SPC003";
			$response["message"] = $stmt -> error;
			return 1;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "SPC004";
		$response["message"] = $sqli_connection -> error;
		return 1;
	}

	return 0;
}
?>