<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idOrcamento = $_POST['idDocument'];
$estado = $_POST['estado'];
$estadoString = '';

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idOrcamento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//VERIFICA SE PODE SER ALTERADO -----------------------------------------
$query = "SELECT Estado FROM faturacao_orcamentos WHERE ID_Orcamento=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idOrcamento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado != 'Aberto') {
	$response["errors"] = true;
	$response["type"] = "usado";
	$response["line"] = "FATS003";
	$response["message"] = "O orçamento não está aberto!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//ATUALIZAR ESTADO ------------------------------------------------------
if( $estado == 1 ) $estadoString = 'Aprovado';
else $estadoString = 'Rejeitado';
$dataAtualizacao = date("d/m/Y H:i:s");

$query = "UPDATE faturacao_orcamentos SET Estado=?, DataAtualizacao=?, ID_UtilizadorAtualizacao=? WHERE ID_Orcamento = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssdd", $estadoString, $dataAtualizacao, $id_utilizador, $idOrcamento);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));
?>