<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idProforma = $_POST['idProforma'];
$cliente = $_POST['cliente'];
$serie = $_POST['serie'];
$numero = $_POST['numero'];
$data = $_POST['data'];
$validade = $_POST['validade'];
$referencia = $_POST['referencia'];
$vencimento = $_POST['vencimento'];
$moeda = $_POST['moeda'];
$desconto = $_POST['desconto'];
$observacoes = $_POST['observacoes'];
$linhas = $_POST['linhas'];
$finalizarDocumento = $_POST['finalizarDocumento'];

//REMAIN VARdtThisValidade ------------------------------------------------------------
$vendedor = $_SESSION['username'];
$estado = 'Rascunho';
$taxPayable = 0;
$netTotal = 0;
$grossTotal = 0;
$systemEntryDate = '';
$timestamp = 0;
$totalDesconto = 0;
$percentagemDesconto = $desconto;
$retencaoTotal = 0;
$totalSDesconto = 0;

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idProforma == '' || $idProforma < 1 || $cliente == '' || $serie == '' || $numero == '' || $data == '' || $validade == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET CLIENT DATA --------------------------------------------------------
$query = "SELECT Nif, Endereco, CodigoPostal, (SELECT Nome FROM concelho WHERE concelho.ID_Concelho = faturacao_clientes.Cidade) AS Cidade, (SELECT Nome FROM distrito WHERE distrito.ID_Distrito = faturacao_clientes.Regiao) AS Regiao, Pais, Email FROM faturacao_clientes WHERE ID_Cliente = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $cliente);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Nif, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Pais, $Email );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//process fields
if( trim($Endereco) == '' ) $Endereco = 'Desconhecido';
if( trim($CodigoPostal) == '' ) $CodigoPostal = 'Desconhecido';
if( trim($Cidade) == '' ) $Cidade = 'Desconhecido';
if( trim($Regiao) == '' ) $Regiao = 'Desconhecido';
if( trim($Pais) == '' ) $Pais = 'Desconhecido';
//------------------------------------------------------------------------

//GET CURRENCY DATA ------------------------------------------------------
$query = "SELECT  Ultima_Taxa FROM faturacao_moedas WHERE ID_Moeda = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $moeda);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ultimaTaxa);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $ultimaTaxa <= 0){
	$response["errors"] = true;
	$response["type"] = "FTGA005";
	$response["message"] = "Moeda inválida";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET COMPANY DATA -------------------------------------------------------
$query = "SELECT  CONCAT(Endereco1,' ',Endereco2) AS Endereco, CodigoPostal, (SELECT Nome FROM concelho WHERE concelho.ID_Concelho = faturacao_empresa_dados.Cidade) AS CIDADENAME, Cidade FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1";
if ($stmt = $sqli_connection -> prepare($query)) {
	// $stmt -> bind_param("d", $moeda);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($enderecoCarga, $codigopostalCarga, $cidadeCarga, $idCidadeCarga);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//GET REGION
$query = "SELECT (SELECT Nome FROM distrito WHERE distrito.ID_Distrito = concelho.ID_Distrito) AS Regiao FROM concelho WHERE ID_Concelho = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idCidadeCarga);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA008";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($regiaoCarga);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA009";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//process fields
if( trim($enderecoCarga) == '' ) $enderecoCarga = 'Desconhecido';
if( trim($codigopostalCarga) == '' ) $codigopostalCarga = 'Desconhecido';
if( trim($cidadeCarga) == '' ) $cidadeCarga = 'Desconhecido';
if( trim($regiaoCarga) == '' ) $regiaoCarga = 'Desconhecido';
//------------------------------------------------------------------------

$timestamp = microtime(true);
$systemEntryDate = date("Y-m-d H:i:s");
$systemEntryDate = str_replace (' ','T',$systemEntryDate);

//INSERT OPEN DOCUMENT ---------------------------------------------------
$query = "UPDATE faturacao_proformas SET ID_Cliente=?, EnderecoCliente=?, CodigoPostalCliente=?, CidadeCliente=?, RegiaoCliente=?, EmailCliente=?, PaisCliente=?, ID_Moeda=?, TaxaMoeda=?, Vendedor=?, Vencimento=?, EnderecoCarga=?, CodigoPostalCarga=?, CidadeCarga=?, RegiaoCarga=?, ID_Serie=?, Data=?, DataValidade=?, Referencia=?, Observacoes=?, SystemEntryDate=?, TimeStampDate=?, Estado=?, ID_Utilizador=? WHERE ID_Proforma=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssssssdsssssssdsssssssdd", $cliente, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Email, $Pais, $moeda, $ultimaTaxa, $vendedor, $vencimento, $enderecoCarga, $codigopostalCarga, $cidadeCarga, $regiaoCarga, $serie, $data, $validade, $referencia, $observacoes, $systemEntryDate, $timestamp, $estado, $id_utilizador, $idProforma );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA010";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA011";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//CLEAN ALL LINES --------------------------------------------------------
$query = "DELETE FROM faturacao_proformas_linhas WHERE ID_Proforma=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idProforma );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA012";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA013";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//PROCESS LINES ----------------------------------------------------------
$numLinha = 1;
foreach ($linhas as $linha) {
	//init vars
	$ProductDescription = '';
	$ProductCode = '';
	$SerialNumber = '';
	$TaxType = '';
	$TaxCountryRegion = '';
	$TaxCode = '';
	$TaxPercentage = '';
	$impostoUsed = '';
	$TaxExemptionCode = '';
	$TaxExemptionReason = '';
	$TaxPointDate = date("Y-m-d");	

	//GET ARTICLE DATA ---------------------------------------------------
	$query = "SELECT  Nome, Codigo, SerialNumber, (SELECT Sigla FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade = faturacao_artigos.ID_Unidade) AS Unidade FROM faturacao_artigos WHERE ID_Artigo = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA015";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ProductDescription, $ProductCode, $SerialNumber, $Unidade);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA016";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	//GET TAXES DATA -----------------------------------------------------
	$query = "SELECT  Tipo, Regiao, Subclasse, Valor FROM faturacao_impostos WHERE ID_Imposto = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['imposto']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA017";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA018";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
		//VERIFICAR SE IMPOSTO JÁ BLOQUEADO -------------------------------------
		$query = "SELECT COUNT(*) FROM faturacao_impostos_usados WHERE ID_Imposto=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $linha['imposto']);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018A";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($impostoUsed);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA018B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		if($impostoUsed < 1){
			//INSERT DB --------------------------------------------------
			$query = "INSERT INTO faturacao_impostos_usados(ID_Imposto) VALUES (?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("d", $linha['imposto'] );
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA018C";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018D";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}
			//------------------------------------------------------------
		}

		//CASO SEJA TIPO ISE
		// if( $TaxCode == 'ISE' ){
		if( $TaxCode == 'ISENTO' ){
			if( $linha['motivo'] < 1){
				$response["errors"] = true;
				$response["type"] = "var";
				$response["line"] = "FTGA018E";
				$response["message"] = "Motivo de isenção inválido";
				die(json_encode($response));
			}else{
				$query = "SELECT  Codigo, Descricao FROM faturacao_motivos_isencao WHERE ID_Motivo = ?";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("d", $linha['motivo']);
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "FTGA018F";
						$response["message"] = $stmt -> error;
						die(json_encode($response));
					}
					$stmt -> bind_result($TaxExemptionCode, $TaxExemptionReason);
					$stmt -> fetch();
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "FTGA018G";
					$response["message"] = $sqli_connection -> error;
					die(json_encode($response));
				}
			}

		}
	//--------------------------------------------------------------------
	
	//check if vals are smaller than 0
	if( $linha['qtd'] <= 0 ){
		$response["errors"] = true;
		$response["type"] = "FTGA018H";
		$response["message"] = 'Valores das linhas menores que 0';
		deleteRecord($idProforma);
		die(json_encode($response));
	}
	if( $linha['preco'] < 0 ){
		$response["errors"] = true;
		$response["type"] = "FTGA018I";
		$response["message"] = 'Valores das linhas menores que 0';
		deleteRecord($idProforma);
		die(json_encode($response));
	}
	
	//TOTALS
	$debitAmount = 0;
	$creditAmount = 0;
	$settelementAmount = 0;
	$totalSIVA = 0;
	$totalLinha = 0;

	$linhaDesconto = $linha['desconto'] * 0.01;
	$descontoProcessed = $desconto * 0.01;
	$taxaIVA = $TaxPercentage * 0.01;
	$ivaProcessed = $taxaIVA + 1 ;

	$totalSIVA = $linha['qtd'] * $linha['preco'];
	$desconto1 = $totalSIVA * $linhaDesconto; //calcula desconto 1
	$totalSIVA = $totalSIVA - ($totalSIVA * $linhaDesconto); //calcula descunto linha
	$desconto2 = $totalSIVA * $descontoProcessed; //calcula desconto 2
	$totalSIVA = $totalSIVA - ($totalSIVA * $descontoProcessed); //calcula desconto global

	$settelementAmount = $desconto1 + $desconto2;
	$creditAmount = $totalSIVA;
	$totalLinha = $totalSIVA * $ivaProcessed;

	$retencao = $linha['retencao'] * 0.01;
	$retencao = $totalSIVA * $retencao;

	//TOTALS PRO-FORMA
	$taxPayable = $taxPayable + ($totalSIVA * $taxaIVA);
	$netTotal = $netTotal + $totalSIVA;
	$grossTotal = $taxPayable + $netTotal;
	$grossTotal = round($grossTotal,2);
	$totalDesconto = $totalDesconto + $settelementAmount;
	if( $Nif != '999999990' ) $retencaoTotal = $retencaoTotal + $retencao;
	$totalSDesconto = $totalSDesconto + ( $linha['qtd'] * $linha['preco'] );

	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_proformas_linhas (ID_Proforma, NumeroLinha, 
		ID_Artigo, ProductCode, ProductDescription, Quantidade, UnidadeMedida, PrecoUnitario, TaxPointDate, Descricao, SerialNumber, 
		ID_Imposto, TaxType, TaxCountryRegion, TaxCode, TaxPercentage, TaxExemptionReason, TaxExemptionCode, 
		DescontoLinha, CreditAmount, DebitAmount, SettlementAmount, ValorRetencao, PercentagemRetencao, TotalLinha, TotalLinhaSIVA) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssss", $idProforma, $numLinha, $linha['artigo'], $ProductCode, $ProductDescription, $linha['qtd'], $Unidade, $linha['preco'], $TaxPointDate, $linha['descricao'], $SerialNumber, $linha['imposto'], $TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage, $TaxExemptionReason, $TaxExemptionCode, $linha['desconto'], $creditAmount, $debitAmount, $settelementAmount, $retencao, $linha['retencao'], $totalLinha, $totalSIVA );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA019";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	$numLinha++;

	//BLOCK ARTICLE ------------------------------------------------------
	$query = "UPDATE faturacao_artigos SET Usado=1 WHERE ID_Artigo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
}
//------------------------------------------------------------------------

//UPDATES TOTALS ---------------------------------------------------------
$query = "UPDATE faturacao_proformas SET TaxPayable=?, NetTotal=?, GrossTotal=?, Desconto=?, PercentagemDesconto=?, TotaRetencao=?, TotalSDesconto=? WHERE ID_Proforma=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssssd", $taxPayable, $netTotal, $grossTotal, $totalDesconto, $percentagemDesconto, $retencaoTotal, $totalSDesconto, $idProforma);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA021";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA022";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
if( $finalizarDocumento > 0 ){
	$dataNew = $data;
	$validadeNew = $validade;
	$dataAtualizacao = date("d/m/Y H:i:s");


	//GET LAST DATE
	$query = "SELECT MAX(Numero), Data FROM faturacao_proformas WHERE ID_Serie = ? AND Numero > 0";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $serie);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA023";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($numMax, $dataLast);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA024";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $numMax > 0){
		//last date timestamp
		$dtLast = DateTime::createFromFormat("d/m/Y H:i:s", $dataLast." 00:00:00");
		$dtLastTime = $dtLast->getTimestamp();

		//this entry date timestamp
		$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
		$dtThisDateTime = $dtThisDate->getTimestamp();
		//this entry validade timestamp
		$dtThisValidade = DateTime::createFromFormat("d/m/Y H:i:s", $validade." 00:00:00");
		$dtThisValidadeTime = $dtThisValidade->getTimestamp();

		//process new dates
		if( $dtThisDateTime < $dtLastTime ){
			$dataNew = $dataLast;
		}
		if( $dtThisValidadeTime < $dtLastTime ){
			$validadeNew = $dataLast;
		}
	}

	// DEFINE NEW NUMBER
	$query = "UPDATE faturacao_proformas SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_proformas WHERE ID_Serie=?) AS SubNumeroMax) + 1), Data=?, DataValidade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_Proforma = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssdsd", $serie, $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idProforma);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
}else{
	$response["proforma"] = $idProforma;
}
//------------------------------------------------------------------------

//BLOCK ARTICLE ----------------------------------------------------------
$query = "UPDATE faturacao_clientes SET Usado=1 WHERE ID_Cliente=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $cliente);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA028";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));
?>