<?php
/**
 * |-----------------------------------------------------------------------
 * |
 * |						Invoices Actions - API
 * |
 * |-----------------------------------------------------------------------
 */
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/auth/controltoken.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/processor.php";

//GLOBAL VARS -----------------------------------------------------------
$opcao = $gOpcaoProcessor;
$baseLnk = getBaseLink();
$api_path = getApiPath();
$webservices_path = getWebservicesPath();
$_tokenRequest = $recToken;
//-----------------------------------------------------------------------

//GET POST VARS ---------------------------------------------------------
switch ($opcao) {
	case 0:
		//GET ALL INVOICES (AJAX)
		$search = $_GET['search'];
		$idinvoice = $_GET['idinvoice']; /*DON'T USE FOR NOW*/
		$page = $_GET['page'];

		getAllInvoices($search, $idinvoice, $page);
		//---------------------------------
		break;

	case 1:
		//GET INVOICE DETAILS
		$idinvoice = $_GET['idinvoice'];

		getInvoiceDetails($idinvoice);
		//---------------------------------
		break;

	case 2:
		//ADD INVOICE
		$receivedData = $_POST;

		addInvoice($receivedData);
		//---------------------------------
		break;

	case 3:
		//EDIT INVOICE
		$receivedData = $_PUT;
		// editInvoice($receivedData);
		
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 501 Not Implemented.');
		$response["errors"] = true;
		$response["received_data"] = $receivedData;
		die( json_encode($response) );
		//---------------------------------
		break;

	case 4:
		//DELETE INVOICE
		$receivedData = $_DELETE;
		// deleteInvoice($receivedData);
		
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 501 Not Implemented.');
		$response["errors"] = true;
		$response["received_data"] = $receivedData;
		die( json_encode($response) );
		//---------------------------------
		break;

	case 5:
		//CANCEL INVOICE
		$receivedData = $_PATCH;
		// cancelInvoice($receivedData);
		
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 501 Not Implemented.');
		$response["errors"] = true;
		$response["received_data"] = $receivedData;
		die( json_encode($response) );
		//---------------------------------
		break;

	default:
		//CANCEL THE REQUEST
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 501 Not Implemented.');
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "WAPI_VAR001";
		$response["message"] = 'Invalid option received. Please provide a valid option.';
		die(json_encode($response));
		//---------------------------------
		break;
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------

//GET ALL INVOICES -------------------------------------------------------
function getAllInvoices($search, $idinvoice, $page){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/combobox/vendas_select2_ajax.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/combobox/vendas_select2_ajax.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		"opcao" => 8,
		"search_term" => $search ? $search : null,
		"search_idfatura" => $idinvoice ? $idinvoice : null,
		"page" => $page ? $page : 1,
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

//GET DETAILS INVOICE ----------------------------------------------------
function getInvoiceDetails($idinvoice){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/faturas/ws_detalhes.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/faturas/ws_detalhes.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		"idDocument" => $idinvoice,
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

//ADD INVOICE ------------------------------------------------------------
function addInvoice($dataToProcess){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/faturas/ws_inserir.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/faturas/ws_inserir.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		"cliente" => $dataToProcess['idclient'],
		"numero" => 0,
		"data" => $dataToProcess['date'],
		"referencia" => $dataToProcess['reference'],
		"vencimento" => $dataToProcess['payment_conditions'],
		"desconto" => $dataToProcess['discount'],
		"observacoes" => $dataToProcess['observation'],
		"linhas" => json_encode( $dataToProcess['lines'] ),
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

?>