<?php 
// $helpersFile = true;

//init common vars
// $uniMedida = getValorPadrao('UnidadesMedida', 'faturacao_personalizar_documentos');
// $numDecimaisPrice = getValorPadrao('NumCasasDecimais', 'faturacao_personalizar_documentos');
// if(!$uniMedida) $uniMedida = 0;
// if(!$numDecimaisPrice) $numDecimaisPrice = 2;
// $numDecimais = 2;

/**
 * |-----------------------------------------------------------------------
 * |
 * |						Helper Functions
 * |
 * | Functions to be used anytime, anywhere. Just like a service provider.
 * |
 * |-----------------------------------------------------------------------
 */

//CHECK IF ADMIN FATURAÇÃO
function adminCheckerFat($userID){
	global $sqli_connection;
	//process
	$query = "SELECT AdministradorFaturacao FROM utilizador WHERE ID_Utilizador = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $userID);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($administrador);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//return next id
	return $administrador;
}

/**
 * Get the Next ID for table
 * @param  $fieldName
 * @param  $tableName
 * @return next id
 */
function getNextID($fieldName,$tableName){
	global $sqli_connection;
	//process
	$query = "SELECT MAX(CAST(".$fieldName." AS UNSIGNED)) FROM ".$tableName."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($nextID);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//return next id
	return $nextID+1;
}

/**
 * Get the Next ID for table
 * @param  $fieldName
 * @param  $tableName
 * @return next id
 */
function getNextID_Perm($fieldName,$tableName){
	global $sqli_connection;
	//process
	$query = "SELECT MAX(CAST(".$fieldName." AS UNSIGNED)) FROM ".$tableName."";
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($nextID);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//new id
	$newID = $nextID+1;
	$finalID = $newID;

	if($newID < 10) $finalID = '000'.$newID;
	elseif($newID < 100) $finalID = '00'.$newID;
	elseif($newID < 1000) $finalID = '0'.$newID;

	//return next id
	return $finalID;
}

/**
 * Get the Next ID for table
 * @param  $fieldName
 * @param  $tableName
 * @return next id
 */
function getUserFullName($userID){
	global $sqli_connection;
	//process
	$query = "SELECT Nome FROM utilizador WHERE ID_Utilizador = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $userID);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($nomeUtilizador);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//return next id
	return $nomeUtilizador;
}

/**
 * Get The base table
 * @return return base table string
 */
function getSncBaseTable(){
	global $sqli_connection;
	//GET SNC TABLE IN USE --------------------------------------------------
	$snc_table = '';

	//GET TYPE OF SNC (S OR M)
	$query = "SELECT NormaContabilistica FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
	    $result = $stmt -> execute();
	    if (false === $result) {}
	    $stmt -> bind_result($typeSNC);
	    $stmt -> fetch();
	    $stmt -> close();
	} else {
	    $response["errors"] = true;
		$response["type"] = "HELP003";
	    $response["message"] = $sqli_connection -> error;
	    die(json_encode($response));
	}
	if($typeSNC == 'S') $snc_table = 'faturacao_snc_base';
	else if($typeSNC == 'M') $snc_table = 'faturacao_snc_micro';
	else{
	    $response["errors"] = true;
		$response["type"] = "HELP004";
	    $response["message"] = 'SNC base não definido!';
	    die(json_encode($response));
	}
	//-----------------------------------------------------------------------
	
	return $snc_table;
}

/**
 * Get Valores Padrão
 * @return padrão
 */
function getValorPadrao($fieldName, $tableName){
	global $sqli_connection;
	$padrao = '';
	//process
	$query = "SELECT ".$fieldName." FROM ".$tableName." LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($padrao);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	return $padrao;
}

/**
 * Check if document can be edited
 * @param  $idObject
 * @param  $statusFieldName
 * @param  $statusString
 * @param  $tableName
 * @return bool
 */
function checkIfCanBeEdit($idObject, $idFieldName, $statusFieldName, $statusString, $tableName){
	global $sqli_connection;
	$canEdit = false;

	//process
	$query = "SELECT ".$statusFieldName." FROM ".$tableName." WHERE ".$idFieldName." = ".$idObject." LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($statusDB);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	if( $statusDB != $statusString ) $canEdit = false;
	else $canEdit = true;

	return $canEdit;
}

/**
 * Check if document can be edited
 * @param  $idObject
 * @param  $statusFieldName
 * @param  $statusString
 * @param  $tableName
 * @return bool
 */
function checkIfCanBeEditCompra($idObject){
	global $sqli_connection;
	$canEdit = false;

	$extraCondition = "(SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE faturacao_compras_notas_credito.ID_Documento_Origem = faturacao_compras.ID_Compra)";

	//process
	$query = "SELECT (SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE faturacao_compras_notas_credito.ID_Documento_Origem = faturacao_compras.ID_Compra) AS CountNotasCredito, (SELECT COUNT(*) FROM faturacao_compras_pagamentos WHERE faturacao_compras_pagamentos.ID_Compra = faturacao_compras.ID_Compra) AS CountPagamentos, Estado FROM faturacao_compras WHERE ID_Compra = ".$idObject." LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($countNC, $countPayments, $estadoAchat);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//process checker
	if($estado == 'Anulado' || $estado == 'Pago' ) $canEdit = false;
	else {
		if($countNC == 0 && $countPayments == 0) $canEdit = true;
		else $canEdit = false;
	}

	// if( $statusDB != $statusString ) $canEdit = false;
	// else $canEdit = true;

	return $canEdit;
}

/**
 * Check payment values
 * @param  $idObject
 * @param  $statusFieldName
 * @param  $statusString
 * @param  $tableName
 * @return bool
 */
function resetDocumentPaymentTotals($idDocument, $type){
	global $sqli_connection;
	$resultChecker = true;

	$totalPagoGeral = 0;
	$totalPagoDocument = 0;
	$fieldIdName = '';
	$tableName = '';

	//MAIN DOCUMENT TABLE NAME
	switch ($type) {
		case 'FT':
			$fieldIdName = 'ID_Fatura';
			$tableName = 'faturacao_faturas';
			break;
		case 'FS':
			$fieldIdName = 'ID_FaturaSimplificada';
			$tableName = 'faturacao_faturas_simplificadas';
			break;
		case 'FR':
			$fieldIdName = 'ID_FaturaRecibo';
			$tableName = 'faturacao_faturas_recibo';
			break;
		
		default:
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0001";
			$response["message"] = 'Tipo inválido!';
			die(json_encode($response));
			break;
	}

	//#GET ASSOCIATED DOCS (ND) --------------------------
	$query = "SELECT SUM(TotalLiquidado) FROM faturacao_notas_debito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ds", $idDocument, $type);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0002";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($sumTotalLiquidadoND );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0003";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//#---------------------------------------------------
	
	//#GET ASSOCIATED DOCS (NC) --------------------------	
	$query = "SELECT SUM(GrossTotal) FROM faturacao_notas_credito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ds", $idDocument, $type);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($sumTotalLiquidadoNC );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0005";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//#---------------------------------------------------

	//GET RECEIPT LINES FOR MAIN DOCUMENT ----------------
	$query = "SELECT CreditAmount, valorIVA FROM faturacao_recibos_linhas, faturacao_recibos 
	WHERE faturacao_recibos_linhas.TipoDocumento=? AND faturacao_recibos_linhas.ID_Documento=? AND faturacao_recibos_linhas.ID_Recibo=faturacao_recibos.ID_Recibo AND faturacao_recibos.Estado = 'Pago' ORDER BY ID_Linha";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("sd", $type, $idDocument);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0006";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($creditAmount, $valorIva );
		while ($stmt -> fetch()) {
			$totalCalc = $creditAmount + $valorIva;
			// $totalCalc = round($totalCalc,2);
			$totalPagoGeral += $totalCalc;
			$totalPagoDocument += $totalCalc;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0007";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//GET MAIN DOCUMENT TOTAL TO PAY
	$query = "SELECT TotalPagar, GrossTotal FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocument);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0008";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($totalPagarDocumento, $totalGrossDocumento);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0009";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//UPDATE MAIN DOCUMENT -----------------------------
	$totalPagarDocumento = round($totalPagarDocumento,2);
	$totalPagoGeral = $totalPagoGeral + $sumTotalLiquidadoND + $sumTotalLiquidadoNC;
	$totalPagoDocument = $totalPagoDocument + $sumTotalLiquidadoNC;
	$totalPagoGeral_tmp = round($totalPagoGeral,2);

	$totalPagoDocument_tmp = round($totalPagoDocument,2);
	
	if( $totalPagoDocument_tmp > $totalGrossDocumento){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0010A";
		$response["message"] = "Total Inválido!";
		die(json_encode($response));
	}
	
	//process estado
	$estadoProcessed = 'Aberto';
	if( $totalPagoGeral_tmp > $totalPagarDocumento){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0010B";
		$response["message"] = "Total Inválido!";
		die(json_encode($response));
	}else if($totalPagoGeral_tmp == $totalPagarDocumento){
		$estadoProcessed = 'Pago';
	}else{
		$estadoProcessed = 'Aberto';
	}

	$query = "UPDATE ".$tableName." SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssd", $totalPagoDocument, $totalPagoGeral, $estadoProcessed, $idDocument);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP0011";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP0012";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	return $resultChecker;
}

/**
 * Increase the stock levels for the articles present on the document
 * @param  $idDocument
 * @param  $tableName 
 * @param  $fieldName 
 * @return bool
 */
function increaseArticlesStock($idDocument, $tableName, $fieldName){
	global $sqli_connection;
	$result = true;

	//Get the arcticles and the stock value to update
	$query = "SELECT ID_Artigo, Quantidade FROM ".$tableName."_linhas WHERE ".$fieldName." =?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocument);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP013";
			$response["message"] = $stmt -> error;
			return $result = false;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($idArticle, $stockNovo);
		while ($stmt -> fetch()) {
			$articles[] = array(
		        	"idArticle" => $idArticle,
		        	"stockNovo" => $stockNovo,
		        );
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP014";
		$response["message"] = $sqli_connection -> error;
		return $result = false;
		die(json_encode($response));
	}

	//Process the articles and change stock
	foreach ($articles as $item) {
		$stockAtual = 0;
		$calculatedStock = 0;
		//Get current stock to be changed later
		$query = "SELECT Stock FROM faturacao_artigos WHERE ID_Artigo=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $item['idArticle']);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP015";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($stockAtual);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP016";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}

		//clean vars for calculation
		$stockAtual = round($stockAtual, 3);
		$stockNovoClean = round($item['stockNovo'], 3);
		//new stock level
		$calculatedStock = $stockAtual + $stockNovoClean;

		//Update stock levels
		$query = "UPDATE faturacao_artigos SET Stock=? WHERE ID_Artigo = ?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("sd", $calculatedStock, $item['idArticle']);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP017";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP018";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}
	}

	return $result;
}

/**
 * Decrease the stock levels for the articles present on the document
 * @param  $idDocument
 * @param  $tableName 
 * @param  $fieldName 
 * @return bool
 */
function decreaseArticlesStock($idDocument, $tableName, $fieldName){
	global $sqli_connection;
	$result = true;

	//get init vars
	$stockminimo = getValorPadrao('StockMinimo', 'faturacao_personalizar_documentos');
	$emailrececaostock = getValorPadrao('EmailRececaoStock', 'faturacao_personalizar_documentos');

	//Get the arcticles and the stock value to update
	$query = "SELECT ID_Artigo, Quantidade FROM ".$tableName."_linhas WHERE ".$fieldName." =?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idDocument);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP013";
			$response["message"] = $stmt -> error;
			return $result = false;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($idArticle, $stockNovo);
		while ($stmt -> fetch()) {
			$articles[] = array(
		        	"idArticle" => $idArticle,
		        	"stockNovo" => $stockNovo,
		        );
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP014";
		$response["message"] = $sqli_connection -> error;
		return $result = false;
		die(json_encode($response));
	}

	//Process the articles and change stock
	foreach ($articles as $item) {
		$stockAtual = 0;
		$calculatedStock = 0;
		//Get current stock to be changed later
		$query = "SELECT Stock, Codigo, Nome, Tipo FROM faturacao_artigos WHERE ID_Artigo=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $item['idArticle']);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP015";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($stockAtual, $articleCode, $articleDescprition, $articleType);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP016";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}

		//clean vars for calculation
		$stockAtual = round($stockAtual, 3);
		$stockNovoClean = round($item['stockNovo'], 3);
		//new stock level
		$calculatedStock = $stockAtual - $stockNovoClean;

		//Update stock levels
		$query = "UPDATE faturacao_artigos SET Stock=? WHERE ID_Artigo = ?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("sd", $calculatedStock, $item['idArticle']);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP017";
				$response["message"] = $stmt -> error;
				return $result = false;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP018";
			$response["message"] = $sqli_connection -> error;
			return $result = false;
			die(json_encode($response));
		}

		//check if stock is lower
		if($calculatedStock < $stockminimo){
			if($emailrececaostock && $articleType == 'P'){
				$subject = 'Frifacturation: Niveau de stock bas';

				$htmlContent = '<p>Cher administrateur,</p>';
				$htmlContent .= '<p>L\'article "'.$articleDescprition.'" a un niveau de stock inférieur à votre limite de stock minimum.</p>';
				$htmlContent .= '<p><br></p>';
				$htmlContent .= '<p><b>Référence:</b> '.$articleCode.'</p>';
				$htmlContent .= '<p><b>Article:</b> '.$articleDescprition.'</p>';
				$htmlContent .= '<p><b>Quantité actuelle:</b> '.$calculatedStock.'</p>';
				$htmlContent .= '<p><br></p><p>Cordialement,</p><p>Frifacturation.</p>';

				sendEmailPHPMailer($htmlContent, $subject, $emailrececaostock);
			}
		}
	}

	return $result;
}

/**
 * Check the usage of specific plan comptable
 * @param  $idPlano
 * @return bool
 */
function checkPlanoContasUsage($codePlano){
	global $sqli_connection;

	//returner flag
	$checker = false;

	//PROCESS TAXES TABLE ---------------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_impostos WHERE PlanoContas = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP019";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP020";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS BANQUE TABLE --------------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_bancos WHERE PlanoContas = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP021";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP022";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS ARTICLE TABLE -------------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_artigos WHERE PlanoContas = ? OR PlanoContasCompras=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP023";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP024";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS CLIENT TABLE --------------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_clientes WHERE PlanoContas = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP025";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP026";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS FOURNISSEUR TABLE ---------------------
	$counterPlanos = 0;

	$query = "SELECT COUNT(*) FROM faturacao_fornecedores WHERE PlanoContas = ?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("d", $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP027";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP028";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 ){
		$checker = true;
	}

	//PROCESS FACTURES TABLE ------------------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_faturas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_faturas WHERE PlanoContasBanco = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP029";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP030";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS FACTURES LINES TABLE ------------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_faturas_linhas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_faturas_linhas WHERE PlanoContasTVA = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP031";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP032";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS NOTES CREDIT FACTURES TABLE -----------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_notas_credito WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_notas_credito WHERE PlanoContasBanco = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP033";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP034";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS NOTES CREDIT LINES FACTURES TABLE -----
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_notas_credito_linhas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_notas_credito_linhas WHERE PlanoContasTVA = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP035";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP036";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS ACHATS TABLE --------------------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_compras WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_compras WHERE PlanoContasBanco = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP037";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP038";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS ACHATS LINES TABLE --------------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_compras_linhas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_compras_linhas WHERE PlanoContasTVA = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP039";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP040";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS NOTES CREDIT ACHATS TABLE -------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE PlanoContasBanco = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP041";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP042";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS NOTES CREDIT LINES ACHATS TABLE -------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT 
				(SELECT COUNT(*) FROM faturacao_compras_notas_credito_linhas WHERE PlanoContas = ?), 
				(SELECT COUNT(*) FROM faturacao_compras_notas_credito_linhas WHERE PlanoContasTVA = ?)
			";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP043";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos, $counterPlanos2);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP044";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//PROCESS MOVEMENTS LINES TABLE -----------------
	$counterPlanos = 0;
	$counterPlanos2 = 0;

	$query = "SELECT COUNT(*) FROM faturacao_movimentos_contabilisticos WHERE PlanoContas_Credito = ? OR PlanoContas_Debito = ?	";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		$stmt -> bind_param("dd", $codePlano, $codePlano);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP045A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($counterPlanos);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP045B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $counterPlanos > 0 || $counterPlanos2 > 0 ){
		$checker = true;
	}

	//RETURN BOOL (TRUE -> IS USED // FALSE -> IS NOT USED)
	return $checker;
}

/**
 * Get Plano Code
 * @return code
 */
function getPlanoCode($fieldName, $tableName, $fieldObject, $idObject){
	global $sqli_connection;
	$code = '';

	//process
	$query = "SELECT ".$fieldName." FROM ".$tableName." WHERE ".$fieldObject." IN (".$idObject.") LIMIT 1";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "HELP045C";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($code);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "HELP046";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	
	//return
	return $code;
}

/**
 * Inserir Novo Movimento Contabilistico
 * @param  $PlanoContas  
 * @param  $Descricao    
 * @param  $TotalPVP     
 * @param  $TotalUnit    
 * @param  $TotalTVA     
 * @param  $TipoMovimento
 * @return result (bool)
 */
function insertMovimentoContabilistico($PlanoContasDebito, $PlanoContasCredito, $Descricao, $TotalPVP, $TotalUnit, $TotalTVA, $TipoMovimento, $codeTVA = 0, $inclTVA = 0){
	global $sqli_connection;
	$result = true;

	//prepare remaining vars
	$data = date("d/m/Y H:i:s");
	$timestamp = microtime(true);
	/*$PlanoContasDebito = 0;
	$PlanoContasCredito = 0;*/

	//Round Values
	// $TotalPVP = round($TotalPVP,2);
	// $TotalUnit = round($TotalUnit,2);
	// $TotalTVA = round($TotalTVA,2);

	//Process Movimentos Débito
	/*if($TipoMovimento == 'D'){
		$PlanoContasDebito = $PlanoContas;
		// var_dump($TotalPVP, $TotalUnit, $TotalTVA);
	}else{
		$TotalPVP = $TotalPVP * (-1);
		$TotalUnit = $TotalUnit * (-1);
		$TotalTVA = $TotalTVA * (-1);
		$PlanoContasCredito = $PlanoContas;
	}*/
	if($TipoMovimento == 'D') $TipoMovimento = 0;
	elseif($TipoMovimento == 'C') $TipoMovimento = 1;
	elseif($TipoMovimento == 0) $TipoMovimento = 0;
	else $TipoMovimento = 1;

	//PROCESS CODE_TVA
	$percentageTVA = 0;
	$percentageTVA_tmp = 0;
	if( $codeTVA < 1 || !$codeTVA ) $codeTVA = 0;
	else{
		$query = "SELECT Valor FROM faturacao_impostos WHERE ID_Imposto = ? ";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			$stmt -> bind_param("d", $codeTVA);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP047AA";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($percentageTVA_tmp);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP047AB";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		if($percentageTVA_tmp != null) $percentageTVA = $percentageTVA_tmp;
	}

	if( $inclTVA < 1 || !$inclTVA ) {
		$inclTVA = 0;
		$TotalTVA = 0;
	}

	//INSERT RECORD
	$query = "INSERT INTO faturacao_movimentos_contabilisticos 
				(Data, PlanoContas_Debito, PlanoContas_Credito, Descricao, Total_PVP, Total_Unit, Total_TVA, TipoMovimento, TimeStampMovimento, ID_ImpostoTVA, PercentageTVA, IncludeTVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssssssdssss", 
		                    $data, 
		                    $PlanoContasDebito, 
		                    $PlanoContasCredito, 
		                    $Descricao, 
		                    $TotalPVP, 
		                    $TotalUnit, 
		                    $TotalTVA,
		                    $TipoMovimento,
		                    $timestamp,
		                    $codeTVA,
		                    $percentageTVA,
		                    $inclTVA
		        );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP047";
			$response["message"] = $stmt -> error;
			
			$result = false;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP048";
		$response["message"] = $sqli_connection -> error;
		
		$result = false;
		die(json_encode($response));
	}

	//return result
	return $result;
}

/**
 * Inserir Novo Movimento Contabilistico (Manual)
 * @param  $PlanoContas  
 * @param  $Descricao    
 * @param  $TotalPVP     
 * @param  $TotalUnit    
 * @param  $TotalTVA     
 * @param  $TipoMovimento
 * @param  $DataMovimento
 * @return result (bool)
 */
function insertMovimentoContabilisticoManual($PlanoContasDebito, $PlanoContasCredito, $Descricao, $TotalPVP, $TotalUnit, $TotalTVA, $TipoMovimento, $DataMovimento, $NaturezaMovimento = null, $codeTVA = null, $inclTVA = 0){
	global $sqli_connection;
	$result = true;
	$naturezaProcessed = null;

	//prepare remaining vars
	// $data = date("d/m/Y H:i:s");
	$tmpDT = DateTime::createFromFormat('d/m/Y', $DataMovimento);
	$data = $tmpDT->format('d/m/Y H:i:s');
	$timestamp = microtime(true);
	/*$PlanoContasDebito = 0;
	$PlanoContasCredito = 0;*/

	//Round Values
	// $TotalPVP = round($TotalPVP,2);
	// $TotalUnit = round($TotalUnit,2);
	// $TotalTVA = round($TotalTVA,2);

	//Process Movimentos Débito
	/*if($TipoMovimento == 'D'){
		$PlanoContasDebito = $PlanoContas;
		// var_dump($TotalPVP, $TotalUnit, $TotalTVA);
	}else{
		$TotalPVP = $TotalPVP * (-1);
		$TotalUnit = $TotalUnit * (-1);
		$TotalTVA = $TotalTVA * (-1);
		$PlanoContasCredito = $PlanoContas;
	}*/
	if($TipoMovimento == 'D') $TipoMovimento = 0;
	elseif($TipoMovimento == 'C') $TipoMovimento = 1;
	elseif($TipoMovimento == 0) $TipoMovimento = 0;
	else $TipoMovimento = 0;

	//PROCESS CODE_TVA
	$percentageTVA = 0;
	$percentageTVA_tmp = 0;
	if( $codeTVA < 1 || !$codeTVA ) $codeTVA = 0;
	else{
		$query = "SELECT Valor FROM faturacao_impostos WHERE ID_Imposto = ? ";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			$stmt -> bind_param("d", $codeTVA);
			//result
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "HELP047BA";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> store_result();
			$stmt -> bind_result($percentageTVA_tmp);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "HELP047BB";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		if($percentageTVA_tmp != null) $percentageTVA = $percentageTVA_tmp;
	}

	if( $inclTVA < 1 || !$inclTVA ) {
		$inclTVA = 0;
		$TotalTVA = 0;
	}

	//Process Movement Nature
	if($NaturezaMovimento) $naturezaProcessed = $NaturezaMovimento;
	else $naturezaProcessed = 'A';

	//INSERT RECORD
	$query = "INSERT INTO faturacao_movimentos_contabilisticos 
				(Data, PlanoContas_Debito, PlanoContas_Credito, Descricao, Total_PVP, Total_Unit, Total_TVA, TipoMovimento, TimeStampMovimento, NaturezaMovimento, ID_ImpostoTVA, PercentageTVA, IncludeTVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssssssdsssss", 
		                    $data, 
		                    $PlanoContasDebito, 
		                    $PlanoContasCredito, 
		                    $Descricao, 
		                    $TotalPVP, 
		                    $TotalUnit, 
		                    $TotalTVA,
		                    $TipoMovimento,
		                    $timestamp,
		                    $naturezaProcessed,
		                    $codeTVA,
		                    $percentageTVA,
		                    $inclTVA
		        );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "HELP047";
			$response["message"] = $stmt -> error;
			
			$result = false;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "HELP048";
		$response["message"] = $sqli_connection -> error;
		
		$result = false;
		die(json_encode($response));
	}

	//return result
	return $result;
}

/**
 * Get Custom Rounded UP Value for Invoices (0.05 UP)
 * @param  [float] $valueToRise
 * @return formatted value
 *  
 * Exemple - Facture CHF 2,60 c'est CHF 2,60
 * Exemple - Facture CHF 2,61 c'est CHF 2,60
 * Exemple - Facture CHF 2,62 c'est CHF 2,60
 * Exemple - Facture CHF 2,63 c’est CHF 2,65
 * Exemple - Facture CHF 2,64 c’est CHF 2,65
 * Exemple - Facture CHF 2,65 c’est CHF 2,65
 * Exemple - Facture CHF 2,66 c’est CHF 2,65
 * Exemple - Facture CHF 2,67 c’est CHF 2,65
 * Exemple - Facture CHF 2,68 c'est CHF 2,70
 * Exemple - Facture CHF 2,69 c’est CHF 2,70
 * Exemple - Facture CHF 2,70 c’est CHF 2,70

 */
function roundPriceUp($valueToRise) {
	$finalValue = 0;
	//confirm that the value is rounded
	$roundedValue = round($valueToRise, 2);
	$roundedValue = number_format($roundedValue, 2, '.', '');
	// var_dump($roundedValue);
	//grab last decimal number
	$lastNumber = substr($roundedValue, -1);

	/* === process the last decimal number === */
	
	//when is bigger than 0 and smaller than 3, 
	//it means that the last decimal needs to be replaced by 0 (from 0.00)
	if($lastNumber > 0 && $lastNumber <= 2) {
		$replacement = 0;
		$finalValue = substr($roundedValue, 0, -1).$replacement;
	}
	//when is bigger than 2 and smaller than 8, 
	//it means that the last decimal needs to be replaced by 5 (from 0.05)
	elseif($lastNumber > 2 && $lastNumber <= 7) {
		$replacement = 5;
		$finalValue = substr($roundedValue, 0, -1).$replacement;
	}
	//when is bigger than 7 and smaller than 10, 
	//it meand we need to round up to 1 decimal case
	//and it will return the 1.00 (number rounded 0.05 up) from the number
	elseif($lastNumber > 7 && $lastNumber <=9 ) {
		$finalValue = round($valueToRise, 1);
	}
	else{
		$finalValue = $roundedValue;
	}
	/* =========== /end processing =========== */

	//return final formatted value
	return round($finalValue,2);
}

/**
 * Calculate and print extensive date in french
 * @param  $date [ enter date format 2011-01-31 (Y-m-d) ]
 * @return extensive date
 */
function date_in_french($date){
	$week_name = array("Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi");
	$month_name=array("","Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août",
	"Septembre","Octobre","Novembre","Décembre");

	$split = preg_split('/-/', $date);
	$year = $split[0];
	$month = round($split[1]);
	$day = round($split[2]);

	$week_day = date("w", mktime(12, 0, 0, $month, $day, $year));
	// return $date_fr = $week_name[$week_day] .' '. $day .' '. $month_name[$month] .' '. $year;
	return $date_fr = $day .' '. $month_name[$month] .' '. $year;
}

/**
 * Calculate and print extensive date in french
 * @param  $date [ enter date format 2011-01-31 (Y-m-d) ]
 * @return extensive date
 */
function date_french_ByElement($date, $format, $element){
	//init vars
	$week_name = array("Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi");
	$month_name=array("","Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août",
	"Septembre","Octobre","Novembre","Décembre");

	$finalResult = '';

	//process date using received format
	$tmpDT = DateTime::createFromFormat($format, $date);

	//process element to retreied
	switch ($element) {
		case 'd':
			$finalResult = $tmpDT->format('d');
			break;
		case 'm':
			$finalResult = $tmpDT->format('m');
			break;
		case 'M':
			$month = round( $tmpDT->format('m') );
			$finalResult = strtolower( $month_name[$month] );
			break;
		case 'y':
			$finalResult = $tmpDT->format('y');
			break;
		case 'Y':
			$finalResult = $tmpDT->format('Y');
			break;
		case 'time':
			$finalResult = $tmpDT->format('H:i:s');
			break;
		
		default:
			$finalResult = $tmpDT->format($format);
			break;
	}

	//return result
	return $finalResult;
}
/**
 * Send emails using PHP Mailer
 * @param  [type] $htmlContent [description]
 * @param  [type] $subject     [description]
 * @param  [type] $toEmail     [description]
 * @return [type]              [description]
 */
function sendEmailPHPMailer($htmlContent, $subject, $toEmail){
	require_once $_SERVER["DOCUMENT_ROOT"] . '/server/PHPMailer/PHPMailerAutoload.php';

	//send email
    try{
        $body = $htmlContent;
        //echo $body;

        $Mailer = new PHPMailer();

        // define que será usado SMTP
        $Mailer -> IsSMTP();

        // envia email HTML
        $Mailer -> isHTML(true);

        // codificação UTF-8, a codificação mais usada recentemente
        $Mailer -> CharSet = 'UTF-8';

        // Configurações do SMTP
        $Mailer -> SMTPAuth = true;
		$Mailer -> SMTPSecure = '';
		$Mailer -> Host = 'mail.infomaniak.com';
		$Mailer -> Port = 587;
		$Mailer -> Username = 'no-reply@frifacturation.ch';
		$Mailer -> Password = 'k5xc0dBFaESq';
		$Mailer -> From = 'no-reply@frifacturation.ch';
		$Mailer -> FromName = 'Frifacturation';
		$Mailer -> Subject = $subject;
		// $Mailer -> AddAttachment($invoiceLink, $invoiceName);
		$Mailer -> AddAddress($toEmail);
		// $Mailer -> AddCC('tiago.pais@ftkode.com');
		$Mailer -> Body = $body;

		//RECEIPT
		// $Mailer->AddCustomHeader( "X-Confirm-Reading-To: ".$fromEmail."" );
		// $Mailer->AddCustomHeader( "Return-receipt-to: ".$fromEmail."" );

        //send email and check response
        $send = $Mailer -> Send();

        if($send) return true;
        else return false;
    }catch(Exception $e){
        return false;
    }

    //return
    return true;
}



// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// 								LOW PRIORITY RESOURCES
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
/**
 * Get The country full name
 * @param  [string] $iso2Code
 * @return response
 */
function getCountryByISO2($iso2Code){
	$fullname = '';
	switch ($iso2Code) {		
		case "CH" : $fullname = "Suisse" ; 													break;
		case "FR" : $fullname = "France" ; 													break;
		case "IT" : $fullname = "Italie" ; 													break;
		case "DE" : $fullname = "Allemagne" ; 												break;
		case "PT" : $fullname = "Portugal" ; 												break;
		case "ES" : $fullname = "Espagne" ; 												break;
		case "AT" : $fullname = "Autriche" ; 												break;
		case "LU" : $fullname = "Luxembourg" ; 												break;
		case "LI" : $fullname = "Liechtenstein" ; 											break;
		case "AF" : $fullname = "Afghanistan" ; 											break;
		case "ZA" : $fullname = "Afrique du Sud" ; 											break;
		case "AL" : $fullname = "Albanie" ; 												break;
		case "DZ" : $fullname = "Algérie" ; 												break;
		case "AD" : $fullname = "Andorre" ; 												break;
		case "AO" : $fullname = "Angola" ; 													break;
		case "AI" : $fullname = "Anguilla" ; 												break;
		case "AG" : $fullname = "Antigua-et-Barbuda" ; 										break;
		case "AN" : $fullname = "Antilles néerlandaises" ; 									break;
		case "SA" : $fullname = "Arabie saoudite" ; 										break;
		case "AR" : $fullname = "Argentine" ; 												break;
		case "AM" : $fullname = "Arménie" ; 												break;
		case "AW" : $fullname = "Aruba" ; 													break;
		case "AU" : $fullname = "Australie" ; 												break;
		case "AZ" : $fullname = "Azerbaïdjan" ; 											break;
		case "BH" : $fullname = "Bahreïn" ; 												break;
		case "BD" : $fullname = "Bangladesh" ; 												break;
		case "BB" : $fullname = "Barbade" ; 												break;
		case "BE" : $fullname = "Belgique" ; 												break;
		case "BZ" : $fullname = "Belize" ; 													break;
		case "BJ" : $fullname = "Bénin" ; 													break;
		case "BY" : $fullname = "Biélorussie" ; 											break;
		case "MM" : $fullname = "Birmanie" ; 												break;
		case "BO" : $fullname = "Bolivie" ; 												break;
		case "BA" : $fullname = "Bosnie-Herzégovine" ; 										break;
		case "BW" : $fullname = "Botswana" ; 												break;
		case "BR" : $fullname = "Brésil" ; 													break;
		case "BN" : $fullname = "Brunei" ; 													break;
		case "BG" : $fullname = "Bulgarie" ; 												break;
		case "BF" : $fullname = "Burkina&nbsp;Faso" ; 										break;
		case "BI" : $fullname = "Burundi" ; 												break;
		case "KH" : $fullname = "Cambodge" ; 												break;
		case "CM" : $fullname = "Cameroun" ; 												break;
		case "CA" : $fullname = "Canada" ; 													break;
		case "CV" : $fullname = "Cap-Vert" ; 												break;
		case "CL" : $fullname = "Chili" ; 													break;
		case "CN" : $fullname = "Chine" ; 													break;
		case "CY" : $fullname = "Chypre" ; 													break;
		case "CO" : $fullname = "Colombie" ; 												break;
		case "KM" : $fullname = "Comores" ; 												break;
		case "CG" : $fullname = "Congo-Brazzaville / (Congo)" ; 							break;
		case "CD" : $fullname = "Congo-Kinshasa / (République démocratique du Congo)" ; 	break;
		case "KP" : $fullname = "Corée du Nord" ; 											break;
		case "KR" : $fullname = "Corée du Sud" ; 											break;
		case "CR" : $fullname = "Costa Rica" ; 												break;
		case "CI" : $fullname = "Côte d'Ivoire" ; 											break;
		case "HR" : $fullname = "Croatie" ; 												break;
		case "CU" : $fullname = "Cuba" ; 													break;
		case "DK" : $fullname = "Danemark" ; 												break;
		case "DJ" : $fullname = "Djibouti" ; 												break;
		case "DM" : $fullname = "Dominique" ; 												break;
		case "EG" : $fullname = "Égypte" ; 													break;
		case "AE" : $fullname = "Émirats arabes unis" ; 									break;
		case "EC" : $fullname = "Équateur" ; 												break;
		case "ER" : $fullname = "Érythrée" ; 												break;
		case "EE" : $fullname = "Estonie" ; 												break;
		case "US" : $fullname = "États-Unis" ; 												break;
		case "ET" : $fullname = "Éthiopie" ; 												break;
		case "FJ" : $fullname = "Fidji" ; 													break;
		case "FI" : $fullname = "Finlande" ; 												break;
		case "GA" : $fullname = "Gabon" ; 													break;
		case "GM" : $fullname = "Gambie" ; 													break;
		case "GE" : $fullname = "Géorgie" ; 												break;
		case "GH" : $fullname = "Ghana" ; 													break;
		case "GR" : $fullname = "Grèce" ; 													break;
		case "GD" : $fullname = "Grenade" ; 												break;
		case "GU" : $fullname = "Guam" ; 													break;
		case "GT" : $fullname = "Guatemala" ; 												break;
		case "GN" : $fullname = "Guinée" ; 													break;
		case "GQ" : $fullname = "Guinée équatoriale" ; 										break;
		case "GW" : $fullname = "Guinée-Bissau" ; 											break;
		case "GY" : $fullname = "Guyana" ; 													break;
		case "HT" : $fullname = "Haïti" ; 													break;
		case "HN" : $fullname = "Honduras" ; 												break;
		case "HU" : $fullname = "Hongrie" ; 												break;
		case "KY" : $fullname = "Îles Caïmans" ; 											break;
		case "CK" : $fullname = "Îles Cook" ; 												break;
		case "PN" : $fullname = "Îles Pitcairn" ; 											break;
		case "TC" : $fullname = "Îles Turques-et-Caïques" ; 								break;
		case "VG" : $fullname = "Îles Vierges britanniques" ; 								break;
		case "VI" : $fullname = "Îles Vierges des États-Unis" ; 							break;
		case "IN" : $fullname = "Inde" ; 													break;
		case "ID" : $fullname = "Indonésie" ; 												break;
		case "IQ" : $fullname = "Irak" ; 													break;
		case "IR" : $fullname = "Iran" ; 													break;
		case "IE" : $fullname = "Irlande" ; 												break;
		case "IS" : $fullname = "Islande" ; 												break;
		case "IL" : $fullname = "Israel" ; 													break;
		case "JM" : $fullname = "Jamaïque" ; 												break;
		case "JP" : $fullname = "Japon" ; 													break;
		case "JO" : $fullname = "Jordanie" ; 												break;
		case "KZ" : $fullname = "Kazakhstan" ; 												break;
		case "KE" : $fullname = "Kenya" ; 													break;
		case "KG" : $fullname = "Kirghizistan" ; 											break;
		case "KI" : $fullname = "Kiribati" ; 												break;
		case "KW" : $fullname = "Koweït" ; 													break;
		case "LA" : $fullname = "Laos" ; 													break;
		case "LS" : $fullname = "Lesotho" ; 												break;
		case "LV" : $fullname = "Lettonie" ; 												break;
		case "LB" : $fullname = "Liban" ; 													break;
		case "LR" : $fullname = "Liberia" ; 												break;
		case "LY" : $fullname = "Libye" ; 													break;
		case "LT" : $fullname = "Lituanie" ; 												break;
		case "MO" : $fullname = "Macao" ; 													break;
		case "MK" : $fullname = "Macédoine" ; 												break;
		case "MG" : $fullname = "Madagascar" ; 												break;
		case "MY" : $fullname = "Malaisie" ; 												break;
		case "MW" : $fullname = "Malawi" ; 													break;
		case "MV" : $fullname = "Maloptiones" ; 											break;
		case "ML" : $fullname = "Mali" ; 													break;
		case "MT" : $fullname = "Malte" ; 													break;
		case "MA" : $fullname = "Maroc" ; 													break;
		case "MH" : $fullname = "Marshall" ; 												break;
		case "MU" : $fullname = "Maurice" ; 												break;
		case "MR" : $fullname = "Mauritanie" ; 												break;
		case "MX" : $fullname = "Mexique" ; 												break;
		case "FM" : $fullname = "Micronésie" ; 												break;
		case "MD" : $fullname = "Moldavie" ; 												break;
		case "MC" : $fullname = "Monaco" ; 													break;
		case "MN" : $fullname = "Mongolie" ; 												break;
		case "ME" : $fullname = "Monténégro" ; 												break;
		case "MS" : $fullname = "Montserrat" ; 												break;
		case "MZ" : $fullname = "Mozambique" ; 												break;
		case "NA" : $fullname = "Namibie" ; 												break;
		case "NR" : $fullname = "Nauru" ; 													break;
		case "NP" : $fullname = "Népal" ; 													break;
		case "NI" : $fullname = "Nicaragua" ; 												break;
		case "NE" : $fullname = "Niger" ; 													break;
		case "NG" : $fullname = "Nigeria" ; 												break;
		case "NU" : $fullname = "Niue" ; 													break;
		case "NF" : $fullname = "Norfolk" ; 												break;
		case "NO" : $fullname = "Norvège" ; 												break;
		case "NZ" : $fullname = "Nouvelle-Zélande" ; 										break;
		case "OM" : $fullname = "Oman" ; 													break;
		case "UG" : $fullname = "Ouganda" ; 												break;
		case "UZ" : $fullname = "Ouzbékistan" ; 											break;
		case "PK" : $fullname = "Pakistan" ; 												break;
		case "PW" : $fullname = "Palaos" ; 													break;
		case "PA" : $fullname = "Panamá" ; 													break;
		case "PG" : $fullname = "Papouasie-Nouvelle-Guinée" ; 								break;
		case "PY" : $fullname = "Paraguay" ; 												break;
		case "NL" : $fullname = "Pays-Bas" ; 												break;
		case "PE" : $fullname = "Pérou" ; 													break;
		case "PH" : $fullname = "Philippines" ; 											break;
		case "PL" : $fullname = "Pologne" ; 												break;
		case "PR" : $fullname = "Porto Rico" ; 												break;
		case "QA" : $fullname = "Qatar" ; 													break;
		case "DO" : $fullname = "République dominicaine" ; 									break;
		case "CZ" : $fullname = "République tchèque" ; 										break;
		case "CF" : $fullname = "République centrafricaine" ; 								break;
		case "RO" : $fullname = "Roumanie" ; 												break;
		case "GB" : $fullname = "Royaume-Uni" ; 											break;
		case "RU" : $fullname = "Russie" ; 													break;
		case "RW" : $fullname = "Rwanda" ; 													break;
		case "KN" : $fullname = "Saint-Christophe-et-Niévès" ; 								break;
		case "LC" : $fullname = "Sainte-Lucie" ; 											break;
		case "SM" : $fullname = "Saint-Marin" ; 											break;
		case "VC" : $fullname = "Saint-Vincent-et-les Grenadines" ; 						break;
		case "SB" : $fullname = "Salomon" ; 												break;
		case "SV" : $fullname = "Salvador" ; 												break;
		case "WS" : $fullname = "Samoa" ; 													break;
		case "ST" : $fullname = "Sao Tomé-et-Principe" ; 									break;
		case "SN" : $fullname = "Sénégal" ; 												break;
		case "RS" : $fullname = "Serbie" ; 													break;
		case "SC" : $fullname = "Seychelles" ; 												break;
		case "SL" : $fullname = "Sierra Leone" ; 											break;
		case "SG" : $fullname = "Singapour" ; 												break;
		case "SK" : $fullname = "Slovaquie" ; 												break;
		case "SI" : $fullname = "Slovénie" ; 												break;
		case "SO" : $fullname = "Somalie" ; 												break;
		case "SD" : $fullname = "Soudan" ; 													break;
		case "LK" : $fullname = "Sri Lanka" ; 												break;
		case "SE" : $fullname = "Suède" ; 													break;
		case "SR" : $fullname = "Suriname" ; 												break;
		case "SZ" : $fullname = "Swaziland" ; 												break;
		case "SY" : $fullname = "Syrie" ; 													break;
		case "TJ" : $fullname = "Tadjikistan" ; 											break;
		case "TW" : $fullname = "Taïwan / (République de Chine)" ; 							break;
		case "TZ" : $fullname = "Tanzanie" ; 												break;
		case "TD" : $fullname = "Tchad" ; 													break;
		case "TH" : $fullname = "Thaïlande" ; 												break;
		case "TL" : $fullname = "Timor oriental" ; 											break;
		case "TG" : $fullname = "Togo" ; 													break;
		case "TK" : $fullname = "Tokelau" ; 												break;
		case "TO" : $fullname = "Tonga" ; 													break;
		case "TT" : $fullname = "Trinité-et-Tobago" ; 										break;
		case "TN" : $fullname = "Tunisie" ; 												break;
		case "TM" : $fullname = "Turkménistan" ; 											break;
		case "TR" : $fullname = "Turquie" ; 												break;
		case "TV" : $fullname = "Tuvalu" ; 													break;
		case "UA" : $fullname = "Ukraine" ; 												break;
		case "UY" : $fullname = "Uruguay" ; 												break;
		case "VU" : $fullname = "Vanuatu" ; 												break;
		case "VA" : $fullname = "Vatican (Saint-Siège)" ; 									break;
		case "VE" : $fullname = "Venezuela" ; 												break;
		case "VN" : $fullname = "Viêt Nam" ; 												break;
		case "YE" : $fullname = "Yémen" ; 													break;
		case "ZM" : $fullname = "Zambie" ; 													break;
		case "ZW" : $fullname = "Zimbabwe" ; 												break;
		
		default:	break;
	}
	return $fullname;
}

/**
 * Get The country full name List
 * @return response
 */
function getCountryList(){
	$countries = array(
		"CH" => "Suisse",
		"FR" => "France",
		"IT" => "Italie",
		"DE" => "Allemagne",
		"PT" => "Portugal",
		"ES" => "Espagne",
		"AT" => "Autriche",
		"LU" => "Luxembourg",
		"LI" => "Liechtenstein",
		"AF" => "Afghanistan",
		"ZA" => "Afrique du Sud",
		"AL" => "Albanie",
		"DZ" => "Algérie",
		"AD" => "Andorre",
		"AO" => "Angola",
		"AI" => "Anguilla",
		"AG" => "Antigua-et-Barbuda",
		"AN" => "Antilles néerlandaises",
		"SA" => "Arabie saoudite",
		"AR" => "Argentine",
		"AM" => "Arménie",
		"AW" => "Aruba",
		"AU" => "Australie",
		"AZ" => "Azerbaïdjan",
		"BH" => "Bahreïn",
		"BD" => "Bangladesh",
		"BB" => "Barbade",
		"BE" => "Belgique",
		"BZ" => "Belize",
		"BJ" => "Bénin",
		"BY" => "Biélorussie",
		"MM" => "Birmanie",
		"BO" => "Bolivie",
		"BA" => "Bosnie-Herzégovine",
		"BW" => "Botswana",
		"BR" => "Brésil",
		"BN" => "Brunei",
		"BG" => "Bulgarie",
		"BF" => "Burkina&nbsp;Faso",
		"BI" => "Burundi",
		"KH" => "Cambodge",
		"CM" => "Cameroun",
		"CA" => "Canada",
		"CV" => "Cap-Vert",
		"CL" => "Chili",
		"CN" => "Chine",
		"CY" => "Chypre",
		"CO" => "Colombie",
		"KM" => "Comores",
		"CG" => "Congo-Brazzaville / (Congo)",
		"CD" => "Congo-Kinshasa / (République démocratique du Congo)",
		"KP" => "Corée du Nord",
		"KR" => "Corée du Sud",
		"CR" => "Costa Rica",
		"CI" => "Côte d'Ivoire",
		"HR" => "Croatie",
		"CU" => "Cuba",
		"DK" => "Danemark",
		"DJ" => "Djibouti",
		"DM" => "Dominique",
		"EG" => "Égypte",
		"AE" => "Émirats arabes unis",
		"EC" => "Équateur",
		"ER" => "Érythrée",
		"EE" => "Estonie",
		"US" => "États-Unis",
		"ET" => "Éthiopie",
		"FJ" => "Fidji",
		"FI" => "Finlande",
		"GA" => "Gabon",
		"GM" => "Gambie",
		"GE" => "Géorgie",
		"GH" => "Ghana",
		"GR" => "Grèce",
		"GD" => "Grenade",
		"GU" => "Guam",
		"GT" => "Guatemala",
		"GN" => "Guinée",
		"GQ" => "Guinée équatoriale",
		"GW" => "Guinée-Bissau",
		"GY" => "Guyana",
		"HT" => "Haïti",
		"HN" => "Honduras",
		"HU" => "Hongrie",
		"KY" => "Îles Caïmans",
		"CK" => "Îles Cook",
		"PN" => "Îles Pitcairn",
		"TC" => "Îles Turques-et-Caïques",
		"VG" => "Îles Vierges britanniques",
		"VI" => "Îles Vierges des États-Unis",
		"IN" => "Inde",
		"ID" => "Indonésie",
		"IQ" => "Irak",
		"IR" => "Iran",
		"IE" => "Irlande",
		"IS" => "Islande",
		"IL" => "Israel",
		"JM" => "Jamaïque",
		"JP" => "Japon",
		"JO" => "Jordanie",
		"KZ" => "Kazakhstan",
		"KE" => "Kenya",
		"KG" => "Kirghizistan",
		"KI" => "Kiribati",
		"KW" => "Koweït",
		"LA" => "Laos",
		"LS" => "Lesotho",
		"LV" => "Lettonie",
		"LB" => "Liban",
		"LR" => "Liberia",
		"LY" => "Libye",
		"LT" => "Lituanie",
		"MO" => "Macao",
		"MK" => "Macédoine",
		"MG" => "Madagascar",
		"MY" => "Malaisie",
		"MW" => "Malawi",
		"MV" => "Maloptiones",
		"ML" => "Mali",
		"MT" => "Malte",
		"MA" => "Maroc",
		"MH" => "Marshall",
		"MU" => "Maurice",
		"MR" => "Mauritanie",
		"MX" => "Mexique",
		"FM" => "Micronésie",
		"MD" => "Moldavie",
		"MC" => "Monaco",
		"MN" => "Mongolie",
		"ME" => "Monténégro",
		"MS" => "Montserrat",
		"MZ" => "Mozambique",
		"NA" => "Namibie",
		"NR" => "Nauru",
		"NP" => "Népal",
		"NI" => "Nicaragua",
		"NE" => "Niger",
		"NG" => "Nigeria",
		"NU" => "Niue",
		"NF" => "Norfolk",
		"NO" => "Norvège",
		"NZ" => "Nouvelle-Zélande",
		"OM" => "Oman",
		"UG" => "Ouganda",
		"UZ" => "Ouzbékistan",
		"PK" => "Pakistan",
		"PW" => "Palaos",
		"PA" => "Panamá",
		"PG" => "Papouasie-Nouvelle-Guinée",
		"PY" => "Paraguay",
		"NL" => "Pays-Bas",
		"PE" => "Pérou",
		"PH" => "Philippines",
		"PL" => "Pologne",
		"PR" => "Porto Rico",
		"QA" => "Qatar",
		"DO" => "République dominicaine",
		"CZ" => "République tchèque",
		"CF" => "République centrafricaine",
		"RO" => "Roumanie",
		"GB" => "Royaume-Uni",
		"RU" => "Russie",
		"RW" => "Rwanda",
		"KN" => "Saint-Christophe-et-Niévès",
		"LC" => "Sainte-Lucie",
		"SM" => "Saint-Marin",
		"VC" => "Saint-Vincent-et-les Grenadines",
		"SB" => "Salomon",
		"SV" => "Salvador",
		"WS" => "Samoa",
		"ST" => "Sao Tomé-et-Principe",
		"SN" => "Sénégal",
		"RS" => "Serbie",
		"SC" => "Seychelles",
		"SL" => "Sierra Leone",
		"SG" => "Singapour",
		"SK" => "Slovaquie",
		"SI" => "Slovénie",
		"SO" => "Somalie",
		"SD" => "Soudan",
		"LK" => "Sri Lanka",
		"SE" => "Suède",
		"SR" => "Suriname",
		"SZ" => "Swaziland",
		"SY" => "Syrie",
		"TJ" => "Tadjikistan",
		"TW" => "Taïwan / (République de Chine)",
		"TZ" => "Tanzanie",
		"TD" => "Tchad",
		"TH" => "Thaïlande",
		"TL" => "Timor oriental",
		"TG" => "Togo",
		"TK" => "Tokelau",
		"TO" => "Tonga",
		"TT" => "Trinité-et-Tobago",
		"TN" => "Tunisie",
		"TM" => "Turkménistan",
		"TR" => "Turquie",
		"TV" => "Tuvalu",
		"UA" => "Ukraine",
		"UY" => "Uruguay",
		"VU" => "Vanuatu",
		"VA" => "Vatican (Saint-Siège)",
		"VE" => "Venezuela",
		"VN" => "Viêt Nam",
		"YE" => "Yémen",
		"ZM" => "Zambie",
		"ZW" => "Zimbabwe",
	);

	return $countries;
}

/**
 * ======================================================================
 * HELPERS WEBSERVICES API
 * ======================================================================
 */
//REMOTE POST CURL
function cUrlPostCall( $urlLnk, $postData = null, $devMode = false ){
	//init some vars
	$returnedInfo = null;
	$urlConnection = $urlLnk;

	//Prepare vars for process
	$postDataToSend = $postData;

	//Process request
	try {
		//init cUrl
		$chConn = curl_init();

		//LOCAL SERVER DEV
		if($devMode == true){
			// This is your Virtual Hosts name
			$request_host   = 'frifacturation.ftkode'; 
			$headers = array("Host: ".$request_host);
			curl_setopt($chConn, CURLOPT_HTTPHEADER, $headers);  
		}

		//prepare opts
		curl_setopt($chConn, CURLOPT_URL, $urlConnection);
		curl_setopt($chConn, CURLOPT_FRESH_CONNECT, true);
		curl_setopt($chConn, CURLOPT_RETURNTRANSFER, true);
		// curl_setopt($chConn, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		// curl_setopt($chConn, CURLOPT_USERPWD, $username_password);
		curl_setopt ($chConn, CURLOPT_POSTFIELDS, $postDataToSend); 
		// curl_setopt ($chConn, CURLOPT_POST, 1);
		
		$resultCURL = curl_exec($chConn);
		// var_dump(json_decode($resultCURL));
		// var_dump($urlConnection,curl_error($chConn),$resultCURL);die();
		
		
		//get results and process anwser
		$array_json = json_decode($resultCURL);
		
		//check if not json
		if(json_last_error()){
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "rest";
			$response["line"] = "REST_P001";
			$response["message"] = json_last_error();
			die(json_encode($response));
		}

		//check if errors
		if( isset($array_json->errors) && $array_json->errors == true ){
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 400 Bad Resquest.');
			$response["errors"] = true;
			$response["type"] = "rest";
			$response["line"] = "REST_P002";
			$response["message"] = $array_json;
			die(json_encode($response));
		}

		//check if errors
		if( !$array_json || $array_json == null ){
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 404 Not Found.');
			$response["errors"] = true;
			$response["type"] = "rest";
			$response["line"] = "REST_P003";
			$response["message"] = 'No reply.';
			die(json_encode($response));
		}else{
			//get receved data
			$returnedInfo = $array_json;
		}

		//close connection to REST API
		curl_close($chConn);
	} catch (Exception $e) {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "rest";
		$response["line"] = "REST_P004";
		$response["message"] = $e->getMessage();
		die(json_encode($response));
	}
	
	//return
	return $returnedInfo;
}

//REMOTE GET CURL
function cUrlGetCall( $urlLnk, $getData = null, $devMode = false ){
	//init vars
	$returnedInfo = null;
	$urlConnection = $urlLnk;

	//Prepare vars for process
	$getDataToSend = $getData;

	//Process request
	try {
		//init cUrl
		$chConn = curl_init();

		//LOCAL SERVER DEV
		if($devMode == true){
			// This is your Virtual Hosts name
			$request_host   = 'frifacturation.ftkode'; 
			$headers = array("Host: ".$request_host);
			curl_setopt($chConn, CURLOPT_HTTPHEADER, $headers);  
		}

		//prepare opts
		curl_setopt($chConn, CURLOPT_URL, $urlConnection);
		curl_setopt($chConn, CURLOPT_FRESH_CONNECT, true);
		curl_setopt($chConn, CURLOPT_RETURNTRANSFER, true);
		// curl_setopt($chConn, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		// curl_setopt($chConn, CURLOPT_USERPWD, $username_password);
		// curl_setopt ($chConn, CURLOPT_POSTFIELDS, $getDataToSend); 
		// curl_setopt ($chConn, CURLOPT_POST, 1);
		
		$resultCURL = curl_exec($chConn);
		// var_dump(json_decode($resultCURL));
		// var_dump($urlConnection,curl_error($chConn),$resultCURL);die();
		
		//get results and process anwser
		$array_json = json_decode($resultCURL);
		
		//check if not json
		if(json_last_error()){
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "rest";
			$response["line"] = "REST_G001";
			$response["message"] = json_last_error();
			die(json_encode($response));
		}

		//check if errors
		if( isset($array_json->errors) && $array_json->errors == true ){
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 400 Bad Resquest.');
			$response["errors"] = true;
			$response["type"] = "rest";
			$response["line"] = "REST_G002";
			$response["message"] = $array_json;
			die(json_encode($response));
		}

		//check if errors
		if( !$array_json || $array_json == null ){
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 404 Not Found.');
			$response["errors"] = true;
			$response["type"] = "rest";
			$response["line"] = "REST_G003";
			$response["message"] = 'No reply.';
			die(json_encode($response));
		}else{
			//get receved data
			$returnedInfo = $array_json;
		}

		//close connection to REST API
		curl_close($chConn);
	} catch (Exception $e) {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "rest";
		$response["line"] = "REST_G004";
		$response["message"] = $e->getMessage();
		die(json_encode($response));
	}

	//response
	return $returnedInfo;
}

//SEARCH LOCALITE BY NPA
function searchLocaliteByNPA($npaPostalCode = null){
	global $sqli_connection;

	//init vars
	$localites = array();

	//process
	$query = "SELECT id, npa, localite FROM faturacao_npa_localites WHERE npa=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $npaPostalCode);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "WEBS001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Localite, $NPA, $Localite);
		while ($stmt -> fetch()) {
			$localites[] = array( "ID_Localite" => $ID_Localite, "NPA" => $NPA,	"Localite" => $Localite );
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "WEBS002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//return localites
	return $localites;
}

//GET PAYMENTS METHODS
function getPaymentMethods(){
	global $sqli_connection;

	//init vars
	$paymentMethods = array();

	//process
	$query = "SELECT ID_Metodo,	Codigo, Descricao FROM faturacao_metodos_pagamento ORDER BY ID_Metodo ASC";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("s", $abcd);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "WEBS003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($id, $codigo, $descricao);
		while ($stmt -> fetch()) {
			$paymentMethods[] = array('ID_Method' => $id,'Code' => $codigo, 'Description' => $descricao);
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "WEBS004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//return paymentMethods
	return $paymentMethods;
}

//GET PAYMENTS CONDITIONS
function getPaymentConditions(){
	global $sqli_connection;

	//init vars
	$paymentConditions = array();

	//process
	$paymentConditions = array(
		"0" => "Paiement Prêt",
		"10" => "10 jours après l'émission",
		"20" => "20 jours après l'émission",
		"30" => "30 jours après l'émission",
		"60" => "60 jours après l'émission",
		"90" => "90 jours après l'émission",
	);

	//return paymentConditions
	return $paymentConditions;
}

//GET PLANS COMPTABLES
function getPlansComptables(){
	global $sqli_connection;

	//init vars
	$plans = array();

	//process
	$query = "SELECT ID_Plano, Codigo, Descricao FROM faturacao_plano_conta WHERE Ecriture <> '' ORDER BY Codigo ASC";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("s", $abcd);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "WEBS005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $ID_Plano, $Codigo, $Descricao );
		while ($stmt -> fetch()) {
			$plans[] = array('ID_Plan' => $ID_Plano,'Code' => $Codigo, 'Description' => $Descricao);
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "WEBS006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//return plans
	return $plans;
}

//GET RESPONSABLES CONTRATS
function getResponsablesContracts(){
	global $sqli_connection;

	//init vars
	$responsibles = array();

	//process
	$query = "SELECT ID_RespContrato, Nome, Codigo_Interno FROM faturacao_responsavel_contratos ORDER BY Codigo_Interno ASC";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("s", $abcd);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "WEBS007";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $id, $Nome, $Codigo_Interno );
		while ($stmt -> fetch()) {
			$responsibles[] = array('ID_Responsible' => $id, 'Name' => $Nome, 'Code' => $Codigo_Interno);
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "WEBS008";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//return responsibles
	return $responsibles;
}

//GET VENDEURS
function getVendeurs(){
	global $sqli_connection;

	//init vars
	$vendeurs = array();

	//process
	if(isVendedor() == 1){
		$internalCode = getUserInternalCode();
		if(!$internalCode) $internalCode = 0;
		$query = "SELECT ID_Vendedor, Nome, Codigo_Interno FROM faturacao_vendedores WHERE Codigo_Interno = '".$internalCode."' ORDER BY Codigo_Interno";
	}else{
		$query = "SELECT ID_Vendedor, Nome, Codigo_Interno FROM faturacao_vendedores ORDER BY Codigo_Interno";
	}
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("s", $abcd);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "WEBS009";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $id, $Nome, $Codigo_Interno );
		while ($stmt -> fetch()) {
			$vendeurs[] = array('ID_Vendeur' => $id, 'Name' => $Nome, 'Code' => $Codigo_Interno);
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "WEBS010";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//return vendeurs
	return $vendeurs;
}

/**
 * ======================================================================
 * ======================================================================
 */

?>