<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "Tous"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[0, "asc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/bancos_fornecedores.php",
		"oLanguage" : {
			"sLengthMenu" : "Show _MENU_ enregistrements par page",
			"sZeroRecords" : "Sans enregistrements",
			"sInfo" : "_START_ a _END_ de _TOTAL_ enregistrements",
			"sInfoEmpty" : " 0 a 0 de 0 enregistrements",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "Suivant",
				"sFirst" : "Premier",
				"sPrevious" : "Précédent",
				"sLast" : "Dernier"
			}
		},
		"aoColumns" : [null,null,null,null,null,
		{
			"sClass" : "text-center",
		},
		{
			"bVisible" : true,
			"sClass" : "text-center",
			"bSortable" : false,
			"bSearchable" : false
		},{
			"bVisible" : false,
			"bSortable" : false,
			"bSearchable" : true
		}],
		"aoColumnDefs" : [
		{
			"aTargets" : [1],
			"mRender" : function(data, type, full) {
				//return html
				return '<span class="ellipsis" data-size="45">'+full[1]+'</span>';
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				//return html
				return '<span class="ellipsis" data-size="30">'+full[2]+'</span>';
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				//return html
				return '<span class="ellipsis" data-size="30">'+full[3]+'</span>';
			}
		},
		{
			"aTargets" : [5],
			"mRender" : function(data, type, full) {
				var element = '';
				//process icon
				if(full[5] == 1){
					element = '&nbsp;<i class="fa fa-check text-green" title="Par défaut"></i>';
				}else{
					element = '<a onClick="predefinirBanco('+full[6]+')" class="options-link text-red" title="Prédéfini"><i class="fa fa-check-square-o"></i></a>';
				}
				return element;
			}
		},
		{
			"aTargets" : [6],
			"mRender" : function(data, type, full) {
				var processedName = full[1].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'"+processedName+"'";
				var html = '';

				//state options
				if(full[7] == 1){
					html += '<a onClick="alterState('+full[6]+')" class="options-link text-violet" title="Désactiver"><i class="fa fa-ban"></i></a>';
				}else{
					html += '<a onClick="alterState('+full[6]+')" class="options-link text-green" title="Activer"><i class="fa fa-check-square-o"></i></a>';
				}
				
				html += '<a href="details?banque='+ full[6] +'" class="options-link text-info"><i class="fa fa-eye" title="Détails"></i></a>';
				
				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[6]);

			return nRow;
		},
		"fnDrawCallback" : function(oSettings) {
            $(".ellipsis").ellipsis(); 
		},
	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> Rechercher</button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
	
	//details for the bank
	function detalhesBanco(idBanco){

	}

	//change Prédéfini
	function predefinirBanco(idBanco){
	<?php if (hasPermission(['P0068']) == 1) { ?>
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/bancos_fornecedores/predefinir.php',
			dataType : 'json',
			data : {
				idBanco : idBanco
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] Erreur. Contactez votre administrateur.", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] Erreur. Contactez votre administrateur.", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("Banque insérée avec succès.", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				location.reload();
			}
		});
	<?php } else {?>
		alert('Votre profil d\'autorisations ne vous permet pas d\'effectuer l\'opération prévue.');
	<?php } ?>
	}

	//change Prédéfini
	function alterState(idBanco){
	<?php if (hasPermission(['P0068']) == 1) { ?>
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/bancos_fornecedores/estado.php',
			dataType : 'json',
			data : {
				idBanco : idBanco
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] Erreur. Contactez votre administrateur.", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] Erreur. Contactez votre administrateur.", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("Banque insérée avec succès.", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				location.reload();
			}
		});
	<?php } else {?>
		alert('Votre profil d\'autorisations ne vous permet pas d\'effectuer l\'opération prévue.');
	<?php } ?>
	}
</script>