<script type="text/javascript">
	/**
	 * Fill the base Accounts to be used as base
	 * @return select list
	 */
	function fill_details(idPlano){
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/plano-contas/detalhes.php',
			dataType : 'json',
			data : { idPlano : idPlano },
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT001] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT002] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$.scojs_message("[FAT003] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
						} else {
							var dados = resposta.data;
							
							//PROCESS DETAILS
							$("#descricao_plano").val(dados.Descricao);
							$("#categoria_plano").val(dados.PlanoCategoria);
							$("#categoria_plano").trigger('change');
							$("#subcategoria_plano").val(dados.SubCategoriaPlanoConta);
							$("#subcategoria_plano").trigger('change');

							fill_ivas(dados.ID_Imposto);

							if( Number(dados.CodigoPai) > 0){

								$("#codigo_plano").val(dados.SmallCode);
								$("#lbl_codigo_plano").html(dados.CodigoPai);

								$("#collect_plano").val(dados.ID_CobrancaIVA);
								$("#collect_plano").trigger('change');
								
								$("#ecriture_plano").val(dados.Ecriture);
								$("#ecriture_plano").trigger('change');

								fill_accounts(dados.CodigoPai_ID, Number(dados.Usado));
							}else{
								var options = $("select#plano_contas_plano");
								$(options).empty();

								$(options).append($("<option />").val(dados.ID_Plano).html(dados.Codigo+' >> '+dados.Descricao).attr('data-codigo-base', dados.Codigo) );

								$(options).attr("disabled", true);
								$(options).trigger('change');

								//process remain fields
								$("#lbl_codigo_plano").html('-');
								$("#codigo_plano").val(dados.Codigo);
								$("#codigo_plano").attr("disabled", true);

								$("#categoria_plano").attr("disabled", true);
								$("#categoria_plano").trigger('change');

								$("#subcategoria_plano").attr("disabled", true);
								$("#subcategoria_plano").trigger('change');

								$("#collect_plano").attr("disabled", true);
								$("#collect_plano").trigger('change');
								
								$("#ecriture_plano").attr("disabled", true);
								$("#ecriture_plano").trigger('change');
							}

							if( Number(dados.Usado) == 1 ){

								$("#codigo_plano").attr("disabled", true);

								$("#categoria_plano").attr("disabled", true);
								$("#categoria_plano").trigger('change');

								$("#subcategoria_plano").attr("disabled", true);
								$("#subcategoria_plano").trigger('change');

								$("#collect_plano").attr("disabled", true);
								$("#collect_plano").trigger('change');
								
								$("#ecriture_plano").attr("disabled", true);
								$("#ecriture_plano").trigger('change');
							}
						}
					}
				}
			},
			complete : function() {
			}
		});
	}

	/**
	 * Fill the base Accounts to be used as base
	 * @return select list
	 */
	function fill_accounts(lastID = 0, usado = 0){
		var options = $("select#plano_contas_plano");
		$(options).empty();
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/plano_contas.php',
			data : {
				opcao : 1
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));
							$.each(resposta.data, function() {
								$(options).append($("<option />").val(this.id).html(this.descricao).attr('data-codigo-base', this.codigo) );
							});
						}
					}
				}
			},
			complete : function() {
				if(lastID != 0) $(options).val(lastID);
				// $(options).val($("select#plano_contas_plano option:eq(1)").val());
				$(options).trigger('change');

				if(usado == 1){
					$("#plano_contas_plano").attr("disabled", true);
					$("#plano_contas_plano").trigger('change');
				}
			}
		});
	}

	/**
	 * Fill the next account code
	 * @return code
	 */
	function getNextAccountNumber(){
		var idPlano = $("select#plano_contas_plano").val();
		var lblCode = $('option:selected', $("select#plano_contas_plano") ).attr('data-codigo-base');

		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/plano_contas.php',
			data : {
				opcao : 2,
				idPlano : idPlano
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL003] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL004] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$("#codigo_plano").val('');
							$("#lbl_codigo_plano").html('0000');

						} else {
							var dados = resposta.data[0];
							$("#codigo_plano").val(dados.code);
							$("#lbl_codigo_plano").html(lblCode);

							$("#categoria_plano").val(dados.cat);
							$("#categoria_plano").trigger('change');
							$("#subcategoria_plano").val(dados.subcat);
							$("#subcategoria_plano").trigger('change');
						}
					}
				}
			},
			complete : function() {	$("#descricao_plano").focus(); }
		});
	}

	/**
	 * Fill the ivas select
	 * @param  select id
	 * @return ivas
	 */
	function fill_ivas(lastID = 0, ){
		var options = $("select#iva_plano");
		$(options).empty();

		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/plano_contas.php',
			dataType : 'json',
			data : { 
				opcao: 5
			},
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT9999] Une erreur s'est produite. Contactez l'administrateur", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("Sélectionnez"));
							$(options).append($('<option />').val("").text("Sélectionnez"));

							// $(options).append($("<option />").val(0).text('-- Imposto --'));
							$.each(resposta.data, function() {
								$(options).append( $("<option />").val(this.ID_Imposto).html(this.Nome+': '+this.Valor+'%') );
							});
						}
					}
				}
			},
			complete : function() {
				if(lastID != 0) $(options).val(lastID);
				// $(options).val($("select#plano_contas_plano option:eq(1)").val());
				$(options).trigger('change');
			}
		});
	}
</script>