<?php
//INCLUDE CONNECTION
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

//GET POST VARS
$id_utilizador = $_POST['id_utilizador'];
$nome_utilizador = '';

if ($id_utilizador == "") {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FTGA001";
	die(json_encode($response));
}

//GET USER DATA
$query = "SELECT Nome FROM utilizador WHERE ID_Utilizador=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($nome_utilizador);
	$stmt -> fetch();
	$stmt -> close();

} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//CHECK USER
$query = "SELECT SUM(
		(SELECT COUNT(*) FROM faturacao_compras	WHERE faturacao_compras.ID_Utilizador = utilizador.ID_Utilizador OR faturacao_compras.ID_UtilizadorAtualizacao = utilizador.ID_Utilizador) +
		
		(SELECT COUNT(*) FROM faturacao_faturas	WHERE faturacao_faturas.ID_Utilizador = utilizador.ID_Utilizador OR faturacao_faturas.ID_UtilizadorAtualizacao = utilizador.ID_Utilizador) +
		
		(SELECT COUNT(*) FROM faturacao_guias_transporte WHERE faturacao_guias_transporte.ID_Utilizador = utilizador.ID_Utilizador OR faturacao_guias_transporte.ID_UtilizadorAtualizacao = utilizador.ID_Utilizador) +
		
		(SELECT COUNT(*) FROM faturacao_compras_notas_credito WHERE faturacao_compras_notas_credito.ID_Utilizador = utilizador.ID_Utilizador OR faturacao_compras_notas_credito.ID_UtilizadorAtualizacao = utilizador.ID_Utilizador) +
		
		(SELECT COUNT(*) FROM faturacao_consommables WHERE faturacao_consommables.ID_Utilizador_Criacao = utilizador.ID_Utilizador OR faturacao_consommables.ID_Utilizador_Atualizacao = utilizador.ID_Utilizador) +
		
		(SELECT COUNT(*) FROM faturacao_devis WHERE faturacao_devis.ID_Utilizador = utilizador.ID_Utilizador OR faturacao_devis.ID_UtilizadorAtualizacao = utilizador.ID_Utilizador) +
		
		(SELECT COUNT(*) FROM faturacao_locations WHERE faturacao_locations.ID_Utilizador_Criacao = utilizador.ID_Utilizador OR faturacao_locations.ID_Utilizador_Atualizacao = utilizador.ID_Utilizador) +
		
		(SELECT COUNT(*) FROM faturacao_notas_credito WHERE faturacao_notas_credito.ID_Utilizador = utilizador.ID_Utilizador OR faturacao_notas_credito.ID_UtilizadorAtualizacao = utilizador.ID_Utilizador) +
		
		(SELECT COUNT(*) FROM faturacao_rapports_travail WHERE faturacao_rapports_travail.ID_Utilizador_Criacao = utilizador.ID_Utilizador OR faturacao_rapports_travail.ID_Utilizador_Atualizacao = utilizador.ID_Utilizador) 
	) AS TOT_SUM FROM utilizador WHERE ID_Utilizador=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA002";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($total);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["line"] = "FTGA003";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}

if ($total > 0) {
	$response["errors"] = true;
	$response["type"] = "validation";
	$response["line"] = "FTGA004";
	$response["foreign"] = "Utilizado por gesfaturação";
	die(json_encode($response));
}

$query = "DELETE FROM utilizador WHERE ID_Utilizador=?";
//QUERIE IS CORRECT
if ($stmt = $sqli_connection -> prepare($query)) {

	$stmt -> bind_param("d", $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {// QUERY IS INCORRECT
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA05";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}

//log sistema - processo
$descricao_log ="Suppression d'utilisateur (id: ".$id_utilizador." | nom: ".$nome_utilizador.")";
insert_log(0,"Apagar",$descricao_log,$sqli_connection);

$response["errors"] = false;
die(json_encode($response));
?>