<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idFecho = $_POST['idFermeture'];

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idFecho == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//GET INFO BD -------------------------------------------------------------
$estadoAtual=0; $anoBD=0; $mesBD=0; $mesStr = '';
$query = "SELECT Estado, Ano, Mes FROM faturacao_fecho_mes WHERE ID_MesFecho = ?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	$stmt -> bind_param("d", $idFecho);
	//result
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FATS0001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($estadoAtual, $anoBD, $mesBD);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FATS0002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
$mesStr = month_in_french($mesBD);
//------------------------------------------------------------------------

//DELETE DB -------------------------------------------------------------
$query = "DELETE FROM faturacao_fecho_mes WHERE ID_MesFecho=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idFecho );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS005";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Élimination de fermeture du mois ( ".$mesStr." ".$anoBD.")";
insert_log(0,"Apagar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>