<?php

//check method and process the vars
$_token_read = null;
//process request method and get the token for validation
switch ($_SERVER['REQUEST_METHOD']) {
	case 'GET': $_token_read = $_GET['_token'] ? $_GET['_token'] : null; break;
	case 'POST': $_token_read = $_POST['_token'] ? $_POST['_token'] : null; break;
	case 'PUT': 
		//parse data x-www-form-urlencoded
		parse_str(file_get_contents("php://input"),$_PUT);
		$_token_read = $_PUT['_token'] ? $_PUT['_token'] : null; 
		break;
	case 'PATCH': 
		//parse data x-www-form-urlencoded
		parse_str(file_get_contents("php://input"),$_PATCH);
		$_token_read = $_PATCH['_token'] ? $_PATCH['_token'] : null; 
		break;
	case 'DELETE': 
		//parse data x-www-form-urlencoded
		parse_str(file_get_contents("php://input"),$_DELETE);
		$_token_read = $_DELETE['_token'] ? $_DELETE['_token'] : null; 
		break;
	
	default: $_token_read = $_POST['_token'] ? $_POST['_token'] : null; break;
}

//webservice controller
if (isset($_token_read) && $_token_read) {
	//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
	if(!isset($sqli_connection)) include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/server_key.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/jwt_helper.php";

	//prepare vars
	$userID = null;
	$Token_Created = null;
	$TokenDecoded = null;
	$user = null;
	$TokenRec = $_token_read;
	$Token = null;
	$Token_Expires = null;
	$usernameWS = null;
	$nome_utilizadorWS = null;
	$email_utilizadorWS = null;

	//process the token
	$query = "SELECT ID_UtilizadorWebservice, Token_Created, Username, Token, Token_Expires, Nome, Email, (SELECT ID_TipoUtilizador FROM utilizador WHERE faturacao_utilizadores_webservices.Username = utilizador.Username LIMIT 1) AS TipoUtilizador FROM faturacao_utilizadores_webservices WHERE Token =?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("s", $TokenRec);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "sql_query";
			$response["line"] = "WAPI_SQLQ001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($userID, $Token_Created, $user, $Token, $Token_Expires, $nome_utilizadorWS, $email_utilizadorWS, $TipoUtilizador);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "sql_conn";
		$response["line"] = "WAPI_SQLC001";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//set vars
	$usernameWS = $user;

	//process token to verify
	if($userID && $user && $Token && $Token_Expires){
		// VALIDATE TOKEN RECEIVED ------------------------
		//get key
		$serverKey = getServerKey();

		//decode token
		$TokenDecoded = JWT::decode($TokenRec, $serverKey);

		//check content of the token
		if($TokenDecoded->user != $userID || $TokenDecoded->created != $Token_Created ){
			//cancel the request
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 403 Forbidden.');
			$response["errors"] = true;
			$response["type"] = "validation";
			$response["line"] = "WAPI_VAL001";
			$response["message"] = 'Invalid token. Please provide a valid token.';
			die(json_encode($response));
		}

		if( isset($_POST['user_id']) && $_POST['user_id'] != ''){
			if($TokenDecoded->user != $_POST['user_id']) {
				//cancel the request
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 403 Forbidden.');
				$response["errors"] = true;
				$response["type"] = "validation";
				$response["line"] = "WAPI_VAL002";
				$response["message"] = 'Invalid user_id. Please provide your user_id.';
				die(json_encode($response));
			}
		}
		if( isset($_POST['username']) && $_POST['username'] != '' ) {
			if($TokenDecoded->username != $_POST['username']) {
				//cancel the request
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 403 Forbidden.');
				$response["errors"] = true;
				$response["type"] = "validation";
				$response["line"] = "WAPI_VAL003";
				$response["message"] = 'Invalid username. Please provide your username.';
				die(json_encode($response));
			}
		}
		//-------------------------------------------------

		$now = time();
		// $expires = $Token_Expires;
		$expires = DateTime::createFromFormat("Y-m-d H:i:s", $Token_Expires);
		$expiresTimestamp = $expires->getTimestamp();

		//check token expire date
		if($now > $expiresTimestamp){
			//get vars
			// $user = $_POST['username'];

			//Update 
			$query = "UPDATE faturacao_utilizadores_webservices SET Token=NULL, Token_Created=NULL, Token_Expires=NULL WHERE Username =?";
			if ( $stmt = $sqli_connection -> prepare($query) ) {
				//bind params
				$stmt -> bind_param("s", $user);
				//result
				$result = $stmt -> execute();
				if (false === $result) {
					header('Content-Type: application/json; charset=UTF-8');
					header('HTTP/1.1 500 Internal Server Error.');
					$response["errors"] = true;
					$response["type"] = "sql_query";
					$response["line"] = "WAPI_SQLQ003";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 500 Internal Server Error.');
				$response["errors"] = true;
				$response["type"] = "sql_conn";
				$response["line"] = "WAPI_SQLC003";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			//cancel the request
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 401 Unauthorized access.');
			$response["errors"] = true;
			$response["type"] = "connection";
			$response["line"] = "WAPI_CONN001";
			$response["message"] = 'Expired token. Please log in again.';
			die(json_encode($response));
		}else{
			//update expire date for more 15 minutes
			$current_date_time = date('Y-m-d H:i:s');
			
			$newExpireDate = date("Y-m-d H:i:s", strtotime("+15 minutes", strtotime($current_date_time)));

			//Update 
			$query = "UPDATE faturacao_utilizadores_webservices SET Token_Expires=? WHERE Token =?";
			if ( $stmt = $sqli_connection -> prepare($query) ) {
				//bind params
				$stmt -> bind_param("ss", $newExpireDate, $TokenRec);
				//result
				$result = $stmt -> execute();
				if (false === $result) {
					header('Content-Type: application/json; charset=UTF-8');
					header('HTTP/1.1 500 Internal Server Error.');
					$response["errors"] = true;
					$response["type"] = "sql_query";
					$response["line"] = "WAPI_SQLQ002";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 500 Internal Server Error.');
				$response["errors"] = true;
				$response["type"] = "sql_conn";
				$response["line"] = "WAPI_SQLC002";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			//process session to use token as alternative
			session_start();
			$_SESSION['LAST_ACTIVITY'] = time();
			$nome_plataforma = 'gesfaturacao';

			$_SESSION['id_utilizador'] = $userID;
			$_SESSION['username'] = $usernameWS;
			$_SESSION['nome_utilizador'] = $nome_utilizadorWS;
			$_SESSION['email_utilizador'] = $email_utilizadorWS;

			$tempo_sessao = 1000;

			$_SESSION['tempo_sessao'] = $tempo_sessao * 60;
			$_SESSION['tipo_utilizador'] = $TipoUtilizador;
			$_SESSION['plataforma'] = $nome_plataforma;
			$_SESSION['gesfaturacao']  = 1;

			//fill remaing session vars
			$sessionInfo = getLoginSessionInfo($userID, $sqli_connection);

			// Check Modulo and DataValidade
			$licenca_expirada = $sessionInfo['licenca_expirada'];
			$id_modulo = $sessionInfo['id_modulo'];
			if($licenca_expirada == true || !$id_modulo || $id_modulo <= 0){
				//cancel the request
				header('Content-Type: application/json; charset=UTF-8');
				header('HTTP/1.1 401 Unauthorized access.');
				$response["errors"] = true;
				$response["type"] = "connection";
				$response["line"] = "WAPI_CONN002";
				$response["message"] = 'Expired licence. Please renew your licence.';
				$response["expired_in"] = $sessionInfo['validade'];
				$response["active_module"] = $id_modulo;
				die(json_encode($response));
			}

			$_SESSION['brasao_topo'] = $sessionInfo['brasao_topo'];
			$_SESSION['versao'] = $sessionInfo['versao'];
			$_SESSION['perm_nome_permissao'] = $sessionInfo['perm_nome_permissao'];
			$_SESSION['ano'] = $sessionInfo['ano'];
			
			$_SESSION['designacao_gesfaturacao'] = $sessionInfo['designacao_gesfaturacao'];
			$_SESSION['logotipo_gesfaturacao'] = $sessionInfo['logotipo_gesfaturacao'];
			
			$_SESSION['id_plano_atual'] = $sessionInfo['id_plano_atual'];
			$_SESSION['mod_Compras'] = $sessionInfo['mod_Compras'];
			$_SESSION['mod_Vendas'] = $sessionInfo['mod_Vendas'];
			$_SESSION['mod_Contratos'] = $sessionInfo['mod_Contratos'];
			$_SESSION['mod_Consommables'] = $sessionInfo['mod_Consommables'];
			$_SESSION['mod_Licences'] = $sessionInfo['mod_Licences'];
			$_SESSION['mod_LojaOnline'] = $sessionInfo['mod_LojaOnline'];
			$_SESSION['mod_Contabilidade'] = $sessionInfo['mod_Contabilidade'];
			$_SESSION['mod_Rapports'] = $sessionInfo['mod_Rapports'];
			$_SESSION['mod_Devis'] = $sessionInfo['mod_Devis'];
			$_SESSION['mod_Livraison'] = $sessionInfo['mod_Livraison'];
		}
	}
	else{
		//cancel the request
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 403 Forbidden.');
		$response["errors"] = true;
		$response["type"] = "validation";
		$response["line"] = "WAPI_VAL004";
		$response["message"] = 'Invalid token. Please provide a valid token.';
		die(json_encode($response));
	}
}
//web browser controller
else{
	session_start();

	if (isset($_SESSION['LAST_ACTIVITY']) && (time() - $_SESSION['LAST_ACTIVITY'] > $_SESSION['tempo_sessao'])) {
		session_unset();
		session_destroy();
			header('Location: /server/logout.php');
	} else {

		if (isset($_SESSION['id_utilizador']) && isset($_SESSION['plataforma']) && isset($_SESSION['_token'])) {

			if ($_SESSION['plataforma'] == 'gesfaturacao') {
				$_SESSION['LAST_ACTIVITY'] = time();
			} else {
				session_unset();
				session_destroy();
				header('Location: /server/logout.php');
			}

		} else {
			session_unset();
			session_destroy();
			header('Location: /server/logout.php');
		}
	}
}

// ===================================================
// HELPERS LOCAL FILE
// ===================================================

//get login info for session vars
function getLoginSessionInfo($userID, $sqli_connection){
	//init and prepare some vars
	$returnedObj = array();
	$returnedObj['ano'] = date('Y');
	$returnedObj['perm_nome_permissao'] = "Administrador";
	$logotipoBrasaoDB = null;
	$gb_brasao_img = null;
	$licenca_expirada = false;

	//GET COMPANY DATA
	$querySpecial = "SELECT Logotipo from faturacao_empresa_dados LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($querySpecial)) {
		$stmt -> execute();
		$stmt -> bind_result($logotipoBrasaoDB);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$logotipoBrasaoDB = null;
	}
	
	if($logotipoBrasaoDB != null && $logotipoBrasaoDB != ''){
		$gb_brasao_img = '/uploads/faturacao/'.$logotipoBrasaoDB;
	}else{
		$logotipoBrasaoDB = 'logo_default.png';
		$gb_brasao_img = '/uploads/faturacao/'.$logotipoBrasaoDB;
	}
	
	$returnedObj['brasao_topo'] = $gb_brasao_img;
	//----------------------------------------------------------

	//GET USER / APPLICATION DATA
	$query = "SELECT utilizador.ID_Permissao, faturacao_dados_aplicacao.Versao FROM utilizador, faturacao_dados_aplicacao WHERE ID_Dados_Aplicacao=1 AND ID_Utilizador=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $userID);
		$stmt -> execute();
		$stmt -> bind_result($id_permissao, $versao);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$id_permissao = 0;
		$versao = 0;
	}

	$returnedObj['id_permissao'] = $id_permissao;
	$returnedObj['versao'] = $versao;
	//----------------------------------------------------------
	
	//GET APPLICATION DATA
	$query = "SELECT Designacao, Logotipo FROM faturacao_empresa_dados LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();
		$stmt -> bind_result($designacao, $logotipo);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$designacao = "";
		$logotipo = "";
	}

	$returnedObj['designacao_gesfaturacao'] = $designacao;
	$returnedObj['logotipo_gesfaturacao'] = $logotipo != '' ? $logotipo : 'logo_default.png';
	//----------------------------------------------------------
	
	//GET USER / APPLICATION DATA
	$query = "SELECT ID_Modulo, DataValidade,
				Mod_Compras, Mod_Vendas, Mod_Contratos, Mod_Consommables, Mod_Licences, Mod_LojaOnline, Mod_Contabilidade, Mod_Rapports, Mod_Devis, Mod_Livraison
			FROM faturacao_modulos WHERE Ativo = 1 ORDER BY STR_TO_DATE(`DataActivacao`, '%d/%m/%Y') DESC";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> execute();
		$stmt -> bind_result($id_modulo, $data_validade_modulo, $modCompras, $modVendas, $modContratos, $modConsommables, $modLicences, $modLojaOnline, $modContabilidade, $modRapport, $modDevis, $modLivraison );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$id_modulo = 0;
		$data_validade_modulo = date('d/m/Y');
		$modCompras = 0;
		$modVendas = 0;
		$modContratos = 0;
		$modConsommables = 0;
		$modLicences = 0;
		$modLojaOnline = 0;
		$modContabilidade = 0;
		$modRapport = 0;
		$modDevis = 0;
		$modLivraison = 0;
	}

	//process the date and check if is valid
	$aux = explode('/', $data_validade_modulo);
	$data_validade_modulo = $aux[2].'-'.$aux[1].'-'.$aux[0];
	$dt_validade_modulo = new DateTime($data_validade_modulo);
	$dt_today = new DateTime(date('Y-m-d'));
	if($dt_validade_modulo < $dt_today) {
		$licenca_expirada = true;
	}

	$returnedObj['id_modulo'] = $id_modulo;
	$returnedObj['licenca_expirada'] = $licenca_expirada;
	$returnedObj['validade'] = $data_validade_modulo;

	$returnedObj['id_plano_atual'] = ($id_modulo == 1 ? 1 : 2);
	$returnedObj['mod_Compras'] = $modCompras;
	$returnedObj['mod_Vendas'] = $modVendas;
	$returnedObj['mod_Contratos'] = $modContratos;
	$returnedObj['mod_Consommables'] = $modConsommables;
	$returnedObj['mod_Licences'] = $modLicences;
	$returnedObj['mod_LojaOnline'] = $modLojaOnline;
	$returnedObj['mod_Contabilidade'] = $modContabilidade;
	$returnedObj['mod_Rapports'] = $modRapport;
	$returnedObj['mod_Devis'] = $modDevis;
	$returnedObj['mod_Livraison'] = $modLivraison;
	//----------------------------------------------------------
	
	//return data
	return $returnedObj;
}
?>