<?php
//INCLUDE CONNECTION
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

//GET POST VARS
$nome_utilizador = $_POST['nome_utilizador'];
$username_utilizador = $_POST['username_utilizador'];
$email_utilizador = $_POST['email_utilizador'];
$perfil_utilizador = $_POST['perfil_utilizador'];
$administrador_faturacao = $_POST['administrador_faturacao'];
$password_utilizador = $_POST['password_utilizador'];
$codigo_siial = $_POST['codigo_siial'];
$codigo_vendedor_utilizador = $_POST['codigo_vendedor_utilizador'];

$departamentos = $_POST['departamentos'];

$id_autarquia = 1;

function createSalt() {
	$text = md5(uniqid(rand(), true));
	return substr($text, 0, 3);
}

//CHECK IF VARS ARE NULL OR EMPTY
if ($nome_utilizador == "" || $username_utilizador == "" || $email_utilizador == "" || $perfil_utilizador == "" || $password_utilizador == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

if($administrador_faturacao == "true") $administradorProcessado = 1;
else $administradorProcessado = 0;

$query = "Select count(*) FROM utilizador WHERE username=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("s", $username_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($total);
	$stmt -> fetch();
	$stmt -> close();

} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if ($total > 0) {
	$response["errors"] = true;
	$response["type"] = "validation";
	die(json_encode($response));
}

$hash = hash('sha256', $password_utilizador);
$salt = createSalt();
$password_utilizador = hash('sha256', $salt . $hash);

$tipo_utilizador = 2;
$estado = 0;

$query = "INSERT INTO utilizador (ID_Autarquia, ID_TipoUtilizador, ID_Permissao, Nome, Email, Username, Password, Salt, CodigoSIIAL, Estado, AdministradorFaturacao, CodigoInternoVendedor) values (?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dddsssssssds", $id_autarquia, $tipo_utilizador, $perfil_utilizador, $nome_utilizador, $email_utilizador, $username_utilizador, $password_utilizador, $salt, $codigo_siial, $estado, $administradorProcessado,$codigo_vendedor_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA007";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA008";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//get the inserted id
$query = "SELECT MAX(ID_Utilizador) FROM utilizador ";
if ($stmt = $sqli_connection -> prepare($query)) {
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA009";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($id_utilizadorNovo);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA010";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

// foreach ($departamentos as $depItem) {
// 	$adminDep = 0;
// 	//process admin bool
// 	if($depItem[1] == 'true') $adminDep = 0;
// 	else $adminDep = 1;
// 	//query
// 	$query = "INSERT INTO departamento_utilizador (ID_Departamento, ID_Utilizador, Administrador) values (?,?,?)";
// 	if ($stmt = $sqli_connection -> prepare($query)) {
// 		$stmt -> bind_param("ddd", $depItem[0], $id_utilizadorNovo, $adminDep);
// 		$result = $stmt -> execute();
// 		if (false === $result) {
// 			$response["errors"] = true;
// 			$response["type"] = "FTGA007";
// 			$response["message"] = $stmt -> error;
// 			die(json_encode($response));
// 		}
// 		$stmt -> close();
// 	} else {
// 		$response["errors"] = true;
// 		$response["type"] = "FTGA008";
// 		$response["message"] = $sqli_connection -> error;
// 		die(json_encode($response));
// 	}
// }

//log sistema - processo
$descricao_log ="Création d'utilisateur (id: ".$id_utilizadorNovo." | nom: ".$nome_utilizador.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

$response["errors"] = false;
die(json_encode($response));
?>