<?php
ob_start();
session_start();
include "connection.php";
// inclui a conexão a database
require_once ('PHPMailer/PHPMailerAutoload.php');

function generateRandomString($length) {
	$characters = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
	$charactersLength = strlen($characters);
	$randomString = '';
	for ($i = 0; $i < $length; $i++) {
		$randomString .= $characters[rand(0, $charactersLength - 1)];
	}
	return $randomString;
}

if (!$_POST['username'] || !$_POST['email']) {
	$response["errors"] = true;
	$response["type"] = 1;
	$response["message"] = "GESA001x";
	die(json_encode($response));
} else {
	$username = $_POST['username'];
	$email = $_POST['email'];

	$query = "SELECT ID_Utilizador, utilizador.Nome, utilizador.Estado from utilizador where Username=? AND utilizador.Email=? AND Estado=0";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ss", $username, $email);
		$stmt -> execute();
		$stmt -> bind_result($id_utilizador, $nome_utilizador, $estado_utilizador);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = 2;
		$response["message"] = "GESA002x";
		die(json_encode($response));
	}

	if ($id_utilizador == "")// User not found. So, redirect to login_form again.
	{

		$response["errors"] = true;
    $response["type"] = 3;
		$response["user_not_found"] = true;
    $response["message"] = "GESA003x";
		$response["details"] = $id_utilizador.' | '.$nome_utilizador.' | '. $estado_utilizador;
		die(json_encode($response));

	} else {
		if ($estado_utilizador != 0) {
			$response["errors"] = true;
			$response["type"] = 4;
			$response["message"] = "GESA003x";
			die(json_encode($response));
		} else {

			$query = "DELETE FROM recuperar_password WHERE ID_Utilizador=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("d", $id_utilizador);
				$stmt -> execute();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = 2;
				$response["message"] = "GESA004x";
				die(json_encode($response));
			}

			$time = time();
			$token = generateRandomString(50);

			$link = "http://$_SERVER[HTTP_HOST]/reset-password?email=" . $email . "&token=" . $token;
			$query = "INSERT INTO recuperar_password (ID_Utilizador, Email, Token, TimeStamp) VALUES (?,?,?,?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("dssd", $id_utilizador, $email, $token, $time);
				$stmt -> execute();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = 2;
				$response["message"] = "GESA004x";
				die(json_encode($response));
			}

			$html = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <title>Recuperar a password - fricode.ch</title>
  <style type="text/css" rel="stylesheet" media="all">
    /* Base ------------------------------ */
    *:not(br):not(tr):not(html) {
      font-family: Arial, "Helvetica Neue", Helvetica, sans-serif;
      -webkit-box-sizing: border-box;
      box-sizing: border-box;
    }
    body {
      width: 100% !important;
      height: 100%;
      margin: 0;
      line-height: 1.4;
      background-color: #F2F4F6;
      color: #74787E;
      -webkit-text-size-adjust: none;
    }
    a {
      color: #3869D4;
    }
    /* Layout ------------------------------ */
    .email-wrapper {
      width: 100%;
      margin: 0;
      padding: 0;
      background-color: #F2F4F6;
    }
    .email-content {
      width: 100%;
      margin: 0;
      padding: 0;
    }
    /* Masthead ----------------------- */
    .email-masthead {
      padding: 25px 0;
      text-align: center;
    }
    .email-masthead_logo {
      max-width: 400px;
      border: 0;
    }
    .email-masthead_name {
      font-size: 16px;
      font-weight: bold;
      color: #bbbfc3;
      text-decoration: none;
      text-shadow: 0 1px 0 white;
    }
    /* Body ------------------------------ */
    .email-body {
      width: 100%;
      margin: 0;
      padding: 0;
      border-top: 1px solid #EDEFF2;
      border-bottom: 1px solid #EDEFF2;
      background-color: #FFF;
    }
    .email-body_inner {
      width: 570px;
      margin: 0 auto;
      padding: 0;
    }
    .email-footer {
      width: 570px;
      margin: 0 auto;
      padding: 0;
      text-align: center;
    }
    .email-footer p {
      color: #AEAEAE;
    }
    .body-action {
      width: 100%;
      margin: 30px auto;
      padding: 0;
      text-align: center;
    }
    .body-sub {
      margin-top: 25px;
      padding-top: 25px;
      border-top: 1px solid #EDEFF2;
    }
    .content-cell {
      padding: 35px;
    }
    .align-right {
      text-align: right;
    }
    /* Type ------------------------------ */
    h1 {
      margin-top: 0;
      color: #2F3133;
      font-size: 19px;
      font-weight: bold;
      text-align: left;
    }
    h2 {
      margin-top: 0;
      color: #2F3133;
      font-size: 16px;
      font-weight: bold;
      text-align: left;
    }
    h3 {
      margin-top: 0;
      color: #2F3133;
      font-size: 14px;
      font-weight: bold;
      text-align: left;
    }
    p {
      margin-top: 0;
      color: #74787E;
      font-size: 16px;
      line-height: 1.5em;
      text-align: left;
    }
    p.sub {
      font-size: 12px;
    }
    p.center {
      text-align: center;
    }
    /* Buttons ------------------------------ */
    .button {
      display: inline-block;
      width: 200px;
      background-color: #3869D4;
      border-radius: 3px;
      color: #ffffff;
      font-size: 15px;
      line-height: 45px;
      text-align: center;
      text-decoration: none;
      -webkit-text-size-adjust: none;
      mso-hide: all;
    }
    .button--green {
      background-color: #22BC66;
    }
    .button--red {
      background-color: #dc4d2f;
    }
    .button--blue {
      background-color: #3869D4;
    }
    /*Media Queries ------------------------------ */
    @media only screen and (max-width: 600px) {
      .email-body_inner,
      .email-footer {
        width: 100% !important;
      }
    }
    @media only screen and (max-width: 500px) {
      .button {
        width: 100% !important;
      }
    }
  </style>
</head>
<body>
  <table class="email-wrapper" width="100%" cellpadding="0" cellspacing="0">
    <tr>
      <td align="center">
        <table class="email-content" width="100%" cellpadding="0" cellspacing="0">
          <!-- Logo -->
          <tr>
            <td class="email-masthead">
              <a class="email-masthead_name"><img src="https://frifacturation.ch/img/ges-autarquia.png" /></a>
            </td>
          </tr>
          <!-- Email Body -->
          <tr>
            <td class="email-body" width="100%">
              <table class="email-body_inner" align="center" width="570" cellpadding="0" cellspacing="0">
                <!-- Body content -->
                <tr>
                  <td class="content-cell">
                    <h1>Bonjour ' . $nome_utilizador . ',</h1>
                    <p>Une réinitialisation de mot de passe a récemment été demandée pour votre compte frifacturation.ch. Cliquez sur le lien ci-dessous pour réinitialiser.</p>
                    <!-- Action -->
                    <table class="body-action" align="center" width="100%" cellpadding="0" cellspacing="0">
                      <tr>
                        <td align="center">
                          <div>
                            <!--[if mso]><v:roundrect xmlns:v="urn:schemas-microsoft-com:vml" xmlns:w="urn:schemas-microsoft-com:office:word" href="{{action_url}}" style="height:45px;v-text-anchor:middle;width:200px;" arcsize="7%" stroke="f" fill="t">
                              <v:fill type="tile" color="#dc4d2f" />
                              <w:anchorlock/>
                              <center style="color:#ffffff;font-family:sans-serif;font-size:15px;">Réinitialiser votre mot de passe</center>
                            </v:roundrect><![endif]-->
                            <a href="' . $link . '" class="button button--red">Réinitialiser le mot de passe</a>
                          </div>
                        </td>
                      </tr>
                    </table>
                    <p>Si vous n\'avez pas demandé de réinitialisation du mot de passe, veuillez ignorer ce message ou contactez-nous.</p>
                    <p>Merci,<br>Frifacturation.</p>
                    <!-- Sub copy -->
                    <table class="body-sub">
                      <tr>
                        <td>
                          <p class="sub">Si vous ne parvenez pas à cliquer sur le bouton de réinitialisation, veuillez copier et coller le lien ci-dessous dans votre navigateur.</p>
                          <p class="sub"><a href="' . $link . '">' . $link . '</a></p>
                        </td>
                      </tr>
                    </table>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td>
              <table class="email-footer" align="center" width="570" cellpadding="0" cellspacing="0">
                <tr>
                  <td class="content-cell">
                    <p class="sub center">&copy; '.date("Y").' frifacturation.ch. Tous droits réservés.</p>
                    <p class="sub center">
                      frifacturation.ch
                      <br>@Fricode Sàrl
                      <br>Boulevard de Pérolles, 93
                      <br>1700 Fribourg, Suisse
                    </p>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
</body>
</html>';

			$Mailer = new PHPMailer();

			// define que será usado SMTP
			$Mailer -> IsSMTP();

			// envia email HTML
			$Mailer -> isHTML(true);

			// codificação UTF-8, a codificação mais usada recentemente
			$Mailer -> CharSet = 'UTF-8';

			$Mailer -> SMTPDebug = 0;

			// Configurações do SMTP
			// $Mailer -> SMTPAuth = true;
			// $Mailer -> SMTPSecure = '';
			// $Mailer -> Host = 'mail.frishop.ch';
			// $Mailer -> Port = 587;
			// $Mailer -> Username = 'no-reply-facturation@frishop.ch';
			// $Mailer -> Password = 'WDD2kIFUgk3c';
			// $Mailer -> From = 'no-reply-facturation@frishop.ch';
			// $Mailer -> FromName = 'Frifacturation';
			// $Mailer -> Subject = "Récupération de mot de passe - Frifacturation";
      $Mailer -> SMTPAuth = true;
      $Mailer -> SMTPSecure = '';
      $Mailer -> Host = 'mail.infomaniak.com';
      $Mailer -> Port = 587;
      $Mailer -> Username = 'no-reply@frifacturation.ch';
      $Mailer -> Password = 'k5xc0dBFaESq';
      $Mailer -> From = 'no-reply@frifacturation.ch';
      $Mailer -> FromName = 'Frifacturation';
      $Mailer -> Subject = "Récupération de mot de passe - Frifacturation";
			$Mailer -> AddAddress($email);
			$Mailer -> Body = $html;
			$send = $Mailer -> Send();
			if ($send) {
				$response["errors"] = false;
				die(json_encode($response));
			} else {
				$response["errors"] = true;
				$response["type"] = 5;
				$response["message"] = "GESA005x";
				die(json_encode($response));
			}
		}

	}
}
?>