SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

CREATE TABLE `ano` (
  `ID_Ano` bigint(20) UNSIGNED NOT NULL,
  `Ano` int(11) NOT NULL,
  `Transportar` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `ano` (`ID_Ano`, `Ano`, `Transportar`) VALUES
(1, 2018, 0);

CREATE TABLE `autarquia` (
  `ID_Autarquia` bigint(20) NOT NULL,
  `Nome` varchar(500) NOT NULL,
  `Morada` varchar(100) NOT NULL,
  `Localidade` varchar(100) NOT NULL,
  `ID_Distrito` int(11) NOT NULL,
  `ID_Concelho` int(20) NOT NULL,
  `ID_Freguesia` int(11) NOT NULL,
  `Telefone` varchar(15) NOT NULL,
  `Telemovel` varchar(100) NOT NULL,
  `Fax` varchar(15) NOT NULL,
  `Email` varchar(100) NOT NULL,
  `Website` varchar(1000) NOT NULL,
  `NIF` int(11) NOT NULL,
  `CodigoPostal` varchar(20) NOT NULL,
  `Latitude` varchar(100) NOT NULL,
  `Longitude` varchar(100) NOT NULL,
  `CodigoAutarquia` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `FooterHTML` varchar(10000) NOT NULL,
  `CodigoSIIAL` varchar(100) NOT NULL,
  `Verificacao` tinyint(1) NOT NULL DEFAULT '0',
  `TempoSessao` int(11) NOT NULL,
  `RemetenteSMS` varchar(100) NOT NULL,
  `Versao` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `autarquia` (`ID_Autarquia`, `Nome`, `Morada`, `Localidade`, `ID_Distrito`, `ID_Concelho`, `ID_Freguesia`, `Telefone`, `Telemovel`, `Fax`, `Email`, `Website`, `NIF`, `CodigoPostal`, `Latitude`, `Longitude`, `CodigoAutarquia`, `FooterHTML`, `CodigoSIIAL`, `Verificacao`, `TempoSessao`, `RemetenteSMS`, `Versao`) VALUES
(1, 'Fricode', 'Fricode, Bd Pérolles 93,', 'Fribourg, Switzerland', 16, 237, 2352, '+41 26 422 16 0', '', '', 'contact@frishop.ch', '', 510000000, '1700', '42.008743', '-8.395491', '123456', '<p><br></p>', '1234', 0, 1000, 'FTKODE', '1.3v1.3');

CREATE TABLE `banco` (
  `ID_Banco` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `TipoBanco` int(1) NOT NULL DEFAULT '1',
  `IBAN` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `Swift` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `Estado` tinyint(1) NOT NULL DEFAULT '0',
  `TimeStamp` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `banco` (`ID_Banco`, `Nome`, `TipoBanco`, `IBAN`, `Swift`, `Estado`, `TimeStamp`) VALUES (1, 'Caixa', 1, '', '', 0, 1494953325);

CREATE TABLE `concelho` (
  `ID_Concelho` bigint(20) UNSIGNED NOT NULL,
  `ID_Distrito` int(11) NOT NULL,
  `Nome` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `concelho` (`ID_Concelho`, `ID_Distrito`, `Nome`) VALUES
(1, 1, 'Águeda'),
(2, 1, 'Albergaria-a-Velha'),
(3, 1, 'Anadia'),
(4, 1, 'Arouca'),
(5, 1, 'Aveiro'),
(6, 1, 'Castelo de Paiva'),
(7, 1, 'Espinho'),
(8, 1, 'Estarreja'),
(9, 1, 'Santa Maria da Feira'),
(10, 1, 'Ílhavo'),
(11, 1, 'Mealhada'),
(12, 1, 'Murtosa'),
(13, 1, 'Oliveira de Azemeis'),
(14, 1, 'Oliveira do Bairro'),
(15, 1, 'Ovar'),
(16, 1, 'S. João da Madeira'),
(17, 1, 'Sever do Vouga'),
(18, 1, 'Vagos'),
(19, 1, 'Vale de Cambra'),
(20, 2, 'Aljustrel'),
(21, 2, 'Almodôvar'),
(22, 2, 'Alvito'),
(23, 2, 'Barrancos'),
(24, 2, 'Beja'),
(25, 2, 'Castro Verde'),
(26, 2, 'Cuba'),
(27, 2, 'Ferreira do Alentejo'),
(28, 2, 'Mértola'),
(29, 2, 'Moura'),
(30, 2, 'Odemira'),
(31, 2, 'Ourique'),
(32, 2, 'Serpa'),
(33, 2, 'Vidigueira'),
(34, 3, 'Amares'),
(35, 3, 'Barcelos'),
(36, 3, 'Braga'),
(37, 3, 'Cabeceiras de Basto'),
(38, 3, 'Celorico de Basto'),
(39, 3, 'Esposende'),
(40, 3, 'Fafe'),
(41, 3, 'Guimarães'),
(42, 3, 'Póvoa de Lanhoso'),
(43, 3, 'Terras de Bouro'),
(44, 3, 'Vieira do Minho'),
(45, 3, 'Vila Nova de Famalicão'),
(46, 3, 'Vila Verde'),
(47, 3, 'Vizela'),
(48, 4, 'Alfândega da Fé'),
(49, 4, 'Bragança'),
(50, 4, 'Crrazeda de Ansiães'),
(51, 4, 'Freixo de Espada à Cinta'),
(52, 4, 'Macedo de Cavaleiros'),
(53, 4, 'Miranda do Douro'),
(54, 4, 'Mirandela'),
(55, 4, 'Mogadouro'),
(56, 4, 'Torre de Moncorvo'),
(57, 4, 'Vila Flôr'),
(58, 4, 'Vimioso'),
(59, 4, 'Vinhais'),
(60, 5, 'Belmonte'),
(61, 5, 'Castelo Branco'),
(62, 5, 'Covilhã'),
(63, 5, 'Fundão'),
(64, 5, 'Idanha-a-Nova'),
(65, 5, 'Oleiros'),
(66, 5, 'Penamacôr'),
(67, 5, 'Proença-a-Nova'),
(68, 5, 'Sertã'),
(69, 5, 'Vila de Rei'),
(70, 5, 'Vila Velha de Ródão'),
(71, 6, 'Arganil'),
(72, 6, 'Cantanhede'),
(73, 6, 'Coimbra'),
(74, 6, 'Condeixa-a-Nova'),
(75, 6, 'Figueira da Foz'),
(76, 6, 'Góis'),
(77, 6, 'Lousã'),
(78, 6, 'Mira'),
(79, 6, 'Miranda do Corvo'),
(80, 6, 'Montemor-o-Velho'),
(81, 6, 'Oliveira do Hospital'),
(82, 6, 'Pampilhosa da Serra'),
(83, 6, 'Penacova'),
(84, 6, 'Penela'),
(85, 6, 'Soure'),
(86, 6, 'Tabua'),
(87, 6, 'VIila Nova de Poiares'),
(88, 7, 'Alandroal'),
(89, 7, 'Arraiolos'),
(90, 7, 'Borba'),
(91, 7, 'Estremoz'),
(92, 7, 'Évora'),
(93, 7, 'Montemor-o-Novo'),
(94, 7, 'Mora'),
(95, 7, 'Mourão'),
(96, 7, 'Portel'),
(97, 7, 'Redondo'),
(98, 7, 'Reguengos de Monsaraz'),
(99, 7, 'Vendas Novas'),
(100, 7, 'Viana do Alentejo'),
(101, 7, 'Vila Viçosa'),
(102, 8, 'Albufeira'),
(103, 8, 'Alcoutim'),
(104, 8, 'Aljezur'),
(105, 8, 'Castro Marim'),
(106, 8, 'Faro'),
(107, 8, 'Lagoa (Algarve)'),
(108, 8, 'Lagos'),
(109, 8, 'Loulé'),
(110, 8, 'Monchique'),
(111, 8, 'Olhão'),
(112, 8, 'Portimão'),
(113, 8, 'S. brás de Alportel'),
(114, 8, 'Silves'),
(115, 8, 'Tavira'),
(116, 8, 'Vila do Bispo'),
(117, 8, 'Vila Real de Santo António'),
(118, 9, 'Aguiar da Beira'),
(119, 9, 'Almeida'),
(120, 9, 'Celorico da Beira'),
(121, 9, 'Figueira de Castelo Rodrigo'),
(122, 9, 'Fornos de Algodres'),
(123, 9, 'Gouveia'),
(124, 9, 'Guarda'),
(125, 9, 'Manteigas'),
(126, 9, 'Meda'),
(127, 9, 'Pinhel'),
(128, 9, 'Sabugal'),
(129, 9, 'Seia'),
(130, 9, 'Trancoso'),
(131, 9, 'Vila Nova de Foz Côa'),
(132, 10, 'Alcobaça'),
(133, 10, 'Alvaiazere'),
(134, 10, 'Ansião'),
(135, 10, 'Batalha'),
(136, 10, 'Bombarral'),
(137, 10, 'Caldas da Rainha'),
(138, 10, 'Castanheira de Pêra'),
(139, 10, 'Figueiró dos Vinhos'),
(140, 10, 'Leiria'),
(141, 10, 'Marinha Grande'),
(142, 10, 'Nazaré'),
(143, 10, 'Óbidos'),
(144, 10, 'Pedrogão Grande'),
(145, 10, 'Peniche'),
(146, 10, 'Pombal'),
(147, 10, 'Porto de Mós'),
(148, 11, 'Alenquer'),
(149, 11, 'Arruda dos Vinhos'),
(150, 11, 'Azambuja'),
(151, 11, 'Cadaval'),
(152, 11, 'Cascais'),
(153, 11, 'LISBOA'),
(154, 11, 'Loures'),
(155, 11, 'Lourinhã'),
(156, 11, 'Mafra'),
(157, 11, 'Oeiras'),
(158, 11, 'Sintra'),
(159, 11, 'Sobral do Monte Agraço'),
(160, 11, 'Torres Vedras'),
(161, 11, 'Vila Franca de Xira'),
(162, 11, 'Amadora'),
(163, 11, 'Odivelas'),
(164, 12, 'Alter do Chão'),
(165, 12, 'Arronches'),
(166, 12, 'Avis'),
(167, 12, 'Campo Maior'),
(168, 12, 'Castelo de Vide'),
(169, 12, 'Crato'),
(170, 12, 'Elvas'),
(171, 12, 'Fronteira'),
(172, 12, 'Gavião'),
(173, 12, 'Marvão'),
(174, 12, 'Monforte'),
(175, 12, 'Nisa'),
(176, 12, 'Ponte de Sôr'),
(177, 12, 'Portalegre'),
(178, 12, 'Sousel'),
(179, 13, 'Amarante'),
(180, 13, 'Baião'),
(181, 13, 'Felgueiras'),
(182, 13, 'Gondomar'),
(183, 13, 'Lousada'),
(184, 13, 'Maia'),
(185, 13, 'Marco de Canaveses'),
(186, 13, 'Matosinhos'),
(187, 13, 'Paços de Ferreira'),
(188, 13, 'Paredes'),
(189, 13, 'Penafiel'),
(190, 13, 'Porto'),
(191, 13, 'Póvoa de Varzim'),
(192, 13, 'Santo Tirso'),
(193, 13, 'Valongo'),
(194, 13, 'Vila do Conde'),
(195, 13, 'Vila Nova de Gaia'),
(196, 13, 'Trofa'),
(197, 14, 'Abrantes'),
(198, 14, 'Alcanena'),
(199, 14, 'Almeirim'),
(200, 14, 'Alpiarça'),
(201, 14, 'Benavente'),
(202, 14, 'Cartaxo'),
(203, 14, 'Chamusca'),
(204, 14, 'Constância'),
(205, 14, 'Coruche'),
(206, 14, 'Entroncamento'),
(207, 14, 'Ferreira do Zêzere'),
(208, 14, 'Golegã'),
(209, 14, 'Mação'),
(210, 14, 'Rio Maior'),
(211, 14, 'Salvaterra de Magos'),
(212, 14, 'Santarém'),
(213, 14, 'Sardoal'),
(214, 14, 'Tomar'),
(215, 14, 'Torres Novas'),
(216, 14, 'Vila Nova da Barquinha'),
(217, 14, 'Ourém'),
(218, 15, 'Alcácer do Sal'),
(219, 15, 'Alcochete'),
(220, 15, 'Almada'),
(221, 15, 'Barreiro'),
(222, 15, 'Grândola'),
(223, 15, 'Moita'),
(224, 15, 'Montijo'),
(225, 15, 'Palmela'),
(226, 15, 'Santiago do Cacém'),
(227, 15, 'Seixal'),
(228, 15, 'Sesimbra'),
(229, 15, 'Setúbal'),
(230, 15, 'Sines'),
(231, 16, 'Arcos de Valdevez'),
(232, 16, 'Caminha'),
(233, 16, 'Melgaço'),
(234, 16, 'Monção'),
(235, 16, 'Paredes de Coura'),
(236, 16, 'Ponte da Barca'),
(237, 16, 'Ponte de Lima'),
(238, 16, 'Valença'),
(239, 16, 'Viana do Castelo'),
(240, 16, 'Vila Nova de Cerveira'),
(241, 17, 'Alijó'),
(242, 17, 'Boticas'),
(243, 17, 'Chaves'),
(244, 17, 'Mesão Frio'),
(245, 17, 'Mondim de Basto'),
(246, 17, 'Montalegre'),
(247, 17, 'Murça'),
(248, 17, 'Peso da Régua'),
(249, 17, 'Ribeira de Pena'),
(250, 17, 'Sabrosa'),
(251, 17, 'Santa Marta de Penaguião'),
(252, 17, 'Valpaços'),
(253, 17, 'Vila Pouca de Aguiar'),
(254, 17, 'Vila Real'),
(255, 18, 'Armamar'),
(256, 18, 'Carregal do Sal'),
(257, 18, 'Castro Daire'),
(258, 18, 'Cinfães'),
(259, 18, 'Lamego'),
(260, 18, 'Mangualde'),
(261, 18, 'Moimenta da Beira'),
(262, 18, 'Mortágua'),
(263, 18, 'Nelas'),
(264, 18, 'Oliveira de Frades'),
(265, 18, 'Penalva do Castelo'),
(266, 18, 'Penedono'),
(267, 18, 'Resende'),
(268, 18, 'Santa Comba Dão'),
(269, 18, 'S. João da Pesqueira'),
(270, 18, 'S. Pedro do Sul'),
(271, 18, 'Sátão'),
(272, 18, 'Sernancelhe'),
(273, 18, 'Tabuaço'),
(274, 18, 'Tarouca'),
(275, 18, 'Tondela'),
(276, 18, 'Vila Nova de Paiva'),
(277, 18, 'Viseu'),
(278, 18, 'Vouzela'),
(279, 19, 'Angrado Heroísmo'),
(280, 19, 'Calheta (Açores)'),
(281, 19, 'Santa Cruz da Graciosa'),
(282, 19, 'Velas'),
(283, 19, 'Vila Praia da Vitória'),
(284, 20, 'Corvo'),
(285, 20, 'Horta'),
(286, 20, 'Lajes das Flores'),
(287, 20, 'Lajes do Pico'),
(288, 20, 'Madalena'),
(289, 20, 'Santa Cruz das Flores'),
(290, 20, 'S. Roque do Pico'),
(291, 21, 'Lagoa (Açores)'),
(292, 21, 'Nordeste'),
(293, 21, 'Ponta Delgada'),
(294, 21, 'Povoação'),
(295, 21, 'Ribeira Grande'),
(296, 21, 'Vila Franca do Campo'),
(297, 21, 'Vila do Porto'),
(298, 22, 'Calheta (Madeira)'),
(299, 22, 'Camara de Lobos'),
(300, 22, 'Funchal'),
(301, 22, 'Machico'),
(302, 22, 'Ponta do Sol'),
(303, 22, 'Porto Moniz'),
(304, 22, 'Porto Santo'),
(305, 22, 'Ribeira Brava'),
(306, 22, 'Santa Cruz'),
(307, 22, 'Santana'),
(308, 22, 'S. Vicente');

CREATE TABLE `departamento` (
  `ID_Departamento` bigint(11) NOT NULL,
  `Sigla` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Nome` varchar(200) NOT NULL,
  `Estado` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `departamento` (`ID_Departamento`, `Sigla`, `Nome`, `Estado`) VALUES
(6, 'EXE', 'Executivo', 0),
(7, 'FIN', 'Financeiro', 0),
(8, 'OP', 'Obras e Espaços Publicos', 0),
(9, 'LIC', 'Licenciamento', 0),
(10, 'HP', 'Higiene Pública', 0),
(11, 'DC', 'Desenvolvimento Comunitário', 0),
(12, 'CI', 'Comunicação e Imagem', 0),
(13, 'ATEND', 'Atendimento', 0),
(14, 'RH', 'Recursos Humanos', 0),
(15, 'CONT', 'Contabilidade', 0);

CREATE TABLE `departamento_utilizador` (
  `ID_DepartamentoUtilizador` bigint(11) NOT NULL,
  `Responsavel` tinyint(1) UNSIGNED NOT NULL DEFAULT '1',
  `Administrador` tinyint(1) UNSIGNED NOT NULL DEFAULT '1',
  `ID_Departamento` int(11) NOT NULL,
  `ID_Utilizador` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `distrito` (
  `ID_Distrito` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `distrito` (`ID_Distrito`, `Nome`) VALUES
(1, 'Aveiro'),
(2, 'Beja'),
(3, 'Braga'),
(4, 'Bragança'),
(5, 'Castelo Branco'),
(6, 'Coimbra'),
(7, 'Évora'),
(8, 'Faro'),
(9, 'Guarda'),
(10, 'Leiria'),
(11, 'Lisboa'),
(12, 'Portalegre'),
(13, 'Porto'),
(14, 'Santarém'),
(15, 'Setubal'),
(16, 'Viana do Castelo'),
(17, 'Vila Real'),
(18, 'Viseu'),
(19, 'Angra do Heroismo'),
(20, 'Horta'),
(21, 'Ponta Delgada'),
(22, 'Funchal');

CREATE TABLE `faturacao_accounts` (
  `ID_Account` bigint(20) UNSIGNED NOT NULL,
  `ID_SNC` int(10) UNSIGNED NOT NULL,
  `AccountID` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `AccountDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Grouping_Category` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'GM',
  `TaxonomyCode` int(10) UNSIGNED NOT NULL,
  `OpeningDebit` decimal(20,6) UNSIGNED NOT NULL,
  `OpeningCredit` decimal(20,6) UNSIGNED NOT NULL,
  `Usado` tinyint(1) NOT NULL DEFAULT '0',
  `ContaSistema` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Conta necessária para o sistema'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_accounts` (`ID_Account`, `ID_SNC`, `AccountID`, `AccountDescription`, `Grouping_Category`, `TaxonomyCode`, `OpeningDebit`, `OpeningCredit`, `Usado`, `ContaSistema`) VALUES
(1, 1, '111', 'Argent', 'GM', 1, '0.000000', '0.000000', 0, 1),
(2, 2, '121', 'Banque Cantonale de Fribourg', 'GM', 2, '0.000000', '0.000000', 0, 0);

CREATE TABLE `faturacao_ano_fiscal` (
  `ID_Ano` int(10) UNSIGNED NOT NULL,
  `Ano` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Inicio` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Fim` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_ano_fiscal` (`ID_Ano`, `Ano`, `Data_Inicio`, `Data_Fim`) VALUES
(1, '2018', '2018-01-01 00:00:00', '2018-12-31 23:59:59');

CREATE TABLE `faturacao_artigos` (
  `ID_Artigo` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Tipo` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoBarras` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Categoria` bigint(20) UNSIGNED NOT NULL,
  `ID_Unidade` int(10) UNSIGNED NOT NULL,
  `Preco` decimal(20,6) UNSIGNED NOT NULL,
  `ID_Imposto` bigint(20) UNSIGNED NOT NULL,
  `ID_Imposto_Fornecedor` bigint(20) UNSIGNED NOT NULL,
  `PrecoPVP` decimal(20,6) UNSIGNED NOT NULL,
  `RetencaoPercentagem` decimal(5,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `RetencaoValor` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `Stock` decimal(20,3) NOT NULL DEFAULT '0.000',
  `Ativo` tinyint(1) NOT NULL DEFAULT '1',
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PlanoContasCompras` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Usado` tinyint(1) NOT NULL DEFAULT '0',
  `ID_Prestashop` int(11) DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_artigos` (`ID_Artigo`, `Nome`, `Codigo`, `Tipo`, `CodigoBarras`, `SerialNumber`, `ID_Categoria`, `ID_Unidade`, `Preco`, `ID_Imposto`, `ID_Imposto_Fornecedor`, `PrecoPVP`, `RetencaoPercentagem`, `RetencaoValor`, `Stock`, `Ativo`, `PlanoContas`, `PlanoContasCompras`, `Usado`, `ID_Prestashop`) VALUES
(1, 'Location mensuelle', 'CL0001', 'S', '', '', 0, 1, '0.000000', 21, 19, '0.000000', '0.00', '0.000000', '-4.000', 0, '6402', '6402', 1, 0),
(2, 'Emolument admin', 'CL0002', 'S', '', '', 0, 1, '0.000000', 21, 19, '0.000000', '0.00', '0.000000', '-1.000', 0, '6402', '6402', 1, 0),
(3, 'Pages noir/blanc', 'CC0001', 'S', '', '', 0, 1, '0.000000', 21, 19, '0.000000', '0.00', '0.000000', '-1.000', 0, '6402', '6402', 1, 0),
(4, 'Pages couleur', 'CC0002', 'S', '', '', 0, 1, '0.000000', 21, 19, '0.000000', '0.00', '0.000000', '-1.000', 0, '6402', '6402', 1, 0);

CREATE TABLE `faturacao_artigos_categorias` (
  `ID_Categoria` bigint(20) NOT NULL,
  `Nome` varchar(50) NOT NULL,
  `Ativo` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_bancos` (
  `ID_Banco` int(10) UNSIGNED NOT NULL,
  `Nome` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostal` varchar(20) NOT NULL,
  `Cidade` varchar(50) NOT NULL,
  `ContaBancaria` varchar(50) NOT NULL,
  `DebitoInicial` decimal(20,6) UNSIGNED NOT NULL,
  `CreditoInicial` decimal(20,6) UNSIGNED NOT NULL,
  `ID_Account` bigint(20) UNSIGNED NOT NULL,
  `Predefinido` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `Ativo` tinyint(1) NOT NULL DEFAULT '1',
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Usado` tinyint(1) NOT NULL DEFAULT '0',
  `CodigoBVR` varchar(11) NOT NULL,
  `CodigoBVR_LP1` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoBVR_LP2` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `QRIBAN` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `IBAN` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- INSERT INTO `faturacao_bancos` (`ID_Banco`, `Nome`, `CodigoPostal`, `Cidade`, `ContaBancaria`, `DebitoInicial`, `CreditoInicial`, `ID_Account`, `Predefinido`, `Ativo`, `PlanoContas`, `Usado`, `CodigoBVR`, `CodigoBVR_LP1`, `CodigoBVR_LP2`) VALUES
-- (1, 'Banque Cantonale de Fribourg', '1701', 'Fribourg', '01-3788-2', '0.000000', '0.000000', 2, 1, 1, '1002', 1, '999000', '01-0000-2', '010000999');

CREATE TABLE `faturacao_bancos_fornecedores` (
  `ID_BancoFornecedor` bigint(30) UNSIGNED NOT NULL,
  `Nome` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Address1` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Address2` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NPA` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Localite` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisBanco` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'Suisse',
  `BCNbr` int(10) UNSIGNED NOT NULL,
  `Predefinido` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `Ativo` tinyint(1) UNSIGNED NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_bancos_fornecedores` (`ID_BancoFornecedor`, `Nome`, `Address1`, `Address2`, `NPA`, `Localite`, `PaisBanco`, `BCNbr`, `Predefinido`, `Ativo`) VALUES
(1, 'Schweizerische Nationalbank', 'Börsenstrasse 15', 'Postfach 2800', '8022', 'Zürich', 'Suisse', 100, 0, 1),
(2, 'Schweizerische Nationalbank', 'Bundesplatz 1', 'Postfach', '3003', 'Bern', 'Suisse', 110, 0, 1),
(3, 'Schweizerische Nationalbank', 'Bundesverw. / Bundes', 'Postfach', '3003', 'Bern', 'Suisse', 115, 0, 1),
(4, 'SECB Swiss Euro Clearing Bank', 'Solmsstrasse 83', '', '60486', 'Frankfurt am Main', 'Suisse', 193, 0, 1),
(5, 'UBS Switzerland AG', 'Poststrasse 10', 'Postfach', '8610', 'Uster 1', 'Suisse', 202, 0, 1),
(6, 'UBS Switzerland AG', 'Bahnhofstrasse 1', 'Postfach', '8600', 'Dübendorf 1', 'Suisse', 202, 0, 1),
(7, 'UBS Switzerland AG', 'Bahnhofstrasse 26', 'Postfach', '9320', 'Arbon', 'Suisse', 203, 0, 1),
(8, 'UBS Switzerland AG', 'Poststrasse 198', 'Postfach', '7050', 'Arosa', 'Suisse', 204, 0, 1),
(9, 'UBS Switzerland AG', 'Paradeplatz 6', 'Postfach', '8098', 'Zürich', 'Suisse', 206, 0, 1),
(10, 'UBS Switzerland AG', 'Bahnhofstrasse 72', 'Postfach', '8098', 'Zürich', 'Suisse', 206, 0, 1),
(11, 'UBS Switzerland AG', 'Löwenplatz / Seideng', 'Postfach', '8098', 'Zürich', 'Suisse', 206, 0, 1),
(12, 'UBS Switzerland AG', 'Bahnhofstrasse 39', 'Postfach', '8180', 'Bülach', 'Suisse', 207, 0, 1),
(13, 'UBS Switzerland AG', 'Poststrasse 1', 'Postfach', '7002', 'Chur', 'Suisse', 208, 0, 1),
(14, 'UBS Switzerland AG', 'Via Nova 64', 'Postfach', '7017', 'Flims Dorf', 'Suisse', 208, 0, 1),
(15, 'UBS Switzerland AG', 'Bahnhofstrasse 14', 'Postfach', '7130', 'Ilanz', 'Suisse', 208, 0, 1),
(16, 'UBS Switzerland AG', 'Voa principala 68', 'Postfach', '7078', 'Lenzerheide/Lai', 'Suisse', 208, 0, 1),
(17, 'UBS Switzerland AG', 'Grossfeldstrasse 19', 'Postfach', '7320', 'Sargans', 'Suisse', 208, 0, 1),
(18, 'UBS Switzerland AG', 'Neudorfstrasse 46', 'Postfach', '7430', 'Thusis', 'Suisse', 208, 0, 1),
(19, 'UBS Switzerland AG', 'Via Sursilvana 18', 'Postfach', '7180', 'Disentis/Mustér', 'Suisse', 208, 0, 1),
(20, 'UBS Switzerland AG', 'Promenade 48', 'Postfach', '7270', 'Davos Platz 1', 'Suisse', 209, 0, 1),
(21, 'UBS Switzerland AG', 'Bahnhofstrasse 6', 'Postfach', '7250', 'Klosters', 'Suisse', 209, 0, 1),
(22, 'UBS Switzerland AG', 'Bahnhofstrasse 11', 'Postfach 768', '5201', 'Brugg AG', 'Suisse', 210, 0, 1),
(23, 'UBS Switzerland AG', 'Hauptstrasse 44', 'Postfach', '3186', 'Düdingen', 'Suisse', 211, 0, 1),
(24, 'UBS Switzerland AG', 'Rorschacherstrasse 1', 'Postfach', '9450', 'Altstätten SG', 'Suisse', 213, 0, 1),
(25, 'UBS Switzerland AG', 'Kirchstrasse 2', 'Postfach', '9435', 'Heerbrugg', 'Suisse', 213, 0, 1),
(26, 'UBS Switzerland AG', 'Zugerstrasse 22', 'Postfach', '8810', 'Horgen 1', 'Suisse', 214, 0, 1),
(27, 'UBS Switzerland AG', 'Gotthardstrasse 40', 'Postfach', '8800', 'Thalwil', 'Suisse', 214, 0, 1),
(28, 'UBS Switzerland AG', 'Zugerstrasse 11', 'Postfach', '8820', 'Wädenswil', 'Suisse', 214, 0, 1),
(29, 'UBS Switzerland AG', 'Churerstrasse 70', 'Postfach', '8808', 'Pfäffikon SZ', 'Suisse', 214, 0, 1),
(30, 'UBS Switzerland AG', 'Bahnhofplatz 3', 'Postfach', '8853', 'Lachen SZ', 'Suisse', 216, 0, 1),
(31, 'UBS Switzerland AG', 'Klosterplatz', 'Postfach', '8840', 'Einsiedeln', 'Suisse', 216, 0, 1),
(32, 'UBS Switzerland AG', 'Hauptstrasse 37', 'Postfach', '8280', 'Kreuzlingen 1', 'Suisse', 217, 0, 1),
(33, 'UBS Switzerland AG', 'Rathausstrasse 11', 'Postfach', '8570', 'Weinfelden', 'Suisse', 219, 0, 1),
(34, 'UBS Switzerland AG', 'St. Gallerstrasse 5', 'Postfach', '9471', 'Buchs SG 1', 'Suisse', 220, 0, 1),
(35, 'UBS Switzerland AG', 'Am Platz 8', 'Postfach', '7310', 'Bad Ragaz', 'Suisse', 220, 0, 1),
(36, 'UBS Switzerland AG', 'Plazza Mauritius/Via', 'Postfach', '7500', 'St. Moritz 1', 'Suisse', 221, 0, 1),
(37, 'UBS Switzerland AG', 'Plazza da Cumün', 'Casella postale', '7742', 'Poschiavo', 'Suisse', 221, 0, 1),
(38, 'UBS Switzerland AG', 'Bahnhofstrasse 25', 'Postfach', '8304', 'Wallisellen', 'Suisse', 222, 0, 1),
(39, 'UBS Switzerland AG', 'Bahnhofplatz 13', 'Postfach', '8953', 'Dietikon 1', 'Suisse', 223, 0, 1),
(40, 'UBS Switzerland AG', 'Zürcherstrasse 18', 'Postfach', '8952', 'Schlieren', 'Suisse', 223, 0, 1),
(41, 'UBS Switzerland AG', 'Bellevue / Theaterst', 'Postfach', '8098', 'Zürich', 'Suisse', 225, 0, 1),
(42, 'UBS Switzerland AG', 'Rue du Jura 11', 'Case postale', '2900', 'Porrentruy 1', 'Suisse', 226, 0, 1),
(43, 'UBS Switzerland AG', 'Rue de l&apos;Avenir', 'Case postale', '2800', 'Delémont 1', 'Suisse', 226, 0, 1),
(44, 'UBS Switzerland AG', 'Bälliz 1', 'Postfach', '3601', 'Thun', 'Suisse', 227, 0, 1),
(45, 'UBS Switzerland AG', 'Promenade 780 B', 'Postfach', '3780', 'Gstaad', 'Suisse', 227, 0, 1),
(46, 'UBS Switzerland AG', 'Rawilstrasse 5', 'Postfach', '3775', 'Lenk im Simmental', 'Suisse', 227, 0, 1),
(47, 'UBS Switzerland AG', 'Seestrasse 7', 'Postfach', '3700', 'Spiez', 'Suisse', 227, 0, 1),
(48, 'UBS Switzerland AG', 'Mühlegasse 1', 'Postfach', '3770', 'Zweisimmen', 'Suisse', 227, 0, 1),
(49, 'UBS Switzerland AG', 'Centre La Combe/R. d', 'Case postale', '1260', 'Nyon 1', 'Suisse', 228, 0, 1),
(50, 'UBS Switzerland AG', 'Rue du Borgeaud 2', 'Case postale', '1196', 'Gland', 'Suisse', 228, 0, 1),
(51, 'UBS Switzerland AG', 'Bahnhofstrasse 45', 'Postfach', '8098', 'Zürich', 'Suisse', 230, 0, 1),
(52, 'UBS Switzerland AG', 'Bahnhofstrasse 61', 'Postfach', '5001', 'Aarau', 'Suisse', 231, 0, 1),
(53, 'UBS Switzerland AG', 'Bahnhofstrasse 7', 'Postfach', '5600', 'Lenzburg 1', 'Suisse', 231, 0, 1),
(54, 'UBS Switzerland AG', 'Schaffhauserstrasse ', 'Postfach', '4332', 'Stein AG', 'Suisse', 231, 0, 1),
(55, 'UBS Switzerland AG', 'Niklaus-Thut-Platz 9', 'Postfach', '4800', 'Zofingen', 'Suisse', 231, 0, 1),
(56, 'UBS Switzerland AG', 'Bahnhofstrasse 5', 'Postfach', '5734', 'Reinach AG', 'Suisse', 231, 0, 1),
(57, 'UBS Switzerland AG', 'Badstrasse 12', 'Postfach', '5401', 'Baden', 'Suisse', 232, 0, 1),
(58, 'UBS Switzerland AG', 'Landstrasse 61', 'Postfach', '5430', 'Wettingen 1', 'Suisse', 232, 0, 1),
(59, 'UBS Switzerland AG', 'Hauptstrasse 55', 'Postfach', '5330', 'Bad Zurzach', 'Suisse', 232, 0, 1),
(60, 'UBS Switzerland AG', 'Badenerstrasse 26', 'Postfach 66', '5442', 'Fislisbach', 'Suisse', 232, 0, 1),
(61, 'UBS Switzerland AG', 'Aeschenplatz 6', 'Postfach', '4002', 'Basel', 'Suisse', 233, 0, 1),
(62, 'UBS Switzerland AG', 'Baslerstrasse 96', 'Postfach', '4123', 'Allschwil 1', 'Suisse', 233, 0, 1),
(63, 'UBS Switzerland AG', 'Hauptstrasse 31', 'Postfach', '4144', 'Arlesheim', 'Suisse', 233, 0, 1),
(64, 'UBS Switzerland AG', 'Ahornhof, Türkheimer', 'Postfach', '4009', 'Basel', 'Suisse', 233, 0, 1),
(65, 'UBS Switzerland AG', 'Austrasse 2', 'Postfach', '4153', 'Reinach BL 1', 'Suisse', 233, 0, 1),
(66, 'UBS Switzerland AG', 'Baselstrasse 48', 'Postfach', '4125', 'Riehen 1', 'Suisse', 233, 0, 1),
(67, 'UBS Switzerland AG', 'Gellert / Hardstrass', 'Postfach', '4020', 'Basel', 'Suisse', 233, 0, 1),
(68, 'UBS Switzerland AG', 'Tellplatz 12', 'Postfach', '4018', 'Basel', 'Suisse', 233, 0, 1),
(69, 'UBS Switzerland AG', 'Oberwilerstrasse 2', 'Postfach', '4102', 'Binningen 1', 'Suisse', 233, 0, 1),
(70, 'UBS Switzerland AG', 'Hauptstrasse 68', 'Postfach', '4132', 'Muttenz 1', 'Suisse', 233, 0, 1),
(71, 'UBS Switzerland AG', 'Bahnhofstrasse 5', 'Postfach', '4133', 'Pratteln 1', 'Suisse', 233, 0, 1),
(72, 'UBS Switzerland AG', 'Kleinbasel / Clarapl', 'Postfach', '4005', 'Basel', 'Suisse', 233, 0, 1),
(73, 'UBS Switzerland AG', 'Centralbahnplatz 6', 'Postfach', '4002', 'Basel', 'Suisse', 233, 0, 1),
(74, 'UBS Switzerland AG', 'Lysbüchel / Elsässer', 'Postfach', '4013', 'Basel', 'Suisse', 233, 0, 1),
(75, 'UBS Switzerland AG', 'Neubad / Neubadstras', 'Postfach', '4015', 'Basel', 'Suisse', 233, 0, 1),
(76, 'UBS Switzerland AG', 'St. Johann / Elsässe', 'Postfach', '4013', 'Basel', 'Suisse', 233, 0, 1),
(77, 'UBS Switzerland AG', 'Hauptstrasse 53', 'Postfach', '4127', 'Birsfelden', 'Suisse', 233, 0, 1),
(78, 'UBS Switzerland AG', 'Bottmingerstrasse 75', 'Postfach', '4104', 'Oberwil BL', 'Suisse', 233, 0, 1),
(79, 'UBS Switzerland AG', 'Marktplatz 17', 'Postfach', '4001', 'Basel', 'Suisse', 233, 0, 1),
(80, 'UBS Switzerland AG', 'Largo Elvezia 2', 'Casella postale', '6501', 'Bellinzona', 'Suisse', 234, 0, 1),
(81, 'UBS Switzerland AG', 'Via Stazione', 'Casella postale', '6780', 'Airolo', 'Suisse', 234, 0, 1),
(82, 'UBS Switzerland AG', 'Via A. Pini 34', 'Casella postale', '6710', 'Biasca', 'Suisse', 234, 0, 1),
(83, 'UBS Switzerland AG', 'Largo Libero Olgiati', '', '6512', 'Giubiasco', 'Suisse', 234, 0, 1),
(84, 'UBS Switzerland AG', 'Bubenbergplatz 3', 'Postfach', '3000', 'Bern 94', 'Suisse', 235, 0, 1),
(85, 'UBS Switzerland AG', 'Langenthalstrasse 33', 'Postfach', '4912', 'Aarwangen', 'Suisse', 235, 0, 1),
(86, 'UBS Switzerland AG', 'Bümpliz / Bottigenst', 'Postfach', '3018', 'Bern', 'Suisse', 235, 0, 1),
(87, 'UBS Switzerland AG', 'Länggassstrasse 29', 'Postfach', '3000', 'Bern 9', 'Suisse', 235, 0, 1),
(88, 'UBS Switzerland AG', 'Bolligenstrasse 94', 'Postfach', '3065', 'Bolligen Station', 'Suisse', 235, 0, 1),
(89, 'UBS Switzerland AG', 'Kramgasse 4', 'Postfach', '3506', 'Grosshöchstetten', 'Suisse', 235, 0, 1),
(90, 'UBS Switzerland AG', 'Moosstrasse 2', 'Postfach', '3073', 'Gümligen', 'Suisse', 235, 0, 1),
(91, 'UBS Switzerland AG', 'Wangenstrasse 10', 'Postfach', '3360', 'Herzogenbuchsee', 'Suisse', 235, 0, 1),
(92, 'UBS Switzerland AG', 'Schwarzenburgstrasse', '', '3098', 'Köniz', 'Suisse', 235, 0, 1),
(93, 'UBS Switzerland AG', 'Kreuzplatz 1', 'Postfach', '3510', 'Konolfingen', 'Suisse', 235, 0, 1),
(94, 'UBS Switzerland AG', 'Marktgasse 16', 'Postfach', '4901', 'Langenthal', 'Suisse', 235, 0, 1),
(95, 'UBS Switzerland AG', 'Thunstrasse 4', 'Postfach', '3110', 'Münsingen', 'Suisse', 235, 0, 1),
(96, 'UBS Switzerland AG', 'Burgdorfstrasse 3', 'Postfach', '3672', 'Oberdiessbach', 'Suisse', 235, 0, 1),
(97, 'UBS Switzerland AG', 'Dorfstrasse 2', 'Postfach', '4914', 'Roggwil BE', 'Suisse', 235, 0, 1),
(98, 'UBS Switzerland AG', 'Chasseralstrasse 156', 'Postfach', '3095', 'Spiegel b. Bern', 'Suisse', 235, 0, 1),
(99, 'UBS Switzerland AG', 'Vorstadt 30', 'Postfach', '3380', 'Wangen an der Aare', 'Suisse', 235, 0, 1),
(100, 'UBS Switzerland AG', 'Kirchweg 1', 'Postfach', '3076', 'Worb 1', 'Suisse', 235, 0, 1),
(101, 'UBS Switzerland AG', 'Bernstrasse 94', 'Postfach', '3052', 'Zollikofen', 'Suisse', 235, 0, 1),
(102, 'UBS Switzerland AG', 'Bärenplatz 8', 'Postfach', '3000', 'Bern 94', 'Suisse', 235, 0, 1),
(103, 'UBS Switzerland AG', 'Breitenrainstrasse 1', 'Postfach', '3000', 'Bern 22', 'Suisse', 235, 0, 1),
(104, 'UBS Switzerland AG', 'Bernstrasse 11', 'Postfach', '3175', 'Flamatt', 'Suisse', 235, 0, 1),
(105, 'UBS Switzerland AG', 'Kalchofenstrasse 6', 'Postfach', '3415', 'Hasle-Rüegsau', 'Suisse', 235, 0, 1),
(106, 'UBS Switzerland AG', 'Dorfstrasse 4', 'Postfach', '3324', 'Hindelbank', 'Suisse', 235, 0, 1),
(107, 'UBS Switzerland AG', 'Talweg 14', 'Postfach', '3063', 'Ittigen', 'Suisse', 235, 0, 1),
(108, 'UBS Switzerland AG', 'Solothurnstrasse 4', 'Postfach', '3422', 'Kirchberg BE', 'Suisse', 235, 0, 1),
(109, 'UBS Switzerland AG', 'Alleestrasse 10 A', 'Postfach', '3550', 'Langnau im Emmental', 'Suisse', 235, 0, 1),
(110, 'UBS Switzerland AG', 'Klosterweg 2', 'Postfach', '3053', 'Münchenbuchsee', 'Suisse', 235, 0, 1),
(111, 'UBS Switzerland AG', 'Emmentalstrasse 11', 'Postfach', '3414', 'Oberburg', 'Suisse', 235, 0, 1),
(112, 'UBS Switzerland AG', 'Dorfstrasse 17', 'Postfach', '3054', 'Schüpfen', 'Suisse', 235, 0, 1),
(113, 'UBS Switzerland AG', 'Emmentalstrasse 14', 'Postfach', '3402', 'Burgdorf', 'Suisse', 235, 0, 1),
(114, 'UBS Switzerland AG', 'Piazza Col. C. Berna', 'Casella postale', '6830', 'Chiasso 1', 'Suisse', 236, 0, 1),
(115, 'UBS Switzerland AG', 'Via Lavizzari 15', 'Casella postale', '6850', 'Mendrisio', 'Suisse', 236, 0, 1),
(116, 'UBS Switzerland AG', 'Viale Serfontana 20', 'Centro Serfontana', '6836', 'Serfontana', 'Suisse', 236, 0, 1),
(117, 'UBS Switzerland AG', 'Via Giulia 25', 'Casella postale', '6855', 'Stabio', 'Suisse', 236, 0, 1),
(118, 'UBS Switzerland AG', 'Dorfstrasse 94', 'Postfach', '8706', 'Meilen', 'Suisse', 238, 0, 1),
(119, 'UBS Switzerland AG', 'Seestrasse 49', 'Postfach', '8712', 'Stäfa', 'Suisse', 238, 0, 1),
(120, 'UBS Switzerland AG', 'Zürcherstrasse 144', 'Postfach', '8501', 'Frauenfeld', 'Suisse', 239, 0, 1),
(121, 'UBS Switzerland AG', 'Bahnhofstrasse 13', 'Postfach', '8580', 'Amriswil', 'Suisse', 239, 0, 1),
(122, 'UBS Switzerland AG', 'Obertor 1', 'Postfach', '9220', 'Bischofszell', 'Suisse', 239, 0, 1),
(123, 'UBS Switzerland AG', 'Rue du Rhône 8', 'Case postale', '1211', 'Genève 2', 'Suisse', 240, 0, 1),
(124, 'UBS Switzerland AG', 'Route de St-Julien 1', 'Case postale', '1228', 'Plan-les-Ouates', 'Suisse', 240, 0, 1),
(125, 'UBS Switzerland AG', 'Rue du Village 28', 'Case postale', '1214', 'Vernier', 'Suisse', 240, 0, 1),
(126, 'UBS Switzerland AG', 'Rampe de la Gare 2', 'Case postale', '1290', 'Versoix', 'Suisse', 240, 0, 1),
(127, 'UBS Switzerland AG', 'Place du Petit-Sacon', 'Case postale', '1211', 'Genève 2', 'Suisse', 240, 0, 1),
(128, 'UBS Switzerland AG', 'Rue de la Servette 7', 'Case postale', '1211', 'Genève 2', 'Suisse', 240, 0, 1),
(129, 'UBS Switzerland AG', 'Avenue de Feuillasse', 'Case postale', '1217', 'Meyrin', 'Suisse', 240, 0, 1),
(130, 'UBS Switzerland AG', 'Lancy-Onex / Rue des', 'Case postale', '1211', 'Genève 2', 'Suisse', 240, 0, 1),
(131, 'UBS Switzerland AG', 'Acacias / Rue des No', 'Case postale', '1211', 'Genève 2', 'Suisse', 240, 0, 1),
(132, 'UBS Switzerland AG', 'Aéroport Cointrin', 'Case postale', '1211', 'Genève 2', 'Suisse', 240, 0, 1),
(133, 'UBS Switzerland AG', 'Place de Cornavin 12', 'Case postale', '1211', 'Genève 1', 'Suisse', 240, 0, 1),
(134, 'UBS Switzerland AG', 'Place des Eaux-Vives', 'Case postale', '1211', 'Genève 2', 'Suisse', 240, 0, 1),
(135, 'UBS Switzerland AG', 'Route de Florissant ', 'Case postale', '1211', 'Genève 2', 'Suisse', 240, 0, 1),
(136, 'UBS Switzerland AG', 'Place du Manoir 16', '', '1223', 'Cologny', 'Suisse', 240, 0, 1),
(137, 'UBS Switzerland AG', 'Bahnhofstrasse 20', 'Postfach', '3800', 'Interlaken', 'Suisse', 241, 0, 1),
(138, 'UBS Switzerland AG', 'Hauptstrasse', 'Postfach', '3818', 'Grindelwald', 'Suisse', 241, 0, 1),
(139, 'UBS Switzerland AG', 'Avenue Léopold-Rober', 'Case postale', '2300', 'Chaux-de-Fonds, La', 'Suisse', 242, 0, 1),
(140, 'UBS Switzerland AG', 'Rue Henry-Grandjean ', 'Case postale', '2400', 'Locle, Le', 'Suisse', 242, 0, 1),
(141, 'UBS Switzerland AG', 'Place St-François 16', 'Case postale', '1002', 'Lausanne', 'Suisse', 243, 0, 1),
(142, 'UBS Switzerland AG', 'Avenue de Chailly 1', 'Case postale', '1000', 'Lausanne 12', 'Suisse', 243, 0, 1),
(143, 'UBS Switzerland AG', 'Grand-Rue 102', 'Case postale', '1110', 'Morges 1', 'Suisse', 243, 0, 1),
(144, 'UBS Switzerland AG', 'Route de Cossonay 23', 'Case postale', '1008', 'Prilly', 'Suisse', 243, 0, 1),
(145, 'UBS Switzerland AG', 'Place Neuve 2', 'Case postale', '1009', 'Pully', 'Suisse', 243, 0, 1),
(146, 'UBS Switzerland AG', 'Centre Universitaire', 'Case postale', '1015', 'Lausanne', 'Suisse', 243, 0, 1),
(147, 'UBS Switzerland AG', 'Avenue d&apos;Ouchy ', 'Case postale', '1000', 'Lausanne 6', 'Suisse', 243, 0, 1),
(148, 'UBS Switzerland AG', 'Grand-Rue 47', 'Case postale', '1180', 'Rolle', 'Suisse', 243, 0, 1),
(149, 'UBS Switzerland AG', 'Rue de la Gare 4', 'Case postale', '1860', 'Aigle', 'Suisse', 243, 0, 1),
(150, 'UBS Switzerland AG', 'Place de l&apos;Hôte', 'Case postale', '1040', 'Echallens', 'Suisse', 243, 0, 1),
(151, 'UBS Switzerland AG', 'Avenue du 14 Avril 5', 'Case postale', '1020', 'Renens VD 1', 'Suisse', 243, 0, 1),
(152, 'UBS Switzerland AG', 'Rue des Laurelles 1', 'Case postale 42', '1304', 'Cossonay-Ville', 'Suisse', 243, 0, 1),
(153, 'UBS Switzerland AG', 'Hauptgasse 8', 'Postfach', '9620', 'Lichtensteig', 'Suisse', 244, 0, 1),
(154, 'UBS Switzerland AG', 'Bahnhofstrasse 9', 'Postfach', '9630', 'Wattwil', 'Suisse', 244, 0, 1),
(155, 'UBS Switzerland AG', 'Rheinstrasse 12', 'Postfach', '4410', 'Liestal', 'Suisse', 245, 0, 1),
(156, 'UBS Switzerland AG', 'Badweg 2', 'Postfach', '4460', 'Gelterkinden', 'Suisse', 245, 0, 1),
(157, 'UBS Switzerland AG', 'Hauptstrasse 54', 'Postfach', '4450', 'Sissach', 'Suisse', 245, 0, 1),
(158, 'UBS Switzerland AG', 'Hauptstrasse 37', 'Postfach', '4242', 'Laufen', 'Suisse', 245, 0, 1),
(159, 'UBS Switzerland AG', 'Wydehof-Center / Lau', 'Postfach', '4226', 'Breitenbach', 'Suisse', 245, 0, 1),
(160, 'UBS Switzerland AG', 'Kaiserstrasse 9', 'Postfach', '4310', 'Rheinfelden', 'Suisse', 245, 0, 1),
(161, 'UBS Switzerland AG', 'Hauptstrasse 73', 'Postfach', '5070', 'Frick', 'Suisse', 245, 0, 1),
(162, 'UBS Switzerland AG', 'Piazza Grande 1', 'Casella postale', '6601', 'Locarno 1', 'Suisse', 246, 0, 1),
(163, 'UBS Switzerland AG', 'Viale Monte Verità 1', 'Casella postale 533', '6612', 'Ascona', 'Suisse', 246, 0, 1),
(164, 'UBS Switzerland AG', 'Via San Gottardo 77', 'Casella postale', '6596', 'Gordola', 'Suisse', 246, 0, 1),
(165, 'UBS Switzerland AG', 'Piazzetta della Post', 'Casella postale', '6901', 'Lugano', 'Suisse', 247, 0, 1),
(166, 'UBS Switzerland AG', 'Cassarate / Viale Ca', 'Casella postale', '6906', 'Lugano', 'Suisse', 247, 0, 1),
(167, 'UBS Switzerland AG', 'Paradiso / Via G. Gu', 'Casella postale', '6902', 'Lugano', 'Suisse', 247, 0, 1),
(168, 'UBS Switzerland AG', 'Via Cantonale 18', 'Casella postale', '6928', 'Manno', 'Suisse', 247, 0, 1),
(169, 'UBS Switzerland AG', 'Via Giulio Pocobelli', 'Casella postale', '6815', 'Melide', 'Suisse', 247, 0, 1),
(170, 'UBS Switzerland AG', 'Via Lugano 27', 'Casella postale', '6988', 'Ponte Tresa', 'Suisse', 247, 0, 1),
(171, 'UBS Switzerland AG', 'Via Lugano 15', 'World Trade Center', '6982', 'Agno', 'Suisse', 247, 0, 1),
(172, 'UBS Switzerland AG', 'Via S. Gottardo 154', '', '6942', 'Savosa', 'Suisse', 247, 0, 1),
(173, 'UBS Switzerland AG', 'Bahnhofplatz 2', 'Postfach', '6002', 'Luzern', 'Suisse', 248, 0, 1),
(174, 'UBS Switzerland AG', 'Seestrasse 20', 'Postfach', '6052', 'Hergiswil NW', 'Suisse', 248, 0, 1),
(175, 'UBS Switzerland AG', 'Gemeindehausstrasse ', 'Postfach', '6011', 'Kriens', 'Suisse', 248, 0, 1),
(176, 'UBS Switzerland AG', 'Würzenbachstrasse 21', 'Postfach', '6000', 'Luzern 15', 'Suisse', 248, 0, 1),
(177, 'UBS Switzerland AG', 'Buochserstrasse 2', 'Postfach', '6371', 'Stans', 'Suisse', 248, 0, 1),
(178, 'UBS Switzerland AG', 'Bahnhofstrasse 28', 'Postfach', '6403', 'Küssnacht am Rigi', 'Suisse', 248, 0, 1),
(179, 'UBS Switzerland AG', 'Bahnhofplatz 1', 'Postfach', '6061', 'Sarnen', 'Suisse', 248, 0, 1),
(180, 'UBS Switzerland AG', 'Avenue du Casino 41', 'Case postale', '1820', 'Montreux 1', 'Suisse', 249, 0, 1),
(181, 'UBS Switzerland AG', 'Avenue Centrale', 'Case postale', '1884', 'Villars-sur-Ollon', 'Suisse', 249, 0, 1),
(182, 'UBS Switzerland AG', 'Rathausstrasse 8', 'Postfach', '8640', 'Rapperswil SG', 'Suisse', 250, 0, 1),
(183, 'UBS Switzerland AG', 'Römerhofplatz 5', '', '8032', 'Zürich', 'Suisse', 251, 0, 1),
(184, 'UBS Switzerland AG', 'Witikon / Witikoners', 'Postfach', '8053', 'Zürich', 'Suisse', 251, 0, 1),
(185, 'UBS Switzerland AG', 'Hauptstrasse 78', 'Postfach', '9401', 'Rorschach', 'Suisse', 252, 0, 1),
(186, 'UBS Switzerland AG', 'Bahnhofstrasse 5', 'Postfach', '8630', 'Rüti ZH', 'Suisse', 253, 0, 1),
(187, 'UBS Switzerland AG', 'Am Bahnhofplatz', 'Postfach', '9001', 'St. Gallen', 'Suisse', 254, 0, 1),
(188, 'UBS Switzerland AG', 'Bahnhofstrasse 2', 'Postfach', '9230', 'Flawil 1', 'Suisse', 254, 0, 1),
(189, 'UBS Switzerland AG', 'Dorfplatz 5', 'Postfach', '9056', 'Gais', 'Suisse', 254, 0, 1),
(190, 'UBS Switzerland AG', 'St. Gallerstrasse 57', 'Postfach', '9201', 'Gossau SG 1', 'Suisse', 254, 0, 1),
(191, 'UBS Switzerland AG', 'Kirchplatz 4', 'Postfach', '9410', 'Heiden', 'Suisse', 254, 0, 1),
(192, 'UBS Switzerland AG', 'Obstmarkt 1', 'Postfach', '9101', 'Herisau', 'Suisse', 254, 0, 1),
(193, 'UBS Switzerland AG', 'Zaun 55', 'Postfach', '9042', 'Speicher', 'Suisse', 254, 0, 1),
(194, 'UBS Switzerland AG', 'Ebni 4', 'Postfach', '9053', 'Teufen AR', 'Suisse', 254, 0, 1),
(195, 'UBS Switzerland AG', 'Herisauer Strasse 5', 'Postfach', '9107', 'Urnäsch', 'Suisse', 254, 0, 1),
(196, 'UBS Switzerland AG', 'Hauptgasse 11', 'Postfach', '9050', 'Appenzell', 'Suisse', 254, 0, 1),
(197, 'UBS Switzerland AG', 'Multertor / Neugasse', 'Postfach', '9001', 'St. Gallen', 'Suisse', 254, 0, 1),
(198, 'UBS Switzerland AG', 'Rue de Lausanne 6', 'Case postale', '1800', 'Vevey 1', 'Suisse', 255, 0, 1),
(199, 'UBS Switzerland AG', 'Obere Bahnhofstrasse', 'Postfach', '9501', 'Wil SG 1', 'Suisse', 256, 0, 1),
(200, 'UBS Switzerland AG', 'Stadthausstrasse 18', 'Postfach', '8401', 'Winterthur', 'Suisse', 257, 0, 1),
(201, 'UBS Switzerland AG', 'Guggenbühlstrasse 2', 'Postfach', '8404', 'Winterthur', 'Suisse', 257, 0, 1),
(202, 'UBS Switzerland AG', 'Rikonerstrasse 16', 'Postfach', '8307', 'Effretikon', 'Suisse', 257, 0, 1),
(203, 'UBS Switzerland AG', 'Zentralstrasse 55', 'Postfach', '5610', 'Wohlen AG 1', 'Suisse', 258, 0, 1),
(204, 'UBS Switzerland AG', 'Zürcherstrasse 7', 'Postfach', '5620', 'Bremgarten AG 1', 'Suisse', 258, 0, 1),
(205, 'UBS Switzerland AG', 'Marktstrasse 7', 'Postfach', '5630', 'Muri AG', 'Suisse', 258, 0, 1),
(206, 'UBS Switzerland AG', 'Bergstrasse 17', 'Postfach', '8702', 'Zollikon', 'Suisse', 259, 0, 1),
(207, 'UBS Switzerland AG', 'Forchstrasse 191', 'Postfach', '8125', 'Zollikerberg', 'Suisse', 259, 0, 1),
(208, 'UBS Switzerland AG', 'Zürichstrasse 141', 'Postfach', '8700', 'Küsnacht ZH', 'Suisse', 259, 0, 1),
(209, 'UBS Switzerland AG', 'Rue Saint-Pierre 1', 'Case postale', '1701', 'Fribourg', 'Suisse', 260, 0, 1),
(210, 'UBS Switzerland AG', 'Route des Pralettes ', 'Case postale', '1723', 'Marly 1', 'Suisse', 260, 0, 1),
(211, 'UBS Switzerland AG', 'Hauptgasse 55', 'Postfach', '3280', 'Murten/Morat', 'Suisse', 260, 0, 1),
(212, 'UBS Switzerland AG', 'Rue de Lausanne 13', 'Case postale', '1530', 'Payerne', 'Suisse', 260, 0, 1),
(213, 'UBS Switzerland AG', 'Rue de la Gare 14', '', '1470', 'Estavayer-le-Lac', 'Suisse', 260, 0, 1),
(214, 'UBS Switzerland AG', 'Route du Jura 37', 'Case postale', '1701', 'Fribourg', 'Suisse', 260, 0, 1),
(215, 'UBS Switzerland AG', 'Rue de l&apos;Eglise', '', '1680', 'Romont FR', 'Suisse', 260, 0, 1),
(216, 'UBS Switzerland AG', 'Froburgstrasse 17', 'Postfach', '4600', 'Olten', 'Suisse', 261, 0, 1),
(217, 'UBS Switzerland AG', 'Amthausplatz 1', 'Postfach', '4502', 'Solothurn', 'Suisse', 262, 0, 1),
(218, 'UBS Switzerland AG', 'Oltenstrasse 5', 'Postfach', '4536', 'Attiswil', 'Suisse', 262, 0, 1),
(219, 'UBS Switzerland AG', 'Dorfstrasse 6', 'Postfach', '4704', 'Niederbipp', 'Suisse', 262, 0, 1),
(220, 'UBS Switzerland AG', 'St. Niklausstrasse 1', 'Postfach', '3425', 'Koppigen', 'Suisse', 262, 0, 1),
(221, 'UBS Switzerland AG', 'Bielstrasse 24', 'Postfach', '2543', 'Lengnau BE', 'Suisse', 262, 0, 1),
(222, 'UBS Switzerland AG', 'Hauptstrasse 14', 'Postfach', '3427', 'Utzenstorf', 'Suisse', 262, 0, 1),
(223, 'UBS Switzerland AG', 'Sebastiansplatz 4', 'Postfach', '3900', 'Brig/Brigue', 'Suisse', 263, 0, 1),
(224, 'UBS Switzerland AG', 'Haus Alpenheim', 'Postfach', '3992', 'Bettmeralp', 'Suisse', 263, 0, 1),
(225, 'UBS Switzerland AG', 'Furkastrasse', 'Postfach', '3984', 'Fiesch', 'Suisse', 263, 0, 1),
(226, 'UBS Switzerland AG', 'Furkastrasse 21', 'Postfach', '3904', 'Naters', 'Suisse', 263, 0, 1),
(227, 'UBS Switzerland AG', 'Marienhof', 'Postfach', '3906', 'Saas Fee', 'Suisse', 263, 0, 1),
(228, 'UBS Switzerland AG', 'Bahnhofstrasse', 'Postfach', '3920', 'Zermatt', 'Suisse', 263, 0, 1),
(229, 'UBS Switzerland AG', 'Avenue de la Gare 2', 'Case postale', '1920', 'Martigny 1', 'Suisse', 264, 0, 1),
(230, 'UBS Switzerland AG', 'Immeuble Eden / Plac', 'Case postale', '1936', 'Verbier 1', 'Suisse', 264, 0, 1),
(231, 'UBS Switzerland AG', 'Rue de Gottefrey 14', 'Case postale', '1907', 'Saxon', 'Suisse', 264, 0, 1),
(232, 'UBS Switzerland AG', 'Rue de la Poste', 'Case postale', '1926', 'Fully', 'Suisse', 264, 0, 1),
(233, 'UBS Switzerland AG', 'Avenue de la Gare 36', 'Case postale', '1951', 'Sion/Sitten', 'Suisse', 265, 0, 1),
(234, 'UBS Switzerland AG', 'Centre Commercial', 'Case postale', '1997', 'Haute-Nendaz', 'Suisse', 265, 0, 1),
(235, 'UBS Switzerland AG', 'Rue du Faubourg', 'Case postale', '1908', 'Riddes', 'Suisse', 265, 0, 1),
(236, 'UBS Switzerland AG', 'Saint Germain', 'Case postale', '1965', 'Savièse', 'Suisse', 265, 0, 1),
(237, 'UBS Switzerland AG', 'Avenue de la Gare 12', 'Case postale', '1630', 'Bulle', 'Suisse', 266, 0, 1),
(238, 'UBS Switzerland AG', 'Route de Vevey 30', 'Case postale', '1618', 'Châtel-St-Denis', 'Suisse', 266, 0, 1),
(239, 'UBS Switzerland AG', 'Albisriederplatz 8', 'Postfach', '8098', 'Zürich', 'Suisse', 267, 0, 1),
(240, 'UBS Switzerland AG', 'Albisrieden/Albisrie', 'Postfach', '8047', 'Zürich', 'Suisse', 267, 0, 1),
(241, 'UBS Switzerland AG', 'Avenue Général-Guisa', 'Case postale', '3960', 'Sierre/Siders', 'Suisse', 268, 0, 1),
(242, 'UBS Switzerland AG', 'Rue du Pas de l&apos', 'Case postale', '3963', 'Crans', 'Suisse', 268, 0, 1),
(243, 'UBS Switzerland AG', 'Rue Thèodore Stéphan', 'Case postale 434', '3963', 'Montana', 'Suisse', 268, 0, 1),
(244, 'UBS Switzerland AG', 'Oerlikon / Schaffhau', 'Postfach', '8050', 'Zürich', 'Suisse', 269, 0, 1),
(245, 'UBS Switzerland AG', 'Wiedikon / Birmensdo', 'Postfach', '8098', 'Zürich', 'Suisse', 270, 0, 1),
(246, 'UBS Switzerland AG', 'Postfach', '', '8098', 'Zürich', 'Suisse', 271, 0, 1),
(247, 'UBS Switzerland AG', 'Nidaugasse 49', 'Postfach', '2501', 'Biel/Bienne', 'Suisse', 272, 0, 1),
(248, 'UBS Switzerland AG', 'Marktplatz 6', 'Postfach', '2540', 'Grenchen 1', 'Suisse', 272, 0, 1),
(249, 'UBS Switzerland AG', 'Murtenstrasse 3', 'Postfach', '3270', 'Aarberg', 'Suisse', 272, 0, 1),
(250, 'UBS Switzerland AG', 'Bahnhofstrasse 2', 'Postfach', '2555', 'Brügg BE', 'Suisse', 272, 0, 1),
(251, 'UBS Switzerland AG', 'Hauptgasse 5', 'Postfach', '3294', 'Büren an der Aare', 'Suisse', 272, 0, 1),
(252, 'UBS Switzerland AG', 'Stadtgraben 4', 'Postfach', '3235', 'Erlach', 'Suisse', 272, 0, 1),
(253, 'UBS Switzerland AG', 'Bahnhofstrasse 11', 'Postfach', '3232', 'Ins', 'Suisse', 272, 0, 1),
(254, 'UBS Switzerland AG', 'Murtenstrasse 12', 'Postfach', '3210', 'Kerzers', 'Suisse', 272, 0, 1),
(255, 'UBS Switzerland AG', 'Marktplatz 9', 'Postfach', '3250', 'Lyss', 'Suisse', 272, 0, 1),
(256, 'UBS Switzerland AG', 'Hauptstrasse 10', 'Postfach', '2560', 'Nidau', 'Suisse', 272, 0, 1),
(257, 'UBS Switzerland AG', 'Baarerstrasse 14a', 'Postfach', '6301', 'Zug', 'Suisse', 273, 0, 1),
(258, 'UBS Switzerland AG', 'Rathausplatz 5', 'Postfach', '6460', 'Altdorf UR', 'Suisse', 273, 0, 1),
(259, 'UBS Switzerland AG', 'Dorfplatz 2', 'Postfach', '6330', 'Cham', 'Suisse', 273, 0, 1),
(260, 'UBS Switzerland AG', 'Oberer Steisteg 20', 'Postfach', '6431', 'Schwyz', 'Suisse', 273, 0, 1),
(261, 'UBS Switzerland AG', 'Rathausstrasse 7', 'Postfach', '6341', 'Baar', 'Suisse', 273, 0, 1),
(262, 'UBS Switzerland AG', 'Bleicherweg 30', 'Postfach', '8098', 'Zürich', 'Suisse', 274, 0, 1),
(263, 'UBS Switzerland AG', 'Höngg / Limmattalstr', 'Postfach', '8049', 'Zürich', 'Suisse', 275, 0, 1),
(264, 'UBS Switzerland AG', 'Bahnhofplatz 10', 'Postfach', '8910', 'Affoltern am Albis', 'Suisse', 276, 0, 1),
(265, 'UBS Switzerland AG', 'Zürcherstrasse 17', 'Postfach', '8903', 'Birmensdorf ZH', 'Suisse', 276, 0, 1),
(266, 'UBS Switzerland AG', 'Rue du Coppet 14', 'Case postale', '1870', 'Monthey 2', 'Suisse', 277, 0, 1),
(267, 'UBS Switzerland AG', 'Place Panaït-Istrati', 'Case postale', '1896', 'Vouvry', 'Suisse', 277, 0, 1),
(268, 'UBS Switzerland AG', 'Schaffhauserstrasse ', 'Postfach', '8302', 'Kloten', 'Suisse', 278, 0, 1),
(269, 'UBS Switzerland AG', 'Flughafen, Terminal ', 'Postfach', '8060', 'Zürich Flughafen', 'Suisse', 278, 0, 1),
(270, 'UBS Switzerland AG', 'Rue du Rhône 8', 'Case postale', '1211', 'Genève 2', 'Suisse', 279, 0, 1),
(271, 'UBS Switzerland AG', 'BIT / Route des Mori', 'Case postale', '1211', 'Genève 22', 'Suisse', 279, 0, 1),
(272, 'UBS Switzerland AG', 'Cern / Route de Meyr', 'Case postale', '1211', 'Genève 2', 'Suisse', 279, 0, 1),
(273, 'UBS Switzerland AG', 'OMC / Rue de Lausann', 'Case postale', '1211', 'Genève 2', 'Suisse', 279, 0, 1),
(274, 'UBS Switzerland AG', 'OMS / Avenue Appia 2', 'Case postale', '1211', 'Genève 2', 'Suisse', 279, 0, 1),
(275, 'UBS Switzerland AG', 'UNO / Palais des Nat', 'Case postale', '1211', 'Genève 2', 'Suisse', 279, 0, 1),
(276, 'UBS Switzerland AG', 'Vermont-Nat./Ch.Loui', 'Case postale', '1211', 'Genève 2', 'Suisse', 279, 0, 1),
(277, 'UBS Switzerland AG', 'Rue de Genève 18', 'Case postale', '1211', 'Genève 2', 'Suisse', 279, 0, 1),
(278, 'UBS Switzerland AG', 'Plainpalais / Bv.du ', 'Case postale', '1211', 'Genève 2', 'Suisse', 279, 0, 1),
(279, 'UBS Switzerland AG', 'Schaffhauserstrasse ', 'Postfach', '8152', 'Glattbrugg', 'Suisse', 283, 0, 1),
(280, 'UBS Switzerland AG', 'Burgstrasse 1', 'Postfach', '8750', 'Glarus', 'Suisse', 284, 0, 1),
(281, 'UBS Switzerland AG', 'Altstetten / Badener', 'Postfach', '8048', 'Zürich', 'Suisse', 285, 0, 1),
(282, 'UBS Switzerland AG', 'UBS GCU Zürich AG', 'Postfach', '8098', 'Zürich', 'Suisse', 286, 0, 1),
(283, 'UBS Switzerland AG', 'Schwertstrasse 2', 'Postfach', '8201', 'Schaffhausen', 'Suisse', 287, 0, 1),
(284, 'UBS Switzerland AG', 'Neuhausen a.R. / Zen', 'Postfach', '8201', 'Schaffhausen', 'Suisse', 287, 0, 1),
(285, 'UBS Switzerland AG', 'Sonnenplatz', 'Postfach', '6021', 'Emmenbrücke 1', 'Suisse', 288, 0, 1),
(286, 'UBS Switzerland AG', 'Hauptstrasse 5', 'Postfach', '6281', 'Hochdorf', 'Suisse', 288, 0, 1),
(287, 'UBS Switzerland AG', 'Bahnhofstrasse 31', 'Postfach', '6210', 'Sursee', 'Suisse', 288, 0, 1),
(288, 'UBS Switzerland AG', 'Centralstrasse 2', 'Postfach', '6215', 'Beromünster', 'Suisse', 288, 0, 1),
(289, 'UBS Switzerland AG', 'Unterfeld 4 A', 'Postfach', '6102', 'Malters', 'Suisse', 288, 0, 1),
(290, 'UBS Switzerland AG', 'Bahnhofstrasse 20', 'Postfach', '6110', 'Wolhusen', 'Suisse', 288, 0, 1),
(291, 'UBS Switzerland AG', 'Place Pury 5', 'Case postale', '2001', 'Neuchâtel', 'Suisse', 290, 0, 1),
(292, 'UBS Switzerland AG', 'Avenue de la Gare 3', 'Case postale', '2114', 'Fleurier', 'Suisse', 290, 0, 1),
(293, 'UBS Switzerland AG', 'Place de la Fontaine', 'Case postale', '2034', 'Peseux', 'Suisse', 290, 0, 1),
(294, 'UBS Switzerland AG', 'Avenue du Collège 8', 'Case postale', '2017', 'Boudry', 'Suisse', 290, 0, 1),
(295, 'UBS Switzerland AG', 'Rue de la Gare 10', 'Case postale', '2525', 'Landeron, Le', 'Suisse', 290, 0, 1),
(296, 'UBS Switzerland AG', 'Frédéric Soguel 1', '', '2053', 'Cernier', 'Suisse', 290, 0, 1),
(297, 'UBS Switzerland AG', 'Zentrum', 'Postfach', '8105', 'Regensdorf 1', 'Suisse', 291, 0, 1),
(298, 'UBS Switzerland AG', 'Aeschenvorstadt 1', 'Postfach', '4002', 'Basel', 'Suisse', 292, 0, 1),
(299, 'UBS Switzerland AG', 'Bahnhofstrasse 47', 'Postfach', '8803', 'Rüschlikon', 'Suisse', 293, 0, 1),
(300, 'UBS Switzerland AG', 'Albisstrasse 6', 'Postfach', '8134', 'Adliswil 1', 'Suisse', 293, 0, 1),
(301, 'UBS Switzerland AG', 'Bahnhofplatz 14', 'Postfach', '3930', 'Visp/Viège', 'Suisse', 294, 0, 1),
(302, 'UBS Switzerland AG', 'Haus Metropol / Bahn', 'Postfach', '3940', 'Steg VS', 'Suisse', 294, 0, 1),
(303, 'UBS Switzerland AG', 'Dorfplatz', 'Postfach', '3925', 'Grächen', 'Suisse', 294, 0, 1),
(304, 'UBS Switzerland AG', 'Dorfstrasse 3', 'Postfach', '3954', 'Leukerbad', 'Suisse', 294, 0, 1),
(305, 'UBS Switzerland AG', 'Sustenstrasse 21', 'Postfach', '3952', 'Susten', 'Suisse', 294, 0, 1),
(306, 'UBS Switzerland AG', 'Bahnhofplatz 4', 'Postfach', '9430', 'St. Margrethen SG', 'Suisse', 295, 0, 1),
(307, 'UBS Switzerland AG', 'Bahnhofstrasse 156', 'Postfach', '8620', 'Wetzikon ZH 2', 'Suisse', 296, 0, 1),
(308, 'UBS Switzerland AG', 'Seestrasse 27', 'Postfach', '8330', 'Pfäffikon ZH', 'Suisse', 296, 0, 1),
(309, 'UBS Switzerland AG', 'Rue de Neuchâtel 1', 'Case postale', '1401', 'Yverdon-les-Bains', 'Suisse', 297, 0, 1),
(310, 'UBS Switzerland AG', 'Bahnhofstrasse 45', 'Corporate Center', '8098', 'Zürich', 'Suisse', 298, 0, 1),
(311, 'UBS AG', 'Bahnhofstrasse 45', 'Postfach', '8098', 'Zürich', 'Suisse', 315, 0, 1),
(312, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 20', 'Postfach 2503', '5001', 'Aarau', 'Suisse', 4003, 0, 1),
(313, 'Credit Suisse (Schweiz) AG', 'Zentralstrasse 42', 'Case postale', '2501', 'Biel/Bienne', 'Suisse', 4006, 0, 1),
(314, 'Credit Suisse (Schweiz) AG', 'Baslerstrasse 62', 'Postfach 1228', '4123', 'Allschwil 1', 'Suisse', 4017, 0, 1),
(315, 'Credit Suisse (Schweiz) AG', 'Tellsgasse 10', 'Postfach 293', '6460', 'Altdorf UR', 'Suisse', 4020, 0, 1),
(316, 'Credit Suisse (Schweiz) AG', 'Marktgasse 52', 'Postfach 163', '9450', 'Altstätten SG', 'Suisse', 4023, 0, 1),
(317, 'Credit Suisse (Schweiz) AG', 'Dorfplatz', 'Postfach 335', '7050', 'Arosa', 'Suisse', 4036, 0, 1),
(318, 'Credit Suisse (Schweiz) AG', 'Viale B. Papio 6', 'Casella postale', '6612', 'Ascona', 'Suisse', 4041, 0, 1),
(319, 'Credit Suisse (Schweiz) AG', 'Dorfstrasse 13', 'Postfach 68', '6341', 'Baar', 'Suisse', 4047, 0, 1),
(320, 'Credit Suisse (Schweiz) AG', 'Dorfplatz 14', 'Postfach 45', '7310', 'Bad Ragaz', 'Suisse', 4049, 0, 1),
(321, 'Credit Suisse (Schweiz) AG', 'Badstrasse 11', 'Postfach 1731', '5401', 'Baden', 'Suisse', 4050, 0, 1),
(322, 'Credit Suisse (Schweiz) AG', 'Piazza Indipendenza ', 'Casella postale 8', '6830', 'Chiasso', 'Suisse', 4055, 0, 1),
(323, 'Credit Suisse (Schweiz) AG', 'St. Alban-Graben 1-3', 'Postfach 2560', '4002', 'Basel', 'Suisse', 4060, 0, 1),
(324, 'Credit Suisse (Schweiz) AG', 'Claraplatz, Untere R', 'Postfach 84', '4005', 'Basel', 'Suisse', 4061, 0, 1),
(325, 'Credit Suisse (Schweiz) AG', 'Schiffsfinanzierunge', 'Postfach 4147', '4002', 'Basel', 'Suisse', 4073, 0, 1),
(326, 'Credit Suisse (Schweiz) AG', 'Spalenberg 65', 'Postfach 2164', '4001', 'Basel', 'Suisse', 4083, 0, 1),
(327, 'Credit Suisse (Schweiz) AG', 'Schaffhauserstrasse ', 'Postfach', '8302', 'Kloten', 'Suisse', 4088, 0, 1),
(328, 'Credit Suisse (Schweiz) AG', 'Viale Stazione 19', 'Casella postale 2025', '6501', 'Bellinzona', 'Suisse', 4090, 0, 1),
(329, 'Credit Suisse (Schweiz) AG', 'Bundesplatz 2', 'Postfach 5364', '3001', 'Bern', 'Suisse', 4094, 0, 1),
(330, 'Credit Suisse (Schweiz) AG', 'Bümpliz, Rehhagstras', 'Postfach 788', '3018', 'Bern', 'Suisse', 4097, 0, 1),
(331, 'Credit Suisse (Schweiz) AG', 'Postfach 2', '', '8070', 'Zürich', 'Suisse', 4106, 0, 1),
(332, 'Credit Suisse (Schweiz) AG', 'Viale Stazione 19', 'Casella postale 2025', '6501', 'Bellinzona', 'Suisse', 4108, 0, 1),
(333, 'Credit Suisse (Schweiz) AG', 'Zentralstrasse 42', 'Case postale 1165', '2501', 'Biel/Bienne', 'Suisse', 4112, 0, 1),
(334, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 49', 'Postfach 165', '4102', 'Binningen', 'Suisse', 4115, 0, 1),
(335, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 13', 'Postfach 480', '3900', 'Brig/Brigue', 'Suisse', 4132, 0, 1),
(336, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 48', 'Postfach 248', '9471', 'Buchs SG 1', 'Suisse', 4141, 0, 1),
(337, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 28', 'Postfach 156', '8180', 'Bülach', 'Suisse', 4144, 0, 1),
(338, 'Credit Suisse (Schweiz) AG', 'Place du Tilleul 9', 'Case postale 614', '1630', 'Bulle', 'Suisse', 4147, 0, 1),
(339, 'Credit Suisse (Schweiz) AG', 'Bahnhofplatz', 'Postfach 864', '3401', 'Burgdorf', 'Suisse', 4150, 0, 1),
(340, 'Credit Suisse (Schweiz) AG', 'Via G. Vagezzi 1', 'Casella postale', '6901', 'Lugano', 'Suisse', 4155, 0, 1),
(341, 'Credit Suisse (Schweiz) AG', 'Place du Marché 12', 'Case postale 100', '1227', 'Carouge GE', 'Suisse', 4156, 0, 1),
(342, 'Credit Suisse (Schweiz) AG', 'Avenue Léopold-Rober', 'Case postale 358', '2301', 'Chaux-de-Fonds, La', 'Suisse', 4163, 0, 1),
(343, 'Credit Suisse (Schweiz) AG', 'Piazza Indipendenza ', 'Casella postale 8', '6830', 'Chiasso 1', 'Suisse', 4172, 0, 1),
(344, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 12', 'Postfach 585', '7001', 'Chur', 'Suisse', 4175, 0, 1),
(345, 'Credit Suisse (Schweiz) AG', 'Piazza Indipendenza ', 'Casella postale', '6830', 'Chiasso', 'Suisse', 4177, 0, 1),
(346, 'Credit Suisse (Schweiz) AG', 'Immeuble Grand-Place', 'Case postale 136', '3963', 'Crans-sur-Sierre', 'Suisse', 4182, 0, 1),
(347, 'Credit Suisse (Schweiz) AG', 'Promenade 65', 'Postfach 150', '7270', 'Davos Platz 1', 'Suisse', 4187, 0, 1),
(348, 'Credit Suisse (Schweiz) AG', 'Promenade 65', 'Postfach 43', '7270', 'Davos Platz 1', 'Suisse', 4188, 0, 1),
(349, 'Credit Suisse (Schweiz) AG', 'Rue de la Maltière 2', 'Case postale 237', '2800', 'Delémont 1', 'Suisse', 4190, 0, 1),
(350, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 34', 'Postfach 151', '8304', 'Wallisellen', 'Suisse', 4192, 0, 1),
(351, 'Credit Suisse (Schweiz) AG', 'Kirchstrasse 20', 'Postfach 860', '8953', 'Dietikon 1', 'Suisse', 4193, 0, 1),
(352, 'Credit Suisse (Schweiz) AG', 'Zürichstrasse 8', 'Postfach 113', '8600', 'Dübendorf', 'Suisse', 4199, 0, 1),
(353, 'Credit Suisse (Schweiz) AG', 'Riedmattstrasse 12', 'Postfach 361', '6031', 'Ebikon', 'Suisse', 4204, 0, 1),
(354, 'Credit Suisse (Schweiz) AG', 'Friedbergstrasse 9', 'Postfach 350', '8820', 'Wädenswil', 'Suisse', 4209, 0, 1),
(355, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 28', 'Postfach', '8180', 'Bülach', 'Suisse', 4210, 0, 1),
(356, 'Credit Suisse (Schweiz) AG', 'Gerliswilstrasse 71', 'Postfach 1242', '6021', 'Emmenbrücke 1', 'Suisse', 4213, 0, 1),
(357, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 2', 'Postfach 971', '6371', 'Stans', 'Suisse', 4216, 0, 1),
(358, 'Credit Suisse (Schweiz) AG', 'Via Gronda', 'Postfach 156', '7017', 'Flims Dorf', 'Suisse', 4226, 0, 1),
(359, 'Credit Suisse (Schweiz) AG', 'Bankplatz 3', 'Postfach 931', '8501', 'Frauenfeld', 'Suisse', 4230, 0, 1),
(360, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 13', 'Case postale', '1701', 'Fribourg', 'Suisse', 4235, 0, 1),
(361, 'Credit Suisse (Schweiz) AG', 'Allmendmarkt', 'Postfach 360', '4460', 'Gelterkinden', 'Suisse', 4243, 0, 1),
(362, 'Credit Suisse (Schweiz) AG', 'Place Bel-Air 2', 'Case postale 100', '1211', 'Genève 70', 'Suisse', 4251, 0, 1),
(363, 'Credit Suisse (Schweiz) AG', 'Praille, Route des A', 'Case postale 100', '1211', 'Genève', 'Suisse', 4254, 0, 1),
(364, 'Credit Suisse (Schweiz) AG', 'Balexert, Avenue Lou', 'Case postale 100', '1211', 'Genève', 'Suisse', 4266, 0, 1),
(365, 'Credit Suisse (Schweiz) AG', 'Cornavin, Rue de Lau', 'Case postale 1332', '1211', 'Genève', 'Suisse', 4267, 0, 1),
(366, 'Credit Suisse (Schweiz) AG', 'Champel, Avenue de C', 'Case postale 100', '1211', 'Genève', 'Suisse', 4271, 0, 1),
(367, 'Credit Suisse (Schweiz) AG', 'Cornavin, Rue de Lau', 'Case postale 100', '1211', 'Genève', 'Suisse', 4272, 0, 1),
(368, 'Credit Suisse (Schweiz) AG', 'Eaux-Vives, Rue Vers', 'Case postale 100', '1211', 'Genève', 'Suisse', 4274, 0, 1),
(369, 'Credit Suisse (Schweiz) AG', 'Cointrin, Avenue Lou', 'Case postale 100', '1211', 'Genève', 'Suisse', 4278, 0, 1),
(370, 'Credit Suisse (Schweiz) AG', 'Balexert, Avenue Lou', 'Case postale 535', '1211', 'Genève', 'Suisse', 4279, 0, 1),
(371, 'Credit Suisse (Schweiz) AG', 'Cornavin, Rue de Lau', 'Case postale 1384', '1211', 'Genève', 'Suisse', 4280, 0, 1),
(372, 'Credit Suisse (Schweiz) AG', 'Petit-Lancy, Route d', 'Case postale 100', '1211', 'Genève', 'Suisse', 4281, 0, 1),
(373, 'Credit Suisse (Schweiz) AG', 'Viale Stazione 19', 'Casella postale 2025', '6501', 'Bellinzona', 'Suisse', 4322, 0, 1),
(374, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 22', 'Postfach 466', '8750', 'Glarus', 'Suisse', 4323, 0, 1),
(375, 'Credit Suisse (Schweiz) AG', 'Am Marktplatz', 'Postfach 127', '2540', 'Grenchen', 'Suisse', 4334, 0, 1),
(376, 'Credit Suisse (Schweiz) AG', 'Höheweg 3', 'Postfach', '3800', 'Interlaken', 'Suisse', 4337, 0, 1),
(377, 'Credit Suisse (Schweiz) AG', 'Promenade', 'Postfach 315', '3780', 'Gstaad', 'Suisse', 4339, 0, 1),
(378, 'Credit Suisse (Schweiz) AG', 'Marktgasse 29', 'Postfach', '4902', 'Langenthal', 'Suisse', 4343, 0, 1),
(379, 'Credit Suisse (Schweiz) AG', 'Gerliswilstrasse 71', 'Postfach 47', '6021', 'Emmenbrücke 1', 'Suisse', 4353, 0, 1),
(380, 'Credit Suisse (Schweiz) AG', 'Alte Landstrasse 24', 'Postfach 176', '8810', 'Horgen', 'Suisse', 4355, 0, 1),
(381, 'Credit Suisse (Schweiz) AG', 'Kantonsstrasse 40', 'Postfach 379', '6048', 'Horw', 'Suisse', 4358, 0, 1),
(382, 'Credit Suisse (Schweiz) AG', 'Via Gronda', 'Postfach 156', '7017', 'Flims Dorf', 'Suisse', 4363, 0, 1),
(383, 'Credit Suisse (Schweiz) AG', 'Höheweg 3', 'Postfach 193', '3800', 'Interlaken', 'Suisse', 4367, 0, 1),
(384, 'Credit Suisse (Schweiz) AG', 'Untere Bahnhofstrass', 'Postfach 1174', '8640', 'Rapperswil SG', 'Suisse', 4373, 0, 1),
(385, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 13', 'Postfach 91', '7250', 'Klosters', 'Suisse', 4381, 0, 1),
(386, 'Credit Suisse (Schweiz) AG', 'Flughafen', 'Postfach 1482', '8058', 'Zürich', 'Suisse', 4383, 0, 1),
(387, 'Credit Suisse (Schweiz) AG', 'Schaffhauserstrasse ', 'Postfach 875', '8302', 'Kloten', 'Suisse', 4384, 0, 1),
(388, 'Credit Suisse (Schweiz) AG', 'Bundesplatz 2', 'Postfach', '3001', 'Bern', 'Suisse', 4396, 0, 1),
(389, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 33', 'Postfach 1270', '8280', 'Kreuzlingen 1', 'Suisse', 4400, 0, 1),
(390, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 4', 'Postfach 1519', '8700', 'Küsnacht ZH', 'Suisse', 4405, 0, 1),
(391, 'Credit Suisse (Schweiz) AG', 'Schützenstrasse 7', 'Postfach 383', '8853', 'Lachen SZ', 'Suisse', 4412, 0, 1),
(392, 'Credit Suisse (Schweiz) AG', 'Via Vedeggio', 'Casella postale 134', '6814', 'Lamone', 'Suisse', 4413, 0, 1),
(393, 'Credit Suisse (Schweiz) AG', 'Marktgasse 29', 'Postfach 496', '4902', 'Langenthal', 'Suisse', 4419, 0, 1),
(394, 'Credit Suisse (Schweiz) AG', 'Rue du Grand Pont 6', 'Case postale 2493', '1002', 'Lausanne', 'Suisse', 4424, 0, 1),
(395, 'Credit Suisse (Schweiz) AG', 'Rue du Lion d&apos;O', 'Case postale 2493', '1002', 'Lausanne', 'Suisse', 4425, 0, 1),
(396, 'Credit Suisse (Schweiz) AG', 'Rue du Lion d&apos;O', 'Case postale 2493', '1002', 'Lausanne', 'Suisse', 4427, 0, 1),
(397, 'Credit Suisse (Schweiz) AG', 'Rue du Lion d&apos;O', 'Case postale 2493', '1002', 'Lausanne', 'Suisse', 4428, 0, 1),
(398, 'Credit Suisse (Schweiz) AG', 'Rue du Lion d&apos;O', 'Case postale 2493', '1002', 'Lausanne', 'Suisse', 4429, 0, 1),
(399, 'Neue Aargauer Bank AG', 'Bahnhofplatz 1', 'Postfach 560', '5600', 'Lenzburg', 'Suisse', 4441, 0, 1),
(400, 'Credit Suisse (Schweiz) AG', 'Rheinstrasse 8', 'Postfach 618', '4410', 'Liestal', 'Suisse', 4446, 0, 1),
(401, 'Credit Suisse (Schweiz) AG', 'Via A. Ciseri 10', 'Casella postale 5600', '6601', 'Locarno', 'Suisse', 4451, 0, 1),
(402, 'Credit Suisse (Schweiz) AG', 'Via Canova 15', 'Casella postale 2836', '6901', 'Lugano', 'Suisse', 4455, 0, 1),
(403, 'Credit Suisse (Schweiz) AG', 'Via Canova 15', 'Casella postale 2836', '6901', 'Lugano', 'Suisse', 4456, 0, 1),
(404, 'Credit Suisse (Schweiz) AG', 'Via Canova 15', 'Casella postale 2836', '6901', 'Lugano', 'Suisse', 4457, 0, 1),
(405, 'Credit Suisse (Schweiz) AG', 'Via Canova 15', 'Casella postale', '6901', 'Lugano', 'Suisse', 4458, 0, 1),
(406, 'Credit Suisse (Schweiz) AG', 'Casella postale', '', '6901', 'Lugano', 'Suisse', 4459, 0, 1),
(407, 'Credit Suisse (Schweiz) AG', 'Schwanenplatz 8', 'Postfach 4569', '6002', 'Luzern', 'Suisse', 4463, 0, 1),
(408, 'Credit Suisse (Schweiz) AG', 'Schwanenplatz 8', 'Postfach 4569', '6002', 'Luzern', 'Suisse', 4465, 0, 1),
(409, 'Credit Suisse (Schweiz) AG', 'Schwanenplatz 8', 'Postfach 4569', '6002', 'Luzern', 'Suisse', 4467, 0, 1),
(410, 'Credit Suisse (Schweiz) AG', 'Via Canova 15', 'Casella postale 2836', '6901', 'Lugano', 'Suisse', 4469, 0, 1),
(411, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 21', 'Case postale 192', '1920', 'Martigny 1', 'Suisse', 4480, 0, 1),
(412, 'Credit Suisse (Schweiz) AG', 'Dorfstrasse 93', 'Postfach 827', '8706', 'Meilen', 'Suisse', 4486, 0, 1),
(413, 'Credit Suisse (Schweiz) AG', 'Höheweg 3', 'Postfach 193', '3800', 'Interlaken', 'Suisse', 4488, 0, 1),
(414, 'Credit Suisse (Schweiz) AG', 'Via Lavizzari 21', 'Casella postale 137', '6850', 'Mendrisio', 'Suisse', 4490, 0, 1),
(415, 'Credit Suisse (Schweiz) AG', 'Centro Commerciale B', 'Casella postale 1172', '6648', 'Minusio', 'Suisse', 4497, 0, 1),
(416, 'Credit Suisse (Schweiz) AG', 'Olten-A', 'Postfach', '4601', 'Olten', 'Suisse', 4499, 0, 1),
(417, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 8', 'Case postale 1476', '1870', 'Monthey 2', 'Suisse', 4500, 0, 1),
(418, 'Credit Suisse (Schweiz) AG', 'Place de la Paix 1', 'Case postale 176', '1820', 'Montreux 1', 'Suisse', 4503, 0, 1),
(419, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 52', 'Case postale 477', '1110', 'Morges 1', 'Suisse', 4507, 0, 1),
(420, 'Credit Suisse (Schweiz) AG', 'Thunstrasse 70', 'Postfach 424', '3074', 'Muri b. Bern', 'Suisse', 4520, 0, 1),
(421, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 82', 'Postfach 512', '4132', 'Muttenz 1', 'Suisse', 4528, 0, 1),
(422, 'Credit Suisse (Schweiz) AG', 'Place Pury 4', 'Case postale 556', '2001', 'Neuchâtel', 'Suisse', 4531, 0, 1),
(423, 'Credit Suisse (Schweiz) AG', 'Rue de la Gare 45', 'Case postale 279', '1260', 'Nyon 1', 'Suisse', 4541, 0, 1),
(424, 'Credit Suisse (Schweiz) AG', 'Froburgstrasse 1', 'Postfach 410', '4601', 'Olten', 'Suisse', 4556, 0, 1),
(425, 'Credit Suisse (Schweiz) AG', 'Bernstrasse 34', 'Postfach', '3072', 'Ostermundigen', 'Suisse', 4565, 0, 1),
(426, 'Credit Suisse (Schweiz) AG', 'Schindellegistrasse ', 'Postfach 59', '8808', 'Pfäffikon SZ', 'Suisse', 4570, 0, 1),
(427, 'Credit Suisse (Schweiz) AG', 'Via Lugano', 'Casella postale 168', '6988', 'Ponte Tresa', 'Suisse', 4573, 0, 1),
(428, 'Credit Suisse (Schweiz) AG', 'Villa Bellavita', 'Postfach 120', '7504', 'Pontresina', 'Suisse', 4574, 0, 1),
(429, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 11', 'Postfach 1255', '4133', 'Pratteln 1', 'Suisse', 4580, 0, 1),
(430, 'Credit Suisse (Schweiz) AG', 'Rue de la Maltière 2', 'Case postale 237', '2800', 'Delémont 1', 'Suisse', 4585, 0, 1),
(431, 'Credit Suisse (Schweiz) AG', 'Place de la Gare 1', 'Case postale 128', '1009', 'Pully', 'Suisse', 4589, 0, 1),
(432, 'Credit Suisse (Schweiz) AG', 'Untere Bahnhofstrass', 'Postfach 1174', '8640', 'Rapperswil SG', 'Suisse', 4595, 0, 1),
(433, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 36', 'Postfach 364', '4153', 'Reinach BL', 'Suisse', 4596, 0, 1),
(434, 'Credit Suisse (Schweiz) AG', 'Watterstrasse 100', 'Postfach 410', '8105', 'Regensdorf 1', 'Suisse', 4598, 0, 1),
(435, 'Credit Suisse (Schweiz) AG', 'Avenue de la Poste 1', 'Case postale 541', '1020', 'Renens VD 1', 'Suisse', 4605, 0, 1),
(436, 'Credit Suisse (Schweiz) AG', 'Kaiserstrasse 4', 'Postfach 661', '4310', 'Rheinfelden 1', 'Suisse', 4607, 0, 1),
(437, 'Credit Suisse (Schweiz) AG', 'Baselstrasse 20', 'Postfach 396', '4125', 'Riehen 1', 'Suisse', 4614, 0, 1),
(438, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 3', 'Postfach 90', '8590', 'Romanshorn 1', 'Suisse', 4616, 0, 1),
(439, 'Credit Suisse (Schweiz) AG', 'Piazzetta', 'Casella postale 141', '6535', 'Roveredo GR', 'Suisse', 4625, 0, 1),
(440, 'Credit Suisse (Schweiz) AG', 'Place Pury 4', 'Case postale 556', '2001', 'Neuchâtel', 'Suisse', 4631, 0, 1),
(441, 'Credit Suisse (Schweiz) AG', 'St. Leonhardstrasse ', 'Postfach 563', '9001', 'St. Gallen', 'Suisse', 4637, 0, 1),
(442, 'Credit Suisse (Schweiz) AG', 'St. Leonhardstrasse ', 'Postfach 563', '9001', 'St. Gallen', 'Suisse', 4642, 0, 1),
(443, 'Credit Suisse (Schweiz) AG', 'Grenzstrasse 11', 'Postfach 174', '9430', 'St. Margrethen SG', 'Suisse', 4644, 0, 1),
(444, 'Credit Suisse (Schweiz) AG', 'Via Maistra 5', 'Postfach 4500', '7500', 'St. Moritz 1', 'Suisse', 4647, 0, 1),
(445, 'Credit Suisse (Schweiz) AG', 'Via Maistra 5', 'Postfach', '7500', 'St. Moritz 1', 'Suisse', 4648, 0, 1),
(446, 'Credit Suisse (Schweiz) AG', 'Plazzet 3', 'Postfach 48', '7503', 'Samedan', 'Suisse', 4654, 0, 1),
(447, 'Credit Suisse (Schweiz) AG', 'Chasa Riva', 'Postfach 122', '7563', 'Samnaun Dorf', 'Suisse', 4655, 0, 1),
(448, 'Credit Suisse (Schweiz) AG', 'Poststrasse 5', 'Postfach 1459', '6061', 'Sarnen 1', 'Suisse', 4656, 0, 1),
(449, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 21', 'Case postale 192', '1920', 'Martigny 1', 'Suisse', 4658, 0, 1),
(450, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 22 - ', 'Postfach 1336', '8201', 'Schaffhausen', 'Suisse', 4659, 0, 1),
(451, 'Credit Suisse (Schweiz) AG', 'Postfach 2', '', '8070', 'Zürich', 'Suisse', 4660, 0, 1),
(452, 'Credit Suisse (Schweiz) AG', 'Kirchstrasse 20', 'Postfach 860', '8953', 'Dietikon 1', 'Suisse', 4663, 0, 1),
(453, 'Credit Suisse (Schweiz) AG', 'Oltnerstrasse 7', 'Postfach 73', '5012', 'Schönenwerd', 'Suisse', 4665, 0, 1),
(454, 'Credit Suisse (Schweiz) AG', 'Center Augustin', 'Postfach 164', '7550', 'Scuol', 'Suisse', 4667, 0, 1),
(455, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 36', 'Postfach 221', '8603', 'Schwerzenbach', 'Suisse', 4671, 0, 1),
(456, 'Credit Suisse (Schweiz) AG', 'Postplatz 11', 'Postfach 363', '6431', 'Schwyz', 'Suisse', 4674, 0, 1),
(457, 'Credit Suisse (Schweiz) AG', 'Avenue Général-Guisa', 'Postfach 312', '3960', 'Sierre/Siders', 'Suisse', 4678, 0, 1),
(458, 'Credit Suisse (Schweiz) AG', 'Avenue du Midi 12', 'Case postale 349', '1951', 'Sion/Sitten', 'Suisse', 4680, 0, 1),
(459, 'Credit Suisse (Schweiz) AG', 'Wengistrasse 2', 'Postfach 1047', '4502', 'Solothurn', 'Suisse', 4685, 0, 1),
(460, 'Neue Aargauer Bank AG', 'Shopping Center', 'Postfach 342', '8957', 'Spreitenbach', 'Suisse', 4691, 0, 1),
(461, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 26', 'Postfach 226', '8712', 'Stäfa', 'Suisse', 4694, 0, 1),
(462, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 2', 'Postfach 971', '6371', 'Stans', 'Suisse', 4697, 0, 1),
(463, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 18', 'Postfach 485', '6210', 'Sursee', 'Suisse', 4706, 0, 1),
(464, 'Credit Suisse (Schweiz) AG', 'Piazza G. Canevascin', 'Casella postale 284', '6598', 'Tenero', 'Suisse', 4712, 0, 1),
(465, 'Credit Suisse (Schweiz) AG', 'Gotthardstrasse 21', 'Postfach 1082', '8801', 'Thalwil', 'Suisse', 4716, 0, 1),
(466, 'Credit Suisse (Schweiz) AG', 'Thônex, Rue de Genèv', 'Case postale 100', '1211', 'Genève 70', 'Suisse', 4720, 0, 1),
(467, 'Credit Suisse (Schweiz) AG', 'Bälliz 36', 'Postfach 1341', '3601', 'Thun', 'Suisse', 4721, 0, 1),
(468, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 36', 'Postfach 221', '8603', 'Schwerzenbach', 'Suisse', 4737, 0, 1),
(469, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 76', 'Postfach 247', '9240', 'Uzwil', 'Suisse', 4741, 0, 1);
INSERT INTO `faturacao_bancos_fornecedores` (`ID_BancoFornecedor`, `Nome`, `Address1`, `Address2`, `NPA`, `Localite`, `PaisBanco`, `BCNbr`, `Predefinido`, `Ativo`) VALUES
(470, 'Credit Suisse (Schweiz) AG', 'Haus Alpina', 'Case postale 98', '1936', 'Verbier 1', 'Suisse', 4744, 0, 1),
(471, 'Credit Suisse (Schweiz) AG', 'Rue des Moulins 23', 'Case postale 636', '1290', 'Versoix', 'Suisse', 4747, 0, 1),
(472, 'Credit Suisse (Schweiz) AG', 'Chemin du Vieux-Vése', 'Case postale 114', '1222', 'Vésenaz', 'Suisse', 4748, 0, 1),
(473, 'Credit Suisse (Schweiz) AG', 'Rue du  Simplon 50', 'Case postale 210', '1800', 'Vevey 1', 'Suisse', 4750, 0, 1),
(474, 'Credit Suisse (Schweiz) AG', 'Bahnhofplatz 4', 'Postfach 280', '3930', 'Visp/Viège', 'Suisse', 4758, 0, 1),
(475, 'Credit Suisse (Schweiz) AG', 'Bundesplatz 2', 'Postfach', '3001', 'Bern', 'Suisse', 4763, 0, 1),
(476, 'Credit Suisse (Schweiz) AG', 'Friedbergstrasse 9', 'Postfach 350', '8820', 'Wädenswil', 'Suisse', 4765, 0, 1),
(477, 'Credit Suisse (Schweiz) AG', 'Corporate Center', 'Postfach', '8070', 'Zürich', 'Suisse', 4770, 0, 1),
(478, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 34', 'Postfach 151', '8304', 'Wallisellen', 'Suisse', 4772, 0, 1),
(479, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 1', 'Postfach 333', '8570', 'Weinfelden', 'Suisse', 4777, 0, 1),
(480, 'Neue Aargauer Bank AG', 'Landstrasse 81', 'Postfach 3224', '5430', 'Wettingen', 'Suisse', 4781, 0, 1),
(481, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 58', 'Postfach 1267', '8620', 'Wetzikon ZH 1', 'Suisse', 4784, 0, 1),
(482, 'Credit Suisse (Schweiz) AG', 'Obere Bahnhofstrasse', 'Postfach 237', '9500', 'Wil SG', 'Suisse', 4787, 0, 1),
(483, 'Credit Suisse (Schweiz) AG', 'Stadthausstrasse 16', 'Postfach 330', '8401', 'Winterthur', 'Suisse', 4791, 0, 1),
(484, 'Credit Suisse (Schweiz) AG', 'Stadthausstrasse 16', 'Postfach 330', '8401', 'Winterthur', 'Suisse', 4795, 0, 1),
(485, 'Credit Suisse (Schweiz) AG', 'Bahnhof, Bahnhofplat', 'Postfach 330', '8401', 'Winterthur', 'Suisse', 4796, 0, 1),
(486, 'Credit Suisse (Schweiz) AG', 'Rue des Remparts 16', 'Case postale 159', '1401', 'Yverdon-les-Bains', 'Suisse', 4806, 0, 1),
(487, 'Credit Suisse (Schweiz) AG', 'Bahnhofplatz', 'Postfach 70', '3920', 'Zermatt', 'Suisse', 4811, 0, 1),
(488, 'Credit Suisse (Schweiz) AG', 'Untere Grabenstrasse', 'Postfach', '4800', 'Zofingen', 'Suisse', 4814, 0, 1),
(489, 'Credit Suisse (Schweiz) AG', 'Alte Landstrasse 91', 'Postfach 214', '8702', 'Zollikon', 'Suisse', 4818, 0, 1),
(490, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 17', 'Postfach 357', '6301', 'Zug', 'Suisse', 4823, 0, 1),
(491, 'Credit Suisse (Schweiz) AG', 'Paradeplatz 8', 'Postfach 100', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(492, 'Credit Suisse (Schweiz) AG', 'Affoltern, In Böden ', 'Postfach 400', '8046', 'Zürich', 'Suisse', 4835, 0, 1),
(493, 'Credit Suisse (Schweiz) AG', 'Allmendmarkt', 'Postfach 360', '4460', 'Gelterkinden', 'Suisse', 4835, 0, 1),
(494, 'Credit Suisse (Schweiz) AG', 'Alte Landstrasse 24', 'Postfach 176', '8810', 'Horgen', 'Suisse', 4835, 0, 1),
(495, 'Credit Suisse (Schweiz) AG', 'Alte Landstrasse 91', 'Postfach 214', '8702', 'Zollikon', 'Suisse', 4835, 0, 1),
(496, 'Credit Suisse (Schweiz) AG', 'Altstetten, Badeners', 'Postfach 4837', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(497, 'Credit Suisse (Schweiz) AG', 'Am Marktplatz', 'Postfach 127', '2540', 'Grenchen 1', 'Suisse', 4835, 0, 1),
(498, 'Credit Suisse (Schweiz) AG', 'Am Platz', 'Postfach 45', '7310', 'Bad Ragaz', 'Suisse', 4835, 0, 1),
(499, 'Credit Suisse (Schweiz) AG', 'Aussersihl, Badeners', 'Postfach 4557', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(500, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 13', 'Case postale 368', '1701', 'Fribourg', 'Suisse', 4835, 0, 1),
(501, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 21', 'Case postale 192', '1920', 'Martigny 1', 'Suisse', 4835, 0, 1),
(502, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 8', 'Case postale 1476', '1870', 'Monthey 2', 'Suisse', 4835, 0, 1),
(503, 'Credit Suisse (Schweiz) AG', 'Avenue de la Poste 1', 'Case postale 541', '1020', 'Renens VD', 'Suisse', 4835, 0, 1),
(504, 'Credit Suisse (Schweiz) AG', 'Avenue du Midi 12', 'Case postale 349', '1951', 'Sion/Sitten', 'Suisse', 4835, 0, 1),
(505, 'Credit Suisse (Schweiz) AG', 'Avenue Général-Guisa', 'Postfach 312', '3960', 'Sierre/Siders', 'Suisse', 4835, 0, 1),
(506, 'Credit Suisse (Schweiz) AG', 'Avenue Léopold-Rober', 'Case postale 368', '2301', 'Chaux-de-Fonds, La', 'Suisse', 4835, 0, 1),
(507, 'Credit Suisse (Schweiz) AG', 'Badstrasse 11', 'Postfach 1731', '5401', 'Baden', 'Suisse', 4835, 0, 1),
(508, 'Credit Suisse (Schweiz) AG', 'Bahnhof, Bahnhofplat', 'Postfach 637', '8401', 'Winterthur', 'Suisse', 4835, 0, 1),
(509, 'Credit Suisse (Schweiz) AG', 'Bahnhofplatz', 'Postfach 70', '3920', 'Zermatt', 'Suisse', 4835, 0, 1),
(510, 'Credit Suisse (Schweiz) AG', 'Bahnhofplatz 1', 'Postfach 624', '8134', 'Adliswil', 'Suisse', 4835, 0, 1),
(511, 'Credit Suisse (Schweiz) AG', 'Bahnhofplatz 10', 'Postfach 125', '3930', 'Visp/Viège', 'Suisse', 4835, 0, 1),
(512, 'Credit Suisse (Schweiz) AG', 'Bahnhofplatz 84', 'Postfach 1120', '3401', 'Burgdorf', 'Suisse', 4835, 0, 1),
(513, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 11', 'Postfach 1255', '4133', 'Pratteln 1', 'Suisse', 4835, 0, 1),
(514, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 12', 'Postfach 109', '3250', 'Lyss', 'Suisse', 4835, 0, 1),
(515, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 12', 'Postfach 585', '7001', 'Chur', 'Suisse', 4835, 0, 1),
(516, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 13', 'Postfach 480', '3900', 'Brig/Brigue', 'Suisse', 4835, 0, 1),
(517, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 13', 'Postfach 91', '7250', 'Klosters', 'Suisse', 4835, 0, 1),
(518, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 17', 'Postfach 357', '6301', 'Zug', 'Suisse', 4835, 0, 1),
(519, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 18', 'Postfach 485', '6210', 'Sursee', 'Suisse', 4835, 0, 1),
(520, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 2', 'Postfach 971', '6371', 'Stans', 'Suisse', 4835, 0, 1),
(521, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 20', 'Postfach 2503', '5001', 'Aarau', 'Suisse', 4835, 0, 1),
(522, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 22 - ', 'Postfach 1385', '8201', 'Schaffhausen', 'Suisse', 4835, 0, 1),
(523, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 26', 'Postfach 226', '8712', 'Stäfa', 'Suisse', 4835, 0, 1),
(524, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 28', 'Postfach 601', '3076', 'Worb', 'Suisse', 4835, 0, 1),
(525, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 28', 'Postfach 748', '8180', 'Bülach', 'Suisse', 4835, 0, 1),
(526, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 3', 'Postfach 90', '8590', 'Romanshorn 1', 'Suisse', 4835, 0, 1),
(527, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 34', 'Postfach 151', '8304', 'Wallisellen', 'Suisse', 4835, 0, 1),
(528, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 35', 'Postfach 577', '6403', 'Küssnacht am Rigi', 'Suisse', 4835, 0, 1),
(529, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 36', 'Postfach 221', '8603', 'Schwerzenbach', 'Suisse', 4835, 0, 1),
(530, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 4', 'Postfach 1519', '8700', 'Küsnacht ZH', 'Suisse', 4835, 0, 1),
(531, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 48', 'Postfach 248', '9471', 'Buchs SG 1', 'Suisse', 4835, 0, 1),
(532, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 58', 'Postfach 1267', '8620', 'Wetzikon ZH 1', 'Suisse', 4835, 0, 1),
(533, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 76', 'Postfach 247', '9240', 'Uzwil', 'Suisse', 4835, 0, 1),
(534, 'Credit Suisse (Schweiz) AG', 'Balexert, Avenue Lou', 'Case postale 100', '1211', 'Genève', 'Suisse', 4835, 0, 1),
(535, 'Credit Suisse (Schweiz) AG', 'Bälliz 36', 'Postfach 1374', '3601', 'Thun', 'Suisse', 4835, 0, 1),
(536, 'Credit Suisse (Schweiz) AG', 'Bankplatz 3', 'Postfach 931', '8501', 'Frauenfeld', 'Suisse', 4835, 0, 1),
(537, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 1', 'Postfach 90', '8570', 'Weinfelden', 'Suisse', 4835, 0, 1),
(538, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 22', 'Postfach 466', '8750', 'Glarus', 'Suisse', 4835, 0, 1),
(539, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 5', 'Postfach 450', '8610', 'Uster 1', 'Suisse', 4835, 0, 1),
(540, 'Credit Suisse (Schweiz) AG', 'Baselstrasse 12', 'Postfach 644', '4242', 'Laufen', 'Suisse', 4835, 0, 1),
(541, 'Credit Suisse (Schweiz) AG', 'Baselstrasse 20', 'Postfach 396', '4125', 'Riehen 1', 'Suisse', 4835, 0, 1),
(542, 'Credit Suisse (Schweiz) AG', 'Baslerstrasse 62', 'Postfach 1228', '4123', 'Allschwil 1', 'Suisse', 4835, 0, 1),
(543, 'Credit Suisse (Schweiz) AG', 'Baslerstrasse 68', 'Postfach 410', '4632', 'Trimbach', 'Suisse', 4835, 0, 1),
(544, 'Credit Suisse (Schweiz) AG', 'Bernstrasse 34', 'Postfach 1647', '3072', 'Ostermundigen 1', 'Suisse', 4835, 0, 1),
(545, 'Credit Suisse (Schweiz) AG', 'Bümpliz, Rehhagstras', 'Postfach 788', '3018', 'Bern', 'Suisse', 4835, 0, 1),
(546, 'Credit Suisse (Schweiz) AG', 'Bundesplatz 2', 'Postfach 5364', '3001', 'Bern', 'Suisse', 4835, 0, 1),
(547, 'Credit Suisse (Schweiz) AG', 'Card-Service', 'Postfach 227', '8810', 'Horgen', 'Suisse', 4835, 0, 1),
(548, 'Credit Suisse (Schweiz) AG', 'Carouge, Place du Ma', '', '1211', 'Genève 70', 'Suisse', 4835, 0, 1),
(549, 'Credit Suisse (Schweiz) AG', 'Casa Comunale', 'Casella postale 86', '6574', 'Vira Gambarogno', 'Suisse', 4835, 0, 1),
(550, 'Credit Suisse (Schweiz) AG', 'Centro Commerciale B', 'Casella postale 1172', '6648', 'Minusio', 'Suisse', 4835, 0, 1),
(551, 'Credit Suisse (Schweiz) AG', 'Champel, Avenue de C', 'Case postale 100', '1211', 'Genève', 'Suisse', 4835, 0, 1),
(552, 'Credit Suisse (Schweiz) AG', 'Chasa Riva', 'Postfach 122', '7563', 'Samnaun Dorf', 'Suisse', 4835, 0, 1),
(553, 'Credit Suisse (Schweiz) AG', 'Chemin du Vieux-Vése', '', '1222', 'Vésenaz', 'Suisse', 4835, 0, 1),
(554, 'Credit Suisse (Schweiz) AG', 'Christoffelgasse 6', 'Postfach 5372', '3011', 'Bern', 'Suisse', 4835, 0, 1),
(555, 'Credit Suisse (Schweiz) AG', 'Claraplatz, Untere R', 'Postfach', '4005', 'Basel', 'Suisse', 4835, 0, 1),
(556, 'Credit Suisse (Schweiz) AG', 'Cornavin, Rue de Lau', 'Case postale 100', '1211', 'Genève', 'Suisse', 4835, 0, 1),
(557, 'Credit Suisse (Schweiz) AG', 'Dorfstrasse 13', 'Postfach 329', '6341', 'Baar', 'Suisse', 4835, 0, 1),
(558, 'Credit Suisse (Schweiz) AG', 'Dorfstrasse 93', 'Postfach 827', '8706', 'Meilen', 'Suisse', 4835, 0, 1),
(559, 'Credit Suisse (Schweiz) AG', 'Eaux-Vives, Rue Vers', 'Case postale 100', '1211', 'Genève', 'Suisse', 4835, 0, 1),
(560, 'Credit Suisse (Schweiz) AG', 'Enge, Bleicherweg 33', 'Postfach 4842', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(561, 'Credit Suisse (Schweiz) AG', 'Flughafen', 'Postfach 2227', '8058', 'Zürich', 'Suisse', 4835, 0, 1),
(562, 'Credit Suisse (Schweiz) AG', 'Friedbergstrasse 9', 'Postfach 350', '8820', 'Wädenswil', 'Suisse', 4835, 0, 1),
(563, 'Credit Suisse (Schweiz) AG', 'Frohburgstrasse 1', 'Postfach 551', '4601', 'Olten', 'Suisse', 4835, 0, 1),
(564, 'Credit Suisse (Schweiz) AG', 'Genève-Carouge, Plac', '', '1227', 'Carouge GE', 'Suisse', 4835, 0, 1),
(565, 'Credit Suisse (Schweiz) AG', 'GE La Praille, Route', '', '1227', 'Carouge GE', 'Suisse', 4835, 0, 1),
(566, 'Credit Suisse (Schweiz) AG', 'Gerliswilstrasse 71', 'Postfach 1242', '6021', 'Emmenbrücke 1', 'Suisse', 4835, 0, 1),
(567, 'Credit Suisse (Schweiz) AG', 'Gotthardstrasse 21', 'Postfach 1082', '8800', 'Thalwil', 'Suisse', 4835, 0, 1),
(568, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 129', 'Case postale 71', '2720', 'Tramelan', 'Suisse', 4835, 0, 1),
(569, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 28', 'Case postale 256', '1680', 'Romont FR', 'Suisse', 4835, 0, 1),
(570, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 39', 'Case postale 363', '1618', 'Châtel-St-Denis', 'Suisse', 4835, 0, 1),
(571, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 52', 'Case postale 224', '1110', 'Morges 1', 'Suisse', 4835, 0, 1),
(572, 'Credit Suisse (Schweiz) AG', 'Grenzstrasse 11', 'Postfach 174', '9430', 'St. Margrethen SG', 'Suisse', 4835, 0, 1),
(573, 'Credit Suisse (Schweiz) AG', 'Gundeldingen, Güters', 'Postfach 228', '4018', 'Basel', 'Suisse', 4835, 0, 1),
(574, 'Credit Suisse (Schweiz) AG', 'Hauptgasse 13', 'Postfach 43', '3280', 'Murten/Morat', 'Suisse', 4835, 0, 1),
(575, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 16', 'Postfach 201', '3186', 'Düdingen', 'Suisse', 4835, 0, 1),
(576, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 33', 'Postfach 1270', '8280', 'Kreuzlingen 1', 'Suisse', 4835, 0, 1),
(577, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 36', '', '4153', 'Reinach BL', 'Suisse', 4835, 0, 1),
(578, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 40', 'Postfach 342', '4702', 'Oensingen', 'Suisse', 4835, 0, 1),
(579, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 49', 'Postfach 165', '4102', 'Binningen', 'Suisse', 4835, 0, 1),
(580, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 82', 'Postfach 512', '4132', 'Muttenz 1', 'Suisse', 4835, 0, 1),
(581, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 83', 'Postfach 563', '8840', 'Einsiedeln', 'Suisse', 4835, 0, 1),
(582, 'Credit Suisse (Schweiz) AG', 'Höheweg 3', 'Postfach 193', '3800', 'Interlaken', 'Suisse', 4835, 0, 1),
(583, 'Credit Suisse (Schweiz) AG', 'Höngg, Regensdorfers', 'Postfach 253', '8049', 'Zürich', 'Suisse', 4835, 0, 1),
(584, 'Credit Suisse (Schweiz) AG', 'Hottingen, Hottinger', 'Postfach 4558', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(585, 'Credit Suisse (Schweiz) AG', 'Immeuble Alpina, Rou', 'Case postale 98', '1936', 'Verbier', 'Suisse', 4835, 0, 1),
(586, 'Credit Suisse (Schweiz) AG', 'Immeuble Grand-Place', 'Case postale 137', '3963', 'Crans-sur-Sierre', 'Suisse', 4835, 0, 1),
(587, 'Credit Suisse (Schweiz) AG', 'Immeuble Grand-Place', 'Case postale 136', '3963', 'Crans-Montana 2', 'Suisse', 4835, 0, 1),
(588, 'Credit Suisse (Schweiz) AG', 'Kaiserstrasse 4', 'Postfach 661', '4310', 'Rheinfelden 1', 'Suisse', 4835, 0, 1),
(589, 'Credit Suisse (Schweiz) AG', 'Kantonsstrasse 40', 'Postfach 379', '6048', 'Horw', 'Suisse', 4835, 0, 1),
(590, 'Credit Suisse (Schweiz) AG', 'Kirchstrasse 20', 'Postfach 860', '8953', 'Dietikon 1', 'Suisse', 4835, 0, 1),
(591, 'Credit Suisse (Schweiz) AG', 'Landstrasse 43', 'Postfach 282', '8450', 'Andelfingen', 'Suisse', 4835, 0, 1),
(592, 'Credit Suisse (Schweiz) AG', 'La-Praille, Route de', 'Case postale 100', '1211', 'Genève 70', 'Suisse', 4835, 0, 1),
(593, 'Credit Suisse (Schweiz) AG', 'Largo Libero Olgiati', 'Casella postale 571', '6512', 'Giubiasco', 'Suisse', 4835, 0, 1),
(594, 'Credit Suisse (Schweiz) AG', 'Luzernerstrasse 26', 'Postfach 1146', '6011', 'Kriens', 'Suisse', 4835, 0, 1),
(595, 'Credit Suisse (Schweiz) AG', 'Marktgasse 29', 'Postfach 480', '4900', 'Langenthal', 'Suisse', 4835, 0, 1),
(596, 'Credit Suisse (Schweiz) AG', 'Marktgasse 52', 'Postfach 163', '9450', 'Altstätten SG', 'Suisse', 4835, 0, 1),
(597, 'Credit Suisse (Schweiz) AG', 'Märtplatz 1', 'Postfach 55', '8307', 'Effretikon', 'Suisse', 4835, 0, 1),
(598, 'Credit Suisse (Schweiz) AG', 'Obere Bahnhofstrasse', 'Postfach 237', '9500', 'Wil SG 1', 'Suisse', 4835, 0, 1),
(599, 'Credit Suisse (Schweiz) AG', 'Oberseeplatz', 'Postfach 335', '7050', 'Arosa', 'Suisse', 4835, 0, 1),
(600, 'Credit Suisse (Schweiz) AG', 'Oerlikon, Albert-Näf', 'Postfach 4857', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(601, 'Credit Suisse (Schweiz) AG', 'Oltnerstrasse 7', 'Postfach 47', '5012', 'Schönenwerd', 'Suisse', 4835, 0, 1),
(602, 'Credit Suisse (Schweiz) AG', 'Paradeplatz, Paradep', 'Postfach 100', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(603, 'Credit Suisse (Schweiz) AG', 'Petit-Lancy, Route d', 'Case postale 100', '1211', 'Genève', 'Suisse', 4835, 0, 1),
(604, 'Credit Suisse (Schweiz) AG', 'Piazza G. Canevascin', 'Casella postale 284', '6598', 'Tenero', 'Suisse', 4835, 0, 1),
(605, 'Credit Suisse (Schweiz) AG', 'Piazza Grande', 'Casella postale 861', '6601', 'Locarno', 'Suisse', 4835, 0, 1),
(606, 'Credit Suisse (Schweiz) AG', 'Piazza Indipendenza ', 'Casella postale 2563', '6830', 'Chiasso', 'Suisse', 4835, 0, 1),
(607, 'Credit Suisse (Schweiz) AG', 'Piazza Stefano Frans', 'Casella postale 357', '6760', 'Faido', 'Suisse', 4835, 0, 1),
(608, 'Credit Suisse (Schweiz) AG', 'Piazzetta', 'Casella postale 141', '6535', 'Roveredo GR', 'Suisse', 4835, 0, 1),
(609, 'Credit Suisse (Schweiz) AG', 'Place Bel-Air 2', 'Case postale 100', '1211', 'Genève 70', 'Suisse', 4835, 0, 1),
(610, 'Credit Suisse (Schweiz) AG', 'Place de la Gare 1', 'Case postale 128', '1009', 'Pully', 'Suisse', 4835, 0, 1),
(611, 'Credit Suisse (Schweiz) AG', 'Place de la Paix 1', 'Case postale 349', '1820', 'Montreux 2', 'Suisse', 4835, 0, 1),
(612, 'Credit Suisse (Schweiz) AG', 'Place du Marché 5', 'Case postale 292', '2610', 'St. Imier', 'Suisse', 4835, 0, 1),
(613, 'Credit Suisse (Schweiz) AG', 'Plazzet 3', 'Postfach 48', '7503', 'Samedan', 'Suisse', 4835, 0, 1),
(614, 'Credit Suisse (Schweiz) AG', 'Postplatz 11', 'Postfach 363', '6431', 'Schwyz', 'Suisse', 4835, 0, 1),
(615, 'Credit Suisse (Schweiz) AG', 'Poststrasse 5', 'Postfach 1459', '6060', 'Sarnen 1', 'Suisse', 4835, 0, 1),
(616, 'Credit Suisse (Schweiz) AG', 'Private Banking', 'Postfach', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(617, 'Credit Suisse (Schweiz) AG', 'Promenade', 'Postfach 315', '3780', 'Gstaad', 'Suisse', 4835, 0, 1),
(618, 'Credit Suisse (Schweiz) AG', 'Promenade 65', 'Postfach 150', '7270', 'Davos Platz 1', 'Suisse', 4835, 0, 1),
(619, 'Credit Suisse (Schweiz) AG', 'Quai des Bergues 1', 'Case postale 500', '1211', 'Genève 70', 'Suisse', 4835, 0, 1),
(620, 'Credit Suisse (Schweiz) AG', 'Rathausplatz 19', 'Postfach 324', '8260', 'Stein am Rhein', 'Suisse', 4835, 0, 1),
(621, 'Credit Suisse (Schweiz) AG', 'Rathausplatz, Limmat', 'Postfach 4860', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(622, 'Credit Suisse (Schweiz) AG', 'Rheinstrasse 8', 'Postfach 618', '4410', 'Liestal', 'Suisse', 4835, 0, 1),
(623, 'Credit Suisse (Schweiz) AG', 'Riedmattstrasse 12', 'Postfach 1156', '6031', 'Ebikon', 'Suisse', 4835, 0, 1),
(624, 'Credit Suisse (Schweiz) AG', 'Via Vedeggio', 'Casella postale 55', '6814', 'Lamone Cadempino', 'Suisse', 4835, 0, 1),
(625, 'Credit Suisse (Schweiz) AG', 'Viale B. Papio 6', 'Casella postale 669', '6612', 'Ascona', 'Suisse', 4835, 0, 1),
(626, 'Credit Suisse (Schweiz) AG', 'Viale Stazione 19', 'Casella postale 2025', '6501', 'Bellinzona', 'Suisse', 4835, 0, 1),
(627, 'Credit Suisse (Schweiz) AG', 'Villa Bellavita', 'Postfach 41', '7504', 'Pontresina', 'Suisse', 4835, 0, 1),
(628, 'Credit Suisse (Schweiz) AG', 'Wengistrasse 2', 'Postfach 353', '4502', 'Solothurn', 'Suisse', 4835, 0, 1),
(629, 'Credit Suisse (Schweiz) AG', 'Werdmühleplatz, Uran', 'Postfach 4879', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(630, 'Credit Suisse (Schweiz) AG', 'Witikon, Witikonerst', 'Postfach 4870', '8053', 'Zürich', 'Suisse', 4835, 0, 1),
(631, 'Credit Suisse (Schweiz) AG', 'Wollishofen, Mutsche', 'Postfach 4872', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(632, 'Credit Suisse (Schweiz) AG', 'Zentralstrasse 42', 'Postfach 352', '2501', 'Biel/Bienne', 'Suisse', 4835, 0, 1),
(633, 'Credit Suisse (Schweiz) AG', 'Zürcherstrasse 110', 'Postfach 370', '8102', 'Oberengstringen', 'Suisse', 4835, 0, 1),
(634, 'Credit Suisse (Schweiz) AG', 'Zürichstrasse 55', 'Postfach 174', '8910', 'Affoltern am Albis', 'Suisse', 4835, 0, 1),
(635, 'Credit Suisse (Schweiz) AG', 'Zürichstrasse 8', 'Postfach 113', '8600', 'Dübendorf', 'Suisse', 4835, 0, 1),
(636, 'Credit Suisse (Schweiz) AG', 'Rigiplatz, Universit', 'Postfach 4862', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(637, 'Credit Suisse (Schweiz) AG', 'Rue Centrale', 'Casella postale 8', '1884', 'Villars-sur-Ollon', 'Suisse', 4835, 0, 1),
(638, 'Credit Suisse (Schweiz) AG', 'Rue Centrale 47', 'Case postale 158', '2740', 'Moutier', 'Suisse', 4835, 0, 1),
(639, 'Credit Suisse (Schweiz) AG', 'Rue de Gruyères 2', 'Case postale 496', '1630', 'Bulle', 'Suisse', 4835, 0, 1),
(640, 'Credit Suisse (Schweiz) AG', 'Rue de la Gare 4', 'Case postale 366', '2350', 'Saignelégier', 'Suisse', 4835, 0, 1),
(641, 'Credit Suisse (Schweiz) AG', 'Rue de la Gare 45', 'Case postale 279', '1260', 'Nyon 1', 'Suisse', 4835, 0, 1),
(642, 'Credit Suisse (Schweiz) AG', 'Rue de la Maltière 2', 'Case postale 237', '2800', 'Delémont 1', 'Suisse', 4835, 0, 1),
(643, 'Credit Suisse (Schweiz) AG', 'Rue de Seyon 12', 'Case postale 2033', '2001', 'Neuchâtel', 'Suisse', 4835, 0, 1),
(644, 'Credit Suisse (Schweiz) AG', 'Rue des Remparts 16', 'Case postale 315', '1401', 'Yverdon-les-Bains', 'Suisse', 4835, 0, 1),
(645, 'Credit Suisse (Schweiz) AG', 'Rue du Grand Pont 6/', 'Case postale 2493', '1002', 'Lausanne', 'Suisse', 4835, 0, 1),
(646, 'Credit Suisse (Schweiz) AG', 'Rue du Lyon d&apos;O', 'Case postale 5722', '1002', 'Lausanne', 'Suisse', 4835, 0, 1),
(647, 'Credit Suisse (Schweiz) AG', 'Rue du Simplon 50', 'Case postale 235', '1800', 'Vevey 1', 'Suisse', 4835, 0, 1),
(648, 'Credit Suisse (Schweiz) AG', 'Rue du Temple 2', 'Case postale 216', '2900', 'Porrentruy', 'Suisse', 4835, 0, 1),
(649, 'Credit Suisse (Schweiz) AG', 'Rue du Temple 5', 'Case postale 48', '1530', 'Payerne', 'Suisse', 4835, 0, 1),
(650, 'Credit Suisse (Schweiz) AG', 'Rue H.-F.-Sandoz 24', 'Case postale 244', '2710', 'Tavannes', 'Suisse', 4835, 0, 1),
(651, 'Credit Suisse (Schweiz) AG', 'Schaffhauserplatz, W', 'Postfach 4560', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(652, 'Credit Suisse (Schweiz) AG', 'Schaffhauserstrasse ', 'Postfach 875', '8302', 'Kloten', 'Suisse', 4835, 0, 1),
(653, 'Credit Suisse (Schweiz) AG', 'Schindellegistrasse ', 'Postfach 59', '8808', 'Pfäffikon SZ', 'Suisse', 4835, 0, 1),
(654, 'Credit Suisse (Schweiz) AG', 'Schützenstrasse 7', 'Postfach 383', '8853', 'Lachen SZ', 'Suisse', 4835, 0, 1),
(655, 'Credit Suisse (Schweiz) AG', 'Schwanenplatz 8', 'Postfach 4569', '6002', 'Luzern', 'Suisse', 4835, 0, 1),
(656, 'Credit Suisse (Schweiz) AG', 'Schwarzenburgstrasse', 'Postfach 496', '3098', 'Köniz', 'Suisse', 4835, 0, 1),
(657, 'Credit Suisse (Schweiz) AG', 'Seefeld, Seefeldstra', 'Postfach 4865', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(658, 'Credit Suisse (Schweiz) AG', 'Seestrasse 15', 'Postfach 48', '6052', 'Hergiswil NW', 'Suisse', 4835, 0, 1),
(659, 'Credit Suisse (Schweiz) AG', 'Spalenberg 65', 'Postfach 2164', '4001', 'Basel', 'Suisse', 4835, 0, 1),
(660, 'Credit Suisse (Schweiz) AG', 'St. Alban-Graben 1-3', 'Postfach 2560', '4002', 'Basel', 'Suisse', 4835, 0, 1),
(661, 'Credit Suisse (Schweiz) AG', 'St. Leonhardstrasse ', 'Postfach 563', '9001', 'St. Gallen', 'Suisse', 4835, 0, 1),
(662, 'Credit Suisse (Schweiz) AG', 'Stadthausstrasse 16', 'Postfach 330', '8401', 'Winterthur', 'Suisse', 4835, 0, 1),
(663, 'Credit Suisse (Schweiz) AG', 'Stradun', '', '7550', 'Scuol', 'Suisse', 4835, 0, 1),
(664, 'Credit Suisse (Schweiz) AG', 'Tellsgasse 10', 'Postfach 259', '6460', 'Altdorf UR', 'Suisse', 4835, 0, 1),
(665, 'Credit Suisse (Schweiz) AG', 'Thônex, Rue de Genèv', 'Case postale 100', '1211', 'Genève 70', 'Suisse', 4835, 0, 1),
(666, 'Credit Suisse (Schweiz) AG', 'Thunstrasse 70', 'Postfach 424', '3074', 'Muri b. Bern', 'Suisse', 4835, 0, 1),
(667, 'Credit Suisse (Schweiz) AG', 'Uetlihof, Uetlibergs', 'Postfach 150', '8070', 'Zürich', 'Suisse', 4835, 0, 1),
(668, 'Credit Suisse (Schweiz) AG', 'Untere Bahnhofstrass', 'Postfach 1174', '8640', 'Rapperswil SG', 'Suisse', 4835, 0, 1),
(669, 'Credit Suisse (Schweiz) AG', 'Untere Grabenstrasse', 'Postfach 367', '4800', 'Zofingen', 'Suisse', 4835, 0, 1),
(670, 'Credit Suisse (Schweiz) AG', 'Via A Giovannini 24', 'Casella postale 1569', '6710', 'Biasca', 'Suisse', 4835, 0, 1),
(671, 'Credit Suisse (Schweiz) AG', 'Via Antonio Ciseri 1', 'Casella postale 364', '6600', 'Locarno', 'Suisse', 4835, 0, 1),
(672, 'Credit Suisse (Schweiz) AG', 'Via Canova 15', 'Casella postale 5900', '6901', 'Lugano', 'Suisse', 4835, 0, 1),
(673, 'Credit Suisse (Schweiz) AG', 'Via G. Vegezzi 1', 'Casella postale 5900', '6901', 'Lugano', 'Suisse', 4835, 0, 1),
(674, 'Credit Suisse (Schweiz) AG', 'Via Lavizzari 21', 'Casella postale 137', '6850', 'Mendrisio', 'Suisse', 4835, 0, 1),
(675, 'Credit Suisse (Schweiz) AG', 'Via Leoncavallo 27', 'Casella postale 244', '6614', 'Brissago', 'Suisse', 4835, 0, 1),
(676, 'Credit Suisse (Schweiz) AG', 'Via Lugano 23', 'Casella postale 168', '6988', 'Ponte Tresa', 'Suisse', 4835, 0, 1),
(677, 'Credit Suisse (Schweiz) AG', 'Via Maistra 5', 'Postfach 4500', '7500', 'St. Moritz 1', 'Suisse', 4835, 0, 1),
(678, 'Credit Suisse (Schweiz) AG', 'Via Mezzana 31a', 'Casella postale 1246', '6616', 'Losone', 'Suisse', 4835, 0, 1),
(679, 'Credit Suisse (Schweiz) AG', 'Via Nova 68', 'Postfach 156', '7017', 'Flims Dorf', 'Suisse', 4835, 0, 1),
(680, 'Credit Suisse (Schweiz) AG', 'Via San Salvatore 3', 'Casella postale 863', '6902', 'Lugano-Paradiso', 'Suisse', 4835, 0, 1),
(681, 'Credit Suisse (Schweiz) AG', 'Poststrasse 15', 'Postfach 73', '8805', 'Richterswil', 'Suisse', 4835, 0, 1),
(682, 'Credit Suisse (Schweiz) AG', 'Affoltern, In Böden ', 'Postfach 400', '8046', 'Zürich', 'Suisse', 4836, 0, 1),
(683, 'Credit Suisse (Schweiz) AG', 'Altstetten, Badeners', 'Postfach 4837', '8070', 'Zürich', 'Suisse', 4837, 0, 1),
(684, 'Credit Suisse (Schweiz) AG', 'Aussersihl, Badeners', 'Postfach 4557', '8070', 'Zürich', 'Suisse', 4839, 0, 1),
(685, 'Credit Suisse (Schweiz) AG', 'Bahnhof, Bahnhofstra', 'Postfach 4858', '8021', 'Zürich', 'Suisse', 4840, 0, 1),
(686, 'Credit Suisse (Schweiz) AG', 'Enge, Bleicherweg 33', 'Postfach 4842', '8070', 'Zürich', 'Suisse', 4842, 0, 1),
(687, 'Credit Suisse (Schweiz) AG', 'Uetlihof, Uetlibergs', 'Postfach 150', '8070', 'Zürich', 'Suisse', 4845, 0, 1),
(688, 'Credit Suisse (Schweiz) AG', 'Höngg, Regensdorfers', 'Postfach 253', '8049', 'Zürich', 'Suisse', 4848, 0, 1),
(689, 'Credit Suisse (Schweiz) AG', 'Aussersihl, Badeners', 'Postfach 4557', '8021', 'Zürich', 'Suisse', 4850, 0, 1),
(690, 'Credit Suisse (Schweiz) AG', 'Aussersihl, Badeners', 'Postfach 4557', '8021', 'Zürich', 'Suisse', 4852, 0, 1),
(691, 'Credit Suisse (Schweiz) AG', 'Oerlikon, Albert-Näf', 'Postfach 4857', '8070', 'Zürich', 'Suisse', 4857, 0, 1),
(692, 'Credit Suisse (Schweiz) AG', 'Bahnhof, Bahnhofstra', 'Postfach 209', '8021', 'Zürich', 'Suisse', 4858, 0, 1),
(693, 'Credit Suisse (Schweiz) AG', 'Rathausplatz, Limmat', 'Postfach 4860', '8070', 'Zürich', 'Suisse', 4860, 0, 1),
(694, 'Credit Suisse (Schweiz) AG', 'Rigiplatz, Universit', 'Postfach 4862', '8070', 'Zürich', 'Suisse', 4862, 0, 1),
(695, 'Credit Suisse (Schweiz) AG', 'Oerlikon, Albert-Näf', 'Postfach 4857', '8050', 'Zürich', 'Suisse', 4864, 0, 1),
(696, 'Credit Suisse (Schweiz) AG', 'Seefeld, Seefeldstra', 'Postfach 4865', '8070', 'Zürich', 'Suisse', 4865, 0, 1),
(697, 'Credit Suisse AG', 'Paradeplatz 8', '', '8001', 'Zürich', 'Suisse', 4866, 0, 1),
(698, 'Credit Suisse (Schweiz) AG', 'Schaffhauserplatz, W', 'Postfach 125', '8035', 'Zürich', 'Suisse', 4868, 0, 1),
(699, 'Credit Suisse (Schweiz) AG', 'Witikon, Witikonerst', 'Postfach 102', '8053', 'Zürich', 'Suisse', 4870, 0, 1),
(700, 'Credit Suisse (Schweiz) AG', 'Wollishofen, Mutsche', 'Postfach 4872', '8070', 'Zürich', 'Suisse', 4872, 0, 1),
(701, 'Credit Suisse (Schweiz) AG', 'Postfach 500', '', '8070', 'Zürich', 'Suisse', 4877, 0, 1),
(702, 'Credit Suisse (Schweiz) AG', 'Postfach', '', '8070', 'Zürich', 'Suisse', 4878, 0, 1),
(703, 'Credit Suisse (Schweiz) AG', 'Werdmühleplatz, Uran', 'Postfach 4879', '8070', 'Zürich', 'Suisse', 4879, 0, 1),
(704, 'Credit Suisse (Schweiz) AG', 'Schützengasse 7', 'Postfach', '8070', 'Zürich', 'Suisse', 4892, 0, 1),
(705, 'Credit Suisse (Schweiz) AG', 'Private Banking', 'Postfach', '8070', 'Zürich', 'Suisse', 4893, 0, 1),
(706, 'Neue Aargauer Bank AG', 'Pilatusstrasse 5', 'Postfach 63', '4663', 'Aarburg', 'Suisse', 501, 0, 1),
(707, 'Credit Suisse (Schweiz) AG', 'Tellsgasse 10', 'Postfach', '6460', 'Altdorf UR', 'Suisse', 502, 0, 1),
(708, 'Credit Suisse (Schweiz) AG', 'Postfach 90', '', '8590', 'Romanshorn 1', 'Suisse', 503, 0, 1),
(709, 'Credit Suisse (Schweiz) AG', 'St. Alban-Graben 1-3', 'Postfach 2560', '4001', 'Basel', 'Suisse', 504, 0, 1),
(710, 'Credit Suisse (Schweiz) AG', 'Claraplatz, Untere R', 'Postfach', '4005', 'Basel', 'Suisse', 505, 0, 1),
(711, 'Credit Suisse (Schweiz) AG', 'Viale Stazione 19', 'Casella postale', '6501', 'Bellinzona', 'Suisse', 506, 0, 1),
(712, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 32', 'Postfach', '8070', 'Zürich', 'Suisse', 5065, 0, 1),
(713, 'Credit Suisse (Schweiz) AG', 'Bundesplatz 2', 'Postfach 5322', '3001', 'Bern', 'Suisse', 507, 0, 1),
(714, 'Credit Suisse (Schweiz) AG', 'Zentralstrasse 42', 'Case postale 1165', '2501', 'Biel/Bienne', 'Suisse', 508, 0, 1),
(715, 'Neue Aargauer Bank AG', 'Schulthess-Allee 1', 'Postfach 285', '5201', 'Brugg AG', 'Suisse', 509, 0, 1),
(716, 'Credit Suisse (Schweiz) AG', 'Place du Tilleul 9', 'Case postale 496', '1630', 'Bulle', 'Suisse', 510, 0, 1),
(717, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 39', 'Case postale 363', '1618', 'Châtel-St-Denis', 'Suisse', 511, 0, 1),
(718, 'Credit Suisse (Schweiz) AG', 'Piazza Indipendenza ', 'Casella postale', '6830', 'Chiasso 1', 'Suisse', 512, 0, 1),
(719, 'Credit Suisse (Schweiz) AG', 'Rue de la Maltière 2', 'Case postale', '2800', 'Delémont 2', 'Suisse', 513, 0, 1),
(720, 'Credit Suisse (Schweiz) AG', 'Kirchstrasse 20', 'Postfach 860', '8953', 'Dietikon 1', 'Suisse', 514, 0, 1),
(721, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 83', 'Postfach 563', '8840', 'Einsiedeln', 'Suisse', 515, 0, 1),
(722, 'Credit Suisse (Schweiz) AG', 'Viale B. Papio 6', 'Casella postale 731', '6612', 'Ascona', 'Suisse', 516, 0, 1),
(723, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 13', 'Case postale 55', '1701', 'Fribourg', 'Suisse', 517, 0, 1),
(724, 'Credit Suisse (Schweiz) AG', 'Rue de Lausanne 11 -', 'Case postale', '1211', 'Genève 70', 'Suisse', 518, 0, 1),
(725, 'Credit Suisse (Schweiz) AG', 'Acacias, Route des A', 'Case postale', '1227', 'Genève', 'Suisse', 519, 0, 1),
(726, 'Credit Suisse (Schweiz) AG', 'Card-Service', 'Postfach 227', '8810', 'Horgen', 'Suisse', 5195, 0, 1),
(727, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 22', 'Postfach', '8750', 'Glarus', 'Suisse', 520, 0, 1),
(728, 'Credit Suisse (Schweiz) AG', 'Liegenschaften GD', 'Postfach', '8065', 'Zürich', 'Suisse', 5205, 0, 1),
(729, 'Credit Suisse (Schweiz) AG', 'Führung PRK', 'Postfach', '3001', 'Bern', 'Suisse', 5209, 0, 1),
(730, 'Credit Suisse (Schweiz) AG', 'Alte Landstrasse 24', 'Postfach', '8810', 'Horgen', 'Suisse', 521, 0, 1),
(731, 'Credit Suisse (Schweiz) AG', 'PSP/CAPK', 'Postfach 8569', '8036', 'Zürich', 'Suisse', 5212, 0, 1),
(732, 'Credit Suisse (Schweiz) AG', 'Zürich Positionen Br', 'Postfach 631', '8021', 'Zürich', 'Suisse', 5215, 0, 1),
(733, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 33', 'Postfach', '8280', 'Kreuzlingen 1', 'Suisse', 522, 0, 1),
(734, 'Credit Suisse (Schweiz) AG', 'Luzernerstrasse 26', 'Postfach 304', '6010', 'Kriens', 'Suisse', 523, 0, 1),
(735, 'Credit Suisse (Schweiz) AG', 'Dorfstrasse 93', 'Postfach 827', '8706', 'Meilen', 'Suisse', 524, 0, 1),
(736, 'Credit Suisse (Schweiz) AG', 'Rue du Grand Pont 6', 'Case postale 240', '1001', 'Lausanne', 'Suisse', 525, 0, 1),
(737, 'Neue Aargauer Bank AG', 'Bahnhofplatz 1', 'Postfach', '5600', 'Lenzburg 2', 'Suisse', 526, 0, 1),
(738, 'Credit Suisse (Schweiz) AG', 'Via A. Ciseri 10', 'Casella postale 364', '6601', 'Locarno', 'Suisse', 527, 0, 1),
(739, 'Credit Suisse (Schweiz) AG', 'Schwanenplatz 8', 'Postfach 4569', '6002', 'Luzern', 'Suisse', 528, 0, 1),
(740, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse', 'Postfach 100', '8070', 'Zürich', 'Suisse', 5288, 0, 1),
(741, 'Credit Suisse (Schweiz) AG', 'Dorfstrasse 93', 'Postfach 827', '8706', 'Meilen', 'Suisse', 529, 0, 1),
(742, 'Credit Suisse (Schweiz) AG', 'Via Lavizzari 21', 'Casella postale 142', '6850', 'Mendrisio', 'Suisse', 530, 0, 1),
(743, 'Credit Suisse (Schweiz) AG', 'Landstrasse 43a', 'Postfach 282', '8450', 'Andelfingen', 'Suisse', 5301, 0, 1),
(744, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 21', 'Case postale 192', '1920', 'Martigny 1', 'Suisse', 5302, 0, 1),
(745, 'Credit Suisse (Schweiz) AG', 'Rue de la Maladière ', 'Case postale 67', '1024', 'Chavannes', 'Suisse', 5303, 0, 1),
(746, 'Credit Suisse (Schweiz) AG', 'Avenue d&apos;Ouchy ', 'Case postale 240', '1001', 'Lausanne', 'Suisse', 5304, 0, 1),
(747, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 28', 'Postfach 156', '8180', 'Bülach', 'Suisse', 5305, 0, 1),
(748, 'Credit Suisse (Schweiz) AG', 'Piazza Stefano Frans', 'Casella postale 357', '6760', 'Faido', 'Suisse', 5306, 0, 1),
(749, 'Credit Suisse (Schweiz) AG', 'Gundeldingen, Güters', 'Postfach 228', '4018', 'Basel', 'Suisse', 5307, 0, 1),
(750, 'Credit Suisse (Schweiz) AG', 'Baselstrasse 12', 'Postfach 644', '4242', 'Laufen', 'Suisse', 5308, 0, 1),
(751, 'Credit Suisse (Schweiz) AG', 'Oerlikon, Albert-Näf', 'Postfach 4857', '8050', 'Zürich', 'Suisse', 5309, 0, 1),
(752, 'Credit Suisse (Schweiz) AG', 'Place de la Paix 1', 'Case postale 133', '1820', 'Montreux 1', 'Suisse', 531, 0, 1),
(753, 'Credit Suisse (Schweiz) AG', 'Centre Commercial', 'Case postale 100', '1219', 'Lignon, Le', 'Suisse', 5311, 0, 1),
(754, 'Credit Suisse (Schweiz) AG', 'Immeuble Grand-Place', 'Case postale 136', '3963', 'Crans-sur-Sierre', 'Suisse', 5312, 0, 1),
(755, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 40', 'Postfach 120', '4702', 'Oensingen', 'Suisse', 5313, 0, 1),
(756, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 22 - ', 'Postfach 1336', '8201', 'Schaffhausen', 'Suisse', 5314, 0, 1),
(757, 'Credit Suisse (Schweiz) AG', 'Rue Centrale 47', 'Case postale 158', '2740', 'Moutier', 'Suisse', 5315, 0, 1),
(758, 'Credit Suisse (Schweiz) AG', 'Petite-Lancy, Route ', 'Case postale 100', '1211', 'Genève 70', 'Suisse', 5316, 0, 1),
(759, 'Credit Suisse (Schweiz) AG', 'Petit-Saconnex, Av. ', 'Case postale 100', '1211', 'Genève 70', 'Suisse', 5317, 0, 1),
(760, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 36', 'Postfach 364', '4153', 'Reinach BL 1', 'Suisse', 5318, 0, 1),
(761, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 18', 'Postfach 485', '6210', 'Sursee', 'Suisse', 5319, 0, 1),
(762, 'Credit Suisse (Schweiz) AG', 'Rue Centrale 47', 'Case postale 158', '2740', 'Moutier', 'Suisse', 532, 0, 1),
(763, 'Credit Suisse (Schweiz) AG', 'Casa Comunale', 'Casella postale 86', '6574', 'Vira', 'Suisse', 5321, 0, 1),
(764, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 21', 'Case postale 192', '1920', 'Martigny 1', 'Suisse', 5322, 0, 1),
(765, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 28', 'Postfach 601', '3076', 'Worb', 'Suisse', 5323, 0, 1),
(766, 'Neue Aargauer Bank AG', 'Zentralstrasse 53', 'Postfach 1512', '5610', 'Wohlen AG', 'Suisse', 5324, 0, 1),
(767, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 12', 'Postfach 585', '7001', 'Chur', 'Suisse', 5325, 0, 1),
(768, 'Credit Suisse (Schweiz) AG', 'Rütistrasse 1', 'Postfach 164', '8636', 'Wald ZH', 'Suisse', 5326, 0, 1),
(769, 'Credit Suisse (Schweiz) AG', 'Zentralstrasse 42', 'Case postale 1165', '2501', 'Biel/Bienne', 'Suisse', 5327, 0, 1),
(770, 'Credit Suisse (Schweiz) AG', 'Rue du Simplon 50', 'Case postale 210', '1800', 'Vevey 1', 'Suisse', 5328, 0, 1),
(771, 'Credit Suisse (Schweiz) AG', 'Hauptgasse 13', 'Postfach 224', '3280', 'Murten/Morat', 'Suisse', 533, 0, 1),
(772, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 13', 'Case postale 55', '1701', 'Fribourg', 'Suisse', 5331, 0, 1),
(773, 'Credit Suisse (Schweiz) AG', 'Rue du Simplon 50', 'Case postale 210', '1800', 'Vevey 1', 'Suisse', 5332, 0, 1),
(774, 'Credit Suisse (Schweiz) AG', 'Schwarzenburgstrasse', 'Postfach 496', '3098', 'Köniz', 'Suisse', 5333, 0, 1),
(775, 'Credit Suisse (Schweiz) AG', 'Eaux-Vives, Rue Vers', 'Case postale 100', '1211', 'Genève 70', 'Suisse', 5334, 0, 1),
(776, 'Credit Suisse (Schweiz) AG', 'Avenue Général-Guisa', 'Postfach 312', '3960', 'Sierre/Siders', 'Suisse', 5335, 0, 1),
(777, 'Credit Suisse (Schweiz) AG', 'Zürcherstrasse 110', 'Postfach 370', '8102', 'Oberengstringen', 'Suisse', 5336, 0, 1),
(778, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 22', 'Postfach 466', '8750', 'Glarus', 'Suisse', 5337, 0, 1),
(779, 'Neue Aargauer Bank AG', 'Landstrasse 81', 'Postfach', '5430', 'Wettingen 3', 'Suisse', 5338, 0, 1),
(780, 'Credit Suisse (Schweiz) AG', 'Immeuble Grand-Place', 'Case postale 136', '3963', 'Crans-sur-Sierre', 'Suisse', 5339, 0, 1),
(781, 'Credit Suisse (Schweiz) AG', 'Rue du Temple 5', 'Case postale 48', '1530', 'Payerne', 'Suisse', 534, 0, 1),
(782, 'Credit Suisse (Schweiz) AG', 'Am Marktplatz', 'Postfach 127', '2540', 'Grenchen 1', 'Suisse', 5342, 0, 1),
(783, 'Credit Suisse (Schweiz) AG', 'Wiedikon, Birmensdor', 'Postfach 4563', '8036', 'Zürich', 'Suisse', 5343, 0, 1),
(784, 'Credit Suisse (Schweiz) AG', 'St. Leonhardstrasse ', 'Postfach 563', '9001', 'St. Gallen', 'Suisse', 5344, 0, 1),
(785, 'Credit Suisse (Schweiz) AG', 'Rue de Seyon 12', 'Case postale', '2001', 'Neuchâtel', 'Suisse', 5345, 0, 1),
(786, 'Credit Suisse (Schweiz) AG', 'Gerliswilstrasse 71', 'Postfach 1242', '6021', 'Emmenbrücke 1', 'Suisse', 5347, 0, 1),
(787, 'Credit Suisse (Schweiz) AG', 'Via Leoncavallo 27', 'Casella postale 244', '6614', 'Brissago', 'Suisse', 5348, 0, 1),
(788, 'Credit Suisse (Schweiz) AG', 'Rue des Remparts 16', 'Case postale 159', '1401', 'Yverdon-les-Bains', 'Suisse', 5349, 0, 1),
(789, 'Credit Suisse (Schweiz) AG', 'Rue du Temple 2', 'Case postale 216', '2900', 'Porrentruy', 'Suisse', 535, 0, 1),
(790, 'Credit Suisse (Schweiz) AG', 'Dorfstrasse 13', 'Postfach 329', '6341', 'Baar', 'Suisse', 5351, 0, 1),
(791, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 17', 'Postfach 357', '6301', 'Zug', 'Suisse', 5352, 0, 1),
(792, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 33', 'Postfach 1270', '8280', 'Kreuzlingen 1', 'Suisse', 5353, 0, 1),
(793, 'Credit Suisse (Schweiz) AG', 'Rue de Bernex 293', 'Case postale 100', '1233', 'Bernex', 'Suisse', 5354, 0, 1),
(794, 'Credit Suisse (Schweiz) AG', 'Postplatz 11', 'Postfach 363', '6431', 'Schwyz', 'Suisse', 5355, 0, 1),
(795, 'Credit Suisse (Schweiz) AG', 'Bälliz 36', 'Postfach 1374', '3601', 'Thun', 'Suisse', 5356, 0, 1),
(796, 'Credit Suisse (Schweiz) AG', 'Seestrasse 15', 'Postfach 176', '6052', 'Hergiswil NW', 'Suisse', 5357, 0, 1),
(797, 'Credit Suisse (Schweiz) AG', 'Riedmattstrasse 12', 'Postfach 361', '6030', 'Ebikon', 'Suisse', 5358, 0, 1),
(798, 'Credit Suisse (Schweiz) AG', 'Place du Marché 12', 'Case postale 100', '1227', 'Carouge GE', 'Suisse', 5359, 0, 1),
(799, 'Neue Aargauer Bank AG', 'Handelshof', 'Postfach 764', '5734', 'Reinach AG', 'Suisse', 536, 0, 1),
(800, 'Credit Suisse (Schweiz) AG', 'Avenue de la Gare 21', 'Case postale 192', '1920', 'Martigny 1', 'Suisse', 5361, 0, 1),
(801, 'Credit Suisse (Schweiz) AG', 'Thônex, Rue de Genèv', 'Case postale 100', '1225', 'Genève 70', 'Suisse', 5362, 0, 1),
(802, 'Credit Suisse (Schweiz) AG', 'Spalenberg 65', 'Postfach 2164', '4001', 'Basel', 'Suisse', 5363, 0, 1),
(803, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 12', 'Postfach 109', '3250', 'Lyss', 'Suisse', 5364, 0, 1),
(804, 'Credit Suisse (Schweiz) AG', 'Zürichstrasse 55', 'Postfach 174', '8910', 'Affoltern am Albis', 'Suisse', 5365, 0, 1),
(805, 'Credit Suisse (Schweiz) AG', 'Rheinstrasse 8', 'Postfach 618', '4410', 'Liestal', 'Suisse', 5366, 0, 1),
(806, 'Credit Suisse (Schweiz) AG', 'Grenzstrasse 11', 'Postfach 174', '9430', 'St. Margrethen SG', 'Suisse', 5368, 0, 1),
(807, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 28', 'Case postale 256', '1680', 'Romont FR', 'Suisse', 537, 0, 1),
(808, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 13', 'Postfach 480', '3900', 'Brig/Brigue', 'Suisse', 5371, 0, 1),
(809, 'Credit Suisse (Schweiz) AG', 'Marktgasse 29', 'Postfach 480', '4900', 'Langenthal', 'Suisse', 5373, 0, 1),
(810, 'Credit Suisse (Schweiz) AG', 'Bernstrasse 34', 'Postfach 1647', '3072', 'Ostermundigen', 'Suisse', 5374, 0, 1),
(811, 'Credit Suisse (Schweiz) AG', 'Hauptstrasse 16', 'Postfach 201', '3186', 'Düdingen', 'Suisse', 5375, 0, 1),
(812, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 52', 'Case postale 477', '1110', 'Morges 1', 'Suisse', 5376, 0, 1),
(813, 'Credit Suisse (Schweiz) AG', 'Poststrasse 5', 'Postfach 1459', '6060', 'Sarnen', 'Suisse', 5377, 0, 1),
(814, 'Credit Suisse (Schweiz) AG', 'Bahnhofpaltz', 'Postfach 70', '3920', 'Zermatt', 'Suisse', 5378, 0, 1),
(815, 'Credit Suisse (Schweiz) AG', 'Rue de la Gare 4', 'Case postale 366', '2350', 'Saignelégier', 'Suisse', 538, 0, 1),
(816, 'Credit Suisse (Schweiz) AG', 'St. Leonhardstrasse ', 'Postfach 2064', '9001', 'St. Gallen', 'Suisse', 539, 0, 1),
(817, 'Credit Suisse (Schweiz) AG', 'Bankplatz 3', 'Postfach 931', '8500', 'Frauenfeld', 'Suisse', 540, 0, 1),
(818, 'Credit Suisse (Schweiz) AG', 'Place du Marché 5', 'Case postale 35', '2610', 'St-Imier', 'Suisse', 541, 0, 1),
(819, 'Credit Suisse (Schweiz) AG', 'Via Maistra 5', 'Postfach 4500', '7500', 'St. Moritz 1', 'Suisse', 542, 0, 1),
(820, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 22 - ', 'Postfach 1336', '8201', 'Schaffhausen', 'Suisse', 543, 0, 1),
(821, 'Credit Suisse (Schweiz) AG', 'Wengistrasse 2', 'Postfach 1047', '4502', 'Solothurn', 'Suisse', 544, 0, 1),
(822, 'Credit Suisse (Schweiz) AG', 'Rue H.-F.-Sandoz 24', 'Case postale 244', '2710', 'Tavannes', 'Suisse', 545, 0, 1),
(823, 'Credit Suisse (Schweiz) AG', 'Gotthardstrasse 21', 'Postfach 1082', '8801', 'Thalwil', 'Suisse', 546, 0, 1),
(824, 'Credit Suisse (Schweiz) AG', 'Grand-Rue 129', 'Case postale 71', '2720', 'Tramelan', 'Suisse', 547, 0, 1),
(825, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 5', 'Postfach 252', '8610', 'Uster 1', 'Suisse', 548, 0, 1),
(826, 'Credit Suisse (Schweiz) AG', 'Friedbergstrasse 9', 'Postfach 350', '8820', 'Wädenswil', 'Suisse', 549, 0, 1),
(827, 'Credit Suisse (Schweiz) AG', 'Bankstrasse 1', 'Postfach 333', '8570', 'Weinfelden', 'Suisse', 550, 0, 1),
(828, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 58', 'Postfach 1267', '8620', 'Wetzikon ZH 1', 'Suisse', 551, 0, 1),
(829, 'Credit Suisse (Schweiz) AG', 'Obere Bahnhofstrasse', 'Postfach 237', '9500', 'Wil SG 1', 'Suisse', 552, 0, 1),
(830, 'Credit Suisse (Schweiz) AG', 'Stadthausstrasse 16', 'Postfach 330', '8401', 'Winterthur', 'Suisse', 553, 0, 1),
(831, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 53', 'Postfach 4879', '8021', 'Zürich', 'Suisse', 554, 0, 1),
(832, 'Credit Suisse (Schweiz) AG', 'Altstetten, Badeners', 'Postfach 4837', '8048', 'Zürich', 'Suisse', 555, 1, 1),
(833, 'Credit Suisse (Schweiz) AG', 'Wiedikon, Birmensdor', 'Postfach 4563', '8039', 'Zürich', 'Suisse', 556, 0, 1),
(834, 'Credit Suisse (Schweiz) AG', 'Aussersihl, Badeners', 'Postfach 673', '8021', 'Zürich', 'Suisse', 557, 0, 1),
(835, 'Credit Suisse (Schweiz) AG', 'Postfach 4558', '', '8070', 'Zürich', 'Suisse', 558, 0, 1),
(836, 'Credit Suisse (Schweiz) AG', 'Oerlikon, Albert-Näf', 'Postfach 4857', '8050', 'Zürich', 'Suisse', 559, 0, 1),
(837, 'Credit Suisse (Schweiz) AG', 'Schaffhauserp. Weinb', 'Postfach 4560', '8042', 'Zürich', 'Suisse', 560, 0, 1),
(838, 'Credit Suisse (Schweiz) AG', 'Seefeld, Seefeldstra', 'Postfach 4865', '8034', 'Zürich', 'Suisse', 561, 0, 1),
(839, 'Credit Suisse (Schweiz) AG', 'Horgen Oberdorf, Neu', 'Postfach', '8070', 'Zürich', 'Suisse', 5611, 0, 1),
(840, 'Credit Suisse (Schweiz) AG', 'Schaffhauserplatz, W', 'Postfach 4560', '8042', 'Zürich', 'Suisse', 562, 0, 1),
(841, 'Credit Suisse (Schweiz) AG', 'Wiedikon, Birmensdor', 'Postfach 4563', '8036', 'Zürich', 'Suisse', 563, 0, 1),
(842, 'Credit Suisse (Schweiz) AG', 'Via G. Vegezzi 1', 'Casella postale 2862', '6901', 'Lugano', 'Suisse', 564, 0, 1),
(843, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 48', 'Postfach 248', '9470', 'Buchs SG', 'Suisse', 565, 0, 1),
(844, 'Credit Suisse (Schweiz) AG', 'Place de la Paix 1', 'Case postale 133', '1820', 'Montreux 1', 'Suisse', 566, 0, 1),
(845, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 11', 'Postfach 1255', '4133', 'Pratteln 1', 'Suisse', 567, 0, 1),
(846, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 28', 'Postfach 156', '8180', 'Bülach', 'Suisse', 568, 0, 1),
(847, 'Credit Suisse (Schweiz) AG', 'Avenue Léopold-Rober', 'Case postale 368', '2301', 'Chaux-de-Fonds, La', 'Suisse', 569, 0, 1),
(848, 'Credit Suisse (Schweiz) AG', 'Avenue du Midi 12', 'Case postale 349', '1951', 'Sion/Sitten', 'Suisse', 570, 0, 1),
(849, 'Credit Suisse (Schweiz) AG', 'Froburgstrasse 1-5', 'Postfach 551', '4601', 'Olten', 'Suisse', 571, 0, 1),
(850, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 12', 'Postfach', '7001', 'Chur', 'Suisse', 572, 0, 1),
(851, 'Credit Suisse (Schweiz) AG', 'Place de la Gare 1', 'Case postale 128', '1009', 'Pully', 'Suisse', 573, 0, 1),
(852, 'Neue Aargauer Bank AG', 'Bahnhofstrasse 49', 'Postfach 3422', '5001', 'Aarau', 'Suisse', 574, 0, 1),
(853, 'Credit Suisse (Schweiz) AG', 'Bahnhofplatz 84', 'Postfach 864', '3401', 'Burgdorf', 'Suisse', 575, 0, 1),
(854, 'Credit Suisse (Schweiz) AG', 'Zürichstrasse 8', 'Postfach 113', '8600', 'Dübendorf', 'Suisse', 576, 0, 1),
(855, 'Credit Suisse (Schweiz) AG', 'Rue du Lion d&apos;O', 'Case postale 2493', '1002', 'Lausanne', 'Suisse', 577, 0, 1),
(856, 'Neue Aargauer Bank AG', 'Bahnhofplatz 1', 'Postfach', '5401', 'Baden', 'Suisse', 578, 0, 1),
(857, 'Credit Suisse (Schweiz) AG', 'Via Lugano', 'Casella postale 168', '6988', 'Ponte Tresa', 'Suisse', 579, 0, 1),
(858, 'Credit Suisse (Schweiz) AG', 'Via San Salvatore 3', 'Casella postale 863', '6902', 'Paradiso', 'Suisse', 580, 0, 1),
(859, 'Credit Suisse (Schweiz) AG', 'Piazza G. Canevascin', 'Casella postale 284', '6598', 'Tenero', 'Suisse', 581, 0, 1),
(860, 'Credit Suisse (Schweiz) AG', 'Bundesplatz 2', 'Postfach 5322', '3001', 'Bern', 'Suisse', 582, 0, 1),
(861, 'Credit Suisse (Schweiz) AG', 'Rathausplatz 19', 'Postfach 324', '8260', 'Stein am Rhein', 'Suisse', 583, 0, 1),
(862, 'Credit Suisse (Schweiz) AG', 'Rue de la Gare 45', 'Case postale 279', '1260', 'Nyon', 'Suisse', 584, 0, 1),
(863, 'Credit Suisse (Schweiz) AG', 'Märtplatz 1', 'Postfach 55', '8307', 'Effretikon', 'Suisse', 585, 0, 1),
(864, 'Credit Suisse (Schweiz) AG', 'Schaffhauserstrasse ', 'Postfach 875', '8302', 'Kloten', 'Suisse', 586, 0, 1),
(865, 'Credit Suisse (Schweiz) AG', 'Rue de Seyon 12', 'Case postale 556', '2001', 'Neuchâtel', 'Suisse', 587, 0, 1),
(866, 'Credit Suisse (Schweiz) AG', 'Via Mezzana 31 a', 'Casella postale 1246', '6616', 'Losone', 'Suisse', 588, 0, 1),
(867, 'Neue Aargauer Bank AG', 'Hauptsitz Bahnhofstr', 'Postfach', '5001', 'Aarau', 'Suisse', 5881, 0, 1),
(868, 'Neue Aargauer Bank AG', 'Einkaufszentrum Tell', '', '5004', 'Aarau', 'Suisse', 5881, 0, 1),
(869, 'Neue Aargauer Bank AG', 'Heinrich Wehrli-Stra', '', '5033', 'Buchs AG', 'Suisse', 5881, 0, 1),
(870, 'Neue Aargauer Bank AG', 'Mitteldorfstrasse 27', '', '5722', 'Gränichen', 'Suisse', 5881, 0, 1),
(871, 'Neue Aargauer Bank AG', 'Tramstrasse 25', '', '5034', 'Suhr', 'Suisse', 5881, 0, 1),
(872, 'Neue Aargauer Bank AG', 'Hauptstrasse 25', '', '5035', 'Unterentfelden', 'Suisse', 5881, 0, 1),
(873, 'Neue Aargauer Bank AG', 'Hauptstrasse 21', '', '5726', 'Unterkulm', 'Suisse', 5881, 0, 1),
(874, 'Neue Aargauer Bank AG', 'Hauptstrasse 24', '', '5312', 'Döttingen', 'Suisse', 5881, 0, 1),
(875, 'Neue Aargauer Bank AG', 'Hauptstrasse 48', '', '5330', 'Bad Zurzach', 'Suisse', 5881, 0, 1),
(876, 'Neue Aargauer Bank AG', 'Zürcherstrasse 109', '', '5432', 'Neuenhof', 'Suisse', 5881, 0, 1),
(877, 'Neue Aargauer Bank AG', 'Shopping-Center', '', '8957', 'Spreitenbach', 'Suisse', 5881, 0, 1),
(878, 'Neue Aargauer Bank AG', 'Landstrasse 81', '', '5430', 'Wettingen', 'Suisse', 5881, 0, 1),
(879, 'Neue Aargauer Bank AG', 'Badenerstrasse 2', '', '5442', 'Fislisbach', 'Suisse', 5881, 0, 1),
(880, 'Neue Aargauer Bank AG', 'Landstrasse 148', '', '5415', 'Nussbaumen AG', 'Suisse', 5881, 0, 1),
(881, 'Neue Aargauer Bank AG', 'Hauptstrasse 53', '', '5070', 'Frick', 'Suisse', 5881, 0, 1),
(882, 'Neue Aargauer Bank AG', 'Winterthurerstrasse ', '', '5080', 'Laufenburg', 'Suisse', 5881, 0, 1),
(883, 'Neue Aargauer Bank AG', 'Bachstrasse 10', '', '4313', 'Möhlin', 'Suisse', 5881, 0, 1),
(884, 'Neue Aargauer Bank AG', 'Langackerstrasse 1', '', '4332', 'Stein AG', 'Suisse', 5881, 0, 1),
(885, 'Neue Aargauer Bank AG', 'Zürcherstrasse 5', '', '5620', 'Bremgarten AG', 'Suisse', 5881, 0, 1),
(886, 'Neue Aargauer Bank AG', 'Aarauerstrasse 7', '', '5630', 'Muri AG', 'Suisse', 5881, 0, 1),
(887, 'Neue Aargauer Bank AG', 'Bellikerstrasse 1', '', '8965', 'Berikon-Mutschellen', 'Suisse', 5881, 0, 1),
(888, 'Neue Aargauer Bank AG', 'Unterdorfstrasse 2', '', '5612', 'Villmergen', 'Suisse', 5881, 0, 1),
(889, 'Neue Aargauer Bank AG', 'Pilatusstrasse 5', '', '4663', 'Aarburg', 'Suisse', 5881, 0, 1),
(890, 'Neue Aargauer Bank AG', 'Brückenstrasse 2', '', '4853', 'Murgenthal', 'Suisse', 5881, 0, 1),
(891, 'Neue Aargauer Bank AG', 'Bernstrasse 189', '', '4852', 'Rothrist', 'Suisse', 5881, 0, 1),
(892, 'Neue Aargauer Bank AG', 'Bahnhofstrasse 3', '', '5300', 'Turgi', 'Suisse', 5881, 0, 1),
(893, 'Neue Aargauer Bank AG', 'Zollrain 9', '', '4310', 'Rheinfelden', 'Suisse', 5881, 0, 1),
(894, 'Neue Aargauer Bank AG', 'Bahnhofplatz 1', '', '5400', 'Baden', 'Suisse', 5881, 0, 1),
(895, 'Neue Aargauer Bank AG', 'Hauptstrasse 1 Postf', '', '5201', 'Brugg AG', 'Suisse', 5881, 0, 1),
(896, 'Neue Aargauer Bank AG', 'Zentralstrasse 53', '', '5610', 'Wohlen AG', 'Suisse', 5881, 0, 1),
(897, 'Neue Aargauer Bank AG', 'Handelshof', '', '5734', 'Reinach AG', 'Suisse', 5881, 0, 1),
(898, 'Neue Aargauer Bank AG', 'Bahnhofplatz 1', '', '5600', 'Lenzburg', 'Suisse', 5881, 0, 1),
(899, 'Neue Aargauer Bank AG', 'Vordere Hauptgasse 6', '', '4800', 'Zofingen', 'Suisse', 5881, 0, 1),
(900, 'Neue Aargauer Bank AG', 'Bahnhofstrasse 49', 'Postfach 3422', '5001', 'Aarau', 'Suisse', 5882, 0, 1),
(901, 'Neue Aargauer Bank AG', 'Schulthess-Allee 1', 'Postfach 285', '5201', 'Brugg AG', 'Suisse', 5883, 0, 1),
(902, 'Neue Aargauer Bank AG', 'Bahnhofplatz 1', 'Postfach', '5401', 'Baden', 'Suisse', 5884, 0, 1),
(903, 'Neue Aargauer Bank AG', 'Bahnhofplatz 1', 'Postfach 930', '5401', 'Baden', 'Suisse', 5885, 0, 1),
(904, 'Neue Aargauer Bank AG', 'Zollrain 9', 'Postfach 464', '4310', 'Rheinfelden', 'Suisse', 5886, 0, 1),
(905, 'Neue Aargauer Bank AG', 'Zentralstrasse 53', 'Postfach', '5610', 'Wohlen AG', 'Suisse', 5887, 0, 1),
(906, 'Neue Aargauer Bank AG', 'Vordere Hauptgasse 6', 'Postfach 655', '4800', 'Zofingen', 'Suisse', 5889, 0, 1),
(907, 'Credit Suisse (Schweiz) AG', 'Untere Bahnhofstrass', 'Postfach 8640', '8640', 'Rapperswil SG', 'Suisse', 589, 0, 1),
(908, 'Neue Aargauer Bank AG', 'Service-Center Brugg', 'Postfach 285', '5201', 'Brugg AG', 'Suisse', 5899, 0, 1),
(909, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 35', 'Postfach 577', '6403', 'Küssnacht am Rigi', 'Suisse', 590, 0, 1);
INSERT INTO `faturacao_bancos_fornecedores` (`ID_BancoFornecedor`, `Nome`, `Address1`, `Address2`, `NPA`, `Localite`, `PaisBanco`, `BCNbr`, `Predefinido`, `Ativo`) VALUES
(910, 'Credit Suisse (Schweiz) AG', 'Via Bellinzona 12', 'Casella postale 1569', '6710', 'Biasca', 'Suisse', 591, 0, 1),
(911, 'Credit Suisse (Schweiz) AG', 'Via Vedeggio', 'Casella postale 55', '6814', 'Lamone-Cadempino', 'Suisse', 592, 0, 1),
(912, 'Credit Suisse (Schweiz) AG', 'Bahnhofstrasse 58', 'Postfach 1267', '8620', 'Wetzikon ZH 1', 'Suisse', 593, 0, 1),
(913, 'Credit Suisse (Schweiz) AG', 'Largo Libero Olgiati', 'Casella postale 571', '6512', 'Giubiasco', 'Suisse', 594, 0, 1),
(914, 'Credit Suisse (Schweiz) AG', 'GD-Zürich', 'Postfach', '8065', 'Zürich', 'Suisse', 595, 0, 1),
(915, 'Crédit Mutuel de la Vallée SA', 'Grande Rue 22', 'Case postale 64', '1347', 'Sentier, Le', 'Suisse', 6180, 0, 1),
(916, 'Caisse d&apos;Epargne de Cossonay société coopérative', 'Rue du Temple 2', 'Case postale 40', '1304', 'Cossonay-Ville', 'Suisse', 6182, 0, 1),
(917, 'Caisse d&apos;Epargne de Cossonay société coopérative', 'Route de Mex 2', 'Case postale 15', '1036', 'Sullens', 'Suisse', 6182, 0, 1),
(918, 'Sparkasse Sense', 'Mariahilfstrasse 4', 'Postfach', '1712', 'Tafers/Tavel', 'Suisse', 6186, 0, 1),
(919, 'Sparkasse Sense', 'F.X. Müllerstrasse 1', 'Postfach', '3185', 'Schmitten FR', 'Suisse', 61861, 0, 1),
(920, 'Caisse d&apos;Epargne CEC SA', 'Grand-Rue 45', 'Case postale 104', '2608', 'Courtelary', 'Suisse', 6240, 0, 1),
(921, 'Caisse d&apos;Epargne CEC SA', 'Rue Neuve 3', 'Case postale 2359', '2300', 'Chaux-de-Fonds, La', 'Suisse', 6240, 0, 1),
(922, 'Caisse d&apos;Epargne CEC SA', 'Grand-Rue 136', 'Case postale 125', '2720', 'Tramelan', 'Suisse', 62401, 0, 1),
(923, 'Caisse d&apos;Epargne CEC SA', 'Rue Francillon 31', 'Case postale 41', '2610', 'St-Imier', 'Suisse', 62402, 0, 1),
(924, 'Caisse d&apos;Epargne CEC SA', 'Rue du Collège 3', 'Case postale 32', '2605', 'Sonceboz-Sombeval', 'Suisse', 62403, 0, 1),
(925, 'Valiant Bank AG', 'Bundesplatz 4', 'Postfach', '3001', 'Bern', 'Suisse', 6300, 0, 1),
(926, 'Valiant Bank AG', 'Solothurnstrasse 4', '', '3315', 'Bätterkinden', 'Suisse', 6300, 0, 1),
(927, 'Valiant Bank AG', 'Bernstrasse 10', 'Postfach', '3312', 'Fraubrunnen', 'Suisse', 6300, 0, 1),
(928, 'Valiant Bank AG', 'Solothurnstrasse 26', 'Postfach', '3303', 'Jegenstorf', 'Suisse', 6300, 0, 1),
(929, 'Valiant Bank AG', 'Bernstrasse 4', '', '3053', 'Münchenbuchsee', 'Suisse', 6300, 0, 1),
(930, 'Valiant Bank AG', 'Zentrumsplatz 1', 'Postfach', '3322', 'Urtenen-Schönbühl', 'Suisse', 6300, 0, 1),
(931, 'Valiant Bank AG', 'Bahnhofstrasse 23', 'Postfach', '3427', 'Utzenstorf', 'Suisse', 6300, 0, 1),
(932, 'Valiant Bank AG', 'Bethlehemstrasse 1', 'Postfach', '3027', 'Bern', 'Suisse', 6300, 0, 1),
(933, 'Valiant Bank AG', 'Schwarzenburgstrasse', 'Postfach', '3098', 'Köniz', 'Suisse', 6300, 0, 1),
(934, 'Valiant Bank AG', 'Breitenrainplatz 33', 'Postfach', '3000', 'Bern 22', 'Suisse', 6300, 0, 1),
(935, 'Valiant Bank AG', 'Talgut-Zentrum 25', 'Postfach', '3063', 'Ittigen', 'Suisse', 6300, 0, 1),
(936, 'Valiant Bank AG', 'Marktgasse 19', 'Postfach', '4900', 'Langenthal', 'Suisse', 6300, 0, 1),
(937, 'Valiant Bank AG', 'Bahnhofstrasse 45', 'Postfach', '3401', 'Burgdorf', 'Suisse', 6300, 0, 1),
(938, 'Valiant Bank AG', 'Füllerichstrasse 53', 'Postfach', '3073', 'Gümligen', 'Suisse', 6300, 0, 1),
(939, 'Valiant Bank AG', 'Murtenstrasse 2', 'Postfach', '3177', 'Laupen BE', 'Suisse', 6300, 0, 1),
(940, 'Valiant Bank AG', 'Bahnhofstrasse 17', 'Postfach', '3250', 'Lyss', 'Suisse', 6300, 0, 1),
(941, 'Valiant Bank AG', 'Murtenstrasse 28', 'Postfach', '3203', 'Mühleberg', 'Suisse', 6300, 0, 1),
(942, 'Valiant Bank AG', 'Oeleweg 2', 'Postfach', '3176', 'Neuenegg', 'Suisse', 6300, 0, 1),
(943, 'Valiant Bank AG', 'Hauptstrasse 14', 'Postfach', '3033', 'Wohlen b. Bern', 'Suisse', 6300, 0, 1),
(944, 'Valiant Bank AG', 'Bahnhofstrasse 8', 'Postfach', '3210', 'Kerzers', 'Suisse', 6300, 0, 1),
(945, 'Valiant Bank AG', 'Dorf', 'Postfach', '3537', 'Eggiwil', 'Suisse', 6300, 0, 1),
(946, 'Valiant Bank AG', 'Dorfstrasse 19', 'Postfach', '3534', 'Signau', 'Suisse', 6300, 0, 1),
(947, 'Valiant Bank AG', 'Bahnhofstrasse 9', 'Postfach', '3555', 'Trubschachen', 'Suisse', 6300, 0, 1),
(948, 'Valiant Bank AG', 'Langnaustrasse 21', 'Postfach', '3436', 'Zollbrück', 'Suisse', 6300, 0, 1),
(949, 'Valiant Bank AG', 'Bernstrasse 3', 'Postfach', '3122', 'Kehrsatz', 'Suisse', 6300, 0, 1),
(950, 'Valiant Bank AG', 'Bahnhofstrasse 19', 'Postfach', '3125', 'Toffen', 'Suisse', 6300, 0, 1),
(951, 'Valiant Bank AG', 'Bahnhofplatz 7', 'Postfach', '3001', 'Bern', 'Suisse', 6300, 0, 1),
(952, 'Valiant Bank AG', 'Bahnhofstrasse 3', 'Postfach', '3123', 'Belp', 'Suisse', 6300, 0, 1),
(953, 'Valiant Bank AG', 'Dorfstrasse 7', 'Postfach', '3550', 'Langnau', 'Suisse', 6300, 0, 1),
(954, 'Valiant Bank AG', 'Schlossgasse 5', 'Postfach', '3280', 'Murten/Morat', 'Suisse', 6300, 0, 1),
(955, 'Valiant Bank AG', 'Bernstrasse 32', 'Postfach', '3072', 'Ostermundigen', 'Suisse', 6300, 0, 1),
(956, 'Valiant Bank AG', 'Bernstrasse 135', '', '3052', 'Zollikofen', 'Suisse', 6300, 0, 1),
(957, 'Valiant Bank AG', 'Bernstrasse 3', 'Postfach', '3175', 'Flamatt', 'Suisse', 6300, 0, 1),
(958, 'Valiant Bank AG', 'Hauptstrasse 29', 'Postfach', '3186', 'Düdingen', 'Suisse', 6300, 0, 1),
(959, 'Valiant Bank AG', 'Laurenzenvorstadt 1', 'Postfach', '5001', 'Aarau', 'Suisse', 6300, 0, 1),
(960, 'Valiant Bank AG', 'Löwenplatz 6', 'Postfach', '5712', 'Beinwil am See', 'Suisse', 6300, 0, 1),
(961, 'Valiant Bank AG', 'Poststrasse 1', 'Postfach', '5707', 'Seengen', 'Suisse', 6300, 0, 1),
(962, 'Valiant Bank AG', 'Tramstrasse 11', 'Postfach', '5034', 'Suhr', 'Suisse', 6300, 0, 1),
(963, 'Valiant Bank AG', 'Dorfstrasse 709', 'Postfach', '5728', 'Gontenschwil', 'Suisse', 6300, 0, 1),
(964, 'Valiant Bank AG', 'Dorfstrasse 2', 'Postfach', '6221', 'Rickenbach LU', 'Suisse', 6300, 0, 1),
(965, 'Valiant Bank AG', 'Oberdorfstrasse 1A', 'Postfach', '5703', 'Seon', 'Suisse', 6300, 0, 1),
(966, 'Valiant Bank AG', 'Dorfstrasse 1', 'Postfach', '5040', 'Schöftland', 'Suisse', 6300, 0, 1),
(967, 'Valiant Bank AG', 'Köllikerstrasse 2', 'Postfach', '5036', 'Oberentfelden', 'Suisse', 6300, 0, 1),
(968, 'Valiant Bank AG', 'Dinkelhof 1', 'Postfach', '5706', 'Boniswil', 'Suisse', 6300, 0, 1),
(969, 'Valiant Bank AG', 'Mitteldorfstrasse 3', 'Postfach', '5722', 'Gränichen', 'Suisse', 6300, 0, 1),
(970, 'Valiant Bank AG', 'Zentrumsplatz 3', 'Postfach', '5726', 'Unterkulm', 'Suisse', 6300, 0, 1),
(971, 'Valiant Bank AG', 'Hauptstrasse 65', 'Postfach', '5734', 'Reinach AG', 'Suisse', 6300, 0, 1),
(972, 'Valiant Bank AG', 'Luzernerstrasse 3', 'Postfach', '6252', 'Dagmersellen', 'Suisse', 6300, 0, 1),
(973, 'Valiant Bank AG', 'Gerliswilstrasse 8', 'Postfach', '6021', 'Emmenbrücke 1', 'Suisse', 6300, 0, 1),
(974, 'Valiant Bank AG', 'Dorfstrasse 3', 'Postfach', '6022', 'Grosswangen', 'Suisse', 6300, 0, 1),
(975, 'Valiant Bank AG', 'Gasshofstrasse 1', 'Postfach', '6014', 'Luzern', 'Suisse', 6300, 0, 1),
(976, 'Valiant Bank AG', 'Ohmstalerstrasse 9', 'Postfach', '6247', 'Schötz', 'Suisse', 6300, 0, 1),
(977, 'Valiant Bank AG', 'Bahnhofstrasse 12', 'Postfach', '6210', 'Sursee', 'Suisse', 6300, 0, 1),
(978, 'Valiant Bank AG', 'Bruggmatt 1', 'Postfach', '6130', 'Willisau', 'Suisse', 6300, 0, 1),
(979, 'Valiant Bank AG', 'Entlebucherstrasse 1', 'Postfach', '6110', 'Wolhusen', 'Suisse', 6300, 0, 1),
(980, 'Valiant Bank AG', 'Luzernstrasse 1', 'Postfach', '6144', 'Zell LU', 'Suisse', 6300, 0, 1),
(981, 'Valiant Bank AG', 'Pilatusstrasse 39', 'Postfach', '6002', 'Luzern', 'Suisse', 6300, 0, 1),
(982, 'Valiant Bank AG', 'Oberstadt 10', 'Postfach', '6204', 'Sempach', 'Suisse', 6300, 0, 1),
(983, 'Valiant Bank AG', 'Tschannhof', 'Postfach', '6033', 'Buchrain', 'Suisse', 6300, 0, 1),
(984, 'Valiant Bank AG', 'Luzernerstrasse 8', 'Postfach', '6045', 'Meggen', 'Suisse', 6300, 0, 1),
(985, 'Valiant Bank AG', 'Bankstrasse 1', 'Postfach', '6281', 'Hochdorf', 'Suisse', 6300, 0, 1),
(986, 'Valiant Bank AG', 'Hellbühlerstrasse 2', 'Postfach', '6017', 'Ruswil', 'Suisse', 6300, 0, 1),
(987, 'Banque Valiant SA', 'Rue de Romont 6', 'Case postale 1591', '1701', 'Fribourg', 'Suisse', 6300, 0, 1),
(988, 'Valiant Bank AG', 'Citypark, Gartenstra', '', '6301', 'Zug', 'Suisse', 6300, 0, 1),
(989, 'Valiant Bank AG', 'Stadtturmstrasse 8', 'Postfach 1457', '5401', 'Baden', 'Suisse', 6300, 0, 1),
(990, 'Banque Valiant SA', 'Grand-Rue 15', 'Case postale 571', '1630', 'Bulle 1', 'Suisse', 6300, 0, 1),
(991, 'Valiant Bank AG', 'Zentr. Kirschgarten,', 'Postfach', '4010', 'Basel', 'Suisse', 6300, 0, 1),
(992, 'Valiant Bank AG', 'Simmengasse 1', 'Postfach 368', '3770', 'Zweisimmen', 'Suisse', 6300, 0, 1),
(993, 'Valiant Bank AG', 'Banhhofstrasse 57', 'Postfach', '2501', 'Biel/Bienne', 'Suisse', 6300, 0, 1),
(994, 'Valiant Bank AG', 'Röschenzstrasse 12', '', '4242', 'Laufen', 'Suisse', 6300, 0, 1),
(995, 'Valiant Bank AG', 'Central 1', '', '4226', 'Breitenbach', 'Suisse', 6300, 0, 1),
(996, 'Valiant Bank AG', 'Hauptstrasse 8', '', '4153', 'Reinach BL', 'Suisse', 6300, 0, 1),
(997, 'Banque Valiant SA', 'Rue de la Plaine 5', '', '1401', 'Yverdon-les-Bains', 'Suisse', 6300, 0, 1),
(998, 'Banque Valiant SA', 'Rue du Seyon 1', '', '2001', 'Neuchâtel', 'Suisse', 6300, 0, 1),
(999, 'Banque Valiant SA', 'Route de l&apos;Egli', '', '1678', 'Siviriez', 'Suisse', 6300, 0, 1),
(1000, 'Banque Valiant SA', 'Rue de la Molière 24', 'Case postale', '2800', 'Delémont', 'Suisse', 6300, 0, 1),
(1001, 'Valiant Bank AG', 'St. Niklausstrasse 1', '', '4500', 'Solothurn', 'Suisse', 6300, 0, 1),
(1002, 'Valiant Bank AG (ex Valiant Privatbank AG)', 'Bundesplatz 4', 'Postfach', '3001', 'Bern', 'Suisse', 6305, 0, 1),
(1003, 'Valiant Bank AG (ex Valiant Privatbank AG)', 'Laurenzenvorstadt 1', '', '5001', 'Aarau', 'Suisse', 6305, 0, 1),
(1004, 'Valiant Bank AG (ex Valiant Privatbank AG)', 'Pilatusstrasse 39', 'Postfach 4903', '6002', 'Luzern', 'Suisse', 6305, 0, 1),
(1005, 'Banque Valiant SA (ex Banque Valiant Privée SA)', 'Rue de Romont 6', 'Case postale 1579', '1701', 'Fribourg', 'Suisse', 6305, 0, 1),
(1006, 'Valiant Bank AG (ex Valiant Privatbank AG)', 'Citypark, Gartenstra', '', '6301', 'Zug', 'Suisse', 6305, 0, 1),
(1007, 'Valiant Bank AG (ex Valiant Privatbank AG)', 'Dorfstrasse 9', '', '3550', 'Langnau i. E.', 'Suisse', 6305, 0, 1),
(1008, 'Banque Valiant SA (ex Banque Valiant Privée SA)', 'Rue de la Molière 24', 'Case postale 134', '2800', 'Delémont', 'Suisse', 6305, 0, 1),
(1009, 'Banque Valiant SA (ex Banque Valiant Privée SA)', 'Rue du Seyon 1', '', '2001', 'Neuchâtel', 'Suisse', 6305, 0, 1),
(1010, 'Banque Valiant SA (ex Banque Valiant Privée SA)', 'Rue de la Plaine 5', '', '1401', 'Yverdon', 'Suisse', 6305, 0, 1),
(1011, 'Bernerland Bank AG', 'Kirchgasse 2', 'Postfach 34', '3454', 'Sumiswald', 'Suisse', 6313, 0, 1),
(1012, 'Bernerland Bank AG', 'Rüegsaustrasse 35', 'Postfach 236', '3415', 'Hasle-Rüegsau', 'Suisse', 6313, 0, 1),
(1013, 'Bernerland Bank AG', 'Dorfstrasse 43', 'Postfach 26', '3432', 'Lützelflüh-Goldbach', 'Suisse', 6313, 0, 1),
(1014, 'Bernerland Bank AG', 'Dorfstrasse 31a', 'Postfach 208', '3457', 'Wasen im Emmental', 'Suisse', 6313, 0, 1),
(1015, 'Bernerland Bank AG', 'Bahnhofstrasse 2', 'Postfach 192', '3360', 'Herzogenbuchsee', 'Suisse', 6313, 0, 1),
(1016, 'Bernerland Bank AG', 'Unterdorfstrasse 9', 'Postfach 74', '4934', 'Madiswil', 'Suisse', 6313, 0, 1),
(1017, 'Bernerland Bank AG', 'Ersigenstrasse 4', 'Postfach 325', '3422', 'Kirchberg', 'Suisse', 6313, 0, 1),
(1018, 'Bernerland Bank AG', 'Kornhausgasse 4', 'Postfach', '3400', 'Burgdorf', 'Suisse', 6313, 0, 1),
(1019, 'Bernerland Bank AG', 'Marktgasse 5', 'Postfach', '4900', 'Langenthal', 'Suisse', 6313, 0, 1),
(1020, 'Bernerland Bank AG', 'Lütoldstrasse 1', 'Postfach 34', '3454', 'Sumiswald', 'Suisse', 6313, 0, 1),
(1021, 'Bernerland Bank AG', 'Schlossstrasse 3', '', '3550', 'Langnau i.E.', 'Suisse', 6313, 0, 1),
(1022, 'Bernerland Bank AG', 'Bahnhofstrasse 19', '', '4950', 'Huttwil', 'Suisse', 6313, 0, 1),
(1023, 'Clientis AG', 'Gurtengasse 6', 'Postfach 252', '3000', 'Bern 7', 'Suisse', 6336, 0, 1),
(1024, 'B, Saanen Bank AG', 'Bahnhofstrasse 2', 'Postfach 7', '3792', 'Saanen', 'Suisse', 6342, 0, 1),
(1025, 'B, Saanen Bank AG', 'Mühlematte', 'Postfach', '3782', 'Lauenen b. Gstaad', 'Suisse', 6342, 0, 1),
(1026, 'B, Saanen Bank AG', 'Gsteigstrasse 9', '', '3785', 'Gsteig b. Gstaad', 'Suisse', 6342, 0, 1),
(1027, 'B, Saanen Bank AG', 'Promenade 52', 'Postfach 96', '3780', 'Gstaad', 'Suisse', 6342, 0, 1),
(1028, 'B, Saanen Bank AG', 'Dorfstrasse 52', 'Postfach', '3778', 'Schönried', 'Suisse', 6342, 0, 1),
(1029, 'Bank SLM AG', 'Dorfplatz 5', 'Postfach 1080', '3110', 'Münsingen', 'Suisse', 6363, 0, 1),
(1030, 'Bank SLM AG', 'Bahnhofstrasse 13', '', '3076', 'Worb', 'Suisse', 6363, 0, 1),
(1031, 'Bank SLM AG', 'Bernstrasse 40', '', '3114', 'Wichtrach', 'Suisse', 6363, 0, 1),
(1032, 'Bank SLM AG', 'Emmentalstrasse 15', '', '3510', 'Konolfingen', 'Suisse', 6363, 0, 1),
(1033, 'Bank SLM AG', 'Kirchgasse 5', '', '3116', 'Kirchdorf BE', 'Suisse', 6363, 0, 1),
(1034, 'Spar+Leihkasse Riggisberg AG', 'Grabenstrasse 7', 'Postfach', '3132', 'Riggisberg', 'Suisse', 6374, 0, 1),
(1035, 'Burgerliche Ersparniskasse Bern Genossenschaft', 'Marktgasse 37', 'Postfach 6362', '3001', 'Bern', 'Suisse', 6382, 0, 1),
(1036, 'Ersparniskasse Affoltern i. E. AG', 'Postfach', '', '3462', 'Weier im Emmental', 'Suisse', 6387, 0, 1),
(1037, 'Entris Banking AG', 'Mattenstrasse 8', 'Abteilung Giroorgani', '3073', 'Gümligen', 'Suisse', 6395, 0, 1),
(1038, 'Clientis Sparkasse Oftringen Genossenschaft', 'Baslerstrasse 1', 'Postfach', '4665', 'Oftringen', 'Suisse', 6428, 0, 1),
(1039, 'Clientis Bank im Thal AG', 'Goldgasse 11', 'Postfach 527', '4710', 'Balsthal', 'Suisse', 6434, 0, 1),
(1040, 'Bank Oberaargau AG', 'Stadthausstrasse 1', 'Postfach', '4950', 'Huttwil', 'Suisse', 6450, 0, 1),
(1041, 'Bank Oberaargau AG', 'Langenthalstrasse 33', 'Postfach', '4912', 'Aarwangen', 'Suisse', 6450, 0, 1),
(1042, 'Bank Oberaargau AG', 'Huttwilstrasse 24', 'Postfach', '4932', 'Lotzwil', 'Suisse', 6450, 0, 1),
(1043, 'Bank Oberaargau AG', 'Bahnhofstrasse 9', 'Postfach', '4938', 'Rohrbach', 'Suisse', 6450, 0, 1),
(1044, 'Bank Oberaargau AG', 'Dorfstrasse 76', 'Postfach', '4917', 'Melchnau', 'Suisse', 6450, 0, 1),
(1045, 'Bank Oberaargau AG', 'Jurastrasse 29', 'Postfach', '4900', 'Langenthal', 'Suisse', 6450, 0, 1),
(1046, 'Bank Oberaargau AG', 'Obere Dürrmühlestras', 'Postfach', '4704', 'Niederbipp', 'Suisse', 6450, 0, 1),
(1047, 'Bank Oberaargau AG', 'Dorfstrass 2', 'Postfach', '4914', 'Roggwil BE', 'Suisse', 6450, 0, 1),
(1048, 'Bank Oberaargau AG', 'Bernstrasse 29', 'Postfach 275', '3360', 'Herzogenbuchsee', 'Suisse', 6450, 0, 1),
(1049, 'Clientis Bank Küttigen-Erlinsbach AG', 'Hauptstrasse 10', 'Postfach', '5024', 'Küttigen', 'Suisse', 6575, 0, 1),
(1050, 'Clientis Bank Küttigen-Erlinsbach AG', 'Ochsenweg 1', 'Postfach 186', '5018', 'Erlinsbach', 'Suisse', 6575, 0, 1),
(1051, 'Bank Leerau Genossenschaft', 'Dorfstrasse 162', 'Postfach 1', '5054', 'Kirchleerau', 'Suisse', 6588, 0, 1),
(1052, 'Bank Leerau Genossenschaft', 'Dorfstrasse 38', 'Postfach', '5040', 'Schöftland', 'Suisse', 6588, 0, 1),
(1053, 'Sparkasse Schwyz AG', 'Herrengasse 23', 'Postfach 564', '6431', 'Schwyz', 'Suisse', 6633, 0, 1),
(1054, 'Sparkasse Schwyz AG', 'Bahnhofstrasse 5', 'Postfach 562', '6440', 'Brunnen', 'Suisse', 6633, 0, 1),
(1055, 'Sparkasse Schwyz AG', 'Centralstrasse 18', 'Postfach 441', '6410', 'Goldau', 'Suisse', 6633, 0, 1),
(1056, 'Sparkasse Schwyz AG', 'Unterdorf 16', 'Postfach 432', '6403', 'Küssnacht', 'Suisse', 6633, 0, 1),
(1057, 'Sparkasse Schwyz AG', 'Hauptplatz 3', 'Postfach 564', '6431', 'Schwyz', 'Suisse', 6633, 0, 1),
(1058, 'Sparkasse Engelberg AG', 'Dorfstrasse 34', 'Postfach 357', '6391', 'Engelberg', 'Suisse', 6666, 0, 1),
(1059, 'Clientis EB Entlebucher Bank AG', 'Hauptstrasse 32', 'Postfach 267', '6170', 'Schüpfheim', 'Suisse', 6670, 0, 1),
(1060, 'Clientis EB Entlebucher Bank AG', 'Dorf', 'Postfach', '6196', 'Marbach LU', 'Suisse', 6670, 0, 1),
(1061, 'Clientis EB Entlebucher Bank AG', 'Hellbühlstrasse 8', '', '6102', 'Malters', 'Suisse', 6670, 0, 1),
(1062, 'Clientis EB Entlebucher Bank AG', 'Dorf 48', 'Postfach 94', '6162', 'Entlebuch', 'Suisse', 66701, 0, 1),
(1063, 'Clientis EB Entlebucher Bank AG', 'Bahnhofstrasse 2', 'Postfach', '6182', 'Escholzmatt', 'Suisse', 66702, 0, 1),
(1064, 'Triba Partner Bank AG', 'Kantonsstrasse 60a', 'Postfach', '6234', 'Triengen', 'Suisse', 6690, 0, 1),
(1065, 'Triba Partner Bank AG', 'Schlierbacherstrasse', 'Postfach', '6233', 'Büron', 'Suisse', 66901, 0, 1),
(1066, 'Triba Partner Bank AG', 'Kirchstrasse 15', 'Postfach', '6244', 'Nebikon', 'Suisse', 66902, 0, 1),
(1067, 'Triba Partner Bank AG', 'Bahnhofstrasse 10', 'Postfach', '6260', 'Reiden', 'Suisse', 66905, 0, 1),
(1068, 'Triba Partner Bank AG', 'Bahnhofstrasse 9', 'Postfach', '6203', 'Sempach Station', 'Suisse', 66906, 0, 1),
(1069, 'Triba Partner Bank AG', 'Kantonsstrasse 60', 'Postfach', '6234', 'Triengen', 'Suisse', 66907, 0, 1),
(1070, 'RB, Glarner Regionalbank Genossenschaft', 'Bahnhofstrasse 25', 'Postfach', '8762', 'Schwanden', 'Suisse', 6807, 0, 1),
(1071, 'RB, Glarner Regionalbank Genossenschaft', 'Dorfstrasse 44', '', '8767', 'Elm', 'Suisse', 6807, 0, 1),
(1072, 'RB, Glarner Regionalbank Genossenschaft', 'Sernftalstrasse 103', '', '8765', 'Engi', 'Suisse', 6807, 0, 1),
(1073, 'RB, Glarner Regionalbank Genossenschaft', 'Burgstrasse 16', 'Postfach', '8750', 'Glarus', 'Suisse', 6807, 0, 1),
(1074, 'RB, Glarner Regionalbank Genossenschaft', 'Hauptstrasse 41A', 'GRB Glarner Regional', '8867', 'Niederurnen', 'Suisse', 6807, 0, 1),
(1075, 'Bank Sparhafen', 'Fraumünsterstrasse 2', 'Postfach', '8001', 'Zürich', 'Suisse', 6808, 0, 1),
(1076, 'Sparcassa 1816 Genossenschaft', 'Zugerstrasse 18', 'Postfach', '8820', 'Wädenswil', 'Suisse', 6814, 0, 1),
(1077, 'Sparcassa 1816 Genossenschaft', 'Dorfstrasse 11a', 'Postfach', '8805', 'Richterswil', 'Suisse', 68141, 0, 1),
(1078, 'Sparcassa 1816 Genossenschaft', 'Bahnhofplatz 9', 'Postfach', '8910', 'Affoltern am Albis', 'Suisse', 68142, 0, 1),
(1079, 'Sparcassa 1816 Genossenschaft', 'Stationsstrasse 7', 'Postfach', '8907', 'Wettswil', 'Suisse', 68143, 0, 1),
(1080, 'Sparcassa 1816 Genossenschaft', 'Albisstrasse 5', 'Postfach', '8932', 'Mettmenstetten', 'Suisse', 68144, 0, 1),
(1081, 'BANK ZIMMERBERG AG', 'Dorfplatz 1', 'Postfach', '8810', 'Horgen 1', 'Suisse', 6824, 0, 1),
(1082, 'BANK, ZIMMERBERG AG', 'Alte Landstrasse 29', 'Postfach', '8942', 'Oberrieden', 'Suisse', 68241, 0, 1),
(1083, 'BANK, ZIMMERBERG AG', 'Vorderi Siten 1', 'Postfach', '8816', 'Hirzel', 'Suisse', 68242, 0, 1),
(1084, 'Regiobank Männedorf AG', 'Bahnhofstrasse 14', 'Postfach 831', '8708', 'Männedorf', 'Suisse', 6828, 0, 1),
(1085, 'Lienhardt &amp; Partner Privatbank Zürich AG', 'Rämistrasse 23', 'Postfach', '8024', 'Zürich', 'Suisse', 6830, 0, 1),
(1086, 'Ersparniskasse Schaffhausen AG', 'Münsterplatz 34', 'Postfach 372', '8201', 'Schaffhausen', 'Suisse', 6835, 0, 1),
(1087, 'Ersparniskasse Schaffhausen AG', 'Schaffhauserstrasse ', '', '8451', 'Kleinandelfingen', 'Suisse', 6835, 0, 1),
(1088, 'Clientis Zürcher Regionalbank Genossenschaft', 'Bahnhofstrasse 3', 'Postfach', '8620', 'Wetzikon ZH', 'Suisse', 6850, 0, 1),
(1089, 'Clientis Zürcher Regionalbank Genossenschaft', 'Bahnhofstrasse 7', '', '8340', 'Hinwil', 'Suisse', 6850, 0, 1),
(1090, 'Clientis Zürcher Regionalbank Genossenschaft', 'Rütistrasse 9', '', '8636', 'Wald ZH', 'Suisse', 6850, 0, 1),
(1091, 'Clientis Zürcher Regionalbank Genossenschaft', 'Ferrachstrasse 8', '', '8630', 'Rüti ZH', 'Suisse', 6850, 0, 1),
(1092, 'Clientis Zürcher Regionalbank Genossenschaft', 'Dorfstrasse 10', '', '8608', 'Bubikon', 'Suisse', 6850, 0, 1),
(1093, 'Clientis Zürcher Regionalbank Genossenschaft', 'Bahnhofstrasse 16', '', '8330', 'Pfäffikon ZH', 'Suisse', 6850, 0, 1),
(1094, 'Clientis Zürcher Regionalbank Genossenschaft', 'Bruggwiesenstrasse 5', '', '8307', 'Effretikon', 'Suisse', 6850, 0, 1),
(1095, 'Clientis Zürcher Regionalbank Genossenschaft', 'Dorfstrasse 46', '', '8494', 'Bauma', 'Suisse', 6850, 0, 1),
(1096, 'Clientis Zürcher Regionalbank Genossenschaft', 'Usterstrasse 11', '', '8308', 'Illnau', 'Suisse', 6850, 0, 1),
(1097, 'Clientis Zürcher Regionalbank Genossenschaft', 'Kempttalstrasse 48', '', '8320', 'Fehraltorf', 'Suisse', 6850, 0, 1),
(1098, 'Clientis Zürcher Regionalbank Genossenschaft', 'Untere Heslibachstra', 'Postfach 1508', '8700', 'Küsnacht ZH', 'Suisse', 6850, 0, 1),
(1099, 'Clientis Zürcher Regionalbank Genossenschaft', 'Goethestrasse 18', '', '8001', 'Zürich', 'Suisse', 6850, 0, 1),
(1100, 'S, Bank Schaffhausen AG', 'Heerengarten 16', 'Postfach', '8215', 'Hallau', 'Suisse', 6858, 0, 1),
(1101, 'S, Bank Schaffhausen AG', 'Poststrasse 38', 'Postfach 134', '8226', 'Schleitheim', 'Suisse', 6858, 0, 1),
(1102, 'S, Bank Schaffhausen AG', 'Hauptstrasse 29', 'Postfach', '8224', 'Löhningen', 'Suisse', 6858, 0, 1),
(1103, 'S, Bank Schaffhausen AG', 'Hauptstrasse 45', 'Postfach 36', '8217', 'Wilchingen', 'Suisse', 6858, 0, 1),
(1104, 'S, Bank Schaffhausen AG', 'Zelgstrasse 8', 'Postfach 205', '8222', 'Beringen', 'Suisse', 6858, 0, 1),
(1105, 'S, Bank Schaffhausen AG', 'Klettgauerplatz 5', 'Postfach 74', '8213', 'Neunkirch', 'Suisse', 6858, 0, 1),
(1106, 'S, Bank Schaffhausen AG', 'Industriestrasse 12', 'Postfach 1034', '8212', 'Neuhausen am Rheinfall', 'Suisse', 6858, 0, 1),
(1107, 'S, Bank Schaffhausen AG', 'Postfach 76', 'Spitalstrasse 5', '8201', 'Schaffhausen', 'Suisse', 6858, 0, 1),
(1108, 'Spar- und Leihkasse Thayngen AG', 'Bahnhofstrasse 32', 'Postfach 200', '8240', 'Thayngen', 'Suisse', 6866, 0, 1),
(1109, 'Spar- und Leihkasse Thayngen AG', 'Hauptstrasse 52', 'Postfach', '8232', 'Merishausen', 'Suisse', 6866, 0, 1),
(1110, 'acrevis Bank AG', 'Schulstrasse 21', 'Postfach 133', '8542', 'Wiesendangen', 'Suisse', 6873, 0, 1),
(1111, 'Leihkasse Stammheim AG', 'Hauptstrasse 6', 'Postfach', '8477', 'Oberstammheim', 'Suisse', 6875, 0, 1),
(1112, 'Zürcher Landbank AG', 'Lindenplatz 3', 'Postfach 373', '8353', 'Elgg', 'Suisse', 6877, 0, 1),
(1113, 'Zürcher Landbank AG', 'St. Gallerstrasse 66', 'Postfach 83', '8352', 'Elsau', 'Suisse', 6877, 0, 1),
(1114, 'Zürcher Landbank AG', 'Hauptstrasse 9', '', '8545', 'Rickenbach b. Winterthur', 'Suisse', 6877, 0, 1),
(1115, 'Zürcher Landbank AG', 'Winterthurstrasse 8', '', '8413', 'Neftenbach', 'Suisse', 6877, 0, 1),
(1116, 'Bank BSU Genossenschaft', 'Bankstrasse 21', 'Postfach', '8610', 'Uster 1', 'Suisse', 6888, 0, 1),
(1117, 'Bank BSU Genossenschaft', 'Bahnhofstrasse 36', 'Postfach', '8600', 'Dübendorf', 'Suisse', 6888, 0, 1),
(1118, 'Bank BSU Genossenschaft', 'Lindenstrasse 7', '', '8604', 'Volketswil', 'Suisse', 6888, 0, 1),
(1119, 'acrevis Bank AG', 'Marktplatz 1', 'Postfach', '9004', 'St. Gallen', 'Suisse', 6900, 0, 1),
(1120, 'acrevis Bank AG', 'St. Gallerstrasse 7', '', '9300', 'Wittenbach SG', 'Suisse', 6900, 0, 1),
(1121, 'acrevis Bank AG', 'Landstrasse 6', '', '9606', 'Bütschwil', 'Suisse', 6900, 0, 1),
(1122, 'acrevis Bank AG', 'Mittlere Bahnhofstra', '', '8853', 'Lachen SZ', 'Suisse', 6900, 0, 1),
(1123, 'acrevis Bank AG', 'Churerstrasse 24', '', '8808', 'Pfäffikon SZ', 'Suisse', 6900, 0, 1),
(1124, 'acrevis Bank AG', 'Poststrasse 4', '', '9201', 'Gossau', 'Suisse', 6900, 0, 1),
(1125, 'acrevis Bank AG', 'Hauptplatz 6', '', '8640', 'Rapperswil SG', 'Suisse', 6900, 0, 1),
(1126, 'acrevis Bank AG', 'Lerchenfeldstrasse 9', '', '9500', 'Wil SG', 'Suisse', 6900, 0, 1),
(1127, 'acrevis Bank AG', 'Marktplatz 1', 'Postfach', '9004', 'St. Gallen', 'Suisse', 6910, 0, 1),
(1128, 'Alpha RHEINTAL Bank AG', 'Bahnhofstrasse 2', '', '9435', 'Heerbrugg', 'Suisse', 6920, 0, 1),
(1129, 'Alpha RHEINTAL Bank AG', 'Bahnhofplatz', '', '9430', 'St. Margrethen SG', 'Suisse', 6920, 0, 1),
(1130, 'Alpha RHEINTAL Bank AG', 'Bahnhofstrasse 7', '', '9443', 'Widnau', 'Suisse', 6920, 0, 1),
(1131, 'Alpha RHEINTAL Bank AG', 'Staatsstrasse 103', 'Postfach', '9463', 'Oberriet SG', 'Suisse', 6920, 0, 1),
(1132, 'Alpha RHEINTAL Bank AG', 'Turnhallestrasse 1', 'Postfach', '9436', 'Balgach', 'Suisse', 6920, 0, 1),
(1133, 'Alpha RHEINTAL Bank AG', 'Auerstrasse 1', '', '9442', 'Berneck', 'Suisse', 6920, 0, 1),
(1134, 'Clientis Bank Oberuzwil AG', 'Wiesentalstrasse 11', 'Postfach', '9242', 'Oberuzwil', 'Suisse', 6935, 0, 1),
(1135, 'Vadian Bank AG', 'Webergasse 8', 'Postfach 2148', '9001', 'St. Gallen', 'Suisse', 6950, 0, 1),
(1136, 'Clientis Bank Toggenburg AG', 'Gähwilerstrasse 7', 'Postfach', '9533', 'Kirchberg SG', 'Suisse', 6955, 0, 1),
(1137, 'Clientis Bank Toggenburg AG', 'Wilerstrasse 15', 'Postfach', '9602', 'Bazenheid', 'Suisse', 6955, 0, 1),
(1138, 'Clientis Bank Toggenburg AG', 'Kirchbergerstrasse 6', '', '9534', 'Gähwil', 'Suisse', 6955, 0, 1),
(1139, 'Clientis Bank Toggenburg AG', 'Lindenplatz 2', '', '9607', 'Mosnang', 'Suisse', 6955, 0, 1),
(1140, 'Clientis Bank Toggenburg AG', 'Bahnhofstrasse 16', 'Postfach', '9630', 'Wattwil', 'Suisse', 6955, 0, 1),
(1141, 'Bank in Zuzwil', 'Mitteldorfstrasse 48', 'Postfach', '9524', 'Zuzwil SG', 'Suisse', 6964, 0, 1),
(1142, 'Clientis Bank Thur Genossenschaft', 'Kappler Strasse 21', 'Postfach', '9642', 'Ebnat-Kappel', 'Suisse', 6977, 0, 1),
(1143, 'Clientis Bank Thur Genossenschaft', 'Hauptstrasse 13', '', '9657', 'Unterwasser', 'Suisse', 6977, 0, 1),
(1144, 'Biene Bank im Rheintal Genossenschaft', 'Rorschacherstrasse 9', 'Postfach', '9450', 'Altstätten SG', 'Suisse', 6980, 0, 1),
(1145, 'Biene Bank im Rheintal Genossenschaft', 'Staatsstrasse 100', 'Postfach', '9464', 'Rüthi SG', 'Suisse', 6980, 0, 1),
(1146, 'Biene Bank im Rheintal Genossenschaft', 'Bahnhofstrasse 20', 'Postfach', '9443', 'Widnau', 'Suisse', 6980, 0, 1),
(1147, 'Zürcher Kantonalbank', 'Postfach', '', '8010', 'Zürich', 'Suisse', 700, 0, 1),
(1148, 'Zürcher Kantonalbank', 'Wiedikon (ex. Enge)', 'Postfach', '8036', 'Zürich', 'Suisse', 702, 0, 1),
(1149, 'Zürcher Kantonalbank', '(Limmatquai)', 'Postfach', '8010', 'Zürich', 'Suisse', 703, 0, 1),
(1150, 'Zürcher Kantonalbank', '(Universitätsspital)', 'Postfach', '8010', 'Zürich', 'Suisse', 703, 0, 1),
(1151, 'Zürcher Kantonalbank', 'Postfach', '', '8712', 'Stäfa', 'Suisse', 704, 0, 1),
(1152, 'Zürcher Kantonalbank', 'Postfach', '', '8604', 'Volketswil', 'Suisse', 705, 0, 1),
(1153, 'Zürcher Kantonalbank', 'Postfach', '', '8953', 'Dietikon 1', 'Suisse', 706, 0, 1),
(1154, 'Zürcher Kantonalbank', 'Postfach', '', '8954', 'Geroldswil', 'Suisse', 706, 0, 1),
(1155, 'Zürcher Kantonalbank', 'Affoltern', 'Postfach', '8046', 'Zürich', 'Suisse', 708, 0, 1),
(1156, 'Zürcher Kantonalbank', 'Postfach', '', '8902', 'Urdorf', 'Suisse', 709, 0, 1),
(1157, 'Zürcher Kantonalbank', 'Postfach', '', '8126', 'Zumikon', 'Suisse', 710, 0, 1),
(1158, 'Zürcher Kantonalbank', 'Postfach', '', '8125', 'Zollikerberg', 'Suisse', 710, 0, 1),
(1159, 'Zürcher Kantonalbank', 'Altstetten', 'Postfach', '8048', 'Zürich', 'Suisse', 711, 0, 1),
(1160, 'Zürcher Kantonalbank', '(Aussersihl)', 'Postfach', '8036', 'Zürich', 'Suisse', 712, 0, 1),
(1161, 'Zürcher Kantonalbank', 'Neumünster', 'Postfach', '8032', 'Zürich', 'Suisse', 713, 0, 1),
(1162, 'Zürcher Kantonalbank', 'Unterstrass', 'Postfach', '8042', 'Zürich', 'Suisse', 714, 0, 1),
(1163, 'Zürcher Kantonalbank', 'Wiedikon', 'Postfach', '8036', 'Zürich', 'Suisse', 715, 0, 1),
(1164, 'Zürcher Kantonalbank', 'Prime Tower, Hardstr', 'Postfach', '8005', 'Zürich', 'Suisse', 716, 0, 1),
(1165, 'Zürcher Kantonalbank', 'Wollishofen', 'Postfach', '8038', 'Zürich', 'Suisse', 717, 0, 1),
(1166, 'Zürcher Kantonalbank', 'Postfach', '', '8802', 'Kilchberg ZH', 'Suisse', 717, 0, 1),
(1167, 'Zürcher Kantonalbank', 'Schwamendingen', 'Postfach', '8051', 'Zürich', 'Suisse', 718, 0, 1),
(1168, 'Zürcher Kantonalbank', 'Seebach', 'Postfach', '8052', 'Zürich', 'Suisse', 719, 0, 1),
(1169, 'Zürcher Kantonalbank', 'Albisrieden', 'Postfach', '8047', 'Zürich', 'Suisse', 720, 0, 1),
(1170, 'Zürcher Kantonalbank', 'Postfach', '', '8910', 'Affoltern am Albis', 'Suisse', 721, 0, 1),
(1171, 'Zürcher Kantonalbank', 'Postfach', '', '8906', 'Bonstetten', 'Suisse', 721, 0, 1),
(1172, 'Zürcher Kantonalbank', 'Postfach', '', '8915', 'Hausen am Albis', 'Suisse', 721, 0, 1),
(1173, 'Zürcher Kantonalbank', 'Postfach', '', '8450', 'Andelfingen', 'Suisse', 722, 0, 1),
(1174, 'Zürcher Kantonalbank', 'Postfach', '', '8460', 'Marthalen', 'Suisse', 722, 0, 1),
(1175, 'Zürcher Kantonalbank', 'Postfach', '', '8494', 'Bauma', 'Suisse', 723, 0, 1),
(1176, 'Zürcher Kantonalbank', 'Postfach', '', '8344', 'Bäretswil', 'Suisse', 723, 0, 1),
(1177, 'Zürcher Kantonalbank', 'Postfach', '', '8180', 'Bülach', 'Suisse', 724, 0, 1),
(1178, 'Zürcher Kantonalbank', 'Postfach', '', '8424', 'Embrach', 'Suisse', 724, 0, 1),
(1179, 'Zürcher Kantonalbank', 'Postfach', '', '8427', 'Freienstein', 'Suisse', 724, 0, 1),
(1180, 'Zürcher Kantonalbank', 'Postfach', '', '8157', 'Dielsdorf', 'Suisse', 725, 0, 1),
(1181, 'Zürcher Kantonalbank', 'Postfach', '', '8172', 'Niederglatt ZH', 'Suisse', 725, 0, 1),
(1182, 'Zürcher Kantonalbank', 'Postfach', '', '8153', 'Rümlang', 'Suisse', 725, 0, 1),
(1183, 'Zürcher Kantonalbank', 'Postfach', '', '8810', 'Horgen 1', 'Suisse', 726, 0, 1),
(1184, 'Zürcher Kantonalbank', 'Postfach', '', '8706', 'Meilen', 'Suisse', 727, 0, 1),
(1185, 'Zürcher Kantonalbank', 'Postfach', '', '8704', 'Herrliberg', 'Suisse', 727, 0, 1),
(1186, 'Zürcher Kantonalbank', 'Oerlikon', 'Postfach', '8050', 'Zürich', 'Suisse', 728, 0, 1),
(1187, 'Zürcher Kantonalbank', 'Postfach', '', '8630', 'Rüti ZH', 'Suisse', 729, 0, 1),
(1188, 'Zürcher Kantonalbank', 'Postfach', '', '8625', 'Gossau ZH', 'Suisse', 729, 0, 1),
(1189, 'Zürcher Kantonalbank', 'Postfach', '', '8627', 'Grüningen', 'Suisse', 729, 0, 1),
(1190, 'Zürcher Kantonalbank', 'Postfach', '', '8610', 'Uster 1', 'Suisse', 730, 0, 1),
(1191, 'Zürcher Kantonalbank', 'Postfach', '', '8606', 'Greifensee', 'Suisse', 730, 0, 1),
(1192, 'Zürcher Kantonalbank', 'Postfach', '', '8636', 'Wald ZH', 'Suisse', 731, 0, 1),
(1193, 'Zürcher Kantonalbank', 'Postfach', '', '8401', 'Winterthur', 'Suisse', 732, 0, 1),
(1194, 'Zürcher Kantonalbank', 'Postfach', '', '8472', 'Seuzach', 'Suisse', 732, 0, 1),
(1195, 'Zürcher Kantonalbank', 'Kantonsspital', 'Postfach', '8401', 'Winterthur', 'Suisse', 732, 0, 1),
(1196, 'Zürcher Kantonalbank', 'Seen', 'Postfach', '8405', 'Winterthur', 'Suisse', 732, 0, 1),
(1197, 'Zürcher Kantonalbank', 'Wülflingen', 'Postfach', '8408', 'Winterthur', 'Suisse', 732, 0, 1),
(1198, 'Zürcher Kantonalbank', 'Postfach', '', '8307', 'Effretikon', 'Suisse', 733, 0, 1),
(1199, 'Zürcher Kantonalbank', 'Witikon', 'Postfach', '8053', 'Zürich', 'Suisse', 734, 0, 1),
(1200, 'Zürcher Kantonalbank', 'Postfach', '', '8132', 'Egg b. Zürich', 'Suisse', 735, 0, 1),
(1201, 'Zürcher Kantonalbank', 'Höngg', 'Postfach', '8049', 'Zürich', 'Suisse', 736, 0, 1),
(1202, 'Zürcher Kantonalbank', 'Klusplatz', 'Postfach', '8032', 'Zürich', 'Suisse', 737, 0, 1),
(1203, 'Zürcher Kantonalbank', 'Postfach', '', '8152', 'Glattbrugg', 'Suisse', 738, 0, 1),
(1204, 'Zürcher Kantonalbank', 'Postfach 17', '', '8634', 'Hombrechtikon', 'Suisse', 739, 0, 1),
(1205, 'Zürcher Kantonalbank', 'Postfach', '', '8600', 'Dübendorf 1', 'Suisse', 740, 0, 1),
(1206, 'Zürcher Kantonalbank', 'Postfach', '', '8117', 'Fällanden', 'Suisse', 740, 0, 1),
(1207, 'Zürcher Kantonalbank', 'Postfach', '', '8193', 'Eglisau', 'Suisse', 741, 0, 1),
(1208, 'Zürcher Kantonalbank', 'Postfach', '', '8197', 'Rafz', 'Suisse', 741, 0, 1),
(1209, 'Zürcher Kantonalbank', 'Postfach', '', '8320', 'Fehraltorf', 'Suisse', 742, 0, 1),
(1210, 'Zürcher Kantonalbank', 'Postfach', '', '8245', 'Feuerthalen', 'Suisse', 743, 0, 1),
(1211, 'Zürcher Kantonalbank', 'Postfach', '', '8302', 'Kloten', 'Suisse', 744, 0, 1),
(1212, 'Zürcher Kantonalbank', 'Postfach', '', '8700', 'Küsnacht ZH', 'Suisse', 745, 0, 1),
(1213, 'Zürcher Kantonalbank', 'Postfach', '', '8703', 'Erlenbach ZH', 'Suisse', 745, 0, 1),
(1214, 'Zürcher Kantonalbank', 'Postfach', '', '8708', 'Männedorf', 'Suisse', 746, 0, 1),
(1215, 'Zürcher Kantonalbank', 'Postfach', '', '8618', 'Oetwil am See', 'Suisse', 746, 0, 1),
(1216, 'Zürcher Kantonalbank', 'Postfach', '', '8805', 'Richterswil', 'Suisse', 747, 0, 1),
(1217, 'Zürcher Kantonalbank', 'Postfach', '', '8952', 'Schlieren', 'Suisse', 748, 0, 1),
(1218, 'Zürcher Kantonalbank', 'Postfach', '', '8103', 'Unterengstringen', 'Suisse', 748, 0, 1),
(1219, 'Zürcher Kantonalbank', 'Postfach', '', '8800', 'Thalwil', 'Suisse', 749, 0, 1),
(1220, 'Zürcher Kantonalbank', 'Postfach', '', '8488', 'Turbenthal', 'Suisse', 750, 0, 1),
(1221, 'Zürcher Kantonalbank', 'Postfach', '', '8304', 'Wallisellen', 'Suisse', 751, 0, 1),
(1222, 'Zürcher Kantonalbank', 'Postfach', '', '8305', 'Dietlikon', 'Suisse', 751, 0, 1),
(1223, 'Zürcher Kantonalbank', 'Postfach', '', '8330', 'Pfäffikon ZH', 'Suisse', 752, 0, 1),
(1224, 'Zürcher Kantonalbank', 'Oberwinterthur', 'Postfach', '8404', 'Winterthur', 'Suisse', 753, 0, 1),
(1225, 'Zürcher Kantonalbank', 'Postfach', '', '8340', 'Hinwil', 'Suisse', 754, 0, 1),
(1226, 'Zürcher Kantonalbank', 'Postfach', '', '8622', 'Wetzikon ZH 2', 'Suisse', 755, 0, 1),
(1227, 'Zürcher Kantonalbank', 'Postfach', '', '8105', 'Regensdorf 1', 'Suisse', 756, 0, 1),
(1228, 'Zürcher Kantonalbank', 'Postfach', '', '8820', 'Wädenswil', 'Suisse', 757, 0, 1),
(1229, 'Zürcher Kantonalbank', 'Postfach', '', '8134', 'Adliswil 1', 'Suisse', 758, 0, 1),
(1230, 'Zürcher Kantonalbank', 'Postfach', '', '8135', 'Langnau am Albis', 'Suisse', 758, 0, 1),
(1231, 'Zürcher Kantonalbank', 'Postfach', '', '8303', 'Bassersdorf', 'Suisse', 759, 0, 1),
(1232, 'Aargauische Kantonalbank', 'Bahnhofplatz 1', 'Postfach 2104', '5001', 'Aarau', 'Suisse', 761, 0, 1),
(1233, 'Aargauische Kantonalbank', 'Lindenplatz 2', 'Postfach 258', '5722', 'Gränichen', 'Suisse', 761, 0, 1),
(1234, 'Aargauische Kantonalbank', 'Poststrasse 2', 'Postfach 2017', '5600', 'Lenzburg 2', 'Suisse', 761, 0, 1),
(1235, 'Aargauische Kantonalbank', 'Hauptstrasse 60', 'Postfach 27', '5734', 'Reinach AG', 'Suisse', 761, 0, 1),
(1236, 'Aargauische Kantonalbank', 'Tramstrasse 49', 'Postfach 185', '5034', 'Suhr', 'Suisse', 761, 0, 1),
(1237, 'Aargauische Kantonalbank', 'Bruggerstrasse 1', 'Postfach 210', '5103', 'Wildegg', 'Suisse', 761, 0, 1),
(1238, 'Aargauische Kantonalbank', 'Muhenstrasse 13', 'Postfach 68', '5036', 'Oberentfelden', 'Suisse', 761, 0, 1),
(1239, 'Aargauische Kantonalbank', 'Lenzburgerstrasse19', '', '5507', 'Mellingen', 'Suisse', 761, 0, 1),
(1240, 'Aargauische Kantonalbank', 'Schulstrasse 1', 'Postfach', '5415', 'Nussbaumen b. Baden', 'Suisse', 761, 0, 1),
(1241, 'Aargauische Kantonalbank', 'Landstrasse 88', 'Postfach 32', '5430', 'Wettingen 1', 'Suisse', 761, 0, 1),
(1242, 'Aargauische Kantonalbank', 'Bahnhofstrasse 23', 'Postfach 32', '5201', 'Brugg AG', 'Suisse', 761, 0, 1),
(1243, 'Aargauische Kantonalbank', 'Kaiserstrasse 8', 'Postfach 32', '4310', 'Rheinfelden', 'Suisse', 761, 0, 1),
(1244, 'Aargauische Kantonalbank', 'Bahnhofplatz 2', 'Postfach 1963', '5405', 'Baden', 'Suisse', 761, 0, 1),
(1245, 'Aargauische Kantonalbank', 'Widenplatz 12', 'Postfach', '5070', 'Frick', 'Suisse', 761, 0, 1),
(1246, 'Aargauische Kantonalbank', 'Bahnhofstrasse 8', 'Postfach', '5080', 'Laufenburg', 'Suisse', 761, 0, 1),
(1247, 'Aargauische Kantonalbank', 'Adlerstrasse 2', 'Postfach', '4312', 'Magden', 'Suisse', 761, 0, 1),
(1248, 'Aargauische Kantonalbank', 'Hauptstrasse 13', 'Postfach', '4313', 'Möhlin', 'Suisse', 761, 0, 1),
(1249, 'Aargauische Kantonalbank', 'Bahnhofstrasse 4', 'Postfach', '5610', 'Wohlen AG', 'Suisse', 761, 0, 1),
(1250, 'Aargauische Kantonalbank', 'Zürcherstrasse 1', 'Postfach', '5620', 'Bremgarten', 'Suisse', 761, 0, 1),
(1251, 'Aargauische Kantonalbank', 'Bärenplatz 2', 'Postfach', '5615', 'Fahrwangen', 'Suisse', 761, 0, 1),
(1252, 'Aargauische Kantonalbank', 'Seetalstrasse 7', 'Postfach', '5630', 'Muri AG', 'Suisse', 761, 0, 1),
(1253, 'Aargauische Kantonalbank', 'Mutschellenstrasse 2', 'Postfach 14', '8965', 'Mutschellen', 'Suisse', 761, 0, 1),
(1254, 'Aargauische Kantonalbank', 'Luzernstrasse 20', 'Postfach', '5643', 'Sins', 'Suisse', 761, 0, 1),
(1255, 'Aargauische Kantonalbank', 'Lindenplatz 18', 'Postfach 1575', '4800', 'Zofingen', 'Suisse', 761, 0, 1),
(1256, 'Aargauische Kantonalbank', 'Strählgasse 5', 'Postfach 231', '4805', 'Brittnau', 'Suisse', 761, 0, 1),
(1257, 'Aargauische Kantonalbank', 'Zentrum EO-Tychboden', 'Postfach', '4665', 'Oftringen', 'Suisse', 761, 0, 1),
(1258, 'Aargauische Kantonalbank', 'Bernstrasse 122', 'Postfach 218', '4852', 'Rothrist', 'Suisse', 761, 0, 1),
(1259, 'Aargauische Kantonalbank', 'Hauptgasse 29', 'Postfach 160', '4600', 'Olten', 'Suisse', 761, 0, 1),
(1260, 'Aargauische Kantonalbank', 'Oberrohrdorferstrass', 'Postfach', '5442', 'Fislisbach', 'Suisse', 761, 0, 1),
(1261, 'Aargauische Kantonalbank', 'Flachsacherstrasse 1', 'Postfach 370', '5242', 'Birr-Lupfig', 'Suisse', 761, 0, 1),
(1262, 'Aargauische Kantonalbank', 'Hauptstrasse 22', 'Postfach', '5312', 'Döttingen', 'Suisse', 761, 0, 1),
(1263, 'Aargauische Kantonalbank', 'Bahnhofplatz 2', 'Postfach 1963', '5401', 'Baden', 'Suisse', 76120, 0, 1),
(1264, 'Aargauische Kantonalbank', 'Landstrasse 88', 'Postfach 32', '5430', 'Wettingen 1', 'Suisse', 76121, 0, 1),
(1265, 'Aargauische Kantonalbank', 'Bahnhofstrasse 23', 'Postfach 23', '5201', 'Brugg AG', 'Suisse', 76130, 0, 1),
(1266, 'Aargauische Kantonalbank', 'Kaiserstrasse 8', 'Postfach 32', '4310', 'Rheinfelden 1', 'Suisse', 76140, 0, 1),
(1267, 'Aargauische Kantonalbank', 'Bahnhofstrasse 4', 'Postfach 1544', '5610', 'Wohlen AG 1', 'Suisse', 76150, 0, 1),
(1268, 'Aargauische Kantonalbank', 'Lindenplatz 18', 'Postfach 1575', '4800', 'Zofingen', 'Suisse', 76160, 0, 1),
(1269, 'Aargauische Kantonalbank', 'Hauptgasse 29', 'Postfach 160', '4600', 'Olten', 'Suisse', 76170, 0, 1),
(1270, 'Appenzeller Kantonalbank', 'Postfach', '', '9050', 'Appenzell', 'Suisse', 763, 0, 1),
(1271, 'Appenzeller Kantonalbank', 'Postfach', '', '9054', 'Haslen AI', 'Suisse', 763, 0, 1),
(1272, 'Appenzeller Kantonalbank', 'Postfach', '', '9413', 'Oberegg', 'Suisse', 763, 0, 1),
(1273, 'Appenzeller Kantonalbank', 'Postfach', '', '9057', 'Weissbad', 'Suisse', 763, 0, 1),
(1274, 'Banca dello Stato del Cantone Ticino', 'Viale H. Guisan 5', 'Casella postale', '6501', 'Bellinzona', 'Suisse', 764, 0, 1),
(1275, 'Banca dello Stato del Cantone Ticino', 'Casella postale', '', '6780', 'Airolo', 'Suisse', 764, 0, 1),
(1276, 'Banca dello Stato del Cantone Ticino', 'Piazza Collegiata', 'Casella postale', '6501', 'Bellinzona', 'Suisse', 764, 0, 1),
(1277, 'Banca dello Stato del Cantone Ticino', 'Casella postale', '', '6743', 'Bodio TI', 'Suisse', 764, 0, 1),
(1278, 'Banca dello Stato del Cantone Ticino', 'Casella postale', '', '6715', 'Dongio', 'Suisse', 764, 0, 1),
(1279, 'Banca dello Stato del Cantone Ticino', 'Piazza Stefano Frans', '', '6760', 'Faido', 'Suisse', 764, 0, 1),
(1280, 'Banca dello Stato del Cantone Ticino', 'Via Pioda 7', 'Casella postale', '6901', 'Lugano', 'Suisse', 76410, 0, 1),
(1281, 'Banca dello Stato del Cantone Ticino', 'Piazza Riforma', 'Casella postale', '6901', 'Lugano', 'Suisse', 76410, 0, 1),
(1282, 'Banca dello Stato del Cantone Ticino', 'Centro Grancia 1', 'Casella postale', '6916', 'Grancia', 'Suisse', 76410, 0, 1),
(1283, 'Banca dello Stato del Cantone Ticino', 'Via G. Pocobelli 14', 'Casella postale', '6815', 'Melide', 'Suisse', 76410, 0, 1),
(1284, 'Banca dello Stato del Cantone Ticino', 'Molino Nuovo', 'Casella postale', '6900', 'Lugano', 'Suisse', 76411, 0, 1),
(1285, 'Banca dello Stato del Cantone Ticino', 'Via Pietro Fontana', 'Casella postale', '6950', 'Tesserete', 'Suisse', 76412, 0, 1),
(1286, 'Banca dello Stato del Cantone Ticino', 'Via Trevani', 'Casella postale', '6601', 'Locarno', 'Suisse', 76420, 0, 1),
(1287, 'Banca dello Stato del Cantone Ticino', 'Casella postale', '', '6614', 'Brissago', 'Suisse', 76420, 0, 1),
(1288, 'Banca dello Stato del Cantone Ticino', 'Casella postale', '', '6675', 'Cevio', 'Suisse', 76420, 0, 1),
(1289, 'Banca dello Stato del Cantone Ticino', 'Via San Francesco 1', 'Casella postale', '6601', 'Locarno', 'Suisse', 76420, 0, 1),
(1290, 'Banca dello Stato del Cantone Ticino', 'Centro Commerciale C', 'Casella postale', '6616', 'Losone', 'Suisse', 76420, 0, 1),
(1291, 'Banca dello Stato del Cantone Ticino', 'Corso San Gottardo 4', 'Casella postale', '6830', 'Chiasso 1', 'Suisse', 76430, 0, 1),
(1292, 'Banca dello Stato del Cantone Ticino', 'Corso Bello 3', 'Casella postale', '6850', 'Mendrisio', 'Suisse', 76440, 0, 1),
(1293, 'Banca dello Stato del Cantone Ticino', 'Via Pini 2', 'Casella postale', '6710', 'Biasca', 'Suisse', 76450, 0, 1),
(1294, 'Banca dello Stato del Cantone Ticino', 'Viale Papio 5', 'Casella postale', '6612', 'Ascona', 'Suisse', 76460, 0, 1),
(1295, 'Banca dello Stato del Cantone Ticino', 'Via Cantonale', 'Casella postale', '6982', 'Agno', 'Suisse', 76470, 0, 1),
(1296, 'Banque Cantonale du Valais', 'Place des Cèdres 8', 'Case postale 222', '1951', 'Sion/Sitten', 'Suisse', 765, 0, 1),
(1297, 'Walliser Kantonalbank', '', '', '3900', 'Brig/Brigue', 'Suisse', 765, 0, 1),
(1298, 'Walliser Kantonalbank', '', '', '3984', 'Fiesch', 'Suisse', 765, 0, 1),
(1299, 'Banque Cantonale du Valais', '', '', '3904', 'Naters', 'Suisse', 765, 0, 1),
(1300, 'Banque Cantonale du Valais', '', '', '3930', 'Visp/Viège', 'Suisse', 765, 0, 1),
(1301, 'Banque Cantonale du Valais', '', '', '3960', 'Sierre/Siders', 'Suisse', 765, 0, 1),
(1302, 'Banque Cantonale du Valais', '', '', '1920', 'Martigny 1', 'Suisse', 765, 0, 1),
(1303, 'Banque Cantonale du Valais', '', '', '1890', 'St-Maurice', 'Suisse', 765, 0, 1),
(1304, 'Banque Cantonale du Valais', '', '', '1870', 'Monthey', 'Suisse', 765, 0, 1),
(1305, 'Banque Cantonale du Valais', '', '', '3963', 'Crans-Montana 1', 'Suisse', 765, 0, 1),
(1306, 'Banque Cantonale du Valais', '', '', '3963', 'Crans-Montana 2', 'Suisse', 765, 0, 1),
(1307, 'Banque Cantonale du Valais', '', '', '1874', 'Champéry', 'Suisse', 765, 0, 1),
(1308, 'Walliser Kantonalbank', '', '', '3920', 'Zermatt', 'Suisse', 765, 0, 1),
(1309, 'Walliser Kantonalbank', '', '', '3906', 'Saas Fee', 'Suisse', 765, 0, 1),
(1310, 'Walliser Kantonalbank', '', '', '1907', 'Saxon', 'Suisse', 765, 0, 1),
(1311, 'Banque Cantonale du Valais', '', '', '1936', 'Verbier', 'Suisse', 765, 0, 1),
(1312, 'Banque Cantonale du Valais', '', '', '1972', 'Anzère', 'Suisse', 765, 0, 1),
(1313, 'Walliser Kantonalbank', '', '', '3952', 'Susten', 'Suisse', 765, 0, 1),
(1314, 'Walliser Kantonalbank', '', '', '3945', 'Gampel', 'Suisse', 765, 0, 1),
(1315, 'Walliser Kantonalbank', '', '', '3954', 'Leukerbad', 'Suisse', 765, 0, 1),
(1316, 'Banque Cantonale Neuchâteloise', 'Case postale 275', '', '2001', 'Neuchâtel', 'Suisse', 766, 0, 1),
(1317, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2416', 'Brenets, Les', 'Suisse', 766, 0, 1),
(1318, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2053', 'Cernier', 'Suisse', 766, 0, 1),
(1319, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2301', 'Chaux-de-Fonds, La', 'Suisse', 766, 0, 1),
(1320, 'Banque Cantonale Neuchâteloise', 'Trafic des paiements', '', '2013', 'Colombier NE', 'Suisse', 766, 0, 1),
(1321, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2108', 'Couvet', 'Suisse', 766, 0, 1),
(1322, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2114', 'Fleurier', 'Suisse', 766, 0, 1),
(1323, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2525', 'Landeron, Le', 'Suisse', 766, 0, 1),
(1324, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2400', 'Locle, Le', 'Suisse', 766, 0, 1),
(1325, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2074', 'Marin-Epagnier', 'Suisse', 766, 0, 1),
(1326, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2034', 'Peseux', 'Suisse', 766, 0, 1),
(1327, 'Banque Cantonale Neuchâteloise', 'Case postale', '', '2024', 'St-Aubin NE', 'Suisse', 766, 0, 1),
(1328, 'Banque Cantonale Vaudoise', 'St-François', 'Case postale 300', '1001', 'Lausanne', 'Suisse', 767, 0, 1),
(1329, 'Banque Cantonale Vaudoise', 'Athénée', 'Case postale', '1003', 'Lausanne', 'Suisse', 767, 0, 1),
(1330, 'Banque Cantonale Vaudoise', 'Bergières', 'Case postale', '1004', 'Lausanne', 'Suisse', 767, 0, 1),
(1331, 'Banque Cantonale Vaudoise', 'Chauderon', 'Case postale 77', '1000', 'Lausanne 9', 'Suisse', 767, 0, 1),
(1332, 'Banque Cantonale Vaudoise', 'Chuv', 'Case postale', '1005', 'Lausanne', 'Suisse', 767, 0, 1),
(1333, 'Banque Cantonale Vaudoise', 'Pépinet', 'Case postale', '1002', 'Lausanne', 'Suisse', 767, 0, 1),
(1334, 'Banque Cantonale Vaudoise', 'Riponne', 'Case postale', '1005', 'Lausanne', 'Suisse', 767, 0, 1),
(1335, 'Banque Cantonale Vaudoise', 'Bel-Air', 'Case postale', '1002', 'Lausanne', 'Suisse', 76711, 0, 1),
(1336, 'Banque Cantonale Vaudoise', 'WTCL', 'Case postale', '1000', 'Lausanne', 'Suisse', 76711, 0, 1),
(1337, 'Banque Cantonale Vaudoise', 'Case postale', '', '1860', 'Aigle', 'Suisse', 76712, 0, 1),
(1338, 'Banque Cantonale Vaudoise', 'Case postale', '', '1170', 'Aubonne', 'Suisse', 76713, 0, 1),
(1339, 'Banque Cantonale Vaudoise', 'Case postale', '', '1145', 'Bière', 'Suisse', 76713, 0, 1),
(1340, 'Banque Cantonale Vaudoise', 'Case postale', '', '1580', 'Avenches', 'Suisse', 76714, 0, 1),
(1341, 'Banque Cantonale Vaudoise', 'Case postale', '', '1880', 'Bex', 'Suisse', 76715, 0, 1),
(1342, 'Banque Cantonale Vaudoise', 'Case postale', '', '1660', 'Château-d&apos;Oex', 'Suisse', 76716, 0, 1),
(1343, 'Banque Cantonale Vaudoise', 'Case postale', '', '1304', 'Cossonay-Ville', 'Suisse', 76717, 0, 1),
(1344, 'Banque Cantonale Vaudoise', 'Case postale', '', '1315', 'Sarraz, La', 'Suisse', 76717, 0, 1),
(1345, 'Banque Cantonale Vaudoise', 'Case postale', '', '1096', 'Cully', 'Suisse', 76718, 0, 1),
(1346, 'Banque Cantonale Vaudoise', 'Case postale', '', '1040', 'Echallens', 'Suisse', 76719, 0, 1),
(1347, 'Banque Cantonale Vaudoise', 'Case postale', '', '1038', 'Bercher', 'Suisse', 76719, 0, 1),
(1348, 'Banque Cantonale Vaudoise', 'Case postale', '', '1422', 'Grandson', 'Suisse', 76720, 0, 1),
(1349, 'Banque Cantonale Vaudoise', 'Case postale', '', '1095', 'Lutry', 'Suisse', 76721, 0, 1),
(1350, 'Banque Cantonale Vaudoise', 'Case postale', '', '1083', 'Mézières VD', 'Suisse', 76721, 0, 1),
(1351, 'Banque Cantonale Vaudoise', 'Case postale', '', '1820', 'Montreux 1', 'Suisse', 76722, 0, 1),
(1352, 'Banque Cantonale Vaudoise', 'Case postale', '', '1110', 'Morges 1', 'Suisse', 76723, 0, 1),
(1353, 'Banque Cantonale Vaudoise', 'Case postale', '', '1162', 'St-Prex', 'Suisse', 76723, 0, 1),
(1354, 'Banque Cantonale Vaudoise', 'Case postale', '', '1510', 'Moudon', 'Suisse', 76724, 0, 1),
(1355, 'Banque Cantonale Vaudoise', 'Case postale', '', '1260', 'Nyon', 'Suisse', 76725, 0, 1),
(1356, 'Banque Cantonale Vaudoise', 'Case postale', '', '1350', 'Orbe', 'Suisse', 76726, 0, 1),
(1357, 'Banque Cantonale Vaudoise', 'Case postale', '', '1323', 'Romainmôtier', 'Suisse', 76726, 0, 1),
(1358, 'Banque Cantonale Vaudoise', 'Case postale', '', '1610', 'Oron-la-Ville', 'Suisse', 76727, 0, 1),
(1359, 'Banque Cantonale Vaudoise', 'Case postale 64', '', '1530', 'Payerne', 'Suisse', 76728, 0, 1),
(1360, 'Banque Cantonale Vaudoise', 'Case postale', '', '1523', 'Granges-près-Marnand', 'Suisse', 76728, 0, 1),
(1361, 'Banque Cantonale Vaudoise', 'Case postale', '', '1020', 'Renens VD', 'Suisse', 76729, 0, 1),
(1362, 'Banque Cantonale Vaudoise', 'Case postale', '', '1180', 'Rolle', 'Suisse', 76730, 0, 1),
(1363, 'Banque Cantonale Vaudoise', 'Case postale', '', '1450', 'Ste-Croix', 'Suisse', 76731, 0, 1),
(1364, 'Banque Cantonale Vaudoise', 'Case postale', '', '1347', 'Sentier, Le', 'Suisse', 76732, 0, 1),
(1365, 'Banque Cantonale Vaudoise', 'Case postale', '', '1337', 'Vallorbe', 'Suisse', 76733, 0, 1),
(1366, 'Banque Cantonale Vaudoise', 'Case postale', '', '1800', 'Vevey 1', 'Suisse', 76734, 0, 1),
(1367, 'Banque Cantonale Vaudoise', 'Nestlé', 'Case postale', '1800', 'Vevey 1', 'Suisse', 76734, 0, 1),
(1368, 'Banque Cantonale Vaudoise', 'Case postale', '', '1401', 'Yverdon-les-Bains', 'Suisse', 76735, 0, 1),
(1369, 'Banque Cantonale Vaudoise', 'Case postale', '', '1814', 'Tour-de-Peilz, La', 'Suisse', 76736, 0, 1),
(1370, 'Banque Cantonale Vaudoise', 'Case postale', '', '1844', 'Villeneuve VD', 'Suisse', 76737, 0, 1),
(1371, 'Banque Cantonale Vaudoise', 'Case postale', '', '1008', 'Prilly', 'Suisse', 76738, 0, 1),
(1372, 'Banque Cantonale Vaudoise', 'Unil', 'Case postale', '1015', 'Lausanne 15', 'Suisse', 76738, 0, 1),
(1373, 'Banque Cantonale Vaudoise', 'Place de la Gare', 'Case postale', '1000', 'Lausanne', 'Suisse', 76739, 0, 1),
(1374, 'Banque Cantonale Vaudoise', 'Case postale', '', '1854', 'Leysin', 'Suisse', 76740, 0, 1),
(1375, 'Banque Cantonale Vaudoise', 'Case postale', '', '1884', 'Villars-sur-Ollon', 'Suisse', 76741, 0, 1),
(1376, 'Banque Cantonale Vaudoise', 'Case postale', '', '1815', 'Clarens', 'Suisse', 76742, 0, 1),
(1377, 'Banque Cantonale Vaudoise', 'Case postale', '', '1196', 'Gland', 'Suisse', 76743, 0, 1),
(1378, 'Banque Cantonale Vaudoise', 'Case postale', '', '1009', 'Pully', 'Suisse', 76744, 0, 1),
(1379, 'Banque Cantonale Vaudoise', 'Case postale', '', '1033', 'Cheseaux-sur-Lausanne', 'Suisse', 76745, 0, 1),
(1380, 'Banque Cantonale Vaudoise', 'Chailly', 'Case postale', '1000', 'Lausanne 12', 'Suisse', 76746, 0, 1),
(1381, 'Banque Cantonale Vaudoise', 'La Sallaz', 'Case postale', '1010', 'Lausanne 10', 'Suisse', 76747, 0, 1),
(1382, 'Banque Cantonale Vaudoise', 'Case postale', '', '1865', 'Diablerets, Les', 'Suisse', 76748, 0, 1),
(1383, 'Banque Cantonale Vaudoise', 'Ouchy', 'Case postale', '1000', 'Lausanne 6', 'Suisse', 76749, 0, 1),
(1384, 'Banque Cantonale Vaudoise', 'Case postale', '', '1030', 'Bussigny-près-Lausanne', 'Suisse', 76750, 0, 1),
(1385, 'Banque Cantonale Vaudoise', 'Pontaise', 'Case postale', '1018', 'Lausanne 18', 'Suisse', 76751, 0, 1),
(1386, 'Banque Cantonale Vaudoise', 'Case postale', '', '1305', 'Penthalaz', 'Suisse', 76752, 0, 1),
(1387, 'Banque Cantonale Vaudoise', 'Case postale', '', '1296', 'Coppet', 'Suisse', 76753, 0, 1),
(1388, 'Banque Cantonale Vaudoise', 'Case postale', '', '1023', 'Crissier', 'Suisse', 76754, 0, 1),
(1389, 'Banque Cantonale Vaudoise', 'Bellevaux', 'Case postale', '1000', 'Lausanne 8', 'Suisse', 76755, 0, 1),
(1390, 'Banque Cantonale Vaudoise', 'Case postale', '', '1522', 'Lucens', 'Suisse', 76756, 0, 1),
(1391, 'Banque Cantonale Vaudoise', 'Case postale', '', '1373', 'Chavornay', 'Suisse', 76758, 0, 1),
(1392, 'Banque Cantonale Vaudoise', 'Case postale', '', '1807', 'Blonay', 'Suisse', 76761, 0, 1),
(1393, 'Banque Cantonale Vaudoise', 'Case postale', '', '1071', 'Chexbres', 'Suisse', 76762, 0, 1);
INSERT INTO `faturacao_bancos_fornecedores` (`ID_BancoFornecedor`, `Nome`, `Address1`, `Address2`, `NPA`, `Localite`, `PaisBanco`, `BCNbr`, `Predefinido`, `Ativo`) VALUES
(1394, 'Banque Cantonale Vaudoise', 'Cour', 'Case postale', '1000', 'Lausanne 3', 'Suisse', 76763, 0, 1),
(1395, 'Banque Cantonale Vaudoise', 'Case postale', '', '1073', 'Savigny', 'Suisse', 76764, 0, 1),
(1396, 'Banque Cantonale Vaudoise', 'Route de Divonne', 'Case postale', '1260', 'Nyon', 'Suisse', 76765, 0, 1),
(1397, 'Banque Cantonale Vaudoise', 'Case postale', '', '1066', 'Epalinges', 'Suisse', 76766, 0, 1),
(1398, 'Banque Cantonale de Fribourg', 'Bd de Pérolles 1', 'Case postale 151', '1701', 'Fribourg', 'Suisse', 768, 0, 1),
(1399, 'Banque Cantonale de Fribourg', 'Case postale', '', '1741', 'Cottens', 'Suisse', 768, 0, 1),
(1400, 'Banque Cantonale de Fribourg', 'Route de Corserey 9', '', '1746', 'Prez-vers-Noréaz', 'Suisse', 768, 0, 1),
(1401, 'Banque Cantonale de Fribourg', 'Sommentier 8', '', '1687', 'Vuisternens-devant-Romont', 'Suisse', 768, 0, 1),
(1402, 'Banque Cantonale de Fribourg', 'Rue de Romont', 'Case postale', '1701', 'Fribourg', 'Suisse', 76822, 0, 1),
(1403, 'Banque Cantonale de Fribourg', 'Case postale', '', '1630', 'Bulle', 'Suisse', 76823, 0, 1),
(1404, 'Banque Cantonale de Fribourg', 'Case postale', '', '1636', 'Broc', 'Suisse', 76823, 0, 1),
(1405, 'Banque Cantonale de Fribourg', 'Case postale', '', '1618', 'Châtel-St-Denis', 'Suisse', 76824, 0, 1),
(1406, 'Freiburger Kantonalbank', 'Postfach', '', '3210', 'Kerzers', 'Suisse', 76825, 0, 1),
(1407, 'Banque Cantonale de Fribourg', 'Case postale', '', '1564', 'Domdidier', 'Suisse', 76826, 0, 1),
(1408, 'Banque Cantonale de Fribourg', 'Case postale', '', '1470', 'Estavayer-le-Lac', 'Suisse', 76827, 0, 1),
(1409, 'Banque Cantonale de Fribourg', 'Case postale', '', '1726', 'Farvagny-le-Grand', 'Suisse', 76828, 0, 1),
(1410, 'Freiburger Kantonalbank', 'Postfach', '', '3280', 'Murten/Morat', 'Suisse', 76829, 0, 1),
(1411, 'Banque Cantonale de Fribourg', 'Case postale', '', '1680', 'Romont FR', 'Suisse', 76830, 0, 1),
(1412, 'Freiburger Kantonalbank', 'Postfach', '', '1712', 'Tafers/Tavel', 'Suisse', 76831, 0, 1),
(1413, 'Freiburger Kantonalbank', 'Guin', 'Postfach', '3186', 'Düdingen', 'Suisse', 76832, 0, 1),
(1414, 'Banque Cantonale de Fribourg', 'Bourg', 'Case postale', '1702', 'Fribourg', 'Suisse', 76833, 0, 1),
(1415, 'Banque Cantonale de Fribourg', 'Case postale', '', '1616', 'Attalens', 'Suisse', 76834, 0, 1),
(1416, 'Banque Cantonale de Fribourg', 'Case postale', '', '1784', 'Courtepin', 'Suisse', 76835, 0, 1),
(1417, 'Freiburger Kantonalbank', 'Postfach', '', '3175', 'Flamatt', 'Suisse', 76836, 0, 1),
(1418, 'Banque Cantonale de Fribourg', 'Case postale', '', '1754', 'Avry-sur-Matran', 'Suisse', 76837, 0, 1),
(1419, 'Banque Cantonale de Fribourg', 'Schönberg', 'Case postale', '1707', 'Fribourg', 'Suisse', 76838, 0, 1),
(1420, 'Banque Cantonale de Fribourg', 'Hôpital Cantonal', 'Case postale', '1708', 'Fribourg', 'Suisse', 76839, 0, 1),
(1421, 'Banque Cantonale de Fribourg', 'Case postale', '', '1731', 'Ependes FR', 'Suisse', 76840, 0, 1),
(1422, 'Banque Cantonale de Fribourg', 'Case postale', '', '1637', 'Charmey (Gruyère)', 'Suisse', 76841, 0, 1),
(1423, 'Banque Cantonale de Fribourg', 'Postfach', '', '1716', 'Plaffeien', 'Suisse', 76842, 0, 1),
(1424, 'Banque Cantonale de Fribourg', 'Case postale', '', '1611', 'Crêt, Le', 'Suisse', 76843, 0, 1),
(1425, 'Basellandschaftliche Kantonalbank', 'Postfach', '', '4410', 'Liestal', 'Suisse', 769, 0, 1),
(1426, 'Basellandschaftliche Kantonalbank', 'Postfach', '', '4144', 'Arlesheim', 'Suisse', 769, 0, 1),
(1427, 'Basellandschaftliche Kantonalbank', 'Postfach', '', '4102', 'Binningen 1', 'Suisse', 769, 0, 1),
(1428, 'Basellandschaftliche Kantonalbank', 'Postfach', '', '4460', 'Gelterkinden', 'Suisse', 769, 0, 1),
(1429, 'Basellandschaftliche Kantonalbank', 'Postfach', '', '4450', 'Sissach', 'Suisse', 769, 0, 1),
(1430, 'Basellandschaftliche Kantonalbank', 'Postfach', '', '4436', 'Oberdorf BL', 'Suisse', 769, 0, 1),
(1431, 'Basellandschaftliche Kantonalbank', 'Postfach', '', '4242', 'Laufen', 'Suisse', 769, 0, 1),
(1432, 'Basellandschaftliche Kantonalbank', 'Postfach', '', '4132', 'Muttenz 1', 'Suisse', 769, 0, 1),
(1433, 'Basler Kantonalbank', 'Spiegelgasse', 'Postfach 2255', '4002', 'Basel', 'Suisse', 770, 0, 1),
(1434, 'Basler Kantonalbank', 'Aeschen', 'Postfach', '4002', 'Basel', 'Suisse', 770, 0, 1),
(1435, 'Basler Kantonalbank', 'Brausebad', '', '4055', 'Basel', 'Suisse', 770, 0, 1),
(1436, 'Basler Kantonalbank', 'Breite', '', '4053', 'Basel', 'Suisse', 770, 0, 1),
(1437, 'Basler Kantonalbank', 'Burgfelderplatz', '', '4055', 'Basel', 'Suisse', 770, 0, 1),
(1438, 'Basler Kantonalbank', 'Claraspital', '', '4058', 'Basel', 'Suisse', 770, 0, 1),
(1439, 'Basler Kantonalbank', 'Gundeldingen', '', '4053', 'Basel', 'Suisse', 770, 0, 1),
(1440, 'Basler Kantonalbank', 'Kleinhüningen', '', '4057', 'Basel', 'Suisse', 770, 0, 1),
(1441, 'Basler Kantonalbank', 'Klybeck', '', '4057', 'Basel', 'Suisse', 770, 0, 1),
(1442, 'Basler Kantonalbank', 'Kongresszentrum, Mes', '', '4058', 'Basel', 'Suisse', 770, 0, 1),
(1443, 'Basler Kantonalbank', 'Neubad', 'Postfach', '4054', 'Basel', 'Suisse', 770, 0, 1),
(1444, 'Basler Kantonalbank', 'Steinen', '', '4051', 'Basel', 'Suisse', 770, 0, 1),
(1445, 'Basler Kantonalbank', 'Riehen-Dorf', 'Postfach', '4125', 'Riehen', 'Suisse', 770, 0, 1),
(1446, 'Basler Kantonalbank', 'Riehen-Rauracher', '', '4125', 'Riehen', 'Suisse', 770, 0, 1),
(1447, 'Basler Kantonalbank', 'Private Banking', 'Postfach', '8039', 'Zürich', 'Suisse', 770, 0, 1),
(1448, 'Basler Kantonalbank', 'Bahnhof-SBB', '', '4051', 'Basel', 'Suisse', 770, 0, 1),
(1449, 'Basler Kantonalbank', 'Voltaplatz', '', '4056', 'Basel', 'Suisse', 770, 0, 1),
(1450, 'Basler Kantonalbank', 'Private Banking', 'Postfach', '4600', 'Olten', 'Suisse', 770, 0, 1),
(1451, 'Basler Kantonalbank', 'Rosental', '', '4058', 'Basel', 'Suisse', 770, 0, 1),
(1452, 'Basler Kantonalbank', 'Güterstrasse', '', '4053', 'Basel', 'Suisse', 770, 0, 1),
(1453, 'Glarner Kantonalbank', 'Postfach 365', '', '8750', 'Glarus', 'Suisse', 773, 0, 1),
(1454, 'Glarner Kantonalbank', 'Postfach', '', '8865', 'Bilten', 'Suisse', 773, 0, 1),
(1455, 'Glarner Kantonalbank', 'Postfach', '', '8783', 'Linthal', 'Suisse', 773, 0, 1),
(1456, 'Glarner Kantonalbank', 'Postfach', '', '8754', 'Netstal', 'Suisse', 773, 0, 1),
(1457, 'Glarner Kantonalbank', 'Postfach', '', '8867', 'Niederurnen', 'Suisse', 773, 0, 1),
(1458, 'Glarner Kantonalbank', 'Postfach', '', '8762', 'Schwanden GL', 'Suisse', 773, 0, 1),
(1459, 'Glarner Kantonalbank', 'Postfach', '', '8752', 'Näfels-Mollis', 'Suisse', 773, 0, 1),
(1460, 'Graubündner Kantonalbank', 'Postfach', '', '7001', 'Chur', 'Suisse', 774, 0, 1),
(1461, 'Graubündner Kantonalbank', 'Center', 'Postfach', '7492', 'Alvaneu Dorf', 'Suisse', 774, 0, 1),
(1462, 'Graubündner Kantonalbank', 'Vei Granda', 'Postfach', '7440', 'Andeer', 'Suisse', 774, 0, 1),
(1463, 'Graubündner Kantonalbank', 'Postfach', '', '7546', 'Ardez', 'Suisse', 774, 0, 1),
(1464, 'Graubündner Kantonalbank', 'Plazzet 6', 'Postfach', '7503', 'Samedan', 'Suisse', 774, 0, 1),
(1465, 'Graubündner Kantonalbank', 'Haus Hotel Silvretta', 'Postfach', '7563', 'Samnaun Dorf', 'Suisse', 774, 0, 1),
(1466, 'Graubündner Kantonalbank', 'Postfach', '', '7460', 'Savognin', 'Suisse', 774, 0, 1),
(1467, 'Graubündner Kantonalbank', 'Bahnhofstrasse 122', 'Postfach', '7220', 'Schiers', 'Suisse', 774, 0, 1),
(1468, 'Graubündner Kantonalbank', 'Stradun', 'Postfach', '7550', 'Scuol', 'Suisse', 774, 0, 1),
(1469, 'Graubündner Kantonalbank', 'Via Alpsu 58', 'Postfach', '7188', 'Sedrun', 'Suisse', 774, 0, 1),
(1470, 'Graubündner Kantonalbank', 'Motta 132 A', 'Postfach', '7212', 'Seewis Dorf', 'Suisse', 774, 0, 1),
(1471, 'Graubündner Kantonalbank', 'Haus 76', 'Postfach', '7545', 'Guarda', 'Suisse', 774, 0, 1),
(1472, 'Graubündner Kantonalbank', 'Unterdorfstrasse 8', 'Postfach', '7206', 'Igis', 'Suisse', 774, 0, 1),
(1473, 'Graubündner Kantonalbank', 'Via Centrala 4', 'Postfach', '7130', 'Ilanz', 'Suisse', 774, 0, 1),
(1474, 'Graubündner Kantonalbank', 'Hauptstrasse 60 A', 'Postfach', '7233', 'Jenaz', 'Suisse', 774, 0, 1),
(1475, 'Graubündner Kantonalbank', 'Alte Bahnhofstrasse ', 'Postfach', '7250', 'Klosters', 'Suisse', 774, 0, 1),
(1476, 'Graubündner Kantonalbank', 'Landstrasse 41', 'Postfach', '7252', 'Klosters Dorf', 'Suisse', 774, 0, 1),
(1477, 'Graubündner Kantonalbank', 'Hauptstrasse 14 D', 'Postfach', '7240', 'Küblis', 'Suisse', 774, 0, 1),
(1478, 'Graubündner Kantonalbank', 'Via Falera, Dorf', 'Postfach', '7031', 'Laax GR', 'Suisse', 774, 0, 1),
(1479, 'Graubündner Kantonalbank', 'Via Sigmina, Mursche', 'Postfach', '7032', 'Laax GR', 'Suisse', 774, 0, 1),
(1480, 'Graubündner Kantonalbank', 'Pradé 135', 'Postfach', '7554', 'Sent', 'Suisse', 774, 0, 1),
(1481, 'Graubündner Kantonalbank', 'Serneuserstrasse 64', 'Postfach', '7249', 'Serneus', 'Suisse', 774, 0, 1),
(1482, 'Graubündner Kantonalbank', 'Hauptstrasse', 'Postfach', '7514', 'Sils/Segl Maria', 'Suisse', 774, 0, 1),
(1483, 'Graubündner Kantonalbank', 'Via dal Farrer 2', 'Postfach', '7513', 'Silvaplana', 'Suisse', 774, 0, 1),
(1484, 'Graubündner Kantonalbank', 'Postfach', '', '7435', 'Splügen', 'Suisse', 774, 0, 1),
(1485, 'Graubündner Kantonalbank', 'Via Maistra', 'Postfach', '7558', 'Strada', 'Suisse', 774, 0, 1),
(1486, 'Graubündner Kantonalbank', 'Surpunt', 'Postfach', '7542', 'Susch', 'Suisse', 774, 0, 1),
(1487, 'Graubündner Kantonalbank', 'Dorfplatz 8', 'Postfach', '7015', 'Tamins', 'Suisse', 774, 0, 1),
(1488, 'Graubündner Kantonalbank', 'Hauptstrasse 51', 'Postfach', '7408', 'Cazis', 'Suisse', 774, 0, 1),
(1489, 'Graubündner Kantonalbank', 'Hauptstrasse', 'Postfach', '7505', 'Celerina/Schlarigna', 'Suisse', 774, 0, 1),
(1490, 'Graubündner Kantonalbank', 'Lacuna', 'Postfach', '7006', 'Chur', 'Suisse', 774, 0, 1),
(1491, 'Graubündner Kantonalbank', 'Ringstrasse', 'Postfach', '7004', 'Chur', 'Suisse', 774, 0, 1),
(1492, 'Graubündner Kantonalbank', 'Haus Tälligrad', 'Postfach', '7075', 'Churwalden', 'Suisse', 774, 0, 1),
(1493, 'Graubündner Kantonalbank', 'Postfach', '', '7272', 'Davos Clavadel', 'Suisse', 774, 0, 1),
(1494, 'Graubündner Kantonalbank', 'Promenade 147', 'Postfach', '7260', 'Davos Dorf', 'Suisse', 774, 0, 1),
(1495, 'Graubündner Kantonalbank', 'Promenade 56', 'Postfach', '7270', 'Davos Platz', 'Suisse', 774, 0, 1),
(1496, 'Graubündner Kantonalbank', 'Via Lucmagn 26', 'Postfach', '7180', 'Disentis/Mustér', 'Suisse', 774, 0, 1),
(1497, 'Graubündner Kantonalbank', 'Viamalazentrum / Neu', 'Postfach', '7430', 'Thusis', 'Suisse', 774, 0, 1),
(1498, 'Graubündner Kantonalbank', 'Vei d&apos;Alvra 14', 'Postfach', '7450', 'Tiefencastel', 'Suisse', 774, 0, 1),
(1499, 'Graubündner Kantonalbank', 'Strässli 24', 'Postfach', '7203', 'Trimmis', 'Suisse', 774, 0, 1),
(1500, 'Graubündner Kantonalbank', 'Gemeindezentrum', 'Postfach', '7014', 'Trin', 'Suisse', 774, 0, 1),
(1501, 'Graubündner Kantonalbank', 'Postfach', '', '7166', 'Trun', 'Suisse', 774, 0, 1),
(1502, 'Graubündner Kantonalbank', 'Stoz', 'Postfach', '7204', 'Untervaz', 'Suisse', 774, 0, 1),
(1503, 'Graubündner Kantonalbank', 'Haus Isis A / Postst', 'Postfach', '7132', 'Vals', 'Suisse', 774, 0, 1),
(1504, 'Graubündner Kantonalbank', 'Bahnhofstrasse 34', 'Postfach', '7302', 'Landquart', 'Suisse', 774, 0, 1),
(1505, 'Graubündner Kantonalbank', 'Voa principala', 'Postfach', '7078', 'Lenzerheide/Lai', 'Suisse', 774, 0, 1),
(1506, 'Graubündner Kantonalbank', 'Postfach', '', '7304', 'Maienfeld', 'Suisse', 774, 0, 1),
(1507, 'Graubündner Kantonalbank', 'Löwengasse 205 / Pla', 'Postfach', '7208', 'Malans GR', 'Suisse', 774, 0, 1),
(1508, 'Graubündner Kantonalbank', 'Plaz Cadruri', 'Postfach', '7144', 'Vella', 'Suisse', 774, 0, 1),
(1509, 'Graubündner Kantonalbank', 'Hauptstrasse 114 A', 'Postfach', '7603', 'Vicosoprano', 'Suisse', 774, 0, 1),
(1510, 'Graubündner Kantonalbank', 'Casa da Scola', 'Postfach', '7149', 'Vrin', 'Suisse', 774, 0, 1),
(1511, 'Graubündner Kantonalbank', 'Postfach', '', '7158', 'Waltensburg/Vuorz', 'Suisse', 774, 0, 1),
(1512, 'Graubündner Kantonalbank', 'Haus Freieck', 'Postfach', '7494', 'Wiesen GR', 'Suisse', 774, 0, 1),
(1513, 'Graubündner Kantonalbank', 'Via Sura 66', 'Postfach', '7530', 'Zernez', 'Suisse', 774, 0, 1),
(1514, 'Graubündner Kantonalbank', 'Poststrasse', 'Postfach', '7050', 'Arosa', 'Suisse', 774, 0, 1),
(1515, 'Graubündner Kantonalbank', 'Hauptstrasse 106', 'Postfach', '7482', 'Bergün/Bravuogn', 'Suisse', 774, 0, 1),
(1516, 'Graubündner Kantonalbank', 'Hauptstrasse', 'Postfach', '7457', 'Bivio', 'Suisse', 774, 0, 1),
(1517, 'Graubündner Kantonalbank', 'Plaz 1', 'Postfach', '7402', 'Bonaduz', 'Suisse', 774, 0, 1),
(1518, 'Graubündner Kantonalbank', 'Sentupada', 'Postfach', '7165', 'Breil/Brigels', 'Suisse', 774, 0, 1),
(1519, 'Graubündner Kantonalbank', 'Strada principale', 'Postfach', '7743', 'Brusio', 'Suisse', 774, 0, 1),
(1520, 'Graubündner Kantonalbank', 'Hauptstrasse', 'Postfach', '7744', 'Campocologno', 'Suisse', 774, 0, 1),
(1521, 'Graubündner Kantonalbank', 'Postfach', '', '7608', 'Castasegna', 'Suisse', 774, 0, 1),
(1522, 'Graubündner Kantonalbank', 'Torkelgasse 2', 'Postfach', '7205', 'Zizers', 'Suisse', 774, 0, 1),
(1523, 'Graubündner Kantonalbank', 'Via Maistra 35 A', 'Postfach', '7524', 'Zuoz', 'Suisse', 774, 0, 1),
(1524, 'Graubündner Kantonalbank', 'Chasa Cumünala', 'Casella postale', '6563', 'Mesocco', 'Suisse', 774, 0, 1),
(1525, 'Graubündner Kantonalbank', 'Postfach', '', '7537', 'Müstair', 'Suisse', 774, 0, 1),
(1526, 'Graubündner Kantonalbank', 'Postfach', '', '7134', 'Obersaxen Meierhof', 'Suisse', 774, 0, 1),
(1527, 'Graubündner Kantonalbank', 'Postfach', '', '7243', 'Pany', 'Suisse', 774, 0, 1),
(1528, 'Graubündner Kantonalbank', 'Via Maistra', 'Postfach', '7504', 'Pontresina', 'Suisse', 774, 0, 1),
(1529, 'Graubündner Kantonalbank', 'Via da Mez', 'Casella postale', '7742', 'Poschiavo', 'Suisse', 774, 0, 1),
(1530, 'Graubündner Kantonalbank', 'Via Nova 86', 'Postfach', '7013', 'Domat/Ems', 'Suisse', 774, 0, 1),
(1531, 'Graubündner Kantonalbank', 'Via Cantunala', 'Postfach', '7153', 'Falera', 'Suisse', 774, 0, 1),
(1532, 'Graubündner Kantonalbank', 'Taminserstrasse 6', 'Postfach', '7012', 'Felsberg', 'Suisse', 774, 0, 1),
(1533, 'Graubündner Kantonalbank', 'Chesa Arcada', 'Postfach', '7477', 'Filisur', 'Suisse', 774, 0, 1),
(1534, 'Graubündner Kantonalbank', 'Hauptstrasse', 'Postfach', '7017', 'Flims Dorf', 'Suisse', 774, 0, 1),
(1535, 'Graubündner Kantonalbank', 'Postfach 123', '', '7018', 'Flims Waldhaus', 'Suisse', 774, 0, 1),
(1536, 'Graubündner Kantonalbank', 'Postfach', '', '7551', 'Ftan', 'Suisse', 774, 0, 1),
(1537, 'Graubündner Kantonalbank', 'Strada Cantonale 27 ', 'Postfach', '6537', 'Grono', 'Suisse', 774, 0, 1),
(1538, 'Graubündner Kantonalbank', 'Hauptstrasse 22 A', 'Postfach', '7214', 'Grüsch', 'Suisse', 774, 0, 1),
(1539, 'Graubündner Kantonalbank', 'Sut Via', 'Postfach', '7172', 'Rabius', 'Suisse', 774, 0, 1),
(1540, 'Graubündner Kantonalbank', 'Via Baselgia 2', 'Postfach', '7403', 'Rhäzüns', 'Suisse', 774, 0, 1),
(1541, 'Graubündner Kantonalbank', 'Piazèta', 'Casella postale', '6535', 'Roveredo GR', 'Suisse', 774, 0, 1),
(1542, 'Graubündner Kantonalbank', 'Postfach', '', '6565', 'S. Bernardino', 'Suisse', 774, 0, 1),
(1543, 'Graubündner Kantonalbank', 'Postfach', '', '7536', 'Sta. Maria im Münstertal', 'Suisse', 774, 0, 1),
(1544, 'Graubündner Kantonalbank', 'Via Maistra 1', 'Postfach', '7500', 'St. Moritz 1', 'Suisse', 774, 0, 1),
(1545, 'Graubündner Kantonalbank', 'Via dal Bagn 1', 'Postfach', '7500', 'St. Moritz 3 Bad', 'Suisse', 774, 0, 1),
(1546, 'Graubündner Kantonalbank', 'Schmittenhaus', 'Postfach', '7107', 'Safien Platz', 'Suisse', 774, 0, 1),
(1547, 'Schwyzer Kantonalbank', 'Bahnhofstrasse 3', 'Postfach 263', '6431', 'Schwyz', 'Suisse', 777, 0, 1),
(1548, 'Schwyzer Kantonalbank', 'Hauptstrasse 61', 'Postfach', '8840', 'Einsiedeln', 'Suisse', 77711, 0, 1),
(1549, 'Schwyzer Kantonalbank', 'Mittlere Bahnhofstra', 'Postfach', '8853', 'Lachen SZ', 'Suisse', 77712, 0, 1),
(1550, 'Schwyzer Kantonalbank', 'Glarnerstrasse 7', 'Postfach', '8854', 'Siebnen', 'Suisse', 77713, 0, 1),
(1551, 'Schwyzer Kantonalbank', 'Bahnhofstrasse 29', 'Postfach', '6440', 'Brunnen', 'Suisse', 77714, 0, 1),
(1552, 'Schwyzer Kantonalbank', 'Bahnhofstrasse 8', 'Postfach', '6403', 'Küssnacht am Rigi', 'Suisse', 77715, 0, 1),
(1553, 'Schwyzer Kantonalbank', 'Gotthardstrasse 21', 'Postfach', '6415', 'Arth', 'Suisse', 77716, 0, 1),
(1554, 'Schwyzer Kantonalbank', 'Bahnhofstrasse 6', 'Postfach', '8808', 'Pfäffikon SZ', 'Suisse', 77717, 0, 1),
(1555, 'Schwyzer Kantonalbank', 'Parkstrasse 1', 'Postfach', '6410', 'Goldau', 'Suisse', 77718, 0, 1),
(1556, 'Schwyzer Kantonalbank', 'Dorfplatz 2', 'Postfach', '8832', 'Wollerau', 'Suisse', 77719, 0, 1),
(1557, 'Schwyzer Kantonalbank', 'Poststrasse 2', 'Postfach', '6442', 'Gersau', 'Suisse', 77720, 0, 1),
(1558, 'Schwyzer Kantonalbank', 'Bahnhofstrasse 1', 'Postfach', '6418', 'Rothenthurm', 'Suisse', 77721, 0, 1),
(1559, 'Schwyzer Kantonalbank', 'Gotthardstrasse 62', 'Postfach', '6438', 'Ibach', 'Suisse', 77722, 0, 1),
(1560, 'Schwyzer Kantonalbank', 'Bahnhofstrasse 132', 'Postfach', '6423', 'Seewen SZ', 'Suisse', 77723, 0, 1),
(1561, 'Schwyzer Kantonalbank', 'Postplatz 3', 'Postfach', '6422', 'Steinen', 'Suisse', 77724, 0, 1),
(1562, 'Schwyzer Kantonalbank', 'Hauptstrasse 25', 'Postfach', '6436', 'Muotathal', 'Suisse', 77725, 0, 1),
(1563, 'Schwyzer Kantonalbank', 'Waagtalstrasse', 'Postfach', '8842', 'Unteriberg', 'Suisse', 77726, 0, 1),
(1564, 'Schwyzer Kantonalbank', 'Mythen-Center', 'Postfach 258', '6438', 'Ibach', 'Suisse', 77727, 0, 1),
(1565, 'Schwyzer Kantonalbank', 'Kantonsstrasse 102', 'Postfach', '8807', 'Freienbach', 'Suisse', 77728, 0, 1),
(1566, 'Schwyzer Kantonalbank', 'Seedamm-Center', '', '8808', 'Pfäffikon SZ', 'Suisse', 77729, 0, 1),
(1567, 'Schwyzer Kantonalbank', 'Dorfstrasse 10', 'Postfach', '6417', 'Sattel', 'Suisse', 77730, 0, 1),
(1568, 'Schwyzer Kantonalbank', 'Säntisstrasse 2', 'Postfach', '8856', 'Tuggen', 'Suisse', 77731, 0, 1),
(1569, 'Schwyzer Kantonalbank', 'Pfäffikonerstrasse 1', 'Postfach', '8834', 'Schindellegi', 'Suisse', 77732, 0, 1),
(1570, 'Schwyzer Kantonalbank', 'Zürcherstrasse 6', 'Postfach', '8852', 'Altendorf', 'Suisse', 77733, 0, 1),
(1571, 'Schwyzer Kantonalbank', 'Kreuzwiesmarkt', 'Postfach', '8864', 'Reichenburg', 'Suisse', 77734, 0, 1),
(1572, 'Luzerner Kantonalbank AG', 'Pilatusstrasse 12', 'Postfach 3567', '6002', 'Luzern', 'Suisse', 778, 0, 1),
(1573, 'Luzerner Kantonalbank AG', 'Grendel', 'Postfach', '6004', 'Luzern', 'Suisse', 778, 0, 1),
(1574, 'Luzerner Kantonalbank AG', 'Postfach', '', '6353', 'Weggis', 'Suisse', 778, 0, 1),
(1575, 'Luzerner Kantonalbank AG', 'Postfach 79', '', '6130', 'Willisau', 'Suisse', 77811, 0, 1),
(1576, 'Luzerner Kantonalbank AG', 'Postfach 14', '', '6170', 'Schüpfheim', 'Suisse', 77812, 0, 1),
(1577, 'Luzerner Kantonalbank AG', 'Postfach 8', '', '6174', 'Sörenberg', 'Suisse', 77812, 0, 1),
(1578, 'Luzerner Kantonalbank AG', 'Oberstadt', 'Postfach', '6210', 'Sursee', 'Suisse', 77813, 0, 1),
(1579, 'Luzerner Kantonalbank AG', 'Postfach 36', '', '6221', 'Rickenbach LU', 'Suisse', 77813, 0, 1),
(1580, 'Luzerner Kantonalbank AG', 'Einkaufszentrum', 'Postfach', '6210', 'Sursee', 'Suisse', 77813, 0, 1),
(1581, 'Luzerner Kantonalbank AG', 'Postfach', '', '6234', 'Triengen', 'Suisse', 77813, 0, 1),
(1582, 'Luzerner Kantonalbank AG', 'Postfach 70', '', '6281', 'Hochdorf', 'Suisse', 77814, 0, 1),
(1583, 'Luzerner Kantonalbank AG', 'Postfach 11', '', '6260', 'Reiden', 'Suisse', 77815, 0, 1),
(1584, 'Luzerner Kantonalbank AG', 'Postfach 1367', '', '6020', 'Emmenbrücke 1', 'Suisse', 77816, 0, 1),
(1585, 'Luzerner Kantonalbank AG', 'Emmen Center', 'Postfach 3113', '6020', 'Emmenbrücke 3', 'Suisse', 77816, 0, 1),
(1586, 'Luzerner Kantonalbank AG', 'Sprengi', 'Postfach', '6020', 'Emmenbrücke 2', 'Suisse', 77816, 0, 1),
(1587, 'Luzerner Kantonalbank AG', 'Postfach', '', '6023', 'Rothenburg', 'Suisse', 77816, 0, 1),
(1588, 'Luzerner Kantonalbank AG', 'Postfach', '', '6010', 'Kriens', 'Suisse', 77817, 0, 1),
(1589, 'Luzerner Kantonalbank AG', 'Postfach 281', '', '6048', 'Horw', 'Suisse', 77818, 0, 1),
(1590, 'Luzerner Kantonalbank AG', 'Löwenplatz', 'Postfach 1985', '6000', 'Luzern 6', 'Suisse', 77819, 0, 1),
(1591, 'Luzerner Kantonalbank AG', 'Postfach 1357', '', '6030', 'Ebikon', 'Suisse', 77820, 0, 1),
(1592, 'Luzerner Kantonalbank AG', 'Postfach 362', '', '6037', 'Root', 'Suisse', 77820, 0, 1),
(1593, 'Luzerner Kantonalbank AG', 'Postfach', '', '6045', 'Meggen', 'Suisse', 77821, 0, 1),
(1594, 'Luzerner Kantonalbank AG', 'Schönbühl', 'Postfach 93', '6000', 'Luzern 14', 'Suisse', 77822, 0, 1),
(1595, 'Luzerner Kantonalbank AG', 'Postfach 141', '', '6014', 'Luzern', 'Suisse', 77823, 0, 1),
(1596, 'Luzerner Kantonalbank AG', 'Postfach 265', '', '6110', 'Wolhusen', 'Suisse', 77824, 0, 1),
(1597, 'Luzerner Kantonalbank AG', 'Postfach 33', '', '6215', 'Beromünster', 'Suisse', 77825, 0, 1),
(1598, 'Luzerner Kantonalbank AG', 'Hauptstrasse 31', 'Postfach', '6170', 'Schüpfheim', 'Suisse', 77826, 0, 1),
(1599, 'Luzerner Kantonalbank AG', '', '', '6274', 'Eschenbach LU', 'Suisse', 77827, 0, 1),
(1600, 'Luzerner Kantonalbank AG', 'Postfach', '', '6285', 'Hitzkirch', 'Suisse', 77828, 0, 1),
(1601, 'Luzerner Kantonalbank AG', 'Postfach 95', '', '6204', 'Sempach', 'Suisse', 77829, 0, 1),
(1602, 'Luzerner Kantonalbank AG', 'Postfach 319', '', '6017', 'Ruswil', 'Suisse', 77860, 0, 1),
(1603, 'Luzerner Kantonalbank AG', 'Postfach', '', '6275', 'Ballwil', 'Suisse', 77866, 0, 1),
(1604, 'Nidwaldner Kantonalbank', 'Stansstaderstrasse 5', 'Postfach 544', '6371', 'Stans', 'Suisse', 779, 0, 1),
(1605, 'Nidwaldner Kantonalbank', 'Dorfstrasse 47', 'Postfach', '6375', 'Beckenried', 'Suisse', 779, 0, 1),
(1606, 'Nidwaldner Kantonalbank', 'Beckenriederstrasse ', 'Postfach', '6374', 'Buochs', 'Suisse', 779, 0, 1),
(1607, 'Nidwaldner Kantonalbank', 'Stanserstrasse 4', 'Postfach', '6373', 'Ennetbürgen', 'Suisse', 779, 0, 1),
(1608, 'Nidwaldner Kantonalbank', 'EKZ Länderpark', 'Postfach', '6371', 'Stans', 'Suisse', 779, 0, 1),
(1609, 'Nidwaldner Kantonalbank', 'Stanserstrasse 10', 'Postfach', '6362', 'Stansstad', 'Suisse', 779, 0, 1),
(1610, 'Nidwaldner Kantonalbank', 'Hauptstrasse 20', 'Postfach', '6386', 'Wolfenschiessen', 'Suisse', 779, 0, 1),
(1611, 'Obwaldner Kantonalbank', 'Postfach', '', '6061', 'Sarnen 1', 'Suisse', 780, 0, 1),
(1612, 'Obwaldner Kantonalbank', 'Postfach', '', '6055', 'Alpnach Dorf', 'Suisse', 780, 0, 1),
(1613, 'Obwaldner Kantonalbank', 'Postfach', '', '6391', 'Engelberg', 'Suisse', 780, 0, 1),
(1614, 'Obwaldner Kantonalbank', 'Postfach', '', '6074', 'Giswil', 'Suisse', 780, 0, 1),
(1615, 'Obwaldner Kantonalbank', 'Postfach', '', '6064', 'Kerns', 'Suisse', 780, 0, 1),
(1616, 'Obwaldner Kantonalbank', 'Postfach', '', '6078', 'Lungern', 'Suisse', 780, 0, 1),
(1617, 'Obwaldner Kantonalbank', 'Postfach', '', '6072', 'Sachseln', 'Suisse', 780, 0, 1),
(1618, 'Obwaldner Kantonalbank', 'Lindenhof', '', '6061', 'Sarnen 1', 'Suisse', 780, 0, 1),
(1619, 'Obwaldner Kantonalbank', 'Sarnen-Center', '', '6061', 'Sarnen 1', 'Suisse', 780, 0, 1),
(1620, 'St. Galler Kantonalbank AG', 'Postfach', '', '9001', 'St. Gallen', 'Suisse', 781, 0, 1),
(1621, 'St. Galler Kantonalbank AG', 'Postfach', '', '9300', 'Wittenbach', 'Suisse', 781, 0, 1),
(1622, 'St. Galler Kantonalbank AG', 'Postfach', '', '9100', 'Herisau', 'Suisse', 781, 0, 1),
(1623, 'St. Galler Kantonalbank AG', '', '', '9053', 'Teufen AR', 'Suisse', 781, 0, 1),
(1624, 't., Galler Kantonalbank AG', 'Neudorf', 'Postfach', '9016', 'St. Gallen', 'Suisse', 78102, 0, 1),
(1625, 't., Galler Kantonalbank AG', 'Bruggen', 'Postfach', '9014', 'St. Gallen', 'Suisse', 78103, 0, 1),
(1626, 't., Galler Kantonalbank AG', 'Postfach', '', '9450', 'Altstätten SG', 'Suisse', 78111, 0, 1),
(1627, 't., Galler Kantonalbank AG', 'Postfach', '', '9463', 'Oberriet SG', 'Suisse', 78111, 0, 1),
(1628, 't., Galler Kantonalbank AG', 'Postfach', '', '7310', 'Bad Ragaz', 'Suisse', 78112, 0, 1),
(1629, 't., Galler Kantonalbank AG', 'Postfach', '', '9470', 'Buchs SG', 'Suisse', 78113, 0, 1),
(1630, 't., Galler Kantonalbank AG', 'Postfach', '', '9475', 'Sevelen', 'Suisse', 78113, 0, 1),
(1631, 't., Galler Kantonalbank AG', 'Postfach', '', '9478', 'Azmoos', 'Suisse', 78113, 0, 1),
(1632, 't., Galler Kantonalbank AG', 'Postfach', '', '9113', 'Degersheim', 'Suisse', 78114, 0, 1),
(1633, 't., Galler Kantonalbank AG', 'Postfach', '', '8887', 'Mels', 'Suisse', 78115, 0, 1),
(1634, 't., Galler Kantonalbank AG', 'Postfach', '', '8640', 'Rapperswil SG', 'Suisse', 78116, 0, 1),
(1635, 't., Galler Kantonalbank AG', 'Postfach', '', '8733', 'Eschenbach SG', 'Suisse', 78116, 0, 1),
(1636, 't., Galler Kantonalbank AG', 'Postfach', '', '9400', 'Rorschach', 'Suisse', 78117, 0, 1),
(1637, 't., Galler Kantonalbank AG', 'Postfach', '', '9630', 'Wattwil', 'Suisse', 78118, 0, 1),
(1638, 't., Galler Kantonalbank AG', 'Postfach', '', '9501', 'Wil SG 1', 'Suisse', 78119, 0, 1),
(1639, 't., Galler Kantonalbank AG', 'Postfach', '', '9602', 'Bazenheid', 'Suisse', 78119, 0, 1),
(1640, 't., Galler Kantonalbank AG', 'Postfach', '', '9230', 'Flawil', 'Suisse', 78120, 0, 1),
(1641, 't., Galler Kantonalbank AG', 'Postfach', '', '9473', 'Gams', 'Suisse', 78121, 0, 1),
(1642, 't., Galler Kantonalbank AG', 'Postfach', '', '9201', 'Gossau SG', 'Suisse', 78122, 0, 1),
(1643, 't., Galler Kantonalbank AG', 'Postfach', '', '9435', 'Heerbrugg', 'Suisse', 78123, 0, 1),
(1644, 't., Galler Kantonalbank AG', 'Postfach', '', '9444', 'Diepoldsau', 'Suisse', 78123, 0, 1),
(1645, 't., Galler Kantonalbank AG', 'Postfach', '', '9434', 'Au SG', 'Suisse', 78123, 0, 1),
(1646, 't., Galler Kantonalbank AG', 'Postfach', '', '9424', 'Rheineck', 'Suisse', 78124, 0, 1),
(1647, 't., Galler Kantonalbank AG', 'Postfach', '', '9430', 'St. Margrethen SG', 'Suisse', 78125, 0, 1),
(1648, 't., Galler Kantonalbank AG', 'Postfach', '', '8730', 'Uznach', 'Suisse', 78126, 0, 1),
(1649, 't., Galler Kantonalbank AG', 'Postfach', '', '8718', 'Schänis', 'Suisse', 78126, 0, 1),
(1650, 't., Galler Kantonalbank AG', 'Postfach', '', '9240', 'Uzwil', 'Suisse', 78127, 0, 1),
(1651, 't., Galler Kantonalbank AG', 'Postfach', '', '8880', 'Walenstadt', 'Suisse', 78128, 0, 1),
(1652, 't., Galler Kantonalbank AG', 'Postfach', '', '8890', 'Flums', 'Suisse', 78128, 0, 1),
(1653, 't., Galler Kantonalbank AG', 'Postfach', '', '9650', 'Nesslau', 'Suisse', 78129, 0, 1),
(1654, 't., Galler Kantonalbank AG', 'Postfach', '', '7320', 'Sargans', 'Suisse', 78130, 0, 1),
(1655, 't., Galler Kantonalbank AG', 'Postfach', '', '9403', 'Goldach', 'Suisse', 78131, 0, 1),
(1656, 't., Galler Kantonalbank AG', 'Postfach', '', '9642', 'Ebnat-Kappel', 'Suisse', 78132, 0, 1),
(1657, 't., Galler Kantonalbank AG', 'Zentrale', 'Postfach', '9001', 'St. Gallen', 'Suisse', 78158, 0, 1),
(1658, 'Schaffhauser Kantonalbank', 'Vorstadt 53', 'Postfach', '8201', 'Schaffhausen', 'Suisse', 782, 0, 1),
(1659, 'Schaffhauser Kantonalbank', 'Bahnhofstrasse 297', 'Postfach', '8262', 'Ramsen', 'Suisse', 782, 0, 1),
(1660, 'Schaffhauser Kantonalbank', 'Fronwagplatz 3', 'Postfach', '8201', 'Schaffhausen', 'Suisse', 782, 0, 1),
(1661, 'Schaffhauser Kantonalbank', 'Bahnhofstrasse 1', 'Postfach', '8240', 'Thayngen', 'Suisse', 782, 0, 1),
(1662, 'Schaffhauser Kantonalbank', 'Wildenstrasse 6', 'Postfach', '8212', 'Neuhausen am Rheinfall', 'Suisse', 78212, 0, 1),
(1663, 'Schaffhauser Kantonalbank', 'Rathausplatz 4', 'Postfach', '8260', 'Stein am Rhein', 'Suisse', 78213, 0, 1),
(1664, 'Thurgauer Kantonalbank', 'Postfach', '', '8570', 'Weinfelden', 'Suisse', 784, 0, 1),
(1665, 'Thurgauer Kantonalbank', 'Postfach', '', '9556', 'Affeltrangen', 'Suisse', 784, 0, 1),
(1666, 'Thurgauer Kantonalbank', 'Postfach', '', '8572', 'Berg TG', 'Suisse', 784, 0, 1),
(1667, 'Thurgauer Kantonalbank', 'Postfach', '', '8575', 'Bürglen TG', 'Suisse', 784, 0, 1),
(1668, 'Thurgauer Kantonalbank', 'Postfach', '', '8580', 'Amriswil', 'Suisse', 78411, 0, 1),
(1669, 'Thurgauer Kantonalbank', 'Postfach', '', '8586', 'Erlen', 'Suisse', 78411, 0, 1),
(1670, 'Thurgauer Kantonalbank', 'Postfach', '', '9320', 'Arbon', 'Suisse', 78412, 0, 1),
(1671, 'Thurgauer Kantonalbank', 'Postfach', '', '9326', 'Horn', 'Suisse', 78412, 0, 1),
(1672, 'Thurgauer Kantonalbank', 'Postfach', '', '9220', 'Bischofszell', 'Suisse', 78413, 0, 1),
(1673, 'Thurgauer Kantonalbank', 'Postfach', '', '8253', 'Diessenhofen', 'Suisse', 78414, 0, 1),
(1674, 'Thurgauer Kantonalbank', 'Postfach', '', '8501', 'Frauenfeld', 'Suisse', 78415, 0, 1),
(1675, 'Thurgauer Kantonalbank', 'Postfach', '', '9545', 'Wängi', 'Suisse', 78415, 0, 1),
(1676, 'Thurgauer Kantonalbank', 'Postfach', '', '8280', 'Kreuzlingen 1', 'Suisse', 78416, 0, 1),
(1677, 'Thurgauer Kantonalbank', 'Postfach', '', '8274', 'Tägerwilen', 'Suisse', 78416, 0, 1),
(1678, 'Thurgauer Kantonalbank', 'Postfach', '', '8590', 'Romanshorn 1', 'Suisse', 78417, 0, 1),
(1679, 'Thurgauer Kantonalbank', 'Postfach', '', '9315', 'Neukirch (Egnach)', 'Suisse', 78417, 0, 1),
(1680, 'Thurgauer Kantonalbank', 'Postfach', '', '8370', 'Sirnach', 'Suisse', 78418, 0, 1),
(1681, 'Thurgauer Kantonalbank', 'Postfach', '', '8360', 'Eschlikon TG', 'Suisse', 78418, 0, 1),
(1682, 'Thurgauer Kantonalbank', 'Postfach', '', '9532', 'Rickenbach b. Wil', 'Suisse', 78418, 0, 1),
(1683, 'Thurgauer Kantonalbank', 'Postfach', '', '8266', 'Steckborn', 'Suisse', 78419, 0, 1),
(1684, 'Thurgauer Kantonalbank', 'Hauptstrasse 88', '', '8264', 'Eschenz', 'Suisse', 78419, 0, 1),
(1685, 'Thurgauer Kantonalbank', 'Postfach', '', '8355', 'Aadorf', 'Suisse', 78420, 0, 1),
(1686, 'Thurgauer Kantonalbank', 'Hauptstrasse 121', 'Postfach 169', '8272', 'Ermatingen', 'Suisse', 78421, 0, 1),
(1687, 'Thurgauer Kantonalbank', 'Postfach', '', '8555', 'Müllheim Dorf', 'Suisse', 78422, 0, 1),
(1688, 'Thurgauer Kantonalbank', 'Postfach', '', '8556', 'Wigoltingen', 'Suisse', 78422, 0, 1),
(1689, 'Thurgauer Kantonalbank', 'Postfach', '', '8583', 'Sulgen', 'Suisse', 78423, 0, 1),
(1690, 'Thurgauer Kantonalbank', 'Postfach', '', '9542', 'Münchwilen TG', 'Suisse', 78424, 0, 1),
(1691, 'Urner Kantonalbank', 'Postfach', '', '6460', 'Altdorf UR', 'Suisse', 785, 0, 1),
(1692, 'Urner Kantonalbank', 'Postfach', '', '6490', 'Andermatt', 'Suisse', 785, 0, 1),
(1693, 'Urner Kantonalbank', 'Postfach', '', '6463', 'Bürglen UR', 'Suisse', 785, 0, 1),
(1694, 'Urner Kantonalbank', 'Postfach', '', '6472', 'Erstfeld', 'Suisse', 785, 0, 1),
(1695, 'Urner Kantonalbank', 'Postfach', '', '6467', 'Schattdorf', 'Suisse', 785, 0, 1),
(1696, 'Zuger Kantonalbank', 'Postfach', '', '6301', 'Zug', 'Suisse', 787, 0, 1),
(1697, 'Zuger Kantonalbank', 'Postfach', '', '6341', 'Baar', 'Suisse', 787, 0, 1),
(1698, 'Zuger Kantonalbank', 'Postfach', '', '6330', 'Cham', 'Suisse', 787, 0, 1),
(1699, 'Zuger Kantonalbank', 'Postfach', '', '6331', 'Hünenberg', 'Suisse', 787, 0, 1),
(1700, 'Zuger Kantonalbank', 'Postfach', '', '6313', 'Menzingen', 'Suisse', 787, 0, 1),
(1701, 'Zuger Kantonalbank', 'Postfach', '', '6345', 'Neuheim', 'Suisse', 787, 0, 1),
(1702, 'Zuger Kantonalbank', 'Postfach', '', '6315', 'Oberägeri', 'Suisse', 787, 0, 1),
(1703, 'Zuger Kantonalbank', 'Postfach', '', '6343', 'Rotkreuz', 'Suisse', 787, 0, 1),
(1704, 'Zuger Kantonalbank', 'Postfach', '', '6312', 'Steinhausen', 'Suisse', 787, 0, 1),
(1705, 'Zuger Kantonalbank', 'EKZ Zugerland', 'Postfach', '6312', 'Steinhausen', 'Suisse', 787, 0, 1),
(1706, 'Zuger Kantonalbank', 'Postfach', '', '6314', 'Unterägeri', 'Suisse', 787, 0, 1),
(1707, 'Zuger Kantonalbank', 'Postfach', '', '6318', 'Walchwil', 'Suisse', 787, 0, 1),
(1708, 'Zuger Kantonalbank', 'Herti', 'Postfach', '6300', 'Zug 3', 'Suisse', 787, 0, 1),
(1709, 'Zuger Kantonalbank', 'Neustadt', 'Postfach', '6301', 'Zug', 'Suisse', 787, 0, 1),
(1710, 'Banque Cantonale de Genève', 'Case postale 2251', '', '1211', 'Genève 2', 'Suisse', 788, 0, 1),
(1711, 'Banque Cantonale du Jura SA', 'Case postale 278', '', '2900', 'Porrentruy 2', 'Suisse', 789, 0, 1),
(1712, 'Banque Cantonale du Jura SA', 'Case postale', '', '2942', 'Alle', 'Suisse', 789, 0, 1),
(1713, 'Banque Cantonale du Jura SA', 'Case postale', '', '2926', 'Boncourt', 'Suisse', 789, 0, 1),
(1714, 'Banque Cantonale du Jura SA', 'Case postale', '', '2950', 'Courgenay', 'Suisse', 789, 0, 1),
(1715, 'Banque Cantonale du Jura SA', 'Case postale', '', '2882', 'St-Ursanne', 'Suisse', 789, 0, 1),
(1716, 'Banque Cantonale du Jura SA', 'Case postale', '', '2800', 'Delémont 1', 'Suisse', 78910, 0, 1),
(1717, 'Banque Cantonale du Jura SA', 'Case postale', '', '2854', 'Bassecourt', 'Suisse', 78910, 0, 1),
(1718, 'Banque Cantonale du Jura SA', 'Case postale', '', '2830', 'Courrendlin', 'Suisse', 78910, 0, 1),
(1719, 'Banque Cantonale du Jura SA', 'Case postale', '', '2822', 'Courroux', 'Suisse', 78910, 0, 1),
(1720, 'Banque Cantonale du Jura SA', 'Ville', 'Case postale', '2800', 'Delémont 2', 'Suisse', 78910, 0, 1),
(1721, 'Banque Cantonale du Jura SA', 'Case postale', '', '2350', 'Saignelégier', 'Suisse', 78920, 0, 1),
(1722, 'Banque Cantonale du Jura SA', 'Case postale', '', '2340', 'Noirmont, Le', 'Suisse', 78920, 0, 1),
(1723, 'Berner Kantonalbank AG', 'Postfach', '', '3001', 'Bern', 'Suisse', 790, 0, 1),
(1724, 'Berner Kantonalbank AG', 'Postfach', '', '3123', 'Belp', 'Suisse', 790, 0, 1),
(1725, 'Berner Kantonalbank AG', 'Postfach', '', '3063', 'Ittigen', 'Suisse', 790, 0, 1),
(1726, 'Berner Kantonalbank AG', '', '', '3098', 'Köniz', 'Suisse', 790, 0, 1),
(1727, 'Berner Kantonalbank AG', 'Postfach', '', '3177', 'Laupen BE', 'Suisse', 790, 0, 1),
(1728, 'Berner Kantonalbank AG', 'Postfach', '', '3110', 'Münsingen', 'Suisse', 790, 0, 1),
(1729, 'Berner Kantonalbank AG', 'Postfach', '', '3074', 'Muri b. Bern', 'Suisse', 790, 0, 1),
(1730, 'Berner Kantonalbank AG', 'Postfach', '', '3072', 'Ostermundigen 1', 'Suisse', 790, 0, 1),
(1731, 'Berner Kantonalbank AG', 'Postfach', '', '3150', 'Schwarzenburg', 'Suisse', 790, 0, 1),
(1732, 'Berner Kantonalbank AG', 'Altstadt', 'Postfach', '3011', 'Bern', 'Suisse', 790, 0, 1),
(1733, 'Berner Kantonalbank AG', 'Breitenrain', 'Postfach', '3014', 'Bern', 'Suisse', 790, 0, 1),
(1734, 'Berner Kantonalbank AG', 'Bümpliz', 'Postfach', '3018', 'Bern', 'Suisse', 790, 0, 1),
(1735, 'Berner Kantonalbank AG', 'Eigerplatz', 'Postfach', '3007', 'Bern', 'Suisse', 790, 0, 1),
(1736, 'Berner Kantonalbank AG', 'Inselspital', 'Postfach', '3010', 'Bern', 'Suisse', 790, 0, 1),
(1737, 'Berner Kantonalbank AG', 'Postfach', '', '3065', 'Bolligen', 'Suisse', 790, 0, 1),
(1738, 'Berner Kantonalbank AG', 'Postfach', '', '3084', 'Wabern', 'Suisse', 790, 0, 1),
(1739, 'Berner Kantonalbank AG', 'Postfach', '', '3076', 'Worb', 'Suisse', 790, 0, 1),
(1740, 'Berner Kantonalbank AG', 'Postfach', '', '3052', 'Zollikofen', 'Suisse', 790, 0, 1),
(1741, 'Berner Kantonalbank AG', '', '', '3661', 'Uetendorf', 'Suisse', 790, 0, 1),
(1742, 'Berner Kantonalbank AG', '', '', '3303', 'Jegenstorf', 'Suisse', 790, 0, 1),
(1743, 'Banque cantonale bernoise SA', 'Case postale 290', '', '2610', 'St-Imier', 'Suisse', 79005, 0, 1),
(1744, 'Banque cantonale bernoise SA', 'Case postale', '', '2606', 'Corgémont', 'Suisse', 79005, 0, 1),
(1745, 'Berner Kantonalbank AG', 'Postfach', '', '2501', 'Biel/Bienne', 'Suisse', 79010, 0, 1),
(1746, 'Berner Kantonalbank AG', 'Postfach', '', '3232', 'Ins', 'Suisse', 79010, 0, 1),
(1747, 'Berner Kantonalbank AG', 'Postfach', '', '2560', 'Nidau', 'Suisse', 79010, 0, 1),
(1748, 'Banque cantonale bernoise SA', 'Case postale', '', '2520', 'Neuveville, La', 'Suisse', 79011, 0, 1),
(1749, 'Berner Kantonalbank AG', 'Postfach', '', '2543', 'Lengnau BE', 'Suisse', 79012, 0, 1),
(1750, 'Berner Kantonalbank AG', 'Postfach', '', '3250', 'Lyss', 'Suisse', 79015, 0, 1),
(1751, 'Berner Kantonalbank AG', 'Postfach', '', '3270', 'Aarberg', 'Suisse', 79015, 0, 1),
(1752, 'Berner Kantonalbank AG', 'Postfach', '', '3255', 'Rapperswil BE', 'Suisse', 79015, 0, 1),
(1753, 'Berner Kantonalbank AG', 'Postfach', '', '3401', 'Burgdorf', 'Suisse', 79020, 0, 1),
(1754, 'Berner Kantonalbank AG', 'Postfach', '', '3422', 'Kirchberg BE', 'Suisse', 79020, 0, 1),
(1755, 'Berner Kantonalbank AG', 'Postfach', '', '3427', 'Utzenstorf', 'Suisse', 79020, 0, 1),
(1756, 'Berner Kantonalbank AG', 'Postfach', '', '3601', 'Thun', 'Suisse', 79025, 0, 1),
(1757, 'Berner Kantonalbank AG', 'Postfach', '', '3672', 'Oberdiessbach', 'Suisse', 79025, 0, 1),
(1758, 'Berner Kantonalbank AG', 'Postfach', '', '3612', 'Steffisburg 1', 'Suisse', 79025, 0, 1),
(1759, 'Berner Kantonalbank AG', 'Marktgasse', 'Postfach', '3601', 'Thun', 'Suisse', 79025, 0, 1),
(1760, 'Berner Kantonalbank AG', 'Postfach', '', '3700', 'Spiez', 'Suisse', 79030, 0, 1),
(1761, 'Berner Kantonalbank AG', 'Postfach', '', '3718', 'Kandersteg', 'Suisse', 79030, 0, 1),
(1762, 'Berner Kantonalbank AG', 'Postfach', '', '3775', 'Lenk im Simmental', 'Suisse', 79030, 0, 1),
(1763, 'Berner Kantonalbank AG', '', '', '3714', 'Frutigen', 'Suisse', 79030, 0, 1),
(1764, 'Berner Kantonalbank AG', 'Postfach', '', '3780', 'Gstaad', 'Suisse', 79031, 0, 1),
(1765, 'Berner Kantonalbank AG', 'Postfach', '', '3778', 'Schönried', 'Suisse', 79031, 0, 1),
(1766, 'Berner Kantonalbank AG', 'Postfach', '', '3715', 'Adelboden', 'Suisse', 79032, 0, 1),
(1767, 'Berner Kantonalbank AG', 'Postfach', '', '4901', 'Langenthal', 'Suisse', 79035, 0, 1),
(1768, 'Berner Kantonalbank AG', 'Postfach', '', '4914', 'Roggwil BE', 'Suisse', 79035, 0, 1),
(1769, 'Banque cantonale bernoise SA', 'Case postale', '', '2740', 'Moutier', 'Suisse', 79045, 0, 1),
(1770, 'Banque cantonale bernoise SA', 'Case postale', '', '2735', 'Malleray', 'Suisse', 79046, 0, 1),
(1771, 'Berner Kantonalbank AG', 'Postfach', '', '3800', 'Interlaken', 'Suisse', 79050, 0, 1),
(1772, 'Berner Kantonalbank AG', 'Postfach', '', '3855', 'Brienz BE', 'Suisse', 79050, 0, 1),
(1773, 'Berner Kantonalbank AG', 'Postfach', '', '3800', 'Unterseen', 'Suisse', 79050, 0, 1),
(1774, 'Berner Kantonalbank AG', 'Postfach', '', '3823', 'Wengen', 'Suisse', 79050, 0, 1),
(1775, 'Berner Kantonalbank AG', 'Postfach', '', '3818', 'Grindelwald', 'Suisse', 79051, 0, 1),
(1776, 'Berner Kantonalbank AG', 'Postfach', '', '3860', 'Meiringen', 'Suisse', 79052, 0, 1),
(1777, 'Berner Kantonalbank AG', 'Postfach', '', '3360', 'Herzogenbuchsee', 'Suisse', 79055, 0, 1),
(1778, 'Berner Kantonalbank AG', 'Postfach', '', '4704', 'Niederbipp', 'Suisse', 79055, 0, 1),
(1779, 'Berner Kantonalbank AG', 'Postfach', '', '3550', 'Langnau im Emmental', 'Suisse', 79065, 0, 1),
(1780, 'Berner Kantonalbank AG', 'Postfach', '', '3506', 'Grosshöchstetten', 'Suisse', 79065, 0, 1),
(1781, 'Berner Kantonalbank AG', 'Postfach', '', '3510', 'Konolfingen', 'Suisse', 79065, 0, 1),
(1782, 'Berner Kantonalbank AG', 'Postfach', '', '3436', 'Zollbrück', 'Suisse', 79065, 0, 1),
(1783, 'Banque cantonale bernoise SA', 'Case postale', '', '2720', 'Tramelan', 'Suisse', 79070, 0, 1),
(1784, 'Banque cantonale bernoise SA', 'Case postale', '', '2710', 'Tavannes', 'Suisse', 79071, 0, 1),
(1785, 'Berner Kantonalbank AG', 'Postfach', '', '4950', 'Huttwil', 'Suisse', 79075, 0, 1),
(1786, 'Berner Kantonalbank AG', 'Postfach', '', '3454', 'Sumiswald', 'Suisse', 79075, 0, 1),
(1787, 'Berner Kantonalbank AG', '', '', '4500', 'Solothurn', 'Suisse', 79085, 0, 1),
(1788, 'Berner Kantonalbank AG', 'Postfach', '', '2540', 'Grenchen', 'Suisse', 79085, 0, 1),
(1789, 'Berner Kantonalbank AG', 'Postfach', '', '4614', 'Hägendorf', 'Suisse', 79085, 0, 1),
(1790, 'Berner Kantonalbank AG', 'Postfach', '', '4702', 'Oensingen', 'Suisse', 79085, 0, 1),
(1791, 'Berner Kantonalbank AG', 'BEKB/BCBE net', 'Postfach', '3001', 'Bern', 'Suisse', 79095, 0, 1),
(1792, 'Raiffeisen Schweiz', 'Raiffeisenplatz', 'Postfach', '9001', 'St. Gallen', 'Suisse', 80000, 0, 1),
(1793, 'Banque Raiffeisen Région Delémont', 'Rue Pierre-Péquignat', '', '2800', 'Delémont', 'Suisse', 80002, 0, 1),
(1794, 'Banque Raiffeisen Région Delémont', 'Route de Châtillon 8', '', '2830', 'Courrendlin', 'Suisse', 80002, 0, 1),
(1795, 'Banque Raiffeisen Région Delémont', 'Avenue de la Gare 37', '', '2800', 'Delémont', 'Suisse', 80002, 0, 1),
(1796, 'Banque Raiffeisen Région Delémont', 'Rue de la Poste 10', '', '2853', 'Courfaivre', 'Suisse', 80002, 0, 1),
(1797, 'Banque Raiffeisen Région Delémont', 'Rue du Col. Hoffmeye', 'Case postale 153', '2854', 'Bassecourt', 'Suisse', 80002, 0, 1),
(1798, 'Banque Raiffeisen Région Delémont', 'Rue Préfet Comte 11', '', '2852', 'Courtételle', 'Suisse', 80002, 0, 1),
(1799, 'Banque Raiffeisen Région Delémont', 'Route de la Transjur', '', '2855', 'Glovelier', 'Suisse', 80002, 0, 1),
(1800, 'Banque Raiffeisen Région Delémont', 'Rue de la Liberté 5', '', '2802', 'Develier', 'Suisse', 80002, 0, 1),
(1801, 'Banque Raiffeisen de la Sorne', 'Rue de la Poste 10', '', '2853', 'Courfaivre', 'Suisse', 80004, 0, 1),
(1802, 'Raiffeisen Schweiz, Niederlassung St. Gallen', 'Vadianstrasse 17', 'Postfach', '9001', 'St. Gallen', 'Suisse', 80005, 0, 1),
(1803, 'Banque Raiffeisen de l&apos;Allaine', 'Route de la Nods 1a', '', '2926', 'Boncourt', 'Suisse', 80015, 0, 1),
(1804, 'Banque Raiffeisen  Ajoie', 'Rue du Jura 37', 'Case postale 1572', '2900', 'Porrentruy', 'Suisse', 80027, 0, 1),
(1805, 'Banque Raiffeisen  Ajoie', 'Rue Pierre Péquignat', '', '2950', 'Courgenay', 'Suisse', 80027, 0, 1),
(1806, 'Banque Raiffeisen  Ajoie', 'Route de la Nods 1a', '', '2926', 'Boncourt', 'Suisse', 80027, 0, 1),
(1807, 'Banque Raiffeisen  Ajoie', 'Rue de l&apos;Eglise', '', '2942', 'Alle', 'Suisse', 80027, 0, 1),
(1808, 'Banque Raiffeisen Clos du Doubs et Haute-Ajoie', 'Rue de l&apos;Hôpita', 'Case postale 54', '2882', 'St-Ursanne', 'Suisse', 80037, 0, 1),
(1809, 'Banque Raiffeisen Clos du Doubs et Haute-Ajoie', 'Rue du 23 juin 66', '', '2905', 'Courtedoux', 'Suisse', 80037, 0, 1),
(1810, 'Banque Raiffeisen Clos du Doubs et Haute-Ajoie', 'Route Principale 107', '', '2915', 'Bure', 'Suisse', 80037, 0, 1),
(1811, 'Banque Raiffeisen Clos du Doubs et Haute-Ajoie', 'Rue de l&apos;Abbaye', '', '2906', 'Chevenez', 'Suisse', 80037, 0, 1),
(1812, 'Banque Raiffeisen Clos du Doubs et Haute-Ajoie', 'Rue de Porrentruy 11', 'Case postale 26', '2916', 'Fahy', 'Suisse', 80037, 0, 1),
(1813, 'Banque Raiffeisen Pierre Pertuis', 'Rue du Collège32', 'Case postale 38', '2605', 'Sonceboz-Sombeval', 'Suisse', 80051, 0, 1),
(1814, 'Banque Raiffeisen Pierre Pertuis', 'Sous Banbois 2', '', '2515', 'Prêles', 'Suisse', 80051, 0, 1),
(1815, 'Banque Raiffeisen Pierre Pertuis', 'Route Principale 38/', '', '2533', 'Evilard', 'Suisse', 80051, 0, 1),
(1816, 'Banque Raiffeisen Pierre Pertuis', 'Place du Village 1', '', '2534', 'Orvin', 'Suisse', 80051, 0, 1),
(1817, 'Banque Raiffeisen Pierre Pertuis', 'Grand-Rue 136', '', '2720', 'Tramelan', 'Suisse', 80051, 0, 1),
(1818, 'Banque Raiffeisen Pierre Pertuis', 'Avenue de la Gare 12', '', '2740', 'Moutier', 'Suisse', 80051, 0, 1),
(1819, 'Banque Raiffeisen Pierre Pertuis', 'Grand-rue 22a', '', '2710', 'Tavannes', 'Suisse', 80051, 0, 1),
(1820, 'Banque Raiffeisen Pierre Pertuis', 'Rue Baptiste-Savoye ', '', '2610', 'St-Imier', 'Suisse', 80051, 0, 1),
(1821, 'Banque Raiffeisen Pierre Pertuis', 'Rue Aimée Charpilloz', '', '2735', 'Bévillard', 'Suisse', 80051, 0, 1),
(1822, 'Banque Raiffeisen Franches-Montagnes', 'Rue de l&apos;Hôpita', 'Case postale 165', '2350', 'Saignelégier', 'Suisse', 80059, 0, 1),
(1823, 'Banque Raiffeisen Franches-Montagnes', 'Rue de la Gare 11', '', '2345', 'Breuleux, Les', 'Suisse', 80059, 0, 1),
(1824, 'Banque Raiffeisen Franches-Montagnes', 'Les Bois, rue Guilla', '', '2336', 'Bois, Les', 'Suisse', 80059, 0, 1),
(1825, 'Banque Raiffeisen Franches-Montagnes', 'Rue du Marché 1', '', '2340', 'Noirmont, Le', 'Suisse', 80059, 0, 1),
(1826, 'Banque Raiffeisen Franches-Montagnes', 'Passage de la Poste ', '', '2714', 'Genevez JU, Les', 'Suisse', 80059, 0, 1),
(1827, 'Banque Raiffeisen Franches-Montagnes', 'Rte Principale 59 B', '', '2718', 'Lajoux JU', 'Suisse', 80059, 0, 1),
(1828, 'Banque Raiffeisen du Val-Terbi', 'Route Principale 51', 'Case postale 126', '2824', 'Vicques', 'Suisse', 80073, 0, 1),
(1829, 'Banque Raiffeisen du Val-Terbi', 'Rue de Bellevie 3', '', '2822', 'Courroux', 'Suisse', 80073, 0, 1),
(1830, 'Banque Raiffeisen Haute Birse', 'Rue Aimé Charpilloz ', 'Case postale 461', '2735', 'Bévilard', 'Suisse', 80093, 0, 1),
(1831, 'Raiffeisenbank Worblen-Emmental', 'Bahnhofstrasse 7', 'Postfach 131', '3507', 'Biglen', 'Suisse', 80094, 0, 1),
(1832, 'Raiffeisenbank Worblen-Emmental', 'Worbstrasse 4', '', '3067', 'Boll', 'Suisse', 80094, 0, 1),
(1833, 'Raiffeisenbank Worblen-Emmental', 'Bernstrasse 81', '', '3072', 'Ostermundigen', 'Suisse', 80094, 0, 1),
(1834, 'Raiffeisenbank Worblen-Emmental', 'Bahnhofplatz 5', '', '3076', 'Worb', 'Suisse', 80094, 0, 1),
(1835, 'Raiffeisenbank Worblen-Emmental', 'Talweg 2', '', '3063', 'Ittigen', 'Suisse', 80094, 0, 1),
(1836, 'Raiffeisenbank Laufental-Thierstein', 'Bahnhofstrasse 17', '', '4242', 'Laufen', 'Suisse', 80097, 0, 1),
(1837, 'Raiffeisenbank Laufental-Thierstein', 'Huggerwaldstrasse 6', '', '4245', 'Kleinlützel', 'Suisse', 80097, 0, 1),
(1838, 'Raiffeisenbank Laufental-Thierstein', 'Breitenbachstrasse 3', '', '4227', 'Büsserach', 'Suisse', 80097, 0, 1),
(1839, 'Raiffeisenbank Gürbe', 'Dorfstrasse 11', 'Postfach 112', '3123', 'Belp', 'Suisse', 80098, 0, 1),
(1840, 'Raiffeisenbank Gürbe', 'Dorfstrasse 7', 'Postfach', '3634', 'Thierachern', 'Suisse', 80098, 0, 1),
(1841, 'Raiffeisenbank Gürbe', 'Postgasse 4', '', '3665', 'Wattenwil', 'Suisse', 80098, 0, 1),
(1842, 'Banque Raiffeisen Sarine-Ouest', 'Route de Fribourg 4', 'Case postale 66', '1782', 'Belfaux', 'Suisse', 80102, 0, 1),
(1843, 'Banque Raiffeisen de Marly', 'Route du Chevalier 3', 'Case postale 287', '1723', 'Marly 1', 'Suisse', 80105, 0, 1),
(1844, 'Banque Raiffeisen de Marly', 'Beaumont 16', '', '1700', 'Fribourg', 'Suisse', 80105, 0, 1),
(1845, 'Banque Raiffeisen Vuadens/Sâles/St-Martin', 'Route Principale 174', '', '1628', 'Vuadens', 'Suisse', 80107, 0, 1),
(1846, 'Banque Raiffeisen de la Glâne', 'Route de Billens 14', 'Case postale 289', '1680', 'Romont FR', 'Suisse', 80108, 0, 1),
(1847, 'Banque Raiffeisen Vallée de la Jogne', 'Rue du Centre 44', 'Case postale 70', '1637', 'Charmey (Gruyère)', 'Suisse', 80117, 0, 1),
(1848, 'Banque Raiffeisen Vallée de la Jogne', 'Rue Montsalvens 11', '', '1636', 'Broc', 'Suisse', 80117, 0, 1),
(1849, 'Banque Raiffeisen Basse Broye Vully', 'Pré de la Cour 29', 'Case postale 30', '1564', 'Domdidier', 'Suisse', 80123, 0, 1),
(1850, 'Banque Raiffeisen Basse Broye Vully', 'Rue Centrale 43', '', '1580', 'Avenches', 'Suisse', 80123, 0, 1),
(1851, 'Banque Raiffeisen Basse Broye Vully', 'Route Principale 20', '', '1786', 'Sugiez', 'Suisse', 80123, 0, 1),
(1852, 'Banque Raiffeisen Moléson', 'Route Principale 174', '', '1628', 'Vuadens', 'Suisse', 80129, 0, 1),
(1853, 'Banque Raiffeisen Moléson', 'Rue du Moléson 19', '', '1669', 'Albeuve', 'Suisse', 80129, 0, 1),
(1854, 'Banque Raiffeisen Moléson', 'Rue de la Gruyère', '', '1632', 'Riaz', 'Suisse', 80129, 0, 1),
(1855, 'Banque Raiffeisen Moléson', 'Place du Village', '', '1617', 'Remaufens', 'Suisse', 80129, 0, 1),
(1856, 'Banque Raiffeisen Moléson', 'Route du Devin 2', '', '1623', 'Semsales', 'Suisse', 80129, 0, 1),
(1857, 'Banque Raiffeisen Moléson', 'Place des Alpes 20', '', '1630', 'Bulle', 'Suisse', 80129, 0, 1),
(1858, 'Banque Raiffeisen Moléson', 'Rue Ancien Comté 27', '', '1635', 'Tour-de-Trême, La', 'Suisse', 80129, 0, 1),
(1859, 'Banque Raiffeisen Moléson', 'Route de Billens 14', '', '1680', 'Romont FR', 'Suisse', 80129, 0, 1),
(1860, 'Banque Raiffeisen Moléson', 'Chemin du Soleil 1', '', '1670', 'Ursy', 'Suisse', 80129, 0, 1),
(1861, 'Banque Raiffeisen Estavayer-Montagny', 'Route de la Chapelle', 'Case postale 855', '1470', 'Estavayer-le-Lac', 'Suisse', 80139, 0, 1),
(1862, 'Banque Raiffeisen Estavayer-Montagny', 'Rue Centrale 56', 'Case postale 22', '1776', 'Montagny-la-Ville', 'Suisse', 80139, 0, 1),
(1863, 'Banque Raiffeisen Cousimbert', 'Route de Fribourg 11', '', '1634', 'Roche FR, La', 'Suisse', 80150, 0, 1),
(1864, 'Banque Raiffeisen Cousimbert', 'Rte du Pafuet 1', '', '1724', 'Mouret, Le', 'Suisse', 80150, 0, 1),
(1865, 'Banque Raiffeisen Cousimbert', 'Route de Montena 1', '', '1728', 'Rossens FR', 'Suisse', 80150, 0, 1),
(1866, 'Banque Raiffeisen du Gibloux', 'Route St-Ignace 43', 'Case postale 24', '1633', 'Marsens', 'Suisse', 80155, 0, 1),
(1867, 'Banque Raiffeisen du Gibloux', 'Chemin des Branches ', '', '1648', 'Hauteville', 'Suisse', 80155, 0, 1),
(1868, 'Banque Raiffeisen du Gibloux', 'Route de l&apos;Egli', '', '1644', 'Avry-devant-Pont', 'Suisse', 80155, 0, 1),
(1869, 'Banque Raiffeisen du Gibloux', 'Chemin de la Paix 6', 'Case postale 24', '1642', 'Sorens', 'Suisse', 80155, 0, 1),
(1870, 'Banque Raiffeisen Fribourg-Ouest', 'Route de Moncor 12', 'Case postale 16', '1752', 'Villars-sur-Glâne', 'Suisse', 80159, 0, 1),
(1871, 'Banque Raiffeisen Région Genève Rhône', 'Rue de Bernex 259A', '', '1233', 'Bernex', 'Suisse', 80181, 0, 1),
(1872, 'Banque Raiffeisen Région Genève Rhône', 'Chemin de Gué 99', '', '1213', 'Petit-Lancy, Le', 'Suisse', 80181, 0, 1),
(1873, 'Banque Raiffeisen Région Genève Rhône', 'Rond-Point de Plainp', 'Région Genève Rhone', '1205', 'Genève', 'Suisse', 80181, 0, 1),
(1874, 'Banque Raiffeisen du Salève', 'Route de Veyrier 264', 'Case postale 160', '1255', 'Veyrier', 'Suisse', 80187, 0, 1),
(1875, 'Banque Raiffeisen du Salève', 'Rte de St-Julien 145', '', '1228', 'Plan des Ouates', 'Suisse', 80187, 0, 1),
(1876, 'Banque Raiffeisen du Salève', 'Avenue Krieg 15', '', '1208', 'Genève', 'Suisse', 80187, 0, 1),
(1877, 'Banque Raiffeisen du Salève', 'Rue de Marché 11', '', '1227', 'Carouge', 'Suisse', 80187, 0, 1),
(1878, 'Banque Raiffeisen d&apos;Arve et Lac', 'Rue Peillonnex 2', 'Case postale 77', '1225', 'Chêne-Bourg', 'Suisse', 80188, 0, 1),
(1879, 'Banque Raiffeisen d&apos;Arve et Lac', '116, rte d&apos;Herm', '', '1245', 'Collonge-Bellerive', 'Suisse', 80188, 0, 1),
(1880, 'Banque Raiffeisen d&apos;Arve et Lac', 'Cours de Rive 4', '', '1204', 'Genève', 'Suisse', 80188, 0, 1),
(1881, 'Banque Raiffeisen de Meyrin', 'Case postale 9', '', '1217', 'Meyrin', 'Suisse', 80206, 0, 1),
(1882, 'Banque Raiffeisen de Meyrin', 'Avenue de Feuillasse', '', '1217', 'Meyrin', 'Suisse', 80206, 0, 1),
(1883, 'Banque Raiffeisen Genève Ouest', 'Route Aire-la-Ville ', 'Case postale 155', '1242', 'Satigny', 'Suisse', 80210, 0, 1),
(1884, 'Banque Raiffeisen Genève Ouest', 'ch. Edouard-Sarasin ', '', '1218', 'Grand-Saconnex, Le', 'Suisse', 80210, 0, 1),
(1885, 'Banque Raiffeisen Genève Ouest', 'Rue de Lyon 2', '', '1201', 'Genève', 'Suisse', 80210, 0, 1);
INSERT INTO `faturacao_bancos_fornecedores` (`ID_BancoFornecedor`, `Nome`, `Address1`, `Address2`, `NPA`, `Localite`, `PaisBanco`, `BCNbr`, `Predefinido`, `Ativo`) VALUES
(1886, 'Banque Raiffeisen de la Versoix', 'Place Charles David ', 'Case postale 228', '1290', 'Versoix', 'Suisse', 80215, 0, 1),
(1887, 'Banque Raiffeisen de la Versoix', 'Rue du Mont-Blanc 19', '', '1201', 'Genève', 'Suisse', 80215, 0, 1),
(1888, 'Banque Raiffeisen des Montagnes Neuchâteloises', 'Rue du Temple 19', '', '2400', 'Locle, Le', 'Suisse', 80237, 0, 1),
(1889, 'Banque Raiffeisen des Montagnes Neuchâteloises', 'Av. Léopold-Robert 1', '', '2300', 'Chaux-de-Fonds, La', 'Suisse', 80237, 0, 1),
(1890, 'Banque Raiffeisen des Montagnes Neuchâteloises', 'Industrie 7', '', '2316', 'Ponts-de-Martel, Les', 'Suisse', 80237, 0, 1),
(1891, 'Banque Raiffeisen des Montagnes Neuchâteloises', 'Rue du Village 180', '', '2406', 'Brévine, La', 'Suisse', 80237, 0, 1),
(1892, 'Banque Raiffeisen du Vignoble', 'Rue du Centre 8', 'Case postale 18', '2023', 'Gorgier', 'Suisse', 80241, 0, 1),
(1893, 'Banque Raiffeisen du Vignoble', 'Rue du Temple 9', '', '2022', 'Bevaix', 'Suisse', 80241, 0, 1),
(1894, 'Banque Raiffeisen du Vignoble', 'rue Haute 21', '', '2013', 'Colombier NE', 'Suisse', 80241, 0, 1),
(1895, 'Banque Raiffeisen du Vignoble', 'Grand-Rue 30', '', '2072', 'St-Blaise', 'Suisse', 80241, 0, 1),
(1896, 'Banque Raiffeisen du Vignoble', 'Rue de la Pierre à M', '', '2000', 'Neuchâtel', 'Suisse', 80241, 0, 1),
(1897, 'Banque Raiffeisen du Vignoble', 'Route de Neuchâtel 1', '', '2520', 'Neuveville, La', 'Suisse', 80241, 0, 1),
(1898, 'Banque Raiffeisen du Val-de-Ruz', 'Rue du Collège 1', '', '2207', 'Coffrane', 'Suisse', 80251, 0, 1),
(1899, 'Banque Raiffeisen du Val-de-Ruz', 'Rue de l&apos;Epervi', '', '2053', 'Cernier', 'Suisse', 80251, 0, 1),
(1900, 'Banque Raiffeisen du Val-de-Ruz', 'Grand-Rue 13', '', '2056', 'Dombresson', 'Suisse', 80251, 0, 1),
(1901, 'Banque Raiffeisen Val-de-Travers', 'Avenue de la Gare 12', 'Case postale 376', '2114', 'Fleurier', 'Suisse', 80261, 0, 1),
(1902, 'Banque Raiffeisen Val-de-Travers', 'Rue du Preyel 2', '', '2108', 'Couvet', 'Suisse', 80261, 0, 1),
(1903, 'Banque Raiffeisen Val-de-Travers', 'Rue Miéville 12', '', '2105', 'Travers', 'Suisse', 80261, 0, 1),
(1904, 'Banque Raiffeisen Val-de-Travers', 'Les Bolles du Temple', '', '2117', 'Côte-aux-Fées, La', 'Suisse', 80261, 0, 1),
(1905, 'Banca Raiffeisen del Basso Mendrisiotto', 'Corso San Gottardo 5', 'Casella postale 2863', '6830', 'Chiasso', 'Suisse', 80272, 0, 1),
(1906, 'Banca Raiffeisen del Basso Mendrisiotto', 'Via San Gottardo 61', 'Casella postale 279', '6828', 'Balerna', 'Suisse', 80272, 0, 1),
(1907, 'Banca Raiffeisen Cugnasco Gordola Verzasca', 'Via San Gottardo 67', 'Casella postale 1033', '6596', 'Gordola', 'Suisse', 80280, 0, 1),
(1908, 'Banca Raiffeisen Cugnasco Gordola Verzasca', 'Via Locarno 1', '', '6516', 'Cugnasco', 'Suisse', 80280, 0, 1),
(1909, 'Banca Raiffeisen Cugnasco Gordola Verzasca', 'Via Stazione 15', '', '6593', 'Cadenazzo', 'Suisse', 80280, 0, 1),
(1910, 'Banca Raiffeisen Cugnasco Gordola Verzasca', 'Via Canonale 138', '', '6573', 'Magadino', 'Suisse', 80280, 0, 1),
(1911, 'Banca Raiffeisen Centovalli Pedemonte Onsernone', 'Stradon 53', '', '6653', 'Verscio', 'Suisse', 80281, 0, 1),
(1912, 'Banca Raiffeisen Centovalli Pedemonte Onsernone', 'via Cantonale', '', '6655', 'Intragna', 'Suisse', 80281, 0, 1),
(1913, 'Banca Raiffeisen Centovalli Pedemonte Onsernone', 'Via XXI Settembre', '', '6661', 'Loco', 'Suisse', 80281, 0, 1),
(1914, 'Banca Raiffeisen del Vedeggio', 'Via Grumo 31', '', '6929', 'Gravesano', 'Suisse', 80283, 0, 1),
(1915, 'Banca Raiffeisen del Vedeggio', 'Via Carvina 4', '', '6807', 'Taverne', 'Suisse', 80283, 0, 1),
(1916, 'Banca Raiffeisen del Vedeggio', 'Via Sirana 54', '', '6814', 'Lamone', 'Suisse', 80283, 0, 1),
(1917, 'Banca Raiffeisen del Vedeggio', 'Via Cantonale', '', '6802', 'Rivera', 'Suisse', 80283, 0, 1),
(1918, 'Banca Raiffeisen Basso Ceresio', 'Via Cantonale 85', 'Casella postale 335', '6818', 'Melano', 'Suisse', 80287, 0, 1),
(1919, 'Banca Raiffeisen Basso Ceresio', 'Piazza Zorzi 2', 'Casella postale 80', '6816', 'Bisone', 'Suisse', 80287, 0, 1),
(1920, 'Banca Raiffeisen Basso Ceresio', 'Via dell&apos; Indip', '', '6826', 'Riva San Vitale', 'Suisse', 80287, 0, 1),
(1921, 'Banca Raiffeisen Morbio-Vacallo', 'Via Asilo 3', 'Casella postale 260', '6834', 'Morbio Inferiore', 'Suisse', 80290, 0, 1),
(1922, 'Banca Raiffeisen Morbio-Vacallo', 'Via Gen. Guisan 2', '', '6833', 'Vacallo', 'Suisse', 80290, 0, 1),
(1923, 'Banca Raiffeisen Riva San Vitale', 'Via dell&apos;Indipe', 'Casella postale 91', '6826', 'Riva San Vitale', 'Suisse', 80296, 0, 1),
(1924, 'Banca Raiffeisen Malcantonese', 'Via Contrada Nuova 3', '', '6982', 'Agno', 'Suisse', 80307, 0, 1),
(1925, 'Banca Raiffeisen Malcantonese', 'Via Cantonale 23', '', '6936', 'Cademario', 'Suisse', 80307, 0, 1),
(1926, 'Banca Raiffeisen Malcantonese', 'Via Cademario 9', 'Casella postale 208', '6934', 'Bioggio', 'Suisse', 80307, 0, 1),
(1927, 'Banca Raiffeisen Malcantonese', 'Piazzale Demarta', 'Casella postale 142', '6986', 'Novaggio', 'Suisse', 80307, 0, 1),
(1928, 'Banca Raiffeisen Malcantonese', 'Piazza Cavalier Giov', '', '6997', 'Sessa', 'Suisse', 80307, 0, 1),
(1929, 'Banca Raiffeisen Canobbio-Comano-Cureglia', 'Via S. Bernardo 20', '', '6952', 'Canobbio', 'Suisse', 80315, 0, 1),
(1930, 'Banca Raiffeisen della Magliasina', 'Via Stazione', 'Casella postale 249', '6987', 'Caslano', 'Suisse', 80317, 0, 1),
(1931, 'Banca Raiffeisen della Magliasina', 'Via Cantonale', '', '6983', 'Magliaso', 'Suisse', 80317, 0, 1),
(1932, 'Banca Raiffeisen della Magliasina', 'Via Cantonale', '', '6995', 'Molinazzo di Monteggio', 'Suisse', 80317, 0, 1),
(1933, 'Banca Raiffeisen Gambarogno e Cadenazzo', 'Centro Contone 1', 'Casella postale 130', '6594', 'Contone', 'Suisse', 80324, 0, 1),
(1934, 'Banca Raiffeisen del Monte San Giorgio', 'Via Mastri Ligornett', '', '6853', 'Ligornetto', 'Suisse', 80332, 0, 1),
(1935, 'Banca Raiffeisen del Monte San Giorgio', 'Via V. Vela 9', '', '6862', 'Rancate', 'Suisse', 80332, 0, 1),
(1936, 'Banca Raiffeisen Losone-Circolo delle Isole', 'Via S.Materno 1', 'Casella postale 741', '6616', 'Losone', 'Suisse', 80333, 0, 1),
(1937, 'Banca Raiffeisen Losone-Circolo delle Isole', 'viale Papio 8', 'Casella postale', '6612', 'Ascona', 'Suisse', 80333, 0, 1),
(1938, 'Banca Raiffeisen Losone-Circolo delle Isole', 'Via R. Leoncavallo 3', '', '6614', 'Brissago', 'Suisse', 80333, 0, 1),
(1939, 'Banca Raiffeisen Vallemaggia', 'Via Cantonale', '', '6673', 'Maggia', 'Suisse', 80335, 0, 1),
(1940, 'Banca Raiffeisen Vallemaggia', 'Via Cantonale', '', '6695', 'Peccia', 'Suisse', 80335, 0, 1),
(1941, 'Banca Raiffeisen Vallemaggia', 'Piazza', '', '6675', 'Cevio', 'Suisse', 80335, 0, 1),
(1942, 'Banca Raiffeisen Mendrisio e Valle di Muggio', 'Via Lavizzari 19A', 'Casella postale 73', '6850', 'Mendrisio', 'Suisse', 80340, 0, 1),
(1943, 'Banca Raiffeisen Mendrisio e Valle di Muggio', 'Via G.B. Maggi', '', '6874', 'Castel San Pietro', 'Suisse', 80340, 0, 1),
(1944, 'Banca Raiffeisen Mendrisio e Valle di Muggio', 'Via Cantonale', '', '6837', 'Caneggio', 'Suisse', 80340, 0, 1),
(1945, 'Banca Raiffeisen del Camoghè', 'Via della Posta 7', '', '6512', 'Giubiasco', 'Suisse', 80344, 0, 1),
(1946, 'Banca Raiffeisen del Camoghè', 'Via al Ticino 18', '', '6514', 'Sementina', 'Suisse', 80344, 0, 1),
(1947, 'Banca Raiffeisen del Camoghè', 'el Cunvént 7', '', '6513', 'Monte Carasso', 'Suisse', 80344, 0, 1),
(1948, 'Banca Raiffeisen del Camoghè', 'In Muntagna 4', '', '6528', 'Camorino', 'Suisse', 80344, 0, 1),
(1949, 'Banca Raiffeisen Tre Valli', 'Via A. Giovannini 4', '', '6710', 'Biasca', 'Suisse', 80350, 0, 1),
(1950, 'Banca Raiffeisen Tre Valli', 'via Campagna', '', '6713', 'Malvaglia', 'Suisse', 80350, 0, 1),
(1951, 'Banca Raiffeisen Tre Valli', 'zona Lavorceno', '', '6718', 'Olivone', 'Suisse', 80350, 0, 1),
(1952, 'Banca Raiffeisen Tre Valli', 'Via Cantonale 147', '', '6527', 'Lodrino', 'Suisse', 80350, 0, 1),
(1953, 'Banca Raiffeisen Tre Valli', 'Piazza Stefano Frans', '', '6760', 'Faido', 'Suisse', 80350, 0, 1),
(1954, 'Banca Raiffeisen Tre Valli', 'Via San Gottardo 41', '', '6780', 'Airolo', 'Suisse', 80350, 0, 1),
(1955, 'Banca Raiffeisen Colline del Ceresio', 'Via San Gottardo 139', 'Casella postale 544', '6942', 'Savosa', 'Suisse', 80362, 0, 1),
(1956, 'Banca Raiffeisen Colline del Ceresio', 'Via Polar 69', '', '6932', 'Breganzona', 'Suisse', 80362, 0, 1),
(1957, 'Banca Raiffeisen Medio Cassarate', 'Piazza Granda 2', '', '6968', 'Sonvico', 'Suisse', 80364, 0, 1),
(1958, 'Banca Raiffeisen della Campagnadorna', 'Via Boff 2', '', '6855', 'Stabio', 'Suisse', 80365, 0, 1),
(1959, 'Banca Raiffeisen della Campagnadorna', 'Via Boschetto 1', 'Casella postale 22', '6883', 'Novazzano', 'Suisse', 80365, 0, 1),
(1960, 'Banca Raiffeisen della Campagnadorna', 'Piazza Baraini', '', '6852', 'Genestrerio', 'Suisse', 80365, 0, 1),
(1961, 'Banca Raiffeisen della Campagnadorna', 'Via Mola 12', '', '6877', 'Coldrerio', 'Suisse', 80365, 0, 1),
(1962, 'Banca Raiffeisen del Cassarate', 'Piazza Motta', 'Casella Postale 162', '6950', 'Tesserete', 'Suisse', 80366, 0, 1),
(1963, 'Banca Raiffeisen del Cassarate', 'Via alle Scuole', '', '6946', 'Ponte Capriasca', 'Suisse', 80366, 0, 1),
(1964, 'Banca Raiffeisen del Cassarate', 'Piazza Sant&apos;Aga', '', '6965', 'Cadro', 'Suisse', 80366, 0, 1),
(1965, 'Banca Raiffeisen del Cassarate', 'Via Massagno 1a', '', '6952', 'Canobbio', 'Suisse', 80366, 0, 1),
(1966, 'Banca Raiffeisen del Cassarate', 'via Cantonale 42', '', '6949', 'Comano', 'Suisse', 80366, 0, 1),
(1967, 'Banca Raiffeisen del Cassarate', 'via Cantonale 12A', '', '6944', 'Cureglia', 'Suisse', 80366, 0, 1),
(1968, 'Banca Raiffeisen del Cassarate', 'Piazza Granda 2', '', '6968', 'Sonvico', 'Suisse', 80366, 0, 1),
(1969, 'Banca Raiffeisen del Cassarate', 'Via al Ram 1', '', '6964', 'Davesco-Soragno', 'Suisse', 80366, 0, 1),
(1970, 'Banca Raiffeisen Leventina', 'Piazza Stefano Frans', 'Casella postale 1347', '6760', 'Faido', 'Suisse', 80374, 0, 1),
(1971, 'Banca Raiffeisen Lugano', 'Via Pretorio 22', '', '6900', 'Lugano', 'Suisse', 80375, 0, 1),
(1972, 'Banca Raiffeisen Lugano', 'Via Cersesio 55', '', '6963', 'Pregassona', 'Suisse', 80375, 0, 1),
(1973, 'Banca Raiffeisen Locarno', 'Piazza Muraccio 6', 'Casella postale 441', '6601', 'Locarno', 'Suisse', 80379, 0, 1),
(1974, 'Banca Raiffeisen Locarno', 'Via Vallemaggia 73', '', '6604', 'Locarno', 'Suisse', 80379, 0, 1),
(1975, 'Banca Raiffeisen Locarno', 'Piazza Stazione 4A', '', '6602', 'Muralto', 'Suisse', 80379, 0, 1),
(1976, 'Banca Raiffeisen Locarno', 'Via San Gottardo 80A', '', '6648', 'Minusio', 'Suisse', 80379, 0, 1),
(1977, 'Banca Raiffeisen Biasca-Lodrino', 'Piazzale Comunale 6', 'Casella postale 1537', '6710', 'Biasca', 'Suisse', 80382, 0, 1),
(1978, 'Banca Raiffeisen Bellinzonese e Visagno', 'Via G. Jauch 1', '', '6501', 'Bellinzona', 'Suisse', 80387, 0, 1),
(1979, 'Banca Raiffeisen Bellinzonese e Visagno', 'Viale Moesa 2', '', '6517', 'Arbedo', 'Suisse', 80387, 0, 1),
(1980, 'Banca Raiffeisen Bellinzonese e Visagno', '', '', '6702', 'Claro', 'Suisse', 80387, 0, 1),
(1981, 'Banque Raiffeisen des Alpes Vaudoises', 'Route de la Cité 16', 'Case postale 196', '1854', 'Leysin', 'Suisse', 80400, 0, 1),
(1982, 'Banque Raiffeisen Mont-Aubert Orbe', 'En Chamard 41 C', '', '1442', 'Montagny-près-Yverdon', 'Suisse', 80401, 0, 1),
(1983, 'Banque Raiffeisen Mont-Aubert Orbe', 'Rue Haute 3', '', '1422', 'Grandson', 'Suisse', 80401, 0, 1),
(1984, 'Banque Raiffeisen Mont-Aubert Orbe', 'Rue Cerntrale 6', 'Case postale', '1450', 'Ste-Croix', 'Suisse', 80401, 0, 1),
(1985, 'Banque Raiffeisen Mont-Aubert Orbe', 'Grand-Rue 9', '', '1337', 'Vallorbe', 'Suisse', 80401, 0, 1),
(1986, 'Banque Raiffeisen Talent-Menthue', 'Rue du Château 4', 'Case postale 28', '1376', 'Goumoens-la-Ville', 'Suisse', 80403, 0, 1),
(1987, 'Banque Raiffeisen d&apos;Assens', 'Rte St-Germain 3', '', '1042', 'Assens', 'Suisse', 80414, 0, 1),
(1988, 'Banque Raiffeisen d&apos;Assens', 'Rte de Lausanne 10', '', '1033', 'Cheseaux-sur-Lausanne', 'Suisse', 80414, 0, 1),
(1989, 'Banque Raiffeisen d&apos;Assens', 'Rue du Centre 21', '', '1023', 'Crissier', 'Suisse', 80414, 0, 1),
(1990, 'Banque Raiffeisen d&apos;Assens', 'Rue de la Mèbre 4', '', '1020', 'Renens', 'Suisse', 80414, 0, 1),
(1991, 'Banque Raiffeisen du Pays-d&apos;Enhaut', 'Place de la Gare, Rt', '', '1660', 'Château-d&apos;Oex', 'Suisse', 80428, 0, 1),
(1992, 'Banque Raiffeisen de La Riviera', 'Rue du Château 2', 'Case postale 78', '1804', 'Corsier-sur-Vevey', 'Suisse', 80430, 0, 1),
(1993, 'Banque Raiffeisen de La Riviera', 'Place de la Gare 7', 'Case postale 164', '1807', 'Blonay', 'Suisse', 80430, 0, 1),
(1994, 'Banque Raiffeisen de La Riviera', 'Quai Grand&apos;Rive', 'Case postale 315', '1844', 'Villeneuve VD', 'Suisse', 80430, 0, 1),
(1995, 'Banque Raiffeisen de La Riviera', 'Rue du Simplon 48', 'Case postale 155', '1800', 'Vevey', 'Suisse', 80430, 0, 1),
(1996, 'Banque Raiffeisen du Gros-de-Vaud', 'Rte de Lausanne 3', 'Case postale 291', '1040', 'Echallens', 'Suisse', 80434, 0, 1),
(1997, 'Banque Raiffeisen du Gros-de-Vaud', 'Rte de Coppoz', '', '1052', 'Mont-sur-Lausanne, Le', 'Suisse', 80434, 0, 1),
(1998, 'Banque Raiffeisen du Gros-de-Vaud', 'La Vy-de-Bottens 2', '', '1055', 'Froideville', 'Suisse', 80434, 0, 1),
(1999, 'Banque Raiffeisen du Gros-de-Vaud', 'Route des Flumeaux 6', 'Case postale 11', '1008', 'Prilly', 'Suisse', 80434, 0, 1),
(2000, 'Banque Raiffeisen Nyon-La Vallée', 'Avenue Alfred-Cortot', '', '1260', 'Nyon', 'Suisse', 80442, 0, 1),
(2001, 'Banque Raiffeisen Nyon-La Vallée', 'Route de France 4', '', '1348', 'Brassus, Le', 'Suisse', 80442, 0, 1),
(2002, 'Banque Raiffeisen Nyon-La Vallée', 'Vy-de-Montorge 1', '', '1295', 'Mies', 'Suisse', 80442, 0, 1),
(2003, 'Banque Raiffeisen du Mont-Tendre', 'Rue du Bourg 11', '', '1147', 'Montricher', 'Suisse', 80445, 0, 1),
(2004, 'Banque Raiffeisen du Mont-Tendre', 'Rue de Chabiez 2', '', '1148', 'Isle, L&apos;', 'Suisse', 80445, 0, 1),
(2005, 'Banque Raiffeisen du Mont-Tendre', 'La Vy de Ballens 6', '', '1145', 'Bière', 'Suisse', 80445, 0, 1),
(2006, 'Banque Raiffeisen du Mont-Tendre', 'Route de Bière 3', '', '1143', 'Apples', 'Suisse', 80445, 0, 1),
(2007, 'Banque Raiffeisen Alpes Chablais Vaudois', 'Place du Centre 1', '', '1860', 'Aigle', 'Suisse', 80447, 0, 1),
(2008, 'Banque Raiffeisen Alpes Chablais Vaudois', 'Rue Centrale 37', '', '1880', 'Bex', 'Suisse', 80447, 0, 1),
(2009, 'Banque Raiffeisen Alpes Chablais Vaudois', 'Chemin de la Forge 1', '', '1867', 'Ollon VD', 'Suisse', 80447, 0, 1),
(2010, 'Banque Raiffeisen Alpes Chablais Vaudois', 'Route de la Cité 16', '', '1854', 'Leysin', 'Suisse', 80447, 0, 1),
(2011, 'Banque Raiffeisen Alpes Chablais Vaudois', 'Rue de la Gare 9', '', '1865', 'Diablerets, Les', 'Suisse', 80447, 0, 1),
(2012, 'Banque Raiffeisen Alpes Chablais Vaudois', 'Route de la Gare 12', '', '1660', 'Château-d&apos;Oex', 'Suisse', 80447, 0, 1),
(2013, 'Banque Raiffeisen Alpes Chablais Vaudois', 'Place du Village 22', '', '1658', 'Rossinière', 'Suisse', 80447, 0, 1),
(2014, 'Banque Raiffeisen Alpes Chablais Vaudois', 'Place de la Gare 3', '', '1659', 'Rougemont', 'Suisse', 80447, 0, 1),
(2015, 'Banque Raiffeisen Lausanne Haute-Broye-Jorat', 'Voie du Chariot 7', '', '1003', 'Lausanne', 'Suisse', 80451, 0, 1),
(2016, 'Banque Raiffeisen Lausanne Haute-Broye-Jorat', 'Ruelle du Pasteur Ma', 'Case postale 73', '1083', 'Mézières VD', 'Suisse', 80451, 0, 1),
(2017, 'Banque Raiffeisen Lausanne Haute-Broye-Jorat', 'Rte de Lausanne 15', 'Case postale 76', '1610', 'Oron-la-Ville', 'Suisse', 80451, 0, 1),
(2018, 'Banque Raiffeisen Lausanne Haute-Broye-Jorat', 'Rte de la Croix-Blan', '', '1066', 'Epalinges', 'Suisse', 80451, 0, 1),
(2019, 'Banque Raiffeisen Puidoux-Chexbres-Forel', 'Chemin de Publoz 11', 'Case postale 24', '1070', 'Puidoux', 'Suisse', 80453, 0, 1),
(2020, 'Banque Raiffeisen de Lavaux', 'Chemin de Publoz 11', 'Case postale 152', '1070', 'Puidoux', 'Suisse', 80454, 0, 1),
(2021, 'Banque Raiffeisen de Lavaux', 'Rue de Temple 18', '', '1096', 'Cully', 'Suisse', 80454, 0, 1),
(2022, 'Banque Raiffeisen de Lavaux', 'Chemin du Pré-de-la ', '', '1009', 'Pully', 'Suisse', 80454, 0, 1),
(2023, 'Banque Raiffeisen de Lavaux', 'Grand-Rue 37', '', '1095', 'Lutry', 'Suisse', 80454, 0, 1),
(2024, 'Banque Raiffeisen de Lavaux', 'Rte de Grandvaux 1', '', '1072', 'Forel (Lavaux)', 'Suisse', 80454, 0, 1),
(2025, 'Banque Raiffeisen Morges Venoge', 'Place de la Gare 3', 'Case postale 192', '1110', 'Morges 1', 'Suisse', 80460, 0, 1),
(2026, 'Banque Raiffeisen Morges Venoge', 'Chemin Neuf 4', '', '1163', 'Etoy', 'Suisse', 80460, 0, 1),
(2027, 'Banque Raiffeisen Morges Venoge', 'Rue du Chêne 1', 'Case postale', '1315', 'Sarraz, La', 'Suisse', 80460, 0, 1),
(2028, 'Banque Raiffeisen Morges Venoge', 'Rue de la Gare 27', '', '1110', 'Morges 1', 'Suisse', 80460, 0, 1),
(2029, 'Banque Raiffeisen Morges Venoge', 'Avenue du Tir- Fédér', '', '1024', 'Ecublens', 'Suisse', 80460, 0, 1),
(2030, 'Banque Raiffeisen Plateau du Jorat-Molondin', 'Rue de la Poste 10', 'Case postale 23', '1410', 'Thierrens', 'Suisse', 80465, 0, 1),
(2031, 'Banque Raiffeisen Plateau du Jorat-Molondin', 'Route du Moulin 4', '', '1059', 'Peney-le-Jorat', 'Suisse', 80465, 0, 1),
(2032, 'Banque Raiffeisen Plateau du Jorat-Molondin', 'Route de Montigon 7b', '', '1415', 'Molondin', 'Suisse', 80465, 0, 1),
(2033, 'Banque Raiffeisen d&apos;Yverdon-les-Bains', 'Av. de la Gare 4', 'Case postale 255', '1401', 'Yverdon-les-Bains', 'Suisse', 80472, 0, 1),
(2034, 'Banque Raiffeisen d&apos;Yverdon-les-Bains', 'Grand-Rue 87', '', '1373', 'Chavornay', 'Suisse', 80472, 0, 1),
(2035, 'Banque Raiffeisen d&apos;Yverdon-les-Bains', 'Rue des 3 Fontaines ', 'Case postale', '1407', 'Donneloye', 'Suisse', 80472, 0, 1),
(2036, 'Banque Raiffeisen d&apos;Yverdon-les-Bains', 'Avenue de la Gare 6', '', '1462', 'Yvonand', 'Suisse', 80472, 0, 1),
(2037, 'Banque Raiffeisen de la Broye', 'Grand&apos;Rue 20', 'Case postale 384', '1530', 'Payerne', 'Suisse', 80479, 0, 1),
(2038, 'Banque Raiffeisen de la Broye', 'Granges-près-Marnand', '', '1523', 'Granges-près-Marnand', 'Suisse', 80479, 0, 1),
(2039, 'Banque Raiffeisen du district de Moudon', 'Avenue de Cerjat 2b', 'Case postale 49', '1510', 'Moudon', 'Suisse', 80482, 0, 1),
(2040, 'Banque Raiffeisen du district de Moudon', 'Grand-Rue 3', '', '1522', 'Lucens', 'Suisse', 80482, 0, 1),
(2041, 'Banque Raiffeisen de Gimel', 'La Chomaz 8', 'Case postale 132', '1188', 'Gimel', 'Suisse', 80485, 0, 1),
(2042, 'Banque Raiffeisen de Gimel', 'Route de Lausanne 5', '', '1180', 'Rolle', 'Suisse', 80485, 0, 1),
(2043, 'Banque Raiffeisen de Gimel', 'Avenue du Mont Blanc', '', '1196', 'Gland', 'Suisse', 80485, 0, 1),
(2044, 'Raiffeisenbank Aletsch', 'Furkastrasse 106', 'Postfach', '3982', 'Bitsch', 'Suisse', 80492, 0, 1),
(2045, 'Raiffeisenbank Mischabel-Matterhorn', 'Bahnhofstrasse 5', 'Postfach', '3924', 'St. Niklaus VS', 'Suisse', 80496, 0, 1),
(2046, 'Raiffeisenbank Mischabel-Matterhorn', 'Dorfplatz', '', '3925', 'Grächen', 'Suisse', 80496, 0, 1),
(2047, 'Raiffeisenbank Mischabel-Matterhorn', 'Zum Bild', '', '3928', 'Randa', 'Suisse', 80496, 0, 1),
(2048, 'Raiffeisenbank Mischabel-Matterhorn', 'Bahnhofstrasse', '', '3929', 'Täsch', 'Suisse', 80496, 0, 1),
(2049, 'Raiffeisenbank Mischabel-Matterhorn', 'Bahnhofstrasse', '', '3920', 'Zermatt', 'Suisse', 80496, 0, 1),
(2050, 'Raiffeisenbank Mischabel-Matterhorn', 'Flüo 7', '', '3926', 'Embd', 'Suisse', 80496, 0, 1),
(2051, 'Raiffeisenbank Mischabel-Matterhorn', 'Beim Dorfplatz', '', '3906', 'Saas-Fee', 'Suisse', 80496, 0, 1),
(2052, 'Raiffeisenbank Mischabel-Matterhorn', 'Bahnhofstrasse 10', '', '3922', 'Stalden VS', 'Suisse', 80496, 0, 1),
(2053, 'Raiffeisenbank Mischabel-Matterhorn', 'Dorf', '', '3922', 'Eisten', 'Suisse', 80496, 0, 1),
(2054, 'Raiffeisenbank Mischabel-Matterhorn', 'zer Tannu 83', '', '3933', 'Staldenried', 'Suisse', 80496, 0, 1),
(2055, 'Raiffeisenbank Mischabel-Matterhorn', 'Moosalpstrasse 73 a', '', '3923', 'Törbel', 'Suisse', 80496, 0, 1),
(2056, 'Raiffeisenbank Mischabel-Matterhorn', 'Dorfplatz', '', '3910', 'Saas-Grund', 'Suisse', 80496, 0, 1),
(2057, 'Raiffeisenbank Visperterminen', 'Kanzleiweg 4', 'Postfach 99', '3932', 'Visperterminen', 'Suisse', 80499, 0, 1),
(2058, 'Raiffeisenbank Gampel-Raron', 'Bahnhofstrasse 21', 'Postfach 113', '3945', 'Gampel', 'Suisse', 80521, 0, 1),
(2059, 'Raiffeisenbank Gampel-Raron', 'Oberdorf 8', '', '3957', 'Erschmatt', 'Suisse', 80521, 0, 1),
(2060, 'Raiffeisenbank Gampel-Raron', 'Grächmatten 74', '', '3956', 'Guttet-Feschel', 'Suisse', 80521, 0, 1),
(2061, 'Raiffeisenbank Gampel-Raron', 'Dorfstrasse 70', '', '3918', 'Wiler (Lötschen)', 'Suisse', 80521, 0, 1),
(2062, 'Raiffeisenbank Gampel-Raron', 'Dorfplatz', '', '3919', 'Blatten (Lötschen)', 'Suisse', 80521, 0, 1),
(2063, 'Raiffeisenbank Gampel-Raron', 'Brückenmoosstrasse 2', 'Postfach 48', '3942', 'Raron', 'Suisse', 80521, 0, 1),
(2064, 'Raiffeisenbank Gampel-Raron', 'Dorfstrasse 19', '', '3942', 'Niedergesteln', 'Suisse', 80521, 0, 1),
(2065, 'Raiffeisenbank Gampel-Raron', '', '', '3942', 'St. German', 'Suisse', 80521, 0, 1),
(2066, 'Raiffeisenbank Region Leuk', 'Bahnhofstrasse 2', '', '3952', 'Susten', 'Suisse', 80527, 0, 1),
(2067, 'Raiffeisenbank Region Leuk', 'Dorfstrasse 11', '', '3954', 'Leukerbad', 'Suisse', 80527, 0, 1),
(2068, 'Raiffeisenbank Region Leuk', 'Klareistrasse 3', '', '3970', 'Salgesch', 'Suisse', 80527, 0, 1),
(2069, 'Raiffeisenbank Region Leuk', 'Resini', '', '3953', 'Varen', 'Suisse', 80527, 0, 1),
(2070, 'Raiffeisenbank Region Leuk', 'Kantonsstrasse 14', '', '3946', 'Turtmann', 'Suisse', 80527, 0, 1),
(2071, 'Raiffeisenbank Region Leuk', 'Dorfstrasse 11', '', '3951', 'Agarn', 'Suisse', 80527, 0, 1),
(2072, 'Raiffeisenbank Region Leuk', 'Mitteldorf 18', '', '3947', 'Ergisch', 'Suisse', 80527, 0, 1),
(2073, 'Raiffeisenbank Region Leuk', 'Moosmattenstrasse 7', '', '3948', 'Oberems', 'Suisse', 80527, 0, 1),
(2074, 'Raiffeisenbank Belalp-Simplon', 'Zentrum Kelchbach', 'Postfach 336', '3904', 'Naters', 'Suisse', 80532, 0, 1),
(2075, 'Raiffeisenbank Belalp-Simplon', 'Simplonstrasse 57', '', '3911', 'Ried-Brig', 'Suisse', 80532, 0, 1),
(2076, 'Raiffeisenbank Belalp-Simplon', 'Alte Simplonstrasse ', '', '3907', 'Simplon Dorf', 'Suisse', 80532, 0, 1),
(2077, 'Raiffeisenbank Belalp-Simplon', 'Dorf', '', '3903', 'Mund', 'Suisse', 80532, 0, 1),
(2078, 'Raiffeisenbank Belalp-Simplon', 'Gliserallee 131', '', '3902', 'Glis', 'Suisse', 80532, 0, 1),
(2079, 'Raiffeisenbank Belalp-Simplon', 'Furkastrasse 1', '', '3900', 'Brig/Brigue', 'Suisse', 80532, 0, 1),
(2080, 'Raiffeisenbank Raron-St. German-Niedergesteln', 'Brückenmoosstrasse 2', 'Postfach 48', '3942', 'Raron', 'Suisse', 80538, 0, 1),
(2081, 'Raiffeisenbank Aletsch-Goms', 'Furkastrasse 15', '', '3998', 'Reckingen', 'Suisse', 80539, 0, 1),
(2082, 'Raiffeisenbank Aletsch-Goms', 'Furkastrasse 48', '', '3985', 'Münster VS', 'Suisse', 80539, 0, 1),
(2083, 'Raiffeisenbank Aletsch-Goms', 'Bahnhofstrasse 1', '', '3988', 'Obergesteln', 'Suisse', 80539, 0, 1),
(2084, 'Raiffeisenbank Aletsch-Goms', 'Furkastrasse 64', '', '3999', 'Oberwald', 'Suisse', 80539, 0, 1),
(2085, 'Raiffeisenbank Aletsch-Goms', 'Furkastrasse 17', '', '3988', 'Ulrichen', 'Suisse', 80539, 0, 1),
(2086, 'Raiffeisenbank Aletsch-Goms', 'Furkastrasse 44', '', '3984', 'Fiesch', 'Suisse', 80539, 0, 1),
(2087, 'Raiffeisenbank Aletsch-Goms', 'Dorf', '', '3997', 'Bellwald', 'Suisse', 80539, 0, 1),
(2088, 'Raiffeisenbank Aletsch-Goms', 'Dorfstrasse 11', '', '3996', 'Binn', 'Suisse', 80539, 0, 1),
(2089, 'Raiffeisenbank Aletsch-Goms', 'Dorfplatz', '', '3995', 'Ernen', 'Suisse', 80539, 0, 1),
(2090, 'Raiffeisenbank Aletsch-Goms', 'Furkastrasse 106', '', '3982', 'Bitsch', 'Suisse', 80539, 0, 1),
(2091, 'Raiffeisenbank Aletsch-Goms', 'Chalet Raiffeisen', '', '3992', 'Bettmeralp', 'Suisse', 80539, 0, 1),
(2092, 'Raiffeisenbank Aletsch-Goms', 'Dorfplatz', '', '3993', 'Grengiols', 'Suisse', 80539, 0, 1),
(2093, 'Raiffeisenbank Aletsch-Goms', 'Furkastrasse 34', '', '3983', 'Mörel', 'Suisse', 80539, 0, 1),
(2094, 'Raiffeisenbank Aletsch-Goms', 'Seilbahnstrasse 2', '', '3986', 'Ried-Mörel', 'Suisse', 80539, 0, 1),
(2095, 'Raiffeisenbank Aletsch-Goms', 'Haus Diana', '', '3987', 'Riederalp', 'Suisse', 80539, 0, 1),
(2096, 'Raiffeisenbank Region Visp', 'Bahnhofstrasse 10', 'Postfach 448', '3930', 'Visp/Viège', 'Suisse', 80553, 0, 1),
(2097, 'Raiffeisenbank Region Visp', 'Dorfstrasse', '', '3931', 'Lalden', 'Suisse', 80553, 0, 1),
(2098, 'Raiffeisenbank Region Visp', 'Dorfstrasse 75', '', '3938', 'Ausserberg', 'Suisse', 80553, 0, 1),
(2099, 'Raiffeisenbank Region Visp', 'Hauptstrasse 31', '', '3937', 'Baltschieder', 'Suisse', 80553, 0, 1),
(2100, 'Raiffeisenbank Region Visp', 'Bahnhofstrasse 18', '', '3939', 'Eggerberg', 'Suisse', 80553, 0, 1),
(2101, 'Raiffeisenbank Region Visp', 'Kantonsstrasse', '', '3943', 'Eischoll', 'Suisse', 80553, 0, 1),
(2102, 'Raiffeisenbank Region Visp', 'Dorfplatz', '', '3944', 'Unterbäch VS', 'Suisse', 80553, 0, 1),
(2103, 'Raiffeisenbank Region Visp', 'Hasel', '', '3935', 'Bürchen', 'Suisse', 80553, 0, 1),
(2104, 'Banque Raiffeisen Riddes-Saxon-Isérables', 'Route de Faubourg 2', 'Case postale 76', '1908', 'Riddes', 'Suisse', 80571, 0, 1),
(2105, 'Banque Raiffeisen Riddes-Saxon-Isérables', 'Place de la Gare 1', '', '1907', 'Saxon', 'Suisse', 80571, 0, 1),
(2106, 'Banque Raiffeisen Riddes-Saxon-Isérables', 'Rue du Téléphérique ', '', '1914', 'Isérables', 'Suisse', 80571, 0, 1),
(2107, 'Banque Raiffeisen Sion et Région', 'Avenue de la Gare 6', '', '1950', 'Sion', 'Suisse', 80572, 0, 1),
(2108, 'Banque Raiffeisen Sion et Région', 'Rue du Stade 19', '', '1965', 'St-Germain (Savièse)', 'Suisse', 80572, 0, 1),
(2109, 'Banque Raiffeisen Sion et Région', 'Rue du Vieux-Village', '', '1967', 'Bramois', 'Suisse', 80572, 0, 1),
(2110, 'Banque Raiffeisen Sion et Région', 'Rue des Casernes 18', '', '1950', 'Sion', 'Suisse', 80572, 0, 1),
(2111, 'Banque Raiffeisen Sion et Région', 'Route de Lens 20', '', '1958', 'St-Léonard', 'Suisse', 80572, 0, 1),
(2112, 'Banque Raiffeisen Sion et Région', 'Route d&apos;Anzère ', '', '1972', 'Anzère', 'Suisse', 80572, 0, 1),
(2113, 'Banque Raiffeisen Sion et Région', 'Place du Marais 4', '', '1974', 'Arbaz', 'Suisse', 80572, 0, 1),
(2114, 'Banque Raiffeisen Sion et Région', 'Route de Botyre 50', '', '1966', 'Ayent', 'Suisse', 80572, 0, 1),
(2115, 'Banque Raiffeisen Sion et Région', 'Rue des Tonnelier 5', '', '1950', 'Sion', 'Suisse', 80572, 0, 1),
(2116, 'Banque Raiffeisen Sion et Région', 'Rue Centrale 142', '', '1983', 'Evolène', 'Suisse', 80572, 0, 1),
(2117, 'Banque Raiffeisen Sion et Région', 'Rue de l&apos;Evouet', '', '1969', 'St-Martin VS', 'Suisse', 80572, 0, 1),
(2118, 'Banque Raiffeisen Sion et Région', 'Route de Sion 18', '', '1981', 'Vex', 'Suisse', 80572, 0, 1),
(2119, 'Banque Raiffeisen Sion et Région', 'Rue de l&apos;Eglise', '', '1987', 'Hérémence', 'Suisse', 80572, 0, 1),
(2120, 'Banque Raiffeisen Sion et Région', 'Rue Centrale 57', '', '1964', 'Conthey', 'Suisse', 80572, 0, 1),
(2121, 'Banque Raiffeisen Sion et Région', 'Route de la Printse ', '', '1994', 'Aproz (Nendaz)', 'Suisse', 80572, 0, 1),
(2122, 'Banque Raiffeisen Sion et Région', 'Roure de Nendaz 356', '', '1996', 'Basse-Nendaz', 'Suisse', 80572, 0, 1),
(2123, 'Banque Raiffeisen Sion et Région', 'Chemin du Praplan 1', '', '1997', 'Haute-Nendaz', 'Suisse', 80572, 0, 1),
(2124, 'Banque Raiffeisen Sion et Région', 'Rte du Simplon 46', '', '1957', 'Ardon', 'Suisse', 80572, 0, 1),
(2125, 'Banque Raiffeisen Sion et Région', 'Chemin Neuf 4', '', '1955', 'Chamoson', 'Suisse', 80572, 0, 1),
(2126, 'Banque Raiffeisen Sion et Région', 'Av. de Vergers 20', '', '1963', 'Vétroz', 'Suisse', 80572, 0, 1),
(2127, 'Banque Raiffeisen de Nendaz', 'Route de Nendaz 356', 'Case postale 9', '1996', 'Basse-Nendaz', 'Suisse', 80577, 0, 1),
(2128, 'Banque Raiffeisen Entremont', 'Route de Verbier 19', 'Case postale 41', '1934', 'Châble VS, Le', 'Suisse', 80581, 0, 1),
(2129, 'Banque Raiffeisen Entremont', 'Place de la Chapelle', '', '1942', 'Levron', 'Suisse', 80581, 0, 1),
(2130, 'Banque Raiffeisen Entremont', 'Route d&apos;Etiez 1', '', '1941', 'Vollèges', 'Suisse', 80581, 0, 1),
(2131, 'Banque Raiffeisen Entremont', 'Route de Verbier 137', '', '1936', 'Verbier', 'Suisse', 80581, 0, 1),
(2132, 'Banque Raiffeisen Entremont', 'Rue Principale 117', '', '1932', 'Boverrnier', 'Suisse', 80581, 0, 1),
(2133, 'Banque Raiffeisen Entremont', 'Route du Grand-St-Be', '', '1945', 'Liddes', 'Suisse', 80581, 0, 1),
(2134, 'Banque Raiffeisen Entremont', 'La Place 15', '', '1933', 'Sembrancher', 'Suisse', 80581, 0, 1),
(2135, 'Banque Raiffeisen Entremont', 'Chemin de Poste 2', 'Case postale 61', '1937', 'Orsières', 'Suisse', 80581, 0, 1),
(2136, 'Banque Raiffeisen de Chalais-Vercorin', 'Case postale 62', '', '3966', 'Chalais', 'Suisse', 80584, 0, 1),
(2137, 'Banque Raiffeisen de Chalais-Vercorin', 'imm. Le Margueron', '', '3967', 'Vercorin', 'Suisse', 80584, 0, 1),
(2138, 'Banque Raiffeisen des Coteaux du Soleil', 'Av. des Vergers 20', '', '1963', 'Vétroz', 'Suisse', 80585, 0, 1),
(2139, 'Banque Raiffeisen du Haut-Léman', 'Route du Léman 10', 'Case postale 12', '1895', 'Vionnaz', 'Suisse', 80588, 0, 1),
(2140, 'Banque Raiffeisen du Haut-Léman', 'ZA Les Plavaux 101', '', '1893', 'Muraz (Collombey)', 'Suisse', 80588, 0, 1),
(2141, 'Banque Raiffeisen du Haut-Léman', 'Grand-Rue 10', 'Case postale 112', '1896', 'Vouvry', 'Suisse', 80588, 0, 1),
(2142, 'Banque Raiffeisen du Haut-Léman', 'Route Cantonale 1', '', '1897', 'Bouveret', 'Suisse', 80588, 0, 1),
(2143, 'Banque Raiffeisen de Conthey', 'Rue Centrale 57', 'Case postale 40', '1964', 'Conthey', 'Suisse', 80589, 0, 1),
(2144, 'Banque Raiffeisen Martigny et Région', 'Rue de la Poste 7', 'Case postale 194', '1920', 'Martigny', 'Suisse', 80595, 0, 1),
(2145, 'Banque Raiffeisen Martigny et Région', 'Rue de la Poste 4', '', '1926', 'Fully', 'Suisse', 80595, 0, 1),
(2146, 'Banque Raiffeisen Martigny et Région', 'Place E. Javelle, Ru', '', '1922', 'Salvan', 'Suisse', 80595, 0, 1),
(2147, 'Banque Raiffeisen Martigny et Région', 'Grand Rue 33', 'Case postale 23', '1904', 'Vernayaz', 'Suisse', 80595, 0, 1),
(2148, 'Banque Raiffeisen Martigny et Région', 'Route d&apos;Ovronna', '', '1912', 'Leytron', 'Suisse', 80595, 0, 1),
(2149, 'Banque Raiffeisen Martigny et Région', 'Route de Fully 1', '', '1913', 'Saillon', 'Suisse', 80595, 0, 1),
(2150, 'Banque Raiffeisen de Sierre &amp; Région', 'Place de la Gare 7', 'Case postale 824', '3960', 'Sierre/Siders', 'Suisse', 80598, 0, 1),
(2151, 'Banque Raiffeisen de Sierre &amp; Région', 'Rue Centrale 164', '', '3979', 'Grône', 'Suisse', 80598, 0, 1),
(2152, 'Banque Raiffeisen de Sierre &amp; Région', 'Grand Avenue 5', '', '3965', 'Chippis', 'Suisse', 80598, 0, 1),
(2153, 'Banque Raiffeisen de Sierre &amp; Région', '', '', '3961', 'Vissoie', 'Suisse', 80598, 0, 1),
(2154, 'Banque Raiffeisen Hérens', 'Rue de l&apos;Eglise', '', '1987', 'Hérémence', 'Suisse', 80599, 0, 1),
(2155, 'Banque Raiffeisen de Leytron-Saillon', 'Route d&apos;Ovronna', 'Case postale 88', '1912', 'Leytron', 'Suisse', 80602, 0, 1),
(2156, 'Banque Raiffeisen Massongex-St-Maurice-Vérossaz', 'Route du Chablais 11', 'Case postale 2', '1869', 'Massongex', 'Suisse', 80606, 0, 1),
(2157, 'Banque Raiffeisen Massongex-St-Maurice-Vérossaz', 'Place Val-de-Marne 1', '', '1890', 'St-Maurice', 'Suisse', 80606, 0, 1),
(2158, 'Banque Raiffeisen Massongex-St-Maurice-Vérossaz', '', '', '1891', 'Vérossaz', 'Suisse', 80606, 0, 1),
(2159, 'Banque Raiffeisen de Miège-Venthône-Veyras', 'Route de Sierre 47', '', '3972', 'Miège', 'Suisse', 80608, 0, 1),
(2160, 'Banque Raiffeisen de Monthey', 'Avenue de la Gare 24', 'Case postale 1151', '1870', 'Monthey 2', 'Suisse', 80611, 0, 1),
(2161, 'Banque Raiffeisen de la Vallée d&apos;Entremont', 'Chemin de la Poste 2', 'Case postale 61', '1937', 'Orsières', 'Suisse', 80613, 0, 1),
(2162, 'Banque Raiffeisen des Communes du Haut Plateau', 'Tsanveulle 15', 'Case postale 18', '3971', 'Chermignon', 'Suisse', 80615, 0, 1),
(2163, 'Banque Raiffeisen des Communes du Haut Plateau', 'Place du Village 4', '', '1978', 'Lens', 'Suisse', 80615, 0, 1),
(2164, 'Banque Raiffeisen des Communes du Haut Plateau', 'Place du Village 1', '', '3975', 'Randogne', 'Suisse', 80615, 0, 1),
(2165, 'Banque Raiffeisen des Communes du Haut Plateau', 'Route du Rawyl 41', '', '3963', 'Crans-Montana', 'Suisse', 80615, 0, 1),
(2166, 'Banque Raiffeisen de Troistorrents', 'Place du Village 5', 'Case postale 49', '1872', 'Troistorrents', 'Suisse', 80626, 0, 1),
(2167, 'Banque Raiffeisen de Troistorrents', 'Route de france 25', '', '1875', 'Morgins', 'Suisse', 80626, 0, 1),
(2168, 'Banque Raiffeisen de Val-d&apos;Illiez-Champéry', 'Chemin de la Musique', '', '1873', 'Val-d&apos;Illiez', 'Suisse', 80627, 0, 1),
(2169, 'Banque Raiffeisen de Val-d&apos;Illiez-Champéry', 'Rue du Village 45', '', '1874', 'Champéry', 'Suisse', 80627, 0, 1),
(2170, 'Raiffeisenbank Böttstein', 'Hauptstrasse 18', 'Postfach', '5314', 'Kleindöttingen', 'Suisse', 80652, 0, 1),
(2171, 'Raiffeisenbank Böttstein', 'Hauptstrasse 23', '', '5312', 'Döttingen', 'Suisse', 80652, 0, 1),
(2172, 'Raiffeisenbank Böttstein', 'Hauptstrasse 26', '', '5234', 'Villigen', 'Suisse', 80652, 0, 1),
(2173, 'Raiffeisenbank Böttstein', 'Schattengasse 33', 'Postfach 26', '5313', 'Klingnau', 'Suisse', 80652, 0, 1),
(2174, 'Raiffeisenbank an der Limmat', 'Bahnhofstrasse 5', '', '8953', 'Dietikon', 'Suisse', 80666, 0, 1),
(2175, 'Raiffeisenbank an der Limmat', 'Zürcherstrasse 18', '', '8952', 'Schlieren', 'Suisse', 80666, 0, 1),
(2176, 'Raiffeisenbank am Lindenberg', 'Sinserstrasse 2', '', '5644', 'Auw', 'Suisse', 80669, 0, 1),
(2177, 'Raiffeisenbank am Lindenberg', 'Wiggwilerstrasse 1', '', '5637', 'Beinwil', 'Suisse', 80669, 0, 1),
(2178, 'Raiffeisenbank Abtwil AG', 'Schulhausstr. 2', 'Postfach 152', '5646', 'Abtwil AG', 'Suisse', 80670, 0, 1),
(2179, 'Raiffeisenbank Mutschellen-Reppischtal', 'Bellikerstrasse 8', 'Postfach 291', '8964', 'Rudolfstetten', 'Suisse', 80673, 0, 1),
(2180, 'Raiffeisenbank Mutschellen-Reppischtal', 'Zürcherstrasse 9', '', '8903', 'Birmensdorf ZH', 'Suisse', 80673, 0, 1),
(2181, 'Raiffeisenbank Boswil-Bünzen', 'Zentralstr. 18', '', '5623', 'Boswil', 'Suisse', 80675, 0, 1),
(2182, 'Raiffeisenbank Eiken', 'Schupfarterstrasse 7', 'Postfach 62', '5074', 'Eiken', 'Suisse', 80683, 0, 1),
(2183, 'Raiffeisenbank Mettauertal', 'Galterstr. 3', '', '5272', 'Gansingen', 'Suisse', 80689, 0, 1),
(2184, 'Raiffeisenbank Wasserschloss', 'Unterriedenstr. 1', '', '5412', 'Gebenstorf', 'Suisse', 80690, 0, 1),
(2185, 'Raiffeisenbank Wasserschloss', 'Bahnhofstrasse 14', '', '5300', 'Turgi', 'Suisse', 80690, 0, 1),
(2186, 'Raiffeisenbank Wasserschloss', 'Dohlenzelgstrasse 8', '', '5210', 'Windisch', 'Suisse', 80690, 0, 1),
(2187, 'Raiffeisenbank Wasserschloss', 'Bahnhofplatz 1', '', '5200', 'Brugg', 'Suisse', 80690, 0, 1),
(2188, 'Raiffeisenbank Regio Frick', 'Hauptstrasse 33', 'Postfach 57', '5070', 'Frick', 'Suisse', 80691, 0, 1),
(2189, 'Raiffeisenbank Regio Frick', 'Oberzeiherstrasse 4', '', '5079', 'Zeihen', 'Suisse', 80691, 0, 1),
(2190, 'Raiffeisenbank Regio Frick', 'Dorfplatz', '', '5063', 'Wölflinswil', 'Suisse', 80691, 0, 1),
(2191, 'Raiffeisenbank Regio Frick', 'Hauptstrasse 37', '', '5027', 'Herznach', 'Suisse', 80691, 0, 1),
(2192, 'Raiffeisenbank Regio Frick', 'Landstrasse 40', '', '5073', 'Gipf-Oberfrick', 'Suisse', 80691, 0, 1),
(2193, 'Raiffeisenbank Regio Frick', 'Schupfarterstrasse 7', '', '5074', 'Eiken', 'Suisse', 80691, 0, 1),
(2194, 'Raiffeisenbank Regio Laufenburg', 'Mitteldorf 2', '', '5082', 'Kaisten', 'Suisse', 80696, 0, 1),
(2195, 'Raiffeisenbank Regio Laufenburg', 'Hauptstrasse 89', '', '5085', 'Sulz AG', 'Suisse', 80696, 0, 1),
(2196, 'Raiffeisenbank Aarau-Lenzburg', 'Kasinostrasse 37', '', '5000', 'Aarau', 'Suisse', 80698, 0, 1),
(2197, 'Raiffeisenbank Aarau-Lenzburg', 'Muhenstrasse 1', 'Postfach 21', '5036', 'Oberentfelden', 'Suisse', 80698, 0, 1),
(2198, 'Raiffeisenbank Aarau-Lenzburg', 'Hauptstrasse 56', '', '5742', 'Kölliken', 'Suisse', 80698, 0, 1),
(2199, 'Raiffeisenbank Aarau-Lenzburg', 'Bahnhofstrasse 41', '', '5600', 'Lenzburg', 'Suisse', 80698, 0, 1),
(2200, 'Raiffeisenbank Aarau-Lenzburg', 'Postweg 1', '', '5722', 'Gränichen', 'Suisse', 80698, 0, 1),
(2201, 'Raiffeisenbank Surbtal-Wehntal', 'Zürichstr. 5', '', '5426', 'Lengnau AG', 'Suisse', 80700, 0, 1),
(2202, 'Raiffeisenbank Surbtal-Wehntal', 'Marktgasse 5', '', '5304', 'Endingen', 'Suisse', 80700, 0, 1),
(2203, 'Raiffeisenbank Surbtal-Wehntal', 'Dorfstrasse 22', 'Postfach', '5425', 'Schneisingen', 'Suisse', 80700, 0, 1),
(2204, 'Raiffeisenbank Surbtal-Wehntal', 'Staltig 1', '', '5306', 'Tegerfelden', 'Suisse', 80700, 0, 1),
(2205, 'Raiffeisenbank Surbtal-Wehntal', 'Wehntalerstrasse 19', '', '8165', 'Schöfflisdorf', 'Suisse', 80700, 0, 1),
(2206, 'Raiffeisenbank Aare-Rhein', 'Schulweg 1', 'Postfach 45', '5316', 'Leuggern', 'Suisse', 80701, 0, 1),
(2207, 'Raiffeisenbank Aare-Rhein', 'Baslerstrasse 2A', '', '5330', 'Bad Zurzach', 'Suisse', 80701, 0, 1),
(2208, 'Raiffeisenbank Aare-Rhein', 'Leuggernstrasse 487', '', '5325', 'Leibstadt', 'Suisse', 80701, 0, 1),
(2209, 'Raiffeisenbank Kelleramt-Albis', 'Zürcherstrasse 1', 'Postfach 75', '8917', 'Oberlunkhofen', 'Suisse', 80702, 0, 1),
(2210, 'Raiffeisenbank Kelleramt-Albis', 'Bahnhofplatz 5a', '', '8910', 'Affoltern am Albis', 'Suisse', 80702, 0, 1),
(2211, 'Raiffeisenbank Aare-Reuss', 'Bahnhofstrasse 8', 'Postfach 248', '5507', 'Mellingen', 'Suisse', 80704, 0, 1),
(2212, 'Raiffeisenbank Aare-Reuss', 'Wydenstrasse 9', '', '5242', 'Lupfig', 'Suisse', 80704, 0, 1),
(2213, 'Raiffeisenbank Aare-Reuss', 'Oberdorfstrasse 8', '', '5107', 'Schinznach Dorf', 'Suisse', 80704, 0, 1),
(2214, 'Raiffeisenbank Aare-Reuss', 'Hegi 360', '', '5112', 'Thalheim AG', 'Suisse', 80704, 0, 1),
(2215, 'Raiffeisenbank Aare-Reuss', 'Bruggerstrasse 3', '', '5103', 'Wildegg', 'Suisse', 80704, 0, 1),
(2216, 'Raiffeisenbank Merenschwand-Obfelden', 'Rütistrasse 1', 'Postfach 67', '5634', 'Merenschwand', 'Suisse', 80705, 0, 1),
(2217, 'Raiffeisenbank Merenschwand-Obfelden', 'Dorfstrasse 60', '', '8912', 'Obfelden', 'Suisse', 80705, 0, 1),
(2218, 'Raiffeisenbank Möhlin', 'Bachstrasse 4', 'Postfach 240', '4313', 'Möhlin', 'Suisse', 80706, 0, 1),
(2219, 'Raiffeisenbank Möhlin', 'Hauptstrasse 65', '', '4322', 'Mumpf', 'Suisse', 80706, 0, 1),
(2220, 'Raiffeisenbank Möhlin', 'Schiffstrasse 16', '', '4323', 'Wallbach', 'Suisse', 80706, 0, 1),
(2221, 'Raiffeisenbank Möhlin', 'Albrechtsplatz 1', '', '4310', 'Rheinfelden', 'Suisse', 80706, 0, 1),
(2222, 'Raiffeisenbank Rohrdorferberg-Fislisbach', 'Bremgartenstrasse 20', 'Postfach 60', '5443', 'Niederrohrdorf', 'Suisse', 80719, 0, 1),
(2223, 'Raiffeisenbank Rohrdorferberg-Fislisbach', 'Ringstrasse 25', 'Postfach 77', '5452', 'Oberrohrdorf', 'Suisse', 80719, 0, 1),
(2224, 'Raiffeisenbank Rohrdorferberg-Fislisbach', 'Badenenerstrasse 5 B', 'Postfach 31', '5442', 'Fislisbach', 'Suisse', 80719, 0, 1),
(2225, 'Raiffeisenbank Region Zofingen', 'Vordere Hauptgasse 5', '', '4800', 'Zofingen', 'Suisse', 80721, 0, 1),
(2226, 'Raiffeisenbank Region Zofingen', 'Bahnhofstrasse 11', '', '5745', 'Safenwil', 'Suisse', 80721, 0, 1),
(2227, 'Raiffeisenbank Region Zofingen', 'Luzernerstrasse 1', 'Postfach 160', '4665', 'Oftringen', 'Suisse', 80721, 0, 1),
(2228, 'Raiffeisenbank Reitnau-Rued', 'Turnhallenstrasse 43', '', '5044', 'Schlossrued', 'Suisse', 80723, 0, 1),
(2229, 'Raiffeisenbank Reitnau-Rued', 'Hauptstrasse 27', '', '5726', 'Unterkulm', 'Suisse', 80723, 0, 1),
(2230, 'Raiffeisenbank Reitnau-Rued', 'Weinhalden 244', '', '5057', 'Reitnau', 'Suisse', 80723, 0, 1),
(2231, 'Raiffeisenbank Reitnau-Rued', 'Dorfstrasse 4', '', '5040', 'Schöftland', 'Suisse', 80723, 0, 1),
(2232, 'Raiffeisenbank Oberfreiamt', 'Luzernerstrasse 14', 'Postfach 90', '5643', 'Sins', 'Suisse', 80728, 0, 1),
(2233, 'Raiffeisenbank Oberfreiamt', 'Poststrasse 2', 'Postfach 315', '5630', 'Muri AG', 'Suisse', 80728, 0, 1),
(2234, 'Raiffeisenbank Oberfreiamt', 'Vorderdorfstrasse 2', '', '6042', 'Dietwil', 'Suisse', 80728, 0, 1),
(2235, 'Raiffeisenbank Villmergen', 'Dorfplatz 2', '', '5612', 'Villmergen', 'Suisse', 80736, 0, 1),
(2236, 'Raiffeisenbank Villmergen', 'Mitteldorfstrasse 3', '', '5605', 'Dottikon', 'Suisse', 80736, 0, 1),
(2237, 'Raiffeisenbank Villmergen', 'Im Zentrum 1b', '', '5614', 'Sarmenstorf', 'Suisse', 80736, 0, 1),
(2238, 'Raiffeisenbank Lägern-Baregg', 'St. Bernhardstrasse ', 'Postfach 2263', '5430', 'Wettingen', 'Suisse', 80740, 0, 1),
(2239, 'Raiffeisenbank Lägern-Baregg', 'Stadtturmstrasse 5', '', '5400', 'Baden', 'Suisse', 80740, 0, 1),
(2240, 'Raiffeisenbank Lägern-Baregg', 'Badenenerstrasse 1', 'Postfach 64', '5413', 'Birmenstorf AG', 'Suisse', 80740, 0, 1),
(2241, 'Raiffeisenbank Lägern-Baregg', 'Dorfstrasse 14', '', '5420', 'Ehrendingen', 'Suisse', 80740, 0, 1),
(2242, 'Raiffeisenbank Wohlen', 'Stegmattweg 1', '', '5610', 'Wohlen AG', 'Suisse', 80744, 0, 1),
(2243, 'Raiffeisenbank Wohlen', 'Büelisackerstrasse 1', '', '5622', 'Waltenschwil', 'Suisse', 80744, 0, 1),
(2244, 'Raiffeisenbank Wohlen', 'Hauptstrasse 14', '', '5524', 'Niederwil AG', 'Suisse', 80744, 0, 1),
(2245, 'Raiffeisenbank Siggenthal-Würenlingen', 'Gartenstrasse 34', 'Postfach 48', '5303', 'Würenlingen', 'Suisse', 80746, 0, 1),
(2246, 'Raiffeisenbank Siggenthal-Würenlingen', 'Landstrasse 50', 'Postfach', '5417', 'Untersiggenthal', 'Suisse', 80746, 0, 1),
(2247, 'Raiffeisenbank Siggenthal-Würenlingen', 'Hertensteinstrasse 1', '', '5415', 'Nussbaumen AG', 'Suisse', 80746, 0, 1),
(2248, 'Raiffeisenbank Würenlos', 'Schulstrasse 4', 'Postfach', '5436', 'Würenlos', 'Suisse', 80747, 0, 1),
(2249, 'Raiffeisenbank Würenlos', 'Albertstrasse 4', '', '5432', 'Neuenhof', 'Suisse', 80747, 0, 1),
(2250, 'Raiffeisenbank Würenlos', 'Dorfstrasse 62', '', '8957', 'Spreitenbach', 'Suisse', 80747, 0, 1),
(2251, 'Raiffeisenbank Wegenstettertal', 'Haldengasse 1', '', '4314', 'Zeiningen', 'Suisse', 80748, 0, 1),
(2252, 'Raiffeisenbank Wegenstettertal', 'Hauptstrasse 46', '', '4317', 'Wegenstetten', 'Suisse', 80748, 0, 1),
(2253, 'Raiffeisenbank Zufikon', 'Schulstrasse 14', '', '5621', 'Zufikon', 'Suisse', 80749, 0, 1),
(2254, 'Raiffeisenbank Zufikon', 'Luzernerstrasse 18', '', '5620', 'Bremgarten AG', 'Suisse', 80749, 0, 1),
(2255, 'Raiffeisenbank Oberbaselbiet', 'Poststrasse 5', 'Postfach 343', '4460', 'Gelterkinden', 'Suisse', 80771, 0, 1),
(2256, 'Raiffeisenbank Liestal-Oberbaselbiet', 'Rathausstrasse 58', 'Postfach 162', '4410', 'Liestal', 'Suisse', 80773, 0, 1),
(2257, 'Raiffeisenbank Liestal-Oberbaselbiet', 'Hofackerstrasse 2', '', '4412', 'Nuglar', 'Suisse', 80773, 0, 1),
(2258, 'Raiffeisenbank Liestal-Oberbaselbiet', 'Hauptstrasse 39', '', '4450', 'Sissach', 'Suisse', 80773, 0, 1),
(2259, 'Raiffeisenbank Liestal-Oberbaselbiet', 'Poststrasse 5', '', '4460', 'Gelterkinden', 'Suisse', 80773, 0, 1),
(2260, 'Raiffeisenbank Birsig', 'Hauptstrasse 16', 'Postfach 648', '4104', 'Oberwil BL', 'Suisse', 80774, 0, 1),
(2261, 'Raiffeisenbank Birsig', 'Hauptstrasse 50', '', '4102', 'Binningen', 'Suisse', 80774, 0, 1),
(2262, 'Raiffeisenbank Birsig', 'Ettingerstrasse 17/1', '', '4114', 'Hofstetten SO', 'Suisse', 80774, 0, 1),
(2263, 'Raiffeisenbank Birsig', 'Bahnhofstrasse 7', '', '4108', 'Witterswil SO', 'Suisse', 80774, 0, 1),
(2264, 'Raiffeisenbank Allschwil-Schönenbuch', 'Baslerstrasse 70', 'Postfach', '4123', 'Allschwil', 'Suisse', 80775, 0, 1),
(2265, 'Raiffeisenbank Arlesheim', 'Hauptstrasse 3', '', '4144', 'Arlesheim', 'Suisse', 80776, 0, 1),
(2266, 'Raiffeisenbank Arlesheim', 'Emil Frey-Strasse 15', '', '4142', 'Münchenstein', 'Suisse', 80776, 0, 1),
(2267, 'Raiffeisenbank Arlesheim', 'Hauptstrasse 81', '', '4132', 'Muttenz', 'Suisse', 80776, 0, 1),
(2268, 'Raiffeisenbank Aesch-Pfeffingen', 'Hauptstrasse 107', 'Postfach 460', '4147', 'Aesch BL', 'Suisse', 80779, 0, 1),
(2269, 'Raiffeisenbank Reinach BL', 'Hauptstrasse 9', 'Postfach 460', '4153', 'Reinach BL', 'Suisse', 80780, 0, 1),
(2270, 'Raiffeisenbank Therwil Ettingen', 'Bahnhofstr. 30', '', '4106', 'Therwil', 'Suisse', 80784, 0, 1),
(2271, 'Raiffeisenbank Therwil Ettingen', 'Hauptstrasse 20', '', '4107', 'Ettingen', 'Suisse', 80784, 0, 1),
(2272, 'Raiffeisenbank Kiesental', '', '', '3533', 'Bowil', 'Suisse', 80811, 0, 1),
(2273, 'Raiffeisenbank Kiesental', 'Thunstrasse 16', '', '3672', 'Oberdiessbach', 'Suisse', 80811, 0, 1),
(2274, 'Raiffeisenbank Kiesental', 'Badhaus 18', '', '3615', 'Heimenschwand', 'Suisse', 80811, 0, 1),
(2275, 'Raiffeisenbank Kiesental', 'Dorfplatz 2', '', '3673', 'Linden', 'Suisse', 80811, 0, 1),
(2276, 'Raiffeisenbank Kiesental', 'Bernstrasse11', '', '3110', 'Münsingen', 'Suisse', 80811, 0, 1),
(2277, 'Raiffeisenbank Kiesental', 'Kreuzplatz 6', '', '3510', 'Konolfingen', 'Suisse', 80811, 0, 1),
(2278, 'Raiffeisenbank Kiesental', 'Bernstrasse 1', '', '3532', 'Zäziwil', 'Suisse', 80811, 0, 1),
(2279, 'Raiffeisenbank Niedersimmental', 'Diemtigtalstrasse 22', 'Postfach 50', '3753', 'Oey', 'Suisse', 80816, 0, 1),
(2280, 'Raiffeisenbank Niedersimmental', 'Hüselistrasse', 'Postfach 26', '3763', 'Därstetten', 'Suisse', 80816, 0, 1),
(2281, 'Raiffeisenbank Niedersimmental', 'Hüpbach', '', '3765', 'Oberwil im Simmental', 'Suisse', 80816, 0, 1),
(2282, 'Raiffeisenbank Niedersimmental', 'Dorf', 'Postfach 1', '3762', 'Erlenbach i.S.', 'Suisse', 80816, 0, 1),
(2283, 'Raiffeisenbank Niedersimmental', 'Dorfplatz 2', '', '3647', 'Reutigen', 'Suisse', 80816, 0, 1),
(2284, 'Raiffeisenbank Niedersimmental', 'Hauptstrasse 20a', '', '3752', 'Wimmis', 'Suisse', 80816, 0, 1),
(2285, 'Raiffeisenbank Steffisburg', 'Höchhusweg 4', 'Postfach 267', '3612', 'Steffisburg', 'Suisse', 80817, 0, 1),
(2286, 'Raiffeisenbank Steffisburg', 'Schwandenstrasse 67', '', '3657', 'Schwanden (Sigriswil)', 'Suisse', 80817, 0, 1),
(2287, 'Raiffeisenbank Steffisburg', 'Rachholtern 66b', '', '3617', 'Fahrni b. Thun', 'Suisse', 80817, 0, 1),
(2288, 'Raiffeisenbank Steffisburg', 'Linden', '', '3619', 'Eriz', 'Suisse', 80817, 0, 1),
(2289, 'Raiffeisenbank Steffisburg', 'Weier 6a', '', '3616', 'Schwarzenegg', 'Suisse', 80817, 0, 1),
(2290, 'Raiffeisenbank Grauholz', 'Zentrum 32', '', '3322', 'Urtenen-Schönbühl', 'Suisse', 80819, 0, 1),
(2291, 'Raiffeisenbank Grauholz', 'Dorfstrasse 2', '', '3054', 'Schüpfen', 'Suisse', 80819, 0, 1),
(2292, 'Raiffeisenbank Grauholz', 'Bernstrasse 101', 'Postfach 634', '3052', 'Zollikofen', 'Suisse', 80819, 0, 1),
(2293, 'Raiffeisenbank Grauholz', 'Säriswilstrasse 15 F', '', '3043', 'Uettligen', 'Suisse', 80819, 0, 1),
(2294, 'Raiffeisenbank Grauholz', 'Bernstrasse 12', '', '3312', 'Fraubrunnen', 'Suisse', 80819, 0, 1),
(2295, 'Raiffeisenbank Frutigland', 'Marktplatz', 'Postfach 32', '3714', 'Frutigen', 'Suisse', 80820, 0, 1),
(2296, 'Raiffeisenbank Frutigland', 'Landstrasse 6B / Mos', '', '3715', 'Adelboden', 'Suisse', 80820, 0, 1),
(2297, 'Raiffeisenbank Frutigland', 'Dorfstrasse 11', '', '3703', 'Aeschi b. Spiez', 'Suisse', 80820, 0, 1),
(2298, 'Raiffeisenbank Frutigland', 'Bahnhofstrasse 21', '', '3713', 'Reichenbach im Kandertal', 'Suisse', 80820, 0, 1),
(2299, 'Raiffeisenbank Saanenland', 'Güterstrasse6', 'Postfach 48', '3780', 'Gstaad', 'Suisse', 80823, 0, 1),
(2300, 'Raiffeisenbank Bielersee', 'Bahnhofplatz 11', 'Postfach', '2501', 'Biel', 'Suisse', 80833, 0, 1),
(2301, 'Raiffeisenbank Bielersee', 'Dorfplatz 8', '', '3232', 'Ins', 'Suisse', 80833, 0, 1),
(2302, 'Raiffeisenbank Bielersee', 'Hauptstrasse 17', '', '2563', 'Ipsach', 'Suisse', 80833, 0, 1),
(2303, 'Raiffeisenbank Lütschinentäler', 'im Raiffeisenhaus', 'Postfach', '3822', 'Lauterbrunnen', 'Suisse', 80837, 0, 1),
(2304, 'Raiffeisenbank Lütschinentäler', 'Dorfstrasse 95', 'Postfach 168', '3818', 'Grindelwald', 'Suisse', 80837, 0, 1),
(2305, 'Raiffeisenbank Lütschinentäler', 'Residence Eiger, Wen', '', '3823', 'Wengen', 'Suisse', 80837, 0, 1),
(2306, 'Raiffeisenbank Thunersee-Süd', 'Bahnhofstrasse 12', 'Postfach 566', '3700', 'Spiez', 'Suisse', 80838, 0, 1),
(2307, 'Raiffeisenbank Jungfrau', 'Untere Bönigstr. 3', 'Postfach 652', '3800', 'Interlaken', 'Suisse', 80842, 0, 1),
(2308, 'Raiffeisenbank Jungfrau', 'Hauptstrasse 62', '', '3806', 'Bönigen b. Interlaken', 'Suisse', 80842, 0, 1),
(2309, 'Raiffeisenbank Jungfrau', 'Metzgergasse 1', '', '3800', 'Matten b. Interlaken', 'Suisse', 80842, 0, 1),
(2310, 'Raiffeisenbank Jungfrau', 'Untere Gasse 4 b', '', '3800', 'Unterseen', 'Suisse', 80842, 0, 1),
(2311, 'Raiffeisenbank Jungfrau', 'Lehngasse 16', '', '3812', 'Wilderswil', 'Suisse', 80842, 0, 1),
(2312, 'Raiffeisenbank Jungfrau', 'Hauptstrasse 169', 'Postfach 8', '3852', 'Ringgenberg BE', 'Suisse', 80842, 0, 1),
(2313, 'Raiffeisenbank Jungfrau', 'Hälteli 400c', '', '3803', 'Beatenberg', 'Suisse', 80842, 0, 1),
(2314, 'Raiffeisenbank Jungfrau', 'Im Holz', '', '3804', 'Habkern', 'Suisse', 80842, 0, 1),
(2315, 'Raiffeisenbank Jungfrau', 'Marderbach', '', '3807', 'Iseltwald', 'Suisse', 80842, 0, 1),
(2316, 'Raiffeisenbank Jungfrau', 'Hauptstrasse 19', '', '3853', 'Niederried b. Interlaken', 'Suisse', 80842, 0, 1),
(2317, 'Raiffeisenbank Region Haslital-Brienz', 'Hauptstrasse 1', 'Postfach 628', '3860', 'Meiringen', 'Suisse', 80843, 0, 1),
(2318, 'Raiffeisenbank Region Haslital-Brienz', 'Hauptstrasse 111', '', '3855', 'Brienz BE', 'Suisse', 80843, 0, 1),
(2319, 'Raiffeisenbank Region Haslital-Brienz', 'Bottigenstrasse 2', '', '3862', 'Innertkirchen', 'Suisse', 80843, 0, 1),
(2320, 'Raiffeisenbank Ringgenberg', 'Hauptstrasse 169', 'Postfach 8', '3852', 'Ringgenberg BE', 'Suisse', 80853, 0, 1),
(2321, 'Raiffeisenbank Obersimmental-Saanenland', 'Farbgasse 6', '', '3770', 'Zweisimmen', 'Suisse', 80856, 0, 1),
(2322, 'Raiffeisenbank Obersimmental-Saanenland', 'Reidenbach 290a', '', '3766', 'Boltigen', 'Suisse', 80856, 0, 1),
(2323, 'Raiffeisenbank Obersimmental-Saanenland', 'Aegertenstrasse 3', 'Postfach 310', '3775', 'Lenk im Simmental', 'Suisse', 80856, 0, 1),
(2324, 'Raiffeisenbank Obersimmental-Saanenland', 'Lenkstrasse 49', '', '3772', 'St. Stephan', 'Suisse', 80856, 0, 1),
(2325, 'Raiffeisenbank Obersimmental-Saanenland', 'Anderhalbacherstrass', '', '3784', 'Feutersoey', 'Suisse', 80856, 0, 1),
(2326, 'Raiffeisenbank Obersimmental-Saanenland', 'Güterstrasse 6', 'Postfach 48', '3780', 'Gstaad', 'Suisse', 80856, 0, 1),
(2327, 'Raiffeisenbank Schwarzwasser', 'Bahnhofstrasse 10', 'Postfach 111', '3150', 'Schwarzenburg', 'Suisse', 80860, 0, 1),
(2328, 'Raiffeisenbank Schwarzwasser', 'Bläuacker 4', '', '3098', 'Köniz', 'Suisse', 80860, 0, 1),
(2329, 'Raiffeisenbank Seeland', 'Hauptstrasse 61', 'Postfach', '2557', 'Studen BE', 'Suisse', 80862, 0, 1);
INSERT INTO `faturacao_bancos_fornecedores` (`ID_BancoFornecedor`, `Nome`, `Address1`, `Address2`, `NPA`, `Localite`, `PaisBanco`, `BCNbr`, `Predefinido`, `Ativo`) VALUES
(2330, 'Raiffeisenbank Seeland', 'Spittelgasse 1', '', '3294', 'Büren an der Aare', 'Suisse', 80862, 0, 1),
(2331, 'Raiffeisenbank Seeland', 'Stadtplatz 29', '', '3270', 'Aarberg', 'Suisse', 80862, 0, 1),
(2332, 'Raiffeisenbank Seeland', 'Bahnhofstrasse 5', '', '3250', 'Lyss', 'Suisse', 80862, 0, 1),
(2333, 'Raiffeisenbank Seeland', 'Hauptstrasse 190', '', '2552', 'Orpund', 'Suisse', 80862, 0, 1),
(2334, 'Raiffeisenbank Thunersee', 'Burgstrasse 20', '', '3600', 'Thun', 'Suisse', 80867, 0, 1),
(2335, 'Raiffeisenbank Thunersee', 'Blümlisalpstrasse 44', '', '3627', 'Heimberg', 'Suisse', 80867, 0, 1),
(2336, 'Raiffeisenbank Thunersee', 'Dorfstrasse 5', '', '3661', 'Uetendorf', 'Suisse', 80867, 0, 1),
(2337, 'Raiffeisenbank Thunersee', 'Bahnhofstrasse 12', '', '3700', 'Spiez', 'Suisse', 80867, 0, 1),
(2338, 'Raiffeisenbank Thunersee', 'Dorfstrasse 12', '', '3706', 'Leissigen', 'Suisse', 80867, 0, 1),
(2339, 'Raiffeisenbank Oberemmental', 'Dorf', '', '3538', 'Röthenbach im Emmental', 'Suisse', 80873, 0, 1),
(2340, 'Raiffeisenbank Unteremmental', 'Dorfstrasse 16', 'Postfach 70', '3432', 'Lützelflüh-Goldbach', 'Suisse', 80875, 0, 1),
(2341, 'Raiffeisenbank Unteremmental', 'Dorfstrasse 3', '', '3457', 'Wasen im Emmental', 'Suisse', 80875, 0, 1),
(2342, 'Raiffeisenbank Unteremmental', 'Bahnhofstrasse 39', 'Postfach 361', '4950', 'Huttwil', 'Suisse', 80875, 0, 1),
(2343, 'Raiffeisenbank Oberes Emmental', 'Dorfstrasse 1', '', '3550', 'Langnau i.E.', 'Suisse', 80882, 0, 1),
(2344, 'Raiffeisenbank Oberes Emmental', 'Dorfstrasse 49', '', '3534', 'Signau', 'Suisse', 80882, 0, 1),
(2345, 'Raiffeisenbank Oberes Emmental', 'Postplatz', '', '3537', 'Eggiwil', 'Suisse', 80882, 0, 1),
(2346, 'Raiffeisenbank Oberes Emmental', 'Gärtli 10', '', '6197', 'Schangnau', 'Suisse', 80882, 0, 1),
(2347, 'Raiffeisenbank Oberes Emmental', 'Dorf', '', '3538', 'Röthenbach im Emmental', 'Suisse', 80882, 0, 1),
(2348, 'Raiffeisenbank Region Burgdorf', 'Bahnhofstrasse 20', 'Postfach', '3401', 'Burgdorf', 'Suisse', 80888, 0, 1),
(2349, 'Raiffeisenbank Region Burgdorf', 'Rüegsaustrasse 28', '', '3415', 'Hasle-Rüegsau', 'Suisse', 80888, 0, 1),
(2350, 'Raiffeisenbank Düdingen', 'Bahnhofplatz 1', '', '3186', 'Düdingen', 'Suisse', 80894, 0, 1),
(2351, 'Raiffeisenbank Sense-Oberland', 'Dorfplatz 7', 'Postfach 99', '1735', 'Giffers', 'Suisse', 80895, 0, 1),
(2352, 'Raiffeisenbank Sense-Oberland', 'zur Schür 10', '', '1736', 'St. Silvester', 'Suisse', 80895, 0, 1),
(2353, 'Raiffeisenbank Sense-Oberland', 'Amselweg 6', '', '1718', 'Rechthalten', 'Suisse', 80895, 0, 1),
(2354, 'Raiffeisenbank Sense-Oberland', 'Dorf 1', '', '1717', 'St. Ursen', 'Suisse', 80895, 0, 1),
(2355, 'Raiffeisenbank Sense-Oberland', 'Hauptstrasse 384', '', '1656', 'Jaun', 'Suisse', 80895, 0, 1),
(2356, 'Raiffeisenbank Sense-Oberland', 'Hauptstrasse 17', '', '1716', 'Plaffeien', 'Suisse', 80895, 0, 1),
(2357, 'Raiffeisenbank Sense-Oberland', 'Dorfweg 16', '', '1737', 'Plasselb', 'Suisse', 80895, 0, 1),
(2358, 'Raiffeisenbank See-Lac', 'St. Germanstrasse 5', '', '3212', 'Gurmels', 'Suisse', 80896, 0, 1),
(2359, 'Banque Raiffeisen See-Lac', 'Rte de Fribourg 59', 'Case postale 118', '1784', 'Courtepin', 'Suisse', 80896, 0, 1),
(2360, 'Raiffeisenbank See-Lac', 'Bernstrasse 30', '', '3280', 'Murten', 'Suisse', 80896, 0, 1),
(2361, 'Raiffeisenbank Plaffeien-Plasselb', 'Hauptstrasse 17', 'Postfach 128', '1716', 'Plaffeien', 'Suisse', 80899, 0, 1),
(2362, 'Raiffeisenbank Freiburg Ost / Fribourg Est', 'Bahnhofplatz 1', 'Postfach 243', '3186', 'Düdingen', 'Suisse', 80901, 0, 1),
(2363, 'Raiffeisenbank Freiburg Ost / Fribourg Est', 'Rue de l&apos; Hôpit', '', '1701', 'Fribourg', 'Suisse', 80901, 0, 1),
(2364, 'Raiffeisenbank Freiburg Ost / Fribourg Est', 'Hauptstrasse 59', 'Postfach 31', '1715', 'Alterswil FR', 'Suisse', 80901, 0, 1),
(2365, 'Raiffeisenbank Freiburg Ost / Fribourg Est', 'Hauptstrasse 44', '', '1714', 'Heitenried', 'Suisse', 80901, 0, 1),
(2366, 'Raiffeisenbank Freiburg Ost / Fribourg Est', 'Thunstrasse 1', '', '1712', 'Tafers', 'Suisse', 80901, 0, 1),
(2367, 'Raiffeisenbank Freiburg Ost / Fribourg Est', 'Hauptstrasse 30', '', '1713', 'St. Antoni', 'Suisse', 80901, 0, 1),
(2368, 'Raiffeisenbank Ueberstorf', 'Albligenstrasse 10', 'Postfach', '3182', 'Ueberstorf', 'Suisse', 80904, 0, 1),
(2369, 'Raiffeisenbank Sensetal', 'Bernstrasse 15', 'Postfach 70', '3175', 'Flamatt', 'Suisse', 80905, 0, 1),
(2370, 'Raiffeisenbank Sensetal', 'Dorfplatz 2', '', '3176', 'Neuenegg', 'Suisse', 80905, 0, 1),
(2371, 'Raiffeisenbank Sensetal', 'F.X. Müllerstrasse 9', '', '3185', 'Schmitten FR', 'Suisse', 80905, 0, 1),
(2372, 'Raiffeisenbank Sensetal', 'Freiburgstrasse 555', '', '3172', 'Niederwangen', 'Suisse', 80905, 0, 1),
(2373, 'Raiffeisenbank Sensetal', 'Freiburgstrasse 8', '', '3178', 'Bösingen', 'Suisse', 80905, 0, 1),
(2374, 'Raiffeisenbank Sensetal', 'Bärenplatz 3', '', '3177', 'Laupen BE', 'Suisse', 80905, 0, 1),
(2375, 'Raiffeisenbank Sensetal', 'Dorfstrasse 11', '', '3184', 'Wünnewil', 'Suisse', 80905, 0, 1),
(2376, 'Raiffeisenbank Dulliken-Starrkirch', 'Bahnhofstrasse 40', '', '4657', 'Dulliken', 'Suisse', 80911, 0, 1),
(2377, 'Raiffeisenbank Gäu-Bipperamt', 'Kornhausplatz 2', 'Postfach', '4622', 'Egerkingen', 'Suisse', 80912, 0, 1),
(2378, 'Raiffeisenbank Gäu-Bipperamt', 'Hauptstrasse 2', 'Postfach 165', '4702', 'Oensingen', 'Suisse', 80912, 0, 1),
(2379, 'Raiffeisenbank Gäu-Bipperamt', 'Bahnhofstrasse 1', '', '4537', 'Wiedlisbach', 'Suisse', 80912, 0, 1),
(2380, 'Raiffeisenbank Gäu-Bipperamt', 'Hauptstrasse 9', '', '4625', 'Oberbuchsiten', 'Suisse', 80912, 0, 1),
(2381, 'Raiffeisenbank Gäu-Bipperamt', 'Dorfstrasse 74', '', '4626', 'Niederbuchsiten', 'Suisse', 80912, 0, 1),
(2382, 'Raiffeisenbank Fulenbach-Murgenthal-Langenthal', 'Breitenstrasse 2', '', '4629', 'Fulenbach', 'Suisse', 80914, 0, 1),
(2383, 'Raiffeisenbank Fulenbach-Murgenthal-Langenthal', 'Hauptstrasse 145', '', '4853', 'Murgenthal', 'Suisse', 80914, 0, 1),
(2384, 'Raiffeisenbank Fulenbach-Murgenthal-Langenthal', 'Mühleweg 11', '', '4900', 'Langenthal', 'Suisse', 80914, 0, 1),
(2385, 'Raiffeisenbank Mittelgösgen', 'Hauptstrasse 7', '', '4654', 'Lostorf', 'Suisse', 80918, 0, 1),
(2386, 'Raiffeisenbank Mittelgösgen', 'Aarauerstrasse 4', '', '4653', 'Obergösgen', 'Suisse', 80918, 0, 1),
(2387, 'Raiffeisenbank Mittelgösgen', 'Unterdorfstrasse 2', 'Postfach 32', '4652', 'Winznau', 'Suisse', 80918, 0, 1),
(2388, 'Raiffeisenbank Gilgenberg', 'Kleine Seite 6', 'Postfach 30', '4208', 'Nunningen', 'Suisse', 80924, 0, 1),
(2389, 'Raiffeisenbank Aeschi- Buchsi', 'Luzernstr. 5', '', '4556', 'Aeschi SO', 'Suisse', 80928, 0, 1),
(2390, 'Raiffeisenbank Aeschi- Buchsi', 'Bahnhofstrasse 23', '', '3360', 'Herzogenbuchsee', 'Suisse', 80928, 0, 1),
(2391, 'Raiffeisenbank Balsthal-Laupersdorf', 'Goldgasse 16', 'Postfach 244', '4710', 'Balsthal', 'Suisse', 80930, 0, 1),
(2392, 'Raiffeisenbank Balsthal-Laupersdorf', 'Unterdorfstrasse 35', '', '4712', 'Laupersdorf', 'Suisse', 80930, 0, 1),
(2393, 'Raiffeisenbank Biberist', 'Bernstrasse 11', 'Postfach', '4562', 'Biberist', 'Suisse', 80933, 0, 1),
(2394, 'Raiffeisenbank Däniken-Gretzenbach', 'Oberdorfstr. 10', '', '4658', 'Däniken SO', 'Suisse', 80936, 0, 1),
(2395, 'Raiffeisenbank Däniken-Gretzenbach', 'Köllikerstrasse 29', 'Postfach', '5014', 'Gretzenbach', 'Suisse', 80936, 0, 1),
(2396, 'Raiffeisenbank Wasseramt Mitte', 'Hauptstrasse 37', 'Postfach 102', '4552', 'Derendingen', 'Suisse', 80938, 0, 1),
(2397, 'Raiffeisenbank Wasseramt Mitte', 'Wangenstrasse 3', '', '4543', 'Deitingen', 'Suisse', 80938, 0, 1),
(2398, 'Raiffeisenbank Wasseramt Mitte', 'Hauptstrasse 24', '', '4542', 'Luterbach', 'Suisse', 80938, 0, 1),
(2399, 'Raiffeisenbank Wasseramt Mitte', 'Bahnhofstrasse 9', '', '4553', 'Subingen', 'Suisse', 80938, 0, 1),
(2400, 'Raiffeisenbank Wasseramt Mitte', 'Hauptstrasse 75', '', '4528', 'Zuchwil', 'Suisse', 80938, 0, 1),
(2401, 'Raiffeisenbank Dornach', 'Bruggweg 129', 'Postfach', '4143', 'Dornach', 'Suisse', 80939, 0, 1),
(2402, 'Raiffeisenbank Dornach', 'Hauptstrasse 4', 'Postfach', '4146', 'Hochwald', 'Suisse', 80939, 0, 1),
(2403, 'Raiffeisenbank Dornach', 'Amthausstrasse 21', '', '4143', 'Dornach', 'Suisse', 80939, 0, 1),
(2404, 'Raiffeisenbank Erlinsbach', 'Hauptstrasse 34', 'Postfach 126', '5015', 'Erlinsbach SO', 'Suisse', 80940, 0, 1),
(2405, 'Raiffeisenbank Erlinsbach', 'Hauptstrasse 15', '', '5024', 'Küttigen', 'Suisse', 80940, 0, 1),
(2406, 'Raiffeisenbank Untergäu', 'Eigasse 8', 'Postfach 443', '4614', 'Hägendorf', 'Suisse', 80947, 0, 1),
(2407, 'Raiffeisenbank Untergäu', 'Mittelgäustrasse 23', '', '4616', 'Kappel SO', 'Suisse', 80947, 0, 1),
(2408, 'Raiffeisenbank Untergäu', 'Allmendstrasse 2', 'Untergäu', '4617', 'Gunzgen', 'Suisse', 80947, 0, 1),
(2409, 'Raiffeisenbank Untergäu', 'Dorfstrasse 71', 'Postfach 368', '4612', 'Wangen b. Olten', 'Suisse', 80947, 0, 1),
(2410, 'Raiffeisenbank Dünnerntal-Guldental', 'Ramiswilerstrasse 1', 'Postfach 109', '4717', 'Mümliswil', 'Suisse', 80962, 0, 1),
(2411, 'Raiffeisenbank Dünnerntal-Guldental', 'Hauptstrasse 97', '', '4718', 'Holderbank SO', 'Suisse', 80962, 0, 1),
(2412, 'Raiffeisenbank Dünnerntal-Guldental', 'Hauptstrasse 550', '', '4716', 'Welschenrohr', 'Suisse', 80962, 0, 1),
(2413, 'Raiffeisenbank Dünnerntal-Guldental', 'Dorfstrasse 54', '', '4713', 'Matzendorf', 'Suisse', 80962, 0, 1),
(2414, 'Raiffeisenbank Niederbuchsiten', 'Dorfstrasse 74', '', '4626', 'Niederbuchsiten', 'Suisse', 80964, 0, 1),
(2415, 'Raiffeisenbank Niedergösgen-Schönenwerd-Eppenberg', 'Hauptstr. 17', '', '5013', 'Niedergösgen', 'Suisse', 80965, 0, 1),
(2416, 'Raiffeisenbank Niedergösgen-Schönenwerd-Eppenberg', 'Hauptstrasse 30', '', '4655', 'Stüsslingen', 'Suisse', 80965, 0, 1),
(2417, 'Raiffeisenbank Weissenstein', 'Weissensteinstrasse ', 'Postfach 251', '4513', 'Langendorf', 'Suisse', 80968, 0, 1),
(2418, 'Raiffeisenbank Olten', 'Ringstrasse 15', 'Postfach', '4600', 'Olten', 'Suisse', 80970, 0, 1),
(2419, 'Raiffeisenbank Recherswil-Gerlafingen-Koppigen', 'Hauptstr. 109', '', '4565', 'Recherswil', 'Suisse', 80971, 0, 1),
(2420, 'Raiffeisenbank Recherswil-Gerlafingen-Koppigen', 'Hauptstrasse 33', '', '3425', 'Koppigen', 'Suisse', 80971, 0, 1),
(2421, 'Raiffeisenbank Recherswil-Gerlafingen-Koppigen', 'Hauptstrasse 10', 'Postfach 308', '4563', 'Gerlafingen', 'Suisse', 80971, 0, 1),
(2422, 'Raiffeisenbank Recherswil-Gerlafingen-Koppigen', 'Bahnhofstrasse 11a', '', '3427', 'Utzenstorf', 'Suisse', 80971, 0, 1),
(2423, 'Raiffeisenbank Weissenstein', 'Hauptgasse 67', 'Postfach 321', '4501', 'Solothurn', 'Suisse', 80976, 0, 1),
(2424, 'Raiffeisenbank Weissenstein', 'Jurastrasse 3', '', '2544', 'Bettlach', 'Suisse', 80976, 0, 1),
(2425, 'Raiffeisenbank Weissenstein', 'Schulhausstrasse 4', '', '2545', 'Selzach', 'Suisse', 80976, 0, 1),
(2426, 'Raiffeisenbank Weissenstein', 'Solothurnerstrasse 3', '', '2540', 'Grenchen', 'Suisse', 80976, 0, 1),
(2427, 'Raiffeisenbank Weissenstein', 'Baselstrasse 3', '', '4534', 'Flumenthal', 'Suisse', 80976, 0, 1),
(2428, 'Raiffeisenbank Weissenstein', 'Weissensteinstrasse ', '', '4513', 'Langendorf', 'Suisse', 80976, 0, 1),
(2429, 'Raiffeisenbank Weissenstein', 'Dorfstrasse', '', '4512', 'Bellach', 'Suisse', 80976, 0, 1),
(2430, 'Raiffeisenbank Solothurn', 'Hauptgasse 67', '', '4501', 'Solothurn', 'Suisse', 80977, 0, 1),
(2431, 'Raiffeisenbank Dünnerntal', 'Hauptstrasse 550', '', '4716', 'Welschenrohr', 'Suisse', 80982, 0, 1),
(2432, 'Raiffeisenbank Oberes Gäu-Aare', 'Hauptstrasse 28', 'Postfach', '4628', 'Wolfwil', 'Suisse', 80985, 0, 1),
(2433, 'Raiffeisenbank Oberes Gäu-Aare', 'Neue Strasse 2', '', '4703', 'Kestenholz', 'Suisse', 80985, 0, 1),
(2434, 'Raiffeisenbank Zuchwil', 'Hauptstrasse 75', 'Postfach 365', '4528', 'Zuchwil', 'Suisse', 80986, 0, 1),
(2435, 'Raiffeisenbank Appenzeller Hinterland', 'Platz 7', 'Postfach', '9100', 'Herisau', 'Suisse', 81011, 0, 1),
(2436, 'Raiffeisenbank Appenzeller Hinterland', 'Dorfstrasse 16', '', '9104', 'Waldstatt', 'Suisse', 81011, 0, 1),
(2437, 'Raiffeisenbank Appenzeller Hinterland', 'Herisauerstrasse 5', '', '9107', 'Urnäsch', 'Suisse', 81011, 0, 1),
(2438, 'Raiffeisenbank Heiden', 'Werdstrasse 1', '', '9410', 'Heiden', 'Suisse', 81012, 0, 1),
(2439, 'Raiffeisenbank Heiden', 'Hauptstrasse 24', '', '9042', 'Speicher', 'Suisse', 81012, 0, 1),
(2440, 'Raiffeisenbank Heiden', 'Heidenerstrasse 10', '', '9034', 'Eggersriet', 'Suisse', 81012, 0, 1),
(2441, 'Raiffeisenbank Appenzell', 'Hauptgasse 41', 'Postfach 241', '9050', 'Appenzell', 'Suisse', 81023, 0, 1),
(2442, 'Raiffeisenbank Appenzell', 'Am Bahnhof, Ebni 3', '', '9053', 'Teufen AR', 'Suisse', 81023, 0, 1),
(2443, 'Raiffeisenbank Appenzell', 'Dorfstrasse 49', '', '9108', 'Gonten', 'Suisse', 81023, 0, 1),
(2444, 'Raiffeisenbank Appenzell', 'Dorf 6', '', '9058', 'Brülisau', 'Suisse', 81023, 0, 1),
(2445, 'Raiffeisenbank Glarnerland', 'Im Dorf 4', 'Postfach 141', '8752', 'Näfels', 'Suisse', 81031, 0, 1),
(2446, 'Raiffeisenbank Glarnerland', 'Stampfgasse 10', '', '8750', 'Glarus', 'Suisse', 81031, 0, 1),
(2447, 'Raiffeisenbank Bündner Rheintal', 'Bahnhofplatz 6', 'Postfach 549', '7001', 'Chur', 'Suisse', 81045, 0, 1),
(2448, 'Raiffeisenbank Bündner Rheintal', 'Bahnhofstrasse 37', '', '7302', 'Landquart', 'Suisse', 81045, 0, 1),
(2449, 'Raiffeisenbank Bündner Rheintal', 'Hauptstrasse 100', '', '7075', 'Churwalden', 'Suisse', 81045, 0, 1),
(2450, 'Raiffeisenbank Bündner Rheintal', 'Plaz 1', '', '7013', 'Domat/Ems', 'Suisse', 81045, 0, 1),
(2451, 'Raiffeisenbank Bündner Rheintal', 'Dorfstrasse 1', '', '7402', 'Bonaduz', 'Suisse', 81045, 0, 1),
(2452, 'Raiffeisenbank Bündner Rheintal', 'Via Scudria 1', '', '7403', 'Rhäzüns', 'Suisse', 81045, 0, 1),
(2453, 'Raiffeisenbank Vorderprättigau', 'Dorfplatz 17A', 'Postfach 47', '7220', 'Schiers', 'Suisse', 81047, 0, 1),
(2454, 'Raiffeisenbank Calanda', 'Kantonsstrasse 60', 'Postfach 28', '7205', 'Zizers', 'Suisse', 81048, 0, 1),
(2455, 'Raiffeisenbank Calanda', 'Malinweg 1', '', '7203', 'Trimmis', 'Suisse', 81048, 0, 1),
(2456, 'Raiffeisenbank Calanda', 'Ulmgasse 1', 'Postfach 44', '7204', 'Untervaz', 'Suisse', 81048, 0, 1),
(2457, 'Banca Raiffeisen del Moesano', 'Piazzetta', 'Casella postale 218', '6535', 'Roveredo GR', 'Suisse', 81054, 0, 1),
(2458, 'Banca Raiffeisen del Moesano', 'Crimeo', '', '6563', 'Mesocco', 'Suisse', 81054, 0, 1),
(2459, 'Banca Raiffeisen del Moesano', 'Centro commerciale', '', '6558', 'Lostallo', 'Suisse', 81054, 0, 1),
(2460, 'Raiffeisenbank Mittelbünden', 'Hauptstrasse 50', 'Postfach 36', '7408', 'Cazis', 'Suisse', 81063, 0, 1),
(2461, 'Raiffeisenbank Mittelbünden', 'Stradung 35', '', '7460', 'Savognin', 'Suisse', 81063, 0, 1),
(2462, 'Raiffeisenbank Mittelbünden', 'Neudorfstrasse 9', '', '7430', 'Thusis', 'Suisse', 81063, 0, 1),
(2463, 'Raiffeisenbank Mittelbünden', 'Hauptstrasse', '', '7435', 'Splügen', 'Suisse', 81063, 0, 1),
(2464, 'Raiffeisenbank Mittelbünden', 'Stradung 27', '', '7450', 'Tiefencastel', 'Suisse', 81063, 0, 1),
(2465, 'Raiffeisenbank Mittelbünden', 'Veja Megstra 86', '', '7482', 'Bergün/Bravuogn', 'Suisse', 81063, 0, 1),
(2466, 'Raiffeisenbank Mittelbünden', 'Voa Principala 37', '', '7078', 'Lenzerheide', 'Suisse', 81063, 0, 1),
(2467, 'Raiffeisenbank Cadi', 'Via Cons 1', '', '7180', 'Disentis/Mustér', 'Suisse', 81072, 0, 1),
(2468, 'Raiffeisenbank Cadi', 'Via Principala 56', '', '7166', 'Trun', 'Suisse', 81072, 0, 1),
(2469, 'Raiffeisenbank Cadi', 'Via Alpsu 91', '', '7188', 'Sedrun', 'Suisse', 81072, 0, 1),
(2470, 'Raiffeisenbank Surselva', 'Glennerstrasse 7', 'Postfach 264', '7130', 'Ilanz', 'Suisse', 81073, 0, 1),
(2471, 'Raiffeisenbank Surselva', 'Via Nova 68', '', '7017', 'Flims Dorf', 'Suisse', 81073, 0, 1),
(2472, 'Raiffeisenbank Surselva', 'Poststrasse 45', '', '7132', 'Vals', 'Suisse', 81073, 0, 1),
(2473, 'Raiffeisenbank Surselva', 'Palius 32D', '', '7144', 'Vella', 'Suisse', 81073, 0, 1),
(2474, 'Raiffeisenbank Surselva', 'Affeier 35', '', '7134', 'Obersaxen Meierhof', 'Suisse', 81073, 0, 1),
(2475, 'Raiffeisenbank Surselva', 'Via Prinicpala 60', '', '7031', 'Laax GR', 'Suisse', 81073, 0, 1),
(2476, 'Raiffeisenbank Prättigau-Davos', 'Promenade 74 A', 'Postfach', '7270', 'Davos Platz', 'Suisse', 81084, 0, 1),
(2477, 'Raiffeisenbank Prättigau-Davos', 'Bahnhofstrasse 14', 'Prättigau-Davos', '7250', 'Klosters', 'Suisse', 81084, 0, 1),
(2478, 'Raiffeisenbank Prättigau-Davos', 'Hauptstrass 6', 'Postfach', '7240', 'Küblis', 'Suisse', 81084, 0, 1),
(2479, 'Raiffeisenbank Prättigau-Davos', 'Dorfplatz 1', '', '7220', 'Schiers', 'Suisse', 81084, 0, 1),
(2480, 'Raiffeisenbank Prättigau-Davos', 'Landstrasse 12', '', '7214', 'Grüsch', 'Suisse', 81084, 0, 1),
(2481, 'Raiffeisenbank Prättigau-Davos', 'Schesaplanastrasse 2', '', '7212', 'Seewis Dorf', 'Suisse', 81084, 0, 1),
(2482, 'Banca Raiffeisen Valposchiavo', 'Via da Li Curt 658A', 'Casella postale 84', '7745', 'Curt, Li', 'Suisse', 81103, 0, 1),
(2483, 'Banca Raiffeisen Valposchiavo', 'Via Cantonale 334', '', '7743', 'Brusio', 'Suisse', 81103, 0, 1),
(2484, 'Banca Raiffeisen Valposchiavo', 'Via Principale 466A', '', '7741', 'San Carlo (Poschiavo)', 'Suisse', 81103, 0, 1),
(2485, 'Raiffeisenbank Tumpiv', 'Via Principala 37', '', '7165', 'Breil/Brigels', 'Suisse', 81137, 0, 1),
(2486, 'Raiffeisenbank Engiadina Val Müstair', 'Plazza da Posta', '', '7537', 'Müstair', 'Suisse', 81144, 0, 1),
(2487, 'Raiffeisenbank Engiadina Val Müstair', 'Plaz', '', '7530', 'Zernez', 'Suisse', 81144, 0, 1),
(2488, 'Raiffeisenbank Engiadina Val Müstair', 'Via Maistra 33A', '', '7524', 'Zuoz', 'Suisse', 81144, 0, 1),
(2489, 'Raiffeisenbank Engiadina Val Müstair', 'San Bastiaun 19', '', '7503', 'Samedan', 'Suisse', 81144, 0, 1),
(2490, 'Raiffeisenbank Engiadina Val Müstair', 'Stradun', '', '7550', 'Scuol', 'Suisse', 81144, 0, 1),
(2491, 'Raiffeisenbank Engiadina Val Müstair', 'Via dal Bagn 8', '', '7500', 'St. Moritz', 'Suisse', 81144, 0, 1),
(2492, 'Raiffeisenbank Hildisrieden', 'Luzernerstrasse 19', '', '6024', 'Hildisrieden', 'Suisse', 81164, 0, 1),
(2493, 'Raiffeisenbank Kriens', 'Luzernerstrasse 4/6', 'Postfach 1547', '6011', 'Kriens', 'Suisse', 81165, 0, 1),
(2494, 'Raiffeisenbank Adligenswil-Udligenswil-Meggen', 'Dorfstrasse 2', 'Postfach 429', '6043', 'Adligenswil', 'Suisse', 81168, 0, 1),
(2495, 'Raiffeisenbank Adligenswil-Udligenswil-Meggen', 'Luzernerstrasse 2', '', '6045', 'Meggen', 'Suisse', 81168, 0, 1),
(2496, 'Raiffeisenbank Hitzkirchertal', 'Bahnhofstrasse 12', 'Postfach 385', '6285', 'Hitzkirch', 'Suisse', 81169, 0, 1),
(2497, 'Raiffeisenbank Hitzkirchertal', 'Kreuzplatz 69', '', '6287', 'Aesch LU', 'Suisse', 81169, 0, 1),
(2498, 'Raiffeisenbank Hitzkirchertal', 'Dorf 1', '', '6027', 'Römerswil LU', 'Suisse', 81169, 0, 1),
(2499, 'Raiffeisenbank Beromünster', 'Oberdorf', 'Postfach 165', '6215', 'Beromünster', 'Suisse', 81170, 0, 1),
(2500, 'Raiffeisenbank Beromünster', 'Botenhofstrasse 4', '', '6205', 'Eich', 'Suisse', 81170, 0, 1),
(2501, 'Raiffeisenbank Beromünster', 'Sandgasse 11', '', '5734', 'Reinach AG', 'Suisse', 81170, 0, 1),
(2502, 'Raiffeisenbank Buttisholz-Ruswil', 'Oberdorf 4', 'Postfach 43', '6018', 'Buttisholz', 'Suisse', 81172, 0, 1),
(2503, 'Raiffeisenbank Emmen', 'Gerliswilstrasse 95', 'Postfach', '6020', 'Emmenbrücke', 'Suisse', 81177, 0, 1),
(2504, 'Raiffeisenbank Emmen', 'Stichermattstrasse 5', 'Postfach 342', '6032', 'Emmen', 'Suisse', 81177, 0, 1),
(2505, 'Raiffeisenbank im Entlebuch', 'Hauptstrasse 113', 'Postfach 106', '6182', 'Escholzmatt', 'Suisse', 81179, 0, 1),
(2506, 'Raiffeisenbank im Entlebuch', 'Bahnhofstrasse 6', '', '6170', 'Schüpfheim', 'Suisse', 81179, 0, 1),
(2507, 'Raiffeisenbank im Entlebuch', 'Heiligkreuzstrasse 1', '', '6166', 'Hasle LU', 'Suisse', 81179, 0, 1),
(2508, 'Raiffeisenbank im Entlebuch', 'Sonnenmatte 1', 'Postfach', '6173', 'Flühli LU', 'Suisse', 81179, 0, 1),
(2509, 'Raiffeisenbank Hergiswil LU', 'Dorfstrasse 28', 'Postfach 22', '6133', 'Hergiswil b. Willisau', 'Suisse', 81184, 0, 1),
(2510, 'Raiffeisenbank Horw', 'Kantonsstrasse 104', 'Postfach', '6048', 'Horw', 'Suisse', 81186, 0, 1),
(2511, 'Raiffeisenbank Oberseetal', 'Freiherrenweg 2', 'Postfach 158', '6274', 'Eschenbach LU', 'Suisse', 81187, 0, 1),
(2512, 'Raiffeisenbank Oberseetal', 'Ballwilerstrasse 3', '', '6034', 'Inwil', 'Suisse', 81187, 0, 1),
(2513, 'Raiffeisenbank Oberseetal', 'Unterdorfstrasse 7', '', '6276', 'Hohenrain', 'Suisse', 81187, 0, 1),
(2514, 'Raiffeisenbank Oberseetal', 'Hauptstrasse 7', '', '6280', 'Hochdorf', 'Suisse', 81187, 0, 1),
(2515, 'Raiffeisenbank Littau-Reussbühl', 'Jodersmatt 1', '', '6014', 'Luzern', 'Suisse', 81190, 0, 1),
(2516, 'Raiffeisenbank Luthern', 'Schnydermatt 5', '', '6154', 'Hofstatt', 'Suisse', 81191, 0, 1),
(2517, 'Raiffeisenbank Malters', 'Mettlenweg 2', 'Postfach 344', '6102', 'Malters', 'Suisse', 81192, 0, 1),
(2518, 'Raiffeisenbank Menznau-Wolhusen', 'Unterdorfstrasse 4', '', '6122', 'Menznau', 'Suisse', 81194, 0, 1),
(2519, 'Raiffeisenbank Menznau-Wolhusen', 'Kirchgasse 2', '', '6110', 'Wolhusen', 'Suisse', 81194, 0, 1),
(2520, 'Raiffeisenbank Sempachersee Süd', 'Zentrum Sagi', '', '6207', 'Nottwil', 'Suisse', 81196, 0, 1),
(2521, 'Raiffeisenbank Sempachersee Süd', 'Mauenseestrasse 2', '', '6212', 'St. Erhard', 'Suisse', 81196, 0, 1),
(2522, 'Raiffeisenbank Sempachersee Süd', 'Luzernstrasse 16', 'Postfach 68', '6206', 'Neuenkirch', 'Suisse', 81196, 0, 1),
(2523, 'Raiffeisenbank Sempachersee Süd', 'Luzernerstrasse 19', '', '6024', 'Hildisrieden', 'Suisse', 81196, 0, 1),
(2524, 'Raiffeisenbank Pfaffnerntal-Rottal', 'Ausserdorfstrasse 8', 'Postfach 53', '6147', 'Altbüron', 'Suisse', 81197, 0, 1),
(2525, 'Raiffeisenbank Luzern', 'Bahnhofstrasse 5', '', '6003', 'Luzern', 'Suisse', 81203, 0, 1),
(2526, 'Raiffeisenbank Luzern', 'Schulstrasse 1', '', '6037', 'Root', 'Suisse', 81203, 0, 1),
(2527, 'Raiffeisenbank Luzern', 'Zentralstrasse 28', 'Postfach 1457', '6030', 'Ebikon', 'Suisse', 81203, 0, 1),
(2528, 'Raiffeisenbank Rothenburg', 'Stationsstrasse 7', 'Postfach 455', '6023', 'Rothenburg', 'Suisse', 81204, 0, 1),
(2529, 'Raiffeisenbank Rothenburg', 'Chilestrasse 2', '', '6026', 'Rain', 'Suisse', 81204, 0, 1),
(2530, 'Raiffeisenbank Luzerner Hinterland', 'Mohrenplatz 10', 'Postfach 3225', '6130', 'Willisau', 'Suisse', 81211, 0, 1),
(2531, 'Raiffeisenbank Luzerner Hinterland', 'Züntihausmatte 2', '', '6142', 'Gettnau', 'Suisse', 81211, 0, 1),
(2532, 'Raiffeisenbank Luzerner Hinterland', 'Dorfstrasse 16', '', '6153', 'Ufhusen', 'Suisse', 81211, 0, 1),
(2533, 'Raiffeisenbank Luzerner Hinterland', 'Dorfstrasse 17', '', '6154', 'Hofstatt', 'Suisse', 81211, 0, 1),
(2534, 'Raiffeisenbank Ettiswil', 'Dorf 7', '', '6218', 'Ettiswil', 'Suisse', 81212, 0, 1),
(2535, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Dorfchärn 2', '', '6247', 'Schötz', 'Suisse', 81214, 0, 1),
(2536, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Baselstrasse 13', '', '6252', 'Dagmersellen', 'Suisse', 81214, 0, 1),
(2537, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Walke B', '', '6260', 'Reiden', 'Suisse', 81214, 0, 1),
(2538, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Bahnhofstrasse 7A', '', '6210', 'Sursee', 'Suisse', 81214, 0, 1),
(2539, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Chäppelimatt 1', '', '6232', 'Geuensee', 'Suisse', 81214, 0, 1),
(2540, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Kantonsstrasse 71', '', '6234', 'Triengen', 'Suisse', 81214, 0, 1),
(2541, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Dorfstrasse 17', '', '6264', 'Pfaffnau', 'Suisse', 81214, 0, 1),
(2542, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Ausserdorfstrasse 8', '', '6147', 'Altbüron', 'Suisse', 81214, 0, 1),
(2543, 'Raiffeisenbank Luzerner Landschaft Nordwest', 'Dorfstrasse 39', '', '4917', 'Melchnau', 'Suisse', 81214, 0, 1),
(2544, 'Raiffeisenbank Vierwaldstättersee-Süd', 'Ennetbürgerstrasse 1', 'Postfach 344', '6374', 'Buochs', 'Suisse', 81222, 0, 1),
(2545, 'Raiffeisenbank Vierwaldstättersee-Süd', 'Buochserstrasse 1a', 'Postfach 456', '6373', 'Ennetbürgen', 'Suisse', 81222, 0, 1),
(2546, 'Raiffeisenbank Vierwaldstättersee-Süd', 'Dorfstrasse 45', 'Postfach 90', '6376', 'Emmetten', 'Suisse', 81222, 0, 1),
(2547, 'Raiffeisenbank Vierwaldstättersee-Süd', 'Tanzplatz 4', '', '6377', 'Seelisberg', 'Suisse', 81222, 0, 1),
(2548, 'Raiffeisenbank Region Stans', 'Robert-Durrer-Strass', 'Postfach 970', '6371', 'Stans', 'Suisse', 81223, 0, 1),
(2549, 'Raiffeisenbank Region Stans', 'Eintracht 8', '', '6386', 'Wolfenschiessen', 'Suisse', 81223, 0, 1),
(2550, 'Raiffeisenbank Region Stans', 'Chrüzmattstrasse 1', '', '6383', 'Dallenwil', 'Suisse', 81223, 0, 1),
(2551, 'Raiffeisenbank Region Stans', 'Dorfplatz 3', '', '6052', 'Hergiswil NW', 'Suisse', 81223, 0, 1),
(2552, 'Raiffeisenbank Sachseln', 'Brünigstrasse 97', 'Postfach 261', '6072', 'Sachseln', 'Suisse', 81231, 0, 1),
(2553, 'Raiffeisenbank Obwalden', 'Brünigstrasse 97', '', '6072', 'Sachseln', 'Suisse', 81232, 0, 1),
(2554, 'Raiffeisenbank Obwalden', 'Dorfstrasse 9', '', '6064', 'Kerns', 'Suisse', 81232, 0, 1),
(2555, 'Raiffeisenbank Obwalden', 'Bahnhofplatz 7', 'Postfach 261', '6060', 'Sarnen', 'Suisse', 81232, 0, 1),
(2556, 'Raiffeisenbank Obwalden', 'Brünigstrasse 56', '', '6074', 'Giswil', 'Suisse', 81232, 0, 1),
(2557, 'Raiffeisenbank Obwalden', 'Brünigstrasse 105', '', '6078', 'Lungern', 'Suisse', 81232, 0, 1),
(2558, 'Raiffeisenbank Obwalden', 'Bahnhofstrasse 1', '', '6055', 'Alpnach Dorf', 'Suisse', 81232, 0, 1),
(2559, 'Raiffeisenbank Abtwil-St.-Josefen', 'Sonnebergstrasse 8', '', '9030', 'Abtwil SG', 'Suisse', 81241, 0, 1),
(2560, 'Raiffeisenbank Eggersriet-Grub', 'Heidenerstrasse 10', 'Postfach 141', '9034', 'Eggersriet', 'Suisse', 81244, 0, 1),
(2561, 'Raiffeisenbank Goldingen-Wald', 'Dorfstrasse 21', '', '8638', 'Goldingen', 'Suisse', 81245, 0, 1),
(2562, 'Raiffeisenbank Werdenberg', 'Bahnhofstrasse 12', 'Postfach 762', '9470', 'Buchs', 'Suisse', 81251, 0, 1),
(2563, 'Raiffeisenbank Werdenberg', 'Staatsstrasse 62', 'Postfach 62', '9472', 'Grabs', 'Suisse', 81251, 0, 1),
(2564, 'Raiffeisenbank Werdenberg', 'Hauptstrasse 11', '', '9477', 'Trübbach', 'Suisse', 81251, 0, 1),
(2565, 'Raiffeisenbank Andwil-Arnegg', 'Arneggerstr. 9', 'Postfach 18', '9204', 'Andwil SG', 'Suisse', 81253, 0, 1),
(2566, 'Raiffeisenbank Andwil-Arnegg', 'Bischofszellerstrass', '', '9212', 'Arnegg', 'Suisse', 81253, 0, 1),
(2567, 'Raiffeisenbank Benken', 'Zentrumplatz 1', '', '8717', 'Benken SG', 'Suisse', 81256, 0, 1),
(2568, 'Raiffeisenbank Benken', 'Dorfstrasse 3', '', '8722', 'Kaltbrunn', 'Suisse', 81256, 0, 1),
(2569, 'Raiffeisenbank Benken', 'Bahnhofstrasse 10', '', '8730', 'Uznach', 'Suisse', 81256, 0, 1),
(2570, 'Raiffeisenbank Benken', 'Dorfplatz 14', '', '8737', 'Gommiswald', 'Suisse', 81256, 0, 1),
(2571, 'Raiffeisenbank Berneck-Au', 'Rathausplatz 6', 'Postfach 152', '9442', 'Berneck', 'Suisse', 81258, 0, 1),
(2572, 'Raiffeisenbank Berneck-Au', 'Berneckerstrasse 3', '', '9434', 'Au SG', 'Suisse', 81258, 0, 1),
(2573, 'Raiffeisenbank Bernhardzell', 'St. Gallerstr. 31', '', '9304', 'Bernhardzell', 'Suisse', 81259, 0, 1),
(2574, 'Raiffeisenbank Unteres Toggenburg', 'Landstrasse 13', '', '9606', 'Bütschwil', 'Suisse', 81261, 0, 1),
(2575, 'Raiffeisenbank Unteres Toggenburg', 'Bütschwilerstrasse 1', '', '9607', 'Mosnang', 'Suisse', 81261, 0, 1),
(2576, 'Raiffeisenbank Unteres Toggenburg', 'Letzistrasse 3', '', '9604', 'Lütisburg', 'Suisse', 81261, 0, 1),
(2577, 'Raiffeisenbank Diepoldsau-Schmitter', 'Vordere Kirchstrasse', 'Postfach', '9444', 'Diepoldsau', 'Suisse', 81262, 0, 1),
(2578, 'Raiffeisenbank Engelburg', 'St. Gallerstrasse 1', '', '9032', 'Engelburg', 'Suisse', 81265, 0, 1),
(2579, 'Raiffeisenbank Flums', 'Postplatz', 'Postfach 92', '8890', 'Flums', 'Suisse', 81267, 0, 1),
(2580, 'Raiffeisenbank Goldach', 'Blumenstrasse 30', 'Postfach', '9403', 'Goldach', 'Suisse', 81269, 0, 1),
(2581, 'Raiffeisenbank Gossau-Niederwil', 'Ringstrasse 18-22', 'Postfach', '9201', 'Gossau SG', 'Suisse', 81271, 0, 1),
(2582, 'Raiffeisenbank Gossau-Niederwil', 'Im Dorf 17', '', '9203', 'Niederwil SG', 'Suisse', 81271, 0, 1),
(2583, 'Raiffeisenbank Rapperswil-Jona', 'St. Gallerstrasse 51', '', '8645', 'Jona', 'Suisse', 81274, 0, 1),
(2584, 'Raiffeisenbank Rapperswil-Jona', 'Forchstrasse 173', '', '8132', 'Egg b. Zürich', 'Suisse', 81274, 0, 1),
(2585, 'Raiffeisenbank Rapperswil-Jona', 'Ferrachstrasse 13', '', '8630', 'Rüti ZH', 'Suisse', 81274, 0, 1),
(2586, 'Raiffeisenbank Rapperswil-Jona', 'Im Zentrum 16', '', '8634', 'Hombrechtikon', 'Suisse', 81274, 0, 1),
(2587, 'Raiffeisenbank Kriessern', 'Oberdorfstr. 17', '', '9451', 'Kriessern', 'Suisse', 81275, 0, 1),
(2588, 'Raiffeisenbank Sarganserland', 'Oberdorfstrasse 11', '', '8887', 'Mels', 'Suisse', 81281, 0, 1),
(2589, 'Raiffeisenbank Sarganserland', 'Sarganserstrasse 20', '', '7324', 'Vilters', 'Suisse', 81281, 0, 1),
(2590, 'Raiffeisenbank Sarganserland', 'Dorfstrasse 26', '', '7323', 'Wangs', 'Suisse', 81281, 0, 1),
(2591, 'Raiffeisenbank Sarganserland', 'Bahnhofstrasse 7', '', '7320', 'Sargans', 'Suisse', 81281, 0, 1),
(2592, 'Raiffeisenbank Sarganserland', 'Maienfelderstrasse 6', '', '7310', 'Bad Ragaz', 'Suisse', 81281, 0, 1),
(2593, 'Raiffeisenbank Sarganserland', 'Postplatz', '', '8890', 'Flums', 'Suisse', 81281, 0, 1),
(2594, 'Raiffeisenbank Mörschwil', 'Schulstrasse 1', 'Postfach 75', '9402', 'Mörschwil', 'Suisse', 81284, 0, 1),
(2595, 'Raiffeisenbank Obertoggenburg', 'Toggenburgerstrasse ', 'Postfach', '9652', 'Neu St. Johann', 'Suisse', 81287, 0, 1),
(2596, 'Raiffeisenbank Obertoggenburg', 'Dorfstrasse 8', '', '9656', 'Alt St. Johann', 'Suisse', 81287, 0, 1),
(2597, 'Raiffeisenbank Obertoggenburg', 'Dorf', '', '9658', 'Wildhaus', 'Suisse', 81287, 0, 1),
(2598, 'Raiffeisenbank Niederhelfenschwil', 'Neudorf 1', '', '9527', 'Niederhelfenschwil', 'Suisse', 81289, 0, 1),
(2599, 'Raiffeisenbank Regio Uzwil', 'Neudorf 8', 'Postfach 136', '9245', 'Oberbüren', 'Suisse', 81291, 0, 1),
(2600, 'Raiffeisenbank Regio Uzwil', 'Raiffeisenplatz 1', 'Postfach', '9244', 'Niederuzwil', 'Suisse', 81291, 0, 1),
(2601, 'Raiffeisenbank Regio Uzwil', 'Staatsstrasse 36', '', '9246', 'Niederbüren', 'Suisse', 81291, 0, 1),
(2602, 'Raiffeisenbank Regio Uzwil', 'Wilerstrasse 37', '', '9536', 'Schwarzenbach SG', 'Suisse', 81291, 0, 1),
(2603, 'Raiffeisenbank Quarten', 'Quartnerstrasse 29', '', '8882', 'Unterterzen', 'Suisse', 81294, 0, 1),
(2604, 'Raiffeisenbank Unteres Rheintal', 'Bahnhofstrasse 38', 'Postfach 147', '9424', 'Rheineck', 'Suisse', 81295, 0, 1),
(2605, 'Raiffeisenbank Unteres Rheintal', 'Grenzstrasse 3', '', '9430', 'St. Margrethen SG', 'Suisse', 81295, 0, 1),
(2606, 'Raiffeisenbank Rorschacherberg-Thal', 'Goldacherstrasse 73', 'Postfach 261', '9404', 'Rorschacherberg', 'Suisse', 81296, 0, 1),
(2607, 'Raiffeisenbank Rorschacherberg-Thal', 'Hauptstrasse 25', '', '9400', 'Rorschach', 'Suisse', 81296, 0, 1),
(2608, 'Raiffeisenbank Oberes Rheintal', 'Churerstrasse 1', '', '9450', 'Altstätten SG', 'Suisse', 81297, 0, 1),
(2609, 'Raiffeisenbank Oberes Rheintal', 'Bahnhofstrasse 5', '', '9463', 'Oberriet SG', 'Suisse', 81297, 0, 1),
(2610, 'Raiffeisenbank Oberes Rheintal', 'Hinterburgstrasse 2', '', '9462', 'Montlingen', 'Suisse', 81297, 0, 1),
(2611, 'Raiffeisenbank Oberes Rheintal', 'Austrasse 2', '', '9464', 'Rüthi SG', 'Suisse', 81297, 0, 1),
(2612, 'Raiffeisenbank Oberes Rheintal', 'Oberdorfstrasse 17', '', '9451', 'Kriessern', 'Suisse', 81297, 0, 1),
(2613, 'Raiffeisenbank am Ricken', 'Rössligass 3', 'Postfach 42', '8733', 'Eschenbach SG', 'Suisse', 81298, 0, 1),
(2614, 'Raiffeisenbank am Ricken', 'Poststrasse 12', '', '8725', 'Ernetschwil', 'Suisse', 81298, 0, 1),
(2615, 'Raiffeisenbank am Ricken', 'Rickenstrasse 30', '', '8735', 'St. Gallenkappel', 'Suisse', 81298, 0, 1),
(2616, 'Raiffeisenbank am Ricken', 'Hauptstrasse 41', '', '8716', 'Schmerikon', 'Suisse', 81298, 0, 1),
(2617, 'Raiffeisenbank am Ricken', 'Dorfstrasse 21', '', '8638', 'Goldingen', 'Suisse', 81298, 0, 1),
(2618, 'Raiffeisenbank am Ricken', 'Bahnhofstrasse 37', '', '8636', 'Wald ZH', 'Suisse', 81298, 0, 1),
(2619, 'Raiffeisenbank Neckertal', 'Hauptstrasse 49', 'Postfach 22', '9105', 'Wald-Schönengrund', 'Suisse', 81300, 0, 1),
(2620, 'Raiffeisenbank Neckertal', 'Dreiegglistrasse 5', '', '9633', 'Hemberg', 'Suisse', 81300, 0, 1),
(2621, 'Raiffeisenbank Neckertal', 'Dorfstrasse 17', '', '9621', 'Oberhelfenschwil', 'Suisse', 81300, 0, 1),
(2622, 'Raiffeisenbank Neckertal', 'Dorfstrasse 20', '', '9125', 'Brunnadern', 'Suisse', 81300, 0, 1),
(2623, 'Raiffeisenbank Oberes Sarganserland', 'Bahnhofstrasse 7', 'Postfach 180', '7320', 'Sargans', 'Suisse', 81301, 0, 1),
(2624, 'Raiffeisenbank Schänis-Amden', 'Oberdorf 7', 'Postfach 62', '8718', 'Schänis', 'Suisse', 81302, 0, 1),
(2625, 'Raiffeisenbank Schänis-Amden', 'Dorfstrasse 22', 'Postfach', '8873', 'Amden', 'Suisse', 81302, 0, 1),
(2626, 'Raiffeisenbank Schwarzenbach', 'Wilerstrasse 37', 'Postfach 57', '9536', 'Schwarzenbach SG', 'Suisse', 81303, 0, 1),
(2627, 'Raiffeisenbank Sennwald', 'Äugstisriet 7', 'Postfach 42', '9466', 'Sennwald', 'Suisse', 81304, 0, 1),
(2628, 'Raiffeisenbank Regio Arbon', 'St. Gallerstrasse 20', 'Postfach 45', '9320', 'Arbon', 'Suisse', 81307, 0, 1),
(2629, 'Raiffeisenbank Regio Arbon', 'Dorfstrasse 15', '', '9323', 'Steinach', 'Suisse', 81307, 0, 1),
(2630, 'Raiffeisenbank Regio Arbon', 'St. Gallerstrasse 51', '', '9325', 'Roggwil TG', 'Suisse', 81307, 0, 1),
(2631, 'Raiffeisenbank Waldkirch', 'Arneggerstr. 2', 'Postfach', '9205', 'Waldkirch', 'Suisse', 81313, 0, 1),
(2632, 'Raiffeisenbank Waldkirch', 'Dorfstrasse 20', '', '9213', 'Hauptwil', 'Suisse', 81313, 0, 1),
(2633, 'Raiffeisenbank Walenstadt', 'Bahnhofstasse 9', 'Postfach 141', '8880', 'Walenstadt', 'Suisse', 81314, 0, 1),
(2634, 'Raiffeisenbank Mittleres Toggenburg', 'Poststrasse 27', 'Postfach 144', '9630', 'Wattwil', 'Suisse', 81317, 0, 1),
(2635, 'Raiffeisenbank Mittleres Toggenburg', 'Ebnaterstrasse 6', '', '9642', 'Ebnat-Kappel', 'Suisse', 81317, 0, 1),
(2636, 'Raiffeisenbank Mittelrheintal', 'Poststrasse 1', 'Postfach', '9443', 'Widnau', 'Suisse', 81319, 0, 1),
(2637, 'Raiffeisenbank Mittelrheintal', 'Hauptstrasse 40a', '', '9436', 'Balgach', 'Suisse', 81319, 0, 1),
(2638, 'Raiffeisenbank Mittelrheintal', 'Rhydorf-Center', '', '9443', 'Widnau', 'Suisse', 81319, 0, 1),
(2639, 'Raiffeisenbank Wil und Umgebung', 'Bronschhoferstrasse ', 'Postfach 239', '9500', 'Wil SG', 'Suisse', 81320, 0, 1),
(2640, 'Raiffeisenbank Winkeln', 'Herisauer Strasse 58', 'Postfach 316', '9015', 'St. Gallen', 'Suisse', 81322, 0, 1),
(2641, 'Raiffeisenbank Wittenbach-Haeggenschwil', 'Im Zentrum 1', 'Postfach 364', '9301', 'Wittenbach SG', 'Suisse', 81323, 0, 1),
(2642, 'Raiffeisenbank Wittenbach-Haeggenschwil', 'Dorfstrasse 16', '', '9312', 'Häggenschwil', 'Suisse', 81323, 0, 1),
(2643, 'Raiffeisenbank Marbach-Rebstein', 'Staatstr. 17a', '', '9437', 'Marbach SG', 'Suisse', 81324, 0, 1),
(2644, 'Raiffeisenbank Marbach-Rebstein', 'Staatsstrasse 99', '', '9445', 'Rebstein', 'Suisse', 81324, 0, 1),
(2645, 'Raiffeisenbank Flawil-Degersheim-Mogelsberg-Oberuzwil', 'Magdenauerstrasse 1', 'Postfach 264', '9230', 'Flawil', 'Suisse', 81325, 0, 1),
(2646, 'Raiffeisenbank Flawil-Degersheim-Mogelsberg-Oberuzwil', 'Wilerstrasse 6', 'Postfach', '9242', 'Oberuzwil', 'Suisse', 81325, 0, 1),
(2647, 'Raiffeisenbank Flawil-Degersheim-Mogelsberg-Oberuzwil', 'Hauptstrasse 69', '', '9113', 'Degersheim', 'Suisse', 81325, 0, 1),
(2648, 'Raiffeisenbank Schaffhausen', 'Bahnhofstrasse 30', '', '8200', 'Schaffhausen', 'Suisse', 81344, 0, 1),
(2649, 'Raiffeisenbank Schaffhausen', 'Hauptstrasse 13', '', '8215', 'Hallau', 'Suisse', 81344, 0, 1),
(2650, 'Raiffeisenbank Schaffhausen', 'Schaffhauserstrasse ', '', '8226', 'Schleitheim', 'Suisse', 81344, 0, 1),
(2651, 'Raiffeisenbank Rigi', 'Postplatz 5', '', '6430', 'Schwyz', 'Suisse', 81351, 0, 1),
(2652, 'Raiffeisenbank Rigi', 'Eichlistrasse 9', '', '6403', 'Immensee', 'Suisse', 81351, 0, 1),
(2653, 'Raiffeisenbank Rigi', 'Parkstrasse 33', '', '6410', 'Goldau', 'Suisse', 81351, 0, 1),
(2654, 'Raiffeisenbank Rigi', 'Luzernerstrasse 44', '', '6353', 'Weggis', 'Suisse', 81351, 0, 1),
(2655, 'Raiffeisenbank Rigi', 'Parkstrasse 1', '', '6440', 'Brunnen', 'Suisse', 81351, 0, 1),
(2656, 'Raiffeisenbank Rigi', 'Bahnhofstrasse 18', '', '6403', 'Küssnacht am Rigi', 'Suisse', 81351, 0, 1),
(2657, 'Raiffeisenbank Höfe', 'Hauptstrasse 13', 'Postfach 585', '8832', 'Wollerau', 'Suisse', 81356, 0, 1),
(2658, 'Raiffeisenbank Höfe', 'Dorfstrasse 32', '', '8834', 'Schindellegi', 'Suisse', 81356, 0, 1),
(2659, 'Raiffeisenbank Höfe', 'Bahnhofstrasse 12', '', '8810', 'Horgen', 'Suisse', 81356, 0, 1),
(2660, 'Raiffeisenbank Höfe', 'Churerstrasse 42', '', '8808', 'Pfäffikon SZ', 'Suisse', 81356, 0, 1),
(2661, 'Raiffeisenbank Illgau', 'Dörfli', '', '6434', 'Illgau', 'Suisse', 81357, 0, 1),
(2662, 'Raiffeisenbank Waldstätte', 'Parkstrasse 1', 'Postfach 462', '6440', 'Brunnen', 'Suisse', 81358, 0, 1),
(2663, 'Raiffeisenbank Muotathal', 'Hauptstrasse 48', 'Postfach 246', '6436', 'Muotathal', 'Suisse', 81360, 0, 1),
(2664, 'Raiffeisenbank Einsiedeln', 'Hauptstrasse 19', 'Postfach', '8840', 'Einsiedeln', 'Suisse', 81361, 0, 1),
(2665, 'Raiffeisenbank March', 'Herrengasse 1', 'Postfach 117', '8856', 'Tuggen', 'Suisse', 81363, 0, 1),
(2666, 'Raiffeisenbank March', 'Kantonsstrasse 45', '', '8854', 'Galgenen', 'Suisse', 81363, 0, 1),
(2667, 'Raiffeisenbank March', 'Oberdorfstrasse 5', '', '8853', 'Lachen SZ', 'Suisse', 81363, 0, 1),
(2668, 'Raiffeisenbank Yberg', 'Kirchenstrasse 1', 'Postfach 17', '8843', 'Oberiberg', 'Suisse', 81364, 0, 1),
(2669, 'Raiffeisenbank Yberg', 'Oberibergerstrasse 2', '', '8842', 'Unteriberg', 'Suisse', 81364, 0, 1),
(2670, 'Raiffeisenbank Regio Altnau', 'Wuhrwiesenstrasse 4', '', '8595', 'Altnau', 'Suisse', 81371, 0, 1),
(2671, 'Raiffeisenbank Regio Altnau', 'Schulstrasse 1', '', '8597', 'Landschlacht', 'Suisse', 81371, 0, 1),
(2672, 'Raiffeisenbank Regio Altnau', 'Sommeristrasse 3', '', '8594', 'Güttingen', 'Suisse', 81371, 0, 1),
(2673, 'Raiffeisenbank Regio Altnau', 'Bahnhofstrasse 6', '', '8574', 'Lengwil', 'Suisse', 81371, 0, 1),
(2674, 'Raiffeisenbank Regio Altnau', 'Herrenhof', '', '8585', 'Langrickenbach', 'Suisse', 81371, 0, 1),
(2675, 'Raiffeisenbank Regio Altnau', 'Hauptstrasse 4', '', '8598', 'Bottighofen', 'Suisse', 81371, 0, 1),
(2676, 'Raiffeisenbank Amriswil-Dozwil-Sommeri', 'Kirchstrasse 13', '', '8580', 'Amriswil', 'Suisse', 81373, 0, 1),
(2677, 'Raiffeisenbank Aadorf', 'Gemeindeplatz 3', '', '8355', 'Aadorf', 'Suisse', 81377, 0, 1),
(2678, 'Raiffeisenbank Aadorf', 'Obergasse 1', '', '8353', 'Elgg', 'Suisse', 81377, 0, 1),
(2679, 'Raiffeisenbank Aadorf', 'Dorfstrasse 47', '', '8542', 'Wiesendangen', 'Suisse', 81377, 0, 1),
(2680, 'Raiffeisenbank am Bichelsee', 'Tösstalstrasse 64', '', '8488', 'Turbenthal', 'Suisse', 81378, 0, 1),
(2681, 'Raiffeisenbank am Bichelsee', 'Hauptstrasse 10', '', '8363', 'Bichelsee', 'Suisse', 81378, 0, 1),
(2682, 'Raiffeisenbank am Bichelsee', 'Bahnhofstrasse 34a', '', '8360', 'Eschlikon TG', 'Suisse', 81378, 0, 1),
(2683, 'Raiffeisenbank Berg-Erlen', 'Hauptstrasse 51', '', '8572', 'Berg TG', 'Suisse', 81379, 0, 1),
(2684, 'Raiffeisenbank Berg-Erlen', 'Bahnhofstrasse 17', '', '8586', 'Erlen', 'Suisse', 81379, 0, 1),
(2685, 'Raiffeisenbank Mittelthurgau', 'Bahnhofstrasse 12', 'Postfach 233', '8570', 'Weinfelden', 'Suisse', 81380, 0, 1),
(2686, 'Raiffeisenbank Mittelthurgau', 'Weinfelderstrasse 9', '', '8575', 'Bürglen TG', 'Suisse', 81380, 0, 1),
(2687, 'Raiffeisenbank Mittelthurgau', 'Bahnhofstrasse 16', '', '8583', 'Sulgen', 'Suisse', 81380, 0, 1),
(2688, 'Raiffeisenbank Mittelthurgau', 'Buhwilerstrasse 2', '', '8577', 'Schönholzerswilen', 'Suisse', 81380, 0, 1),
(2689, 'Raiffeisenbank Dussnang-Fischingen', 'Sonnenhofstrasse 4', 'Postfach 27', '8374', 'Dussnang', 'Suisse', 81381, 0, 1),
(2690, 'Raiffeisenbank Untersee-Rhein', 'Frauenfelderstrasse ', 'Postfach', '8264', 'Eschenz', 'Suisse', 81382, 0, 1),
(2691, 'Raiffeisenbank Untersee-Rhein', 'Seestrasse 129', '', '8266', 'Steckborn', 'Suisse', 81382, 0, 1),
(2692, 'Raiffeisenbank Untersee-Rhein', 'Bahnhofstrasse 30', '', '8253', 'Diessenhofen', 'Suisse', 81382, 0, 1),
(2693, 'Raiffeisenbank Frauenfeld', 'Zürcherstrasse 162', 'Postfach', '8501', 'Frauenfeld', 'Suisse', 81384, 0, 1),
(2694, 'Raiffeisenbank Neukirch-Romanshorn', 'Amriswilerstrasse 2a', 'Postfach 71', '9315', 'Neukirch (Egnach)', 'Suisse', 81398, 0, 1),
(2695, 'Raiffeisenbank Neukirch-Romanshorn', 'Alleestrasse 31', '', '8590', 'Romanshorn', 'Suisse', 81398, 0, 1),
(2696, 'Raiffeisenbank Seerücken', 'Hauptstrasse 35', 'Postfach 11', '8505', 'Pfyn', 'Suisse', 81401, 0, 1),
(2697, 'Raiffeisenbank Seerücken', 'Frauenfelderstrasse ', '', '8535', 'Herdern', 'Suisse', 81401, 0, 1),
(2698, 'Raiffeisenbank Seerücken', 'Metzgergasse 2', '', '8555', 'Müllheim Dorf', 'Suisse', 81401, 0, 1),
(2699, 'Raiffeisenbank Rickenbach-Wilen', 'Wilenstr. 23', '', '9532', 'Rickenbach b. Wil', 'Suisse', 81402, 0, 1),
(2700, 'Raiffeisenbank Sirnach', 'Wilerstrasse 4', 'Postfach', '8370', 'Sirnach', 'Suisse', 81409, 0, 1),
(2701, 'Raiffeisenbank Sulgen', 'Bahnhofstrasse 16', 'Postfach 60', '8583', 'Sulgen', 'Suisse', 81411, 0, 1),
(2702, 'Raiffeisenbank Tägerwilen', 'Hauptstrasse 67', '', '8274', 'Tägerwilen', 'Suisse', 81412, 0, 1),
(2703, 'Raiffeisenbank Tägerwilen', 'Hauptstrasse 122', '', '8272', 'Ermatingen', 'Suisse', 81412, 0, 1),
(2704, 'Raiffeisenbank Tägerwilen', 'Hauptstrasse 53', '', '8280', 'Kreuzlingen', 'Suisse', 81412, 0, 1),
(2705, 'Raiffeisenbank Tägerwilen', 'Postweg 1', '', '8573', 'Siegershausen', 'Suisse', 81412, 0, 1),
(2706, 'Raiffeisenbank Tägerwilen', 'Dorfzentrum', '', '8564', 'Hefenhausen', 'Suisse', 81412, 0, 1),
(2707, 'Raiffeisenbank Münchwilen-Tobel', 'Hauptstrasse 10', 'Postfach', '9555', 'Tobel', 'Suisse', 81414, 0, 1),
(2708, 'Raiffeisenbank Münchwilen-Tobel', 'Eschlikonerstrasse 2', '', '9542', 'Münchwilen TG', 'Suisse', 81414, 0, 1),
(2709, 'Raiffeisenbank Wängi-Matzingen', 'Aadorferstrasse 1', 'Postfach 19', '9545', 'Wängi', 'Suisse', 81416, 0, 1),
(2710, 'Raiffeisenbank Wängi-Matzingen', 'Stettfurterstrasse 9', '', '9548', 'Matzingen', 'Suisse', 81416, 0, 1),
(2711, 'Raiffeisenbank Zihlschlacht-Muolen-Bischofszell', 'Schützengütlistrasse', '', '9220', 'Bischofszell', 'Suisse', 81417, 0, 1),
(2712, 'Raiffeisenbank Zihlschlacht-Muolen-Bischofszell', 'Bernhauserstrasse 5', '', '8588', 'Zihlschlacht', 'Suisse', 81417, 0, 1),
(2713, 'Raiffeisenbank Zihlschlacht-Muolen-Bischofszell', 'Dorfstrasse 30', '', '9313', 'Muolen', 'Suisse', 81417, 0, 1),
(2714, 'Raiffeisenbank Urner Unterland', 'Lehnplatz 20', 'Postfach 855', '6460', 'Altdorf UR', 'Suisse', 81431, 0, 1),
(2715, 'Raiffeisenbank Urner Unterland', 'Adlergartenstrasse 1', '', '6467', 'Schattdorf', 'Suisse', 81431, 0, 1),
(2716, 'Raiffeisenbank Schächental', 'Klausenstrasse 146', 'Postfach 154', '6463', 'Bürglen UR', 'Suisse', 81432, 0, 1),
(2717, 'Raiffeisenbank Urner Oberland', 'Gotthardstrasse 105', 'Postfach 228', '6472', 'Erstfeld', 'Suisse', 81433, 0, 1),
(2718, 'Raiffeisenbank Urner Oberland', 'Gotthardstrasse 51', '', '6490', 'Andermatt', 'Suisse', 81433, 0, 1),
(2719, 'Raiffeisenbank Steinhausen', 'Bahnhofstrasse 1', 'Postfach 425', '6312', 'Steinhausen', 'Suisse', 81452, 0, 1),
(2720, 'Raiffeisenbank Zug', 'Rathausstrasse 10', 'Postfach 1656', '6341', 'Baar', 'Suisse', 81454, 0, 1),
(2721, 'Raiffeisenbank Zug', 'Dorfstrasse 7', 'Postfach 86', '6318', 'Walchwil', 'Suisse', 81454, 0, 1),
(2722, 'Raiffeisenbank Zug', 'Bahnhofstrasse 7', '', '6301', 'Zug', 'Suisse', 81454, 0, 1),
(2723, 'Raiffeisenbank Cham-Steinhausen', 'Schulhausstrasse 8', 'Postfach 765', '6330', 'Cham', 'Suisse', 81455, 0, 1),
(2724, 'Raiffeisenbank Cham-Steinhausen', 'Bahnhofstrasse 19', '', '8932', 'Mettmenstetten', 'Suisse', 81455, 0, 1),
(2725, 'Raiffeisenbank Cham-Steinhausen', 'Ebertswilerstrasse 2', '', '8915', 'Hausen am Albis', 'Suisse', 81455, 0, 1),
(2726, 'Raiffeisenbank Cham-Steinhausen', 'Bahnhofstrasse 1', 'Postfach 425', '6312', 'Steinhausen', 'Suisse', 81455, 0, 1),
(2727, 'Raiffeisenbank Hünenberg', 'Chamerstr. 15', 'Postfach 542', '6331', 'Hünenberg', 'Suisse', 81456, 0, 1),
(2728, 'Raiffeisenbank Menzingen-Neuheim', 'Neudorfstrasse 4', 'Postfach 361', '6313', 'Menzingen', 'Suisse', 81457, 0, 1),
(2729, 'Raiffeisenbank Menzingen-Neuheim', 'Poststrasse 4', '', '6345', 'Neuheim', 'Suisse', 81457, 0, 1),
(2730, 'Raiffeisenbank Region Ägerital-Sattel', 'Zugerstrasse 24', '', '6314', 'Unterägeri', 'Suisse', 81459, 0, 1),
(2731, 'Raiffeisenbank Region Ägerital-Sattel', 'Hauptsrasse 42', '', '6315', 'Oberägeri', 'Suisse', 81459, 0, 1),
(2732, 'Raiffeisenbank Region Ägerital-Sattel', 'Dorfstrasse 18', '', '6417', 'Sattel', 'Suisse', 81459, 0, 1),
(2733, 'Raiffeisenbank Risch-Rotkreuz', 'Luzernerstrasse 2', '', '6343', 'Rotkreuz', 'Suisse', 81460, 0, 1),
(2734, 'Raiffeisenbank Unterägeri', 'Zugerstrasse 24', 'Postfach 463', '6314', 'Unterägeri', 'Suisse', 81461, 0, 1),
(2735, 'Raiffeisenbank Zürcher Oberland', 'Bahnhofstrasse 2', 'Postfach 1323', '8610', 'Uster', 'Suisse', 81471, 0, 1),
(2736, 'Raiffeisenbank Zürcher Oberland', 'Bahnhofstrasse 143', '', '8620', 'Wetzikon ZH', 'Suisse', 81471, 0, 1),
(2737, 'Raiffeisenbank Zürcher Oberland', 'Grütstrasse 51', 'Postfach', '8625', 'Gossau ZH', 'Suisse', 81471, 0, 1),
(2738, 'Raiffeisenbank Zürcher Oberland', 'Bahnhofstrasse 7', '', '8330', 'Pfäffikon ZH', 'Suisse', 81471, 0, 1),
(2739, 'Raiffeisenbank Guntalingen-Neunforn', 'Dorfstr. 32', '', '8468', 'Guntalingen', 'Suisse', 81472, 0, 1),
(2740, 'Raiffeisenbank Zürich Flughafen', 'Schaffhauserstrasse ', '', '8302', 'Kloten', 'Suisse', 81474, 0, 1),
(2741, 'Raiffeisenbank Zürich Flughafen', 'Wallisellenstrasse 7', '', '8600', 'Dübendorf', 'Suisse', 81474, 0, 1),
(2742, 'Raiffeisenbank Zürich Flughafen', 'Dorfstrasse 76', '', '8424', 'Embrach', 'Suisse', 81474, 0, 1),
(2743, 'Raiffeisenbank Zürich Flughafen', 'Industriestrasse 16a', '', '8604', 'Volketswil', 'Suisse', 81474, 0, 1),
(2744, 'Raiffeisenbank Züri-Unterland', 'Marktgasse 7', 'Postfach 269', '8180', 'Bülach', 'Suisse', 81475, 0, 1),
(2745, 'Raiffeisenbank Züri-Unterland', 'Riedpark', 'Zürcherstrasse 17', '8173', 'Neerach', 'Suisse', 81475, 0, 1),
(2746, 'Raiffeisenbank Züri-Unterland', 'Watterstrasse 31', '', '8105', 'Regensdorf', 'Suisse', 81475, 0, 1),
(2747, 'Raiffeisenbank Züri-Unterland', 'Obergass 3', '', '8193', 'Eglisau', 'Suisse', 81475, 0, 1),
(2748, 'Raiffeisenbank Oberembrach-Bassersdorf', 'Jakob-Bosshart-Stras', 'Postfach 23', '8425', 'Oberembrach', 'Suisse', 81477, 0, 1),
(2749, 'Raiffeisenbank Oberembrach-Bassersdorf', 'Klotenerstrasse 20', '', '8303', 'Bassersdorf', 'Suisse', 81477, 0, 1),
(2750, 'Raiffeisenbank Oberembrach-Bassersdorf', 'Bahnhofstrasse 1', '', '8304', 'Wallisellen', 'Suisse', 81477, 0, 1),
(2751, 'Raiffeisenbank Oberembrach-Bassersdorf', 'Rikonerstrasse 15', '', '8307', 'Effretikon', 'Suisse', 81477, 0, 1),
(2752, 'Raiffeisenbank Weinland', 'Thurtalstrasse 4', '', '8450', 'Andelfingen', 'Suisse', 81479, 0, 1),
(2753, 'Raiffeisenbank Weinland', 'Mettschlatterstrasse', '', '8252', 'Schlatt TG', 'Suisse', 81479, 0, 1),
(2754, 'Raiffeisenbank Weinland', 'Ochsengasse 1', '', '8462', 'Rheinau', 'Suisse', 81479, 0, 1),
(2755, 'Raiffeisenbank Weinland', 'Dorfstrasse 32', '', '8468', 'Guntalingen', 'Suisse', 81479, 0, 1),
(2756, 'Raiffeisenbank Weinland', 'Hauptstrasse', '', '8526', 'Oberneunforn', 'Suisse', 81479, 0, 1),
(2757, 'Raiffeisenbank rechter Zürichsee', 'Bahnhofstrasse 20', 'Postfach', '8708', 'Männedorf', 'Suisse', 81481, 0, 1),
(2758, 'Raiffeisenbank rechter Zürichsee', 'Dorfstrasse 18', '', '8700', 'Küsnacht', 'Suisse', 81481, 0, 1),
(2759, 'Raiffeisenbank rechter Zürichsee', 'Dorfstrasse 110', '', '8706', 'Meilen', 'Suisse', 81481, 0, 1),
(2760, 'Raiffeisenbank rechter Zürichsee', 'Bahnhofstrasse 30', '', '8712', 'Stäfa', 'Suisse', 81481, 0, 1),
(2761, 'Raiffeisenbank rechter Zürichsee', 'Bergstrasse 15', '', '8702', 'Zollikon', 'Suisse', 81481, 0, 1),
(2762, 'Raiffeisen Schweiz, Zweigniederlassung Winterthur', 'Bahnhofplatz 15', 'Postfach 2235', '8401', 'Winterthur', 'Suisse', 81485, 0, 1),
(2763, 'Raiffeisen Schweiz, Zweigniederlassung Winterthur', 'Stationsstrasse 24', '', '8472', 'Seuzach', 'Suisse', 81485, 0, 1),
(2764, 'Raiffeisen Schweiz, Niederlassung Basel', 'St. Jakobstrasse 7', 'Postfach', '4002', 'Basel', 'Suisse', 81486, 0, 1),
(2765, 'Raiffeisen Schweiz, Niederlassung Basel', 'Baselstrasse 56', '', '4125', 'Riehen', 'Suisse', 81486, 0, 1),
(2766, 'Raiffeisen Schweiz, Niederlassung Zürich', 'Limmatquai 68', 'Postfach', '8022', 'Zürich', 'Suisse', 81487, 0, 1),
(2767, 'Raiffeisen Schweiz, Niederlassung Zürich', 'Schaffhauserstrasse ', '', '8050', 'Zürich', 'Suisse', 81487, 0, 1),
(2768, 'Raiffeisen Schweiz, Niederlassung Zürich', 'Albisstrasse 39', '', '8038', 'Zürich', 'Suisse', 81487, 0, 1),
(2769, 'Raiffeisen Schweiz, Niederlassung Zürich', 'Birmensdorferstrasse', '', '8003', 'Zürich', 'Suisse', 81487, 0, 1),
(2770, 'Raiffeisen Schweiz, Niederlassung Zürich', 'Kreuzplatz, Zeltweg ', '', '8032', 'Zürich', 'Suisse', 81487, 0, 1),
(2771, 'Raiffeisen Schweiz, Niederlassung Zürich', 'Limmatalstrasse 181', '', '8049', 'Zürich', 'Suisse', 81487, 0, 1),
(2772, 'Raiffeisen Schweiz, Niederlassung Bern', 'Waisenhausplatz 26', '', '3011', 'Bern', 'Suisse', 81488, 0, 1),
(2773, 'Raiffeisen Schweiz, Niederlassung Bern', 'Brünnenstrasse 123', '', '3018', 'Bern', 'Suisse', 81488, 0, 1),
(2774, 'Raiffeisen Schweiz, Niederlassung Bern', 'Thunstrasse 72', '', '3074', 'Muri b. Bern', 'Suisse', 81488, 0, 1),
(2775, 'Raiffeisen Schweiz, Zweigniederlassung Thalwil', 'Gotthardstrasse 20/2', 'Postfach', '8800', 'Thalwil', 'Suisse', 81490, 0, 1),
(2776, 'Raiffeisen Schweiz, Zweigniederlassung Thalwil', 'Bahnhofplatz 1', 'Postfach 378', '8134', 'Adliswil', 'Suisse', 81490, 0, 1),
(2777, 'RAIFFEISEN SCHWEIZ, FIRMENKUNDEN', 'Raiffeisenplatz 4', '', '9001', 'St. Gallen', 'Suisse', 81491, 0, 1),
(2778, 'NORDEA BANK S.A. LUXEMBOURG', '562, rue de Neudorf', '', '2220', 'Luxembourg', 'Suisse', 82004, 0, 1),
(2779, 'Bank, Hapoalim (Switzerland) Ltd.', '7, rue de la Chapell', '', '1325', 'Luxembourg', 'Suisse', 82006, 0, 1),
(2780, 'Union Bancaire Privée (Europe) SA', '287-289 route d&apos', '', '1150', 'Luxembourg', 'Suisse', 82007, 0, 1),
(2781, 'Mirabaud &amp; Cie (Europe) SA', '25, avenue de la Lib', '', '1931', 'Luxembourg', 'Suisse', 82008, 0, 1),
(2782, 'Banco Santander (Suisse) SA', 'Rue Ami-Lévrier 5-7', 'Case postale 1256', '1211', 'Genève 1', 'Suisse', 8235, 0, 1),
(2783, 'Credit Europe Bank (Suisse SA', 'Rue du Mont-Blanc 12', 'Case postale 1449', '1211', 'Genève 1', 'Suisse', 8236, 0, 1);
INSERT INTO `faturacao_bancos_fornecedores` (`ID_BancoFornecedor`, `Nome`, `Address1`, `Address2`, `NPA`, `Localite`, `PaisBanco`, `BCNbr`, `Predefinido`, `Ativo`) VALUES
(2784, 'BANQUE PRIVEE BCP (SUISSE) SA', 'Place du Molard 4', 'Case postale 3126', '1211', 'Genève 3', 'Suisse', 8237, 0, 1),
(2785, 'Investec Bank (Switzerland) AG', 'Löwenstrasse 29', 'Postfach', '8022', 'Zürich', 'Suisse', 8238, 0, 1),
(2786, 'Banca Intermobiliare di Investimenti e Gestioni (Suisse) SA', 'Contrada di Sasselo ', 'Casella postale 5835', '6901', 'Lugano', 'Suisse', 8239, 0, 1),
(2787, 'Fibi Bank (Schweiz) AG', 'Seestrasse 61', 'Postfach', '8027', 'Zürich', 'Suisse', 8242, 0, 1),
(2788, 'Crédit Agricole Financements (Suisse) SA', 'Rue du Rhône 67', '', '1207', 'Genève', 'Suisse', 8243, 0, 1),
(2789, 'Mourgue d&apos;Algue &amp; Cie', '5, rue de la Fontain', 'Case postale 3485', '1211', 'Genève 3', 'Suisse', 8244, 0, 1),
(2790, 'P, ANLAGE &amp; PRIVATBANK AG', 'Limmatquai 4', '', '8001', 'Zürich', 'Suisse', 8245, 0, 1),
(2791, 'S, Banque SA', '9, chemin des Mines', 'Case postale 3', '1211', 'Genève 21', 'Suisse', 8246, 0, 1),
(2792, '., van Lanschot Bankiers (Schweiz) AG', 'Mittelstrasse 10', 'Postfach 365', '8034', 'Zürich', 'Suisse', 8248, 0, 1),
(2793, 'Banca Popolare di Sondrio (Suisse) SA', 'Casella postale 5832', '', '6901', 'Lugano 1', 'Suisse', 8252, 0, 1),
(2794, 'Volksbank AG', 'Hauptstrasse 111', 'Postfach 850', '9430', 'St. Margrethen SG', 'Suisse', 8255, 0, 1),
(2795, 'Volksbank AG', 'Adlerstrasse 35', 'Postfach 517', '4020', 'Basel', 'Suisse', 8255, 0, 1),
(2796, 'FINTER BANK ZUERICH AG', 'Claridenstrasse 35', 'Postfach 2299', '8022', 'Zürich', 'Suisse', 8256, 0, 1),
(2797, 'Falcon Private Bank AG', 'Pelikanstrasse 37', 'Postfach 1376', '8021', 'Zürich', 'Suisse', 8260, 0, 1),
(2798, 'BL, (SWITZERLAND) Ltd', 'Bd Georges-Favon 7', 'Case postale', '1211', 'Genève 11', 'Suisse', 8261, 0, 1),
(2799, 'Deutsche Bank (Schweiz) AG, ex Bank Sal. Oppenheim (Schweiz)', 'Postfach', '', '8022', 'Zürich', 'Suisse', 8263, 0, 1),
(2800, 'Banque Internationale à Luxembourg (Suisse) SA', 'Beethovenstrasse 48', 'Postfach 2192', '8022', 'Zürich', 'Suisse', 8268, 0, 1),
(2801, 'BBVA (Suiza) SA', 'Zeltweg 63', 'Postfach 3930', '8021', 'Zürich', 'Suisse', 8270, 0, 1),
(2802, 'Goldman Sachs Bank AG', 'Claridenstrasse 22', 'Postfach', '8022', 'Zürich', 'Suisse', 8278, 0, 1),
(2803, 'Bank Hapoalim (Schweiz) AG', 'Stockerstrasse 33', 'Postfach 1801', '8027', 'Zürich', 'Suisse', 8281, 0, 1),
(2804, 'Bank Hapoalim (Switzerland) Ltd.', 'Quai du Mont-Blanc 5', 'Case postale 1683', '1211', 'Genève 1', 'Suisse', 8281, 0, 1),
(2805, 'KB, Privatbank Zürich AG', 'Bleicherweg 20', 'Postfach', '8022', 'Zürich', 'Suisse', 8283, 0, 1),
(2806, 'Sallfort Privatbank AG', 'Bellerivestrasse 241', 'Postfach', '8034', 'Zürich', 'Suisse', 8285, 0, 1),
(2807, 'Frankfurter Bankgesellschaft (Schweiz) AG', 'Börsenstrasse 16', 'Postfach', '8022', 'Zürich', 'Suisse', 8288, 0, 1),
(2808, 'HF-BANK (Schweiz) AG', 'Schulhausstrasse 6', 'Postfach', '8027', 'Zürich', 'Suisse', 8289, 0, 1),
(2809, 'Cembra Money Bank AG', 'Bändliweg 20', '', '8048', 'Zürich', 'Suisse', 8296, 0, 1),
(2810, 'Cembra Money Bank SA', 'Rue de la Banque 1', 'Case postale', '1701', 'Fribourg', 'Suisse', 82961, 0, 1),
(2811, 'Cembra Money Bank SA', 'Rue du Cendrier 17', 'Case postale', '1201', 'Genève', 'Suisse', 82962, 0, 1),
(2812, 'Cembra Money Bank AG', 'Freie Strasse 39', 'Postfach', '4001', 'Basel', 'Suisse', 82963, 0, 1),
(2813, 'Cembra Money Bank AG', 'Oberer Graben 3', 'Postfach', '9004', 'St. Gallen', 'Suisse', 82964, 0, 1),
(2814, 'Cembra Money Bank AG', 'Bahnhofstrasse 8', 'Postfach', '5001', 'Aarau', 'Suisse', 82965, 0, 1),
(2815, 'Cembra Money Bank AG', 'Schwanengasse 1', 'Postfach', '3001', 'Bern', 'Suisse', 82966, 0, 1),
(2816, 'Cembra Money Bank AG', 'Weggisgasse 1 / Falk', 'Postfach', '6000', 'Luzern 5', 'Suisse', 82967, 0, 1),
(2817, 'Cembra Money Bank SA', 'Avenue Ruchonnet 1', 'Case postale', '1003', 'Lausanne', 'Suisse', 82968, 0, 1),
(2818, 'Cembra Money Bank SA', 'Faubourg de l&apos;H', 'Case postale', '2001', 'Neuchâtel', 'Suisse', 82969, 0, 1),
(2819, 'Cembra Money Bank AG', 'Dufourstrasse 12', 'Postfach', '2500', 'Biel/Bienne 3', 'Suisse', 82971, 0, 1),
(2820, 'Cembra Money Bank SA', 'Avenue Léopold-Rober', 'Case postale', '2301', 'Chaux-de-Fonds, La', 'Suisse', 82972, 0, 1),
(2821, 'Cembra Money Bank AG', 'Hauptbahnhofstrasse ', 'Postfach', '4501', 'Solothurn', 'Suisse', 82973, 0, 1),
(2822, 'Cembra Money Bank SA', 'Via E. Bossi 1', 'Casella postale', '6901', 'Lugano', 'Suisse', 82975, 0, 1),
(2823, 'Cembra Money Bank SA', 'Avenue des Mayennets', 'Case postale', '1951', 'Sion/Sitten', 'Suisse', 82976, 0, 1),
(2824, 'Cembra Money Bank AG', 'Schmidgasse 7', 'Postfach', '8401', 'Winterthur', 'Suisse', 82977, 0, 1),
(2825, 'Cembra Money Bank AG', 'Bahnhofstrasse 14', 'Postfach', '5401', 'Baden', 'Suisse', 82979, 0, 1),
(2826, 'Cembra Money Bank AG', 'Jurastrasse 19', 'Postfach', '4601', 'Olten', 'Suisse', 82981, 0, 1),
(2827, 'Cembra Money Bank AG', 'Schaffhauserstrasse ', 'Postfach 8218', '8050', 'Zürich', 'Suisse', 82983, 0, 1),
(2828, 'Cembra Money Bank AG', 'Alexanderstrasse 18', 'Postfach 351', '7001', 'Chur', 'Suisse', 82984, 0, 1),
(2829, 'Cembra Money Bank SA', 'Rue Igor Stravinsky ', 'Case postale 103', '1820', 'Montreux 2', 'Suisse', 82986, 0, 1),
(2830, 'Cembra Money Bank AG', 'Bändliweg 20', '', '8048', 'Zürich', 'Suisse', 82998, 0, 1),
(2831, 'Spar- und Leihkasse Wynigen AG', 'Postfach 180', '', '3472', 'Wynigen', 'Suisse', 8300, 0, 1),
(2832, 'Spar- und Leihkasse Wynigen AG', 'Postfach', '', '3473', 'Alchenstorf', 'Suisse', 8300, 0, 1),
(2833, 'Spar- und Leihkasse Wynigen AG', 'Postfach', '', '3423', 'Ersigen', 'Suisse', 8300, 0, 1),
(2834, 'Spar- und Leihkasse Wynigen AG', 'Postfach', '', '3412', 'Heimiswil', 'Suisse', 8300, 0, 1),
(2835, 'Spar- und Leihkasse Wynigen AG', 'Postfach', '', '3367', 'Ochlenberg', 'Suisse', 8300, 0, 1),
(2836, 'Mitsubishi UFJ Wealth Management Bank (Switzerland), Ltd.', '67 rue du Rhone', '', '1207', 'Genève', 'Suisse', 83001, 0, 1),
(2837, 'Bank, von Roll AG', 'Bleicherweg 37', '', '8027', 'Zürich', 'Suisse', 83002, 0, 1),
(2838, 'IX, x-clear AG', 'Brandschenkestrasse ', 'Postfach 1758', '8021', 'Zürich', 'Suisse', 83003, 0, 1),
(2839, 'Hypothekarbank Lenzburg AG', 'Bahnhofstrasse 2', 'Postfach', '5600', 'Lenzburg 1', 'Suisse', 8307, 0, 1),
(2840, 'Hypothekarbank Lenzburg AG', 'Kreuzplatz', 'Postfach', '5103', 'Wildegg', 'Suisse', 8307, 0, 1),
(2841, 'Hypothekarbank Lenzburg AG', 'Bahnhofstrasse 20', 'Postfach', '5605', 'Dottikon', 'Suisse', 8307, 0, 1),
(2842, 'Hypothekarbank Lenzburg AG', 'Hauptstrasse 9', 'Postfach', '5502', 'Hunzenschwil', 'Suisse', 8307, 0, 1),
(2843, 'Hypothekarbank Lenzburg AG', 'Augustin Keller-Stra', 'Postfach', '5600', 'Lenzburg', 'Suisse', 8307, 0, 1),
(2844, 'Hypothekarbank Lenzburg AG', 'Hauptstrasse 37', 'Postfach', '5616', 'Meisterschwanden', 'Suisse', 8307, 0, 1),
(2845, 'Hypothekarbank Lenzburg AG', 'Lenzburgerstr. 15', 'Postfach', '5507', 'Mellingen', 'Suisse', 8307, 0, 1),
(2846, 'Hypothekarbank Lenzburg AG', 'Hauptstrasse 16', 'Postfach', '5702', 'Niederlenz', 'Suisse', 8307, 0, 1),
(2847, 'Hypothekarbank Lenzburg AG', 'Zentrum 1', 'Postfach', '5452', 'Oberrohrdorf', 'Suisse', 8307, 0, 1),
(2848, 'Hypothekarbank Lenzburg AG', 'Mitteldorf 2', 'Postfach', '5102', 'Rupperswil', 'Suisse', 8307, 0, 1),
(2849, 'Hypothekarbank Lenzburg AG', 'Seetalstrasse 47', 'Postfach', '5703', 'Seon', 'Suisse', 8307, 0, 1),
(2850, 'Hypothekarbank Lenzburg AG', 'Postweg 1', 'Postfach', '5034', 'Suhr', 'Suisse', 8307, 0, 1),
(2851, 'Hypothekarbank Lenzburg AG', 'Hauptstrasse 40a', 'Postfach', '5737', 'Menziken', 'Suisse', 8307, 0, 1),
(2852, 'Banque SYZ SA', '30, rue du Rhône', 'Case postale 5015', '1211', 'Genève 11', 'Suisse', 8309, 0, 1),
(2853, 'Caisse d&apos;Epargne de Nyon société coopérative', 'Rue St-Jean 11', 'Case postale', '1260', 'Nyon', 'Suisse', 8326, 0, 1),
(2854, 'Caisse d&apos;Epargne d&apos;Aubonne Sociéte coopérative', 'Rue de l&apos;Hôtel-', 'Case postale 56', '1170', 'Aubonne', 'Suisse', 8327, 0, 1),
(2855, 'Ersparniskasse Speicher', 'Hauptstrasse 21', '', '9042', 'Speicher', 'Suisse', 8329, 0, 1),
(2856, 'Baloise Bank SoBa AG', 'Amthausplatz 4', '', '4500', 'Solothurn', 'Suisse', 8334, 0, 1),
(2857, 'Baloise Bank SoBa AG', 'Herrengasse 10', '', '4710', 'Balsthal', 'Suisse', 8334, 0, 1),
(2858, 'Baloise Bank SoBa AG', 'Dorfstrasse 41', '', '2544', 'Bettlach', 'Suisse', 8334, 0, 1),
(2859, 'Baloise Bank SoBa AG', 'Hauptstrasse 24', '', '4562', 'Biberist', 'Suisse', 8334, 0, 1),
(2860, 'Baloise Bank SoBa AG', 'Passwangstrasse 27', '', '4226', 'Breitenbach', 'Suisse', 8334, 0, 1),
(2861, 'Baloise Bank SoBa AG', 'Solothurnstrasse 8', '', '4573', 'Lohn-Ammannsegg SO', 'Suisse', 8334, 0, 1),
(2862, 'Baloise Bank SoBa AG', 'Bienkenstrasse 22', '', '4702', 'Oensingen', 'Suisse', 8334, 0, 1),
(2863, 'Baloise Bank SoBa AG', 'Froburgstrasse 4', '', '4600', 'Olten', 'Suisse', 8334, 0, 1),
(2864, 'Baloise Bank SoBa AG', 'Gösgerstrasse 2', '', '5012', 'Schönenwerd', 'Suisse', 8334, 0, 1),
(2865, 'Baloise Bank SoBa AG', 'Steinmattstrasse 26', '', '4552', 'Derendingen', 'Suisse', 8334, 0, 1),
(2866, 'Baloise Bank SoBa AG', 'Amthausstrasse', '', '4143', 'Dornach', 'Suisse', 8334, 0, 1),
(2867, 'Baloise Bank SoBa AG', 'Centralstrasse 8', '', '2540', 'Grenchen', 'Suisse', 8334, 0, 1),
(2868, 'Baloise Bank SoBa AG', 'Hauptstrasse 60', '', '4566', 'Kriegstetten', 'Suisse', 8334, 0, 1),
(2869, 'Baloise Bank SoBa AG', 'Bitziusstrasse 15', '', '3360', 'Herzogenbuchsee', 'Suisse', 8334, 0, 1),
(2870, 'Baloise Bank SoBa AG', 'Aeschengraben 25', '', '4002', 'Basel', 'Suisse', 8334, 0, 1),
(2871, 'Baloise Bank SoBa AG', 'Förrlibuckstrasse 10', '', '8037', 'Zürich', 'Suisse', 8334, 0, 1),
(2872, 'Baloise Bank SoBa AG', 'Spitalgasse 35', '', '3011', 'Bern', 'Suisse', 8334, 0, 1),
(2873, 'Baloise Bank SoBa AG', 'Rue Pichard 13', '', '1002', 'Lausanne', 'Suisse', 8334, 0, 1),
(2874, 'GT, Bank (Schweiz) AG', 'Lange Gasse 15', 'Postfach', '4002', 'Basel', 'Suisse', 8335, 0, 1),
(2875, 'GT, Bank (Schweiz) AG', 'Spitalgasse 2', '', '3011', 'Bern', 'Suisse', 8335, 0, 1),
(2876, 'GT, Bank (Schweiz) AG', 'Piazza A. Manzoni 2a', '', '6901', 'Lugano', 'Suisse', 8335, 0, 1),
(2877, 'GT, Bank (Schweiz) AG', 'Glärnischstrasse 36', '', '8027', 'Zürich', 'Suisse', 8335, 0, 1),
(2878, 'GT, Bank (Schweiz) AG', 'Rue du Rhône 21', '', '1204', 'Genève', 'Suisse', 8335, 0, 1),
(2879, 'Banque Algérienne du Commerce Extérieur SA', 'Talacker 41', 'Postfach 7484', '8023', 'Zürich', 'Suisse', 8346, 0, 1),
(2880, 'Spar- und Leihkasse Leuk und Umgebung Genossenschaft', 'Rathausplatz 4', '', '3953', 'Leuk Stadt', 'Suisse', 8347, 0, 1),
(2881, 'Caisse d&apos;Epargne et de Crédit Mutuel de Chermignon', 'Case postale 14', '', '3971', 'Chermignon', 'Suisse', 8348, 0, 1),
(2882, 'Caisse d&apos;Epargne Riviera, société coopérative', 'Avenue Paul-Ceresole', 'Case postale 300', '1800', 'Vevey 1', 'Suisse', 8349, 0, 1),
(2883, 'SecurePost AG', 'Nordringstrasse 22', '', '4702', 'Oensingen', 'Suisse', 8350, 0, 1),
(2884, 'OS, Surveillance SA', 'Route de Tabary 1', '', '1904', 'Vernayaz', 'Suisse', 8351, 0, 1),
(2885, 'Loomis Schweiz SA', 'Peter Merian-Strasse', '', '4052', 'Basel', 'Suisse', 8352, 0, 1),
(2886, 'Loomis Schweiz SA', 'Glattalstrasse 519', '', '8153', 'Rümlang', 'Suisse', 8353, 0, 1),
(2887, 'China Construction Bank Corporation, Beijing, Swiss Branch', 'Beethovenstrasse 33', '', '8002', 'Zürich', 'Suisse', 8373, 0, 1),
(2888, 'CACEIS Bank Luxembourg', 'Route de Signy 35', '', '1260', 'Nyon', 'Suisse', 8374, 0, 1),
(2889, 'Banque Degroof Petercam (Suisse) SA', 'Case postale 1119', '', '1211', 'Genève 5', 'Suisse', 8376, 0, 1),
(2890, 'BS, Swiss Financial Advisers AG', 'Löwenstrasse 49', '', '8098', 'Zürich', 'Suisse', 8377, 0, 1),
(2891, 'PB, Neue Privat Bank AG', 'Limmatquai 1 / am Be', '', '8024', 'Zürich', 'Suisse', 8378, 0, 1),
(2892, 'NB, (Suisse) SA', 'Quai du Mont-Blanc 1', '', '1201', 'Genève', 'Suisse', 8379, 0, 1),
(2893, '.P. Morgan (Suisse) SA', '8, rue de la Confédé', '', '1211', 'Genève 11', 'Suisse', 8380, 0, 1),
(2894, 'Reyl &amp; Cie S.A.', 'Rue du Rhône 62', '', '1204', 'Genève', 'Suisse', 8384, 0, 1),
(2895, 'BK, Banque Privée (Suisse) SA', 'Quai du Mont-Blanc 2', 'Case postale 1923', '1211', 'Genève 1', 'Suisse', 8385, 0, 1),
(2896, 'Swissquote Bank SA', 'Avenue d&apos;Ouchy ', '', '1006', 'Lausanne', 'Suisse', 8386, 0, 1),
(2897, 'NG, Belgique, Bruxelles', '6, rue Jean-Petitot', 'Case postale 5613', '1211', 'Genève 11', 'Suisse', 8387, 0, 1),
(2898, 'Banque Eric Sturdza SA', 'Rue du Rhône 112', 'Case postale 3024', '1211', 'Genève 3', 'Suisse', 8388, 0, 1),
(2899, 'Bezirks-Sparkasse Dielsdorf Genossenschaft', 'Bahnhofstrasse 29', 'Postfach', '8157', 'Dielsdorf', 'Suisse', 8389, 0, 1),
(2900, 'Bezirks-Sparkasse Dielsdorf Genossenschaft', 'Badenerstrasse 2', 'Postfach', '8107', 'Buchs ZH', 'Suisse', 8389, 0, 1),
(2901, 'Bezirks-Sparkasse Dielsdorf Genossenschaft', 'Glattalstrasse 188', 'Postfach', '8153', 'Rümlang', 'Suisse', 8389, 0, 1),
(2902, 'Bezirks-Sparkasse Dielsdorf Genossenschaft', 'Grafschaftstrasse 8', 'Postfach', '8172', 'Niederglatt ZH', 'Suisse', 8389, 0, 1),
(2903, 'Bezirks-Sparkasse Dielsdorf Genossenschaft', 'Dorfstrasse 2', '', '8166', 'Niederweningen', 'Suisse', 8389, 0, 1),
(2904, 'Alternative Bank Schweiz AG', 'Amthausquai 21', 'Postfach', '4601', 'Olten', 'Suisse', 8390, 0, 1),
(2905, 'IR, Bank Genossenschaft', 'Auberg 1', 'Postfach', '4002', 'Basel', 'Suisse', 8391, 0, 1),
(2906, 'IR, Bank Genossenschaft', 'Helvetiastrasse 35', '', '3000', 'Bern 6', 'Suisse', 8391, 0, 1),
(2907, 'IR, Bank Genossenschaft', 'Obergrundstrasse 88', 'Postfach', '6000', 'Luzern 4', 'Suisse', 8391, 0, 1),
(2908, 'IR, Bank Genossenschaft', 'Blumenbergplatz 7', '', '9001', 'St. Gallen', 'Suisse', 8391, 0, 1),
(2909, 'IR, Bank Genossenschaft', 'Rötelstrasse 37', '', '8042', 'Zürich', 'Suisse', 8391, 0, 1),
(2910, 'Banque WIR société coopérative', '3, rue du Simplon', '', '1001', 'Lausanne', 'Suisse', 8391, 0, 1),
(2911, 'Banca WIR società cooperativa', 'Riva Caccia 1', '', '6900', 'Lugano', 'Suisse', 8391, 0, 1),
(2912, 'Freie Gemeinschaftsbank Genossenschaft', 'Gerbergasse 30', 'Postfach', '4001', 'Basel', 'Suisse', 8392, 0, 1),
(2913, 'Bank EKI Genossenschaft', 'Rosenstrasse 1', 'Postfach', '3800', 'Interlaken', 'Suisse', 8393, 0, 1),
(2914, 'Bank EKI Genossenschaft', 'Beim Bahnhof', '', '3818', 'Grindelwald', 'Suisse', 8393, 0, 1),
(2915, 'Bank EKI Genossenschaft', 'Beim Bahnhof', '', '3822', 'Lauterbrunnen', 'Suisse', 8393, 0, 1),
(2916, 'Bank EKI Genossenschaft', 'Bahnhofplatz', '', '3812', 'Wilderswil', 'Suisse', 8393, 0, 1),
(2917, 'Bank EEK AG', 'Amthausgasse 14 / Ma', 'Postfach', '3001', 'Bern', 'Suisse', 8394, 0, 1),
(2918, 'Spar- und Leihkasse Bucheggberg', 'Hauptstrasse 69', 'Postfach', '4584', 'Lüterswil', 'Suisse', 8395, 0, 1),
(2919, 'SPAR + LEIHKASSE GUERBETAL AG', 'Dorfstrasse 19', 'Postfach', '3127', 'Mühlethurnen', 'Suisse', 8396, 0, 1),
(2920, 'C, Bank Deposito-Cassa der Stadt Bern', 'Schauplatzgasse 21', 'Postfach', '3001', 'Bern', 'Suisse', 8397, 0, 1),
(2921, 'Z, Depotbank AG', 'Innere Güterstrasse ', '', '6300', 'Zug', 'Suisse', 8398, 0, 1),
(2922, 'Migros Bank AG', 'Postfach', '', '8010', 'Zürich Mülligen', 'Suisse', 8401, 0, 1),
(2923, 'Migros Bank AG', 'Postfach', '', '5400', 'Baden', 'Suisse', 8401, 0, 1),
(2924, 'Migros Bank AG', 'Postfach', '', '8301', 'Glattzentrum b. Wallisellen', 'Suisse', 8401, 0, 1),
(2925, 'Migros Bank AG', 'Postfach', '', '4600', 'Olten', 'Suisse', 8401, 0, 1),
(2926, 'Migros Bank AG', 'Postfach', '', '6300', 'Zug', 'Suisse', 8401, 0, 1),
(2927, 'Migros Bank AG', 'Altstetten', 'Postfach', '8048', 'Zürich', 'Suisse', 8401, 0, 1),
(2928, 'Migros Bank AG', 'Limmatplatz', 'Postfach', '8031', 'Zürich', 'Suisse', 8401, 0, 1),
(2929, 'Migros Bank AG', 'Oerlikon', 'Postfach', '8050', 'Zürich', 'Suisse', 8401, 0, 1),
(2930, 'Migros Bank AG', 'Stockerstrasse', 'Postfach', '8027', 'Zürich', 'Suisse', 8401, 0, 1),
(2931, 'Migros Bank AG', 'Bahnhofstrasse 12', '', '8180', 'Bülach', 'Suisse', 8401, 0, 1),
(2932, 'Migros Bank AG', 'Zürichstrasse 12a', '', '8610', 'Uster', 'Suisse', 8401, 0, 1),
(2933, 'Migros Bank AG', 'Gotthardstrasse 13', '', '8800', 'Thalwil', 'Suisse', 8401, 0, 1),
(2934, 'Migros Bank AG', 'Bahnhofstrasse 22', '', '5201', 'Brugg', 'Suisse', 8401, 0, 1),
(2935, 'Migros Bank AG', 'Unterer Graben 35', 'Postfach', '8401', 'Winterthur', 'Suisse', 8401, 0, 1),
(2936, 'Migros Bank AG', 'Postfach', '', '8640', 'Rapperswil SG', 'Suisse', 8401, 0, 1),
(2937, 'Migros Bank AG', 'Postfach', '', '8201', 'Schaffhausen', 'Suisse', 8401, 0, 1),
(2938, 'Migros Bank AG', 'Postfach', '', '9500', 'Wil SG 1', 'Suisse', 8401, 0, 1),
(2939, 'Migros Bank AG', 'Bahnhofstrasse 4', 'Postfach', '9001', 'St. Gallen', 'Suisse', 8401, 0, 1),
(2940, 'Migros Bank AG', 'Poststrasse 6', '', '3400', 'Burgdorf', 'Suisse', 8401, 0, 1),
(2941, 'Migros Bank AG', '', '', '7001', 'Chur', 'Suisse', 8401, 0, 1),
(2942, 'Migros Bank AG', 'Zürcherstrasse 148', '', '8500', 'Frauenfeld', 'Suisse', 8401, 0, 1),
(2943, 'Migros Bank AG', 'Postfach', '', '8280', 'Kreuzlingen 1', 'Suisse', 8401, 0, 1),
(2944, 'Migros Bank AG', 'Postfach', '', '8808', 'Pfäffikon SZ', 'Suisse', 8401, 0, 1),
(2945, 'Migros Bank AG', 'Bahnhofstrasse 6', 'Postfach', '6002', 'Luzern', 'Suisse', 8401, 0, 1),
(2946, 'Migros Bank AG', 'Hauptplatz 7', '', '6430', 'Schwyz', 'Suisse', 8401, 0, 1),
(2947, 'Migros Bank AG', 'Bahnhofstrasse 19', '', '6210', 'Sursee', 'Suisse', 8401, 0, 1),
(2948, 'Migros Bank AG', 'Postfach', '', '4051', 'Basel', 'Suisse', 8401, 0, 1),
(2949, 'Migros Bank AG', 'Claraplatz', 'Postfach', '4058', 'Basel', 'Suisse', 8401, 0, 1),
(2950, 'Migros Bank AG', 'Gundelitor', 'Postfach', '4053', 'Basel', 'Suisse', 8401, 0, 1),
(2951, 'Migros Bank AG', 'Hauptstrasse 52', '', '5070', 'Frick', 'Suisse', 8401, 0, 1),
(2952, 'Migros Bank AG', 'Postfach', '', '4410', 'Liestal', 'Suisse', 8401, 0, 1),
(2953, 'Migros Bank AG', 'Hauptstrasse 15', '', '4153', 'Reinach BL', 'Suisse', 8401, 0, 1),
(2954, 'Migros Bank AG', 'Rössligasse 20', '', '4125', 'Riehen', 'Suisse', 8401, 0, 1),
(2955, 'Migros Bank AG', 'Vordere Hauptgasse 6', '', '4800', 'Zofingen', 'Suisse', 8401, 0, 1),
(2956, 'Migros Bank AG', 'Aarbergergasse 20-22', 'Postfach', '3001', 'Bern', 'Suisse', 8401, 0, 1),
(2957, 'Migros Bank AG', 'Postfach', '', '2502', 'Biel/Bienne', 'Suisse', 8401, 0, 1),
(2958, 'Migros Bank AG', 'Marktgasse 6', '', '4900', 'Langenthal', 'Suisse', 8401, 0, 1),
(2959, 'Banque Migros SA', 'Avenue du 1er Mars 1', '', '2000', 'Neuchâtel', 'Suisse', 8401, 0, 1),
(2960, 'Migros Bank AG', 'EKZ Shoppyland', 'Postfach', '3322', 'Schönbühl-Urtenen', 'Suisse', 8401, 0, 1),
(2961, 'Migros Bank AG', 'Hauptgasse 49', '', '4502', 'Solothurn 2 Stadt', 'Suisse', 8401, 0, 1),
(2962, 'Migros Bank AG', 'Postfach', '', '3601', 'Thun', 'Suisse', 8401, 0, 1),
(2963, 'Banque Migros SA', '15, Rue Pierre-Fatio', 'Case postale', '1211', 'Genève 3', 'Suisse', 8401, 0, 1),
(2964, 'Banque Migros SA', 'Rue de Genève 70', '', '1225', 'Chêne-Bourg', 'Suisse', 8401, 0, 1),
(2965, 'Banque Migros SA', 'Rue du Mont-Blanc 7', '', '1201', 'Genève', 'Suisse', 8401, 0, 1),
(2966, 'Banque Migros SA', 'Place de l&apos; Eur', '', '1003', 'Lausanne', 'Suisse', 8401, 0, 1),
(2967, 'Banque Migros SA', 'Avenue Edouard Rod 4', '', '1260', 'Nyon 1', 'Suisse', 8401, 0, 1),
(2968, 'Banque Migros SA', 'Rue de Romont 4', 'Case postale', '1701', 'Fribourg', 'Suisse', 8401, 0, 1),
(2969, 'Migros Bank AG', 'Einkaufszentrum West', '', '3027', 'Bern-Brünnen', 'Suisse', 8401, 0, 1),
(2970, 'Banque Migros SA', 'Avenue de France 10', 'Case postale', '1951', 'Sion/Sitten', 'Suisse', 8401, 0, 1),
(2971, 'Banque Migros SA', 'Center Saltina', '', '3902', 'Glis', 'Suisse', 8401, 0, 1),
(2972, 'Banca Migros SA', 'Via Pretorio 7A', 'Casella postale', '6901', 'Lugano', 'Suisse', 8401, 0, 1),
(2973, 'Banca Migros SA', 'Via Camminata 1', 'Casella postale', '6501', 'Bellinzona', 'Suisse', 8401, 0, 1),
(2974, 'Banca Migros SA', 'Casella postale', '', '6830', 'Chiasso', 'Suisse', 8401, 0, 1),
(2975, 'Banca Migros SA', 'Casella postale', '', '6601', 'Locarno', 'Suisse', 8401, 0, 1),
(2976, 'Banque Migros SA', 'Case postale', '', '1800', 'Vevey', 'Suisse', 8401, 0, 1),
(2977, 'Migros Bank AG', 'Seidengasse 12', '', '8021', 'Zürich', 'Suisse', 8401, 0, 1),
(2978, 'Migros Bank AG', 'Bahnhofstrasse 15', '', '5610', 'Wohlen AG', 'Suisse', 8401, 0, 1),
(2979, 'Banque Migros SA', 'Place Centrale 9 B', '', '1920', 'Martigny', 'Suisse', 8401, 0, 1),
(2980, 'Banque Migros SA', '32, Avenue Vibert', '', '1227', 'Carouge-La Praille', 'Suisse', 8401, 0, 1),
(2981, 'Banque Migros SA', 'Avenue Leopold-Rober', '', '2302', 'La Chaux-de-Fonds 2', 'Suisse', 8401, 0, 1),
(2982, 'Migros Bank AG', 'Oberdorfstrasse 22', '', '8820', 'Wädenswil', 'Suisse', 8401, 0, 1),
(2983, 'Banque Migros SA', 'Rue de Gruyères 33', '', '1630', 'Bulle', 'Suisse', 8401, 0, 1),
(2984, 'Migros Bank AG', 'Bachstrasse 15', '', '5600', 'Lenzburg', 'Suisse', 8401, 0, 1),
(2985, 'Banque Migros SA', 'Rue Madeleine 9', '', '1003', 'Lausanne', 'Suisse', 8401, 0, 1),
(2986, 'Migros Bank AG', 'Bahnhofplatz 4', '', '5001', 'Aarau', 'Suisse', 8401, 0, 1),
(2987, 'Migros Bank AG', 'Bahnhofstrasse 18', '', '9470', 'Buchs SG', 'Suisse', 8401, 0, 1),
(2988, 'Banque Migros SA', 'Rue de la Plaine 29', '', '1400', 'Yverdon-les-Bains', 'Suisse', 8401, 0, 1),
(2989, 'Banque Migros SA', '24, Avenue de la Feu', '', '1217', 'Meyrin 1', 'Suisse', 8401, 0, 1),
(2990, 'Banque Migros SA', 'Rue de Genève 88', '', '1004', 'Lausanne', 'Suisse', 8401, 0, 1),
(2991, 'Migros Bank AG', 'Murtenstrasse 143', '', '3008', 'Bern', 'Suisse', 8401, 0, 1),
(2992, 'Bank Coop AG', 'Postfach', '', '4002', 'Basel', 'Suisse', 8440, 0, 1),
(2993, 'Bank Coop AG', 'Gundeldingen', 'Postfach', '4018', 'Basel', 'Suisse', 8441, 0, 1),
(2994, 'Bank Coop AG', 'Kleinbasel', 'Postfach', '4005', 'Basel', 'Suisse', 8442, 0, 1),
(2995, 'Bank Coop AG', 'Postfach', '', '3001', 'Bern', 'Suisse', 8443, 0, 1),
(2996, 'Bank Coop AG', 'Postfach', '', '3601', 'Thun', 'Suisse', 8443, 0, 1),
(2997, 'Bank Coop AG', 'Postfach', '', '2501', 'Biel/Bienne', 'Suisse', 8444, 0, 1),
(2998, 'Bank Coop AG', 'Westbahnhofstrasse 1', '', '4500', 'Solothurn', 'Suisse', 8444, 0, 1),
(2999, 'Bank Coop AG', 'Neumarkt 2', 'Postfach', '5201', 'Brugg AG', 'Suisse', 8445, 0, 1),
(3000, 'Bank Coop AG', 'Postfach', '', '5001', 'Aarau', 'Suisse', 8445, 0, 1),
(3001, 'Banque Coop SA', 'Case postale', '', '2001', 'Neuchâtel', 'Suisse', 8446, 0, 1),
(3002, 'Banque Coop SA', 'Case postale', '', '2301', 'Chaux-de-Fonds, La', 'Suisse', 8446, 0, 1),
(3003, 'Banque Coop SA', 'Case postale', '', '2800', 'Delémont 1', 'Suisse', 8446, 0, 1),
(3004, 'Banque Coop SA', 'Case postale', '', '1204', 'Genève 3', 'Suisse', 8447, 0, 1),
(3005, 'Banque Coop SA', 'Case postale 5783', '', '1002', 'Lausanne', 'Suisse', 8448, 0, 1),
(3006, 'Banque Coop SA', 'Case postale', '', '1951', 'Sion/Sitten', 'Suisse', 8448, 0, 1),
(3007, 'Banque Coop SA', 'Case postale', '', '1800', 'Vevey 1', 'Suisse', 8448, 0, 1),
(3008, 'Banque Coop SA', 'Case postale', '', '1401', 'Yverdon-les-Bains', 'Suisse', 8448, 0, 1),
(3009, 'Banca Coop SA', 'Casella postale', '', '6901', 'Lugano', 'Suisse', 8449, 0, 1),
(3010, 'Bank Coop AG', 'Postfach', '', '6002', 'Luzern', 'Suisse', 8450, 0, 1),
(3011, 'Bank Coop AG', 'Postfach', '', '4600', 'Olten', 'Suisse', 8451, 0, 1),
(3012, 'Bank Coop AG', 'Postfach', '', '8201', 'Schaffhausen', 'Suisse', 8452, 0, 1),
(3013, 'Bank Coop AG', 'Postfach', '', '8400', 'Winterthur', 'Suisse', 8452, 0, 1),
(3014, 'Bank Coop AG', 'Uraniastrasse 6', 'Postfach 3830', '8021', 'Zürich', 'Suisse', 8453, 0, 1),
(3015, 'Bank Coop AG', 'Postfach', '', '8645', 'Jona', 'Suisse', 8453, 0, 1),
(3016, 'Bank Coop AG', 'Postfach', '', '6301', 'Zug', 'Suisse', 8453, 0, 1),
(3017, 'Bank Coop AG', 'Wiedikon', 'Postfach', '8055', 'Zürich', 'Suisse', 8453, 0, 1),
(3018, 'Bank Coop AG', 'Oerlikon', 'Postfach', '8050', 'Zürich', 'Suisse', 8454, 0, 1),
(3019, 'Banca Coop SA', 'Casella postale', '', '6501', 'Bellinzona', 'Suisse', 8455, 0, 1),
(3020, 'Bank Coop AG', 'Postfach', '', '9001', 'St. Gallen', 'Suisse', 8456, 0, 1),
(3021, 'Bank Coop AG', 'Masanserstrasse 17', '', '7002', 'Chur', 'Suisse', 8456, 0, 1),
(3022, 'Banque Coop SA', '35, Rue de Romont', '', '1701', 'Fribourg', 'Suisse', 8457, 0, 1),
(3023, 'SI, SA', 'Casella postale 2833', '', '6901', 'Lugano', 'Suisse', 8465, 0, 1),
(3024, 'SI, SA', 'Avenue de Rumine 3', 'Case postale 5411', '1005', 'Lausanne', 'Suisse', 8466, 0, 1),
(3025, 'SI, SA', 'Case postale', '', '1211', 'Genève 11', 'Suisse', 8468, 0, 1),
(3026, 'SI, SA', 'Casella postale', '', '6501', 'Bellinzona', 'Suisse', 8471, 0, 1),
(3027, 'SI, SA', 'Casella postale 35', '', '6830', 'Chiasso 1', 'Suisse', 8472, 0, 1),
(3028, 'SI, SA', 'Casella postale 1982', '', '6601', 'Locarno', 'Suisse', 8473, 0, 1),
(3029, 'SI, AG', 'Schützengasse 31', 'Postfach 3980', '8021', 'Zürich', 'Suisse', 8486, 0, 1),
(3030, 'SI, AG', 'Postfach', '', '7500', 'St. Moritz 1', 'Suisse', 8487, 0, 1),
(3031, 'Cornèr Banca SA', 'Via Canova 16', '', '6901', 'Lugano', 'Suisse', 8490, 0, 1),
(3032, 'Cornèr Banca SA', 'Cassarate', 'Casella postale 66', '6906', 'Lugano', 'Suisse', 8490, 0, 1),
(3033, 'Cornèr Banca SA', 'Paradiso', 'Casella postale 144', '6902', 'Lugano', 'Suisse', 8490, 0, 1),
(3034, 'Cornèr Banca SA', 'Casella postale 188', '', '6900', 'Massagno', 'Suisse', 8490, 0, 1),
(3035, 'Cornèr Banca SA', 'Casella postale 25', '', '6963', 'Pregassona', 'Suisse', 8490, 0, 1),
(3036, 'Cornèr Banca SA', 'Casella postale 1262', '', '6601', 'Locarno', 'Suisse', 8490, 0, 1),
(3037, 'Cornèr Banca SA', 'Casella postale 603', '', '6612', 'Ascona', 'Suisse', 8490, 0, 1),
(3038, 'Cornèr Banca SA', 'Case postale 64', '', '1000', 'Lausanne 20', 'Suisse', 8490, 0, 1),
(3039, 'Cornèr Bank AG', 'Tödistrasse 27', '', '8001', 'Zürich', 'Suisse', 8490, 0, 1),
(3040, 'Cornèr Banca SA', 'Via Bossi 26', '', '6830', 'Chiasso', 'Suisse', 8490, 0, 1),
(3041, 'BANCA CREDINVEST SA', 'Via G. Cattori 14', '', '6902', 'Lugano', 'Suisse', 8495, 0, 1),
(3042, 'Banca Aletti &amp; C. (Suisse) SA', 'Via D&apos;Alberti 1', 'Casella postale 5826', '6901', 'Lugano', 'Suisse', 8496, 0, 1),
(3043, 'SAXO BANK (SCHWEIZ) SA', 'Beethovenstrasse 33', '', '8002', 'Zürich', 'Suisse', 8497, 0, 1),
(3044, 'Axion SWISS Bank SA', 'Via Emilio Bossi 1', '', '6901', 'Lugano', 'Suisse', 8498, 0, 1),
(3045, 'NBAD Private Bank (Suisse) SA', 'Quai de l&apos;Ile 5', 'Case postale 5055', '1211', 'Genève 11', 'Suisse', 8499, 0, 1),
(3046, 'DEGROOF BANQUE PRIVEE SA', 'Avenue Louis Casaï 1', 'Case postale 219', '1211', 'Genève 28', 'Suisse', 8504, 0, 1),
(3047, 'Mercantil Bank (Schweiz) AG', 'Kasernenstrasse 1', 'Postfach 9758', '8036', 'Zürich', 'Suisse', 8509, 0, 1),
(3048, 'Nordea Bank S.A. Luxemburg, Zurich', 'Mainaustrasse', 'N. 21-23', '8034', 'Zuerich', 'Suisse', 8514, 0, 1),
(3049, 'Bank Julius Bär &amp; Co AG', 'Bahnhofstrasse 36', 'Postfach', '8010', 'Zürich', 'Suisse', 8515, 0, 1),
(3050, 'Bank Julius Bär &amp; Co AG', 'Schwanenplatz 2', 'Postfach', '6002', 'Luzern', 'Suisse', 8515, 0, 1),
(3051, 'Banque Julius Baer &amp; Cie S.A.', 'Rue du Grande-Chêne ', 'Case postale', '1002', 'Lausanne', 'Suisse', 8515, 0, 1),
(3052, 'Banque Julius Baer &amp; Cie S.A.', 'Rue Pierre-Fatio 7', 'Case postale', '1211', 'Genève 11', 'Suisse', 8515, 0, 1),
(3053, 'Bank Julius Bär &amp; Co AG', 'Freie Strasse 107', 'Postfach', '4001', 'Basel', 'Suisse', 8515, 0, 1),
(3054, 'Bank Julius Bär &amp; Co AG', 'Bundesgasse 30', 'Postfach', '3001', 'Bern', 'Suisse', 8515, 0, 1),
(3055, 'Banca Julius Baer &amp; Cie S.A.', 'Piazzetta San Carlo ', 'Casella postale 2797', '6901', 'Lugano', 'Suisse', 8515, 0, 1),
(3056, 'Bank Gantrisch Genossenschaft', 'Bahnhofstrasse 2', 'Postfach 14', '3150', 'Schwarzenburg', 'Suisse', 8518, 0, 1),
(3057, 'Ersparniskasse Rüeggisberg Genossenschaft', 'Dorfstrasse 19', 'Postfach', '3088', 'Rüeggisberg', 'Suisse', 8519, 0, 1),
(3058, 'Ersparniskasse Rüeggisberg Genossenschaft', 'Kirchstrasse 5', '', '3086', 'Zimmerwald', 'Suisse', 8519, 0, 1),
(3059, 'BO, Bank Brienz Oberhasli AG', 'Hauptstrasse 115', 'Postfach 771', '3855', 'Brienz', 'Suisse', 8521, 0, 1),
(3060, 'BO, Bank Brienz Oberhasli AG', 'Bahnhofstrasse 24', '', '3860', 'Meiringen', 'Suisse', 8521, 0, 1),
(3061, 'Società Bancaria Ticinese', 'Casella postale 2062', '', '6501', 'Bellinzona', 'Suisse', 8522, 0, 1),
(3062, 'EDMOND DE ROTHSCHILD (SUISSE) S.A.', 'Via Ginevra 2', 'Casella postale 5882', '6901', 'Lugano', 'Suisse', 8524, 0, 1),
(3063, 'Bank für Tirol und Vorarlberg Aktiengesellschaft, Innsbruck', 'Hauptstrasse 19', '', '9422', 'Staad SG', 'Suisse', 8525, 0, 1),
(3064, 'Privatbank IHAG Zürich AG', 'Postfach', '', '8022', 'Zürich', 'Suisse', 8528, 0, 1),
(3065, 'UniCredit Bank AG, München, Niederlassung Zürich', 'Gartenstrasse 32', 'Postfach', '8027', 'Zürich', 'Suisse', 8529, 0, 1),
(3066, 'Hyposwiss Privatbank AG', 'Stauffacherstrasse 4', 'Postfach 3180', '8004', 'Zürich', 'Suisse', 8530, 0, 1),
(3067, 'SELVI &amp; Cie SA', '4, rue du Grütli', 'Case postale', '1211', 'Genève 11', 'Suisse', 8533, 0, 1),
(3068, 'P, Bank (Schweiz) AG', 'Bahnhofstrasse 3', '', '8001', 'Zürich', 'Suisse', 8534, 0, 1),
(3069, 'Banque Internationale de Commerce-BRED (Suisse) SA', '1, place Longemalle', 'Case postale 3296', '1204', 'Genève', 'Suisse', 8537, 0, 1),
(3070, 'BERENBERG BANK (SCHWEIZ) AG', 'Kreuzstrasse 5', 'Postfach 186', '8034', 'Zürich', 'Suisse', 8539, 0, 1),
(3071, 'BLOM BANK (Switzerland) SA', 'Rue de la Rôtisserie', 'Case postale 3040', '1211', 'Genève 3', 'Suisse', 8540, 0, 1),
(3072, 'Banca Privata Ed.de Rothschild Lugano SA, (ex Sella Bank AG)', 'Corso Elvezia 9', '', '6900', 'Lugano', 'Suisse', 8542, 0, 1),
(3073, 'Scobag Privatbank AG', 'Postfach', '', '4010', 'Basel', 'Suisse', 8543, 0, 1),
(3074, 'Banque J. Safra Sarasin SA', '70, rue du Rhône', 'Case postale 5809', '1211', 'Genève 11', 'Suisse', 8547, 0, 1),
(3075, 'Hyposwiss Private Bank Genève SA', '3, rue du Général-Du', 'Case postale 5611', '1211', 'Genève 1', 'Suisse', 8548, 0, 1),
(3076, 'Valartis Bank AG', 'Sihlstrasse 24', 'Postfach', '8021', 'Zürich', 'Suisse', 8549, 0, 1),
(3077, 'Banque de Dépôts et de Gestion SA', 'Avenue du Théâtre 14', 'Case postale 5415', '1002', 'Lausanne', 'Suisse', 8550, 0, 1),
(3078, 'Banque de Dépôts et de Gestion SA', 'Via Franscini 6', 'Case postale 1159', '6850', 'Mendrisio', 'Suisse', 85502, 0, 1),
(3079, 'Banque de Dépôts et de Gestion SA', 'Piazza Riforma 3', 'Casella postale 5839', '6901', 'Lugano', 'Suisse', 8551, 0, 1),
(3080, 'Banque de Dépôts et de Gestion SA', 'Faubourg de l&apos;H', 'Case postale 1856', '2001', 'Neuchâtel', 'Suisse', 8552, 0, 1),
(3081, 'Z, Bank Aktiengesellschaft', 'Egglirain 15', 'Postfach', '8832', 'Wilen b. Wollerau', 'Suisse', 8553, 0, 1),
(3082, 'Bank am Bellevue AG', 'Seestrasse 16', 'Postfach 1366', '8700', 'Küsnacht', 'Suisse', 8559, 0, 1),
(3083, 'Privatbank Von Graffenried AG', 'Postfach', '', '3001', 'Bern', 'Suisse', 8564, 0, 1),
(3084, 'Dreyfus Söhne &amp; Cie AG, Banquiers', 'Aeschenvorstadt 16', 'Postfach 2656', '4002', 'Basel', 'Suisse', 8565, 0, 1),
(3085, 'Banque Bonhôte &amp; Cie SA', '16, Rue du Bassin', 'Case postale', '2001', 'Neuchâtel', 'Suisse', 8570, 0, 1),
(3086, 'Edmond de Rothschild (Suisse) S.A', 'Case postale 5478', '', '1211', 'Genève 11', 'Suisse', 8571, 0, 1),
(3087, 'Edmond de Rothschild (Suisse) S.A', 'Case postale', '', '1700', 'Fribourg', 'Suisse', 8571, 0, 1),
(3088, 'Edmond de Rothschild (Suisse) S.A', 'Avenue Agassiz 2', 'Case postale 2520', '1002', 'Lausanne', 'Suisse', 8571, 0, 1),
(3089, 'Trafina Privatbank AG', 'Rennweg 50', 'Postfach', '4020', 'Basel', 'Suisse', 8572, 0, 1),
(3090, 'Maerki, Baumann &amp; Co. AG', 'Dreikönigstrasse 6', 'Postfach 4688', '8022', 'Zürich', 'Suisse', 8573, 0, 1),
(3091, 'BANKMED SUISSE SA', '3 rue du Mont Blanc', 'Case postale 1523', '1211', 'Genève 1', 'Suisse', 8574, 0, 1),
(3092, '.M. Warburg Bank (Schweiz) AG', 'Parkring 12', 'Postfach 1960', '8027', 'Zürich', 'Suisse', 8575, 0, 1),
(3093, 'BANQUE MORVAL SA', '18 rue Charles-Galla', 'Case postale 339', '1211', 'Genève 12', 'Suisse', 8578, 0, 1),
(3094, 'BANCA MORVAL SA', '', '', '6900', 'Lugano', 'Suisse', 8578, 0, 1),
(3095, 'SOCIETE GENERALE', 'Rue de la Corraterie', 'Case postale 5022', '1211', 'Genève 11', 'Suisse', 8582, 0, 1),
(3096, 'SOCIETE GENERALE', 'Talstrasse 66', 'Postfach', '8039', 'Zürich', 'Suisse', 8582, 0, 1),
(3097, 'SOCIETE GENERALE', 'Avenue de Rumine 20', 'Case postale 220', '1001', 'Lausanne', 'Suisse', 8582, 0, 1),
(3098, 'SOCIETE GENERALE', 'Viale Stefano Fransc', 'Casella postale 5830', '6901', 'Lugano', 'Suisse', 8582, 0, 1),
(3099, 'Banca del Ceresio SA', 'Casella postale 2860', '', '6901', 'Lugano', 'Suisse', 8584, 0, 1),
(3100, 'Banque Genevoise de Gestion SA', 'Case postale 3271', '', '1211', 'Genève 3', 'Suisse', 8587, 0, 1),
(3101, 'BANCA ZARATTINI &amp; Co. SA', 'Via Pretorio 1', 'Casella postale 5893', '6900', 'Lugano', 'Suisse', 8609, 0, 1),
(3102, 'Z, PRIVATBANK (SCHWEIZ) AG', 'Münsterhof 12', 'Postfach 5178', '8022', 'Zürich', 'Suisse', 8615, 0, 1),
(3103, 'FG, Bank European Financial Group SA', '24, Quai du Seujet', 'Case postale', '1211', 'Genève 2', 'Suisse', 8616, 0, 1),
(3104, 'Nomura Bank (Switzerland) Ltd', 'Postfach', '', '8021', 'Zürich', 'Suisse', 8619, 0, 1),
(3105, 'Banque Havilland (Suisse) SA', 'Rue de Hollande 10', 'Case postale 5760', '1211', 'Genève 11', 'Suisse', 8623, 0, 1),
(3106, 'Banque Havilland (Suisse) SA', 'Bellariastrasse 23', 'Postfach 684', '8027', 'Zürich', 'Suisse', 8623, 0, 1),
(3107, 'Banque Audi (Suisse) SA', 'Case postale 384', '', '1211', 'Genève 12', 'Suisse', 8624, 0, 1),
(3108, 'Banque de Commerce et de Placements SA', '1, rue de la Fontain', 'Case postale 3069', '1211', 'Genève 3', 'Suisse', 8629, 0, 1),
(3109, 'Schroder &amp; Co Bank AG', 'Central 2', 'Postfach 1820', '8021', 'Zürich', 'Suisse', 8634, 0, 1),
(3110, 'JPMorgan Chase Bank, National Association, Columbus', 'Dreikönigstrasse 21', 'Postfach 2623', '8022', 'Zürich', 'Suisse', 8635, 0, 1),
(3111, 'Citibank (Switzerland) AG', 'Prime Tower / Hardst', 'P.O. Box', '8010', 'Zürich', 'Suisse', 8638, 0, 1),
(3112, 'Citibank (Switzerland) AG', 'Case postale 3946', '', '1211', 'Genève 3', 'Suisse', 8638, 0, 1),
(3113, 'Citibank (Switzerland) AG', 'Casella postale 2859', '', '6901', 'Lugano', 'Suisse', 8638, 0, 1),
(3114, 'Mizuho Bank (Schweiz) AG', 'Löwenstrasse 32', 'Postfach', '8021', 'Zürich', 'Suisse', 8644, 0, 1),
(3115, 'UNION BANCAIRE PRIVEE, UBP SA', 'Case postale 1320', '', '1211', 'Genève 1', 'Suisse', 8657, 0, 1),
(3116, 'UNION BANCAIRE PRIVEE, UBP SA', 'Casella postale', '', '6900', 'Lugano', 'Suisse', 8657, 0, 1),
(3117, 'UNION BANCAIRE PRIVEE, UBP SA', 'Postfach', '', '8022', 'Zürich', 'Suisse', 8657, 0, 1),
(3118, 'Deutsche Bank (Suisse) S.A.', 'Place des Bergues 3', 'Private Banking', '1211', 'Genève 1', 'Suisse', 8659, 0, 1),
(3119, 'Deutsche Bank (Schweiz) AG', 'Bahnhofquai 9/11', 'Private Banking', '8021', 'Zürich', 'Suisse', 8659, 0, 1),
(3120, 'Deutsche Bank (Svizzera) S.A.', 'Via Ferruccio Pelli ', 'Private Banking', '6901', 'Lugano', 'Suisse', 8659, 0, 1),
(3121, 'Gazprombank (Schweiz) AG', 'Zollikerstrasse 183', 'Postfach 1721', '8032', 'Zürich', 'Suisse', 8660, 0, 1),
(3122, 'Rothschild Bank AG', 'Postfach', '', '8034', 'Zürich', 'Suisse', 8661, 0, 1),
(3123, 'KB, PRIVATBANK SA', 'Via Serafina Balestr', 'Casella postale', '6901', 'Lugano', 'Suisse', 8663, 0, 1),
(3124, 'KB, PRIVATBANK AG', 'Tödistrasse 47', 'Postfach', '8022', 'Zürich', 'Suisse', 8664, 0, 1),
(3125, 'KB, PRIVATBANK SA', '12, Charles Galland', 'Case postale', '1206', 'Genève', 'Suisse', 8665, 0, 1),
(3126, 'BANCA DEL SEMPIONE SA', 'Via Peri 5', 'Casella postale 2825', '6901', 'Lugano 1', 'Suisse', 8666, 0, 1),
(3127, 'BANCA DEL SEMPIONE SA', 'Viale Stazione 8a', 'Casella postale 2021', '6501', 'Bellinzona', 'Suisse', 8666, 0, 1),
(3128, 'BANCA DEL SEMPIONE SA', 'Piazza Boffalora 4', 'Casella postale 146', '6830', 'Chiasso 1', 'Suisse', 8666, 0, 1),
(3129, 'BANCA DEL SEMPIONE SA', 'Piazza Stazione 9, 6', 'Casella postale 664', '6600', 'Locarno', 'Suisse', 8666, 0, 1),
(3130, 'FG, Bank AG', 'Bleicherweg 8', 'Postfach 6012', '8022', 'Zürich', 'Suisse', 8667, 0, 1),
(3131, 'FG, Bank SA', '24, Quai du Seujet', 'Case postale', '1211', 'Genève 2', 'Suisse', 8667, 0, 1),
(3132, 'Banque SYZ SA (ex-RBC)', 'Rue François-Diday 6', 'Case postale 5696', '1211', 'Genève 11', 'Suisse', 8672, 0, 1),
(3133, 'NP, Paribas (Suisse) SA', 'Place de Hollande, 2', 'Case postale', '1211', 'Genève 11', 'Suisse', 8686, 0, 1),
(3134, 'NP, Paribas (Suisse) SA', 'Aeschengraben 26', '', '4051', 'Basel', 'Suisse', 8686, 0, 1),
(3135, 'NP, Paribas (Suisse) SA', 'Selnaustrasse 16', '', '8022', 'Zürich', 'Suisse', 8686, 0, 1),
(3136, 'HSBC Private Bank (Suisse) SA', 'Quai Général-Guisan ', 'Case postale 2888', '1211', 'Genève 1', 'Suisse', 8689, 0, 1),
(3137, 'HSBC Private Bank (Suisse) SA', 'Paradeplatz 5', 'Postfach', '8027', 'Zürich', 'Suisse', 8689, 0, 1),
(3138, 'UNITED MIZRAHI BANK (Schweiz) AG', 'Nüschelerstrasse 31', 'Postfach 1330', '8021', 'Zürich', 'Suisse', 8695, 0, 1),
(3139, 'Citibank N.A., Sioux Falls', 'Bleicherweg 10', 'Postfach', '8010', 'Zürich', 'Suisse', 8700, 0, 1),
(3140, 'Citibank N.A., Sioux Falls', 'Case postale 3946', '', '1211', 'Genève 3', 'Suisse', 8700, 0, 1),
(3141, 'HSBC Bank plc, London, Zweigniederlassung Zürich', 'Bederstrasse 49', '', '8002', 'Zürich', 'Suisse', 8701, 0, 1),
(3142, 'Leonteq Securities AG', 'Europaallee 39', '', '8004', 'Zürich', 'Suisse', 8702, 0, 1),
(3143, 'bank zweiplus ag', 'Bändliweg 20', 'Postfach', '8048', 'Zürich', 'Suisse', 8703, 0, 1),
(3144, 'EK, BANK 1826 Genossenschaft', 'Hofstettenstrasse 2', 'Postfach', '3601', 'Thun', 'Suisse', 8704, 0, 1),
(3145, 'EK, BANK 1826 Genossenschaft', 'Staatsstrasse', '', '3654', 'Gunten', 'Suisse', 8704, 0, 1),
(3146, 'EK, BANK 1826 Genossenschaft', 'Bahnhofstrasse 6', '', '3627', 'Heimberg', 'Suisse', 8704, 0, 1),
(3147, 'EK, BANK 1826 Genossenschaft', 'Staatsstrasse 144', '', '3626', 'Hünibach', 'Suisse', 8704, 0, 1),
(3148, 'EK, BANK 1826 Genossenschaft', 'Staatsstrasse 4', '', '3653', 'Oberhofen am Thunersee', 'Suisse', 8704, 0, 1),
(3149, 'EK, BANK 1826 Genossenschaft', 'Oberdorf 743 F', '', '3753', 'Oey', 'Suisse', 8704, 0, 1),
(3150, 'EK, BANK 1826 Genossenschaft', 'Dorf 864A', '', '3655', 'Sigriswil', 'Suisse', 8704, 0, 1),
(3151, 'EK, BANK 1826 Genossenschaft', 'Oberlandstrasse 9', '', '3700', 'Spiez', 'Suisse', 8704, 0, 1),
(3152, 'EK, BANK 1826 Genossenschaft', 'Mühleweg 11', '', '3612', 'Steffisburg', 'Suisse', 8704, 0, 1),
(3153, 'EK, BANK 1826 Genossenschaft', 'Bälliz 46 a', '', '3601', 'Thun', 'Suisse', 8704, 0, 1),
(3154, 'EK, BANK 1826 Genossenschaft', 'Frutigenstrasse 62', '', '3604', 'Thun', 'Suisse', 8704, 0, 1),
(3155, 'EK, BANK 1826 Genossenschaft', 'Lindenweg 2A / Schul', '', '3604', 'Thun', 'Suisse', 8704, 0, 1),
(3156, 'EK, BANK 1826 Genossenschaft', 'Dorfstrasse 43a', '', '3661', 'Uetendorf', 'Suisse', 8704, 0, 1),
(3157, 'EK, BANK 1826 Genossenschaft', 'Hauptstrasse 30', '', '3752', 'Wimmis', 'Suisse', 8704, 0, 1),
(3158, 'Société Générale', 'Talacker 50', 'Postfach 1928', '8021', 'Zürich', 'Suisse', 8705, 0, 1),
(3159, 'he, Royal Bank of Scotland, plc', 'Hauptstrasse 11', '', '9477', 'Trübbach', 'Suisse', 8707, 0, 1),
(3160, 'Bank CIC (SCHWEIZ) AG', 'Marktplatz 11-13', 'Postfach', '4001', 'Basel', 'Suisse', 8710, 0, 1),
(3161, 'Banque CIC (Suisse) SA', 'Faubourg du Lac 2', 'Case postale 1913', '2001', 'Neuchâtel', 'Suisse', 8710, 0, 1),
(3162, 'Banque CIC (Suisse) SA', 'Avenue de la Gare 1', '', '1701', 'Fribourg', 'Suisse', 8710, 0, 1),
(3163, 'Banque CIC (Suisse) SA', '29, avenue du Champe', 'Case postale 327', '1211', 'Genève', 'Suisse', 8710, 0, 1),
(3164, 'Banque CIC (Suisse) SA', 'Rue du Petit-Chêne 2', 'Case postale 370', '1001', 'Lausanne', 'Suisse', 8710, 0, 1),
(3165, 'Bank CIC (SCHWEIZ) AG', 'Löwenstrasse 62', 'Postfach 3856', '8021', 'Zürich', 'Suisse', 8710, 0, 1),
(3166, 'Banca CIC (Svizzera) SA', 'Via F. Pelli 15', 'Casella postale', '6901', 'Lugano', 'Suisse', 8710, 0, 1),
(3167, 'Banca CIC (Svizzera) SA', 'Via Stazione 9', 'Casella postale 663', '6602', 'Locarno-Muralto', 'Suisse', 8710, 0, 1),
(3168, 'Bank, CIC (SCHWEIZ) AG', 'CIC-Group', 'Postfach', '4001', 'Basel', 'Suisse', 87105, 0, 1),
(3169, 'Arab Bank (Switzerland) Ltd.', 'place de Longemalle ', 'Postfach 2023', '1204', 'Genève', 'Suisse', 8719, 0, 1),
(3170, 'Gonet &amp; Cie SA', 'Boulevard du Théâtre', 'Case postale 5009', '1211', 'Genève 11', 'Suisse', 8721, 0, 1),
(3171, 'Bank of America Merrill Lynch Int. London, Zurich Branch', 'Stockerhof, Stockers', '', '8002', 'Zürich', 'Suisse', 8726, 0, 1),
(3172, 'Banque Cramer &amp; Cie SA', 'Avenue de Miremont 2', 'Case postale 403', '1211', 'Genève 12', 'Suisse', 8727, 0, 1),
(3173, 'Banque Cramer &amp; Cie SA', 'Avenue du Théâtre 14', '', '1002', 'Lausanne', 'Suisse', 8727, 0, 1),
(3174, 'Banque Cramer &amp; Cie SA', 'Riva Antonio Caccia ', '', '6900', 'Lugano', 'Suisse', 8727, 0, 1),
(3175, 'Bank Linth LLB AG', 'Zürcherstrasse 3', 'Postfach 168', '8730', 'Uznach', 'Suisse', 8731, 0, 1),
(3176, 'Bank Linth LLB AG', 'Schulhausstrasse 3', 'Postfach 116', '8722', 'Kaltbrunn', 'Suisse', 8731, 0, 1),
(3177, 'Bank Linth LLB AG', 'Ritterhausstrasse 9', 'Postfach', '8713', 'Uerikon', 'Suisse', 8731, 0, 1),
(3178, 'Bank Linth LLB AG', 'Untere Bahnhofstrass', 'Postfach', '8640', 'Rapperswil SG', 'Suisse', 8731, 0, 1),
(3179, 'Bank Linth LLB AG', 'Bahnhofstrasse 5', '', '8716', 'Schmerikon', 'Suisse', 8731, 0, 1),
(3180, 'Bank Linth LLB AG', 'Zürcherstrasse 4', 'Postfach', '8854', 'Siebnen', 'Suisse', 8731, 0, 1),
(3181, 'Bank Linth LLB AG', 'Bahnhofplatz 5', 'Postfach', '8853', 'Lachen SZ', 'Suisse', 8731, 0, 1),
(3182, 'Bank Linth LLB AG', 'Molkereistrasse 1', 'Postfach', '8645', 'Jona', 'Suisse', 8731, 0, 1),
(3183, 'Bank Linth LLB AG', 'Churerstrasse 21', 'Postfach', '8808', 'Pfäffikon SZ', 'Suisse', 8731, 0, 1),
(3184, 'Bank Linth LLB AG', 'Hauptstrasse', 'Postfach', '8872', 'Weesen', 'Suisse', 8731, 0, 1),
(3185, 'Bank Linth LLB AG', 'Ziegelbrückstrasse 2', 'Postfach', '8867', 'Niederurnen', 'Suisse', 8731, 0, 1),
(3186, 'Bank Linth LLB AG', 'Belsitostrasse 1', 'Postfach', '8640', 'Kempraten', 'Suisse', 8731, 0, 1),
(3187, 'Bank Linth LLB AG', 'Dorfplatz 6', 'Postfach', '8852', 'Altendorf', 'Suisse', 8731, 0, 1),
(3188, 'Bank Linth LLB AG', 'Dorfstrasse 2', 'Postfach', '8630', 'Rüti ZH', 'Suisse', 8731, 0, 1),
(3189, 'Bank Linth LLB AG', 'Rickenstrasse 25', 'Postfach', '8737', 'Gommiswald', 'Suisse', 8731, 0, 1),
(3190, 'Bank Linth LLB AG', 'Bahnhofstrasse', 'Postfach', '8890', 'Flums', 'Suisse', 8731, 0, 1),
(3191, 'Bank Linth LLB AG', 'Bahnhofstrasse 10', 'Postfach', '7320', 'Sargans', 'Suisse', 8731, 0, 1),
(3192, 'Bank Linth LLB AG', 'Am Platz', 'Postfach', '7310', 'Bad Ragaz', 'Suisse', 8731, 0, 1),
(3193, 'Bank Linth LLB AG', 'Wangserstrasse 44', 'Postfach', '8887', 'Mels', 'Suisse', 8731, 0, 1),
(3194, 'Bank Linth LLB AG', 'Bergstrasse 8', 'Postfach', '8712', 'Stäfa', 'Suisse', 8731, 0, 1),
(3195, 'Bank Linth LLB AG', 'Feldbachstrasse 4', 'Postfach', '8634', 'Hombrechtikon', 'Suisse', 8731, 0, 1),
(3196, 'Bank Linth LLB AG', 'Bergstrasse 143', 'Postfach', '8707', 'Uetikon am See', 'Suisse', 8731, 0, 1),
(3197, 'Bank Thalwil Genossenschaft', 'Gotthardstrasse 14', 'Postfach', '8800', 'Thalwil', 'Suisse', 8733, 0, 1),
(3198, 'Bank Thalwil Genossenschaft', 'Albisstrasse 15', '', '8134', 'Adliswil 1', 'Suisse', 8733, 0, 1),
(3199, 'Bank Thalwil Genossenschaft', 'Bahnhofstrasse 7', '', '8802', 'Kilchberg ZH', 'Suisse', 8733, 0, 1),
(3200, 'Bank Thalwil Genossenschaft', 'Neue Dorfstrasse 15', '', '8135', 'Langnau am Albis', 'Suisse', 8733, 0, 1),
(3201, 'Barclays Bank (Suisse) SA', 'Chemin de Grange-Can', 'Case postale 3941', '1211', 'Genève 3', 'Suisse', 8735, 0, 1),
(3202, 'Barclays Bank (Suisse) SA', 'Via Marconi 2', '', '6901', 'Lugano', 'Suisse', 8735, 0, 1),
(3203, 'Banque Thaler SA', 'Rue Pierre-Fatio 3', 'Case postale 3335', '1211', 'Genève 3', 'Suisse', 8737, 0, 1),
(3204, 'Habibsons Bank Limited, London', 'Beckenhofstrasse 1', 'Postfach 189', '8006', 'Zürich', 'Suisse', 8738, 0, 1),
(3205, 'A, Indosuez (Switzerland) SA', 'Chemin de Bérée 46-4', 'Case postale 224', '1010', 'Lausanne', 'Suisse', 8740, 0, 1),
(3206, 'A, Indosuez (Switzerland) SA', 'Quai Général Guisan ', 'Case postale 5260', '1211', 'Genève 11', 'Suisse', 8741, 0, 1),
(3207, 'A, Indosuez (Switzerland) SA', 'Via F. Pelli 3', 'Casella postale', '6901', 'Lugano', 'Suisse', 8742, 0, 1),
(3208, 'A, Indosuez (Switzerland) SA', 'Lintheschergasse 15', 'Postfach 3668', '8021', 'Zürich', 'Suisse', 8743, 0, 1),
(3209, 'BANQUE PROFIL DE GESTION SA', 'Cours de Rive 11', 'Case postale 3668', '1211', 'Genève 3', 'Suisse', 8747, 0, 1),
(3210, 'Bank J. Safra Sarasin AG', 'Elisabethenstrasse 6', 'Postfach', '4002', 'Basel', 'Suisse', 8750, 0, 1),
(3211, 'Bank J. Safra Sarasin AG', 'Bleicherweg 1 / Para', 'Postfach 2123', '8022', 'Zürich', 'Suisse', 8751, 0, 1),
(3212, 'Bank J. Safra Sarasin AG', '(ex Direkt Anlage Ba', 'Elisabethenstrasse 6', '4002', 'Basel', 'Suisse', 8752, 0, 1),
(3213, 'Banque Pictet &amp; Cie SA', 'Route des Acacias 60', 'Case postale', '1211', 'Genève 73', 'Suisse', 8755, 0, 1),
(3214, 'Baumann &amp; Cie', 'St. Jakobs-Strasse 4', 'Postfach', '4002', 'Basel', 'Suisse', 8756, 0, 1),
(3215, 'Bank Vontobel AG', 'Gotthardstrasse 43', 'Postfach', '8022', 'Zürich', 'Suisse', 8757, 0, 1),
(3216, 'Banque Lombard Odier &amp; Cie SA', 'Rue de la Corraterie', 'Case postale 5215', '1211', 'Genève 11', 'Suisse', 8760, 0, 1),
(3217, 'Reichmuth &amp; Co', 'Rütligasse 1', 'Postfach', '6000', 'Luzern 7', 'Suisse', 8761, 0, 1),
(3218, 'BH, - Compagnie Bancaire Helvétique SA', 'Boulevard Emile-Jaqu', 'Case postale', '1211', 'Genève 3', 'Suisse', 8762, 0, 1),
(3219, 'Notenstein La Roche Privatbank AG', 'Bohl 17', 'Postfach', '9004', 'St. Gallen', 'Suisse', 8765, 0, 1),
(3220, 'Bordier &amp; Cie', '16, rue de Hollande', 'Case postale 5515', '1211', 'Genève 11', 'Suisse', 8767, 0, 1),
(3221, 'Bordier &amp; Cie', 'Zeughausgasse 28', '', '3011', 'Bern', 'Suisse', 8767, 0, 1),
(3222, 'Bordier &amp; Cie', 'Talstrasse 83', '', '8001', 'Zürich', 'Suisse', 8767, 0, 1),
(3223, 'Bordier &amp; Cie', '13, Rue de la Porcel', 'Case postale 1045', '1260', 'Nyon 1', 'Suisse', 8767, 0, 1),
(3224, 'LANDOLT &amp; CIE SA', 'Chemin de Roseneck 6', 'Case postale 6739', '1002', 'Lausanne', 'Suisse', 8768, 0, 1),
(3225, 'Mirabaud &amp; Cie SA', '29, boulevard George', 'Case postale 5815', '1211', 'Genève 11', 'Suisse', 8770, 0, 1),
(3226, 'Isbank AG, Frankfurt am Main (DE)', 'Bodmerstrasse 14', 'Postfach 1859', '8002', 'Zürich', 'Suisse', 8774, 0, 1),
(3227, '., Gutzwiller &amp; Cie Banquiers', 'Postfach 1216', '', '4001', 'Basel', 'Suisse', 8775, 0, 1),
(3228, 'Piguet Galland &amp; Cie SA', 'Rue de la Plaine 14', 'Case postale 575', '1401', 'Yverdon-les-Bains', 'Suisse', 8777, 0, 1),
(3229, 'Piguet Galland &amp; Cie SA', '5, Place de l&apos;U', 'Case postale 3456', '1211', 'Genève', 'Suisse', 8777, 0, 1),
(3230, 'Piguet Galland &amp; Cie SA', 'Rue du Grand-Chêne 8', 'Case postale 3492', '1002', 'Lausanne', 'Suisse', 8777, 0, 1),
(3231, 'Piguet Galland &amp; Cie SA', 'Via S. Balestra 17', 'Case postale 2840', '6901', 'Lugano', 'Suisse', 8777, 0, 1),
(3232, 'BANCA ARNER SA', 'Piazza Manzoni 8', 'Casella postale 5881', '6901', 'Lugano', 'Suisse', 8778, 0, 1),
(3233, 'Rahn+Bodmer Co.', 'Postfach 4522', '', '8022', 'Zürich', 'Suisse', 8779, 0, 1),
(3234, 'Deutsche Bank AG Zürich Branch', 'Postfach 3604 / Uran', 'Investment Banking', '8021', 'Zürich', 'Suisse', 8780, 0, 1),
(3235, 'Deutsche Bank AG Zürich Branch', 'Postfach 3604 / Uran', 'Kommerzielles Geschä', '8021', 'Zürich', 'Suisse', 87801, 0, 1),
(3236, 'Deutsche Bank AG Zürich Branch', 'Postfach 3604 / Uran', 'Hausinternes Clearin', '8021', 'Zürich', 'Suisse', 87802, 0, 1),
(3237, 'Swissquote Bank SA', 'Chemin de la Crétaux', 'Case postale 319', '1196', 'Gland', 'Suisse', 8781, 0, 1),
(3238, 'Spar- und Leihkasse Frutigen AG', 'Dorfstrasse 15', '', '3714', 'Frutigen', 'Suisse', 8784, 0, 1),
(3239, 'Regiobank Solothurn AG', 'Westbahnhofstrasse 1', 'Postfach', '4502', 'Solothurn', 'Suisse', 8785, 0, 1),
(3240, 'Regiobank Solothurn AG', 'Hauptstrasse 34', '', '4562', 'Biberist', 'Suisse', 8785, 0, 1),
(3241, 'Regiobank Solothurn AG', 'Bahnhofstrasse 9', '', '4622', 'Egerkingen', 'Suisse', 8785, 0, 1),
(3242, 'Regiobank Solothurn AG', 'Kirchstrasse 11', 'Postfach 155', '2540', 'Grenchen', 'Suisse', 8785, 0, 1),
(3243, 'Regiobank Solothurn AG', 'Hauptstrasse 48', '', '4528', 'Zuchwil', 'Suisse', 8785, 0, 1),
(3244, 'Bankhaus Jungholz AG', 'Poststrasse 6', '', '9000', 'St. Gallen', 'Suisse', 8786, 0, 1),
(3245, 'Pfandbriefbank schweizerischer Hypothekarinstitute AG', 'Nansenstrasse 16', 'Postfach 6446', '8050', 'Zürich', 'Suisse', 8787, 0, 1),
(3246, 'BANQUE HERITAGE SA', 'Route de Chêne 61', 'Case postale 6600', '1211', 'Genève 6', 'Suisse', 8788, 0, 1),
(3247, 'Habib Bank AG Zürich', 'Weinbergstrasse 59', 'Postfach 225', '8042', 'Zürich', 'Suisse', 8789, 0, 1),
(3248, 'NP, PARIBAS SECURITIES SERVICES', 'Selnaustrasse 16', 'Postfach 2119', '8022', 'Zürich', 'Suisse', 8792, 0, 1),
(3249, 'Timber Hill (Europe) AG', 'Gotthardstrasse 3', 'Postfach 254', '6301', 'Zug', 'Suisse', 8797, 0, 1),
(3250, 'InCore Bank AG', 'Stauffacherstrasse 4', 'Postfach', '8004', 'Zürich', 'Suisse', 8799, 0, 1),
(3251, 'Liechtensteinische Landesbank Aktiengesellschaft', 'Städtle 44', 'Postfach 384', '9490', 'Vaduz', 'Suisse', 8800, 0, 1),
(3252, 'BANK ALPINUM AKTIENGESELLSCHAFT', 'Austrasse 59', 'Postfach 1528', '9490', 'Vaduz', 'Suisse', 8801, 0, 1),
(3253, 'Neue Bank AG', 'Marktgass 20', 'Postfach 1533', '9490', 'Vaduz', 'Suisse', 8802, 0, 1),
(3254, 'BENDURA BANK AG', 'Schaaner Strasse 27', '', '9487', 'Gamprin-Bendern', 'Suisse', 8803, 0, 1),
(3255, 'P, Bank AG', 'Aeulestrasse 6', 'Postfach 885', '9490', 'Vaduz', 'Suisse', 8805, 0, 1),
(3256, 'Kaiser Partner Privatbank AG', 'Herrengasse 23', 'Postfach 725', '9490', 'Vaduz', 'Suisse', 8806, 0, 1),
(3257, 'P, Bank AG (formerly Centrum Bank AG)', 'Kirchstrasse 3', 'Postfach 1168', '9490', 'Vaduz', 'Suisse', 8808, 0, 1),
(3258, 'GT, Bank AG', 'Postfach 85', '', '9490', 'Vaduz', 'Suisse', 8810, 0, 1),
(3259, 'Bank Frick &amp; Co. Aktiengesellschaft', 'Landstrasse 8', 'Postfach 43', '9496', 'Balzers', 'Suisse', 8811, 0, 1),
(3260, 'Volksbank AG', 'Feldkircher Strasse ', 'Postfach 855', '9494', 'Schaan', 'Suisse', 8812, 0, 1);
INSERT INTO `faturacao_bancos_fornecedores` (`ID_BancoFornecedor`, `Nome`, `Address1`, `Address2`, `NPA`, `Localite`, `PaisBanco`, `BCNbr`, `Predefinido`, `Ativo`) VALUES
(3261, 'Raiffeisen Privatbank Liechtenstein AG', 'Austrasse 51', 'Postfach 1621', '9490', 'Vaduz', 'Suisse', 8813, 0, 1),
(3262, 'Banque Havilland (Liechtenstein) AG', 'Austrasse 61', 'Postfach', '9490', 'Vaduz', 'Suisse', 8814, 0, 1),
(3263, 'Union Bank AG', 'Austrasse 46', 'Postfach 1535', '9490', 'Vaduz', 'Suisse', 8815, 0, 1),
(3264, 'Dominick Company AG', 'Mittelstrasse 14 / S', 'Postfach', '8034', 'Zürich', 'Suisse', 8820, 0, 1),
(3265, 'Vorarlberger Landes- und Hypothekenbank AG', 'Bankgasse 1', 'Postfach', '9004', 'St. Gallen', 'Suisse', 8821, 0, 1),
(3266, 'IM, BANQUE SA', 'Rue Merle d&apos;Aub', 'Case postale 6297', '1211', 'Genève 6', 'Suisse', 8822, 0, 1),
(3267, 'SBERBANK (SWITZERLAND) AG', 'Gartenstrasse 24', 'Postfach 2136', '8027', 'Zürich', 'Suisse', 8825, 0, 1),
(3268, 'Bantleon Bank AG', 'Bahnhofstrasse 2', '', '6300', 'Zug', 'Suisse', 8826, 0, 1),
(3269, 'HINDUJA BANQUE (SUISSE) SA', 'Place de la Fusterie', 'Case postale 1011', '1211', 'Genève 1', 'Suisse', 8827, 0, 1),
(3270, 'HINDUJA BANK (SCHWEIZ) AG', 'Pilatusstrasse 35', 'Postfach 2167', '6002', 'Luzern', 'Suisse', 8827, 0, 1),
(3271, 'INTESA SANPAOLO PRIVATE BANK (SUISSE) SA', 'Via Balestra 12', '', '6900', 'Lugano', 'Suisse', 8830, 0, 1),
(3272, 'ABANCA CORPORACION BANCARIA S.A., BETANZOS', 'Rue du Mont-Blanc 14', 'Case postale 1283', '1211', 'Genève 1', 'Suisse', 8831, 0, 1),
(3273, 'Banque Pâris Bertrand Sturdza SA', 'Rue de Candolle 19', 'Case postale 340', '1211', 'Genève 12', 'Suisse', 8833, 0, 1),
(3274, 'COMMERZBANK AG FF, Zweigniederlassung Zürich', 'Utoquai 55', '', '8008', 'Zürich', 'Suisse', 8836, 0, 1),
(3275, 'Banque du Léman SA', '12 rue François-Boni', '', '1201', 'Genève', 'Suisse', 8838, 0, 1),
(3276, 'Quilvest (Switzerland) Ltd.', 'Stockerstrasse 23', '', '8002', 'Zürich', 'Suisse', 8839, 0, 1),
(3277, 'Banco Itaú (Suisse) SA', 'Bleicherweg 30', '', '8002', 'Zürich', 'Suisse', 8841, 0, 1),
(3278, 'Globalance Bank AG', 'Gartenstrasse 16', '', '8002', 'Zürich', 'Suisse', 8842, 0, 1),
(3279, 'Dukascopy Bank SA', 'Route de Pré-Bois 20', '', '1215', 'Genève 15', 'Suisse', 8843, 0, 1),
(3280, 'Neue Helvetische Bank AG', 'Seefeldstrasse 215', '', '8008', 'Zürich', 'Suisse', 8845, 0, 1),
(3281, 'Aquila &amp; Co. AG', 'Bahnhofstrasse 28a/P', '', '8001', 'Zürich', 'Suisse', 8846, 0, 1),
(3282, 'BL, (Switzerland) AG', 'Feldeggstrasse 55', 'Postfach 1176', '8034', 'Zürich', 'Suisse', 8847, 0, 1),
(3283, 'G, Bank S.A.', '42, rue du Rhône', '', '1204', 'Genève', 'Suisse', 8848, 0, 1),
(3284, 'Fonds de compensation AVS/AI/APG', 'Bd. Georges-Favon 6', '', '1204', 'Genève', 'Suisse', 8850, 0, 1),
(3285, 'UVA', 'Fluhmattstrasse 1', 'Postfach 4358', '6002', 'Luzern', 'Suisse', 8851, 0, 1),
(3286, 'Swiss Life AG', 'General-Guisan-Quai ', 'Postfach', '8022', 'Zürich', 'Suisse', 8852, 0, 1),
(3287, 'Schweizerische Rückversicherungs-Gesellschaft AG', 'Mythenquai 50/60', '', '8022', 'Zürich', 'Suisse', 8853, 0, 1),
(3288, 'XA, Leben AG', 'General Guisan-Stras', 'Postfach 357', '8401', 'Winterthur', 'Suisse', 8854, 0, 1),
(3289, 'Zurich Insurance Company Ltd', 'Mythenquai 2', '', '8022', 'Zurich', 'Suisse', 8855, 0, 1),
(3290, 'Basler Leben AG', 'Aeschengraben 21', 'Postfach', '4002', 'Basel', 'Suisse', 8856, 0, 1),
(3291, 'ew, Reinsurance Company Ltd.', 'Zollikerstrasse 226', '', '8008', 'Zürich', 'Suisse', 8857, 0, 1),
(3292, 'Basler Versicherung AG', 'Aeschengraben 21', '', '4002', 'Basel', 'Suisse', 8858, 0, 1),
(3293, 'Schweizerische Mobiliar Versicherungsgesellschaft AG', 'Bundesgasse 35', '', '3001', 'Bern', 'Suisse', 8859, 0, 1),
(3294, 'BC, Investor Services Bank S.A.', 'Badenerstrasse 567', 'Postfach 1292', '8048', 'Zürich', 'Suisse', 8863, 0, 1),
(3295, 'Compagnie Privée de Conseils et d&apos;Investissement', 'Rue Petitot 7', 'Case postale 5345', '1211', 'Genève 11', 'Suisse', 8864, 0, 1),
(3296, 'Remaco Wealth Management AG', 'Postfach 510', '', '4020', 'Basel', 'Suisse', 8865, 0, 1),
(3297, 'F, FINANCE (SUISSE) SA', 'Case postale 3667', '', '1211', 'Genève 3', 'Suisse', 8866, 0, 1),
(3298, 'State Street Bank International GmbH, München, ZN Zürich', 'Beethovenstrasse 19', 'Postfach', '8027', 'Zürich', 'Suisse', 8867, 0, 1),
(3299, 'PATRIMONY 1873 SA', 'Via Peri 21b', '', '6901', 'Lugano', 'Suisse', 8869, 0, 1),
(3300, 'Zähringer Privatbank AG', 'Schmiedenplatz 3', 'Postfach', '3011', 'Bern', 'Suisse', 8871, 0, 1),
(3301, 'IX, SIS AG', 'Brandschenkestrasse ', 'Postfach 1758', '8021', 'Zürich', 'Suisse', 8880, 0, 1),
(3302, 'IX, SIS AG', 'Parking Account', 'Postfach 1758', '8021', 'Zürich', 'Suisse', 8881, 0, 1),
(3303, 'EUREX Clearing AG', 'Mergenthalerallee 61', '', '65760', 'Eschborn', 'Suisse', 8883, 0, 1),
(3304, 'IX, SIS AG', 'MPA-Account', 'Postfach', '8021', 'Zürich', 'Suisse', 8887, 0, 1),
(3305, 'IX, SIS (Terravis) AG', 'Postfach', '', '8021', 'Zürich', 'Suisse', 88871, 0, 1),
(3306, 'Sparkasse Bundespersonal', 'Monbijoustrasse 118', '', '3003', 'Bern', 'Suisse', 8890, 0, 1),
(3307, 'IZ, Bank für Internationalen Zahlungsausgleich', 'Postfach', '', '4002', 'Basel', 'Suisse', 8899, 0, 1),
(3308, '., Metzler seel. Sohn &amp; Co. KGaA', 'Untermainanlage 1', 'Postfach 20 01 38', '60329', 'Frankfurt am Main', 'Suisse', 89002, 0, 1),
(3309, 'Landesbank Berlin AG', 'Alexanderplatz 2', 'Postfach', '10889', 'Berlin', 'Suisse', 89006, 0, 1),
(3310, 'Bankhaus Lampe KG', 'Jägerhofstrasse 10', 'Postfach 10 14 42', '40479', 'Düsseldorf', 'Suisse', 89007, 0, 1),
(3311, 'Bayerische Landesbank', 'Brienner Strasse 18', 'Postfach', '80277', 'München', 'Suisse', 89012, 0, 1),
(3312, 'UniCredit Bank AG', 'Am Tucherpark 16', 'Postfach', '80311', 'München', 'Suisse', 89013, 0, 1),
(3313, 'COMMERZBANK AG', 'Kaiserstrasse 16', 'Postfach', '60261', 'Frankfurt am Main', 'Suisse', 89018, 0, 1),
(3314, 'Bethmann Bank AG', 'Bethmannstrasse 7-9', 'Postfach 10 06 32', '60006', 'Frankfurt am Main', 'Suisse', 89021, 0, 1),
(3315, 'Deutsche Bank AG', 'Börsenstrasse 7-11', 'Postfach', '60272', 'Frankfurt am Main', 'Suisse', 89022, 0, 1),
(3316, 'DekaBank Deutsche Girozentrale', 'Mainzer Landstrasse ', 'Postfach 11 05 23', '60040', 'Frankfurt am Main', 'Suisse', 89023, 0, 1),
(3317, 'Deutsche Postbank AG', 'Friedrich-Ebert-Alle', 'Postfach 40 00', '53105', 'Bonn', 'Suisse', 89024, 0, 1),
(3318, 'Z, Bank AG', 'Platz der Republik', 'Postfach', '60265', 'Frankfurt am Main', 'Suisse', 89025, 0, 1),
(3319, 'Hamburger Sparkasse AG', 'Postfach', '', '20454', 'Hamburg', 'Suisse', 89030, 0, 1),
(3320, '.P., Morgan Securities plc.', '25 Bank Street, Cana', '', 'E14 5JP', 'London', 'Suisse', 89033, 0, 1),
(3321, 'Landesbank Hessen-Thüringen', 'Neue Mainzer Strasse', 'Postfach', '60311', 'Frankfurt am Main', 'Suisse', 89034, 0, 1),
(3322, 'SH, Nordbank AG', 'Martensdamm 6', '', '24103', 'Kiel', 'Suisse', 89036, 0, 1),
(3323, 'Merck Finck &amp; Co Privatbankiers', 'Pacellistrasse 16', 'Postfach', '80333', 'München', 'Suisse', 89042, 0, 1),
(3324, 'Morgan Stanley Bank AG', 'Junghofstrasse 13-15', 'Postfach 10 16 01', '60016', 'Frankfurt am Main', 'Suisse', 89045, 0, 1),
(3325, 'Landesbank Baden-Württemberg', 'Am Hauptbahnhof 2', 'Postfach 10 60 49', '70049', 'Stuttgart', 'Suisse', 89058, 0, 1),
(3326, 'SBC, Trinkaus &amp; Burkhardt AG', 'Königsallee 21/23', 'Postfach 10 11 08', '40002', 'Düsseldorf', 'Suisse', 89059, 0, 1),
(3327, 'Z, Bank AG Deutsche Genossenschaftsbank', 'Ludwig-Erhard-Allee ', 'Postfach 10 10 32', '40227', 'Düsseldorf', 'Suisse', 89060, 0, 1),
(3328, 'Banco Santander, SA, Filiale Frankfurt', 'Bockenheimer Landstr', '', '60325', 'Frankfurt am Main', 'Suisse', 89067, 0, 1),
(3329, 'Goldman Sachs AG', 'MesseTurm/Friedrich-', '', '60308', 'Frankfurt am Main', 'Suisse', 89070, 0, 1),
(3330, 'he, Royal Bank of Scotland Plc', '280, Bishopsgate', '', 'EC2M 4RB', 'London', 'Suisse', 89079, 0, 1),
(3331, 'Dornbirner Sparkasse Bank AG', 'Bahnhofstrasse 2', 'Postfach 199', '6850', 'Dornbirn', 'Suisse', 89081, 0, 1),
(3332, 'Skandinaviska Enskilda Banken AB', 'Kungsträdgardsgatan ', '', 'SE-106 40', 'Stockholm', 'Suisse', 89088, 0, 1),
(3333, 'Landesbank Hessen Thüringen', '3rd Floor, 95 Queen ', '', 'EC4V 4HN', 'London', 'Suisse', 89089, 0, 1),
(3334, 'Z, PRIVATBANK S.A.', '4, rue Thomas Edison', 'Boîte postale 661', '1445', 'Luxembourg-Strassen', 'Suisse', 89091, 0, 1),
(3335, 'Barclays Bank PLC', 'Canary Wharf', '5, The North Colonna', 'E14 4BB', 'London', 'Suisse', 89092, 0, 1),
(3336, 'Volksbank Dreiländereck EG', 'Tumringer-Strasse 23', 'Postfach 2440', '79537', 'Lörrach', 'Suisse', 89093, 0, 1),
(3337, 'Citibank N.A.', 'Canada Square / Cana', '13th Floor Citigroup', 'E14 5LB', 'London', 'Suisse', 89095, 0, 1),
(3338, 'Allgemeine Sparkasse Oberösterreich Bank AG', 'Promenade 11-13', 'Postfach 92', '4041', 'Linz', 'Suisse', 89098, 0, 1),
(3339, 'Erste Group Bank AG', 'Am Belvedere 1', '', '1100', 'Wien', 'Suisse', 89099, 0, 1),
(3340, 'LS, Bank International', '39 Broadway, 29th Fl', '', 'NY 10006', 'New York, NY 1006-3053', 'Suisse', 8910, 0, 1),
(3341, 'Societe Generale International Ltd', '10 Bishops Square', '', 'E1 6EG', 'London', 'Suisse', 89101, 0, 1),
(3342, 'Coöperatieve Rabobank U.A.', 'Croeselann 18', 'P.O. Box 17100', '3500', 'HG Utrecht', 'Suisse', 89102, 0, 1),
(3343, 'UniCredit Bank Austria AG', 'Julius Tandler-Platz', '', '1090', 'Wien', 'Suisse', 89104, 0, 1),
(3344, 'ORD/LB Luxembourg S.A.', '7, rue Lou Hemmer', '', '1748', 'Luxembourg-Findel', 'Suisse', 89105, 0, 1),
(3345, 'AS, Bank N.V.', 'Spuistraat 172', 'P.O. Box 24001', '1000', 'DB Amsterdam', 'Suisse', 89108, 0, 1),
(3346, 'Raiffeisenlandesbank Oberösterreich AG', 'Europaplatz 1a', 'Postfach 455', '4020', 'Linz', 'Suisse', 89109, 0, 1),
(3347, 'Oberbank AG', 'Untere Donaulände 28', '', '4020', 'Linz', 'Suisse', 89112, 0, 1),
(3348, 'Bank, of America N.A.', 'Canary Wharf, 5 Cana', '', 'E14 5AQ', 'London', 'Suisse', 89113, 0, 1),
(3349, 'Swisscanto Funds Centre Limited', '5th Floor, 110, Cann', '', 'EC4N 6EU', 'London', 'Suisse', 89115, 0, 1),
(3350, 'National Bank of Greece S.A.', 'Akadimias 68', '', '106 78', 'Athens', 'Suisse', 89116, 0, 1),
(3351, 'Vorarlberger Landes- und Hyppothekenbank AG', 'Hypo Passage 1', '', '6900', 'Bregenz', 'Suisse', 89117, 0, 1),
(3352, 'BAWAG P.S.K.', 'Georg-Coch-Platz 2', '', '1018', 'Wien', 'Suisse', 89122, 0, 1),
(3353, 'Merrill Lynch International', '2 King Edward Street', '', 'EC1A 1HQ', 'London', 'Suisse', 89123, 0, 1),
(3354, 'Banca IMI S.p.A.', 'Largo Mattioli, 3', '', 'IT-20121', 'Milano', 'Suisse', 89128, 0, 1),
(3355, 'Bank, für Tirol und Vorarlberg Aktiengesellschaft', 'Stadtforum', '', '6020', 'Innsbruck', 'Suisse', 89129, 0, 1),
(3356, 'Banque Internationale à Luxembourg SA', '69, route d&apos;Esc', '', '2953', 'Luxembourg', 'Suisse', 89136, 0, 1),
(3357, 'Raiffeisen Bank International AG', 'Am Stadtpark 9', 'Postfach 50', '1011', 'Wien', 'Suisse', 89139, 0, 1),
(3358, 'European Investment Bank', 'Boulevard Konrad Ade', '', '2950', 'Luxembourg', 'Suisse', 89142, 0, 1),
(3359, 'Aareal Bank AG', 'Paulinenstrasse 15', '', '65189', 'Wiesbaden', 'Suisse', 89144, 0, 1),
(3360, 'Marex Financial Limited', '155 Bishopsgate', '', 'EC2M 3TQ', 'London', 'Suisse', 89149, 0, 1),
(3361, 'NG, Bank N.V.', 'Foppingadreef 7', 'P.O. Box 1800', '1000', 'BV Amsterdam', 'Suisse', 89151, 0, 1),
(3362, 'Sparkasse der Stadt Feldkirch', 'Sparkassenplatz 1', 'Postfach 50', '6800', 'Feldkirch', 'Suisse', 89152, 0, 1),
(3363, 'YPO, TIROL BANK AG', 'Hypo Passage 2', 'Postfach 524', '6020', 'Innsbruck', 'Suisse', 89157, 0, 1),
(3364, 'BC, Europe Limited', 'Riverbank House, 2 S', '', 'EC4R 3BF', 'London', 'Suisse', 89158, 0, 1),
(3365, 'Danske Bank A/S', 'Holmens Kanal 2-12', '', '1092', 'Copenhagen K', 'Suisse', 89162, 0, 1),
(3366, 'Raiffeisenlandesbank Vorarlberg', 'Rheinstrasse 11', 'Postfach 120', '6900', 'Bregenz', 'Suisse', 89165, 0, 1),
(3367, 'CACEIS Bank Deutschland GmbH', 'Lilienthalallee 34-3', '', '80939', 'München', 'Suisse', 89169, 0, 1),
(3368, 'RAIFFEISENLANDESBANK NIEDERÖSTERREICH-WIEN AG', 'Friedrich-Wilhelm-Ra', 'Postfach 991', '1011', 'Wien', 'Suisse', 89171, 0, 1),
(3369, 'Raiffeisen-Landesbank Steiermark AG', 'Kaiserfeldgasse 5-7', 'Postfach 847', '8011', 'Graz', 'Suisse', 89172, 0, 1),
(3370, 'Raiffeisen-Landesbank Tirol AG', 'Adamgasse 1-7', 'Postfach 543', '6021', 'Innsbruck', 'Suisse', 89174, 0, 1),
(3371, 'RW.BANK', 'Kavalleriestrasse 22', '', '40213', 'Düsseldorf', 'Suisse', 89175, 0, 1),
(3372, 'Raiffeisenverband Salzburg eGen', 'Schwarzstrasse 13-15', '', '5020', 'Salzburg', 'Suisse', 89176, 0, 1),
(3373, 'Nomura International plc', '1 Angel Lane', '', 'EC4R 3AB', 'London', 'Suisse', 89183, 0, 1),
(3374, 'Raiffeisenlandesbank Kärnten reg.Gen.m.b.H.', 'Raiffeisenplatz 1', '', '9020', 'Klagenfurt', 'Suisse', 89184, 0, 1),
(3375, 'KS, Bank AG', 'St. Veiter Ring 43', '', 'AT-9020', 'Klagenfurt', 'Suisse', 89185, 0, 1),
(3376, 'Sparkasse Schwaz AG', 'Franz-Josef-Strasse ', 'Postfach 45', '6130', 'Schwaz', 'Suisse', 89186, 0, 1),
(3377, 'Goldman Sachs International', '133 Fleet Street', '', 'EC4A 2BB', 'London', 'Suisse', 89191, 0, 1),
(3378, 'YPO, NOE Gruppe Bank AG', 'Hypogasse 1', '', '3100', 'St. Pölten', 'Suisse', 89193, 0, 1),
(3379, 'KB, Deutsche Industriebank AG', 'Wilhelm-Bötzkes-Stra', '', 'DE-40474', 'Düsseldorf', 'Suisse', 89195, 0, 1),
(3380, 'Abbey National Treasury Services plc London', 'Regents Place, 2 Tri', '', 'NW1 3A', 'London', 'Suisse', 89196, 0, 1),
(3381, 'Nordea Bank AB (publ)', 'Smalandsgatan 17', '', '105 71', 'Stockholm', 'Suisse', 89197, 0, 1),
(3382, 'Volksbank Hochrhein eG', 'Bismarckstrasse 29', '', '79761', 'Waldshut-Tiengen', 'Suisse', 89199, 0, 1),
(3383, 'Sparkasse Hochrhein', 'Bismarckstrasse 7', '', '79761', 'Waldshut-Tiengen', 'Suisse', 89202, 0, 1),
(3384, 'Austrian Anadi Bank AG', 'Domgasse 5', '', '9020', 'Klagenfurt', 'Suisse', 89205, 0, 1),
(3385, 'European Central Counterparty N.V.', 'Strawinskylaan 1163 ', '', '1077', 'BG Amsterdam', 'Suisse', 89206, 0, 1),
(3386, 'Oesterreichische Kontrollbank AG', 'Am Hof 4', '', '1011', 'Wien', 'Suisse', 89207, 0, 1),
(3387, 'Volksbank Rhein-Wehra eG', 'Schützenstrasse 7-11', '', '79713', 'Bad Säckingen', 'Suisse', 89208, 0, 1),
(3388, ' D &amp; F  Man Capital Markets Limited', '3 London Bridge Stre', '', 'SE1 9SG', 'London', 'Suisse', 89212, 0, 1),
(3389, 'Banque de Luxembourg S.A.', '55, rue de Scillas', '', '2529', 'luxembourg', 'Suisse', 89213, 0, 1),
(3390, 'Sparkasse Lörrach-Rheinfelden', 'Haagener Strasse 2', '', '79539', 'Lörrach', 'Suisse', 89214, 0, 1),
(3391, 'CH.Clearnet Limited', '33 Aldgate High Stre', '', 'EC3N 1EA', 'London', 'Suisse', 89215, 0, 1),
(3392, 'BN, AMRO Clearing Bank N.V.', 'Gustav Mahlerlaan 10', '', '1082', 'PP Amsterdam', 'Suisse', 89216, 0, 1),
(3393, 'PostFinance AG', 'Mingerstrasse 20', '', '3030', 'Bern', 'Suisse', 9000, 0, 1);

CREATE TABLE `faturacao_clientes` (
  `ID_Cliente` bigint(30) UNSIGNED NOT NULL,
  `Titulo` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'M',
  `Nome` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Apelido` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Nif` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Endereco` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostal` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Cidade` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Pais` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'PT',
  `Regiao` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Email` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Telefone` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Telemovel` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Fax` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Website` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Grupo` bigint(20) UNSIGNED NOT NULL,
  `MetPagamento` int(10) UNSIGNED NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `Desconto` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaNome` varchar(400) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaTelefone` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaEmail` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaTelemovel` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Account` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Usado` tinyint(1) NOT NULL DEFAULT '0',
  `TimestampCliente` varchar(20) NOT NULL,
  `ID_Prestashop` int(11) DEFAULT NULL,
  `ID_Vendedor` bigint(30) UNSIGNED NOT NULL,
  `ID_Responsavel` bigint(30) UNSIGNED NOT NULL,
  `Annee_Naissance` int(11) DEFAULT NULL,
  `Equipe` text DEFAULT NULL,
  `Photo` text DEFAULT NULL,
  `Role` text DEFAULT NULL,
  `Club` text DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_clientes_grupos` (
  `ID_Grupo` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Ativo` tinyint(1) UNSIGNED NOT NULL DEFAULT '1',
  `Predefinido` tinyint(1) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_cliente_vendedor` (
  `ID_Cliente_Rel` bigint(30) UNSIGNED NOT NULL,
  `ID_Vendedor_Rel` bigint(30) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_compras` (
  `ID_Compra` bigint(20) UNSIGNED NOT NULL,
  `ID_Fornecedor` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoFornecedor` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalFornecedor` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeFornecedor` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoFornecedor` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailFornecedor` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisFornecedor` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoDescarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalDescarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeDescarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoDescarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Numero` varchar(50) NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataPagamento` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `TotalCreditado` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `PlanoContasBanco` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Pago','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL,
  `IBAN` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `BIC_SWIFT` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ComptePostal` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_BVR` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NumeroCompte` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MotifPayment` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TypePayment` int(10) UNSIGNED NOT NULL,
  `ID_BancoFornecedor` bigint(30) UNSIGNED NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_compras_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_Compra` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `PlanoContasTVA` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_compras_notas_credito` (
  `ID_NotaCreditoCompra` bigint(20) UNSIGNED NOT NULL,
  `ID_Fornecedor` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoFornecedor` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalFornecedor` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeFornecedor` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoFornecedor` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailFornecedor` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisFornecedor` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Numero` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `PlanoContasBanco` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Pago','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL,
  `ID_Documento_Origem` bigint(30) UNSIGNED NOT NULL,
  `Tipo_Documento_Origem` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Documento_Origem` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason_Origem` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_compras_notas_credito_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_NotaCreditoCompra` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `PlanoContasTVA` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL,
  `ID_LinhaOrigem` bigint(30) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_consommables` (
  `ID_Consommable` bigint(30) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Cliente` bigint(30) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoClienteDescarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoCliente2Descarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalClienteDescarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeClienteDescarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoClienteDescarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailClienteDescarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisClienteDescarga` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Vendedor_Primeiro` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Vendedor_Segundo` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Debut` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Facturation` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Decompte_pages` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Paiment` smallint(5) UNSIGNED NOT NULL,
  `Referencia` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Remarque` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Prix_noir` decimal(20,6) UNSIGNED NOT NULL,
  `Prix_couleur` decimal(20,6) UNSIGNED NOT NULL,
  `Etat_noir` int(10) UNSIGNED NOT NULL,
  `Etat_couleur` int(10) UNSIGNED NOT NULL,
  `Etat_noir_begin` int(10) UNSIGNED NOT NULL,
  `Etat_couleur_begin` int(10) UNSIGNED NOT NULL,
  `ID_ResponsavelPrimeiro` bigint(30) UNSIGNED NOT NULL,
  `ID_ResponsavelSegundo` bigint(30) UNSIGNED NOT NULL,
  `ForfaitMensuel` decimal(20,6) UNSIGNED NOT NULL,
  `ForfaitNoir` int(10) UNSIGNED NOT NULL,
  `ForfaitCouleur` int(10) UNSIGNED NOT NULL,
  `ForfaitDisponivel` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `Estado` enum('Rascunho','Confirmado','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataCriacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Criacao` bigint(30) UNSIGNED NOT NULL,
  `DataAtualizacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Atualizacao` bigint(30) UNSIGNED NOT NULL,
  `TimeStamp_Consommable` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_consommables_compteurs` (
  `ID_Compteur` bigint(30) UNSIGNED NOT NULL,
  `ID_Consommable` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Ficheiro` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NumContagem` int(10) UNSIGNED NOT NULL,
  `Faturado` tinyint(1) NOT NULL,
  `ContagemPreto` int(10) UNSIGNED NOT NULL,
  `ContagemCores` int(10) UNSIGNED NOT NULL,
  `Fabricante` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Modelo` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoIP` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NumSerie` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MacAddress` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `UltimaVerificacao` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ContadorDispositivo` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NomeDispositivo` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Piso` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Localizacao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NomeAgente` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `VersaoAgente` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DeviceId` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Inatividade` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_consommables_linhas` (
  `ID_Linha` bigint(30) UNSIGNED NOT NULL,
  `ID_Consommable` bigint(30) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_dados_aplicacao` (
  `ID_Dados_Aplicacao` int(10) UNSIGNED NOT NULL,
  `Versao` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `N_Certificado_AT` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Software` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Versao_SAFT_Atual` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Nif_Produtor` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Nome_Produtor` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Header_Comment` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Telefone` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Email` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Website` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_dados_aplicacao` (`ID_Dados_Aplicacao`, `Versao`, `N_Certificado_AT`, `ID_Software`, `Versao_SAFT_Atual`, `Nif_Produtor`, `Nome_Produtor`, `Header_Comment`, `Telefone`, `Email`, `Website`) VALUES
(1, '1.4', '9999', 'Frifacturation', '1.04_01', '', 'Fricode Sàrl', 'Fricode/Frifacturation', '+41 26 422 16 00', 'contact@fricode.ch', 'www.fricode.ch');

CREATE TABLE `faturacao_empresa_dados` (
  `ID_dados_empresa` int(11) NOT NULL,
  `Designacao` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Nif` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegistoComercial` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Endereco1` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Endereco2` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostal` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Cidade` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TipoEmpresa` tinyint(3) NOT NULL DEFAULT 1,
  `Email` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Website` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CapitalSocial` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Conservatoria` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Telefone` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Fax` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Logotipo` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NormaContabilistica` varchar(2) NOT NULL DEFAULT 'S',
  `CAE_Principal` varchar(5) NOT NULL,
  `LaPosteCodigo` varchar(20) NOT NULL,
  `Pays` varchar(2) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_empresa_dados` (`ID_dados_empresa`, `Designacao`, `Nif`, `RegistoComercial`, `Endereco1`, `Endereco2`, `CodigoPostal`, `Cidade`, `TipoEmpresa`, `Email`, `Website`, `CapitalSocial`, `Conservatoria`, `Telefone`, `Fax`, `Logotipo`, `NormaContabilistica`, `CAE_Principal`, `LaPosteCodigo`, `Pays`) VALUES
(1, '', '', '0', '', '', '', '', 0, '', '', '0', '', '', '', 'logotipo.png', 'S', '0', '', '');

CREATE TABLE `faturacao_faturas` (
  `ID_Fatura` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `InvoiceStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `InvoiceStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceBilling` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'P',
  `Hash` varchar(172) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `HashControl` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Hash_Print` varchar(4) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Period` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `InvoiceType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'FT',
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SelfBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `CashVATSchemeIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `ThirdPartiesBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `EACCode` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementStartTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementEndTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TotalLiquidadoDocumento` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalLiquidado` decimal(20,6) UNSIGNED NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `PlanoContasBanco` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Pago','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL,
  `Tipo_Doc_Origem` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Doc_Origem` bigint(30) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Doc_Origem` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `BVR` varchar(27) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Exportada` tinyint(1) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_faturas_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_Fatura` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `PlanoContasTVA` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_faturas_recibo` (
  `ID_FaturaRecibo` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `InvoiceStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `InvoiceStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceBilling` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'P',
  `Hash` varchar(172) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `HashControl` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Hash_Print` varchar(4) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Period` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `InvoiceType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'FR',
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SelfBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `CashVATSchemeIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `ThirdPartiesBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `EACCode` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementStartTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementEndTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TotalLiquidadoDocumento` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalLiquidado` decimal(20,6) UNSIGNED NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `Estado` enum('Rascunho','Pago','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_faturas_recibo_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_FaturaRecibo` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_faturas_simplificadas` (
  `ID_FaturaSimplificada` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `InvoiceStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `InvoiceStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceBilling` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'P',
  `Hash` varchar(172) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `HashControl` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Hash_Print` varchar(4) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Period` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `InvoiceType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'FS',
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SelfBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `CashVATSchemeIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `ThirdPartiesBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `EACCode` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementStartTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementEndTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TotalLiquidadoDocumento` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalLiquidado` decimal(20,6) UNSIGNED NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `Estado` enum('Rascunho','Pago','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_faturas_simplificadas_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_FaturaSimplificada` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_fornecedores` (
  `ID_Fornecedor` bigint(30) UNSIGNED NOT NULL,
  `Titulo` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'M',
  `Nome` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Apelido` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Nif` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Endereco` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostal` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Cidade` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Pais` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'PT',
  `Regiao` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Email` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Telefone` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Telemovel` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Fax` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Website` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Grupo` bigint(20) UNSIGNED NOT NULL,
  `MetPagamento` int(10) UNSIGNED NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `Desconto` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaNome` varchar(400) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaTelefone` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaEmail` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaTelemovel` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Account` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Usado` tinyint(1) NOT NULL DEFAULT '0',
  `TimestampFornecedor` varchar(20) NOT NULL,
  `IBAN` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `BIC_SWIFT` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ComptePostal` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_BVR` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NumeroCompte` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MotifPayment` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TypePayment` int(10) UNSIGNED NOT NULL,
  `ID_BancoFornecedor` bigint(30) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_fornecedores_grupos` (
  `ID_Grupo` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Ativo` tinyint(1) UNSIGNED NOT NULL DEFAULT '1',
  `Predefinido` tinyint(1) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_funcionalidades` (
  `ID_Funcionalidade` int(10) UNSIGNED NOT NULL,
  `Nome` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Posicao` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES
(1, 'Définitions', 1),
(2, 'Autre', 2),
(3, 'Vue Globale', 3),
(4, 'Clients > Clients', 4),
(5, 'Clients > Bulletin Livraison', 5),
(6, 'Clients > Factures', 6),
(7, 'Clients > Notes de Crédit', 7),
(8, 'Contrats > Location', 8),
(9, 'Contrats > Consommables', 9),
(10, 'Fournisseurs > Fournisseurs', 10),
(11, 'Fournisseurs > Factures', 11),
(12, 'Fournisseurs > Notes de Crédit', 12),
(13, 'Tableaux > Articles', 13),
(14, 'Tableaux > Banques', 14),
(15, 'Tableaux > Banques Fournisseurs', 15),
(16, 'Tableaux > Plan Comptable', 16),
(17, 'Tableaux > Taxes (TVA)', 17),
(18, 'Tableaux > Responsables', 18),
(19, 'Tableaux > Vendeurs', 19),
(20, 'TVA > Décompte', 20),
(21, 'TVA > Récapitulatif', 21),
(22, 'Comptabilité > Bilan', 22),
(23, 'Comptabilité > Compte Résultat', 23),
(24, 'Comptabilité > Mouvements', 24),
(25, 'Opérations Bancaires > Gestion BVR', 25),
(26, 'Shop Online > Synchroniser', 26),
(27, 'Shop Online > Archive', 27),
(28, 'Shop Online > Historique', 28),
(29, 'Rechercher > Lignes de Factures', 29),
(30, 'Tableaux > Contrats Responsables', 19);

CREATE TABLE `faturacao_ghosts_artigos` (
  `ID_Artigo` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Tipo` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoBarras` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Categoria` bigint(20) UNSIGNED NOT NULL,
  `ID_Unidade` int(10) UNSIGNED NOT NULL,
  `Preco` decimal(20,6) UNSIGNED NOT NULL,
  `ID_Imposto` bigint(20) UNSIGNED NOT NULL,
  `PrecoPVP` decimal(20,6) UNSIGNED NOT NULL,
  `RetencaoPercentagem` decimal(5,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `RetencaoValor` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `Stock` decimal(20,3) NOT NULL DEFAULT '0.000',
  `Ativo` tinyint(1) NOT NULL DEFAULT '1',
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Usado` tinyint(1) NOT NULL DEFAULT '0',
  `ID_Prestashop` int(11) DEFAULT '0',
  `Estado` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_ghosts_clientes` (
  `ID_Cliente` bigint(30) UNSIGNED NOT NULL,
  `Titulo` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'M',
  `Nome` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Apelido` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Nif` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Endereco` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostal` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Cidade` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Pais` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'PT',
  `Regiao` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Email` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Telefone` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Telemovel` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Fax` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Website` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Grupo` bigint(20) UNSIGNED NOT NULL,
  `MetPagamento` int(10) UNSIGNED NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `Desconto` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaNome` varchar(400) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaTelefone` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaEmail` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PreferenciaTelemovel` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Account` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Usado` tinyint(1) NOT NULL DEFAULT '0',
  `TimestampCliente` varchar(20) NOT NULL,
  `ID_Prestashop` int(11) DEFAULT NULL,
  `Estado` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_ghosts_faturas` (
  `ID_Fatura` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `InvoiceStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `InvoiceStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceBilling` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'P',
  `Hash` varchar(172) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `HashControl` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Hash_Print` varchar(4) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Period` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `InvoiceType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'FT',
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SelfBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `CashVATSchemeIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `ThirdPartiesBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `EACCode` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementStartTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementEndTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TotalLiquidadoDocumento` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalLiquidado` decimal(20,6) UNSIGNED NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `PlanoContasBanco` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Pago','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL,
  `Tipo_Doc_Origem` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Doc_Origem` bigint(30) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Doc_Origem` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `BVR` varchar(27) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EstadoSync` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_ghosts_faturas_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_Fatura` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `PlanoContasTVA` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL,
  `Estado` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_guias_transporte` (
  `ID_GuiaTransporte` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataCarga` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataDescarga` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `HoraCarga` varchar(10) NOT NULL,
  `HoraDescarga` varchar(10) NOT NULL,
  `EnderecoDescarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalDescarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeDescarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoDescarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCarga` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisDescarga` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `InvoiceStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `InvoiceStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceBilling` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'P',
  `Hash` varchar(172) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `HashControl` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Hash_Print` varchar(4) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Period` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `InvoiceType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'FT',
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SelfBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `CashVATSchemeIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `ThirdPartiesBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `EACCode` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementStartTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementEndTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TotalLiquidadoDocumento` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalLiquidado` decimal(20,6) UNSIGNED NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `Estado` enum('Rascunho','Fechado','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL,
  `ATDocCodeID` varchar(200) NOT NULL,
  `DeliveryID` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_guias_transporte_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_GuiaTransporte` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_honorarios` (
  `ID_Honorario` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataValidade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `Estado` enum('Rascunho','Rejeitado','Aprovado','Aberto') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_honorarios_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_Honorario` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_impostos` (
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `Nome` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Valor` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Predefinido` tinyint(1) UNSIGNED NOT NULL,
  `Regiao` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Subclasse` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Tipo` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `Descricao` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `Ativo` tinyint(1) UNSIGNED NOT NULL DEFAULT '1',
  `FinalidadeTexto` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `FinalidadeTipo` enum('C','F') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PlanoContas` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_impostos` (`ID_Imposto`, `Nome`, `Valor`, `Predefinido`, `Regiao`, `Subclasse`, `Tipo`, `Descricao`, `Ativo`, `FinalidadeTexto`, `FinalidadeTipo`, `PlanoContas`) VALUES
(1, 'ETR0', '0', 0, 'CH', 'ISE', 'TVA', 'Prestations à l\'étranger', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200'),
(2, 'Libre', '0', 0, 'CH', 'ISE', 'TVA', 'Non imposable TVA', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200'),
(3, 'Pi25', '2.5', 0, 'CH', 'RED', 'TVA', 'TVA s/invest. Et autres charges d\'exploitation 2.5%', 1, 'Impôt préalable', 'F', '1171'),
(4, 'Pi80', '8.0', 0, 'CH', 'NOR', 'TVA', 'TVA s/invest. Et autres charges d\'exploitation 8.0%', 1, 'Impôt préalable', 'F', '1171'),
(5, 'PM25', '2.5', 0, 'CH', 'RED', 'TVA', 'TVA s/marchandises et prestation de service 2.5%', 1, 'Impôt préalable', 'F', '1170'),
(6, 'PM80', '8.0', 0, 'CH', 'NOR', 'TVA', 'TVA s/marchandises et prestation de service 8%', 1, 'Impôt préalable', 'F', '1170'),
(9, 'PY38', '3.08', 0, 'CH', 'INT', 'TVA', 'Impôt spécial à 3.8% pour une nuit d\'hôtel', 1, 'Impôt préalable', 'F', '1171'),
(10, 'SML25', '2.5', 0, 'CH', 'RED', 'TVA', 'TVA s/prestations à soi-même 2.5%', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200'),
(11, 'SML80', '8', 0, 'CH', 'NOR', 'TVA', 'TVA s/prestations à soi-même 8.0%', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200'),
(12, 'TVA25', '2.5', 0, 'CH', 'RED', 'TVA', 'TVA s/ marchandise et prestation de service 2.5%', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200'),
(13, 'TVA38', '3.8', 0, 'CH', 'INT', 'TVA', 'TVA s/prestations secteur de l\'hébergement 3.8%', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200'),
(14, 'TVA80', '8', 0, 'CH', 'NOR', 'TVA', 'TVA s/marchandise et prestation de service 8.0%', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200'),
(15, 'Libre', '0', 0, 'CH', 'ISE', 'IVA', 'SANS TVA 0%', 1, 'Impôt préalable', 'F', '1170'),
(16, 'PI81', '7.7', 0, 'CH', 'NOR', 'IVA', 'TVA s/invest. et autres charges d\'exploitation 7.7%', 0, 'Impôt préalable', 'F', '1171'),
(17, 'PM81', '7.7', 0, 'CH', 'NOR', 'IVA', 'TVA s/marchandises et prestation de service 7.7%', 0, 'Impôt préalable', 'F', '1170'),
(18, 'TVA81', '7.7', 0, 'CH', 'NOR', 'IVA', 'TVA s/marchandise et prestation de service 7.7%', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200'),
(19, 'PM77', '7.7', 1, 'CH', 'NOR', 'IVA', 'TVA s/marchandises et prestation de service 7.7%', 1, 'Impôt préalable', 'F', '1170'),
(20, 'PI77', '7.7', 0, 'CH', 'NOR', 'IVA', 'TVA s/invest. et autres charges d\'exploitation 7.7%', 1, 'Impôt préalable', 'F', '1171'),
(21, 'TVA77', '7.7', 1, 'CH', 'NOR', 'IVA', 'TVA s/marchandise et prestation de service 7.7%', 1, 'Impôt sur le chiffre d\'affaires', 'C', '2200');

CREATE TABLE `faturacao_impostos_usados` (
  `ID_ImpostoUsado` bigint(20) UNSIGNED NOT NULL,
  `ID_Imposto` bigint(20) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_impostos_usados` (`ID_ImpostoUsado`, `ID_Imposto`) VALUES
(2, 4),
(3, 11),
(4, 0),
(5, 14),
(6, 6),
(7, 3),
(8, 18),
(9, 17),
(10, 16),
(11, 21),
(12, 19),
(13, 2),
(14, 15),
(15, 1);

CREATE TABLE `faturacao_locations` (
  `ID_Location` bigint(30) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Cliente` bigint(30) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Vendedor_Primeiro` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Vendedor_Segundo` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Debut` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Duree` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Paiment` smallint(5) UNSIGNED NOT NULL,
  `Referencia` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Remarque` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Location_Mensuelle` decimal(20,6) UNSIGNED NOT NULL,
  `Emolument_Admin` decimal(20,6) UNSIGNED NOT NULL,
  `TVA_Exclue_Primeiro` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TVA_Exclue_Segundo` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Confirmado','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_ResponsavelPrimeiro` bigint(30) UNSIGNED NOT NULL,
  `ID_ResponsavelSegundo` bigint(30) UNSIGNED NOT NULL,
  `Decompte_pages` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataCriacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Criacao` bigint(30) UNSIGNED NOT NULL,
  `DataAtualizacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Atualizacao` bigint(30) UNSIGNED NOT NULL,
  `TimeStamp_Location` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Cotisation` tinyint(1) unsigned DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_locations_linhas` (
  `ID_Linha` bigint(30) UNSIGNED NOT NULL,
  `ID_Location` bigint(30) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_mapas_iva_gerados` (
  `ID_Mapa` bigint(30) UNSIGNED NOT NULL,
  `Descricao` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `AnoMapa` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TrimestreAno` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Inicio` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Final` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Criacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CriadoPor` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Total` decimal(20,6) NOT NULL,
  `Total_Isento` decimal(20,6) NOT NULL,
  `Total_SIsencao` decimal(20,6) NOT NULL,
  `TotalImpostoNormal` decimal(20,6) NOT NULL,
  `ID_ImpostoNormal` int(10) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_metodos_pagamento` (
  `ID_Metodo` int(10) UNSIGNED NOT NULL,
  `Codigo` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Banco` tinyint(1) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_metodos_pagamento` (`ID_Metodo`, `Codigo`, `Descricao`, `Banco`) VALUES
(1, 'NU', 'Cash', 0),
(3, 'TB', 'Virement Bancaire', 1),
(4, 'CC', 'Carte de Crédit', 1),
(5, 'CD', 'Carte de Débit', 1);

CREATE TABLE `faturacao_modelo_email` (
  `ID_ModeloEmail` bigint(20) UNSIGNED NOT NULL,
  `Assunto` varchar(1000) NOT NULL,
  `Texto` mediumtext NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_modelo_email` (`ID_ModeloEmail`, `Assunto`, `Texto`) VALUES
(1, 'Livraison de facture', '<p>M./Mme&nbsp;{%client%}</p><p><br></p><p>\n</p><p>La facture&nbsp;{%numero_facture%} au montant de&nbsp;{%total%} CHF avec une date de&nbsp;{%date%} est jointe.\n</p><p>\n</p><p><br></p><p><br></p><p>Cordialement,</p><p>Frifacturation.</p>');

CREATE TABLE `faturacao_modulos` (
  `ID_Modulo` int(11) UNSIGNED NOT NULL,
  `Nome` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `ValorAtivacao` decimal(10,2) NOT NULL,
  `ValorAnuidade` decimal(10,2) NOT NULL,
  `Ativo` tinyint(1) NOT NULL DEFAULT '0',
  `DataActivacao` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `DataValidade` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `DataPrimeiraActivacao` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `Mod_Compras` tinyint(1) NOT NULL DEFAULT '0',
  `Mod_Vendas` tinyint(1) NOT NULL DEFAULT '0',
  `Mod_Contratos` tinyint(1) NOT NULL DEFAULT '0',
  `Mod_LojaOnline` tinyint(1) NOT NULL DEFAULT '0',
  `Mod_Contabilidade` tinyint(1) NOT NULL DEFAULT '0',
  `Mod_Avencas` tinyint(1) NOT NULL DEFAULT '0',
  `Mod_Salarios` tinyint(1) NOT NULL DEFAULT '0',
  `Max_Users` int(11) UNSIGNED NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `faturacao_modulos` (`ID_Modulo`, `Nome`, `ValorAtivacao`, `ValorAnuidade`, `Ativo`, `DataActivacao`, `DataValidade`, `DataPrimeiraActivacao`, `Mod_Compras`, `Mod_Vendas`, `Mod_Contratos`, `Mod_LojaOnline`, `Mod_Contabilidade`, `Mod_Avencas`, `Mod_Salarios`, `Max_Users`) VALUES
(1, 'Basic', '0.00', '80.00', 0, '', '', '', 0, 1, 0, 0, 1, 0, 0, 1),
(2, 'Pro', '0.00', '120.00', 0, '', '', '', 1, 1, 1, 1, 1, 0, 0, 1),
(3, 'Demo', '0.00', '0.00', 1, '', '', '', 1, 1, 1, 1, 1, 0, 0, 1);

ALTER TABLE `faturacao_modulos` ADD `Mod_Rapports` TINYINT(1) NOT NULL DEFAULT '0' AFTER `Max_Users`, ADD `Mod_Devis` TINYINT(1) NOT NULL DEFAULT '0' AFTER `Mod_Rapports`;

UPDATE `faturacao_modulos` SET `Mod_Rapports`=1, `Mod_Devis`=1 WHERE `Nome` = 'Pro' OR `Nome` = 'Demo';

CREATE TABLE `faturacao_moedas` (
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `Nome` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ISO_Code` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Simbolo` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Ultima_Taxa` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_moedas` (`ID_Moeda`, `Nome`, `ISO_Code`, `Simbolo`, `Ultima_Taxa`) VALUES
(1, 'Franc Suisse', 'CHF', 'CHF', '1.000000');

CREATE TABLE `faturacao_motivos_isencao` (
  `ID_Motivo` int(10) UNSIGNED NOT NULL,
  `Codigo` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_motivos_isencao` (`ID_Motivo`, `Codigo`, `Descricao`) VALUES
(1, 'M01', 'Artigo 16º nº 6 do CIVA.'),
(2, 'M02', 'Artigo 6º do Decreto-Lei nº 198/90, de 19 de Junho.'),
(3, 'M03', 'Exigibilidade de caixa.'),
(4, 'M04', 'Isento Artigo 13º do CIVA.'),
(5, 'M05', 'Isento Artigo 14º do CIVA.'),
(6, 'M06', 'Isento Artigo 15º do CIVA.'),
(7, 'M07', 'Isento Artigo 9º do CIVA.'),
(8, 'M08', 'IVA - autoliquidação.'),
(9, 'M09', 'IVA - não confere direito a dedução.'),
(10, 'M10', 'IVA - Regime de isenção.'),
(11, 'M11', 'Regime particular do tabaco.'),
(12, 'M12', 'Regime da margem de lucro - Agências de viagens.'),
(13, 'M13', 'Regime da margem de lucro - Bens em segunda mão.'),
(14, 'M14', 'Regime da margem de lucro - Objetos de arte.'),
(15, 'M15', 'Regime da margem de lucro - Objetos de coleção e antiguidades.'),
(16, 'M16', 'Isento Artigo 14º do RITI.'),
(17, 'M20', 'IVA - Regime forfetário'),
(18, 'M99', 'Não sujeito; não tributado (ou similar).');

CREATE TABLE `faturacao_motivos_notas` (
  `ID_Motivo` bigint(20) UNSIGNED NOT NULL,
  `Descricao` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_motivos_notas` (`ID_Motivo`, `Descricao`) VALUES
(1, 'Correction TVA'),
(2, 'Rupture de Stock'),
(3, 'Pas de Réduction'),
(4, 'Produit Rejeté'),
(5, 'Augmentation du Prix'),
(6, 'Produit Incorrect'),
(7, 'Erreur dans le Prix');

CREATE TABLE `faturacao_movimentos_contabilisticos` (
  `ID_Movimento` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PlanoContas_Debito` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PlanoContas_Credito` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Total_PVP` decimal(20,6) NOT NULL,
  `Total_Unit` decimal(20,6) NOT NULL,
  `Total_TVA` decimal(20,6) NOT NULL,
  `TipoMovimento` tinyint(1) NOT NULL,
  `TimeStampMovimento` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NumSerie` bigint(30) UNSIGNED NOT NULL,
  `ID_ImpostoTVA` bigint(30) UNSIGNED NOT NULL,
  `PercentageTVA` decimal(10,2) NOT NULL,
  `SaldoDebit` decimal(20,4) NOT NULL,
  `SaldoCredit` decimal(20,4) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_movimento_bvr_importados` (
  `ID_Movimento` bigint(30) UNSIGNED NOT NULL,
  `Linha` bigint(30) UNSIGNED NOT NULL,
  `TipoMovimento` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DocumentoAssociado` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Both_Transaction_Code` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Both_Transaction_Type` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Participant_ID` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Both_Banking_Account` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Internal_Bank_Reference` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Microfilm_Reference` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Payment_type` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Both_Signed_Amount` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Both_ABS_Amount` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Date_Paid` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Date_Processed` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Date_Credit_Note` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_DateValuta` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Full_BVR` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Short_BVR` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Reject_Code` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Row_Fee` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Resume_Number_Transactions` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Resume_Date_File_Creation` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Resume_Sorting_Key` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Resume_Total_Fees` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DocumentoAssociadoTipo` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `FicheiroBVR` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(300) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_notas_credito` (
  `ID_NotaCredito` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `InvoiceStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `InvoiceStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceBilling` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'P',
  `Hash` varchar(172) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `HashControl` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Hash_Print` varchar(4) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Period` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `InvoiceType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'ND',
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SelfBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `CashVATSchemeIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `ThirdPartiesBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `EACCode` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementStartTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementEndTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TotalLiquidadoDocumento` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalLiquidado` decimal(20,6) UNSIGNED NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `PlanoContasBanco` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Pago','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL,
  `ID_Documento_Origem` bigint(30) UNSIGNED NOT NULL,
  `Tipo_Documento_Origem` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Documento_Origem` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason_Origem` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_notas_credito_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_NotaCredito` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `PlanoContasTVA` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL,
  `ID_LinhaOrigem` bigint(30) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_notas_debito` (
  `ID_NotaDebito` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `InvoiceStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `InvoiceStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceBilling` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'P',
  `Hash` varchar(172) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `HashControl` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Hash_Print` varchar(4) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Period` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `InvoiceType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'ND',
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SelfBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `CashVATSchemeIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `ThirdPartiesBillingIndicator` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `EACCode` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementStartTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementEndTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TotalLiquidadoDocumento` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalLiquidado` decimal(20,6) UNSIGNED NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `Estado` enum('Rascunho','Pago','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL,
  `ID_Documento_Origem` bigint(30) UNSIGNED NOT NULL,
  `Tipo_Documento_Origem` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Documento_Origem` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason_Origem` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_notas_debito_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_NotaDebito` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_npa_localites` (
  `id` int(10) UNSIGNED NOT NULL,
  `npa` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `localite` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `created_at` timestamp NULL DEFAULT NULL,
  `updated_at` timestamp NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `faturacao_npa_localites` (`id`, `npa`, `localite`, `created_at`, `updated_at`) VALUES
(1, '1000', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2, '1001', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3, '1002', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(4, '1003', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(5, '1004', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(6, '1005', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(7, '1006', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(8, '1007', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(9, '1008', 'Prilly', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(10, '1009', 'Pully', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(11, '1010', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(12, '1011', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(13, '1012', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(14, '1014', 'Lausanne ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(15, '1015', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(16, '1017', 'Lausanne Veillon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(17, '1018', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(18, '1019', 'Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(19, '1020', 'Renens VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(20, '1022', 'Chavannes-Renens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(21, '1023', 'Crissier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(22, '1024', 'Ecublens VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(23, '1025', 'St-Sulpice VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(24, '1026', 'Echandens-Denges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(25, '1027', 'Lonay', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(26, '1028', 'Préverenges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(27, '1029', 'Villars-Ste-Croix', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(28, '1030', 'Bussigny-Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(29, '1031', 'Mex VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(30, '1032', 'Romanel-s-Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(31, '1033', 'Cheseaux-Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(32, '1034', 'Boussens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(33, '1035', 'Bournens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(34, '1036', 'Sullens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(35, '1037', 'Etagnières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(36, '1038', 'Bercher', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(37, '1039', 'Cheseaux Polyval', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(38, '1040', 'Echallens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(39, '1041', 'Dommartin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(40, '1042', 'Bettens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(41, '1043', 'Sugnens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(42, '1044', 'Fey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(43, '1045', 'Ogens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(44, '1046', 'Rueyres', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(45, '1047', 'Oppens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(46, '1052', 'Mont-sur-Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(47, '1053', 'Bretigny-Morrens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(48, '1054', 'Morrens VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(49, '1055', 'Froideville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(50, '1058', 'Villars-Tiercelin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(51, '1059', 'Peney-le-Jorat', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(52, '1061', 'Villars-Mendraz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(53, '1062', 'Sottens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(54, '1063', 'Peyres-Possens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(55, '1066', 'Epalinges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(56, '1068', 'Les Monts-de-Pully', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(57, '1070', 'Puidoux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(58, '1071', 'Chexbres', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(59, '1072', 'Forel (Lavaux)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(60, '1073', 'Savigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(61, '1076', 'Ferlens VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(62, '1077', 'Servion', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(63, '1078', 'Essertes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(64, '1080', 'Les Cullayes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(65, '1081', 'Montpreveyres', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(66, '1082', 'Corcelles-le-Jorat', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(67, '1083', 'Mézières VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(68, '1084', 'Carrouge VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(69, '1085', 'Vulliens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(70, '1088', 'Ropraz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(71, '1090', 'La Croix (Lutry)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(72, '1091', 'Grandvaux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(73, '1092', 'Belmont-Lausanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(74, '1093', 'La Conversion', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(75, '1094', 'Paudex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(76, '1095', 'Lutry', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(77, '1096', 'Cully', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(78, '1097', 'Riex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(79, '1098', 'Epesses', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(80, '1110', 'Morges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(81, '1112', 'Echichens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(82, '1113', 'St-Saphorin-Morges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(83, '1114', 'Colombier VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(84, '1115', 'Vullierens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(85, '1116', 'Cottens VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(86, '1117', 'Grancy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(87, '1121', 'Bremblens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(88, '1122', 'Romanel-sur-Morges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(89, '1123', 'Aclens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(90, '1124', 'Gollion', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(91, '1125', 'Monnaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(92, '1126', 'Vaux-sur-Morges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(93, '1127', 'Clarmont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(94, '1128', 'Reverolle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(95, '1131', 'Tolochenaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(96, '1132', 'Lully VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(97, '1134', 'Vufflens-Château', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(98, '1135', 'Denens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(99, '1136', 'Bussy-Chardonney', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(100, '1141', 'Sévery', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(101, '1142', 'Pampigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(102, '1143', 'Apples', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(103, '1144', 'Ballens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(104, '1145', 'Bière', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(105, '1146', 'Mollens VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(106, '1147', 'Montricher', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(107, '1148', 'L\'Isle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(108, '1149', 'Berolle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(109, '1162', 'St-Prex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(110, '1163', 'Etoy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(111, '1164', 'Buchillon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(112, '1165', 'Allaman', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(113, '1166', 'Perroy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(114, '1167', 'Lussy-sur-Morges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(115, '1168', 'Villars-sous-Yens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(116, '1169', 'Yens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(117, '1170', 'Aubonne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(118, '1172', 'Bougy-Villars', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(119, '1173', 'Féchy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(120, '1174', 'Montherod', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(121, '1175', 'Lavigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(122, '1176', 'St-Livres', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(123, '1180', 'Rolle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(124, '1182', 'Gilly', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(125, '1183', 'Bursins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(126, '1184', 'Vinzel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(127, '1185', 'Mont-sur-Rolle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(128, '1186', 'Essertines-Rolle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(129, '1187', 'St-Oyens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(130, '1188', 'Gimel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(131, '1189', 'Saubraz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(132, '1195', 'Dully-Bursinel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(133, '1196', 'Gland', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(134, '1197', 'Prangins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(135, '1200', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(136, '1201', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(137, '1202', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(138, '1203', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(139, '1204', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(140, '1205', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(141, '1206', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(142, '1207', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(143, '1208', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(144, '1209', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(145, '1210', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(146, '1211', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(147, '1212', 'Grand-Lancy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(148, '1213', 'Petit-Lancy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(149, '1214', 'Vernier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(150, '1215', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(151, '1216', 'Cointrin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(152, '1217', 'Meyrin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(153, '1218', 'Le Grand-Saconnex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(154, '1219', 'Le Lignon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(155, '1220', 'Les Avanchets', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(156, '1222', 'Vésenaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(157, '1223', 'Cologny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(158, '1224', 'Chêne-Bougeries', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(159, '1225', 'Chêne-Bourg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(160, '1226', 'Thônex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(161, '1227', 'Carouge GE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(162, '1228', 'Plan-les-Ouates', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(163, '1231', 'Conches', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(164, '1232', 'Confignon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(165, '1233', 'Bernex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(166, '1234', 'Vessy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(167, '1236', 'Cartigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(168, '1237', 'Avully', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(169, '1239', 'Collex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(170, '1240', 'Genève', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(171, '1241', 'Puplinge', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(172, '1242', 'Satigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(173, '1243', 'Presinge', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(174, '1244', 'Choulex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(175, '1245', 'Collonge-Bellerive', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(176, '1246', 'Corsier GE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(177, '1247', 'Anières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(178, '1248', 'Hermance', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(179, '1251', 'Gy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(180, '1252', 'Meinier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(181, '1253', 'Vandoeuvres', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(182, '1254', 'Jussy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(183, '1255', 'Veyrier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(184, '1256', 'Troinex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(185, '1257', 'La Croix-de-Rozon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(186, '1258', 'Perly', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(187, '1260', 'Nyon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(188, '1261', 'Marchissy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(189, '1262', 'Eysins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(190, '1263', 'Crassier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(191, '1264', 'St-Cergue', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(192, '1265', 'La Cure', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(193, '1266', 'Duillier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(194, '1267', 'Vich-Coinsins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(195, '1268', 'Burtigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(196, '1269', 'Bassins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(197, '1270', 'Trélex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(198, '1271', 'Givrins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(199, '1272', 'Genolier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(200, '1273', 'Arzier-Le Muids', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(201, '1274', 'Grens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(202, '1275', 'Chéserex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(203, '1276', 'Gingins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(204, '1277', 'Borex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(205, '1278', 'La Rippe', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(206, '1279', 'Chavannes-de-Bogis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(207, '1281', 'Russin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(208, '1283', 'Dardagny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(209, '1284', 'Chancy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(210, '1285', 'Athenaz (Avusy)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(211, '1286', 'Soral', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(212, '1287', 'Laconnex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(213, '1288', 'Aire-la-Ville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(214, '1290', 'Versoix', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(215, '1291', 'Commugny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(216, '1292', 'Chambésy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(217, '1293', 'Bellevue', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(218, '1294', 'Genthod', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(219, '1295', 'Mies-Tannay', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(220, '1296', 'Coppet', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(221, '1297', 'Founex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(222, '1298', 'Céligny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(223, '1299', 'Crans-près-Céligny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(224, '1300', 'Eclépens CC', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(225, '1302', 'Vufflens-la-Ville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(226, '1303', 'Penthaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(227, '1304', 'Senarclens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(228, '1305', 'Penthalaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(229, '1306', 'Daillens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(230, '1307', 'Lussery-Villars', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(231, '1308', 'La Chaux-Cossonay', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(232, '1310', 'Daillens ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(233, '1311', 'Eclépens SC', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(234, '1312', 'Eclépens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(235, '1313', 'Ferreyres', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(236, '1315', 'La Sarraz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(237, '1316', 'Chevilly', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(238, '1317', 'Orny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(239, '1318', 'Pompaples', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(240, '1320', 'Daillens ST PP 1', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(241, '1321', 'Arnex-sur-Orbe', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(242, '1322', 'Croy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(243, '1323', 'Romainmôtier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(244, '1324', 'Premier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(245, '1325', 'Vaulion', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(246, '1326', 'Juriens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(247, '1329', 'Bretonnières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(248, '1330', 'Daillens CALL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(249, '1337', 'Vallorbe', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(250, '1338', 'Ballaigues', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(251, '1341', 'Orient', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(252, '1342', 'Le Pont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(253, '1343', 'Les Charbonnières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(254, '1344', 'L\'Abbaye', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(255, '1345', 'Le Lieu', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(256, '1346', 'Les Bioux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(257, '1347', 'Le Sentier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(258, '1348', 'Le Brassus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(259, '1350', 'Orbe', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(260, '1352', 'Agiez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(261, '1353', 'Bofflens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(262, '1354', 'Montcherand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(263, '1355', 'L\'Abergement', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(264, '1356', 'Les Clées', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(265, '1357', 'Lignerolle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(266, '1358', 'Valeyres-Rances', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(267, '1372', 'Bavois', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(268, '1373', 'Chavornay', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(269, '1374', 'Corcelles-Chavorn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(270, '1375', 'Penthéréaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(271, '1376', 'Goumoens-la-Ville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(272, '1377', 'Oulens-Echallens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(273, '1400', 'Yverdon-les-Bains', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(274, '1401', 'Yverdon-les-Bains', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(275, '1404', 'Cuarny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(276, '1405', 'Pomy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(277, '1406', 'Cronay', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(278, '1407', 'Bioley-Magnoux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(279, '1408', 'Prahins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(280, '1409', 'Chanéaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(281, '1410', 'Thierrens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(282, '1412', 'Valeyres-Ursins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(283, '1413', 'Orzens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(284, '1415', 'Molondin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(285, '1416', 'Pailly', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(286, '1417', 'Epautheyres', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(287, '1418', 'Vuarrens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(288, '1420', 'Fiez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(289, '1421', 'Fontaines-Grandson', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(290, '1422', 'Grandson', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(291, '1423', 'Villars-Burquin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(292, '1424', 'Champagne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(293, '1425', 'Onnens VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(294, '1426', 'Concise', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(295, '1427', 'Bonvillars', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(296, '1428', 'Mutrux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(297, '1429', 'Giez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(298, '1430', 'Orges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(299, '1431', 'Vugelles-La Mothe', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(300, '1432', 'Belmont-Yverdon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(301, '1433', 'Suchy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(302, '1434', 'Ependes VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(303, '1435', 'Essert-Pittet', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(304, '1436', 'Treycovagnes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(305, '1437', 'Suscévaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(306, '1438', 'Mathod', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(307, '1439', 'Rances', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(308, '1440', 'Montagny-Chamard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(309, '1441', 'Valeyres-Montagny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(310, '1442', 'Montagny-Yverdon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(311, '1443', 'Champvent', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(312, '1445', 'Vuiteboeuf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(313, '1446', 'Baulmes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(314, '1450', 'Ste-Croix', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(315, '1452', 'Les Rasses', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(316, '1453', 'Mauborget', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(317, '1454', 'L\'Auberson', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(318, '1462', 'Yvonand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(319, '1463', 'Rovray', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(320, '1464', 'Chavannes-le-Chêne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(321, '1468', 'Cheyres', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(322, '1470', 'Estavayer-le-Lac', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(323, '1473', 'Font', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(324, '1474', 'Châbles FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(325, '1475', 'Autavaux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(326, '1482', 'Cugy FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(327, '1483', 'Montet (Broye)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(328, '1484', 'Aumont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(329, '1485', 'Nuvilly', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(330, '1486', 'Vuissens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(331, '1489', 'Murist', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(332, '1509', 'Vucherens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(333, '1510', 'Syens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(334, '1512', 'Chavannes-s-Moudon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(335, '1513', 'Hermenches', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(336, '1514', 'Bussy-sur-Moudon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(337, '1515', 'Villars-le-Comte', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(338, '1521', 'Curtilles', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(339, '1522', 'Oulens-sur-Lucens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(340, '1523', 'Granges-Marnand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(341, '1524', 'Marnand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(342, '1525', 'Henniez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(343, '1526', 'Forel-sur-Lucens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(344, '1527', 'Villeneuve FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(345, '1528', 'Surpierre', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(346, '1529', 'Cheiry', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(347, '1530', 'Payerne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(348, '1532', 'Fétigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(349, '1533', 'Ménières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(350, '1534', 'Sassel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(351, '1535', 'Combremont-Grand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(352, '1536', 'Combremont-Petit', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(353, '1537', 'Champtauroz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(354, '1538', 'Treytorrens-Payern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(355, '1541', 'Bussy FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(356, '1542', 'Rueyres-les-Prés', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(357, '1543', 'Grandcour', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(358, '1544', 'Gletterens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(359, '1545', 'Chevroux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(360, '1551', 'Vers-chez-Perrin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(361, '1552', 'Trey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(362, '1553', 'Châtonnaye', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(363, '1554', 'Sédeilles', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(364, '1555', 'Villarzel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(365, '1562', 'Corcelles-Payerne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(366, '1563', 'Dompierre FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(367, '1564', 'Domdidier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(368, '1565', 'Missy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(369, '1566', 'St-Aubin FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(370, '1567', 'Delley', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(371, '1568', 'Portalban', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(372, '1580', 'Avenches', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(373, '1583', 'Villarepos', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(374, '1584', 'Villars-le-Grand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(375, '1585', 'Salavaux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(376, '1586', 'Vallamand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(377, '1587', 'Montmagny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(378, '1588', 'Cudrefin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(379, '1589', 'Chabrey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(380, '1595', 'Faoug', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(381, '1607', 'Palézieux-Village', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(382, '1608', 'Oron-le-Châtel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(383, '1609', 'St-Martin FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(384, '1610', 'Châtillens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(385, '1611', 'Le Crêt-p-Semsales', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(386, '1612', 'Ecoteaux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(387, '1613', 'Maracon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(388, '1614', 'Granges (Veveyse)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(389, '1615', 'Bossonnens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(390, '1616', 'Attalens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(391, '1617', 'Remaufens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(392, '1618', 'Châtel-St-Denis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(393, '1619', 'Les Paccots', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(394, '1623', 'Semsales', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(395, '1624', 'La Verrerie', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(396, '1625', 'Sâles (Gruyère)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(397, '1626', 'Romanens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(398, '1627', 'Vaulruz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(399, '1628', 'Vuadens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(400, '1630', 'Bulle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(401, '1631', 'Bulle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(402, '1632', 'Riaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(403, '1633', 'Vuippens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(404, '1634', 'La Roche FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(405, '1635', 'La Tour-de-Trême', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(406, '1636', 'Broc', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(407, '1637', 'Charmey (Gruyère)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(408, '1638', 'Morlon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(409, '1642', 'Sorens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(410, '1643', 'Gumefens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(411, '1644', 'Avry-devant-Pont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(412, '1645', 'Le Bry', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(413, '1646', 'Echarlens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(414, '1647', 'Corbières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(415, '1648', 'Hauteville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(416, '1649', 'Pont-la-Ville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(417, '1651', 'Villarvolard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(418, '1652', 'Botterens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(419, '1653', 'Châtel-Montsalvens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(420, '1654', 'Cerniat FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(421, '1656', 'Im Fang', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(422, '1657', 'Abländschen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(423, '1658', 'La Tine', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(424, '1659', 'Flendruz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(425, '1660', 'Les Moulins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(426, '1661', 'Pâquier-Montbarry', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(427, '1663', 'Moléson-s-Gruyères', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(428, '1665', 'Estavannens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(429, '1666', 'Grandvillard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(430, '1667', 'Enney', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(431, '1669', 'Neirivue', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(432, '1670', 'Ursy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(433, '1673', 'Auboranges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(434, '1674', 'Vuarmarens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(435, '1675', 'Vauderens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(436, '1676', 'Chavannes-Forts', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(437, '1677', 'Prez-vers-Siviriez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(438, '1678', 'Siviriez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(439, '1679', 'Villaraboud', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(440, '1680', 'Romont FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(441, '1681', 'Billens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(442, '1682', 'Villars-Bramard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(443, '1683', 'Brenles', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(444, '1684', 'Mézières FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(445, '1685', 'Villariaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(446, '1686', 'Grangettes-Romont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(447, '1687', 'Estévenens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(448, '1688', 'Sommentier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(449, '1689', 'Châtelard-p-Romont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(450, '1690', 'Villaz-St-Pierre', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(451, '1691', 'Villarimboud', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(452, '1692', 'Massonnens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(453, '1694', 'Orsonnens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(454, '1695', 'Villarlod', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(455, '1696', 'Vuisternens-Ogoz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(456, '1697', 'La Joux FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(457, '1699', 'Bouloz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(458, '1700', 'Fribourg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(459, '1701', 'Fribourg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(460, '1702', 'Fribourg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(461, '1704', 'Fribourg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(462, '1705', 'Fribourg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(463, '1707', 'Fribourg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(464, '1708', 'Fribourg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(465, '1709', 'Fribourg Beaumont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(466, '1712', 'Tafers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(467, '1713', 'St. Antoni', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(468, '1714', 'Heitenried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(469, '1715', 'Alterswil FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(470, '1716', 'Schwarzsee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(471, '1717', 'St. Ursen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(472, '1718', 'Rechthalten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(473, '1719', 'Brünisried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(474, '1720', 'Corminboeuf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(475, '1721', 'Misery-Courtion', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(476, '1722', 'Bourguillon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(477, '1723', 'Marly', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(478, '1724', 'Bonnefontaine', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(479, '1725', 'Posieux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(480, '1726', 'Farvagny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(481, '1727', 'Corpataux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(482, '1728', 'Rossens FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(483, '1730', 'Ecuvillens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(484, '1731', 'Ependes FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(485, '1732', 'Arconciel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(486, '1733', 'Treyvaux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(487, '1734', 'Tentlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(488, '1735', 'Giffers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(489, '1736', 'St. Silvester', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(490, '1737', 'Plasselb', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(491, '1738', 'Sangernboden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(492, '1740', 'Neyruz FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(493, '1741', 'Cottens FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(494, '1742', 'Autigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(495, '1744', 'Chénens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(496, '1745', 'Lentigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(497, '1746', 'Prez-vers-Noréaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(498, '1747', 'Corserey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(499, '1748', 'Torny-le-Grand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(500, '1749', 'Middes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(501, '1752', 'Villars-sur-Glâne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(502, '1753', 'Matran', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(503, '1754', 'Rosé', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(504, '1756', 'Onnens FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(505, '1757', 'Noréaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(506, '1762', 'Givisiez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(507, '1763', 'Granges-Paccot', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(508, '1772', 'Grolley', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(509, '1773', 'Léchelles', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(510, '1774', 'Cousset', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(511, '1775', 'Mannens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(512, '1776', 'Montagny-la-Ville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(513, '1782', 'Belfaux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(514, '1783', 'Pensier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(515, '1784', 'Courtepin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(516, '1785', 'Cressier FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(517, '1786', 'Sugiez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(518, '1787', 'Môtier (Vully)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(519, '1788', 'Praz (Vully)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(520, '1789', 'Lugnorre', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(521, '1791', 'Courtaman', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(522, '1792', 'Cordast', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(523, '1793', 'Jeuss', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(524, '1794', 'Salvenach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(525, '1795', 'Courlevon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(526, '1796', 'Courgevaux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(527, '1797', 'Münchenwiler', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(528, '1800', 'Vevey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(529, '1801', 'Le Mont-Pèlerin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(530, '1802', 'Corseaux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(531, '1803', 'Chardonne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(532, '1804', 'Corsier-sur-Vevey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(533, '1805', 'Jongny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(534, '1806', 'St-Légier-Chiésaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(535, '1807', 'Blonay', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(536, '1808', 'Monts-de-Corsier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(537, '1809', 'Fenil-sur-Corsier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(538, '1811', 'Vevey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(539, '1814', 'La Tour-de-Peilz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(540, '1815', 'Clarens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(541, '1816', 'Chailly-Montreux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(542, '1817', 'Brent', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(543, '1818', 'Montreux Redoute', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(544, '1820', 'Montreux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(545, '1822', 'Chernex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(546, '1823', 'Glion', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(547, '1824', 'Caux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(548, '1832', 'Villard-sur-Chamby', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(549, '1833', 'Les Avants', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(550, '1844', 'Villeneuve VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(551, '1845', 'Noville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(552, '1846', 'Chessel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(553, '1847', 'Rennaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(554, '1852', 'Roche VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(555, '1853', 'Yvorne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(556, '1854', 'Leysin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(557, '1856', 'Corbeyrier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(558, '1860', 'Aigle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(559, '1862', 'La Comballaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(560, '1863', 'Le Sépey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(561, '1864', 'Vers-l\'Eglise', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(562, '1865', 'Les Diablerets', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(563, '1866', 'La Forclaz VD', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(564, '1867', 'St-Triphon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(565, '1868', 'Collombey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(566, '1869', 'Massongex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(567, '1870', 'Monthey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(568, '1871', 'Choëx', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(569, '1872', 'Troistorrents', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(570, '1873', 'Val-d\'Illiez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(571, '1874', 'Champéry', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(572, '1875', 'Morgins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(573, '1880', 'Bex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(574, '1882', 'Gryon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(575, '1884', 'Huémoz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(576, '1885', 'Chesières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(577, '1890', 'St-Maurice', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(578, '1891', 'Vérossaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(579, '1892', 'Lavey-Village', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(580, '1893', 'Muraz (Collombey)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(581, '1895', 'Vionnaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(582, '1896', 'Vouvry', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(583, '1897', 'Les Evouettes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(584, '1898', 'St-Gingolph', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(585, '1899', 'Torgon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(586, '1902', 'Evionnaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(587, '1903', 'Collonges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(588, '1904', 'Vernayaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(589, '1905', 'Dorénaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(590, '1906', 'Charrat', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(591, '1907', 'Saxon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(592, '1908', 'Riddes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(593, '1911', 'Ovronnaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(594, '1912', 'Leytron', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(595, '1913', 'Saillon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(596, '1914', 'Isérables', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(597, '1918', 'La Tzoumaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(598, '1919', 'Martigny Mutuel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(599, '1920', 'Martigny', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(600, '1921', 'Martigny-Croix', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(601, '1922', 'Salvan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(602, '1923', 'Le Trétien', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(603, '1925', 'Le Châtelard VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(604, '1926', 'Fully', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(605, '1927', 'Chemin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(606, '1928', 'Ravoire', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(607, '1929', 'Trient', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(608, '1932', 'Bovernier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(609, '1933', 'Sembrancher', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(610, '1934', 'Le Châble VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(611, '1936', 'Verbier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(612, '1937', 'Orsières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(613, '1938', 'Champex-Lac', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(614, '1941', 'Vollèges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(615, '1942', 'Levron', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(616, '1943', 'Praz-de-Fort', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(617, '1944', 'La Fouly VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(618, '1945', 'Liddes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(619, '1946', 'Bourg-St-Pierre', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(620, '1947', 'Versegères', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(621, '1948', 'Lourtier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(622, '1950', 'Sion', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(623, '1951', 'Sion', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(624, '1953', 'Sion RZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(625, '1955', 'Chamoson', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(626, '1957', 'Ardon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(627, '1958', 'St-Léonard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(628, '1961', 'Vernamiège', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(629, '1962', 'Pont-de-la-Morge', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(630, '1963', 'Vétroz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(631, '1964', 'Conthey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(632, '1965', 'Savièse', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(633, '1966', 'Ayent', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(634, '1967', 'Bramois', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(635, '1968', 'Mase', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(636, '1969', 'St-Martin VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(637, '1971', 'Grimisuat', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(638, '1972', 'Anzère', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(639, '1973', 'Nax', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(640, '1974', 'Arbaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(641, '1975', 'St-Séverin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(642, '1976', 'Erde', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(643, '1977', 'Icogne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(644, '1978', 'Lens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(645, '1981', 'Vex', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(646, '1982', 'Euseigne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(647, '1983', 'Evolène', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(648, '1984', 'Les Haudères', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(649, '1985', 'La Sage', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(650, '1986', 'Arolla', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(651, '1987', 'Hérémence', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(652, '1988', 'Les Collons', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(653, '1991', 'Salins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(654, '1992', 'Les Agettes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(655, '1993', 'Veysonnaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(656, '1994', 'Aproz (Nendaz)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(657, '1996', 'Fey (Nendaz)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(658, '1997', 'Siviez (Nendaz)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(659, '2000', 'Neuchâtel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(660, '2001', 'Neuchâtel 1 ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(661, '2002', 'Neuchâtel 2', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(662, '2003', 'Neuchâtel 3', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(663, '2004', 'Neuchâtel 4', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(664, '2006', 'Neuchâtel 6', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(665, '2007', 'Neuchâtel 7', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(666, '2008', 'Neuchâtel 8', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(667, '2009', 'Neuchâtel 9', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(668, '2010', 'Neuchâtel OFS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(669, '2012', 'Auvernier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(670, '2013', 'Colombier NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(671, '2014', 'Bôle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(672, '2015', 'Areuse', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(673, '2016', 'Cortaillod', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(674, '2017', 'Boudry', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(675, '2019', 'Chambrelien', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(676, '2022', 'Bevaix', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(677, '2023', 'Gorgier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(678, '2024', 'St-Aubin-Sauges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(679, '2025', 'Chez-le-Bart', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(680, '2027', 'Montalchez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(681, '2028', 'Vaumarcus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(682, '2034', 'Peseux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(683, '2035', 'Corcelles NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(684, '2036', 'Cormondrèche', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(685, '2037', 'Montmollin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(686, '2042', 'Valangin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(687, '2043', 'Boudevilliers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(688, '2046', 'Fontaines NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(689, '2052', 'Fontainemelon', '2017-06-02 18:00:00', '2017-06-02 18:00:00');
INSERT INTO `faturacao_npa_localites` (`id`, `npa`, `localite`, `created_at`, `updated_at`) VALUES
(690, '2053', 'Cernier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(691, '2054', 'Chézard-St-Martin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(692, '2056', 'Dombresson', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(693, '2057', 'Villiers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(694, '2058', 'Le Pâquier NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(695, '2063', 'Vilars NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(696, '2065', 'Savagnier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(697, '2067', 'Chaumont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(698, '2068', 'Hauterive NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(699, '2072', 'St-Blaise', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(700, '2073', 'Enges', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(701, '2074', 'Marin-Epagnier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(702, '2075', 'Thielle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(703, '2087', 'Cornaux NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(704, '2088', 'Cressier NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(705, '2103', 'Noiraigue', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(706, '2105', 'Travers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(707, '2108', 'Couvet', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(708, '2112', 'Môtiers NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(709, '2113', 'Boveresse', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(710, '2114', 'Fleurier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(711, '2115', 'Buttes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(712, '2116', 'Mont-de-Buttes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(713, '2117', 'La Côte-aux-Fées', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(714, '2123', 'St-Sulpice NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(715, '2124', 'Les Sagnettes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(716, '2126', 'Les Verrières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(717, '2127', 'Les Bayards', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(718, '2149', 'Champ-du-Moulin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(719, '2206', 'Geneveys-Coffrane', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(720, '2207', 'Coffrane', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(721, '2208', 'Les Hauts-Geneveys', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(722, '2300', 'La Chaux-de-Fonds', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(723, '2301', 'La Chaux-de-Fonds', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(724, '2302', 'La Chaux-de-Fonds', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(725, '2303', 'La Chaux-de-Fonds', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(726, '2304', 'La Chaux-de-Fonds', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(727, '2305', 'La Chaux-de-Fonds', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(728, '2314', 'La Sagne NE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(729, '2316', 'Petit-Martel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(730, '2318', 'Brot-Plamboz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(731, '2322', 'Le Crêt-du-Locle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(732, '2325', 'Les Planchettes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(733, '2333', 'La Ferrière', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(734, '2336', 'Les Bois', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(735, '2338', 'Les Emibois', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(736, '2340', 'Le Noirmont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(737, '2345', 'Les Breuleux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(738, '2350', 'Saignelégier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(739, '2353', 'Les Pommerats', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(740, '2354', 'Goumois', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(741, '2360', 'Le Bémont JU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(742, '2362', 'Montfaucon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(743, '2363', 'Les Enfers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(744, '2364', 'St-Brais', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(745, '2400', 'Le Locle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(746, '2405', 'La Chaux-du-Milieu', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(747, '2406', 'La Brévine', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(748, '2414', 'Cerneux-Péquignot', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(749, '2416', 'Les Brenets', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(750, '2500', 'Biel/Bienne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(751, '2501', 'Biel/Bienne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(752, '2502', 'Biel/Bienne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(753, '2503', 'Biel/Bienne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(754, '2504', 'Biel/Bienne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(755, '2505', 'Biel/Bienne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(756, '2510', 'Biel/Bienne ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(757, '2512', 'Tüscherz-Alfermée', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(758, '2513', 'Twann', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(759, '2514', 'Ligerz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(760, '2515', 'Prêles', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(761, '2516', 'Lamboing', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(762, '2517', 'Diesse', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(763, '2518', 'Nods', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(764, '2520', 'La Neuveville', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(765, '2523', 'Lignières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(766, '2525', 'Le Landeron', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(767, '2532', 'Magglingen/Macolin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(768, '2533', 'Evilard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(769, '2534', 'Orvin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(770, '2535', 'Frinvillier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(771, '2536', 'Plagne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(772, '2537', 'Vauffelin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(773, '2538', 'Romont BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(774, '2540', 'Grenchen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(775, '2542', 'Pieterlen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(776, '2543', 'Lengnau BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(777, '2544', 'Bettlach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(778, '2545', 'Selzach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(779, '2552', 'Orpund', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(780, '2553', 'Safnern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(781, '2554', 'Meinisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(782, '2555', 'Brügg BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(783, '2556', 'Scheuren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(784, '2557', 'Studen BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(785, '2558', 'Aegerten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(786, '2560', 'Nidau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(787, '2562', 'Port', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(788, '2563', 'Ipsach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(789, '2564', 'Bellmund', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(790, '2565', 'Jens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(791, '2572', 'Sutz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(792, '2575', 'Täuffelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(793, '2576', 'Lüscherz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(794, '2577', 'Siselen BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(795, '2603', 'Péry', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(796, '2604', 'La Heutte', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(797, '2605', 'Sonceboz-Sombeval', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(798, '2606', 'Corgémont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(799, '2607', 'Cortébert', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(800, '2608', 'Courtelary', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(801, '2610', 'St-Imier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(802, '2612', 'Cormoret', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(803, '2613', 'Villeret', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(804, '2615', 'Sonvilier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(805, '2616', 'Renan BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(806, '2710', 'Tavannes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(807, '2712', 'Le Fuet', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(808, '2713', 'Bellelay', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(809, '2714', 'Le Prédame', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(810, '2715', 'Châtelat-Monible', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(811, '2716', 'Sornetan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(812, '2717', 'Fornet-Dessous', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(813, '2718', 'Fornet-Dessus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(814, '2720', 'Tramelan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(815, '2722', 'Les Reussilles', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(816, '2723', 'Mont-Tramelan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(817, '2732', 'Reconvilier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(818, '2733', 'Pontenet', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(819, '2735', 'Malleray-Bévilard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(820, '2736', 'Sorvilier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(821, '2738', 'Court', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(822, '2740', 'Moutier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(823, '2742', 'Perrefitte', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(824, '2743', 'Eschert', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(825, '2744', 'Belprahon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(826, '2745', 'Grandval', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(827, '2746', 'Crémines', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(828, '2747', 'Seehof', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(829, '2748', 'Souboz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(830, '2762', 'Roches BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(831, '2800', 'Delémont', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(832, '2802', 'Develier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(833, '2803', 'Bourrignon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(834, '2805', 'Soyhières', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(835, '2806', 'Mettembert', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(836, '2807', 'Pleigne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(837, '2812', 'Movelier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(838, '2813', 'Ederswiler', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(839, '2814', 'Roggenburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(840, '2822', 'Courroux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(841, '2823', 'Courcelon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(842, '2824', 'Vicques', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(843, '2825', 'Courchapoix', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(844, '2826', 'Corban', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(845, '2827', 'Mervelier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(846, '2828', 'Montsevelier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(847, '2829', 'Vermes', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(848, '2830', 'Courrendlin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(849, '2832', 'Rebeuvelier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(850, '2842', 'Rossemaison', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(851, '2843', 'Châtillon JU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(852, '2852', 'Courtételle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(853, '2853', 'Courfaivre', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(854, '2854', 'Bassecourt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(855, '2855', 'Glovelier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(856, '2856', 'Boécourt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(857, '2857', 'Montavon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(858, '2863', 'Undervelier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(859, '2864', 'Soulce', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(860, '2873', 'Saulcy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(861, '2882', 'St-Ursanne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(862, '2883', 'Montmelon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(863, '2884', 'Montenol', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(864, '2885', 'Epauvillers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(865, '2886', 'Epiquerez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(866, '2887', 'Soubey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(867, '2888', 'Seleute', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(868, '2889', 'Ocourt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(869, '2900', 'Porrentruy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(870, '2902', 'Fontenais', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(871, '2903', 'Villars-Fontenais', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(872, '2904', 'Bressaucourt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(873, '2905', 'Courtedoux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(874, '2906', 'Chevenez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(875, '2907', 'Rocourt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(876, '2908', 'Grandfontaine', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(877, '2912', 'Roche-d\'Or', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(878, '2914', 'Damvant', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(879, '2915', 'Bure', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(880, '2916', 'Fahy', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(881, '2922', 'Courchavon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(882, '2923', 'Courtemaîche', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(883, '2924', 'Montignez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(884, '2925', 'Buix', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(885, '2926', 'Boncourt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(886, '2932', 'Coeuve', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(887, '2933', 'Damphreux', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(888, '2935', 'Beurnevésin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(889, '2942', 'Alle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(890, '2943', 'Vendlincourt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(891, '2944', 'Bonfol', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(892, '2946', 'Miécourt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(893, '2947', 'Charmoille', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(894, '2950', 'Courgenay', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(895, '2952', 'Cornol', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(896, '2953', 'Fregiécourt-Pleuj', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(897, '2954', 'Asuel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(898, '3000', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(899, '3001', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(900, '3002', 'Bern ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(901, '3003', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(902, '3004', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(903, '3005', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(904, '3006', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(905, '3007', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(906, '3008', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(907, '3010', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(908, '3011', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(909, '3012', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(910, '3013', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(911, '3014', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(912, '3015', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(913, '3017', 'Bern Zustellung', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(914, '3018', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(915, '3019', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(916, '3020', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(917, '3024', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(918, '3027', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(919, '3029', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(920, '3030', 'Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(921, '3032', 'Hinterkappelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(922, '3033', 'Wohlen b. Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(923, '3034', 'Murzelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(924, '3035', 'Frieswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(925, '3036', 'Detligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(926, '3037', 'Herrenschwanden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(927, '3038', 'Kirchlindach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(928, '3039', 'Bern PF OC', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(929, '3040', 'Bern Verarb.zentr.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(930, '3041', 'Bern UBS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(931, '3042', 'Ortschwaben', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(932, '3043', 'Uettligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(933, '3044', 'Innerberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(934, '3045', 'Meikirch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(935, '3046', 'Wahlendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(936, '3047', 'Bremgarten b. Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(937, '3048', 'Worblaufen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(938, '3049', 'Säriswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(939, '3050', 'Bern Swisscom', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(940, '3052', 'Zollikofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(941, '3053', 'Münchenbuchsee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(942, '3054', 'Schüpfen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(943, '3063', 'Ittigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(944, '3065', 'Bolligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(945, '3066', 'Stettlen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(946, '3067', 'Boll', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(947, '3068', 'Utzigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(948, '3070', 'Ostermundigen LZB', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(949, '3071', 'Ostermundigen Zust', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(950, '3072', 'Ostermundigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(951, '3073', 'Gümligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(952, '3074', 'Muri b. Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(953, '3075', 'Rüfenacht BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(954, '3076', 'Worb', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(955, '3077', 'Enggistein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(956, '3078', 'Richigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(957, '3082', 'Schlosswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(958, '3083', 'Trimstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(959, '3084', 'Wabern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(960, '3085', 'Wabern Weihnachten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(961, '3086', 'Zimmerwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(962, '3087', 'Niedermuhlern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(963, '3088', 'Oberbütschel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(964, '3089', 'Hinterfultigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(965, '3095', 'Spiegel b. Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(966, '3096', 'Oberbalm', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(967, '3097', 'Liebefeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(968, '3098', 'Köniz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(969, '3099', 'Rüti b. Riggisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(970, '3110', 'Münsingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(971, '3111', 'Tägertschi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(972, '3112', 'Allmendingen b. BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(973, '3113', 'Rubigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(974, '3114', 'Wichtrach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(975, '3115', 'Gerzensee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(976, '3116', 'Kirchdorf BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(977, '3122', 'Kehrsatz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(978, '3123', 'Belp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(979, '3124', 'Belpberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(980, '3125', 'Toffen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(981, '3126', 'Kaufdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(982, '3127', 'Mühlethurnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(983, '3128', 'Kirchenthurnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(984, '3132', 'Riggisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(985, '3144', 'Gasel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(986, '3145', 'Niederscherli', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(987, '3147', 'Mittelhäusern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(988, '3148', 'Lanzenhäusern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(989, '3150', 'Schwarzenburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(990, '3152', 'Mamishaus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(991, '3153', 'Rüschegg Gambach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(992, '3154', 'Rüschegg Heubach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(993, '3155', 'Helgisried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(994, '3156', 'Riffenmatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(995, '3157', 'Milken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(996, '3158', 'Guggisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(997, '3159', 'Riedstätt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(998, '3172', 'Niederwangen BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(999, '3173', 'Oberwangen b. Bern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1000, '3174', 'Thörishaus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1001, '3175', 'Flamatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1002, '3176', 'Neuenegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1003, '3177', 'Laupen BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1004, '3178', 'Bösingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1005, '3179', 'Kriechenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1006, '3182', 'Ueberstorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1007, '3183', 'Albligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1008, '3184', 'Wünnewil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1009, '3185', 'Schmitten FR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1010, '3186', 'Düdingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1011, '3202', 'Frauenkappelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1012, '3203', 'Mühleberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1013, '3204', 'Rosshäusern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1014, '3205', 'Gümmenen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1015, '3206', 'Rizenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1016, '3207', 'Wileroltigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1017, '3208', 'Gurbrü', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1018, '3210', 'Kerzers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1019, '3212', 'Gurmels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1020, '3213', 'Liebistorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1021, '3214', 'Ulmiz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1022, '3215', 'Gempenach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1023, '3216', 'Ried b. Kerzers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1024, '3225', 'Müntschemier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1025, '3226', 'Treiten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1026, '3232', 'Ins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1027, '3233', 'Tschugg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1028, '3234', 'Vinelz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1029, '3235', 'Erlach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1030, '3236', 'Gampelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1031, '3237', 'Brüttelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1032, '3238', 'Gals', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1033, '3250', 'Lyss', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1034, '3251', 'Wengi b. Büren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1035, '3252', 'Worben', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1036, '3253', 'Schnottwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1037, '3254', 'Messen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1038, '3255', 'Rapperswil BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1039, '3256', 'Dieterswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1040, '3257', 'Grossaffoltern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1041, '3262', 'Suberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1042, '3263', 'Büetigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1043, '3264', 'Diessbach b. Büren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1044, '3266', 'Wiler b. Seedorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1045, '3267', 'Seedorf BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1046, '3268', 'Lobsigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1047, '3270', 'Aarberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1048, '3271', 'Radelfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1049, '3272', 'Walperswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1050, '3273', 'Kappelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1051, '3274', 'Hermrigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1052, '3280', 'Murten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1053, '3282', 'Bargen BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1054, '3283', 'Kallnach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1055, '3284', 'Fräschels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1056, '3285', 'Galmiz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1057, '3286', 'Muntelier', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1058, '3292', 'Busswil BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1059, '3293', 'Dotzigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1060, '3294', 'Büren an der Aare', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1061, '3295', 'Rüti b. Büren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1062, '3296', 'Arch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1063, '3297', 'Leuzigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1064, '3298', 'Oberwil b. Büren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1065, '3302', 'Moosseedorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1066, '3303', 'Jegenstorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1067, '3305', 'Iffwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1068, '3306', 'Etzelkofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1069, '3307', 'Brunnenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1070, '3308', 'Grafenried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1071, '3309', 'Kernenried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1072, '3312', 'Fraubrunnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1073, '3313', 'Büren zum Hof', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1074, '3314', 'Schalunen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1075, '3315', 'Bätterkinden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1076, '3317', 'Limpach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1077, '3321', 'Schönbühl EKZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1078, '3322', 'Urtenen-Schönbühl', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1079, '3323', 'Bäriswil BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1080, '3324', 'Hindelbank', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1081, '3325', 'Hettiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1082, '3326', 'Krauchthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1083, '3360', 'Herzogenbuchsee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1084, '3362', 'Niederönz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1085, '3363', 'Oberönz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1086, '3365', 'Seeberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1087, '3366', 'Bettenhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1088, '3367', 'Thörigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1089, '3368', 'Bleienbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1090, '3372', 'Wanzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1091, '3373', 'Heimenhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1092, '3374', 'Wangenried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1093, '3375', 'Inkwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1094, '3376', 'Graben', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1095, '3377', 'Walliswil b.Wangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1096, '3380', 'Wangen an der Aare', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1097, '3400', 'Burgdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1098, '3401', 'Burgdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1099, '3402', 'Burgdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1100, '3412', 'Heimiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1101, '3413', 'Kaltacker', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1102, '3414', 'Oberburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1103, '3415', 'Hasle-Rüegsau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1104, '3416', 'Affoltern BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1105, '3417', 'Rüegsau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1106, '3418', 'Rüegsbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1107, '3419', 'Biembach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1108, '3421', 'Lyssach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1109, '3422', 'Kirchberg BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1110, '3423', 'Ersigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1111, '3424', 'Niederösch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1112, '3425', 'Koppigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1113, '3426', 'Aefligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1114, '3427', 'Utzenstorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1115, '3428', 'Wiler b.Utzenstorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1116, '3429', 'Höchstetten-Hells', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1117, '3432', 'Lützelflüh-Goldb', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1118, '3433', 'Schwanden i. E.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1119, '3434', 'Obergoldbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1120, '3435', 'Ramsei', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1121, '3436', 'Zollbrück', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1122, '3437', 'Rüderswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1123, '3438', 'Lauperswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1124, '3439', 'Ranflüh', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1125, '3452', 'Grünenmatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1126, '3453', 'Heimisbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1127, '3454', 'Sumiswald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1128, '3455', 'Grünen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1129, '3456', 'Trachselwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1130, '3457', 'Wasen im Emmental', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1131, '3462', 'Weier im Emmental', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1132, '3463', 'Häusernmoos', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1133, '3464', 'Schmidigen-Mühlew', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1134, '3465', 'Dürrenroth', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1135, '3472', 'Wynigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1136, '3473', 'Alchenstorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1137, '3474', 'Rüedisbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1138, '3475', 'Riedtwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1139, '3476', 'Oschwand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1140, '3503', 'Gysenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1141, '3504', 'Niederhünigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1142, '3506', 'Grosshöchstetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1143, '3507', 'Biglen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1144, '3508', 'Arni BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1145, '3510', 'Konolfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1146, '3512', 'Walkringen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1147, '3513', 'Bigenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1148, '3531', 'Oberthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1149, '3532', 'Zäziwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1150, '3533', 'Bowil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1151, '3534', 'Signau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1152, '3535', 'Schüpbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1153, '3536', 'Aeschau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1154, '3537', 'Eggiwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1155, '3538', 'Röthenbach i. E.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1156, '3543', 'Emmenmatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1157, '3550', 'Langnau i. E.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1158, '3551', 'Oberfrittenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1159, '3552', 'Bärau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1160, '3553', 'Gohl', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1161, '3555', 'Trubschachen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1162, '3556', 'Trub', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1163, '3557', 'Fankhaus (Trub)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1164, '3600', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1165, '3601', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1166, '3602', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1167, '3603', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1168, '3604', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1169, '3605', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1170, '3607', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1171, '3608', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1172, '3609', 'Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1173, '3612', 'Steffisburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1174, '3613', 'Steffisburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1175, '3614', 'Unterlangenegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1176, '3615', 'Heimenschwand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1177, '3616', 'Schwarzenegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1178, '3617', 'Fahrni b. Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1179, '3618', 'Süderen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1180, '3619', 'Eriz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1181, '3622', 'Homberg b. Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1182, '3623', 'Teuffenthal BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1183, '3624', 'Goldiwil (Thun)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1184, '3625', 'Heiligenschwendi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1185, '3626', 'Hünibach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1186, '3627', 'Heimberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1187, '3628', 'Uttigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1188, '3629', 'Kiesen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1189, '3631', 'Höfen b. Thun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1190, '3632', 'Niederstocken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1191, '3633', 'Amsoldingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1192, '3634', 'Thierachern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1193, '3635', 'Uebeschi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1194, '3636', 'Längenbühl', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1195, '3638', 'Blumenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1196, '3645', 'Gwatt (Thun)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1197, '3646', 'Einigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1198, '3647', 'Reutigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1199, '3652', 'Hilterfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1200, '3653', 'Oberhofen Thun\'see', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1201, '3654', 'Gunten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1202, '3655', 'Sigriswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1203, '3656', 'Tschingel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1204, '3657', 'Schwanden Sigrisw', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1205, '3658', 'Merligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1206, '3661', 'Uetendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1207, '3662', 'Seftigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1208, '3663', 'Gurzelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1209, '3664', 'Burgistein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1210, '3665', 'Wattenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1211, '3671', 'Brenzikofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1212, '3672', 'Oberdiessbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1213, '3673', 'Linden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1214, '3674', 'Bleiken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1215, '3700', 'Spiez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1216, '3702', 'Hondrich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1217, '3703', 'Aeschi b. Spiez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1218, '3704', 'Krattigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1219, '3705', 'Faulensee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1220, '3706', 'Leissigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1221, '3707', 'Därligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1222, '3711', 'Emdthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1223, '3713', 'Reichenbach i. K.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1224, '3714', 'Frutigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1225, '3715', 'Adelboden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1226, '3716', 'Kandergrund', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1227, '3717', 'Blausee-Mitholz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1228, '3718', 'Kandersteg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1229, '3722', 'Scharnachtal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1230, '3723', 'Kiental', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1231, '3724', 'Ried (Frutigen)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1232, '3725', 'Achseten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1233, '3752', 'Wimmis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1234, '3753', 'Oey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1235, '3754', 'Diemtigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1236, '3755', 'Horboden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1237, '3756', 'Zwischenflüh', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1238, '3757', 'Schwenden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1239, '3758', 'Latterbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1240, '3762', 'Erlenbach i. S.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1241, '3763', 'Därstetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1242, '3764', 'Weissenburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1243, '3765', 'Oberwil i. S.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1244, '3766', 'Boltigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1245, '3770', 'Zweisimmen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1246, '3771', 'Blankenburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1247, '3772', 'St. Stephan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1248, '3773', 'Matten(St.Stephan)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1249, '3775', 'Lenk im Simmental', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1250, '3776', 'Oeschseite', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1251, '3777', 'Saanenmöser', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1252, '3778', 'Schönried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1253, '3780', 'Gstaad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1254, '3781', 'Turbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1255, '3782', 'Lauenen b. Gstaad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1256, '3783', 'Grund b. Gstaad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1257, '3784', 'Feutersoey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1258, '3785', 'Gsteig b. Gstaad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1259, '3792', 'Saanen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1260, '3800', 'Interlaken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1261, '3801', 'Jungfraujoch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1262, '3802', 'Interlaken Ost', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1263, '3803', 'Beatenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1264, '3804', 'Habkern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1265, '3805', 'Goldswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1266, '3806', 'Bönigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1267, '3807', 'Iseltwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1268, '3812', 'Wilderswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1269, '3813', 'Saxeten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1270, '3814', 'Gsteigwiler', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1271, '3815', 'Zweilütschinen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1272, '3816', 'Lütschental', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1273, '3818', 'Grindelwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1274, '3822', 'Lauterbrunnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1275, '3823', 'Wengen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1276, '3824', 'Stechelberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1277, '3825', 'Mürren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1278, '3826', 'Gimmelwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1279, '3852', 'Ringgenberg BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1280, '3853', 'Niederried Interl', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1281, '3854', 'Oberried Brienz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1282, '3855', 'Brienz BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1283, '3856', 'Brienzwiler', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1284, '3857', 'Unterbach BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1285, '3858', 'Hofstetten BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1286, '3860', 'Meiringen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1287, '3862', 'Innertkirchen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1288, '3863', 'Gadmen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1289, '3864', 'Guttannen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1290, '3900', 'Brig', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1291, '3901', 'Rothwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1292, '3902', 'Glis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1293, '3903', 'Birgisch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1294, '3904', 'Naters', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1295, '3905', 'Saas-Almagell', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1296, '3906', 'Saas-Fee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1297, '3907', 'Simplon Hospiz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1298, '3908', 'Saas-Balen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1299, '3910', 'Saas-Grund', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1300, '3911', 'Ried-Brig', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1301, '3912', 'Termen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1302, '3913', 'Rosswald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1303, '3914', 'Blatten b. Naters', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1304, '3916', 'Ferden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1305, '3917', 'Goppenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1306, '3918', 'Wiler (Lötschen)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1307, '3919', 'Blatten(Lötschen)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1308, '3920', 'Zermatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1309, '3922', 'Eisten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1310, '3923', 'Törbel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1311, '3924', 'St. Niklaus VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1312, '3925', 'Grächen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1313, '3926', 'Embd', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1314, '3927', 'Herbriggen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1315, '3928', 'Randa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1316, '3929', 'Täsch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1317, '3930', 'Visp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1318, '3931', 'Lalden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1319, '3932', 'Visperterminen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1320, '3933', 'Staldenried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1321, '3934', 'Zeneggen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1322, '3935', 'Bürchen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1323, '3937', 'Baltschieder', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1324, '3938', 'Ausserberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1325, '3939', 'Eggerberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1326, '3940', 'Steg VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1327, '3942', 'St. German', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1328, '3943', 'Eischoll', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1329, '3944', 'Unterbäch VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1330, '3945', 'Gampel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1331, '3946', 'Gruben', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1332, '3947', 'Ergisch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1333, '3948', 'Unterems', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1334, '3949', 'Hohtenn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1335, '3951', 'Agarn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1336, '3952', 'Susten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1337, '3953', 'Varen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1338, '3954', 'Leukerbad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1339, '3955', 'Albinen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1340, '3956', 'Guttet-Feschel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1341, '3957', 'Erschmatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1342, '3960', 'Sierre', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1343, '3961', 'Vissoie', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1344, '3963', 'Montana', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1345, '3965', 'Chippis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1346, '3966', 'Chalais', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1347, '3967', 'Vercorin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1348, '3968', 'Veyras', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1349, '3970', 'Salgesch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1350, '3971', 'Chermignon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1351, '3972', 'Miège', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1352, '3973', 'Venthône', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1353, '3974', 'Mollens VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1354, '3975', 'Randogne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1355, '3976', 'Noës', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1356, '3977', 'Granges VS', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1357, '3978', 'Flanthey', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1358, '3979', 'Grône', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1359, '3982', 'Bitsch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1360, '3983', 'Mörel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1361, '3984', 'Fiesch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1362, '3985', 'Geschinen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1363, '3986', 'Ried-Mörel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1364, '3987', 'Riederalp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1365, '3988', 'Obergesteln', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1366, '3989', 'Niederwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1367, '3991', 'Betten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1368, '3992', 'Bettmeralp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1369, '3993', 'Grengiols', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1370, '3994', 'Lax', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1371, '3995', 'Ernen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1372, '3996', 'Binn', '2017-06-02 18:00:00', '2017-06-02 18:00:00');
INSERT INTO `faturacao_npa_localites` (`id`, `npa`, `localite`, `created_at`, `updated_at`) VALUES
(1373, '3997', 'Bellwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1374, '3998', 'Gluringen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1375, '3999', 'Oberwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1376, '4000', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1377, '4001', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1378, '4002', 'Basel ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1379, '4003', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1380, '4004', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1381, '4005', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1382, '4007', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1383, '4009', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1384, '4010', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1385, '4011', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1386, '4012', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1387, '4013', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1388, '4015', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1389, '4016', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1390, '4017', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1391, '4018', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1392, '4019', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1393, '4020', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1394, '4023', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1395, '4024', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1396, '4025', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1397, '4028', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1398, '4030', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1399, '4031', 'Basel ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1400, '4032', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1401, '4033', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1402, '4034', 'Basel 34 Breite', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1403, '4035', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1404, '4039', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1405, '4040', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1406, '4041', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1407, '4042', 'Basel PF OC', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1408, '4051', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1409, '4052', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1410, '4053', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1411, '4054', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1412, '4055', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1413, '4056', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1414, '4057', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1415, '4058', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1416, '4059', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1417, '4070', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1418, '4075', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1419, '4089', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1420, '4091', 'Basel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1421, '4101', 'Bruderholz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1422, '4102', 'Binningen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1423, '4103', 'Bottmingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1424, '4104', 'Oberwil BL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1425, '4105', 'Biel-Benken BL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1426, '4106', 'Therwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1427, '4107', 'Ettingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1428, '4108', 'Witterswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1429, '4112', 'Bättwil-Flüh', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1430, '4114', 'Hofstetten SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1431, '4115', 'Mariastein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1432, '4116', 'Metzerlen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1433, '4117', 'Burg im Leimental', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1434, '4118', 'Rodersdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1435, '4123', 'Allschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1436, '4124', 'Schönenbuch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1437, '4125', 'Riehen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1438, '4126', 'Bettingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1439, '4127', 'Birsfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1440, '4132', 'Muttenz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1441, '4133', 'Pratteln', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1442, '4142', 'Münchenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1443, '4143', 'Dornach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1444, '4144', 'Arlesheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1445, '4145', 'Gempen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1446, '4146', 'Hochwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1447, '4147', 'Aesch BL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1448, '4148', 'Pfeffingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1449, '4153', 'Rheinfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1450, '4202', 'Duggingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1451, '4203', 'Grellingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1452, '4204', 'Himmelried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1453, '4206', 'Seewen SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1454, '4207', 'Bretzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1455, '4208', 'Nunningen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1456, '4222', 'Zwingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1457, '4223', 'Blauen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1458, '4224', 'Nenzlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1459, '4225', 'Brislach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1460, '4226', 'Breitenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1461, '4227', 'Büsserach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1462, '4228', 'Erschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1463, '4229', 'Beinwil SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1464, '4232', 'Fehren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1465, '4233', 'Meltingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1466, '4234', 'Zullwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1467, '4242', 'Laufen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1468, '4243', 'Dittingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1469, '4244', 'Röschenz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1470, '4245', 'Kleinlützel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1471, '4246', 'Wahlen b. Laufen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1472, '4247', 'Grindel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1473, '4252', 'Bärschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1474, '4253', 'Liesberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1475, '4254', 'Liesberg Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1476, '4302', 'Augst BL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1477, '4303', 'Kaiseraugst', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1478, '4304', 'Giebenach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1479, '4305', 'Olsberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1480, '4310', 'Rheinfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1481, '4312', 'Magden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1482, '4313', 'Möhlin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1483, '4314', 'Zeiningen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1484, '4315', 'Zuzgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1485, '4316', 'Hellikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1486, '4317', 'Wegenstetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1487, '4322', 'Mumpf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1488, '4323', 'Wallbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1489, '4324', 'Obermumpf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1490, '4325', 'Schupfart', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1491, '4332', 'Stein AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1492, '4333', 'Münchwilen AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1493, '4334', 'Sisseln AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1494, '4402', 'Frenkendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1495, '4410', 'Liestal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1496, '4411', 'Seltisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1497, '4412', 'Nuglar', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1498, '4413', 'Büren SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1499, '4414', 'Füllinsdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1500, '4415', 'Lausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1501, '4416', 'Bubendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1502, '4417', 'Ziefen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1503, '4418', 'Reigoldswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1504, '4419', 'Lupsingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1505, '4421', 'St. Pantaleon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1506, '4422', 'Arisdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1507, '4423', 'Hersberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1508, '4424', 'Arboldswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1509, '4425', 'Titterten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1510, '4426', 'Lauwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1511, '4431', 'Bennwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1512, '4432', 'Lampenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1513, '4433', 'Ramlinsburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1514, '4434', 'Hölstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1515, '4435', 'Niederdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1516, '4436', 'Oberdorf BL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1517, '4437', 'Waldenburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1518, '4438', 'Langenbruck', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1519, '4441', 'Thürnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1520, '4442', 'Diepflingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1521, '4443', 'Wittinsburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1522, '4444', 'Rümlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1523, '4445', 'Häfelfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1524, '4446', 'Buckten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1525, '4447', 'Känerkinden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1526, '4448', 'Läufelfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1527, '4450', 'Sissach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1528, '4451', 'Wintersingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1529, '4452', 'Itingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1530, '4453', 'Nusshof', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1531, '4455', 'Zunzgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1532, '4456', 'Tenniken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1533, '4457', 'Diegten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1534, '4458', 'Eptingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1535, '4460', 'Gelterkinden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1536, '4461', 'Böckten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1537, '4462', 'Rickenbach BL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1538, '4463', 'Buus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1539, '4464', 'Maisprach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1540, '4465', 'Hemmiken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1541, '4466', 'Ormalingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1542, '4467', 'Rothenfluh', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1543, '4468', 'Kienberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1544, '4469', 'Anwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1545, '4492', 'Tecknau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1546, '4493', 'Wenslingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1547, '4494', 'Oltingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1548, '4495', 'Zeglingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1549, '4496', 'Kilchberg BL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1550, '4497', 'Rünenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1551, '4500', 'Solothurn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1552, '4501', 'Solothurn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1553, '4502', 'Solothurn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1554, '4503', 'Solothurn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1555, '4504', 'Solothurn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1556, '4509', 'Solothurn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1557, '4512', 'Bellach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1558, '4513', 'Langendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1559, '4514', 'Lommiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1560, '4515', 'Weissenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1561, '4522', 'Rüttenen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1562, '4523', 'Niederwil SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1563, '4524', 'Günsberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1564, '4525', 'Balm b. Günsberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1565, '4528', 'Zuchwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1566, '4532', 'Feldbrunnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1567, '4533', 'Riedholz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1568, '4534', 'Flumenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1569, '4535', 'Hubersdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1570, '4536', 'Attiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1571, '4537', 'Wiedlisbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1572, '4538', 'Oberbipp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1573, '4539', 'Rumisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1574, '4542', 'Luterbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1575, '4543', 'Deitingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1576, '4551', 'Derendingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1577, '4552', 'Derendingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1578, '4553', 'Subingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1579, '4554', 'Etziken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1580, '4556', 'Aeschi SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1581, '4557', 'Horriwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1582, '4558', 'Hersiwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1583, '4562', 'Biberist', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1584, '4563', 'Gerlafingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1585, '4564', 'Obergerlafingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1586, '4565', 'Recherswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1587, '4566', 'Kriegstetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1588, '4571', 'Lüterkofen-Ichert', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1589, '4573', 'Lohn-Ammannsegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1590, '4574', 'Nennigkofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1591, '4576', 'Tscheppach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1592, '4577', 'Hessigkofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1593, '4578', 'Bibern SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1594, '4579', 'Gossliwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1595, '4581', 'Küttigkofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1596, '4582', 'Brügglen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1597, '4583', 'Mühledorf SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1598, '4584', 'Gächliwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1599, '4585', 'Biezwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1600, '4586', 'Kyburg-Buchegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1601, '4587', 'Aetingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1602, '4588', 'Unterramsern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1603, '4600', 'Olten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1604, '4601', 'Olten ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1605, '4604', 'Olten 4 Hammer', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1606, '4609', 'Olten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1607, '4611', 'Härkingen SC', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1608, '4612', 'Wangen b. Olten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1609, '4613', 'Rickenbach SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1610, '4614', 'Hägendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1611, '4615', 'Allerheiligenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1612, '4616', 'Kappel SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1613, '4617', 'Gunzgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1614, '4618', 'Boningen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1615, '4620', 'Härkingen PZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1616, '4621', 'Härkingen BZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1617, '4622', 'Egerkingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1618, '4623', 'Neuendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1619, '4624', 'Härkingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1620, '4625', 'Oberbuchsiten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1621, '4626', 'Niederbuchsiten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1622, '4628', 'Wolfwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1623, '4629', 'Fulenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1624, '4630', 'Härkingen CALL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1625, '4632', 'Trimbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1626, '4633', 'Hauenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1627, '4634', 'Wisen SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1628, '4640', 'Härkingen ST PP 1', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1629, '4652', 'Winznau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1630, '4653', 'Obergösgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1631, '4654', 'Lostorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1632, '4655', 'Stüsslingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1633, '4656', 'Starrkirch-Wil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1634, '4657', 'Dulliken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1635, '4658', 'Däniken SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1636, '4663', 'Aarburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1637, '4665', 'Oftringen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1638, '4702', 'Oensingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1639, '4703', 'Kestenholz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1640, '4704', 'Niederbipp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1641, '4710', 'Balsthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1642, '4712', 'Laupersdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1643, '4713', 'Matzendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1644, '4714', 'Aedermannsdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1645, '4715', 'Herbetswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1646, '4716', 'Welschenrohr', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1647, '4717', 'Mümliswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1648, '4718', 'Holderbank SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1649, '4719', 'Ramiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1650, '4800', 'Zofingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1651, '4801', 'Zofingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1652, '4802', 'Strengelbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1653, '4803', 'Vordemwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1654, '4805', 'Brittnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1655, '4806', 'Wikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1656, '4807', 'Zofingen PF', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1657, '4808', 'Zofingen PF', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1658, '4809', 'Zofingen PF', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1659, '4812', 'Mühlethal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1660, '4813', 'Uerkheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1661, '4814', 'Bottenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1662, '4852', 'Rothrist', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1663, '4853', 'Murgenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1664, '4856', 'Glashütten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1665, '4900', 'Langenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1666, '4901', 'Langenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1667, '4911', 'Schwarzhäusern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1668, '4912', 'Aarwangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1669, '4913', 'Bannwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1670, '4914', 'Roggwil BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1671, '4915', 'St. Urban', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1672, '4916', 'Untersteckholz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1673, '4917', 'Melchnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1674, '4919', 'Reisiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1675, '4922', 'Bützberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1676, '4923', 'Wynau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1677, '4924', 'Obersteckholz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1678, '4932', 'Lotzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1679, '4933', 'Rütschelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1680, '4934', 'Madiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1681, '4935', 'Leimiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1682, '4936', 'Kleindietwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1683, '4937', 'Ursenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1684, '4938', 'Rohrbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1685, '4942', 'Walterswil BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1686, '4943', 'Oeschenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1687, '4944', 'Auswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1688, '4950', 'Huttwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1689, '4952', 'Eriswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1690, '4953', 'Schwarzenbach BE', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1691, '4954', 'Wyssachen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1692, '4955', 'Gondiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1693, '5000', 'Aarau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1694, '5001', 'Aarau ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1695, '5004', 'Aarau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1696, '5012', 'Schönenwerd', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1697, '5013', 'Niedergösgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1698, '5014', 'Gretzenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1699, '5015', 'Erlinsbach SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1700, '5017', 'Barmelweid', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1701, '5018', 'Erlinsbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1702, '5022', 'Rombach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1703, '5023', 'Biberstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1704, '5024', 'Küttigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1705, '5025', 'Asp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1706, '5026', 'Densbüren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1707, '5027', 'Herznach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1708, '5028', 'Ueken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1709, '5032', 'Aarau Rohr', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1710, '5033', 'Buchs AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1711, '5034', 'Suhr', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1712, '5035', 'Unterentfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1713, '5036', 'Oberentfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1714, '5037', 'Muhen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1715, '5040', 'Schöftland', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1716, '5042', 'Hirschthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1717, '5043', 'Holziken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1718, '5044', 'Schlossrued', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1719, '5046', 'Schmiedrued', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1720, '5053', 'Staffelbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1721, '5054', 'Kirchleerau-Moosle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1722, '5056', 'Attelwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1723, '5057', 'Reitnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1724, '5058', 'Wiliberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1725, '5062', 'Oberhof', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1726, '5063', 'Wölflinswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1727, '5064', 'Wittnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1728, '5070', 'Frick', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1729, '5072', 'Oeschgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1730, '5073', 'Gipf-Oberfrick', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1731, '5074', 'Eiken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1732, '5075', 'Hornussen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1733, '5076', 'Bözen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1734, '5077', 'Elfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1735, '5078', 'Effingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1736, '5079', 'Zeihen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1737, '5080', 'Laufenburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1738, '5082', 'Kaisten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1739, '5083', 'Ittenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1740, '5084', 'Rheinsulz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1741, '5085', 'Sulz AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1742, '5102', 'Rupperswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1743, '5103', 'Wildegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1744, '5105', 'Auenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1745, '5106', 'Veltheim AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1746, '5107', 'Schinznach Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1747, '5108', 'Oberflachs', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1748, '5112', 'Thalheim AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1749, '5113', 'Holderbank AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1750, '5116', 'Schinznach Bad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1751, '5200', 'Brugg AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1752, '5201', 'Brugg AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1753, '5210', 'Windisch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1754, '5212', 'Hausen AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1755, '5213', 'Villnachern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1756, '5222', 'Umiken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1757, '5223', 'Riniken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1758, '5225', 'Bözberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1759, '5232', 'Villigen PSI', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1760, '5233', 'Stilli', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1761, '5234', 'Villigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1762, '5235', 'Rüfenach AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1763, '5236', 'Remigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1764, '5237', 'Mönthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1765, '5242', 'Birr-Lupfig', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1766, '5243', 'Mülligen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1767, '5244', 'Birrhard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1768, '5245', 'Habsburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1769, '5246', 'Scherz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1770, '5272', 'Gansingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1771, '5273', 'Oberhofen AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1772, '5274', 'Mettau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1773, '5275', 'Etzgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1774, '5276', 'Wil AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1775, '5277', 'Hottwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1776, '5300', 'Turgi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1777, '5301', 'Siggenthal Station', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1778, '5303', 'Würenlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1779, '5304', 'Endingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1780, '5305', 'Unterendingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1781, '5306', 'Tegerfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1782, '5312', 'Döttingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1783, '5313', 'Klingnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1784, '5314', 'Kleindöttingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1785, '5315', 'Böttstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1786, '5316', 'Leuggern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1787, '5317', 'Hettenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1788, '5318', 'Mandach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1789, '5322', 'Koblenz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1790, '5323', 'Rietheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1791, '5324', 'Full-Reuenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1792, '5325', 'Leibstadt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1793, '5326', 'Schwaderloch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1794, '5330', 'Bad Zurzach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1795, '5332', 'Rekingen AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1796, '5333', 'Baldingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1797, '5334', 'Böbikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1798, '5400', 'Baden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1799, '5401', 'Baden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1800, '5402', 'Baden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1801, '5404', 'Baden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1802, '5405', 'Baden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1803, '5406', 'Baden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1804, '5408', 'Ennetbaden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1805, '5412', 'Gebenstorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1806, '5413', 'Birmenstorf AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1807, '5415', 'Nussbaumen AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1808, '5416', 'Kirchdorf AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1809, '5417', 'Untersiggenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1810, '5420', 'Ehrendingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1811, '5423', 'Freienwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1812, '5425', 'Schneisingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1813, '5426', 'Lengnau AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1814, '5430', 'Wettingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1815, '5431', 'Wettingen Sonderd', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1816, '5432', 'Neuenhof', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1817, '5436', 'Würenlos', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1818, '5442', 'Fislisbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1819, '5443', 'Niederrohrdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1820, '5444', 'Künten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1821, '5445', 'Eggenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1822, '5452', 'Oberrohrdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1823, '5453', 'Remetschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1824, '5454', 'Bellikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1825, '5462', 'Siglistorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1826, '5463', 'Wislikofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1827, '5464', 'Rümikon AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1828, '5465', 'Mellikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1829, '5466', 'Kaiserstuhl AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1830, '5467', 'Fisibach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1831, '5502', 'Hunzenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1832, '5503', 'Schafisheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1833, '5504', 'Othmarsingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1834, '5505', 'Brunegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1835, '5506', 'Mägenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1836, '5507', 'Mellingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1837, '5512', 'Wohlenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1838, '5522', 'Tägerig', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1839, '5524', 'Nesselnbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1840, '5525', 'Fischbach-Göslikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1841, '5600', 'Lenzburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1842, '5603', 'Staufen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1843, '5604', 'Hendschiken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1844, '5605', 'Dottikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1845, '5606', 'Dintikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1846, '5607', 'Hägglingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1847, '5608', 'Stetten AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1848, '5610', 'Wohlen AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1849, '5611', 'Anglikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1850, '5612', 'Villmergen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1851, '5613', 'Hilfikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1852, '5614', 'Sarmenstorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1853, '5615', 'Fahrwangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1854, '5616', 'Meisterschwanden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1855, '5617', 'Tennwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1856, '5618', 'Bettwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1857, '5619', 'Büttikon AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1858, '5620', 'Bremgarten AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1859, '5621', 'Zufikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1860, '5622', 'Waltenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1861, '5623', 'Boswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1862, '5624', 'Bünzen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1863, '5625', 'Kallern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1864, '5626', 'Hermetschwil-Staff', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1865, '5627', 'Besenbüren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1866, '5628', 'Aristau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1867, '5630', 'Muri AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1868, '5632', 'Buttwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1869, '5634', 'Merenschwand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1870, '5636', 'Benzenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1871, '5637', 'Beinwil (Freiamt)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1872, '5642', 'Mühlau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1873, '5643', 'Sins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1874, '5644', 'Auw', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1875, '5645', 'Aettenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1876, '5646', 'Abtwil AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1877, '5647', 'Oberrüti', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1878, '5702', 'Niederlenz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1879, '5703', 'Seon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1880, '5704', 'Egliswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1881, '5705', 'Hallwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1882, '5706', 'Boniswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1883, '5707', 'Seengen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1884, '5708', 'Birrwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1885, '5712', 'Beinwil am See', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1886, '5722', 'Gränichen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1887, '5723', 'Teufenthal AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1888, '5724', 'Dürrenäsch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1889, '5725', 'Leutwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1890, '5726', 'Unterkulm', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1891, '5727', 'Oberkulm', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1892, '5728', 'Gontenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1893, '5732', 'Zetzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1894, '5733', 'Leimbach AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1895, '5734', 'Reinach AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1896, '5735', 'Pfeffikon LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1897, '5736', 'Burg AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1898, '5737', 'Menziken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1899, '5742', 'Kölliken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1900, '5745', 'Safenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1901, '5746', 'Walterswil SO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1902, '6000', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1903, '6002', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1904, '6003', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1905, '6004', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1906, '6005', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1907, '6006', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1908, '6007', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1909, '6009', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1910, '6010', 'Kriens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1911, '6011', 'Kriens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1912, '6012', 'Obernau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1913, '6013', 'Eigenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1914, '6014', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1915, '6015', 'Luzern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1916, '6016', 'Hellbühl', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1917, '6017', 'Ruswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1918, '6018', 'Buttisholz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1919, '6019', 'Sigigen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1920, '6020', 'Emmenbrücke', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1921, '6021', 'Emmenbrücke ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1922, '6022', 'Grosswangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1923, '6023', 'Rothenburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1924, '6024', 'Hildisrieden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1925, '6025', 'Neudorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1926, '6026', 'Rain', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1927, '6027', 'Römerswil LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1928, '6028', 'Herlisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1929, '6030', 'Ebikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1930, '6031', 'Ebikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1931, '6032', 'Emmen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1932, '6033', 'Buchrain', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1933, '6034', 'Inwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1934, '6035', 'Perlen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1935, '6036', 'Dierikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1936, '6037', 'Root', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1937, '6038', 'Gisikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1938, '6039', 'Root D4', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1939, '6042', 'Dietwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1940, '6043', 'Adligenswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1941, '6044', 'Udligenswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1942, '6045', 'Meggen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1943, '6047', 'Kastanienbaum', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1944, '6048', 'Horw', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1945, '6052', 'Hergiswil NW', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1946, '6053', 'Alpnachstad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1947, '6055', 'Alpnach Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1948, '6056', 'Kägiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1949, '6060', 'Sarnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1950, '6061', 'Sarnen ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1951, '6062', 'Wilen (Sarnen)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1952, '6063', 'Stalden (Sarnen)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1953, '6064', 'Kerns', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1954, '6066', 'St. Niklausen OW', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1955, '6067', 'Melchtal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1956, '6068', 'Melchsee-Frutt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1957, '6072', 'Sachseln', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1958, '6073', 'Flüeli-Ranft', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1959, '6074', 'Giswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1960, '6078', 'Bürglen OW', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1961, '6083', 'Hasliberg Hohfluh', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1962, '6084', 'Hasliberg Wasserw', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1963, '6085', 'Hasliberg Goldern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1964, '6086', 'Hasliberg Reuti', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1965, '6102', 'Malters', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1966, '6103', 'Schwarzenberg LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1967, '6105', 'Schachen LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1968, '6106', 'Werthenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1969, '6110', 'Wolhusen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1970, '6112', 'Doppleschwand', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1971, '6113', 'Romoos', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1972, '6114', 'Steinhuserberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1973, '6122', 'Menznau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1974, '6123', 'Geiss', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1975, '6125', 'Menzberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1976, '6126', 'Daiwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1977, '6130', 'Willisau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1978, '6132', 'Rohrmatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1979, '6133', 'Hergiswil LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1980, '6142', 'Gettnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1981, '6143', 'Ohmstal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1982, '6144', 'Zell LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1983, '6145', 'Fischbach LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1984, '6146', 'Grossdietwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1985, '6147', 'Altbüron', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1986, '6152', 'Hüswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1987, '6153', 'Ufhusen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1988, '6154', 'Hofstatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1989, '6156', 'Luthern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1990, '6160', 'Entlebuch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1991, '6161', 'Entlebuch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1992, '6162', 'Entlebuch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1993, '6163', 'Ebnet', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1994, '6166', 'Hasle LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1995, '6167', 'Bramboden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1996, '6170', 'Schüpfheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1997, '6173', 'Flühli LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1998, '6174', 'Sörenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(1999, '6182', 'Escholzmatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2000, '6192', 'Wiggen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2001, '6196', 'Marbach LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2002, '6197', 'Schangnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2003, '6203', 'Sempach Station', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2004, '6204', 'Sempach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2005, '6205', 'Eich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2006, '6206', 'Neuenkirch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2007, '6207', 'Nottwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2008, '6208', 'Oberkirch LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2009, '6210', 'Sursee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2010, '6211', 'Buchs LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2011, '6212', 'St. Erhard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2012, '6213', 'Knutwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2013, '6214', 'Schenkon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2014, '6215', 'Beromünster', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2015, '6216', 'Mauensee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2016, '6217', 'Kottwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2017, '6218', 'Ettiswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2018, '6221', 'Rickenbach LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2019, '6222', 'Gunzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2020, '6231', 'Schlierbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2021, '6232', 'Geuensee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2022, '6233', 'Büron', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2023, '6234', 'Triengen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2024, '6235', 'Winikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2025, '6236', 'Wilihof', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2026, '6242', 'Wauwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2027, '6243', 'Egolzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2028, '6244', 'Nebikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2029, '6245', 'Ebersecken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2030, '6246', 'Altishofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2031, '6247', 'Schötz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2032, '6248', 'Alberswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2033, '6252', 'Dagmersellen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2034, '6253', 'Uffikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2035, '6260', 'Reiden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2036, '6262', 'Langnau b. Reiden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2037, '6263', 'Richenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2038, '6264', 'Pfaffnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2039, '6265', 'Roggliswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2040, '6274', 'Eschenbach LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2041, '6275', 'Ballwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2042, '6276', 'Hohenrain', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2043, '6277', 'Kleinwangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2044, '6280', 'Hochdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2045, '6281', 'Hochdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2046, '6283', 'Baldegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2047, '6284', 'Gelfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2048, '6285', 'Hitzkirch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2049, '6286', 'Altwis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2050, '6287', 'Aesch LU', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2051, '6288', 'Schongau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2052, '6289', 'Müswangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2053, '6294', 'Ermensee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2054, '6295', 'Mosen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2055, '6300', 'Zug', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2056, '6301', 'Zug', '2017-06-02 18:00:00', '2017-06-02 18:00:00');
INSERT INTO `faturacao_npa_localites` (`id`, `npa`, `localite`, `created_at`, `updated_at`) VALUES
(2057, '6302', 'Zug', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2058, '6303', 'Zug', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2059, '6310', 'Zug', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2060, '6312', 'Steinhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2061, '6313', 'Edlibach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2062, '6314', 'Unterägeri', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2063, '6315', 'Morgarten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2064, '6317', 'Oberwil b. Zug', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2065, '6318', 'Walchwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2066, '6319', 'Allenwinden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2067, '6330', 'Cham', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2068, '6331', 'Hünenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2069, '6332', 'Hagendorn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2070, '6333', 'Hünenberg See', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2071, '6340', 'Baar', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2072, '6341', 'Baar', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2073, '6343', 'Rotkreuz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2074, '6344', 'Meierskappel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2075, '6345', 'Neuheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2076, '6346', 'Baar 3', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2077, '6349', 'Baar', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2078, '6353', 'Weggis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2079, '6354', 'Vitznau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2080, '6356', 'Rigi Kaltbad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2081, '6362', 'Stansstad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2082, '6363', 'Obbürgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2083, '6365', 'Kehrsiten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2084, '6370', 'Stans', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2085, '6371', 'Stans', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2086, '6372', 'Ennetmoos', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2087, '6373', 'Ennetbürgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2088, '6374', 'Buochs', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2089, '6375', 'Beckenried', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2090, '6376', 'Emmetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2091, '6377', 'Seelisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2092, '6382', 'Büren NW', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2093, '6383', 'Dallenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2094, '6386', 'Wolfenschiessen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2095, '6387', 'Oberrickenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2096, '6388', 'Grafenort', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2097, '6390', 'Engelberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2098, '6391', 'Engelberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2099, '6402', 'Merlischachen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2100, '6403', 'Küssnacht am Rigi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2101, '6404', 'Greppen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2102, '6405', 'Immensee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2103, '6410', 'Goldau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2104, '6414', 'Oberarth', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2105, '6415', 'Arth', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2106, '6416', 'Steinerberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2107, '6417', 'Sattel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2108, '6418', 'Rothenthurm', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2109, '6422', 'Steinen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2110, '6423', 'Seewen SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2111, '6424', 'Lauerz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2112, '6430', 'Schwyz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2113, '6431', 'Schwyz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2114, '6432', 'Rickenbach SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2115, '6433', 'Stoos SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2116, '6434', 'Illgau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2117, '6436', 'Ried (Muotathal)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2118, '6438', 'Ibach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2119, '6440', 'Brunnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2120, '6441', 'Rütli', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2121, '6442', 'Gersau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2122, '6443', 'Morschach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2123, '6452', 'Sisikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2124, '6454', 'Flüelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2125, '6460', 'Altdorf UR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2126, '6461', 'Isenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2127, '6462', 'Seedorf UR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2128, '6463', 'Bürglen UR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2129, '6464', 'Spiringen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2130, '6465', 'Unterschächen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2131, '6466', 'Bauen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2132, '6467', 'Schattdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2133, '6468', 'Attinghausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2134, '6469', 'Haldi b.Schattdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2135, '6472', 'Erstfeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2136, '6473', 'Silenen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2137, '6474', 'Amsteg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2138, '6475', 'Bristen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2139, '6476', 'Intschi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2140, '6482', 'Gurtnellen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2141, '6484', 'Wassen UR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2142, '6485', 'Meien', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2143, '6487', 'Göschenen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2144, '6490', 'Andermatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2145, '6491', 'Realp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2146, '6493', 'Hospental', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2147, '6500', 'Bellinzona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2148, '6501', 'Bellinzona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2149, '6503', 'Bellinzona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2150, '6506', 'Bellinzona ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2151, '6511', 'Cadenazzo SC', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2152, '6512', 'Giubiasco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2153, '6513', 'Monte Carasso', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2154, '6514', 'Sementina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2155, '6515', 'Gudo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2156, '6516', 'Cugnasco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2157, '6517', 'Arbedo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2158, '6518', 'Gorduno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2159, '6523', 'Preonzo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2160, '6524', 'Moleno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2161, '6525', 'Gnosca', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2162, '6526', 'Prosito', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2163, '6527', 'Lodrino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2164, '6528', 'Camorino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2165, '6532', 'Castione', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2166, '6533', 'Lumino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2167, '6534', 'S. Vittore', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2168, '6535', 'Roveredo GR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2169, '6537', 'Grono', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2170, '6538', 'Verdabbio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2171, '6540', 'Castaneda', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2172, '6541', 'Sta. Maria', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2173, '6542', 'Buseno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2174, '6543', 'Arvigo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2175, '6544', 'Braggio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2176, '6545', 'Selma', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2177, '6546', 'Cauco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2178, '6547', 'Augio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2179, '6548', 'Rossa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2180, '6549', 'Laura', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2181, '6556', 'Leggia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2182, '6557', 'Cama', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2183, '6558', 'Lostallo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2184, '6562', 'Soazza', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2185, '6563', 'Mesocco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2186, '6565', 'S. Bernardino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2187, '6571', 'Indemini', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2188, '6572', 'Quartino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2189, '6573', 'Magadino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2190, '6574', 'Vira (Gambarogno)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2191, '6575', 'S. Nazzaro', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2192, '6576', 'Gerra (Gambarogno)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2193, '6577', 'Ranzo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2194, '6578', 'Caviano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2195, '6579', 'Piazzogna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2196, '6582', 'Pianezzo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2197, '6583', 'S. Antonio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2198, '6584', 'Carena', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2199, '6590', 'Cadenazzo (CLL)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2200, '6592', 'S. Antonino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2201, '6593', 'Cadenazzo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2202, '6594', 'Contone', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2203, '6595', 'Riazzino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2204, '6596', 'Gordola', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2205, '6597', 'Agarone', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2206, '6598', 'Tenero', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2207, '6599', 'Robasacco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2208, '6600', 'Locarno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2209, '6601', 'Locarno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2210, '6602', 'Muralto', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2211, '6604', 'Locarno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2212, '6605', 'Locarno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2213, '6611', 'Mosogno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2214, '6612', 'Ascona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2215, '6613', 'Porto Ronco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2216, '6614', 'Brissago', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2217, '6616', 'Losone', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2218, '6618', 'Arcegno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2219, '6622', 'Ronco sopra Ascona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2220, '6631', 'Corippo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2221, '6632', 'Vogorno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2222, '6633', 'Lavertezzo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2223, '6634', 'Brione (Verzasca)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2224, '6635', 'Gerra (Verzasca)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2225, '6636', 'Frasco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2226, '6637', 'Sonogno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2227, '6644', 'Orselina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2228, '6645', 'Brione s. Minusio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2229, '6646', 'Contra', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2230, '6647', 'Mergoscia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2231, '6648', 'Minusio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2232, '6652', 'Tegna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2233, '6653', 'Verscio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2234, '6654', 'Cavigliano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2235, '6655', 'Verdasio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2236, '6656', 'Golino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2237, '6657', 'Palagnedra', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2238, '6658', 'Borgnone', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2239, '6659', 'Camedo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2240, '6661', 'Auressio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2241, '6662', 'Russo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2242, '6663', 'Comologno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2243, '6664', 'Vergeletto', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2244, '6670', 'Avegno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2245, '6672', 'Gordevio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2246, '6673', 'Maggia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2247, '6674', 'Riveo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2248, '6675', 'Cevio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2249, '6676', 'Bignasco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2250, '6677', 'Moghegno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2251, '6678', 'Coglio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2252, '6682', 'Linescio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2253, '6683', 'Cerentino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2254, '6684', 'Campo (VM)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2255, '6685', 'Bosco/Gurin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2256, '6690', 'Cavergno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2257, '6692', 'Brontallo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2258, '6693', 'Broglio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2259, '6694', 'Prato-Sornico', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2260, '6695', 'Peccia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2261, '6696', 'Fusio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2262, '6702', 'Claro', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2263, '6703', 'Osogna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2264, '6705', 'Cresciano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2265, '6707', 'Iragna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2266, '6710', 'Biasca', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2267, '6713', 'Malvaglia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2268, '6714', 'Semione', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2269, '6715', 'Dongio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2270, '6716', 'Leontica', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2271, '6717', 'Dangio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2272, '6718', 'Olivone', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2273, '6719', 'Aquila', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2274, '6720', 'Campo (Blenio)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2275, '6721', 'Ludiano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2276, '6722', 'Corzoneso', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2277, '6723', 'Prugiasco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2278, '6724', 'Ponto Valentino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2279, '6742', 'Pollegio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2280, '6743', 'Bodio TI', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2281, '6744', 'Personico', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2282, '6745', 'Giornico', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2283, '6746', 'Lavorgo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2284, '6747', 'Chironico', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2285, '6748', 'Anzonico', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2286, '6749', 'Sobrio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2287, '6760', 'Faido', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2288, '6763', 'Mairengo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2289, '6764', 'Chiggiogna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2290, '6772', 'Rodi-Fiesso', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2291, '6773', 'Prato (Leventina)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2292, '6774', 'Dalpe', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2293, '6775', 'Ambrì', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2294, '6776', 'Piotta', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2295, '6777', 'Quinto', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2296, '6780', 'Airolo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2297, '6781', 'Villa Bedretto', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2298, '6802', 'Rivera', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2299, '6803', 'Camignolo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2300, '6804', 'Bironico', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2301, '6805', 'Mezzovico', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2302, '6806', 'Sigirino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2303, '6807', 'Taverne', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2304, '6808', 'Torricella', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2305, '6809', 'Medeglia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2306, '6810', 'Isone', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2307, '6814', 'Lamone-Cadempino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2308, '6815', 'Melide', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2309, '6816', 'Bissone', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2310, '6817', 'Maroggia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2311, '6818', 'Melano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2312, '6821', 'Rovio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2313, '6822', 'Arogno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2314, '6823', 'Pugerna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2315, '6825', 'Capolago', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2316, '6826', 'Riva San Vitale', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2317, '6827', 'Brusino Arsizio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2318, '6828', 'Balerna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2319, '6830', 'Chiasso', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2320, '6832', 'Pedrinate', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2321, '6833', 'Vacallo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2322, '6834', 'Morbio Inferiore', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2323, '6835', 'Morbio Superiore', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2324, '6836', 'Serfontana', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2325, '6837', 'Caneggio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2326, '6838', 'Cabbio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2327, '6839', 'Sagno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2328, '6850', 'Mendrisio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2329, '6852', 'Genestrerio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2330, '6853', 'Ligornetto', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2331, '6854', 'S. Pietro', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2332, '6855', 'Stabio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2333, '6862', 'Rancate', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2334, '6863', 'Besazio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2335, '6864', 'Arzo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2336, '6865', 'Tremona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2337, '6866', 'Meride', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2338, '6867', 'Serpiano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2339, '6872', 'Salorino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2340, '6873', 'Corteglia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2341, '6874', 'Castel San Pietro', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2342, '6875', 'Monte', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2343, '6877', 'Coldrerio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2344, '6883', 'Novazzano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2345, '6900', 'Lugano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2346, '6901', 'Lugano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2347, '6902', 'Lugano ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2348, '6903', 'Lugano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2349, '6904', 'Lugano ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2350, '6905', 'Lugano ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2351, '6906', 'Lugano ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2352, '6907', 'Lugano ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2353, '6908', 'Massagno Caselle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2354, '6911', 'Campione', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2355, '6912', 'Pazzallo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2356, '6913', 'Carabbia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2357, '6914', 'Carona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2358, '6915', 'Pambio-Noranco', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2359, '6916', 'Grancia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2360, '6917', 'Barbengo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2361, '6918', 'Figino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2362, '6919', 'Carabietta', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2363, '6921', 'Vico Morcote', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2364, '6922', 'Morcote', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2365, '6924', 'Sorengo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2366, '6925', 'Gentilino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2367, '6926', 'Montagnola', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2368, '6927', 'Agra', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2369, '6928', 'Manno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2370, '6929', 'Gravesano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2371, '6930', 'Bedano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2372, '6932', 'Breganzona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2373, '6933', 'Muzzano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2374, '6934', 'Bioggio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2375, '6935', 'Bosco Luganese', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2376, '6936', 'Cademario', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2377, '6937', 'Breno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2378, '6938', 'Vezio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2379, '6939', 'Arosio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2380, '6942', 'Savosa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2381, '6943', 'Vezia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2382, '6944', 'Cureglia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2383, '6945', 'Origlio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2384, '6946', 'Ponte Capriasca', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2385, '6947', 'Vaglio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2386, '6948', 'Porza', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2387, '6949', 'Comano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2388, '6950', 'Tesserete', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2389, '6951', 'Insone', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2390, '6952', 'Canobbio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2391, '6953', 'Lugaggia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2392, '6954', 'Sala Capriasca', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2393, '6955', 'Cagiallo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2394, '6956', 'Lopagno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2395, '6957', 'Roveredo TI', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2396, '6958', 'Bidogno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2397, '6959', 'Cimadera', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2398, '6960', 'Odogno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2399, '6962', 'Viganello', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2400, '6963', 'Pregassona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2401, '6964', 'Davesco-Soragno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2402, '6965', 'Cadro', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2403, '6966', 'Villa Luganese', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2404, '6967', 'Dino', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2405, '6968', 'Sonvico', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2406, '6974', 'Aldesago', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2407, '6976', 'Castagnola', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2408, '6977', 'Ruvigliana', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2409, '6978', 'Gandria', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2410, '6979', 'Brè sopra Lugano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2411, '6980', 'Castelrotto', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2412, '6981', 'Bedigliora', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2413, '6982', 'Agno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2414, '6983', 'Magliaso', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2415, '6984', 'Pura', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2416, '6986', 'Miglieglia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2417, '6987', 'Caslano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2418, '6988', 'Ponte Tresa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2419, '6989', 'Purasca', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2420, '6990', 'Cassina d\'Agno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2421, '6991', 'Neggio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2422, '6992', 'Vernate', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2423, '6993', 'Iseo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2424, '6994', 'Aranno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2425, '6995', 'Molinazzo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2426, '6996', 'Ponte Cremenaga', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2427, '6997', 'Sessa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2428, '6998', 'Termine', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2429, '6999', 'Astano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2430, '7000', 'Chur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2431, '7001', 'Chur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2432, '7003', 'Chur Postauto', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2433, '7004', 'Chur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2434, '7006', 'Chur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2435, '7007', 'Chur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2436, '7012', 'Felsberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2437, '7013', 'Domat/Ems', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2438, '7014', 'Trin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2439, '7015', 'Tamins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2440, '7016', 'Trin Mulin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2441, '7017', 'Flims Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2442, '7018', 'Flims Waldhaus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2443, '7019', 'Fidaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2444, '7023', 'Haldenstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2445, '7026', 'Maladers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2446, '7027', 'Lüen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2447, '7028', 'St. Peter', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2448, '7029', 'Peist', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2449, '7031', 'Laax GR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2450, '7032', 'Laax GR ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2451, '7050', 'Arosa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2452, '7056', 'Molinis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2453, '7057', 'Langwies', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2454, '7058', 'Litzirüti', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2455, '7062', 'Passugg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2456, '7063', 'Praden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2457, '7064', 'Tschiertschen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2458, '7074', 'Malix', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2459, '7075', 'Churwalden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2460, '7076', 'Parpan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2461, '7077', 'Valbella', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2462, '7078', 'Lenzerheide/Lai', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2463, '7082', 'Vaz/Obervaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2464, '7083', 'Lantsch/Lenz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2465, '7084', 'Brienz/Brinzauls', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2466, '7104', 'Versam', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2467, '7106', 'Tenna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2468, '7107', 'Safien Platz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2469, '7109', 'Thalkirch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2470, '7110', 'Peiden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2471, '7111', 'Pitasch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2472, '7112', 'Duvin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2473, '7113', 'Camuns', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2474, '7114', 'Uors (Lumnezia)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2475, '7115', 'Surcasti', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2476, '7116', 'Tersnaus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2477, '7122', 'Valendas', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2478, '7126', 'Castrisch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2479, '7127', 'Sevgein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2480, '7128', 'Riein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2481, '7130', 'Ilanz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2482, '7132', 'Vals', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2483, '7134', 'Obersaxen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2484, '7137', 'Flond', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2485, '7138', 'Surcuolm', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2486, '7141', 'Luven', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2487, '7142', 'Cumbel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2488, '7143', 'Morissen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2489, '7144', 'Vella', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2490, '7145', 'Degen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2491, '7146', 'Vattiz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2492, '7147', 'Vignogn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2493, '7148', 'Lumbrein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2494, '7149', 'Vrin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2495, '7151', 'Schluein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2496, '7152', 'Sagogn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2497, '7153', 'Falera', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2498, '7154', 'Ruschein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2499, '7155', 'Ladir', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2500, '7156', 'Pigniu', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2501, '7157', 'Siat', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2502, '7158', 'Waltensburg/Vuorz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2503, '7159', 'Andiast', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2504, '7162', 'Tavanasa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2505, '7163', 'Danis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2506, '7164', 'Dardin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2507, '7165', 'Breil/Brigels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2508, '7166', 'Trun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2509, '7167', 'Zignau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2510, '7168', 'Schlans', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2511, '7172', 'Rabius', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2512, '7173', 'Surrein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2513, '7174', 'S. Benedetg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2514, '7175', 'Sumvitg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2515, '7176', 'Cumpadials', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2516, '7180', 'Disentis/Mustér', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2517, '7182', 'Cavardiras', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2518, '7183', 'Mumpé Medel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2519, '7184', 'Curaglia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2520, '7185', 'Platta', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2521, '7186', 'Segnas', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2522, '7187', 'Camischolas', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2523, '7188', 'Sedrun', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2524, '7189', 'Rueras', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2525, '7202', 'Says', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2526, '7203', 'Trimmis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2527, '7204', 'Untervaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2528, '7205', 'Zizers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2529, '7206', 'Igis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2530, '7208', 'Malans GR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2531, '7212', 'Seewis Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2532, '7213', 'Valzeina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2533, '7214', 'Grüsch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2534, '7215', 'Fanas', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2535, '7220', 'Schiers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2536, '7222', 'Lunden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2537, '7223', 'Buchen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2538, '7224', 'Putz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2539, '7226', 'Stels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2540, '7228', 'Schuders', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2541, '7231', 'Pragg-Jenaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2542, '7232', 'Furna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2543, '7233', 'Jenaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2544, '7235', 'Fideris', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2545, '7240', 'Küblis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2546, '7241', 'Conters', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2547, '7242', 'Luzein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2548, '7243', 'Pany', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2549, '7244', 'Gadenstätt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2550, '7245', 'Ascharina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2551, '7246', 'St. Antönien', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2552, '7247', 'Saas im Prättigau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2553, '7249', 'Serneus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2554, '7250', 'Klosters', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2555, '7252', 'Klosters Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2556, '7260', 'Davos Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2557, '7265', 'Davos Wolfgang', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2558, '7270', 'Davos Platz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2559, '7272', 'Davos Clavadel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2560, '7276', 'Davos Frauenkirch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2561, '7277', 'Davos Glaris', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2562, '7278', 'Davos Monstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2563, '7302', 'Landquart', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2564, '7303', 'Mastrils', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2565, '7304', 'Maienfeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2566, '7306', 'Fläsch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2567, '7307', 'Jenins', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2568, '7310', 'Bad Ragaz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2569, '7312', 'Pfäfers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2570, '7313', 'St. Margrethenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2571, '7314', 'Vadura', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2572, '7315', 'Vättis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2573, '7317', 'Valens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2574, '7320', 'Sargans', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2575, '7323', 'Wangs', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2576, '7324', 'Vilters', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2577, '7325', 'Schwendi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2578, '7326', 'Weisstannen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2579, '7402', 'Bonaduz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2580, '7403', 'Rhäzüns', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2581, '7404', 'Feldis/Veulden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2582, '7405', 'Rothenbrunnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2583, '7407', 'Trans', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2584, '7408', 'Cazis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2585, '7411', 'Sils im Domleschg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2586, '7412', 'Scharans', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2587, '7413', 'Fürstenaubruck', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2588, '7414', 'Fürstenau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2589, '7415', 'Rodels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2590, '7416', 'Almens', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2591, '7417', 'Paspels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2592, '7418', 'Tumegl/Tomils', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2593, '7419', 'Scheid', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2594, '7421', 'Summaprada', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2595, '7422', 'Tartar', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2596, '7423', 'Sarn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2597, '7424', 'Präz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2598, '7425', 'Masein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2599, '7426', 'Flerden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2600, '7427', 'Urmein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2601, '7428', 'Tschappina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2602, '7430', 'Thusis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2603, '7431', 'Mutten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2604, '7432', 'Zillis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2605, '7433', 'Donat', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2606, '7434', 'Sufers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2607, '7435', 'Splügen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2608, '7436', 'Medels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2609, '7437', 'Nufenen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2610, '7438', 'Hinterrhein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2611, '7440', 'Andeer', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2612, '7442', 'Clugin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2613, '7443', 'Pignia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2614, '7444', 'Ausserferrera', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2615, '7445', 'Innerferrera', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2616, '7446', 'Campsut-Cröt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2617, '7447', 'Cresta (Avers)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2618, '7448', 'Juf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2619, '7450', 'Tiefencastel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2620, '7451', 'Alvaschein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2621, '7452', 'Cunter', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2622, '7453', 'Tinizong', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2623, '7454', 'Rona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2624, '7455', 'Mulegns', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2625, '7456', 'Sur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2626, '7457', 'Bivio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2627, '7458', 'Mon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2628, '7459', 'Stierva', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2629, '7460', 'Savognin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2630, '7462', 'Salouf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2631, '7463', 'Riom', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2632, '7464', 'Parsonz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2633, '7472', 'Surava', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2634, '7473', 'Alvaneu Bad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2635, '7477', 'Filisur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2636, '7482', 'Bergün/Bravuogn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2637, '7484', 'Latsch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2638, '7492', 'Alvaneu Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2639, '7493', 'Schmitten (Albula)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2640, '7494', 'Davos Wiesen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2641, '7500', 'St. Moritz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2642, '7502', 'Bever', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2643, '7503', 'Samedan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2644, '7504', 'Pontresina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2645, '7505', 'Celerina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2646, '7512', 'Champfèr', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2647, '7513', 'Silvaplana', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2648, '7514', 'Sils/Segl Maria', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2649, '7515', 'Sils/Segl Baselgia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2650, '7516', 'Maloja', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2651, '7517', 'Plaun da Lej', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2652, '7522', 'La Punt-Chamues-ch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2653, '7523', 'Madulain', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2654, '7524', 'Zuoz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2655, '7525', 'S-chanf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2656, '7526', 'Cinuos-chel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2657, '7527', 'Brail', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2658, '7530', 'Zernez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2659, '7532', 'Tschierv', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2660, '7533', 'Fuldera', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2661, '7534', 'Lü', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2662, '7535', 'Valchava', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2663, '7536', 'Sta. Maria V. M.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2664, '7537', 'Müstair', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2665, '7542', 'Susch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2666, '7543', 'Lavin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2667, '7545', 'Guarda', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2668, '7546', 'Ardez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2669, '7550', 'Scuol', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2670, '7551', 'Ftan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2671, '7552', 'Vulpera', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2672, '7553', 'Tarasp', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2673, '7554', 'Sent', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2674, '7556', 'Ramosch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2675, '7557', 'Vnà', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2676, '7558', 'Strada', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2677, '7559', 'Tschlin', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2678, '7560', 'Martina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2679, '7562', 'Samnaun-Compatsch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2680, '7563', 'Samnaun Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2681, '7602', 'Casaccia', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2682, '7603', 'Vicosoprano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2683, '7604', 'Borgonovo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2684, '7605', 'Stampa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2685, '7606', 'Promontogno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2686, '7608', 'Castasegna', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2687, '7610', 'Soglio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2688, '7710', 'Ospizio Bernina', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2689, '7741', 'S. Carlo GR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2690, '7742', 'Poschiavo', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2691, '7743', 'Brusio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2692, '7744', 'Campocologno', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2693, '7745', 'Li Curt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2694, '7746', 'Le Prese', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2695, '7747', 'Viano', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2696, '7748', 'Campascio', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2697, '8000', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2698, '8001', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2699, '8002', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2700, '8003', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2701, '8004', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2702, '8005', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2703, '8006', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2704, '8008', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2705, '8010', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2706, '8011', 'Zürich Mülligen SC', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2707, '8012', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2708, '8014', 'Zürich 14 Zust', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2709, '8015', 'Zürich ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2710, '8016', 'Zürich ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2711, '8021', 'Zürich ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2712, '8022', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2713, '8023', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2714, '8024', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2715, '8025', 'Zürich 25 Urania', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2716, '8026', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2717, '8027', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2718, '8030', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2719, '8031', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2720, '8032', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2721, '8033', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2722, '8034', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2723, '8036', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2724, '8037', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2725, '8038', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2726, '8039', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2727, '8040', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2728, '8041', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2729, '8042', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2730, '8044', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2731, '8045', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2732, '8046', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2733, '8047', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2734, '8048', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2735, '8049', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2736, '8050', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2737, '8051', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2738, '8052', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2739, '8053', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2740, '8055', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2741, '8057', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2742, '8058', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2743, '8059', 'Zürich 59 EO', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2744, '8060', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2745, '8061', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2746, '8063', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2747, '8064', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2748, '8066', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00');
INSERT INTO `faturacao_npa_localites` (`id`, `npa`, `localite`, `created_at`, `updated_at`) VALUES
(2749, '8068', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2750, '8070', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2751, '8071', 'Zürich CS PZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2752, '8074', 'Zürich Voice Pub', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2753, '8075', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2754, '8080', 'Zürich ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2755, '8081', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2756, '8085', 'Zürich ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2757, '8086', 'Zürich R Digest', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2758, '8087', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2759, '8088', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2760, '8090', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2761, '8091', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2762, '8092', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2763, '8093', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2764, '8096', 'Zürich IBRS local', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2765, '8098', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2766, '8099', 'Zürich', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2767, '8102', 'Oberengstringen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2768, '8103', 'Unterengstringen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2769, '8104', 'Weiningen ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2770, '8105', 'Regensdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2771, '8106', 'Adlikon b.Regensdf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2772, '8107', 'Buchs ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2773, '8108', 'Dällikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2774, '8109', 'Kloster Fahr', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2775, '8112', 'Otelfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2776, '8113', 'Boppelsen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2777, '8114', 'Dänikon ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2778, '8115', 'Hüttikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2779, '8117', 'Fällanden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2780, '8118', 'Pfaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2781, '8121', 'Benglen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2782, '8122', 'Binz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2783, '8123', 'Ebmatingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2784, '8124', 'Maur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2785, '8125', 'Zollikerberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2786, '8126', 'Zumikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2787, '8127', 'Forch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2788, '8132', 'Hinteregg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2789, '8133', 'Esslingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2790, '8134', 'Adliswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2791, '8135', 'Langnau am Albis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2792, '8136', 'Gattikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2793, '8142', 'Uitikon Waldegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2794, '8143', 'Uetliberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2795, '8152', 'Glattbrugg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2796, '8153', 'Rümlang', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2797, '8154', 'Oberglatt ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2798, '8155', 'Niederhasli', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2799, '8156', 'Oberhasli', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2800, '8157', 'Dielsdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2801, '8158', 'Regensberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2802, '8162', 'Steinmaur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2803, '8164', 'Bachs', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2804, '8165', 'Schöfflisdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2805, '8166', 'Niederweningen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2806, '8172', 'Niederglatt ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2807, '8173', 'Neerach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2808, '8174', 'Stadel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2809, '8175', 'Windlach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2810, '8180', 'Bülach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2811, '8181', 'Höri', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2812, '8182', 'Hochfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2813, '8183', 'Bülach Dist Ba', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2814, '8184', 'Bachenbülach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2815, '8185', 'Winkel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2816, '8187', 'Weiach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2817, '8192', 'Glattfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2818, '8193', 'Eglisau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2819, '8194', 'Hüntwangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2820, '8195', 'Wasterkingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2821, '8196', 'Wil ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2822, '8197', 'Rafz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2823, '8200', 'Schaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2824, '8201', 'Schaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2825, '8202', 'Schaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2826, '8203', 'Schaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2827, '8204', 'Schaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2828, '8205', 'Schaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2829, '8207', 'Schaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2830, '8208', 'Schaffhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2831, '8210', 'Schaffhausen ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2832, '8212', 'Neuhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2833, '8213', 'Neunkirch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2834, '8214', 'Gächlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2835, '8215', 'Hallau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2836, '8216', 'Oberhallau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2837, '8217', 'Wilchingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2838, '8218', 'Osterfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2839, '8219', 'Trasadingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2840, '8222', 'Beringen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2841, '8223', 'Guntmadingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2842, '8224', 'Löhningen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2843, '8225', 'Siblingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2844, '8226', 'Schleitheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2845, '8228', 'Beggingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2846, '8231', 'Hemmental', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2847, '8232', 'Merishausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2848, '8233', 'Bargen SH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2849, '8234', 'Stetten SH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2850, '8235', 'Lohn SH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2851, '8236', 'Opfertshofen SH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2852, '8238', 'Büsingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2853, '8239', 'Dörflingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2854, '8240', 'Thayngen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2855, '8241', 'Barzheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2856, '8242', 'Bibern SH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2857, '8243', 'Altdorf SH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2858, '8245', 'Feuerthalen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2859, '8246', 'Langwiesen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2860, '8247', 'Flurlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2861, '8248', 'Uhwiesen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2862, '8252', 'Schlatt TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2863, '8253', 'Diessenhofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2864, '8254', 'Basadingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2865, '8255', 'Schlattingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2866, '8259', 'Kaltenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2867, '8260', 'Stein am Rhein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2868, '8261', 'Hemishofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2869, '8262', 'Ramsen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2870, '8263', 'Buch SH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2871, '8264', 'Eschenz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2872, '8265', 'Mammern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2873, '8266', 'Steckborn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2874, '8267', 'Berlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2875, '8268', 'Mannenbach-Salenst', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2876, '8269', 'Fruthwilen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2877, '8272', 'Ermatingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2878, '8273', 'Triboltingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2879, '8274', 'Tägerwilen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2880, '8280', 'Kreuzlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2881, '8285', 'Kreuzlingen Ifolor', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2882, '8301', 'Glattzentrum', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2883, '8302', 'Kloten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2884, '8303', 'Bassersdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2885, '8304', 'Wallisellen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2886, '8305', 'Dietlikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2887, '8306', 'Brüttisellen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2888, '8307', 'Effretikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2889, '8308', 'Illnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2890, '8309', 'Nürensdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2891, '8310', 'Kemptthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2892, '8311', 'Brütten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2893, '8312', 'Winterberg ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2894, '8314', 'Kyburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2895, '8315', 'Lindau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2896, '8317', 'Tagelswangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2897, '8320', 'Fehraltorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2898, '8322', 'Madetswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2899, '8325', 'Effretikon ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2900, '8330', 'Pfäffikon ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2901, '8331', 'Auslikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2902, '8332', 'Russikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2903, '8335', 'Hittnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2904, '8340', 'Hinwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2905, '8342', 'Wernetshausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2906, '8343', 'Hinwil Dist Ba', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2907, '8344', 'Bäretswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2908, '8345', 'Adetswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2909, '8352', 'Elsau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2910, '8353', 'Elgg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2911, '8354', 'Hofstetten ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2912, '8355', 'Aadorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2913, '8356', 'Ettenhausen TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2914, '8357', 'Guntershausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2915, '8360', 'Eschlikon TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2916, '8362', 'Balterswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2917, '8363', 'Bichelsee', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2918, '8370', 'Sirnach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2919, '8371', 'Busswil TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2920, '8372', 'Wiezikon b.Sirnach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2921, '8374', 'Oberwangen TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2922, '8376', 'Fischingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2923, '8400', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2924, '8401', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2925, '8402', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2926, '8403', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2927, '8404', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2928, '8405', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2929, '8406', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2930, '8408', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2931, '8409', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2932, '8410', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2933, '8411', 'Winterthur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2934, '8412', 'Aesch (Neftenbach)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2935, '8413', 'Neftenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2936, '8414', 'Buch am Irchel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2937, '8415', 'Berg am Irchel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2938, '8416', 'Flaach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2939, '8418', 'Schlatt ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2940, '8421', 'Dättlikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2941, '8422', 'Pfungen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2942, '8424', 'Embrach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2943, '8425', 'Oberembrach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2944, '8426', 'Lufingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2945, '8427', 'Freienstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2946, '8428', 'Teufen ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2947, '8442', 'Hettlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2948, '8444', 'Henggart', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2949, '8447', 'Dachsen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2950, '8450', 'Andelfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2951, '8451', 'Kleinandelfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2952, '8452', 'Adlikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2953, '8453', 'Alten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2954, '8454', 'Buchberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2955, '8455', 'Rüdlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2956, '8457', 'Humlikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2957, '8458', 'Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2958, '8459', 'Volken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2959, '8460', 'Marthalen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2960, '8461', 'Oerlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2961, '8462', 'Rheinau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2962, '8463', 'Benken ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2963, '8464', 'Ellikon am Rhein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2964, '8465', 'Rudolfingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2965, '8466', 'Trüllikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2966, '8467', 'Truttikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2967, '8468', 'Guntalingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2968, '8471', 'Rutschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2969, '8472', 'Seuzach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2970, '8474', 'Dinhard', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2971, '8475', 'Ossingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2972, '8476', 'Unterstammheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2973, '8477', 'Oberstammheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2974, '8478', 'Thalheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2975, '8479', 'Altikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2976, '8482', 'Sennhof', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2977, '8483', 'Kollbrunn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2978, '8484', 'Weisslingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2979, '8486', 'Rikon im Tösstal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2980, '8487', 'Rämismühle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2981, '8488', 'Turbenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2982, '8489', 'Wildberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2983, '8492', 'Wila', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2984, '8493', 'Saland', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2985, '8494', 'Bauma', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2986, '8495', 'Schmidrüti', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2987, '8496', 'Steg im Tösstal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2988, '8497', 'Fischenthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2989, '8498', 'Gibswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2990, '8499', 'Sternenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2991, '8500', 'Frauenfeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2992, '8501', 'Frauenfeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2993, '8502', 'Frauenfeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2994, '8503', 'Frauenfeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2995, '8505', 'Pfyn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2996, '8506', 'Lanzenneunforn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2997, '8507', 'Hörhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2998, '8508', 'Homburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(2999, '8509', 'Frauenfeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3000, '8510', 'Frauenfeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3001, '8512', 'Thundorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3002, '8514', 'Amlikon-Bissegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3003, '8520', 'Frauenfeld PZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3004, '8522', 'Häuslenen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3005, '8523', 'Hagenbuch ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3006, '8524', 'Uesslingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3007, '8525', 'Niederneunforn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3008, '8526', 'Oberneunforn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3009, '8530', 'Frauenfeld CALL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3010, '8532', 'Warth', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3011, '8535', 'Herdern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3012, '8536', 'Hüttwilen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3013, '8537', 'Nussbaumen TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3014, '8540', 'Frauenfeld ST PP 1', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3015, '8542', 'Wiesendangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3016, '8543', 'Bertschikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3017, '8544', 'Attikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3018, '8545', 'Rickenbach ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3019, '8546', 'Islikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3020, '8547', 'Gachnang', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3021, '8548', 'Ellikon a d Thur', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3022, '8552', 'Felben-Wellhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3023, '8553', 'Hüttlingen-Mettdf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3024, '8554', 'Müllheim-Wigoltgn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3025, '8555', 'Müllheim Dorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3026, '8556', 'Wigoltingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3027, '8558', 'Raperswilen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3028, '8560', 'Märstetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3029, '8561', 'Ottoberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3030, '8564', 'Lipperswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3031, '8565', 'Hugelshofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3032, '8566', 'Dotnacht', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3033, '8570', 'Weinfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3034, '8572', 'Berg TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3035, '8573', 'Siegershausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3036, '8574', 'Illighausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3037, '8575', 'Bürglen TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3038, '8576', 'Mauren TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3039, '8577', 'Schönholzerswilen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3040, '8580', 'Amriswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3041, '8581', 'Schocherswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3042, '8582', 'Dozwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3043, '8583', 'Sulgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3044, '8584', 'Leimbach TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3045, '8585', 'Mattwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3046, '8586', 'Erlen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3047, '8587', 'Oberaach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3048, '8588', 'Zihlschlacht', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3049, '8589', 'Sitterdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3050, '8590', 'Romanshorn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3051, '8592', 'Uttwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3052, '8593', 'Kesswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3053, '8594', 'Güttingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3054, '8595', 'Altnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3055, '8596', 'Scherzingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3056, '8597', 'Landschlacht', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3057, '8598', 'Bottighofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3058, '8599', 'Salmsach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3059, '8600', 'Dübendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3060, '8602', 'Wangen ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3061, '8603', 'Schwerzenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3062, '8604', 'Volketswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3063, '8605', 'Gutenswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3064, '8606', 'Nänikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3065, '8607', 'Aathal-Seegräben', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3066, '8608', 'Bubikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3067, '8610', 'Uster', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3068, '8612', 'Uster Niederuster', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3069, '8613', 'Uster ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3070, '8614', 'Bertschikon Gossau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3071, '8615', 'Wermatswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3072, '8616', 'Riedikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3073, '8617', 'Mönchaltorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3074, '8618', 'Oetwil am See', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3075, '8620', 'Wetzikon ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3076, '8621', 'Wetzikon ZH ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3077, '8622', 'Wetzikon ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3078, '8623', 'Wetzikon ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3079, '8624', 'Grüt (Gossau ZH)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3080, '8625', 'Gossau ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3081, '8626', 'Ottikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3082, '8627', 'Grüningen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3083, '8630', 'Rüti ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3084, '8632', 'Tann', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3085, '8633', 'Wolfhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3086, '8634', 'Hombrechtikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3087, '8635', 'Dürnten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3088, '8636', 'Wald ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3089, '8637', 'Laupen ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3090, '8638', 'Goldingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3091, '8639', 'Faltigberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3092, '8640', 'Rapperswil SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3093, '8645', 'Jona', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3094, '8646', 'Wagen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3095, '8700', 'Küsnacht ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3096, '8702', 'Zollikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3097, '8703', 'Erlenbach ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3098, '8704', 'Herrliberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3099, '8706', 'Meilen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3100, '8707', 'Uetikon am See', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3101, '8708', 'Männedorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3102, '8712', 'Stäfa', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3103, '8713', 'Uerikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3104, '8714', 'Feldbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3105, '8715', 'Bollingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3106, '8716', 'Schmerikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3107, '8717', 'Benken SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3108, '8718', 'Schänis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3109, '8722', 'Kaltbrunn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3110, '8723', 'Rufi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3111, '8725', 'Ernetschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3112, '8726', 'Ricken SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3113, '8727', 'Walde SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3114, '8730', 'Uznach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3115, '8732', 'Neuhaus SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3116, '8733', 'Eschenbach SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3117, '8734', 'Ermenswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3118, '8735', 'St. Gallenkappel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3119, '8737', 'Gommiswald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3120, '8738', 'Uetliburg SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3121, '8739', 'Rieden SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3122, '8740', 'Uznach Vögele AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3123, '8750', 'Glarus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3124, '8751', 'Urnerboden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3125, '8752', 'Näfels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3126, '8753', 'Mollis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3127, '8754', 'Netstal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3128, '8755', 'Ennenda', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3129, '8756', 'Mitlödi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3130, '8757', 'Filzbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3131, '8758', 'Obstalden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3132, '8759', 'Netstal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3133, '8762', 'Schwanden GL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3134, '8765', 'Engi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3135, '8766', 'Matt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3136, '8767', 'Elm', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3137, '8772', 'Nidfurn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3138, '8773', 'Haslen GL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3139, '8774', 'Leuggelbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3140, '8775', 'Luchsingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3141, '8777', 'Diesbach GL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3142, '8782', 'Rüti GL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3143, '8783', 'Linthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3144, '8784', 'Braunwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3145, '8800', 'Thalwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3146, '8802', 'Kilchberg ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3147, '8803', 'Rüschlikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3148, '8804', 'Au ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3149, '8805', 'Richterswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3150, '8806', 'Bäch SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3151, '8807', 'Freienbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3152, '8808', 'Pfäffikon SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3153, '8810', 'Horgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3154, '8812', 'Horgen Bhf Oberd.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3155, '8813', 'Horgen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3156, '8815', 'Horgenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3157, '8816', 'Hirzel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3158, '8820', 'Wädenswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3159, '8824', 'Schönenberg ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3160, '8825', 'Hütten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3161, '8832', 'Wollerau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3162, '8833', 'Samstagern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3163, '8834', 'Schindellegi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3164, '8835', 'Feusisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3165, '8836', 'Bennau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3166, '8840', 'Einsiedeln', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3167, '8841', 'Gross', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3168, '8842', 'Unteriberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3169, '8843', 'Oberiberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3170, '8844', 'Euthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3171, '8845', 'Studen SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3172, '8846', 'Willerzell', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3173, '8847', 'Egg SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3174, '8849', 'Alpthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3175, '8852', 'Altendorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3176, '8853', 'Lachen SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3177, '8854', 'Siebnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3178, '8855', 'Wangen SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3179, '8856', 'Tuggen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3180, '8857', 'Vorderthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3181, '8858', 'Innerthal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3182, '8862', 'Schübelbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3183, '8863', 'Buttikon SZ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3184, '8864', 'Reichenburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3185, '8865', 'Bilten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3186, '8866', 'Ziegelbrücke', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3187, '8867', 'Niederurnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3188, '8868', 'Oberurnen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3189, '8872', 'Weesen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3190, '8873', 'Amden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3191, '8874', 'Mühlehorn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3192, '8877', 'Murg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3193, '8878', 'Quinten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3194, '8879', 'Pizolpark (Mels)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3195, '8880', 'Walenstadt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3196, '8881', 'Walenstadtberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3197, '8882', 'Unterterzen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3198, '8883', 'Quarten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3199, '8884', 'Oberterzen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3200, '8885', 'Mols', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3201, '8886', 'Mädris-Vermol', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3202, '8887', 'Mels', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3203, '8888', 'Heiligkreuz (Mels)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3204, '8889', 'Plons', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3205, '8890', 'Flums', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3206, '8892', 'Berschis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3207, '8893', 'Flums Hochwiese', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3208, '8894', 'Flumserberg Saxli', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3209, '8895', 'Flumserberg Portel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3210, '8896', 'Flumserberg Bergh', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3211, '8897', 'Flumserberg Theim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3212, '8898', 'Flumserberg Tboden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3213, '8901', 'Urdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3214, '8902', 'Urdorf', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3215, '8903', 'Birmensdorf ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3216, '8904', 'Aesch ZH', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3217, '8905', 'Arni-Islisberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3218, '8906', 'Bonstetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3219, '8907', 'Wettswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3220, '8908', 'Hedingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3221, '8909', 'Zwillikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3222, '8910', 'Affoltern am Albis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3223, '8911', 'Rifferswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3224, '8912', 'Obfelden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3225, '8913', 'Ottenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3226, '8914', 'Aeugst am Albis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3227, '8915', 'Hausen am Albis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3228, '8916', 'Jonen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3229, '8917', 'Oberlunkhofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3230, '8918', 'Unterlunkhofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3231, '8919', 'Rottenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3232, '8925', 'Ebertswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3233, '8926', 'Kappel am Albis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3234, '8932', 'Mettmenstetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3235, '8933', 'Maschwanden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3236, '8934', 'Knonau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3237, '8942', 'Oberrieden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3238, '8951', 'Fahrweid', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3239, '8952', 'Schlieren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3240, '8953', 'Dietikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3241, '8954', 'Geroldswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3242, '8955', 'Oetwil a.d. Limmat', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3243, '8956', 'Killwangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3244, '8957', 'Spreitenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3245, '8962', 'Bergdietikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3246, '8964', 'Rudolfstetten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3247, '8965', 'Berikon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3248, '8966', 'Oberwil-Lieli', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3249, '8967', 'Widen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3250, '8970', 'Urdorf Exchange', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3251, '9000', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3252, '9001', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3253, '9004', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3254, '9006', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3255, '9007', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3256, '9008', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3257, '9010', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3258, '9011', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3259, '9012', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3260, '9013', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3261, '9014', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3262, '9015', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3263, '9016', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3264, '9020', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3265, '9022', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3266, '9023', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3267, '9024', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3268, '9026', 'St. Gallen K AG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3269, '9027', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3270, '9028', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3271, '9029', 'St. Gallen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3272, '9030', 'Abtwil SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3273, '9032', 'Engelburg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3274, '9033', 'Untereggen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3275, '9034', 'Eggersriet', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3276, '9035', 'Grub AR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3277, '9036', 'Grub SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3278, '9037', 'Speicherschwendi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3279, '9038', 'Rehetobel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3280, '9042', 'Speicher', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3281, '9043', 'Trogen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3282, '9044', 'Wald AR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3283, '9050', 'Appenzell', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3284, '9052', 'Niederteufen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3285, '9053', 'Teufen AR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3286, '9054', 'Haslen AI', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3287, '9055', 'Bühler', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3288, '9056', 'Gais', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3289, '9057', 'Weissbad', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3290, '9058', 'Brülisau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3291, '9062', 'Lustmühle', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3292, '9063', 'Stein AR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3293, '9064', 'Hundwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3294, '9100', 'Herisau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3295, '9101', 'Herisau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3296, '9102', 'Herisau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3297, '9103', 'Schwellbrunn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3298, '9104', 'Waldstatt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3299, '9105', 'Schönengrund', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3300, '9107', 'Urnäsch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3301, '9108', 'Gonten', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3302, '9112', 'Schachen b.Herisau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3303, '9113', 'Degersheim', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3304, '9114', 'Hoffeld', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3305, '9115', 'Dicken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3306, '9116', 'Wolfertswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3307, '9122', 'Mogelsberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3308, '9123', 'Nassen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3309, '9125', 'Brunnadern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3310, '9126', 'Necker', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3311, '9127', 'St. Peterzell', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3312, '9200', 'Gossau SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3313, '9201', 'Gossau SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3314, '9203', 'Niederwil SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3315, '9204', 'Andwil SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3316, '9205', 'Waldkirch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3317, '9212', 'Arnegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3318, '9213', 'Hauptwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3319, '9214', 'Kradolf-Schönenb.', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3320, '9215', 'Schönenberg TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3321, '9216', 'Heldswil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3322, '9217', 'Neukirch', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3323, '9220', 'Bischofszell', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3324, '9223', 'Schweizersholz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3325, '9225', 'Wilen (Gottshaus)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3326, '9230', 'Flawil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3327, '9231', 'Egg (Flawil)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3328, '9240', 'Uzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3329, '9242', 'Oberuzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3330, '9243', 'Jonschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3331, '9244', 'Niederuzwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3332, '9245', 'Oberbüren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3333, '9246', 'Niederbüren', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3334, '9247', 'Henau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3335, '9248', 'Bichwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3336, '9249', 'Algetshausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3337, '9300', 'Wittenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3338, '9301', 'Wittenbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3339, '9304', 'Bernhardzell', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3340, '9305', 'Berg SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3341, '9306', 'Freidorf TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3342, '9308', 'Lömmenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3343, '9312', 'Häggenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3344, '9313', 'Muolen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3345, '9314', 'Steinebrunn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3346, '9315', 'Winden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3347, '9320', 'Arbon', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3348, '9322', 'Egnach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3349, '9323', 'Steinach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3350, '9325', 'Roggwil TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3351, '9326', 'Horn', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3352, '9327', 'Tübach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3353, '9400', 'Rorschach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3354, '9401', 'Rorschach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3355, '9402', 'Mörschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3356, '9403', 'Goldach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3357, '9404', 'Rorschacherberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3358, '9405', 'Wienacht-Tobel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3359, '9410', 'Heiden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3360, '9411', 'Reute AR', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3361, '9413', 'Oberegg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3362, '9422', 'Staad SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3363, '9423', 'Altenrhein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3364, '9424', 'Rheineck', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3365, '9425', 'Thal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3366, '9426', 'Lutzenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3367, '9427', 'Wolfhalden', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3368, '9428', 'Walzenhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3369, '9430', 'St. Margrethen SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3370, '9434', 'Au SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3371, '9435', 'Heerbrugg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3372, '9436', 'Balgach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3373, '9437', 'Marbach SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3374, '9442', 'Berneck', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3375, '9443', 'Widnau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3376, '9444', 'Diepoldsau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3377, '9445', 'Rebstein', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3378, '9450', 'Lüchingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3379, '9451', 'Kriessern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3380, '9452', 'Hinterforst', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3381, '9453', 'Eichberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3382, '9462', 'Montlingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3383, '9463', 'Oberriet SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3384, '9464', 'Rüthi (Rheintal)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3385, '9465', 'Salez', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3386, '9466', 'Sennwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3387, '9467', 'Frümsen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3388, '9468', 'Sax', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3389, '9469', 'Haag (Rheintal)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3390, '9470', 'Buchs SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3391, '9471', 'Buchs SG ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3392, '9472', 'Grabs', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3393, '9473', 'Gams', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3394, '9475', 'Sevelen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3395, '9476', 'Weite', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3396, '9477', 'Trübbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3397, '9478', 'Azmoos', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3398, '9479', 'Oberschan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3399, '9485', 'Nendeln', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3400, '9486', 'Schaanwald', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3401, '9487', 'Gamprin-Bendern', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3402, '9488', 'Schellenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3403, '9489', 'Schaan Log', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3404, '9490', 'Vaduz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3405, '9491', 'Ruggell', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3406, '9492', 'Eschen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3407, '9493', 'Mauren FL', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3408, '9494', 'Schaan', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3409, '9495', 'Triesen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3410, '9496', 'Balzers', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3411, '9497', 'Triesenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3412, '9498', 'Planken', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3413, '9500', 'Wil SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3414, '9501', 'Wil SG ', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3415, '9502', 'Braunau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3416, '9503', 'Stehrenberg', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3417, '9504', 'Friltschen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3418, '9506', 'Lommis', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3419, '9507', 'Stettfurt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3420, '9508', 'Weingarten-Kalth', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3421, '9512', 'Rossrüti', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3422, '9514', 'Wuppenau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3423, '9515', 'Hosenruck', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3424, '9517', 'Mettlen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3425, '9523', 'Züberwangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3426, '9524', 'Zuzwil SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00');
INSERT INTO `faturacao_npa_localites` (`id`, `npa`, `localite`, `created_at`, `updated_at`) VALUES
(3427, '9525', 'Lenggenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3428, '9526', 'Zuckenriet', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3429, '9527', 'Niederhelfenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3430, '9532', 'Rickenbach b. Wil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3431, '9533', 'Kirchberg SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3432, '9534', 'Gähwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3433, '9535', 'Wilen b. Wil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3434, '9536', 'Schwarzenbach SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3435, '9542', 'Münchwilen TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3436, '9543', 'St. Margarethen TG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3437, '9545', 'Wängi', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3438, '9546', 'Tuttwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3439, '9547', 'Wittenwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3440, '9548', 'Matzingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3441, '9552', 'Bronschhofen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3442, '9553', 'Bettwiesen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3443, '9554', 'Tägerschen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3444, '9555', 'Tobel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3445, '9556', 'Affeltrangen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3446, '9562', 'Märwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3447, '9565', 'Rothenhausen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3448, '9573', 'Littenheid', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3449, '9601', 'Lütisburg Station', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3450, '9602', 'Bazenheid', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3451, '9604', 'Oberrindal', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3452, '9606', 'Bütschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3453, '9607', 'Mosnang', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3454, '9608', 'Ganterschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3455, '9612', 'Dreien', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3456, '9613', 'Mühlrüti', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3457, '9614', 'Libingen', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3458, '9615', 'Dietfurt', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3459, '9620', 'Lichtensteig', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3460, '9621', 'Oberhelfenschwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3461, '9622', 'Krinau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3462, '9630', 'Wattwil', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3463, '9631', 'Ulisbach', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3464, '9633', 'Bächli (Hemberg)', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3465, '9642', 'Ebnat-Kappel', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3466, '9643', 'Krummenau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3467, '9650', 'Nesslau', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3468, '9651', 'Ennetbühl', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3469, '9652', 'Neu St. Johann', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3470, '9655', 'Stein SG', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3471, '9656', 'Alt St. Johann', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3472, '9657', 'Unterwasser', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3473, '9658', 'Wildhaus', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3474, '1724', 'Ferpicloz', '2017-06-02 18:00:00', '2017-06-02 18:00:00'),
(3475, '1724', 'Le Mouret', '2018-10-02 22:00:00', '2018-10-02 22:00:00'),
(3476, '1724', 'Senèdes', '2018-10-02 22:00:00', '2018-10-02 22:00:00'),
(3477, '1724', 'Oberried', '2018-10-02 22:00:00', '2018-10-02 22:00:00');

CREATE TABLE `faturacao_orcamentos` (
  `ID_Orcamento` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `WorkType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'OR',
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataValidade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `Estado` enum('Rascunho','Rejeitado','Aprovado','Aberto') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_orcamentos_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_Orcamento` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_permissions` (
  `ID_Permission` bigint(30) UNSIGNED NOT NULL,
  `Machine_Name` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Name` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Funcionalidade` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
(3, '0001', 'Gestion des autorisations (Créer / Modifier / Supprimer / Consulter)', 1),
(4, '0002', 'Gestion des utilisateurs (Créer)', 1),
(5, '0003', 'Gestion des utilisateurs (Modifier)', 1),
(6, '0004', 'Gestion des utilisateurs (Supprimer)', 1),
(7, '0005', 'Gestion des utilisateurs (Consulter)', 1),
(8, '0006', 'Donnés Société (Modifier)', 1),
(9, '0007', 'Personnaliser (Modifier)', 1),
(10, '0008', 'Série (Modifier)', 1),
(11, '0009', 'Modèle d\'Expédition (Modifier)', 1),
(12, '0010', 'Information  (Consulter)', 1),
(13, '0011', 'Logs (Consulter)', 1),
(14, '0012', 'Informations générales (coin supérieur) (Consulter)', 2),
(15, '0013', 'Vue Globale - Statistiques (Consulter)', 3),
(16, '0014', 'Vue Globale - Rappels (Consulter)', 3),
(17, '0015', 'Afficher Tout (Consulter)', 4),
(18, '0016', 'Gestion des Clients (Créer)', 4),
(19, '0017', 'Gestion des Clients (Modifier)', 4),
(20, '0018', 'Gestion des Clients (Supprimer)', 4),
(21, '0019', 'Gestion des Clients (Consulter)', 4),
(22, '0020', 'Bulletin de Livraison (Créer)', 5),
(23, '0021', 'Bulletin de Livraison (Modifier)', 5),
(24, '0022', 'Bulletin de Livraison (Supprimer)', 5),
(25, '0023', 'Bulletin de Livraison (Consulter)', 5),
(26, '0024', 'Bulletin de Livraison (Générer Documents)', 5),
(27, '0025', 'Factures (Créer)', 6),
(28, '0026', 'Factures (Modifier)', 6),
(29, '0027', 'Factures (Supprimer)', 6),
(30, '0028', 'Factures (Consulter)', 6),
(31, '0029', 'Factures (Générer Documents)', 6),
(32, '0030', 'Factures (Paiments - Créer / Modifier / Consulter)', 6),
(33, '0031', 'Notes de Crédit (Créer)', 7),
(34, '0032', 'Notes de Crédit (Modifier)', 7),
(35, '0033', 'Notes de Crédit (Supprimer)', 7),
(36, '0034', 'Notes de Crédit (Consulter)', 7),
(37, '0035', 'Contrats de Location (Créer)', 8),
(38, '0036', 'Contrats de Location (Modifier)', 8),
(39, '0037', 'Contrats de Location (Supprimer)', 8),
(40, '0038', 'Contrats de Location (Consulter)', 8),
(41, '0039', 'Contrats de Location (Générer Documents)', 8),
(42, '0040', 'Contrats de Consommables (Créer)', 9),
(43, '0041', 'Contrats de Consommables (Modifier)', 9),
(44, '0042', 'Contrats de Consommables (Supprimer)', 9),
(45, '0043', 'Contrats de Consommables (Consulter)', 9),
(46, '0044', 'Contrats de Consommables (Générer Documents)', 9),
(47, '0045', 'Afficher Tout (Consulter)', 10),
(48, '0046', 'Gestion des Fournisseurs (Créer)', 10),
(49, '0047', 'Gestion des Fournisseurs (Modifier)', 10),
(50, '0048', 'Gestion des Fournisseurs (Supprimer)', 10),
(51, '0049', 'Gestion des Fournisseurs (Consulter)', 10),
(52, '0050', 'Achats (Créer)', 11),
(53, '0051', 'Achats (Modifier)', 11),
(54, '0052', 'Achats (Supprimer)', 11),
(55, '0053', 'Achats (Consulter)', 11),
(56, '0054', 'Achats (Payer / Ouvrir / Annuler)', 11),
(57, '0055', 'Achats: Notes de Crédit (Créer)', 12),
(58, '0056', 'Achats: Notes de Crédit (Modifier)', 12),
(59, '0057', 'Achats: Notes de Crédit (Supprimer)', 12),
(60, '0058', 'Achats: Notes de Crédit (Consulter)', 12),
(61, '0059', 'Achats: Notes de Crédit (Payer / Ouvrir / Annuler)', 12),
(62, '0060', 'Articles (Créer)', 13),
(63, '0061', 'Articles (Modifier)', 13),
(64, '0062', 'Articles (Supprimer)', 13),
(65, '0063', 'Articles (Consulter)', 13),
(66, '0064', 'Banques (Créer)', 14),
(67, '0065', 'Banques (Modifier)', 14),
(68, '0066', 'Banques (Supprimer)', 14),
(69, '0067', 'Banques (Consulter)', 14),
(70, '0068', 'Banques Fournisseurs (Modifier / Consulter)', 15),
(71, '0069', 'Plan Comptable (Créer)', 16),
(72, '0070', 'Plan Comptable (Modifier)', 16),
(73, '0071', 'Plan Comptable (Supprimer)', 16),
(74, '0072', 'Plan Comptable (Consulter)', 16),
(75, '0073', 'Taxes (Créer)', 17),
(76, '0074', 'Taxes (Modifier)', 17),
(77, '0075', 'Taxes (Supprimer)', 17),
(78, '0076', 'Taxes (Consulter)', 17),
(79, '0077', 'Responsables (Créer)', 18),
(80, '0078', 'Responsables (Modifier)', 18),
(81, '0079', 'Responsables (Supprimer)', 18),
(82, '0080', 'Responsables (Consulter)', 18),
(83, '0081', 'Vendeurs (Créer)', 19),
(84, '0082', 'Vendeurs (Modifier)', 19),
(85, '0083', 'Vendeurs (Supprimer)', 19),
(86, '0084', 'Vendeurs (Consulter)', 19),
(87, '0085', 'TVA Décompte (Générer)', 20),
(88, '0086', 'TVA Décompte (Consulter)', 20),
(89, '0087', 'TVA Récapitulatif Payer / Recapitularif Réception (Générer)', 21),
(90, '0088', 'Bilan (Consulter)', 22),
(91, '0089', 'Compte Résultat (Consulter)', 23),
(92, '0090', 'Mouvements (Créer)', 24),
(93, '0091', 'Mouvements (Modifier)', 24),
(94, '0092', 'Mouvements (Supprimer)', 24),
(95, '0093', 'Gestion BVR (Importer / Consulter)', 25),
(96, '0094', 'Shop Online: Synchroniser (Générer Documents)', 26),
(97, '0095', 'Shop Online: Synchroniser (Consulter)', 26),
(98, '0096', 'Shop Online: Synchroniser (Archive)', 26),
(99, '0097', 'Shop Online: Archive (Restaurer / Consulter)', 27),
(100, '0098', 'Shop Online: Historique (Restaurer / Consulter)', 28),
(101, '0099', 'Rechercher: Lignes de Factures (Consulter)', 29),
(102, '0100', 'Gestion des contrats responsables (Créer)', 30),
(103, '0101', 'Gestion des contrats responsables (Modifier)', 30),
(104, '0102', 'Gestion des contrats responsables (Supprimer)', 30),
(105, '0103', 'Gestion des contrats responsables (Consulter)', 30),
(106, '0104', 'ACCÈS LIMITÉ (VENDEUR)', 1),
(107, '0105', 'Vue Globale - Statistiques Vendeur (Consulter)', 3),
(108, '0106', 'Vue Globale - Rappels Vendeur (Consulter)', 3),
(109, '0107', 'Informations générales Vendeurs (coin supérieur) (Consulter)', 2);

CREATE TABLE `faturacao_personalizar_documentos` (
  `ID_personalizar` int(10) UNSIGNED NOT NULL,
  `MetodoPagamento` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RazaoIsencao` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Rodape` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NumeroCopias` int(10) UNSIGNED NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `Iban` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Swift` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_personalizar_documentos` (`ID_personalizar`, `MetodoPagamento`, `RazaoIsencao`, `Observacoes`, `Rodape`, `NumeroCopias`, `Vencimento`, `Iban`, `Swift`) VALUES
(1, '3', '', '', '', 2, 10, '', '');

CREATE TABLE `faturacao_personalizar_planos_defeito` (
  `ID_Personalizacao` bigint(20) UNSIGNED NOT NULL,
  `Keyword` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PlanoConta` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_personalizar_planos_defeito` (`ID_Personalizacao`, `Keyword`, `PlanoConta`) VALUES
(1, 'cliente', '1100'),
(2, 'fornecedor', '2000'),
(3, 'artigo_chiffre', '3200'),
(4, 'artigo_prealable', '4200'),
(5, 'banco', '1002'),
(6, 'imposto', '2200');

CREATE TABLE `faturacao_plano_conta` (
  `ID_Plano` bigint(20) NOT NULL,
  `Codigo` int(10) NOT NULL,
  `Descricao` varchar(100) NOT NULL,
  `PlanoCategoria` varchar(100) NOT NULL,
  `SubCategoriaPlanoConta` varchar(100) NOT NULL,
  `ID_CobrancaIVA` varchar(100) NOT NULL,
  `ID_CodigoIVA` int(11) NOT NULL,
  `Ecriture` varchar(100) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_plano_conta` (`ID_Plano`, `Codigo`, `Descricao`, `PlanoCategoria`, `SubCategoriaPlanoConta`, `ID_CobrancaIVA`, `ID_CodigoIVA`, `Ecriture`) VALUES
(1, 1, 'ACTIFS', 'Bilan', 'Actif', '', 0, ''),
(2, 10, 'ACTIFS CIRCULANTS', 'Bilan', 'Actif', '', 0, ''),
(3, 100, 'LIQUIDITES', 'Bilan', 'Actif', '', 0, ''),
(4, 1000, 'Caisse', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(5, 1020, 'Banque (avoir)', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(6, 106, 'AVOIRS A COURT TERME COTES EN BOURSE', 'Bilan', 'Actif', '', 0, ''),
(7, 1060, 'Titres', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(8, 1069, 'Ajustement de la valeur des titres', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(9, 110, 'CREANCES RESULTANT DE LIVRAISONS ET PRESTATIONS', 'Bilan', 'Actif', '', 0, ''),
(10, 1100, 'Créances provenant de livraisons et de prestations (Débiteurs)', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(11, 1109, 'Ducroire', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(12, 1110, 'Créances résultant de livr. et prest. envers les sociétés du groupe', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(13, 114, 'AUTRES CREANCES A COURT TERME', 'Bilan', 'Actif', '', 0, ''),
(14, 1140, 'Avances et prêts', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(15, 1149, 'Ajustement de la valeur des avances et des prêts', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(16, 1170, 'Impôt préalable: TVA s/matériel, marchandises, prestations et énergie', 'Bilan', 'Actif', 'Contrepartie TVA', 0, 'Neutre'),
(17, 1171, 'Impôt préalable: TVA s/investissements et autres charges d\'exploitation', 'Bilan', 'Actif', 'Contrepartie TVA', 0, 'Neutre'),
(18, 1176, 'Impôt anticipé', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(19, 1180, 'Créances envers les assurances sociales et institutions de prévoyance', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(20, 1189, 'Impôt à la source', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(21, 1190, 'Autres créances à court terme', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(22, 1199, 'Ajustement de la valeur des créances à court terme', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(23, 120, 'STOCKS ET PRESTATIONS NON FACTUREES', 'Bilan', 'Actif', '', 0, ''),
(24, 1200, 'Marchandises commerciales', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(25, 1210, 'Matières premières', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(26, 1220, 'Matières auxiliaires', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(27, 1230, 'Matières consommables', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(28, 1250, 'Marchandises en consignation', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(29, 1260, 'Stocks de produits finis', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(30, 1280, 'Travaux en cours', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(31, 130, 'COMPTE DE REGULARISATION DE L\'ACTIF', 'Bilan', 'Actif', '', 0, ''),
(32, 1300, 'Charges payées d\'avance', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(33, 1301, 'Produits à recevoir', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(34, 14, 'ACTIFS IMMOBILISES', 'Bilan', 'Actif', '', 0, ''),
(35, 140, 'IMMOBILISATIONS FINANCIERES', 'Bilan', 'Actif', '', 0, ''),
(36, 1400, 'Titres à long terme', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(37, 1409, 'Ajustement de la valeur des titres', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(38, 1440, 'Prêts', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(39, 1441, 'Hypothèques', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(40, 1449, 'Ajustement de la valeur des créances à long terme', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(41, 148, 'PARTICIPATIONS', 'Bilan', 'Actif', '', 0, ''),
(42, 1480, 'Participations', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(43, 1489, 'Ajustement de la valeur des participations', 'Bilan', 'Actif', 'Hors TVA', 0, 'Neutre'),
(44, 150, 'IMMOBILISATIONS CORPORELLES MEUBLES ', 'Bilan', 'Actif', '', 0, ''),
(45, 1500, 'Machines et appareils', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(46, 1509, 'Ajustement de la valeur des machines et appareils', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(47, 1510, 'Mobilier et installations', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(48, 1519, 'Ajustement de la valeur du mobilier et des installations', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(49, 1520, 'Machines de bureau, informatique, systèmes de communication', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(50, 1529, 'Ajustement de la valeur des machines de bureau, inf. et syst. comm.', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(51, 1530, 'Véhicules', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(52, 1539, 'Ajustement de la valeur des véhicules', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(53, 1540, 'Outillages et appareils', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(54, 1549, 'Ajustement de la valeur des outillages et appareils', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(55, 160, 'IMMOBILISATIONS CORPORELLES IMMEUBLES', 'Bilan', 'Actif', '', 0, ''),
(56, 1600, 'Immeubles d\'exploitation', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(57, 1609, 'Ajustement de la valeur des immeubles d\'exploitation', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(58, 170, 'IMMOBILISATIONS INCORPORELLES', 'Bilan', 'Actif', '', 0, ''),
(59, 1700, 'Brevets, know-how, licences, droits, développement', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(60, 1709, 'Ajustement de la valeur des brevets, know-how, licences, droits, dév.', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(61, 1770, 'Goodwill', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(62, 1779, 'Ajustement de la valeur des goodwill', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(63, 180, 'CAPITAL NON VERSE : CAPITAL SOCIAL, CAPITAL DE FONDATION', 'Bilan', 'Actif', '', 0, ''),
(64, 1850, 'Capital actions, capital social, droits de participations ou capital de fondation non versés', 'Bilan', 'Actif', 'Imposable', 0, 'Neutre'),
(65, 2, 'PASSIFS', 'Bilan', 'Passif', '', 0, ''),
(66, 20, 'DETTES A COURT TERME', 'Bilan', 'Passif', '', 0, ''),
(67, 200, 'DETTES A COURT TERME RESULTANT D\'ACHATS ET DE PRESTATIONS DE SERVICES', 'Bilan', 'Passif', '', 0, ''),
(68, 2000, 'Dettes résultant d\'achats et de prestation de services (créanciers)', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(69, 2030, 'Acomptes de clients', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(70, 2050, 'Dettes résultant d\'achats et de prestations de services envers des sociétés du groupe', 'Bilan', 'Passif', 'Imposable', 0, 'Neutre'),
(71, 210, 'DETTES A COURT TERME REMUNERES', 'Bilan', 'Passif', '', 0, ''),
(72, 2100, 'Dettes bancaires', 'Bilan', 'Passif', 'Imposable', 0, 'Neutre'),
(73, 2120, 'Engagements de financement par leasing', 'Bilan', 'Passif', 'Imposable', 0, 'Neutre'),
(74, 2140, 'Autres dettes à court terme rémunérées', 'Bilan', 'Passif', 'Imposable', 0, 'Neutre'),
(75, 220, 'AUTRES DETTES A COURT TERME', 'Bilan', 'Passif', '', 0, ''),
(76, 2200, 'TVA due', 'Bilan', 'Passif', 'Contrepartie TVA', 0, 'Neutre'),
(77, 2201, 'Décompte TVA', 'Bilan', 'Passif', 'Contrepartie TVA', 0, 'Neutre'),
(78, 2206, 'Impôt anticipé dû', 'Bilan', 'Passif', 'Contrepartie TVA', 0, 'Neutre'),
(79, 2208, 'Impôts directs', 'Bilan', 'Passif', 'Contrepartie TVA', 0, 'Neutre'),
(80, 2210, 'Autres dettes à court terme', 'Bilan', 'Passif', 'Contrepartie TVA', 0, 'Neutre'),
(81, 2261, 'Dividendes', 'Bilan', 'Passif', 'Contrepartie TVA', 0, 'Neutre'),
(82, 2270, 'Assurances sociales et institutions de prévoyance', 'Bilan', 'Passif', 'Contrepartie TVA', 0, 'Neutre'),
(83, 2279, 'Impôt à la source', 'Bilan', 'Passif', 'Contrepartie TVA', 0, 'Neutre'),
(84, 230, 'PASSIFS DE REGULARISATION ET PROVISIONS A COURT TERME', 'Bilan', 'Passif', '', 0, ''),
(85, 2300, 'Charges à payer', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(86, 2301, 'Produits encaissés d\'avance', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(87, 2330, 'Provisions à court terme', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(88, 24, 'DETTES A LONG TERME', 'Bilan', 'Passif', '', 0, ''),
(89, 240, 'DETTES A LONG TERME REMUNEREES', 'Bilan', 'Passif', '', 0, ''),
(90, 2400, 'Dettes bancaires', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(91, 2420, 'Engagements de financement par leasing', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(92, 2430, 'Emprunts obligataires', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(93, 2450, 'Emprunts', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(94, 2451, 'Hypothèques', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(95, 250, 'AUTRES DETTES A LONG TERME', 'Bilan', 'Passif', '', 0, ''),
(96, 2500, 'Autres dettes à long terme', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(97, 260, 'PROVISIONS A LONG TERMES ET PROVISIONS LEGALES', 'Bilan', 'Passif', '', 0, ''),
(98, 2600, 'Provisions', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(99, 28, 'FONDS PROPRES (PERSONNES MORALES)', 'Bilan', 'Passif', '', 0, ''),
(100, 280, 'CAPITAL SOCIAL OU CAPITAL DE FONDATION', 'Bilan', 'Passif', '', 0, ''),
(101, 2800, 'Capital-actions, capital social, capital de fondation', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(102, 290, 'RESERVES / BENEFICES ET PERTES', 'Bilan', 'Passif', '', 0, ''),
(103, 2900, 'Réserves légales issues du capital', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(104, 2930, 'Réserves sur participations propres au capital', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(105, 2940, 'Réserves d\'évaluation', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(106, 2950, 'Réserves légales issues du bénéfice', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(107, 2960, 'Réserves libres', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(108, 2970, 'Bénéfice / perte reporté', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(109, 2979, 'Bénéfice / perte de l\'exercice', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(110, 2980, 'Propres actions, parts sociales, droits de participations (poste négatif)', 'Bilan', 'Passif', 'Hors TVA', 0, 'Neutre'),
(111, 3, 'CHIFFRE D\'AFFAIRES RESULTANT DES VENTES ET DES PRESTATIONS DE SERVICES', 'Compte d\'exploitation', 'Rendement', '', 0, ''),
(112, 3000, 'Ventes de produits fabriqués', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre'),
(113, 3200, 'Ventes de marchandises', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre'),
(114, 3400, 'Ventes de prestations', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre'),
(115, 3600, 'Autres ventes et prestations de services', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre'),
(116, 3700, 'Prestations propres', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre'),
(117, 3710, 'Consommations propres', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre'),
(118, 3800, 'Déductions sur ventes', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre'),
(119, 3805, 'Pertes sur clients, variation du ducroire', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre'),
(120, 3900, 'Variation des stocks de produits semi-finis', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Débit'),
(121, 3901, 'Variation des stocks de produits finis', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Débit'),
(122, 3940, 'Variation de la valeur des prestations non facturées', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Débit'),
(123, 4, 'CHARGES DE MATERIEL, DE MARCHANDISES ET DE PRESTATIONS DE TIERS', 'Compte d\'exploitation', 'Charges', '', 0, ''),
(124, 4000, 'Charges de matériel de l\'atelier', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(125, 4200, 'Achats de marchandises destinées à la revente', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(126, 4400, 'Prestations / travaux de tiers', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Neutre'),
(127, 4500, 'Charges d\'énergie pour l\'exploitation', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Neutre'),
(128, 4900, 'Déductions sur les charges', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Neutre'),
(129, 5, 'CHARGES DE PERSONNEL', 'Compte d\'exploitation', 'Charges', '', 0, ''),
(130, 5000, 'Salaires', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(131, 5700, 'Charges sociales', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(132, 5800, 'Autres charges du personnel', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(133, 5900, 'Charges de personnels temporaires', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(134, 6, 'AUTRES CHARGES D\'EXPLOITATION, AMORTISSEMENTS ET AJUSTEMENT DE VALEUR, RESULTAT FINANCIER', 'Compte d\'exploitation', 'Charges', '', 0, ''),
(135, 6000, 'Charges de locaux', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(136, 6100, 'Entretien, réparations et remplacement des inst. servant à l\'exploitation', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(137, 6105, 'Leasing immobilisations corporelles meubles', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(138, 6200, 'Charges de véhicules et de transport', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(139, 6260, 'Leasing et location de véhicules', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(140, 6300, 'Assurances-choses, droits, taxes, autorisations', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(141, 6400, 'Charges d\'énergie et évacuation des déchets', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(142, 6500, 'Charges d\'administration', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(143, 6570, 'Charges et leasing d\'informatique', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(144, 6600, 'Publicité', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(145, 6700, 'Autres charges d\'exploitation', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(146, 6800, 'Amortissement et ajustement de valeur des postes sur immobilisations corporelles', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Neutre'),
(147, 6900, 'Charges financières', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(148, 6950, 'Produits financiers', 'Compte d\'exploitation', 'Charges', 'Imposable', 0, 'Débit'),
(149, 7, 'RESULTAT DES ACTIVITES ANNEXES D\'EXPLOITATION', 'Compte d\'exploitation', 'Rendement', '', 0, ''),
(150, 7000, 'Produits accessoires', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Credit'),
(151, 7100, 'Charges accessoires', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Débit'),
(152, 7500, 'Produits des immeubles d\'exploitation', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Credit'),
(153, 7510, 'Charges des immeubles d\'exploitation', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Débit'),
(154, 8, 'RESULTATS EXTRAORDINAIRES ET HORS EXPLOITATION', 'Compte d\'exploitation', 'Rendement', '', 0, ''),
(155, 8000, 'Charges hors exploitation', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Credit'),
(156, 8100, 'Produits hors exploitation', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Débit'),
(157, 8500, 'Charges extraordinaires, exceptionnelles ou hors période', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(158, 8510, 'Produits extraordinaires, exceptionnels ou hors période', 'Compte d\'exploitation', 'Rendement', 'Hors TVA', 0, 'Débit'),
(159, 8900, 'Impôts directs', 'Compte d\'exploitation', 'Charges', 'Hors TVA', 0, 'Débit'),
(160, 9, 'CLÔTURE', 'Neutre', 'Indéfini', '', 0, ''),
(161, 9200, 'Bénéfice / perte de l\'exercice', 'Neutre', 'Indéfini', '', 0, 'Neutre'),
(162, 3207, 'Frais de Rappel', 'Compte d\'exploitation', 'Rendement', 'Imposable', 0, 'Neutre');

CREATE TABLE `faturacao_proformas` (
  `ID_Proforma` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Vencimento` int(10) UNSIGNED NOT NULL,
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `WorkType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'PF',
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataValidade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemDesconto` decimal(20,6) NOT NULL,
  `TotaRetencao` decimal(20,6) NOT NULL,
  `TotalSDesconto` decimal(20,6) UNSIGNED NOT NULL,
  `Estado` enum('Rascunho','Rejeitado','Aprovado','Aberto') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_UtilizadorAtualizacao` int(11) NOT NULL,
  `DataAtualizacao` varchar(30) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_proformas_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_Proforma` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NOT NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_recibos` (
  `ID_Recibo` bigint(20) UNSIGNED NOT NULL,
  `ID_Serie` bigint(20) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Period` int(2) UNSIGNED NOT NULL,
  `TransactionDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaymentType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'RG',
  `PaymentStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `PaymentStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourcePayment` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'P',
  `Description` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID_Estado` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SourceID_Origem` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimestampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `TotalRecebido` decimal(20,6) UNSIGNED NOT NULL,
  `ID_Moeda` int(10) UNSIGNED NOT NULL,
  `TaxaMoeda` decimal(20,6) UNSIGNED NOT NULL,
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `Estado` enum('Pago','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_DocumentoMain` bigint(30) UNSIGNED NOT NULL,
  `Tipo_DocumentoMain` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_recibos_linhas` (
  `ID_Linha` bigint(20) UNSIGNED NOT NULL,
  `ID_Recibo` bigint(20) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Documento` bigint(20) UNSIGNED NOT NULL,
  `TipoDocumento` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `OriginatingOn` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NOT NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NOT NULL,
  `ValorRetencao` decimal(20,6) UNSIGNED NOT NULL,
  `valorIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_recibos_pagamentos` (
  `ID_Pagamento` bigint(20) UNSIGNED NOT NULL,
  `ID_Recibo` bigint(20) UNSIGNED NOT NULL,
  `PaymentMechanism` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaymentAmount` decimal(20,6) UNSIGNED NOT NULL,
  `PaymentDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Metodo` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_responsaveis` (
  `ID_Responsavel` bigint(30) UNSIGNED NOT NULL,
  `Codigo` bigint(30) UNSIGNED NOT NULL,
  `Nome` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Prenom` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Contacto` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Email` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampResponsavel` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_responsavel_contratos` (
  `ID_RespContrato` bigint(30) UNSIGNED NOT NULL,
  `Nome` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Contacto` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo_Interno` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampVendedor` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_responsavel_entidades` (
  `ID_RespEnt` bigint(30) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Fornecedor` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Responsavel` bigint(30) UNSIGNED NOT NULL,
  `Posicao` tinyint(3) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_roles` (
  `ID_Role` bigint(30) UNSIGNED NOT NULL,
  `Name` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Timestamp_Role` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_roles` (`ID_Role`, `Name`, `Timestamp_Role`) VALUES
(1, 'Vendeur', '1523641656.29'),
(3, 'Collaborateur', '1523890364.0297'),
(4, 'Administrateur', '1523890391.5096');

CREATE TABLE `faturacao_role_permission` (
  `ID_Role_Rel` bigint(30) UNSIGNED NOT NULL,
  `ID_Permission_Rel` bigint(30) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_series` (
  `ID_Serie` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Predefinida` tinyint(1) UNSIGNED NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_series` (`ID_Serie`, `Nome`, `Predefinida`) VALUES
(1, YEAR(NOW()), 1);

CREATE TABLE `faturacao_snc_base` (
  `ID_Snc_Base` int(11) NOT NULL,
  `Snc_Code` bigint(30) NOT NULL,
  `Taxonomy_Code` bigint(30) NOT NULL,
  `Descricao` varchar(100) NOT NULL,
  `Grouping_Category` varchar(2) NOT NULL,
  `Grouping_Code` bigint(30) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_snc_base` (`ID_Snc_Base`, `Snc_Code`, `Taxonomy_Code`, `Descricao`, `Grouping_Category`, `Grouping_Code`) VALUES
(1, 11, 1, 'Caixa', 'GR', 0),
(2, 12, 2, 'Depósitos à ordem', 'GR', 0),
(3, 13, 3, 'Outros depósitos bancários', 'GR', 0),
(4, 14, 0, 'Outros instrumentos financeiros', 'GR', 0),
(5, 141, 0, 'Derivados', 'GA', 14),
(6, 1411, 4, 'Potencialmente favoráveis', 'GA', 141),
(7, 1412, 5, 'Potencialmente favoráveis', 'GA', 141),
(8, 142, 0, 'Instrumentos financeiros detidos para negociação', 'GA', 14),
(9, 1421, 6, 'Ativos Finaceiros', 'GA', 142),
(10, 1422, 7, 'Passivos Finaceiros', 'GA', 142),
(11, 143, 0, 'Outros ativos e passivos financeiros', 'GA', 14),
(12, 1431, 8, 'Outros ativos financeiros', 'GA', 143),
(13, 1432, 9, 'Outros passivos financeiros', 'GA', 143),
(14, 21, 0, 'Clientes', 'GR', 0),
(15, 211, 0, 'Clientes c/c', 'GA', 21),
(16, 2111, 10, 'Clientes gerais', 'GA', 211),
(17, 2112, 11, 'Clientes - empresa-mâe', 'GA', 211),
(18, 2113, 12, 'Clientes - empresas subsidiárias', 'GA', 211),
(19, 2114, 13, 'Clientes - empresas associadas', 'GA', 211),
(20, 2115, 14, 'Clientes - empreendimentos conjuntos', 'GA', 211),
(21, 2116, 15, 'Clientes - outras partes relacionadas', 'GA', 211),
(22, 2117, 10, 'Clientes gerais', 'GA', 211),
(23, 2118, 10, 'Clientes gerais', 'GA', 211),
(24, 2119, 10, 'Clientes gerais', 'GA', 211),
(25, 212, 0, 'Clientes - títulos a receber', 'GA', 21),
(26, 2121, 16, 'Clientes gerais', 'GA', 212),
(27, 2122, 17, 'Clientes - empresa-mâe', 'GA', 212),
(28, 2123, 18, 'Clientes - empresas-subsidiárias', 'GA', 212),
(29, 2124, 19, 'Clientes - empresas - associadas', 'GA', 212),
(30, 2125, 20, 'Clientes - empreendimentos conjuntos', 'GA', 212),
(31, 2126, 21, 'Clientes - outras partes relacionadas', 'GA', 212),
(32, 2127, 16, 'Clientes gerais', 'GA', 212),
(33, 2128, 16, 'Clientes gerais', 'GA', 212),
(34, 2129, 16, 'Clientes gerais', 'GA', 212),
(35, 218, 23, 'Atendimento de clientes', 'GA', 21),
(36, 219, 24, 'Perdas por imparidade acumuladas - Clientes c/c - Clientes gerais', 'GA', 21),
(37, 219, 25, 'Perdas por imparidade acumuladas - Clientes c/c - empresa-mâe', 'GA', 21),
(38, 219, 26, 'Perdas por imparidade acumuladas - Clientes c/c - empresas subsidiárias', 'GA', 21),
(39, 219, 27, 'Perdas por imparidade acumuladas - Clientes c/c - empresas associadas', 'GA', 21),
(40, 219, 28, 'Perdas por imparidade acumuladas - Clientes c/c - empreendimentos conjuntos', 'GA', 21),
(41, 219, 29, 'Perdas por imparidade acumuladas - Clientes c/c - outras partes relacionadas', 'GA', 21),
(42, 219, 30, 'Perdas por imparidade acumuladas - Clientes c/c - Titulos a receber - Clientes gerais', 'GA', 21),
(43, 219, 31, 'Perdas por imparidade acumuladas - Clientes c/c - Titulos a receber - Clientes - empresa-mâe', 'GA', 21),
(44, 219, 32, 'Perdas por imparidade acumuladas - Clientes c/c - Titulos a receber - Clientes - empresas subsidiári', 'GA', 21),
(45, 219, 33, 'Perdas por imparidade acumuladas - Clientes c/c - Titulos a receber - Clientes - empresas associadas', 'GA', 21),
(46, 219, 34, 'Perdas por imparidade acumuladas - Clientes c/c - Titulos a receber - Clientes - empreendimentos con', 'GA', 21),
(47, 219, 35, 'Perdas por imparidade acumuladas - Clientes c/c - Titulos a receber - Clientes - outras partes relac', 'GA', 21),
(48, 219, 36, 'Perdas por imparidade acumuladas - Outros clientes', 'GA', 21),
(49, 22, 0, 'Fornecedores', 'GR', 0),
(50, 221, 0, 'Fornecedores c/c', 'GA', 22),
(51, 2211, 37, 'Fornecedores gerais', 'GA', 221),
(52, 2212, 38, 'Fornecedores - empresa-mâe', 'GA', 221),
(53, 2213, 39, 'Fornecedores - empresas-subsidiárias', 'GA', 221),
(54, 2214, 40, 'Fornecedores - empresas associadas', 'GA', 221),
(55, 2215, 41, 'Fornecedores - empresas empreendimentos conjuntos', 'GA', 221),
(56, 2216, 42, 'Fornecedores - outras partes relacionadas', 'GA', 221),
(57, 2217, 37, 'Fornecedores gerais', 'GA', 221),
(58, 2218, 37, 'Fornecedores gerais', 'GA', 221),
(59, 2219, 37, 'Fornecedores gerais', 'GA', 221),
(60, 222, 0, 'Fornecedores - Titulos a pagar', 'GA', 22),
(61, 2221, 43, 'Fornecedores gerais', 'GA', 222),
(62, 2222, 44, 'Fornecedores - empresa-mâe', 'GA', 222),
(63, 2223, 45, 'Fornecedores - empresas-subsidiárias', 'GA', 222),
(64, 2224, 46, 'Fornecedores - empresas associadas', 'GA', 222),
(65, 2225, 47, 'Fornecedores - empreendimentos conjuntos', 'GA', 222),
(66, 2226, 48, 'Fornecedores - Outras partes relacionadas', 'GA', 222),
(67, 2227, 43, 'Fornecedores gerais', 'GA', 222),
(68, 2228, 43, 'Fornecedores gerais', 'GA', 222),
(69, 2229, 43, 'Fornecedores gerais', 'GA', 222),
(70, 223, 49, 'Fornecedores - Outros Fornecedores', 'GA', 22),
(71, 224, 49, 'Fornecedores - Outros Fornecedores', 'GA', 22),
(72, 225, 50, 'Faturas em recepção e conferência', 'GA', 22),
(73, 226, 49, 'Fornecedores - Outros Fornecedores', 'GA', 22),
(74, 227, 49, 'Fornecedores - Outros Fornecedores', 'GA', 22),
(75, 228, 51, 'Adiantamentos de Fornecedores', 'GA', 22),
(76, 229, 52, 'Perdas por Imparidade acumuladas', 'GA', 22),
(77, 23, 0, 'Pessoal', 'GR', 0),
(78, 231, 0, 'Remunerações a pagar', 'GA', 23),
(79, 2311, 53, 'Aos orgãos sociais', 'GA', 231),
(80, 2312, 54, 'Ao Pessoal', 'GA', 231),
(81, 232, 0, 'Adiantamentos', 'GA', 23),
(82, 2321, 55, 'Aos orgãos sociais', 'GA', 232),
(83, 2322, 56, 'Ao Pessoal', 'GA', 232),
(84, 233, 61, 'Com os orgãos sociais (corrente)', 'GA', 23),
(85, 233, 62, 'Com os orgãos sociais (Não corrente)', 'GA', 23),
(86, 234, 61, 'Com os orgãos sociais (corrente)', 'GA', 23),
(87, 234, 62, 'Com os orgãos sociais (Não corrente)', 'GA', 23),
(88, 235, 61, 'Com os orgãos sociais (corrente)', 'GA', 23),
(89, 235, 62, 'Com os orgãos sociais (Não corrente)', 'GA', 23),
(90, 236, 61, 'Com os orgãos sociais (corrente)', 'GA', 23),
(91, 236, 62, 'Com os orgãos sociais (Não corrente)', 'GA', 23),
(92, 233, 63, 'Com o pessoal (corrente)', 'GA', 23),
(93, 233, 64, 'Com o pessoal (Não corrente)', 'GA', 23),
(94, 234, 63, 'Com o pessoal (corrente)', 'GA', 23),
(95, 234, 64, 'Com o pessoal (Não corrente)', 'GA', 23),
(96, 235, 63, 'Com o pessoal (corrente)', 'GA', 23),
(97, 235, 64, 'Com o pessoal (Não corrente)', 'GA', 23),
(98, 236, 63, 'Com o pessoal (corrente)', 'GA', 23),
(99, 236, 64, 'Com o pessoal (Não corrente)', 'GA', 23),
(100, 2371, 57, 'Dos orgãos sociais (Corrente)', 'GA', 237),
(101, 2371, 58, 'Dos orgãos sociais (Não Corrente)', 'GA', 237),
(102, 2372, 59, 'Do Pessoal(Corrente)', 'GA', 237),
(103, 2372, 60, 'Do Pessoal(Não Corrente)', 'GA', 237),
(104, 238, 0, 'Outras Operações', 'GA', 237),
(105, 2381, 61, 'Com orgãos sociais (Corrente)', 'GA', 237),
(106, 2381, 62, 'Com orgãos sociais (Não Corrente)', 'GA', 237),
(107, 2382, 63, 'Com o Pessoal (Corrente)', 'GA', 237),
(108, 2382, 64, 'Com o Pessoal (Não Corrente)', 'GA', 237),
(109, 239, 65, 'Perdas por imparidade acumuladas - Aos orgãos sociais', 'GA', 23),
(110, 239, 66, 'Perdas por imparidade acumuladas - Ao pessoal', 'GA', 23),
(111, 239, 67, 'Perdas por imparidade acumuladas - Aos orgãos sociais (Corrente)', 'GA', 23),
(112, 239, 68, 'Perdas por imparidade acumuladas - Aos orgãos sociais (Não Corrente)', 'GA', 23),
(113, 239, 69, 'Perdas por imparidade acumuladas - Ao pessoal (Corrente)', 'GA', 23),
(114, 239, 70, 'Perdas por imparidade acumuladas - Ao pessoal (Não Corrente)', 'GA', 23),
(115, 24, 0, 'Estado e outros entes publicos', 'GR', 0),
(116, 241, 71, 'Imposto sobre o rendimento', 'GA', 24),
(117, 242, 72, 'Retençao de Impostos sobre rendimentos', 'GA', 24),
(118, 243, 0, 'Imposto sobre o valor acrescentado', 'GA', 24),
(119, 2431, 73, 'IVA - Suportado', 'GA', 243),
(120, 2432, 74, 'IVA - Dedutível', 'GA', 243),
(121, 2433, 75, 'IVA - Liquidado', 'GA', 243),
(122, 2434, 76, 'IVA - Regularizações', 'GA', 243),
(123, 2435, 77, 'IVA - Apuramento', 'GA', 243),
(124, 2436, 78, 'IVA - A pagar', 'GA', 243),
(125, 2437, 79, 'IVA - A Recuperar', 'GA', 243),
(126, 2438, 80, 'IVA - Reembolsos Pedidos', 'GA', 243),
(127, 2439, 81, 'IVA - Liquidações oficiosas', 'GA', 243),
(128, 244, 82, 'Outros impostos', 'GA', 24),
(129, 245, 83, 'Contribuições para a segurança social', 'GA', 24),
(130, 246, 84, 'Tributos a autarquias locais', 'GA', 24),
(131, 247, 85, 'Outras tributações', 'GA', 24),
(132, 248, 85, 'Outras tributações', 'GA', 24),
(133, 25, 0, 'Financiamentos obtidos', 'GR', 0),
(134, 251, 0, 'Instituições de crédito e sociedades financeiras', 'GA', 25),
(135, 2511, 86, 'Empréstimos bancários (Corrente)', 'GA', 251),
(136, 2511, 87, 'Empréstimos bancários (Não Corrente)', 'GA', 251),
(137, 2512, 88, 'Descobertos bancários (Corrente)', 'GA', 251),
(138, 2512, 89, 'Descobertos bancários (Não Corrente)', 'GA', 251),
(139, 2513, 90, 'Locações financeiras (Corrente)', 'GA', 251),
(140, 2513, 91, 'Locações financeiras (Não Corrente)', 'GA', 251),
(141, 2514, 92, 'Outros financiamentos (Corrente)', 'GA', 251),
(142, 2514, 93, 'Outros financiamentos(Não Corrente)', 'GA', 251),
(143, 2515, 92, 'Outros financiamentos (Corrente)', 'GA', 251),
(144, 2515, 93, 'Outros financiamentos (Não Corrente)', 'GA', 251),
(145, 2516, 92, 'Outros financiamentos (Corrente)', 'GA', 251),
(146, 2516, 93, 'Outros financiamentos (Não Corrente)', 'GA', 251),
(147, 2517, 92, 'Outros financiamentos (Corrente)', 'GA', 251),
(148, 2517, 93, 'Outros financiamentos (Não Corrente)', 'GA', 251),
(149, 2518, 92, 'Outros financiamentos (Corrente)', 'GA', 251),
(150, 2518, 93, 'Outros financiamentos (Não Corrente)', 'GA', 251),
(151, 2518, 92, 'Outros financiamentos (Corrente)', 'GA', 251),
(152, 2518, 93, 'Outros financiamentos (Não Corrente)', 'GA', 251),
(153, 2519, 92, 'Outros financiamentos (Corrente)', 'GA', 251),
(154, 2519, 93, 'Outros financiamentos (Não Corrente)', 'GA', 251),
(155, 252, 0, 'Mercado de valores mobiliários', 'GA', 25),
(156, 2521, 94, 'Empréstimos por obrigações (Corrente)', 'GA', 252),
(157, 2521, 95, 'Empréstimos por obrigações (Nao Corrente)', 'GA', 252),
(158, 2522, 96, 'Outros financiamentos (Corrente)', 'GA', 252),
(159, 2529, 97, 'Outros financiamentos (Não Corrente)', 'GA', 252),
(160, 2523, 96, 'Outros financiamentos (Corrente)', 'GA', 252),
(161, 2529, 97, 'Outros financiamentos (Não Corrente)', 'GA', 252),
(162, 2524, 96, 'Outros financiamentos (Corrente)', 'GA', 252),
(163, 2529, 97, 'Outros financiamentos (Não Corrente)', 'GA', 252),
(164, 2525, 96, 'Outros financiamentos (Corrente)', 'GA', 252),
(165, 2529, 97, 'Outros financiamentos (Não Corrente)', 'GA', 252),
(166, 2526, 96, 'Outros financiamentos (Corrente)', 'GA', 252),
(167, 2529, 97, 'Outros financiamentos (Não Corrente)', 'GA', 252),
(168, 2527, 96, 'Outros financiamentos (Corrente)', 'GA', 252),
(169, 2529, 97, 'Outros financiamentos (Não Corrente)', 'GA', 252),
(170, 2528, 96, 'Outros financiamentos (Corrente)', 'GA', 252),
(171, 2529, 97, 'Outros financiamentos (Não Corrente)', 'GA', 252),
(172, 2529, 96, 'Outros financiamentos (Corrente)', 'GA', 252),
(173, 2529, 97, 'Outros financiamentos (Não Corrente)', 'GA', 252),
(174, 253, 0, 'Participantes de capital', 'GA', 25),
(175, 2531, 98, 'Empresa-mãe - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(176, 2531, 99, 'Empresa-mãe - Suprimentos e outros mútuos (Nao Corrente)', 'GA', 253),
(177, 2532, 100, 'Outros Participantes - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(178, 2533, 100, 'Outros Participantes - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(179, 2534, 100, 'Outros Participantes - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(180, 2535, 100, 'Outros Participantes - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(181, 2536, 100, 'Outros Participantes - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(182, 2537, 100, 'Outros Participantes - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(183, 2538, 100, 'Outros Participantes - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(184, 2539, 100, 'Outros Participantes - Suprimentos e outros mútuos (Corrente)', 'GA', 253),
(185, 2532, 101, 'Outros Participantes - Suprimentos e outros mútuos (Não Corrente)', 'GA', 253),
(186, 2533, 101, 'Outros Participantes - Suprimentos e outros mútuos (Não Corrente)', 'GA', 253),
(187, 2534, 101, 'Outros Participantes - Suprimentos e outros mútuos (Não Corrente)', 'GA', 253),
(188, 2535, 101, 'Outros Participantes - Suprimentos e outros mútuos (Não Corrente)', 'GA', 253),
(189, 2536, 101, 'Outros Participantes - Suprimentos e outros mútuos (Não Corrente)', 'GA', 253),
(190, 2537, 101, 'Outros Participantes - Suprimentos e outros mútuos (Não Corrente)', 'GA', 253),
(191, 2538, 101, 'Outros Participantes - Suprimentos e outros mútuos (Não Corrente)', 'GA', 253),
(192, 2539, 101, 'Outros Participantes - Suprimentos e outros mútuos (Não Corrente)', 'GA', 253),
(193, 254, 104, 'subsidiárias, associadas e empreendimentos conjuntos (Corrente)', 'GA', 25),
(194, 254, 105, 'subsidiárias, associadas e empreendimentos conjuntos (Não Corrente)', 'GA', 25),
(195, 255, 104, 'subsidiárias, associadas e empreendimentos conjuntos (Corrente)', 'GA', 25),
(196, 255, 105, 'subsidiárias, associadas e empreendimentos conjuntos (Não Corrente)', 'GA', 25),
(197, 256, 104, 'subsidiárias, associadas e empreendimentos conjuntos (Corrente)', 'GA', 25),
(198, 256, 105, 'subsidiárias, associadas e empreendimentos conjuntos (Não Corrente)', 'GA', 25),
(199, 257, 104, 'subsidiárias, associadas e empreendimentos conjuntos (Corrente)', 'GA', 25),
(200, 257, 105, 'subsidiárias, associadas e empreendimentos conjuntos (Não Corrente)', 'GA', 25),
(201, 258, 104, 'subsidiárias, associadas e empreendimentos conjuntos (Corrente)', 'GA', 25),
(202, 258, 105, 'subsidiárias, associadas e empreendimentos conjuntos (Não Corrente)', 'GA', 25),
(203, 25, 0, 'Accionistas/sócios', 'GR', 0),
(204, 261, 106, 'Accionistas c/ subscrição', 'GA', 26),
(205, 262, 107, 'Quotas não liberadas', 'GA', 26),
(206, 263, 108, 'Adiantamentos por conta de lucros', 'GA', 26),
(207, 264, 109, 'Resultados atribuídos', 'GA', 26),
(208, 265, 110, 'Lucros dispoíveis', 'GA', 26),
(209, 266, 111, 'Empréstimos concedidos - empresa-mâe (Corrente)', 'GA', 26),
(210, 266, 112, 'Empréstimos concedidos - empresa-mâe (Não Corrente)', 'GA', 26),
(211, 267, 113, 'Outras Operações (Corrente)', 'GA', 26),
(212, 267, 114, 'Outras Operações (Não Corrente)', 'GA', 26),
(213, 268, 113, 'Outras Operações (Corrente)', 'GA', 26),
(214, 268, 114, 'Outras Operações (Não corrente)', 'GA', 26),
(215, 269, 115, 'Perdas por imparidade acumuladas - Accionistas c/ subscrição', 'GA', 26),
(216, 269, 116, 'Perdas por imparidade acumuladas - Quotas não liberadas', 'GA', 26),
(217, 269, 117, 'Perdas por imparidade acumuladas - Adiantamentos por conta de lucros', 'GA', 26),
(218, 269, 118, 'Perdas por imparidade acumuladas - Resultados atribuídos', 'GA', 26),
(219, 269, 119, 'Perdas por imparidade acumuladas - Lucros dispoíveis', 'GA', 26),
(220, 269, 120, 'Perdas por imparidade acumuladas - Empréstimos concedidos - empresa-mâe (Corrente)', 'GA', 26),
(221, 269, 121, 'Perdas por imparidade acumuladas - Empréstimos concedidos - empresa-mâe (Não Corrente)', 'GA', 26),
(222, 269, 122, 'Perdas por imparidade acumuladas - Outras Operações (Corrente)', 'GA', 26),
(223, 269, 123, 'Perdas por imparidade acumuladas - Outras Operações (Não Corrente)', 'GA', 26),
(224, 27, 0, 'Outras contas a receber e a pagar', 'GR', 0),
(225, 271, 0, 'Fornecedores de investimentos', 'GA', 27),
(226, 2711, 124, 'Fornecedores de investimentos - contas gerais (Corrente)', 'GA', 271),
(227, 2711, 125, 'Fornecedores de investimentos - contas gerais (Não Corrente)', 'GA', 271),
(228, 2712, 126, 'Fornecedores de investimentos - Faturas em recepção e conferência (Corrente)', 'GA', 271),
(229, 2712, 127, 'Fornecedores de investimentos - Faturas em recepção e referência (Não Corrente)', 'GA', 271),
(230, 2713, 128, 'Fornecedores de investimentos - Adiantamentos a fonecedores de investimentos (Corrente)', 'GA', 271),
(231, 2713, 129, 'Fornecedores de investimentos - Adiantamentos a fonecedores de investimentos (Não Corrente)', 'GA', 271),
(232, 272, 0, 'Devedores e credores por acréscimos (periodização económica)', 'GA', 27),
(233, 2721, 130, 'Devedores por acréscimos de rendimentos', 'GA', 272),
(234, 2722, 131, 'Credores por acréscimos de gastos', 'GA', 272),
(235, 273, 132, 'Benefícios pós-emprego', 'GA', 27),
(236, 2741, 133, 'Activos por impostos deferidos', 'GA', 274),
(237, 2742, 134, 'Passivos por impostos deferidos', 'GA', 274),
(238, 275, 135, 'Credores por subscrições não liberadas (Corrente)', 'GA', 27),
(239, 275, 136, 'Credores por subscrições não liberadas (Não corrente)', 'GA', 27),
(240, 276, 137, 'Adiantamentos por conta de vendas', 'GA', 27),
(241, 277, 138, 'Outros devedores e credores (Corrente)', 'GA', 27),
(242, 277, 139, 'Outros devedores e credores (Não Corrente)', 'GA', 27),
(243, 278, 138, 'Outros devedores e credores (Corrente)', 'GA', 27),
(244, 278, 139, 'Outros devedores e credores (Não Corrente)', 'GA', 27),
(245, 279, 0, 'Perdas por imparidade acumuladas', 'GA', 27),
(246, 279, 140, 'Perdas por imparidade acumuladas - Fornecedores de investimentos - Adiantamentos a Fornecedores de i', 'GA', 27),
(247, 279, 141, 'Perdas por imparidade acumuladas - Fornecedores de investimentos - Adiantamentos a Fornecedores de i', 'GA', 27),
(248, 279, 142, 'Perdas por imparidade acumuladas - Devedores e credores por acréscimos (periodização económica)- Dev', 'GA', 27),
(249, 279, 143, 'Perdas por imparidade acumuladas - Impostos deferidos- Activos por impostos referidos', 'GA', 27),
(250, 279, 144, 'Perdas por imparidade acumuladas - Outros devedores e credores (Corrente)', 'GA', 27),
(251, 279, 145, 'Perdas por imparidade acumuladas - Outros devedores e credores (Não Corrente)', 'GA', 27),
(252, 28, 0, 'Diferimentos', 'GR', 0),
(253, 281, 146, 'Gastos a reconhecer', 'GA', 28),
(254, 282, 147, 'Rendimentos a reconhecer', 'GA', 28),
(255, 28, 0, 'Provisões', 'GR', 0),
(256, 291, 148, 'Impostos', 'GA', 29),
(257, 292, 149, 'Garantias a clientes', 'GA', 29),
(258, 293, 150, 'Processos judiciais em curso', 'GA', 29),
(259, 294, 151, 'Acidentes de trabalho e doenças profissionais', 'GA', 29),
(260, 295, 152, 'Matérias ambientais', 'GA', 29),
(261, 296, 153, 'Contratos onerosos', 'GA', 29),
(262, 297, 154, 'Reestruturação', 'GA', 29),
(263, 298, 155, 'Outras Provisões', 'GA', 29),
(264, 31, 0, 'Compras', 'GR', 0),
(265, 311, 156, 'Mercadorias', 'GA', 31),
(266, 312, 157, 'Matérias-primas, subsidiárias e de consumo', 'GA', 31),
(267, 313, 158, 'Ativos biológicos', 'GA', 31),
(268, 317, 159, 'Devoluções de compras - Mercadorias', 'GA', 31),
(269, 317, 160, 'Devoluções de compras - Matérias-primas, subsidiárias e de consumo', 'GA', 31),
(270, 317, 161, 'Devoluções de compras - Ativos biológicos', 'GA', 31),
(271, 318, 162, 'Descontos e abatimentos em compras - Mercadorias', 'GA', 31),
(272, 318, 163, 'Descontos e abatimentos em compras - Matérias-primas, subsidiárias e de consumo', 'GA', 31),
(273, 318, 164, 'Descontos e abatimentos em compras - Ativos biológicos', 'GA', 31),
(274, 32, 0, 'Mercadorias', 'GR', 0),
(275, 321, 165, 'Mercadorias', 'GA', 32),
(276, 322, 165, 'Mercadorias', 'GA', 32),
(277, 323, 165, 'Mercadorias', 'GA', 32),
(278, 324, 165, 'Mercadorias', 'GA', 32),
(279, 325, 166, 'Mercadorias em trânsito', 'GA', 32),
(280, 326, 167, 'Mercadorias em poder de terceiros', 'GA', 32),
(281, 327, 165, 'Mercadorias', 'GA', 32),
(282, 328, 165, 'Mercadorias', 'GA', 32),
(283, 329, 168, 'Perdas por imparidade acumuladas - Mercadorias', 'GA', 32),
(284, 329, 169, 'Perdas por imparidade acumuladas - Mercadorias em trânsito', 'GA', 32),
(285, 329, 169, 'Perdas por imparidade acumuladas - Mercadorias em poder de terceiros', 'GA', 32),
(286, 33, 0, 'Matérias-primas, subsidiárias e de consumo', 'GR', 0),
(287, 331, 171, 'Matérias-primas', 'GA', 33),
(288, 332, 172, 'Matérias subsidiárias', 'GA', 33),
(289, 333, 173, 'Embalagens', 'GA', 33),
(290, 334, 174, 'Materiais diversos', 'GA', 33),
(291, 335, 175, 'Materiais em trânsito', 'GA', 33),
(292, 336, 176, 'Materiais primas, subsidiárias e de consumo', 'GA', 33),
(293, 337, 176, 'Materiais primas, subsidiárias e de consumo', 'GA', 33),
(294, 338, 176, 'Materiais primas, subsidiárias e de consumo', 'GA', 33),
(295, 339, 177, 'Perdas por imparidade acumuladas - Matérias-primas', 'GA', 33),
(296, 339, 178, 'Perdas por imparidade acumuladas - Matérias subsidiárias', 'GA', 33),
(297, 339, 179, 'Perdas por imparidade acumuladas - Embalagens', 'GA', 33),
(298, 339, 180, 'Perdas por imparidade acumuladas - Materiais diversos', 'GA', 33),
(299, 339, 181, 'Perdas por imparidade acumuladas - Materiais em trânsito', 'GA', 33),
(300, 339, 182, 'Perdas por imparidade acumuladas - Outras Matérias-primas, subsidiárias e de consumo', 'GA', 33),
(301, 34, 0, 'Produtos acabados e intermédios', 'GR', 0),
(302, 341, 183, 'Produtos acabados e intermédios', 'GA', 34),
(303, 342, 183, 'Produtos acabados e intermédios', 'GA', 34),
(304, 343, 183, 'Produtos acabados e intermédios', 'GA', 34),
(305, 344, 183, 'Produtos acabados e intermédios', 'GA', 34),
(306, 345, 183, 'Produtos acabados e intermédios', 'GA', 34),
(307, 346, 184, 'Produtos em poder de terceiros', 'GA', 34),
(308, 347, 183, 'Produtos acabados e intermédios', 'GA', 34),
(309, 348, 183, 'Produtos acabados e intermédios', 'GA', 34),
(310, 349, 185, 'Produtos acabados e intermédios', 'GA', 34),
(311, 349, 186, 'Produtos em poder de terceiros', 'GA', 34),
(312, 35, 0, 'Subprodutos, desperdícios, resíduos e refugos', 'GR', 0),
(313, 351, 187, 'Subprodutos', 'GA', 35),
(314, 352, 188, 'Desperdícios, resíduos e refugos', 'GA', 35),
(315, 353, 189, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(316, 354, 189, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(317, 355, 189, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(318, 356, 189, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(319, 357, 189, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(320, 358, 189, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(321, 359, 190, 'Perdas por imparidade acumuladas - Subprodutos', 'GA', 35),
(322, 359, 191, 'Perdas por imparidade acumuladas - Desperdícios, resíduos e refugos', 'GA', 35),
(323, 359, 192, 'Perdas por imparidade acumuladas - Outros subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(324, 36, 194, 'Produtos e trabalhos em curso', 'GR', 0),
(325, 37, 199, 'Depreciações acumuladas - Consumíveis', 'GR', 0),
(326, 37, 200, 'Depreciações acumuladas - De produção', 'GR', 0),
(327, 37, 201, 'Perdas por imparidade acumuladas - Consumíveis', 'GR', 0),
(328, 37, 202, 'Perdas por imparidade acumuladas - De produção', 'GR', 0),
(329, 371, 0, 'Consumíveis', 'GA', 37),
(330, 3711, 195, 'Animais', 'GA', 371),
(331, 3712, 196, 'Plantas', 'GA', 371),
(332, 372, 0, 'De produção', 'GA', 37),
(333, 3721, 197, 'Animais', 'GA', 372),
(334, 3722, 198, 'Plantas', 'GA', 372),
(335, 38, 0, 'Reclassificação e regularização de inventário e activos biológicos', 'GA', 372),
(336, 382, 203, 'Mercadorias', 'GA', 38),
(337, 383, 204, 'Matérias-primas, subsidiárias e de consumo', 'GA', 38),
(338, 384, 205, 'Produtos acabados e intermédios', 'GA', 38),
(339, 385, 206, 'Subprodutos, desperdícios. resíduos e refugos', 'GA', 38),
(340, 386, 207, 'Produtos e trabalhos em curso', 'GA', 38),
(341, 387, 208, 'Activos biológicos', 'GA', 38),
(342, 39, 209, 'Adiantamentos por conta de compras - Mercadorias', 'GR', 0),
(343, 39, 210, 'Adiantamentos por conta de compras - Matérias-primas, subsidiárias e de consumo', 'GR', 0),
(344, 39, 211, 'Adiantamentos por conta de compras - produtos acabados e intermédios', 'GR', 0),
(345, 39, 212, 'Adiantamentos por conta de compras - Subprodutos, desperdícios, resíduos e refugos', 'GR', 0),
(346, 39, 213, 'Adiantamentos por conta de compras - Produtos e trabalhos em curso', 'GR', 0),
(347, 39, 214, 'Adiantamentos por conta de compras - Ativos biológicos Consumíveis', 'GR', 0),
(348, 39, 215, 'Adiantamentos por conta de compras - Ativos biológicos de produção', 'GR', 0),
(349, 41, 0, 'Investimentos financeiros', 'GR', 0),
(350, 411, 0, 'Investimentos em subsidiárias', 'GA', 41),
(351, 4111, 216, 'Participações da capital - método da equivalência patrimonial', 'GA', 411),
(352, 4111, 217, 'Participações da capital - método da equivalência patrimonial', 'GA', 411),
(353, 4112, 218, 'Participações da capital - Outros métodos', 'GA', 411),
(354, 4113, 219, 'Participações da capital - Empréstimos concedidos', 'GA', 411),
(355, 4114, 220, 'Investimentos financeiros - Investimentos em subsidiárias - Outros investimentos financeiros', 'GA', 411),
(356, 4115, 220, 'Investimentos financeiros - Investimentos em subsidiárias - Outros investimentos financeiros', 'GA', 411),
(357, 4116, 220, 'Investimentos financeiros - Investimentos em subsidiárias - Outros investimentos financeiros', 'GA', 411),
(358, 4117, 220, 'Investimentos financeiros - Investimentos em subsidiárias - Outros investimentos financeiros', 'GA', 411),
(359, 4118, 220, 'Investimentos financeiros - Investimentos em subsidiárias - Outros investimentos financeiros', 'GA', 411),
(360, 4119, 220, 'Investimentos financeiros - Investimentos em subsidiárias - Outros investimentos financeiros', 'GA', 411),
(361, 412, 0, 'Investimentos em associadas', 'GA', 41),
(362, 4121, 221, 'Participações de capital - método de equivalência patrimonial', 'GA', 412),
(363, 4121, 222, 'Participações de capital - método de equivalência patrimonial', 'GA', 412),
(364, 4122, 223, 'Participações de capital - outros métodos', 'GA', 412),
(365, 4123, 224, 'Emprestimos concedidos', 'GA', 412),
(366, 4124, 225, 'Outros investimentos financeiros', 'GA', 412),
(367, 4125, 225, 'Outros investimentos financeiros', 'GA', 412),
(368, 4126, 225, 'Outros investimentos financeiros', 'GA', 412),
(369, 4127, 225, 'Outros investimentos financeiros', 'GA', 412),
(370, 4128, 225, 'Outros investimentos financeiros', 'GA', 412),
(371, 4129, 225, 'Outros investimentos financeiros', 'GA', 412),
(372, 4129, 225, 'Investimentos em entidades conjuntamente controladas', 'GA', 412),
(373, 4131, 226, 'Participações de capital - método da equivalência patrimonial', 'GA', 413),
(374, 4132, 227, 'Participações de capital - Outros métodos', 'GA', 413),
(375, 4133, 229, 'Emprestimos concedidos', 'GA', 413),
(376, 4134, 230, 'Outros investimentos financeiros', 'GA', 413),
(377, 4135, 230, 'Outros investimentos financeiros', 'GA', 413),
(378, 4136, 230, 'Outros investimentos financeiros', 'GA', 413),
(379, 4137, 230, 'Outros investimentos financeiros', 'GA', 413),
(380, 4138, 230, 'Outros investimentos financeiros', 'GA', 413),
(381, 4139, 230, 'Outros investimentos financeiros', 'GA', 413),
(382, 414, 0, 'Investimentos noutras empresas', 'GA', 413),
(383, 4141, 231, 'Participações de capital', 'GA', 414),
(384, 4142, 232, 'Empréstimos concedidos', 'GA', 414),
(385, 4143, 233, 'Outros investimentos financeiros', 'GA', 414),
(386, 4144, 233, 'Outros investimentos financeiros', 'GA', 414),
(387, 4145, 233, 'Outros investimentos financeiros', 'GA', 414),
(388, 4146, 233, 'Outros investimentos financeiros', 'GA', 414),
(389, 4147, 233, 'Outros investimentos financeiros', 'GA', 414),
(390, 4148, 233, 'Outros investimentos financeiros', 'GA', 414),
(391, 4149, 233, 'Outros investimentos financeiros', 'GA', 414),
(392, 415, 0, 'Outros investimentos financeiros', 'GA', 41),
(393, 4151, 234, 'Detidos até à maturidade', 'GA', 415),
(394, 4152, 235, 'Outros investimentos financeiros', 'GA', 415),
(395, 4153, 235, 'Outros investimentos financeiros', 'GA', 415),
(396, 4154, 235, 'Outros investimentos financeiros', 'GA', 415),
(397, 4155, 235, 'Outros investimentos financeiros', 'GA', 415),
(398, 4156, 235, 'Outros investimentos financeiros', 'GA', 415),
(399, 4157, 235, 'Outros investimentos financeiros', 'GA', 415),
(400, 4158, 235, 'Outros investimentos financeiros', 'GA', 415),
(401, 4159, 235, 'Outros investimentos financeiros', 'GA', 415),
(402, 416, 235, 'Outros investimentos financeiros', 'GA', 41),
(403, 417, 235, 'Outros investimentos financeiros', 'GA', 41),
(404, 418, 235, 'Outros investimentos financeiros', 'GA', 41),
(405, 41, 236, 'investimentos financeiros - investimentos em subsidiárias', 'GR', 0),
(406, 41, 237, 'investimentos financeiros -  Investimentos em associadas', 'GR', 0),
(407, 41, 238, 'investimentos financeiros - Investimentos em entidades conjuntamente controladas', 'GR', 0),
(408, 419, 239, 'Perdas por imparidade acumuladas - Investimentos em subsidiárias - Participação de capital', 'GA', 41),
(409, 419, 240, 'Perdas por imparidade acumuladas - Investimentos em subsidiárias - Goodwill ', 'GA', 41),
(410, 419, 241, 'Perdas por imparidade acumuladas - Investimentos em subsidiárias - Outros métodos ', 'GA', 41),
(411, 419, 242, 'Perdas por imparidade acumuladas - Investimentos em subsidiárias - Empréstimos concedidos ', 'GA', 41),
(412, 419, 243, 'Perdas por imparidade acumuladas - Investimentos em subsidiárias - Outros investimentos financeiros ', 'GA', 41),
(413, 419, 244, 'Perdas por imparidade acumuladas - Investimentos em associadas - Outros investimentos financeiros ', 'GA', 41),
(414, 419, 245, 'Perdas por imparidade acumuladas - Investimentos em associadas - Participações de capital ', 'GA', 41),
(415, 419, 246, 'Perdas por imparidade acumuladas - Investimentos em associadas - Godwill ', 'GA', 41),
(416, 419, 247, 'Perdas por imparidade acumuladas - Investimentos em associadas - Empréstimos concedidos ', 'GA', 41),
(417, 419, 248, 'Perdas por imparidade acumuladas - Investimentos em associadas - Outros investimentos financeiros ', 'GA', 41),
(418, 419, 249, 'Perdas por imparidade acumuladas - Investimentos em entidades conjuntamente controladas - Participaç', 'GA', 41),
(419, 419, 250, 'Perdas por imparidade acumuladas - Investimentos em entidades conjuntamente controladas - Goodwill ', 'GA', 41),
(420, 419, 251, 'Perdas por imparidade acumuladas - Investimentos em entidades conjuntamente controladas - Outros mét', 'GA', 41),
(421, 419, 252, 'Perdas por imparidade acumuladas - Investimentos em entidades conjuntamente controladas - Empréstimo', 'GA', 41),
(422, 419, 253, 'Perdas por imparidade acumuladas - Investimentos em entidades conjuntamente controladas - Outros inv', 'GA', 41),
(423, 419, 254, 'Perdas por imparidade acumuladas - Investimentos noutras empresas - Participações de capital ', 'GA', 41),
(424, 419, 255, 'Perdas por imparidade acumuladas - Investimentos noutras empresas - Empréstimos concedidos ', 'GA', 41),
(425, 419, 256, 'Perdas por imparidade acumuladas - Investimentos noutras empresas - Outros investimentos financeiros', 'GA', 41),
(426, 419, 257, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Detidos até à maturidade ', 'GA', 41),
(427, 419, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 41),
(428, 4152, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 415),
(429, 4153, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 415),
(430, 4154, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 415),
(431, 4155, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 415),
(432, 4156, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 415),
(433, 4157, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 415),
(434, 4158, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 415),
(435, 4159, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 415),
(436, 416, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 41),
(437, 417, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 41),
(438, 418, 258, 'Perdas por imparidade acumuladas - Outros investimentos financeiros - Outros ', 'GA', 41),
(439, 42, 0, 'Propriedades de investimento ', 'GR', 0),
(440, 421, 259, 'Terrenos e recursos naturais ', 'GA', 42),
(441, 422, 260, 'Edifiçios e outras construções ', 'GA', 42),
(442, 423, 261, 'Outras propriedades de investimento ', 'GA', 42),
(443, 424, 261, 'Outras propriedades de investimento ', 'GA', 42),
(444, 425, 261, 'Outras propriedades de investimento ', 'GA', 42),
(445, 426, 261, 'Outras propriedades de investimento ', 'GA', 42),
(446, 427, 261, 'Outras propriedades de investimento ', 'GA', 42),
(447, 428, 262, 'Depreciações acumuladas - Terrenos e recursos naturais', 'GA', 42),
(448, 428, 263, 'Depreciações acumuladas - Edifiçios e outras construções', 'GA', 42),
(449, 428, 264, 'Depreciações acumuladas - Outras propriedades de investimento', 'GA', 42),
(450, 429, 265, 'Depreciações acumuladas - Terrenos e recursos naturais', 'GA', 42),
(451, 429, 266, 'Perdas por imparidade acumuladas - Edifíçios e outras construções', 'GA', 42),
(452, 429, 267, 'Perdas por imparidade acumuladas - Outras propriedades de investimento', 'GA', 42),
(453, 43, 0, 'Ativos fixos e tangíveis ', 'GR', 0),
(454, 431, 268, 'Terrenos e recursos naturais', 'GA', 43),
(455, 432, 269, 'Edifíçios e outras construções', 'GA', 43),
(456, 433, 270, 'Equipamento básico', 'GA', 43),
(457, 434, 271, 'Equipamento de transporte', 'GA', 43),
(458, 435, 272, 'Equipamento administrativo', 'GA', 43),
(459, 436, 273, 'Equipamentos biológicos', 'GA', 43),
(460, 437, 274, 'Outros ativos fixos e tangíveis', 'GA', 43),
(461, 438, 275, 'Depreciações acumuladas -Terrenos e recursos naturais ', 'GA', 43),
(462, 438, 276, 'Depreciações acumuladas - Edifíçios e outras construções', 'GA', 43),
(463, 438, 277, 'Depreciações acumuladas - Equipamento básico', 'GA', 43),
(464, 438, 278, 'Depreciações acumuladas - Equipamento de transporte', 'GA', 43),
(465, 438, 279, 'Depreciações acumuladas - Equipamento administrativo', 'GA', 43),
(466, 438, 280, 'Depreciações acumuladas - Equipamentos biológicos', 'GA', 43),
(467, 438, 281, 'Depreciações acumuladas - Outros ativos fixos tangíveis', 'GA', 43),
(468, 439, 282, 'Perdas por imparidade acumuladas - terrenos e recursos naturais', 'GA', 43),
(469, 439, 283, 'Perdas por imparidade acumuladas - Edifíçios e outras construções', 'GA', 43),
(470, 439, 284, 'Perdas por imparidade acumuladas - Equipamento básico', 'GA', 43),
(471, 439, 285, 'Perdas por imparidade acumuladas - Equipamento de transporte', 'GA', 43),
(472, 439, 286, 'Perdas por imparidade acumuladas - Equipamento administrativo', 'GA', 43),
(473, 439, 287, 'Perdas por imparidade acumuladas - Equipamentos biológicos', 'GA', 43),
(474, 439, 288, 'Perdas por imparidade acumuladas - Outros ativos fixos tangíveis', 'GA', 43),
(475, 44, 0, 'Ativos tangíveis', 'GR', 0),
(476, 441, 289, 'Goodwill', 'GA', 44),
(477, 442, 290, 'Projetos de desenvolvimento', 'GA', 44),
(478, 443, 291, 'Programas de computador', 'GA', 44),
(479, 444, 292, 'Propriedade industrial', 'GA', 44),
(480, 445, 293, 'Outros ativos intangíveis', 'GA', 44),
(481, 446, 293, 'Outros ativos intangíveis', 'GA', 44),
(482, 447, 293, 'Outros ativos intangíveis', 'GA', 44),
(483, 448, 294, 'Amortizações acumuladas - Goodwill', 'GA', 44),
(484, 448, 295, 'Amortizações acumuladas - Projetos de desenvolvimento', 'GA', 44),
(485, 448, 296, 'Amortizações acumuladas - Programas de computador', 'GA', 44),
(486, 448, 297, 'Amortizações acumuladas - Propriedade industrial', 'GA', 44),
(487, 448, 298, 'Amortizações acumuladas - Outros ativos intangíveis', 'GA', 44),
(488, 449, 299, 'Perdas por imparidade acumuladas - Goodwill', 'GA', 44),
(489, 449, 300, 'Perdas por imparidade acumuladas - Projetos de desenvolvimento', 'GA', 44),
(490, 449, 301, 'Perdas por imparidade acumuladas - Programas de computador', 'GA', 44),
(491, 449, 302, 'Perdas por imparidade acumuladas - Propriedade industrial', 'GA', 44),
(492, 449, 303, 'Perdas por imparidade acumuladas - Outros ativos intangíveis', 'GA', 44),
(493, 45, 0, 'Investimentos em curso', 'GR', 0),
(494, 451, 304, 'Investimentos financeiros em curso', 'GA', 45),
(495, 452, 305, 'Propriedades de investimento em curso', 'GA', 45),
(496, 453, 306, 'Ativos fixos tangíveis em curso', 'GA', 45),
(497, 454, 307, 'Ativos tangíveis em curso', 'GA', 45),
(498, 455, 308, 'Adiantamentos por conta de investimentos - Investimentos financeiros em curso', 'GA', 45),
(499, 455, 309, 'Adiantamentos por conta de investimentos - Propriedades de investimento em curso', 'GA', 45),
(500, 455, 310, 'Adiantamentos por conta de investimentos - Ativos fixos tangíveis em curso', 'GA', 45),
(501, 455, 311, 'Adiantamentos por conta de investimentos - Ativos intangíveis em curso', 'GA', 45),
(502, 459, 312, 'Perdas por imparidade acumuladas - Investimentos financeiros em curso', 'GA', 45),
(503, 459, 313, 'Perdas por imparidade acumuladas - Propriedades de investimento em curso', 'GA', 45),
(504, 459, 314, 'Perdas por imparidade acumuladas - Ativos fixos tangíveis em curso', 'GA', 45),
(505, 459, 315, 'Perdas por imparidade acumuladas - Ativos intangíveis em curso', 'GA', 45),
(506, 459, 316, 'Perdas por imparidade acumuladas - Adiantamentos por conta de investimentos - Investimentos financei', 'GA', 45),
(507, 459, 317, 'Perdas por imparidade acumuladas - Adiantamentos por conta de investimentos - Propriedades de invest', 'GA', 45),
(508, 459, 318, 'Perdas por imparidade acumuladas - Adiantamentos por conta de investimentos - Ativos fixos tangíveis', 'GA', 45),
(509, 459, 319, 'Perdas por imparidade acumuladas - Adiantamentos por conta de investimentos - Ativos intangíveis em ', 'GA', 45),
(510, 46, 320, 'Ativos não correntes detidos para venda - Investimentos financeiros', 'GR', 0),
(511, 46, 321, 'Ativos não correntes detidos para venda - Propriedades de Investimentos', 'GR', 0),
(512, 46, 322, 'Ativos não correntes detidos para venda - Ativos fixos tangíveis', 'GR', 0),
(513, 46, 323, 'Ativos não correntes detidos para venda - Ativos tangíveis', 'GR', 0),
(514, 46, 324, 'Ativos não correntes detidos para venda - Outros', 'GR', 0),
(515, 46, 325, 'Ativos não correntes detidos para venda - Passivos nao correntes detidos para venda', 'GR', 0),
(516, 469, 326, 'Perdas por imparidade acumuladas - Investimentos financeiros', 'GA', 46),
(517, 469, 327, 'Perdas por imparidade acumuladas - Propriedades de investimento', 'GA', 46),
(518, 469, 328, 'Perdas por imparidade acumuladas - Ativos fixos tangíveis', 'GA', 46),
(519, 469, 329, 'Perdas por imparidade acumuladas - Ativos tangíveis', 'GA', 46),
(520, 469, 330, 'Perdas por imparidade acumuladas - Outros', 'GA', 46),
(521, 51, 331, 'Capital subscrito', 'GR', 0),
(522, 52, 0, 'Ações (quotas) próprias', 'GR', 0),
(523, 521, 332, 'Valor nominal', 'GA', 52),
(524, 522, 333, 'Descontos e prémios', 'GA', 52),
(525, 53, 334, 'Outros instrumentos de capital próprio', 'GR', 0),
(526, 54, 335, 'Prémios de emissão', 'GR', 0),
(527, 55, 0, 'Reservas', 'GR', 0),
(528, 551, 336, 'Reservas legais', 'GA', 55),
(529, 552, 337, 'Outras reservas', 'GA', 55),
(530, 553, 337, 'Outras reservas', 'GA', 55),
(531, 554, 337, 'Outras reservas', 'GA', 55),
(532, 555, 337, 'Outras reservas', 'GA', 55),
(533, 556, 337, 'Outras reservas', 'GA', 55),
(534, 557, 337, 'Outras reservas', 'GA', 55),
(535, 558, 337, 'Outras reservas', 'GA', 55),
(536, 559, 337, 'Outras reservas', 'GA', 55),
(537, 56, 338, 'Resultados transitados', 'GR', 0),
(538, 57, 0, 'Ajustamentos em ativos financeiros', 'GR', 0),
(539, 571, 0, 'Relacionados com o método de equivalência patrimonial', 'GA', 57),
(540, 5711, 339, 'Ajustamentos de transição', 'GA', 571),
(541, 5712, 340, 'Lucros não atribuídos', 'GA', 571),
(542, 5713, 341, 'Decorrentes de outras variações nos capitais próprios das participadas', 'GA', 571),
(543, 5714, 341, 'Decorrentes de outras variações nos capitais próprios das participadas', 'GA', 571),
(544, 5715, 341, 'Decorrentes de outras variações nos capitais próprios das participadas', 'GA', 571),
(545, 5716, 341, 'Decorrentes de outras variações nos capitais próprios das participadas', 'GA', 571),
(546, 5717, 341, 'Decorrentes de outras variações nos capitais próprios das participadas', 'GA', 571),
(547, 5718, 341, 'Decorrentes de outras variações nos capitais próprios das participadas', 'GA', 571),
(548, 5719, 341, 'Decorrentes de outras variações nos capitais próprios das participadas', 'GA', 571),
(549, 572, 342, 'Outros', 'GA', 57),
(550, 573, 342, 'Outros', 'GA', 57),
(551, 574, 342, 'Outros', 'GA', 57),
(552, 575, 342, 'Outros', 'GA', 57),
(553, 576, 342, 'Outros', 'GA', 57),
(554, 577, 342, 'Outros', 'GA', 57),
(555, 578, 342, 'Outros', 'GA', 57),
(556, 579, 342, 'Outros', 'GA', 57),
(557, 58, 0, 'Excedente de revalorização de ativos fixos tangíveis e intangíveis', 'GR', 0),
(558, 581, 342, 'Reavaliações decorrentes de diplomas legais', 'GA', 58),
(559, 5811, 343, 'Antes de imposto sobre o rendimento', 'GA', 581),
(560, 582, 345, 'Antes de imposto sobre o rendimento', 'GA', 58),
(561, 583, 345, 'Antes de imposto sobre o rendimento', 'GA', 58),
(562, 584, 345, 'Antes de imposto sobre o rendimento', 'GA', 58),
(563, 585, 345, 'Antes de imposto sobre o rendimento', 'GA', 58),
(564, 586, 345, 'Antes de imposto sobre o rendimento', 'GA', 58),
(565, 587, 345, 'Antes de imposto sobre o rendimento', 'GA', 58),
(566, 588, 345, 'Antes de imposto sobre o rendimento', 'GA', 58),
(567, 5812, 344, 'Impostos deferidos', 'GA', 581),
(568, 582, 346, 'Impostos deferidos', 'GA', 58),
(569, 583, 346, 'Impostos deferidos', 'GA', 58),
(570, 584, 346, 'Impostos deferidos', 'GA', 58),
(571, 585, 346, 'Impostos deferidos', 'GA', 58),
(572, 586, 346, 'Impostos deferidos', 'GA', 58),
(573, 587, 346, 'Impostos deferidos', 'GA', 58),
(574, 588, 346, 'Impostos deferidos', 'GA', 58),
(575, 589, 34, 'Outros excedentes', 'GA', 58),
(576, 5891, 345, 'Antes de imposto sobre o rendimento', 'GA', 589),
(577, 5892, 346, 'Impostos deferidos', 'GA', 589),
(578, 59, 0, 'Outras variações no capital próprio', 'GR', 0),
(579, 591, 347, 'Diferenças de conversão de demonstrações financeiras', 'GA', 59),
(580, 592, 348, 'Ajustamentos por impostos deferidos', 'GA', 59),
(581, 593, 0, 'Subsidios', 'GA', 59),
(582, 5931, 349, 'Subsidios atribuídos', 'GA', 593),
(583, 5932, 350, 'Ajustamentos em subsidios', 'GA', 593),
(584, 594, 351, 'Subsidios', 'GA', 59),
(585, 595, 352, 'Outras', 'GA', 59),
(586, 596, 352, 'Outras', 'GA', 59),
(587, 597, 352, 'Outras', 'GA', 59),
(588, 598, 352, 'Outras', 'GA', 59),
(589, 599, 352, 'Outras', 'GA', 59),
(590, 61, 0, 'Custos das mercadorias vendidas e das matérias consumidas', 'GR', 0),
(591, 611, 353, 'Mercadorias', 'GA', 61),
(592, 612, 354, 'Materias primas, subsidiárias e de consumo', 'GA', 61),
(593, 613, 355, 'Ativos biológicos (Compras)', 'GA', 61),
(594, 62, 0, 'Fornecimentos e serviços externos', 'GR', 0),
(595, 621, 356, 'Subcontratos', 'GA', 62),
(596, 622, 0, 'Serviços especializados', 'GA', 62),
(597, 6221, 357, 'Trabalhos especializados', 'GA', 622),
(598, 6222, 358, 'Publicidade e propaganda', 'GA', 622),
(599, 6223, 359, 'Vigilância e segurança', 'GA', 622),
(600, 6224, 360, 'Honorários', 'GA', 622),
(601, 6225, 361, 'Comissoões', 'GA', 622),
(602, 6226, 362, 'Conservação e reparação', 'GA', 622),
(603, 6227, 363, 'Outros', 'GA', 622),
(604, 6228, 363, 'Outros', 'GA', 622),
(605, 623, 0, 'Materiais', 'GA', 62),
(606, 6231, 364, 'Ferramentas e utensílios de de desgaste rápido', 'GA', 623),
(607, 6232, 365, 'Livros e documentação técnica', 'GA', 623),
(608, 6233, 366, 'Material de escritório', 'GA', 623),
(609, 6234, 367, 'Artigos para oferta', 'GA', 623),
(610, 6235, 368, 'Outros', 'GA', 623),
(611, 6236, 368, 'Outros', 'GA', 623),
(612, 6237, 368, 'Outros', 'GA', 623),
(613, 6238, 368, 'Outros', 'GA', 623),
(614, 6238, 368, 'Outros', 'GA', 623),
(615, 624, 0, 'Energia e fluidos', 'GA', 62),
(616, 6241, 369, 'Eletrecidade', 'GA', 624),
(617, 6242, 370, 'Combustíveis', 'GA', 624),
(618, 6243, 371, 'Água', 'GA', 624),
(619, 6244, 372, 'Outros', 'GA', 624),
(620, 6245, 372, 'Outros', 'GA', 624),
(621, 6246, 372, 'Outros', 'GA', 624),
(622, 6247, 372, 'Outros', 'GA', 624),
(623, 6248, 372, 'Outros', 'GA', 624),
(624, 625, 0, 'Deslocações, estadas e transportes', 'GA', 62),
(625, 6251, 373, 'Deslocações e estadas', 'GA', 625),
(626, 6251, 374, 'Transportes de pessoal', 'GA', 625),
(627, 6251, 375, 'Transportes de mercadorias', 'GA', 625),
(628, 6254, 376, 'Outros', 'GA', 625),
(629, 6255, 376, 'Outros', 'GA', 625),
(630, 6256, 376, 'Outros', 'GA', 625),
(631, 6257, 376, 'Outros', 'GA', 625),
(632, 6258, 376, 'Outros', 'GA', 625),
(633, 626, 0, 'Serviços diversos', 'GA', 62),
(634, 6261, 377, 'Rendas e alugueres', 'GA', 626),
(635, 6262, 378, 'Comunicação', 'GA', 626),
(636, 6263, 379, 'Seguros', 'GA', 626),
(637, 6264, 380, 'Royalties', 'GA', 626),
(638, 6265, 381, 'Contencioso e notariado', 'GA', 626),
(639, 6266, 382, 'Despesas de representação', 'GA', 626),
(640, 6267, 383, 'Limpeza, higiéne e conforto', 'GA', 626),
(641, 6268, 384, 'Outros serviços', 'GA', 626),
(642, 63, 0, 'Gastos com o pessoal', 'GR', 0),
(643, 631, 385, 'Remunerações dos orgãos sociais', 'GA', 63),
(644, 632, 386, 'Remunerações do pessoal', 'GA', 63),
(645, 633, 0, 'Benefícios pós-emprego', 'GA', 63),
(646, 6331, 387, 'Prémios para pensões', 'GA', 633),
(647, 6332, 388, 'Outros Benefícios', 'GA', 633),
(648, 634, 389, 'Indemnizações', 'GA', 63),
(649, 635, 390, 'Encargos sobre remunerações', 'GA', 63),
(650, 636, 391, 'Seguros de acidentes no trabalho e doenças profissionais', 'GA', 63),
(651, 637, 392, 'Gastos de ação social', 'GA', 63),
(652, 638, 393, 'Outros gastos com, o pessoal', 'GA', 63),
(653, 64, 0, 'Gastos de depreciação e de amortização', 'GR', 0),
(654, 641, 394, 'Propriedades de investimento - Terrenos e recursos naturais', 'GA', 64),
(655, 641, 395, 'Propriedades de investimento - Edifíçios e outras construções', 'GA', 64),
(656, 641, 396, 'Propriedades de investimento - Outras propriedades de investiemnto', 'GA', 64),
(657, 642, 397, 'Ativos fixos tangíveis - terrenos e recursos naturais', 'GA', 64),
(658, 642, 398, 'Ativos fixos tangíveis - Edifiçios e outras construções', 'GA', 64),
(659, 642, 399, 'Ativos fixos tangíveis - Equipamento básico', 'GA', 64),
(660, 642, 400, 'Ativos fixos tangíveis - Equipamento de transporte', 'GA', 64),
(661, 642, 401, 'Ativos fixos tangíveis - Equipamento administrativo', 'GA', 64),
(662, 642, 402, 'Ativos fixos tangíveis - Equipamentos biológicos', 'GA', 64),
(663, 642, 403, 'Ativos fixos tangíveis - Outros ativos fixos tangíveis', 'GA', 64),
(664, 643, 404, 'Activos intangíveis - Goodwill', 'GA', 64),
(665, 643, 405, 'Activos intangíveis - Projetos de desenvolvimento', 'GA', 64),
(666, 643, 406, 'Activos intangíveis - Programas de computador', 'GA', 64),
(667, 643, 407, 'Activos intangíveis - Propriedade industrial', 'GA', 64),
(668, 643, 408, 'Activos intangíveis - Outros ativos intangíveis', 'GA', 64),
(669, 64, 409, 'Gastos de desperdício e de amortização - Ativos biológicos - Consumíveis', 'GR', 0),
(670, 64, 410, 'Gastos de desperdício e de amortização - Ativos biológicos - DE produção', 'GR', 0),
(671, 64, 411, 'Gastos de desperdício e de amortização - Investimentos financeiros - Goodwill', 'GR', 0),
(672, 641, 0, 'Propriedades de investimento', 'GA', 64),
(673, 642, 0, 'Ativos fixos tangíveis', 'GA', 64),
(674, 643, 0, 'Ativos intangíveis', 'GA', 64),
(675, 65, 412, 'Perdas por imparidade', 'GR', 0),
(676, 651, 0, 'Em dividas a receber', 'GA', 65),
(677, 6511, 413, 'Clientes', 'GA', 651),
(678, 6512, 414, 'Outros devedores', 'GA', 651),
(679, 652, 415, 'Em inventários - Mercadorias', 'GA', 65),
(680, 652, 416, 'Em inventários - Matérias-primas, subsidiárias e de consumo', 'GA', 65),
(681, 652, 417, 'Em inventários - Produtos acabados e intermédios', 'GA', 65),
(682, 652, 418, 'Em inventários - Subprodutos, desperdícios, resíduos e refugos', 'GA', 65),
(683, 652, 419, 'Em inventários - Produtos e trabalhos em curso', 'GA', 65),
(684, 652, 420, 'Em inventários - Ativos biológicos Consumíveis', 'GA', 65),
(685, 652, 421, 'Em inventários - Ativos biológicos de produção', 'GA', 65),
(686, 653, 422, 'Em investimentos financeiros - Participações de capital', 'GA', 65),
(687, 653, 423, 'Em investimentos financeiros - Empréstimos concedidos', 'GA', 65),
(688, 653, 424, 'Em investimentos financeiros - Outros investimentos financeiros', 'GA', 65),
(689, 653, 425, 'Em investimentos financeiros - Goodwill', 'GA', 65),
(690, 654, 426, 'Em propriedades de investimento - Terrenos e recursos naturais', 'GA', 65),
(691, 654, 427, 'Em propriedades de investimento - Edifíçios e outras construções', 'GA', 65),
(692, 654, 428, 'Em propriedades de investimento - Outras propriedades de investimento', 'GA', 65),
(693, 655, 429, 'Em ativos fixos tangíveis - Terrenos e recursos naturais', 'GA', 65),
(694, 655, 430, 'Em ativos fixos tangíveis - Edifíçios e outras construções', 'GA', 65),
(695, 655, 431, 'Em ativos fixos tangíveis - Equipamento básico', 'GA', 65),
(696, 655, 432, 'Em ativos fixos tangíveis - Equipamento de transporte', 'GA', 65),
(697, 655, 433, 'Em ativos fixos tangíveis - Equipamento administrativo', 'GA', 65),
(698, 655, 434, 'Em ativos fixos tangíveis - Equipamentos biológicos', 'GA', 65),
(699, 655, 435, 'Em ativos fixos tangíveis - Outros ativos fixos tangíveis', 'GA', 65),
(700, 656, 436, 'Em ativos intangíveis - Goodwill', 'GA', 65),
(701, 656, 437, 'Em ativos intangíveis - Projetos de desenvolvimento', 'GA', 65),
(702, 656, 438, 'Em ativos intangíveis - Programas de computador', 'GA', 65),
(703, 656, 439, 'Em ativos intangíveis - Propriedade industrial', 'GA', 65),
(704, 656, 440, 'Em ativos intangíveis - Outros ativos fixos tangíveis', 'GA', 65),
(705, 657, 441, 'Em investimentos em curso - Investimentos financeiros em curso', 'GA', 65),
(706, 657, 442, 'Em investimentos em curso - Propriedades de investimento em curso', 'GA', 65),
(707, 657, 443, 'Em investimentos em curso - Ativos fixos tangíveis em curso', 'GA', 65),
(708, 657, 444, 'Em investimentos em curso - Ativos intangíveis em curso', 'GA', 65),
(709, 657, 445, 'Em investimentos em curso - Adiantamentos por conta de investimentos - Investimentos financeiros em ', 'GA', 65),
(710, 657, 446, 'Em investimentos em curso - Adiantamentos por conta de investimentos - Propriedades de investimento ', 'GA', 65),
(711, 657, 447, 'Em investimentos em curso - Adiantamentos por conta de investimentos - Ativos fixos tangíveis em cur', 'GA', 65),
(712, 657, 448, 'Em investimentos em curso - Ativos intangíveis em curso', 'GA', 65),
(713, 658, 449, 'Em ativos não correntes detidos para venda - Investimentos financeiros', 'GA', 65),
(714, 658, 450, 'Em ativos não correntes detidos para venda - Propriedades de investimento', 'GA', 65),
(715, 658, 451, 'Em ativos não correntes detidos para venda - Ativos fixos tangíveis', 'GA', 65),
(716, 658, 452, 'Em ativos não correntes detidos para venda - Ativos intangíveis', 'GA', 65),
(717, 658, 453, 'Em ativos não correntes detidos para venda - Outros', 'GA', 65),
(718, 66, 0, 'Perdas por reduções de justo valor', 'GR', 0),
(719, 661, 454, 'Em instrumentos financeiros', 'GA', 66);
INSERT INTO `faturacao_snc_base` (`ID_Snc_Base`, `Snc_Code`, `Taxonomy_Code`, `Descricao`, `Grouping_Category`, `Grouping_Code`) VALUES
(720, 662, 455, 'Em investimentos financeiros - Participações de capital', 'GA', 66),
(721, 662, 456, 'Em investimentos financeiros - Outros investimentos financeiros', 'GA', 66),
(722, 663, 457, 'Em propriedade de investimento - Terrenos e recursos naturais', 'GA', 66),
(723, 663, 458, 'Em propriedade de investimento - Edifíçios e outras construções', 'GA', 66),
(724, 663, 459, 'Em propriedade de investimento - Outras propriedades de investimento', 'GA', 66),
(725, 663, 460, 'Em propriedade de investimento - Propriedades de investimento em curso', 'GA', 66),
(726, 664, 461, 'Em ativos biológicos - Consumíveis', 'GA', 66),
(727, 664, 462, 'Em ativos biológicos - De produção', 'GA', 66),
(728, 67, 0, 'Provisões do período', 'GR', 0),
(729, 671, 463, 'Impostos', 'GA', 67),
(730, 672, 464, 'Garantias a clientes', 'GA', 67),
(731, 673, 465, 'Processos judiciais em curso', 'GA', 67),
(732, 674, 466, 'Acidentes no trabalho e doenças profissionais', 'GA', 67),
(733, 675, 467, 'Materiais ambientais', 'GA', 67),
(734, 676, 468, 'Contratos onerosos', 'GA', 67),
(735, 677, 469, 'Reestruturação', 'GA', 67),
(736, 678, 470, 'Outras Provisões', 'GA', 67),
(737, 68, 0, 'Outros gastos e perdas', 'GR', 0),
(738, 681, 0, 'Impostos', 'GA', 68),
(739, 6811, 471, 'Impostos diretos', 'GA', 681),
(740, 6812, 472, 'Impostos indiretos', 'GA', 681),
(741, 6813, 473, 'Taxas', 'GA', 681),
(742, 682, 474, 'Descontos de pagamentos concedidos', 'GA', 68),
(743, 683, 475, 'Dívidas incobráveis', 'GA', 68),
(744, 684, 0, 'Perdas em inventários', 'GA', 68),
(745, 6841, 476, 'Sinistros', 'GA', 684),
(746, 6842, 477, 'Quebras', 'GA', 684),
(747, 6843, 478, 'Outras perdas', 'GA', 684),
(748, 6844, 478, 'Outras perdas', 'GA', 684),
(749, 6845, 478, 'Outras perdas', 'GA', 684),
(750, 6846, 478, 'Outras perdas', 'GA', 684),
(751, 6847, 478, 'Outras perdas', 'GA', 684),
(752, 685, 0, 'Outras perdas em subsidiárias, associadas e empreendimentos conjuntos', 'GA', 68),
(753, 6851, 479, 'Cobertura de prejuízos', 'GA', 685),
(754, 6852, 480, 'Aplicação do método de equivalência patrimonial', 'GA', 685),
(755, 6853, 481, 'Alienações', 'GA', 685),
(756, 6854, 482, 'Outros gastos e perdas', 'GA', 685),
(757, 6855, 482, 'Outros gastos e perdas', 'GA', 685),
(758, 6856, 482, 'Outros gastos e perdas', 'GA', 685),
(759, 6857, 482, 'Outros gastos e perdas', 'GA', 685),
(760, 6858, 482, 'Outros gastos e perdas', 'GA', 685),
(761, 685, 0, 'Gastos e perdas nos restantes investimentos financeiros', 'GA', 68),
(762, 6861, 483, 'Cobertura de prejuízos', 'GA', 686),
(763, 6862, 484, 'Alienações', 'GA', 686),
(764, 6863, 485, 'Diferenças de câmbio desfavoráveis', 'GA', 686),
(765, 6864, 486, 'Outros gastos e perdas', 'GA', 686),
(766, 6865, 486, 'Outros gastos e perdas', 'GA', 686),
(767, 6866, 486, 'Outros gastos e perdas', 'GA', 686),
(768, 6867, 486, 'Outros gastos e perdas', 'GA', 686),
(769, 6868, 486, 'Outros gastos e perdas', 'GA', 686),
(770, 687, 0, 'Gastos e perdas em investimentos não financeiros', 'GA', 68),
(771, 6871, 487, 'Alienações', 'GA', 687),
(772, 6872, 488, 'Sinistros', 'GA', 687),
(773, 6873, 489, 'Abates', 'GA', 687),
(774, 6874, 490, 'Gastos em propriedades de investimento', 'GA', 687),
(775, 6875, 491, 'Outros gastos e perdas', 'GA', 687),
(776, 6876, 491, 'Outros gastos e perdas', 'GA', 687),
(777, 6877, 491, 'Outros gastos e perdas', 'GA', 687),
(778, 6878, 491, 'Outros gastos e perdas', 'GA', 687),
(779, 688, 0, 'Outros', 'GA', 68),
(780, 6881, 492, 'Correções relativas a períodos', 'GA', 688),
(781, 6882, 493, 'Donativos', 'GA', 688),
(782, 6883, 494, 'Quotizações', 'GA', 688),
(783, 6884, 495, 'Ofertas e amostras de inventários', 'GA', 688),
(784, 6885, 496, 'Insuficiência da estimativa para impostos', 'GA', 688),
(785, 6886, 497, 'Perdas em instrumentos financeiros', 'GA', 688),
(786, 6887, 498, 'Diferenças de câmbio desfavoráveis', 'GA', 688),
(787, 6888, 499, 'Outros nao especificados', 'GA', 688),
(788, 69, 0, 'Gastos e perdas de financiamento', 'GR', 0),
(789, 691, 0, 'Juros suportados', 'GA', 69),
(790, 6911, 500, 'Juros de financiamento obtidos', 'GA', 691),
(791, 6912, 501, 'Outros juros', 'GA', 691),
(792, 6913, 501, 'Outros juros', 'GA', 691),
(793, 6914, 501, 'Outros juros', 'GA', 691),
(794, 6915, 501, 'Outros juros', 'GA', 691),
(795, 6916, 501, 'Outros juros', 'GA', 691),
(796, 6917, 501, 'Outros juros', 'GA', 691),
(797, 6918, 501, 'Outros juros', 'GA', 691),
(798, 692, 501, 'Diferenças de câmbio desfavoráveis', 'GA', 69),
(799, 6921, 502, 'relativas a financiamentos obtidos', 'GA', 692),
(800, 6922, 503, 'Outras', 'GA', 692),
(801, 6923, 503, 'Outras', 'GA', 692),
(802, 6924, 503, 'Outras', 'GA', 692),
(803, 6925, 503, 'Outras', 'GA', 692),
(804, 6926, 503, 'Outras', 'GA', 692),
(805, 6927, 503, 'Outras', 'GA', 692),
(806, 6928, 503, 'Outras', 'GA', 692),
(807, 693, 504, 'Relativos a financiamentos obtidos', 'GA', 69),
(808, 694, 504, 'Relativos a financiamentos obtidos', 'GA', 69),
(809, 695, 504, 'Relativos a financiamentos obtidos', 'GA', 69),
(810, 696, 504, 'Relativos a financiamentos obtidos', 'GA', 69),
(811, 697, 504, 'Relativos a financiamentos obtidos', 'GA', 69),
(812, 698, 0, 'Outros gastos e perdas de financiamento', 'GA', 69),
(813, 6981, 504, 'Relativos a financiamentos obtidos', 'GA', 698),
(814, 6982, 505, 'Relativos a financiamentos obtidos', 'GA', 698),
(815, 6983, 505, 'Relativos a financiamentos obtidos', 'GA', 698),
(816, 6984, 505, 'Relativos a financiamentos obtidos', 'GA', 698),
(817, 6985, 505, 'Relativos a financiamentos obtidos', 'GA', 698),
(818, 6986, 505, 'Relativos a financiamentos obtidos', 'GA', 698),
(819, 6987, 505, 'Relativos a financiamentos obtidos', 'GA', 698),
(820, 6988, 505, 'Relativos a financiamentos obtidos', 'GA', 698),
(821, 71, 0, 'Vendas', 'GR', 0),
(822, 711, 506, 'Mercadorias', 'GA', 71),
(823, 712, 507, 'Produtos acabados e intermédios', 'GA', 71),
(824, 713, 508, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 71),
(825, 714, 509, 'Ativos biológicos', 'GA', 71),
(826, 716, 510, 'IVA das vendas com imposto incluido', 'GA', 71),
(827, 717, 511, 'Devoluções de vendas', 'GA', 71),
(828, 718, 512, 'Descontos e abatimentos de vendas', 'GA', 71),
(829, 72, 0, 'Prestações e serviços', 'GR', 0),
(830, 721, 513, 'Serviço A', 'GA', 72),
(831, 722, 514, 'Serviço B', 'GA', 72),
(832, 723, 515, 'Outros serviços', 'GA', 72),
(833, 724, 515, 'Outros serviços', 'GA', 72),
(834, 725, 516, 'Serviços secundários', 'GA', 72),
(835, 726, 517, 'IVA dos serviços com imposto incluído', 'GA', 72),
(836, 727, 515, 'Outros serviços', 'GA', 72),
(837, 728, 518, 'Descontos e abatimentos', 'GA', 72),
(838, 73, 0, 'Variações nos inventários da produção', 'GR', 0),
(839, 731, 519, 'Produtos acabados e intermédios', 'GA', 73),
(840, 732, 520, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 73),
(841, 733, 521, 'Produtos e trabalhos em curso', 'GA', 73),
(842, 734, 522, 'Ativos biológicos', 'GA', 73),
(843, 74, 0, 'Trabalhos para a própria identidade', 'GR', 0),
(844, 741, 523, 'Ativos fixos tangíveis', 'GA', 74),
(845, 742, 524, 'Ativos intangíveis', 'GA', 74),
(846, 743, 525, 'Propriedades de investimento', 'GA', 74),
(847, 744, 526, 'Ativos por gastos deferidos', 'GA', 74),
(848, 75, 0, 'Subsídios à exploração', 'GR', 0),
(849, 751, 527, 'Subsídios do estado e outros entes públicos', 'GA', 75),
(850, 752, 528, 'Subsídios de outras entidades', 'GA', 75),
(851, 76, 0, 'Reversões', 'GR', 0),
(852, 761, 0, 'De Depreciações e de amortizações', 'GA', 76),
(853, 7611, 529, 'Propriedades de investimento - Terrenos e recursos naturais', 'GA', 761),
(854, 7611, 530, 'Propriedades de investimento - Edifíçios e outras construções', 'GA', 761),
(855, 7611, 531, 'Propriedades de investimento - Outras propriedades de investimento', 'GA', 761),
(856, 7612, 532, 'Ativos fixos tangíveis - Terrenos e recursos naturais', 'GA', 761),
(857, 7612, 533, 'Ativos fixos tangíveis - Edifíçios e outras construções', 'GA', 761),
(858, 7612, 534, 'Ativos fixos tangíveis - Equipamento básico', 'GA', 761),
(859, 7612, 535, 'Ativos fixos tangíveis - Equipamento de transporte', 'GA', 761),
(860, 7612, 536, 'Ativos fixos tangíveis - Equipamento administrativo', 'GA', 761),
(861, 7612, 537, 'Ativos fixos tangíveis - Equipamentos biológicos', 'GA', 761),
(862, 7612, 538, 'Ativos fixos tangíveis - Outros fixos tangíveis', 'GA', 761),
(863, 7613, 539, 'Ativos intangíveis - Goodwill', 'GA', 761),
(864, 7613, 540, 'Ativos intangíveis - Projetos de desenvolvimento', 'GA', 761),
(865, 7613, 541, 'Ativos intangíveis - Programas de computador', 'GA', 761),
(866, 7613, 542, 'Ativos intangíveis - Propriedade industrial', 'GA', 761),
(867, 7613, 543, 'Ativos intangíveis - Outros ativos intangíveis', 'GA', 761),
(868, 761, 544, 'Ativos biológicos - Consumíveis', 'GA', 76),
(869, 761, 545, 'Ativos biológicos - De produção', 'GA', 76),
(870, 761, 546, 'Investimentos financiamento .  Goodwill', 'GA', 76),
(871, 762, 0, 'De perdas de imparidade', 'GA', 76),
(872, 7621, 0, 'Em dividas a receber', 'GA', 762),
(873, 76211, 547, 'Clientes', 'GA', 7621),
(874, 76212, 548, 'Outros devedores', 'GA', 7621),
(875, 7622, 549, 'Em inventários - Mercadorias', 'GA', 762),
(876, 7622, 550, 'Em inventários - Materias-primas, subsidiárias e de consumo', 'GA', 762),
(877, 7622, 551, 'Em inventários - Produtos acabados e intermédios', 'GA', 762),
(878, 7622, 552, 'Em inventários - Subprodutos, desperdícios, resíduos e refugos', 'GA', 762),
(879, 7622, 553, 'Em inventários - Produtos e trabalhos em curso', 'GA', 762),
(880, 7622, 554, 'Em inventários - Ativos biológicos consumíveis', 'GA', 762),
(881, 7622, 555, 'Em inventários - Ativos biológicos de produção', 'GA', 762),
(882, 7623, 556, 'Em investimentos financeiros - Participações de capital', 'GA', 762),
(883, 7623, 557, 'Em investimentos financeiros - Empréstimos concedidos', 'GA', 762),
(884, 7623, 558, 'Em investimentos financeiros - Outros investimentos financeiros', 'GA', 762),
(885, 7624, 559, 'Em propriedades de investimento - Terrenos e recursos naturais', 'GA', 762),
(886, 7624, 560, 'Em propriedades de investimento - Edifíçios e outras construções', 'GA', 762),
(887, 7624, 561, 'Em propriedades de investimento - Outras propriedades de investimento', 'GA', 762),
(888, 7625, 562, 'Em ativos fixos tangíveis - Terrenos e recursos naturais', 'GA', 762),
(889, 7625, 563, 'Em ativos fixos tangíveis - Edifíçios e outras construções', 'GA', 762),
(890, 7625, 564, 'Em ativos fixos tangíveis - Equipamento básico', 'GA', 762),
(891, 7625, 565, 'Em ativos fixos tangíveis - Equipamento de transporte', 'GA', 762),
(892, 7625, 566, 'Em ativos fixos tangíveis - Equipamento administrativo', 'GA', 762),
(893, 7625, 567, 'Em ativos fixos tangíveis - Equipamentos biológicos', 'GA', 762),
(894, 7625, 568, 'Em ativos fixos tangíveis - Outros ativos fixos tangíveis', 'GA', 762),
(895, 7626, 569, 'Em ativos intangíveis - Projetos de desenvolvimento', 'GA', 762),
(896, 7626, 570, 'Em ativos intangíveis - Programas de computador', 'GA', 762),
(897, 7626, 571, 'Em ativos intangíveis - Propriedade industrial', 'GA', 762),
(898, 7626, 572, 'Em ativos intangíveis - Outros ativos intangíveis', 'GA', 762),
(899, 7627, 573, 'Em investimentos em curso - Investimentos financeiros em curso', 'GA', 762),
(900, 7627, 574, 'Em investimentos em curso - Propriedades de investimento em curso', 'GA', 762),
(901, 7627, 575, 'Em investimentos em curso - Ativos fixos tangíveis em curso', 'GA', 762),
(902, 7627, 576, 'Em investimentos em curso - Ativos intangíveis em curso', 'GA', 762),
(903, 7627, 577, 'Em investimentos em curso - Adiantamentos por conta de investimentos - Investimentos financeiros em ', 'GA', 762),
(904, 7627, 578, 'Em investimentos em curso - Adiantamentos por conta de investimentos - Propriedades de investimento ', 'GA', 762),
(905, 7627, 579, 'Em investimentos em curso - Adiantamentos por conta de investimentos - Ativos fixos tangíveis em cur', 'GA', 762),
(906, 7627, 580, 'Em investimentos em curso - Adiantamentos por conta de investimentos - Ativos intangíveis em curso', 'GA', 762),
(907, 7628, 581, 'Em ativos não correntes detidos para venda - Investimentos financeiros', 'GA', 762),
(908, 7628, 582, 'Em ativos não correntes detidos para venda - Propriedades de investimento', 'GA', 762),
(909, 7628, 583, 'Em ativos não correntes detidos para venda - Ativos fixos tangíveis', 'GA', 762),
(910, 7628, 584, 'Em ativos não correntes detidos para venda - Ativos intangíveis', 'GA', 762),
(911, 7628, 585, 'Em ativos não correntes detidos para venda - Outros', 'GA', 762),
(912, 763, 0, 'De Provisões', 'GA', 76),
(913, 7631, 586, 'Impostos', 'GA', 763),
(914, 7632, 587, 'Garantias a clientes', 'GA', 763),
(915, 7633, 588, 'Processos judiciais em curso', 'GA', 763),
(916, 7634, 589, 'Acidentes no trabalho ', 'GA', 763),
(917, 7635, 590, 'Matérias ambientais', 'GA', 763),
(918, 7636, 591, 'Contratos onerosos', 'GA', 763),
(919, 7637, 592, 'Reestruturação', 'GA', 763),
(920, 7638, 593, 'Outras Provisões', 'GA', 763),
(921, 77, 0, 'Ganhos por aumentos de justo valor', 'GR', 0),
(922, 771, 594, 'Em instrumentos financeiros', 'GA', 77),
(923, 772, 595, 'Em investimentos financeiros - Participações de capital', 'GA', 77),
(924, 772, 596, 'Em investimentos financeiros - Outros investimentos financeiros', 'GA', 77),
(925, 773, 597, 'Em propriedades de investimento - Terrenos e recursos naturais', 'GA', 77),
(926, 773, 598, 'Em propriedades de investimento - Edifíçios e outras construções', 'GA', 77),
(927, 773, 599, 'Em propriedades de investimento - Outras propriedades de investimento', 'GA', 77),
(928, 773, 600, 'Em propriedades de investimento - Propriedades de investimento em curso', 'GA', 77),
(929, 774, 601, 'Em ativos biológicos - Consumíveis', 'GA', 77),
(930, 774, 602, 'Em ativos biológicos - De produção', 'GA', 77),
(931, 78, 0, 'Outros rendimentos e ganhos', 'GR', 0),
(932, 781, 0, 'Rendimentos suplementares', 'GA', 78),
(933, 7811, 603, 'Serviços sociais', 'GA', 781),
(934, 7812, 604, 'Serviços aluguer de equipamento', 'GA', 781),
(935, 7813, 605, 'Estudos, projetos e assistência tecnológica', 'GA', 781),
(936, 7814, 606, 'Royalties', 'GA', 781),
(937, 7815, 607, 'Desempenhos de cargas sociais noutras empresas', 'GA', 781),
(938, 7816, 608, 'Outros rendimentos suplementares', 'GA', 781),
(939, 782, 609, 'Descontos de pronto pagamento obtidos', 'GA', 78),
(940, 783, 610, 'Recuperação de dividas a receber', 'GA', 78),
(941, 784, 0, 'Ganhos em inventários', 'GA', 78),
(942, 7841, 611, 'Sinistros', 'GA', 784),
(943, 7842, 612, 'Sobras', 'GA', 784),
(944, 7843, 613, 'Outros ganhos', 'GA', 784),
(945, 7844, 613, 'Outros ganhos', 'GA', 784),
(946, 7845, 613, 'Outros ganhos', 'GA', 784),
(947, 7846, 613, 'Outros ganhos', 'GA', 784),
(948, 7847, 613, 'Outros ganhos', 'GA', 784),
(949, 7848, 613, 'Outros ganhos', 'GA', 784),
(950, 785, 613, 'Rendimentos e ganhos em subsidiárias, associadas e empreendimentos conjuntos', 'GA', 78),
(951, 7851, 614, 'Aplicação do método de equivalência patrimonial', 'GA', 785),
(952, 7852, 615, 'Alienações', 'GA', 785),
(953, 7853, 616, 'Outros rendimentos', 'GA', 785),
(954, 7854, 616, 'Outros rendimentos', 'GA', 785),
(955, 7855, 616, 'Outros rendimentos', 'GA', 785),
(956, 7856, 616, 'Outros rendimentos', 'GA', 785),
(957, 7857, 616, 'Outros rendimentos', 'GA', 785),
(958, 7858, 616, 'Outros rendimentos', 'GA', 785),
(959, 786, 617, 'Rendimentos e ganhos nos restantes ativos financeiros', 'GA', 78),
(960, 7861, 618, 'Diferenças de câmbio favoráveis', 'GA', 786),
(961, 7862, 619, 'Alienações', 'GA', 786),
(962, 7863, 620, 'Outros rendimentos', 'GA', 786),
(963, 7864, 620, 'Outros rendimentos', 'GA', 786),
(964, 7865, 620, 'Outros rendimentos', 'GA', 786),
(965, 7866, 620, 'Outros rendimentos', 'GA', 786),
(966, 7867, 620, 'Outros rendimentos', 'GA', 786),
(967, 7868, 620, 'Outros rendimentos', 'GA', 786),
(968, 787, 0, 'Rendimentos e ganhos em investimentos nao financeiros', 'GA', 78),
(969, 7871, 620, 'Alienações', 'GA', 787),
(970, 7872, 621, 'Sinistros', 'GA', 787),
(971, 7873, 622, 'Rendas e outros rendimentos em propriedades de investimento', 'GA', 787),
(972, 7874, 623, 'Outros rendimentos', 'GA', 787),
(973, 7875, 623, 'Outros rendimentos', 'GA', 787),
(974, 7876, 623, 'Outros rendimentos', 'GA', 787),
(975, 7877, 623, 'Outros rendimentos', 'GA', 787),
(976, 7878, 623, 'Outros rendimentos', 'GA', 787),
(977, 788, 0, 'Outros', 'GA', 78),
(978, 7881, 624, 'Correções relativas a períodos anteriores', 'GA', 788),
(979, 7882, 625, 'Excesso da estimativa para impostos', 'GA', 788),
(980, 7883, 626, 'Imputação de subsídios para investimentos', 'GA', 788),
(981, 7884, 627, 'Ganhos em outros instrumentos financeiros', 'GA', 788),
(982, 7885, 628, 'Restituição de impostos', 'GA', 788),
(983, 7886, 630, 'Outros nao especificados', 'GA', 788),
(984, 7887, 629, 'Diferenças de câmbio favoráveis', 'GA', 788),
(985, 7888, 630, 'outros não especificados', 'GA', 788),
(986, 79, 0, 'Juros, dividendos e outros rendimentos similiares', 'GR', 0),
(987, 791, 0, 'Juros obtidos', 'GA', 79),
(988, 7911, 631, 'De depósitos', 'GA', 791),
(989, 7912, 632, 'De outras aplicações de meios financeiros liquidos', 'GA', 791),
(990, 7913, 633, 'De financiamentos concedidos a associadas e empreendimentos conjuntos', 'GA', 791),
(991, 7914, 634, 'De financiamentos conjuntos a associadas', 'GA', 791),
(992, 7915, 635, 'De financiamentos obtidos', 'GA', 791),
(993, 7916, 636, 'De outros financiamentos concedidos', 'GA', 791),
(994, 7917, 636, 'De outros financiamentos concedidos', 'GA', 791),
(995, 7918, 636, 'De outros financiamentos concedidos', 'GA', 791),
(996, 792, 0, 'dividendos obtidos', 'GA', 79),
(997, 7921, 637, 'De aplicações de meios financeiros liquidos', 'GA', 792),
(998, 7922, 638, 'De associadas e empreendimentos conjuntos', 'GA', 792),
(999, 7923, 639, 'De subsidiárias', 'GA', 792),
(1000, 7924, 640, 'Outras', 'GA', 792),
(1001, 7925, 640, 'Outras', 'GA', 792),
(1002, 7926, 640, 'Outras', 'GA', 792),
(1003, 7927, 640, 'Outras', 'GA', 792),
(1004, 7928, 640, 'Outras', 'GA', 792),
(1005, 793, 641, 'Dividendos obtidos', 'GA', 79),
(1006, 794, 642, 'Outros rendimentos similiares', 'GA', 79),
(1007, 795, 642, 'Outros rendimentos similiares', 'GA', 79),
(1008, 796, 642, 'Outros rendimentos similiares', 'GA', 79),
(1009, 797, 642, 'Outros rendimentos similiares', 'GA', 79),
(1010, 798, 642, 'Outros rendimentos similiares', 'GA', 79),
(1011, 81, 0, 'Resultado liquido do período', 'GR', 0),
(1012, 811, 643, 'Resultado antes de impostos', 'GA', 81),
(1013, 812, 0, 'Imposto sobre o rendimento do período', 'GA', 81),
(1014, 8121, 644, 'Imposto estimado para o período', 'GA', 812),
(1015, 8122, 645, 'Imposto deferido', 'GA', 812),
(1016, 818, 646, 'Resultado liquido', 'GA', 81),
(1017, 818, 647, 'Dividendos antecipados', 'GA', 81);

CREATE TABLE `faturacao_snc_micro` (
  `ID_Snc_Base` int(11) NOT NULL,
  `Snc_Code` bigint(30) NOT NULL,
  `Taxonomy_Code` bigint(30) NOT NULL,
  `Descricao` varchar(100) NOT NULL,
  `Grouping_Category` varchar(2) NOT NULL,
  `Grouping_Code` bigint(30) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_snc_micro` (`ID_Snc_Base`, `Snc_Code`, `Taxonomy_Code`, `Descricao`, `Grouping_Category`, `Grouping_Code`) VALUES
(1, 11, 1, 'Caixa', 'GR', 0),
(2, 12, 2, 'Depósitos à ordem', 'GR', 0),
(3, 13, 3, 'Outros depósitos bancários', 'GR', 0),
(4, 14, 4, 'Outros instrumentos financeiros', 'GR', 0),
(5, 21, 0, 'Clientes', 'GR', 0),
(6, 211, 5, 'Clientes c/c', 'GA', 21),
(7, 212, 6, 'Clientes - títulos a receber', 'GA', 21),
(8, 213, 7, 'Outros clientes', 'GA', 21),
(9, 214, 7, 'Outros clientes', 'GA', 21),
(10, 215, 7, 'Outros clientes', 'GA', 21),
(11, 216, 7, 'Outros clientes', 'GA', 21),
(12, 217, 7, 'Outros clientes', 'GA', 21),
(13, 218, 8, 'Adiantamentos de clientes', 'GA', 21),
(14, 219, 9, 'Perdas por imparidade acumuladas - Clientes c/c', 'GA', 21),
(15, 219, 10, 'Perdas por imparidade acumuladas - títulos a receber', 'GA', 21),
(16, 219, 11, 'Perdas por imparidade acumuladas - Outros clientes', 'GA', 21),
(17, 22, 0, 'Fornecedores', 'GR', 0),
(18, 221, 12, 'Fornecedores c/c', 'GA', 22),
(19, 222, 13, 'Fornecedores - títulos a pagar', 'GA', 22),
(20, 223, 14, 'Outros fornecedores', 'GA', 22),
(21, 224, 14, 'Outros fornecedores', 'GA', 22),
(22, 225, 15, 'Faturas em receção e conferência', 'GA', 22),
(23, 226, 14, 'Outros fornecedores', 'GA', 22),
(24, 227, 14, 'Outros fornecedores', 'GA', 22),
(25, 228, 16, 'Adiantamentos a fornecedores', 'GA', 22),
(26, 229, 17, 'Perdas por imparidade acumuladas', 'GA', 22),
(27, 23, 0, 'Pessoal', 'GR', 0),
(28, 231, 0, 'Remunerações a pagar', 'GA', 23),
(29, 2311, 18, 'Aos orgãos sociais', 'GA', 231),
(30, 2312, 19, 'Ao pessoal', 'GA', 231),
(31, 232, 0, 'Adiantamentos', 'GA', 23),
(32, 2321, 20, 'Aos orgaõs socias', 'GA', 232),
(33, 2322, 21, 'Ao pessoal', 'GA', 232),
(34, 233, 22, 'Com os orgãos socias (Corrente)', 'GA', 23),
(35, 234, 22, 'Com os orgãos socias (Corrente)', 'GA', 23),
(36, 235, 22, 'Com os orgãos socias (Corrente)', 'GA', 23),
(37, 236, 22, 'Com os orgãos socias (Corrente)', 'GA', 23),
(38, 233, 23, 'Com os orgãos socias (Não corrente)', 'GA', 23),
(39, 234, 23, 'Com os orgãos socias (Não corrente)', 'GA', 23),
(40, 235, 23, 'Com os orgãos socias (Não corrente)', 'GA', 23),
(41, 236, 23, 'Com os orgãos socias (Não corrente)', 'GA', 23),
(42, 233, 24, 'Com o pessoal (Corrente)', 'GA', 23),
(43, 234, 24, 'Com o pessoal (Corrente)', 'GA', 23),
(44, 235, 24, 'Com o pessoal (Corrente)', 'GA', 23),
(45, 236, 24, 'Com o pessoal (Corrente)', 'GA', 23),
(46, 233, 25, 'Com o pessoal (Não corrente)', 'GA', 23),
(47, 234, 25, 'Com o pessoal (Não corrente)', 'GA', 23),
(48, 235, 25, 'Com o pessoal (Não corrente)', 'GA', 23),
(49, 236, 25, 'Com o pessoal (Não corrente)', 'GA', 23),
(50, 238, 0, 'Outras operações', 'GA', 23),
(51, 2381, 22, 'Com os orgãos sociais (Corrente)', 'GA', 238),
(52, 2381, 23, 'Com os orgãos sociais (Não corrente)', 'GA', 238),
(53, 2382, 24, 'Com o pessoal (Corrente)', 'GA', 238),
(54, 2382, 25, 'Com o pessoal (Não corrente)', 'GA', 238),
(55, 239, 26, 'Perdas por imparidade acumuladas - Aos orgãos sociais', 'GA', 23),
(56, 239, 27, 'Perdas por imparidade acumuladas - Ao pesosal', 'GA', 23),
(57, 239, 28, 'Perdas por imparidade acumuladas - Aos orgãos sociais (Corrente)', 'GA', 23),
(58, 239, 29, 'Perdas por imparidade acumuladas - Aos orgãos sociais (Não corrente)', 'GA', 23),
(59, 239, 30, 'Perdas por imparidade acumuladas - Ao pessoal (corrente)', 'GA', 23),
(60, 239, 31, 'Perdas por imparidade acumuladas - Ao pessoal (Não corrente)', 'GA', 23),
(61, 24, 0, 'Outras operações', 'GR', 0),
(62, 241, 32, 'Imposto sobre o rendimento', 'GA', 24),
(63, 242, 33, 'Retenção de impostos sobre rendimentos', 'GA', 24),
(64, 243, 0, 'Imposto sobre o valor acrescentado (IVA)', 'GA', 24),
(65, 2431, 34, 'IVA-Suportado', 'GA', 243),
(66, 2432, 35, 'IVA-Dedutível', 'GA', 243),
(67, 2433, 36, 'IVA-Liquidado', 'GA', 243),
(68, 2434, 37, 'IVA-Regularizações', 'GA', 243),
(69, 2435, 38, 'IVA-Apuramento', 'GA', 243),
(70, 2436, 39, 'IVA-A pagar', 'GA', 243),
(71, 2437, 40, 'IVA-A recuperar', 'GA', 243),
(72, 2438, 41, 'IVA-Reembolsos pedidos', 'GA', 243),
(73, 2439, 42, 'IVA-Liquidações oficiosas', 'GA', 243),
(74, 244, 43, 'Outros impostos', 'GA', 24),
(75, 245, 44, 'Contribuições para a segurança social', 'GA', 24),
(76, 246, 45, 'Tributos das autarquias locais', 'GA', 24),
(77, 247, 46, 'Outras tributações', 'GA', 24),
(78, 248, 46, 'Outras tributações', 'GA', 24),
(79, 25, 0, 'Financiamentos obtidos', 'GR', 0),
(80, 251, 0, 'Instituições de crédito e sociedades financeiras', 'GA', 25),
(81, 2511, 47, 'Empréstimos bancários (Corrente)', 'GA', 251),
(82, 2511, 48, 'Empréstimos bancários (Não corrente)', 'GA', 251),
(83, 2512, 49, 'Descobertos bancários (Corrente)', 'GA', 251),
(84, 2512, 50, 'Descobertos bancários (Não corrente)', 'GA', 251),
(85, 2513, 51, 'Locações financeiras (Corrente)', 'GA', 251),
(86, 2513, 52, 'Outros financiamentos (Corrente)', 'GA', 251),
(87, 2514, 53, 'Outros financiamentos (Corrente)', 'GA', 251),
(88, 2515, 53, 'Outros financiamentos (Corrente)', 'GA', 251),
(89, 2516, 53, 'Outros financiamentos (Corrente)', 'GA', 251),
(90, 2517, 53, 'Outros financiamentos (Corrente)', 'GA', 251),
(91, 2518, 53, 'Outros financiamentos (Corrente)', 'GA', 251),
(92, 2519, 53, 'Outros financiamentos (Corrente)', 'GA', 251),
(93, 2514, 54, 'Outros financiamentos (Não corrente)', 'GA', 251),
(94, 2515, 54, 'Outros financiamentos (Não corrente)', 'GA', 251),
(95, 2516, 54, 'Outros financiamentos (Não corrente)', 'GA', 251),
(96, 2517, 54, 'Outros financiamentos (Não corrente)', 'GA', 251),
(97, 2518, 54, 'Outros financiamentos (Não corrente)', 'GA', 251),
(98, 2519, 54, 'Outros financiamentos (Não corrente)', 'GA', 251),
(99, 255, 55, 'Outros financiadores (Corrente)', 'GA', 25),
(100, 256, 55, 'Outros financiadores (Corrente)', 'GA', 25),
(101, 257, 55, 'Outros financiadores (Corrente)', 'GA', 25),
(102, 258, 55, 'Outros financiadores (Corrente)', 'GA', 25),
(103, 255, 56, 'Outros financiadores (Não corrente)', 'GA', 25),
(104, 256, 56, 'Outros financiadores (Não corrente)', 'GA', 25),
(105, 257, 56, 'Outros financiadores (Não corrente)', 'GA', 25),
(106, 258, 56, 'Outros financiadores (Não corrente)', 'GA', 25),
(107, 26, 0, 'Acionistas/sócios', 'GR', 0),
(108, 262, 57, 'Quotas nao liberadas', 'GA', 26),
(109, 263, 58, 'Adiantamentos por conta de lucros', 'GA', 26),
(110, 264, 59, 'Resultados atribuidos', 'GA', 26),
(111, 265, 60, 'Lucros disponiveis', 'GA', 26),
(112, 267, 61, 'Outras operações (Corrente)', 'GA', 26),
(113, 267, 62, 'Outras operações (Não corrente)', 'GA', 26),
(114, 268, 61, 'Outras operações (Corrente)', 'GA', 26),
(115, 268, 62, 'Outras operações (Não corrente)', 'GA', 26),
(116, 269, 63, 'Perdas por imparidade acumuladas - Quotas não liberadas', 'GA', 26),
(117, 269, 64, 'Perdas por imparidade acumuladas - Adiantamentos por conta de lucros', 'GA', 26),
(118, 269, 65, 'Perdas por imparidade acumuladas - Resultados atribuidos', 'GA', 26),
(119, 269, 66, 'Perdas por imparidade acumuladas - Lucros disponiveis', 'GA', 26),
(120, 269, 67, 'Perdas por imparidade acumuladas - Outras operações (Corrente)', 'GA', 26),
(121, 269, 68, 'Perdas por imparidade acumuladas - Outras operações (Não corrente)', 'GA', 26),
(122, 27, 0, 'Outras contas a receber e a pagar', 'GR', 0),
(123, 271, 0, 'Fornecedores de investimento', 'GA', 27),
(124, 2711, 69, 'Fornecedores de investimento - Quotas gerais (Corrente)', 'GA', 271),
(125, 2711, 70, 'Fornecedores de investimento - Quotas gerais (Não corrente)', 'GA', 271),
(126, 2712, 71, 'Faturas em recepção e conferência (Corrente)', 'GA', 271),
(127, 2712, 72, 'Faturas em recepção e conferência (Não corrente)', 'GA', 271),
(128, 2713, 73, 'Adiantamentos a fornecedores de investimentos (Corrente)', 'GA', 271),
(129, 2713, 74, 'Adiantamentos a fornecedores de investimentos (Não corrente)', 'GA', 271),
(130, 272, 0, 'Devedores e credores por acréscimos (Periodização económica)', 'GA', 27),
(131, 2721, 75, 'Devedores por acréscimos de rendimentos', 'GA', 272),
(132, 2722, 76, 'Credores por acréscimos de gastos', 'GA', 272),
(133, 276, 77, 'Adiantamentos por conta de investimentos', 'GA', 27),
(134, 277, 78, 'Outros devedores e credores (Corrente)', 'GA', 27),
(135, 277, 79, 'Outros devedores e credores (Não corrente)', 'GA', 27),
(136, 278, 78, 'Outros devedores e credores (Corrente)', 'GA', 27),
(137, 278, 79, 'Outros devedores e credores (Corrente)', 'GA', 27),
(138, 279, 80, 'Perdas por imparidade acumuladas - Adiantamentos a fornecedores de investimentos (Corrente)', 'GA', 27),
(139, 279, 81, 'Perdas por imparidade acumuladas - Adiantamentos a fornecedores de investimentos (Não corrente)', 'GA', 27),
(140, 279, 82, 'Perdas por imparidade acumuladas - Devedores por acréscimos de rendimentos', 'GA', 27),
(141, 279, 83, 'Perdas por imparidade acumuladas - Outros devedores e credores (Corrente)', 'GA', 27),
(142, 279, 84, 'Perdas por imparidade acumuladas - Outros devedores e credores (Não corrente)', 'GA', 27),
(143, 28, 0, 'Diferimentos', 'GR', 0),
(144, 281, 85, 'Gastos a reconhecer', 'GA', 28),
(145, 282, 86, 'Rendimentos a reconhecer', 'GA', 28),
(146, 29, 0, 'Provisões', 'GR', 0),
(147, 291, 87, 'Impostos', 'GA', 29),
(148, 292, 88, 'Garantias a clientes', 'GA', 29),
(149, 293, 89, 'Processos judiciais em curso', 'GA', 29),
(150, 294, 90, 'Acidentes de trabalho e doenças profissionais', 'GA', 29),
(151, 298, 91, 'Outras Provisões', 'GA', 29),
(152, 31, 0, 'Compras', 'GR', 0),
(153, 311, 92, 'Mercadorias', 'GA', 31),
(154, 312, 93, 'Matérias-primas, subsidiárias e de consumo', 'GA', 31),
(155, 317, 94, 'Devolução de compras', 'GA', 31),
(156, 317, 95, 'Matérias-primas, subsidiárias e de consumo', 'GA', 31),
(157, 318, 96, 'Descontos e abatimentos em compras - Mercadorias', 'GA', 31),
(158, 318, 97, 'Descontos e abatimentos em compras - Matérias-primas, subsidiárias e de consumo', 'GA', 31),
(159, 32, 0, 'Mercadorias', 'GR', 0),
(160, 321, 98, 'Mercadorias', 'GA', 32),
(161, 322, 98, 'Mercadorias', 'GA', 32),
(162, 323, 98, 'Mercadorias', 'GA', 32),
(163, 324, 98, 'Mercadorias', 'GA', 32),
(164, 325, 99, 'Mercadorias em trânsito', 'GA', 32),
(165, 326, 100, 'Mercadorias em poder de terceiros', 'GA', 32),
(166, 327, 98, 'Mercadorias', 'GA', 32),
(167, 328, 98, 'Mercadorias', 'GA', 32),
(168, 329, 101, 'Perdas por imparidade acumuladas - Mercadorias', 'GA', 32),
(169, 329, 102, 'Perdas por imparidade acumuladas - Mercadorias em trânsito', 'GA', 32),
(170, 329, 103, 'Perdas por imparidade acumuladas - Mercadorias em poder de terceiros', 'GA', 32),
(171, 33, 0, 'Matérias-primas, subsidiárias e de consumo', 'GR', 0),
(172, 331, 104, 'Matérias-primas', 'GA', 33),
(173, 332, 105, 'Matérias subsidiárias', 'GA', 33),
(174, 333, 106, 'Embalagens', 'GA', 33),
(175, 334, 107, 'Materiais diversos', 'GA', 33),
(176, 335, 108, 'Matérias em trânsito', 'GA', 33),
(177, 336, 109, 'Outras matérias-primas, subsidiárias e de consumo', 'GA', 33),
(178, 337, 109, 'Outras matérias-primas, subsidiárias e de consumo', 'GA', 33),
(179, 338, 109, 'Outras matérias-primas, subsidiárias e de consumo', 'GA', 33),
(180, 339, 110, 'Matérias-primas', 'GA', 33),
(181, 339, 111, 'Matérias subsidiárias', 'GA', 33),
(182, 339, 112, 'Embalagens', 'GA', 33),
(183, 339, 113, 'Materiais diversos', 'GA', 33),
(184, 339, 114, 'Matérias em trânsito', 'GA', 33),
(185, 339, 115, 'Outras matérias-primas, subsidiárias e de consumo', 'GA', 33),
(186, 34, 0, 'Produtos acabados e intermédios', 'GR', 0),
(187, 341, 116, 'Produtos acabados e intermédios', 'GA', 34),
(188, 342, 116, 'Produtos acabados e intermédios', 'GA', 34),
(189, 343, 116, 'Produtos acabados e intermédios', 'GA', 34),
(190, 344, 116, 'Produtos acabados e intermédios', 'GA', 34),
(191, 345, 116, 'Produtos acabados e intermédios', 'GA', 34),
(192, 346, 117, 'Produtos em poder de terceiros', 'GA', 34),
(193, 347, 116, 'Produtos acabados e intermédios', 'GA', 34),
(194, 348, 116, 'Produtos acabados e intermédios', 'GA', 34),
(195, 349, 118, 'Perdas por imparidade acumuladas', 'GA', 34),
(196, 349, 119, 'Perdas por imparidade acumuladas', 'GA', 34),
(197, 35, 0, 'Subprodutos, desperdícios, resíduos e refugos', 'GR', 0),
(198, 351, 120, 'Subprodutos', 'GA', 35),
(199, 352, 121, 'Desperdícios, resíduos e refugos', 'GA', 35),
(200, 353, 122, 'Outros subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(201, 354, 122, 'Outros subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(202, 355, 122, 'Outros subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(203, 356, 122, 'Outros subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(204, 357, 122, 'Outros subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(205, 358, 122, 'Outros subprodutos, desperdícios, resíduos e refugos', 'GA', 35),
(206, 359, 123, 'Subprodutos', 'GA', 35),
(207, 359, 124, 'Desperdícios, resíduos e refugos', 'GA', 35),
(208, 359, 125, 'Outros subprodutos, resíduos e refugos', 'GA', 35),
(209, 36, 127, 'Produtos e trabalhos em curso', 'GR', 0),
(210, 361, 126, 'Produtos e trabalhos em curso', 'GA', 36),
(211, 362, 126, 'Produtos e trabalhos em curso', 'GA', 36),
(212, 363, 126, 'Produtos e trabalhos em curso', 'GA', 36),
(213, 364, 126, 'Produtos e trabalhos em curso', 'GA', 36),
(214, 365, 126, 'Produtos e trabalhos em curso', 'GA', 36),
(215, 366, 126, 'Produtos e trabalhos em curso', 'GA', 36),
(216, 367, 126, 'Produtos e trabalhos em curso', 'GA', 36),
(217, 368, 126, 'Produtos e trabalhos em curso', 'GA', 36),
(218, 38, 0, 'Reclassificação e regularização de Investários e ativos biológicos', 'GR', 0),
(219, 382, 128, 'Desperdícios, resíduos e refugos', 'GA', 38),
(220, 383, 129, 'Matérias-primas, subsidiárias e de consumo', 'GA', 38),
(221, 384, 130, 'Produtos acabados e intermédios', 'GA', 38),
(222, 385, 131, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 38),
(223, 386, 132, 'Produtos e trabalhos em curso', 'GA', 38),
(224, 39, 133, 'Adiantamentos por conta de compras', 'GR', 0),
(225, 39, 134, 'Matérias-primas, subsidiárias e de consumo', 'GR', 0),
(226, 39, 135, 'Produtos acabados e intermédios', 'GR', 0),
(227, 39, 136, 'Subprodutos, desperdícios, resíduos e refugos', 'GR', 0),
(228, 39, 137, 'Produtos e trabalhos em curso', 'GR', 0),
(229, 41, 0, 'Investimentos financeiros', 'GR', 0),
(230, 414, 0, 'Investimentos noutras empresas', 'GA', 41),
(231, 4141, 138, 'Participações de capital', 'GA', 414),
(232, 4142, 139, 'Empréstimos concedidos', 'GA', 414),
(233, 4143, 140, 'Outros investimentos financeiros', 'GA', 414),
(234, 4144, 140, 'Outros investimentos financeiros', 'GA', 414),
(235, 4145, 140, 'Outros investimentos financeiros', 'GA', 414),
(236, 4146, 140, 'Outros investimentos financeiros', 'GA', 414),
(237, 4147, 140, 'Outros investimentos financeiros', 'GA', 414),
(238, 4148, 140, 'Outros investimentos financeiros', 'GA', 414),
(239, 4149, 140, 'Outros investimentos financeiros', 'GA', 414),
(240, 419, 141, 'Perdas por imparidade acumuladas - Participações de capital', 'GA', 41),
(241, 419, 142, 'Perdas por imparidade acumuladas - Empréstimos concedidos', 'GA', 41),
(242, 419, 143, 'Perdas por imparidade acumuladas - Outros investimentos financeiros', 'GA', 41),
(243, 43, 0, 'Ativos fixos tangíveis', 'GR', 0),
(244, 431, 144, 'Terrenos e recursos naturais', 'GA', 43),
(245, 432, 145, 'Edifícios e outras construções', 'GA', 43),
(246, 433, 146, 'Equipamento básico', 'GA', 43),
(247, 434, 147, 'Equipamento de transporte', 'GA', 43),
(248, 435, 148, 'Equipamento administrativo', 'GA', 43),
(249, 436, 149, 'Equipamentos biológicos', 'GA', 43),
(250, 437, 150, 'Outros ativos fixos tangíveis', 'GA', 43),
(251, 438, 151, 'Depreciações acumuladas - Terrenos e recursos naturais', 'GA', 43),
(252, 438, 152, 'Depreciações acumuladas - Edifícios e outras construções', 'GA', 43),
(253, 438, 153, 'Depreciações acumuladas - Equipamento básico', 'GA', 43),
(254, 438, 154, 'Depreciações acumuladas - Equipamento de transporte', 'GA', 43),
(255, 438, 155, 'Depreciações acumuladas - Equipamento administrativo', 'GA', 43),
(256, 438, 156, 'Depreciações acumuladas - Equipamentos biológicos', 'GA', 43),
(257, 438, 157, 'Depreciações acumuladas - Outros ativos fixos tangíveis', 'GA', 43),
(258, 44, 0, 'Ativos intangíveis', 'GR', 0),
(259, 441, 158, 'Goodwill', 'GA', 44),
(260, 442, 159, 'Projetos de desenvolvimento', 'GA', 44),
(261, 443, 160, 'Programas de computador', 'GA', 44),
(262, 444, 161, 'Propriedade industrial', 'GA', 44),
(263, 445, 162, 'Outros ativos fixos tangíveis', 'GA', 44),
(264, 446, 162, 'Outros ativos fixos tangíveis', 'GA', 44),
(265, 447, 162, 'Outros ativos fixos tangíveis', 'GA', 44),
(266, 448, 163, 'Amortizações acumuladas - Godwill', 'GA', 44),
(267, 448, 164, 'Amortizações acumuladas - Projetos de desenvolvimento', 'GA', 44),
(268, 448, 165, 'Amortizações acumuladas - Programas de computador', 'GA', 44),
(269, 448, 166, 'Amortizações acumuladas - Propriedade industrial', 'GA', 44),
(270, 448, 167, 'Amortizações acumuladas - Outros ativos intangíveis', 'GA', 44),
(271, 45, 0, 'Investimentos em curso', 'GR', 0),
(272, 451, 168, 'Investimentos financeiros em curso', 'GA', 45),
(273, 453, 169, 'Ativos fixos tangíveis em curso', 'GA', 45),
(274, 454, 170, 'Ativos intangíveis em curso', 'GA', 45),
(275, 455, 171, 'Adiantamentos por conta de investimentos - Investimentos financeiros em curso', 'GA', 45),
(276, 455, 172, 'Adiantamentos por conta de investimentos - Ativos fixos tangíveis em curso', 'GA', 45),
(277, 455, 173, 'Adiantamentos por conta de investimentos - Ativos intangíveis em curso', 'GA', 45),
(278, 51, 174, 'Capital subscrito', 'GR', 0),
(279, 52, 0, 'Acões (quotas) próprias', 'GR', 0),
(280, 521, 175, 'Valor nominal', 'GA', 52),
(281, 522, 176, 'Descontos e prémios', 'GA', 52),
(282, 53, 177, 'Outros instrumentos de capital próprio', 'GR', 0),
(283, 54, 178, 'Prémios de emissão', 'GR', 0),
(284, 55, 0, 'Reservas', 'GR', 0),
(285, 551, 179, 'Reservas legais', 'GA', 55),
(286, 552, 180, 'Reservas legais', 'GA', 55),
(287, 56, 181, 'Resultados transitados', 'GR', 0),
(288, 58, 0, 'Excedentes de revalorização de ativos fixos tangiveis e intangíveis', 'GR', 0),
(289, 581, 182, 'Reavaliações decorrentes de diplomas legais', 'GA', 58),
(290, 582, 183, 'Outros excedentes', 'GA', 58),
(291, 583, 183, 'Outros excedentes', 'GA', 58),
(292, 584, 183, 'Outros excedentes', 'GA', 58),
(293, 585, 183, 'Outros excedentes', 'GA', 58),
(294, 586, 183, 'Outros excedentes', 'GA', 58),
(295, 587, 183, 'Outros excedentes', 'GA', 58),
(296, 588, 183, 'Outros excedentes', 'GA', 58),
(297, 589, 183, 'Outros excedentes', 'GA', 58),
(298, 59, 0, 'Outras variações no capital próprio', 'GR', 0),
(299, 593, 0, 'Subsídios', 'GA', 59),
(300, 5931, 184, 'Subsídios atribuidos', 'GA', 593),
(301, 5932, 185, 'Ajustamentos em subsídios', 'GA', 593),
(302, 594, 186, 'Doações', 'GA', 59),
(303, 595, 187, 'Outras', 'GA', 59),
(304, 596, 187, 'Outras', 'GA', 59),
(305, 597, 187, 'Outras', 'GA', 59),
(306, 598, 187, 'Outras', 'GA', 59),
(307, 599, 187, 'Outras', 'GA', 59),
(308, 61, 0, 'Custo dos Investários vendidos e das matérias consumidas', 'GR', 0),
(309, 611, 188, 'Mercadorias', 'GA', 61),
(310, 612, 189, 'Matérias-primas, subsidiárias e de consumo', 'GA', 61),
(311, 62, 0, 'Fornecimentos e serviços externos', 'GR', 0),
(312, 621, 190, 'Subcontratos', 'GA', 62),
(313, 622, 191, 'Serviços especializados', 'GA', 62),
(314, 623, 192, 'Materiais', 'GA', 62),
(315, 624, 193, 'Energia e fluidos', 'GA', 62),
(316, 625, 194, 'Deslocações, estadas e transportes', 'GA', 62),
(317, 626, 195, 'Serviços diversos', 'GA', 62),
(318, 63, 0, 'Gastos com o pessoal', 'GR', 0),
(319, 631, 196, 'Remunerações dos orgãos sociais', 'GA', 63),
(320, 632, 197, 'Remunerações do pessoal', 'GA', 63),
(321, 634, 198, 'Indemnizações', 'GA', 63),
(322, 635, 199, 'Encargos sobre remunerações', 'GA', 63),
(323, 636, 200, 'Seguros de acidentes no trabalho e doenças profissionais', 'GA', 63),
(324, 637, 201, 'Gastos de ação social', 'GA', 63),
(325, 638, 202, 'Outros gastos com o pessoal', 'GA', 63),
(326, 64, 0, 'Gastos de depreciação e de amortização', 'GR', 0),
(327, 642, 203, 'Ativos fixos tangíveis - Terrenos e recursos naturais', 'GA', 64),
(328, 642, 204, 'Ativos fixos tangíveis - Edifícios e outras construções', 'GA', 64),
(329, 642, 205, 'Ativos fixos tangíveis - Equipamento básico', 'GA', 64),
(330, 642, 206, 'Ativos fixos tangíveis - Equipamento de transporte', 'GA', 64),
(331, 642, 207, 'Ativos fixos tangíveis - Equipamento administrativo', 'GA', 64),
(332, 642, 208, 'Ativos fixos tangíveis - Equipamentos biológicos', 'GA', 64),
(333, 642, 209, 'Ativos fixos tangíveis - Outros ativos fixos tangiveis', 'GA', 64),
(334, 643, 210, 'Ativos intangíveis - Goodwill', 'GA', 64),
(335, 643, 211, 'Ativos intangíveis - Projetos de desenvolvimento', 'GA', 64),
(336, 643, 212, 'Ativos intangíveis - Programas de computador', 'GA', 64),
(337, 643, 213, 'Ativos intangíveis - Propriedade industrial', 'GA', 64),
(338, 643, 214, 'Ativos intangíveis - Outros ativos intangíveis', 'GA', 64),
(339, 65, 215, 'Perdas por imparidade', 'GR', 0),
(340, 651, 0, 'Em dívidas a receber', 'GA', 65),
(341, 6511, 216, 'Clientes', 'GA', 651),
(342, 6512, 217, 'Outros devedores', 'GA', 651),
(343, 652, 218, 'Em Investários - Mercadorias', 'GA', 65),
(344, 652, 219, 'Em Investários - Matérias-primas, subsidiárias e de consumo', 'GA', 65),
(345, 652, 220, 'Em Investários - Produtos acabados e intermédios', 'GA', 65),
(346, 652, 221, 'Em Investários - Subprodutos, desperdícios, resíduos e refugos', 'GA', 65),
(347, 652, 222, 'Em Investários - Produtos e trabalhos em curso', 'GA', 65),
(348, 653, 223, 'Em investimentos financeiros - Participações de capital', 'GA', 65),
(349, 653, 224, 'Em investimentos financeiros - Empréstimos concedidos', 'GA', 65),
(350, 653, 225, 'Em investimentos financeiros - Outros investimentos financeiros', 'GA', 65),
(351, 653, 226, 'Em investimentos financeiros - Goodwill', 'GA', 65),
(352, 67, 0, 'Provisões do período', 'GR', 0),
(353, 671, 227, 'Impostos', 'GA', 67),
(354, 672, 228, 'Garantias a clientes', 'GA', 67),
(355, 673, 229, 'Processos judiciais em curso', 'GA', 67),
(356, 674, 230, 'Acidentes no trabalho e doenças profissionais', 'GA', 67),
(357, 678, 231, 'Outras provisões', 'GA', 67),
(358, 68, 0, 'Outros gastos', 'GR', 0),
(359, 681, 0, 'Impostos', 'GA', 68),
(360, 6811, 232, 'Impostos diretos', 'GA', 681),
(361, 6812, 233, 'Impostos diretos', 'GA', 681),
(362, 6813, 234, 'Taxas', 'GA', 681),
(363, 682, 235, 'Descontos a pronto pagamento concedidos', 'GA', 68),
(364, 683, 236, 'Dividas incobráveis', 'GA', 68),
(365, 684, 0, 'Perdas em inventários', 'GA', 68),
(366, 6841, 237, 'Sinistros', 'GA', 684),
(367, 6842, 238, 'Quebras', 'GA', 684),
(368, 6843, 239, 'Outras perdas', 'GA', 684),
(369, 6844, 239, 'Outras perdas', 'GA', 684),
(370, 6845, 239, 'Outras perdas', 'GA', 684),
(371, 6846, 239, 'Outras perdas', 'GA', 684),
(372, 6847, 239, 'Outras perdas', 'GA', 684),
(373, 6848, 239, 'Outras perdas', 'GA', 684),
(374, 686, 0, 'Gastos nos restantes investimentos financeiros', 'GA', 68),
(375, 6861, 240, 'Cobertura de prejuízos', 'GA', 686),
(376, 6862, 241, 'Alienações', 'GA', 686),
(377, 6863, 242, 'Diferenças entre câmbio desfavoráveis', 'GA', 686),
(378, 6864, 243, 'Outros gastos', 'GA', 686),
(379, 6865, 243, 'Outros gastos', 'GA', 686),
(380, 6866, 243, 'Outros gastos', 'GA', 686),
(381, 6867, 243, 'Outros gastos', 'GA', 686),
(382, 6868, 243, 'Outros gastos', 'GA', 686),
(383, 687, 0, 'Gastos em investimentos não financeiros', 'GA', 68),
(384, 6871, 244, 'Alienações', 'GA', 687),
(385, 6872, 245, 'Sinistros', 'GA', 687),
(386, 6873, 246, 'Abates', 'GA', 687),
(387, 6875, 247, 'Outros gastos', 'GA', 687),
(388, 6876, 247, 'Outros gastos', 'GA', 687),
(389, 6877, 247, 'Outros gastos', 'GA', 687),
(390, 6878, 247, 'Outros gastos', 'GA', 687),
(391, 688, 0, 'Outros', 'GA', 68),
(392, 6881, 248, 'Correções relativas a períodos anteriores', 'GA', 688),
(393, 6882, 249, 'Donativos', 'GA', 688),
(394, 6883, 250, 'Quotizações', 'GA', 688),
(395, 6884, 251, 'Ofertas e amostras de Investários', 'GA', 688),
(396, 6885, 252, 'Insuficiência da estimativa para impsotos', 'GA', 688),
(397, 6887, 253, 'Diferenças de câmbios desfavoráveis', 'GA', 688),
(398, 6888, 254, 'Outros não especificados', 'GA', 688),
(399, 69, 0, 'Gastos de financiamento', 'GR', 0),
(400, 691, 0, 'Juros suportados', 'GA', 69),
(401, 6911, 255, 'Juros de financiamento obtidos', 'GA', 691),
(402, 6912, 256, 'Outros juros', 'GA', 691),
(403, 6913, 256, 'Outros juros', 'GA', 691),
(404, 6914, 256, 'Outros juros', 'GA', 691),
(405, 6915, 256, 'Outros juros', 'GA', 691),
(406, 6916, 256, 'Outros juros', 'GA', 691),
(407, 6917, 256, 'Outros juros', 'GA', 691),
(408, 6918, 256, 'Outros juros', 'GA', 691),
(409, 692, 0, 'Diferenças de câmbio desfavoráveis', 'GA', 69),
(410, 6921, 257, 'Relativas a financiamentos obtidos', 'GA', 692),
(411, 6922, 258, 'Outras', 'GA', 692),
(412, 6923, 258, 'Outras', 'GA', 692),
(413, 6924, 258, 'Outras', 'GA', 692),
(414, 6925, 258, 'Outras', 'GA', 692),
(415, 6926, 258, 'Outras', 'GA', 692),
(416, 6927, 258, 'Outras', 'GA', 692),
(417, 6928, 258, 'Outras', 'GA', 692),
(418, 693, 259, 'Outros gastos de financiamento', 'GA', 69),
(419, 694, 259, 'Outros gastos de financiamento', 'GA', 69),
(420, 695, 259, 'Outros gastos de financiamento', 'GA', 69),
(421, 696, 259, 'Outros gastos de financiamento', 'GA', 69),
(422, 697, 259, 'Outros gastos de financiamento', 'GA', 69),
(423, 698, 0, 'Outros gastos de financiamento', 'GA', 69),
(424, 6981, 259, 'Relativos a financiamentos obtidos', 'GA', 698),
(425, 6982, 260, 'Outras', 'GA', 698),
(426, 6983, 260, 'Outras', 'GA', 698),
(427, 6984, 260, 'Outras', 'GA', 698),
(428, 6985, 260, 'Outras', 'GA', 698),
(429, 6986, 260, 'Outras', 'GA', 698),
(430, 6987, 260, 'Outras', 'GA', 698),
(431, 6988, 260, 'Outras', 'GA', 698),
(432, 71, 0, 'Vendas', 'GR', 0),
(433, 711, 261, 'Mercadorias', 'GA', 71),
(434, 712, 262, 'Produtos acabados e intermédios', 'GA', 71),
(435, 713, 263, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 71),
(436, 716, 264, 'IVA das vendas com imposto incluído', 'GA', 71),
(437, 717, 265, 'Devoluções de vendas', 'GA', 71),
(438, 718, 266, 'Descontos e abatimentos em vendas', 'GA', 71),
(439, 72, 0, 'Prestações de serviços', 'GR', 0),
(440, 721, 267, 'Serviço A', 'GA', 72),
(441, 722, 268, 'Serviço B', 'GA', 72),
(442, 723, 269, 'Outros serviços', 'GA', 72),
(443, 724, 269, 'Outros serviços', 'GA', 72),
(444, 725, 270, 'Serviços secundários', 'GA', 72),
(445, 726, 271, 'IVA dos serviços com imposto incluído', 'GA', 72),
(446, 727, 269, 'Outros serviços', 'GA', 72),
(447, 728, 272, 'Descontos e abatimentos', 'GA', 72),
(448, 73, 0, 'Variações nos investários ', 'GR', 0),
(449, 731, 273, 'Produtos acabados e intermédios', 'GA', 73),
(450, 732, 274, 'Subprodutos, desperdícios, resíduos e refugos', 'GA', 73),
(451, 733, 275, 'Produtos e trablhos em curso', 'GA', 73),
(452, 74, 0, 'Trabalhos para a própria entidade', 'GR', 0),
(453, 741, 276, 'Ativos fixos tangíveis', 'GA', 74),
(454, 742, 277, 'Ativos intangíveis', 'GA', 74),
(455, 744, 278, 'Ativos por gastos diferidos', 'GA', 74),
(456, 75, 0, 'Subsídios à exploração', 'GR', 0),
(457, 751, 279, 'Ativos por gastos diferidos', 'GA', 75),
(458, 752, 280, 'Subsídios de outras entidades', 'GA', 75),
(459, 76, 0, 'Reversões', 'GR', 0),
(460, 761, 0, 'De Depreciações e de amortizações', 'GA', 76),
(461, 7612, 281, 'Ativos fixos tangíveis - Terrenos e recursos naturais', 'GA', 761),
(462, 7612, 282, 'Ativos fixos tangíveis - Edifícios e outras construções', 'GA', 761),
(463, 7612, 283, 'Ativos fixos tangíveis - Equipamento básico', 'GA', 761),
(464, 7612, 284, 'Ativos fixos tangíveis - Equipamento de transporte', 'GA', 761),
(465, 7612, 285, 'Ativos fixos tangíveis - Equipamento administrativo', 'GA', 761),
(466, 7612, 286, 'Ativos fixos tangíveis - Equipamentos biológicos', 'GA', 761),
(467, 7612, 287, 'Ativos fixos tangíveis - Outros ativos fixos tangíveis', 'GA', 761),
(468, 7613, 288, 'Ativos intangíveis - Goodwill', 'GA', 761),
(469, 7613, 289, 'Ativos intangíveis - Projetos de desenvolvimento', 'GA', 761),
(470, 7613, 290, 'Ativos intangíveis - Programas de computador', 'GA', 761),
(471, 7613, 291, 'Ativos intangíveis - Propriedade industrial', 'GA', 761),
(472, 7613, 292, 'Ativos intangíveis - Outros ativos intangíveis', 'GA', 761),
(473, 76211, 293, 'Clientes', 'GA', 7621),
(474, 76212, 294, 'Outros devedores', 'GA', 7621),
(475, 7622, 295, 'Em inventários - Mercadorias', 'GA', 762),
(476, 7622, 296, 'Em inventários - Matérias-primas, subsidiárias e de consumo', 'GA', 762),
(477, 7622, 297, 'Em inventários - Produtos acabados e intermédios', 'GA', 762),
(478, 7622, 298, 'Em inventários - Subprodutos, desperdícios, resíduos e refugos', 'GA', 762),
(479, 7622, 299, 'Em inventários - Produtos e trabalhos em curso', 'GA', 762),
(480, 7623, 300, 'Em investimentos financeiros - Participações de capital', 'GA', 762),
(481, 7623, 301, 'Em investimentos financeiros - Empréstimos concedidos', 'GA', 762),
(482, 7623, 302, 'Em investimentos financeiros - Outros investimentos financeiros', 'GA', 762),
(483, 763, 0, 'De provisões', 'GA', 76),
(484, 7631, 303, 'Impostos', 'GA', 763),
(485, 7632, 304, 'Garantias a clientes', 'GA', 763),
(486, 7633, 305, 'Processos judiciais em curso', 'GA', 763),
(487, 7634, 306, 'Acidentes no trabalho e doenças profissionais', 'GA', 763),
(488, 78, 0, 'Outros rendimentos', 'GR', 0),
(489, 781, 307, 'Rendimentos suplementares', 'GA', 78),
(490, 782, 308, 'Desconto de pronto pagamento obtido', 'GA', 78),
(491, 783, 309, 'Recuperação de dívidas a receber', 'GA', 78),
(492, 784, 0, 'Ganhos em inventários', 'GA', 78),
(493, 7841, 310, 'Sinistros', 'GA', 784),
(494, 7842, 311, 'Sobras', 'GA', 784),
(495, 7843, 312, 'Outros ganhos', 'GA', 784),
(496, 7844, 312, 'Outros ganhos', 'GA', 784),
(497, 7845, 312, 'Outros ganhos', 'GA', 784),
(498, 7846, 312, 'Outros ganhos', 'GA', 784),
(499, 7847, 312, 'Outros ganhos', 'GA', 784),
(500, 7848, 312, 'Outros ganhos', 'GA', 784),
(501, 786, 0, 'Rendimentos nos restantes ativos financeiros', 'GA', 78),
(502, 7861, 313, 'Diferenças de câmbio favoráveis', 'GA', 786),
(503, 7862, 314, 'Alienações', 'GA', 786),
(504, 7863, 315, 'Outros rendimentos', 'GA', 786),
(505, 7864, 315, 'Outros rendimentos', 'GA', 786),
(506, 7865, 315, 'Outros rendimentos', 'GA', 786),
(507, 7866, 315, 'Outros rendimentos', 'GA', 786),
(508, 7867, 315, 'Outros rendimentos', 'GA', 786),
(509, 7868, 315, 'Outros rendimentos', 'GA', 786),
(510, 787, 0, 'Rendimentos em investimentos não financeiros', 'GA', 78),
(511, 7871, 316, 'Alienações', 'GA', 787),
(512, 7872, 317, 'Sinistros', 'GA', 787),
(513, 7874, 318, 'Outros rendimentos', 'GA', 787),
(514, 7875, 318, 'Outros rendimentos', 'GA', 787),
(515, 7876, 318, 'Outros rendimentos', 'GA', 787),
(516, 7877, 318, 'Outros rendimentos', 'GA', 787),
(517, 7878, 318, 'Outros rendimentos', 'GA', 787),
(518, 788, 0, 'Outros', 'GA', 78),
(519, 7881, 319, 'Correções relativas a períodos anteriores', 'GA', 788),
(520, 7882, 320, 'Excesso de estimativa para impostos', 'GA', 788),
(521, 7883, 321, 'Imputação de subsídios para investimentos', 'GA', 788),
(522, 7885, 322, 'Restituição de impostos', 'GA', 788),
(523, 7886, 324, 'Outros não especificados', 'GA', 788),
(524, 7887, 323, 'Diferenças de câmbio desfavoráveis', 'GA', 788),
(525, 7888, 324, 'Diferenças de câmbio desfavoráveis', 'GA', 788),
(526, 79, 0, 'Juros, dividendos e outros rendimentos similiares', 'GR', 0),
(527, 791, 0, 'Juros obtidos', 'GA', 79),
(528, 7911, 325, 'De depósitos', 'GA', 791),
(529, 7915, 326, 'De financiamentos obtidos', 'GA', 791),
(530, 7916, 327, 'Outros', 'GA', 791),
(531, 7917, 327, 'Outros', 'GA', 791),
(532, 7918, 327, 'Outros', 'GA', 791),
(533, 792, 328, 'Dividendos obtidos', 'GA', 79),
(534, 793, 329, 'Diferenças de câmbio favoráveis', 'GA', 79),
(535, 794, 330, 'Outros rendimentos similiares', 'GA', 79),
(536, 795, 330, 'Outros rendimentos similiares', 'GA', 79),
(537, 796, 330, 'Outros rendimentos similiares', 'GA', 79),
(538, 797, 330, 'Outros rendimentos similiares', 'GA', 79),
(539, 798, 330, 'Outros rendimentos similiares', 'GA', 79),
(540, 81, 0, 'Resultado líquido do período', 'GR', 0),
(541, 811, 331, 'Resultado antes de impsotos', 'GA', 81),
(542, 812, 0, 'Imposto sobre o rendimento do período', 'GA', 81),
(543, 8121, 332, 'Imposto estimado para o período', 'GA', 812),
(544, 818, 333, 'Resultado liquído', 'GA', 81),
(545, 89, 334, 'Dividendos antecipados', 'GR', 0);

CREATE TABLE `faturacao_unidades` (
  `ID_Unidade` int(10) UNSIGNED NOT NULL,
  `Descricao` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Sigla` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `faturacao_unidades` (`ID_Unidade`, `Descricao`, `Sigla`) VALUES
(1, 'Unité', 'UN'),
(2, 'Kilo', 'KG'),
(3, 'Métro', 'MT'),
(4, 'Kilomètre', 'KM'),
(5, 'Hour', 'HR'),
(6, 'Jour', 'JR'),
(7, 'Box', 'BX');

CREATE TABLE `faturacao_user_role` (
  `ID_Utilizador_Rel` bigint(30) UNSIGNED NOT NULL,
  `ID_Role_Rel` bigint(30) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_vendedores` (
  `ID_Vendedor` bigint(30) UNSIGNED NOT NULL,
  `Nome` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Contacto` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Codigo_Interno` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampVendedor` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `freguesia` (
  `ID_Freguesia` bigint(20) UNSIGNED NOT NULL,
  `ID_Concelho` int(11) NOT NULL,
  `Nome` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `freguesia` (`ID_Freguesia`, `ID_Concelho`, `Nome`) VALUES
(1, 1, 'Aguada de Cima'),
(2, 1, 'Fermentelos'),
(3, 1, 'Macinhata do Vouga'),
(4, 1, 'Valongo do Vouga'),
(5, 1, 'União das Freguesias de Águeda e Borralha'),
(6, 1, 'União das Freguesias de Barrô e Aguada de Baixo'),
(7, 1, 'União das Freguesias de Belazaima do Chão, Castanheira do Vouga e Agadão'),
(8, 1, 'União das Freguesias de Recardães e Espinhel'),
(9, 1, 'União das Freguesias de Travassô e Óis da Ribeira'),
(10, 1, 'União das Freguesias de Trofa, Segadães e Lamas do Vouga'),
(11, 1, 'União das Freguesias do Préstimo e Macieira de Alcoba'),
(12, 2, 'Alquerubim'),
(13, 2, 'Angeja'),
(14, 2, 'Branca'),
(15, 2, 'Ribeira de Fráguas'),
(16, 2, 'Albergaria-A-Velha e Valmaior'),
(17, 2, 'São João de Louro E Frossos'),
(18, 3, 'Avelãs de Caminho'),
(19, 3, 'Avelãs de Cima'),
(20, 3, 'Moita'),
(21, 3, 'Sangalhos'),
(22, 3, 'S. Lourenço do Bairro'),
(23, 3, 'Vila Nova de Monsarros'),
(24, 3, 'Vilarinho do Bairro'),
(25, 3, 'União das Freguesias de Amoreira da Gândara, Paredes do Bairro e Ancas'),
(26, 3, 'União das Freguesias de Arcos e Mogofores'),
(27, 3, 'União das Freguesias de Tamengos, Aguim e Óis do Bairro'),
(28, 4, 'Alvarenga'),
(29, 4, 'Chave'),
(30, 4, 'Escariz'),
(31, 4, 'Fermedo'),
(32, 4, 'Mansores'),
(33, 4, 'Moldes'),
(34, 4, 'Rossas'),
(35, 4, 'Santa Eulélia'),
(36, 4, 'S. Miguel Do Mato'),
(37, 4, 'Tropeço'),
(38, 4, 'Urro'),
(39, 4, 'Várzea'),
(40, 4, 'União das Freguesias de Arouca e Burgo'),
(41, 4, 'União das Freguesias de Cabreiros e Albergaria da Serra'),
(42, 4, 'União das Freguesias de Canelas e Espiunca'),
(43, 4, 'União das Freguesias de Covelo de Paivó e Janarde'),
(44, 5, 'Aradas'),
(45, 5, 'Cacia'),
(46, 5, 'Esgueira'),
(47, 5, 'Oliveirinha'),
(48, 5, 'S. Bernardo'),
(49, 5, 'S. Jacinto'),
(50, 5, 'Santa Joana'),
(51, 5, 'Eixo e Eirol'),
(52, 5, 'Requeixo, Nossa Senhora de Fátima e Nariz'),
(53, 5, 'União das Freguesias de Glória e Vera Cruz'),
(54, 6, 'Fornos'),
(55, 6, 'Real'),
(56, 6, 'Santa Maria de Sardoura'),
(57, 6, 'S. Martinho de Sardoura'),
(58, 6, 'União das Freguesias de Raiva, Pedorido e Paraíso'),
(59, 6, 'União das Freguesias de Sobrado e Bairros'),
(60, 7, 'Espinho'),
(61, 7, 'Paramos'),
(62, 7, 'Silvalde'),
(63, 7, 'União das Freguesias de Anta e Guetim'),
(64, 8, 'Avanca'),
(65, 8, 'Pardilho'),
(66, 8, 'Salreu'),
(67, 8, 'União das Freguesias de Beduído e Veiros'),
(68, 8, 'União das Freguesias de Canelas e Fermelã'),
(69, 9, 'Argoncilhe'),
(70, 9, 'Arrifana'),
(71, 9, 'Escapães'),
(72, 9, 'Fiães'),
(73, 9, 'Fornos'),
(74, 9, 'Lourosa'),
(75, 9, 'Milheiros de Poiares'),
(76, 9, 'Mozelos'),
(77, 9, 'Nogueira da Regedoura'),
(78, 9, 'S. Paio de Oleiros'),
(79, 9, 'Paços de Brandão'),
(80, 9, 'Rio Meão'),
(81, 9, 'Romariz'),
(82, 9, 'Sanguedo'),
(83, 9, 'Santa Maria de Lamas'),
(84, 9, 'S. João de Ver'),
(85, 9, 'União das Freguesias de Caldas de São Jorge e Pigeiros'),
(86, 9, 'União das Freguesias de Canedo, Vale e Vila Maior'),
(87, 9, 'União das Freguesias de Lobão, Gião, Louredo e Guisande'),
(88, 9, 'União das Freguesias de Santa Maria da Feira, Travanca, Sanfins e Espargo'),
(89, 9, 'União das Freguesias de São Miguel do Souto e Mosteirô'),
(90, 10, 'Gafanha da Encarnação'),
(91, 10, 'Gafanha da Nazaré'),
(92, 10, 'Gafanha do Carmo'),
(93, 10, 'Ílhavo (São Salvador)'),
(94, 11, 'Barcouço'),
(95, 11, 'Casal Comba'),
(96, 11, 'Luso'),
(97, 11, 'Pampilhosa'),
(98, 11, 'Vacariça'),
(99, 11, 'União das Freguesias da Mealhada, Ventosa do Bairro e Antes'),
(100, 12, 'Bunheiro'),
(101, 12, 'Monte'),
(102, 12, 'Murtosa'),
(103, 12, 'Torreira'),
(104, 13, 'Carregosa'),
(105, 13, 'Cesar'),
(106, 13, 'Fajões'),
(107, 13, 'Loureiro'),
(108, 13, 'Macieira de Sarnes'),
(109, 13, 'Ossela'),
(110, 13, 'S. Martinho da Gandara'),
(111, 13, 'São Roque'),
(112, 13, 'Vila de Cucujães'),
(113, 13, 'União das Freguesias de Nogueira do Cravo e Pindelo'),
(114, 13, 'União das Freguesias de Oliveira de Azeméis, Santiago de Riba-Ul, Ul, Macinhata da Seixa E Madail'),
(115, 13, 'União das Freguesias de Pinheiro da Bemposta, Travanca e Palmaz'),
(116, 14, 'Oiã'),
(117, 14, 'Oliveira do Bairro'),
(118, 14, 'Palhaça'),
(119, 14, 'União das Freguesias de Bustos, Troviscal e Mamarrosa'),
(120, 15, 'Cortegaça'),
(121, 15, 'Esmoriz'),
(122, 15, 'Maceda'),
(123, 15, 'Valega'),
(124, 15, 'União das Freguesias de Ovar, São João, Arada e São Vicente de Pereira Jusã'),
(125, 16, 'S. João da Madeira'),
(126, 17, 'Couto de Esteves'),
(127, 17, 'Pessegueiro do Vouga'),
(128, 17, 'Rocas do Vouga'),
(129, 17, 'Sever do Vouga'),
(130, 17, 'Talhadas'),
(131, 17, 'União das Freguesias de Cedrim e Paradela'),
(132, 17, 'União das Freguesias de Silva Escura e Dornelas'),
(133, 18, 'Calvão'),
(134, 18, 'Gafanha da Boa Hora'),
(135, 18, 'Ouca'),
(136, 18, 'Soza'),
(137, 18, 'Santo Andre de Vagos'),
(138, 18, 'União das Freguesias de Fonte de Angeão e Covão do Lobo'),
(139, 18, 'União das Freguesias de Ponte de Vagos e Santa Catarina'),
(140, 18, 'União das Freguesias de Vagos e Santo António'),
(141, 19, 'Arões'),
(142, 19, 'São Pedro de Castelões'),
(143, 19, 'Cepelos'),
(144, 19, 'Junqueira'),
(145, 19, 'Macieira de Cambra'),
(146, 19, 'Roge'),
(147, 19, 'União das Freguesias de Vila Chã, Codal e Vila Cova de Perrinho'),
(148, 20, 'Ervidel'),
(149, 20, 'Messejana'),
(150, 20, 'S. João de Negrilhos'),
(151, 20, 'União das Freguesias de Aljustrel e Rio de Moinhos'),
(152, 21, 'Rosario'),
(153, 21, 'Santa Cruz'),
(154, 21, 'S. Barnabe'),
(155, 21, 'Aldeia dos Fernandes'),
(156, 21, 'União das Freguesias de Almodôvar e Graça dos Padrões'),
(157, 21, 'União das Freguesias de Santa Clara-A-Nova e Gomes Aires'),
(158, 22, 'Alvito'),
(159, 22, 'Vila Nova da Baronia'),
(160, 23, 'Barrancos'),
(161, 24, 'Baleizão'),
(162, 24, 'Beringel'),
(163, 24, 'Cabeça Gorda'),
(164, 24, 'Nossa Senhora das Neves'),
(165, 24, 'Santa Clara de Louredo'),
(166, 24, 'S. Matias'),
(167, 24, 'União das Freguesias de Albernoa e Trindade'),
(168, 24, 'União das Freguesias de Beja (Salvador e Santa Maria da Feira)'),
(169, 24, 'União das Freguesias de Beja (Santiago Maior e São João Baptista)'),
(170, 24, 'União das Freguesias de Salvada e Quintos'),
(171, 24, 'União das Freguesias de Santa Vitória e Mombeja'),
(172, 24, 'União das Freguesias de Trigaches e São Brissos'),
(173, 25, 'Entradas'),
(174, 25, 'Santa Barbara de Padrões'),
(175, 25, 'S. Marcos da Ataboeira'),
(176, 25, 'União das Freguesias de Castro Verde e Casével'),
(177, 26, 'Cuba'),
(178, 26, 'Faro do Alentejo'),
(179, 26, 'Vila Alva'),
(180, 26, 'Vila Ruiva'),
(181, 27, 'Figueira dos Cavaleiros'),
(182, 27, 'Odivelas'),
(183, 27, 'União das Freguesias de Alfundão e Peroguarda'),
(184, 27, 'União das Freguesias de Ferreira do Alentejo e Canhestros'),
(185, 28, 'Alcaria Ruiva'),
(186, 28, 'Corte do Pinto'),
(187, 28, 'Espirito Santo'),
(188, 28, 'Mertola'),
(189, 28, 'Santana de Cambas'),
(190, 28, 'S. João dos Caldeireiros'),
(191, 28, 'União das Freguesias de São Miguel do Pinheiro, São Pedro de Solis e São Sebastião dos Carros'),
(192, 29, 'Amareleja'),
(193, 29, 'Povoa de São Miguel'),
(194, 29, 'Sobral da Adiça'),
(195, 29, 'União das Freguesias de Moura (Santo Agostinho e São João Baptista) e Santo Amador'),
(196, 29, 'União das Freguesias de Safara e Santo Aleixo da Restauração'),
(197, 30, 'Reliquias'),
(198, 30, 'Saboia'),
(199, 30, 'S. Luis'),
(200, 30, 'S. Martinho das Amoreiras'),
(201, 30, 'Vila Nova de Milfontes'),
(202, 30, 'Luzianes-Gare'),
(203, 30, 'Longueira/Almograve'),
(204, 30, 'Boavista Dos Pinheiros'),
(205, 30, 'Colos'),
(206, 30, 'Santa Clara-A-Velha'),
(207, 30, 'São Salvador e Santa Maria'),
(208, 30, 'São Teotónio'),
(209, 30, 'Vale de Santiago'),
(210, 31, 'Ourique'),
(211, 31, 'Santana da Serra'),
(212, 31, 'União das Freguesias de Garvão e Santa Luzia'),
(213, 31, 'União das Freguesias de Panoias e Conceição'),
(214, 32, 'Brinches'),
(215, 32, 'Pias'),
(216, 32, 'Vila Verde de Ficalho'),
(217, 32, 'União das Freguesias de Serpa (Salvador e Santa Maria)'),
(218, 32, 'União das Freguesias de Vila Nova de São Bento e Vale de Vargo'),
(219, 33, 'Pedrogão'),
(220, 33, 'Selmes'),
(221, 33, 'Vidigueira'),
(222, 33, 'Vila de Frades'),
(223, 34, 'Barreiros'),
(224, 34, 'Bico'),
(225, 34, 'Caires'),
(226, 34, 'Carrazedo'),
(227, 34, 'Dornelas'),
(228, 34, 'Fiscal'),
(229, 34, 'Goães'),
(230, 34, 'Lago'),
(231, 34, 'Rendufe'),
(232, 34, 'Bouro (Santa Maria)'),
(233, 34, 'Bouro (Santa Marta)'),
(234, 34, 'União das Freguesias de Amares e Figueiredo'),
(235, 34, 'União das Freguesias de Caldelas, Sequeiros e Paranhos'),
(236, 34, 'União das Freguesias de Ferreiros, Prozelo e Besteiros'),
(237, 34, 'União das Freguesias de Torre e Portela'),
(238, 34, 'União das Freguesias de Vilela, Seramil e Paredes Secas'),
(239, 35, 'Abade de Neiva'),
(240, 35, 'Aborim'),
(241, 35, 'Adães'),
(242, 35, 'Airo'),
(243, 35, 'Aldreu'),
(244, 35, 'Alvelos'),
(245, 35, 'Arcozelo'),
(246, 35, 'Areias'),
(247, 35, 'Balugães'),
(248, 35, 'Barcelinhos'),
(249, 35, 'Barqueiros'),
(250, 35, 'Cambeses'),
(251, 35, 'Carapeços'),
(252, 35, 'Carvalhal'),
(253, 35, 'Carvalhas'),
(254, 35, 'Cossourado'),
(255, 35, 'Cristelo'),
(256, 35, 'Fornelos'),
(257, 35, 'Fragoso'),
(258, 35, 'Gilmonde'),
(259, 35, 'Lama'),
(260, 35, 'Lijo'),
(261, 35, 'Macieira de Rates'),
(262, 35, 'Manhente'),
(263, 35, 'Martim'),
(264, 35, 'Moure'),
(265, 35, 'Oliveira'),
(266, 35, 'Palme'),
(267, 35, 'Panque'),
(268, 35, 'Paradela'),
(269, 35, 'Pereira'),
(270, 35, 'Perelhal'),
(271, 35, 'Pousa'),
(272, 35, 'Remelhe'),
(273, 35, 'Roriz'),
(274, 35, 'Rio Covo (Santa Eugenia)'),
(275, 35, 'Galegos (Santa Maria)'),
(276, 35, 'Galegos (S. Martinho)'),
(277, 35, 'Tamel (S. Verissimo)'),
(278, 35, 'Silva'),
(279, 35, 'Ucha'),
(280, 35, 'Varzea'),
(281, 35, 'Vila Seca'),
(282, 35, 'União das Freguesias de Alheira e Igreja Nova'),
(283, 35, 'União das Freguesias de Alvito (São Pedro e São Martinho) e Couto'),
(284, 35, 'União das Freguesias de Areias De Vilar e Encourados'),
(285, 35, 'União das Freguesias de Barcelos, Vila Boa e Vila Frescainha (São Martinho e São Pedro)'),
(286, 35, 'União das Freguesias de Campo e Tamel (São Pedro Fins)'),
(287, 35, 'União das Freguesias de Carreira e Fonte Coberta'),
(288, 35, 'União das Freguesias de Chorente, Góios, Courel, Pedra Furada e Gueral'),
(289, 35, 'União das Freguesias de Creixomil e Mariz'),
(290, 35, 'União das Freguesias de Durrães e Tregosa'),
(291, 35, 'União das Freguesias de Gamil e Midões'),
(292, 35, 'União das Freguesias de Milhazes, Vilar de Figos e Faria'),
(293, 35, 'União das Freguesias de Negreiros e Chavão'),
(294, 35, 'União das Freguesias de Quintiães e Aguiar'),
(295, 35, 'União das Freguesias de Sequeade e Bastuço (São João e Santo Estevão)'),
(296, 35, 'União das Freguesias de Silveiros e Rio Covo (Santa Eulália)'),
(297, 35, 'União das Freguesias de Tamel (Santa Leocádia) e Vilar do Monte'),
(298, 35, 'União das Freguesias de Viatodos, Grimancelos, Minhotães e Monte de Fralães'),
(299, 35, 'União das Freguesias de Vila Cova e Feitos'),
(300, 36, 'Adaufe'),
(301, 36, 'Espinho'),
(302, 36, 'Esporões'),
(303, 36, 'Figueiredo'),
(304, 36, 'Gualtar'),
(305, 36, 'Lama'),
(306, 36, 'Mire de Tibães'),
(307, 36, 'Padim da Graça'),
(308, 36, 'Palmeira'),
(309, 36, 'Pedralva'),
(310, 36, 'Priscos'),
(311, 36, 'Ruilhe'),
(312, 36, 'Braga (S. Vicente)'),
(313, 36, 'Braga (S. Vitor)'),
(314, 36, 'Sequeira'),
(315, 36, 'Sobreposta'),
(316, 36, 'Tadim'),
(317, 36, 'Tebosa'),
(318, 36, 'União das Freguesias de Arentim e Cunha'),
(319, 36, 'União das Freguesias de Braga (Maximinos, Sé e Cividade)'),
(320, 36, 'União das Freguesias de Braga (São José de São Lázaro e São João do Souto)'),
(321, 36, 'União das Freguesias de Cabreiros e Passos (São Julião)'),
(322, 36, 'União das Freguesias de Celeirós, Aveleda e Vimieiro'),
(323, 36, 'União das Freguesias de Crespos e Pousada'),
(324, 36, 'União das Freguesias de Escudeiros e Penso (Santo Estêvão e São Vicente)'),
(325, 36, 'União das Freguesias de Este (São Pedro e São Mamede)'),
(326, 36, 'União das Freguesias de Ferreiros e Gondizalves'),
(327, 36, 'União das Freguesias de Guisande e Oliveira (São Pedro)'),
(328, 36, 'União das Freguesias de Lomar e Arcos'),
(329, 36, 'União das Freguesias de Merelim (São Paio), Panoias e Parada De Tibães'),
(330, 36, 'União das Freguesias de Merelim (São Pedro) e Frossos'),
(331, 36, 'União das Freguesias de Morreira e Trandeiras'),
(332, 36, 'União das Freguesias de Nogueira, Fraião e Lamaçães'),
(333, 36, 'União das Freguesias de Nogueiró e Tenões'),
(334, 36, 'União das Freguesias de Real, Dume e Semelhe'),
(335, 36, 'União das Freguesias de Santa Lucrécia de Algeriz e Navarra'),
(336, 36, 'União das Freguesias de Vilaça e Fradelos'),
(337, 37, 'Abadim'),
(338, 37, 'Basto'),
(339, 37, 'Bucos'),
(340, 37, 'Cabeceiras de Basto'),
(341, 37, 'Cavez'),
(342, 37, 'Faia'),
(343, 37, 'Pedraça'),
(344, 37, 'Rio Douro'),
(345, 37, 'União das Freguesias de Alvite e Passos'),
(346, 37, 'União das Freguesias de Arco De Baúlhe e Vila Nune'),
(347, 37, 'União das Freguesias de Gondiães e Vilar de Cunhas'),
(348, 37, 'União das Freguesias de Refojos de Basto, Outeiro e Painzela'),
(349, 38, 'Agilde'),
(350, 38, 'Arnoia'),
(351, 38, 'Borba da Montanha'),
(352, 38, 'Codeçoso'),
(353, 38, 'Fervença'),
(354, 38, 'Moreira do Castelo'),
(355, 38, 'Rego'),
(356, 38, 'Ribas'),
(357, 38, 'Basto (S. Clemente)'),
(358, 38, 'Vale De Bouro'),
(359, 38, 'União das Freguesias de Britelo, Gémeos e Ourilhe'),
(360, 38, 'União das Freguesias de Caçarilhe e Infesta'),
(361, 38, 'União das Freguesias de Canedo de Basto e Corgo'),
(362, 38, 'União das Freguesias de Carvalho e Basto (Santa Tecla)'),
(363, 38, 'União das Freguesias de Veade, Gagos e Molares'),
(364, 39, 'Antas'),
(365, 39, 'Forjães'),
(366, 39, 'Gemeses'),
(367, 39, 'Vila Chã'),
(368, 39, 'União das Freguesias de Apúlia e Fão'),
(369, 39, 'União das Freguesias de Belinho e Mar'),
(370, 39, 'União das Freguesias de Esposende, Marinhas e Gandra'),
(371, 39, 'União das Freguesias de Fonte Boa e Rio Tinto'),
(372, 39, 'União das Freguesias de Palmeira de Faro e Curvos'),
(373, 40, 'Armil'),
(374, 40, 'Estorãos'),
(375, 40, 'Fafe'),
(376, 40, 'Fornelos'),
(377, 40, 'Golães'),
(378, 40, 'Medelo'),
(379, 40, 'Passos'),
(380, 40, 'Quinchães'),
(381, 40, 'Regadas'),
(382, 40, 'Revelhe'),
(383, 40, 'Ribeiros'),
(384, 40, 'Arões (Santa Cristina)'),
(385, 40, 'S. Gens'),
(386, 40, 'Silvares (S. Martinho)'),
(387, 40, 'Arões (S. Romão)'),
(388, 40, 'Travassos'),
(389, 40, 'Vinhos'),
(390, 40, 'União de Freguesias de Aboim, Felgueiras, Gontim e Pedraído'),
(391, 40, 'União de Freguesias de Agrela e Serafão'),
(392, 40, 'União de Freguesias de Antime e Silvares (São Clemente)'),
(393, 40, 'União de Freguesias de Ardegão, Arnozela e Seidões'),
(394, 40, 'União de Freguesias de Cepães e Fareja'),
(395, 40, 'União de Freguesias de Freitas e Vila Cova'),
(396, 40, 'União de Freguesias de Monte e Queimadela'),
(397, 40, 'União de Freguesias de Moreira do Rei e Várzea Cova'),
(398, 41, 'Aldão'),
(399, 41, 'Azurem'),
(400, 41, 'Barco'),
(401, 41, 'Brito'),
(402, 41, 'Caldelas'),
(403, 41, 'Costa'),
(404, 41, 'Creixomil'),
(405, 41, 'Fermentões'),
(406, 41, 'Gonça'),
(407, 41, 'Gondar'),
(408, 41, 'Guardizela'),
(409, 41, 'Infantas'),
(410, 41, 'Longos'),
(411, 41, 'Lordelo'),
(412, 41, 'Mesão Frio'),
(413, 41, 'Moreira de Conegos'),
(414, 41, 'Nespereira'),
(415, 41, 'Pencelo'),
(416, 41, 'Pinheiro'),
(417, 41, 'Polvoreira'),
(418, 41, 'Ponte'),
(419, 41, 'Ronfe'),
(420, 41, 'Prazins (Santa Eufemia)'),
(421, 41, 'Selho (S. Cristovão)'),
(422, 41, 'Selho (S. Jorge)'),
(423, 41, 'Candoso (S. Martinho)'),
(424, 41, 'Sande (S. Martinho)'),
(425, 41, 'S. Torcato'),
(426, 41, 'Serzedelo'),
(427, 41, 'Silvares'),
(428, 41, 'Urgezes'),
(429, 41, 'União das Freguesias de Abação e Gémeos'),
(430, 41, 'União das Freguesias de Airão Santa Maria, Airão São João e Vermil'),
(431, 41, 'União das Freguesias de Arosa e Castelões'),
(432, 41, 'União das Freguesias de Atães e Rendufe'),
(433, 41, 'União das Freguesias de Briteiros Santo Estêvão e Donim'),
(434, 41, 'União das Freguesias de Briteiros São Salvador e Briteiros Santa Leocádia'),
(435, 41, 'União das Freguesias de Candoso São Tiago e Mascotelos'),
(436, 41, 'União das Freguesias de Conde e Gandarela'),
(437, 41, 'União das Freguesias de Leitões, Oleiros e Figueiredo'),
(438, 41, 'União das Freguesias de Oliveira, São Paio e São Sebastião'),
(439, 41, 'União das Freguesias de Prazins Santo Tirso e Corvite'),
(440, 41, 'União das Freguesias de Sande São Lourenço e Balazar'),
(441, 41, 'União das Freguesias de Sande Vila Nova e Sande São Clemente'),
(442, 41, 'União das Freguesias de Selho São Lourenço e Gominhães'),
(443, 41, 'União das Freguesias de Serzedo e Calvos'),
(444, 41, 'União das Freguesias de Souto Santa Maria, Souto São Salvador e Gondomar'),
(445, 41, 'União das Freguesias de Tabuadelo e São Faustino'),
(446, 42, 'Covelas'),
(447, 42, 'Ferreiros'),
(448, 42, 'Galegos'),
(449, 42, 'Garfe'),
(450, 42, 'Geraz do Minho'),
(451, 42, 'Lanhoso'),
(452, 42, 'Monsul'),
(453, 42, 'Povoa de Lanhoso (N. Senhora do Amparo)'),
(454, 42, 'Rendufinho'),
(455, 42, 'Santo Emilião'),
(456, 42, 'S. João de Rei'),
(457, 42, 'Serzedelo'),
(458, 42, 'Sobradelo da Goma'),
(459, 42, 'Taide'),
(460, 42, 'Travassos'),
(461, 42, 'Vilela'),
(462, 42, 'União das Freguesias de Águas Santas e Moure'),
(463, 42, 'União das Freguesias de Calvos e Frades'),
(464, 42, 'União das Freguesias de Campos e Louredo'),
(465, 42, 'União das Freguesias de Esperança e Brunhais'),
(466, 42, 'União das Freguesias de Fonte Arcada e Oliveira'),
(467, 42, 'União das Freguesias de Verim, Friande e Ajude'),
(468, 43, 'Balança'),
(469, 43, 'Campo do Geres'),
(470, 43, 'Carvalheira'),
(471, 43, 'Covide'),
(472, 43, 'Gondoriz'),
(473, 43, 'Moimenta'),
(474, 43, 'Ribeira'),
(475, 43, 'Rio Caldo'),
(476, 43, 'Souto'),
(477, 43, 'Valdosende'),
(478, 43, 'Vilar da Veiga'),
(479, 43, 'União das Freguesias de Chamoim e Vilar'),
(480, 43, 'União das Freguesias de Chorense e Monte'),
(481, 43, 'União das Freguesias de Cibões e Brufe'),
(482, 44, 'Cantelães'),
(483, 44, 'Eira Vedra'),
(484, 44, 'Guilhofrei'),
(485, 44, 'Louredo'),
(486, 44, 'Mosteiro'),
(487, 44, 'Parada do Bouro'),
(488, 44, 'Pinheiro'),
(489, 44, 'Rossas'),
(490, 44, 'Salamonde'),
(491, 44, 'Tabuaças'),
(492, 44, 'Vieira do Minho'),
(493, 44, 'União das Freguesias de Anissó e Soutelo'),
(494, 44, 'União das Freguesias de Anjos e Vilar do Chão'),
(495, 44, 'União das Freguesias de Caniçada e Soengas'),
(496, 44, 'União das Freguesias de Ruivães e Campos'),
(497, 44, 'União das Freguesias de Ventosa e Cova'),
(498, 45, 'Bairro'),
(499, 45, 'Brufe'),
(500, 45, 'Castelões'),
(501, 45, 'Cruz'),
(502, 45, 'Delães'),
(503, 45, 'Fradelos'),
(504, 45, 'Gavião'),
(505, 45, 'Joane'),
(506, 45, 'Landim'),
(507, 45, 'Louro'),
(508, 45, 'Lousado'),
(509, 45, 'Mogege'),
(510, 45, 'Nine'),
(511, 45, 'Pedome'),
(512, 45, 'Pousada de Saramagos'),
(513, 45, 'Requião'),
(514, 45, 'Riba De Ave'),
(515, 45, 'Ribeirão'),
(516, 45, 'Oliveira (Santa Maria)'),
(517, 45, 'Vale (S. Martinho)'),
(518, 45, 'Oliveira (S. Mateus)'),
(519, 45, 'Vermoim'),
(520, 45, 'Vilarinho das Cambas'),
(521, 45, 'União das Freguesias de Antas E Abade De Vermoim'),
(522, 45, 'União das Freguesias de Arnoso (Santa Maria e Santa Eulália) e Sezures'),
(523, 45, 'União das Freguesias de Avidos e Lagoa'),
(524, 45, 'União das Freguesias de Carreira e Bente'),
(525, 45, 'União das Freguesias de Esmeriz e Cabeçudos'),
(526, 45, 'União das Freguesias de Gondifelos, Cavalões e Outiz'),
(527, 45, 'União das Freguesias de Lemenhe, Mouquim e Jesufrei'),
(528, 45, 'União das Freguesias de Ruivães e Novais'),
(529, 45, 'União das Freguesias de Seide'),
(530, 45, 'União das Freguesias de Vale (São Cosme), Telhado e Portela'),
(531, 45, 'União das Freguesias de Vila Nova de Famalicão e Calendário'),
(532, 46, 'Atiães'),
(533, 46, 'Cabanelas'),
(534, 46, 'Cervães'),
(535, 46, 'Coucieiro'),
(536, 46, 'Dossãos'),
(537, 46, 'Freiriz'),
(538, 46, 'Gême'),
(539, 46, 'Lage'),
(540, 46, 'Lanhas'),
(541, 46, 'Loureira'),
(542, 46, 'Moure'),
(543, 46, 'Oleiros'),
(544, 46, 'Parada de Gatim'),
(545, 46, 'Pico'),
(546, 46, 'Ponte'),
(547, 46, 'Sabariz'),
(548, 46, 'Vila de Prado'),
(549, 46, 'Prado (S. Miguel)'),
(550, 46, 'Soutelo'),
(551, 46, 'Turiz'),
(552, 46, 'Valdreu'),
(553, 46, 'Aboim da Nóbrega e Gondomar'),
(554, 46, 'União das Freguesias da Ribeira do Neiva'),
(555, 46, 'União das Freguesias de Carreiras (São Miguel) e Carreiras (Santiago)'),
(556, 46, 'União das Freguesias de Escariz (São Mamede) e Escariz (São Martinho)'),
(557, 46, 'União das Freguesias de Esqueiros, Nevogilde e Travassós'),
(558, 46, 'União das Freguesias de Marrancos e Arcozelo'),
(559, 46, 'União das Freguesias de Oriz (Santa Marinha) e Oriz (São Miguel)'),
(560, 46, 'União das Freguesias de Pico De Regalados, Gondiães e Mós'),
(561, 46, 'União das Freguesias de Sande, Vilarinho, Barros e Gomide'),
(562, 46, 'União das Freguesias de Valbom (São Pedro), Passô e Valbom (São Martinho)'),
(563, 46, 'União das Freguesias do Vade'),
(564, 46, 'Vila Verde e Barbudo'),
(565, 47, 'Infias'),
(566, 47, 'Santa Eulália'),
(567, 47, 'Santo Adrião de Vizela'),
(568, 47, 'União das Freguesias de Caldas de Vizela (São Miguel e São João)'),
(569, 47, 'União das Freguesias de Tagilde e Vizela (São Paio)'),
(570, 48, 'Alfandega da Fé'),
(571, 48, 'Cerejais'),
(572, 48, 'Sambade'),
(573, 48, 'Vilar Chão'),
(574, 48, 'Vilarelhos'),
(575, 48, 'Vilares de Vilariça'),
(576, 48, 'União das Freguesias de Agrobom, Saldonha e Vale Pereiro'),
(577, 48, 'União das Freguesias de Eucisia, Gouveia e Valverde'),
(578, 48, 'União das Freguesias de Ferradosa e Sendim da Serra'),
(579, 48, 'União das Freguesias de Gebelim e Soeima'),
(580, 48, 'União das Freguesias de Parada e Sendim da Ribeira'),
(581, 48, 'União das Freguesias de Pombal e Vales'),
(582, 49, 'Alfaião'),
(583, 49, 'Babe'),
(584, 49, 'Baçal'),
(585, 49, 'Carragosa'),
(586, 49, 'Castro de Avelãs'),
(587, 49, 'Coelhoso'),
(588, 49, 'Donai'),
(589, 49, 'Espinhosela'),
(590, 49, 'França'),
(591, 49, 'Gimonde'),
(592, 49, 'Gondesende'),
(593, 49, 'Gostei'),
(594, 49, 'Grijo de Parada'),
(595, 49, 'Macedo do Mato'),
(596, 49, 'Mos'),
(597, 49, 'Nogueira'),
(598, 49, 'Outeiro'),
(599, 49, 'Paramio'),
(600, 49, 'Pinela'),
(601, 49, 'Quintanilha'),
(602, 49, 'Quintela de Lampaças'),
(603, 49, 'Rabal'),
(604, 49, 'Rebordãos'),
(605, 49, 'Salsas'),
(606, 49, 'Samil'),
(607, 49, 'Santa Comba de Rossas'),
(608, 49, 'S. Pedro de Serracenos'),
(609, 49, 'Sendas'),
(610, 49, 'Serapicos'),
(611, 49, 'Sortes'),
(612, 49, 'Zoio'),
(613, 49, 'União das Freguesias de Aveleda e Rio de Onor'),
(614, 49, 'União das Freguesias de Castrelos e Carrazedo'),
(615, 49, 'União das Freguesias de Izeda, Calvelhe e Paradinha Nova'),
(616, 49, 'União das Freguesias de Parada e Faílde'),
(617, 49, 'União das Freguesias de Rebordainhos e Pombares'),
(618, 49, 'União das Freguesias de Rio Frio e Milhão'),
(619, 49, 'União das Freguesias de São Julião de Palácios e Deilão'),
(620, 49, 'União das Freguesias de Sé, Santa Maria e Meixedo'),
(621, 50, 'Carrazeda de Ansiães'),
(622, 50, 'Fonte Longa'),
(623, 50, 'Linhares'),
(624, 50, 'Marzagão'),
(625, 50, 'Parambos'),
(626, 50, 'Pereiros'),
(627, 50, 'Pinhal do Norte'),
(628, 50, 'Pombal'),
(629, 50, 'Seixo de Ansiães'),
(630, 50, 'Vilarinho da Castanheira'),
(631, 50, 'União das Freguesias de Amedo e Zedes'),
(632, 50, 'União das Freguesias de Belver e Mogo de Malta'),
(633, 50, 'União das Freguesias de Castanheiro do Norte e Ribalonga'),
(634, 50, 'União das Freguesias de Lavandeira, Beira Grande e Selores'),
(635, 51, 'Ligares'),
(636, 51, 'Poiares'),
(637, 51, 'União das Freguesias de Freixo de Espada À Cinta e Mazouco'),
(638, 51, 'União das Freguesias de Lagoaça e Fornos'),
(639, 52, 'Amendoeira'),
(640, 52, 'Arcas'),
(641, 52, 'Carrapatas'),
(642, 52, 'Chacim'),
(643, 52, 'Cortiços'),
(644, 52, 'Corujas'),
(645, 52, 'Ferreira'),
(646, 52, 'Grijo'),
(647, 52, 'Lagoa'),
(648, 52, 'Lamalonga'),
(649, 52, 'Lamas'),
(650, 52, 'Lombo'),
(651, 52, 'Macedo de Cavaleiros'),
(652, 52, 'Morais'),
(653, 52, 'Olmos'),
(654, 52, 'Peredo'),
(655, 52, 'Salselas'),
(656, 52, 'Sezulfe'),
(657, 52, 'Talhas'),
(658, 52, 'Vale Benfeito'),
(659, 52, 'Vale da Porca'),
(660, 52, 'Vale de Prados'),
(661, 52, 'Vilarinho de Agrochão'),
(662, 52, 'Vinhas'),
(663, 52, 'União das Freguesias de Ala e Vilarinho do Monte'),
(664, 52, 'União das Freguesias de Bornes e Burga'),
(665, 52, 'União das Freguesias de Castelãos e Vilar do Monte'),
(666, 52, 'União das Freguesias de Espadanedo, Edroso, Murçós e Soutelo Mourisco'),
(667, 52, 'União das Freguesias de Podence e Santa Combinha'),
(668, 52, 'União das Freguesias de Talhinhas e Bagueixe'),
(669, 53, 'Duas Igrejas'),
(670, 53, 'Genisio'),
(671, 53, 'Malhadas'),
(672, 53, 'Miranda do Douro'),
(673, 53, 'Palaçoulo'),
(674, 53, 'Picote'),
(675, 53, 'Povoa'),
(676, 53, 'S. Martinho de Angueira'),
(677, 53, 'Vila Chã de Braciosa'),
(678, 53, 'União das Freguesias de Constantim e Cicouro'),
(679, 53, 'União das Freguesias de Ifanes e Paradela'),
(680, 53, 'União das Freguesias de Sendim e Atenor'),
(681, 53, 'União das Freguesias de Silva e Águas Vivas'),
(682, 54, 'Abambres'),
(683, 54, 'Abreiro'),
(684, 54, 'Aguieiras'),
(685, 54, 'Alvites'),
(686, 54, 'Bouça'),
(687, 54, 'Cabanelas'),
(688, 54, 'Caravelas'),
(689, 54, 'Carvalhais'),
(690, 54, 'Cedães'),
(691, 54, 'Cobro'),
(692, 54, 'Fradizela'),
(693, 54, 'Frechas'),
(694, 54, 'Lamas de Orelhão'),
(695, 54, 'Mascarenhas'),
(696, 54, 'Mirandela'),
(697, 54, 'Murias'),
(698, 54, 'Passos'),
(699, 54, 'S. Pedro Velho'),
(700, 54, 'S. Salvador'),
(701, 54, 'Suçães'),
(702, 54, 'Torre de D. Chama'),
(703, 54, 'Vale de Asnes'),
(704, 54, 'Vale de Gouvinhas'),
(705, 54, 'Vale de Salgueiro'),
(706, 54, 'Vale de Telhas'),
(707, 54, 'União das Freguesias de Avantos e Romeu'),
(708, 54, 'União das Freguesias de Avidagos, Navalho e Pereira'),
(709, 54, 'União das Freguesias de Barcel, Marmelos e Valverde da Gestosa'),
(710, 54, 'União das Freguesias de Franco e Vila Boa'),
(711, 54, 'União das Freguesias de Freixeda e Vila Verde'),
(712, 55, 'Azinhoso'),
(713, 55, 'Bemposta'),
(714, 55, 'Bruço'),
(715, 55, 'Brunhoso'),
(716, 55, 'Castelo Branco'),
(717, 55, 'Castro Vicente'),
(718, 55, 'Meirinhos'),
(719, 55, 'Paradela'),
(720, 55, 'Penas Roias'),
(721, 55, 'Peredo da Bemposta'),
(722, 55, 'Saldanha'),
(723, 55, 'S. Martinho do Peso'),
(724, 55, 'To'),
(725, 55, 'Travanca'),
(726, 55, 'Urros'),
(727, 55, 'Vale da Madre'),
(728, 55, 'Vila de Ala'),
(729, 55, 'União das Freguesias de Brunhozinho, Castanheira e Sanhoane'),
(730, 55, 'União das Freguesias de Mogadouro, Valverde, Vale De Porco e Vilar De Rei'),
(731, 55, 'União das Freguesias de Remondes e Soutelo'),
(732, 55, 'União das Freguesias de Vilarinho dos Galegos e Ventozelo'),
(733, 56, 'Açoreira'),
(734, 56, 'Cabeça Boa'),
(735, 56, 'Carviçais'),
(736, 56, 'Castedo'),
(737, 56, 'Horta da Vilariça'),
(738, 56, 'Larinho'),
(739, 56, 'Lousa'),
(740, 56, 'Mos'),
(741, 56, 'Torre de Moncorvo'),
(742, 56, 'União das Freguesias de Adeganha e Cardanha'),
(743, 56, 'União das Freguesias de Felgar e Souto da Velha'),
(744, 56, 'União das Freguesias de Felgueiras e Maçores'),
(745, 56, 'União das Freguesias de Urros e Peredo dos Castelhanos'),
(746, 57, 'Benlhevai'),
(747, 57, 'Freixiel'),
(748, 57, 'Roios'),
(749, 57, 'Samões'),
(750, 57, 'Sampaio'),
(751, 57, 'Santa Comba de Vilariça'),
(752, 57, 'Seixo de Manhoses'),
(753, 57, 'Trindade'),
(754, 57, 'Vale Frechoso'),
(755, 57, 'União das Freguesias de Assares e Lodões'),
(756, 57, 'União das Freguesias de Candoso e Carvalho de Egas'),
(757, 57, 'União das Freguesias de Valtorno e Mourão'),
(758, 57, 'União das Freguesias de Vila Flor e Nabo'),
(759, 57, 'União das Freguesias de Vilas Boas e Vilarinho das Azenhas'),
(760, 58, 'Argozelo'),
(761, 58, 'Carção'),
(762, 58, 'Matela'),
(763, 58, 'Pinelo'),
(764, 58, 'Santulhão'),
(765, 58, 'Vilar Seco'),
(766, 58, 'Vimioso'),
(767, 58, 'União das Freguesias de Algoso, Campo de Víboras e Uva'),
(768, 58, 'União das Freguesias de Caçarelhos e Angueira'),
(769, 58, 'União das Freguesias de Vale de Frades e Avelanoso'),
(770, 59, 'Agrochão'),
(771, 59, 'Candedo'),
(772, 59, 'Celas'),
(773, 59, 'Edral'),
(774, 59, 'Edrosa'),
(775, 59, 'Ervedosa'),
(776, 59, 'Paço'),
(777, 59, 'Penhas Juntas'),
(778, 59, 'Rebordelo'),
(779, 59, 'Santalha'),
(780, 59, 'Tuizelo'),
(781, 59, 'Vale das Fontes'),
(782, 59, 'Vila Boa de Ousilhão'),
(783, 59, 'Vila Verde'),
(784, 59, 'Vilar de Ossos'),
(785, 59, 'Vilar de Peregrinos'),
(786, 59, 'Vilar Seco de Lomba'),
(787, 59, 'Vinhais'),
(788, 59, 'União das Freguesias de Curopos e Vale de Janeiro'),
(789, 59, 'União das Freguesias de Moimenta e Montouto'),
(790, 59, 'União das Freguesias de Nunes e Ousilhão'),
(791, 59, 'União das Freguesias de Quirás e Pinheiro Novo'),
(792, 59, 'União das Freguesias de Sobreiro de Baixo e Alvaredos'),
(793, 59, 'União das Freguesias de Soeira, Fresulfe e Mofreita'),
(794, 59, 'União das Freguesias de Travanca e Santa Cruz'),
(795, 59, 'União das Freguesias de Vilar de Lomba e São Jomil'),
(796, 60, 'Caria'),
(797, 60, 'Inguias'),
(798, 60, 'Maçainhas'),
(799, 60, 'União das Freguesias de Belmonte e Colmeal da Torre'),
(800, 61, 'Alcains'),
(801, 61, 'Almaceda'),
(802, 61, 'Benquerenças'),
(803, 61, 'Castelo Branco'),
(804, 61, 'Lardosa'),
(805, 61, 'Louriçal do Campo'),
(806, 61, 'Malpica do Tejo'),
(807, 61, 'Monforte da Beira'),
(808, 61, 'Salgueiro do Campo'),
(809, 61, 'Santo Andre das Tojeiras'),
(810, 61, 'S. Vicente da Beira'),
(811, 61, 'Sarzedas'),
(812, 61, 'Tinalhas'),
(813, 61, 'União das Freguesias de Cebolais de Cima e Retaxo'),
(814, 6, 'União das Freguesias de Escalos de Baixo e Mata'),
(815, 61, 'União das Freguesias de Escalos de Cima e Lousa'),
(816, 61, 'União das Freguesias de Freixial e Juncal do Campo'),
(817, 61, 'União das Freguesias de Ninho do Açor e Sobral do Campo'),
(818, 61, 'União das Freguesias de Póvoa de Rio de Moinhos e Cafede'),
(819, 62, 'Aldeia De S. Francisco de Assis'),
(820, 62, 'Boidobra'),
(821, 62, 'Cortes do Meio'),
(822, 62, 'Dominguizo'),
(823, 62, 'Erada'),
(824, 62, 'Ferro'),
(825, 62, 'Orjais'),
(826, 62, 'Paul'),
(827, 62, 'Peraboa'),
(828, 62, 'S. Jorge da Beira'),
(829, 62, 'Sobral de S. Miguel'),
(830, 62, 'Tortosendo'),
(831, 62, 'Unhais da Serra'),
(832, 62, 'Verdelhos'),
(833, 62, 'União das Freguesias de Barco e Coutada'),
(834, 62, 'União das Freguesias de Cantar-Galo e Vila do Carvalho'),
(835, 62, 'União das Freguesias de Casegas e Ourondo'),
(836, 62, 'União das Freguesias de Covilhã e Canhoso'),
(837, 62, 'União das Freguesias de Peso e Vales do Rio'),
(838, 62, 'União das Freguesias de Teixoso e Sarzedo'),
(839, 62, 'União das Freguesias de Vale Formoso e Aldeia do Souto'),
(840, 63, 'Alcaide'),
(841, 63, 'Alcaria'),
(842, 63, 'Alcongosta'),
(843, 63, 'Alpedrinha'),
(844, 63, 'Barroca'),
(845, 63, 'Bogas de Cima'),
(846, 63, 'Capinha'),
(847, 63, 'Castelejo'),
(848, 63, 'Castelo Novo'),
(849, 63, 'Fatela'),
(850, 63, 'Lavacolhos'),
(851, 63, 'Orca'),
(852, 63, 'Pero Viseu'),
(853, 63, 'Silvares'),
(854, 63, 'Soalheira'),
(855, 63, 'Souto da Casa'),
(856, 63, 'Telhado'),
(857, 63, 'Enxames'),
(858, 63, 'Três Povos'),
(859, 63, 'União das Freguesias de Janeiro de Cima e Bogas dDe Baixo'),
(860, 63, 'União das Freguesias de Fundão, Valverde, Donas, Aldeia de Joanes e Aldeia Nova do Cabo'),
(861, 63, 'União das Freguesias de Póvoa de Atalaia e Atalaia do Campo'),
(862, 63, 'União das Freguesias de Vale de Prazeres e Mata da Rainha'),
(863, 64, 'Aldeia de Santa Margarida'),
(864, 64, 'Ladoeiro'),
(865, 64, 'Medelim'),
(866, 64, 'Oledo'),
(867, 64, 'Penha Garcia'),
(868, 64, 'Proença-A-Velha'),
(869, 64, 'Rosmaninhal'),
(870, 64, 'S. Miguel de Acha'),
(871, 64, 'Toulões'),
(872, 64, 'União das Freguesias de Idanha-A-Nova e Alcafozes'),
(873, 64, 'União das Freguesias de Monfortinho e Salvaterra do Extremo'),
(874, 64, 'União das Freguesias de Monsanto e Idanha-A-Velha'),
(875, 64, 'União das Freguesias de Zebreira e Segura'),
(876, 65, 'Alvaro'),
(877, 65, 'Cambas'),
(878, 65, 'Isna'),
(879, 65, 'Madeirã'),
(880, 65, 'Mosteiro'),
(881, 65, 'Orvalho'),
(882, 65, 'Sarnadas de S. Simão'),
(883, 65, 'Sobral'),
(884, 65, 'Estreito-Vilar Barroco'),
(885, 65, 'Oleiros-Amieira'),
(886, 66, 'Aranhas'),
(887, 66, 'Benquerença'),
(888, 66, 'Meimão'),
(889, 66, 'Meimoa'),
(890, 66, 'Penamacor'),
(891, 66, 'Salvador'),
(892, 66, 'Vale Da Senhora Da Povoa'),
(893, 66, 'União das Freguesias de Aldeia do Bispo, Águas e Aldeia De João Pires'),
(894, 66, 'União das Freguesias de Pedrógão de São Pedro e Bemposta'),
(895, 67, 'Montes da Senhora'),
(896, 67, 'S. Pedro do Esteval'),
(897, 67, 'União das Freguesias de Proença-A-Nova e Peral'),
(898, 67, 'União das Freguesias de Sobreira Formosa e Alvito ea Beira'),
(899, 68, 'Cabeçudo'),
(900, 68, 'Carvalhal'),
(901, 68, 'Castelo'),
(902, 68, 'Pedrogão Pequeno'),
(903, 68, 'Sertã'),
(904, 68, 'Troviscal'),
(905, 68, 'Varzea dos Cavaleiros'),
(906, 68, 'União das Freguesias de Cernache do Bonjardim, Nesperal e Palhais'),
(907, 68, 'União das Freguesias de Cumeada e Marmeleiro'),
(908, 68, 'União das Freguesias de Ermida e Figueiredo'),
(909, 69, 'Fundada'),
(910, 69, 'S. João do Peso'),
(911, 69, 'Vila de Rei'),
(912, 70, 'Fratel'),
(913, 70, 'Perais'),
(914, 70, 'Sarnadas de Rodão'),
(915, 70, 'Vila Velha de Rodão'),
(916, 71, 'Arganil'),
(917, 71, 'Benfeita'),
(918, 71, 'Celavisa'),
(919, 71, 'Folques'),
(920, 71, 'Piodão'),
(921, 71, 'Pomares'),
(922, 71, 'Pombeiro da Beira'),
(923, 71, 'S. Martinho da Cortiça'),
(924, 71, 'Sarzedo'),
(925, 71, 'Secarias'),
(926, 71, 'União das Freguesias de Cepos e Teixeira'),
(927, 71, 'União das Freguesias de Cerdeira e Moura da Serra'),
(928, 71, 'União das Freguesias de Côja e Barril de Alva'),
(929, 71, 'União das Freguesias de Vila Cova de Alva e Anseriz'),
(930, 72, 'Ançã'),
(931, 72, 'Cadima'),
(932, 72, 'Cordinhã'),
(933, 72, 'Febres'),
(934, 72, 'Murtede'),
(935, 72, 'Ourentã'),
(936, 72, 'Tocha'),
(937, 72, 'S. Caetano'),
(938, 72, 'Sanguinheira'),
(939, 72, 'União das Freguesias de Cantanhede e Pocariça'),
(940, 72, 'União das Freguesias de Covões e Camarneira'),
(941, 72, 'União das Freguesias de Portunhos e Outil'),
(942, 72, 'União das Freguesias de Sepins e Bolho'),
(943, 72, 'União das Freguesias de Vilamar e Corticeiro de Cima'),
(944, 73, 'Almalagues'),
(945, 73, 'Brasfemes'),
(946, 73, 'Ceira'),
(947, 73, 'Cernache'),
(948, 73, 'Santo Antonio dos Olivais'),
(949, 73, 'S. João do Campo'),
(950, 73, 'S. Silvestre'),
(951, 73, 'Torres do Mondego'),
(952, 73, 'União das Freguesias de Antuzede E Vil de Matos'),
(953, 73, 'União das Freguesias de Assafarge e Antanhol'),
(954, 73, 'União das Freguesias de Coimbra (Sé Nova, Santa Cruz, Almedina e São Bartolomeu)'),
(955, 73, 'União das Freguesias de Eiras e São Paulo de Frades'),
(956, 73, 'União das Freguesias de Santa Clara e Castelo Viegas'),
(957, 73, 'União das Freguesias de São Martinho de Árvore e Lamarosa'),
(958, 73, 'União das Freguesias de São Martinho do Bispo e Ribeira de Frades'),
(959, 73, 'União das Freguesias de Souselas e Botão'),
(960, 73, 'União das Freguesias de Taveiro, Ameal e Arzila'),
(961, 73, 'União das Freguesias de Trouxemil e Torre de Vilela'),
(962, 74, 'Anobra'),
(963, 74, 'Ega'),
(964, 74, 'Furadouro'),
(965, 74, 'Zambujal'),
(966, 74, 'União das Freguesias de Condeixa-A-Velha e Condeixa-A-Nova'),
(967, 74, 'União das Freguesias de Sebal e Belide'),
(968, 74, 'União das Freguesias de Vila Seca e Bem da Fé'),
(969, 75, 'Alqueidão'),
(970, 75, 'Maiorca'),
(971, 75, 'Marinha das Ondas'),
(972, 75, 'Tavarede'),
(973, 75, 'Vila Verde'),
(974, 75, 'S. Pedro'),
(975, 75, 'Bom Sucesso'),
(976, 75, 'Moinhos de Gandara'),
(977, 75, 'Alhadas'),
(978, 75, 'Buarcos'),
(979, 75, 'Ferreira-A-Nova'),
(980, 75, 'Lavos'),
(981, 75, 'Paião'),
(982, 75, 'Quiaios'),
(983, 76, 'Alvares'),
(984, 76, 'Gois'),
(985, 76, 'Vila Nova do Ceira'),
(986, 76, 'União das Freguesias de Cadafaz e Colmeal'),
(987, 77, 'Serpins'),
(988, 77, 'Gandaras'),
(989, 77, 'União das Freguesias de Foz de Arouce e Casal de Ermio'),
(990, 77, 'União das Freguesias de Lousã e Vilarinho'),
(991, 78, 'Mira'),
(992, 78, 'Seixo'),
(993, 78, 'Carapelhos'),
(994, 78, 'Praia de Mira'),
(995, 79, 'Lamas'),
(996, 79, 'Miranda do Corvo'),
(997, 79, 'Vila Nova'),
(998, 79, 'União das Freguesias de Semide e Rio Vide'),
(999, 80, 'Arazede'),
(1000, 80, 'Carapinheira'),
(1001, 80, 'Liceia'),
(1002, 80, 'Meãs do Campo'),
(1003, 80, 'Pereira'),
(1004, 80, 'Santo Varão'),
(1005, 80, 'Seixo de Gatões'),
(1006, 80, 'Tentugal'),
(1007, 80, 'Ereira'),
(1008, 80, 'União das Freguesias de Abrunheira, Verride e Vila Nova da Barca'),
(1009, 80, 'União das Freguesias de Montemor-O-Velho e Gatões'),
(1010, 81, 'Aldeia das Dez'),
(1011, 81, 'Alvoco das Varzeas'),
(1012, 81, 'Avo'),
(1013, 81, 'Bobadela'),
(1014, 81, 'Lagares'),
(1015, 81, 'Lourosa'),
(1016, 81, 'Meruge'),
(1017, 81, 'Nogueira do Cravo'),
(1018, 81, 'S. Gião'),
(1019, 81, 'Seixo da Beira'),
(1020, 81, 'Travanca de Lagos'),
(1021, 81, 'União das Freguesias de Ervedal e Vila Franca da Beira'),
(1022, 81, 'União das Freguesias de Lagos da Beira e Lajeosa'),
(1023, 81, 'União das Freguesias de Oliveira do Hospital e São Paio De Gramaços'),
(1024, 81, 'União das Freguesias de Penalva de Alva e São Sebastião da Feira'),
(1025, 81, 'União das Freguesias de Santa Ovaia e Vila Pouca da Beira'),
(1026, 82, 'Cabril'),
(1027, 82, 'Dornelas do Zezere'),
(1028, 82, 'Janeiro de Baixo'),
(1029, 82, 'Pampilhosa da Serra'),
(1030, 82, 'Pessegueiro'),
(1031, 82, 'Unhais-o-Velho'),
(1032, 82, 'Fajão-Vidual'),
(1033, 82, 'Portela do Fojo-Machio'),
(1034, 83, 'Carvalho'),
(1035, 83, 'Figueira de Lorvão'),
(1036, 83, 'Lorvão'),
(1037, 83, 'Penacova'),
(1038, 83, 'Sazes do Lorvão'),
(1039, 83, 'União das Freguesias de Friúmes e Paradela'),
(1040, 83, 'União das Freguesias de Oliveira do Mondego e Travanca do Mondego'),
(1041, 83, 'União das Freguesias de São Pedro de Alva e São Paio de Mondego'),
(1042, 84, 'Cumeeira'),
(1043, 84, 'Espinhal'),
(1044, 84, 'Podentes'),
(1045, 84, 'União das Freguesias de São Miguel, Santa Eufémia e Rabaçal'),
(1046, 85, 'Alfarelos'),
(1047, 85, 'Figueiro do Campo'),
(1048, 85, 'Granja do Ulmeiro'),
(1049, 85, 'Samuel'),
(1050, 85, 'Soure'),
(1051, 85, 'Tapeus'),
(1052, 85, 'Vila Nova de Anços'),
(1053, 85, 'Vinha da Rainha'),
(1054, 85, 'União das Freguesias de Degracias e Pombalinho'),
(1055, 85, 'União das Freguesias de Gesteira e Brunhós'),
(1056, 86, 'Candosa'),
(1057, 86, 'Carapinha'),
(1058, 86, 'Midões'),
(1059, 86, 'Mouronho'),
(1060, 86, 'Povoa de Midões'),
(1061, 86, 'S. João da Boa Vista'),
(1062, 86, 'Tabua'),
(1063, 86, 'União das Freguesias de Ázere e Covelo'),
(1064, 86, 'União das Freguesias de Covas e Vila Nova de Oliveirinha'),
(1065, 86, 'União das Freguesias de Espariz e Sinde'),
(1066, 86, 'União das Freguesias de Pinheiro de Coja e Meda de Mouros'),
(1067, 87, 'Arrifana'),
(1068, 87, 'Lavegadas'),
(1069, 87, 'Poiares (Santo Andre)'),
(1070, 87, 'S. Miguel de Poiares'),
(1071, 88, 'Santiago Maior'),
(1072, 88, 'Capelins (Santo Antonio)'),
(1073, 88, 'Terena (S. Pedro)'),
(1074, 88, 'União das Freguesias de Alandroal (Nossa Senhora da Conceição), São Brás Dos Matos (Mina do Bugalho)'),
(1075, 89, 'Arraiolos'),
(1076, 89, 'Igrejinha'),
(1077, 89, 'Vimieiro'),
(1078, 89, 'União das Freguesias de Gafanhoeira (São Pedro) e Sabugueiro'),
(1079, 89, 'União das Freguesias de São Gregório e Santa Justa'),
(1080, 90, 'Borba (Matriz)'),
(1081, 90, 'Orada'),
(1082, 90, 'Rio de Moinhos'),
(1083, 90, 'Borba (S. Bartolomeu)'),
(1084, 91, 'Arcos'),
(1085, 91, 'Gloria'),
(1086, 91, 'Evora Monte (Santa Maria)'),
(1087, 91, 'S. Domingos de Ana Loura'),
(1088, 91, 'Veiros'),
(1089, 91, 'União das Freguesias de Estremoz (Santa Maria e Santo André)'),
(1090, 91, 'União das Freguesias de São Bento do Cortiço e Santo Estêvão'),
(1091, 91, 'União das Freguesias de São Lourenço de Mamporcão e São Bento de Ana Loura'),
(1092, 91, 'União Das Freguesias do Ameixial (Santa Vitória e São Bento)'),
(1093, 92, 'Nossa Senhora da Graça do Divor'),
(1094, 92, 'Nossa Senhora de Machede'),
(1095, 92, 'S. Bento do Mato'),
(1096, 92, 'S. Miguel de Machede'),
(1097, 92, 'Torre de Coelheiros'),
(1098, 92, 'Canaviais'),
(1099, 92, 'União das Freguesias de Bacelo e Senhora da Saúde'),
(1100, 92, 'União das Freguesias de Évora (São Mamede, Sé, São Pedro e Santo Antão)'),
(1101, 92, 'União das Freguesias de Malagueira e Horta das Figueiras'),
(1102, 92, 'União das Freguesias de Nossa Senhora da Tourega e Nossa Senhora de Guadalupe'),
(1103, 92, 'União das Freguesias de São Manços e São Vicente do Pigeiro'),
(1104, 92, 'União das Freguesias de São Sebastião da Giesteira e Nossa Senhora da Boa Fé'),
(1105, 93, 'Cabrela'),
(1106, 93, 'Santiago do Escoural'),
(1107, 93, 'S. Cristovão'),
(1108, 93, 'Ciborro'),
(1109, 93, 'Foros de Vale de Figueira'),
(1110, 93, 'União das Freguesias de Cortiçadas de Lavre e Lavre'),
(1111, 93, 'União das Freguesias de Nossa Senhora da Vila, Nossa Senhora do Bispo e Silveiras'),
(1112, 94, 'Brotas'),
(1113, 94, 'Cabeção'),
(1114, 94, 'Mora'),
(1115, 94, 'Pavia'),
(1116, 95, 'Granja'),
(1117, 95, 'Luz'),
(1118, 95, 'Mourão'),
(1119, 96, 'Monte do Trigo'),
(1120, 96, 'Portel'),
(1121, 96, 'Santana'),
(1122, 96, 'Vera Cruz'),
(1123, 96, 'União das Freguesias de Amieira e Alqueva'),
(1124, 96, 'União das Freguesias de São Bartolomeu do Outeiro e Oriola'),
(1125, 97, 'Montoito'),
(1126, 97, 'Redondo'),
(1127, 98, 'Corval'),
(1128, 98, 'Monsaraz'),
(1129, 98, 'Reguengos de Monsaraz'),
(1130, 98, 'União das Freguesias de Campo e Campinho'),
(1131, 99, 'Vendas Novas'),
(1132, 99, 'Landeira'),
(1133, 100, 'Alcaçovas'),
(1134, 100, 'Viana do Alentejo'),
(1135, 100, 'Aguiar'),
(1136, 101, 'Bencatel'),
(1137, 101, 'Ciladas'),
(1138, 101, 'Pardais'),
(1139, 101, 'Nossa Senhora da Conceição e São Bartolomeu'),
(1140, 102, 'Guia'),
(1141, 102, 'Paderne'),
(1142, 102, 'Ferreiras'),
(1143, 102, 'Albufeira e Olhos de Água'),
(1144, 103, 'Giões'),
(1145, 103, 'Martim Longo'),
(1146, 103, 'Vaqueiros'),
(1147, 103, 'União das Freguesias de Alcoutim e Pereiro'),
(1148, 104, 'Aljezur'),
(1149, 104, 'Bordeira'),
(1150, 104, 'Odeceixe'),
(1151, 104, 'Rogil'),
(1152, 105, 'Azinhal'),
(1153, 105, 'Castro Marim'),
(1154, 105, 'Odeleite'),
(1155, 105, 'Altura'),
(1156, 106, 'Santa Barbara de Nexe'),
(1157, 106, 'Montenegro'),
(1158, 106, 'União das Freguesias de Conceição e Estoi'),
(1159, 106, 'União das Freguesias de Faro (Sé e São Pedro)'),
(1160, 107, 'Ferragudo'),
(1161, 107, 'Porches'),
(1162, 107, 'União das Freguesias de Estômbar e Parchal'),
(1163, 107, 'União das Freguesias de Lagoa e Carvoeiro'),
(1164, 108, 'Luz'),
(1165, 108, 'Odiaxere'),
(1166, 108, 'União das Freguesias de Bensafrim e Barão de São João'),
(1167, 108, 'União das Freguesias de Lagos (São Sebastião e Santa Maria)'),
(1168, 109, 'Almancil'),
(1169, 109, 'Alte'),
(1170, 109, 'Ameixial'),
(1171, 109, 'Boliqueime'),
(1172, 109, 'Quarteira'),
(1173, 109, 'Salir'),
(1174, 109, 'Loule (S. Clemente)'),
(1175, 109, 'Loule (S. Sebastião)'),
(1176, 109, 'União de Freguesias De Querença, Tôr e Benafim'),
(1177, 110, 'Alferce'),
(1178, 110, 'Marmelete'),
(1179, 110, 'Monchique'),
(1180, 111, 'Olhão'),
(1181, 111, 'Pechão'),
(1182, 111, 'Quelfes'),
(1183, 111, 'União das Freguesias de Moncarapacho e Fuseta'),
(1184, 112, 'Alvor'),
(1185, 112, 'Mexilhoeira Grande'),
(1186, 112, 'Portimão'),
(1187, 113, 'S. Bras de Alportel'),
(1188, 114, 'Armação de Pêra'),
(1189, 114, 'S. Bartolomeu de Messines'),
(1190, 114, 'S. Marcos da Serra'),
(1191, 114, 'Silves'),
(1192, 114, 'União das Freguesias de Alcantarilha e Pêra'),
(1193, 114, 'União das Freguesias de Algoz e Tunes'),
(1194, 115, 'Cachopo'),
(1195, 115, 'Santa Catarina da Fonte do Bispo'),
(1196, 115, 'Santa Luzia'),
(1197, 115, 'União das Freguesias de Conceição e Cabanas de Tavira'),
(1198, 115, 'União das Freguesias de Luz de Tavira e Santo Estêvão'),
(1199, 115, 'União das Freguesias de Tavira (Santa Maria e Santiago)'),
(1200, 116, 'Barão de S. Miguel'),
(1201, 116, 'Budens'),
(1202, 116, 'Vila de Sagres'),
(1203, 116, 'Vila do Bispo e Raposeira'),
(1204, 117, 'Vila Nova de Cacela'),
(1205, 117, 'Vila Real de Santo António'),
(1206, 117, 'Monte Gordo'),
(1207, 118, 'Carapito'),
(1208, 118, 'Cortiçada'),
(1209, 118, 'Dornelas'),
(1210, 118, 'Eirado'),
(1211, 118, 'Forninhos'),
(1212, 118, 'Pena Verde'),
(1213, 118, 'Pinheiro'),
(1214, 118, 'União das Freguesias de Aguiar da Beira e Coruche'),
(1215, 118, 'União das Freguesias de Sequeiros e Gradiz'),
(1216, 118, 'União das Freguesias de Souto de Aguiar da Beira e Valverde'),
(1217, 119, 'Almeida'),
(1218, 119, 'Castelo Bom'),
(1219, 119, 'Freineda'),
(1220, 119, 'Freixo'),
(1221, 119, 'Malhada Sorda'),
(1222, 119, 'Nave de Haver'),
(1223, 119, 'S. Pedro de Rio Seco'),
(1224, 119, 'Vale da Mula'),
(1225, 119, 'Vilar Formoso'),
(1226, 119, 'União das Freguesias de Amoreira, Parada e Cabreira'),
(1227, 119, 'União das Freguesias de Azinhal, Peva e Valverde'),
(1228, 119, 'União das Freguesias de Castelo Mendo, Ade, Monteperobolso e Mesquitela'),
(1229, 119, 'União das Freguesias de Junça e Naves'),
(1230, 119, 'União das Freguesias de Leomil, Mido, Senouras e Aldeia Nova'),
(1231, 119, 'União das Freguesias de Malpartida e Vale de Coelha'),
(1232, 119, 'União das Freguesias de Miuzela e Porto de Ovelha'),
(1233, 120, 'Baraçal'),
(1234, 120, 'Carrapichana'),
(1235, 120, 'Forno Telheiro'),
(1236, 120, 'Lajeosa do Mondego'),
(1237, 120, 'Linhares'),
(1238, 120, 'Maçal do Chão'),
(1239, 120, 'Mesquitela'),
(1240, 120, 'Minhocal'),
(1241, 120, 'Prados'),
(1242, 120, 'Ratoeira'),
(1243, 120, 'Vale de Azares'),
(1244, 120, 'Casas do Soeiro'),
(1245, 120, 'União das Freguesias de Açores e Velosa'),
(1246, 120, 'União das Freguesias de Celorico (São Pedro e Santa Maria) e Vila Boa do Mondego'),
(1247, 120, 'União das Freguesias de Cortiçô da Serra, Vide Entre Vinhas e Salgueirais'),
(1248, 120, 'União das Freguesias de Rapa e Cadafaz'),
(1249, 121, 'Castelo Rodrigo'),
(1250, 121, 'Escalhão'),
(1251, 121, 'Figueira de Castelo Rodrigo'),
(1252, 121, 'Mata de Lobos'),
(1253, 121, 'Vermiosa'),
(1254, 121, 'União das Freguesias de Algodres, Vale de Afonsinho e Vilar de Amargo'),
(1255, 121, 'União das Freguesias de Almofala e Escarigo'),
(1256, 121, 'União das Freguesias de Cinco Vilas e Reigada'),
(1257, 121, 'União das Freguesias de Freixeda do Torrão, Quintã de Pêro Martins e Penha de Águia'),
(1258, 121, 'União das Freguesias do Colmeal e Vilar Torpim'),
(1259, 122, 'Algodres'),
(1260, 122, 'Casal Vasco'),
(1261, 122, 'Figueiro da Granja'),
(1262, 122, 'Fornos de Algodres'),
(1263, 122, 'Infias'),
(1264, 122, 'Maceira'),
(1265, 122, 'Matança'),
(1266, 122, 'Muxagata'),
(1267, 122, 'Queiriz'),
(1268, 122, 'União das Freguesias de Cortiçô e Vila Chã'),
(1269, 122, 'União das Freguesias de Juncais, Vila Ruiva e Vila Soeiro do Chão'),
(1270, 122, 'União das Freguesias de Sobral Pichorro e Fuinhas'),
(1271, 123, 'Arcozelo'),
(1272, 123, 'Cativelos'),
(1273, 123, 'Folgosinho'),
(1274, 123, 'Nespereira'),
(1275, 123, 'Paços da Serra'),
(1276, 123, 'Ribamondego'),
(1277, 123, 'S. Paio'),
(1278, 123, 'Vila Cortes da Serra'),
(1279, 123, 'Vila Franca da Serra'),
(1280, 123, 'Vila Nova de Tazem'),
(1281, 123, 'União das Freguesias de Aldeias e Mangualde da Serra'),
(1282, 123, 'União das Freguesias de Figueiró da Serra e Freixo da Serra'),
(1283, 123, 'União das Freguesias de Gouveia (São Pedro e São Julião)'),
(1284, 123, 'União das Freguesias de Melo e Nabais'),
(1285, 123, 'União das Freguesias de Moimenta Da Serra e Vinhó'),
(1286, 123, 'União das Freguesias de Rio Torto e Lagarinhos'),
(1287, 124, 'Aldeia do Bispo'),
(1288, 124, 'Aldeia Viçosa'),
(1289, 124, 'Alvendre'),
(1290, 124, 'Arrifana'),
(1291, 124, 'Avelãs da Ribeira'),
(1292, 124, 'Benespera'),
(1293, 124, 'Casal de Cinza'),
(1294, 124, 'Castanheira'),
(1295, 124, 'Cavadoude'),
(1296, 124, 'Codesseiro'),
(1297, 124, 'Faia'),
(1298, 124, 'Famalicão'),
(1299, 124, 'Fernão Joanes'),
(1300, 124, 'Gonçalo Bocas'),
(1301, 124, 'João Antão'),
(1302, 124, 'Maçainhas'),
(1303, 124, 'Marmeleiro'),
(1304, 124, 'Meios'),
(1305, 124, 'Panoias de Cima'),
(1306, 124, 'Pega'),
(1307, 124, 'Pera do Moço'),
(1308, 124, 'Porto da Carne'),
(1309, 124, 'Ramela'),
(1310, 124, 'Santana da Azinha'),
(1311, 124, 'Sobral da Serra'),
(1312, 124, 'Vale de Estrela'),
(1313, 124, 'Valhelhas'),
(1314, 124, 'Vela'),
(1315, 124, 'Videmonte'),
(1316, 124, 'Vila Cortes do Mondego'),
(1317, 124, 'Vila Fernando'),
(1318, 124, 'Vila Franca do Deão'),
(1319, 124, 'Vila Garcia'),
(1320, 124, 'Gonçalo'),
(1321, 124, 'Guarda'),
(1322, 124, 'Jarmelo São Miguel'),
(1323, 124, 'Jarmelo São Pedro'),
(1324, 124, 'União de Freguesias de Avelãs de Ambom e Rocamondo'),
(1325, 124, 'União de Freguesias de Corujeira e Trinta'),
(1326, 124, 'União de Freguesias de Mizarela, Pêro Soares e Vila Soeiro'),
(1327, 124, 'União de Freguesias de Pousade e Albardo'),
(1328, 124, 'União de Freguesias de Rochoso e Monte Margarida'),
(1329, 124, 'Adão'),
(1330, 125, 'Sameiro'),
(1331, 125, 'Manteigas (Santa Maria)'),
(1332, 125, 'Manteigas (S. Pedro)'),
(1333, 125, 'Vale da Amoreira'),
(1334, 126, 'Aveloso'),
(1335, 126, 'Barreira'),
(1336, 126, 'Coriscada'),
(1337, 126, 'Longroiva'),
(1338, 126, 'Marialva'),
(1339, 126, 'Poço do Canto'),
(1340, 126, 'Rabaçal'),
(1341, 126, 'Ranhados'),
(1342, 126, 'União das Freguesias de Mêda, Outeiro de Gatos e Fonte Longa'),
(1343, 126, 'União das Freguesias de Prova e Casteição'),
(1344, 126, 'União das Freguesias de Vale Flor, Carvalhal e Pai Penela'),
(1345, 127, 'Ervedosa'),
(1346, 127, 'Freixedas'),
(1347, 127, 'Lamegal'),
(1348, 127, 'Lameiras'),
(1349, 127, 'Manigoto'),
(1350, 127, 'Pala'),
(1351, 127, 'Pinhel'),
(1352, 127, 'Pinzio'),
(1353, 127, 'Souro Pires'),
(1354, 127, 'Vascoveiro'),
(1355, 127, 'Agregação das Freguesias Sul de Pinhel'),
(1356, 127, 'Alverca da Beira/Bouça Cova'),
(1357, 127, 'Terras de Massueime'),
(1358, 127, 'Valbom/Bogalhal'),
(1359, 127, 'Alto do Palurdo'),
(1360, 12827, 'Vale do Côa'),
(1361, 12827, 'Vale do Massueime'),
(1362, 12827, 'União das Freguesias de Atalaia e Safurdão'),
(1363, 128, 'Aguas Belas'),
(1364, 128, 'Aldeia do Bispo'),
(1365, 128, 'Aldeia da Ponte'),
(1366, 128, 'Aldeia Velha'),
(1367, 128, 'Alfaiates'),
(1368, 128, 'Baraçal'),
(1369, 128, 'Bendada'),
(1370, 128, 'Bismula'),
(1371, 128, 'Casteleiro'),
(1372, 128, 'Cerdeira'),
(1373, 128, 'Foios'),
(1374, 128, 'Malcata'),
(1375, 128, 'Nave'),
(1376, 128, 'Quadrazais'),
(1377, 128, 'Quintas de São Bartolomeu'),
(1378, 128, 'Rapoula do Côa'),
(1379, 128, 'Rebolosa'),
(1380, 128, 'Rendo'),
(1381, 128, 'Sortelha'),
(1382, 128, 'Souto'),
(1383, 128, 'Vale de Espinho'),
(1384, 128, 'Vila Boa'),
(1385, 128, 'Vila do Touro'),
(1386, 128, 'União das Freguesias de Aldeia da Ribeira, Vilar Maior e Badamalos'),
(1387, 128, 'União das Freguesias de Lajeosa e Forcalhos'),
(1388, 128, 'União das Freguesias de Pousafoles do Bispo, Pena Lobo e Lomba'),
(1389, 128, 'União das Freguesias de Ruvina, Ruivós e Vale das Éguas'),
(1390, 128, 'União Das Freguesias do Sabugal e Aldeia de Santo António'),
(1391, 128, 'União das Freguesias de Santo Estêvão e Moita'),
(1392, 128, 'União das Freguesias de Seixo Do Côa e Vale Longo'),
(1393, 129, 'Alvoco da Serra'),
(1394, 129, 'Girabolhos'),
(1395, 129, 'Loriga'),
(1396, 129, 'Paranhos'),
(1397, 129, 'Pinhanços'),
(1398, 129, 'Sabugueiro'),
(1399, 129, 'Sandomil'),
(1400, 129, 'Santa Comba'),
(1401, 129, 'Santiago'),
(1402, 129, 'Sazes da Beira'),
(1403, 129, 'Teixeira'),
(1404, 129, 'Travancinha'),
(1405, 129, 'Valezim'),
(1406, 129, 'Vila Cova a Coelheira'),
(1407, 129, 'União das Freguesias de Carragozela e Várzea de Meruge'),
(1408, 129, 'União das Freguesias de Sameice e Santa Eulália'),
(1409, 129, 'União das Freguesias de Santa Marinha e São Martinho'),
(1410, 129, 'União das Freguesias de Seia, São Romão e Lapa dos Dinheiros'),
(1411, 129, 'União das Freguesias de Torrozelo e Folhadosa'),
(1412, 129, 'União das Freguesias de Tourais e Lajes'),
(1413, 129, 'União das Freguesias de Vide e Cabeça'),
(1414, 130, 'Aldeia Nova'),
(1415, 130, 'Castanheira'),
(1416, 130, 'Cogula'),
(1417, 130, 'Cotimos'),
(1418, 130, 'Fiães'),
(1419, 130, 'Granja'),
(1420, 130, 'Guilheiro'),
(1421, 130, 'Moimentinha'),
(1422, 130, 'Moreira de Rei'),
(1423, 130, 'Palhais'),
(1424, 130, 'Povoa do Concelho'),
(1425, 130, 'Reboleiro'),
(1426, 130, 'Rio de Mel');
INSERT INTO `freguesia` (`ID_Freguesia`, `ID_Concelho`, `Nome`) VALUES
(1427, 130, 'Tamanhos'),
(1428, 130, 'Valdujo'),
(1429, 130, 'União das Freguesias de Freches e Torres'),
(1430, 130, 'União das Freguesias de Torre do Terrenho, Sebadelhe da Serra e Terrenho'),
(1431, 130, 'União das Freguesias de Trancoso (São Pedro e Santa Maria) e Souto Maior'),
(1432, 130, 'União das Freguesias de Vale Do Seixo e Vila Garcia'),
(1433, 130, 'União das Freguesias de Vila Franca das Naves e Feital'),
(1434, 130, 'União das Freguesias de Vilares e Carnicães'),
(1435, 131, 'Almendra'),
(1436, 131, 'Castelo Melhor'),
(1437, 131, 'Cedovim'),
(1438, 131, 'Chãs'),
(1439, 131, 'Custoias'),
(1440, 131, 'Horta'),
(1441, 131, 'Muxagata'),
(1442, 131, 'Numão'),
(1443, 131, 'Santa Comba'),
(1444, 131, 'Sebadelhe'),
(1445, 131, 'Seixas'),
(1446, 131, 'Touça'),
(1447, 131, 'Freixo De Numão'),
(1448, 131, 'Vila Nova de Foz Côa'),
(1449, 132, 'Alfeizerão'),
(1450, 132, 'Barrio'),
(1451, 132, 'Benedita'),
(1452, 132, 'Cela'),
(1453, 132, 'Evora de Alcobaça'),
(1454, 132, 'Maiorga'),
(1455, 132, 'S. Martinho do Porto'),
(1456, 132, 'Turquel'),
(1457, 132, 'Vimeiro'),
(1458, 132, 'Aljubarrota'),
(1459, 132, 'União das Freguesias de Alcobaça e Vestiaria'),
(1460, 132, 'União das Freguesias de Coz, Alpedriz e Montes'),
(1461, 132, 'União das Freguesias de Pataias e Martingança'),
(1462, 133, 'Almoster'),
(1463, 133, 'Maçãs de D. Maria'),
(1464, 133, 'Pelma'),
(1465, 133, 'Alvaiázere'),
(1466, 133, 'Pussos São Pedro'),
(1467, 134, 'Alvorge'),
(1468, 134, 'Avelar'),
(1469, 134, 'Chão de Couce'),
(1470, 134, 'Pousaflores'),
(1471, 134, 'Santiago da Guarda'),
(1472, 134, 'Ansião'),
(1473, 135, 'Batalha'),
(1474, 135, 'Reguengo do Fetal'),
(1475, 135, 'S. Mamede'),
(1476, 135, 'Golpilheira'),
(1477, 136, 'Carvalhal'),
(1478, 136, 'Roliça'),
(1479, 136, 'Po'),
(1480, 136, 'União das Freguesias do Bombarral e Vale Covo'),
(1481, 137, 'A dos Francos'),
(1482, 137, 'Alvorninha'),
(1483, 137, 'Carvalhal Benfeito'),
(1484, 137, 'Foz do Arelho'),
(1485, 137, 'Landal'),
(1486, 137, 'Nadadouro'),
(1487, 137, 'Salir de Matos'),
(1488, 137, 'Santa Catarina'),
(1489, 137, 'Vidais'),
(1490, 137, 'União das Freguesias de Caldas da Rainha - Nossa Senhora do Pópulo, Coto e São Gregório'),
(1491, 137, 'União das Freguesias de Caldas da Rainha - Santo Onofre e Serra do Bouro'),
(1492, 137, 'União das Freguesias de Tornada e Salir do Porto'),
(1493, 138, 'União das Freguesias de Castanheira de Pêra e Coentral'),
(1494, 139, 'Aguda'),
(1495, 139, 'Arega'),
(1496, 139, 'Campelo'),
(1497, 139, 'União das Freguesias de Figueiró dos Vinhos e Bairradas'),
(1498, 140, 'Amor'),
(1499, 140, 'Arrabal'),
(1500, 140, 'Caranguejeira'),
(1501, 140, 'Coimbrão'),
(1502, 140, 'Maceira'),
(1503, 140, 'Milagres'),
(1504, 140, 'Regueira de Pontes'),
(1505, 140, 'Bajouca'),
(1506, 140, 'Bidoeira de Cima'),
(1507, 140, 'União das Freguesias de Colmeias e Memória'),
(1508, 140, 'União das Freguesias de Leiria, Pousos, Barreira e Cortes'),
(1509, 140, 'União das Freguesias de Marrazes e Barosa'),
(1510, 140, 'União das Freguesias de Monte Real e Carvide'),
(1511, 140, 'União das Freguesias de Monte Redondo e Carreira'),
(1512, 140, 'União das Freguesias de Parceiros e Azoia'),
(1513, 140, 'União das Freguesias de Santa Catarina da Serra e Chainça'),
(1514, 140, 'União das Freguesias de Santa Eufémia e Boa Vista'),
(1515, 140, 'União das Freguesias de Souto da Carpalhosa e Ortigosa'),
(1516, 141, 'Marinha Grande'),
(1517, 141, 'Vieira de Leiria'),
(1518, 141, 'Moita'),
(1519, 142, 'Famalicão'),
(1520, 142, 'Nazare'),
(1521, 142, 'Valado dos Frades'),
(1522, 143, 'A dos Negros'),
(1523, 143, 'Amoreira'),
(1524, 143, 'Olho Marinho'),
(1525, 143, 'Vau'),
(1526, 143, 'Gaeiras'),
(1527, 143, 'Usseira'),
(1528, 143, 'Santa Maria, São Pedro e Sobral da Lagoa'),
(1529, 144, 'Graça'),
(1530, 144, 'Pedrogão Grande'),
(1531, 144, 'Vila Facaia'),
(1532, 145, 'Atouguia da Baleia'),
(1533, 145, 'Serra del-Rei'),
(1534, 145, 'Ferrel'),
(1535, 145, 'Peniche'),
(1536, 146, 'Abiul'),
(1537, 146, 'Almagreira'),
(1538, 146, 'Carnide'),
(1539, 146, 'Carriço'),
(1540, 146, 'Louriçal'),
(1541, 146, 'Pelariga'),
(1542, 146, 'Pombal'),
(1543, 146, 'Redinha'),
(1544, 146, 'Vermoil'),
(1545, 146, 'Vila Cã'),
(1546, 146, 'Meirinhas'),
(1547, 146, 'União das Freguesias de Guia, Ilha e Mata Mourisca'),
(1548, 146, 'União das Freguesias de Santiago e São Simão de Litém e Albergaria dos Doze'),
(1549, 147, 'Alqueidão da Serra'),
(1550, 147, 'Calvaria de Cima'),
(1551, 147, 'Juncal'),
(1552, 147, 'Mira de Aire'),
(1553, 147, 'Pedreiras'),
(1554, 147, 'S. Bento'),
(1555, 147, 'Serro Ventoso'),
(1556, 147, 'Porto de Mós - São João Baptista e São Pedro'),
(1557, 147, 'União das Freguesias de Alvados e Alcaria'),
(1558, 147, 'União das Freguesias de Arrimal e Mendiga'),
(1559, 148, 'Carnota'),
(1560, 148, 'Meca'),
(1561, 148, 'Olhalvo'),
(1562, 148, 'Ota'),
(1563, 148, 'Ventosa'),
(1564, 148, 'Vila Verde dos Francos'),
(1565, 148, 'União das Freguesias de Abrigada e Cabanas de Torres'),
(1566, 148, 'União das Freguesias de Aldeia Galega da Merceana e Aldeia Gavinha'),
(1567, 148, 'União das Freguesias de Alenquer (Santo Estêvão e Triana)'),
(1568, 148, 'União das Freguesias de Carregado e Cadafais'),
(1569, 148, 'União das Freguesias de Ribafria e Pereiro de Palhacana'),
(1570, 149, 'Arranho'),
(1571, 149, 'Arruda dos Vinhos'),
(1572, 149, 'Cardosas'),
(1573, 149, 'Santiago dos Velhos'),
(1574, 150, 'Alcoentre'),
(1575, 150, 'Aveiras de Baixo'),
(1576, 150, 'Aveiras de Cima'),
(1577, 150, 'Azambuja'),
(1578, 150, 'Vale do Paraiso'),
(1579, 150, 'Vila Nova da Rainha'),
(1580, 150, 'União das Freguesias de Manique do Intendente, Vila Nova de São Pedro e Maçussa'),
(1581, 151, 'Alguber'),
(1582, 151, 'Peral'),
(1583, 151, 'Vermelha'),
(1584, 151, 'Vilar'),
(1585, 151, 'União das Freguesias do Cadaval e Pêro Moniz'),
(1586, 151, 'União das Freguesias de Lamas e Cercal'),
(1587, 151, 'União das Freguesias de Painho e Figueiros'),
(1588, 152, 'Alcabideche'),
(1589, 152, 'S. Domingos de Rana'),
(1590, 152, 'União das Freguesias de Carcavelos e Parede'),
(1591, 152, 'União das Freguesias de Cascais e Estoril'),
(1592, 153, 'Ajuda'),
(1593, 153, 'Alcantara'),
(1594, 153, 'Beato'),
(1595, 153, 'Benfica'),
(1596, 153, 'Campolide'),
(1597, 153, 'Carnide'),
(1598, 153, 'Lumiar'),
(1599, 153, 'Marvila'),
(1600, 153, 'Olivais'),
(1601, 153, 'S. Domingos de Benfica'),
(1602, 153, 'Alvalade'),
(1603, 153, 'Areeiro'),
(1604, 153, 'Arroios'),
(1605, 153, 'Avenidas Novas'),
(1606, 153, 'Belém'),
(1607, 153, 'Campo de Ourique'),
(1608, 153, 'Estrela'),
(1609, 153, 'Misericórdia'),
(1610, 153, 'Parque das Nações'),
(1611, 153, 'Penha de França'),
(1612, 153, 'Santa Clara'),
(1613, 153, 'Santa Maria Maior'),
(1614, 153, 'Santo António'),
(1615, 153, 'São Vicente'),
(1616, 154, 'Bucelas'),
(1617, 154, 'Fanhões'),
(1618, 154, 'Loures'),
(1619, 154, 'Lousa'),
(1620, 154, 'União das Freguesias de Moscavide e Portela'),
(1621, 154, 'União das Freguesias de Sacavém e Prior Velho'),
(1622, 154, 'União das Freguesias de Santa Iria de Azoia, São João da Talha e Bobadela'),
(1623, 154, 'União das Freguesias de Santo Antão e São Julião do Tojal'),
(1624, 154, 'União das Freguesias de Santo António dos Cavaleiros e Frielas'),
(1625, 154, 'União das Freguesias de Camarate, Unhos e Apelação'),
(1626, 155, 'Moita dos Ferreiros'),
(1627, 155, 'Reguengo Grande'),
(1628, 155, 'Santa Barbara'),
(1629, 155, 'Vimeiro'),
(1630, 155, 'Ribamar'),
(1631, 155, 'União das Freguesias de Lourinhã e Atalaia'),
(1632, 155, 'União das Freguesias de Miragaia e Marteleira'),
(1633, 155, 'União das Freguesias de São Bartolomeu dos Galegos e Moledo'),
(1634, 156, 'Carvoeira'),
(1635, 156, 'Encarnação'),
(1636, 156, 'Ericeira'),
(1637, 156, 'Mafra'),
(1638, 156, 'Milharado'),
(1639, 156, 'Santo Isidoro'),
(1640, 156, 'União das Freguesias de Azueira e Sobral da Abelheira'),
(1641, 156, 'União das Freguesias de Enxara do Bispo, Gradil e Vila Franca do Rosário'),
(1642, 156, 'União das Freguesias de Igreja Nova e Cheleiros'),
(1643, 156, 'União das Freguesias de Malveira e São Miguel de Alcainça'),
(1644, 156, 'União das Freguesias de Venda do Pinheiro e Santo Estêvão das Galés'),
(1645, 157, 'Barcarena'),
(1646, 157, 'Porto Salvo'),
(1647, 157, 'União das Freguesias de Algés, Linda-a-Velha e Cruz Quebrada-Dafundo'),
(1648, 157, 'União das Freguesias de Carnaxide e Queijas'),
(1649, 157, 'União das Freguesias de Oeiras e São Julião da Barra, Paço de Arcos e Caxias'),
(1650, 158, 'Algueirão-Mem Martins'),
(1651, 158, 'Colares'),
(1652, 158, 'Rio de Mouro'),
(1653, 158, 'Casal de Cambra'),
(1654, 158, 'União das Freguesias de Agualva e Mira-Sintra'),
(1655, 158, 'União das Freguesias de Almargem do Bispo, Pêro Pinheiro e Montelavar'),
(1656, 158, 'União Das Freguesias do Cacém e São Marcos'),
(1657, 158, 'União das Freguesias de Massamá e Monte Abraão'),
(1658, 158, 'União das Freguesias de Queluz e Belas'),
(1659, 158, 'União das Freguesias de São João das Lampas e Terrugem'),
(1660, 158, 'União das Freguesias de Sintra (Santa Maria e São Miguel, São Martinho e São Pedro de Penaferrim)'),
(1661, 159, 'Santo Quintino'),
(1662, 159, 'Sapataria'),
(1663, 159, 'Sobral de Monte Agraço'),
(1664, 160, 'Freiria'),
(1665, 160, 'Ponte do Rol'),
(1666, 160, 'Ramalhal'),
(1667, 160, 'S. Pedro da Cadeira'),
(1668, 160, 'Silveira'),
(1669, 160, 'Turcifal'),
(1670, 160, 'Ventosa'),
(1671, 160, 'União das Freguesias de A dos Cunhados e Maceira'),
(1672, 160, 'União das Freguesias de Campelos e Outeiro da Cabeça'),
(1673, 160, 'União das Freguesias de Carvoeira e Carmões'),
(1674, 160, 'União das Freguesias de Dois Portos e Runa'),
(1675, 160, 'União das Freguesias de Maxial e Monte Redondo'),
(1676, 160, 'União das Freguesias de Torres Vedras (São Pedro, Santiago, Santa Maria do Castelo e São Miguel) E M'),
(1677, 161, 'Vialonga'),
(1678, 161, 'Vila Franca de Xira'),
(1679, 161, 'União das Freguesias de Alhandra, São João dos Montes e Calhandriz'),
(1680, 161, 'União das Freguesias de Alverca do Ribatejoe Sobralinho'),
(1681, 161, 'União das Freguesias de Castanheira do Ribatejo e Cachoeiras'),
(1682, 161, 'União das Freguesias de Póvoa de Santa Iria e Forte da Casa'),
(1683, 162, 'Alfragide'),
(1684, 162, 'Águas Livres'),
(1685, 162, 'Encosta do Sol'),
(1686, 162, 'Falagueira-Venda Nova'),
(1687, 162, 'Mina de Água'),
(1688, 162, 'Venteira'),
(1689, 163, 'Odivelas'),
(1690, 163, 'União das Freguesias de Pontinha e Famões'),
(1691, 163, 'União das Freguesias de Póvoa de Santo Adrião e Olival Basto'),
(1692, 163, 'União das Freguesias de Ramada e Caneças'),
(1693, 164, 'Alter do Chão'),
(1694, 164, 'Chancelaria'),
(1695, 164, 'Seda'),
(1696, 164, 'Cunheira'),
(1697, 165, 'Assunção'),
(1698, 165, 'Esperança'),
(1699, 165, 'Mosteiros'),
(1700, 166, 'Aldeia Velha'),
(1701, 166, 'Avis'),
(1702, 166, 'Ervedal'),
(1703, 166, 'Figueira e Barros'),
(1704, 166, 'União das Freguesias de Alcórrego e Maranhão'),
(1705, 166, 'União das Freguesias de Benavila e Valongo'),
(1706, 167, 'Nossa Senhora da Expectação'),
(1707, 167, 'Nossa Senhora da Graça dos Degolados'),
(1708, 167, 'S. João Baptista'),
(1709, 168, 'Nossa Senhora da Graça de Povoa e Meadas'),
(1710, 168, 'Santa Maria Da Devesa'),
(1711, 168, 'Santiago Maior'),
(1712, 168, 'S. João Baptista'),
(1713, 169, 'Aldeia da Mata'),
(1714, 169, 'Gafete'),
(1715, 169, 'Monte da Pedra'),
(1716, 169, 'União das Freguesias de Crato e Mártires, Flor da Rosa e Vale do Peso'),
(1717, 170, 'Santa Eulalia'),
(1718, 170, 'S. Bras e S. Lourenço'),
(1719, 170, 'S. Vicente e Ventosa'),
(1720, 170, 'Assunção, Ajuda, Salvador e Santo Ildefonso'),
(1721, 170, 'Caia, São Pedro e Alcáçova'),
(1722, 170, 'União das Freguesias de Barbacena e Vila Fernando'),
(1723, 170, 'União das Freguesias de Terrugem e Vila Boim'),
(1724, 171, 'Cabeço de Vide'),
(1725, 171, 'Fronteira'),
(1726, 171, 'S. Saturnino'),
(1727, 172, 'Belver'),
(1728, 172, 'Comenda'),
(1729, 172, 'Margem'),
(1730, 172, 'União das Freguesias de Gavião e Atalaia'),
(1731, 173, 'Beirã'),
(1732, 173, 'Santa Maria de Marvão'),
(1733, 173, 'Santo Antonio das Areias'),
(1734, 173, 'S. Salvador da Aramenha'),
(1735, 174, 'Assumar'),
(1736, 174, 'Monforte'),
(1737, 174, 'Santo Aleixo'),
(1738, 174, 'Vaiamonte'),
(1739, 175, 'Alpalhão'),
(1740, 175, 'Montalvão'),
(1741, 175, 'Santana'),
(1742, 175, 'S. Matias'),
(1743, 175, 'Tolosa'),
(1744, 175, 'União das Freguesias de Arez e Amieira do Tejo'),
(1745, 175, 'União das Freguesias de Espírito Santo, Nossa Senhora da Graça e São Simão'),
(1746, 176, 'Galveias'),
(1747, 176, 'Montargil'),
(1748, 176, 'Foros de Arrão'),
(1749, 176, 'Longomel'),
(1750, 176, 'União das Freguesias de Ponte de Sôr, Tramaga e Vale de Açor'),
(1751, 177, 'Alagoa'),
(1752, 177, 'Alegrete'),
(1753, 177, 'Fortios'),
(1754, 177, 'Urra'),
(1755, 177, 'União Das Freguesias da Sé e São Lourenço'),
(1756, 177, 'União das Freguesias de Reguengo e São Julião'),
(1757, 177, 'União das Freguesias de Ribeira de Nisa e Carreiras'),
(1758, 178, 'Cano'),
(1759, 178, 'Casa Branca'),
(1760, 178, 'Santo Amaro'),
(1761, 178, 'Sousel'),
(1762, 179, 'Ansiães'),
(1763, 179, 'Candemil'),
(1764, 179, 'Fregim'),
(1765, 179, 'Fridão'),
(1766, 179, 'Gondar'),
(1767, 179, 'Jazente'),
(1768, 179, 'Lomba'),
(1769, 179, 'Louredo'),
(1770, 179, 'Lufrei'),
(1771, 179, 'Mancelos'),
(1772, 179, 'Padronelo'),
(1773, 179, 'Rebordelo'),
(1774, 179, 'Salvador do Monte'),
(1775, 179, 'Gouveia (S. Simão)'),
(1776, 179, 'Telões'),
(1777, 179, 'Travanca'),
(1778, 179, 'Vila Caiz'),
(1779, 179, 'Vila Chão do Marão'),
(1780, 179, 'União das Freguesias de Aboadela, Sanche e Várzea'),
(1781, 179, 'União das Freguesias de Amarante (São Gonçalo), Madalena, Cepelos e Gatão'),
(1782, 179, 'União das Freguesias de Bustelo, Carneiro e Carvalho de Rei'),
(1783, 179, 'União das Freguesias de Figueiró (Santiago e Santa Cristina)'),
(1784, 179, 'União das Freguesias de Freixo de Cima e de Baixo'),
(1785, 179, 'União das Freguesias de Olo e Canadelo'),
(1786, 179, 'União das Freguesias de Real, Ataíde e Oliveira'),
(1787, 179, 'União das Freguesias de Vila Garcia, Aboim e Chapa'),
(1788, 180, 'Frende'),
(1789, 180, 'Gestaço'),
(1790, 180, 'Gove'),
(1791, 180, 'Grilo'),
(1792, 180, 'Loivos do Monte'),
(1793, 180, 'Santa Marinha do Zêzere'),
(1794, 180, 'Valadares'),
(1795, 180, 'Viariz'),
(1796, 180, 'União das Freguesias de Ancede e Ribadouro'),
(1797, 180, 'União das Freguesias de Baião (Santa Leocádia) e Mesquinhata'),
(1798, 180, 'União das Freguesias de Campelo e Ovil'),
(1799, 180, 'União das Freguesias de Loivos da Ribeira e Tresouras'),
(1800, 180, 'União das Freguesias de Santa Cruz do Douro e São Tomé de Covelas'),
(1801, 180, 'União das Freguesias de Teixeira e Teixeiró'),
(1802, 181, 'Aião'),
(1803, 181, 'Airães'),
(1804, 181, 'Friande'),
(1805, 181, 'Idães'),
(1806, 181, 'Jugueiros'),
(1807, 181, 'Penacova'),
(1808, 181, 'Pinheiro'),
(1809, 181, 'Pombeiro de Ribavizela'),
(1810, 181, 'Refontoura'),
(1811, 181, 'Regilde'),
(1812, 181, 'Revinhade'),
(1813, 181, 'Sendim'),
(1814, 181, 'União das Freguesias de Macieira da Lixa e Caramos'),
(1815, 181, 'União das Freguesias de Margaride (Santa Eulália), Várzea, Lagares, Varziela e Moure'),
(1816, 181, 'União das Freguesias de Pedreira, Rande e Sernande'),
(1817, 181, 'União das Freguesias de Torrados e Sousa'),
(1818, 181, 'União das Freguesias de Unhão e Lordelo'),
(1819, 181, 'União das Freguesias de Vila Cova Da Lixa e Borba de Godim'),
(1820, 181, 'União das Freguesias de Vila Fria e Vizela (São Jorge)'),
(1821, 181, 'União das Freguesias de Vila Verde e Santão'),
(1822, 182, 'Lomba'),
(1823, 182, 'Rio Tinto'),
(1824, 182, 'Baguim do Monte (Rio Tinto)'),
(1825, 182, 'União das Freguesias de Fânzeres e São Pedro da Cova'),
(1826, 182, 'União das Freguesias de Foz do Sousa e Covelo'),
(1827, 182, 'União das Freguesias de Gondomar (São Cosme), Valbom e Jovim'),
(1828, 182, 'União das Freguesias de Melres e Medas'),
(1829, 183, 'Aveleda'),
(1830, 183, 'Caide de Rei'),
(1831, 183, 'Lodares'),
(1832, 183, 'Macieira'),
(1833, 183, 'Meinedo'),
(1834, 183, 'Nevogilde'),
(1835, 183, 'Sousela'),
(1836, 183, 'Torno'),
(1837, 183, 'Vilar do Torno e Alentem'),
(1838, 183, 'União das Freguesias de Cernadelo e Lousada (São Miguel e Santa Margarida)'),
(1839, 183, 'União das Freguesias de Cristelos, Boim e Ordem'),
(1840, 183, 'União das Freguesias de Figueiras e Covas'),
(1841, 183, 'União das Freguesias de Lustosa e Barrosas (Santo Estêvão)'),
(1842, 183, 'União das Freguesias de Nespereira e Casais'),
(1843, 183, 'União das Freguesias de Silvares, Pias, Nogueira e Alvarenga'),
(1844, 184, 'Aguas Santas'),
(1845, 184, 'Folgosa'),
(1846, 184, 'Milheiros'),
(1847, 184, 'Moreira'),
(1848, 184, 'S. Pedro Fins'),
(1849, 184, 'Vila Nova da Telha'),
(1850, 184, 'Pedrouços'),
(1851, 185, 'Castêlo da Maia'),
(1852, 185, 'Cidade da Maia'),
(1853, 185, 'Nogueira e Silva Escura'),
(1854, 185, 'Banho e Carvalhosa'),
(1855, 185, 'Constance'),
(1856, 185, 'Soalhães'),
(1857, 185, 'Sobretamega'),
(1858, 185, 'Tabuado'),
(1859, 185, 'Vila Boa do Bispo'),
(1860, 185, 'Alpendorada, Várzea e Torrão'),
(1861, 185, 'Avessadas e Rosém'),
(1862, 185, 'Bem Viver'),
(1863, 185, 'Livração'),
(1864, 185, 'Marco'),
(1865, 185, 'Paredes de Viadores e Manhuncelos'),
(1866, 185, 'Penhalonga e Paços de Gaiolo'),
(1867, 185, 'Sande e São Lourenço'),
(1868, 185, 'Várzea, Aliviada e Folhada'),
(1869, 185, 'Vila Boa De Quires e Maureles'),
(1870, 186, 'União das Freguesias de Custóias, Leça do Balio e Guifões'),
(1871, 186, 'União das Freguesias de Matosinhos e Leça da Palmeira'),
(1872, 186, 'União das Freguesias de Perafita, Lavra e Santa Cruz do Bispo'),
(1873, 186, 'União das Freguesias de São Mamede de Infesta e Senhora da Hora'),
(1874, 187, 'Carvalhosa'),
(1875, 187, 'Eiriz'),
(1876, 187, 'Ferreira'),
(1877, 187, 'Figueiro'),
(1878, 187, 'Freamunde'),
(1879, 187, 'Meixomil'),
(1880, 187, 'Penamaior'),
(1881, 187, 'Raimonda'),
(1882, 187, 'Seroa'),
(1883, 187, 'Frazão Arreigada'),
(1884, 187, 'Paços de Ferreira'),
(1885, 187, 'Sanfins Lamoso Codessos'),
(1886, 188, 'Aguiar de Sousa'),
(1887, 188, 'Astromil'),
(1888, 188, 'Baltar'),
(1889, 188, 'Beire'),
(1890, 188, 'Cete'),
(1891, 188, 'Cristelo'),
(1892, 188, 'Duas Igrejas'),
(1893, 188, 'Gandra'),
(1894, 188, 'Lordelo'),
(1895, 188, 'Louredo'),
(1896, 188, 'Parada de Todeia'),
(1897, 188, 'Rebordosa'),
(1898, 188, 'Recarei'),
(1899, 188, 'Sobreira'),
(1900, 188, 'Sobrosa'),
(1901, 188, 'Vandoma'),
(1902, 188, 'Vilela'),
(1903, 188, 'Paredes'),
(1904, 189, 'Abragão'),
(1905, 189, 'Boelhe'),
(1906, 189, 'Bustelo'),
(1907, 189, 'Cabeça Santa'),
(1908, 189, 'Canelas'),
(1909, 189, 'Capela'),
(1910, 189, 'Castelões'),
(1911, 189, 'Croca'),
(1912, 189, 'Duas Igrejas'),
(1913, 189, 'Eja'),
(1914, 189, 'Fonte Arcada'),
(1915, 189, 'Galegos'),
(1916, 189, 'Irivo'),
(1917, 189, 'Oldrões'),
(1918, 189, 'Paço de Sousa'),
(1919, 189, 'Perozelo'),
(1920, 189, 'Rans'),
(1921, 189, 'Rio de Moinhos'),
(1922, 189, 'Recezinhos (S. Mamede)'),
(1923, 189, 'Recezinhos (S. Martinho)'),
(1924, 189, 'Sebolido'),
(1925, 189, 'Valpedre'),
(1926, 189, 'Rio Mau'),
(1927, 189, 'Penafiel'),
(1928, 189, 'Luzim e Vila Cova'),
(1929, 189, 'Guilhufe e Urrô'),
(1930, 189, 'Lagares e Figueira'),
(1931, 189, 'Termas de São Vicente'),
(1932, 190, 'Bonfim'),
(1933, 190, 'Campanhã'),
(1934, 190, 'Paranhos'),
(1935, 190, 'Ramalde'),
(1936, 190, 'União das Freguesias de Aldoar, Foz do Douro e Nevogilde'),
(1937, 190, 'União das Freguesias de Cedofeita, Santo Ildefonso, Sé, Miragaia, São Nicolau e Vitória'),
(1938, 190, 'União das Freguesias de Lordelo do Ouro e Massarelos'),
(1939, 191, 'Balazar'),
(1940, 191, 'Estela'),
(1941, 191, 'Laundos'),
(1942, 191, 'Rates'),
(1943, 191, 'União das Freguesias de Aver-o-Mar, Amorim e Terroso'),
(1944, 191, 'União das Freguesias de Aguçadoura e Navais'),
(1945, 191, 'União das Freguesias da Póvoa de Varzim, Beiriz e Argivai'),
(1946, 192, 'Agrela'),
(1947, 192, 'Agua Longa'),
(1948, 192, 'Aves'),
(1949, 192, 'Monte Cordova'),
(1950, 192, 'Rebordões'),
(1951, 192, 'Reguenga'),
(1952, 192, 'Roriz'),
(1953, 192, 'Negrelos (S. Tome)'),
(1954, 192, 'Vilarinho'),
(1955, 192, 'União das Freguesias de Areias, Sequeiró, Lama e Palmeira'),
(1956, 192, 'União das Freguesias de Campo (São Martinho), São Salvador do Campo e Negrelos (São Mamede)'),
(1957, 192, 'União das Freguesias de Carreira e Refojos de Riba de Ave'),
(1958, 192, 'União das Freguesias de Lamelas e Guimarei'),
(1959, 192, 'União das Freguesias de Santo Tirso, Couto (Santa Cristina e São Miguel) e Burgães'),
(1960, 193, 'Alfena'),
(1961, 193, 'Ermesinde'),
(1962, 193, 'Valongo'),
(1963, 193, 'União das Freguesias de Campo e Sobrado'),
(1964, 194, 'Arvore'),
(1965, 194, 'Aveleda'),
(1966, 194, 'Azurara'),
(1967, 194, 'Fajozes'),
(1968, 194, 'Gião'),
(1969, 194, 'Guilhabreu'),
(1970, 194, 'Junqueira'),
(1971, 194, 'Labruge'),
(1972, 194, 'Macieira da Maia'),
(1973, 194, 'Mindelo'),
(1974, 194, 'Modivas'),
(1975, 194, 'Vila Chã'),
(1976, 194, 'Vila do Conde'),
(1977, 194, 'Vilar de Pinheiro'),
(1978, 194, 'União das Freguesias de Bagunte, Ferreiró, Outeiro Maior e Parada'),
(1979, 194, 'União das Freguesias de Fornelo e Vairão'),
(1980, 194, 'União das Freguesias de Malta e Canidelo'),
(1981, 194, 'União das Freguesias de Retorta e Tougues'),
(1982, 194, 'União das Freguesias de Rio Mau e Arcos'),
(1983, 194, 'União das Freguesias de Touguinha e Touguinhó'),
(1984, 194, 'União das Freguesias de Vilar e Mosteiró'),
(1985, 195, 'Arcozelo'),
(1986, 195, 'Avintes'),
(1987, 195, 'Canelas'),
(1988, 195, 'Canidelo'),
(1989, 195, 'Madalena'),
(1990, 195, 'Oliveira do Douro'),
(1991, 195, 'S. Felix da Marinha'),
(1992, 195, 'Vilar de Andorinho'),
(1993, 195, 'União das Freguesias de Grijó e Sermonde'),
(1994, 195, 'União das Freguesias de Gulpilhares e Valadares'),
(1995, 195, 'União das Freguesias de Mafamude e Vilar do Paraíso'),
(1996, 195, 'União das Freguesias de Pedroso e Seixezelo'),
(1997, 195, 'União das Freguesias de Sandim, Olival, Lever e Crestuma'),
(1998, 195, 'União das Freguesias de Santa Marinha e São Pedro da Afurada'),
(1999, 195, 'União das Freguesias de Serzedo e Perosinho'),
(2000, 196, 'Covelas'),
(2001, 196, 'Muro'),
(2002, 196, 'União das Freguesias de Alvarelhos e Guidões'),
(2003, 196, 'União das Freguesias de Bougado (São Martinho e Santiago)'),
(2004, 196, 'União das Freguesias de Coronado (São Romão e São Mamede)'),
(2005, 197, 'Bemposta'),
(2006, 197, 'Martinchel'),
(2007, 197, 'Mouriscas'),
(2008, 197, 'Pego'),
(2009, 197, 'Rio de Moinhos'),
(2010, 197, 'Tramagal'),
(2011, 197, 'Fontes'),
(2012, 197, 'Carvalhal'),
(2013, 197, 'União das Freguesias de Abrantes (São Vicente e São João) e Alferrarede'),
(2014, 197, 'União das Freguesias de Aldeia do Mato e Souto'),
(2015, 197, 'União das Freguesias de Alvega e Concavada'),
(2016, 197, 'União das Freguesias de São Facundo e Vale das Mós'),
(2017, 197, 'União das Freguesias de São Miguel do Rio Torto e Rossio ao Sul do Tejo'),
(2018, 198, 'Bugalhos'),
(2019, 198, 'Minde'),
(2020, 198, 'Moitas Venda'),
(2021, 198, 'Monsanto'),
(2022, 198, 'Serra de Santo Antonio'),
(2023, 198, 'União das Freguesias de Alcanena e Vila Moreira'),
(2024, 198, 'União das Freguesias de Malhou, Louriceira e Espinheiro'),
(2025, 199, 'Almeirim'),
(2026, 199, 'Benfica do Ribatejo'),
(2027, 199, 'Fazendas de Almeirim'),
(2028, 199, 'Raposa'),
(2029, 200, 'Alpiarça'),
(2030, 201, 'Benavente'),
(2031, 201, 'Samora Correia'),
(2032, 201, 'Santo Estevão'),
(2033, 201, 'Barrosa'),
(2034, 202, 'Pontevel'),
(2035, 202, 'Valada'),
(2036, 202, 'Vila Chã de Ourique'),
(2037, 202, 'Vale da Pedra'),
(2038, 202, 'União Das Freguesias do Cartaxo e Vale da Pinta'),
(2039, 202, 'União das Freguesias de Ereira e Lapa'),
(2040, 203, 'Ulme'),
(2041, 203, 'Vale de Cavalos'),
(2042, 203, 'Carregueira'),
(2043, 203, 'União das Freguesias da Chamusca e Pinheiro Grande'),
(2044, 203, 'União das Freguesias de Parreira e Chouto'),
(2045, 204, 'Constancia'),
(2046, 204, 'Montalvo'),
(2047, 204, 'Santa Margarida da Coutada'),
(2048, 205, 'Couço'),
(2049, 205, 'S. Jose da Lamarosa'),
(2050, 205, 'Branca'),
(2051, 205, 'Biscainho'),
(2052, 205, 'Santana do Mato'),
(2053, 205, 'União das Freguesias de Coruche, Fajarda e Erra'),
(2054, 206, 'Entroncamento'),
(2055, 206, 'Nossa Sra de Fatima'),
(2056, 206, 'São João Baptista'),
(2057, 207, 'Aguas Belas'),
(2058, 207, 'Beco'),
(2059, 207, 'Chãos'),
(2060, 207, 'Ferreira do Zêzere'),
(2061, 207, 'Igreja Nova do Sobral'),
(2062, 207, 'Nossa Senhora do Pranto'),
(2063, 207, 'União das Freguesias de Areias e Pias'),
(2064, 208, 'Azinhaga'),
(2065, 208, 'Golegã'),
(2066, 209, 'Amendoa'),
(2067, 209, 'Cardigos'),
(2068, 209, 'Carvoeiro'),
(2069, 209, 'Envendos'),
(2070, 209, 'Ortiga'),
(2071, 209, 'União das Freguesias de Mação, Penhascoso e Aboboreira'),
(2072, 210, 'Alcobertas'),
(2073, 210, 'Arrouquelas'),
(2074, 210, 'Fraguas'),
(2075, 210, 'Rio Maior'),
(2076, 210, 'Asseiceira'),
(2077, 210, 'S. Sebastião'),
(2078, 210, 'União das Freguesias de Azambujeira e Malaqueijo'),
(2079, 210, 'União das Freguesias de Marmeleira e Assentiz'),
(2080, 210, 'União das Freguesias de Outeiro da Cortiçada e Arruda dos Pisões'),
(2081, 210, 'União das Freguesias de São João da Ribeira e Ribeira de São João'),
(2082, 211, 'Marinhais'),
(2083, 211, 'Muge'),
(2084, 211, 'União das Freguesias de Glória do Ribatejo e Granho'),
(2085, 211, 'União das Freguesias de Salvaterra de Magos e Foros de Salvaterra'),
(2086, 212, 'Abitureiras'),
(2087, 212, 'Abrã'),
(2088, 212, 'Alcanede'),
(2089, 212, 'Alcanhões'),
(2090, 212, 'Almoster'),
(2091, 212, 'Amiais de Baixo'),
(2092, 212, 'Arneiro das Milhariças'),
(2093, 212, 'Moçarria'),
(2094, 212, 'Pernes'),
(2095, 212, 'Pombalinho'),
(2096, 212, 'Povoa da Isenta'),
(2097, 212, 'Vale de Santarem'),
(2098, 212, 'Gançaria'),
(2099, 212, 'União das Freguesias de Achete, Azoia de Baixo e Póvoa de Santarém'),
(2100, 212, 'União das Freguesias de Azoia de Cimae Tremês'),
(2101, 212, 'União das Freguesias de Casével e Vaqueiros'),
(2102, 212, 'União das Freguesias de Romeira e Várzea'),
(2103, 212, 'União das Freguesias de Santarém (Marvila), Santa Iria da Ribeira de Santarém, Santarém (São Salvado'),
(2104, 212, 'União das Freguesias de São Vicente do Paul e Vale de Figueira'),
(2105, 213, 'Alcaravela'),
(2106, 213, 'Santiago de Montalegre'),
(2107, 213, 'Sardoal'),
(2108, 213, 'Valhascos'),
(2109, 214, 'Asseiceira'),
(2110, 214, 'Carregueiros'),
(2111, 214, 'Olalhas'),
(2112, 214, 'Paialvo'),
(2113, 214, 'S. Pedro de Tomar'),
(2114, 214, 'Sabacheira'),
(2115, 214, 'União das Freguesias de Além da Ribeira e Pedreira'),
(2116, 214, 'União das Freguesias de Casais e Alviobeira'),
(2117, 214, 'União das Freguesias de Madalena e Beselga'),
(2118, 214, 'União das Freguesias de Serra e Junceira'),
(2119, 214, 'União das Freguesias de Tomar (São João Baptista) e Santa Maria dos Olivais'),
(2120, 215, 'Assentiz'),
(2121, 215, 'Chancelaria'),
(2122, 215, 'Pedrogão'),
(2123, 215, 'Riachos'),
(2124, 215, 'Zibreira'),
(2125, 215, 'Meia Via'),
(2126, 215, 'União das Freguesias de Brogueira, Parceiros de Igreja e Alcorochel'),
(2127, 215, 'União das Freguesias de Olaia e Paço'),
(2128, 215, 'União das Freguesias de Torres Novas (Santa Maria, Salvador e Santiago)'),
(2129, 215, 'União das Freguesias de Torres Novas (São Pedro), Lapas e Ribeira Branca'),
(2130, 216, 'Atalaia'),
(2131, 216, 'Praia do Ribatejo'),
(2132, 216, 'Tancos'),
(2133, 216, 'Vila Nova da Barquinha'),
(2134, 217, 'Alburitel'),
(2135, 217, 'Atouguia'),
(2136, 217, 'Caxarias'),
(2137, 217, 'Espite'),
(2138, 217, 'Fatima'),
(2139, 217, 'Nossa Senhora das Misericordias'),
(2140, 217, 'Seiça'),
(2141, 217, 'Urqueira'),
(2142, 217, 'Nossa Senhora da Piedade'),
(2143, 217, 'União das Freguesias de Freixianda, Ribeira do Fárrio e Formigais'),
(2144, 217, 'União das Freguesias de Gondemaria e Olival'),
(2145, 217, 'União das Freguesias de Matas e Cercal'),
(2146, 217, 'União das Freguesias de Rio de Couros e Casal dos Bernardos'),
(2147, 218, 'Torrão'),
(2148, 218, 'S. Martinho'),
(2149, 218, 'Comporta'),
(2150, 218, 'União das Freguesias de Alcácer do Sal (Santa Maria do Castelo e Santiago) e Santa Susana'),
(2151, 219, 'Alcochete'),
(2152, 219, 'Samouco'),
(2153, 219, 'S. Francisco'),
(2154, 220, 'Costa da Caparica'),
(2155, 220, 'União das Freguesias de Almada, Cova da Piedade, Pragal e Cacilhas'),
(2156, 220, 'União das Freguesias de Caparica e Trafaria'),
(2157, 220, 'União das Freguesias de Charneca de Caparica e Sobreda'),
(2158, 220, 'União das Freguesias de Laranjeiro e Feijó'),
(2159, 221, 'Santo Antonio da Charneca'),
(2160, 221, 'União das Freguesias de Alto do Seixalinho, Santo André e Verderena'),
(2161, 221, 'União das Freguesias de Barreiro e Lavradio'),
(2162, 221, 'União das Freguesias de Palhais e Coina'),
(2163, 222, 'Azinheira Dos Barros e São Mamede do Sádão'),
(2164, 222, 'Melides'),
(2165, 222, 'Carvalhal'),
(2166, 222, 'União das Freguesias de Grândola e Santa Margarida da Serra'),
(2167, 223, 'Alhos Vedros'),
(2168, 223, 'Moita'),
(2169, 223, 'União das Freguesias de Baixa da Banheira e Vale da Amoreira'),
(2170, 223, 'União das Freguesias de Gaio-Rosário e Sarilhos Pequenos'),
(2171, 224, 'Canha'),
(2172, 224, 'Sarilhos Grandes'),
(2173, 224, 'União das Freguesias de Atalaia e Alto Estanqueiro-Jardia'),
(2174, 224, 'União das Freguesias de Montijo e Afonsoeiro'),
(2175, 224, 'União das Freguesias de Pegões'),
(2176, 225, 'Palmela'),
(2177, 225, 'Pinhal Novo'),
(2178, 225, 'Quinta do Anjo'),
(2179, 225, 'União das Freguesias de Poceirão e Marateca'),
(2180, 226, 'Abela'),
(2181, 226, 'Alvalade'),
(2182, 226, 'Cercal'),
(2183, 226, 'Ermidas-Sado'),
(2184, 226, 'Santo Andre'),
(2185, 226, 'S. Francisco da Serra'),
(2186, 226, 'União das Freguesias de Santiago do Cacém, Santa Cruz e São Bartolomeu da Serra'),
(2187, 226, 'União das Freguesias de São Domingos e Vale de Água'),
(2188, 227, 'Amora'),
(2189, 227, 'Corroios'),
(2190, 227, 'Fernão Ferro'),
(2191, 227, 'União das Freguesias do Seixal, Arrentela e Aldeia de Paio Pires'),
(2192, 228, 'Sesimbra (Castelo)'),
(2193, 228, 'Sesimbra (Santiago)'),
(2194, 228, 'Quinta do Conde'),
(2195, 229, 'Setubal (S. Sebastião)'),
(2196, 229, 'Gambia-Pontes-Alto da Guerra'),
(2197, 229, 'Sado'),
(2198, 229, 'União das Freguesias de Azeitão (São Lourenço e São Simão)'),
(2199, 229, 'União das Freguesias de Setúbal (São Julião, Nossa Senhora da Anunciada e Santa Maria da Graça)'),
(2200, 230, 'Sines'),
(2201, 230, 'Porto Covo'),
(2202, 231, 'Aboim das Choças'),
(2203, 231, 'Aguiã'),
(2204, 231, 'Azere'),
(2205, 231, 'Cabana Maior'),
(2206, 231, 'Cabreiro'),
(2207, 231, 'Cendufe'),
(2208, 231, 'Couto'),
(2209, 231, 'Gavieira'),
(2210, 231, 'Gondoriz'),
(2211, 231, 'Miranda'),
(2212, 231, 'Onte Redondo'),
(2213, 231, 'Oliveira'),
(2214, 231, 'Paço'),
(2215, 231, 'Padroso'),
(2216, 231, 'Prozelo'),
(2217, 231, 'Rio Frio'),
(2218, 231, 'Rio de Moinhos'),
(2219, 231, 'Sabadim'),
(2220, 231, 'Jolda (S. Paio)'),
(2221, 231, 'Senharei'),
(2222, 231, 'Sistelo'),
(2223, 231, 'Soajo'),
(2224, 231, 'Vale'),
(2225, 231, 'União das Freguesias de Alvora e Loureda'),
(2226, 231, 'União das Freguesias de Arcos de Valdevez (São Paio) e Giela'),
(2227, 231, 'União das Freguesias de Arcos de Valdevez (Salvador), Vila Fonche e Parada'),
(2228, 231, 'União das Freguesias de Eiras E Mei'),
(2229, 231, 'União das Freguesias de Grade e Carralcova'),
(2230, 231, 'União das Freguesias de Guilhadeses e Santar'),
(2231, 231, 'União das Freguesias de Jolda (Madalena) e Rio Cabrão'),
(2232, 231, 'União das Freguesias de Padreiro (Salvador e Santa Cristina)'),
(2233, 231, 'União das Freguesias de Portela e Extremo'),
(2234, 231, 'União das Freguesias de São Jorge e Ermelo'),
(2235, 231, 'União das Freguesias de Souto e Tabaçô'),
(2236, 231, 'União das Freguesias de Távora (Santa Maria e São Vicente)'),
(2237, 231, 'União das Freguesias de Vilela, São Cosme e São Damião e Sá'),
(2238, 232, 'Âncora'),
(2239, 232, 'Argela'),
(2240, 232, 'Dem'),
(2241, 232, 'Lanhelas'),
(2242, 232, 'Riba de Âncora'),
(2243, 232, 'Seixas'),
(2244, 232, 'Vila Praia de Âncora'),
(2245, 232, 'Vilar de Mouros'),
(2246, 232, 'Vile'),
(2247, 232, 'União das Freguesias de Arga (Baixo, Cima e São João)'),
(2248, 232, 'União das Freguesias de Caminha (Matriz) e Vilarelho'),
(2249, 232, 'União das Freguesias de Gondar e Orbacém'),
(2250, 232, 'União das Freguesias de Moledo e Cristelo'),
(2251, 232, 'União das Freguesias de Venade e Azevedo'),
(2252, 233, 'Alvaredo'),
(2253, 233, 'Cousso'),
(2254, 233, 'Cristoval'),
(2255, 233, 'Fiães'),
(2256, 233, 'Gave'),
(2257, 233, 'Paderne'),
(2258, 233, 'Penso'),
(2259, 233, 'S. Paio'),
(2260, 233, 'União das Freguesias de Castro Laboreiro e Lamas de Mouro'),
(2261, 233, 'União das Freguesias de Chaviães e Paços'),
(2262, 233, 'União das Freguesias de Parada do Monte e Cubalhão'),
(2263, 233, 'União das Freguesias de Prado e Remoães'),
(2264, 233, 'União das Freguesias de Vila e Roussas'),
(2265, 234, 'Abedim'),
(2266, 234, 'Barbeita'),
(2267, 234, 'Barroças e Taias'),
(2268, 234, 'Bela'),
(2269, 234, 'Cambeses'),
(2270, 234, 'Lara'),
(2271, 234, 'Longos Vales'),
(2272, 234, 'Merufe'),
(2273, 234, 'Moreira'),
(2274, 234, 'Pias'),
(2275, 234, 'Pinheiros'),
(2276, 234, 'Podame'),
(2277, 234, 'Portela'),
(2278, 234, 'Riba de Mouro'),
(2279, 234, 'Segude'),
(2280, 234, 'Tangil'),
(2281, 234, 'Trute'),
(2282, 234, 'União das Freguesias de Anhões e Luzio'),
(2283, 234, 'União das Freguesias de Ceivães e Badim'),
(2284, 234, 'União das Freguesias de Mazedo e Cortes'),
(2285, 234, 'União das Freguesias de Messegães, Valadares e Sá'),
(2286, 234, 'União das Freguesias de Monção e Troviscoso'),
(2287, 234, 'União das Freguesias de Sago, Lordelo e Parada'),
(2288, 234, 'União das Freguesias de Troporiz e Lapela'),
(2289, 235, 'Agualonga'),
(2290, 235, 'Castanheira'),
(2291, 235, 'Coura'),
(2292, 235, 'Cunha'),
(2293, 235, 'Infesta'),
(2294, 235, 'Mozelos'),
(2295, 235, 'Padornelo'),
(2296, 235, 'Parada'),
(2297, 235, 'Romarigães'),
(2298, 235, 'Rubiães'),
(2299, 235, 'Vascões'),
(2300, 235, 'União das Freguesias de Bico e Cristelo'),
(2301, 235, 'União das Freguesias de Cossourado e Linhares'),
(2302, 235, 'União das Freguesias de Formariz e Ferreira'),
(2303, 235, 'União das Freguesias de Insalde e Porreiras'),
(2304, 235, 'União das Freguesias de Paredes de Coura e Resende'),
(2305, 236, 'Azias'),
(2306, 236, 'Boivães'),
(2307, 236, 'Bravães'),
(2308, 236, 'Britelo'),
(2309, 236, 'Cuide de Vila Verde'),
(2310, 236, 'Lavradas'),
(2311, 236, 'Lindoso'),
(2312, 236, 'Nogueira'),
(2313, 236, 'Oleiros'),
(2314, 236, 'Sampriz'),
(2315, 236, 'Vade (S. Pedro)'),
(2316, 236, 'Vade (S. Tome)'),
(2317, 236, 'União das Freguesias de Crasto, Ruivos e Grovelas'),
(2318, 236, 'União das Freguesias de Entre Ambos-os-Rios, Ermida e Germil'),
(2319, 236, 'União das Freguesias de Ponte da Barca, Vila Nova de Muía e Paço Vedro de Magalhães'),
(2320, 236, 'União das Freguesias de Touvedo (São Lourenço e Salvador)'),
(2321, 236, 'União das Freguesias de Vila Chã (São João Baptista e Santiago)'),
(2322, 237, 'Anais'),
(2323, 237, 'São Pedro D\'Arcos'),
(2324, 237, 'Arcozelo'),
(2325, 237, 'Beiral Do Lima'),
(2326, 237, 'Bertiandos'),
(2327, 237, 'Boalhosa'),
(2328, 237, 'Brandara'),
(2329, 237, 'Calheiros'),
(2330, 237, 'Calvelo'),
(2331, 237, 'Correlhã'),
(2332, 237, 'Estorãos'),
(2333, 237, 'Facha'),
(2334, 237, 'Feitosa'),
(2335, 237, 'Fontão'),
(2336, 237, 'Friastelas'),
(2337, 237, 'Gandra'),
(2338, 237, 'Gemieira'),
(2339, 237, 'Gondufe'),
(2340, 237, 'Labruja'),
(2341, 237, 'Poiares'),
(2342, 237, 'Refoios do Lima'),
(2343, 237, 'Ribeira'),
(2344, 237, 'Sa'),
(2345, 237, 'Santa Comba'),
(2346, 237, 'Santa Cruz do Lima'),
(2347, 237, 'Rebordões (Santa Maria)'),
(2348, 237, 'Seara'),
(2349, 237, 'Serdedelo'),
(2350, 237, 'Rebordões (Souto)'),
(2351, 237, 'Vitorino das Donas'),
(2352, 237, 'Arca e Ponte de Lima'),
(2353, 237, 'Ardegão, Freixo e Mato'),
(2354, 237, 'Associação de Freguesias do Vale do Neiva'),
(2355, 237, 'Bárrio e Cepões'),
(2356, 237, 'Cabaços e Fojo Lobal'),
(2357, 237, 'Cabração e Moreira do Lima'),
(2358, 237, 'Fornelos e Queijada'),
(2359, 237, 'Labrujó, Rendufe e Vilar do Monte'),
(2360, 237, 'Navió e Vitorino dos Piães'),
(2361, 238, 'Boivão'),
(2362, 238, 'Cerdal'),
(2363, 238, 'Fontoura'),
(2364, 238, 'Friestas'),
(2365, 238, 'Ganfei'),
(2366, 238, 'S. Pedro da Torre'),
(2367, 238, 'Verdoejo'),
(2368, 238, 'União das Freguesias de Gandra e Taião'),
(2369, 238, 'União das Freguesias de Gondomil e Sanfins'),
(2370, 238, 'União das Freguesias de São Julião e Silva'),
(2371, 238, 'União das Freguesias de Valença, Cristelo Covo e Arão'),
(2372, 239, 'Afife'),
(2373, 239, 'Alvarães'),
(2374, 239, 'Amonde'),
(2375, 239, 'Vila Nova de Anha'),
(2376, 239, 'Areosa'),
(2377, 239, 'Carreço'),
(2378, 239, 'Castelo do Neiva'),
(2379, 239, 'Darque'),
(2380, 239, 'Freixieiro de Soutelo'),
(2381, 239, 'Lanheses'),
(2382, 239, 'Montaria'),
(2383, 239, 'Mujães'),
(2384, 239, 'São Romão de Neiva'),
(2385, 239, 'Outeiro'),
(2386, 239, 'Perre'),
(2387, 239, 'Santa Marta de Portuzelo'),
(2388, 239, 'Vila Franca'),
(2389, 239, 'Vila de Punhe'),
(2390, 239, 'Chafe'),
(2391, 239, 'União das Freguesias de Barroselas e Carvoeiro'),
(2392, 239, 'União das Freguesias de Cardielos e Serreleis'),
(2393, 239, 'União das Freguesias de Geraz do Lima (Santa Maria, Santa Leocádia e Moreira) e Deão'),
(2394, 239, 'União das Freguesias de Mazarefes e Vila Fria'),
(2395, 239, 'União das Freguesias de Nogueira, Meixedo e Vilar de Murteda'),
(2396, 239, 'União das Freguesias de Subportela, Deocriste e Portela Susã'),
(2397, 239, 'União das Freguesias de Torre e Vila Mou'),
(2398, 239, 'União das Freguesias de Viana do Castelo (Santa Maria Maior e Monserrate) e Meadela'),
(2399, 240, 'Cornes'),
(2400, 240, 'Covas'),
(2401, 240, 'Gondarem'),
(2402, 240, 'Loivo'),
(2403, 240, 'Mentrestido'),
(2404, 240, 'Sapardos'),
(2405, 240, 'Sopo'),
(2406, 240, 'União das Freguesias de Campos e Vila Meã'),
(2407, 240, 'União das Freguesias de Candemil e Gondar'),
(2408, 240, 'União das Freguesias de Reboreda e Nogueira'),
(2409, 240, 'União das Freguesias de Vila Nova de Cerveira e Lovelhe'),
(2410, 241, 'Alijó'),
(2411, 241, 'Favaios'),
(2412, 241, 'Pegarinhos'),
(2413, 241, 'Pinhão'),
(2414, 241, 'Sanfins do Douro'),
(2415, 241, 'Santa Eugenia'),
(2416, 241, 'S. Mamede de Ribatua'),
(2417, 241, 'Vila Chã'),
(2418, 241, 'Vila Verde'),
(2419, 241, 'Vilar de Maçada'),
(2420, 241, 'União das Freguesias de Carlão e Amieiro'),
(2421, 241, 'União das Freguesias de Castedo e Cotas'),
(2422, 241, 'União das Freguesias de Pópulo e Ribalonga'),
(2423, 241, 'União das Freguesias de Vale de Mendiz, Casal de Loivos e Vilarinho de Cotas'),
(2424, 242, 'Beça'),
(2425, 242, 'Covas do Barroso'),
(2426, 242, 'Dornelas'),
(2427, 242, 'Pinho'),
(2428, 242, 'Sapiãos'),
(2429, 242, 'Alturas do Barroso e Cerdedo'),
(2430, 242, 'Ardãos e Bobadela'),
(2431, 242, 'Boticas e Granja'),
(2432, 242, 'Codessoso, Curros e Fiães do Tâmega'),
(2433, 242, 'Vilar e Viveiro'),
(2434, 243, 'Aguas Frias'),
(2435, 243, 'Anelhe'),
(2436, 243, 'Bustelo'),
(2437, 243, 'Cimo de Vila da Castanheira'),
(2438, 243, 'Curalha'),
(2439, 243, 'Ervededo'),
(2440, 243, 'Faiões'),
(2441, 243, 'Lama de Arcos'),
(2442, 243, 'Mairos'),
(2443, 243, 'Moreiras'),
(2444, 243, 'Nogueira da Montanha'),
(2445, 243, 'Oura'),
(2446, 243, 'Outeiro Seco'),
(2447, 243, 'Paradela'),
(2448, 243, 'Redondelo'),
(2449, 243, 'Sanfins'),
(2450, 243, 'Santa Leocadia'),
(2451, 243, 'Santo Antonio de Monforte'),
(2452, 243, 'Santo Estevão'),
(2453, 243, 'S. Pedro de Agostem'),
(2454, 243, 'S. Vicente'),
(2455, 243, 'Tronco'),
(2456, 243, 'Vale De Anta'),
(2457, 243, 'Vila Verde da Raia'),
(2458, 243, 'Vilar de Nantes'),
(2459, 243, 'Vilarelho da Raia'),
(2460, 243, 'Vilas Boas'),
(2461, 243, 'Vilela Seca'),
(2462, 243, 'Vilela do Tâmega'),
(2463, 243, 'Santa Maria Maior'),
(2464, 243, 'Planalto de Monforte (União das Freguesias de Oucidres e Bobadela)'),
(2465, 243, 'União das Freguesias da Madalenae Samaiões'),
(2466, 243, 'União das Freguesias das Eiras, São Julião de Montenegro e Cela'),
(2467, 243, 'União das Freguesias de Calvão e Soutelinho da Raia'),
(2468, 243, 'União das Freguesias de Loivos e Póvoa De Agrações'),
(2469, 243, 'União das Freguesias de Santa Cruz/Trindade e Sanjurge'),
(2470, 243, 'União das Freguesias de Soutelo e Seara Velha'),
(2471, 243, 'União das Freguesias de Travancas e Roriz'),
(2472, 243, 'Vidago (União das Freguesias de Vidago, Arcossó, Selhariz e Vilarinho das Paranheiras)'),
(2473, 244, 'Barqueiros'),
(2474, 244, 'Cidadelhe'),
(2475, 244, 'Oliveira'),
(2476, 244, 'Vila Marim'),
(2477, 244, 'Mesão Frio (Santo André)'),
(2478, 255, 'Atei'),
(2479, 255, 'Bilhó'),
(2480, 255, 'Mondim de Basto'),
(2481, 255, 'Vilar de Ferreiros'),
(2482, 255, 'União das Freguesias de Campanhó e Paradança'),
(2483, 255, 'União das Freguesias de Ermelo e Pardelhas'),
(2484, 246, 'Cabril'),
(2485, 246, 'Cervos'),
(2486, 246, 'Chã'),
(2487, 246, 'Covelo do Gerês'),
(2488, 246, 'Ferral'),
(2489, 246, 'Gralhas'),
(2490, 246, 'Morgade'),
(2491, 246, 'Negrões'),
(2492, 246, 'Outeiro'),
(2493, 246, 'Pitões das Junias'),
(2494, 246, 'Reigoso'),
(2495, 246, 'Salto'),
(2496, 246, 'Santo André'),
(2497, 246, 'Sarraquinhos'),
(2498, 246, 'Solveira'),
(2499, 246, 'Tourem'),
(2500, 246, 'Vila da Ponte'),
(2501, 246, 'União das Freguesias de Cambeses do Rio, Donões e Mourilhe'),
(2502, 246, 'União das Freguesias de Meixedo e Padornelos'),
(2503, 246, 'União das Freguesias de Montalegre e Padroso'),
(2504, 246, 'União das Freguesias de Paradela, Contim e Fiães'),
(2505, 246, 'União das Freguesias de Sezelhe e Covelães'),
(2506, 246, 'União das Freguesias de Venda Nova e Pondras'),
(2507, 246, 'União das Freguesias de Viade de Baixo e Fervidelas'),
(2508, 246, 'União das Freguesias de Vilar de Perdizes e Meixide'),
(2509, 247, 'Candedo'),
(2510, 247, 'Fiolhoso'),
(2511, 247, 'Jou'),
(2512, 247, 'Murça'),
(2513, 247, 'Valongo de Milhais'),
(2514, 247, 'União das Freguesias de Carva e Vilares'),
(2515, 247, 'União das Freguesias de Noura e Palheiros'),
(2516, 248, 'Fontelas'),
(2517, 248, 'Loureiro'),
(2518, 248, 'Sedielos'),
(2519, 248, 'Vilarinho dos Freires'),
(2520, 248, 'União das Freguesias de Galafura e Covelinhas'),
(2521, 248, 'União das Freguesias de Moura Morta e Vinhós'),
(2522, 248, 'União das Freguesias de Peso da Régua e Godim'),
(2523, 248, 'União das Freguesias de Poiares e Canelas'),
(2524, 249, 'Alvadia'),
(2525, 249, 'Canedo'),
(2526, 249, 'Santa Marinha'),
(2527, 249, 'União das Freguesias de Cerva e Limões'),
(2528, 249, 'União das Freguesias de Ribeira de Pena (Salvador) e Santo Aleixo de Além-Tâmega'),
(2529, 250, 'Celeirós'),
(2530, 250, 'Covas do Douro'),
(2531, 250, 'Gouvinhas'),
(2532, 250, 'Parada de Pinhão'),
(2533, 250, 'Paços'),
(2534, 250, 'Sabrosa'),
(2535, 250, 'S. Lourenço de Ribapinhão'),
(2536, 250, 'Souto Maior'),
(2537, 250, 'Torre do Pinhão'),
(2538, 250, 'Vilarinho de S. Romão'),
(2539, 250, 'União das Freguesias de Provesende, Gouvães do Douro e São Cristóvão do Douro'),
(2540, 250, 'União das Freguesias de São Martinho de Antas e Paradela de Guiães'),
(2541, 251, 'Alvações do Corgo'),
(2542, 251, 'Cumieira'),
(2543, 251, 'Fontes'),
(2544, 251, 'Medrões'),
(2545, 251, 'Sever'),
(2546, 251, 'União das Freguesias de Lobrigos (São Miguel e São João Baptista) e Sanhoane'),
(2547, 251, 'União das Freguesias de Louredo e Fornelos'),
(2548, 252, 'Água Reves e Crasto'),
(2549, 252, 'Argeriz'),
(2550, 252, 'Bouçoães'),
(2551, 252, 'Canaveses'),
(2552, 252, 'Ervões'),
(2553, 252, 'Fornos do Pinhal'),
(2554, 252, 'Friões'),
(2555, 252, 'Padrela e Tazem'),
(2556, 252, 'Possacos'),
(2557, 252, 'Rio Torto'),
(2558, 252, 'Santa Maria de Emeres'),
(2559, 252, 'Santa Valha'),
(2560, 252, 'Santiago de Ribeira de Alhariz'),
(2561, 252, 'S. João da Corveira'),
(2562, 252, 'S. Pedro de Veiga de Lila'),
(2563, 252, 'Serapicos'),
(2564, 252, 'Vales'),
(2565, 252, 'Vassal'),
(2566, 252, 'Veiga de Lila'),
(2567, 252, 'Vilarandelo'),
(2568, 252, 'Carrazedo de Montenegro e Curros'),
(2569, 252, 'Lebução, Fiães e Nozelos'),
(2570, 252, 'Sonim e Barreiros'),
(2571, 252, 'Tinhela e Alvarelhos'),
(2572, 253, 'Valpaços e Sanfins'),
(2573, 253, 'Alfarela de Jales'),
(2574, 253, 'Bornes de Aguiar'),
(2575, 253, 'Bragado'),
(2576, 253, 'Capeludos'),
(2577, 253, 'Soutelo de Aguiar'),
(2578, 253, 'Telões'),
(2579, 253, 'Tresminas'),
(2580, 253, 'Valoura'),
(2581, 253, 'Vila Pouca de Aguiar'),
(2582, 253, 'Vreia de Bornes'),
(2583, 253, 'Vreia de Jales'),
(2584, 253, 'Sabroso de Aguiar'),
(2585, 253, 'Alvão'),
(2586, 253, 'União das Freguesias de Pensalvos e Parada de Monteiros'),
(2587, 254, 'Abaças'),
(2588, 254, 'Andrães'),
(2589, 254, 'Arroios'),
(2590, 254, 'Campeã'),
(2591, 254, 'Folhadela'),
(2592, 254, 'Guiães'),
(2593, 254, 'Lordelo'),
(2594, 254, 'Mateus'),
(2595, 254, 'Mondrões'),
(2596, 254, 'Parada de Cunhos'),
(2597, 254, 'Torgueda'),
(2598, 254, 'Vila Marim'),
(2599, 254, 'União das Freguesias de Adoufe e Vilarinho de Samardã'),
(2600, 254, 'União das Freguesias de Borbela e Lamas de Olo'),
(2601, 254, 'União das Freguesias de Constantim e Vale de Nogueiras'),
(2602, 254, 'União das Freguesias de Mouçós e Lamares'),
(2603, 254, 'União das Freguesias de Nogueira e Ermida'),
(2604, 254, 'União das Freguesias de Pena, Quintã e Vila Cova'),
(2605, 254, 'União das Freguesias de São Tomé do Castelo e Justes'),
(2606, 254, 'União das Freguesias de Vila Real (Nossa Senhora da Conceição, São Pedro e São Dinis)'),
(2607, 255, 'Aldeias'),
(2608, 255, 'Cimbres'),
(2609, 255, 'Folgosa'),
(2610, 255, 'Fontelo'),
(2611, 255, 'Queimada'),
(2612, 255, 'Queimadela'),
(2613, 255, 'Santa Cruz'),
(2614, 255, 'S. Cosmado'),
(2615, 255, 'S. Martinho das Chãs'),
(2616, 255, 'Vacalar'),
(2617, 255, 'Armamar'),
(2618, 255, 'União das Freguesias de Aricera e Goujoim'),
(2619, 255, 'União das Freguesias de São Romão e Santiago'),
(2620, 255, 'União das Freguesias de Vila Seca e Santo Adrião'),
(2621, 256, 'Beijos'),
(2622, 256, 'Cabanas de Viriato'),
(2623, 256, 'Oliveira do Conde'),
(2624, 256, 'Parada'),
(2625, 256, 'União das Freguesias de Currelos, Papízios e Sobral'),
(2626, 257, 'Almofala'),
(2627, 257, 'Cabril'),
(2628, 257, 'Castro Daire'),
(2629, 257, 'Cujo'),
(2630, 257, 'Gosende'),
(2631, 257, 'Mões'),
(2632, 257, 'Moledo'),
(2633, 257, 'Monteiras'),
(2634, 257, 'Pepim'),
(2635, 257, 'Pinheiro'),
(2636, 257, 'S. Joaninho'),
(2637, 257, 'União das Freguesias de Mamouros, Alva e Ribolhos'),
(2638, 257, 'União das Freguesias de Mezio e Moura Morta'),
(2639, 257, 'União das Freguesias de Parada de Ester e Ester'),
(2640, 257, 'União das Freguesias de Picão e Ermida'),
(2641, 257, 'União das Freguesias de Reriz e Gafanhão'),
(2642, 258, 'Cinfães'),
(2643, 258, 'Espadanedo'),
(2644, 258, 'Ferreiros de Tendais'),
(2645, 258, 'Fornelos'),
(2646, 258, 'Moimenta'),
(2647, 258, 'Nespereira'),
(2648, 258, 'Oliveira do Douro'),
(2649, 258, 'Santiago de Piães'),
(2650, 258, 'S. Cristovão de Nogueira'),
(2651, 258, 'Souselo'),
(2652, 258, 'Tarouquela'),
(2653, 258, 'Tendais'),
(2654, 258, 'Travanca'),
(2655, 258, 'União das Freguesias de Alhões, Bustelo, Gralheira e Ramires'),
(2656, 259, 'Avões'),
(2657, 259, 'Britiande'),
(2658, 259, 'Cambres'),
(2659, 259, 'Ferreirim'),
(2660, 259, 'Ferreiros de Avões'),
(2661, 259, 'Figueira'),
(2662, 259, 'Lalim'),
(2663, 259, 'Lazarim'),
(2664, 259, 'Penajoia'),
(2665, 259, 'Penude'),
(2666, 259, 'Samodães'),
(2667, 259, 'Sande'),
(2668, 259, 'Varzea de Abrunhais'),
(2669, 259, 'Vila Nova de Souto D El-Rei'),
(2670, 259, 'Lamego (Almacave e Sé)'),
(2671, 259, 'União das Freguesias de Bigorne, Magueija e Pretarouca'),
(2672, 259, 'União das Freguesias de Cepões, Meijinhos e Melcões'),
(2673, 259, 'União das Freguesias de Parada do Bispo e Valdigem'),
(2674, 260, 'Abrunhosa-a-Velha'),
(2675, 260, 'Alcafache'),
(2676, 260, 'Cunha Baixa'),
(2677, 260, 'Espinho'),
(2678, 260, 'Fornos de Maceira Dão'),
(2679, 260, 'Freixiosa'),
(2680, 260, 'Quintela de Azurara'),
(2681, 260, 'S. João Da Fresta'),
(2682, 260, 'União das Freguesias de Mangualde, Mesquitela e Cunha Alta'),
(2683, 260, 'União das Freguesias de Moimenta de Maceira Dão e Lobelhe do Mato'),
(2684, 260, 'União das Freguesias de Santiago de Cassurrães e Póvoa de Cervães'),
(2685, 260, 'União das Freguesias de Tavares (Chãs, Várzea e Travanca)'),
(2686, 261, 'Alvite'),
(2687, 261, 'Arcozelos'),
(2688, 261, 'Baldos'),
(2689, 261, 'Cabaços'),
(2690, 261, 'Caria'),
(2691, 261, 'Castelo'),
(2692, 261, 'Leomil'),
(2693, 261, 'Moimenta da Beira'),
(2694, 261, 'Passo'),
(2695, 261, 'Rua'),
(2696, 261, 'Sarzedo'),
(2697, 261, 'Sever'),
(2698, 261, 'Vilar'),
(2699, 261, 'União das Freguesias de Paradinha e Nagosa'),
(2700, 261, 'União das Freguesias de Pêra Velha, Aldeia de Nacomba e Ariz'),
(2701, 261, 'União das Freguesias de Peva e Segões'),
(2702, 262, 'Cercosa'),
(2703, 262, 'Espinho'),
(2704, 262, 'Marmeleira'),
(2705, 262, 'Pala'),
(2706, 262, 'Sobral'),
(2707, 262, 'Trezoi'),
(2708, 262, 'União das Freguesias de Mortágua, Vale de Remígio, Cortegaça e Almaça'),
(2709, 263, 'Canas de Senhorim'),
(2710, 263, 'Nelas'),
(2711, 263, 'Senhorim'),
(2712, 263, 'Vilar Seco'),
(2713, 263, 'Lapa do Lobo'),
(2714, 263, 'União das Freguesias de Carvalhal Redondo e Aguieira'),
(2715, 263, 'União das Freguesias de Santar e Moreira'),
(2716, 264, 'Arcozelo das Maias'),
(2717, 264, 'Pinheiro'),
(2718, 264, 'Ribeiradio'),
(2719, 264, 'S. João da Serra'),
(2720, 264, 'S. Vicente de Lafões'),
(2721, 264, 'União das Freguesias de Arca e Varzielas'),
(2722, 264, 'União das Freguesias de Destriz e Reigoso'),
(2723, 264, 'União das Freguesias de Oliveira de Frades, Souto de Lafões e Sejães'),
(2724, 265, 'Castelo de Penalva'),
(2725, 265, 'Esmolfe'),
(2726, 265, 'Germil'),
(2727, 265, 'Insua'),
(2728, 265, 'Lusinde'),
(2729, 265, 'Pindo'),
(2730, 265, 'Real'),
(2731, 265, 'Sezures'),
(2732, 265, 'Trancozelos'),
(2733, 265, 'União das Freguesias de Antas e Matela'),
(2734, 265, 'União das Freguesias de Vila Cova do Covelo/Mareco'),
(2735, 266, 'Beselga'),
(2736, 266, 'Castainço'),
(2737, 266, 'Penela da Beira'),
(2738, 266, 'Povoa de Penela'),
(2739, 266, 'Souto'),
(2740, 266, 'União das Freguesias de Antas e Ourozinho'),
(2741, 266, 'União das Freguesias de Penedono e Granja'),
(2742, 267, 'Barro'),
(2743, 267, 'Carquere'),
(2744, 267, 'Paus'),
(2745, 267, 'Resende'),
(2746, 267, 'S. Cipriano'),
(2747, 267, 'S. João de Fontoura'),
(2748, 267, 'S. Martinho de Mouros'),
(2749, 267, 'União das Freguesias de Anreade e São Romão de Aregos'),
(2750, 267, 'União das Freguesias de Felgueiras e Feirão'),
(2751, 267, 'União das Freguesias de Freigil e Miomães'),
(2752, 267, 'União das Freguesias de Ovadas e Panchorra'),
(2753, 268, 'Pinheiro de Azêre'),
(2754, 268, 'S. Joaninho'),
(2755, 268, 'S. João de Areias'),
(2756, 268, 'União das Freguesias de Ovoa e Vimieiro'),
(2757, 268, 'União das Freguesias de Santa Comba Dão e Couto do Mosteiro'),
(2758, 268, 'União das Freguesias de Treixedo e Nagozela'),
(2759, 269, 'Castanheiro do Sul'),
(2760, 269, 'Ervedosa do Douro'),
(2761, 269, 'Nagozelo do Douro'),
(2762, 269, 'Paredes da Beira'),
(2763, 269, 'Riodades'),
(2764, 269, 'Soutelo do Douro'),
(2765, 269, 'Vale de Figueira'),
(2766, 269, 'Valongo dos Azeites'),
(2767, 269, 'União das Freguesias de São João da Pesqueira e Várzea de Trevões'),
(2768, 269, 'União das Freguesias de Trevões e Espinhosa'),
(2769, 269, 'União das Freguesias de Vilarouco e Pereiros'),
(2770, 270, 'Bordonhos'),
(2771, 270, 'Figueiredo de Alva'),
(2772, 270, 'Manhouce'),
(2773, 270, 'Pindelo dos Milagres'),
(2774, 270, 'Pinho'),
(2775, 270, 'S. Félix'),
(2776, 270, 'Serrazes'),
(2777, 270, 'Sul'),
(2778, 270, 'Valadares'),
(2779, 270, 'Vila Maior'),
(2780, 270, 'União das Freguesias de Carvalhais e Candal'),
(2781, 270, 'União das Freguesias de Santa Cruz da Trapa e São Cristóvão de Lafões'),
(2782, 270, 'União das Freguesias de São Martinho das Moitase Covas do Rio'),
(2783, 270, 'União das Freguesias de São Pedro do Sul, Várzea e Baiões'),
(2784, 271, 'Avelal'),
(2785, 271, 'Ferreira de Aves'),
(2786, 271, 'Mioma'),
(2787, 271, 'Rio de Moinhos'),
(2788, 271, 'S. Miguel de Vila Boa'),
(2789, 271, 'Satão'),
(2790, 271, 'Silvã de Cima'),
(2791, 271, 'União das Freguesias de Águas Boas e Forles'),
(2792, 271, 'União das Freguesias de Romãs, Decermilo e Vila Longa'),
(2793, 272, 'Arnas'),
(2794, 272, 'Carregal');
INSERT INTO `freguesia` (`ID_Freguesia`, `ID_Concelho`, `Nome`) VALUES
(2795, 272, 'Chosendo'),
(2796, 272, 'Cunha'),
(2797, 272, 'Faia'),
(2798, 272, 'Granjal'),
(2799, 272, 'Lamosa'),
(2800, 272, 'Quintela'),
(2801, 272, 'Vila da Ponte'),
(2802, 272, 'União das Freguesias de Ferreirim e Macieira'),
(2803, 272, 'União das Freguesias de Fonte Arcada e Escurquela'),
(2804, 272, 'União das Freguesias de Penso e Freixinho'),
(2805, 272, 'União das Freguesias de Sernancelhe e Sarzeda'),
(2806, 273, 'Adorigo'),
(2807, 273, 'Arcos'),
(2808, 273, 'Chavães'),
(2809, 273, 'Desejosa'),
(2810, 273, 'Granja do Tedo'),
(2811, 273, 'Longa'),
(2812, 273, 'Sendim'),
(2813, 273, 'Tabuaço'),
(2814, 273, 'Valença do Douro'),
(2815, 273, 'União das Freguesias de Barcos e Santa Leocádia'),
(2816, 273, 'União das Freguesias de Paradela e Granjinha'),
(2817, 273, 'União das Freguesias de Pinheiros e Vale de Figueira'),
(2818, 273, 'União das Freguesias de Távora e Pereiro'),
(2819, 274, 'Mondim da Beira'),
(2820, 274, 'Salzedas'),
(2821, 274, 'S. João de Tarouca'),
(2822, 274, 'Varzea da Serra'),
(2823, 274, 'União das Freguesias de Gouviães e Ucanha'),
(2824, 274, 'União das Freguesias de Granja Nova e Vila Chã da Beira'),
(2825, 274, 'União das Freguesias de Tarouca e Dálvares'),
(2826, 275, 'Campo de Besteiros'),
(2827, 275, 'Canas de Santa Maria'),
(2828, 275, 'Castelões'),
(2829, 275, 'Dardavaz'),
(2830, 275, 'Ferreiros do Dão'),
(2831, 275, 'Guardão'),
(2832, 275, 'Lajeosa do Dão'),
(2833, 275, 'Lobão da Beira'),
(2834, 275, 'Molelos'),
(2835, 275, 'Parada de Gonta'),
(2836, 275, 'Santiago de Besteiros'),
(2837, 275, 'Tonda'),
(2838, 275, 'União das Freguesias de Barreiro de Besteiros e Tourigo'),
(2839, 275, 'União das Freguesias de Caparrosa e Silvares'),
(2840, 275, 'União das Freguesias de Mouraz e Vila Nova da Rainha'),
(2841, 275, 'União das Freguesias de São João do Monte e Mosteirinho'),
(2842, 275, 'União das Freguesias de São Miguel do Outeiro e Sabugosa'),
(2843, 275, 'União das Freguesias de Tondela e Nandufe'),
(2844, 275, 'União das Freguesias de Vilar de Besteiros e Mosteiro de Fráguas'),
(2845, 276, 'Pendilhe'),
(2846, 276, 'Queiriga'),
(2847, 276, 'Touro'),
(2848, 276, 'Vila Cova a Coelheira'),
(2849, 276, 'União das Freguesias de Vila Nova de Paiva, Alhais e Fráguas'),
(2850, 277, 'Abraveses'),
(2851, 277, 'Bodiosa'),
(2852, 277, 'Calde'),
(2853, 277, 'Campo'),
(2854, 277, 'Cavernães'),
(2855, 277, 'Cota'),
(2856, 277, 'Fragosela'),
(2857, 277, 'Lordosa'),
(2858, 277, 'Silgueiros'),
(2859, 277, 'Mundão'),
(2860, 277, 'Orgens'),
(2861, 277, 'Povolide'),
(2862, 277, 'Ranhados'),
(2863, 277, 'Ribafeita'),
(2864, 277, 'Rio de Loba'),
(2865, 277, 'Santos Evos'),
(2866, 277, 'S. João de Lourosa'),
(2867, 277, 'S. Pedro de France'),
(2868, 277, 'União das Freguesias de Barreiros e Cepões'),
(2869, 277, 'União das Freguesias de Boa Aldeia, Farminhão e Torredeita'),
(2870, 277, 'União das Freguesias de Couto de Baixo e Couto de Cima'),
(2871, 277, 'União das Freguesias de Faíl e Vila Chã de Sá'),
(2872, 277, 'União das Freguesias de Repeses e São Salvador'),
(2873, 277, 'União das Freguesias de São Cipriano e Vil de Souto'),
(2874, 277, 'União das Freguesias de Viseu'),
(2875, 278, 'Alcofra'),
(2876, 278, 'Campia'),
(2877, 278, 'Fornelo do Monte'),
(2878, 278, 'Queirã'),
(2879, 278, 'S. Miguel do Mato'),
(2880, 278, 'Ventosa'),
(2881, 278, 'União das Freguesias de Cambra e Carvalhal de Vermilhas'),
(2882, 278, 'União das Freguesias de Fataunços e Figueiredo das Donas'),
(2883, 278, 'União das Freguesias de Vouzela e Paços de Vilharigues'),
(2884, 279, 'Altares'),
(2885, 279, 'Doze Ribeiras'),
(2886, 279, 'Feteira'),
(2887, 279, 'Angra (Nossa Senhora da Conceição)'),
(2888, 279, 'Cinco Ribeiras'),
(2889, 279, 'Porto Judeu'),
(2890, 279, 'Raminho'),
(2891, 279, 'Ribeirinha'),
(2892, 279, 'Santa Barbara'),
(2893, 279, 'Angra (Santa Luzia)'),
(2894, 279, 'S. Bartolomeu de Regatos'),
(2895, 279, 'S. Bento'),
(2896, 279, 'S. Mateus da Calheta'),
(2897, 279, 'Angra (S. Pedro)'),
(2898, 279, 'S. Sebastião'),
(2899, 279, 'Angra (Se)'),
(2900, 279, 'Serreta'),
(2901, 279, 'Terra Chã'),
(2902, 279, 'Posto Santo'),
(2903, 280, 'Calheta'),
(2904, 280, 'Norte Pequeno'),
(2905, 280, 'Topo (Nossa Senhora do Rosario)'),
(2906, 280, 'Ribeira Seca'),
(2907, 280, 'Santo Antão'),
(2908, 281, 'Guadalupe'),
(2909, 281, 'Luz'),
(2910, 281, 'Santa Cruz da Graciosa'),
(2911, 281, 'São Mateus'),
(2912, 282, 'Norte Grande (Neves)'),
(2913, 282, 'Rosais'),
(2914, 282, 'Manadas (Santa Barbara)'),
(2915, 282, 'Santo Amaro'),
(2916, 282, 'Velas (S. Jorge)'),
(2917, 282, 'Urzelina (S. Mateus)'),
(2918, 283, 'Agualva'),
(2919, 283, 'Biscoitos'),
(2920, 283, 'Cabo da Praia'),
(2921, 283, 'Fonte do Bastardo'),
(2922, 283, 'Fontinhas'),
(2923, 283, 'Lajes'),
(2924, 283, 'Quatro Ribeiras'),
(2925, 283, 'Praia da Vitória (Santa Cruz)'),
(2926, 283, 'S. Bras'),
(2927, 283, 'Vila Nova'),
(2928, 283, 'Porto Martins'),
(2929, 284, 'Corvo'),
(2930, 285, 'Horta (Angustias)'),
(2931, 285, 'Capelo'),
(2932, 285, 'Castelo Branco'),
(2933, 285, 'Cedros'),
(2934, 285, 'Horta (Conceição)'),
(2935, 285, 'Feteira'),
(2936, 285, 'Flamengos'),
(2937, 285, 'Horta (Matriz)'),
(2938, 285, 'Pedro Miguel'),
(2939, 285, 'Praiad Almoxarife'),
(2940, 285, 'Praia do Norte'),
(2941, 285, 'Ribeirinha'),
(2942, 285, 'Salão'),
(2943, 286, 'Fajã Grande'),
(2944, 286, 'Fajãzinha'),
(2945, 286, 'Fazenda'),
(2946, 286, 'Lajedo'),
(2947, 286, 'Lajes das Flores'),
(2948, 286, 'Lomba'),
(2949, 286, 'Mosteiro'),
(2950, 287, 'Calheta de Nesquim'),
(2951, 287, 'Lajes do Pico'),
(2952, 287, 'Piedade'),
(2953, 287, 'Ribeiras'),
(2954, 287, 'S. João'),
(2955, 287, 'Ribeirinha'),
(2956, 288, 'Bandeiras'),
(2957, 288, 'Candelaria'),
(2958, 288, 'Criação Velha'),
(2959, 288, 'Madalena'),
(2960, 288, 'S. Caetano'),
(2961, 288, 'S. Mateus'),
(2962, 288, 'Caveira'),
(2963, 288, 'Cedros'),
(2964, 288, 'Ponta Delgada'),
(2965, 288, 'Santa Cruz das Flores'),
(2966, 290, 'Prainha'),
(2967, 290, 'Santa Luzia'),
(2968, 290, 'Santo Amaro'),
(2969, 290, 'Santo António'),
(2970, 290, 'S. Roque do Pico'),
(2971, 291, 'Água de Pau'),
(2972, 291, 'Lagoa (Nossa Senhora do Rosário)'),
(2973, 291, 'Ribeira Chã'),
(2974, 291, 'Lagoa (Santa Cruz)'),
(2975, 291, 'Cabouco'),
(2976, 292, 'Achada'),
(2977, 292, 'Achadinha'),
(2978, 292, 'Lomba da Fazenda'),
(2979, 292, 'Nordeste'),
(2980, 292, 'Santana'),
(2981, 292, 'Salga'),
(2982, 292, 'Algarvia'),
(2983, 292, 'Santo António de Nordestinho'),
(2984, 292, 'Sao Pedro de Nordestinho'),
(2985, 293, 'Arrifes'),
(2986, 293, 'Candelaria'),
(2987, 293, 'Capelas'),
(2988, 293, 'Fajã de Baixo'),
(2989, 293, 'Fajã de Cima'),
(2990, 293, 'Fenais da Luz'),
(2991, 293, 'Feteiras'),
(2992, 293, 'Ginetes'),
(2993, 293, 'Rosto do Cão (Livramento)'),
(2994, 293, 'Mosteiros'),
(2995, 293, 'Ponta Delgada (São Sebastião)'),
(2996, 293, 'Relva'),
(2997, 293, 'Remedios'),
(2998, 293, 'Santo António'),
(2999, 293, 'Ponta Delgada (S. José)'),
(3000, 293, 'Ponta Delgada (S. Pedro)'),
(3001, 293, 'Rosto do Cão (S. Roque)'),
(3002, 293, 'S. Vicente Ferreira'),
(3003, 293, 'Sete Cidades'),
(3004, 293, 'Covoada'),
(3005, 293, 'Santa Bárbara'),
(3006, 293, 'Ajuda da Bretanha'),
(3007, 293, 'Pilar da Bretanha'),
(3008, 293, 'Santa Clara'),
(3009, 294, 'Água Retorta'),
(3010, 294, 'Faial da Terra'),
(3011, 294, 'Nossa Senhora dos Remédios'),
(3012, 294, 'Furnas'),
(3013, 294, 'Povoação'),
(3014, 294, 'Ribeira Quente'),
(3015, 295, 'Calhetas'),
(3016, 295, 'Ribeira Grande (Conceição)'),
(3017, 295, 'Fenais da Ajuda'),
(3018, 295, 'Lomba da Maia'),
(3019, 295, 'Maia'),
(3020, 295, 'Pico da Pedra'),
(3021, 295, 'Porto Formoso'),
(3022, 295, 'Rabo de Peixe'),
(3023, 295, 'Ribeira Grande (Matriz)'),
(3024, 295, 'Ribeira Seca'),
(3025, 295, 'Ribeirinha'),
(3026, 295, 'Santa Bárbara'),
(3027, 295, 'Lomba de S. Pedro'),
(3028, 295, 'S. Brás'),
(3029, 296, 'Água De Alto'),
(3030, 296, 'Ponta Garça'),
(3031, 296, 'Vila Franca do Campo (S. Miguel)'),
(3032, 296, 'Vila Franca do Campo (S. Pedro)'),
(3033, 296, 'Ribeira das Tainhas'),
(3034, 296, 'Ribeira Seca'),
(3035, 297, 'Almagreira'),
(3036, 297, 'Santa Bárbara'),
(3037, 297, 'Santo Espírito'),
(3038, 297, 'S. Pedro'),
(3039, 297, 'Vila do Porto'),
(3040, 298, 'Arco Da Calheta'),
(3041, 298, 'Calheta'),
(3042, 298, 'Estreito da Calheta'),
(3043, 298, 'Fajã da Ovelha'),
(3044, 298, 'Jardim do Mar'),
(3045, 298, 'Paul do Mar'),
(3046, 298, 'Ponta do Pargo'),
(3047, 298, 'Prazeres'),
(3048, 299, 'Camara de Lobos'),
(3049, 299, 'Curral das Freiras'),
(3050, 299, 'Estreito de Camara de Lobos'),
(3051, 299, 'Quinta Grande'),
(3052, 299, 'Jardim da Serra'),
(3053, 300, 'Imaculado Coração de Maria'),
(3054, 300, 'Monte'),
(3055, 300, 'Funchal (Santa Luzia)'),
(3056, 300, 'Funchal (Santa Maria Maior)'),
(3057, 300, 'Santo António'),
(3058, 300, 'S. Gonçalo'),
(3059, 300, 'S. Martinho'),
(3060, 300, 'Funchal (S. Pedro)'),
(3061, 300, 'S. Roque'),
(3062, 300, 'Funchal (Sé)'),
(3063, 301, 'Agua de Pena'),
(3064, 301, 'Caniçal'),
(3065, 301, 'Machico'),
(3066, 301, 'Porto da Cruz'),
(3067, 301, 'Santo António da Serra'),
(3068, 302, 'Canhas'),
(3069, 302, 'Madalena do Mar'),
(3070, 302, 'Ponta do Sol'),
(3071, 303, 'Achadas da Cruz'),
(3072, 303, 'Porto Moniz'),
(3073, 303, 'Ribeira da Janela'),
(3074, 303, 'Seixal'),
(3075, 304, 'Porto Santo'),
(3076, 305, 'Campanario'),
(3077, 305, 'Ribeira Brava'),
(3078, 305, 'Serra de Água'),
(3079, 305, 'Tabua'),
(3080, 306, 'Camacha'),
(3081, 306, 'Caniço'),
(3082, 306, 'Gaula'),
(3083, 306, 'Santa Cruz'),
(3084, 306, 'Santo António da Serra'),
(3085, 307, 'Arco de S. Jorge'),
(3086, 307, 'Faial'),
(3087, 307, 'Santana'),
(3088, 307, 'S. Jorge'),
(3089, 307, 'S. Roque do Faial'),
(3090, 307, 'Ilha'),
(3091, 308, 'Boa Ventura'),
(3092, 308, 'Ponta Delgada'),
(3093, 308, 'S. Vicente');

CREATE TABLE `log` (
  `ID_Log` bigint(20) UNSIGNED NOT NULL,
  `ID_Utilizador` int(11) NOT NULL,
  `Nome` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `Data` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `Hora` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `ID_Modulo` int(11) NOT NULL,
  `Accao` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `Descricao` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `IP` varchar(100) COLLATE utf8_unicode_ci NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `modulo` (
  `ID_Modulo` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(500) NOT NULL,
  `ValorActivacao` decimal(10,2) NOT NULL,
  `ValorAnuidade` decimal(10,2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `modulo` (`ID_Modulo`, `Nome`, `ValorActivacao`, `ValorAnuidade`) VALUES
(1, 'GesCanídeo', '350.00', '60.00'),
(2, 'GesCemitério', '350.00', '150.00'),
(3, 'GesToponímia', '350.00', '80.00'),
(4, 'GesInventário', '350.00', '80.00'),
(5, 'GesDocumental', '350.00', '120.00'),
(6, 'GesPocal', '350.00', '200.00'),
(7, 'GesIncidentes', '350.00', '80.00'),
(8, 'GesPopulação', '350.00', '80.00'),
(9, 'GesSMS', '350.00', '80.00'),
(10, 'GesProcesso', '350.00', '80.00'),
(11, 'GesTarefa', '350.00', '80.00'),
(12, 'GesFaturacao', '350.00', '120.00');

CREATE TABLE `modulo_autarquia` (
  `ID_ModuloAutarquia` bigint(20) UNSIGNED NOT NULL,
  `ID_Modulo` int(11) NOT NULL,
  `Activo` tinyint(1) NOT NULL DEFAULT '0',
  `DataActivacao` varchar(100) NOT NULL,
  `DataValidade` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `modulo_autarquia` (`ID_ModuloAutarquia`, `ID_Modulo`, `Activo`, `DataActivacao`, `DataValidade`) VALUES
(1, 1, 0, '19/04/2016', '19/12/2017'),
(2, 2, 0, '19/04/2016', '19/12/2017'),
(3, 5, 0, '19/03/2016', '19/12/2017'),
(4, 3, 0, '25/04/2016', '24/12/2017'),
(5, 6, 0, '17/10/2016', '17/10/2017'),
(6, 9, 0, '21/12/2016', '21/12/2017'),
(7, 10, 0, '21/12/2016', '21/12/2017'),
(9, 11, 0, '21/12/2016', '21/12/2017'),
(10, 4, 1, '21/12/2016', '21/12/2018'),
(11, 12, 1, '20/05/2017', '20/05/2019');

CREATE TABLE `modulo_demo` (
  `ID_ModuloDemo` bigint(20) UNSIGNED NOT NULL,
  `ID_Modulo` int(11) NOT NULL,
  `Demo` tinyint(1) NOT NULL DEFAULT '0',
  `DataActivacao` varchar(100) NOT NULL,
  `DataValidade` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `pais` (
  `ID_Pais` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  `Codigo2` tinyint(1) NOT NULL DEFAULT '1',
  `Codigo3` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `pais` (`ID_Pais`, `Nome`, `Codigo2`, `Codigo3`) VALUES
(1, 'Afeganistão', 1, 1),
(3, 'África do Sul', 1, 1),
(4, 'Albânia', 1, 1),
(5, 'Alemanha', 1, 1),
(6, 'American Samoa', 1, 1),
(7, 'Andorra', 1, 1),
(8, 'Angola', 1, 1),
(9, 'Anguilla', 1, 1),
(10, 'Antígua e Barbuda', 1, 1),
(11, 'Antilhas Neerlandesas', 1, 1),
(12, 'Arábia Saudita', 1, 1),
(13, 'Argélia', 1, 1),
(14, 'Argentina', 1, 1),
(15, 'Arménia', 1, 1),
(16, 'Aruba', 1, 1),
(17, 'Austrália', 1, 1),
(18, 'Áustria', 1, 1),
(19, 'Azerbaijão', 1, 1),
(20, 'Bahamas', 1, 1),
(21, 'Bangladeche', 1, 1),
(22, 'Barbados', 1, 1),
(23, 'Barém', 1, 1),
(25, 'Bélgica', 1, 1),
(26, 'Belize', 1, 1),
(27, 'Benim', 1, 1),
(28, 'Bermudas', 1, 1),
(29, 'Bielorrússia', 1, 1),
(30, 'Bolívia', 1, 1),
(31, 'Bósnia-Herzegovina', 1, 1),
(32, 'Botswana', 1, 1),
(33, 'Brasil', 1, 1),
(34, 'Brunei Darussalam', 1, 1),
(35, 'Bulgária', 1, 1),
(36, 'Burquina Faso', 1, 1),
(37, 'Burundi', 1, 1),
(38, 'Butão', 1, 1),
(39, 'Cabo Verde', 1, 1),
(40, 'Camarões', 1, 1),
(41, 'Camboja', 1, 1),
(42, 'Canadá', 1, 1),
(43, 'Catar', 1, 1),
(44, 'Cazaquistão', 1, 1),
(45, 'Centro-Africana República', 1, 1),
(46, 'Chade', 1, 1),
(47, 'Chile', 1, 1),
(48, 'China', 1, 1),
(49, 'Chipre', 1, 1),
(50, 'Colômbia', 1, 1),
(51, 'Comores', 1, 1),
(52, 'Congo', 1, 1),
(53, 'Congo República Democrática', 1, 1),
(54, 'Coreia Do Norte', 1, 1),
(55, 'Coreia Do Sul', 1, 1),
(56, 'Costa Do Marfim', 1, 1),
(57, 'Costa Rica', 1, 1),
(58, 'Croácia', 1, 1),
(59, 'Cuba', 1, 1),
(60, 'Dinamarca', 1, 1),
(61, 'Domínica', 1, 1),
(62, 'Egipto', 1, 1),
(63, 'Emirados Árabes Unidos', 1, 1),
(64, 'Equador', 1, 1),
(65, 'Eritreia', 1, 1),
(66, 'Eslováquia', 1, 1),
(67, 'Eslovénia', 1, 1),
(68, 'Espanha', 1, 1),
(69, 'Estados Unidos', 1, 1),
(70, 'Estónia', 1, 1),
(71, 'Etiópia', 1, 1),
(72, 'Faixa De Gaza', 1, 1),
(73, 'Fiji', 1, 1),
(74, 'Filipinas', 1, 1),
(75, 'Finlândia', 1, 1),
(76, 'França', 1, 1),
(77, 'Gabão', 1, 1),
(78, 'Gâmbia', 1, 1),
(79, 'Gana', 1, 1),
(80, 'Geórgia', 1, 1),
(81, 'Gibraltar', 1, 1),
(82, 'Granada', 1, 1),
(83, 'Grécia', 1, 1),
(84, 'Gronelândia', 1, 1),
(85, 'Guadalupe', 1, 1),
(86, 'Guam', 1, 1),
(87, 'Guatemala', 1, 1),
(88, 'Guernsey', 1, 1),
(89, 'Guiana', 1, 1),
(90, 'Guiana Francesa', 1, 1),
(91, 'Guiné', 1, 1),
(92, 'Guiné Equatorial', 1, 1),
(93, 'Guiné-Bissau', 1, 1),
(94, 'Haiti', 1, 1),
(95, 'Honduras', 1, 1),
(96, 'Hong Kong', 1, 1),
(97, 'Hungria', 1, 1),
(98, 'Iémen', 1, 1),
(100, 'Ilha Christmas', 1, 1),
(103, 'Ilha do Homem', 1, 1),
(104, 'Ilha de Navassa', 1, 1),
(105, 'Ilha Europa', 1, 1),
(106, 'Ilha Norfolk', 1, 1),
(107, 'Ilha Tromelin', 1, 1),
(108, 'Ilhas Ashmore e Cartier', 1, 1),
(109, 'Ilhas Caiman', 1, 1),
(110, 'Ilhas Cocos (Keeling)', 1, 1),
(111, 'Ilhas Cook', 1, 1),
(112, 'Ilhas do Mar de Coral', 1, 1),
(113, 'Ilhas Falklands (Ilhas Malvinas)', 1, 1),
(114, 'Ilhas Feroe', 1, 1),
(115, 'Ilhas Geórgia do Sul e Sandwich do Sul', 1, 1),
(116, 'Ilhas Marianas do Norte', 1, 1),
(117, 'Ilhas Marshall', 1, 1),
(118, 'Ilhas Paracel', 1, 1),
(119, 'Ilhas Pitcairn', 1, 1),
(120, 'Ilhas Salomão', 1, 1),
(121, 'Ilhas Spratly', 1, 1),
(122, 'Ilhas Virgens Americanas', 1, 1),
(123, 'Ilhas Virgens Britânicas', 1, 1),
(124, 'Índia', 1, 1),
(125, 'Indonésia', 1, 1),
(126, 'Irão', 1, 1),
(127, 'Iraque', 1, 1),
(128, 'Irlanda', 1, 1),
(129, 'Islândia', 1, 1),
(130, 'Israel', 1, 1),
(131, 'Itália', 1, 1),
(132, 'Jamaica', 1, 1),
(133, 'Jan Mayen', 1, 1),
(134, 'Japão', 1, 1),
(135, 'Jersey', 1, 1),
(136, 'Jibuti', 1, 1),
(137, 'Jordânia', 1, 1),
(138, 'Kiribati', 1, 1),
(139, 'Koweit', 1, 1),
(140, 'Laos', 1, 1),
(141, 'Lesoto', 1, 1),
(142, 'Letónia', 1, 1),
(143, 'Líbano', 1, 1),
(144, 'Libéria', 1, 1),
(145, 'Líbia', 1, 1),
(146, 'Listenstaine', 1, 1),
(147, 'Lituânia', 1, 1),
(148, 'Luxemburgo', 1, 1),
(149, 'Macau', 1, 1),
(150, 'Macedónia', 1, 1),
(151, 'Madagáscar', 1, 1),
(152, 'Malásia', 1, 1),
(153, 'Malavi', 1, 1),
(154, 'Maldivas', 1, 1),
(155, 'Mali', 1, 1),
(156, 'Malta', 1, 1),
(157, 'Marrocos', 1, 1),
(158, 'Martinica', 1, 1),
(159, 'Maurícia', 1, 1),
(160, 'Mauritânia', 1, 1),
(161, 'Mayotte', 1, 1),
(162, 'México', 1, 1),
(163, 'Mianmar', 1, 1),
(164, 'Micronésia', 1, 1),
(165, 'Moçambique', 1, 1),
(166, 'Moldávia', 1, 1),
(167, 'Mónaco', 1, 1),
(168, 'Mongólia', 1, 1),
(169, 'Montenegro', 1, 1),
(170, 'Montserrat', 1, 1),
(171, 'Namíbia', 1, 1),
(172, 'Nauru', 1, 1),
(173, 'Nepal', 1, 1),
(174, 'Nicarágua', 1, 1),
(175, 'Níger', 1, 1),
(176, 'Nigéria', 1, 1),
(177, 'Niue', 1, 1),
(178, 'Noruega', 1, 1),
(179, 'Nova Caledónia', 1, 1),
(180, 'Nova Zelândia', 1, 1),
(181, 'Omã', 1, 1),
(182, 'Países Baixos', 1, 1),
(183, 'Palau', 1, 1),
(184, 'Palestina', 1, 1),
(185, 'Panamá', 1, 1),
(186, 'Papuásia-Nova Guiné', 1, 1),
(187, 'Paquistão', 1, 1),
(188, 'Paraguai', 1, 1),
(189, 'Peru', 1, 1),
(190, 'Polinésia Francesa', 1, 1),
(191, 'Polónia', 1, 1),
(192, 'Porto Rico', 1, 1),
(193, 'Portugal', 1, 1),
(194, 'Quénia', 1, 1),
(195, 'Quirguizistão', 1, 1),
(196, 'Reino Unido', 1, 1),
(197, 'República Checa', 1, 1),
(198, 'República Dominicana', 1, 1),
(199, 'Roménia', 1, 1),
(200, 'Ruanda', 1, 1),
(201, 'Rússia', 1, 1),
(202, 'Sahara Occidental', 1, 1),
(203, 'Salvador', 1, 1),
(204, 'Samoa', 1, 1),
(205, 'Santa Helena', 1, 1),
(206, 'Santa LúCia', 1, 1),
(207, 'Santa Sé', 1, 1),
(208, 'São Cristóvão e Neves', 1, 1),
(209, 'São Marino', 1, 1),
(210, 'São Pedro e Miquelão', 1, 1),
(211, 'São Tomé e Príncipe', 1, 1),
(212, 'São Vicente e Granadinas', 1, 1),
(213, 'Seicheles', 1, 1),
(214, 'Senegal', 1, 1),
(215, 'Serra Leoa', 1, 1),
(216, 'Sérvia', 1, 1),
(217, 'Singapura', 1, 1),
(218, 'Síria', 1, 1),
(219, 'Somália', 1, 1),
(220, 'Sri Lanca', 1, 1),
(221, 'Suazilândia', 1, 1),
(222, 'Sudão', 1, 1),
(223, 'Suécia', 1, 1),
(224, 'Suíça', 1, 1),
(225, 'Suriname', 1, 1),
(226, 'Svalbard', 1, 1),
(227, 'Tailândia', 1, 1),
(228, 'Taiwan', 1, 1),
(229, 'Tajiquistão', 1, 1),
(230, 'Tanzânia', 1, 1),
(231, 'Território Britânico do Oceano Índico', 1, 1),
(232, 'Território das Ilhas Heard e Mcdonald', 1, 1),
(233, 'Timor-Leste', 1, 1),
(234, 'Togo', 1, 1),
(235, 'Tokelau', 1, 1),
(236, 'Tonga', 1, 1),
(237, 'Trindade e Tobago', 1, 1),
(238, 'Tunísia', 1, 1),
(239, 'Turks e Caicos', 1, 1),
(240, 'Turquemenistão', 1, 1),
(241, 'Turquia', 1, 1),
(242, 'Tuvalu', 1, 1),
(243, 'Ucrânia', 1, 1),
(244, 'Uganda', 1, 1),
(245, 'Uruguai', 1, 1),
(246, 'Usbequistão', 1, 1),
(247, 'Vanuatu', 1, 1),
(248, 'Venezuela', 1, 1),
(249, 'Vietname', 1, 1),
(250, 'Wallis e Futuna', 1, 1),
(251, 'Zâmbia', 1, 1),
(252, 'Sudão do Sul', 1, 1),
(253, 'Zimbabwe', 1, 1),
(254, 'Bonaire', 1, 1),
(255, 'Curaçao', 1, 1);

CREATE TABLE `permissoes` (
  `ID_Permissao` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(500) NOT NULL,
  `Geral_Ano` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Inserir_Ano` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Editar_Ano` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Eliminar_Ano` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Banco` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Inserir_Banco` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Editar_Banco` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Eliminar_Banco` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Membro` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Inserir_Membro` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Editar_Membro` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Eliminar_Membro` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_MetodoPagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Inserir_MetodoPagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Editar_MetodoPagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Eliminar_MetodoPagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Profissao` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Inserir_Profissao` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Editar_Profissao` tinyint(1) NOT NULL DEFAULT '0',
  `Geral_Eliminar_Profissao` tinyint(1) NOT NULL DEFAULT '0',
  `GesCanideo` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Animal` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Animal` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Animal` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Detalhe_Animal` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Animal` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Abate` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Abate` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Abate` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Detalhe_Abate` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Abate` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Detalhe_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Detalhe_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Licenca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Licenca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Licenca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Detalhe_Licenca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Renovar_Licenca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Exportar_Licenca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Licenca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Detalhe_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Categoria` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Categoria` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Categoria` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Categoria` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Raca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Raca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Raca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Raca` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Veterinario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Inserir_Veterinario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Veterinario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Eliminar_Veterinario` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Taxas` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Editar_Taxas` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `Can_Exportar_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `GesCemiterio` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Proprietario` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Defunto` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Defunto` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Defunto` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Defunto` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Inumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Inumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Inumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Exportar_Inumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Recibo_Inumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Inumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Exumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Exumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Exumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Exumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Exportar_Exumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Recibo_Exumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Exumacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Trasladacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Trasladacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Trasladacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Trasladacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Exportar_Trasladacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Recibo_Trasladacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Trasladacao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Alvara` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Alvara` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Alvara` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Exportar_Alvara` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Recibo_Alvara` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Alvara` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Concessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Concessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Concessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Concessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Concessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Mudanca` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Mudanca` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Mudanca` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Mudanca` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Recibo_Mudanca` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Mudanca` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Sucessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Sucessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Sucessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Sucessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Recibo_Sucessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Sucessao` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Pagamento_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Pagamento_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Pagamento_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Pagamento_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Recibo_Pagamento_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Pagamento_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Funeraria` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Funeraria` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Funeraria` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Funeraria` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Funeraria` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Local` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Detalhe_Local` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Taxas` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Taxas` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Inserir_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Eliminar_Taxa_Anual` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Alvara_Generico` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Editar_Alvara_Generico` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `Cem_Exportar_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `GesToponimia` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Arruamento` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Inserir_Arruamento` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Editar_Arruamento` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Detalhe_Arruamento` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Eliminar_Arruamento` tinyint(1) NOT NULL DEFAULT '0',
  `Top_NPolicia` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Inserir_NPolicia` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Editar_NPolicia` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Detalhe_NPolicia` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Associar_NPolicia` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Eliminar_NPolicia` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Inserir_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Editar_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Detalhe_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Eliminar_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Editar_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Detalhe_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Eliminar_Incidente` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `Top_Exportar_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `GesDocumental` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Ata_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Ata_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Ata_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Anexar_Ata_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Download_Ata_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Ata_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Ata_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Convocatoria_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Convocatoria_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Convocatoria_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Convocatoria_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Convocatoria_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Despacho_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Despacho_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Despacho_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Despacho_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Despacho_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Edital_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Edital_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Edital_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Edital_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Edital_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Ata_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Ata_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Ata_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Anexar_Ata_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Download_Ata_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Ata_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Ata_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Aviso_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Aviso_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Aviso_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Aviso_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Aviso_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Despacho_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Despacho_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Despacho_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Despacho_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Despacho_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Edital_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Edital_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Edital_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Edital_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Edital_Executivo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Emissao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Emissao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Emissao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Emissao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Emissao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Recepcao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Recepcao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Recepcao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Download_Recepcao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Recepcao` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Entidade` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Entidade` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Entidade` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Detalhe_Entidade` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Entidade` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Processo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Inserir_Processo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Processo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Eliminar_Processo` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Modelos_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Editar_Modelos_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Mapas_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `Doc_Exportar_Mapas_Assembleia` tinyint(1) NOT NULL DEFAULT '0',
  `GesPopulacao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Inserir_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Editar_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Detalhe_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Eliminar_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Inserir_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Editar_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Exportar_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Recibo_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Eliminar_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Inserir_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Editar_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Exportar_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Recibo_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Eliminar_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Inserir_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Editar_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Exportar_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Recibo_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Eliminar_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Estatistica` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Tipo_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Inserir_Tipo_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Editar_Tipo_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Detalhe_Tipo_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Eliminar_Tipo_Atestado` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Tipo_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Inserir_Tipo_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Editar_Tipo_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Detalhe_Tipo_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Eliminar_Tipo_Certidao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Tipo_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Inserir_Tipo_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Editar_Tipo_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Detalhe_Tipo_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Eliminar_Tipo_Declaracao` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `Pop_Exportar_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `GesSMS` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Envio` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Inserir_Envio` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Detalhe_Envio` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Inserir_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Editar_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Detalhe_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Eliminar_Pessoa` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Modelos` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Inserir_Modelo` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Editar_Modelo` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Detalhe_Modelo` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Eliminar_Modelo` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `Sms_Exportar_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `GesSNCAP` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Cabimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Cabimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Editar_Cabimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Detalhe_Cabimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Cabimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_Cabimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Compromisso` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Compromisso` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Editar_Compromisso` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Detalhe_Compromisso` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Compromisso` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_Compromisso` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Obrigacao` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Obrigacao` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Editar_Obrigacao` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Detalhe_Obrigacao` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Obrigacao` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_Obrigacao` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Pagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Pagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Editar_Pagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Detalhe_Pagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Pagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_Pagamento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Cab_Com_Obg` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Cab_Com_Obg` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Cab_Com_Obg_Pag` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Cab_Com_Obg_Pag` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Guia_Recebimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Guia_Recebimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Editar_Guia_Recebimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Detalhe_Guia_Recebimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Guia_Recebimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_Guia_Recebimento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Recibo` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Recibo` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Editar_Recibo` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Detalhe_Recibo` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Recibo` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_Recibo` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Guia_Recebimento_Recibo` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Guia_Recebimento_Recibo` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Mapas_Movimentos` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Consultar_Mapas_Movimentos` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Extratos_Bancarios` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Extratos_Bancarios` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_OT_Receita` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_OT_Receita` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Editar_OT_Receita` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Detalhe_OT_Receita` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_OT_Receita` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_OT_Receita` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_OT_Despesa` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_OT_Despesa` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Editar_OT_Despesa` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Detalhe_OT_Despesa` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_OT_Despesa` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_OT_Despesa` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_OT_Consultar` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Consultar_OT` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Inserir_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Eliminar_Transferencia` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Orcamento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Consultar_Orcamento` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_PPI` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Consultar_PPI` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Mapas_Gerais` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Exportar_Mapas_Gerais` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Tabelas` tinyint(1) NOT NULL DEFAULT '0',
  `Sncap_Consultar_Tabelas` tinyint(1) NOT NULL DEFAULT '0',
  `GesProcesso` tinyint(1) NOT NULL,
  `Processo_Presidente` tinyint(1) NOT NULL,
  `Processo_Inserir_Presidente` tinyint(1) NOT NULL,
  `Processo_Processo` tinyint(1) NOT NULL,
  `Processo_Inserir` tinyint(1) NOT NULL,
  `Processo_Editar` tinyint(1) NOT NULL,
  `Processo_Detalhe` tinyint(1) NOT NULL,
  `Processo_Exportar` tinyint(1) NOT NULL,
  `Processo_Eliminar` tinyint(1) NOT NULL,
  `Processos_Mapas_Gerais` tinyint(1) NOT NULL,
  `Processos_Exportar_Mapas_Gerais` tinyint(1) NOT NULL,
  `GesTarefa` tinyint(1) NOT NULL,
  `GesFaturacao` tinyint(1) NOT NULL DEFAULT '0',
  `Faturacao_Mapas` tinyint(1) NOT NULL DEFAULT '0',
  `Faturacao_Artigos` tinyint(1) NOT NULL DEFAULT '0',
  `Faturacao_Guias` tinyint(1) NOT NULL DEFAULT '0',
  `Faturacao_Orcamentos` tinyint(1) NOT NULL DEFAULT '0',
  `Faturacao_Faturas` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `permissoes` (`ID_Permissao`, `Nome`, `Geral_Ano`, `Geral_Inserir_Ano`, `Geral_Editar_Ano`, `Geral_Eliminar_Ano`, `Geral_Banco`, `Geral_Inserir_Banco`, `Geral_Editar_Banco`, `Geral_Eliminar_Banco`, `Geral_Membro`, `Geral_Inserir_Membro`, `Geral_Editar_Membro`, `Geral_Eliminar_Membro`, `Geral_MetodoPagamento`, `Geral_Inserir_MetodoPagamento`, `Geral_Editar_MetodoPagamento`, `Geral_Eliminar_MetodoPagamento`, `Geral_Profissao`, `Geral_Inserir_Profissao`, `Geral_Editar_Profissao`, `Geral_Eliminar_Profissao`, `GesCanideo`, `Can_Animal`, `Can_Inserir_Animal`, `Can_Editar_Animal`, `Can_Detalhe_Animal`, `Can_Eliminar_Animal`, `Can_Abate`, `Can_Inserir_Abate`, `Can_Editar_Abate`, `Can_Detalhe_Abate`, `Can_Eliminar_Abate`, `Can_Incidente`, `Can_Inserir_Incidente`, `Can_Editar_Incidente`, `Can_Detalhe_Incidente`, `Can_Eliminar_Incidente`, `Can_Proprietario`, `Can_Inserir_Proprietario`, `Can_Editar_Proprietario`, `Can_Detalhe_Proprietario`, `Can_Eliminar_Proprietario`, `Can_Licenca`, `Can_Inserir_Licenca`, `Can_Editar_Licenca`, `Can_Detalhe_Licenca`, `Can_Renovar_Licenca`, `Can_Exportar_Licenca`, `Can_Eliminar_Licenca`, `Can_Transferencia`, `Can_Inserir_Transferencia`, `Can_Editar_Transferencia`, `Can_Detalhe_Transferencia`, `Can_Eliminar_Transferencia`, `Can_Categoria`, `Can_Inserir_Categoria`, `Can_Editar_Categoria`, `Can_Eliminar_Categoria`, `Can_Raca`, `Can_Inserir_Raca`, `Can_Editar_Raca`, `Can_Eliminar_Raca`, `Can_Veterinario`, `Can_Inserir_Veterinario`, `Can_Editar_Veterinario`, `Can_Eliminar_Veterinario`, `Can_Taxas`, `Can_Editar_Taxas`, `Can_Mapas`, `Can_Exportar_Mapas`, `GesCemiterio`, `Cem_Proprietario`, `Cem_Inserir_Proprietario`, `Cem_Editar_Proprietario`, `Cem_Detalhe_Proprietario`, `Cem_Eliminar_Proprietario`, `Cem_Defunto`, `Cem_Inserir_Defunto`, `Cem_Editar_Defunto`, `Cem_Detalhe_Defunto`, `Cem_Inumacao`, `Cem_Inserir_Inumacao`, `Cem_Editar_Inumacao`, `Cem_Detalhe_Inumacao`, `Cem_Exportar_Inumacao`, `Cem_Recibo_Inumacao`, `Cem_Eliminar_Inumacao`, `Cem_Exumacao`, `Cem_Inserir_Exumacao`, `Cem_Editar_Exumacao`, `Cem_Detalhe_Exumacao`, `Cem_Exportar_Exumacao`, `Cem_Recibo_Exumacao`, `Cem_Eliminar_Exumacao`, `Cem_Trasladacao`, `Cem_Inserir_Trasladacao`, `Cem_Editar_Trasladacao`, `Cem_Detalhe_Trasladacao`, `Cem_Exportar_Trasladacao`, `Cem_Recibo_Trasladacao`, `Cem_Eliminar_Trasladacao`, `Cem_Alvara`, `Cem_Inserir_Alvara`, `Cem_Editar_Alvara`, `Cem_Exportar_Alvara`, `Cem_Recibo_Alvara`, `Cem_Eliminar_Alvara`, `Cem_Concessao`, `Cem_Inserir_Concessao`, `Cem_Editar_Concessao`, `Cem_Detalhe_Concessao`, `Cem_Eliminar_Concessao`, `Cem_Mudanca`, `Cem_Inserir_Mudanca`, `Cem_Editar_Mudanca`, `Cem_Detalhe_Mudanca`, `Cem_Recibo_Mudanca`, `Cem_Eliminar_Mudanca`, `Cem_Sucessao`, `Cem_Inserir_Sucessao`, `Cem_Editar_Sucessao`, `Cem_Detalhe_Sucessao`, `Cem_Recibo_Sucessao`, `Cem_Eliminar_Sucessao`, `Cem_Pagamento_Taxa_Anual`, `Cem_Inserir_Pagamento_Taxa_Anual`, `Cem_Editar_Pagamento_Taxa_Anual`, `Cem_Detalhe_Pagamento_Taxa_Anual`, `Cem_Recibo_Pagamento_Taxa_Anual`, `Cem_Eliminar_Pagamento_Taxa_Anual`, `Cem_Funeraria`, `Cem_Inserir_Funeraria`, `Cem_Editar_Funeraria`, `Cem_Detalhe_Funeraria`, `Cem_Eliminar_Funeraria`, `Cem_Local`, `Cem_Detalhe_Local`, `Cem_Taxas`, `Cem_Editar_Taxas`, `Cem_Taxa_Anual`, `Cem_Inserir_Taxa_Anual`, `Cem_Editar_Taxa_Anual`, `Cem_Eliminar_Taxa_Anual`, `Cem_Alvara_Generico`, `Cem_Editar_Alvara_Generico`, `Cem_Mapas`, `Cem_Exportar_Mapas`, `GesToponimia`, `Top_Arruamento`, `Top_Inserir_Arruamento`, `Top_Editar_Arruamento`, `Top_Detalhe_Arruamento`, `Top_Eliminar_Arruamento`, `Top_NPolicia`, `Top_Inserir_NPolicia`, `Top_Editar_NPolicia`, `Top_Detalhe_NPolicia`, `Top_Associar_NPolicia`, `Top_Eliminar_NPolicia`, `Top_Pessoa`, `Top_Inserir_Pessoa`, `Top_Editar_Pessoa`, `Top_Detalhe_Pessoa`, `Top_Eliminar_Pessoa`, `Top_Incidente`, `Top_Editar_Incidente`, `Top_Detalhe_Incidente`, `Top_Eliminar_Incidente`, `Top_Mapas`, `Top_Exportar_Mapas`, `GesDocumental`, `Doc_Ata_Assembleia`, `Doc_Inserir_Ata_Assembleia`, `Doc_Editar_Ata_Assembleia`, `Doc_Anexar_Ata_Assembleia`, `Doc_Download_Ata_Assembleia`, `Doc_Exportar_Ata_Assembleia`, `Doc_Eliminar_Ata_Assembleia`, `Doc_Convocatoria_Assembleia`, `Doc_Inserir_Convocatoria_Assembleia`, `Doc_Editar_Convocatoria_Assembleia`, `Doc_Exportar_Convocatoria_Assembleia`, `Doc_Eliminar_Convocatoria_Assembleia`, `Doc_Despacho_Assembleia`, `Doc_Inserir_Despacho_Assembleia`, `Doc_Editar_Despacho_Assembleia`, `Doc_Exportar_Despacho_Assembleia`, `Doc_Eliminar_Despacho_Assembleia`, `Doc_Edital_Assembleia`, `Doc_Inserir_Edital_Assembleia`, `Doc_Editar_Edital_Assembleia`, `Doc_Exportar_Edital_Assembleia`, `Doc_Eliminar_Edital_Assembleia`, `Doc_Ata_Executivo`, `Doc_Inserir_Ata_Executivo`, `Doc_Editar_Ata_Executivo`, `Doc_Anexar_Ata_Executivo`, `Doc_Download_Ata_Executivo`, `Doc_Exportar_Ata_Executivo`, `Doc_Eliminar_Ata_Executivo`, `Doc_Aviso_Executivo`, `Doc_Inserir_Aviso_Executivo`, `Doc_Editar_Aviso_Executivo`, `Doc_Exportar_Aviso_Executivo`, `Doc_Eliminar_Aviso_Executivo`, `Doc_Despacho_Executivo`, `Doc_Inserir_Despacho_Executivo`, `Doc_Editar_Despacho_Executivo`, `Doc_Exportar_Despacho_Executivo`, `Doc_Eliminar_Despacho_Executivo`, `Doc_Edital_Executivo`, `Doc_Inserir_Edital_Executivo`, `Doc_Editar_Edital_Executivo`, `Doc_Exportar_Edital_Executivo`, `Doc_Eliminar_Edital_Executivo`, `Doc_Emissao`, `Doc_Inserir_Emissao`, `Doc_Editar_Emissao`, `Doc_Exportar_Emissao`, `Doc_Eliminar_Emissao`, `Doc_Recepcao`, `Doc_Inserir_Recepcao`, `Doc_Editar_Recepcao`, `Doc_Download_Recepcao`, `Doc_Eliminar_Recepcao`, `Doc_Entidade`, `Doc_Inserir_Entidade`, `Doc_Editar_Entidade`, `Doc_Detalhe_Entidade`, `Doc_Eliminar_Entidade`, `Doc_Processo`, `Doc_Inserir_Processo`, `Doc_Editar_Processo`, `Doc_Eliminar_Processo`, `Doc_Modelos_Assembleia`, `Doc_Editar_Modelos_Assembleia`, `Doc_Mapas`, `Doc_Exportar_Mapas`, `Doc_Mapas_Assembleia`, `Doc_Exportar_Mapas_Assembleia`, `GesPopulacao`, `Pop_Pessoa`, `Pop_Inserir_Pessoa`, `Pop_Editar_Pessoa`, `Pop_Detalhe_Pessoa`, `Pop_Eliminar_Pessoa`, `Pop_Atestado`, `Pop_Inserir_Atestado`, `Pop_Editar_Atestado`, `Pop_Exportar_Atestado`, `Pop_Recibo_Atestado`, `Pop_Eliminar_Atestado`, `Pop_Certidao`, `Pop_Inserir_Certidao`, `Pop_Editar_Certidao`, `Pop_Exportar_Certidao`, `Pop_Recibo_Certidao`, `Pop_Eliminar_Certidao`, `Pop_Declaracao`, `Pop_Inserir_Declaracao`, `Pop_Editar_Declaracao`, `Pop_Exportar_Declaracao`, `Pop_Recibo_Declaracao`, `Pop_Eliminar_Declaracao`, `Pop_Estatistica`, `Pop_Tipo_Atestado`, `Pop_Inserir_Tipo_Atestado`, `Pop_Editar_Tipo_Atestado`, `Pop_Detalhe_Tipo_Atestado`, `Pop_Eliminar_Tipo_Atestado`, `Pop_Tipo_Certidao`, `Pop_Inserir_Tipo_Certidao`, `Pop_Editar_Tipo_Certidao`, `Pop_Detalhe_Tipo_Certidao`, `Pop_Eliminar_Tipo_Certidao`, `Pop_Tipo_Declaracao`, `Pop_Inserir_Tipo_Declaracao`, `Pop_Editar_Tipo_Declaracao`, `Pop_Detalhe_Tipo_Declaracao`, `Pop_Eliminar_Tipo_Declaracao`, `Pop_Mapas`, `Pop_Exportar_Mapas`, `GesSMS`, `Sms_Envio`, `Sms_Inserir_Envio`, `Sms_Detalhe_Envio`, `Sms_Pessoa`, `Sms_Inserir_Pessoa`, `Sms_Editar_Pessoa`, `Sms_Detalhe_Pessoa`, `Sms_Eliminar_Pessoa`, `Sms_Modelos`, `Sms_Inserir_Modelo`, `Sms_Editar_Modelo`, `Sms_Detalhe_Modelo`, `Sms_Eliminar_Modelo`, `Sms_Mapas`, `Sms_Exportar_Mapas`, `GesSNCAP`, `Sncap_Cabimento`, `Sncap_Inserir_Cabimento`, `Sncap_Editar_Cabimento`, `Sncap_Detalhe_Cabimento`, `Sncap_Exportar_Cabimento`, `Sncap_Eliminar_Cabimento`, `Sncap_Compromisso`, `Sncap_Inserir_Compromisso`, `Sncap_Editar_Compromisso`, `Sncap_Detalhe_Compromisso`, `Sncap_Exportar_Compromisso`, `Sncap_Eliminar_Compromisso`, `Sncap_Obrigacao`, `Sncap_Inserir_Obrigacao`, `Sncap_Editar_Obrigacao`, `Sncap_Detalhe_Obrigacao`, `Sncap_Exportar_Obrigacao`, `Sncap_Eliminar_Obrigacao`, `Sncap_Pagamento`, `Sncap_Inserir_Pagamento`, `Sncap_Editar_Pagamento`, `Sncap_Detalhe_Pagamento`, `Sncap_Exportar_Pagamento`, `Sncap_Eliminar_Pagamento`, `Sncap_Cab_Com_Obg`, `Sncap_Inserir_Cab_Com_Obg`, `Sncap_Cab_Com_Obg_Pag`, `Sncap_Inserir_Cab_Com_Obg_Pag`, `Sncap_Guia_Recebimento`, `Sncap_Inserir_Guia_Recebimento`, `Sncap_Editar_Guia_Recebimento`, `Sncap_Detalhe_Guia_Recebimento`, `Sncap_Exportar_Guia_Recebimento`, `Sncap_Eliminar_Guia_Recebimento`, `Sncap_Recibo`, `Sncap_Inserir_Recibo`, `Sncap_Editar_Recibo`, `Sncap_Detalhe_Recibo`, `Sncap_Exportar_Recibo`, `Sncap_Eliminar_Recibo`, `Sncap_Guia_Recebimento_Recibo`, `Sncap_Inserir_Guia_Recebimento_Recibo`, `Sncap_Mapas_Movimentos`, `Sncap_Consultar_Mapas_Movimentos`, `Sncap_Extratos_Bancarios`, `Sncap_Exportar_Extratos_Bancarios`, `Sncap_OT_Receita`, `Sncap_Inserir_OT_Receita`, `Sncap_Editar_OT_Receita`, `Sncap_Detalhe_OT_Receita`, `Sncap_Exportar_OT_Receita`, `Sncap_Eliminar_OT_Receita`, `Sncap_OT_Despesa`, `Sncap_Inserir_OT_Despesa`, `Sncap_Editar_OT_Despesa`, `Sncap_Detalhe_OT_Despesa`, `Sncap_Exportar_OT_Despesa`, `Sncap_Eliminar_OT_Despesa`, `Sncap_OT_Consultar`, `Sncap_Consultar_OT`, `Sncap_Transferencia`, `Sncap_Inserir_Transferencia`, `Sncap_Exportar_Transferencia`, `Sncap_Eliminar_Transferencia`, `Sncap_Orcamento`, `Sncap_Consultar_Orcamento`, `Sncap_PPI`, `Sncap_Consultar_PPI`, `Sncap_Mapas_Gerais`, `Sncap_Exportar_Mapas_Gerais`, `Sncap_Tabelas`, `Sncap_Consultar_Tabelas`, `GesProcesso`, `Processo_Presidente`, `Processo_Inserir_Presidente`, `Processo_Processo`, `Processo_Inserir`, `Processo_Editar`, `Processo_Detalhe`, `Processo_Exportar`, `Processo_Eliminar`, `Processos_Mapas_Gerais`, `Processos_Exportar_Mapas_Gerais`, `GesTarefa`, `GesFaturacao`, `Faturacao_Mapas`, `Faturacao_Artigos`, `Faturacao_Guias`, `Faturacao_Orcamentos`, `Faturacao_Faturas`) VALUES
(29, 'GesFacturation', 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1);

CREATE TABLE `recuperar_password` (
  `ID_RecuperarPassword` bigint(20) UNSIGNED NOT NULL,
  `ID_Utilizador` int(11) NOT NULL,
  `Email` varchar(500) NOT NULL,
  `Token` varchar(100) NOT NULL,
  `TimeStamp` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `recuperar_password` (`ID_RecuperarPassword`, `ID_Utilizador`, `Email`, `Token`, `TimeStamp`) VALUES
(4, 1, 'geral@ftkode.com', '8TVV5U218HHAD4VORL7H599KJRMY9HAHB6DG0GI9YZJB4F0W07', 1507827415);

CREATE TABLE `sms_modelo` (
  `ID_Modelo` bigint(20) UNSIGNED NOT NULL,
  `Nome` varchar(1000) NOT NULL,
  `Texto` varchar(10000) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `sms_modelo` (`ID_Modelo`, `Nome`, `Texto`) VALUES
(1, 'Teste', 'A todos um Bom Natal da UF de Freguesias');

CREATE TABLE `sms_prefs` (
  `ID_Preferencia` bigint(20) UNSIGNED NOT NULL,
  `Capa` tinyint(1) NOT NULL DEFAULT '0',
  `Header` tinyint(1) NOT NULL DEFAULT '0',
  `Footer` tinyint(1) NOT NULL DEFAULT '0',
  `NotificarAniversario` tinyint(1) NOT NULL DEFAULT '0',
  `ID_ModeloAniversario` int(11) NOT NULL,
  `NotificarFimValidadeDocIdent` tinyint(1) NOT NULL DEFAULT '0',
  `ID_ModeloDocIdent` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `sms_prefs` (`ID_Preferencia`, `Capa`, `Header`, `Footer`, `NotificarAniversario`, `ID_ModeloAniversario`, `NotificarFimValidadeDocIdent`, `ID_ModeloDocIdent`) VALUES
(1, 0, 0, 0, 0, 0, 0, 0);

CREATE TABLE `utilizador` (
  `ID_Utilizador` bigint(20) UNSIGNED NOT NULL,
  `ID_Autarquia` int(11) NOT NULL,
  `ID_TipoUtilizador` int(11) NOT NULL,
  `ID_Permissao` int(11) NOT NULL,
  `Nome` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `Email` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `Username` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `Password` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `Salt` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `CodigoSIIAL` varchar(1000) COLLATE utf8_unicode_ci NOT NULL,
  `PasswordErrada` int(11) NOT NULL,
  `Estado` tinyint(1) NOT NULL DEFAULT '0',
  `AdministradorFaturacao` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `CodigoInternoVendedor` varchar(20) COLLATE utf8_unicode_ci NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `utilizador` (`ID_Utilizador`, `ID_Autarquia`, `ID_TipoUtilizador`, `ID_Permissao`, `Nome`, `Email`, `Username`, `Password`, `Salt`, `CodigoSIIAL`, `PasswordErrada`, `Estado`, `AdministradorFaturacao`, `CodigoInternoVendedor`) VALUES
(1, 1, 1, 29, 'Administrador', 'geral@ftkode.com', 'ftkode', 'f7f81fdd4b45343113e943a4e694dbc325842d742ee3a47d24eca635f232d86f', 'd0f', '1', 0, 0, 1, ''),
(2, 1, 2, 29, 'Fricode', 'contact@fricode.ch', 'fricode', 'f7f81fdd4b45343113e943a4e694dbc325842d742ee3a47d24eca635f232d86f', 'd0f', '1', 0, 0, 1, '');

ALTER TABLE `ano`
  ADD PRIMARY KEY (`ID_Ano`),
  ADD UNIQUE KEY `ID_Ano` (`ID_Ano`);

ALTER TABLE `autarquia`
  ADD PRIMARY KEY (`ID_Autarquia`);

ALTER TABLE `banco`
  ADD PRIMARY KEY (`ID_Banco`),
  ADD UNIQUE KEY `ID_Banco` (`ID_Banco`);

ALTER TABLE `concelho`
  ADD PRIMARY KEY (`ID_Concelho`),
  ADD UNIQUE KEY `ID_Concelho` (`ID_Concelho`);

ALTER TABLE `departamento`
  ADD PRIMARY KEY (`ID_Departamento`);

ALTER TABLE `departamento_utilizador`
  ADD PRIMARY KEY (`ID_DepartamentoUtilizador`);

ALTER TABLE `distrito`
  ADD PRIMARY KEY (`ID_Distrito`),
  ADD UNIQUE KEY `ID_Distrito` (`ID_Distrito`);

ALTER TABLE `faturacao_accounts`
  ADD PRIMARY KEY (`ID_Account`);

ALTER TABLE `faturacao_ano_fiscal`
  ADD PRIMARY KEY (`ID_Ano`);

ALTER TABLE `faturacao_artigos`
  ADD PRIMARY KEY (`ID_Artigo`);

ALTER TABLE `faturacao_artigos_categorias`
  ADD PRIMARY KEY (`ID_Categoria`);

ALTER TABLE `faturacao_bancos`
  ADD PRIMARY KEY (`ID_Banco`);

ALTER TABLE `faturacao_bancos_fornecedores`
  ADD PRIMARY KEY (`ID_BancoFornecedor`);

ALTER TABLE `faturacao_clientes`
  ADD PRIMARY KEY (`ID_Cliente`);

ALTER TABLE `faturacao_clientes_grupos`
  ADD PRIMARY KEY (`ID_Grupo`);

ALTER TABLE `faturacao_compras`
  ADD PRIMARY KEY (`ID_Compra`);

ALTER TABLE `faturacao_compras_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_compras_notas_credito`
  ADD PRIMARY KEY (`ID_NotaCreditoCompra`);

ALTER TABLE `faturacao_compras_notas_credito_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_consommables`
  ADD PRIMARY KEY (`ID_Consommable`);

ALTER TABLE `faturacao_consommables_compteurs`
  ADD PRIMARY KEY (`ID_Compteur`);

ALTER TABLE `faturacao_consommables_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_dados_aplicacao`
  ADD PRIMARY KEY (`ID_Dados_Aplicacao`);

ALTER TABLE `faturacao_empresa_dados`
  ADD PRIMARY KEY (`ID_dados_empresa`);

ALTER TABLE `faturacao_faturas`
  ADD PRIMARY KEY (`ID_Fatura`);

ALTER TABLE `faturacao_faturas_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_faturas_recibo`
  ADD PRIMARY KEY (`ID_FaturaRecibo`);

ALTER TABLE `faturacao_faturas_recibo_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_faturas_simplificadas`
  ADD PRIMARY KEY (`ID_FaturaSimplificada`);

ALTER TABLE `faturacao_faturas_simplificadas_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_fornecedores`
  ADD PRIMARY KEY (`ID_Fornecedor`);

ALTER TABLE `faturacao_fornecedores_grupos`
  ADD PRIMARY KEY (`ID_Grupo`);

ALTER TABLE `faturacao_funcionalidades`
  ADD PRIMARY KEY (`ID_Funcionalidade`);

ALTER TABLE `faturacao_ghosts_artigos`
  ADD PRIMARY KEY (`ID_Artigo`);

ALTER TABLE `faturacao_ghosts_clientes`
  ADD PRIMARY KEY (`ID_Cliente`);

ALTER TABLE `faturacao_ghosts_faturas`
  ADD PRIMARY KEY (`ID_Fatura`);

ALTER TABLE `faturacao_ghosts_faturas_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_guias_transporte`
  ADD PRIMARY KEY (`ID_GuiaTransporte`);

ALTER TABLE `faturacao_guias_transporte_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_honorarios`
  ADD PRIMARY KEY (`ID_Honorario`);

ALTER TABLE `faturacao_honorarios_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_impostos`
  ADD PRIMARY KEY (`ID_Imposto`);

ALTER TABLE `faturacao_impostos_usados`
  ADD PRIMARY KEY (`ID_ImpostoUsado`);

ALTER TABLE `faturacao_locations`
  ADD PRIMARY KEY (`ID_Location`);

ALTER TABLE `faturacao_locations_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_mapas_iva_gerados`
  ADD PRIMARY KEY (`ID_Mapa`);

ALTER TABLE `faturacao_metodos_pagamento`
  ADD PRIMARY KEY (`ID_Metodo`);

ALTER TABLE `faturacao_modelo_email`
  ADD PRIMARY KEY (`ID_ModeloEmail`),
  ADD UNIQUE KEY `ID_ModeloEmail` (`ID_ModeloEmail`);

ALTER TABLE `faturacao_modulos`
  ADD PRIMARY KEY (`ID_Modulo`);

ALTER TABLE `faturacao_moedas`
  ADD PRIMARY KEY (`ID_Moeda`);

ALTER TABLE `faturacao_motivos_isencao`
  ADD PRIMARY KEY (`ID_Motivo`);

ALTER TABLE `faturacao_motivos_notas`
  ADD PRIMARY KEY (`ID_Motivo`);

ALTER TABLE `faturacao_movimentos_contabilisticos`
  ADD PRIMARY KEY (`ID_Movimento`);

ALTER TABLE `faturacao_movimento_bvr_importados`
  ADD PRIMARY KEY (`ID_Movimento`);

ALTER TABLE `faturacao_notas_credito`
  ADD PRIMARY KEY (`ID_NotaCredito`);

ALTER TABLE `faturacao_notas_credito_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_notas_debito`
  ADD PRIMARY KEY (`ID_NotaDebito`);

ALTER TABLE `faturacao_notas_debito_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_npa_localites`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `faturacao_orcamentos`
  ADD PRIMARY KEY (`ID_Orcamento`);

ALTER TABLE `faturacao_orcamentos_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_permissions`
  ADD PRIMARY KEY (`ID_Permission`);

ALTER TABLE `faturacao_personalizar_documentos`
  ADD PRIMARY KEY (`ID_personalizar`);

ALTER TABLE `faturacao_personalizar_planos_defeito`
  ADD PRIMARY KEY (`ID_Personalizacao`);

ALTER TABLE `faturacao_plano_conta`
  ADD PRIMARY KEY (`ID_Plano`);

ALTER TABLE `faturacao_proformas`
  ADD PRIMARY KEY (`ID_Proforma`);

ALTER TABLE `faturacao_proformas_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_recibos`
  ADD PRIMARY KEY (`ID_Recibo`);

ALTER TABLE `faturacao_recibos_linhas`
  ADD PRIMARY KEY (`ID_Linha`);

ALTER TABLE `faturacao_recibos_pagamentos`
  ADD PRIMARY KEY (`ID_Pagamento`);

ALTER TABLE `faturacao_responsaveis`
  ADD PRIMARY KEY (`ID_Responsavel`);

ALTER TABLE `faturacao_responsavel_contratos`
  ADD PRIMARY KEY (`ID_RespContrato`);

ALTER TABLE `faturacao_responsavel_entidades`
  ADD PRIMARY KEY (`ID_RespEnt`);

ALTER TABLE `faturacao_roles`
  ADD PRIMARY KEY (`ID_Role`);
ALTER TABLE `faturacao_series`
  ADD PRIMARY KEY (`ID_Serie`);

ALTER TABLE `faturacao_snc_base`
  ADD PRIMARY KEY (`ID_Snc_Base`);

ALTER TABLE `faturacao_snc_micro`
  ADD PRIMARY KEY (`ID_Snc_Base`);

ALTER TABLE `faturacao_unidades`
  ADD PRIMARY KEY (`ID_Unidade`);

ALTER TABLE `faturacao_vendedores`
  ADD PRIMARY KEY (`ID_Vendedor`);

ALTER TABLE `freguesia`
  ADD PRIMARY KEY (`ID_Freguesia`),
  ADD UNIQUE KEY `ID_Freguesia` (`ID_Freguesia`);

ALTER TABLE `log`
  ADD PRIMARY KEY (`ID_Log`),
  ADD UNIQUE KEY `ID_Log` (`ID_Log`);

ALTER TABLE `modulo`
  ADD PRIMARY KEY (`ID_Modulo`),
  ADD UNIQUE KEY `ID_Modulo` (`ID_Modulo`);

ALTER TABLE `modulo_autarquia`
  ADD PRIMARY KEY (`ID_ModuloAutarquia`),
  ADD UNIQUE KEY `ID_ModuloAutarquia` (`ID_ModuloAutarquia`);

ALTER TABLE `modulo_demo`
  ADD PRIMARY KEY (`ID_ModuloDemo`),
  ADD UNIQUE KEY `ID_ModuloAutarquia` (`ID_ModuloDemo`);

ALTER TABLE `pais`
  ADD PRIMARY KEY (`ID_Pais`),
  ADD UNIQUE KEY `ID_Pais` (`ID_Pais`);

ALTER TABLE `permissoes`
  ADD PRIMARY KEY (`ID_Permissao`),
  ADD UNIQUE KEY `ID_Permissao` (`ID_Permissao`),
  ADD UNIQUE KEY `ID_Permissao_2` (`ID_Permissao`);

ALTER TABLE `recuperar_password`
  ADD PRIMARY KEY (`ID_RecuperarPassword`),
  ADD UNIQUE KEY `ID_RecuperarPassword` (`ID_RecuperarPassword`);

ALTER TABLE `sms_modelo`
  ADD PRIMARY KEY (`ID_Modelo`),
  ADD UNIQUE KEY `ID_Modelo` (`ID_Modelo`);

ALTER TABLE `sms_prefs`
  ADD PRIMARY KEY (`ID_Preferencia`),
  ADD UNIQUE KEY `ID_Preferencia` (`ID_Preferencia`);

ALTER TABLE `utilizador`
  ADD PRIMARY KEY (`ID_Utilizador`),
  ADD UNIQUE KEY `ID_Utilizador` (`ID_Utilizador`);


ALTER TABLE `ano`
  MODIFY `ID_Ano` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `autarquia`
  MODIFY `ID_Autarquia` bigint(20) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `banco`
  MODIFY `ID_Banco` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `concelho`
  MODIFY `ID_Concelho` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=309;

ALTER TABLE `departamento`
  MODIFY `ID_Departamento` bigint(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=16;

ALTER TABLE `departamento_utilizador`
  MODIFY `ID_DepartamentoUtilizador` bigint(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `distrito`
  MODIFY `ID_Distrito` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=23;

ALTER TABLE `faturacao_accounts`
  MODIFY `ID_Account` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `faturacao_ano_fiscal`
  MODIFY `ID_Ano` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `faturacao_artigos`
  MODIFY `ID_Artigo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5;

ALTER TABLE `faturacao_artigos_categorias`
  MODIFY `ID_Categoria` bigint(20) NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_bancos`
  MODIFY `ID_Banco` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

ALTER TABLE `faturacao_bancos_fornecedores`
  MODIFY `ID_BancoFornecedor` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3394;

ALTER TABLE `faturacao_clientes`
  MODIFY `ID_Cliente` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_clientes_grupos`
  MODIFY `ID_Grupo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_compras`
  MODIFY `ID_Compra` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_compras_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_compras_notas_credito`
  MODIFY `ID_NotaCreditoCompra` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_compras_notas_credito_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_consommables`
  MODIFY `ID_Consommable` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_consommables_compteurs`
  MODIFY `ID_Compteur` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_consommables_linhas`
  MODIFY `ID_Linha` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_dados_aplicacao`
  MODIFY `ID_Dados_Aplicacao` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `faturacao_empresa_dados`
  MODIFY `ID_dados_empresa` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `faturacao_faturas`
  MODIFY `ID_Fatura` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_faturas_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_faturas_recibo`
  MODIFY `ID_FaturaRecibo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_faturas_recibo_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_faturas_simplificadas`
  MODIFY `ID_FaturaSimplificada` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_faturas_simplificadas_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_fornecedores`
  MODIFY `ID_Fornecedor` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_fornecedores_grupos`
  MODIFY `ID_Grupo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_funcionalidades`
  MODIFY `ID_Funcionalidade` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=41;

ALTER TABLE `faturacao_ghosts_artigos`
  MODIFY `ID_Artigo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_ghosts_clientes`
  MODIFY `ID_Cliente` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_ghosts_faturas`
  MODIFY `ID_Fatura` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_ghosts_faturas_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_guias_transporte`
  MODIFY `ID_GuiaTransporte` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_guias_transporte_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_honorarios`
  MODIFY `ID_Honorario` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_honorarios_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_impostos`
  MODIFY `ID_Imposto` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=22;

ALTER TABLE `faturacao_impostos_usados`
  MODIFY `ID_ImpostoUsado` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=16;

ALTER TABLE `faturacao_locations`
  MODIFY `ID_Location` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_locations_linhas`
  MODIFY `ID_Linha` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_mapas_iva_gerados`
  MODIFY `ID_Mapa` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_metodos_pagamento`
  MODIFY `ID_Metodo` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=6;

ALTER TABLE `faturacao_modelo_email`
  MODIFY `ID_ModeloEmail` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `faturacao_modulos`
  MODIFY `ID_Modulo` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;

ALTER TABLE `faturacao_moedas`
  MODIFY `ID_Moeda` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `faturacao_motivos_isencao`
  MODIFY `ID_Motivo` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=19;

ALTER TABLE `faturacao_motivos_notas`
  MODIFY `ID_Motivo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=8;

ALTER TABLE `faturacao_movimentos_contabilisticos`
  MODIFY `ID_Movimento` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_movimento_bvr_importados`
  MODIFY `ID_Movimento` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_notas_credito`
  MODIFY `ID_NotaCredito` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_notas_credito_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_notas_debito`
  MODIFY `ID_NotaDebito` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_notas_debito_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_npa_localites`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3474;

ALTER TABLE `faturacao_orcamentos`
  MODIFY `ID_Orcamento` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_orcamentos_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_permissions`
  MODIFY `ID_Permission` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=107;

ALTER TABLE `faturacao_personalizar_documentos`
  MODIFY `ID_personalizar` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `faturacao_personalizar_planos_defeito`
  MODIFY `ID_Personalizacao` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7;

ALTER TABLE `faturacao_plano_conta`
  MODIFY `ID_Plano` bigint(20) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=197;

ALTER TABLE `faturacao_proformas`
  MODIFY `ID_Proforma` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_proformas_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_recibos`
  MODIFY `ID_Recibo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_recibos_linhas`
  MODIFY `ID_Linha` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_recibos_pagamentos`
  MODIFY `ID_Pagamento` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_responsaveis`
  MODIFY `ID_Responsavel` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_responsavel_contratos`
  MODIFY `ID_RespContrato` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_responsavel_entidades`
  MODIFY `ID_RespEnt` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_roles`
  MODIFY `ID_Role` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5;

ALTER TABLE `faturacao_series`
  MODIFY `ID_Serie` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `faturacao_snc_base`
  MODIFY `ID_Snc_Base` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1018;

ALTER TABLE `faturacao_snc_micro`
  MODIFY `ID_Snc_Base` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=546;

ALTER TABLE `faturacao_unidades`
  MODIFY `ID_Unidade` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=8;

ALTER TABLE `faturacao_vendedores`
  MODIFY `ID_Vendedor` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `freguesia`
  MODIFY `ID_Freguesia` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3094;

ALTER TABLE `log`
  MODIFY `ID_Log` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `modulo`
  MODIFY `ID_Modulo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=13;

ALTER TABLE `modulo_autarquia`
  MODIFY `ID_ModuloAutarquia` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=12;

ALTER TABLE `modulo_demo`
  MODIFY `ID_ModuloDemo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;

ALTER TABLE `pais`
  MODIFY `ID_Pais` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=256;

ALTER TABLE `permissoes`
  MODIFY `ID_Permissao` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=30;

ALTER TABLE `recuperar_password`
  MODIFY `ID_RecuperarPassword` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5;

ALTER TABLE `sms_modelo`
  MODIFY `ID_Modelo` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5;

ALTER TABLE `sms_prefs`
  MODIFY `ID_Preferencia` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `utilizador`
  MODIFY `ID_Utilizador` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;


-- INSERT INTO `faturacao_artigos` (`Nome`, `Codigo`, `Tipo`, `CodigoBarras`, `SerialNumber`, `ID_Categoria`, `ID_Unidade`, `Preco`, `ID_Imposto`, `ID_Imposto_Fornecedor`, `PrecoPVP`, `RetencaoPercentagem`, `RetencaoValor`, `Stock`, `Ativo`, `PlanoContas`, `PlanoContasCompras`, `Usado`, `ID_Prestashop`) VALUES
-- ('Support informatique via TeamViewer', 'FRISUP', 'S', '', '', 1, 1, '92.850500', 21, 19, '100.000000', '0.00', '0.000000', '0.000', 1, '3400', '4400', 1, 0),
-- ('Service rendus, réparation MFP ', 'FRISER', 'S', '', '', 1, 1, '141.132800', 21, 19, '152.000000', '0.00', '0.000000', '0.000', 1, '3601', '4270', 1, 0),
-- ('Déplacement, S1', 'FRIDEP', 'S', '', '', 1, 1, '25.069600', 21, 19, '27.000000', '0.00', '0.000000', '0.000', 1, '3203', '4204', 1, 0),
-- ('Mise en service + connexion réseau HP ', 'ITINFO', 'S', '', '', 1, 5, '180.501400', 21, 19, '194.400000', '0.00', '0.000000', '0.00', 1, '3400', '4400', 1, 0);

INSERT INTO `faturacao_artigos_categorias` (`ID_Categoria`, `Nome`, `Ativo`) VALUES
(1, 'Rapports de Travail', 1);

CREATE TABLE `faturacao_rapports_travail` (
  `ID_Rapport` bigint(30) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Cliente` bigint(30) UNSIGNED NOT NULL,
  `EnderecoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TelefoneCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Vendedor_Primeiro` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Vendedor_Segundo` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Debut` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Duree` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Paiment` smallint(5) UNSIGNED NOT NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `Tecnico` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Impressora` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NumImpressora` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CompteurNB` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CompteurCoul` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Remarque` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Confirmado','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_ResponsavelPrimeiro` bigint(30) UNSIGNED NOT NULL,
  `ID_ResponsavelSegundo` bigint(30) UNSIGNED NOT NULL,
  `DataCriacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Criacao` bigint(30) UNSIGNED NOT NULL,
  `DataAtualizacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Atualizacao` bigint(30) UNSIGNED NOT NULL,
  `TimeStamp_Rapport` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Documento_Origem` bigint(30) UNSIGNED NOT NULL,
  `Tipo_Documento_Origem` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Data_Documento_Origem` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Assinatura` longtext CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `faturacao_rapports_travail_linhas` (
  `ID_Linha` bigint(30) UNSIGNED NOT NULL,
  `ID_Rapport` bigint(30) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL,
  `UnidadeMedida` varchar(20) NOT NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NOT NULL,
  `Descricao` varchar(1000) NOT NULL,
  `ID_Imposto` int(10) UNSIGNED NOT NULL,
  `TaxType` varchar(3) NOT NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) NOT NULL,
  `TaxCode` varchar(10) NOT NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NOT NULL,
  `TaxExemptionReason` varchar(60) NOT NULL,
  `TaxExemptionCode` varchar(3) NOT NULL,
  `TotalLinha` decimal(20,6) UNSIGNED NOT NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


ALTER TABLE `faturacao_rapports_travail`
  ADD PRIMARY KEY (`ID_Rapport`);

ALTER TABLE `faturacao_rapports_travail_linhas`
  ADD PRIMARY KEY (`ID_Linha`);


ALTER TABLE `faturacao_rapports_travail`
  MODIFY `ID_Rapport` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;
ALTER TABLE `faturacao_rapports_travail_linhas`
  MODIFY `ID_Linha` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

ALTER TABLE `faturacao_rapports_travail` ADD `DateDebut` VARCHAR(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL AFTER `Assinatura`, ADD `DateFin` VARCHAR(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL AFTER `DateDebut`;

INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES (31, 'Clients > Rapports de Travail', '4');

INSERT INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
(113, '0111', 'Rapports de Travail (Supprimer)', 31),
(112, '0110', 'Rapports de Travail (Modifier et Signer)', 31),
(111, '0109', 'Rapports de Travail (Créer)', 31),
(110, '0108', 'Rapports de Travail (Consulter)', 31);

INSERT INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
(114, '0112', 'Rapports de Travail (Générer Documents)', 31);

ALTER TABLE `faturacao_rapports_travail` ADD `EnderecoClienteDescarga` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '' AFTER `DateFin`, ADD `EnderecoCliente2Descarga` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '' AFTER `EnderecoClienteDescarga`, ADD `CodigoPostalClienteDescarga` VARCHAR(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '' AFTER `EnderecoCliente2Descarga`, ADD `CidadeClienteDescarga` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '' AFTER `CodigoPostalClienteDescarga`, ADD `RegiaoClienteDescarga` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '' AFTER `CidadeClienteDescarga`, ADD `EmailClienteDescarga` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '' AFTER `RegiaoClienteDescarga`;

ALTER TABLE `faturacao_rapports_travail` ADD `PaisClienteDescarga` VARCHAR(2) NOT NULL DEFAULT '' AFTER `EmailClienteDescarga`;

ALTER TABLE `faturacao_rapports_travail_linhas` ADD `DescontoLinha` DECIMAL(6,2) UNSIGNED NOT NULL DEFAULT '0' AFTER `TotalLinhaSIVA`, ADD `SettlementAmount` DECIMAL(20,6) UNSIGNED NOT NULL DEFAULT '0' AFTER `DescontoLinha`;

ALTER TABLE `faturacao_rapports_travail` ADD `TecnicoSegundo` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `Tecnico`, ADD `ID_Tecnico` BIGINT(30) UNSIGNED NULL DEFAULT '0' AFTER `TecnicoSegundo`, ADD `ID_TecnicoSegundo` BIGINT(30) UNSIGNED NULL DEFAULT '0' AFTER `ID_Tecnico`;

CREATE TABLE `faturacao_tecnicos` (
  `ID_Tecnico` bigint(30) UNSIGNED NOT NULL,
  `Nome` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Contacto` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Email` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampTecnico` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `faturacao_tecnicos`
  ADD PRIMARY KEY (`ID_Tecnico`);

ALTER TABLE `faturacao_tecnicos`
  MODIFY `ID_Tecnico` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES (32, 'Tableaux > Techniciens', '19');

INSERT INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
(118, '0116', 'Technicien (Supprimer)', 32),
(117, '0115', 'Technicien (Modifier)', 32),
(116, '0114', 'Technicien (Créer)', 32),
(115, '0113', 'Technicien (Consulter)', 32);


INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES
(33, 'Clients > Devis', 4);

INSERT INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
(123, '0121', 'Devis (Générer Documents)', 33),
(122, '0120', 'Devis (Supprimer)', 33),
(121, '0119', 'Devis (Modifier)', 33),
(120, '0118', 'Devis (Créer)', 33),
(119, '0117', 'Devis (Consulter)', 33);

CREATE TABLE `faturacao_fecho_mes` (
  `ID_MesFecho` bigint(20) UNSIGNED NOT NULL,
  `Ano` int(10) UNSIGNED DEFAULT NULL,
  `Mes` int(10) UNSIGNED DEFAULT NULL,
  `Estado` tinyint(1) UNSIGNED DEFAULT '1' COMMENT '1 - Bloqueado | 0 - Desbloqueado'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `faturacao_fecho_mes`
  ADD PRIMARY KEY (`ID_MesFecho`);

ALTER TABLE `faturacao_fecho_mes`
  MODIFY `ID_MesFecho` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;
COMMIT;

CREATE TABLE `faturacao_devis` (
  `ID_Devis` bigint(20) UNSIGNED NOT NULL,
  `ID_Cliente` bigint(20) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `EnderecoCliente` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `CidadeCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `RegiaoCliente` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `EmailCliente` varchar(254) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `ID_Moeda` int(10) UNSIGNED NULL DEFAULT '1',
  `TaxaMoeda` decimal(20,6) UNSIGNED NULL DEFAULT '1.000000',
  `Vendedor` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `Vencimento` int(10) UNSIGNED NULL DEFAULT '0',
  `EnderecoCarga` varchar(210) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `CodigoPostalCarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `CidadeCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `RegiaoCarga` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `ID_Serie` int(11) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Validade` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Referencia` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `Observacoes` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `TaxPayable` decimal(20,6) UNSIGNED NOT NULL,
  `NetTotal` decimal(20,6) UNSIGNED NOT NULL,
  `GrossTotal` decimal(20,6) UNSIGNED NOT NULL,
  `SystemEntryDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TimeStampDate` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Desconto` decimal(20,6) UNSIGNED NULL DEFAULT '0.000000',
  `PercentagemDesconto` decimal(20,6) NULL DEFAULT '0.000000',
  `TotaRetencao` decimal(20,6) NULL DEFAULT '0.000000',
  `TotalSDesconto` decimal(20,6) UNSIGNED NULL DEFAULT '0.000000',
  `InvoiceStatus` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'N',
  `InvoiceStatusDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `SourceID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `SourceBilling` varchar(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT 'P',
  `Hash` varchar(172) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `HashControl` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `Hash_Print` varchar(4) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `Period` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `InvoiceType` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'FT',
  `InvoiceDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SelfBillingIndicator` tinyint(3) UNSIGNED NULL DEFAULT '0',
  `CashVATSchemeIndicator` tinyint(3) UNSIGNED NULL DEFAULT '0',
  `ThirdPartiesBillingIndicator` tinyint(3) UNSIGNED NULL DEFAULT '0',
  `EACCode` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT '0',
  `CustomerID` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `MovementStartTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT '-',
  `MovementEndTime` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT '-',
  `TotalLiquidadoDocumento` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalLiquidado` decimal(20,6) UNSIGNED NOT NULL DEFAULT '0.000000',
  `TotalPagar` decimal(20,6) UNSIGNED NOT NULL,
  `ATCUD` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT '0',
  `MetodoPagamento` int(10) UNSIGNED NOT NULL,
  `ID_Banco` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `PlanoContasBanco` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Aberto','Confirmado','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador` bigint(20) UNSIGNED NULL,
  `ID_UtilizadorAtualizacao` int(11) NULL,
  `DataAtualizacao` varchar(30) NULL,
  `Tipo_Doc_Origem` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `ID_Doc_Origem` bigint(30) UNSIGNED NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `Data_Doc_Origem` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `BVR` varchar(27) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `Exportada` tinyint(1) UNSIGNED NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


CREATE TABLE `faturacao_devis_linhas` (
  `ID_Linha` bigint(50) UNSIGNED NOT NULL,
  `ID_Devis` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `PlanoContas` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `Quantidade` decimal(20,6) UNSIGNED NULL,
  `UnidadeMedida` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `PrecoUnitario` decimal(20,6) UNSIGNED NULL,
  `TaxPointDate` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `Descricao` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `ID_Imposto` int(10) UNSIGNED NULL,
  `PlanoContasTVA` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `TaxType` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT 'IVA',
  `TaxCountryRegion` varchar(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `TaxCode` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `TaxPercentage` decimal(6,2) UNSIGNED NULL,
  `TaxExemptionReason` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `TaxExemptionCode` varchar(3) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL,
  `DescontoLinha` decimal(6,2) UNSIGNED NULL,
  `CreditAmount` decimal(20,6) UNSIGNED NULL,
  `DebitAmount` decimal(20,6) UNSIGNED NULL,
  `SettlementAmount` decimal(20,6) UNSIGNED NULL,
  `Reference` varchar(60) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL COMMENT 'Sem_uso',
  `Reason` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL COMMENT 'Sem_uso',
  `ValorRetencao` decimal(20,6) UNSIGNED NULL,
  `PercentagemRetencao` decimal(6,2) UNSIGNED NULL DEFAULT '0.00',
  `TotalLinha` decimal(20,6) UNSIGNED NULL,
  `TotalLinhaSIVA` decimal(20,6) UNSIGNED NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


ALTER TABLE `faturacao_devis`
  ADD PRIMARY KEY (`ID_Devis`);


ALTER TABLE `faturacao_devis_linhas`
  ADD PRIMARY KEY (`ID_Linha`);



ALTER TABLE `faturacao_devis`
  MODIFY `ID_Devis` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;


ALTER TABLE `faturacao_devis_linhas`
  MODIFY `ID_Linha` bigint(50) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.45.7.1' WHERE 1;

ALTER TABLE `utilizador` ADD `Token` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `CodigoInternoVendedor`;

INSERT INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
(125, '0123', 'Contrats de Consommables (Résilier le Contrat)', 9),
(124, '0122', 'Contrats de Location (Résilier le Contrat)', 8);

ALTER TABLE `faturacao_consommables` ADD `DataTermo` VARCHAR(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `ID_Utilizador_Atualizacao`;

ALTER TABLE `faturacao_locations` ADD `DataTermo` VARCHAR(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `ID_Utilizador_Atualizacao`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.46.4.1' WHERE 1;


UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.47.1.1' WHERE 1;

ALTER TABLE `faturacao_consommables` ADD `TituloCliente` VARCHAR(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `ID_Cliente`, ADD `NomeCliente` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `TituloCliente`, ADD `ApelidoCliente` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `NomeCliente`;

ALTER TABLE `faturacao_locations` ADD `TituloCliente` VARCHAR(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `ID_Cliente`, ADD `NomeCliente` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `TituloCliente`, ADD `ApelidoCliente` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `NomeCliente`;

UPDATE faturacao_unidades SET Descricao = 'Mètre' WHERE Sigla = 'MT';
UPDATE faturacao_unidades SET Descricao = 'Heure' WHERE Sigla = 'HR';
UPDATE faturacao_unidades SET Descricao = 'Boîte/carton' WHERE Sigla = 'BX';

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.47.2.1' WHERE 1;



UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.1.1' WHERE 1;

CREATE TABLE `faturacao_licences` (
  `ID_Licence` bigint(30) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Cliente` bigint(30) UNSIGNED NOT NULL,
  `TituloCliente` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `NomeCliente` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `ApelidoCliente` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `EnderecoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Vendedor_Primeiro` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Vendedor_Segundo` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Debut` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Duree` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Paiment` smallint(5) UNSIGNED NOT NULL,
  `Referencia` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Remarque` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Location_Mensuelle` decimal(20,6) UNSIGNED NOT NULL,
  `Emolument_Admin` decimal(20,6) UNSIGNED NOT NULL,
  `TVA_Exclue_Primeiro` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `TVA_Exclue_Segundo` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Estado` enum('Rascunho','Confirmado','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_ResponsavelPrimeiro` bigint(30) UNSIGNED NOT NULL,
  `ID_ResponsavelSegundo` bigint(30) UNSIGNED NOT NULL,
  `Decompte_pages` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataCriacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Criacao` bigint(30) UNSIGNED NOT NULL,
  `DataAtualizacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Atualizacao` bigint(30) UNSIGNED NOT NULL,
  `DataTermo` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `TimeStamp_Location` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


CREATE TABLE `faturacao_licences_linhas` (
  `ID_Linha` bigint(30) UNSIGNED NOT NULL,
  `ID_Licence` bigint(30) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


ALTER TABLE `faturacao_licences`
  ADD PRIMARY KEY (`ID_Licence`);


ALTER TABLE `faturacao_licences_linhas`
  ADD PRIMARY KEY (`ID_Linha`);


ALTER TABLE `faturacao_licences`
  MODIFY `ID_Licence` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;


ALTER TABLE `faturacao_licences_linhas`
  MODIFY `ID_Linha` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;


INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES (34, 'Contrats > Licences', '9');

INSERT INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
(126, '0124', 'Contrats de Licences (Créer)', 34),
(127, '0125', 'Contrats de Licences (Modifier)', 34),
(128, '0126', 'Contrats de Licences (Supprimer)', 34),
(129, '0127', 'Contrats de Licences (Consulter)', 34),
(130, '0128', 'Contrats de Licences (Générer Documents)', 34),
(131, '0129', 'Contrats de Licences (Résilier le Contrat)', 34);

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.10.1' WHERE 1;

ALTER TABLE `faturacao_consommables` ADD `NomeCliente2` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `PaisCliente`, ADD `ApelidoCliente2` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `NomeCliente2`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.11.1' WHERE 1;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.12.1' WHERE 1;

ALTER TABLE `faturacao_clientes` CHANGE `ID_Vendedor` `ID_Vendedor` BIGINT(30) UNSIGNED NULL DEFAULT NULL;

ALTER TABLE `faturacao_clientes` CHANGE `ID_Responsavel` `ID_Responsavel` BIGINT(30) UNSIGNED NULL DEFAULT NULL;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.13.1' WHERE 1;

ALTER TABLE `faturacao_modulos` ADD `Mod_Livraison` TINYINT(1) NOT NULL DEFAULT '0' AFTER `Mod_Devis`;

UPDATE `faturacao_modulos` SET `Mod_Livraison`=1 WHERE `Nome` = 'Pro' OR `Nome` = 'Demo';

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.14.1' WHERE 1;

ALTER TABLE `faturacao_modelo_email` ADD `emailcc` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `ID_ModeloEmail`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.15.1' WHERE 1;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.16.1' WHERE 1;

ALTER TABLE `faturacao_rapports_travail` ADD `NomeEmplacement` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `PaisClienteDescarga`, ADD `ApelidoEmplacement` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `NomeEmplacement`, ADD `TituloEmplacement` VARCHAR(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `ApelidoEmplacement`, ADD `ContactoEmplacement` VARCHAR(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `TituloEmplacement`, ADD `EmailEmplacement` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `ContactoEmplacement`;

UPDATE faturacao_rapports_travail SET NomeEmplacement = (SELECT faturacao_clientes.Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_rapports_travail.ID_Cliente);
UPDATE faturacao_rapports_travail SET ApelidoEmplacement = (SELECT faturacao_clientes.Apelido FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_rapports_travail.ID_Cliente);
UPDATE faturacao_rapports_travail SET TituloEmplacement = (SELECT faturacao_clientes.Titulo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_rapports_travail.ID_Cliente);
UPDATE faturacao_rapports_travail SET ContactoEmplacement = (SELECT faturacao_clientes.Telemovel FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_rapports_travail.ID_Cliente);
UPDATE faturacao_rapports_travail SET EmailEmplacement = (SELECT faturacao_clientes.Email FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_rapports_travail.ID_Cliente);

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.17.1' WHERE 1;

INSERT INTO `faturacao_modelo_email` (`ID_ModeloEmail`, `Assunto`, `Texto`) VALUES
(2, 'Livraison de devis', '<p>M./Mme&nbsp;{%client%}</p><p><br></p><p>\n</p><p>Le devis&nbsp;{%numero_facture%} au montant de&nbsp;{%total%} CHF avec une date de&nbsp;{%date%} est jointe.\n</p><p>\n</p><p><br></p><p><br></p><p>Cordialement,</p><p>Frifacturation.</p>');

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.18.1' WHERE 1;

ALTER TABLE `faturacao_faturas` CHANGE `Referencia` `Referencia` VARCHAR(10000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;
ALTER TABLE `faturacao_compras` CHANGE `Referencia` `Referencia` VARCHAR(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;
ALTER TABLE `faturacao_compras_notas_credito` CHANGE `Referencia` `Referencia` VARCHAR(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;
ALTER TABLE `faturacao_notas_credito` CHANGE `Referencia` `Referencia` VARCHAR(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;
ALTER TABLE `faturacao_devis` CHANGE `Referencia` `Referencia` VARCHAR(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;

ALTER TABLE `faturacao_guias_transporte` ADD `ID_DocAgregado` BIGINT(30) UNSIGNED NULL DEFAULT NULL AFTER `DataAtualizacao`, ADD `Tipo_DocAgregado` VARCHAR(5) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL AFTER `ID_DocAgregado`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.19.1' WHERE 1;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.20.1' WHERE 1;

INSERT INTO `faturacao_modelo_email` (`ID_ModeloEmail`, `Assunto`, `Texto`) VALUES
(3, 'Facture n° {%numero_facture%} (1º Rappel)', '<p>M./Mme&nbsp;{%client%}</p><p><br></p><p>\n</p><p>La facture&nbsp;{%numero_facture%} au montant de&nbsp;{%total%} CHF avec une date de&nbsp;{%date%} est jointe.\n</p><p>\n</p><p><br></p><p><br></p><p>Cordialement,</p><p>Frifacturation.</p>');

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.21.1' WHERE 1;

INSERT INTO `faturacao_modelo_email` (`ID_ModeloEmail`, `Assunto`, `Texto`) VALUES
(4, 'Facture n° {%numero_facture%} (2º Rappel)', '<p>M./Mme&nbsp;{%client%}</p><p><br></p><p>\n</p><p>La facture&nbsp;{%numero_facture%} au montant de&nbsp;{%total%} CHF avec une date de&nbsp;{%date%} est jointe.\n</p><p>\n</p><p><br></p><p><br></p><p>Cordialement,</p><p>Frifacturation.</p>');

INSERT INTO `faturacao_modelo_email` (`ID_ModeloEmail`, `Assunto`, `Texto`) VALUES
(5, 'Note de crédit n° {%numero_facture%}', '<p>M./Mme&nbsp;{%client%}</p><p><br></p><p>\n</p><p>La note de crédit&nbsp;{%numero_facture%} au montant de&nbsp;{%total%} CHF avec une date de&nbsp;{%date%} est jointe.\n</p><p>\n</p><p><br></p><p><br></p><p>Cordialement,</p><p>Frifacturation.</p>');

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.22.1' WHERE 1;

CREATE TABLE `faturacao_clientes_comentarios` (
  `ID_Comentario` bigint(30) UNSIGNED NOT NULL,
  `CreatedAt` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `ID_Cliente` bigint(30) UNSIGNED DEFAULT NULL,
  `ID_Utilizador` bigint(30) UNSIGNED DEFAULT NULL,
  `Nome_Utilizador` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `Texto` text CHARACTER SET utf8 COLLATE utf8_unicode_ci
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


ALTER TABLE `faturacao_clientes_comentarios`
  ADD PRIMARY KEY (`ID_Comentario`);


ALTER TABLE `faturacao_clientes_comentarios`
  MODIFY `ID_Comentario` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

  UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.23.1' WHERE 1;

CREATE TABLE `faturacao_parametros_bvr` (
  `ID_Param` int(10) UNSIGNED NOT NULL,
  `VersementPourGauche_X` decimal(5,2) NULL DEFAULT 0,
  `VersementPourGauche_Y` decimal(5,2) NULL DEFAULT 0,
  `VersementPourDroite_X` decimal(5,2) NULL DEFAULT 0,
  `VersementPourDroite_Y` decimal(5,2) NULL DEFAULT 0,
  `EnFaveurGauche_X` decimal(5,2) NULL DEFAULT 0,
  `EnFaveurGauche_Y` decimal(5,2) NULL DEFAULT 0,
  `EnFaveurDroite_X` decimal(5,2) NULL DEFAULT 0,
  `EnFaveurDroite_Y` decimal(5,2) NULL DEFAULT 0,
  `NumCompteGauche_X` decimal(5,2) NULL DEFAULT 0,
  `NumCompteGauche_Y` decimal(5,2) NULL DEFAULT 0,
  `NumCompteDroite_X` decimal(5,2) NULL DEFAULT 0,
  `NumCompteDroite_Y` decimal(5,2) NULL DEFAULT 0,
  `MontantFrancsGauche_X` decimal(5,2) NULL DEFAULT 0,
  `MontantFrancsGauche_Y` decimal(5,2) NULL DEFAULT 0,
  `MontantFrancsDroite_X` decimal(5,2) NULL DEFAULT 0,
  `MontantFrancsDroite_Y` decimal(5,2) NULL DEFAULT 0,
  `MontantCentsGauche_X` decimal(5,2) NULL DEFAULT 0,
  `MontantCentsGauche_Y` decimal(5,2) NULL DEFAULT 0,
  `MontantCentsDroite_X` decimal(5,2) NULL DEFAULT 0,
  `MontantCentsDroite_Y` decimal(5,2) NULL DEFAULT 0,
  `VerseParGauche_X` decimal(5,2) NULL DEFAULT 0,
  `VerseParGauche_Y` decimal(5,2) NULL DEFAULT 0,
  `VerseParDroite_X` decimal(5,2) NULL DEFAULT 0,
  `VerseParDroite_Y` decimal(5,2) NULL DEFAULT 0,
  `NumReference_X` decimal(5,2) NULL DEFAULT 0,
  `NumReference_Y` decimal(5,2) NULL DEFAULT 0,
  `LigneCodage_X` decimal(5,2) NULL DEFAULT 0,
  `LigneCodage_Y` decimal(5,2) NULL DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `faturacao_parametros_bvr`
  ADD PRIMARY KEY (`ID_Param`);


ALTER TABLE `faturacao_parametros_bvr`
  MODIFY `ID_Param` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

INSERT INTO `faturacao_parametros_bvr` (`ID_Param`) VALUES (1);

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.24.1' WHERE 1;

ALTER TABLE `faturacao_compras` ADD `TotalLiquidado` DECIMAL(20,6) UNSIGNED NOT NULL DEFAULT '0' AFTER `TotalCreditado`;

CREATE TABLE `faturacao_compras_pagamentos` (
  `ID_Liquidacao` bigint(30) UNSIGNED NOT NULL,
  `ID_Compra` bigint(30) UNSIGNED DEFAULT NULL,
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `TotalPago` decimal(20,6) UNSIGNED DEFAULT '0.000000',
  `Banco` int(10) UNSIGNED DEFAULT NULL,
  `Metodo` int(10) UNSIGNED DEFAULT NULL,
  `Observacoes` text CHARACTER SET utf8 COLLATE utf8_unicode_ci
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `faturacao_compras_pagamentos`
  ADD PRIMARY KEY (`ID_Liquidacao`);

ALTER TABLE `faturacao_compras_pagamentos`
  MODIFY `ID_Liquidacao` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT;

UPDATE faturacao_compras SET TotalLiquidado = GrossTotal WHERE Estado = 'Pago';

UPDATE faturacao_compras SET TotalLiquidado = TotalCreditado WHERE Estado = 'Aberto';

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.48.25.1' WHERE 1;

CREATE TABLE `faturacao_emails_kpax_readed` (
  `ID_Email` bigint(30) NOT NULL,
  `FromAddr` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `Subject` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `MailDate` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `XmlFileURL` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `UDateTime` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `faturacao_emails_kpax_readed`
  ADD PRIMARY KEY (`ID_Email`);

ALTER TABLE `faturacao_emails_kpax_readed`
  MODIFY `ID_Email` bigint(30) NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_emails_kpax_readed` ADD `CreatedAt` VARCHAR(50) NULL DEFAULT NULL AFTER `UDateTime`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.1.1' WHERE 1;

ALTER TABLE `faturacao_movimentos_contabilisticos` ADD `NaturezaMovimento` VARCHAR(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT 'A' AFTER `SaldoCredit`;

ALTER TABLE `faturacao_plano_conta` ADD `ID_Imposto` BIGINT(30) UNSIGNED NULL DEFAULT NULL AFTER `Ecriture`;

ALTER TABLE `faturacao_modulos` ADD `Mod_Consommables` TINYINT(1) UNSIGNED NULL DEFAULT '0' AFTER `Mod_Livraison`, ADD `Mod_Licences` TINYINT(1) UNSIGNED NULL DEFAULT '0' AFTER `Mod_Consommables`;

UPDATE `faturacao_modulos` SET `Mod_Consommables`=1, `Mod_Licences`=1 WHERE `Nome` = 'Pro' OR `Nome` = 'Demo';

ALTER TABLE `faturacao_modulos` ADD `Mod_Sportifs` TINYINT(1) UNSIGNED NULL DEFAULT '0' AFTER `Mod_Licences`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.2.1' WHERE 1;

DROP TABLE `ano`;

DROP TABLE `autarquia`, `banco`, `departamento`, `departamento_utilizador`, `freguesia`, `modulo`, `modulo_autarquia`, `modulo_demo`, `sms_modelo`, `sms_prefs`;

UPDATE faturacao_modelo_email SET emailcc = (SELECT Email FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1), Assunto = CONCAT( "Facture " ,(SELECT Designacao FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1), " n° {%numero_document%}" ), Texto = CONCAT('<p>Concerne: {%client%}.\r</p><p>Madame, Monsieur,\r</p><p>Vous trouverez en pièce jointe votre facture {%numero_document%} pour un montant de {%total%} CHF du {%date%}.\r</p><p>En cas de question, n\'hésitez surtout pas à nous contacter \"', (SELECT Email FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,'\", ou contacter votre personne de référence.\r</p><p><br></p><p>Cordialement,</p><p>', (SELECT Designacao FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,'</p>') WHERE ID_ModeloEmail = 1;

UPDATE faturacao_modelo_email SET emailcc = (SELECT Email FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1), Assunto = CONCAT( "Devis {%numero_document%}" ), Texto = CONCAT('<p style=\"line-height: 1;\">{%client%}</p><p style=\"line-height: 1;\"><br></p><p style=\"line-height: 1;\">\n</p><p style=\"line-height: 1;\">Offre ', (SELECT Designacao FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,' {%numero_document%}</p><p style=\"line-height: 1;\">\n</p><p style=\"line-height: 1;\">', (SELECT Cidade FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,', le {%date%}</p><p style=\"line-height: 1;\"><br></p><p style=\"line-height: 1;\">\n</p><p style=\"line-height: 1;\">\n</p><p style=\"line-height: 1;\">Madame, Monsieur,</p><p style=\"line-height: 1;\">Par la présente, nous vous remercions pour l\'intérêt que vous portez à nos produits et avons l’avantage de vous proposer, en annexe, une offre pour l’appareil susmentionné.</p><p style=\"line-height: 1;\">\n</p><p style=\"line-height: 1;\">En espérant vous satisfaire avec cette proposition, nous vous remercions pour votre confiance et restons à votre entière disposition pour de plus amples renseignements.\n</p><p style=\"line-height: 1;\">\n</p><p style=\"line-height: 1;\">Dans l\'attente de vos nouvelles, nous vous présentons, Madame, Monsieur, nos plus cordiales salutations.\n</p><p style=\"line-height: 1;\"><br></p><p style=\"line-height: 1;\">', (SELECT Designacao FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,' \n</p><p style=\"line-height: 1;\">\n</p><p style=\"line-height: 1;\">', (SELECT Telefone FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,'</p><p style=\"line-height: 1;\">', (SELECT Website FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,' \n</p>') WHERE ID_ModeloEmail = 2;

UPDATE faturacao_modelo_email SET emailcc = (SELECT Email FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1), Assunto = "Facture n° {%numero_document%} (1º Rappel)", Texto = CONCAT('<p>Concerne: <b>1er rappel</b> {%client%}. \n</p><p>\nMadame, Monsieur,&nbsp;</p><p>Sauf erreur ou omission de notre part, le paiement de la facture {%numero_document%} pour un montant de {%total%} CHF du {%date%} ne nous est pas parvenu. \n</p><p>Nous vous remercions de bien vouloir régler cette dernière dans un délai de {%conditions%} jours .\n</p><p>Si entretemps votre paiement nous est parvenu, nous vous saurions gré de ne pas tenir compte du présent mail.\n</p><p>En cas de question, n\'hésitez surtout pas à nous contacter \"', (SELECT Email FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,'\", ou contacter votre personne de référence.</p><p><br></p><p>Cordialement,</p><p>', (SELECT Designacao FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,'.</p>') WHERE ID_ModeloEmail = 3;

UPDATE faturacao_modelo_email SET emailcc = (SELECT Email FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1), Assunto = "Facture n° {%numero_document%} (2º Rappel)", Texto = CONCAT('<p>Concerne: <b>2ème rappel</b> {%client%}.\n</p><p>Madame, Monsieur,\n</p><p>Sauf erreur ou omission de notre part, le paiement de la facture {%numero_document%} pour un montant de {%total%} CHF du {%date%} ne nous est pas parvenu.\n</p><p>Nous vous remercions de bien vouloir régler cette dernière dans un délai de {%conditions%} jours, <u>car autrement nous serions obligé de vous bloquer votre compte.\n</u></p><p>Si entretemps votre paiement nous est parvenu, nous vous saurions gré de ne pas tenir compte du présent mail.\n</p><p>En cas de question, n\'hésitez surtout pas à nous contacter \"', (SELECT Email FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,'\", ou contacter votre personne de référence.\n</p><p><br></p><p>Cordialement,\n</p><p>', (SELECT Designacao FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,'.</p>') WHERE ID_ModeloEmail = 4;

UPDATE faturacao_modelo_email SET emailcc = (SELECT Email FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1), Assunto = "Note de crédit n° {%numero_document%}", Texto = CONCAT('<p>M./Mme&nbsp;{%client%}</p><p><br></p><p>\n</p><p>La note de crédit&nbsp;{%numero_document%} au montant de&nbsp;{%total%} CHF avec une date de&nbsp;{%date%} est jointe.\n</p><p>\n</p><p><br></p><p><br></p><p>Cordialement,</p><p>', (SELECT Designacao FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1) ,'.</p>') WHERE ID_ModeloEmail = 5;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.3.1' WHERE 1;

ALTER TABLE `faturacao_movimentos_contabilisticos` ADD `IncludeTVA` TINYINT(1) UNSIGNED NULL DEFAULT '0' AFTER `NaturezaMovimento`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.3.1' WHERE 1;

DROP TABLE `concelho`;

DROP TABLE `distrito`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.4.1' WHERE 1;

ALTER TABLE `faturacao_faturas` ADD `TotalExtra` DECIMAL(20,6) UNSIGNED NULL DEFAULT '0' AFTER `TotalPagar`, ADD `TotalExtraLiquidado` DECIMAL(20,6) UNSIGNED NULL DEFAULT '0' AFTER `TotalExtra`;

ALTER TABLE `faturacao_recibos_linhas` ADD `TotalExtraRecebido` DECIMAL(20,6) UNSIGNED NULL DEFAULT '0' AFTER `valorIVA`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.5.1' WHERE 1;

INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES (35, 'Comptabilité > Documents clients', '24');

INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES (36, 'Comptabilité > Documents fournisseurs', '24');

INSERT INTO `faturacao_permissions` (`Machine_Name`, `Name`, `Funcionalidade`) VALUES
('0130', 'Documents clients (Générer Documents)', 35),
('0131', 'Documents fournisseurs (Générer Documents)', 36);

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.6.1' WHERE 1;

ALTER TABLE `faturacao_personalizar_documentos` ADD `UnidadesMedida` TINYINT UNSIGNED NULL DEFAULT '0' AFTER `Swift`, ADD `NumCasasDecimais` TINYINT UNSIGNED NULL DEFAULT '2' AFTER `UnidadesMedida`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.7.1' WHERE 1;

ALTER TABLE `faturacao_locations` ADD `Arquivado` TINYINT(1) UNSIGNED NULL DEFAULT '0' AFTER `TimeStamp_Location`;

ALTER TABLE `faturacao_personalizar_documentos` ADD `StockMinimo` INT UNSIGNED NULL DEFAULT '0' AFTER `NumCasasDecimais`, ADD `EmailRececaoStock` VARCHAR(300) NULL DEFAULT NULL AFTER `StockMinimo`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.49.8.1' WHERE 1;

ALTER TABLE `faturacao_faturas` CHANGE `PlanoContasBanco` `PlanoContasBanco` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL;

ALTER TABLE `faturacao_compras` CHANGE `PlanoContasBanco` `PlanoContasBanco` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL;

ALTER TABLE `faturacao_compras_notas_credito` CHANGE `PlanoContasBanco` `PlanoContasBanco` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL;

ALTER TABLE `faturacao_devis` CHANGE `PlanoContasBanco` `PlanoContasBanco` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL;

ALTER TABLE `faturacao_notas_credito` CHANGE `PlanoContasBanco` `PlanoContasBanco` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.50.1.1' WHERE 1;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.51.1.1' WHERE 1;

ALTER TABLE `faturacao_unidades` ADD `Sistema` TINYINT(1) UNSIGNED NULL DEFAULT '0' AFTER `Sigla`;
ALTER TABLE `faturacao_unidades` ADD `Ativo` TINYINT(1) UNSIGNED NULL DEFAULT '1' AFTER `Sistema`;

UPDATE faturacao_unidades SET Sistema=1 WHERE ID_Unidade < 8;

INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES (37, 'Tableaux > Unités de Mesure', '19');

INSERT INTO `faturacao_permissions` (`Machine_Name`, `Name`, `Funcionalidade`) VALUES
('0132', 'Unités de Mesure (Consulter)', 37),
('0133', 'Unités de Mesure (Supprimer)', 37),
('0134', 'Unités de Mesure (Modifier)', 37),
('0135', 'Unités de Mesure (Créer)', 37);

INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES (38, 'Tableaux > Code Postal (NPA)', '19');

INSERT INTO `faturacao_permissions` (`Machine_Name`, `Name`, `Funcionalidade`) VALUES
('0136', 'Code Postal (NPA) (Consulter)', 38),
('0137', 'Code Postal (NPA) (Supprimer)', 38),
('0138', 'Code Postal (NPA) (Modifier)', 38),
('0139', 'Code Postal (NPA) (Créer)', 38);

INSERT INTO `faturacao_funcionalidades` (`ID_Funcionalidade`, `Nome`, `Posicao`) VALUES (39, 'Contrats > Achats', '9'),(40, 'Sportifs', '40');

INSERT INTO `faturacao_permissions` (`Machine_Name`, `Name`, `Funcionalidade`) VALUES
('0140', 'Contrats de Achats (Consulter)', 39),
('0141', 'Contrats de Achats (Supprimer)', 39),
('0142', 'Contrats de Achats (Modifier)', 39),
('0143', 'Contrats de Achats (Créer)', 39),
('0144', 'Contrats de Achats (Générer Documents)', 39),
('0145', 'Contrats de Achats (Résilier le Contrat)', 39);

CREATE TABLE `faturacao_contrats_achats` (
  `ID_Achat` bigint(30) UNSIGNED NOT NULL,
  `Numero` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Cliente` bigint(30) UNSIGNED NOT NULL,
  `TituloCliente` varchar(10) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `NomeCliente` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `ApelidoCliente` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `EnderecoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalCliente` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailCliente` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisCliente` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `NomeCliente2` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `ApelidoCliente2` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `EnderecoClienteDescarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EnderecoCliente2Descarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CodigoPostalClienteDescarga` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `CidadeClienteDescarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `RegiaoClienteDescarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `EmailClienteDescarga` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PaisClienteDescarga` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Vendedor_Primeiro` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `ID_Vendedor_Segundo` bigint(30) UNSIGNED NOT NULL DEFAULT '0',
  `Data` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Debut` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Facturation` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Paiment` smallint(5) UNSIGNED NOT NULL,
  `Referencia` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Remarque` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `PrixAchat` decimal(20,6) UNSIGNED NOT NULL,
  `PrixInstallation` decimal(20,6) UNSIGNED NOT NULL,
  `PrixPreparation` decimal(20,6) UNSIGNED NOT NULL,
  `PrixTaxeAntecipe` decimal(20,6) UNSIGNED NOT NULL,
  `ID_ResponsavelPrimeiro` bigint(30) UNSIGNED NOT NULL,
  `ID_ResponsavelSegundo` bigint(30) UNSIGNED NOT NULL,
  `Estado` enum('Rascunho','Confirmado','Aberto','Anulado') CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `DataCriacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Criacao` bigint(30) UNSIGNED NOT NULL,
  `DataAtualizacao` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ID_Utilizador_Atualizacao` bigint(30) UNSIGNED NOT NULL,
  `DataTermo` varchar(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `TimeStamp_Achat` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `faturacao_performances` (
  `ID_Perf` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ID_Sportif` bigint(30) unsigned DEFAULT NULL,
  `Activite` text DEFAULT NULL,
  `Adversaire` text DEFAULT NULL,
  `Resultat` text DEFAULT NULL,
  `Technique` tinyint(4) unsigned DEFAULT NULL,
  `Intelligence` tinyint(4) unsigned DEFAULT NULL,
  `Personalite` tinyint(4) unsigned DEFAULT NULL,
  `Vitesse` tinyint(4) unsigned DEFAULT NULL,
  `Titulaire` tinyint(4) unsigned DEFAULT NULL,
  `Minutes` tinyint(4) DEFAULT NULL,
  `Position` text DEFAULT NULL,
  `Buts` tinyint(4) unsigned DEFAULT NULL,
  `Assistances` tinyint(4) unsigned DEFAULT NULL,
  `Avertissements` tinyint(4) unsigned DEFAULT NULL,
  `Note` float unsigned DEFAULT NULL,
  `Details` text DEFAULT NULL,
  PRIMARY KEY (`ID_Perf`),
  KEY `FK_faturacao_performances_faturacao_clientes` (`ID_Sportif`),
  CONSTRAINT `FK_faturacao_performances_faturacao_clientes` FOREIGN KEY (`ID_Sportif`) REFERENCES `faturacao_clientes` (`ID_Cliente`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE `faturacao_contrats_achats_linhas` (
  `ID_Linha` bigint(30) UNSIGNED NOT NULL,
  `ID_Achat` bigint(30) UNSIGNED NOT NULL,
  `ID_Artigo` bigint(30) UNSIGNED NOT NULL,
  `NumeroLinha` int(10) UNSIGNED NOT NULL,
  `ProductCode` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `ProductDescription` varchar(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `SerialNumber` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `Quantidade` decimal(20,6) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


ALTER TABLE `faturacao_contrats_achats`
  ADD PRIMARY KEY (`ID_Achat`);


ALTER TABLE `faturacao_contrats_achats_linhas`
  ADD PRIMARY KEY (`ID_Linha`);


ALTER TABLE `faturacao_contrats_achats`
  MODIFY `ID_Achat` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

ALTER TABLE `faturacao_contrats_achats_linhas`
  MODIFY `ID_Linha` bigint(30) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

INSERT INTO `faturacao_artigos` (`Nome`, `Codigo`, `Tipo`, `CodigoBarras`, `SerialNumber`, `ID_Categoria`, `ID_Unidade`, `Preco`, `ID_Imposto`, `ID_Imposto_Fornecedor`, `PrecoPVP`, `RetencaoPercentagem`, `RetencaoValor`, `Stock`, `Ativo`, `PlanoContas`, `PlanoContasCompras`, `Usado`, `ID_Prestashop`) VALUES
('Prix d\'achat', 'CA0001', 'S', '', '', 0, 1, '0.000000', 21, 19, '0.000000', '0.00', '0.000000', '0.000', 0, '6402', '6402', 1, 0),
('Prix installation IT', 'CA0002', 'S', '', '', 0, 1, '0.000000', 21, 19, '0.000000', '0.00', '0.000000', '0.000', 0, '6402', '6402', 1, 0),
('Prix de préparation, livraison et formation', 'CA0003', 'S', '', '', 0, 1, '0.000000', 21, 19, '0.000000', '0.00', '0.000000', '0.000', 0, '6402', '6402', 1, 0),
('Prix taxe anticipée', 'CA0004', 'S', '', '', 0, 1, '0.000000', 21, 19, '0.000000', '0.00', '0.000000', '0.000', 0, '6402', '6402', 1, 0);

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.52.1.1' WHERE 1;

CREATE TABLE `faturacao_utilizadores_webservices` (
  `ID_UtilizadorWebservice` bigint(30) NOT NULL,
  `Nome` varchar(500) DEFAULT NULL,
  `Email` varchar(500) DEFAULT NULL,
  `Username` varchar(500) NOT NULL,
  `Password` varchar(1000) NOT NULL,
  `Salt` varchar(100) NOT NULL,
  `PasswordErrada` int(11) DEFAULT NULL,
  `PasswordBloqueada` timestamp NULL DEFAULT NULL,
  `Ativo` tinyint(4) NOT NULL DEFAULT '1',
  `Token` varchar(1000) DEFAULT NULL,
  `Token_Expires` timestamp NULL DEFAULT NULL,
  `Created` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `Updated` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `faturacao_utilizadores_webservices`
  ADD PRIMARY KEY (`ID_UtilizadorWebservice`);

ALTER TABLE `faturacao_utilizadores_webservices`
  MODIFY `ID_UtilizadorWebservice` bigint(30) NOT NULL AUTO_INCREMENT;

ALTER TABLE `faturacao_utilizadores_webservices` ADD `Token_Created` TIMESTAMP NULL DEFAULT NULL AFTER `Token`;

ALTER TABLE `faturacao_personalizar_documentos` ADD `SerieWebservices` INT UNSIGNED NOT NULL DEFAULT '0' AFTER `EmailRececaoStock`, ADD `MetodoPagamentoWebservices` INT UNSIGNED NOT NULL DEFAULT '1' AFTER `SerieWebservices`, ADD `BancoWebservices` INT UNSIGNED NOT NULL DEFAULT '0' AFTER `MetodoPagamentoWebservices`;

UPDATE faturacao_personalizar_documentos SET SerieWebservices = (SELECT ID_Serie FROM faturacao_series WHERE Predefinida = 1 ORDER BY ID_Serie DESC LIMIT 1), MetodoPagamentoWebservices = MetodoPagamento, BancoWebservices = (SELECT ID_Banco FROM faturacao_bancos WHERE Predefinido = 1 ORDER BY ID_Banco DESC LIMIT 1) WHERE 1;

UPDATE `faturacao_modelo_email` SET `Assunto` = 'Facture {%nom_societe%} n° {%numero_document%}', `Texto` = '<p>Concerne: {%client%}.</p><p>Madame, Monsieur,</p><p>Vous trouverez en pièce jointe votre facture {%numero_document%} pour un montant de {%total%} CHF du {%date%}.</p><p>En cas de question, n\'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p>Cordialement,</p><p>{%nom_societe%}</p><p><br></p><p><br></p><p>Concerne: {%client%}.</p><p>Sehr geehrte Damen und Herren</p><p>Sie finden anbei Ihre Rechnung {%numero_document%} für den Betrag von {%total%} CHF, vom {%date%}.</p><p>Bei Fragen Können Sie sich an {%mail%} oder an Ihre Referenz Person wenden.</p><p>Mit freundlichen Grüssen</p><p>{%nom_societe%} </p>' WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 1;

UPDATE `faturacao_modelo_email` SET `Texto` = '<p style="line-height: 1;">{%client%}</p><p style="line-height: 1;">Fribourg, le {%date%}</p><p style="line-height: 1;">Offre {%nom_societe%} {%numero_document%}</p><p style="line-height: 1;">Madame, Monsieur,</p><p style="line-height: 1;">Par la présente, nous vous remercions de l\'intérêt que vous portez à nos produits et vous proposons, en annexe, une offre correspondant à votre demande.</p><p style="line-height: 1;">En espérant vous satisfaire avec cette proposition, nous vous remercions pour votre confiance et restons à votre entière disposition pour de plus amples renseignements.</p><p style="line-height: 1;">En cas de question, n\'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p style="line-height: 1;">Dans l\'attente de vos nouvelles, nous vous présentons, Madame, Monsieur, nos plus cordiales salutations.</p><p style="line-height: 1;"><br></p><p style="line-height: 1;"><br></p><p style="line-height: 1;">{%client%}</p><p style="line-height: 1;">Freiburg, {%date%}</p><p style="line-height: 1;">Angebot {%nom_societe%} {%numero_document%}</p><p style="line-height: 1;">Sehr geehrte Damen und Herren,</p><p style="line-height: 1;">Wir bedanken uns für Ihr Interesse an unseren Produkten und unterbreiten Ihnen ein Angebot gemäß Ihrer Anfrage.</p><p style="line-height: 1;">Wir hoffen, Sie mit diesem Vorschlag zufrieden zu stellen, danken Ihnen für Ihr Vertrauen und stehen Ihnen für weitere Informationen gerne zur Verfügung.</p><p style="line-height: 1;">Bei Fragen Können Sie sich an {%mail%} oder an Ihre Referenz Person wenden.</p><p style="line-height: 1;">Wir freuen uns auf Ihre Kontaktaufnahme und möchten Sie, Frau, Herr, herzlichst begrüßen.</p><p style="line-height: 1;"><br></p><p style="line-height: 1;">{%nom_societe%}</p><p style="line-height: 1;">(numéro de télephone)</p><p style="line-height: 1;">(site internet) </p>' WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 2;

UPDATE `faturacao_modelo_email` SET `Texto` = '<p>Concerne: 1er rappel {%client%}.</p><p>Madame, Monsieur,</p><p>Sauf erreur ou omission de notre part, le paiement de la facture {%numero_document%} pour un montant de {%total%} CHF du {%date%} ne nous est pas parvenu.</p><p>Nous vous remercions de bien vouloir régler cette dernière dans un délai de {%conditions%} jours .</p><p>Si entretemps votre paiement nous est parvenu, nous vous saurions gré de ne pas tenir compte du présent mail.</p><p>En cas de question, n\'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p>Cordialement,</p><p>{%nom_societe%}</p><p><br></p><p><br></p><p>Bedenken: 1. Erinnerung {%client%}.</p><p>Sehr geehrte Damen und Herren,</p><p>Sofern wir keinen Fehler oder Auslassung gemacht haben, haben wir keine Zahlung der Rechnung {%numero_document%} für einen Betrag von {%total%} CHF von {%date%} erhalten.</p><p>Wir danken Ihnen, dass Sie diese innerhalb von 10 Tagen bezahlt haben.</p><p>Wenn wir in der Zwischenzeit Ihre Zahlung erhalten haben, würden wir uns freuen, wenn Sie diese E-Mail nicht beachten würden.</p><p>Bei Fragen stehen wir Ihnen gerne unter {%mail%} zur Verfügung oder kontaktieren Sie Ihren Ansprechpartner.</p><p>Mit freundlichen Grüßen,</p><p>{%nom_societe%} </p>' WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 3;

UPDATE `faturacao_modelo_email` SET `Texto` = '<p>Concerne: 2ème rappel {%client%}.</p><p>Madame, Monsieur,</p><p>Sauf erreur ou omission de notre part, le paiement de la facture {%numero_document%} pour un montant de {%total%} CHF du {%date%} ne nous est pas parvenu.</p><p>Nous vous remercions de bien vouloir régler cette dernière dans un délai de {%conditions%} jours, car autrement nous serions obligé de vous bloquer votre compte.</p><p>Si entretemps votre paiement nous est parvenu, nous vous saurions gré de ne pas tenir compte du présent mail.</p><p>En cas de question, n\'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p>Cordialement,</p><p>{%nom_societe%}</p><p><br></p><p><br></p><p>Bedenken: 2. Erinnerung {%client%}.</p><p>Sehr geehrte Damen und Herren,</p><p>Sofern wir keinen Fehler oder Auslassung gemacht haben, haben wir keine Zahlung der Rechnung {%numero_document%} für einen Betrag von {%total%} CHF von {%date%} erhalten.</p><p>Wir danken Ihnen, dass Sie die Zahlung innerhalb von 10 Tagen geleistet haben, sonst wären wir verpflichtet, Ihr Konto zu sperren.</p><p>Wenn wir in der Zwischenzeit Ihre Zahlung erhalten haben, würden wir uns freuen, wenn Sie diese E-Mail nicht beachten würden.</p><p>Bei Fragen stehen wir Ihnen gerne unter {%mail%} zur Verfügung oder kontaktieren Sie Ihren Ansprechpartner.</p><p>Mit freundlichen Grüßen,</p><p>{%nom_societe%} </p>' WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 4;

UPDATE `faturacao_modelo_email` SET `Texto` = '<p>Concerne: {%client%}.</p><p>Madame, Monsieur,</p><p>Vous trouverez en pièce jointe votre note de crédit {%numero_document%} pour un montant de {%total%} CHF du {%date%}.</p><p>En cas de question, n\'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p>Cordialement,</p><p>{%nom_societe%}</p><p><br></p><p><br></p><p>Concerne: {%client%}.</p><p>Sehr geehrte Damen und Herren</p><p>Sie finden anbei Ihre Gutschrift {%numero_document%} für den Betrag von {%total%} CHF, vom {%date%}.</p><p>Bei Fragen Können Sie sich an {%mail%} oder an Ihre Referenz Person wenden.</p><p>Mit freundlichen Grüssen</p><p>{%nom_societe%} </p>' WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 5;

ALTER TABLE `faturacao_consommables` ADD `Arquivado` TINYINT(1) UNSIGNED NULL DEFAULT '0' AFTER `TimeStamp_Consommable`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.52.1.1' WHERE 1;


ALTER TABLE `utilizador` CHANGE `PasswordErrada` `PasswordErrada` INT(11) NULL DEFAULT NULL;

ALTER TABLE `utilizador` CHANGE `PasswordErrada` `PasswordErrada` INT(11) NULL DEFAULT NULL;

ALTER TABLE `utilizador` CHANGE `ID_Autarquia` `ID_Autarquia` INT(11) NULL DEFAULT NULL;
ALTER TABLE `utilizador` CHANGE `ID_TipoUtilizador` `ID_TipoUtilizador` INT(11) NULL DEFAULT NULL;
ALTER TABLE `utilizador` CHANGE `ID_Permissao` `ID_Permissao` INT(11) NULL DEFAULT NULL;
ALTER TABLE `utilizador` CHANGE `Nome` `Nome` VARCHAR(500) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;
ALTER TABLE `utilizador` CHANGE `Email` `Email` VARCHAR(500) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;
ALTER TABLE `utilizador` CHANGE `Username` `Username` VARCHAR(500) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;
ALTER TABLE `utilizador` CHANGE `Password` `Password` VARCHAR(500) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;

ALTER TABLE `utilizador` CHANGE `Salt` `Salt` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;
ALTER TABLE `utilizador` CHANGE `CodigoSIIAL` `CodigoSIIAL` VARCHAR(1000) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;
ALTER TABLE `utilizador` CHANGE `CodigoInternoVendedor` `CodigoInternoVendedor` VARCHAR(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.52.2.1' WHERE 1;

ALTER TABLE `faturacao_personalizar_documentos` ADD `RapportsTravailSpecial` TINYINT(1) UNSIGNED NULL DEFAULT '0' COMMENT '0 - Não | 1 - Sim' AFTER `BancoWebservices`;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.52.3.1' WHERE 1;

INSERT INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
(148, '0146', 'Contrats de Consommables: Détails - Top Corner Information (Consulter)', 9),
(149, '0147', 'Contrats de Consommables: Détails - Informations inférieures (Consulter)', 9),
(150, '0148', 'Contrats de Consommables Imprimer (Consulter)', 9);

INSERT IGNORE INTO `faturacao_permissions` (`ID_Permission`, `Machine_Name`, `Name`, `Funcionalidade`) VALUES
	(152, '0150', 'Sportifs (Consulter)', 40),
	(153, '0151', 'Sportifs (Supprimer)', 40),
	(154, '0152', 'Sportifs (Modifier)', 40),
	(155, '0153', 'Sportifs (Créer)', 40),
	(156, '0154', 'Cotisation (Consulter)', 40),
	(157, '0155', 'Cotisation (Supprimer)', 40),
	(158, '0156', 'Cotisation (Modifier)', 40),
	(159, '0157', 'Cotisation (Créer)', 40),
	(160, '0158', 'Cotisation (Générer Documents)', 40),
	(161, '0159', 'Cotisation (Résilier le Contrat)', 40);
	


INSERT INTO `faturacao_role_permission` (`ID_Role_Rel`, `ID_Permission_Rel`) VALUES
(1, 106),
(1, 17),
(1, 18),
(1, 19),
(1, 20),
(1, 21),
(1, 22),
(1, 23),
(1, 24),
(1, 25),
(1, 26),
(1, 27),
(1, 28),
(1, 29),
(1, 30),
(1, 31),
(1, 33),
(1, 34),
(1, 35),
(1, 36),
(1, 37),
(1, 38),
(1, 39),
(1, 40),
(1, 41),
(1, 42),
(1, 43),
(1, 44),
(1, 45),
(1, 46),
(1, 114),
(1, 113),
(1, 112),
(1, 111),
(1, 110),
(1, 118),
(1, 117),
(1, 116),
(1, 115),
(1, 123),
(1, 122),
(1, 121),
(1, 120),
(1, 119),
(4, 5),
(4, 7),
(4, 8),
(4, 9),
(4, 10),
(4, 14),
(4, 109),
(4, 15),
(4, 16),
(4, 107),
(4, 108),
(4, 17),
(4, 18),
(4, 19),
(4, 20),
(4, 21),
(4, 110),
(4, 111),
(4, 112),
(4, 113),
(4, 114),
(4, 119),
(4, 120),
(4, 121),
(4, 122),
(4, 123),
(4, 22),
(4, 23),
(4, 24),
(4, 25),
(4, 26),
(4, 27),
(4, 28),
(4, 29),
(4, 30),
(4, 31),
(4, 32),
(4, 33),
(4, 34),
(4, 35),
(4, 36),
(4, 37),
(4, 38),
(4, 39),
(4, 40),
(4, 41),
(4, 124),
(4, 47),
(4, 48),
(4, 49),
(4, 50),
(4, 51),
(4, 52),
(4, 53),
(4, 54),
(4, 55),
(4, 56),
(4, 57),
(4, 58),
(4, 59),
(4, 60),
(4, 61),
(4, 62),
(4, 63),
(4, 64),
(4, 65),
(4, 79),
(4, 80),
(4, 81),
(4, 82),
(4, 83),
(4, 84),
(4, 85),
(4, 86),
(4, 102),
(4, 103),
(4, 104),
(4, 105),
(4, 115),
(4, 116),
(4, 117),
(4, 118),
(4, 134),
(4, 135),
(4, 136),
(4, 137),
(4, 138),
(4, 139),
(4, 140),
(4, 141),
(3, 9),
(3, 11),
(3, 12),
(3, 14),
(3, 15),
(3, 16),
(3, 17),
(3, 18),
(3, 19),
(3, 20),
(3, 21),
(3, 110),
(3, 22),
(3, 23),
(3, 24),
(3, 25),
(3, 26),
(3, 27),
(3, 28),
(3, 29),
(3, 30),
(3, 31),
(3, 32),
(3, 33),
(3, 34),
(3, 35),
(3, 36),
(3, 37),
(3, 38),
(3, 39),
(3, 40),
(3, 41),
(3, 42),
(3, 43),
(3, 44),
(3, 45),
(3, 46),
(3, 47),
(3, 48),
(3, 49),
(3, 50),
(3, 51),
(3, 52),
(3, 53),
(3, 54),
(3, 55),
(3, 56),
(3, 57),
(3, 58),
(3, 59),
(3, 60),
(3, 61),
(3, 62),
(3, 63),
(3, 64),
(3, 65),
(3, 66),
(3, 67),
(3, 68),
(3, 69),
(3, 70),
(3, 71),
(3, 72),
(3, 73),
(3, 74),
(3, 75),
(3, 76),
(3, 77),
(3, 78),
(3, 79),
(3, 80),
(3, 81),
(3, 82),
(3, 83),
(3, 84),
(3, 85),
(3, 86),
(3, 102),
(3, 103),
(3, 104),
(3, 105),
(3, 87),
(3, 88),
(3, 89),
(3, 90),
(3, 91),
(3, 92),
(3, 93),
(3, 94),
(3, 95),
(3, 96),
(3, 97),
(3, 98),
(3, 99),
(3, 100),
(3, 101);

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.52.4.1' WHERE 1;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '1.52.5.1' WHERE 1;

ALTER TABLE faturacao_series ADD `NumeroInicial_FT` int(11) UNSIGNED NULL DEFAULT 1 AFTER `Predefinida`;
ALTER TABLE faturacao_series ADD `NumeroInicial_NC` int(11) UNSIGNED NULL DEFAULT 1 AFTER `NumeroInicial_FT`;
ALTER TABLE faturacao_series ADD `NumeroInicial_GT` int(11) UNSIGNED NULL DEFAULT 1 AFTER `NumeroInicial_NC`;
ALTER TABLE faturacao_series ADD `NumeroInicial_DV` int(11) UNSIGNED NULL DEFAULT 1 AFTER `NumeroInicial_GT`;
ALTER TABLE faturacao_series ADD `NumeroInicial_RG` int(11) UNSIGNED NULL DEFAULT 1 AFTER `NumeroInicial_DV`;
ALTER TABLE `faturacao_bancos` CHANGE `CodigoBVR` `CodigoBVR` VARCHAR(11) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '000000';

ALTER TABLE faturacao_personalizar_documentos ADD `NumeroInicial_RT` int(11) UNSIGNED NULL DEFAULT 1 AFTER `RapportsTravailSpecial`;
ALTER TABLE faturacao_personalizar_documentos ADD `NumeroInicial_CLIC` int(11) UNSIGNED NULL DEFAULT 1 AFTER `NumeroInicial_RT`;
ALTER TABLE faturacao_personalizar_documentos ADD `NumeroInicial_CLOC` int(11) UNSIGNED NULL DEFAULT 1 AFTER `NumeroInicial_CLIC`;
ALTER TABLE faturacao_personalizar_documentos ADD `NumeroInicial_CCON` int(11) UNSIGNED NULL DEFAULT 1 AFTER `NumeroInicial_CLOC`;
ALTER TABLE faturacao_personalizar_documentos ADD `NumeroInicial_CACH` int(11) UNSIGNED NULL DEFAULT 1 AFTER `NumeroInicial_CCON`;

ALTER TABLE `faturacao_modelo_email`  ADD `Francais` TEXT NOT NULL  AFTER `Texto`;
ALTER TABLE `faturacao_modelo_email`  ADD `Anglais` TEXT NOT NULL  AFTER `Francais`;
ALTER TABLE `faturacao_modelo_email`  ADD `Allemand` TEXT NOT NULL  AFTER `Anglais`;

UPDATE `faturacao_modelo_email` SET Assunto = "{%type_doc%} n° {%numero_document%}",
Francais = "<p>Concerne: {%client%}.</p><p><br></p><p> Madame, Monsieur, Vous trouverez en pièce jointe votre facture {%numero_document%} pour un montant de {%total%} CHF du {%date%}.</p><p> La référence BVR pour votre paiement est {%bvr%}.</p><p><br></p><p> En cas de question, n'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p><br></p><p> Cordialement, {%nom_societe%}</p>",
Anglais = "<p>Concerns: {%client%}.</p><p><br></p><p> Dear Sir/Madam, Enclosed you will find your invoice {%numero_document%} for an amount of {%total%} CHF of {%date%}.</p><p> The ISR reference for your payment is {%bvr%}.</p><p><br></p><p> If you have any questions, please do not hesitate to contact us at {%mail%}, or contact your contact person.</p><p><br></p><p> Yours faithfully, {%nom_societe%}</p>",
Allemand = "<p>Bedenken: {%client%}.</p><p><br></p><p> Sehr geehrte Damen und Herren Sie finden anbei Ihre Rechnung {%numero_document%} für den Betrag von {%total%} CHF, vom {%date%}.</p><p> Die Referenznummer für Ihre Zahlung ist {%bvr%}.</p><p><br></p><p> Bei Fragen Können Sie sich an {%mail%} oder an Ihre Referenz Person wenden.</p><p><br></p><p> Mit freundlichen Grüssen {%nom_societe%}</p>"
WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 1;

UPDATE `faturacao_modelo_email` SET Assunto = "{%type_doc%} {%numero_document%}", 
Francais = "<p>{%client%} Fribourg, le {%date%} Offre {%numero_document%}</p><p><br></p><p> Madame, Monsieur, Par la présente, nous vous remercions de l'intérêt que vous portez à nos produits et vous proposons, en annexe, une offre correspondant à votre demande.</p><p> En espérant vous satisfaire avec cette proposition, nous vous remercions pour votre confiance et restons à votre entière disposition pour de plus amples renseignements.</p><p><br></p><p>En cas de question, n'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p><br></p><p> Dans l'attente de vos nouvelles, nous vous présentons, Madame, Monsieur, nos plus cordiales salutations.</p><p></p>", 
Anglais = "<p>{%client%} Fribourg, {%date%} offer {%numero_document%}</p><p><br></p><p> Dear Sir/Madam, We would like to thank you for your interest in our products and enclose an offer corresponding to your request.</p><p> We hope that you will be satisfied with this proposal.</p><p> We thank you for your confidence and remain at your disposal for further information.</p><p><br></p><p>If you have any questions, please do not hesitate to contact us at {%mail%}, or contact your contact person.</p><p><br></p><p> We look forward to hearing from you.</p>", 
Allemand = "<p>{%client%} Freiburg, {%date%} Angebot {%numero_document%}</p><p><br></p><p> Sehr geehrte Damen und Herren, Wir bedanken uns für Ihr Interesse an unseren Produkten und unterbreiten Ihnen ein Angebot gemäß Ihrer Anfrage.</p><p> Wir hoffen, Sie mit diesem Vorschlag zufrieden zu stellen, danken Ihnen für Ihr Vertrauen und stehen Ihnen für weitere Informationen gerne zur Verfügung.</p><p><br></p><p>Bei Fragen Können Sie sich an {%mail%} oder an Ihre Referenz Person wenden.</p><p><br></p><p> {%nom_societe%} </p>"
WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 2;

UPDATE `faturacao_modelo_email` SET Assunto = "{%type_doc%} {%numero_document%}", 
Francais = "<p>Concerne: 1er rappel {%client%}.</p><p><br></p><p> Madame, Monsieur, Sauf erreur ou omission de notre par, le paiement de la facture {%numero_document%} pour un montant de {%total%} CHF du {%date%} ne nous est pas parvenu.</p><p> La référence BVR pour votre paiement est {%bvr%} Nous vous remercions de bien vouloir régler cette dernière dans un délai de 10 jours .</p><p> Si entretemps votre paiement nous est parvenu, nous vous saurions gré de ne pas tenir compte du présent mail.</p><p><br></p><p> En cas de question, n'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p><br></p><p> Cordialement, {%nom_societe%}</p>", 
Anglais = "<p>Re: 1st reminder {%client%}.</p><p><br></p><p> Dear Sir/Madam, Unless we have made an error or omission, the payment of the invoice {%numero_document%} for an amount of {%total%} CHF of {%date%} has not reached us.</p><p> The ISR reference for your payment is {%bvr%}.</p><p> We would be grateful if you could settle this within 10 days.</p><p> If we have received your payment in the meantime, we would be grateful if you would disregard this e-mail.</p><p><br></p><p> If you have any questions, please do not hesitate to contact us at {%mail%}, or contact your contact person.</p><p><br></p><p> Yours faithfully, {%nom_societe%}</p>",
Allemand = "<p>Bedenken: 1. Erinnerung {%client%}.</p><p><br></p><p> Sehr geehrte Damen und Herren, Sofern wir keinen Fehler oder Auslassung gemacht haben, haben wir keine Zahlung der Rechnung {%numero_document%} für einen Betrag von {%total%} CHF von {%date%} erhalten.</p><p>Die ESR-Referenz für Ihre Zahlung ist {%bvr%}.</p><p> Wir danken Ihnen, dass Sie diese innerhalb von 10 Tagen bezahlt haben.</p><p> Wenn wir in der Zwischenzeit Ihre Zahlung erhalten haben, würden wir uns freuen, wenn Sie diese E-Mail nicht beachten würden.</p><p><br></p><p> Bei Fragen stehen wir Ihnen gerne unter {%mail%} zur Verfügung oder kontaktieren Sie Ihren Ansprechpartner.</p><p><br></p><p> Mit freundlichen Grüßen, {%nom_societe%}</p>"
WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 3;

UPDATE `faturacao_modelo_email` SET Assunto = "{%type_doc%} n° {%numero_document%} ", 
Francais = "<p>Concerne: 2ème rappel {%client%}.</p><p><br></p><p> Madame, Monsieur, Sauf erreur ou omission de notre par, le paiement de la facture {%numero_document%} pour un montant de {%total%} CHF du {%date%} ne nous est pas parvenu.</p><p> La référence BVR pour votre paiement est {%bvr%} Nous vous remercions de bien vouloir régler cette dernière dans un délai de 10 jours, car autrement nous serions obligé de vous bloquer votre compte.</p><p> Si entretemps votre paiement nous est parvenu, nous vous saurions gré de ne pas tenir compte du présent mail.</p><p><br></p><p> En cas de question, n'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p><br></p><p> Cordialement, {%nom_societe%}</p>", 
Anglais = "<p>Re: 2nd reminder {%client%}.</p><p><br></p><p> Dear Sir/Madam, Unless we have made an error or omission, the payment of the invoice {%document_number%} for an amount of {%total%} CHF of {%date%} has not reached us.</p><p> The ISR reference for your payment is {%bvr%}.</p><p> We would be grateful if you could settle this within 10 days, otherwise we would be obliged to block your account.</p><p> If we have received your payment in the meantime, we would be grateful if you would disregard this e-mail.</p><p><br></p><p> If you have any questions, please do not hesitate to contact us at {%mail%}, or contact your contact person.</p><p><br></p><p> Yours faithfully, {%society_name%}</p>", 
Allemand = "<p>Bedenken: 2. Erinnerung {%client%}.</p><p><br></p><p> Sehr geehrte Damen und Herren, Sofern wir keinen Fehler oder Auslassung gemacht haben, haben wir keine Zahlung der Rechnung {%numero_document%} für einen Betrag von {%total%} CHF von {%date%} erhalten.</p><p> Die ESR-Referenz für Ihre Zahlung ist {%bvr%}.</p><p> Wir danken Ihnen, dass Sie die Zahlung innerhalb von 10 Tagen geleistet haben, sonst wären wir verpflichtet, Ihr Konto zu sperren.</p><p> Wenn wir in der Zwischenzeit Ihre Zahlung erhalten haben, würden wir uns freuen, wenn Sie diese -Mail nicht beachten würden.</p><p><br></p><p> Bei Fragen stehen wir Ihnen gerne unter {%mail%} zur Verfügung oder kontaktieren Sie Ihren Ansprechpartner.</p><p><br></p><p> Mit freundlichen Grüßen, {%nom_societe%}</p>"
WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 4;

UPDATE `faturacao_modelo_email` SET Assunto = "{%type_doc%} n° {%numero_document%}",
Francais = "<p>Concerne: {%client%}.</p><p><br></p><p> Madame, Monsieur, Vous trouverez en pièce jointe votre note de crédit {%numero_document%} pour un montant de {%total%} CHF du {%date%}.</p><p><br></p><p> En cas de question, n'hésitez surtout pas à nous contacter {%mail%}, ou contacter votre personne de référence.</p><p><br></p><p> Cordialement, {%nom_societe%}</p>", 
Anglais = "<p>Concerns: {%client%}.</p><p><br></p><p> Dear Sir/Madam, Please find enclosed your credit note {%numero_document%} for an amount of {%total%} CHF of {%date%}.</p><p><br></p><p> If you have any questions, please do not hesitate to contact us at {%mail%}, or contact your contact person.</p><p><br></p><p> Yours faithfully, {%nom_societe%}</p>", 
Allemand = "<p>Bedenken: {%client%}.</p><p><br></p><p> Sehr geehrte Damen und Herren Sie finden anbei Ihre Gutschrift {%numero_document%} für den Betrag von {%total%} CHF, vom {%date%}.</p><p><br></p><p> Bei Fragen Können Sie sich an {%mail%} oder an Ihre Referenz Person wenden.</p><p><br></p><p> Mit freundlichen Grüssen {%nom_societe%}</p>"
WHERE `faturacao_modelo_email`.`ID_ModeloEmail` = 5;


alter table `faturacao_clientes` add `AVS` text DEFAULT NULL;

ALTER TABLE `faturacao_bancos` ADD `Escompte` VARCHAR(11) NOT NULL DEFAULT '0' AFTER `IBAN`;

ALTER TABLE `faturacao_faturas` ADD `Escompte` VARCHAR(11) NOT NULL DEFAULT '0';

ALTER TABLE faturacao_clientes ADD Suspendu VARCHAR(50) NULL;

ALTER TABLE `faturacao_responsaveis` ADD `Fonction` TEXT NULL DEFAULT NULL AFTER `Prenom`;

ALTER TABLE `faturacao_faturas` ADD `PourcentReduc` BOOLEAN NOT NULL DEFAULT TRUE AFTER `Escompte`;

INSERT INTO `faturacao_permissions` ( `Machine_Name`, `Name`, `Funcionalidade`) VALUES
('0149', 'Fermeture du Mois (Toutes les actions)', 1);

ALTER TABLE `faturacao_compras` CHANGE `ID_BVR` `ID_BVR` VARCHAR(30) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;

UPDATE `faturacao_dados_aplicacao` SET `Versao` = '2.0.0' WHERE `faturacao_dados_aplicacao`.`ID_Dados_Aplicacao` = 1;

ALTER TABLE `faturacao_personalizar_documentos` ADD `Rappels` BOOLEAN NULL DEFAULT 1 AFTER `NumeroInicial_CACH`;

INSERT INTO `faturacao_artigos` (`ID_Artigo`, `Nome`, `Codigo`, `Tipo`, `CodigoBarras`, `SerialNumber`, `ID_Categoria`, `ID_Unidade`, `Preco`, `ID_Imposto`, `ID_Imposto_Fornecedor`, `PrecoPVP`, `RetencaoPercentagem`, `RetencaoValor`, `Stock`, `Ativo`, `PlanoContas`, `PlanoContasCompras`, `Usado`, `ID_Prestashop`) VALUES (NULL, 'Article pour achats fournisseurs', 'CAMIMP', 'P', '', '', '0', '1', '0', '21', '19', '0', '0.00', '0.000000', '999999999990.000', '1', '3200', '4200', '1', '0');